!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file idvtes.f
!
!     this file includes documentation and code for
!     subroutine idvtes         i
!
! ... files which must be loaded with idvtes.f
!
!     sphcom.f, hrfft.f, vhses.f,shaes.f
!
!
!     subroutine idvtes(nlat,nlon,isym,nt,v,w,idvw,jdvw,ad,bd,av,bv,
!    +mdab,ndab,wvhses,lvhses,work,lwork,pertbd,pertbv,ierror)
!
!     given the scalar spherical harmonic coefficients ad,bd precomputed
!     by subroutine shaes for the scalar field divg and coefficients av,bv
!     precomputed by subroutine shaes for the scalar field vort, subroutine
!     idvtes computes a vector field (v,w) whose divergence is divg - pertbd
!     and whose vorticity is vort - pertbv.  w the is east longitude component
!     and v is the colatitudinal component of the velocity.  if nt=1 (see nt
!     below) pertrbd and pertbv are constants which must be subtracted from
!     divg and vort for (v,w) to exist (see the description of pertbd and
!     pertrbv below).  usually pertbd and pertbv are zero or small relative
!     to divg and vort.  w(i,j) and v(i,j) are the velocity components at
!     colatitude
!
!            theta(i) = (i-1)*pi/(nlat-1)
!
!     and longitude
!
!            lambda(j) = (j-1)*2*pi/nlon
!
!     the
!
!            divergence(v(i,j),w(i,j))
!
!         =  [d(sint*v)/dtheta + dw/dlambda]/sint
!
!         =  divg(i,j) - pertbd
!
!     and
!
!            vorticity(v(i,j),w(i,j))
!
!         =  [-dv/dlambda + d(sint*w)/dtheta]/sint
!
!         =  vort(i,j) - pertbv
!
!     where
!
!            sint = cos(theta(i)).
!
!
!     input parameters
!
!     nlat   the number of colatitudes on the full sphere including the
!            poles. for example, nlat = 37 for a five degree grid.
!            nlat determines the grid increment in colatitude as
!            pi/(nlat-1).  if nlat is odd the equator is located at
!            grid point i=(nlat+1)/2. if nlat is even the equator is
!            located half way between points i=nlat/2 and i=nlat/2+1.
!            nlat must be at least 3. note: on the half sphere, the
!            number of grid points in the colatitudinal direction is
!            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than 3. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!
!     isym   isym determines whether (v,w) are computed on the full or half
!            sphere as follows:
!
!      = 0
!            divg,vort are neither pairwise symmetric/antisymmetric nor
!            antisymmetric/symmetric about the equator as described for
!            isym = 1 or isym = 2  below.  in this case, the vector field
!            (v,w) is computed on the entire sphere.  i.e., in the arrays
!            w(i,j) and v(i,j) i=1,...,nlat and j=1,...,nlon.
!
!      = 1
!
!            divg is antisymmetric and vort is symmetric about the equator.
!            in this case w is antisymmetric and v is symmetric about the
!            equator.  w and v are computed on the northern hemisphere only.
!            if nlat is odd they are computed for i=1,...,(nlat+1)/2
!            and j=1,...,nlon.  if nlat is even they are computed for
!            i=1,...,nlat/2 and j=1,...,nlon.
!
!      = 2
!
!            divg is symmetric and vort is antisymmetric about the equator.
!            in this case w is symmetric and v is antisymmetric about the
!            equator.  w and v are computed on the northern hemisphere only.
!            if nlat is odd they are computed for i=1,...,(nlat+1)/2
!            and j=1,...,nlon.  if nlat is even they are computed for
!            i=1,...,nlat/2 and j=1,...,nlon.
!
!
!     nt     in the program that calls idvtes, nt is the number of scalar
!            and vector fields.  some computational efficiency is obtained
!            for multiple fields.  the arrays ad,bd,av,bv,u, and v can be
!            three dimensional and pertbd,pertbv can be one dimensional
!            corresponding to indexed multiple arrays divg, vort.  in this
!            case, multiple synthesis will be performed to compute each
!            vector field.  the third index for ad,bd,av,bv,v,w and first
!            pertrbd,pertbv is the synthesis index which assumes the values
!            k=1,...,nt.  for a single synthesis set nt=1. the description of
!            remaining parameters is simplified by assuming that nt=1 or that
!            ad,bd,av,bv,v,w are two dimensional and pertbd,pertbv are
!            constants.
!
!     idvw   the first dimension of the arrays v,w as it appears in
!            the program that calls idvtes. if isym = 0 then idvw
!            must be at least nlat.  if isym = 1 or 2 and nlat is
!            even then idvw must be at least nlat/2. if isym = 1 or 2
!            and nlat is odd then idvw must be at least (nlat+1)/2.
!
!     jdvw   the second dimension of the arrays v,w as it appears in
!            the program that calls idvtes. jdvw must be at least nlon.
!
!     ad,bd  two or three dimensional arrays (see input parameter nt)
!            that contain scalar spherical harmonic coefficients
!            of the divergence array divg as computed by subroutine shaes.
!
!     av,bv  two or three dimensional arrays (see input parameter nt)
!            that contain scalar spherical harmonic coefficients
!            of the vorticity array vort as computed by subroutine shaes.
!     ***    ad,bd,av,bv must be computed by shaes prior to calling idvtes.
!
!     mdab   the first dimension of the arrays ad,bd,av,bv as it appears
!            in the program that calls idvtes (and shaes). mdab must be at
!            least min0(nlat,(nlon+2)/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndab   the second dimension of the arrays ad,bd,av,bv as it appears in
!            the program that calls idvtes (and shaes). ndab must be at
!            least nlat.
!
!  wvhses    an array which must be initialized by subroutine vhsesi.
!            wvhses can be used repeatedly by idvtes as long as nlon
!            and nlat remain unchanged.  wvhses must not be altered
!            between calls of idvtes.
!
!
!  lvhses    the dimension of the array wvhses as it appears in the
!            program that calls idvtes. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lvhses must be at least
!
!               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
!
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls idvtes. define
!
!               l2 = nlat/2                    if nlat is even or
!               l2 = (nlat+1)/2                if nlat is odd
!               l1 = min0(nlat,nlon/2)       if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2)   if nlon is odd
!
!            if isym = 0 then lwork must be at least
!
!                       nlat*((2*nt+1)*nlon+4*nt*l1+1)
!
!            if isym = 1 or 2 then lwork must be at least
!
!                       (2*nt+1)*l2*nlon+nlat*(4*nt*l1+1)
!
!     **************************************************************
!
!     output parameters
!
!
!     v,w   two or three dimensional arrays (see input parameter nt) that
!           contain a vector field whose divergence is divg - pertbd and
!           whose vorticity is vort - pertbv.  w(i,j) is the east longitude
!           component and v(i,j) is the colatitudinal component of velocity
!           at the colatitude theta(i) = (i-1)*pi/(nlat-1) and longitude
!           lambda(j) = (j-1)*2*pi/nlon for i=1,...,nlat and j=1,...,nlon.
!
!   pertbd  a nt dimensional array (see input parameter nt and assume nt=1
!           for the description that follows).  divg - pertbd is a scalar
!           field which can be the divergence of a vector field (v,w).
!           pertbd is related to the scalar harmonic coefficients ad,bd
!           of divg (computed by shaes) by the formula
!
!                pertbd = ad(1,1)/(2.*sqrt(2.))
!
!           an unperturbed divg can be the divergence of a vector field
!           only if ad(1,1) is zero.  if ad(1,1) is nonzero (flagged by
!           pertbd nonzero) then subtracting pertbd from divg yields a
!           scalar field for which ad(1,1) is zero.  usually pertbd is
!           zero or small relative to divg.
!
!   pertbv a nt dimensional array (see input parameter nt and assume nt=1
!           for the description that follows).  vort - pertbv is a scalar
!           field which can be the vorticity of a vector field (v,w).
!           pertbv is related to the scalar harmonic coefficients av,bv
!           of vort (computed by shaes) by the formula
!
!                pertbv = av(1,1)/(2.*sqrt(2.))
!
!           an unperturbed vort can be the vorticity of a vector field
!           only if av(1,1) is zero.  if av(1,1) is nonzero (flagged by
!           pertbv nonzero) then subtracting pertbv from vort yields a
!           scalar field for which av(1,1) is zero.  usually pertbv is
!           zero or small relative to vort.
!
!    ierror = 0  no errors
!           = 1  error in the specification of nlat
!           = 2  error in the specification of nlon
!           = 3  error in the specification of isym
!           = 4  error in the specification of nt
!           = 5  error in the specification of idvw
!           = 6  error in the specification of jdvw
!           = 7  error in the specification of mdab
!           = 8  error in the specification of ndab
!           = 9  error in the specification of lvhses
!           = 10 error in the specification of lwork
! **********************************************************************


      SUBROUTINE IDVTES(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Ad,Bd,Av,Bv,    &
                      & Mdab,Ndab,Wvhses,Lvhses,Work,Lwork,Pertbd,      &
                      & Pertbv,Ierror)
      IMPLICIT NONE

      REAL Ad , Av , Bd , Bv , Pertbd , Pertbv , V , W , Work , Wvhses
      INTEGER ibi , ibr , ici , icr , Idvw , idz , Ierror , imid , is , &
            & Isym , iwk , Jdvw , liwk , Lvhses , Lwork , lzimn , Mdab ,&
            & mmax , mn , Ndab
      INTEGER Nlat , Nlon , Nt

      DIMENSION W(Idvw,Jdvw,Nt) , V(Idvw,Jdvw,Nt) , Pertbd(Nt) ,        &
              & Pertbv(Nt)
      DIMENSION Ad(Mdab,Ndab,Nt) , Bd(Mdab,Ndab,Nt)
      DIMENSION Av(Mdab,Ndab,Nt) , Bv(Mdab,Ndab,Nt)
      DIMENSION Wvhses(Lvhses) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idvw<Nlat) .OR. (Isym/=0 .AND. Idvw<imid) )   &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<MIN0(Nlat,(Nlon+2)/2) ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      idz = (mmax*(Nlat+Nlat-mmax+1))/2
      lzimn = idz*imid
      IF ( Lvhses<lzimn+lzimn+Nlon+15 ) RETURN
      Ierror = 10
!
!     verify unsaved work space length
!
      mn = mmax*Nlat*Nt
      IF ( Isym/=0 .AND. Lwork<Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon))       &
         & +4*mn+Nlat ) RETURN
      IF ( Isym==0 .AND. Lwork<imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon))       &
         & +4*mn+Nlat ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ibr = 1
      ibi = ibr + mn
      icr = ibi + mn
      ici = icr + mn
      is = ici + mn
      iwk = is + Nlat
      liwk = Lwork - 4*mn - Nlat
      CALL IDVTES1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Work(ibr),Work(ibi), &
                 & Work(icr),Work(ici),mmax,Work(is),Mdab,Ndab,Ad,Bd,Av,&
                 & Bv,Wvhses,Lvhses,Work(iwk),liwk,Pertbd,Pertbv,Ierror)
    END SUBROUTINE IDVTES


    SUBROUTINE IDVTES1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,   &
           & Mmax,Sqnn,Mdab,Ndab,Ad,Bd,Av,Bv,Widvtes,       &
                       & Lidvtes,Wk,Lwk,Pertbd,Pertbv,Ierror)
      IMPLICIT NONE
      REAL Ad , Av , Bd , Bi , Br , Bv , Ci , Cr , fn , Pertbd ,        &
         & Pertbv , Sqnn , V , W , Widvtes , Wk
      INTEGER Idvw , Ierror , Isym , ityp , Jdvw , k , Lidvtes , Lwk ,  &
            & m , Mdab , Mmax , n , Ndab , Nlat , Nlon , Nt
      DIMENSION W(Idvw,Jdvw,Nt) , V(Idvw,Jdvw,Nt)
      DIMENSION Br(Mmax,Nlat,Nt) , Bi(Mmax,Nlat,Nt) , Sqnn(Nlat)
      DIMENSION Cr(Mmax,Nlat,Nt) , Ci(Mmax,Nlat,Nt)
      DIMENSION Ad(Mdab,Ndab,Nt) , Bd(Mdab,Ndab,Nt)
      DIMENSION Av(Mdab,Ndab,Nt) , Bv(Mdab,Ndab,Nt)
      DIMENSION Widvtes(Lidvtes) , Wk(Lwk)
      DIMENSION Pertbd(Nt) , Pertbv(Nt)
!
!     preset coefficient multiplyers in vector
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.))
      ENDDO
!
!     compute multiple vector fields coefficients
!
      DO k = 1 , Nt
!
!     set divergence,vorticity perturbation constants
!
         Pertbd(k) = Ad(1,1,k)/(2.*SQRT(2.))
         Pertbv(k) = Av(1,1,k)/(2.*SQRT(2.))
!
!     preset br,bi,cr,ci to 0.0
!
         DO n = 1 , Nlat
            DO m = 1 , Mmax
               Br(m,n,k) = 0.0
               Bi(m,n,k) = 0.0
               Cr(m,n,k) = 0.0
               Ci(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            Br(1,n,k) = -Ad(1,n,k)/Sqnn(n)
            Bi(1,n,k) = -Bd(1,n,k)/Sqnn(n)
            Cr(1,n,k) = Av(1,n,k)/Sqnn(n)
            Ci(1,n,k) = Bv(1,n,k)/Sqnn(n)
         ENDDO
!
!     compute m>0 coefficients
!
         DO m = 2 , Mmax
            DO n = m , Nlat
               Br(m,n,k) = -Ad(m,n,k)/Sqnn(n)
               Bi(m,n,k) = -Bd(m,n,k)/Sqnn(n)
               Cr(m,n,k) = Av(m,n,k)/Sqnn(n)
               Ci(m,n,k) = Bv(m,n,k)/Sqnn(n)
            ENDDO
         ENDDO
      ENDDO
!
!     set ityp for vector synthesis without assuming div=0 or curl=0
!
      IF ( Isym==0 ) THEN
         ityp = 0
      ELSEIF ( Isym==1 ) THEN
         ityp = 3
      ELSEIF ( Isym==2 ) THEN
         ityp = 6
      ENDIF
!
!     sythesize br,bi,cr,ci into the vector field (v,w)
!
      CALL VHSES(Nlat,Nlon,ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,Mmax,Nlat, &
               & Widvtes,Lidvtes,Wk,Lwk,Ierror)
      END SUBROUTINE IDVTES1


      SUBROUTINE DIDVTES(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Ad,Bd,Av,Bv,    &
                      & Mdab,Ndab,Wvhses,Lvhses,Work,Lwork,Pertbd,      &
                      & Pertbv,Ierror)
      IMPLICIT NONE

      DOUBLE PRECISION Ad , Av , Bd , Bv , Pertbd , Pertbv , V , W , Work , Wvhses
      INTEGER ibi , ibr , ici , icr , Idvw , idz , Ierror , imid , is , &
            & Isym , iwk , Jdvw , liwk , Lvhses , Lwork , lzimn , Mdab ,&
            & mmax , mn , Ndab
      INTEGER Nlat , Nlon , Nt

      DIMENSION W(Idvw,Jdvw,Nt) , V(Idvw,Jdvw,Nt) , Pertbd(Nt) ,        &
              & Pertbv(Nt)
      DIMENSION Ad(Mdab,Ndab,Nt) , Bd(Mdab,Ndab,Nt)
      DIMENSION Av(Mdab,Ndab,Nt) , Bv(Mdab,Ndab,Nt)
      DIMENSION Wvhses(Lvhses) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idvw<Nlat) .OR. (Isym/=0 .AND. Idvw<imid) )   &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<MIN0(Nlat,(Nlon+2)/2) ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      idz = (mmax*(Nlat+Nlat-mmax+1))/2
      lzimn = idz*imid
      IF ( Lvhses<lzimn+lzimn+Nlon+15 ) RETURN
      Ierror = 10
!
!     verify unsaved work space length
!
      mn = mmax*Nlat*Nt
      IF ( Isym/=0 .AND. Lwork<Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon))       &
         & +4*mn+Nlat ) RETURN
      IF ( Isym==0 .AND. Lwork<imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon))       &
         & +4*mn+Nlat ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ibr = 1
      ibi = ibr + mn
      icr = ibi + mn
      ici = icr + mn
      is = ici + mn
      iwk = is + Nlat
      liwk = Lwork - 4*mn - Nlat
      CALL DIDVTES1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Work(ibr),Work(ibi), &
                 & Work(icr),Work(ici),mmax,Work(is),Mdab,Ndab,Ad,Bd,Av,&
                 & Bv,Wvhses,Lvhses,Work(iwk),liwk,Pertbd,Pertbv,Ierror)
    END SUBROUTINE DIDVTES


    SUBROUTINE DIDVTES1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,   &
           & Mmax,Sqnn,Mdab,Ndab,Ad,Bd,Av,Bv,Widvtes,       &
                       & Lidvtes,Wk,Lwk,Pertbd,Pertbv,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION Ad , Av , Bd , Bi , Br , Bv , Ci , Cr , fn , Pertbd ,        &
         & Pertbv , Sqnn , V , W , Widvtes , Wk
      INTEGER Idvw , Ierror , Isym , ityp , Jdvw , k , Lidvtes , Lwk ,  &
            & m , Mdab , Mmax , n , Ndab , Nlat , Nlon , Nt
      DIMENSION W(Idvw,Jdvw,Nt) , V(Idvw,Jdvw,Nt)
      DIMENSION Br(Mmax,Nlat,Nt) , Bi(Mmax,Nlat,Nt) , Sqnn(Nlat)
      DIMENSION Cr(Mmax,Nlat,Nt) , Ci(Mmax,Nlat,Nt)
      DIMENSION Ad(Mdab,Ndab,Nt) , Bd(Mdab,Ndab,Nt)
      DIMENSION Av(Mdab,Ndab,Nt) , Bv(Mdab,Ndab,Nt)
      DIMENSION Widvtes(Lidvtes) , Wk(Lwk)
      DIMENSION Pertbd(Nt) , Pertbv(Nt)
!
!     preset coefficient multiplyers in vector
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.))
      ENDDO
!
!     compute multiple vector fields coefficients
!
      DO k = 1 , Nt
!
!     set divergence,vorticity perturbation constants
!
         Pertbd(k) = Ad(1,1,k)/(2.*SQRT(2.))
         Pertbv(k) = Av(1,1,k)/(2.*SQRT(2.))
!
!     preset br,bi,cr,ci to 0.0
!
         DO n = 1 , Nlat
            DO m = 1 , Mmax
               Br(m,n,k) = 0.0
               Bi(m,n,k) = 0.0
               Cr(m,n,k) = 0.0
               Ci(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            Br(1,n,k) = -Ad(1,n,k)/Sqnn(n)
            Bi(1,n,k) = -Bd(1,n,k)/Sqnn(n)
            Cr(1,n,k) = Av(1,n,k)/Sqnn(n)
            Ci(1,n,k) = Bv(1,n,k)/Sqnn(n)
         ENDDO
!
!     compute m>0 coefficients
!
         DO m = 2 , Mmax
            DO n = m , Nlat
               Br(m,n,k) = -Ad(m,n,k)/Sqnn(n)
               Bi(m,n,k) = -Bd(m,n,k)/Sqnn(n)
               Cr(m,n,k) = Av(m,n,k)/Sqnn(n)
               Ci(m,n,k) = Bv(m,n,k)/Sqnn(n)
            ENDDO
         ENDDO
      ENDDO
!
!     set ityp for vector synthesis without assuming div=0 or curl=0
!
      IF ( Isym==0 ) THEN
         ityp = 0
      ELSEIF ( Isym==1 ) THEN
         ityp = 3
      ELSEIF ( Isym==2 ) THEN
         ityp = 6
      ENDIF
!
!     sythesize br,bi,cr,ci into the vector field (v,w)
!
      CALL DVHSES(Nlat,Nlon,ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,Mmax,Nlat, &
               & Widvtes,Lidvtes,Wk,Lwk,Ierror)
      END SUBROUTINE DIDVTES1

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file sfvpec.f
c
c     this file includes documentation and code for
c     subroutine sfvpec          i
c
c ... files which must be loaded with sfvpec.f
c
c     sphcom.f, hrfft.f, vhaec.f, shsec.f
c
c
c     subroutine sfvpec(nlat,nlon,isym,nt,sf,vp,idv,jdv,br,bi,cr,ci,
c    +                   mdb,ndb,wshsec,lshsec,work,lwork,ierror)
c
c     given the vector spherical harmonic coefficients br,bi,cr,ci,
c     computed by subroutine vhaec for a vector field (v,w), sfvpec
c     computes a scalar stream function sf and scalar velocity potential
c     vp for (v,w).  (v,w) is expressed in terms of sf and vp by the
c     helmholtz relations (in mathematical spherical coordinates):
c
c          v = -1/sint*d(vp)/dlambda + d(st)/dtheta
c
c          w =  1/sint*d(st)/dlambda + d(vp)/dtheta
c
c     where sint = sin(theta).  w is the east longitudinal and v
c     is the colatitudinal component of the vector field from which
c     br,bi,cr,ci were precomputed.  required associated legendre
c     polynomials are recomputed rather than stored as they are in
c     subroutine sfvpes. sf(i,j) and vp(i,j) are given at colatitude
c
c            theta(i) = (i-1)*pi/(nlat-1)
c
c     and east longitude
c
c            lambda(j) = (j-1)*2*pi/nlon
c
c     on the sphere.
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater than
c            3.  the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   a parameter which determines whether the stream function and
c            velocity potential are computed on the full or half sphere
c            as follows:
c
c      = 0
c
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in (v,w) about the equator.  in this case sf
c            and vp are not necessarily symmetric or antisymmetric about
c            the equator.  sf and vp are computed on the entire sphere.
c            i.e., in arrays sf(i,j),vp(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c
c            w is antisymmetric and v is symmetric about the equator.
c            in this case sf is symmetric and vp antisymmetric about
c            the equator and are computed for the northern hemisphere
c            only.  i.e., if nlat is odd the sf(i,j),vp(i,j) are computed
c            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
c            even then sf(i,j),vp(i,j) are computed for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c      = 2
c
c            w is symmetric and v is antisymmetric about the equator.
c            in this case sf is antisymmetric and vp symmetric about
c            the equator and are computed for the northern hemisphere
c            only.  i.e., if nlat is odd the sf(i,j),vp(i,j) are computed
c            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
c            even then sf(i,j),vp(i,j) are computed for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c     nt     nt is the number of scalar and vector fields.  some
c            computational efficiency is obtained for multiple fields. arrays
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple scalar synthesis will
c            be performed to compute sf,vp for each field.  the
c            third index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt = 1.  the
c            description of the remaining parameters is simplified by
c            assuming that nt=1 or that all the arrays are two dimensional.
c
c     idv    the first dimension of the arrays sf,vp as it appears in
c            the program that calls sfvpec. if isym = 0 then idv
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idv must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idv must be at least (nlat+1)/2.
c
c     jdv    the second dimension of the arrays sf,vp as it appears in
c            the program that calls sfvpec. jdv must be at least nlon.
c
c     br,bi, two or three dimensional arrays (see input parameter nt)
c     cr,ci  that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhaec.
c
c     mdb    the first dimension of the arrays br,bi,cr,ci as it
c            appears in the program that calls sfvpec. mdb must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndb    the second dimension of the arrays br,bi,cr,ci as it
c            appears in the program that calls sfvpec. ndb must be at
c            least nlat.
c
c     wshsec an array which must be initialized by subroutine shseci.
c            once initialized, wshsec can be used repeatedly by sfvpec
c            as long as nlon and nlat remain unchanged.  wshsec must
c            not bel altered between calls of sfvpec.
c
c
c     lshsec the dimension of the array wshsec as it appears in the
c            program that calls sfvpec. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsec must be at least
c
c            2*nlat*l2+3*((l1-2)*(nlat+nlat-l1-1))/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls sfvpec. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c
c            if isym is zero then lwork must be at least
c
c                nlat*((nt*nlon+max0(3*l2,nlon)) + 2*l1*nt+1)
c
c            if isym is not zero then lwork must be at least
c
c                l2*(nt*nlon+max0(3*nlat,nlon)) + nlat*(2*l1*nt+1)
c
c     **************************************************************
c
c     output parameters
c
c    sf,vp  two or three dimensional arrays (see input parameter nt)
c           that contains the stream function and velocity potential
c           of the vector field (v,w) whose coefficients br,bi,cr,ci
c           where precomputed by subroutine vhaec.  sf(i,j),vp(i,j)
c           are given at the colatitude point
c
c                theta(i) = (i-1)*pi/(nlat-1)
c
c           and longitude point
c
c                lambda(j) = (j-1)*2*pi/nlon
c
c           the index ranges are defined above at the input parameter isym.
c
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idv
c           = 6  error in the specification of jdv
c           = 7  error in the specification of mdb
c           = 8  error in the specification of ndb
c           = 9  error in the specification of lshsec
c           = 10 error in the specification of lwork
c **********************************************************************
c                                                                              
      subroutine sfvpec(nlat,nlon,isym,nt,sf,vp,idv,jdv,br,bi,cr,ci,
     +                   mdb,ndb,wshsec,lshsec,work,lwork,ierror)
      implicit none
      integer nlat,nlon,isym,nt,idv,jdv,mdb,ndb,lshsec,lwork,ierror
      real sf(idv,jdv,nt),vp(idv,jdv,nt)
      real br(mdb,ndb,nt),bi(mdb,ndb,nt)
      real cr(mdb,ndb,nt),ci(mdb,ndb,nt)
      real wshsec(lshsec),work(lwork)
      integer imid,mmax,lzz1,labc,ls,nln,mab,mn,ia,ib,is,lwk,iwk,lwmin
c
c     check input parameters
c
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if (nlon .lt. 4) return
      ierror = 3
      if (isym.lt.0 .or. isym.gt.2) return
      ierror = 4
      if (nt .lt. 0) return
      ierror = 5
      imid = (nlat+1)/2
      if((isym.eq.0 .and. idv.lt.nlat) .or.
     +   (isym.gt.0 .and. idv.lt.imid)) return
      ierror = 6
      if(jdv .lt. nlon) return
      ierror = 7
      mmax = min0(nlat,(nlon+2)/2)
      if(mdb .lt. min0(nlat,(nlon+1)/2)) return
      ierror = 8
      if (ndb .lt. nlat) return
      ierror = 9
c
c     verify saved work space (same as shsec)
c
      imid = (nlat+1)/2
      lzz1 = 2*nlat*imid
      labc = 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
      lwmin = lzz1+labc+nlon+15

      if(lshsec .lt. lwmin) return
c
c     verify unsaved work space (add to what shec requires)
c
      ierror = 10
      ls = nlat
      if (isym.gt. 0) ls = imid
      nln = nt*ls*nlon
c
c     set first dimension for a,b (as requried by shsec)
c
      mab = min0(nlat,nlon/2+1)
      mn = mab*nlat*nt
      if(lwork .lt. nln+max0(ls*nlon,3*nlat*imid)+2*mn+nlat) return
      ierror = 0
c
c     set work space pointers
c
      ia = 1
      ib = ia+mn
      is = ib+mn
      iwk = is+nlat
      lwk = lwork-2*mn-nlat
      call sfvpec1(nlat,nlon,isym,nt,sf,vp,idv,jdv,br,bi,cr,ci,mdb,ndb,
     +work(ia),work(ib),mab,work(is),wshsec,lshsec,work(iwk),lwk,
     +ierror)
      return
      end

      subroutine sfvpec1(nlat,nlon,isym,nt,sf,vp,idv,jdv,br,bi,cr,ci,
     +mdb,ndb,a,b,mab,fnn,wshsec,lshsec,wk,lwk,ierror)
      implicit none
      integer nlat,nlon,isym,nt,idv,jdv,mdb,ndb,mab,lshsec,lwk,ierror
      real sf(idv,jdv,nt),vp(idv,jdv,nt)
      real br(mdb,ndb,nt),bi(mdb,ndb,nt),cr(mdb,ndb,nt),ci(mdb,ndb,nt)
      real a(mab,nlat,nt),b(mab,nlat,nt)
      real wshsec(lshsec),wk(lwk),fnn(nlat)
      integer n,m,mmax,k
c
c     set coefficient multiplyers
c
      do n=2,nlat
	fnn(n) = 1.0/sqrt(float(n*(n-1)))
      end do
      mmax = min0(nlat,(nlon+1)/2)
c
c     compute sf scalar coefficients from cr,ci
c
      do k=1,nt
	do n=1,nlat
	  do m=1,mab
	    a(m,n,k) = 0.0
	    b(m,n,k) = 0.0
	  end do
	end do
c
c     compute m=0 coefficients
c
	do n=2,nlat
	  a(1,n,k) =-fnn(n)*cr(1,n,k)
	  b(1,n,k) =-fnn(n)*ci(1,n,k)
	end do
c
c     compute m>0 coefficients using vector spherepack value for mmax
c
	do m=2,mmax
	  do n=m,nlat
	    a(m,n,k) =-fnn(n)*cr(m,n,k)
	    b(m,n,k) =-fnn(n)*ci(m,n,k)
	  end do
	end do
      end do
c
c     synthesize a,b into st
c
      call shsec(nlat,nlon,isym,nt,sf,idv,jdv,a,b,
     +           mab,nlat,wshsec,lshsec,wk,lwk,ierror)
c
c    set coefficients for vp from br,bi
c
      do k=1,nt
	do n=1,nlat
	  do m=1,mab
	    a(m,n,k) = 0.0
	    b(m,n,k) = 0.0
	  end do
	end do
c
c     compute m=0 coefficients
c
	do n=2,nlat
	  a(1,n,k) = fnn(n)*br(1,n,k)
	  b(1,n,k) = fnn(n)*bi(1,n,k)
	end do
c
c     compute m>0 coefficients using vector spherepack value for mmax
c
	mmax = min0(nlat,(nlon+1)/2)
	do m=2,mmax
	  do n=m,nlat
	    a(m,n,k) = fnn(n)*br(m,n,k)
	    b(m,n,k) = fnn(n)*bi(m,n,k)
	  end do
	end do
      end do
c
c     synthesize a,b into vp
c
      call shsec(nlat,nlon,isym,nt,vp,idv,jdv,a,b,
     +           mab,nlat,wshsec,lshsec,wk,lwk,ierror)
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
! ... file shsgc.f
!
!     this file contains code and documentation for subroutines
!     shsgc and shsgci
!
! ... files which must be loaded with shsgc.f
!
!     sphcom.f, hrfft.f, gaqd.f
!
!     subroutine shsgc(nlat,nlon,isym,nt,g,idg,jdg,a,b,mdab,ndab,
!    +                 wshsgc,lshsgc,work,lwork,ierror)
!
!     subroutine shsgc performs the spherical harmonic synthesis
!     on the arrays a and b and stores the result in the array g.
!     the synthesis is performed on an equally spaced longitude grid
!     and a gaussian colatitude grid.  the associated legendre functions
!     are recomputed rather than stored as they are in subroutine
!     shsgs.  the synthesis is described below at output parameter
!     g.
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are compu
!            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid poi
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than or equal to 4. the efficiency of the computation is
!            improved when nlon is a product of small prime numbers.
!
!     isym   = 0  no symmetries exist about the equator. the synthesis
!                 is performed on the entire sphere.  i.e. on the
!                 array g(i,j) for i=1,...,nlat and j=1,...,nlon.
!                 (see description of g below)
!
!            = 1  g is antisymmetric about the equator. the synthesis
!                 is performed on the northern hemisphere only.  i.e.
!                 if nlat is odd the synthesis is performed on the
!                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
!                 if nlat is even the synthesis is performed on the
!                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!
!            = 2  g is symmetric about the equator. the synthesis is
!                 performed on the northern hemisphere only.  i.e.
!                 if nlat is odd the synthesis is performed on the
!                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
!                 if nlat is even the synthesis is performed on the
!                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!     nt     the number of syntheses.  in the program that calls shsgc,
!            the arrays g,a and b can be three dimensional in which
!            case multiple synthesis will be performed.  the third
!            index is the synthesis index which assumes the values
!            k=1,...,nt.  for a single synthesis set nt=1. the
!            discription of the remaining parameters is simplified
!            by assuming that nt=1 or that the arrays g,a and b
!            have only two dimensions.
!
!     idg    the first dimension of the array g as it appears in the
!            program that calls shsgc. if isym equals zero then idg
!            must be at least nlat.  if isym is nonzero then idg must
!            be at least nlat/2 if nlat is even or at least (nlat+1)/2
!            if nlat is odd.
!
!     jdg    the second dimension of the array g as it appears in the
!            program that calls shsgc. jdg must be at least nlon.
!
!     mdab   the first dimension of the arrays a and b as it appears
!            in the program that calls shsgc. mdab must be at least
!            min0((nlon+2)/2,nlat) if nlon is even or at least
!            min0((nlon+1)/2,nlat) if nlon is odd
!
!     ndab   the second dimension of the arrays a and b as it appears
!            in the program that calls shsgc. ndab must be at least nlat
!
!     a,b    two or three dimensional arrays (see the input parameter
!            nt) that contain the coefficients in the spherical harmonic
!            expansion of g(i,j) given below at the definition of the
!            output parameter g.  a(m,n) and b(m,n) are defined for
!            indices m=1,...,mmax and n=m,...,nlat where mmax is the
!            maximum (plus one) longitudinal wave number given by
!            mmax = min0(nlat,(nlon+2)/2) if nlon is even or
!            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     wshsgc an array which must be initialized by subroutine shsgci.
!            once initialized, wshsgc can be used repeatedly by shsgc
!            as long as nlat and nlon remain unchanged.  wshsgc must
!            not be altered between calls of shsgc.
!
!     lshsgc the dimension of the array wshsgc as it appears in the
!            program that calls shsgc. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshsgc must be at least
!
!               nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls shsgc. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            if isym is zero then lwork must be at least
!
!                      nlat*(nlon*nt+max0(3*l2,nlon))
!
!            if isym is not zero then lwork must be at least
!
!                      l2*(nlon*nt+max0(3*nlat,nlon))
!
!     **************************************************************
!
!     output parameters
!
!     g      a two or three dimensional array (see input parameter nt)
!            that contains the discrete function which is synthesized.
!            g(i,j) contains the value of the function at the gaussian
!            colatitude point theta(i) and longitude point
!            phi(j) = (j-1)*2*pi/nlon. the index ranges are defined
!            above at the input parameter isym.  for isym=0, g(i,j)
!            is given by the the equations listed below.  symmetric
!            versions are used when isym is greater than zero.
!
!     the normalized associated legendre functions are given by
!
!     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
!                       *sin(theta)**m/(2**n*factorial(n)) times the
!                       (n+m)th derivative of (x**2-1)**n with respect
!                       to x=cos(theta)
!
!
!     define the maximum (plus one) longitudinal wave number
!     as   mmax = min0(nlat,(nlon+2)/2) if nlon is even or
!          mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     then g(i,j) = the sum from n=0 to n=nlat-1 of
!
!                   .5*pbar(0,n,theta(i))*a(1,n+1)
!
!              plus the sum from m=1 to m=mmax-1 of
!
!                   the sum from n=m to n=nlat-1 of
!
!              pbar(m,n,theta(i))*(a(m+1,n+1)*cos(m*phi(j))
!                                    -b(m+1,n+1)*sin(m*phi(j)))
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of isym
!            = 4  error in the specification of nt
!            = 5  error in the specification of idg
!            = 6  error in the specification of jdg
!            = 7  error in the specification of mdab
!            = 8  error in the specification of ndab
!            = 9  error in the specification of lwshig
!            = 10 error in the specification of lwork
!
!
! ****************************************************************
!
!     subroutine shsgci(nlat,nlon,wshsgc,lshsgc,dwork,ldwork,ierror)
!
!     subroutine shsgci initializes the array wshsgc which can then
!     be used repeatedly by subroutines shsgc. it precomputes
!     and stores in wshsgc quantities such as gaussian weights,
!     legendre polynomial coefficients, and fft trigonometric tables.
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are compu
!            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid poi
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than or equal to 4. the efficiency of the computation is
!            improved when nlon is a product of small prime numbers.
!
!     wshsgc an array which must be initialized by subroutine shsgci.
!            once initialized, wshsgc can be used repeatedly by shsgc
!            as long as nlat and nlon remain unchanged.  wshsgc must
!            not be altered between calls of shsgc.
!
!     lshsgc the dimension of the array wshsgc as it appears in the
!            program that calls shsgc. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshsgc must be at least
!
!                  nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
!
!     dwork  a double precision work array that does not have to be saved.
!
!     ldwork the dimension of the array dwork as it appears in the
!            program that calls shsgci. ldwork must be at least
!
!                 nlat*(nlat+4)
!
!     output parameter
!
!     wshsgc an array which must be initialized before calling shsgc.
!            once initialized, wshsgc can be used repeatedly by shsgc
!            as long as nlat and nlon remain unchanged.  wshsgc must not
!            altered between calls of shsgc.
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of lshsgc
!            = 4  error in the specification of ldwork
!            = 5  failure in gaqd to compute gaussian points
!                 (due to failure in eigenvalue routine)
!
!
! ****************************************************************
      SUBROUTINE SHSGC(Nlat,Nlon,Mode,Nt,G,Idg,Jdg,A,B,Mdab,Ndab,Wshsgc,&
                     & Lshsgc,Work,Lwork,Ierror)
      IMPLICIT NONE
      REAL A , B , G , Work , Wshsgc
      INTEGER Idg , Ierror , ifft , ipmn , Jdg , l , l1 , l2 , lat ,    &
            & late , Lshsgc , Lwork , Mdab , Mode , Ndab , Nlat , Nlon ,&
            & Nt
!     subroutine shsgc performs the spherical harmonic synthesis on
!     a gaussian grid using the coefficients in array(s) a,b and returns
!     the results in array(s) g.  the legendre polynomials are computed
!     as needed in this version.
!
      DIMENSION G(Idg,Jdg,1) , A(Mdab,Ndab,1) , B(Mdab,Ndab,1) ,        &
              & Wshsgc(Lshsgc) , Work(Lwork)
!     check input parameters
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Mode<0 .OR. Mode>2 ) RETURN
      Ierror = 4
      IF ( Nt<1 ) RETURN
!     set limit for m iin a(m,n),b(m,n) computation
      l = MIN0((Nlon+2)/2,Nlat)
!     set gaussian point nearest equator pointer
      late = (Nlat+MOD(Nlat,2))/2
!     set number of grid points for analysis/synthesis
      lat = Nlat
      IF ( Mode/=0 ) lat = late
      Ierror = 5
      IF ( Idg<lat ) RETURN
      Ierror = 6
      IF ( Jdg<Nlon ) RETURN
      Ierror = 7
      IF ( Mdab<l ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      l1 = l
      l2 = late
      Ierror = 9
!     check permanent work space length
      IF ( Lshsgc<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 10
!     check temporary work space length
      IF ( Mode==0 ) THEN
         IF ( Lwork<Nlat*(Nlon*Nt+MAX0(3*l2,Nlon)) ) RETURN
!     mode.ne.0
      ELSEIF ( Lwork<l2*(Nlon*Nt+MAX0(3*Nlat,Nlon)) ) THEN
         RETURN
      ENDIF
      Ierror = 0
!     starting address  fft values
      ifft = Nlat + 2*Nlat*late + 3*(l*(l-1)/2+(Nlat-l)*(l-1)) + 1
!     set pointers for internal storage of g and legendre polys
      ipmn = lat*Nlon*Nt + 1
      CALL SHSGC1(Nlat,Nlon,l,lat,Mode,G,Idg,Jdg,Nt,A,B,Mdab,Ndab,      &
                & Wshsgc,Wshsgc(ifft),late,Work(ipmn),Work)
    END SUBROUTINE SHSGC

    
    SUBROUTINE SHSGC1(Nlat,Nlon,L,Lat,Mode,Gs,Idg,Jdg,Nt,A,B,Mdab,    &
                      & Ndab,W,Wfft,Late,Pmn,G)
      IMPLICIT NONE
      REAL A , B , G , Gs , Pmn , t1 , t2 , t3 , t4 , W , Wfft
      INTEGER i , Idg , is , j , Jdg , k , km , L , Lat , Late , lm1 ,  &
            & lp1 , m , Mdab , meo , Mode , mp1 , mp2 , ms , Ndab
      INTEGER nl2 , Nlat , Nlon , np1 , ns , Nt
      DIMENSION Gs(Idg,Jdg,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION W(1) , Pmn(Nlat,Late,3) , G(Lat,Nlon,Nt) , Wfft(1)
!     reconstruct fourier coefficients in g on gaussian grid
!     using coefficients in a,b
!     set m+1 limit for b coefficient calculation
      lm1 = L
      IF ( Nlon==L+L-2 ) lm1 = L - 1
!     initialize to zero
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               G(i,j,k) = 0.0
            ENDDO
         ENDDO
      ENDDO
      IF ( Mode==0 ) THEN
!     set first column in g
         m = 0
!     compute pmn for all i and n=m,...,l-1
         CALL LEGIN(Mode,L,Nlat,m,W,Pmn,km)
         DO k = 1 , Nt
!     n even
            DO np1 = 1 , Nlat , 2
               DO i = 1 , Late
                  G(i,1,k) = G(i,1,k) + A(1,np1,k)*Pmn(np1,i,km)
               ENDDO
            ENDDO
!     n odd
            nl2 = Nlat/2
            DO np1 = 2 , Nlat , 2
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  G(is,1,k) = G(is,1,k) + A(1,np1,k)*Pmn(np1,i,km)
               ENDDO
            ENDDO
!     restore m=0 coefficents (reverse implicit even/odd reduction)
            DO i = 1 , nl2
               is = Nlat - i + 1
               t1 = G(i,1,k)
               t3 = G(is,1,k)
               G(i,1,k) = t1 + t3
               G(is,1,k) = t1 - t3
            ENDDO
         ENDDO
!     sweep  columns of g for which b is available
         DO mp1 = 2 , lm1
            m = mp1 - 1
            mp2 = m + 2
!     compute pmn for all i and n=m,...,l-1
            CALL LEGIN(Mode,L,Nlat,m,W,Pmn,km)
            DO k = 1 , Nt
!     for n-m even store (g(i,p,k)+g(nlat-i+1,p,k))/2 in g(i,p,k) p=2*m,
!     for i=1,...,late
               DO np1 = mp1 , Nlat , 2
                  DO i = 1 , Late
                     G(i,2*m,k) = G(i,2*m,k) + A(mp1,np1,k)             &
                                & *Pmn(np1,i,km)
                     G(i,2*m+1,k) = G(i,2*m+1,k) + B(mp1,np1,k)         &
                                  & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
!     for n-m odd store g(i,p,k)-g(nlat-i+1,p,k) in g(nlat-i+1,p,k)
!     for i=1,...,nlat/2 (p=2*m,p=2*m+1)
               DO np1 = mp2 , Nlat , 2
                  DO i = 1 , nl2
                     is = Nlat - i + 1
                     G(is,2*m,k) = G(is,2*m,k) + A(mp1,np1,k)           &
                                 & *Pmn(np1,i,km)
                     G(is,2*m+1,k) = G(is,2*m+1,k) + B(mp1,np1,k)       &
                                   & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
!     now set fourier coefficients using even-odd reduction above
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  t1 = G(i,2*m,k)
                  t2 = G(i,2*m+1,k)
                  t3 = G(is,2*m,k)
                  t4 = G(is,2*m+1,k)
                  G(i,2*m,k) = t1 + t3
                  G(i,2*m+1,k) = t2 + t4
                  G(is,2*m,k) = t1 - t3
                  G(is,2*m+1,k) = t2 - t4
               ENDDO
            ENDDO
         ENDDO
!     set last column (using a only)
         IF ( Nlon==L+L-2 ) THEN
            m = L - 1
            CALL LEGIN(Mode,L,Nlat,m,W,Pmn,km)
            DO k = 1 , Nt
!     n-m even
               DO np1 = L , Nlat , 2
                  DO i = 1 , Late
                     G(i,Nlon,k) = G(i,Nlon,k) + 2.0*A(L,np1,k)         &
                                 & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
               lp1 = L + 1
!     n-m odd
               DO np1 = lp1 , Nlat , 2
                  DO i = 1 , nl2
                     is = Nlat - i + 1
                     G(is,Nlon,k) = G(is,Nlon,k) + 2.0*A(L,np1,k)       &
                                  & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  t1 = G(i,Nlon,k)
                  t3 = G(is,Nlon,k)
                  G(i,Nlon,k) = t1 + t3
                  G(is,Nlon,k) = t1 - t3
               ENDDO
            ENDDO
         ENDIF
      ELSE
!     half sphere (mode.ne.0)
!     set first column in g
         m = 0
         meo = 1
         IF ( Mode==1 ) meo = 2
         ms = m + meo
!     compute pmn for all i and n=m,...,l-1
         CALL LEGIN(Mode,L,Nlat,m,W,Pmn,km)
         DO k = 1 , Nt
            DO np1 = ms , Nlat , 2
               DO i = 1 , Late
                  G(i,1,k) = G(i,1,k) + A(1,np1,k)*Pmn(np1,i,km)
               ENDDO
            ENDDO
         ENDDO
!     sweep interior columns of g
         DO mp1 = 2 , lm1
            m = mp1 - 1
            ms = m + meo
!     compute pmn for all i and n=m,...,l-1
            CALL LEGIN(Mode,L,Nlat,m,W,Pmn,km)
            DO k = 1 , Nt
               DO np1 = ms , Nlat , 2
                  DO i = 1 , Late
                     G(i,2*m,k) = G(i,2*m,k) + A(mp1,np1,k)             &
                                & *Pmn(np1,i,km)
                     G(i,2*m+1,k) = G(i,2*m+1,k) + B(mp1,np1,k)         &
                                  & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
         IF ( Nlon==L+L-2 ) THEN
!     set last column
            m = L - 1
            CALL LEGIN(Mode,L,Nlat,m,W,Pmn,km)
            ns = L
            IF ( Mode==1 ) ns = L + 1
            DO k = 1 , Nt
               DO i = 1 , Late
                  DO np1 = ns , Nlat , 2
                     G(i,Nlon,k) = G(i,Nlon,k) + 2.0*A(L,np1,k)         &
                                 & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
      ENDIF
!     do inverse fourier transform
      DO k = 1 , Nt
         CALL HRFFTB(Lat,Nlon,G(1,1,k),Lat,Wfft,Pmn)
      ENDDO
!     scale output in gs
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               Gs(i,j,k) = 0.5*G(i,j,k)
            ENDDO
         ENDDO
      ENDDO
    END SUBROUTINE SHSGC1

    
    SUBROUTINE SHSGCI(Nlat,Nlon,Wshsgc,Lshsgc,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER i1 , i2 , i3 , i4 , i5 , i6 , i7 , idth , idwts , Ierror ,&
            & iw , l , l1 , l2 , late , Ldwork , Lshsgc , Nlat , Nlon
      REAL Wshsgc
!     this subroutine must be called before calling shsgc with
!     fixed nlat,nlon. it precomputes quantites such as the gaussian
!     points and weights, m=0,m=1 legendre polynomials, recursion
!     recursion coefficients.
      DIMENSION Wshsgc(Lshsgc)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+MOD(Nlat,2))/2
      l1 = l
      l2 = late
      Ierror = 3
!     check permanent work space length
      IF ( Lshsgc<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 4
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set pointers
      i1 = 1
      i2 = i1 + Nlat
      i3 = i2 + Nlat*late
      i4 = i3 + Nlat*late
      i5 = i4 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i6 = i5 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i7 = i6 + l*(l-1)/2 + (Nlat-l)*(l-1)
!     set indices in temp work for double precision gaussian wts and pts
      idth = 1
      idwts = idth + Nlat
      iw = idwts + Nlat
      CALL SHSGCI1(Nlat,Nlon,l,late,Wshsgc(i1),Wshsgc(i2),Wshsgc(i3),   &
                 & Wshsgc(i4),Wshsgc(i5),Wshsgc(i6),Wshsgc(i7),         &
                 & Dwork(idth),Dwork(idwts),Dwork(iw),Ierror)
      IF ( Ierror/=0 ) Ierror = 5
      END SUBROUTINE SHSGCI

      
      SUBROUTINE SHSGCI1(Nlat,Nlon,L,Late,Wts,P0n,P1n,Abel,Bbel,Cbel,   &
                       & Wfft,Dtheta,Dwts,Work,Ier)
      IMPLICIT NONE
      REAL Abel , Bbel , Cbel , P0n , P1n , Wfft , Wts
      INTEGER i , Ier , imn , IMNDX , INDX , L , Late , lw , m , mlim , &
            & n , Nlat , Nlon , np1
      DIMENSION Wts(Nlat) , P0n(Nlat,Late) , P1n(Nlat,Late) , Abel(1) , &
              & Bbel(1) , Cbel(1) , Wfft(1) , Dtheta(Nlat) , Dwts(Nlat)
      DOUBLE PRECISION pb , Dtheta , Dwts , Work(*)
!     compute the nlat  gaussian points and weights, the
!     m=0,1 legendre polys for gaussian points and all n,
!     and the legendre recursion coefficients
!     define index function used in storing
!     arrays for recursion coefficients (functions of (m,n))
!     the index function indx(m,n) is defined so that
!     the pairs (m,n) map to [1,2,...,indx(l-1,l-1)] with no
!     "holes" as m varies from 2 to n and n varies from 2 to l-1.
!     (m=0,1 are set from p0n,p1n for all n)
!     define for 2.le.n.le.l-1
      INDX(m,n) = (n-1)*(n-2)/2 + m - 1
!     define index function for l.le.n.le.nlat
      IMNDX(m,n) = L*(L-1)/2 + (n-L-1)*(L-1) + m - 1
!     preset quantites for fourier transform
      CALL HRFFTI(Nlon,Wfft)
!     compute double precision gaussian points and weights
!     lw = 4*nlat*(nlat+1)+2
      lw = Nlat*(Nlat+2)
      CALL GAQD(Nlat,Dtheta,Dwts,Work,lw,Ier)
      IF ( Ier/=0 ) RETURN
!     store gaussian weights single precision to save computation
!     in inner loops in analysis
      DO i = 1 , Nlat
         Wts(i) = Dwts(i)
      ENDDO
!     initialize p0n,p1n using double precision dnlfk,dnlft
      DO np1 = 1 , Nlat
         DO i = 1 , Late
            P0n(np1,i) = 0.0
            P1n(np1,i) = 0.0
         ENDDO
      ENDDO
!     compute m=n=0 legendre polynomials for all theta(i)
      np1 = 1
      n = 0
      m = 0
      CALL DNLFK(m,n,Work)
      DO i = 1 , Late
         CALL DNLFT(m,n,Dtheta(i),Work,pb)
         P0n(1,i) = pb
      ENDDO
!     compute p0n,p1n for all theta(i) when n.gt.0
      DO np1 = 2 , Nlat
         n = np1 - 1
         m = 0
         CALL DNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DNLFT(m,n,Dtheta(i),Work,pb)
            P0n(np1,i) = pb
         ENDDO
!     compute m=1 legendre polynomials for all n and theta(i)
         m = 1
         CALL DNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DNLFT(m,n,Dtheta(i),Work,pb)
            P1n(np1,i) = pb
         ENDDO
      ENDDO
!     compute and store swarztrauber recursion coefficients
!     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      DO n = 2 , Nlat
         mlim = MIN0(n,L)
         DO m = 2 , mlim
            imn = INDX(m,n)
            IF ( n>=L ) imn = IMNDX(m,n)
            Abel(imn) = SQRT(FLOAT((2*n+1)*(m+n-2)*(m+n-3))/FLOAT(((2*n-&
                      & 3)*(m+n-1)*(m+n))))
            Bbel(imn) = SQRT(FLOAT((2*n+1)*(n-m-1)*(n-m))/FLOAT(((2*n-3)&
                      & *(m+n-1)*(m+n))))
            Cbel(imn) = SQRT(FLOAT((n-m+1)*(n-m+2))/FLOAT(((n+m-1)*(n+m)&
                      & )))
         ENDDO
      ENDDO
      END SUBROUTINE SHSGCI1


      SUBROUTINE DSHSGC(Nlat,Nlon,Mode,Nt,G,Idg,Jdg,A,B,Mdab,Ndab,Wshsgc,&
                     & Lshsgc,Work,Lwork,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , G , Work , Wshsgc
      INTEGER Idg , Ierror , ifft , ipmn , Jdg , l , l1 , l2 , lat ,    &
            & late , Lshsgc , Lwork , Mdab , Mode , Ndab , Nlat , Nlon ,&
            & Nt
!     subroutine shsgc performs the spherical harmonic synthesis on
!     a gaussian grid using the coefficients in array(s) a,b and returns
!     the results in array(s) g.  the legendre polynomials are computed
!     as needed in this version.
!
      DIMENSION G(Idg,Jdg,1) , A(Mdab,Ndab,1) , B(Mdab,Ndab,1) ,        &
              & Wshsgc(Lshsgc) , Work(Lwork)
!     check input parameters
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Mode<0 .OR. Mode>2 ) RETURN
      Ierror = 4
      IF ( Nt<1 ) RETURN
!     set limit for m iin a(m,n),b(m,n) computation
      l = MIN0((Nlon+2)/2,Nlat)
!     set gaussian point nearest equator pointer
      late = (Nlat+MOD(Nlat,2))/2
!     set number of grid points for analysis/synthesis
      lat = Nlat
      IF ( Mode/=0 ) lat = late
      Ierror = 5
      IF ( Idg<lat ) RETURN
      Ierror = 6
      IF ( Jdg<Nlon ) RETURN
      Ierror = 7
      IF ( Mdab<l ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      l1 = l
      l2 = late
      Ierror = 9
!     check permanent work space length
      IF ( Lshsgc<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 10
!     check temporary work space length
      IF ( Mode==0 ) THEN
         IF ( Lwork<Nlat*(Nlon*Nt+MAX0(3*l2,Nlon)) ) RETURN
!     mode.ne.0
      ELSEIF ( Lwork<l2*(Nlon*Nt+MAX0(3*Nlat,Nlon)) ) THEN
         RETURN
      ENDIF
      Ierror = 0
!     starting address  fft values
      ifft = Nlat + 2*Nlat*late + 3*(l*(l-1)/2+(Nlat-l)*(l-1)) + 1
!     set pointers for internal storage of g and legendre polys
      ipmn = lat*Nlon*Nt + 1
      CALL DSHSGC1(Nlat,Nlon,l,lat,Mode,G,Idg,Jdg,Nt,A,B,Mdab,Ndab,      &
                & Wshsgc,Wshsgc(ifft),late,Work(ipmn),Work)
    END SUBROUTINE DSHSGC

    
    SUBROUTINE DSHSGC1(Nlat,Nlon,L,Lat,Mode,Gs,Idg,Jdg,Nt,A,B,Mdab,    &
                      & Ndab,W,Wfft,Late,Pmn,G)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , G , Gs , Pmn , t1 , t2 , t3 , t4 , W , Wfft
      INTEGER i , Idg , is , j , Jdg , k , km , L , Lat , Late , lm1 ,  &
            & lp1 , m , Mdab , meo , Mode , mp1 , mp2 , ms , Ndab
      INTEGER nl2 , Nlat , Nlon , np1 , ns , Nt
      DIMENSION Gs(Idg,Jdg,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION W(1) , Pmn(Nlat,Late,3) , G(Lat,Nlon,Nt) , Wfft(1)
!     reconstruct fourier coefficients in g on gaussian grid
!     using coefficients in a,b
!     set m+1 limit for b coefficient calculation
      lm1 = L
      IF ( Nlon==L+L-2 ) lm1 = L - 1
!     initialize to zero
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               G(i,j,k) = 0.0
            ENDDO
         ENDDO
      ENDDO
      IF ( Mode==0 ) THEN
!     set first column in g
         m = 0
!     compute pmn for all i and n=m,...,l-1
         CALL DLEGIN(Mode,L,Nlat,m,W,Pmn,km)
         DO k = 1 , Nt
!     n even
            DO np1 = 1 , Nlat , 2
               DO i = 1 , Late
                  G(i,1,k) = G(i,1,k) + A(1,np1,k)*Pmn(np1,i,km)
               ENDDO
            ENDDO
!     n odd
            nl2 = Nlat/2
            DO np1 = 2 , Nlat , 2
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  G(is,1,k) = G(is,1,k) + A(1,np1,k)*Pmn(np1,i,km)
               ENDDO
            ENDDO
!     restore m=0 coefficents (reverse implicit even/odd reduction)
            DO i = 1 , nl2
               is = Nlat - i + 1
               t1 = G(i,1,k)
               t3 = G(is,1,k)
               G(i,1,k) = t1 + t3
               G(is,1,k) = t1 - t3
            ENDDO
         ENDDO
!     sweep  columns of g for which b is available
         DO mp1 = 2 , lm1
            m = mp1 - 1
            mp2 = m + 2
!     compute pmn for all i and n=m,...,l-1
            CALL LEGIN(Mode,L,Nlat,m,W,Pmn,km)
            DO k = 1 , Nt
!     for n-m even store (g(i,p,k)+g(nlat-i+1,p,k))/2 in g(i,p,k) p=2*m,
!     for i=1,...,late
               DO np1 = mp1 , Nlat , 2
                  DO i = 1 , Late
                     G(i,2*m,k) = G(i,2*m,k) + A(mp1,np1,k)             &
                                & *Pmn(np1,i,km)
                     G(i,2*m+1,k) = G(i,2*m+1,k) + B(mp1,np1,k)         &
                                  & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
!     for n-m odd store g(i,p,k)-g(nlat-i+1,p,k) in g(nlat-i+1,p,k)
!     for i=1,...,nlat/2 (p=2*m,p=2*m+1)
               DO np1 = mp2 , Nlat , 2
                  DO i = 1 , nl2
                     is = Nlat - i + 1
                     G(is,2*m,k) = G(is,2*m,k) + A(mp1,np1,k)           &
                                 & *Pmn(np1,i,km)
                     G(is,2*m+1,k) = G(is,2*m+1,k) + B(mp1,np1,k)       &
                                   & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
!     now set fourier coefficients using even-odd reduction above
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  t1 = G(i,2*m,k)
                  t2 = G(i,2*m+1,k)
                  t3 = G(is,2*m,k)
                  t4 = G(is,2*m+1,k)
                  G(i,2*m,k) = t1 + t3
                  G(i,2*m+1,k) = t2 + t4
                  G(is,2*m,k) = t1 - t3
                  G(is,2*m+1,k) = t2 - t4
               ENDDO
            ENDDO
         ENDDO
!     set last column (using a only)
         IF ( Nlon==L+L-2 ) THEN
            m = L - 1
            CALL DLEGIN(Mode,L,Nlat,m,W,Pmn,km)
            DO k = 1 , Nt
!     n-m even
               DO np1 = L , Nlat , 2
                  DO i = 1 , Late
                     G(i,Nlon,k) = G(i,Nlon,k) + 2.0*A(L,np1,k)         &
                                 & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
               lp1 = L + 1
!     n-m odd
               DO np1 = lp1 , Nlat , 2
                  DO i = 1 , nl2
                     is = Nlat - i + 1
                     G(is,Nlon,k) = G(is,Nlon,k) + 2.0*A(L,np1,k)       &
                                  & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  t1 = G(i,Nlon,k)
                  t3 = G(is,Nlon,k)
                  G(i,Nlon,k) = t1 + t3
                  G(is,Nlon,k) = t1 - t3
               ENDDO
            ENDDO
         ENDIF
      ELSE
!     half sphere (mode.ne.0)
!     set first column in g
         m = 0
         meo = 1
         IF ( Mode==1 ) meo = 2
         ms = m + meo
!     compute pmn for all i and n=m,...,l-1
         CALL DLEGIN(Mode,L,Nlat,m,W,Pmn,km)
         DO k = 1 , Nt
            DO np1 = ms , Nlat , 2
               DO i = 1 , Late
                  G(i,1,k) = G(i,1,k) + A(1,np1,k)*Pmn(np1,i,km)
               ENDDO
            ENDDO
         ENDDO
!     sweep interior columns of g
         DO mp1 = 2 , lm1
            m = mp1 - 1
            ms = m + meo
!     compute pmn for all i and n=m,...,l-1
            CALL DLEGIN(Mode,L,Nlat,m,W,Pmn,km)
            DO k = 1 , Nt
               DO np1 = ms , Nlat , 2
                  DO i = 1 , Late
                     G(i,2*m,k) = G(i,2*m,k) + A(mp1,np1,k)             &
                                & *Pmn(np1,i,km)
                     G(i,2*m+1,k) = G(i,2*m+1,k) + B(mp1,np1,k)         &
                                  & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
         IF ( Nlon==L+L-2 ) THEN
!     set last column
            m = L - 1
            CALL DLEGIN(Mode,L,Nlat,m,W,Pmn,km)
            ns = L
            IF ( Mode==1 ) ns = L + 1
            DO k = 1 , Nt
               DO i = 1 , Late
                  DO np1 = ns , Nlat , 2
                     G(i,Nlon,k) = G(i,Nlon,k) + 2.0*A(L,np1,k)         &
                                 & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
      ENDIF
!     do inverse fourier transform
      DO k = 1 , Nt
         CALL DHRFFTB(Lat,Nlon,G(1,1,k),Lat,Wfft,Pmn)
      ENDDO
!     scale output in gs
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               Gs(i,j,k) = 0.5*G(i,j,k)
            ENDDO
         ENDDO
      ENDDO
    END SUBROUTINE DSHSGC1

    
    SUBROUTINE DSHSGCI(Nlat,Nlon,Wshsgc,Lshsgc,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER i1 , i2 , i3 , i4 , i5 , i6 , i7 , idth , idwts , Ierror ,&
            & iw , l , l1 , l2 , late , Ldwork , Lshsgc , Nlat , Nlon
      DOUBLE PRECISION Wshsgc
!     this subroutine must be called before calling shsgc with
!     fixed nlat,nlon. it precomputes quantites such as the gaussian
!     points and weights, m=0,m=1 legendre polynomials, recursion
!     recursion coefficients.
      DIMENSION Wshsgc(Lshsgc)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+MOD(Nlat,2))/2
      l1 = l
      l2 = late
      Ierror = 3
!     check permanent work space length
      IF ( Lshsgc<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 4
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set pointers
      i1 = 1
      i2 = i1 + Nlat
      i3 = i2 + Nlat*late
      i4 = i3 + Nlat*late
      i5 = i4 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i6 = i5 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i7 = i6 + l*(l-1)/2 + (Nlat-l)*(l-1)
!     set indices in temp work for double precision gaussian wts and pts
      idth = 1
      idwts = idth + Nlat
      iw = idwts + Nlat
      CALL DSHSGCI1(Nlat,Nlon,l,late,Wshsgc(i1),Wshsgc(i2),Wshsgc(i3),   &
                 & Wshsgc(i4),Wshsgc(i5),Wshsgc(i6),Wshsgc(i7),         &
                 & Dwork(idth),Dwork(idwts),Dwork(iw),Ierror)
      IF ( Ierror/=0 ) Ierror = 5
      END SUBROUTINE DSHSGCI

      
      SUBROUTINE DSHSGCI1(Nlat,Nlon,L,Late,Wts,P0n,P1n,Abel,Bbel,Cbel,   &
                       & Wfft,Dtheta,Dwts,Work,Ier)
      IMPLICIT NONE
      DOUBLE PRECISION Abel , Bbel , Cbel , P0n , P1n , Wfft , Wts
      INTEGER i , Ier , imn , IMNDX , INDX , L , Late , lw , m , mlim , &
            & n , Nlat , Nlon , np1
      DIMENSION Wts(Nlat) , P0n(Nlat,Late) , P1n(Nlat,Late) , Abel(1) , &
              & Bbel(1) , Cbel(1) , Wfft(1) , Dtheta(Nlat) , Dwts(Nlat)
      DOUBLE PRECISION pb , Dtheta , Dwts , Work(*)
!     compute the nlat  gaussian points and weights, the
!     m=0,1 legendre polys for gaussian points and all n,
!     and the legendre recursion coefficients
!     define index function used in storing
!     arrays for recursion coefficients (functions of (m,n))
!     the index function indx(m,n) is defined so that
!     the pairs (m,n) map to [1,2,...,indx(l-1,l-1)] with no
!     "holes" as m varies from 2 to n and n varies from 2 to l-1.
!     (m=0,1 are set from p0n,p1n for all n)
!     define for 2.le.n.le.l-1
      INDX(m,n) = (n-1)*(n-2)/2 + m - 1
!     define index function for l.le.n.le.nlat
      IMNDX(m,n) = L*(L-1)/2 + (n-L-1)*(L-1) + m - 1
!     preset quantites for fourier transform
      CALL DHRFFTI(Nlon,Wfft)
!     compute double precision gaussian points and weights
!     lw = 4*nlat*(nlat+1)+2
      lw = Nlat*(Nlat+2)
      CALL DGAQD(Nlat,Dtheta,Dwts,Work,lw,Ier)
      IF ( Ier/=0 ) RETURN
!     store gaussian weights single precision to save computation
!     in inner loops in analysis
      DO i = 1 , Nlat
         Wts(i) = Dwts(i)
      ENDDO
!     initialize p0n,p1n using double precision dnlfk,dnlft
      DO np1 = 1 , Nlat
         DO i = 1 , Late
            P0n(np1,i) = 0.0
            P1n(np1,i) = 0.0
         ENDDO
      ENDDO
!     compute m=n=0 legendre polynomials for all theta(i)
      np1 = 1
      n = 0
      m = 0
      CALL DDNLFK(m,n,Work)
      DO i = 1 , Late
         CALL DDNLFT(m,n,Dtheta(i),Work,pb)
         P0n(1,i) = pb
      ENDDO
!     compute p0n,p1n for all theta(i) when n.gt.0
      DO np1 = 2 , Nlat
         n = np1 - 1
         m = 0
         CALL DDNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DDNLFT(m,n,Dtheta(i),Work,pb)
            P0n(np1,i) = pb
         ENDDO
!     compute m=1 legendre polynomials for all n and theta(i)
         m = 1
         CALL DDNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DDNLFT(m,n,Dtheta(i),Work,pb)
            P1n(np1,i) = pb
         ENDDO
      ENDDO
!     compute and store swarztrauber recursion coefficients
!     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      DO n = 2 , Nlat
         mlim = MIN0(n,L)
         DO m = 2 , mlim
            imn = INDX(m,n)
            IF ( n>=L ) imn = IMNDX(m,n)
            Abel(imn) = SQRT(FLOAT((2*n+1)*(m+n-2)*(m+n-3))/FLOAT(((2*n-&
                      & 3)*(m+n-1)*(m+n))))
            Bbel(imn) = SQRT(FLOAT((2*n+1)*(n-m-1)*(n-m))/FLOAT(((2*n-3)&
                      & *(m+n-1)*(m+n))))
            Cbel(imn) = SQRT(FLOAT((n-m+1)*(n-m+2))/FLOAT(((n+m-1)*(n+m)&
                      & )))
         ENDDO
      ENDDO
      END SUBROUTINE DSHSGCI1

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file shigc.f
!
!     this file contains code and documentation for subroutine shigc
!
! ... files which must be loaded with shigc.f
!
!     sphcom.f, hrfft.f, gaqd.f
!
!     3/6/98
!
! *** shigc is functionally the same as shagci or shsgci.  It
!     it included in spherepack3.0 because legacy codes, using
!     the older version of spherepack call shigc to initialize
!     the saved work space wshigc, for either shagc or shsgc
!
!     subroutine shigc(nlat,nlon,wshigc,lshigc,dwork,ldwork,ierror)
!
!     subroutine shigc initializes the array wshigc which can then
!     be used repeatedly by subroutines shsgc or shagc. it precomputes
!     and stores in wshigc quantities such as gaussian weights,
!     legendre polynomial coefficients, and fft trigonometric tables.
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are compu
!            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid poi
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than or equal to 4. the efficiency of the computation is
!            improved when nlon is a product of small prime numbers.
!
!     wshigc an array which must be initialized by subroutine shigc.
!            once initialized, wshigc can be used repeatedly by shsgc
!            or shagc as long as nlat and nlon remain unchanged.  wshigc
!            must not be altered between calls of shsgc or shagc.
!
!     lshigc the dimension of the array wshigc as it appears in the
!            program that calls shsgc or shagc. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshigc must be at least
!
!                  nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
!
!     dwork  a double precision work array that does not have to be saved.
!
!     ldwork the dimension of the array dwork as it appears in the
!            program that calls shigc. ldwork must be at least
!
!               nlat*(nlat+4)
!
!     output parameter
!
!     wshigc an array which must be initialized before calling shsgc or shagc.
!            once initialized, wshigc can be used repeatedly by shsgc or shagc
!            as long as nlat and nlon remain unchanged.  wshigc must not
!            altered between calls of shsgc or shagc
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of lshigc
!            = 4  error in the specification of ldwork
!            = 5  failure in gaqd to compute gaussian points
!                 (due to failure in eigenvalue routine)
!
!
! ****************************************************************
      SUBROUTINE SHIGC(Nlat,Nlon,Wshigc,Lshigc,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER i1 , i2 , i3 , i4 , i5 , i6 , i7 , idth , idwts , Ierror ,&
            & iw , l , l1 , l2 , late , Ldwork , Lshigc , Nlat , Nlon
      REAL Wshigc
!     this subroutine must be called before calling shsgc/shagc with
!     fixed nlat,nlon. it precomputes quantites such as the gaussian
!     points and weights, m=0,m=1 legendre polynomials, recursion
!     recursion coefficients.
      DIMENSION Wshigc(Lshigc)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+MOD(Nlat,2))/2
      l1 = l
      l2 = late
      Ierror = 3
!     check permanent work space length
      IF ( Lshigc<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 4
!     if (lwork.lt.4*nlat*(nlat+2)+2) return
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set pointers
      i1 = 1
      i2 = i1 + Nlat
      i3 = i2 + Nlat*late
      i4 = i3 + Nlat*late
      i5 = i4 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i6 = i5 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i7 = i6 + l*(l-1)/2 + (Nlat-l)*(l-1)
!     set indices in temp work for double precision gaussian wts and pts
      idth = 1
!     idwts = idth+2*nlat
!     iw = idwts+2*nlat
      idwts = idth + Nlat
      iw = idwts + Nlat
      CALL SHIGC1(Nlat,Nlon,l,late,Wshigc(i1),Wshigc(i2),Wshigc(i3),    &
                & Wshigc(i4),Wshigc(i5),Wshigc(i6),Wshigc(i7),          &
                & Dwork(idth),Dwork(idwts),Dwork(iw),Ierror)
      IF ( Ierror/=0 ) Ierror = 5
    END SUBROUTINE SHIGC


    SUBROUTINE SHIGC1(Nlat,Nlon,L,Late,Wts,P0n,P1n,Abel,Bbel,Cbel,    &
                      & Wfft,Dtheta,Dwts,Work,Ier)
      IMPLICIT NONE
      REAL Abel , Bbel , Cbel , P0n , P1n , Wfft , Wts
      INTEGER i , Ier , imn , IMNDX , INDX , L , Late , lw , m , mlim , &
            & n , Nlat , Nlon , np1
      DIMENSION Wts(Nlat) , P0n(Nlat,Late) , P1n(Nlat,Late) , Abel(1) , &
              & Bbel(1) , Cbel(1) , Wfft(1) , Dtheta(Nlat) , Dwts(Nlat)
      DOUBLE PRECISION pb , Dtheta , Dwts , Work(*)
!     compute the nlat  gaussian points and weights, the
!     m=0,1 legendre polys for gaussian points and all n,
!     and the legendre recursion coefficients
!     define index function used in storing
!     arrays for recursion coefficients (functions of (m,n))
!     the index function indx(m,n) is defined so that
!     the pairs (m,n) map to [1,2,...,indx(l-1,l-1)] with no
!     "holes" as m varies from 2 to n and n varies from 2 to l-1.
!     (m=0,1 are set from p0n,p1n for all n)
!     define for 2.le.n.le.l-1
      INDX(m,n) = (n-1)*(n-2)/2 + m - 1
!     define index function for l.le.n.le.nlat
      IMNDX(m,n) = L*(L-1)/2 + (n-L-1)*(L-1) + m - 1
!     preset quantites for fourier transform
      CALL HRFFTI(Nlon,Wfft)
!     compute double precision gaussian points and weights
!     lw = 4*nlat*(nlat+1)+2
      lw = Nlat*(Nlat+2)
      CALL GAQD(Nlat,Dtheta,Dwts,Work,lw,Ier)
      IF ( Ier/=0 ) RETURN
!     store gaussian weights single precision to save computation
!     in inner loops in analysis
      DO i = 1 , Nlat
         Wts(i) = Dwts(i)
      ENDDO
!     initialize p0n,p1n using double precision dnlfk,dnlft
      DO np1 = 1 , Nlat
         DO i = 1 , Late
            P0n(np1,i) = 0.0
            P1n(np1,i) = 0.0
         ENDDO
      ENDDO
!     compute m=n=0 legendre polynomials for all theta(i)
      np1 = 1
      n = 0
      m = 0
      CALL DNLFK(m,n,Work)
      DO i = 1 , Late
         CALL DNLFT(m,n,Dtheta(i),Work,pb)
         P0n(1,i) = pb
      ENDDO
!     compute p0n,p1n for all theta(i) when n.gt.0
      DO np1 = 2 , Nlat
         n = np1 - 1
         m = 0
         CALL DNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DNLFT(m,n,Dtheta(i),Work,pb)
            P0n(np1,i) = pb
         ENDDO
!     compute m=1 legendre polynomials for all n and theta(i)
         m = 1
         CALL DNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DNLFT(m,n,Dtheta(i),Work,pb)
            P1n(np1,i) = pb
         ENDDO
      ENDDO
!     compute and store swarztrauber recursion coefficients
!     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      DO n = 2 , Nlat
         mlim = MIN0(n,L)
         DO m = 2 , mlim
            imn = INDX(m,n)
            IF ( n>=L ) imn = IMNDX(m,n)
            Abel(imn) = SQRT(FLOAT((2*n+1)*(m+n-2)*(m+n-3))/FLOAT(((2*n-&
                      & 3)*(m+n-1)*(m+n))))
            Bbel(imn) = SQRT(FLOAT((2*n+1)*(n-m-1)*(n-m))/FLOAT(((2*n-3)&
                      & *(m+n-1)*(m+n))))
            Cbel(imn) = SQRT(FLOAT((n-m+1)*(n-m+2))/FLOAT(((n+m-1)*(n+m)&
                      & )))
         ENDDO
      ENDDO
      END SUBROUTINE SHIGC1


      SUBROUTINE DSHIGC(Nlat,Nlon,Wshigc,Lshigc,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER i1 , i2 , i3 , i4 , i5 , i6 , i7 , idth , idwts , Ierror ,&
            & iw , l , l1 , l2 , late , Ldwork , Lshigc , Nlat , Nlon
      DOUBLE PRECISION Wshigc
!     this subroutine must be called before calling shsgc/shagc with
!     fixed nlat,nlon. it precomputes quantites such as the gaussian
!     points and weights, m=0,m=1 legendre polynomials, recursion
!     recursion coefficients.
      DIMENSION Wshigc(Lshigc)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+MOD(Nlat,2))/2
      l1 = l
      l2 = late
      Ierror = 3
!     check permanent work space length
      IF ( Lshigc<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 4
!     if (lwork.lt.4*nlat*(nlat+2)+2) return
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set pointers
      i1 = 1
      i2 = i1 + Nlat
      i3 = i2 + Nlat*late
      i4 = i3 + Nlat*late
      i5 = i4 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i6 = i5 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i7 = i6 + l*(l-1)/2 + (Nlat-l)*(l-1)
!     set indices in temp work for double precision gaussian wts and pts
      idth = 1
!     idwts = idth+2*nlat
!     iw = idwts+2*nlat
      idwts = idth + Nlat
      iw = idwts + Nlat
      CALL DSHIGC1(Nlat,Nlon,l,late,Wshigc(i1),Wshigc(i2),Wshigc(i3),    &
                & Wshigc(i4),Wshigc(i5),Wshigc(i6),Wshigc(i7),          &
                & Dwork(idth),Dwork(idwts),Dwork(iw),Ierror)
      IF ( Ierror/=0 ) Ierror = 5
    END SUBROUTINE DSHIGC


      SUBROUTINE DSHIGC1(Nlat,Nlon,L,Late,Wts,P0n,P1n,Abel,Bbel,Cbel,    &
                      & Wfft,Dtheta,Dwts,Work,Ier)
      IMPLICIT NONE
      DOUBLE PRECISION Abel , Bbel , Cbel , P0n , P1n , Wfft , Wts
      INTEGER i , Ier , imn , IMNDX , INDX , L , Late , lw , m , mlim , &
            & n , Nlat , Nlon , np1
      DIMENSION Wts(Nlat) , P0n(Nlat,Late) , P1n(Nlat,Late) , Abel(1) , &
              & Bbel(1) , Cbel(1) , Wfft(1) , Dtheta(Nlat) , Dwts(Nlat)
      DOUBLE PRECISION pb , Dtheta , Dwts , Work(*)
!     compute the nlat  gaussian points and weights, the
!     m=0,1 legendre polys for gaussian points and all n,
!     and the legendre recursion coefficients
!     define index function used in storing
!     arrays for recursion coefficients (functions of (m,n))
!     the index function indx(m,n) is defined so that
!     the pairs (m,n) map to [1,2,...,indx(l-1,l-1)] with no
!     "holes" as m varies from 2 to n and n varies from 2 to l-1.
!     (m=0,1 are set from p0n,p1n for all n)
!     define for 2.le.n.le.l-1
      INDX(m,n) = (n-1)*(n-2)/2 + m - 1
!     define index function for l.le.n.le.nlat
      IMNDX(m,n) = L*(L-1)/2 + (n-L-1)*(L-1) + m - 1
!     preset quantites for fourier transform
      CALL DHRFFTI(Nlon,Wfft)
!     compute double precision gaussian points and weights
!     lw = 4*nlat*(nlat+1)+2
      lw = Nlat*(Nlat+2)
      CALL DGAQD(Nlat,Dtheta,Dwts,Work,lw,Ier)
      IF ( Ier/=0 ) RETURN
!     store gaussian weights single precision to save computation
!     in inner loops in analysis
      DO i = 1 , Nlat
         Wts(i) = Dwts(i)
      ENDDO
!     initialize p0n,p1n using double precision dnlfk,dnlft
      DO np1 = 1 , Nlat
         DO i = 1 , Late
            P0n(np1,i) = 0.0
            P1n(np1,i) = 0.0
         ENDDO
      ENDDO
!     compute m=n=0 legendre polynomials for all theta(i)
      np1 = 1
      n = 0
      m = 0
      CALL DDNLFK(m,n,Work)
      DO i = 1 , Late
         CALL DDNLFT(m,n,Dtheta(i),Work,pb)
         P0n(1,i) = pb
      ENDDO
!     compute p0n,p1n for all theta(i) when n.gt.0
      DO np1 = 2 , Nlat
         n = np1 - 1
         m = 0
         CALL DDNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DDNLFT(m,n,Dtheta(i),Work,pb)
            P0n(np1,i) = pb
         ENDDO
!     compute m=1 legendre polynomials for all n and theta(i)
         m = 1
         CALL DDNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DDNLFT(m,n,Dtheta(i),Work,pb)
            P1n(np1,i) = pb
         ENDDO
      ENDDO
!     compute and store swarztrauber recursion coefficients
!     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      DO n = 2 , Nlat
         mlim = MIN0(n,L)
         DO m = 2 , mlim
            imn = INDX(m,n)
            IF ( n>=L ) imn = IMNDX(m,n)
            Abel(imn) = SQRT(FLOAT((2*n+1)*(m+n-2)*(m+n-3))/FLOAT(((2*n-&
                      & 3)*(m+n-1)*(m+n))))
            Bbel(imn) = SQRT(FLOAT((2*n+1)*(n-m-1)*(n-m))/FLOAT(((2*n-3)&
                      & *(m+n-1)*(m+n))))
            Cbel(imn) = SQRT(FLOAT((n-m+1)*(n-m+2))/FLOAT(((n+m-1)*(n+m)&
                      & )))
         ENDDO
      ENDDO
      END SUBROUTINE DSHIGC1

!
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file sfvpes.f
!
!     this file includes documentation and code for
!     subroutine sfvpes          i
!
! ... files which must be loaded with sfvpes.f
!
!     sphcom.f, hrfft.f, vhaes.f, shses.f
!
!
!     subroutine sfvpes(nlat,nlon,isym,nt,sf,vp,idv,jdv,br,bi,cr,ci,
!    +                   mdb,ndb,wshses,lshses,work,lwork,ierror)
!
!     given the vector spherical harmonic coefficients br,bi,cr,ci,
!     computed by subroutine vhaes for a vector field (v,w), sfvpes
!     computes a scalar stream function sf and scalar velocity potential
!     vp for (v,w).  (v,w) is expressed in terms of sf and vp by the
!     helmholtz relations (in mathematical spherical coordinates):
!
!          v = -1/sint*d(vp)/dlambda + d(st)/dtheta
!
!          w =  1/sint*d(st)/dlambda + d(vp)/dtheta
!
!     where sint = sin(theta).  w is the east longitudinal and v
!     is the colatitudinal component of the vector field from which
!     br,bi,cr,ci were precomputed.  required associated legendre
!     polynomials are stored rather than recomputed as they are in
!     subroutine sfvpec. sf(i,j) and vp(i,j) are given at colatitude
!
!            theta(i) = (i-1)*pi/(nlat-1)
!
!     and east longitude
!
!            lambda(j) = (j-1)*2*pi/nlon
!
!     on the sphere.
!
!
!     input parameters
!
!     nlat   the number of colatitudes on the full sphere including the
!            poles. for example, nlat = 37 for a five degree grid.
!            nlat determines the grid increment in colatitude as
!            pi/(nlat-1).  if nlat is odd the equator is located at
!            grid point i=(nlat+1)/2. if nlat is even the equator is
!            located half way between points i=nlat/2 and i=nlat/2+1.
!            nlat must be at least 3. note: on the half sphere, the
!            number of grid points in the colatitudinal direction is
!            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater than
!            3.  the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!
!     isym   a parameter which determines whether the stream function and
!            velocity potential are computed on the full or half sphere
!            as follows:
!
!      = 0
!
!            the symmetries/antsymmetries described in isym=1,2 below
!            do not exist in (v,w) about the equator.  in this case sf
!            and vp are not necessarily symmetric or antisymmetric about
!            the equator.  sf and vp are computed on the entire sphere.
!            i.e., in arrays sf(i,j),vp(i,j) for i=1,...,nlat and
!            j=1,...,nlon.
!
!      = 1
!
!            w is antisymmetric and v is symmetric about the equator.
!            in this case sf is symmetric and vp antisymmetric about
!            the equator and are computed for the northern hemisphere
!            only.  i.e., if nlat is odd the sf(i,j),vp(i,j) are computed
!            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
!            even then sf(i,j),vp(i,j) are computed for i=1,...,nlat/2
!            and j=1,...,nlon.
!
!      = 2
!
!            w is symmetric and v is antisymmetric about the equator.
!            in this case sf is antisymmetric and vp symmetric about
!            the equator and are computed for the northern hemisphere
!            only.  i.e., if nlat is odd the sf(i,j),vp(i,j) are computed
!            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
!            even then sf(i,j),vp(i,j) are computed for i=1,...,nlat/2
!            and j=1,...,nlon.
!
!     nt     nt is the number of scalar and vector fields.  some
!            computational efficiency is obtained for multiple fields.
!            can be three dimensional corresponding to an indexed multiple
!            vector field.  in this case multiple scalar synthesis will
!            be performed to compute sf,vp for each field.  the
!            third index is the synthesis index which assumes the values
!            k=1,...,nt.  for a single synthesis set nt = 1.  the
!            description of the remaining parameters is simplified by
!            assuming that nt=1 or that all the arrays are two dimensional.
!
!     idv    the first dimension of the arrays sf,vp as it appears in
!            the program that calls sfvpes. if isym = 0 then idv
!            must be at least nlat.  if isym = 1 or 2 and nlat is
!            even then idv must be at least nlat/2. if isym = 1 or 2
!            and nlat is odd then idv must be at least (nlat+1)/2.
!
!     jdv    the second dimension of the arrays sf,vp as it appears in
!            the program that calls sfvpes. jdv must be at least nlon.
!
!     br,bi, two or three dimensional arrays (see input parameter nt)
!     cr,ci  that contain vector spherical harmonic coefficients
!            of the vector field (v,w) as computed by subroutine vhaec.
!
!     mdb    the first dimension of the arrays br,bi,cr,ci as it
!            appears in the program that calls sfvpes. mdb must be at
!            least min0(nlat,nlon/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndb    the second dimension of the arrays br,bi,cr,ci as it
!            appears in the program that calls sfvpes. ndb must be at
!            least nlat.
!
!     wshses an array which must be initialized by subroutine shsesi.
!            once initialized, wshses can be used repeatedly by sfvpes
!            as long as nlon and nlat remain unchanged.  wshses must
!            not bel altered between calls of sfvpes.
!
!
!     lshses the dimension of the array wshses as it appears in the
!            program that calls sfrvpes. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshses must be at least
!
!               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
!
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls sfvpes. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2                    if nlat is even or
!               l2 = (nlat+1)/2                if nlat is odd
!
!            if isym is zero then lwork must be at least
!
!               nlat*((nt+1)*nlon + 2*l2*nt+1)
!
!            if isym is nonzero then lwork must be at least
!
!               l2*((nt+1)*nlon + 2*nlat*nt) + nlat
!
!     **************************************************************
!
!     output parameters
!
!    sf,vp  two or three dimensional arrays (see input parameter nt)
!           that contains the stream function and velocity potential
!           of the vector field (v,w) whose coefficients br,bi,cr,ci
!           where computed by subroutine vhaec.  sf(i,j),vp(i,j)
!           are given at the colatitude point
!
!                theta(i) = (i-1)*pi/(nlat-1)
!
!           and longitude point
!
!                lambda(j) = (j-1)*2*pi/nlon
!
!           the index ranges are defined above at the input parameter isym.
!
!
!    ierror = 0  no errors
!           = 1  error in the specification of nlat
!           = 2  error in the specification of nlon
!           = 3  error in the specification of isym
!           = 4  error in the specification of nt
!           = 5  error in the specification of idv
!           = 6  error in the specification of jdv
!           = 7  error in the specification of mdb
!           = 8  error in the specification of ndb
!           = 9  error in the specification of lshses
!           = 10 error in the specification of lwork
! **********************************************************************
!
      SUBROUTINE SFVPES(Nlat,Nlon,Isym,Nt,Sf,Vp,Idv,Jdv,Br,Bi,Cr,Ci,Mdb,&
                      & Ndb,Wshses,Lshses,Work,Lwork,Ierror)
      IMPLICIT NONE
      INTEGER Nlat , Nlon , Isym , Nt , Idv , Jdv , Mdb , Ndb , Lshses ,&
            & Lwork , Ierror
      REAL Sf(Idv,Jdv,Nt) , Vp(Idv,Jdv,Nt)
      REAL Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt)
      REAL Cr(Mdb,Ndb,Nt) , Ci(Mdb,Ndb,Nt)
      REAL Wshses(Lshses) , Work(Lwork)
      INTEGER imid , mmax , ls , mab , mn , ia , ib , is , lwk , iwk
      INTEGER lpimn
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idv<Nlat) .OR. (Isym>0 .AND. Idv<imid) )      &
         & RETURN
      Ierror = 6
      IF ( Jdv<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+2)/2)
      IF ( Mdb<MIN0(Nlat,(Nlon+1)/2) ) RETURN
      Ierror = 8
      IF ( Ndb<Nlat ) RETURN
      Ierror = 9
!
!     verify saved work space (same as shses)
!
      imid = (Nlat+1)/2
      lpimn = (imid*mmax*(Nlat+Nlat-mmax+1))/2
      IF ( Lshses<lpimn+Nlon+15 ) RETURN
!
!     verify unsaved work space (add to what shec requires)
!
      Ierror = 10
      ls = Nlat
      IF ( Isym>0 ) ls = imid
!
!     set first dimension for a,b (as requried by shses)
!
      mab = MIN0(Nlat,Nlon/2+1)
      mn = mab*Nlat*Nt
      IF ( Lwork<ls*(Nt+1)*Nlon+Nlat*(2*imid+1) ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ia = 1
      ib = ia + mn
      is = ib + mn
      iwk = is + Nlat
      lwk = Lwork - 2*mn - Nlat
      CALL SFVPES1(Nlat,Nlon,Isym,Nt,Sf,Vp,Idv,Jdv,Br,Bi,Cr,Ci,Mdb,Ndb, &
                 & Work(ia),Work(ib),mab,Work(is),Wshses,Lshses,        &
                 & Work(iwk),lwk,Ierror)
      END SUBROUTINE SFVPES

      
      SUBROUTINE SFVPES1(Nlat,Nlon,Isym,Nt,Sf,Vp,Idv,Jdv,Br,Bi,Cr,Ci,   &
                       & Mdb,Ndb,A,B,Mab,Fnn,Wshses,Lshses,Wk,Lwk,      &
                       & Ierror)
      IMPLICIT NONE

      INTEGER Nlat , Nlon , Isym , Nt , Idv , Jdv , Mdb , Ndb , Mab ,   &
            & Lshses , Lwk , Ierror
      REAL Sf(Idv,Jdv,Nt) , Vp(Idv,Jdv,Nt)
      REAL Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt) , Cr(Mdb,Ndb,Nt) ,           &
         & Ci(Mdb,Ndb,Nt)
      REAL A(Mab,Nlat,Nt) , B(Mab,Nlat,Nt)
      REAL Wshses(Lshses) , Wk(Lwk) , Fnn(Nlat)
      INTEGER n , m , mmax , k
!
!     set coefficient multiplyers
!
      DO n = 2 , Nlat
         Fnn(n) = 1.0/SQRT(FLOAT(n*(n-1)))
      ENDDO
      mmax = MIN0(Nlat,(Nlon+1)/2)
!
!     compute sf scalar coefficients from cr,ci
!
      DO k = 1 , Nt
         DO n = 1 , Nlat
            DO m = 1 , Mab
               A(m,n,k) = 0.0
               B(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            A(1,n,k) = -Fnn(n)*Cr(1,n,k)
            B(1,n,k) = -Fnn(n)*Ci(1,n,k)
         ENDDO
!
!     compute m>0 coefficients using vector spherepack value for mmax
!
         DO m = 2 , mmax
            DO n = m , Nlat
               A(m,n,k) = -Fnn(n)*Cr(m,n,k)
               B(m,n,k) = -Fnn(n)*Ci(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     synthesize a,b into st
!
      CALL SHSES(Nlat,Nlon,Isym,Nt,Sf,Idv,Jdv,A,B,Mab,Nlat,Wshses,      &
               & Lshses,Wk,Lwk,Ierror)
!
!    set coefficients for vp from br,bi
!
      DO k = 1 , Nt
         DO n = 1 , Nlat
            DO m = 1 , Mab
               A(m,n,k) = 0.0
               B(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            A(1,n,k) = Fnn(n)*Br(1,n,k)
            B(1,n,k) = Fnn(n)*Bi(1,n,k)
         ENDDO
!
!     compute m>0 coefficients using vector spherepack value for mmax
!
         mmax = MIN0(Nlat,(Nlon+1)/2)
         DO m = 2 , mmax
            DO n = m , Nlat
               A(m,n,k) = Fnn(n)*Br(m,n,k)
               B(m,n,k) = Fnn(n)*Bi(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     synthesize a,b into vp
!
      CALL SHSES(Nlat,Nlon,Isym,Nt,Vp,Idv,Jdv,A,B,Mab,Nlat,Wshses,      &
               & Lshses,Wk,Lwk,Ierror)
      END SUBROUTINE SFVPES1


      SUBROUTINE DSFVPES(Nlat,Nlon,Isym,Nt,Sf,Vp,Idv,Jdv,Br,Bi,Cr,Ci,Mdb,&
                      & Ndb,Wshses,Lshses,Work,Lwork,Ierror)
      IMPLICIT NONE
      INTEGER Nlat , Nlon , Isym , Nt , Idv , Jdv , Mdb , Ndb , Lshses ,&
            & Lwork , Ierror
      DOUBLE PRECISION Sf(Idv,Jdv,Nt) , Vp(Idv,Jdv,Nt)
      DOUBLE PRECISION Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt)
      DOUBLE PRECISION Cr(Mdb,Ndb,Nt) , Ci(Mdb,Ndb,Nt)
      DOUBLE PRECISION Wshses(Lshses) , Work(Lwork)
      INTEGER imid , mmax , ls , mab , mn , ia , ib , is , lwk , iwk
      INTEGER lpimn
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idv<Nlat) .OR. (Isym>0 .AND. Idv<imid) )      &
         & RETURN
      Ierror = 6
      IF ( Jdv<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+2)/2)
      IF ( Mdb<MIN0(Nlat,(Nlon+1)/2) ) RETURN
      Ierror = 8
      IF ( Ndb<Nlat ) RETURN
      Ierror = 9
!
!     verify saved work space (same as shses)
!
      imid = (Nlat+1)/2
      lpimn = (imid*mmax*(Nlat+Nlat-mmax+1))/2
      IF ( Lshses<lpimn+Nlon+15 ) RETURN
!
!     verify unsaved work space (add to what shec requires)
!
      Ierror = 10
      ls = Nlat
      IF ( Isym>0 ) ls = imid
!
!     set first dimension for a,b (as requried by shses)
!
      mab = MIN0(Nlat,Nlon/2+1)
      mn = mab*Nlat*Nt
      IF ( Lwork<ls*(Nt+1)*Nlon+Nlat*(2*imid+1) ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ia = 1
      ib = ia + mn
      is = ib + mn
      iwk = is + Nlat
      lwk = Lwork - 2*mn - Nlat
      CALL DSFVPES1(Nlat,Nlon,Isym,Nt,Sf,Vp,Idv,Jdv,Br,Bi,Cr,Ci,Mdb,Ndb, &
                 & Work(ia),Work(ib),mab,Work(is),Wshses,Lshses,        &
                 & Work(iwk),lwk,Ierror)
      END SUBROUTINE DSFVPES

      
      SUBROUTINE DSFVPES1(Nlat,Nlon,Isym,Nt,Sf,Vp,Idv,Jdv,Br,Bi,Cr,Ci,   &
                       & Mdb,Ndb,A,B,Mab,Fnn,Wshses,Lshses,Wk,Lwk,      &
                       & Ierror)
      IMPLICIT NONE

      INTEGER Nlat , Nlon , Isym , Nt , Idv , Jdv , Mdb , Ndb , Mab ,   &
            & Lshses , Lwk , Ierror
      DOUBLE PRECISION Sf(Idv,Jdv,Nt) , Vp(Idv,Jdv,Nt)
      DOUBLE PRECISION Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt) , Cr(Mdb,Ndb,Nt) ,           &
         & Ci(Mdb,Ndb,Nt)
      DOUBLE PRECISION A(Mab,Nlat,Nt) , B(Mab,Nlat,Nt)
      DOUBLE PRECISION Wshses(Lshses) , Wk(Lwk) , Fnn(Nlat)
      INTEGER n , m , mmax , k
!
!     set coefficient multiplyers
!
      DO n = 2 , Nlat
         Fnn(n) = 1.0/SQRT(FLOAT(n*(n-1)))
      ENDDO
      mmax = MIN0(Nlat,(Nlon+1)/2)
!
!     compute sf scalar coefficients from cr,ci
!
      DO k = 1 , Nt
         DO n = 1 , Nlat
            DO m = 1 , Mab
               A(m,n,k) = 0.0
               B(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            A(1,n,k) = -Fnn(n)*Cr(1,n,k)
            B(1,n,k) = -Fnn(n)*Ci(1,n,k)
         ENDDO
!
!     compute m>0 coefficients using vector spherepack value for mmax
!
         DO m = 2 , mmax
            DO n = m , Nlat
               A(m,n,k) = -Fnn(n)*Cr(m,n,k)
               B(m,n,k) = -Fnn(n)*Ci(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     synthesize a,b into st
!
      CALL DSHSES(Nlat,Nlon,Isym,Nt,Sf,Idv,Jdv,A,B,Mab,Nlat,Wshses,      &
               & Lshses,Wk,Lwk,Ierror)
!
!    set coefficients for vp from br,bi
!
      DO k = 1 , Nt
         DO n = 1 , Nlat
            DO m = 1 , Mab
               A(m,n,k) = 0.0
               B(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            A(1,n,k) = Fnn(n)*Br(1,n,k)
            B(1,n,k) = Fnn(n)*Bi(1,n,k)
         ENDDO
!
!     compute m>0 coefficients using vector spherepack value for mmax
!
         mmax = MIN0(Nlat,(Nlon+1)/2)
         DO m = 2 , mmax
            DO n = m , Nlat
               A(m,n,k) = Fnn(n)*Br(m,n,k)
               B(m,n,k) = Fnn(n)*Bi(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     synthesize a,b into vp
!
      CALL DSHSES(Nlat,Nlon,Isym,Nt,Vp,Idv,Jdv,A,B,Mab,Nlat,Wshses,      &
               & Lshses,Wk,Lwk,Ierror)
      END SUBROUTINE DSFVPES1

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file shigs.f
c
c     this file contains code and documentation for subroutine shigs
c
c ... files which must be loaded with shigs.f
c
c     sphcom.f, hrfft.f, gaqd.f
c
c     3/6/98
c
c *** shigs is functionally the same as shagsi or shsgsi.  It
c     it included in spherepack3.0 because legacy codes, using
c     the older version of spherepack, call shigs to initialize
c     the saved work space wshigs for either shags or shsgs
c     Its arguments are identical to those of shagsi or shsgsi.
c
c ****************************************************************
c
c     subroutine shigs(nlat,nlon,wshigs,lshigs,work,lwork,dwork,ldwork,
c    +                 ierror)
c
c     subroutine shigs initializes the array wshigs which can then
c     be used repeatedly by subroutines shags,shsgs. it precomputes
c     and stores in wshigs quantities such as gaussian weights,
c     legendre polynomial coefficients, and fft trigonometric tables.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are compu
c            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid poi
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     wshigs an array which must be initialized by subroutine shigs .
c            once initialized, wshigs can be used repeatedly by shigs
c            as long as nlat and nlon remain unchanged.  wshigs must
c            not be altered between calls of shigs.
c
c     lshigs the dimension of the array wshigs as it appears in the
c            program that calls shigs. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshigs must be at least
c
c            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
c
c     work   a real work space which need not be saved
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shigs. lwork must be at least
c            4*nlat*(nlat+2)+2 in the routine calling shigs
c
c     dwork   a double precision work array that does not have to be saved.
c
c     ldwork  the length of dwork in the calling routine.  ldwork must
c             be at least nlat*(nlat+4)
c
c     output parameter
c
c     wshags an array which must be initialized before calling shags or
c            once initialized, wshags can be used repeatedly by shags or
c            as long as nlat and nlon remain unchanged.  wshags must not
c            altered between calls of shasc.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lshags
c            = 4  error in the specification of lwork
c            = 5  error in the specification of ldwork
c            = 6  failure in gaqd to compute gaussian points
c                 (due to failure in eigenvalue routine)
c
c
c ****************************************************************
c
      subroutine shigs(nlat,nlon,wshigs,lshigs,work,lwork,dwork,
     +                 ldwork,ierror)
c
c     this subroutine must be called before calling shags or shsgs with
c     fixed nlat,nlon. it precomputes the gaussian weights, points
c     and all necessary legendre polys and stores them in wshigs.
c     these quantities must be preserved when calling shsgs or shags
c     repeatedly with fixed nlat,nlon.
c
      dimension wshigs(lshigs),work(lwork)
      double precision dwork(ldwork)
      ierror = 1
      if (nlat.lt.3) return
      ierror = 2
      if (nlon.lt.4) return
c     set triangular truncation limit for spherical harmonic basis
      l = min0((nlon+2)/2,nlat)
c     set equator or nearest point (if excluded) pointer
      late = (nlat+1)/2
      l1 = l
      l2 = late
c     check permanent work space length
      ierror = 3
      lp=nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
      if(lshigs.lt.lp) return
      ierror = 4
c     check temporary work space
      if (lwork.lt.4*nlat*(nlat+2)+2) return
c     check temp double precision space
      ierror = 5
      if (ldwork .lt. nlat*(nlat+4)) return
      ierror = 0
c     set preliminary quantites needed to compute and store legendre polys
      call shigsp(nlat,nlon,wshigs,lshigs,dwork,ldwork,ierror)
      if (ierror.ne.0) return
c     set legendre poly pointer in wshigs
      ipmnf = nlat+2*nlat*late+3*(l*(l-1)/2+(nlat-l)*(l-1))+nlon+16
      call shigss1(nlat,l,late,wshigs,work,wshigs(ipmnf))
      return
      end

      subroutine shigss1(nlat,l,late,w,pmn,pmnf)
      dimension w(1),pmn(nlat,late,3),pmnf(late,1)
c     compute and store legendre polys for i=1,...,late,m=0,...,l-1
c     and n=m,...,l-1
      do i=1,nlat
	do j=1,late
	  do k=1,3
	    pmn(i,j,k) = 0.0
	  end do
	end do
      end do
      do 100 mp1=1,l
      m = mp1-1
      mml1 = m*(2*nlat-m-1)/2
c     compute pmn for n=m,...,nlat-1 and i=1,...,(l+1)/2
      mode = 0
      call legin(mode,l,nlat,m,w,pmn,km)
c     store above in pmnf
      do 101 np1=mp1,nlat
      mn = mml1+np1
      do 102 i=1,late
      pmnf(i,mn) = pmn(np1,i,km)
  102 continue
  101 continue
  100 continue
      return
      end
      subroutine shigsp(nlat,nlon,wshigs,lshigs,dwork,ldwork,ierror)
      dimension wshigs(lshigs)
      double precision dwork(ldwork)
      ierror = 1
      if (nlat.lt.3) return
      ierror = 2
      if (nlon.lt.4) return
c     set triangular truncation limit for spherical harmonic basis
      l = min0((nlon+2)/2,nlat)
c     set equator or nearest point (if excluded) pointer
      late = (nlat+mod(nlat,2))/2
      l1 = l
      l2 = late
      ierror = 3
c     check permanent work space length
      if (lshigs .lt. nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15)return
      ierror = 4
c     if (lwork.lt.4*nlat*(nlat+2)+2) return
      if (ldwork .lt. nlat*(nlat+4)) return
      ierror = 0
c     set pointers
      i1 = 1
      i2 = i1+nlat
      i3 = i2+nlat*late
      i4 = i3+nlat*late
      i5 = i4+l*(l-1)/2 +(nlat-l)*(l-1)
      i6 = i5+l*(l-1)/2 +(nlat-l)*(l-1)
      i7 = i6+l*(l-1)/2 +(nlat-l)*(l-1)
c     set indices in temp work for double precision gaussian wts and pts
      idth = 1
c     idwts = idth+2*nlat
c     iw = idwts+2*nlat
      idwts = idth+nlat
      iw = idwts+nlat
      call shigsp1(nlat,nlon,l,late,wshigs(i1),wshigs(i2),wshigs(i3),
     1wshigs(i4),wshigs(i5),wshigs(i6),wshigs(i7),dwork(idth),
     2dwork(idwts),dwork(iw),ierror)
      if (ierror.ne.0) ierror = 5
      return
      end

      subroutine shigsp1(nlat,nlon,l,late,wts,p0n,p1n,abel,bbel,cbel,
     +                   wfft,dtheta,dwts,work,ier)
      dimension wts(nlat),p0n(nlat,late),p1n(nlat,late),abel(1),bbel(1),
     1 cbel(1),wfft(1),dtheta(nlat),dwts(nlat)
      double precision pb,dtheta,dwts,work(*)
      indx(m,n) = (n-1)*(n-2)/2+m-1
      imndx(m,n) = l*(l-1)/2+(n-l-1)*(l-1)+m-1
      call hrffti(nlon,wfft)
c     compute double precision gaussian points and weights
c     lw = 4*nlat*(nlat+2)
      lw = nlat*(nlat+2)
      call gaqd(nlat,dtheta,dwts,work,lw,ier)
      if (ier.ne.0) return
c     store gaussian weights single precision to save computation
c     in inner loops in analysis
      do 100 i=1,nlat
      wts(i) = dwts(i)
  100 continue
c     initialize p0n,p1n using double precision dnlfk,dnlft
      do 101 np1=1,nlat
      do 101 i=1,late
      p0n(np1,i) = 0.0
      p1n(np1,i) = 0.0
  101 continue
c     compute m=n=0 legendre polynomials for all theta(i)
      np1 = 1
      n = 0
      m = 0
      call dnlfk(m,n,work)
      do 103 i=1,late
      call dnlft(m,n,dtheta(i),work,pb)
      p0n(1,i) = pb
  103 continue
c     compute p0n,p1n for all theta(i) when n.gt.0
      do 104 np1=2,nlat
      n = np1-1
      m = 0
      call dnlfk(m,n,work)
      do 105 i=1,late
      call dnlft(m,n,dtheta(i),work,pb)
      p0n(np1,i) = pb
  105 continue
c     compute m=1 legendre polynomials for all n and theta(i)
      m = 1
      call dnlfk(m,n,work)
      do 106 i=1,late
      call dnlft(m,n,dtheta(i),work,pb)
      p1n(np1,i) = pb
  106 continue
  104 continue
c
c     compute and store swarztrauber recursion coefficients
c     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      do 107 n=2,nlat
      mlim = min0(n,l)
      do 107 m=2,mlim
      imn = indx(m,n)
      if (n.ge.l) imn = imndx(m,n)
      abel(imn)=sqrt(float((2*n+1)*(m+n-2)*(m+n-3))/
     1               float(((2*n-3)*(m+n-1)*(m+n))))
      bbel(imn)=sqrt(float((2*n+1)*(n-m-1)*(n-m))/
     1               float(((2*n-3)*(m+n-1)*(m+n))))
      cbel(imn)=sqrt(float((n-m+1)*(n-m+2))/
     1               float(((n+m-1)*(n+m))))
  107 continue
      return
      end

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c ... file ihgeod.f
c
c     contains documentation and code for subroutine ihgeod
c
c
      subroutine ihgeod(m,idp,jdp,x,y,z)
      dimension x(idp,jdp,5),y(idp,jdp,5),z(idp,jdp,5)
c
c     m         is the number of points on the edge of a 
c               single geodesic triangle
c
c     x,y,z     the coordinates of the geodesic points on 
c               the sphere are x(i,j,k), y(i,j,k), z(i,j,k)
c               where i=1,...,m+m-1; j=1,...,m; and k=1,...,5.
c               the indices are defined on the unfolded 
c               icosahedron as follows for the case m=3
c
c                north pole
c
c                 (5,1)          0      l
c        i     (4,1) (5,2)              a    (repeated for
c           (3,1) (4,2) (5,3)  theta1   t    k=2,3,4,5 in
c        (2,1) (3,2) (4,3)              i        -->
c     (1,1) (2,2) (3,3)        theta2   t    the longitudinal 
c        (1,2) (2,3)                    u    direction)
c           (1,3)                pi     d
c      j                                e
c         south pole
c
c                total number of points is 10*(m-1)**2+2
c                total number of triangles is 20*(m-1)**2
c                total number of edges is 30*(m-1)**2
c
      pi = 4.*atan(1.)
      dphi = .4*pi
      beta = cos(dphi)
      theta1 = acos(beta/(1.-beta))
      theta2 = pi-theta1
      hdphi = dphi/2.
      tdphi = 3.*hdphi
      do k=1,5
	phi = (k-1)*dphi
	call stoc(1.,theta2,phi,x1,y1,z1)
	call stoc(1.,pi,phi+hdphi,x2,y2,z2)
	call stoc(1.,theta2,phi+dphi,x3,y3,z3)
	dxi = (x2-x1)/(m-1)
	dyi = (y2-y1)/(m-1)
	dzi = (z2-z1)/(m-1)
	dxj = (x3-x2)/(m-1)
	dyj = (y3-y2)/(m-1)
	dzj = (z3-z2)/(m-1)
	do i=1,m
	  xs = x1 + (i-1)*dxi
	  ys = y1 + (i-1)*dyi
	  zs = z1 + (i-1)*dzi
	  do j=1,i
	    x(j,i,k) = xs + (j-1)*dxj
	    y(j,i,k) = ys + (j-1)*dyj
	    z(j,i,k) = zs + (j-1)*dzj
	  end do
	end do
	call stoc(1.,theta1,phi+hdphi,x4,y4,z4)
	dxi = (x3-x4)/(m-1)
	dyi = (y3-y4)/(m-1)
	dzi = (z3-z4)/(m-1)
	dxj = (x4-x1)/(m-1)
	dyj = (y4-y1)/(m-1)
	dzj = (z4-z1)/(m-1)
	do j=1,m
	  xs = x1 + (j-1)*dxj
	  ys = y1 + (j-1)*dyj
	  zs = z1 + (j-1)*dzj
	  do i=1,j
	    x(j,i,k) = xs + (i-1)*dxi
	    y(j,i,k) = ys + (i-1)*dyi
	    z(j,i,k) = zs + (i-1)*dzi
	  end do
	end do
	call stoc(1.,theta1,phi+tdphi,x5,y5,z5)
	dxj = (x5-x3)/(m-1)
	dyj = (y5-y3)/(m-1)
	dzj = (z5-z3)/(m-1)
	do i=1,m
	  xs = x4 + (i-1)*dxi
	  ys = y4 + (i-1)*dyi
	  zs = z4 + (i-1)*dzi
	  do j=1,i
	    x(j+m-1,i,k) = xs + (j-1)*dxj
	    y(j+m-1,i,k) = ys + (j-1)*dyj
	    z(j+m-1,i,k) = zs + (j-1)*dzj
	  end do
	end do
	call stoc(1.,0.,phi+dphi,x6,y6,z6)
	dxi = (x5-x6)/(m-1)
	dyi = (y5-y6)/(m-1)
	dzi = (z5-z6)/(m-1)
	dxj = (x6-x4)/(m-1)
	dyj = (y6-y4)/(m-1)
	dzj = (z6-z4)/(m-1)
	do j=1,m
	  xs = x4 + (j-1)*dxj
	  ys = y4 + (j-1)*dyj
	  zs = z4 + (j-1)*dzj
	  do i=1,j
	    x(j+m-1,i,k) = xs + (i-1)*dxi
	    y(j+m-1,i,k) = ys + (i-1)*dyi
	    z(j+m-1,i,k) = zs + (i-1)*dzi
	  end do
	end do
      end do
      do k=1,5
	do j=1,m+m-1
	  do i=1,m
	    call ctos(x(j,i,k),y(j,i,k),z(j,i,k),rad,theta,phi)
	    call stoc(1.,theta,phi,x(j,i,k),y(j,i,k),z(j,i,k))
	  end do
	end do
      end do
      return
      end
      subroutine ctos(x,y,z,r,theta,phi)
      r1 = x*x+y*y
      if(r1 .ne. 0.) go to 10
      phi = 0.
      theta = 0.
      if(z .lt. 0.) theta = 4.*atan(1.)
      return
   10 r = sqrt(r1+z*z)
      r1 = sqrt(r1) 
      phi = atan2(y,x)
      theta = atan2(r1,z)
      return
      end
      subroutine stoc(r,theta,phi,x,y,z)
      st = sin(theta)
      x = r*st*cos(phi)
      y = r*st*sin(phi)
      z = r*cos(theta)
      return
      end

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c
c ... file isfvpec.f
c
c     this file includes documentation and code for
c     subroutine isfvpec          i
c
c ... files which must be loaded with isfvpec.f
c
c     sphcom.f, hrfft.f, vhsec.f,shaec.f
c
c
c     subroutine isfvpec(nlat,nlon,isym,nt,sf,vp,idv,jdv,as,bs,av,bv,
c    +                   mdb,ndb,wvhsec,lvhsec,work,lwork,ierror)
c
c     given the scalar spherical harmonic coefficients as,bs precomputed
c     by shaec for the scalar stream function sf and av,bv precomputed by
c     shaec for the scalar velocity potenital vp, subroutine isfvpec computes
c     the vector field (v,w) corresponding to sf and vp.  w is the east
c     longitudinal and v is the colatitudinal component of the vector field.
c     (v,w) is expressed in terms of sf,vp by the helmholtz relations (in
c     mathematical spherical coordinates):
c
c          v = -1/sin(theta)*d(vp)/dlambda + d(st)/dtheta
c
c          w =  1/sin(theta)*d(st)/dlambda + d(vp)/dtheta
c
c     required legendre functions are recomputed rather than stored as
c     they are in subroutine isfvpes.  v(i,j) and w(i,j) are given at
c     colatitude
c
c            theta(i) = (i-1)*pi/(nlat-1)
c
c     and east longitude
c
c            lambda(j) = (j-1)*2*pi/nlon
c
c     on the sphere (pi=4.0*atan(1.0)).
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater than
c            3.  the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   a parameter which determines whether the vector field is
c            computed on the full or half sphere as follows:
c
c      = 0
c
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in sf,vp about the equator.  in this case v
c            and w are not necessarily symmetric or antisymmetric about
c            equator.  v and w are computed on the entire sphere.
c            i.e., in arrays sf(i,j),vp(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c
c            vp is antisymmetric and sf is symmetric about the equator.
c            in this case v is symmetric and w antisymmetric about
c            the equator and are computed for the northern hemisphere
c            only.  i.e., if nlat is odd the v(i,j),w(i,j) are computed
c            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
c            even then v(i,j),w(i,j) are computed for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c      = 2
c
c            vp is symmetric and sf is antisymmetric about the equator.
c            in this case v is antisymmetric and w symmetric about
c            the equator and are computed for the northern hemisphere
c            only.  i.e., if nlat is odd the v(i,j),w(i,j) are computed
c            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
c            even then v(i,j),w(i,j) are computed for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c     nt     nt is the number of scalar and vector fields.  some
c            computational efficiency is obtained for multiple fields. arrays
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple vector synthesis will
c            be performed to compute (v,w) for each field.  the
c            third index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt = 1.  the
c            description of the remaining parameters is simplified by
c            assuming that nt=1 or that all the arrays are two dimensional.
c
c     idv    the first dimension of the arrays v,w as it appears in
c            the program that calls isfvpec. if isym = 0 then idv
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idv must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idv must be at least (nlat+1)/2.
c
c     jdv    the second dimension of the arrays v,w as it appears in
c            the program that calls isfvpec. jdv must be at least nlon.
c
c     as,bs  two or three dimensional arrays (see input parameter nt)
c            that contain the spherical harmonic coefficients of
c            the scalar field sf as computed by subroutine shaec.
c
c     av,bv  two or three dimensional arrays (see input parameter nt)
c            that contain the spherical harmonic coefficients of
c            the scalar field vp as computed by subroutine shaec.
c
c     mdb    the first dimension of the arrays as,bs,av,bv as it
c            appears in the program that calls isfvpec. mdb must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndb    the second dimension of the arrays as,bs,av,bv as it
c            appears in the program that calls isfvpec. ndb must be at
c            least nlat.
c
c     wvhsec an array which must be initialized by subroutine vhseci.
c            once initialized, wvhsec can be used repeatedly by isfvpec
c            as long as nlon and nlat remain unchanged.  wvhsec must
c            not bel altered between calls of isfvpec.
c
c
c     lvhsec the dimension of the array wvhsec as it appears in the
c            program that calls isfvpec. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhsec must be at least
c
c
c               4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls isfvpec. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c
c            if isym = 0 then lwork must be at least
c
c               nlat*(2*nt*nlon+max0(6*l2,nlon)+4*l1*nt+1)
c
c            if isym = 1 or 2 then lwork must be at least
c
c               l2*(2*nt*nlon+max0(6*nlat,nlon))+nlat*(4*l1*nt+1)
c
c     **************************************************************
c
c     output parameters
c
c    v,w    two or three dimensional arrays (see input parameter nt)
c           that contains the vector field corresponding to the stream
c           function sf and velocity potential vp whose coefficients,
c           as,bs (for sf) and av,bv (for vp), were precomputed by
c           subroutine shaec.  v(i,j) and w(i,j) are given at the
c           colatitude point
c
c                theta(i) = (i-1)*pi/(nlat-1)
c
c           and longitude point
c
c                lambda(j) = (j-1)*2*pi/nlon
c
c           the index ranges are defined above at the input parameter isym.
c
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idv
c           = 6  error in the specification of jdv
c           = 7  error in the specification of mdb
c           = 8  error in the specification of ndb
c           = 9  error in the specification of lvhsec
c           = 10 error in the specification of lwork
c **********************************************************************
c                                                                              
      subroutine isfvpec(nlat,nlon,isym,nt,v,w,idv,jdv,as,bs,av,bv,
     +                   mdb,ndb,wvhsec,lvhsec,work,lwork,ierror)
      implicit none
      integer nlat,nlon,isym,nt,idv,jdv,mdb,ndb,lvhsec,lwork,ierror
      real v(idv,jdv,nt),w(idv,jdv,nt)
      real as(mdb,ndb,nt),bs(mdb,ndb,nt)
      real av(mdb,ndb,nt),bv(mdb,ndb,nt)
      real wvhsec(lvhsec),work(lwork)
      integer mmax,l1,l2,lzz1,labc,mn,is,lwk,iwk,lwmin
      integer ibr,ibi,icr,ici
c
c     check input parameters
c
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if (nlon .lt. 4) return
      ierror = 3
      if (isym.lt.0 .or. isym.gt.2) return
      ierror = 4
      if (nt .lt. 0) return
      ierror = 5
      l2 = (nlat+1)/2
      if((isym.eq.0 .and. idv.lt.nlat) .or.
     +   (isym.gt.0 .and. idv.lt.l2)) return
      ierror = 6
      if(jdv .lt. nlon) return
      ierror = 7
      l1 = min0(nlat,(nlon+1)/2)
      if (mdb .lt. min0(nlat,(nlon+2)/2)) return
      ierror = 8
      if (ndb .lt. nlat) return
      ierror = 9
      lzz1 = 2*nlat*l2
      labc = 3*(max0(l1-2,0)*(nlat+nlat-l1-1))/2
      if (lvhsec .lt. 2*(lzz1+labc)+nlon+15) return
      ierror = 10
      if (isym .eq. 0) then
	lwmin = nlat*(2*nt*nlon+max0(6*l2,nlon)+4*l1*nt+1)
      else
	lwmin = l2*(2*nt*nlon+max0(6*nlat,nlon))+nlat*(4*l1*nt+1)
      end if
      if (lwork .lt. lwmin) return
c
c     set first dimension for br,bi,cr,ci (as requried by vhsec)
c
      mmax = min0(nlat,(nlon+1)/2)
      mn = mmax*nlat*nt
      ierror = 0
c
c     set work space pointers
c
      ibr = 1
      ibi = ibr+mn
      icr = ibi+mn
      ici = icr+mn
      is = ici+mn
      iwk = is+nlat
      lwk = lwork-4*mn-nlat
      call isfvpec1(nlat,nlon,isym,nt,v,w,idv,jdv,as,bs,av,bv,mdb,
     +ndb,work(ibr),work(ibi),work(icr),work(ici),l1,work(is),
     +wvhsec,lvhsec,work(iwk),lwk,ierror)
      return
      end

      subroutine isfvpec1(nlat,nlon,isym,nt,v,w,idv,jdv,as,bs,av,bv,
     +mdb,ndb,br,bi,cr,ci,mab,fnn,wvhsec,lvhsec,wk,lwk,ierror)
      implicit none
      integer nlat,nlon,isym,nt,idv,jdv,mdb,ndb,mab,lvhsec,lwk,ierror
      real v(idv,jdv,nt),w(idv,jdv,nt)
      real as(mdb,ndb,nt),bs(mdb,ndb,nt)
      real av(mdb,ndb,nt),bv(mdb,ndb,nt)
      real br(mab,nlat,nt),bi(mab,nlat,nt)
      real cr(mab,nlat,nt),ci(mab,nlat,nt)
      real wvhsec(lvhsec),wk(lwk),fnn(nlat)
      integer n,m,mmax,k,ityp
c
c     set coefficient multiplyers
c
      do n=2,nlat
	fnn(n) = -sqrt(float(n*(n-1)))
      end do
      mmax = min0(nlat,(nlon+1)/2)
c
c     compute (v,w) coefficients from as,bs,av,bv
c
      do k=1,nt
	do n=1,nlat
	  do m=1,mab
	    br(m,n,k) = 0.0
	    bi(m,n,k) = 0.0
	    cr(m,n,k) = 0.0
	    ci(m,n,k) = 0.0
	  end do
	end do
c
c     compute m=0 coefficients
c
	do n=2,nlat
	  br(1,n,k) = -fnn(n)*av(1,n,k)
	  bi(1,n,k) = -fnn(n)*bv(1,n,k)
	  cr(1,n,k) =  fnn(n)*as(1,n,k)
	  ci(1,n,k) =  fnn(n)*bs(1,n,k)
	end do
c
c     compute m>0 coefficients using vector spherepack value for mmax
c
	do m=2,mmax
	  do n=m,nlat
	    br(m,n,k) = -fnn(n)*av(m,n,k)
	    bi(m,n,k) = -fnn(n)*bv(m,n,k)
	    cr(m,n,k) =  fnn(n)*as(m,n,k)
	    ci(m,n,k) =  fnn(n)*bs(m,n,k)
	  end do
	end do
      end do
c
c     synthesize br,bi,cr,ci into (v,w)
c
      if (isym .eq.0) then
	ityp = 0
      else if (isym .eq.1) then
	ityp = 3
      else if (isym .eq.2) then
	ityp = 6
      end if
      call vhsec(nlat,nlon,ityp,nt,v,w,idv,jdv,br,bi,cr,ci,
     +           mab,nlat,wvhsec,lvhsec,wk,lwk,ierror)
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
!     file alf.f contains subroutines alfk,lfim,lfim1,lfin,lfin1,lfpt
!     for computing normalized associated legendre polynomials
!
! subroutine alfk (n,m,cp)
!
! dimension of           real cp(n/2 + mod(n,2))
! arguments
!
! purpose                routine alfk computes single precision fourier
!                        coefficients in the trigonometric series
!                        representation of the normalized associated
!                        legendre function pbar(n,m,theta) for use by
!                        routines lfp and lfpt in calculating single
!                        precision pbar(n,m,theta).
!
!                        first define the normalized associated
!                        legendre functions
!
!                        pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)
!                        /(2*factorial(n+m)))*sin(theta)**m/(2**n*
!                        factorial(n)) times the (n+m)th derivative of
!                        (x**2-1)**n with respect to x=cos(theta)
!
!                        where theta is colatitude.
!
!                        then subroutine alfk computes the coefficients
!                        cp(k) in the following trigonometric
!                        expansion of pbar(m,n,theta).
!
!                        1) for n even and m even, pbar(m,n,theta) =
!                           .5*cp(1) plus the sum from k=1 to k=n/2
!                           of cp(k)*cos(2*k*th)
!
!                        2) for n even and m odd, pbar(m,n,theta) =
!                           the sum from k=1 to k=n/2 of
!                           cp(k)*sin(2*k*th)
!
!                        3) for n odd and m even, pbar(m,n,theta) =
!                           the sum from k=1 to k=(n+1)/2 of
!                           cp(k)*cos((2*k-1)*th)
!
!                        4) for n odd and m odd,  pbar(m,n,theta) =
!                           the sum from k=1 to k=(n+1)/2 of
!                           cp(k)*sin((2*k-1)*th)
!
!
! usage                  call alfk(n,m,cp)
!
! arguments
!
! on input               n
!                          nonnegative integer specifying the degree of
!                          pbar(n,m,theta)
!
!                        m
!                          is the order of pbar(n,m,theta). m can be
!                          any integer however cp is computed such that
!                          pbar(n,m,theta) = 0 if abs(m) is greater
!                          than n and pbar(n,m,theta) = (-1)**m*
!                          pbar(n,-m,theta) for negative m.
!
! on output              cp
!                          single precision array of length (n/2)+1
!                          which contains the fourier coefficients in
!                          the trigonometric series representation of
!                          pbar(n,m,theta)
!
!
! special conditions     none
!
! precision              single
!
! algorithm              the highest order coefficient is determined in
!                        closed form and the remainig coefficients are
!                        determined as the solution of a backward
!                        recurrence relation.
!
! accuracy               comparison between routines alfk and double
!                        precision dalfk on the cray1 indicates
!                        greater accuracy for smaller values
!                        of input parameter n.  agreement to 14
!                        places was obtained for n=10 and to 13
!                        places for n=100.
!
      SUBROUTINE ALFK(N,M,Cp)
      IMPLICIT NONE
      REAL a1 , b1 , c1 ,  cp2 , fden , fk , fnmh , fnmsq , fnnp1 , &
           & fnum , pm1  , t1 , t2
      REAL, DIMENSION(N/2+1) :: Cp
      INTEGER i , l , M , ma , N , nex , nmms2

      REAL, PARAMETER :: SC10=1024.
      REAL, PARAMETER :: SC20=SC10*SC10
      REAL, PARAMETER :: SC40=SC20*SC20

      Cp(1) = 0.
      ma = IABS(M)
      IF ( ma.GT.N ) RETURN
      IF ( N.LT.1 ) THEN
         Cp(1) = SQRT(2.)
         RETURN
      ELSEIF ( N.EQ.1 ) THEN
         IF ( ma.NE.0 ) THEN
            Cp(1) = SQRT(.75)
            IF ( M.EQ.-1 ) Cp(1) = -Cp(1)
            RETURN
         ELSE
            Cp(1) = SQRT(1.5)
            RETURN
         ENDIF
      ELSE
         IF ( MOD(N+ma,2).NE.0 ) THEN
            nmms2 = (N-ma-1)/2
            fnum = N + ma + 2
            fnmh = N - ma + 2
            pm1 = -1.
         ELSE
            nmms2 = (N-ma)/2
            fnum = N + ma + 1
            fnmh = N - ma + 1
            pm1 = 1.
         ENDIF
         t1 = 1./SC20
         nex = 20
         fden = 2.
         IF ( nmms2.GE.1 ) THEN
            DO i = 1 , nmms2
               t1 = fnum*t1/fden
               IF ( t1.GT.SC20 ) THEN
                  t1 = t1/SC40
                  nex = nex + 40
               ENDIF
               fnum = fnum + 2.
               fden = fden + 2.
            ENDDO
         ENDIF
         t1 = t1/2.**(N-1-nex)
         IF ( MOD(ma/2,2).NE.0 ) t1 = -t1
         t2 = 1.
         IF ( ma.NE.0 ) THEN
            DO i = 1 , ma
               t2 = fnmh*t2/(fnmh+pm1)
               fnmh = fnmh + 2.
            ENDDO
         ENDIF
         cp2 = t1*SQRT((N+.5)*t2)
         fnnp1 = N*(N+1)
         fnmsq = fnnp1 - 2.*ma*ma
         l = (N+1)/2
         IF ( MOD(N,2).EQ.0 .AND. MOD(ma,2).EQ.0 ) l = l + 1
         Cp(l) = cp2
         IF ( M.LT.0 ) THEN
            IF ( MOD(ma,2).NE.0 ) Cp(l) = -Cp(l)
         ENDIF
         IF ( l.LE.1 ) RETURN
         fk = N
         a1 = (fk-2.)*(fk-1.) - fnnp1
         b1 = 2.*(fk*fk-fnmsq)
         Cp(l-1) = b1*Cp(l)/a1
 50      l = l - 1
         IF ( l.LE.1 ) RETURN
         fk = fk - 2.
         a1 = (fk-2.)*(fk-1.) - fnnp1
         b1 = -2.*(fk*fk-fnmsq)
         c1 = (fk+1.)*(fk+2.) - fnnp1
         Cp(l-1) = -(b1*Cp(l)+c1*Cp(l+1))/a1
         GOTO 50
      ENDIF
      END SUBROUTINE ALFK

      
      SUBROUTINE DALFK(N,M,Cp)
      IMPLICIT NONE
      DOUBLE PRECISION  a1 , b1 , c1 ,  cp2 , fden , fk , fnmh , fnmsq , fnnp1 , &
           & fnum , pm1 , SC10 , SC20 , SC40 , t1 , t2
      DOUBLE PRECISION, DIMENSION(N/2+1) :: Cp
      INTEGER i , l , M , ma , N , nex , nmms2

      PARAMETER (SC10=1024.)
      PARAMETER (SC20=SC10*SC10)
      PARAMETER (SC40=SC20*SC20)
!
      Cp(1) = 0.
      ma = IABS(M)
      IF ( ma.GT.N ) RETURN
      IF ( N.LT.1 ) THEN
         Cp(1) = SQRT(2.)
         RETURN
      ELSEIF ( N.EQ.1 ) THEN
         IF ( ma.NE.0 ) THEN
            Cp(1) = SQRT(.75)
            IF ( M.EQ.-1 ) Cp(1) = -Cp(1)
            RETURN
         ELSE
            Cp(1) = SQRT(1.5)
            RETURN
         ENDIF
      ELSE
         IF ( MOD(N+ma,2).NE.0 ) THEN
            nmms2 = (N-ma-1)/2
            fnum = N + ma + 2
            fnmh = N - ma + 2
            pm1 = -1.
         ELSE
            nmms2 = (N-ma)/2
            fnum = N + ma + 1
            fnmh = N - ma + 1
            pm1 = 1.
         ENDIF
         t1 = 1./SC20
         nex = 20
         fden = 2.
         IF ( nmms2.GE.1 ) THEN
            DO i = 1 , nmms2
               t1 = fnum*t1/fden
               IF ( t1.GT.SC20 ) THEN
                  t1 = t1/SC40
                  nex = nex + 40
               ENDIF
               fnum = fnum + 2.
               fden = fden + 2.
            ENDDO
         ENDIF
         t1 = t1/2.**(N-1-nex)
         IF ( MOD(ma/2,2).NE.0 ) t1 = -t1
         t2 = 1.
         IF ( ma.NE.0 ) THEN
            DO i = 1 , ma
               t2 = fnmh*t2/(fnmh+pm1)
               fnmh = fnmh + 2.
            ENDDO
         ENDIF
         cp2 = t1*SQRT((N+.5)*t2)
         fnnp1 = N*(N+1)
         fnmsq = fnnp1 - 2.*ma*ma
         l = (N+1)/2
         IF ( MOD(N,2).EQ.0 .AND. MOD(ma,2).EQ.0 ) l = l + 1
         Cp(l) = cp2
         IF ( M.LT.0 ) THEN
            IF ( MOD(ma,2).NE.0 ) Cp(l) = -Cp(l)
         ENDIF
         IF ( l.LE.1 ) RETURN
         fk = N
         a1 = (fk-2.)*(fk-1.) - fnnp1
         b1 = 2.*(fk*fk-fnmsq)
         Cp(l-1) = b1*Cp(l)/a1
 50      l = l - 1
         IF ( l.LE.1 ) RETURN
         fk = fk - 2.
         a1 = (fk-2.)*(fk-1.) - fnnp1
         b1 = -2.*(fk*fk-fnmsq)
         c1 = (fk+1.)*(fk+2.) - fnnp1
         Cp(l-1) = -(b1*Cp(l)+c1*Cp(l+1))/a1
         GOTO 50
      ENDIF
      END SUBROUTINE DALFK

! subroutine lfim (init,theta,l,n,nm,pb,id,wlfim)
!
! dimension of           theta(l),  pb(id,nm+1),  wlfim(4*l*(nm+1))
! arguments
!
! purpose                given n and l, routine lfim calculates
!                        the normalized associated legendre functions
!                        pbar(n,m,theta) for m=0,...,n and theta(i)
!                        for i=1,...,l where
!
!                        pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)
!                        /(2*factorial(n+m)))*sin(theta)**m/(2**n*
!                        factorial(n)) times the (n+m)th derivative of
!                        (x**2-1)**n with respect to x=cos(theta)
!
! usage                  call lfim (init,theta,l,n,nm,pb,id,wlfim)
!
! arguments
! on input               init
!                        = 0
!                            initialization only - using parameters
!                            l, nm and array theta, subroutine lfim
!                            initializes array wlfim for subsequent
!                            use in the computation of the associated
!                            legendre functions pb. initialization
!                            does not have to be repeated unless
!                            l, nm, or array theta are changed.
!                        = 1
!                            subroutine lfim uses the array wlfim that
!                            was computed with init = 0 to compute pb.
!
!                        theta
!                          an array that contains the colatitudes
!                          at which the associated legendre functions
!                          will be computed. the colatitudes must be
!                          specified in radians.
!
!                        l
!                          the length of the theta array. lfim is
!                          vectorized with vector length l.
!
!                        n
!                          nonnegative integer, less than nm, specifying
!                          degree of pbar(n,m,theta). subroutine lfim
!                          must be called starting with n=0. n must be
!                          incremented by one in subsequent calls and
!                          must not exceed nm.
!
!                        nm
!                          the maximum value of n and m
!
!                        id
!                          the first dimension of the two dimensional
!                          array pb as it appears in the program that
!                          calls lfim. (see output parameter pb)
!
!                        wlfim
!                          an array with length 4*l*(nm+1) which
!                          must be initialized by calling lfim
!                          with init=0 (see parameter init)  it
!                          must not be altered between calls to
!                          lfim.
!
!
! on output              pb
!                          a two dimensional array with first
!                          dimension id in the program that calls
!                          lfim. the second dimension of pb must
!                          be at least nm+1. starting with n=0
!                          lfim is called repeatedly with n being
!                          increased by one between calls. on each
!                          call, subroutine lfim computes
!                          = pbar(m,n,theta(i)) for m=0,...,n and
!                          i=1,...l.
!
!                        wlfim
!                          array containing values which must not
!                          be altered unless l, nm or the array theta
!                          are changed in which case lfim must be
!                          called with init=0 to reinitialize the
!                          wlfim array.
!
! special conditions     n must be increased by one between calls
!                        of lfim in which n is not zero.
!
! precision              single
!
!
! algorithm              routine lfim calculates pbar(n,m,theta) using
!                        a four term recurrence relation. (unpublished
!                        notes by paul n. swarztrauber)
!
      SUBROUTINE LFIM(Init,Theta,L,N,Nm,Pb,Id,Wlfim)
      IMPLICIT NONE
!*--LFIM284

      INTEGER Id , Init , iw1 , iw2 , iw3 , L , lnx , N , Nm
      REAL :: Theta
      REAL, DIMENSION(1) :: Pb, Wlfim

!
!     total length of wlfim is 4*l*(nm+1)
!
      lnx = L*(Nm+1)
      iw1 = lnx + 1
      iw2 = iw1 + lnx
      iw3 = iw2 + lnx
      CALL LFIM1(Init,Theta,L,N,Nm,Id,Pb,Wlfim,Wlfim(iw1),Wlfim(iw2),   &
               & Wlfim(iw3),Wlfim(iw2))
    END SUBROUTINE LFIM

    
    SUBROUTINE DLFIM(Init,Theta,L,N,Nm,Pb,Id,Wlfim)
      IMPLICIT NONE
!*--LFIM284

      INTEGER Id , Init , iw1 , iw2 , iw3 , L , lnx , N , Nm
      DOUBLE PRECISION :: Theta
      DOUBLE PRECISION, DIMENSION(1) :: Pb, Wlfim

!
!     total length of wlfim is 4*l*(nm+1)
!
      lnx = L*(Nm+1)
      iw1 = lnx + 1
      iw2 = iw1 + lnx
      iw3 = iw2 + lnx
      CALL DLFIM1(Init,Theta,L,N,Nm,Id,Pb,Wlfim,Wlfim(iw1),Wlfim(iw2),   &
               & Wlfim(iw3),Wlfim(iw2))
    END SUBROUTINE DLFIM

      
    SUBROUTINE LFIM1(Init,Theta,L,N,Nm,Id,P3,Phz,Ph1,P1,P2,Cp)
      IMPLICIT NONE

      REAL cc , cn , dd , ee , fm , fn , fnmm , fnpm  ,   &
         &    sq1s6 , sq5s6 , ssqrt2 , temp ,  tn
      INTEGER i , Id , Init , L , m , mp1 , N , nh , Nm , nm1 , nmp1 ,  &
            & np1

      REAL, DIMENSION(L,1) :: P1, P2, Ph1, Phz
      REAL, DIMENSION(1)   :: Cp, Theta
      REAL, DIMENSION(Id, 1) :: P3
      nmp1 = Nm + 1
      IF ( Init.EQ.0 ) THEN
         ssqrt2 = 1./SQRT(2.)
         DO i = 1 , L
            Phz(i,1) = ssqrt2
         ENDDO
         DO np1 = 2 , nmp1
            nh = np1 - 1
            CALL ALFK(nh,0,Cp)
            DO i = 1 , L
               CALL LFPT(nh,0,Theta(i),Cp,Phz(i,np1))
            ENDDO
            CALL ALFK(nh,1,Cp)
            DO i = 1 , L
               CALL LFPT(nh,1,Theta(i),Cp,Ph1(i,np1))
            ENDDO
         ENDDO
         RETURN
      ELSEIF ( N.GT.2 ) THEN
         nm1 = N - 1
         np1 = N + 1
         fn = FLOAT(N)
         tn = fn + fn
         cn = (tn+1.)/(tn-3.)
         DO i = 1 , L
            P3(i,1) = Phz(i,np1)
            P3(i,2) = Ph1(i,np1)
         ENDDO
         IF ( nm1.GE.3 ) THEN
            DO mp1 = 3 , nm1
               m = mp1 - 1
               fm = FLOAT(m)
               fnpm = fn + fm
               fnmm = fn - fm
               temp = fnpm*(fnpm-1.)
               cc = SQRT(cn*(fnpm-3.)*(fnpm-2.)/temp)
               dd = SQRT(cn*fnmm*(fnmm-1.)/temp)
               ee = SQRT((fnmm+1.)*(fnmm+2.)/temp)
               DO i = 1 , L
                  P3(i,mp1) = cc*P1(i,mp1-2) + dd*P1(i,mp1)             &
                            & - ee*P3(i,mp1-2)
               ENDDO
            ENDDO
         ENDIF
         fnpm = fn + fn - 1.
         temp = fnpm*(fnpm-1.)
         cc = SQRT(cn*(fnpm-3.)*(fnpm-2.)/temp)
         ee = SQRT(6./temp)
         DO i = 1 , L
            P3(i,N) = cc*P1(i,N-2) - ee*P3(i,N-2)
         ENDDO
         fnpm = fn + fn
         temp = fnpm*(fnpm-1.)
         cc = SQRT(cn*(fnpm-3.)*(fnpm-2.)/temp)
         ee = SQRT(2./temp)
         DO i = 1 , L
            P3(i,N+1) = cc*P1(i,N-1) - ee*P3(i,N-1)
         ENDDO
         DO mp1 = 1 , np1
            DO i = 1 , L
               P1(i,mp1) = P2(i,mp1)
               P2(i,mp1) = P3(i,mp1)
            ENDDO
         ENDDO
      ELSEIF ( N.LT.1 ) THEN
         DO i = 1 , L
            P3(i,1) = Phz(i,1)
         ENDDO
         RETURN
      ELSEIF ( N.EQ.1 ) THEN
         DO i = 1 , L
            P3(i,1) = Phz(i,2)
            P3(i,2) = Ph1(i,2)
         ENDDO
         RETURN
      ELSE
         sq5s6 = SQRT(5./6.)
         sq1s6 = SQRT(1./6.)
         DO i = 1 , L
            P3(i,1) = Phz(i,3)
            P3(i,2) = Ph1(i,3)
            P3(i,3) = sq5s6*Phz(i,1) - sq1s6*P3(i,1)
            P1(i,1) = Phz(i,2)
            P1(i,2) = Ph1(i,2)
            P2(i,1) = Phz(i,3)
            P2(i,2) = Ph1(i,3)
            P2(i,3) = P3(i,3)
         ENDDO
         RETURN
      ENDIF
    END SUBROUTINE LFIM1

    
    SUBROUTINE DLFIM1(Init,Theta,L,N,Nm,Id,P3,Phz,Ph1,P1,P2,Cp)
      IMPLICIT  NONE

      DOUBLE PRECISION cc , cn , Cp , dd , ee , fm , fn , fnmm , fnpm , P1 , P2 ,   &
         & P3 , Ph1 , Phz , sq1s6 , sq5s6 , ssqrt2 , temp , Theta , tn
      INTEGER i , Id , Init , L , m , mp1 , N , nh , Nm , nm1 , nmp1 ,  &
            & np1

      DIMENSION P1(L,1) , P2(L,1) , P3(Id,1) , Phz(L,1) , Ph1(L,1) ,    &
              & Cp(1) , Theta(1)
      nmp1 = Nm + 1
      IF ( Init.EQ.0 ) THEN
         ssqrt2 = 1./SQRT(2.)
         DO i = 1 , L
            Phz(i,1) = ssqrt2
         ENDDO
         DO np1 = 2 , nmp1
            nh = np1 - 1
            CALL DALFK(nh,0,Cp)
            DO i = 1 , L
               CALL DLFPT(nh,0,Theta(i),Cp,Phz(i,np1))
            ENDDO
            CALL DALFK(nh,1,Cp)
            DO i = 1 , L
               CALL DLFPT(nh,1,Theta(i),Cp,Ph1(i,np1))
            ENDDO
         ENDDO
         RETURN
      ELSEIF ( N.GT.2 ) THEN
         nm1 = N - 1
         np1 = N + 1
         fn = FLOAT(N)
         tn = fn + fn
         cn = (tn+1.)/(tn-3.)
         DO i = 1 , L
            P3(i,1) = Phz(i,np1)
            P3(i,2) = Ph1(i,np1)
         ENDDO
         IF ( nm1.GE.3 ) THEN
            DO mp1 = 3 , nm1
               m = mp1 - 1
               fm = FLOAT(m)
               fnpm = fn + fm
               fnmm = fn - fm
               temp = fnpm*(fnpm-1.)
               cc = SQRT(cn*(fnpm-3.)*(fnpm-2.)/temp)
               dd = SQRT(cn*fnmm*(fnmm-1.)/temp)
               ee = SQRT((fnmm+1.)*(fnmm+2.)/temp)
               DO i = 1 , L
                  P3(i,mp1) = cc*P1(i,mp1-2) + dd*P1(i,mp1)             &
                            & - ee*P3(i,mp1-2)
               ENDDO
            ENDDO
         ENDIF
         fnpm = fn + fn - 1.
         temp = fnpm*(fnpm-1.)
         cc = SQRT(cn*(fnpm-3.)*(fnpm-2.)/temp)
         ee = SQRT(6./temp)
         DO i = 1 , L
            P3(i,N) = cc*P1(i,N-2) - ee*P3(i,N-2)
         ENDDO
         fnpm = fn + fn
         temp = fnpm*(fnpm-1.)
         cc = SQRT(cn*(fnpm-3.)*(fnpm-2.)/temp)
         ee = SQRT(2./temp)
         DO i = 1 , L
            P3(i,N+1) = cc*P1(i,N-1) - ee*P3(i,N-1)
         ENDDO
         DO mp1 = 1 , np1
            DO i = 1 , L
               P1(i,mp1) = P2(i,mp1)
               P2(i,mp1) = P3(i,mp1)
            ENDDO
         ENDDO
      ELSEIF ( N.LT.1 ) THEN
         DO i = 1 , L
            P3(i,1) = Phz(i,1)
         ENDDO
         RETURN
      ELSEIF ( N.EQ.1 ) THEN
         DO i = 1 , L
            P3(i,1) = Phz(i,2)
            P3(i,2) = Ph1(i,2)
         ENDDO
         RETURN
      ELSE
         sq5s6 = SQRT(5./6.)
         sq1s6 = SQRT(1./6.)
         DO i = 1 , L
            P3(i,1) = Phz(i,3)
            P3(i,2) = Ph1(i,3)
            P3(i,3) = sq5s6*Phz(i,1) - sq1s6*P3(i,1)
            P1(i,1) = Phz(i,2)
            P1(i,2) = Ph1(i,2)
            P2(i,1) = Phz(i,3)
            P2(i,2) = Ph1(i,3)
            P2(i,3) = P3(i,3)
         ENDDO
         RETURN
      ENDIF
    END SUBROUTINE DLFIM1

! subroutine lfin (init,theta,l,m,nm,pb,id,wlfin)
!
! dimension of           theta(l),  pb(id,nm+1),  wlfin(4*l*(nm+1))
! arguments
!
! purpose                given m and l, routine lfin calculates
!                        the normalized associated legendre functions
!                        pbar(n,m,theta) for n=m,...,nm and theta(i)
!                        for i=1,...,l where
!
!                        pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)
!                        /(2*factorial(n+m)))*sin(theta)**m/(2**n*
!                        factorial(n)) times the (n+m)th derivative of
!                        (x**2-1)**n with respect to x=cos(theta)
!
! usage                  call lfin (init,theta,l,m,nm,pb,id,wlfin)
!
! arguments
! on input               init
!                        = 0
!                            initialization only - using parameters
!                            l, nm and the array theta, subroutine lfin
!                            initializes the array wlfin for subsequent
!                            use in the computation of the associated
!                            legendre functions pb. initialization does
!                            not have to be repeated unless l, nm or
!                            the array theta are changed.
!                        = 1
!                            subroutine lfin uses the array wlfin that
!                            was computed with init = 0 to compute pb
!
!                        theta
!                          an array that contains the colatitudes
!                          at which the associated legendre functions
!                          will be computed. the colatitudes must be
!                          specified in radians.
!
!                        l
!                          the length of the theta array. lfin is
!                          vectorized with vector length l.
!
!                        m
!                          nonnegative integer, less than nm, specifying
!                          degree of pbar(n,m,theta). subroutine lfin
!                          must be called starting with n=0. n must be
!                          incremented by one in subsequent calls and
!                          must not exceed nm.
!
!                        nm
!                          the maximum value of n and m
!
!                        id
!                          the first dimension of the two dimensional
!                          array pb as it appears in the program that
!                          calls lfin. (see output parameter pb)
!
!                        wlfin
!                          an array with length 4*l*(nm+1) which
!                          must be initialized by calling lfin
!                          with init=0 (see parameter init)  it
!                          must not be altered between calls to
!                          lfin.
!
!
! on output              pb
!                          a two dimensional array with first
!                          dimension id in the program that calls
!                          lfin. the second dimension of pb must
!                          be at least nm+1. starting with m=0
!                          lfin is called repeatedly with m being
!                          increased by one between calls. on each
!                          call, subroutine lfin computes pb(i,n+1)
!                          = pbar(m,n,theta(i)) for n=m,...,nm and
!                          i=1,...l.
!
!                        wlfin
!                          array containing values which must not
!                          be altered unless l, nm or the array theta
!                          are changed in which case lfin must be
!                          called with init=0 to reinitialize the
!                          wlfin array.
!
! special conditions     m must be increased by one between calls
!                        of lfin in which m is not zero.
!
! precision              single
!
! algorithm              routine lfin calculates pbar(n,m,theta) using
!                        a four term recurrence relation. (unpublished
!                        notes by paul n. swarztrauber)
!
      SUBROUTINE LFIN(Init,Theta,L,M,Nm,Pb,Id,Wlfin)
      IMPLICIT NONE

      INTEGER Id , Init , iw1 , iw2 , iw3 , L , lnx , M , Nm
      REAL Theta

      REAL, DIMENSION(1) :: Pb, Wlfin

!     total length of wlfin is 4*l*(nm+1)

      lnx = L*(Nm+1)
      iw1 = lnx + 1
      iw2 = iw1 + lnx
      iw3 = iw2 + lnx
      CALL LFIN1(Init,Theta,L,M,Nm,Id,Pb,Wlfin,Wlfin(iw1),Wlfin(iw2),   &
               & Wlfin(iw3),Wlfin(iw2))
    END SUBROUTINE LFIN

    
    SUBROUTINE DLFIN(Init,Theta,L,M,Nm,Pb,Id,Wlfin)
      IMPLICIT NONE

      INTEGER Id , Init , iw1 , iw2 , iw3 , L , lnx , M , Nm
      DOUBLE PRECISION, DIMENSION(1) :: Pb ,  Wlfin
      DOUBLE PRECISION :: Theta

      !     total length of wlfin is 4*l*(nm+1)

      lnx = L*(Nm+1)
      iw1 = lnx + 1
      iw2 = iw1 + lnx
      iw3 = iw2 + lnx
      CALL DLFIN1(Init,Theta,L,M,Nm,Id,Pb,Wlfin,Wlfin(iw1),Wlfin(iw2),   &
               & Wlfin(iw3),Wlfin(iw2))
      END SUBROUTINE DLFIN

      
      SUBROUTINE LFIN1(Init,Theta,L,M,Nm,Id,P3,Phz,Ph1,P1,P2,Cp)
      IMPLICIT NONE

      REAL cc , cn , Cp , dd , ee , fm , fn , fnmm , fnpm , P1 , P2 ,   &
         & P3 , Ph1 , Phz , ssqrt2 , temp , Theta , tm , tn
      INTEGER i , Id , Init , L , M , mp1 , mp3 , n , nh , Nm , nmp1 ,  &
            & np1

      DIMENSION P1(L,1) , P2(L,1) , P3(Id,1) , Phz(L,1) , Ph1(L,1) ,    &
              & Cp(1) , Theta(1)
      nmp1 = Nm + 1
      IF ( Init.NE.0 ) THEN
         mp1 = M + 1
         fm = FLOAT(M)
         tm = fm + fm
         IF ( M.LT.1 ) THEN
            DO np1 = 1 , nmp1
               DO i = 1 , L
                  P3(i,np1) = Phz(i,np1)
                  P1(i,np1) = Phz(i,np1)
               ENDDO
            ENDDO
            RETURN
         ELSEIF ( M.EQ.1 ) THEN
            DO np1 = 2 , nmp1
               DO i = 1 , L
                  P3(i,np1) = Ph1(i,np1)
                  P2(i,np1) = Ph1(i,np1)
               ENDDO
            ENDDO
            RETURN
         ELSE
            temp = tm*(tm-1.)
            cc = SQRT((tm+1.)*(tm-2.)/temp)
            ee = SQRT(2./temp)
            DO i = 1 , L
               P3(i,M+1) = cc*P1(i,M-1) - ee*P1(i,M+1)
            ENDDO
            IF ( M.EQ.Nm ) RETURN
            temp = tm*(tm+1.)
            cc = SQRT((tm+3.)*(tm-2.)/temp)
            ee = SQRT(6./temp)
            DO i = 1 , L
               P3(i,M+2) = cc*P1(i,M) - ee*P1(i,M+2)
            ENDDO
            mp3 = M + 3
            IF ( nmp1.GE.mp3 ) THEN
               DO np1 = mp3 , nmp1
                  n = np1 - 1
                  fn = FLOAT(n)
                  tn = fn + fn
                  cn = (tn+1.)/(tn-3.)
                  fnpm = fn + fm
                  fnmm = fn - fm
                  temp = fnpm*(fnpm-1.)
                  cc = SQRT(cn*(fnpm-3.)*(fnpm-2.)/temp)
                  dd = SQRT(cn*fnmm*(fnmm-1.)/temp)
                  ee = SQRT((fnmm+1.)*(fnmm+2.)/temp)
                  DO i = 1 , L
                     P3(i,np1) = cc*P1(i,np1-2) + dd*P3(i,np1-2)        &
                               & - ee*P1(i,np1)
                  ENDDO
               ENDDO
            ENDIF
            DO np1 = M , nmp1
               DO i = 1 , L
                  P1(i,np1) = P2(i,np1)
                  P2(i,np1) = P3(i,np1)
               ENDDO
            ENDDO
         ENDIF
      ELSE
         ssqrt2 = 1./SQRT(2.)
         DO i = 1 , L
            Phz(i,1) = ssqrt2
         ENDDO
         DO np1 = 2 , nmp1
            nh = np1 - 1
            CALL ALFK(nh,0,Cp)
            DO i = 1 , L
               CALL LFPT(nh,0,Theta(i),Cp,Phz(i,np1))
            ENDDO
            CALL ALFK(nh,1,Cp)
            DO i = 1 , L
               CALL LFPT(nh,1,Theta(i),Cp,Ph1(i,np1))
            ENDDO
         ENDDO
         RETURN
      ENDIF
    END SUBROUTINE LFIN1

    
    SUBROUTINE DLFIN1(Init,Theta,L,M,Nm,Id,P3,Phz,Ph1,P1,P2,Cp)
      IMPLICIT NONE


      DOUBLE PRECISION cc , cn , Cp , dd , ee , fm , fn , fnmm , fnpm , P1 , P2 ,   &
         & P3 , Ph1 , Phz , ssqrt2 , temp , Theta , tm , tn
      INTEGER i , Id , Init , L , M , mp1 , mp3 , n , nh , Nm , nmp1 ,  &
            & np1

      DIMENSION P1(L,1) , P2(L,1) , P3(Id,1) , Phz(L,1) , Ph1(L,1) ,    &
              & Cp(1) , Theta(1)
      nmp1 = Nm + 1
      IF ( Init.NE.0 ) THEN
         mp1 = M + 1
         fm = FLOAT(M)
         tm = fm + fm
         IF ( M.LT.1 ) THEN
            DO np1 = 1 , nmp1
               DO i = 1 , L
                  P3(i,np1) = Phz(i,np1)
                  P1(i,np1) = Phz(i,np1)
               ENDDO
            ENDDO
            RETURN
         ELSEIF ( M.EQ.1 ) THEN
            DO np1 = 2 , nmp1
               DO i = 1 , L
                  P3(i,np1) = Ph1(i,np1)
                  P2(i,np1) = Ph1(i,np1)
               ENDDO
            ENDDO
            RETURN
         ELSE
            temp = tm*(tm-1.)
            cc = SQRT((tm+1.)*(tm-2.)/temp)
            ee = SQRT(2./temp)
            DO i = 1 , L
               P3(i,M+1) = cc*P1(i,M-1) - ee*P1(i,M+1)
            ENDDO
            IF ( M.EQ.Nm ) RETURN
            temp = tm*(tm+1.)
            cc = SQRT((tm+3.)*(tm-2.)/temp)
            ee = SQRT(6./temp)
            DO i = 1 , L
               P3(i,M+2) = cc*P1(i,M) - ee*P1(i,M+2)
            ENDDO
            mp3 = M + 3
            IF ( nmp1.GE.mp3 ) THEN
               DO np1 = mp3 , nmp1
                  n = np1 - 1
                  fn = FLOAT(n)
                  tn = fn + fn
                  cn = (tn+1.)/(tn-3.)
                  fnpm = fn + fm
                  fnmm = fn - fm
                  temp = fnpm*(fnpm-1.)
                  cc = SQRT(cn*(fnpm-3.)*(fnpm-2.)/temp)
                  dd = SQRT(cn*fnmm*(fnmm-1.)/temp)
                  ee = SQRT((fnmm+1.)*(fnmm+2.)/temp)
                  DO i = 1 , L
                     P3(i,np1) = cc*P1(i,np1-2) + dd*P3(i,np1-2)        &
                               & - ee*P1(i,np1)
                  ENDDO
               ENDDO
            ENDIF
            DO np1 = M , nmp1
               DO i = 1 , L
                  P1(i,np1) = P2(i,np1)
                  P2(i,np1) = P3(i,np1)
               ENDDO
            ENDDO
         ENDIF
      ELSE
         ssqrt2 = 1./SQRT(2.)
         DO i = 1 , L
            Phz(i,1) = ssqrt2
         ENDDO
         DO np1 = 2 , nmp1
            nh = np1 - 1
            CALL DALFK(nh,0,Cp)
            DO i = 1 , L
               CALL DLFPT(nh,0,Theta(i),Cp,Phz(i,np1))
            ENDDO
            CALL DALFK(nh,1,Cp)
            DO i = 1 , L
               CALL DLFPT(nh,1,Theta(i),Cp,Ph1(i,np1))
            ENDDO
         ENDDO
         RETURN
      ENDIF
      END SUBROUTINE DLFIN1

! subroutine lfpt (n,m,theta,cp,pb)
!
! dimension of
! arguments
!                        cp((n/2)+1)
!
! purpose                routine lfpt uses coefficients computed by
!                        routine alfk to compute the single precision
!                        normalized associated legendre function pbar(n,
!                        m,theta) at colatitude theta.
!
! usage                  call lfpt(n,m,theta,cp,pb)
!
! arguments
!
! on input               n
!                          nonnegative integer specifying the degree of
!                          pbar(n,m,theta)
!                        m
!                          is the order of pbar(n,m,theta). m can be
!                          any integer however pbar(n,m,theta) = 0
!                          if abs(m) is greater than n and
!                          pbar(n,m,theta) = (-1)**m*pbar(n,-m,theta)
!                          for negative m.
!
!                        theta
!                          single precision colatitude in radians
!
!                        cp
!                          single precision array of length (n/2)+1
!                          containing coefficients computed by routine
!                          alfk
!
! on output              pb
!                          single precision variable containing
!                          pbar(n,m,theta)
!
! special conditions     calls to routine lfpt must be preceded by an
!                        appropriate call to routine alfk.
!
! precision              single
!
! algorithm              the trigonometric series formula used by
!                        routine lfpt to calculate pbar(n,m,th) at
!                        colatitude th depends on m and n as follows:
!
!                           1) for n even and m even, the formula is
!                              .5*cp(1) plus the sum from k=1 to k=n/2
!                              of cp(k)*cos(2*k*th)
!                           2) for n even and m odd. the formula is
!                              the sum from k=1 to k=n/2 of
!                              cp(k)*sin(2*k*th)
!                           3) for n odd and m even, the formula is
!                              the sum from k=1 to k=(n+1)/2 of
!                              cp(k)*cos((2*k-1)*th)
!                           4) for n odd and m odd, the formula is
!                              the sum from k=1 to k=(n+1)/2 of
!                              cp(k)*sin((2*k-1)*th)
!
! accuracy               comparison between routines lfpt and double
!                        precision dlfpt on the cray1 indicates greater
!                        accuracy for greater values on input parameter
!                        n.  agreement to 13 places was obtained for
!                        n=10 and to 12 places for n=100.
!
! timing                 time per call to routine lfpt is dependent on
!                        the input parameter n.
!
      SUBROUTINE LFPT(N,M,Theta,Cp,Pb)
      IMPLICIT NONE

      REAL cdt , ct , cth , Pb , sdt , st , sum , Theta
      INTEGER k , kdo , kp1 , M , ma , mmod , N , nmod , np1

      REAL, DIMENSION(1) ::  Cp
!
      Pb = 0.
      ma = IABS(M)
      IF ( ma.GT.N ) RETURN
      IF ( N.LE.0 ) THEN
         IF ( ma.LE.0 ) THEN
            Pb = SQRT(.5)
            GOTO 99999
         ENDIF
      ENDIF
      np1 = N + 1
      nmod = MOD(N,2)
      mmod = MOD(ma,2)
      IF ( nmod.GT.0 ) THEN
         kdo = (N+1)/2
         IF ( mmod.LE.0 ) THEN
            cdt = COS(Theta+Theta)
            sdt = SIN(Theta+Theta)
            ct = COS(Theta)
            st = -SIN(Theta)
            sum = 0.
            DO k = 1 , kdo
               cth = cdt*ct - sdt*st
               st = sdt*ct + cdt*st
               ct = cth
               sum = sum + Cp(k)*ct
            ENDDO
            Pb = sum
         ELSE
            cdt = COS(Theta+Theta)
            sdt = SIN(Theta+Theta)
            ct = COS(Theta)
            st = -SIN(Theta)
            sum = 0.
            DO k = 1 , kdo
               cth = cdt*ct - sdt*st
               st = sdt*ct + cdt*st
               ct = cth
               sum = sum + Cp(k)*st
            ENDDO
            Pb = sum
         ENDIF
      ELSEIF ( mmod.LE.0 ) THEN
         kdo = N/2 + 1
         cdt = COS(Theta+Theta)
         sdt = SIN(Theta+Theta)
         ct = 1.
         st = 0.
         sum = .5*Cp(1)
         DO kp1 = 2 , kdo
            cth = cdt*ct - sdt*st
            st = sdt*ct + cdt*st
            ct = cth
            sum = sum + Cp(kp1)*ct
         ENDDO
         Pb = sum
      ELSE
         kdo = N/2
         cdt = COS(Theta+Theta)
         sdt = SIN(Theta+Theta)
         ct = 1.
         st = 0.
         sum = 0.
         DO k = 1 , kdo
            cth = cdt*ct - sdt*st
            st = sdt*ct + cdt*st
            ct = cth
            sum = sum + Cp(k)*st
         ENDDO
         Pb = sum
      ENDIF
99999 END SUBROUTINE LFPT

      
      SUBROUTINE DLFPT(N,M,Theta,Cp,Pb)
      IMPLICIT NONE

      DOUBLE PRECISION cdt , ct , cth , Pb , sdt , st , sum , Theta
      INTEGER k , kdo , kp1 , M , ma , mmod , N , nmod , np1

      DOUBLE PRECISION, DIMENSION(1) ::  Cp
!
      Pb = 0.
      ma = IABS(M)
      IF ( ma.GT.N ) RETURN
      IF ( N.LE.0 ) THEN
         IF ( ma.LE.0 ) THEN
            Pb = SQRT(.5)
            GOTO 99999
         ENDIF
      ENDIF
      np1 = N + 1
      nmod = MOD(N,2)
      mmod = MOD(ma,2)
      IF ( nmod.GT.0 ) THEN
         kdo = (N+1)/2
         IF ( mmod.LE.0 ) THEN
            cdt = COS(Theta+Theta)
            sdt = SIN(Theta+Theta)
            ct = COS(Theta)
            st = -SIN(Theta)
            sum = 0.
            DO k = 1 , kdo
               cth = cdt*ct - sdt*st
               st = sdt*ct + cdt*st
               ct = cth
               sum = sum + Cp(k)*ct
            ENDDO
            Pb = sum
         ELSE
            cdt = COS(Theta+Theta)
            sdt = SIN(Theta+Theta)
            ct = COS(Theta)
            st = -SIN(Theta)
            sum = 0.
            DO k = 1 , kdo
               cth = cdt*ct - sdt*st
               st = sdt*ct + cdt*st
               ct = cth
               sum = sum + Cp(k)*st
            ENDDO
            Pb = sum
         ENDIF
      ELSEIF ( mmod.LE.0 ) THEN
         kdo = N/2 + 1
         cdt = COS(Theta+Theta)
         sdt = SIN(Theta+Theta)
         ct = 1.
         st = 0.
         sum = .5*Cp(1)
         DO kp1 = 2 , kdo
            cth = cdt*ct - sdt*st
            st = sdt*ct + cdt*st
            ct = cth
            sum = sum + Cp(kp1)*ct
         ENDDO
         Pb = sum
      ELSE
         kdo = N/2
         cdt = COS(Theta+Theta)
         sdt = SIN(Theta+Theta)
         ct = 1.
         st = 0.
         sum = 0.
         DO k = 1 , kdo
            cth = cdt*ct - sdt*st
            st = sdt*ct + cdt*st
            ct = cth
            sum = sum + Cp(k)*st
         ENDDO
         Pb = sum
      ENDIF
99999 END SUBROUTINE DLFPT

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vtsec.f
c
c     this file includes documentation and code for
c     subroutines vtsec and vtseci
c
c ... files which must be loaded with vtsec.f
c
c     sphcom.f, hrfft.f, vhaec.f, vhsec.f
c   
c     subroutine vtsec(nlat,nlon,ityp,nt,vt,wt,idvw,jdvw,br,bi,cr,ci,
c    +                 mdab,ndab,wvts,lwvts,work,lwork,ierror)
c
c     given the vector harmonic analysis br,bi,cr, and ci (computed
c     by subroutine vhaec) of some vector function (v,w), this 
c     subroutine computes the vector function (vt,wt) which is
c     the derivative of (v,w) with respect to colatitude theta. vtsec
c     is similar to vhsec except the vector harmonics are replaced by 
c     their derivative with respect to colatitude with the result that
c     (vt,wt) is computed instead of (v,w). vt(i,j) is the derivative
c     of the colatitudinal component v(i,j) at the point theta(i) =
c     (i-1)*pi/(nlat-1) and longitude phi(j) = (j-1)*2*pi/nlon. the
c     spectral representation of (vt,wt) is given below at output
c     parameters vt,wt.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     ityp   = 0  no symmetries exist about the equator. the synthesis
c                 is performed on the entire sphere. i.e. the arrays
c                 vt(i,j),wt(i,j) are computed for i=1,...,nlat and
c                 j=1,...,nlon.   
c
c            = 1  no symmetries exist about the equator however the
c                 the coefficients cr and ci are zero. the synthesis
c                 is performed on the entire sphere.  i.e. the arrays
c                 vt(i,j),wt(i,j) are computed for i=1,...,nlat and
c                 j=1,...,nlon.
c
c            = 2  no symmetries exist about the equator however the
c                 the coefficients br and bi are zero. the synthesis
c                 is performed on the entire sphere.  i.e. the arrays
c                 vt(i,j),wt(i,j) are computed for i=1,...,nlat and 
c                 j=1,...,nlon.
c
c            = 3  vt is odd and wt is even about the equator. the 
c                 synthesis is performed on the northern hemisphere
c                 only.  i.e., if nlat is odd the arrays vt(i,j),wt(i,j)
c                 are computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the arrays vt(i,j),wt(i,j) are computed 
c                 for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 4  vt is odd and wt is even about the equator and the 
c                 coefficients cr and ci are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for 
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 5  vt is odd and wt is even about the equator and the 
c                 coefficients br and bi are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for 
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 6  vt is even and wt is odd about the equator. the 
c                 synthesis is performed on the northern hemisphere
c                 only.  i.e., if nlat is odd the arrays vt(i,j),wt(i,j)
c                 are computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the arrays vt(i,j),wt(i,j) are computed 
c                 for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 7  vt is even and wt is odd about the equator and the 
c                 coefficients cr and ci are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for 
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 8  vt is even and wt is odd about the equator and the 
c                 coefficients br and bi are zero. the synthesis is
c                 performed on the northern hemisphere only. i.e. if
c                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
c                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the arrays vt(i,j),wt(i,j) are computed for 
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c     nt     the number of syntheses.  in the program that calls vtsec,
c            the arrays vt,wt,br,bi,cr, and ci can be three dimensional
c            in which case multiple syntheses will be performed.
c            the third index is the synthesis index which assumes the 
c            values k=1,...,nt.  for a single synthesis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that all the arrays are two
c            dimensional.
c
c     idvw   the first dimension of the arrays vt,wt as it appears in
c            the program that calls vtsec. if ityp .le. 2 then idvw
c            must be at least nlat.  if ityp .gt. 2 and nlat is
c            even then idvw must be at least nlat/2. if ityp .gt. 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays vt,wt as it appears in
c            the program that calls vtsec. jdvw must be at least nlon.
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c     cr,ci  that contain the vector spherical harmonic coefficients
c            of (v,w) as computed by subroutine vhaec.
c
c     mdab   the first dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vtsec. mdab must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vtsec. ndab must be at
c            least nlat.
c
c     wvts   an array which must be initialized by subroutine vtseci.
c            once initialized, wvts can be used repeatedly by vtsec
c            as long as nlon and nlat remain unchanged.  wvts must
c            not be altered between calls of vtsec.
c
c     lwvts  the dimension of the array wvts as it appears in the
c            program that calls vtsec. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lwvts must be at least
c
c            4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vtsec. define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if ityp .le. 2 then lwork must be at least
c
c                    nlat*(2*nt*nlon+max0(6*l2,nlon))
c
c            if ityp .gt. 2 then lwork must be at least
c
c                    l2*(2*nt*nlon+max0(6*nlat,nlon))
c
c     **************************************************************
c
c     output parameters
c
c     vt,wt  two or three dimensional arrays (see input parameter nt)
c            in which the derivative of (v,w) with respect to 
c            colatitude theta is stored. vt(i,j),wt(i,j) contain the
c            derivatives at colatitude theta(i) = (i-1)*pi/(nlat-1)
c            and longitude phi(j) = (j-1)*2*pi/nlon. the index ranges
c            are defined above at the input parameter ityp. vt and wt
c            are computed from the formulas for v and w given in 
c            subroutine vhsec but with vbar and wbar replaced with
c            their derivatives with respect to colatitude. these
c            derivatives are denoted by vtbar and wtbar. 
c
c   in terms of real variables this expansion takes the form
c
c             for i=1,...,nlat and  j=1,...,nlon
c
c     vt(i,j) = the sum from n=1 to n=nlat-1 of
c
c               .5*br(1,n+1)*vtbar(0,n,theta(i))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to 
c     n=nlat-1 of the real part of
c
c       (br(m+1,n+1)*vtbar(m,n,theta(i))
c                   -ci(m+1,n+1)*wtbar(m,n,theta(i)))*cos(m*phi(j))
c      -(bi(m+1,n+1)*vtbar(m,n,theta(i))
c                   +cr(m+1,n+1)*wtbar(m,n,theta(i)))*sin(m*phi(j))
c
c    and for i=1,...,nlat and  j=1,...,nlon
c
c     wt(i,j) = the sum from n=1 to n=nlat-1 of
c
c              -.5*cr(1,n+1)*vtbar(0,n,theta(i))
c
c     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
c     n=nlat-1 of the real part of
c
c      -(cr(m+1,n+1)*vtbar(m,n,theta(i))
c                   +bi(m+1,n+1)*wtbar(m,n,theta(i)))*cos(m*phi(j))
c      +(ci(m+1,n+1)*vtbar(m,n,theta(i))
c                   -br(m+1,n+1)*wtbar(m,n,theta(i)))*sin(m*phi(j))
c
c
c      br(m+1,nlat),bi(m+1,nlat),cr(m+1,nlat), and ci(m+1,nlat) are
c      assumed zero for m even.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of ityp
c            = 4  error in the specification of nt
c            = 5  error in the specification of idvw
c            = 6  error in the specification of jdvw
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lwvts
c            = 10 error in the specification of lwork
c
c
c *******************************************************************
c
c     subroutine vtseci(nlat,nlon,wvts,lwvts,dwork,ldwork,ierror)
c
c     subroutine vtseci initializes the array wvts which can then be
c     used repeatedly by subroutine vtsec until nlat or nlon is changed.
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     lwvts  the dimension of the array wvts as it appears in the
c            program that calls vtsec. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lwvts must be at least
c
c            4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
c
c
c     dwork  a double precision work array that does not have to be saved.
c
c     ldwork the dimension of the array work as it appears in the
c            program that calls vtsec. lwork must be at least
c            2*(nlat+1)
c
c     **************************************************************
c
c     output parameters
c
c     wvts   an array which is initialized for use by subroutine vtsec.
c            once initialized, wvts can be used repeatedly by vtsec
c            as long as nlat or nlon remain unchanged.  wvts must not
c            be altered between calls of vtsec.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lwvts
c            = 4  error in the specification of ldwork
c
c **********************************************************************
c                                                                              
      subroutine vtsec(nlat,nlon,ityp,nt,vt,wt,idvw,jdvw,br,bi,cr,ci,
     1           mdab,ndab,wvts,lwvts,work,lwork,ierror)
c
      dimension vt(idvw,jdvw,1),wt(idvw,jdvw,1),br(mdab,ndab,1),
     1          bi(mdab,ndab,1),cr(mdab,ndab,1),ci(mdab,ndab,1),
     2          work(1),wvts(1)
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if(nlon .lt. 1) return
      ierror = 3
      if(ityp.lt.0 .or. ityp.gt.8) return
      ierror = 4
      if(nt .lt. 0) return
      ierror = 5
      imid = (nlat+1)/2
      if((ityp.le.2 .and. idvw.lt.nlat) .or.
     1   (ityp.gt.2 .and. idvw.lt.imid)) return
      ierror = 6
      if(jdvw .lt. nlon) return
      ierror = 7
      mmax = min0(nlat,(nlon+1)/2)
      if(mdab .lt. mmax) return
      ierror = 8
      if(ndab .lt. nlat) return
      ierror = 9
      lzz1 = 2*nlat*imid
      labc = 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
      if(lwvts .lt. 2*(lzz1+labc)+nlon+15) return
      ierror = 10
      if(ityp .le. 2 .and. 
     1         lwork .lt. nlat*(2*nt*nlon+max0(6*imid,nlon))) return
      if(ityp .gt. 2 .and. 
     1         lwork .lt. imid*(2*nt*nlon+max0(6*nlat,nlon))) return
      ierror = 0
      idv = nlat
      if(ityp .gt. 2) idv = imid
      lnl = nt*idv*nlon
      ist = 0
      if(ityp .le. 2) ist = imid
      iw1 = ist+1
      iw2 = lnl+1
      iw3 = iw2+ist
      iw4 = iw2+lnl
      iw5 = iw4+3*imid*nlat
      lzz1 = 2*nlat*imid
      labc = 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
      lwzvin = lzz1+labc
      jw1 = lwzvin+1
      jw2 = jw1+lwzvin
      call vtsec1(nlat,nlon,ityp,nt,imid,idvw,jdvw,vt,wt,mdab,ndab,
     1     br,bi,cr,ci,idv,work,work(iw1),work(iw2),work(iw3),
     2     work(iw4),work(iw5),wvts,wvts(jw1),wvts(jw2))
      return
      end
      subroutine vtsec1(nlat,nlon,ityp,nt,imid,idvw,jdvw,vt,wt,mdab,
     1   ndab,br,bi,cr,ci,idv,vte,vto,wte,wto,vb,wb,wvbin,wwbin,wrfft)
      dimension vt(idvw,jdvw,1),wt(idvw,jdvw,1),br(mdab,ndab,1),
     1          bi(mdab,ndab,1),cr(mdab,ndab,1),ci(mdab,ndab,1),
     2          vte(idv,nlon,1),vto(idv,nlon,1),wte(idv,nlon,1),
     3          wto(idv,nlon,1),wvbin(1),wwbin(1),wrfft(1),
     4          vb(imid,nlat,3),wb(imid,nlat,3)
      nlp1 = nlat+1
      mlat = mod(nlat,2)
      mlon = mod(nlon,2)
      mmax = min0(nlat,(nlon+1)/2)
      imm1 = imid
      if(mlat .ne. 0) imm1 = imid-1
      do 10 k=1,nt
      do 10 j=1,nlon
      do 10 i=1,idv
      vte(i,j,k) = 0.
      wte(i,j,k) = 0.
   10 continue
      ndo1 = nlat
      ndo2 = nlat
      if(mlat .ne. 0) ndo1 = nlat-1
      if(mlat .eq. 0) ndo2 = nlat-1
   18 itypp = ityp+1
      go to (1,100,200,300,400,500,600,700,800),itypp
c
c     case ityp=0   no symmetries
c
    1 call vbin(0,nlat,nlon,0,vb,iv,wvbin)
c
c     case m = 0
c
      do 15 k=1,nt
      do 15 np1=2,ndo2,2
      do 15 i=1,imm1
      vto(i,1,k)=vto(i,1,k)+br(1,np1,k)*vb(i,np1,iv)
      wto(i,1,k)=wto(i,1,k)-cr(1,np1,k)*vb(i,np1,iv)
   15 continue
      do 16 k=1,nt
      do 16 np1=3,ndo1,2
      do 16 i=1,imid
      vte(i,1,k)=vte(i,1,k)+br(1,np1,k)*vb(i,np1,iv)
      wte(i,1,k)=wte(i,1,k)-cr(1,np1,k)*vb(i,np1,iv)
   16 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) go to 950
      do 30 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(0,nlat,nlon,m,vb,iv,wvbin)
      call wbin(0,nlat,nlon,m,wb,iw,wwbin)
      if(mp1 .gt. ndo1) go to 26
      do 25 k=1,nt
      do 24 np1=mp1,ndo1,2
      do 23 i=1,imm1
      vte(i,2*mp1-2,k) = vte(i,2*mp1-2,k)+br(mp1,np1,k)*vb(i,np1,iv)
      vto(i,2*mp1-2,k) = vto(i,2*mp1-2,k)-ci(mp1,np1,k)*wb(i,np1,iw)
      vte(i,2*mp1-1,k) = vte(i,2*mp1-1,k)+bi(mp1,np1,k)*vb(i,np1,iv)
      vto(i,2*mp1-1,k) = vto(i,2*mp1-1,k)+cr(mp1,np1,k)*wb(i,np1,iw)
      wte(i,2*mp1-2,k) = wte(i,2*mp1-2,k)-cr(mp1,np1,k)*vb(i,np1,iv)
      wto(i,2*mp1-2,k) = wto(i,2*mp1-2,k)-bi(mp1,np1,k)*wb(i,np1,iw)
      wte(i,2*mp1-1,k) = wte(i,2*mp1-1,k)-ci(mp1,np1,k)*vb(i,np1,iv)
      wto(i,2*mp1-1,k) = wto(i,2*mp1-1,k)+br(mp1,np1,k)*wb(i,np1,iw)
   23 continue
      if(mlat .eq. 0) go to 24
      vte(imid,2*mp1-2,k) = vte(imid,2*mp1-2,k)
     1                     +br(mp1,np1,k)*vb(imid,np1,iv)
      vte(imid,2*mp1-1,k) = vte(imid,2*mp1-1,k)
     1                     +bi(mp1,np1,k)*vb(imid,np1,iv)
      wte(imid,2*mp1-2,k) = wte(imid,2*mp1-2,k)
     1                     -cr(mp1,np1,k)*vb(imid,np1,iv) 
      wte(imid,2*mp1-1,k) = wte(imid,2*mp1-1,k)
     1                     -ci(mp1,np1,k)*vb(imid,np1,iv)
   24 continue
   25 continue
   26 if(mp2 .gt. ndo2) go to 30
      do 29 k=1,nt
      do 28 np1=mp2,ndo2,2
      do 27 i=1,imm1
      vto(i,2*mp1-2,k) = vto(i,2*mp1-2,k)+br(mp1,np1,k)*vb(i,np1,iv)
      vte(i,2*mp1-2,k) = vte(i,2*mp1-2,k)-ci(mp1,np1,k)*wb(i,np1,iw)
      vto(i,2*mp1-1,k) = vto(i,2*mp1-1,k)+bi(mp1,np1,k)*vb(i,np1,iv)
      vte(i,2*mp1-1,k) = vte(i,2*mp1-1,k)+cr(mp1,np1,k)*wb(i,np1,iw)
      wto(i,2*mp1-2,k) = wto(i,2*mp1-2,k)-cr(mp1,np1,k)*vb(i,np1,iv)
      wte(i,2*mp1-2,k) = wte(i,2*mp1-2,k)-bi(mp1,np1,k)*wb(i,np1,iw)
      wto(i,2*mp1-1,k) = wto(i,2*mp1-1,k)-ci(mp1,np1,k)*vb(i,np1,iv)
      wte(i,2*mp1-1,k) = wte(i,2*mp1-1,k)+br(mp1,np1,k)*wb(i,np1,iw)
   27 continue
      if(mlat .eq. 0) go to 28
      vte(imid,2*mp1-2,k) = vte(imid,2*mp1-2,k)
     1                     -ci(mp1,np1,k)*wb(imid,np1,iw) 
      vte(imid,2*mp1-1,k) = vte(imid,2*mp1-1,k)
     1                     +cr(mp1,np1,k)*wb(imid,np1,iw)
      wte(imid,2*mp1-2,k) = wte(imid,2*mp1-2,k)
     1                     -bi(mp1,np1,k)*wb(imid,np1,iw)
      wte(imid,2*mp1-1,k) = wte(imid,2*mp1-1,k)
     1                     +br(mp1,np1,k)*wb(imid,np1,iw)
   28 continue
   29 continue
   30 continue
      go to 950
c
c     case ityp=1   no symmetries,  cr and ci equal zero
c
  100 call vbin(0,nlat,nlon,0,vb,iv,wvbin)
c
c     case m = 0
c
      do 115 k=1,nt
      do 115 np1=2,ndo2,2
      do 115 i=1,imm1
      vto(i,1,k)=vto(i,1,k)+br(1,np1,k)*vb(i,np1,iv)
  115 continue
      do 116 k=1,nt
      do 116 np1=3,ndo1,2
      do 116 i=1,imid
      vte(i,1,k)=vte(i,1,k)+br(1,np1,k)*vb(i,np1,iv)
  116 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) go to 950
      do 130 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(0,nlat,nlon,m,vb,iv,wvbin)
      call wbin(0,nlat,nlon,m,wb,iw,wwbin)
      if(mp1 .gt. ndo1) go to 126
      do 125 k=1,nt
      do 124 np1=mp1,ndo1,2
      do 123 i=1,imm1
      vte(i,2*mp1-2,k) = vte(i,2*mp1-2,k)+br(mp1,np1,k)*vb(i,np1,iv)
      vte(i,2*mp1-1,k) = vte(i,2*mp1-1,k)+bi(mp1,np1,k)*vb(i,np1,iv)
      wto(i,2*mp1-2,k) = wto(i,2*mp1-2,k)-bi(mp1,np1,k)*wb(i,np1,iw)
      wto(i,2*mp1-1,k) = wto(i,2*mp1-1,k)+br(mp1,np1,k)*wb(i,np1,iw)
  123 continue
      if(mlat .eq. 0) go to 124
      vte(imid,2*mp1-2,k) = vte(imid,2*mp1-2,k)
     1                     +br(mp1,np1,k)*vb(imid,np1,iv)
      vte(imid,2*mp1-1,k) = vte(imid,2*mp1-1,k)
     1                     +bi(mp1,np1,k)*vb(imid,np1,iv)
  124 continue
  125 continue
  126 if(mp2 .gt. ndo2) go to 130
      do 129 k=1,nt
      do 128 np1=mp2,ndo2,2
      do 127 i=1,imm1
      vto(i,2*mp1-2,k) = vto(i,2*mp1-2,k)+br(mp1,np1,k)*vb(i,np1,iv)
      vto(i,2*mp1-1,k) = vto(i,2*mp1-1,k)+bi(mp1,np1,k)*vb(i,np1,iv)
      wte(i,2*mp1-2,k) = wte(i,2*mp1-2,k)-bi(mp1,np1,k)*wb(i,np1,iw)
      wte(i,2*mp1-1,k) = wte(i,2*mp1-1,k)+br(mp1,np1,k)*wb(i,np1,iw)
  127 continue
      if(mlat .eq. 0) go to 128
      wte(imid,2*mp1-2,k) = wte(imid,2*mp1-2,k)
     1                     -bi(mp1,np1,k)*wb(imid,np1,iw)
      wte(imid,2*mp1-1,k) = wte(imid,2*mp1-1,k)
     1                     +br(mp1,np1,k)*wb(imid,np1,iw)
  128 continue
  129 continue
  130 continue
      go to 950
c
c     case ityp=2   no symmetries,  br and bi are equal to zero
c
  200 call vbin(0,nlat,nlon,0,vb,iv,wvbin)
c
c     case m = 0
c
      do 215 k=1,nt
      do 215 np1=2,ndo2,2
      do 215 i=1,imm1
      wto(i,1,k)=wto(i,1,k)-cr(1,np1,k)*vb(i,np1,iv)
  215 continue
      do 216 k=1,nt
      do 216 np1=3,ndo1,2
      do 216 i=1,imid
      wte(i,1,k)=wte(i,1,k)-cr(1,np1,k)*vb(i,np1,iv)
  216 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) go to 950
      do 230 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(0,nlat,nlon,m,vb,iv,wvbin)
      call wbin(0,nlat,nlon,m,wb,iw,wwbin)
      if(mp1 .gt. ndo1) go to 226
      do 225 k=1,nt
      do 224 np1=mp1,ndo1,2
      do 223 i=1,imm1
      vto(i,2*mp1-2,k) = vto(i,2*mp1-2,k)-ci(mp1,np1,k)*wb(i,np1,iw)
      vto(i,2*mp1-1,k) = vto(i,2*mp1-1,k)+cr(mp1,np1,k)*wb(i,np1,iw)
      wte(i,2*mp1-2,k) = wte(i,2*mp1-2,k)-cr(mp1,np1,k)*vb(i,np1,iv)
      wte(i,2*mp1-1,k) = wte(i,2*mp1-1,k)-ci(mp1,np1,k)*vb(i,np1,iv)
  223 continue
      if(mlat .eq. 0) go to 224
      wte(imid,2*mp1-2,k) = wte(imid,2*mp1-2,k)
     1                     -cr(mp1,np1,k)*vb(imid,np1,iv) 
      wte(imid,2*mp1-1,k) = wte(imid,2*mp1-1,k)
     1                     -ci(mp1,np1,k)*vb(imid,np1,iv)
  224 continue
  225 continue
  226 if(mp2 .gt. ndo2) go to 230
      do 229 k=1,nt
      do 228 np1=mp2,ndo2,2
      do 227 i=1,imm1
      vte(i,2*mp1-2,k) = vte(i,2*mp1-2,k)-ci(mp1,np1,k)*wb(i,np1,iw)
      vte(i,2*mp1-1,k) = vte(i,2*mp1-1,k)+cr(mp1,np1,k)*wb(i,np1,iw)
      wto(i,2*mp1-2,k) = wto(i,2*mp1-2,k)-cr(mp1,np1,k)*vb(i,np1,iv)
      wto(i,2*mp1-1,k) = wto(i,2*mp1-1,k)-ci(mp1,np1,k)*vb(i,np1,iv)
  227 continue
      if(mlat .eq. 0) go to 228
      vte(imid,2*mp1-2,k) = vte(imid,2*mp1-2,k)
     1                     -ci(mp1,np1,k)*wb(imid,np1,iw) 
      vte(imid,2*mp1-1,k) = vte(imid,2*mp1-1,k)
     1                     +cr(mp1,np1,k)*wb(imid,np1,iw)
  228 continue
  229 continue
  230 continue
      go to 950
c
c     case ityp=3   v odd,  w even
c
  300 call vbin(0,nlat,nlon,0,vb,iv,wvbin)
c
c     case m = 0
c
      do 315 k=1,nt
      do 315 np1=2,ndo2,2
      do 315 i=1,imm1
      vto(i,1,k)=vto(i,1,k)+br(1,np1,k)*vb(i,np1,iv)
  315 continue
      do 316 k=1,nt
      do 316 np1=3,ndo1,2
      do 316 i=1,imid
      wte(i,1,k)=wte(i,1,k)-cr(1,np1,k)*vb(i,np1,iv)
  316 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) go to 950
      do 330 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(0,nlat,nlon,m,vb,iv,wvbin)
      call wbin(0,nlat,nlon,m,wb,iw,wwbin)
      if(mp1 .gt. ndo1) go to 326
      do 325 k=1,nt
      do 324 np1=mp1,ndo1,2
      do 323 i=1,imm1
      vto(i,2*mp1-2,k) = vto(i,2*mp1-2,k)-ci(mp1,np1,k)*wb(i,np1,iw)
      vto(i,2*mp1-1,k) = vto(i,2*mp1-1,k)+cr(mp1,np1,k)*wb(i,np1,iw)
      wte(i,2*mp1-2,k) = wte(i,2*mp1-2,k)-cr(mp1,np1,k)*vb(i,np1,iv)
      wte(i,2*mp1-1,k) = wte(i,2*mp1-1,k)-ci(mp1,np1,k)*vb(i,np1,iv)
  323 continue
      if(mlat .eq. 0) go to 324
      wte(imid,2*mp1-2,k) = wte(imid,2*mp1-2,k)
     1                     -cr(mp1,np1,k)*vb(imid,np1,iv) 
      wte(imid,2*mp1-1,k) = wte(imid,2*mp1-1,k)
     1                     -ci(mp1,np1,k)*vb(imid,np1,iv)
  324 continue
  325 continue
  326 if(mp2 .gt. ndo2) go to 330
      do 329 k=1,nt
      do 328 np1=mp2,ndo2,2
      do 327 i=1,imm1
      vto(i,2*mp1-2,k) = vto(i,2*mp1-2,k)+br(mp1,np1,k)*vb(i,np1,iv)
      vto(i,2*mp1-1,k) = vto(i,2*mp1-1,k)+bi(mp1,np1,k)*vb(i,np1,iv)
      wte(i,2*mp1-2,k) = wte(i,2*mp1-2,k)-bi(mp1,np1,k)*wb(i,np1,iw)
      wte(i,2*mp1-1,k) = wte(i,2*mp1-1,k)+br(mp1,np1,k)*wb(i,np1,iw)
  327 continue
      if(mlat .eq. 0) go to 328
      wte(imid,2*mp1-2,k) = wte(imid,2*mp1-2,k)
     1                     -bi(mp1,np1,k)*wb(imid,np1,iw)
      wte(imid,2*mp1-1,k) = wte(imid,2*mp1-1,k)
     1                     +br(mp1,np1,k)*wb(imid,np1,iw)
  328 continue
  329 continue
  330 continue
      go to 950
c
c     case ityp=4   v odd,  w even, and both cr and ci equal zero 
c
  400 call vbin(1,nlat,nlon,0,vb,iv,wvbin)
c
c     case m = 0
c
      do 415 k=1,nt
      do 415 np1=2,ndo2,2
      do 415 i=1,imm1
      vto(i,1,k)=vto(i,1,k)+br(1,np1,k)*vb(i,np1,iv)
  415 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) go to 950
      do 430 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(1,nlat,nlon,m,vb,iv,wvbin)
      call wbin(1,nlat,nlon,m,wb,iw,wwbin)
      if(mp2 .gt. ndo2) go to 430
      do 429 k=1,nt
      do 428 np1=mp2,ndo2,2
      do 427 i=1,imm1
      vto(i,2*mp1-2,k) = vto(i,2*mp1-2,k)+br(mp1,np1,k)*vb(i,np1,iv)
      vto(i,2*mp1-1,k) = vto(i,2*mp1-1,k)+bi(mp1,np1,k)*vb(i,np1,iv)
      wte(i,2*mp1-2,k) = wte(i,2*mp1-2,k)-bi(mp1,np1,k)*wb(i,np1,iw)
      wte(i,2*mp1-1,k) = wte(i,2*mp1-1,k)+br(mp1,np1,k)*wb(i,np1,iw)
  427 continue
      if(mlat .eq. 0) go to 428
      wte(imid,2*mp1-2,k) = wte(imid,2*mp1-2,k)
     1                     -bi(mp1,np1,k)*wb(imid,np1,iw)
      wte(imid,2*mp1-1,k) = wte(imid,2*mp1-1,k)
     1                     +br(mp1,np1,k)*wb(imid,np1,iw)
  428 continue
  429 continue
  430 continue
      go to 950
c
c     case ityp=5   v odd,  w even,     br and bi equal zero 
c
  500 call vbin(2,nlat,nlon,0,vb,iv,wvbin)
c
c     case m = 0
c
      do 516 k=1,nt
      do 516 np1=3,ndo1,2
      do 516 i=1,imid
      wte(i,1,k)=wte(i,1,k)-cr(1,np1,k)*vb(i,np1,iv)
  516 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) go to 950
      do 530 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(2,nlat,nlon,m,vb,iv,wvbin)
      call wbin(2,nlat,nlon,m,wb,iw,wwbin)
      if(mp1 .gt. ndo1) go to 530
      do 525 k=1,nt
      do 524 np1=mp1,ndo1,2
      do 523 i=1,imm1
      vto(i,2*mp1-2,k) = vto(i,2*mp1-2,k)-ci(mp1,np1,k)*wb(i,np1,iw)
      vto(i,2*mp1-1,k) = vto(i,2*mp1-1,k)+cr(mp1,np1,k)*wb(i,np1,iw)
      wte(i,2*mp1-2,k) = wte(i,2*mp1-2,k)-cr(mp1,np1,k)*vb(i,np1,iv)
      wte(i,2*mp1-1,k) = wte(i,2*mp1-1,k)-ci(mp1,np1,k)*vb(i,np1,iv)
  523 continue
      if(mlat .eq. 0) go to 524
      wte(imid,2*mp1-2,k) = wte(imid,2*mp1-2,k)
     1                     -cr(mp1,np1,k)*vb(imid,np1,iv) 
      wte(imid,2*mp1-1,k) = wte(imid,2*mp1-1,k)
     1                     -ci(mp1,np1,k)*vb(imid,np1,iv)
  524 continue
  525 continue
  530 continue
      go to 950
c
c     case ityp=6   v even  ,  w odd
c
  600 call vbin(0,nlat,nlon,0,vb,iv,wvbin)
c
c     case m = 0
c
      do 615 k=1,nt
      do 615 np1=2,ndo2,2
      do 615 i=1,imm1
      wto(i,1,k)=wto(i,1,k)-cr(1,np1,k)*vb(i,np1,iv)
  615 continue
      do 616 k=1,nt
      do 616 np1=3,ndo1,2
      do 616 i=1,imid
      vte(i,1,k)=vte(i,1,k)+br(1,np1,k)*vb(i,np1,iv)
  616 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) go to 950
      do 630 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(0,nlat,nlon,m,vb,iv,wvbin)
      call wbin(0,nlat,nlon,m,wb,iw,wwbin)
      if(mp1 .gt. ndo1) go to 626
      do 625 k=1,nt
      do 624 np1=mp1,ndo1,2
      do 623 i=1,imm1
      vte(i,2*mp1-2,k) = vte(i,2*mp1-2,k)+br(mp1,np1,k)*vb(i,np1,iv)
      vte(i,2*mp1-1,k) = vte(i,2*mp1-1,k)+bi(mp1,np1,k)*vb(i,np1,iv)
      wto(i,2*mp1-2,k) = wto(i,2*mp1-2,k)-bi(mp1,np1,k)*wb(i,np1,iw)
      wto(i,2*mp1-1,k) = wto(i,2*mp1-1,k)+br(mp1,np1,k)*wb(i,np1,iw)
  623 continue
      if(mlat .eq. 0) go to 624
      vte(imid,2*mp1-2,k) = vte(imid,2*mp1-2,k)
     1                     +br(mp1,np1,k)*vb(imid,np1,iv)
      vte(imid,2*mp1-1,k) = vte(imid,2*mp1-1,k)
     1                     +bi(mp1,np1,k)*vb(imid,np1,iv)
  624 continue
  625 continue
  626 if(mp2 .gt. ndo2) go to 630
      do 629 k=1,nt
      do 628 np1=mp2,ndo2,2
      do 627 i=1,imm1
      vte(i,2*mp1-2,k) = vte(i,2*mp1-2,k)-ci(mp1,np1,k)*wb(i,np1,iw)
      vte(i,2*mp1-1,k) = vte(i,2*mp1-1,k)+cr(mp1,np1,k)*wb(i,np1,iw)
      wto(i,2*mp1-2,k) = wto(i,2*mp1-2,k)-cr(mp1,np1,k)*vb(i,np1,iv)
      wto(i,2*mp1-1,k) = wto(i,2*mp1-1,k)-ci(mp1,np1,k)*vb(i,np1,iv)
  627 continue
      if(mlat .eq. 0) go to 628
      vte(imid,2*mp1-2,k) = vte(imid,2*mp1-2,k)
     1                     -ci(mp1,np1,k)*wb(imid,np1,iw) 
      vte(imid,2*mp1-1,k) = vte(imid,2*mp1-1,k)
     1                     +cr(mp1,np1,k)*wb(imid,np1,iw)
  628 continue
  629 continue
  630 continue
      go to 950
c
c     case ityp=7   v even, w odd   cr and ci equal zero
c
  700 call vbin(2,nlat,nlon,0,vb,iv,wvbin)
c
c     case m = 0
c
      do 716 k=1,nt
      do 716 np1=3,ndo1,2
      do 716 i=1,imid
      vte(i,1,k)=vte(i,1,k)+br(1,np1,k)*vb(i,np1,iv)
  716 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) go to 950
      do 730 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(2,nlat,nlon,m,vb,iv,wvbin)
      call wbin(2,nlat,nlon,m,wb,iw,wwbin)
      if(mp1 .gt. ndo1) go to 730
      do 725 k=1,nt
      do 724 np1=mp1,ndo1,2
      do 723 i=1,imm1
      vte(i,2*mp1-2,k) = vte(i,2*mp1-2,k)+br(mp1,np1,k)*vb(i,np1,iv)
      vte(i,2*mp1-1,k) = vte(i,2*mp1-1,k)+bi(mp1,np1,k)*vb(i,np1,iv)
      wto(i,2*mp1-2,k) = wto(i,2*mp1-2,k)-bi(mp1,np1,k)*wb(i,np1,iw)
      wto(i,2*mp1-1,k) = wto(i,2*mp1-1,k)+br(mp1,np1,k)*wb(i,np1,iw)
  723 continue
      if(mlat .eq. 0) go to 724
      vte(imid,2*mp1-2,k) = vte(imid,2*mp1-2,k)
     1                     +br(mp1,np1,k)*vb(imid,np1,iv)
      vte(imid,2*mp1-1,k) = vte(imid,2*mp1-1,k)
     1                     +bi(mp1,np1,k)*vb(imid,np1,iv)
  724 continue
  725 continue
  730 continue
      go to 950
c
c     case ityp=8   v even,  w odd   br and bi equal zero
c
  800 call vbin(1,nlat,nlon,0,vb,iv,wvbin)
c
c     case m = 0
c
      do 815 k=1,nt
      do 815 np1=2,ndo2,2
      do 815 i=1,imm1
      wto(i,1,k)=wto(i,1,k)-cr(1,np1,k)*vb(i,np1,iv)
  815 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) go to 950
      do 830 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(1,nlat,nlon,m,vb,iv,wvbin)
      call wbin(1,nlat,nlon,m,wb,iw,wwbin)
      if(mp2 .gt. ndo2) go to 830
      do 829 k=1,nt
      do 828 np1=mp2,ndo2,2
      do 827 i=1,imm1
      vte(i,2*mp1-2,k) = vte(i,2*mp1-2,k)-ci(mp1,np1,k)*wb(i,np1,iw)
      vte(i,2*mp1-1,k) = vte(i,2*mp1-1,k)+cr(mp1,np1,k)*wb(i,np1,iw)
      wto(i,2*mp1-2,k) = wto(i,2*mp1-2,k)-cr(mp1,np1,k)*vb(i,np1,iv)
      wto(i,2*mp1-1,k) = wto(i,2*mp1-1,k)-ci(mp1,np1,k)*vb(i,np1,iv)
  827 continue
      if(mlat .eq. 0) go to 828
      vte(imid,2*mp1-2,k) = vte(imid,2*mp1-2,k)
     1                     -ci(mp1,np1,k)*wb(imid,np1,iw) 
      vte(imid,2*mp1-1,k) = vte(imid,2*mp1-1,k)
     1                     +cr(mp1,np1,k)*wb(imid,np1,iw)
  828 continue
  829 continue
  830 continue
  950 do 14 k=1,nt
      call hrfftb(idv,nlon,vte(1,1,k),idv,wrfft,vb)
      call hrfftb(idv,nlon,wte(1,1,k),idv,wrfft,vb)
   14 continue
      if(ityp .gt. 2) go to 12
      do 60 k=1,nt
      do 60 j=1,nlon
      do 60 i=1,imm1
      vt(i,j,k) = .5*(vte(i,j,k)+vto(i,j,k))
      wt(i,j,k) = .5*(wte(i,j,k)+wto(i,j,k))
      vt(nlp1-i,j,k) = .5*(vte(i,j,k)-vto(i,j,k))
      wt(nlp1-i,j,k) = .5*(wte(i,j,k)-wto(i,j,k))
   60 continue
      go to 13
   12 do 11 k=1,nt
      do 11 j=1,nlon
      do 11 i=1,imm1
      vt(i,j,k) = .5*vte(i,j,k)
      wt(i,j,k) = .5*wte(i,j,k)
   11 continue
   13 if(mlat .eq. 0) return
      do 65 k=1,nt
      do 65 j=1,nlon
      vt(imid,j,k) = .5*vte(imid,j,k)
      wt(imid,j,k) = .5*wte(imid,j,k)
   65 continue
      return
      end
      subroutine vtseci(nlat,nlon,wvts,lwvts,dwork,ldwork,ierror)
c
      dimension wvts(lwvts)
      double precision dwork(ldwork)
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if(nlon .lt. 1) return
      ierror = 3
      imid = (nlat+1)/2
      lzz1 = 2*nlat*imid
      mmax = min0(nlat,(nlon+1)/2)
      labc = 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
      if(lwvts .lt. 2*(lzz1+labc)+nlon+15) return
      ierror = 4
      if (ldwork .lt. 2*nlat+2) return
      ierror = 0
      call vtinit (nlat,nlon,wvts,dwork)
      lwvbin = lzz1+labc
      iw1 = lwvbin+1
      call wtinit (nlat,nlon,wvts(iw1),dwork)
      iw2 = iw1+lwvbin
      call hrffti(nlon,wvts(iw2))
      return
      end

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c
c ... file divgs.f
c
c     this file includes documentation and code for
c     subroutine divgs          i
c
c ... files which must be loaded with divgs.f
c
c     sphcom.f, hrfft.f, vhags.f, shsgs.f, gaqd.f
c
c
c     subroutine divgs(nlat,nlon,isym,nt,divg,idiv,jdiv,br,bi,mdb,ndb,
c    +                 wshsgs,lshsgs,work,lwork,ierror)
c
c     given the vector spherical harmonic coefficients br and bi, precomputed
c     by subroutine vhags for a vector field (v,w), subroutine divgs
c     computes the divergence of the vector field in the scalar array divg.
c     divg(i,j) is the divergence at the gaussian colatitude point theta(i)
c     (see nlat as input parameter) and east longitude
c
c            lambda(j) = (j-1)*2*pi/nlon
c
c     on the sphere.  i.e.
c
c            dv(i,j) = 1/sint*[ d(sint*v(i,j))/dtheta + d(w(i,j))/dlambda ]
c
c     where sint = sin(theta(i)).  w is the east longitudinal and v
c     is the colatitudinal component of the vector field from which
c     br,bi were precomputed
c
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are computed
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   a parameter which determines whether the divergence is
c            computed on the full or half sphere as follows:
c
c      = 0
c
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in (v,w) about the equator.  in this case the
c            divergence is neither symmetric nor antisymmetric about
c            the equator.  the divergence is computed on the entire
c            sphere.  i.e., in the array divg(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c
c            w is antisymmetric and v is symmetric about the equator.
c            in this case the divergence is antisymmetyric about
c            the equator and is computed for the northern hemisphere
c            only.  i.e., if nlat is odd the divergence is computed
c            in the array divg(i,j) for i=1,...,(nlat+1)/2 and for
c            j=1,...,nlon.  if nlat is even the divergence is computed
c            in the array divg(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c      = 2
c            w is symmetric and v is antisymmetric about the equator
c            in this case the divergence is symmetyric about the
c            equator and is computed for the northern hemisphere
c            only.  i.e., if nlat is odd the divergence is computed
c            in the array divg(i,j) for i=1,...,(nlat+1)/2 and for
c            j=1,...,nlon.  if nlat is even the divergence is computed
c            in the array divg(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c
c     nt     nt is the number of scalar and vector fields.  some
c            computational efficiency is obtained for multiple fields.
c            in the program that calls divgs, the arrays br,bi, and divg
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple scalar synthesis will
c            be performed to compute the divergence for each field.  the
c            third index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt = 1.  the
c            description of the remaining parameters is simplified by
c            assuming that nt=1 or that all the arrays are two dimensional.
c
c     idiv   the first dimension of the array divg as it appears in
c            the program that calls divgs. if isym = 0 then idiv
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idiv must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idiv must be at least (nlat+1)/2.
c
c     jdiv   the second dimension of the array divg as it appears in
c            the program that calls divgs. jdiv must be at least nlon.
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c            that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhags.
c     ***    br and bi must be computed by vhags prior to calling
c            divgs.
c
c     mdb    the first dimension of the arrays br and bi as it
c            appears in the program that calls divgs. mdb must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndb    the second dimension of the arrays br and bi as it
c            appears in the program that calls divgs. ndb must be at
c            least nlat.
c
c
c     wshsgs an array which must be intialized by subroutine shsgsi.
c            once initialized,
c            wshsgs can be used repeatedly by divgs as long as nlon
c            and nlat remain unchanged.  wshsgs must not be altered
c            between calls of divgs.
c
c
c     lshsgs the dimension of the array wshsgs as it appears in the
c            program that calls divgs. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsgs must be at least
c
c               nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls divgs. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c
c            if isym = 0 then lwork must be at least
c
c               nlat*((nt+1)*nlon+2*nt*l1+1)
c
c            if isym > 0 then lwork must be at least
c
c               (nt+1)*l2*nlon+nlat*(2*nt*l1+1)
c
c     **************************************************************
c
c     output parameters
c
c
c    divg   a two or three dimensional array (see input parameter nt)
c           that contains the divergence of the vector field (v,w)
c           whose coefficients br,bi where computed by subroutine
c           vhags.  divg(i,j) is the divergence at the gaussian colatitude
c           point theta(i) and longitude point lambda(j) = (j-1)*2*pi/nlon.
c           the index ranges are defined above at the input parameter
c           isym.
c
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idiv
c           = 6  error in the specification of jdiv
c           = 7  error in the specification of mdb
c           = 8  error in the specification of ndb
c           = 9  error in the specification of lshsgs
c           = 10 error in the specification of lwork
c **********************************************************************
c                                                                              
c   
      subroutine divgs(nlat,nlon,isym,nt,divg,idiv,jdiv,br,bi,mdb,ndb,
     +                 wshsgs,lshsgs,work,lwork,ierror)

      dimension divg(idiv,jdiv,nt),br(mdb,ndb,nt),bi(mdb,ndb,nt)
      dimension wshsgs(lshsgs),work(lwork)
c
c     check input parameters
c
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if(nlon .lt. 4) return
      ierror = 3
      if (isym.lt.0 .or. isym.gt.2) return
      ierror = 4
      if(nt .lt. 0) return
      ierror = 5
      imid = (nlat+1)/2
      if((isym.eq.0 .and. idiv.lt.nlat) .or.
     1   (isym.gt.0 .and. idiv.lt.imid)) return
      ierror = 6
      if(jdiv .lt. nlon) return
      ierror = 7
      if(mdb .lt. min0(nlat,(nlon+1)/2)) return
      mmax = min0(nlat,(nlon+2)/2)
      ierror = 8
      if(ndb .lt. nlat) return
      ierror = 9
      imid = (nlat+1)/2
      lpimn = (imid*mmax*(nlat+nlat-mmax+1))/2
c     check permanent work space length
      l2 = (nlat+1)/2
      l1 = min0((nlon+2)/2,nlat)
      lp=nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
      if(lshsgs.lt.lp) return
      ierror = 10
c
c     verify unsaved work space (add to what shses requires, file f3)
c
      ls = nlat
      if(isym .gt. 0) ls = imid
      nln = nt*ls*nlon
c
c     set first dimension for a,b (as requried by shses)
c
      mab = min0(nlat,nlon/2+1)
      mn = mab*nlat*nt
      if(lwork.lt. nln+ls*nlon+2*mn+nlat) return
      ierror = 0
c
c     set work space pointers
c
      ia = 1
      ib = ia+mn
      is = ib+mn
      iwk = is+nlat
      lwk = lwork-2*mn-nlat
      call divgs1(nlat,nlon,isym,nt,divg,idiv,jdiv,br,bi,mdb,ndb,
     +work(ia),work(ib),mab,work(is),wshsgs,lshsgs,work(iwk),lwk,
     +ierror)
      return
      end

      subroutine divgs1(nlat,nlon,isym,nt,divg,idiv,jdiv,br,bi,mdb,ndb,
     +                  a,b,mab,sqnn,wshsgs,lshsgs,wk,lwk,ierror)
      dimension divg(idiv,jdiv,nt),br(mdb,ndb,nt),bi(mdb,ndb,nt)
      dimension a(mab,nlat,nt),b(mab,nlat,nt),sqnn(nlat)
      dimension wshsgs(lshsgs),wk(lwk)
c
c     set coefficient multiplyers
c
      do 1 n=2,nlat
      fn = float(n-1)
      sqnn(n) = sqrt(fn*(fn+1.))
    1 continue
c
c     compute divergence scalar coefficients for each vector field
c
      do 2 k=1,nt
      do 3 n=1,nlat
      do 4 m=1,mab
      a(m,n,k) = 0.0
      b(m,n,k) = 0.0
    4 continue
    3 continue
c
c     compute m=0 coefficients
c
      do 5 n=2,nlat
      a(1,n,k) = -sqnn(n)*br(1,n,k)
      b(1,n,k) = -sqnn(n)*bi(1,n,k)
    5 continue
c
c     compute m>0 coefficients using vector spherepack value for mmax
c
      mmax = min0(nlat,(nlon+1)/2)
      do 6 m=2,mmax
      do 7 n=m,nlat
      a(m,n,k) = -sqnn(n)*br(m,n,k)
      b(m,n,k) = -sqnn(n)*bi(m,n,k)
    7 continue
    6 continue
    2 continue
c
c     synthesize a,b into divg
c
      call shsgs(nlat,nlon,isym,nt,divg,idiv,jdiv,a,b,
     +           mab,nlat,wshsgs,lshsgs,wk,lwk,ierror)
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
! ... file sshifte.f contains code and documentation for subroutine sshifte
!     and its' initialization subroutine sshifti
!
! ... required files off spherepack3.0
!
!     hrfft.f
!
!     subroutine sshifte(ioff,nlon,nlat,goff,greg,wsav,lsav,work,lwork,ier)
!
! *** purpose
!
!     subroutine sshifte does a highly accurate 1/2 grid increment shift
!     in both longitude and latitude of equally spaced data on the sphere.
!     data is transferred between the nlon by nlat "offset grid" in goff
!     (which excludes poles) and the nlon by nlat+1 "regular grid" in greg
!     (which includes poles).  the transfer can go from goff to greg or from
!     greg to goff (see ioff).  the grids which underly goff and greg are
!     described below.  the north and south poles are at latitude 0.5*pi and
!     -0.5*pi radians respectively where pi = 4.*atan(1.).
!
! *** grid descriptions
!
!     let dlon = (pi+pi)/nlon and dlat = pi/nlat be the uniform grid
!     increments in longitude and latitude
!
!     offset grid
!
!     the "1/2 increment offset" grid (long(j),lat(i)) on which goff(j,i)
!     is given (ioff=0) or generated (ioff=1) is
!
!          long(j) =0.5*dlon + (j-1)*dlon  (j=1,...,nlon)
!
!     and
!
!          lat(i) = -0.5*pi + 0.5*dlat + (i-1)*dlat (i=1,...,nlat)
!
!     the data in goff is "shifted" one half a grid increment in longitude
!     and latitude and excludes the poles.  each goff(j,1) is given at
!     latitude -0.5*pi+0.5*dlat and goff(j,nlat) is given at 0.5*pi-0.5*dlat
!     (1/2 a grid increment away from the poles).  each goff(1,i),goff(nlon,i)
!     is given at longitude 0.5*dlon and 2.*pi-0.5*dlon.
!
!     regular grid
!
!     let dlat,dlon be as above.  then the nlon by nlat+1 grid on which
!     greg(j,i) is generated (ioff=0) or given (ioff=1) is given by
!
!          lone(j) = (j-1)*dlon (j=1,...,nlon)
!
!      and
!
!          late(i) = -0.5*pi + (i-1)*dlat (i=1,...,nlat+1)
!
!     values in greg include the poles and start at zero degrees longitude.
!
! *** remark
!
!     subroutine sshifte can be used in conjunction with subroutine trssph
!     when transferring data from an equally spaced "1/2 increment offset"
!     grid to a gaussian or equally spaced grid (which includes poles) of
!     any resolution.  this problem (personal communication with dennis
!     shea) is encountered in geophysical modeling and data analysis.
!
! *** method
!
!     fast fourier transform software from spherepack2 and trigonometric
!     identities are used to accurately "shift" periodic vectors half a
!     grid increment in latitude and longitude.  latitudinal shifts are
!     accomplished by setting periodic 2*nlat vectors over the pole for each
!     longitude.  when nlon is odd, this requires an additional longitude
!     shift.  longitudinal shifts are then executed for each shifted latitude.
!     when necessary (ioff=0) poles are obtained by averaging the nlon
!     shifted polar values.
!
! *** required files from spherepack3.0
!
!     hrfft.f
!
! *** argument description
!
! ... ioff
!
!     ioff = 0 if values on the offset grid in goff are given and values
!              on the regular grid in greg are to be generated.
!
!     ioff = 1 if values on the regular grid in greg are given and values
!              on the offset grid in goff are to be generated.
!
! ... nlon
!
!     the number of longitude points on both the "offset" and "regular"
!     uniform grid in longitude (see "grid description" above).  nlon
!     is also the first dimension of array goff and greg.  nlon determines
!     the grid increment in longitude as dlon = 2.*pi/nlon.  for example,
!     nlon = 144 for a 2.5 degree grid.  nlon can be even or odd and must
!     be greater than or equal to 4.  the efficiency of the computation
!     is improved when nlon is a product of small primes.
!
! ... nlat
!
!     the number of latitude points on the "offset" uniform grid.  nlat+1
!     is the number of latitude points on the "regular" uniform grid (see
!     "grid description" above).  nlat is the second dimension of array goff.
!     nlat+1 must be the second dimension of the array greg in the program
!     calling sshifte.  nlat determines the grid in latitude as pi/nlat.
!     for example, nlat = 36 for a five degree grid.  nlat must be at least 3.
!
! ... goff
!
!     a nlon by nlat array that contains data on the offset grid
!     described above.  goff is a given input argument if ioff=0.
!     goff is a generated output argument if ioff=1.
!
! ... greg
!
!     a nlon by nlat+1 array that contains data on the regular grid
!     described above.  greg is a given input argument if ioff=1.
!     greg is a generated output argument if ioff=0.
!
! ... wsav
!
!     a real saved work space array that must be initialized by calling
!     subroutine sshifti(ioff,nlon,nlat,wsav,ier) before calling sshifte.
!     wsav can then be used repeatedly by sshifte as long as ioff, nlon,
!     and nlat do not change.  this bypasses redundant computations and
!     saves time.  undetectable errors will result if sshifte is called
!     without initializing wsav whenever ioff, nlon, or nlat change.
!
! ... lsav
!
!     the length of the saved work space wsav in the routine calling sshifte
!     and sshifti.  lsave must be greater than or equal to 2*(2*nlat+nlon+16).
!
! ... work
!
!     a real unsaved work space
!
! ... lwork
!
!     the length of the unsaved work space in the routine calling sshifte
!     lwork must be greater than or equal to 2*nlon*(nlat+1) if nlon is even.
!     lwork must be greater than or equal to nlon*(5*nlat+1) if nlon is odd.
!
! ... ier
!
!     indicates errors in input parameters
!
!     = 0 if no errors are detected
!
!     = 1 if ioff is not equal to 0 or 1
!
!     = 1 if nlon < 4
!
!     = 2 if nlat < 3
!
!     = 3 if lsave < 2*(nlon+2*nlat+16)
!
!     = 4 if lwork < 2*nlon*(nlat+1) for nlon even or
!            lwork < nlon*(5*nlat+1) for nlon odd
!
! *** end of sshifte documentation
!
!     subroutine sshifti(ioff,nlon,nlat,lsav,wsav,ier)
!
!     subroutine sshifti initializes the saved work space wsav
!     for ioff and nlon and nlat (see documentation for sshifte).
!     sshifti must be called before sshifte whenever ioff or nlon
!     or nlat change.
!
! ... ier
!
!     = 0 if no errors with input arguments
!
!     = 1 if ioff is not 0 or 1
!
!     = 2 if nlon < 4
!
!     = 3 if nlat < 3
!
!     = 4 if lsav < 2*(2*nlat+nlon+16)
!
! *** end of sshifti documentation
!
      SUBROUTINE SSHIFTE(Ioff,Nlon,Nlat,Goff,Greg,Wsav,Lsav,Wrk,Lwrk,   &
                       & Ier)
      IMPLICIT NONE
!*--SSHIFTE203
      INTEGER Ioff , Nlon , Nlat , n2 , nr , nlat2 , nlatp1 , Lsav ,    &
            & Lwrk , i1 , i2 , Ier
      REAL Goff(Nlon,Nlat) , Greg(Nlon,*) , Wsav(Lsav) , Wrk(Lwrk)
!
!     check input parameters
!
      Ier = 1
      IF ( Ioff*(Ioff-1)/=0 ) RETURN
      Ier = 2
      IF ( Nlon<4 ) RETURN
      Ier = 3
      IF ( Nlat<3 ) RETURN
      Ier = 4
      IF ( Lsav<2*(2*Nlat+Nlon+16) ) RETURN
      Ier = 5
      n2 = (Nlon+1)/2
      IF ( 2*n2==Nlon ) THEN
         IF ( Lwrk<2*Nlon*(Nlat+1) ) RETURN
         i1 = 1
         nr = n2
      ELSE
         IF ( Lwrk<Nlon*(5*Nlat+1) ) RETURN
         i1 = 1 + 2*Nlat*Nlon
         nr = Nlon
      ENDIF
      Ier = 0
      nlat2 = Nlat + Nlat
      i2 = i1 + (Nlat+1)*Nlon
      IF ( Ioff==0 ) THEN
         CALL SHFTOFF(Nlon,Nlat,Goff,Greg,Wsav,nr,nlat2,Wrk,Wrk(i1),    &
                    & Wrk(i2))
      ELSE
         nlatp1 = Nlat + 1
         CALL SHFTREG(Nlon,Nlat,Goff,Greg,Wsav,nr,nlat2,nlatp1,Wrk,     &
                    & Wrk(i1),Wrk(i2))
      ENDIF
      END SUBROUTINE SSHIFTE 

      
      SUBROUTINE SHFTOFF(Nlon,Nlat,Goff,Greg,Wsav,Nr,Nlat2,Rlat,Rlon,   &
                       & Wrk)
!
!     shift offset grid to regular grid, i.e.,
!     goff is given, greg is to be generated
!
      IMPLICIT NONE
!*--SHFTOFF250
      INTEGER Nlon , Nlat , Nlat2 , n2 , Nr , j , i , js , isav
      REAL Goff(Nlon,Nlat) , Greg(Nlon,Nlat+1)
      REAL Rlat(Nr,Nlat2) , Rlon(Nlat,Nlon)
      REAL Wsav(*) , Wrk(*)
      REAL gnorth , gsouth
      isav = 4*Nlat + 17
      n2 = (Nlon+1)/2
!
!     execute full circle latitude shifts for nlon odd or even
!
      IF ( 2*n2>Nlon ) THEN
!
!     odd number of longitudes
!
         DO i = 1 , Nlat
            DO j = 1 , Nlon
               Rlon(i,j) = Goff(j,i)
            ENDDO
         ENDDO
!
!       half shift in longitude
!
         CALL SHIFTH(Nlat,Nlon,Rlon,Wsav(isav),Wrk)
!
!       set full 2*nlat circles in rlat using shifted values in rlon
!
         DO j = 1 , n2 - 1
            js = j + n2
            DO i = 1 , Nlat
               Rlat(j,i) = Goff(j,i)
               Rlat(j,Nlat+i) = Rlon(Nlat+1-i,js)
            ENDDO
         ENDDO
         DO j = n2 , Nlon
            js = j - n2 + 1
            DO i = 1 , Nlat
               Rlat(j,i) = Goff(j,i)
               Rlat(j,Nlat+i) = Rlon(Nlat+1-i,js)
            ENDDO
         ENDDO
!
!       shift the nlon rlat vectors one half latitude grid
!
         CALL SHIFTH(Nlon,Nlat2,Rlat,Wsav,Wrk)
!
!       set nonpole values in greg and average for poles
!
         gnorth = 0.0
         gsouth = 0.0
         DO j = 1 , Nlon
            gnorth = gnorth + Rlat(j,1)
            gsouth = gsouth + Rlat(j,Nlat+1)
            DO i = 2 , Nlat
               Greg(j,i) = Rlat(j,i)
            ENDDO
         ENDDO
         gnorth = gnorth/Nlon
         gsouth = gsouth/Nlon
 
      ELSE
!
!     even number of longitudes (no initial longitude shift necessary)
!     set full 2*nlat circles (over poles) for each longitude pair (j,js)
!
         DO j = 1 , n2
            js = n2 + j
            DO i = 1 , Nlat
               Rlat(j,i) = Goff(j,i)
               Rlat(j,Nlat+i) = Goff(js,Nlat+1-i)
            ENDDO
         ENDDO
!
!       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
!
         CALL SHIFTH(n2,Nlat2,Rlat,Wsav,Wrk)
!
!       set nonpole values in greg and average poles
!
         gnorth = 0.0
         gsouth = 0.0
         DO j = 1 , n2
            js = n2 + j
            gnorth = gnorth + Rlat(j,1)
            gsouth = gsouth + Rlat(j,Nlat+1)
            DO i = 2 , Nlat
               Greg(j,i) = Rlat(j,i)
               Greg(js,i) = Rlat(j,Nlat2-i+2)
            ENDDO
         ENDDO
         gnorth = gnorth/n2
         gsouth = gsouth/n2
      ENDIF
!
!     set poles
!
      DO j = 1 , Nlon
         Greg(j,1) = gnorth
         Greg(j,Nlat+1) = gsouth
      ENDDO
!
!     execute full circle longitude shift
!
      DO j = 1 , Nlon
         DO i = 1 , Nlat
            Rlon(i,j) = Greg(j,i)
         ENDDO
      ENDDO
      CALL SHIFTH(Nlat,Nlon,Rlon,Wsav(isav),Wrk)
      DO j = 1 , Nlon
         DO i = 2 , Nlat
            Greg(j,i) = Rlon(i,j)
         ENDDO
      ENDDO
    END SUBROUTINE SHFTOFF
    

    SUBROUTINE SHFTREG(Nlon,Nlat,Goff,Greg,Wsav,Nr,Nlat2,Nlatp1,Rlat, &
                       & Rlon,Wrk)
!
!     shift regular grid to offset grid, i.e.,
!     greg is given, goff is to be generated
!
      IMPLICIT NONE
!*--SHFTREG374
      INTEGER Nlon , Nlat , Nlat2 , Nlatp1 , n2 , Nr , j , i , js , isav
      REAL Goff(Nlon,Nlat) , Greg(Nlon,Nlatp1)
      REAL Rlat(Nr,Nlat2) , Rlon(Nlatp1,Nlon)
      REAL Wsav(*) , Wrk(*)
      isav = 4*Nlat + 17
      n2 = (Nlon+1)/2
!
!     execute full circle latitude shifts for nlon odd or even
!
      IF ( 2*n2>Nlon ) THEN
!
!     odd number of longitudes
!
         DO i = 1 , Nlat + 1
            DO j = 1 , Nlon
               Rlon(i,j) = Greg(j,i)
            ENDDO
         ENDDO
!
!       half shift in longitude in rlon
!
         CALL SHIFTH(Nlat+1,Nlon,Rlon,Wsav(isav),Wrk)
!
!       set full 2*nlat circles in rlat using shifted values in rlon
!
         DO j = 1 , n2
            js = j + n2 - 1
            Rlat(j,1) = Greg(j,1)
            DO i = 2 , Nlat
               Rlat(j,i) = Greg(j,i)
               Rlat(j,Nlat+i) = Rlon(Nlat+2-i,js)
            ENDDO
            Rlat(j,Nlat+1) = Greg(j,Nlat+1)
         ENDDO
         DO j = n2 + 1 , Nlon
            js = j - n2
            Rlat(j,1) = Greg(j,1)
            DO i = 2 , Nlat
               Rlat(j,i) = Greg(j,i)
               Rlat(j,Nlat+i) = Rlon(Nlat+2-i,js)
            ENDDO
            Rlat(j,Nlat+1) = Greg(j,Nlat+1)
         ENDDO
!
!       shift the nlon rlat vectors one halflatitude grid
!
         CALL SHIFTH(Nlon,Nlat2,Rlat,Wsav,Wrk)
!
!       set values in goff
!
         DO j = 1 , Nlon
            DO i = 1 , Nlat
               Goff(j,i) = Rlat(j,i)
            ENDDO
         ENDDO
 
      ELSE
!
!     even number of longitudes (no initial longitude shift necessary)
!     set full 2*nlat circles (over poles) for each longitude pair (j,js)
!
         DO j = 1 , n2
            js = n2 + j
            Rlat(j,1) = Greg(j,1)
            DO i = 2 , Nlat
               Rlat(j,i) = Greg(j,i)
               Rlat(j,Nlat+i) = Greg(js,Nlat+2-i)
            ENDDO
            Rlat(j,Nlat+1) = Greg(j,Nlat+1)
         ENDDO
!
!       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
!
         CALL SHIFTH(n2,Nlat2,Rlat,Wsav,Wrk)
!
!       set values in goff
!
         DO j = 1 , n2
            js = n2 + j
            DO i = 1 , Nlat
               Goff(j,i) = Rlat(j,i)
               Goff(js,i) = Rlat(j,Nlat2+1-i)
            ENDDO
         ENDDO
      ENDIF
!
!     execute full circle longitude shift for all latitude circles
!
      DO j = 1 , Nlon
         DO i = 1 , Nlat
            Rlon(i,j) = Goff(j,i)
         ENDDO
      ENDDO
      CALL SHIFTH(Nlat+1,Nlon,Rlon,Wsav(isav),Wrk)
      DO j = 1 , Nlon
         DO i = 1 , Nlat
            Goff(j,i) = Rlon(i,j)
         ENDDO
      ENDDO
    END SUBROUTINE SHFTREG

    
      SUBROUTINE SSHIFTI(Ioff,Nlon,Nlat,Lsav,Wsav,Ier)
      IMPLICIT NONE
      INTEGER Lsav
      INTEGER Ioff , Nlat , Nlon , nlat2 , isav , Ier
      REAL Wsav(Lsav)
      REAL pi , dlat , dlon , dp
      Ier = 1
      IF ( Ioff*(Ioff-1)/=0 ) RETURN
      Ier = 2
      IF ( Nlon<4 ) RETURN
      Ier = 3
      IF ( Nlat<3 ) RETURN
      Ier = 4
      IF ( Lsav<2*(2*Nlat+Nlon+16) ) RETURN
      Ier = 0
      pi = 4.0*ATAN(1.0)
!
!     set lat,long increments
!
      dlat = pi/Nlat
      dlon = (pi+pi)/Nlon
!
!     initialize wsav for left or right latitude shifts
!
      IF ( Ioff==0 ) THEN
         dp = -0.5*dlat
      ELSE
         dp = 0.5*dlat
      ENDIF
      nlat2 = Nlat + Nlat
      CALL SHIFTHI(nlat2,dp,Wsav)
!
!     initialize wsav for left or right longitude shifts
!
      IF ( Ioff==0 ) THEN
         dp = -0.5*dlon
      ELSE
         dp = 0.5*dlon
      ENDIF
      isav = 4*Nlat + 17
      CALL SHIFTHI(Nlon,dp,Wsav(isav))
      END

      
      SUBROUTINE SHIFTH(M,N,R,Wsav,Work)
      IMPLICIT NONE
      INTEGER M , N , n2 , k , l
      REAL R(M,N) , Wsav(*) , Work(*) , r2km2 , r2km1
      n2 = (N+1)/2
!
!     compute fourier coefficients for r on shifted grid
!
      CALL HRFFTF(M,N,R,M,Wsav(N+2),Work)
      DO l = 1 , M
         DO k = 2 , n2
            r2km2 = R(l,k+k-2)
            r2km1 = R(l,k+k-1)
            R(l,k+k-2) = r2km2*Wsav(n2+k) - r2km1*Wsav(k)
            R(l,k+k-1) = r2km2*Wsav(k) + r2km1*Wsav(n2+k)
         ENDDO
      ENDDO
!
!     shift r with fourier synthesis and normalization
!
      CALL HRFFTB(M,N,R,M,Wsav(N+2),Work)
      DO l = 1 , M
         DO k = 1 , N
            R(l,k) = R(l,k)/N
         ENDDO
      ENDDO
    END SUBROUTINE SHIFTH
    
    SUBROUTINE SHIFTHI(N,Dp,Wsav)
!
!     initialize wsav for subroutine shifth
!
      IMPLICIT NONE
!*--SHIFTHI559
      INTEGER N , n2 , k
      REAL Wsav(*) , Dp
      n2 = (N+1)/2
      DO k = 2 , n2
         Wsav(k) = SIN((k-1)*Dp)
         Wsav(k+n2) = COS((k-1)*Dp)
      ENDDO
      CALL HRFFTI(N,Wsav(N+2))
      END SUBROUTINE SHIFTHI


      SUBROUTINE DSSHIFTE(Ioff,Nlon,Nlat,Goff,Greg,Wsav,Lsav,Wrk,Lwrk,   &
                       & Ier)
      IMPLICIT NONE
      INTEGER Ioff , Nlon , Nlat , n2 , nr , nlat2 , nlatp1 , Lsav ,    &
            & Lwrk , i1 , i2 , Ier
      DOUBLE PRECISION Goff(Nlon,Nlat) , Greg(Nlon,*) , Wsav(Lsav) , Wrk(Lwrk)
!
!     check input parameters
!
      Ier = 1
      IF ( Ioff*(Ioff-1)/=0 ) RETURN
      Ier = 2
      IF ( Nlon<4 ) RETURN
      Ier = 3
      IF ( Nlat<3 ) RETURN
      Ier = 4
      IF ( Lsav<2*(2*Nlat+Nlon+16) ) RETURN
      Ier = 5
      n2 = (Nlon+1)/2
      IF ( 2*n2==Nlon ) THEN
         IF ( Lwrk<2*Nlon*(Nlat+1) ) RETURN
         i1 = 1
         nr = n2
      ELSE
         IF ( Lwrk<Nlon*(5*Nlat+1) ) RETURN
         i1 = 1 + 2*Nlat*Nlon
         nr = Nlon
      ENDIF
      Ier = 0
      nlat2 = Nlat + Nlat
      i2 = i1 + (Nlat+1)*Nlon
      IF ( Ioff==0 ) THEN
         CALL DSHFTOFF(Nlon,Nlat,Goff,Greg,Wsav,nr,nlat2,Wrk,Wrk(i1),    &
                    & Wrk(i2))
      ELSE
         nlatp1 = Nlat + 1
         CALL DSHFTREG(Nlon,Nlat,Goff,Greg,Wsav,nr,nlat2,nlatp1,Wrk,     &
                    & Wrk(i1),Wrk(i2))
      ENDIF
      END SUBROUTINE DSSHIFTE 

      
      SUBROUTINE DSHFTOFF(Nlon,Nlat,Goff,Greg,Wsav,Nr,Nlat2,Rlat,Rlon,   &
                       & Wrk)
!
!     shift offset grid to regular grid, i.e.,
!     goff is given, greg is to be generated
!
      IMPLICIT NONE
!*--SHFTOFF250
      INTEGER Nlon , Nlat , Nlat2 , n2 , Nr , j , i , js , isav
      DOUBLE PRECISION Goff(Nlon,Nlat) , Greg(Nlon,Nlat+1)
      DOUBLE PRECISION Rlat(Nr,Nlat2) , Rlon(Nlat,Nlon)
      DOUBLE PRECISION Wsav(*) , Wrk(*)
      DOUBLE PRECISION gnorth , gsouth
      isav = 4*Nlat + 17
      n2 = (Nlon+1)/2
!
!     execute full circle latitude shifts for nlon odd or even
!
      IF ( 2*n2>Nlon ) THEN
!
!     odd number of longitudes
!
         DO i = 1 , Nlat
            DO j = 1 , Nlon
               Rlon(i,j) = Goff(j,i)
            ENDDO
         ENDDO
!
!       half shift in longitude
!
         CALL DSHIFTH(Nlat,Nlon,Rlon,Wsav(isav),Wrk)
!
!       set full 2*nlat circles in rlat using shifted values in rlon
!
         DO j = 1 , n2 - 1
            js = j + n2
            DO i = 1 , Nlat
               Rlat(j,i) = Goff(j,i)
               Rlat(j,Nlat+i) = Rlon(Nlat+1-i,js)
            ENDDO
         ENDDO
         DO j = n2 , Nlon
            js = j - n2 + 1
            DO i = 1 , Nlat
               Rlat(j,i) = Goff(j,i)
               Rlat(j,Nlat+i) = Rlon(Nlat+1-i,js)
            ENDDO
         ENDDO
!
!       shift the nlon rlat vectors one half latitude grid
!
         CALL DSHIFTH(Nlon,Nlat2,Rlat,Wsav,Wrk)
!
!       set nonpole values in greg and average for poles
!
         gnorth = 0.0
         gsouth = 0.0
         DO j = 1 , Nlon
            gnorth = gnorth + Rlat(j,1)
            gsouth = gsouth + Rlat(j,Nlat+1)
            DO i = 2 , Nlat
               Greg(j,i) = Rlat(j,i)
            ENDDO
         ENDDO
         gnorth = gnorth/Nlon
         gsouth = gsouth/Nlon
 
      ELSE
!
!     even number of longitudes (no initial longitude shift necessary)
!     set full 2*nlat circles (over poles) for each longitude pair (j,js)
!
         DO j = 1 , n2
            js = n2 + j
            DO i = 1 , Nlat
               Rlat(j,i) = Goff(j,i)
               Rlat(j,Nlat+i) = Goff(js,Nlat+1-i)
            ENDDO
         ENDDO
!
!       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
!
         CALL DSHIFTH(n2,Nlat2,Rlat,Wsav,Wrk)
!
!       set nonpole values in greg and average poles
!
         gnorth = 0.0
         gsouth = 0.0
         DO j = 1 , n2
            js = n2 + j
            gnorth = gnorth + Rlat(j,1)
            gsouth = gsouth + Rlat(j,Nlat+1)
            DO i = 2 , Nlat
               Greg(j,i) = Rlat(j,i)
               Greg(js,i) = Rlat(j,Nlat2-i+2)
            ENDDO
         ENDDO
         gnorth = gnorth/n2
         gsouth = gsouth/n2
      ENDIF
!
!     set poles
!
      DO j = 1 , Nlon
         Greg(j,1) = gnorth
         Greg(j,Nlat+1) = gsouth
      ENDDO
!
!     execute full circle longitude shift
!
      DO j = 1 , Nlon
         DO i = 1 , Nlat
            Rlon(i,j) = Greg(j,i)
         ENDDO
      ENDDO
      CALL DSHIFTH(Nlat,Nlon,Rlon,Wsav(isav),Wrk)
      DO j = 1 , Nlon
         DO i = 2 , Nlat
            Greg(j,i) = Rlon(i,j)
         ENDDO
      ENDDO
    END SUBROUTINE DSHFTOFF
    

    SUBROUTINE DSHFTREG(Nlon,Nlat,Goff,Greg,Wsav,Nr,Nlat2,Nlatp1,Rlat, &
                       & Rlon,Wrk)
!
!     shift regular grid to offset grid, i.e.,
!     greg is given, goff is to be generated
!
      IMPLICIT NONE
!*--SHFTREG374
      INTEGER Nlon , Nlat , Nlat2 , Nlatp1 , n2 , Nr , j , i , js , isav
      DOUBLE PRECISION Goff(Nlon,Nlat) , Greg(Nlon,Nlatp1)
      DOUBLE PRECISION Rlat(Nr,Nlat2) , Rlon(Nlatp1,Nlon)
      DOUBLE PRECISION Wsav(*) , Wrk(*)
      isav = 4*Nlat + 17
      n2 = (Nlon+1)/2
!
!     execute full circle latitude shifts for nlon odd or even
!
      IF ( 2*n2>Nlon ) THEN
!
!     odd number of longitudes
!
         DO i = 1 , Nlat + 1
            DO j = 1 , Nlon
               Rlon(i,j) = Greg(j,i)
            ENDDO
         ENDDO
!
!       half shift in longitude in rlon
!
         CALL DSHIFTH(Nlat+1,Nlon,Rlon,Wsav(isav),Wrk)
!
!       set full 2*nlat circles in rlat using shifted values in rlon
!
         DO j = 1 , n2
            js = j + n2 - 1
            Rlat(j,1) = Greg(j,1)
            DO i = 2 , Nlat
               Rlat(j,i) = Greg(j,i)
               Rlat(j,Nlat+i) = Rlon(Nlat+2-i,js)
            ENDDO
            Rlat(j,Nlat+1) = Greg(j,Nlat+1)
         ENDDO
         DO j = n2 + 1 , Nlon
            js = j - n2
            Rlat(j,1) = Greg(j,1)
            DO i = 2 , Nlat
               Rlat(j,i) = Greg(j,i)
               Rlat(j,Nlat+i) = Rlon(Nlat+2-i,js)
            ENDDO
            Rlat(j,Nlat+1) = Greg(j,Nlat+1)
         ENDDO
!
!       shift the nlon rlat vectors one halflatitude grid
!
         CALL DSHIFTH(Nlon,Nlat2,Rlat,Wsav,Wrk)
!
!       set values in goff
!
         DO j = 1 , Nlon
            DO i = 1 , Nlat
               Goff(j,i) = Rlat(j,i)
            ENDDO
         ENDDO
 
      ELSE
!
!     even number of longitudes (no initial longitude shift necessary)
!     set full 2*nlat circles (over poles) for each longitude pair (j,js)
!
         DO j = 1 , n2
            js = n2 + j
            Rlat(j,1) = Greg(j,1)
            DO i = 2 , Nlat
               Rlat(j,i) = Greg(j,i)
               Rlat(j,Nlat+i) = Greg(js,Nlat+2-i)
            ENDDO
            Rlat(j,Nlat+1) = Greg(j,Nlat+1)
         ENDDO
!
!       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
!
         CALL DSHIFTH(n2,Nlat2,Rlat,Wsav,Wrk)
!
!       set values in goff
!
         DO j = 1 , n2
            js = n2 + j
            DO i = 1 , Nlat
               Goff(j,i) = Rlat(j,i)
               Goff(js,i) = Rlat(j,Nlat2+1-i)
            ENDDO
         ENDDO
      ENDIF
!
!     execute full circle longitude shift for all latitude circles
!
      DO j = 1 , Nlon
         DO i = 1 , Nlat
            Rlon(i,j) = Goff(j,i)
         ENDDO
      ENDDO
      CALL DSHIFTH(Nlat+1,Nlon,Rlon,Wsav(isav),Wrk)
      DO j = 1 , Nlon
         DO i = 1 , Nlat
            Goff(j,i) = Rlon(i,j)
         ENDDO
      ENDDO
    END SUBROUTINE DSHFTREG

    
      SUBROUTINE DSSHIFTI(Ioff,Nlon,Nlat,Lsav,Wsav,Ier)
      IMPLICIT NONE
      INTEGER Lsav
      INTEGER Ioff , Nlat , Nlon , nlat2 , isav , Ier
      DOUBLE PRECISION Wsav(Lsav)
      DOUBLE PRECISION pi , dlat , dlon , dp
      Ier = 1
      IF ( Ioff*(Ioff-1)/=0 ) RETURN
      Ier = 2
      IF ( Nlon<4 ) RETURN
      Ier = 3
      IF ( Nlat<3 ) RETURN
      Ier = 4
      IF ( Lsav<2*(2*Nlat+Nlon+16) ) RETURN
      Ier = 0
      pi = 4.0*ATAN(1.0)
!
!     set lat,long increments
!
      dlat = pi/Nlat
      dlon = (pi+pi)/Nlon
!
!     initialize wsav for left or right latitude shifts
!
      IF ( Ioff==0 ) THEN
         dp = -0.5*dlat
      ELSE
         dp = 0.5*dlat
      ENDIF
      nlat2 = Nlat + Nlat
      CALL DSHIFTHI(nlat2,dp,Wsav)
!
!     initialize wsav for left or right longitude shifts
!
      IF ( Ioff==0 ) THEN
         dp = -0.5*dlon
      ELSE
         dp = 0.5*dlon
      ENDIF
      isav = 4*Nlat + 17
      CALL DSHIFTHI(Nlon,dp,Wsav(isav))
      END SUBROUTINE DSSHIFTI

      
      SUBROUTINE DSHIFTH(M,N,R,Wsav,Work)
      IMPLICIT NONE
      INTEGER M , N , n2 , k , l
      DOUBLE PRECISION R(M,N) , Wsav(*) , Work(*) , r2km2 , r2km1
      n2 = (N+1)/2
!
!     compute fourier coefficients for r on shifted grid
!
      CALL DHRFFTF(M,N,R,M,Wsav(N+2),Work)
      DO l = 1 , M
         DO k = 2 , n2
            r2km2 = R(l,k+k-2)
            r2km1 = R(l,k+k-1)
            R(l,k+k-2) = r2km2*Wsav(n2+k) - r2km1*Wsav(k)
            R(l,k+k-1) = r2km2*Wsav(k) + r2km1*Wsav(n2+k)
         ENDDO
      ENDDO
!
!     shift r with fourier synthesis and normalization
!
      CALL DHRFFTB(M,N,R,M,Wsav(N+2),Work)
      DO l = 1 , M
         DO k = 1 , N
            R(l,k) = R(l,k)/N
         ENDDO
      ENDDO
    END SUBROUTINE DSHIFTH

    
    SUBROUTINE DSHIFTHI(N,Dp,Wsav)
!
!     initialize wsav for subroutine shifth
!
      IMPLICIT NONE
!*--SHIFTHI559
      INTEGER N , n2 , k
      DOUBLE PRECISION Wsav(*) , Dp
      n2 = (N+1)/2
      DO k = 2 , n2
         Wsav(k) = SIN((k-1)*Dp)
         Wsav(k+n2) = COS((k-1)*Dp)
      ENDDO
      CALL DHRFFTI(N,Wsav(N+2))
      END SUBROUTINE DSHIFTHI

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file ivrtes.f
c
c     this file includes documentation and code for
c     subroutine ivrtes         i
c
c ... files which must be loaded with ivrtes.f
c
c     sphcom.f, hrfft.f, vhses.f,shaes.f
c
c
c     subroutine ivrtes(nlat,nlon,isym,nt,v,w,idvw,jdvw,a,b,mdab,ndab,
c    +                  wvhses,lvhses,work,lwork,pertrb,ierror)
c
c     given the scalar spherical harmonic coefficients a and b, precomputed
c     by subroutine shaes for a scalar array vort, subroutine ivrtes computes
c     a divergence free vector field (v,w) whose vorticity is vort - pertrb.
c     w is the east longitude component and v is the colatitudinal component.
c     pertrb is a constant which must be subtracted from vort for (v,w) to
c     exist (see the description of pertrb below).  usually pertrb is zero
c     or small relative to vort.  the divergence of (v,w), as computed by
c     ivrtes, is the zero scalar field.  i.e., v(i,j) and w(i,j) are the
c     colaatitudinal and east longitude velocity components at colatitude
c
c            theta(i) = (i-1)*pi/(nlat-1)
c
c     and longitude
c
c            lambda(j) = (j-1)*2*pi/nlon.
c
c     the
c
c            vorticity(v(i,j),w(i,j))
c
c         =  [-dv/dlambda + d(sint*w)/dtheta]/sint
c
c         =  vort(i,j) - pertrb
c
c     and
c
c            divergence(v(i,j),w(i,j))
c
c         =  [d(sint*v)/dtheta + dw/dlambda]/sint
c
c         =  0.0
c
c     where sint = sin(theta(i)).  required associated legendre polynomials
c     are stored rather than recomputed as they are in subroutine ivrtec.
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than 3. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   this has the same value as the isym that was input to
c            subroutine shaes to compute the arrays a and b.  isym
c            determines whether (v,w) are computed on the full or half
c            sphere as follows:
c
c      = 0
c            vort is not symmetric about the equator. in this case
c            the vector field (v,w) is computed on the entire sphere.
c            i.e., in the arrays  v(i,j),w(i,j) for i=1,...,nlat and
c            j=1,...,nlon.
c
c      = 1
c
c            vort is symmetric about the equator. in this case w is
c            antiymmetric and v is symmetric about the equator. v
c            and w are computed on the northern hemisphere only.  i.e.,
c            if nlat is odd they are computed for i=1,...,(nlat+1)/2
c            and j=1,...,nlon.  if nlat is even they are computed for
c            i=1,...,nlat/2 and j=1,...,nlon.
c
c       = 2
c
c            vort is antisymmetric about the equator. in this case w is
c            symmetric and v is antisymmetric about the equator. w
c            and v are computed on the northern hemisphere only.  i.e.,
c            if nlat is odd they are computed for i=1,...,(nlat+1)/2
c            and j=1,...,nlon.  if nlat is even they are computed for
c            i=1,...,nlat/2 and j=1,...,nlon.
c
c
c     nt     in the program that calls ivrtes, nt is the number of vorticity
c            and vector fields.  some computational efficiency is obtained
c            for multiple fields.  the arrays a,b,v, and w can be three
c            dimensional and pertrb can be one dimensional corresponding
c            to an indexed multiple array vort.  in this case, multiple vector
c            synthesis will be performed to compute each vector field.  the
c            third index for a,b,v,w and first for pertrb is the synthesis
c            index which assumes the values k=1,...,nt.  for a single
c            synthesis set nt=1. the description of the remaining parameters
c            is simplified by assuming that nt=1 or that a,b,v,w are two
c            dimensional and pertrb is a constant.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls ivrtes. if isym = 0 then idvw
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idvw must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls ivrtes. jdvw must be at least nlon.
c
c     a,b    two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
c            of the vorticity array vort as computed by subroutine shaes.
c     ***    a,b must be computed by shaes prior to calling ivrtes.
c
c     mdab   the first dimension of the arrays a and b as it appears in
c            the program that calls ivrtes (and shaes). mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays a and b as it appears in
c            the program that calls ivrtes (and shaes). ndab must be at
c            least nlat.
c
c
c  wvhses    an array which must be initialized by subroutine vhsesi.
c            once initialized
c            wvhses can be used repeatedly by ivrtes as long as nlon
c            and nlat remain unchanged.  wvhses must not be altered
c            between calls of ivrtes.
c
c
c  lvhses    the dimension of the array wvhses as it appears in the
c            program that calls ivrtes. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhses must be at least
c
c               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls ivrtes. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,nlon/2)         if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2)     if nlon is odd
c
c            if isym = 0 then lwork must be at least
c
c               nlat*((2*nt+1)*nlon+2*l1*nt+1)
c
c            if isym = 1 or 2 then lwork must be at least
c
c               (2*nt+1)*l2*nlon+nlat*(2*nt*l1+1)
c
c     **************************************************************
c
c     output parameters
c
c
c     v,w   two or three dimensional arrays (see input parameter nt) that
c           contain a divergence free vector field whose vorticity is
c           vort - pertrb at the lattitude point theta(i)=pi/2-(i-1)*pi/(nlat-1)
c           and longitude point lambda(j)=(j-1)*2*pi/nlon.  w is the east
c           longitude component and v is the colatitudinal component.  the
c           indices for v and w are defined at the input parameter isym.
c           the divergence of (v,w) is the zero scalar field.
c
c   pertrb  a nt dimensional array (see input parameter nt and assume nt=1
c           for the description that follows).  vort - pertrb is a scalar
c           field which can be the vorticity of a vector field (v,w).
c           pertrb is related to the scalar harmonic coefficients a,b
c           of vort (computed by shaes) by the formula
c
c                pertrb = a(1,1)/(2.*sqrt(2.))
c
c           an unperturbed vort can be the vorticity of a vector field
c           only if a(1,1) is zero.  if a(1,1) is nonzero (flagged by
c           pertrb nonzero) then subtracting pertrb from vort yields a
c           scalar field for which a(1,1) is zero.
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idvw
c           = 6  error in the specification of jdvw
c           = 7  error in the specification of mdab
c           = 8  error in the specification of ndab
c           = 9  error in the specification of lvhses
c           = 10 error in the specification of lwork
c **********************************************************************
c                                                                              
c   
      subroutine ivrtes(nlat,nlon,isym,nt,v,w,idvw,jdvw,a,b,mdab,ndab,
     +                  wvhses,lvhses,work,lwork,pertrb,ierror)
      dimension v(idvw,jdvw,nt),w(idvw,jdvw,nt),pertrb(nt)
      dimension a(mdab,ndab,nt),b(mdab,ndab,nt)
      dimension wvhses(lvhses),work(lwork)
c
c     check input parameters
c
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if(nlon .lt. 4) return
      ierror = 3
      if(isym.lt.0 .or. isym.gt.2) return
      ierror = 4
      if(nt .lt. 0) return
      ierror = 5
      imid = (nlat+1)/2
      if((isym.eq.0 .and. idvw.lt.nlat) .or.
     +   (isym.ne.0 .and. idvw.lt.imid)) return
      ierror = 6
      if(jdvw .lt. nlon) return
      ierror = 7
      mmax = min0(nlat,(nlon+1)/2)
      if(mdab .lt. min0(nlat,(nlon+2)/2)) return
      ierror = 8
      if(ndab .lt. nlat) return
      ierror = 9
      lzz1 = 2*nlat*imid
      labc = 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
      l1 = min0(nlat,(nlon+2)/2)
      l2 = (nlat+1)/2
      lwmin = (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
      ierror = 10
c
c     verify unsaved work space length
c
      mn = mmax*nlat*nt
      if(isym.ne.0  .and. lwork .lt.
     +nlat*(2*nt*nlon+max0(6*imid,nlon))+2*mn+nlat) return
      if(isym.eq.0  .and. lwork .lt.
     +imid*(2*nt*nlon+max0(6*nlat,nlon))+2*mn+nlat) return
      ierror = 0
c
c     set work space pointers
c
      icr = 1
      ici = icr + mn
      is = ici + mn
      iwk = is + nlat
      liwk = lwork-2*mn-nlat
      call ivtes1(nlat,nlon,isym,nt,v,w,idvw,jdvw,work(icr),work(ici),
     +            mmax,work(is),mdab,ndab,a,b,wvhses,lvhses,work(iwk),
     +            liwk,pertrb,ierror)
      return
      end

      subroutine ivtes1(nlat,nlon,isym,nt,v,w,idvw,jdvw,cr,ci,mmax,
     +sqnn,mdab,ndab,a,b,wsav,lwsav,wk,lwk,pertrb,ierror)
      dimension v(idvw,jdvw,nt),w(idvw,jdvw,nt),pertrb(nt)
      dimension cr(mmax,nlat,nt),ci(mmax,nlat,nt),sqnn(nlat)
      dimension a(mdab,ndab,nt),b(mdab,ndab,nt)
      dimension wsav(lwsav),wk(lwk)
c
c     preset coefficient multiplyers in vector
c
      do 1 n=2,nlat
      fn = float(n-1)
      sqnn(n) = sqrt(fn*(fn+1.))
    1 continue
c
c     compute multiple vector fields coefficients
c
      do 2 k=1,nt
c
c     set vorticity field perturbation adjustment
c
      pertrb(k) = a(1,1,k)/(2.*sqrt(2.))
c
c     preset br,bi to 0.0
c
      do 3 n=1,nlat
      do 4 m=1,mmax
      cr(m,n,k) = 0.0
      ci(m,n,k) = 0.0
    4 continue
    3 continue
c
c     compute m=0 coefficients
c
      do 5 n=2,nlat
      cr(1,n,k) = a(1,n,k)/sqnn(n)
      ci(1,n,k) = b(1,n,k)/sqnn(n)
    5 continue
c
c     compute m>0 coefficients
c
      do 6 m=2,mmax
      do 7 n=m,nlat
      cr(m,n,k) = a(m,n,k)/sqnn(n)
      ci(m,n,k) = b(m,n,k)/sqnn(n)
    7 continue
    6 continue
    2 continue
c
c     set ityp for vector synthesis with divergence=0
c
      if (isym.eq.0) then
      ityp = 2
      else if (isym.eq.1) then
      ityp = 5
      else if (isym.eq.2) then
      ityp = 8
      end if
c
c     vector sythesize cr,ci into divergence free vector field (v,w)
c
      call vhses(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
     +           mmax,nlat,wsav,lwsav,wk,lwk,ierror)
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file shagc.f
!
!     this file contains code and documentation for subroutines
!     shagc and shagci
!
! ... files which must be loaded with shagc.f
!
!     sphcom.f, hrfft.f, gaqd.f
!
!
!     subroutine shagc(nlat,nlon,isym,nt,g,idg,jdg,a,b,mdab,ndab,
!    +                 wshagc,lshagc,work,lwork,ierror)
!
!     subroutine shagc performs the spherical harmonic analysis
!     on the array g and stores the result in the arrays a and b.
!     the analysis is performed on a gaussian grid in colatitude
!     and an equally spaced grid in longitude.  the associated
!     legendre functions are recomputed rather than stored as they
!     are in subroutine shags.  the analysis is described below
!     at output parameters a,b.
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are compu
!            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid poi
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than or equal to 4. the efficiency of the computation is
!            improved when nlon is a product of small prime numbers.
!
!     isym   = 0  no symmetries exist about the equator. the analysis
!                 is performed on the entire sphere.  i.e. on the
!                 array g(i,j) for i=1,...,nlat and j=1,...,nlon.
!                 (see description of g below)
!
!            = 1  g is antisymmetric about the equator. the analysis
!                 is performed on the northern hemisphere only.  i.e.
!                 if nlat is odd the analysis is performed on the
!                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
!                 if nlat is even the analysis is performed on the
!                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!
!            = 2  g is symmetric about the equator. the analysis is
!                 performed on the northern hemisphere only.  i.e.
!                 if nlat is odd the analysis is performed on the
!                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
!                 if nlat is even the analysis is performed on the
!                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!     nt     the number of analyses.  in the program that calls shagc,
!            the arrays g,a and b can be three dimensional in which
!            case multiple analyses will be performed.  the third
!            index is the analysis index which assumes the values
!            k=1,...,nt.  for a single analysis set nt=1. the
!            discription of the remaining parameters is simplified
!            by assuming that nt=1 or that the arrays g,a and b
!            have only two dimensions.
!
!     g      a two or three dimensional array (see input parameter
!            nt) that contains the discrete function to be analyzed.
!            g(i,j) contains the value of the function at the gaussian
!            point theta(i) and longitude point phi(j) = (j-1)*2*pi/nlon
!            the index ranges are defined above at the input parameter
!            isym.
!
!     idg    the first dimension of the array g as it appears in the
!            program that calls shagc. if isym equals zero then idg
!            must be at least nlat.  if isym is nonzero then idg must
!            be at least nlat/2 if nlat is even or at least (nlat+1)/2
!            if nlat is odd.
!
!     jdg    the second dimension of the array g as it appears in the
!            program that calls shagc. jdg must be at least nlon.
!
!     mdab   the first dimension of the arrays a and b as it appears
!            in the program that calls shagc. mdab must be at least
!            min0((nlon+2)/2,nlat) if nlon is even or at least
!            min0((nlon+1)/2,nlat) if nlon is odd
!
!     ndab   the second dimension of the arrays a and b as it appears
!            in the program that calls shaec. ndab must be at least nlat
!
!     wshagc an array which must be initialized by subroutine shagci.
!            once initialized, wshagc can be used repeatedly by shagc.
!            as long as nlat and nlon remain unchanged.  wshagc must
!            not be altered between calls of shagc.
!
!     lshagc the dimension of the array wshagc as it appears in the
!            program that calls shagc. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshagc must be at least
!
!                  nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
!
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls shagc. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            if isym is zero then lwork must be at least
!
!                      nlat*(nlon*nt+max0(3*l2,nlon))
!
!            if isym is not zero then lwork must be at least
!
!                      l2*(nlon*nt+max0(3*nlat,nlon))
!
!     **************************************************************
!
!     output parameters
!
!     a,b    both a,b are two or three dimensional arrays (see input
!            parameter nt) that contain the spherical harmonic
!            coefficients in the representation of g(i,j) given in the
!            discription of subroutine shagc. for isym=0, a(m,n) and
!            b(m,n) are given by the equations listed below. symmetric
!            versions are used when isym is greater than zero.
!
!     definitions
!
!     1. the normalized associated legendre functions
!
!     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
!                       *sin(theta)**m/(2**n*factorial(n)) times the
!                       (n+m)th derivative of (x**2-1)**n with respect
!                       to x=cos(theta).
!
!     2. the fourier transform of g(i,j).
!
!     c(m,i)          = 2/nlon times the sum from j=1 to j=nlon of
!                       g(i,j)*cos((m-1)*(j-1)*2*pi/nlon)
!                       (the first and last terms in this sum
!                       are divided by 2)
!
!     s(m,i)          = 2/nlon times the sum from j=2 to j=nlon of
!                       g(i,j)*sin((m-1)*(j-1)*2*pi/nlon)
!
!
!     3. the gaussian points and weights on the sphere
!        (computed by subroutine gaqd).
!
!        theta(1),...,theta(nlat) (gaussian pts in radians)
!        wts(1),...,wts(nlat) (corresponding gaussian weights)
!
!     4. the maximum (plus one) longitudinal wave number
!
!            mmax = min0(nlat,(nlon+2)/2) if nlon is even or
!            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
!
!
!     then for m=0,...,mmax-1 and n=m,...,nlat-1 the arrays a,b
!     are given by
!
!     a(m+1,n+1)     =  the sum from i=1 to i=nlat of
!                       c(m+1,i)*wts(i)*pbar(m,n,theta(i))
!
!     b(m+1,n+1)      = the sum from i=1 to nlat of
!                       s(m+1,i)*wts(i)*pbar(m,n,theta(i))
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of isym
!            = 4  error in the specification of nt
!            = 5  error in the specification of idg
!            = 6  error in the specification of jdg
!            = 7  error in the specification of mdab
!            = 8  error in the specification of ndab
!            = 9  error in the specification of lshagc
!            = 10 error in the specification of lwork
!
!
! ****************************************************************
!
!     subroutine shagci(nlat,nlon,wshagc,lshagc,dwork,ldwork,ierror)
!
!     subroutine shagci initializes the array wshagc which can then
!     be used repeatedly by subroutines shagc. it precomputes
!     and stores in wshagc quantities such as gaussian weights,
!     legendre polynomial coefficients, and fft trigonometric tables.
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are compu
!            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid poi
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than or equal to 4. the efficiency of the computation is
!            improved when nlon is a product of small prime numbers.
!
!     wshagc an array which must be initialized by subroutine shagci.
!            once initialized, wshagc can be used repeatedly by shagc
!            as long as nlat and nlon remain unchanged.  wshagc must
!            not be altered between calls of shagc.
!
!     lshagc the dimension of the array wshagc as it appears in the
!            program that calls shagc. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshagc must be at least
!
!                  nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
!
!     dwork   a double precision work array that does not have to be saved.
!
!     ldwork  the dimension of the array dwork as it appears in the
!            program that calls shagci. ldwork must be at least
!
!                nlat*(nlat+4)
!
!     output parameter
!
!     wshagc an array which must be initialized before calling shagc or
!            once initialized, wshagc can be used repeatedly by shagc or
!            as long as nlat and nlon remain unchanged.  wshagc must not
!            altered between calls of shagc.
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of lshagc
!            = 4  error in the specification of ldwork
!            = 5  failure in gaqd to compute gaussian points
!                 (due to failure in eigenvalue routine)
!
!
! ****************************************************************
      SUBROUTINE SHAGC(Nlat,Nlon,Isym,Nt,G,Idg,Jdg,A,B,Mdab,Ndab,Wshagc,&
                     & Lshagc,Work,Lwork,Ierror)
      IMPLICIT NONE
      REAL A , B , G , Work , Wshagc
      INTEGER Idg , Ierror , ifft , ipmn , Isym , iwts , Jdg , l , l1 , &
            & l2 , lat , late , Lshagc , Lwork , Mdab , Ndab , Nlat ,   &
            & Nlon , Nt

!     subroutine shagc performs the spherical harmonic analysis on
!     a gaussian grid on the array(s) in g and returns the coefficients
!     in array(s) a,b. the necessary legendre polynomials are computed
!     as needed in this version.
!
      DIMENSION G(Idg,Jdg,1) , A(Mdab,Ndab,1) , B(Mdab,Ndab,1) ,        &
              & Wshagc(Lshagc) , Work(Lwork)
!     check input parameters
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<1 ) RETURN
!     set upper limit on m for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set gaussian point nearest equator pointer
      late = (Nlat+MOD(Nlat,2))/2
!     set number of grid points for analysis/synthesis
      lat = Nlat
      IF ( Isym/=0 ) lat = late
      Ierror = 5
      IF ( Idg<lat ) RETURN
      Ierror = 6
      IF ( Jdg<Nlon ) RETURN
      Ierror = 7
      IF ( Mdab<l ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      l1 = l
      l2 = late
      Ierror = 9
!     check permanent work space length
      IF ( Lshagc<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 10
!     check temporary work space length
      IF ( Isym==0 ) THEN
         IF ( Lwork<Nlat*(Nlon*Nt+MAX0(3*l2,Nlon)) ) RETURN
!     isym.ne.0
      ELSEIF ( Lwork<l2*(Nlon*Nt+MAX0(3*Nlat,Nlon)) ) THEN
         RETURN
      ENDIF
      Ierror = 0
!     starting address for gaussian wts in shigc and fft values
      iwts = 1
      ifft = Nlat + 2*Nlat*late + 3*(l*(l-1)/2+(Nlat-l)*(l-1)) + 1
!     set pointers for internal storage of g and legendre polys
      ipmn = lat*Nlon*Nt + 1
      CALL SHAGC1(Nlat,Nlon,l,lat,Isym,G,Idg,Jdg,Nt,A,B,Mdab,Ndab,      &
                & Wshagc,Wshagc(iwts),Wshagc(ifft),late,Work(ipmn),Work)
    END SUBROUTINE SHAGC

    
    SUBROUTINE SHAGC1(Nlat,Nlon,L,Lat,Mode,Gs,Idg,Jdg,Nt,A,B,Mdab,    &
                      & Ndab,W,Wts,Wfft,Late,Pmn,G)
      IMPLICIT NONE
      REAL A , B , G , Gs , Pmn , sfn , t1 , t2 , W , Wfft , Wts
      INTEGER i , Idg , is , j , Jdg , k , km , L , Lat , Late , lm1 ,  &
            & lp1 , m , Mdab , Mode , mp1 , mp2 , ms , Ndab , nl2
      INTEGER Nlat , Nlon , np1 , ns , Nt
      DIMENSION Gs(Idg,Jdg,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt) ,    &
              & G(Lat,Nlon,Nt)
      DIMENSION W(1) , Wts(Nlat) , Wfft(1) , Pmn(Nlat,Late,3)
!     set gs array internally in shagc1
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               G(i,j,k) = Gs(i,j,k)
            ENDDO
         ENDDO
      ENDDO
!     do fourier transform
      DO k = 1 , Nt
         CALL HRFFTF(Lat,Nlon,G(1,1,k),Lat,Wfft,Pmn)
      ENDDO
!     scale result
      sfn = 2.0/FLOAT(Nlon)
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               G(i,j,k) = sfn*G(i,j,k)
            ENDDO
         ENDDO
      ENDDO
!     compute using gaussian quadrature
!     a(n,m) = s (ga(theta,m)*pnm(theta)*sin(theta)*dtheta)
!     b(n,m) = s (gb(theta,m)*pnm(theta)*sin(theta)*dtheta)
!     here ga,gb are the cos(phi),sin(phi) coefficients of
!     the fourier expansion of g(theta,phi) in phi.  as a result
!     of the above fourier transform they are stored in array
!     g as follows:
!     for each theta(i) and k= l-1
!     ga(0),ga(1),gb(1),ga(2),gb(2),...,ga(k-1),gb(k-1),ga(k)
!     correspond to (in the case nlon=l+l-2)
!     g(i,1),g(i,2),g(i,3),g(i,4),g(i,5),...,g(i,2l-4),g(i,2l-3),g(i,2l-
!     initialize coefficients to zero
      DO k = 1 , Nt
         DO np1 = 1 , Nlat
            DO mp1 = 1 , L
               A(mp1,np1,k) = 0.0
               B(mp1,np1,k) = 0.0
            ENDDO
         ENDDO
      ENDDO
!     set m+1 limit on b(m+1) calculation
      lm1 = L
      IF ( Nlon==L+L-2 ) lm1 = L - 1
      IF ( Mode==0 ) THEN
!     for full sphere (mode=0) and even/odd reduction:
!     overwrite g(i) with (g(i)+g(nlat-i+1))*wts(i)
!     overwrite g(nlat-i+1) with (g(i)-g(nlat-i+1))*wts(i)
         nl2 = Nlat/2
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  t1 = G(i,j,k)
                  t2 = G(is,j,k)
                  G(i,j,k) = Wts(i)*(t1+t2)
                  G(is,j,k) = Wts(i)*(t1-t2)
               ENDDO
!     adjust equator if necessary(nlat odd)
               IF ( MOD(Nlat,2)/=0 ) G(Late,j,k) = Wts(Late)*G(Late,j,k)
            ENDDO
         ENDDO
!     set m = 0 coefficients first
         m = 0
         CALL LEGIN(Mode,L,Nlat,m,W,Pmn,km)
         DO k = 1 , Nt
            DO i = 1 , Late
               is = Nlat - i + 1
               DO np1 = 1 , Nlat , 2
!     n even
                  A(1,np1,k) = A(1,np1,k) + G(i,1,k)*Pmn(np1,i,km)
               ENDDO
               DO np1 = 2 , Nlat , 2
!     n odd
                  A(1,np1,k) = A(1,np1,k) + G(is,1,k)*Pmn(np1,i,km)
               ENDDO
            ENDDO
         ENDDO
!     compute coefficients for which b(m,n) is available
         DO mp1 = 2 , lm1
            m = mp1 - 1
            mp2 = m + 2
!     compute pmn for all i and n=m,...,l-1
            CALL LEGIN(Mode,L,Nlat,m,W,Pmn,km)
            DO k = 1 , Nt
               DO i = 1 , Late
                  is = Nlat - i + 1
!     n-m even
                  DO np1 = mp1 , Nlat , 2
                     A(mp1,np1,k) = A(mp1,np1,k) + G(i,2*m,k)           &
                                  & *Pmn(np1,i,km)
                     B(mp1,np1,k) = B(mp1,np1,k) + G(i,2*m+1,k)         &
                                  & *Pmn(np1,i,km)
                  ENDDO
!     n-m odd
                  DO np1 = mp2 , Nlat , 2
                     A(mp1,np1,k) = A(mp1,np1,k) + G(is,2*m,k)          &
                                  & *Pmn(np1,i,km)
                     B(mp1,np1,k) = B(mp1,np1,k) + G(is,2*m+1,k)        &
                                  & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
         IF ( Nlon==L+L-2 ) THEN
!     compute a(l,np1) coefficients only
            m = L - 1
            CALL LEGIN(Mode,L,Nlat,m,W,Pmn,km)
            DO k = 1 , Nt
               DO i = 1 , Late
                  is = Nlat - i + 1
!     n-m even
                  DO np1 = L , Nlat , 2
                     A(L,np1,k) = A(L,np1,k) + 0.5*G(i,Nlon,k)          &
                                & *Pmn(np1,i,km)
                  ENDDO
                  lp1 = L + 1
!     n-m odd
                  DO np1 = lp1 , Nlat , 2
                     A(L,np1,k) = A(L,np1,k) + 0.5*G(is,Nlon,k)         &
                                & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
      ELSE
!     half sphere
!     overwrite g(i) with wts(i)*(g(i)+g(i)) for i=1,...,nlate/2
         nl2 = Nlat/2
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , nl2
                  G(i,j,k) = Wts(i)*(G(i,j,k)+G(i,j,k))
               ENDDO
!     adjust equator separately if a grid point
               IF ( nl2<Late ) G(Late,j,k) = Wts(Late)*G(Late,j,k)
            ENDDO
         ENDDO
!     set m = 0 coefficients first
         m = 0
         CALL LEGIN(Mode,L,Nlat,m,W,Pmn,km)
         ms = 1
         IF ( Mode==1 ) ms = 2
         DO k = 1 , Nt
            DO i = 1 , Late
               DO np1 = ms , Nlat , 2
                  A(1,np1,k) = A(1,np1,k) + G(i,1,k)*Pmn(np1,i,km)
               ENDDO
            ENDDO
         ENDDO
!     compute coefficients for which b(m,n) is available
         DO mp1 = 2 , lm1
            m = mp1 - 1
            ms = mp1
            IF ( Mode==1 ) ms = mp1 + 1
!     compute pmn for all i and n=m,...,nlat-1
            CALL LEGIN(Mode,L,Nlat,m,W,Pmn,km)
            DO k = 1 , Nt
               DO i = 1 , Late
                  DO np1 = ms , Nlat , 2
                     A(mp1,np1,k) = A(mp1,np1,k) + G(i,2*m,k)           &
                                  & *Pmn(np1,i,km)
                     B(mp1,np1,k) = B(mp1,np1,k) + G(i,2*m+1,k)         &
                                  & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
         IF ( Nlon==L+L-2 ) THEN
!     compute coefficient a(l,np1) only
            m = L - 1
            CALL LEGIN(Mode,L,Nlat,m,W,Pmn,km)
            ns = L
            IF ( Mode==1 ) ns = L + 1
            DO k = 1 , Nt
               DO i = 1 , Late
                  DO np1 = ns , Nlat , 2
                     A(L,np1,k) = A(L,np1,k) + 0.5*G(i,Nlon,k)          &
                                & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      END SUBROUTINE SHAGC1

      
      SUBROUTINE SHAGCI(Nlat,Nlon,Wshagc,Lshagc,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER i1 , i2 , i3 , i4 , i5 , i6 , i7 , idth , idwts , Ierror ,&
            & iw , l , l1 , l2 , late , Ldwork , Lshagc , Nlat , Nlon
      REAL Wshagc
!     this subroutine must be called before calling shagc with
!     fixed nlat,nlon. it precomputes quantites such as the gaussian
!     points and weights, m=0,m=1 legendre polynomials, recursion
!     recursion coefficients.
      DIMENSION Wshagc(Lshagc)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+MOD(Nlat,2))/2
      l1 = l
      l2 = late
      Ierror = 3
!     check permanent work space length
      IF ( Lshagc<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 4
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set pointers
      i1 = 1
      i2 = i1 + Nlat
      i3 = i2 + Nlat*late
      i4 = i3 + Nlat*late
      i5 = i4 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i6 = i5 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i7 = i6 + l*(l-1)/2 + (Nlat-l)*(l-1)
!     set indices in temp work for double precision gaussian wts and pts
      idth = 1
      idwts = idth + Nlat
      iw = idwts + Nlat
      CALL SHAGCI1(Nlat,Nlon,l,late,Wshagc(i1),Wshagc(i2),Wshagc(i3),   &
                 & Wshagc(i4),Wshagc(i5),Wshagc(i6),Wshagc(i7),         &
                 & Dwork(idth),Dwork(idwts),Dwork(iw),Ierror)
      IF ( Ierror/=0 ) Ierror = 5
    END SUBROUTINE SHAGCI

    
    SUBROUTINE SHAGCI1(Nlat,Nlon,L,Late,Wts,P0n,P1n,Abel,Bbel,Cbel,   &
                       & Wfft,Dtheta,Dwts,Work,Ier)
      IMPLICIT NONE
      REAL Abel , Bbel , Cbel , P0n , P1n , Wfft , Wts
      INTEGER i , Ier , imn , IMNDX , INDX , L , Late , lw , m , mlim , &
            & n , Nlat , Nlon , np1
      DIMENSION Wts(Nlat) , P0n(Nlat,Late) , P1n(Nlat,Late) , Abel(1) , &
              & Bbel(1) , Cbel(1) , Wfft(1)
      DOUBLE PRECISION pb , Dtheta(Nlat) , Dwts(Nlat) , Work(*)
!     compute the nlat  gaussian points and weights, the
!     m=0,1 legendre polys for gaussian points and all n,
!     and the legendre recursion coefficients
!     define index function used in storing
!     arrays for recursion coefficients (functions of (m,n))
!     the index function indx(m,n) is defined so that
!     the pairs (m,n) map to [1,2,...,indx(l-1,l-1)] with no
!     "holes" as m varies from 2 to n and n varies from 2 to l-1.
!     (m=0,1 are set from p0n,p1n for all n)
!     define for 2.le.n.le.l-1
      INDX(m,n) = (n-1)*(n-2)/2 + m - 1
!     define index function for l.le.n.le.nlat
      IMNDX(m,n) = L*(L-1)/2 + (n-L-1)*(L-1) + m - 1
!     preset quantites for fourier transform
      CALL HRFFTI(Nlon,Wfft)
!     compute double precision gaussian points and weights
!     lw = 4*nlat*(nlat+1)+2
      lw = Nlat*(Nlat+2)
      CALL GAQD(Nlat,Dtheta,Dwts,Work,lw,Ier)
      IF ( Ier/=0 ) RETURN
!     store gaussian weights single precision to save computation
!     in inner loops in analysis
      DO i = 1 , Nlat
         Wts(i) = Dwts(i)
      ENDDO
!     initialize p0n,p1n using double precision dnlfk,dnlft
      DO np1 = 1 , Nlat
         DO i = 1 , Late
            P0n(np1,i) = 0.0
            P1n(np1,i) = 0.0
         ENDDO
      ENDDO
!     compute m=n=0 legendre polynomials for all theta(i)
      np1 = 1
      n = 0
      m = 0
      CALL DNLFK(m,n,Work)
      DO i = 1 , Late
         CALL DNLFT(m,n,Dtheta(i),Work,pb)
         P0n(1,i) = pb
      ENDDO
!     compute p0n,p1n for all theta(i) when n.gt.0
      DO np1 = 2 , Nlat
         n = np1 - 1
         m = 0
         CALL DNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DNLFT(m,n,Dtheta(i),Work,pb)
            P0n(np1,i) = pb
         ENDDO
!     compute m=1 legendre polynomials for all n and theta(i)
         m = 1
         CALL DNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DNLFT(m,n,Dtheta(i),Work,pb)
            P1n(np1,i) = pb
         ENDDO
      ENDDO
!     compute and store swarztrauber recursion coefficients
!     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      DO n = 2 , Nlat
         mlim = MIN0(n,L)
         DO m = 2 , mlim
            imn = INDX(m,n)
            IF ( n>=L ) imn = IMNDX(m,n)
            Abel(imn) = SQRT(FLOAT((2*n+1)*(m+n-2)*(m+n-3))/FLOAT(((2*n-&
                      & 3)*(m+n-1)*(m+n))))
            Bbel(imn) = SQRT(FLOAT((2*n+1)*(n-m-1)*(n-m))/FLOAT(((2*n-3)&
                      & *(m+n-1)*(m+n))))
            Cbel(imn) = SQRT(FLOAT((n-m+1)*(n-m+2))/FLOAT(((n+m-1)*(n+m)&
                      & )))
         ENDDO
      ENDDO
      END SUBROUTINE SHAGCI1


      SUBROUTINE DSHAGC(Nlat,Nlon,Isym,Nt,G,Idg,Jdg,A,B,Mdab,Ndab,Wshagc,&
                     & Lshagc,Work,Lwork,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , G , Work , Wshagc
      INTEGER Idg , Ierror , ifft , ipmn , Isym , iwts , Jdg , l , l1 , &
            & l2 , lat , late , Lshagc , Lwork , Mdab , Ndab , Nlat ,   &
            & Nlon , Nt

!     subroutine shagc performs the spherical harmonic analysis on
!     a gaussian grid on the array(s) in g and returns the coefficients
!     in array(s) a,b. the necessary legendre polynomials are computed
!     as needed in this version.
!
      DIMENSION G(Idg,Jdg,1) , A(Mdab,Ndab,1) , B(Mdab,Ndab,1) ,        &
              & Wshagc(Lshagc) , Work(Lwork)
!     check input parameters
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<1 ) RETURN
!     set upper limit on m for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set gaussian point nearest equator pointer
      late = (Nlat+MOD(Nlat,2))/2
!     set number of grid points for analysis/synthesis
      lat = Nlat
      IF ( Isym/=0 ) lat = late
      Ierror = 5
      IF ( Idg<lat ) RETURN
      Ierror = 6
      IF ( Jdg<Nlon ) RETURN
      Ierror = 7
      IF ( Mdab<l ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      l1 = l
      l2 = late
      Ierror = 9
!     check permanent work space length
      IF ( Lshagc<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 10
!     check temporary work space length
      IF ( Isym==0 ) THEN
         IF ( Lwork<Nlat*(Nlon*Nt+MAX0(3*l2,Nlon)) ) RETURN
!     isym.ne.0
      ELSEIF ( Lwork<l2*(Nlon*Nt+MAX0(3*Nlat,Nlon)) ) THEN
         RETURN
      ENDIF
      Ierror = 0
!     starting address for gaussian wts in shigc and fft values
      iwts = 1
      ifft = Nlat + 2*Nlat*late + 3*(l*(l-1)/2+(Nlat-l)*(l-1)) + 1
!     set pointers for internal storage of g and legendre polys
      ipmn = lat*Nlon*Nt + 1
      CALL DSHAGC1(Nlat,Nlon,l,lat,Isym,G,Idg,Jdg,Nt,A,B,Mdab,Ndab,      &
                & Wshagc,Wshagc(iwts),Wshagc(ifft),late,Work(ipmn),Work)
    END SUBROUTINE DSHAGC

    
    SUBROUTINE DSHAGC1(Nlat,Nlon,L,Lat,Mode,Gs,Idg,Jdg,Nt,A,B,Mdab,    &
                      & Ndab,W,Wts,Wfft,Late,Pmn,G)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , G , Gs , Pmn , sfn , t1 , t2 , W , Wfft , Wts
      INTEGER i , Idg , is , j , Jdg , k , km , L , Lat , Late , lm1 ,  &
            & lp1 , m , Mdab , Mode , mp1 , mp2 , ms , Ndab , nl2
      INTEGER Nlat , Nlon , np1 , ns , Nt
      DIMENSION Gs(Idg,Jdg,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt) ,    &
              & G(Lat,Nlon,Nt)
      DIMENSION W(1) , Wts(Nlat) , Wfft(1) , Pmn(Nlat,Late,3)
!     set gs array internally in shagc1
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               G(i,j,k) = Gs(i,j,k)
            ENDDO
         ENDDO
      ENDDO
!     do fourier transform
      DO k = 1 , Nt
         CALL DHRFFTF(Lat,Nlon,G(1,1,k),Lat,Wfft,Pmn)
      ENDDO
!     scale result
      sfn = 2.0/FLOAT(Nlon)
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               G(i,j,k) = sfn*G(i,j,k)
            ENDDO
         ENDDO
      ENDDO
!     compute using gaussian quadrature
!     a(n,m) = s (ga(theta,m)*pnm(theta)*sin(theta)*dtheta)
!     b(n,m) = s (gb(theta,m)*pnm(theta)*sin(theta)*dtheta)
!     here ga,gb are the cos(phi),sin(phi) coefficients of
!     the fourier expansion of g(theta,phi) in phi.  as a result
!     of the above fourier transform they are stored in array
!     g as follows:
!     for each theta(i) and k= l-1
!     ga(0),ga(1),gb(1),ga(2),gb(2),...,ga(k-1),gb(k-1),ga(k)
!     correspond to (in the case nlon=l+l-2)
!     g(i,1),g(i,2),g(i,3),g(i,4),g(i,5),...,g(i,2l-4),g(i,2l-3),g(i,2l-
!     initialize coefficients to zero
      DO k = 1 , Nt
         DO np1 = 1 , Nlat
            DO mp1 = 1 , L
               A(mp1,np1,k) = 0.0
               B(mp1,np1,k) = 0.0
            ENDDO
         ENDDO
      ENDDO
!     set m+1 limit on b(m+1) calculation
      lm1 = L
      IF ( Nlon==L+L-2 ) lm1 = L - 1
      IF ( Mode==0 ) THEN
!     for full sphere (mode=0) and even/odd reduction:
!     overwrite g(i) with (g(i)+g(nlat-i+1))*wts(i)
!     overwrite g(nlat-i+1) with (g(i)-g(nlat-i+1))*wts(i)
         nl2 = Nlat/2
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  t1 = G(i,j,k)
                  t2 = G(is,j,k)
                  G(i,j,k) = Wts(i)*(t1+t2)
                  G(is,j,k) = Wts(i)*(t1-t2)
               ENDDO
!     adjust equator if necessary(nlat odd)
               IF ( MOD(Nlat,2)/=0 ) G(Late,j,k) = Wts(Late)*G(Late,j,k)
            ENDDO
         ENDDO
!     set m = 0 coefficients first
         m = 0
         CALL DLEGIN(Mode,L,Nlat,m,W,Pmn,km)
         DO k = 1 , Nt
            DO i = 1 , Late
               is = Nlat - i + 1
               DO np1 = 1 , Nlat , 2
!     n even
                  A(1,np1,k) = A(1,np1,k) + G(i,1,k)*Pmn(np1,i,km)
               ENDDO
               DO np1 = 2 , Nlat , 2
!     n odd
                  A(1,np1,k) = A(1,np1,k) + G(is,1,k)*Pmn(np1,i,km)
               ENDDO
            ENDDO
         ENDDO
!     compute coefficients for which b(m,n) is available
         DO mp1 = 2 , lm1
            m = mp1 - 1
            mp2 = m + 2
!     compute pmn for all i and n=m,...,l-1
            CALL DLEGIN(Mode,L,Nlat,m,W,Pmn,km)
            DO k = 1 , Nt
               DO i = 1 , Late
                  is = Nlat - i + 1
!     n-m even
                  DO np1 = mp1 , Nlat , 2
                     A(mp1,np1,k) = A(mp1,np1,k) + G(i,2*m,k)           &
                                  & *Pmn(np1,i,km)
                     B(mp1,np1,k) = B(mp1,np1,k) + G(i,2*m+1,k)         &
                                  & *Pmn(np1,i,km)
                  ENDDO
!     n-m odd
                  DO np1 = mp2 , Nlat , 2
                     A(mp1,np1,k) = A(mp1,np1,k) + G(is,2*m,k)          &
                                  & *Pmn(np1,i,km)
                     B(mp1,np1,k) = B(mp1,np1,k) + G(is,2*m+1,k)        &
                                  & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
         IF ( Nlon==L+L-2 ) THEN
!     compute a(l,np1) coefficients only
            m = L - 1
            CALL DLEGIN(Mode,L,Nlat,m,W,Pmn,km)
            DO k = 1 , Nt
               DO i = 1 , Late
                  is = Nlat - i + 1
!     n-m even
                  DO np1 = L , Nlat , 2
                     A(L,np1,k) = A(L,np1,k) + 0.5*G(i,Nlon,k)          &
                                & *Pmn(np1,i,km)
                  ENDDO
                  lp1 = L + 1
!     n-m odd
                  DO np1 = lp1 , Nlat , 2
                     A(L,np1,k) = A(L,np1,k) + 0.5*G(is,Nlon,k)         &
                                & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
      ELSE
!     half sphere
!     overwrite g(i) with wts(i)*(g(i)+g(i)) for i=1,...,nlate/2
         nl2 = Nlat/2
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , nl2
                  G(i,j,k) = Wts(i)*(G(i,j,k)+G(i,j,k))
               ENDDO
!     adjust equator separately if a grid point
               IF ( nl2<Late ) G(Late,j,k) = Wts(Late)*G(Late,j,k)
            ENDDO
         ENDDO
!     set m = 0 coefficients first
         m = 0
         CALL DLEGIN(Mode,L,Nlat,m,W,Pmn,km)
         ms = 1
         IF ( Mode==1 ) ms = 2
         DO k = 1 , Nt
            DO i = 1 , Late
               DO np1 = ms , Nlat , 2
                  A(1,np1,k) = A(1,np1,k) + G(i,1,k)*Pmn(np1,i,km)
               ENDDO
            ENDDO
         ENDDO
!     compute coefficients for which b(m,n) is available
         DO mp1 = 2 , lm1
            m = mp1 - 1
            ms = mp1
            IF ( Mode==1 ) ms = mp1 + 1
!     compute pmn for all i and n=m,...,nlat-1
            CALL DLEGIN(Mode,L,Nlat,m,W,Pmn,km)
            DO k = 1 , Nt
               DO i = 1 , Late
                  DO np1 = ms , Nlat , 2
                     A(mp1,np1,k) = A(mp1,np1,k) + G(i,2*m,k)           &
                                  & *Pmn(np1,i,km)
                     B(mp1,np1,k) = B(mp1,np1,k) + G(i,2*m+1,k)         &
                                  & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
         IF ( Nlon==L+L-2 ) THEN
!     compute coefficient a(l,np1) only
            m = L - 1
            CALL DLEGIN(Mode,L,Nlat,m,W,Pmn,km)
            ns = L
            IF ( Mode==1 ) ns = L + 1
            DO k = 1 , Nt
               DO i = 1 , Late
                  DO np1 = ns , Nlat , 2
                     A(L,np1,k) = A(L,np1,k) + 0.5*G(i,Nlon,k)          &
                                & *Pmn(np1,i,km)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      END SUBROUTINE DSHAGC1

      
      SUBROUTINE DSHAGCI(Nlat,Nlon,Wshagc,Lshagc,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER i1 , i2 , i3 , i4 , i5 , i6 , i7 , idth , idwts , Ierror ,&
            & iw , l , l1 , l2 , late , Ldwork , Lshagc , Nlat , Nlon
      DOUBLE PRECISION Wshagc
!     this subroutine must be called before calling shagc with
!     fixed nlat,nlon. it precomputes quantites such as the gaussian
!     points and weights, m=0,m=1 legendre polynomials, recursion
!     recursion coefficients.
      DIMENSION Wshagc(Lshagc)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+MOD(Nlat,2))/2
      l1 = l
      l2 = late
      Ierror = 3
!     check permanent work space length
      IF ( Lshagc<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 4
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set pointers
      i1 = 1
      i2 = i1 + Nlat
      i3 = i2 + Nlat*late
      i4 = i3 + Nlat*late
      i5 = i4 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i6 = i5 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i7 = i6 + l*(l-1)/2 + (Nlat-l)*(l-1)
!     set indices in temp work for double precision gaussian wts and pts
      idth = 1
      idwts = idth + Nlat
      iw = idwts + Nlat
      CALL DSHAGCI1(Nlat,Nlon,l,late,Wshagc(i1),Wshagc(i2),Wshagc(i3),   &
                 & Wshagc(i4),Wshagc(i5),Wshagc(i6),Wshagc(i7),         &
                 & Dwork(idth),Dwork(idwts),Dwork(iw),Ierror)
      IF ( Ierror/=0 ) Ierror = 5
    END SUBROUTINE DSHAGCI

    
    SUBROUTINE DSHAGCI1(Nlat,Nlon,L,Late,Wts,P0n,P1n,Abel,Bbel,Cbel,   &
                       & Wfft,Dtheta,Dwts,Work,Ier)
      IMPLICIT NONE
      DOUBLE PRECISION Abel , Bbel , Cbel , P0n , P1n , Wfft , Wts
      INTEGER i , Ier , imn , IMNDX , INDX , L , Late , lw , m , mlim , &
            & n , Nlat , Nlon , np1
      DIMENSION Wts(Nlat) , P0n(Nlat,Late) , P1n(Nlat,Late) , Abel(1) , &
              & Bbel(1) , Cbel(1) , Wfft(1)
      DOUBLE PRECISION pb , Dtheta(Nlat) , Dwts(Nlat) , Work(*)
!     compute the nlat  gaussian points and weights, the
!     m=0,1 legendre polys for gaussian points and all n,
!     and the legendre recursion coefficients
!     define index function used in storing
!     arrays for recursion coefficients (functions of (m,n))
!     the index function indx(m,n) is defined so that
!     the pairs (m,n) map to [1,2,...,indx(l-1,l-1)] with no
!     "holes" as m varies from 2 to n and n varies from 2 to l-1.
!     (m=0,1 are set from p0n,p1n for all n)
!     define for 2.le.n.le.l-1
      INDX(m,n) = (n-1)*(n-2)/2 + m - 1
!     define index function for l.le.n.le.nlat
      IMNDX(m,n) = L*(L-1)/2 + (n-L-1)*(L-1) + m - 1
!     preset quantites for fourier transform
      CALL DHRFFTI(Nlon,Wfft)
!     compute double precision gaussian points and weights
!     lw = 4*nlat*(nlat+1)+2
      lw = Nlat*(Nlat+2)
      CALL DGAQD(Nlat,Dtheta,Dwts,Work,lw,Ier)
      IF ( Ier/=0 ) RETURN
!     store gaussian weights single precision to save computation
!     in inner loops in analysis
      DO i = 1 , Nlat
         Wts(i) = Dwts(i)
      ENDDO
!     initialize p0n,p1n using double precision dnlfk,dnlft
      DO np1 = 1 , Nlat
         DO i = 1 , Late
            P0n(np1,i) = 0.0
            P1n(np1,i) = 0.0
         ENDDO
      ENDDO
!     compute m=n=0 legendre polynomials for all theta(i)
      np1 = 1
      n = 0
      m = 0
      CALL DDNLFK(m,n,Work)
      DO i = 1 , Late
         CALL DDNLFT(m,n,Dtheta(i),Work,pb)
         P0n(1,i) = pb
      ENDDO
!     compute p0n,p1n for all theta(i) when n.gt.0
      DO np1 = 2 , Nlat
         n = np1 - 1
         m = 0
         CALL DDNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DDNLFT(m,n,Dtheta(i),Work,pb)
            P0n(np1,i) = pb
         ENDDO
!     compute m=1 legendre polynomials for all n and theta(i)
         m = 1
         CALL DDNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DDNLFT(m,n,Dtheta(i),Work,pb)
            P1n(np1,i) = pb
         ENDDO
      ENDDO
!     compute and store swarztrauber recursion coefficients
!     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      DO n = 2 , Nlat
         mlim = MIN0(n,L)
         DO m = 2 , mlim
            imn = INDX(m,n)
            IF ( n>=L ) imn = IMNDX(m,n)
            Abel(imn) = SQRT(FLOAT((2*n+1)*(m+n-2)*(m+n-3))/FLOAT(((2*n-&
                      & 3)*(m+n-1)*(m+n))))
            Bbel(imn) = SQRT(FLOAT((2*n+1)*(n-m-1)*(n-m))/FLOAT(((2*n-3)&
                      & *(m+n-1)*(m+n))))
            Cbel(imn) = SQRT(FLOAT((n-m+1)*(n-m+2))/FLOAT(((n+m-1)*(n+m)&
                      & )))
         ENDDO
      ENDDO
      END SUBROUTINE DSHAGCI1

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
! ... file gradgs.f
!
!     this file includes documentation and code for
!     subroutine gradgs         i
!
! ... files which must be loaded with gradgec.f
!
!     sphcom.f, hrfft.f, shags.f,vhsgs.f
!
!     subroutine gradgs(nlat,nlon,isym,nt,v,w,idvw,jdvw,a,b,mdab,ndab,
!    +                  wvhsgs,lvhsgs,work,lwork,ierror)
!
!     given the scalar spherical harmonic coefficients a and b, precomputed
!     by subroutine shags for a scalar field sf, subroutine gradgs computes
!     an irrotational vector field (v,w) such that
!
!           gradient(sf) = (v,w).
!
!     v is the colatitudinal and w is the east longitudinal component
!     of the gradient.  i.e.,
!
!            v(i,j) = d(sf(i,j))/dtheta
!
!     and
!
!            w(i,j) = 1/sint*d(sf(i,j))/dlambda
!
!     at the gaussian colatitude point theta(i) (see nlat as input
!     parameter) and longitude lambda(j) = (j-1)*2*pi/nlon where
!     sint = sin(theta(i)).
!
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are computed
!            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid point
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater than
!            3.  the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!
!     isym   this has the same value as the isym that was input to
!            subroutine shags to compute the arrays a and b from the
!            scalar field sf.  isym determines whether (v,w) are
!            computed on the full or half sphere as follows:
!
!      = 0
!
!           sf is not symmetric about the equator. in this case
!           the vector field (v,w) is computed on the entire sphere.
!           i.e., in the arrays  v(i,j),w(i,j) for i=1,...,nlat and
!           j=1,...,nlon.
!
!      = 1
!
!           sf is antisymmetric about the equator. in this case w is
!           antisymmetric and v is symmetric about the equator. w
!           and v are computed on the northern hemisphere only.  i.e.,
!           if nlat is odd they are computed for i=1,...,(nlat+1)/2
!           and j=1,...,nlon.  if nlat is even they are computed for
!           i=1,...,nlat/2 and j=1,...,nlon.
!
!      = 2
!
!           sf is symmetric about the equator. in this case w is
!           symmetric and v is antisymmetric about the equator. w
!           and v are computed on the northern hemisphere only.  i.e.,
!           if nlat is odd they are computed for i=1,...,(nlat+1)/2
!           and j=1,...,nlon.  if nlat is even they are computed for
!           i=1,...,nlat/2 and j=1,...,nlon.
!
!
!     nt     nt is the number of scalar and vector fields.  some
!            computational efficiency is obtained for multiple fields.
!            the arrays a,b,v, and w can be three dimensional corresponding
!            to an indexed multiple array sf.  in this case, multiple
!            vector synthesis will be performed to compute each vector
!            field.  the third index for a,b,v, and w is the synthesis
!            index which assumes the values k = 1,...,nt.  for a single
!            synthesis set nt = 1.  the description of the remaining
!            parameters is simplified by assuming that nt=1 or that a,b,v,
!            and w are two dimensional arrays.
!
!     idvw   the first dimension of the arrays v,w as it appears in
!            the program that calls gradgs. if isym = 0 then idvw
!            must be at least nlat.  if isym = 1 or 2 and nlat is
!            even then idvw must be at least nlat/2. if isym = 1 or 2
!            and nlat is odd then idvw must be at least (nlat+1)/2.
!
!     jdvw   the second dimension of the arrays v,w as it appears in
!            the program that calls gradgs. jdvw must be at least nlon.
!
!     a,b    two or three dimensional arrays (see input parameter nt)
!            that contain scalar spherical harmonic coefficients
!            of the scalar field array sf as computed by subroutine shags.
!     ***    a,b must be computed by shags prior to calling gradgs.
!
!     mdab   the first dimension of the arrays a and b as it appears in
!            the program that calls gradgs (and shags). mdab must be at
!            least min0(nlat,(nlon+2)/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndab   the second dimension of the arrays a and b as it appears in
!            the program that calls gradgs (and shags). ndab must be at
!            least nlat.
!
!
!     wvhsgs an array which must be initialized by subroutine vhsgsi.
!            once initialized,
!            wvhsgs can be used repeatedly by gradgs as long as nlon
!            and nlat remain unchanged.  wvhsgs must not be altered
!            between calls of gradgs.
!
!
!     lvhsgs the dimension of the array wvhsgs as it appears in the
!            program that calls grradgs.  define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lvhsgs must be at least
!
!                 l1*l2*(nlat+nlat-l1+1)+nlon+15+2*nlat
!
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls gradgs. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2                  if nlat is even or
!               l2 = (nlat+1)/2              if nlat is odd
!
!            if isym = 0, lwork must be greater than or equal to
!
!               nlat*((2*nt+1)*nlon+2*l1*nt+1).
!
!            if isym = 1 or 2, lwork must be greater than or equal to
!
!               (2*nt+1)*l2*nlon+nlat*(2*l1*nt+1).
!
!
!     **************************************************************
!
!     output parameters
!
!
!     v,w   two or three dimensional arrays (see input parameter nt) that
!           contain an irrotational vector field such that the gradient of
!           the scalar field sf is (v,w).  w(i,j) is the east longitude
!           component and v(i,j) is the colatitudinal component of velocity
!           at gaussian colatitude and longitude lambda(j) = (j-1)*2*pi/nlon
!           the indices for v and w are defined at the input parameter
!           isym.  the vorticity of (v,w) is zero.  note that any nonzero
!           vector field on the sphere will be multiple valued at the poles
!           [reference swarztrauber].
!
!
!  ierror   = 0  no errors
!           = 1  error in the specification of nlat
!           = 2  error in the specification of nlon
!           = 3  error in the specification of isym
!           = 4  error in the specification of nt
!           = 5  error in the specification of idvw
!           = 6  error in the specification of jdvw
!           = 7  error in the specification of mdab
!           = 8  error in the specification of ndab
!           = 9  error in the specification of lvhsgs
!           = 10 error in the specification of lwork
! **********************************************************************
!
!
      SUBROUTINE GRADGS(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,A,B,Mdab,Ndab,  &
                      & Wvhsgs,Lvhsgs,Work,Lwork,Ierror)
      IMPLICIT NONE

      REAL A , B , V , W
      REAL, DIMENSION(Lvhsgs)  :: Wvhsgs
      REAL, DIMENSION(Lwork) :: Work
      INTEGER ibi , ibr , idv , Idvw , idz , Ierror , imid , is , Isym ,&
            & iwk , Jdvw , lgdmin , liwk , lnl , Lvhsgs , lwkmin ,      &
            & Lwork , lzimn , Mdab , mmax
      INTEGER mn , Ndab , Nlat , Nlon , Nt

      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt)
      DIMENSION A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idvw<Nlat) .OR. (Isym/=0 .AND. Idvw<imid) )   &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<MIN0(Nlat,(Nlon+2)/2) ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
!
!     verify minimum saved work space length
!
      idz = (mmax*(Nlat+Nlat-mmax+1))/2
      lzimn = idz*imid
      lgdmin = lzimn + lzimn + Nlon + 15
      IF ( Lvhsgs<lgdmin ) RETURN
      Ierror = 10
!
!     verify minimum unsaved work space length
!
      mn = mmax*Nlat*Nt
      idv = Nlat
      IF ( Isym/=0 ) idv = imid
      lnl = Nt*idv*Nlon
      lwkmin = lnl + lnl + idv*Nlon + 2*mn + Nlat
      IF ( Lwork<lwkmin ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ibr = 1
      ibi = ibr + mn
      is = ibi + mn
      iwk = is + Nlat
      liwk = Lwork - 2*mn - Nlat
      CALL GRADGS1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Work(ibr),Work(ibi), &
                 & mmax,Work(is),Mdab,Ndab,A,B,Wvhsgs,Lvhsgs,Work(iwk), &
                 & liwk,Ierror)
    END SUBROUTINE GRADGS
 
    SUBROUTINE GRADGS1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Br,Bi,Mmax,    &
                       & Sqnn,Mdab,Ndab,A,B,Wvhsgs,Lvhsgs,Wk,Lwk,Ierror)
      IMPLICIT NONE

      REAL A , B , Bi , Br , ci , cr , fn , Sqnn , V , W , Wk , Wvhsgs
      INTEGER Idvw , Ierror , Isym , ityp , Jdvw , k , Lvhsgs , Lwk ,   &
            & m , Mdab , Mmax , n , Ndab , Nlat , Nlon , Nt

      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt)
      DIMENSION Br(Mmax,Nlat,Nt) , Bi(Mmax,Nlat,Nt) , Sqnn(Nlat)
      DIMENSION A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wvhsgs(Lvhsgs) , Wk(Lwk)
!
!     preset coefficient multiplyers in vector
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.))
      ENDDO
!
!     compute multiple vector fields coefficients
!
      DO k = 1 , Nt
!
!     preset br,bi to 0.0
!
         DO n = 1 , Nlat
            DO m = 1 , Mmax
               Br(m,n,k) = 0.0
               Bi(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            Br(1,n,k) = Sqnn(n)*A(1,n,k)
            Bi(1,n,k) = Sqnn(n)*B(1,n,k)
         ENDDO
!
!     compute m>0 coefficients
!
         DO m = 2 , Mmax
            DO n = m , Nlat
               Br(m,n,k) = Sqnn(n)*A(m,n,k)
               Bi(m,n,k) = Sqnn(n)*B(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     set ityp for irrotational vector synthesis to compute gradient
!
      IF ( Isym==0 ) THEN
         ityp = 1
      ELSEIF ( Isym==1 ) THEN
         ityp = 4
      ELSEIF ( Isym==2 ) THEN
         ityp = 7
      ENDIF
!
!     vector sythesize br,bi into (v,w) (cr,ci are dummy variables)
!
      CALL VHSGS(Nlat,Nlon,ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,cr,ci,Mmax,Nlat, &
               & Wvhsgs,Lvhsgs,Wk,Lwk,Ierror)
      END SUBROUTINE GRADGS1


      SUBROUTINE DGRADGS(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,A,B,Mdab,Ndab,  &
                 & Wvhsgs,Lvhsgs,Work,Lwork,Ierror)
      IMPLICIT NONE

      DOUBLE PRECISION A , B , V , W
      DOUBLE PRECISION, DIMENSION(Lvhsgs)  :: Wvhsgs
      DOUBLE PRECISION, DIMENSION(Lwork) :: Work
      INTEGER ibi , ibr , idv , Idvw , idz , Ierror , imid , is , Isym ,&
            & iwk , Jdvw , lgdmin , liwk , lnl , Lvhsgs , lwkmin ,      &
            & Lwork , lzimn , Mdab , mmax
      INTEGER mn , Ndab , Nlat , Nlon , Nt

      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt)
      DIMENSION A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idvw<Nlat) .OR. (Isym/=0 .AND. Idvw<imid) )   &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<MIN0(Nlat,(Nlon+2)/2) ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
!
!     verify minimum saved work space length
!
      idz = (mmax*(Nlat+Nlat-mmax+1))/2
      lzimn = idz*imid
      lgdmin = lzimn + lzimn + Nlon + 15
      IF ( Lvhsgs<lgdmin ) RETURN
      Ierror = 10
!
!     verify minimum unsaved work space length
!
      mn = mmax*Nlat*Nt
      idv = Nlat
      IF ( Isym/=0 ) idv = imid
      lnl = Nt*idv*Nlon
      lwkmin = lnl + lnl + idv*Nlon + 2*mn + Nlat
      IF ( Lwork<lwkmin ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ibr = 1
      ibi = ibr + mn
      is = ibi + mn
      iwk = is + Nlat
      liwk = Lwork - 2*mn - Nlat
      CALL DGRADGS1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Work(ibr),Work(ibi), &
                 & mmax,Work(is),Mdab,Ndab,A,B,Wvhsgs,Lvhsgs,Work(iwk), &
                 & liwk,Ierror)
    END SUBROUTINE DGRADGS
 
    SUBROUTINE DGRADGS1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Br,Bi,Mmax,    &
                       & Sqnn,Mdab,Ndab,A,B,Wvhsgs,Lvhsgs,Wk,Lwk,Ierror)
      IMPLICIT NONE

      DOUBLE PRECISION A , B , Bi , Br , ci , cr , fn , Sqnn , V , W , Wk , Wvhsgs
      INTEGER Idvw , Ierror , Isym , ityp , Jdvw , k , Lvhsgs , Lwk ,   &
            & m , Mdab , Mmax , n , Ndab , Nlat , Nlon , Nt

      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt)
      DIMENSION Br(Mmax,Nlat,Nt) , Bi(Mmax,Nlat,Nt) , Sqnn(Nlat)
      DIMENSION A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wvhsgs(Lvhsgs) , Wk(Lwk)
!
!     preset coefficient multiplyers in vector
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.))
      ENDDO
!
!     compute multiple vector fields coefficients
!
      DO k = 1 , Nt
!
!     preset br,bi to 0.0
!
         DO n = 1 , Nlat
            DO m = 1 , Mmax
               Br(m,n,k) = 0.0
               Bi(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            Br(1,n,k) = Sqnn(n)*A(1,n,k)
            Bi(1,n,k) = Sqnn(n)*B(1,n,k)
         ENDDO
!
!     compute m>0 coefficients
!
         DO m = 2 , Mmax
            DO n = m , Nlat
               Br(m,n,k) = Sqnn(n)*A(m,n,k)
               Bi(m,n,k) = Sqnn(n)*B(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     set ityp for irrotational vector synthesis to compute gradient
!
      IF ( Isym==0 ) THEN
         ityp = 1
      ELSEIF ( Isym==1 ) THEN
         ityp = 4
      ELSEIF ( Isym==2 ) THEN
         ityp = 7
      ENDIF
!
!     vector sythesize br,bi into (v,w) (cr,ci are dummy variables)
!
      CALL DVHSGS(Nlat,Nlon,ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,cr,ci,Mmax,Nlat, &
               & Wvhsgs,Lvhsgs,Wk,Lwk,Ierror)
      END SUBROUTINE DGRADGS1

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file shigc.f
c
c     this file contains code and documentation for subroutine shigc
c
c ... files which must be loaded with shigc.f
c
c     sphcom.f, hrfft.f, gaqd.f
c
c     3/6/98
c
c *** shigc is functionally the same as shagci or shsgci.  It
c     it included in spherepack3.0 because legacy codes, using
c     the older version of spherepack call shigc to initialize
c     the saved work space wshigc, for either shagc or shsgc
c
c     subroutine shigc(nlat,nlon,wshigc,lshigc,dwork,ldwork,ierror)
c
c     subroutine shigc initializes the array wshigc which can then
c     be used repeatedly by subroutines shsgc or shagc. it precomputes
c     and stores in wshigc quantities such as gaussian weights,
c     legendre polynomial coefficients, and fft trigonometric tables.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are compu
c            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid poi
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     wshigc an array which must be initialized by subroutine shigc.
c            once initialized, wshigc can be used repeatedly by shsgc
c            or shagc as long as nlat and nlon remain unchanged.  wshigc
c            must not be altered between calls of shsgc or shagc.
c
c     lshigc the dimension of the array wshigc as it appears in the
c            program that calls shsgc or shagc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshigc must be at least
c
c                  nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
c
c     dwork  a double precision work array that does not have to be saved.
c
c     ldwork the dimension of the array dwork as it appears in the
c            program that calls shigc. ldwork must be at least
c
c               nlat*(nlat+4)
c
c     output parameter
c
c     wshigc an array which must be initialized before calling shsgc or shagc.
c            once initialized, wshigc can be used repeatedly by shsgc or shagc
c            as long as nlat and nlon remain unchanged.  wshigc must not
c            altered between calls of shsgc or shagc
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lshigc
c            = 4  error in the specification of ldwork
c            = 5  failure in gaqd to compute gaussian points
c                 (due to failure in eigenvalue routine)
c
c
c ****************************************************************
      subroutine shigc(nlat,nlon,wshigc,lshigc,dwork,ldwork,ierror)
c     this subroutine must be called before calling shsgc/shagc with
c     fixed nlat,nlon. it precomputes quantites such as the gaussian
c     points and weights, m=0,m=1 legendre polynomials, recursion
c     recursion coefficients.
      dimension wshigc(lshigc)
      double precision dwork(ldwork)
      ierror = 1
      if (nlat.lt.3) return
      ierror = 2
      if (nlon.lt.4) return
c     set triangular truncation limit for spherical harmonic basis
      l = min0((nlon+2)/2,nlat)
c     set equator or nearest point (if excluded) pointer
      late = (nlat+mod(nlat,2))/2
      l1 = l
      l2 = late
      ierror = 3
c     check permanent work space length
      if (lshigc .lt. nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15)return
      ierror = 4
c     if (lwork.lt.4*nlat*(nlat+2)+2) return
      if (ldwork .lt. nlat*(nlat+4)) return
      ierror = 0
c     set pointers
      i1 = 1
      i2 = i1+nlat
      i3 = i2+nlat*late
      i4 = i3+nlat*late
      i5 = i4+l*(l-1)/2 +(nlat-l)*(l-1)
      i6 = i5+l*(l-1)/2 +(nlat-l)*(l-1)
      i7 = i6+l*(l-1)/2 +(nlat-l)*(l-1)
c     set indices in temp work for double precision gaussian wts and pts
      idth = 1
c     idwts = idth+2*nlat
c     iw = idwts+2*nlat
      idwts = idth+nlat
      iw = idwts+nlat
      call shigc1(nlat,nlon,l,late,wshigc(i1),wshigc(i2),wshigc(i3),
     1wshigc(i4),wshigc(i5),wshigc(i6),wshigc(i7),dwork(idth),
     2dwork(idwts),dwork(iw),ierror)
      if (ierror.ne.0) ierror = 5
      return
      end
      subroutine shigc1(nlat,nlon,l,late,wts,p0n,p1n,abel,bbel,cbel,
     1                  wfft,dtheta,dwts,work,ier)
      dimension wts(nlat),p0n(nlat,late),p1n(nlat,late),abel(1),bbel(1),
     1 cbel(1),wfft(1),dtheta(nlat),dwts(nlat)
      double precision pb,dtheta,dwts,work(*)
c     compute the nlat  gaussian points and weights, the
c     m=0,1 legendre polys for gaussian points and all n,
c     and the legendre recursion coefficients
c     define index function used in storing
c     arrays for recursion coefficients (functions of (m,n))
c     the index function indx(m,n) is defined so that
c     the pairs (m,n) map to [1,2,...,indx(l-1,l-1)] with no
c     "holes" as m varies from 2 to n and n varies from 2 to l-1.
c     (m=0,1 are set from p0n,p1n for all n)
c     define for 2.le.n.le.l-1
      indx(m,n) = (n-1)*(n-2)/2+m-1
c     define index function for l.le.n.le.nlat
      imndx(m,n) = l*(l-1)/2+(n-l-1)*(l-1)+m-1
c     preset quantites for fourier transform
      call hrffti(nlon,wfft)
c     compute double precision gaussian points and weights
c     lw = 4*nlat*(nlat+1)+2
      lw = nlat*(nlat+2)
      call gaqd(nlat,dtheta,dwts,work,lw,ier)
      if (ier.ne.0) return
c     store gaussian weights single precision to save computation
c     in inner loops in analysis
      do 100 i=1,nlat
      wts(i) = dwts(i)
  100 continue
c     initialize p0n,p1n using double precision dnlfk,dnlft
      do 101 np1=1,nlat
      do 101 i=1,late
      p0n(np1,i) = 0.0
      p1n(np1,i) = 0.0
  101 continue
c     compute m=n=0 legendre polynomials for all theta(i)
      np1 = 1
      n = 0
      m = 0
      call dnlfk(m,n,work)
      do 103 i=1,late
      call dnlft(m,n,dtheta(i),work,pb)
      p0n(1,i) = pb
  103 continue
c     compute p0n,p1n for all theta(i) when n.gt.0
      do 104 np1=2,nlat
      n = np1-1
      m = 0
      call dnlfk(m,n,work)
      do 105 i=1,late
      call dnlft(m,n,dtheta(i),work,pb)
      p0n(np1,i) = pb
  105 continue
c     compute m=1 legendre polynomials for all n and theta(i)
      m = 1
      call dnlfk(m,n,work)
      do 106 i=1,late
      call dnlft(m,n,dtheta(i),work,pb)
      p1n(np1,i) = pb
  106 continue
  104 continue
c     compute and store swarztrauber recursion coefficients
c     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      do 107 n=2,nlat
      mlim = min0(n,l)
      do 107 m=2,mlim
      imn = indx(m,n)
      if (n.ge.l) imn = imndx(m,n)
      abel(imn)=sqrt(float((2*n+1)*(m+n-2)*(m+n-3))/
     1               float(((2*n-3)*(m+n-1)*(m+n))))
      bbel(imn)=sqrt(float((2*n+1)*(n-m-1)*(n-m))/
     1               float(((2*n-3)*(m+n-1)*(m+n))))
      cbel(imn)=sqrt(float((n-m+1)*(n-m+2))/
     1               float(((n+m-1)*(n+m))))
  107 continue
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file isfvpes.f
!
!     this file includes documentation and code for
!     subroutine isfvpes          i
!
! ... files which must be loaded with isfvpes.f
!
!     sphcom.f, hrfft.f, vhses.f,shaes.f
!
!
!     subroutine isfvpes(nlat,nlon,isym,nt,sf,vp,idv,jdv,as,bs,av,bv,
!    +                   mdb,ndb,wvhses,lvhses,work,lwork,ierror)
!
!     given the scalar spherical harmonic coefficients as,bs precomputed
!     by shaes for the scalar stream function sf and av,bv precomputed by
!     shaes for the scalar velocity potenital vp, subroutine isfvpes computes
!     the vector field (v,w) corresponding to sf and vp.  w is the east
!     longitudinal and v is the colatitudinal component of the vector field.
!     (v,w) is expressed in terms of sf,vp by the helmholtz relations (in
!     mathematical spherical coordinates):
!
!          v = -1/sin(theta)*d(vp)/dlambda + d(st)/dtheta
!
!          w =  1/sin(theta)*d(st)/dlambda + d(vp)/dtheta
!
!     required legendre functions are stored rather than recomputed as
!     they are in subroutine isfvpes.  v(i,j) and w(i,j) are given at
!     colatitude
!
!            theta(i) = (i-1)*pi/(nlat-1)
!
!     and east longitude
!
!            lambda(j) = (j-1)*2*pi/nlon
!
!     on the sphere (pi=4.0*atan(1.0)).
!
!
!     input parameters
!
!     nlat   the number of colatitudes on the full sphere including the
!            poles. for example, nlat = 37 for a five degree grid.
!            nlat determines the grid increment in colatitude as
!            pi/(nlat-1).  if nlat is odd the equator is located at
!            grid point i=(nlat+1)/2. if nlat is even the equator is
!            located half way between points i=nlat/2 and i=nlat/2+1.
!            nlat must be at least 3. note: on the half sphere, the
!            number of grid points in the colatitudinal direction is
!            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater than
!            3.  the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!
!     isym   a parameter which determines whether the vector field is
!            computed on the full or half sphere as follows:
!
!      = 0
!
!            the symmetries/antsymmetries described in isym=1,2 below
!            do not exist in sf,vp about the equator.  in this case v
!            and w are not necessarily symmetric or antisymmetric about
!            equator.  v and w are computed on the entire sphere.
!            i.e., in arrays sf(i,j),vp(i,j) for i=1,...,nlat and
!            j=1,...,nlon.
!
!      = 1
!
!            vp is antisymmetric and sf is symmetric about the equator.
!            in this case v is symmetric and w antisymmetric about
!            the equator and are computed for the northern hemisphere
!            only.  i.e., if nlat is odd the v(i,j),w(i,j) are computed
!            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
!            even then v(i,j),w(i,j) are computed for i=1,...,nlat/2
!            and j=1,...,nlon.
!
!      = 2
!
!            vp is symmetric and sf is antisymmetric about the equator.
!            in this case v is antisymmetric and w symmetric about
!            the equator and are computed for the northern hemisphere
!            only.  i.e., if nlat is odd the v(i,j),w(i,j) are computed
!            for i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is
!            even then v(i,j),w(i,j) are computed for i=1,...,nlat/2
!            and j=1,...,nlon.
!
!     nt     nt is the number of scalar and vector fields.  some
!            computational efficiency is obtained for multiple fields. arrays
!            can be three dimensional corresponding to an indexed multiple
!            vector field.  in this case multiple vector synthesis will
!            be performed to compute (v,w) for each field.  the
!            third index is the synthesis index which assumes the values
!            k=1,...,nt.  for a single synthesis set nt = 1.  the
!            description of the remaining parameters is simplified by
!            assuming that nt=1 or that all the arrays are two dimensional.
!
!     idv    the first dimension of the arrays v,w as it appears in
!            the program that calls isfvpes. if isym = 0 then idv
!            must be at least nlat.  if isym = 1 or 2 and nlat is
!            even then idv must be at least nlat/2. if isym = 1 or 2
!            and nlat is odd then idv must be at least (nlat+1)/2.
!
!     jdv    the second dimension of the arrays v,w as it appears in
!            the program that calls isfvpes. jdv must be at least nlon.
!
!     as,bs  two or three dimensional arrays (see input parameter nt)
!            that contain the spherical harmonic coefficients of
!            the scalar field sf as computed by subroutine shaes.
!
!     av,bv  two or three dimensional arrays (see input parameter nt)
!            that contain the spherical harmonic coefficients of
!            the scalar field vp as computed by subroutine shaes.
!
!     mdb    the first dimension of the arrays as,bs,av,bv as it
!            appears in the program that calls isfvpes. mdb must be at
!            least min0(nlat,(nlon+2)/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndb    the second dimension of the arrays as,bs,av,bv as it
!            appears in the program that calls isfvpes. ndb must be at
!            least nlat.
!
!     wvhses an array which must be initialized by subroutine vhsesi.
!            once initialized, wvhses can be used repeatedly by isfvpes
!            as long as nlon and nlat remain unchanged.  wvhses must
!            not bel altered between calls of isfvpes.
!
!
!     lvhses the dimension of the array wvhses as it appears in the
!            program that calls isfvpes. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lvhses must be at least
!
!               l1*l2*(nlat+nlat-l1+1)+nlon+15
!
!
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls isfvpes. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2                    if nlat is even or
!               l2 = (nlat+1)/2                if nlat is odd
!
!            if isym=0 then lwork must be at least
!
!                       nlat*((2*nt+1)*nlon + 4*l1*nt + 1)
!
!            if isym=1 or 2 then lwork must be at least
!
!                       (2*nt+1)*l2*nlon + nlat*(4*l1*nt + 1)
!
!
!     **************************************************************
!
!     output parameters
!
!    v,w    two or three dimensional arrays (see input parameter nt)
!           that contains the vector field corresponding to the stream
!           function sf and velocity potential vp whose coefficients,
!           as,bs (for sf) and av,bv (for vp), were precomputed by
!           subroutine shaes.  v(i,j) and w(i,j) are given at the
!           colatitude point
!
!                theta(i) = (i-1)*pi/(nlat-1)
!
!           and longitude point
!
!                lambda(j) = (j-1)*2*pi/nlon
!
!           the index ranges are defined above at the input parameter isym.
!
!
!    ierror = 0  no errors
!           = 1  error in the specification of nlat
!           = 2  error in the specification of nlon
!           = 3  error in the specification of isym
!           = 4  error in the specification of nt
!           = 5  error in the specification of idv
!           = 6  error in the specification of jdv
!           = 7  error in the specification of mdb
!           = 8  error in the specification of ndb
!           = 9  error in the specification of lvhses
!           = 10 error in the specification of lwork
! **********************************************************************
!
      SUBROUTINE ISFVPES(Nlat,Nlon,Isym,Nt,V,W,Idv,Jdv,As,Bs,Av,Bv,Mdb, &
                       & Ndb,Wvhses,Lvhses,Work,Lwork,Ierror)
      IMPLICIT NONE

      INTEGER Nlat , Nlon , Isym , Nt , Idv , Jdv , Mdb , Ndb , Lvhses ,&
            & Lwork , Ierror
      REAL V(Idv,Jdv,Nt) , W(Idv,Jdv,Nt)
      REAL As(Mdb,Ndb,Nt) , Bs(Mdb,Ndb,Nt)
      REAL Av(Mdb,Ndb,Nt) , Bv(Mdb,Ndb,Nt)
      REAL Wvhses(Lvhses) , Work(Lwork)
      INTEGER l1 , l2 , mn , is , lwk , iwk
      INTEGER ibr , ibi , icr , ici
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      l2 = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idv<Nlat) .OR. (Isym>0 .AND. Idv<l2) ) RETURN
      Ierror = 6
      IF ( Jdv<Nlon ) RETURN
      Ierror = 7
      l1 = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdb<MIN0(Nlat,(Nlon+2)/2) ) RETURN
      Ierror = 8
      IF ( Ndb<Nlat ) RETURN
      Ierror = 9
      l1 = MIN0(Nlat,(Nlon+2)/2)
      IF ( Lvhses<l1*l2*(Nlat+Nlat-l1+1)+Nlon+15 ) RETURN
      Ierror = 10
      IF ( Isym==0 ) THEN
         IF ( Lwork<Nlat*((2*Nt+1)*Nlon+4*l1*Nt+1) ) RETURN
      ELSEIF ( Lwork<(2*Nt+1)*Nlon+Nlat*(4*l1*Nt+1) ) THEN
         RETURN
      ENDIF
!
!     set first dimension for br,bi,cr,ci (as requried by vhses)
!
      mn = l1*Nlat*Nt
      Ierror = 0
!
!     set work space pointers
!
      ibr = 1
      ibi = ibr + mn
      icr = ibi + mn
      ici = icr + mn
      is = ici + mn
      iwk = is + Nlat
      lwk = Lwork - 4*mn - Nlat
      CALL ISFVPES1(Nlat,Nlon,Isym,Nt,V,W,Idv,Jdv,As,Bs,Av,Bv,Mdb,Ndb,  &
                  & Work(ibr),Work(ibi),Work(icr),Work(ici),l1,Work(is),&
                  & Wvhses,Lvhses,Work(iwk),lwk,Ierror)
    END SUBROUTINE ISFVPES
 
    SUBROUTINE ISFVPES1(Nlat,Nlon,Isym,Nt,V,W,Idv,Jdv,As,Bs,Av,Bv,Mdb,&
                        & Ndb,Br,Bi,Cr,Ci,Mab,Fnn,Wvhses,Lvhses,Wk,Lwk, &
                        & Ierror)
      IMPLICIT NONE
      INTEGER Nlat , Nlon , Isym , Nt , Idv , Jdv , Mdb , Ndb , Mab ,   &
            & Lvhses , Lwk , Ierror
      REAL V(Idv,Jdv,Nt) , W(Idv,Jdv,Nt)
      REAL As(Mdb,Ndb,Nt) , Bs(Mdb,Ndb,Nt)
      REAL Av(Mdb,Ndb,Nt) , Bv(Mdb,Ndb,Nt)
      REAL Br(Mab,Nlat,Nt) , Bi(Mab,Nlat,Nt)
      REAL Cr(Mab,Nlat,Nt) , Ci(Mab,Nlat,Nt)
      REAL Wvhses(Lvhses) , Wk(Lwk) , Fnn(Nlat)
      INTEGER n , m , mmax , k , ityp
!
!     set coefficient multiplyers
!
      DO n = 2 , Nlat
         Fnn(n) = -SQRT(FLOAT(n*(n-1)))
      ENDDO
      mmax = MIN0(Nlat,(Nlon+1)/2)
!
!     compute (v,w) coefficients from as,bs,av,bv
!
      DO k = 1 , Nt
         DO n = 1 , Nlat
            DO m = 1 , Mab
               Br(m,n,k) = 0.0
               Bi(m,n,k) = 0.0
               Cr(m,n,k) = 0.0
               Ci(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            Br(1,n,k) = -Fnn(n)*Av(1,n,k)
            Bi(1,n,k) = -Fnn(n)*Bv(1,n,k)
            Cr(1,n,k) = Fnn(n)*As(1,n,k)
            Ci(1,n,k) = Fnn(n)*Bs(1,n,k)
         ENDDO
!
!     compute m>0 coefficients using vector spherepack value for mmax
!
         DO m = 2 , mmax
            DO n = m , Nlat
               Br(m,n,k) = -Fnn(n)*Av(m,n,k)
               Bi(m,n,k) = -Fnn(n)*Bv(m,n,k)
               Cr(m,n,k) = Fnn(n)*As(m,n,k)
               Ci(m,n,k) = Fnn(n)*Bs(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     synthesize br,bi,cr,ci into (v,w)
!
      IF ( Isym==0 ) THEN
         ityp = 0
      ELSEIF ( Isym==1 ) THEN
         ityp = 3
      ELSEIF ( Isym==2 ) THEN
         ityp = 6
      ENDIF
      CALL VHSES(Nlat,Nlon,ityp,Nt,V,W,Idv,Jdv,Br,Bi,Cr,Ci,Mab,Nlat,    &
               & Wvhses,Lvhses,Wk,Lwk,Ierror)
      END SUBROUTINE ISFVPES1

      SUBROUTINE DISFVPES(Nlat,Nlon,Isym,Nt,V,W,Idv,Jdv,As,Bs,Av,Bv,Mdb, &
                       & Ndb,Wvhses,Lvhses,Work,Lwork,Ierror)
      IMPLICIT NONE
!*--ISFVPES224
      INTEGER Nlat , Nlon , Isym , Nt , Idv , Jdv , Mdb , Ndb , Lvhses ,&
            & Lwork , Ierror
      DOUBLE PRECISION V(Idv,Jdv,Nt) , W(Idv,Jdv,Nt)
      DOUBLE PRECISION As(Mdb,Ndb,Nt) , Bs(Mdb,Ndb,Nt)
      DOUBLE PRECISION Av(Mdb,Ndb,Nt) , Bv(Mdb,Ndb,Nt)
      DOUBLE PRECISION Wvhses(Lvhses) , Work(Lwork)
      INTEGER l1 , l2 , mn , is , lwk , iwk
      INTEGER ibr , ibi , icr , ici
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      l2 = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idv<Nlat) .OR. (Isym>0 .AND. Idv<l2) ) RETURN
      Ierror = 6
      IF ( Jdv<Nlon ) RETURN
      Ierror = 7
      l1 = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdb<MIN0(Nlat,(Nlon+2)/2) ) RETURN
      Ierror = 8
      IF ( Ndb<Nlat ) RETURN
      Ierror = 9
      l1 = MIN0(Nlat,(Nlon+2)/2)
      IF ( Lvhses<l1*l2*(Nlat+Nlat-l1+1)+Nlon+15 ) RETURN
      Ierror = 10
      IF ( Isym==0 ) THEN
         IF ( Lwork<Nlat*((2*Nt+1)*Nlon+4*l1*Nt+1) ) RETURN
      ELSEIF ( Lwork<(2*Nt+1)*Nlon+Nlat*(4*l1*Nt+1) ) THEN
         RETURN
      ENDIF
!
!     set first dimension for br,bi,cr,ci (as requried by vhses)
!
      mn = l1*Nlat*Nt
      Ierror = 0
!
!     set work space pointers
!
      ibr = 1
      ibi = ibr + mn
      icr = ibi + mn
      ici = icr + mn
      is = ici + mn
      iwk = is + Nlat
      lwk = Lwork - 4*mn - Nlat
      CALL DISFVPES1(Nlat,Nlon,Isym,Nt,V,W,Idv,Jdv,As,Bs,Av,Bv,Mdb,Ndb,  &
                  & Work(ibr),Work(ibi),Work(icr),Work(ici),l1,Work(is),&
                  & Wvhses,Lvhses,Work(iwk),lwk,Ierror)
      END SUBROUTINE DISFVPES
 
      SUBROUTINE DISFVPES1(Nlat,Nlon,Isym,Nt,V,W,Idv,Jdv,As,Bs,Av,Bv,Mdb,&
                        & Ndb,Br,Bi,Cr,Ci,Mab,Fnn,Wvhses,Lvhses,Wk,Lwk, &
                        & Ierror)
      IMPLICIT NONE
      INTEGER Nlat , Nlon , Isym , Nt , Idv , Jdv , Mdb , Ndb , Mab ,   &
            & Lvhses , Lwk , Ierror
      DOUBLE PRECISION V(Idv,Jdv,Nt) , W(Idv,Jdv,Nt)
      DOUBLE PRECISION As(Mdb,Ndb,Nt) , Bs(Mdb,Ndb,Nt)
      DOUBLE PRECISION Av(Mdb,Ndb,Nt) , Bv(Mdb,Ndb,Nt)
      DOUBLE PRECISION Br(Mab,Nlat,Nt) , Bi(Mab,Nlat,Nt)
      DOUBLE PRECISION Cr(Mab,Nlat,Nt) , Ci(Mab,Nlat,Nt)
      DOUBLE PRECISION Wvhses(Lvhses) , Wk(Lwk) , Fnn(Nlat)
      INTEGER n , m , mmax , k , ityp
!
!     set coefficient multiplyers
!
      DO n = 2 , Nlat
         Fnn(n) = -SQRT(FLOAT(n*(n-1)))
      ENDDO
      mmax = MIN0(Nlat,(Nlon+1)/2)
!
!     compute (v,w) coefficients from as,bs,av,bv
!
      DO k = 1 , Nt
         DO n = 1 , Nlat
            DO m = 1 , Mab
               Br(m,n,k) = 0.0
               Bi(m,n,k) = 0.0
               Cr(m,n,k) = 0.0
               Ci(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            Br(1,n,k) = -Fnn(n)*Av(1,n,k)
            Bi(1,n,k) = -Fnn(n)*Bv(1,n,k)
            Cr(1,n,k) = Fnn(n)*As(1,n,k)
            Ci(1,n,k) = Fnn(n)*Bs(1,n,k)
         ENDDO
!
!     compute m>0 coefficients using vector spherepack value for mmax
!
         DO m = 2 , mmax
            DO n = m , Nlat
               Br(m,n,k) = -Fnn(n)*Av(m,n,k)
               Bi(m,n,k) = -Fnn(n)*Bv(m,n,k)
               Cr(m,n,k) = Fnn(n)*As(m,n,k)
               Ci(m,n,k) = Fnn(n)*Bs(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     synthesize br,bi,cr,ci into (v,w)
!
      IF ( Isym==0 ) THEN
         ityp = 0
      ELSEIF ( Isym==1 ) THEN
         ityp = 3
      ELSEIF ( Isym==2 ) THEN
         ityp = 6
      ENDIF
      CALL DVHSES(Nlat,Nlon,ityp,Nt,V,W,Idv,Jdv,Br,Bi,Cr,Ci,Mab,Nlat,    &
               & Wvhses,Lvhses,Wk,Lwk,Ierror)
      END SUBROUTINE DISFVPES1

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file shags.f
c
c     this file contains code and documentation for subroutines
c     shags and shagsi
c
c ... files which must be loaded with shags.f
c
c     sphcom.f, hrfft.f, gaqd.f
c
c     subroutine shags(nlat,nlon,isym,nt,g,idg,jdg,a,b,mdab,ndab,
c    1                    wshags,lshags,work,lwork,ierror)
c
c     subroutine shags performs the spherical harmonic analysis
c     on the array g and stores the result in the arrays a and b.
c     the analysis is performed on a gaussian grid in colatitude
c     and an equally spaced grid in longitude.  the associated
c     legendre functions are stored rather than recomputed as they
c     are in subroutine shagc.  the analysis is described below
c     at output parameters a,b.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are compu
c            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid poi
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     isym   = 0  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 array g(i,j) for i=1,...,nlat and j=1,...,nlon.
c                 (see description of g below)
c
c            = 1  g is antisymmetric about the equator. the analysis
c                 is performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the analysis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the analysis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c
c            = 2  g is symmetric about the equator. the analysis is
c                 performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the analysis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the analysis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c     nt     the number of analyses.  in the program that calls shags,
c            the arrays g,a and b can be three dimensional in which
c            case multiple analyses will be performed.  the third
c            index is the analysis index which assumes the values
c            k=1,...,nt.  for a single analysis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that the arrays g,a and b
c            have only two dimensions.
c
c     g      a two or three dimensional array (see input parameter
c            nt) that contains the discrete function to be analyzed.
c            g(i,j) contains the value of the function at the gaussian
c            point theta(i) and longitude point phi(j) = (j-1)*2*pi/nlon
c            the index ranges are defined above at the input parameter
c            isym.
c
c     idg    the first dimension of the array g as it appears in the
c            program that calls shags. if isym equals zero then idg
c            must be at least nlat.  if isym is nonzero then idg must
c            be at least nlat/2 if nlat is even or at least (nlat+1)/2
c            if nlat is odd.
c
c     jdg    the second dimension of the array g as it appears in the
c            program that calls shags. jdg must be at least nlon.
c
c     mdab   the first dimension of the arrays a and b as it appears
c            in the program that calls shags. mdab must be at least
c            min0((nlon+2)/2,nlat) if nlon is even or at least
c            min0((nlon+1)/2,nlat) if nlon is odd.
c
c     ndab   the second dimension of the arrays a and b as it appears
c            in the program that calls shags. ndab must be at least nlat
c
c     wshags an array which must be initialized by subroutine shagsi.
c            once initialized, wshags can be used repeatedly by shags
c            as long as nlat and nlon remain unchanged.  wshags must
c            not be altered between calls of shags.
c
c     lshags the dimension of the array wshags as it appears in the
c            program that calls shags. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshags must be at least
c
c            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
c
c     work   a real work space which need not be saved
c
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shags. define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c
c            if isym is zero then lwork must be at least
c
c                  nlat*nlon*(nt+1)
c
c            if isym is nonzero then lwork must be at least
c
c                  l2*nlon*(nt+1)
c
c     **************************************************************
c
c     output parameters
c
c     a,b    both a,b are two or three dimensional arrays (see input
c            parameter nt) that contain the spherical harmonic
c            coefficients in the representation of g(i,j) given in the
c            discription of subroutine shags. for isym=0, a(m,n) and
c            b(m,n) are given by the equations listed below. symmetric
c            versions are used when isym is greater than zero.
c
c     definitions
c
c     1. the normalized associated legendre functions
c
c     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
c                       *sin(theta)**m/(2**n*factorial(n)) times the
c                       (n+m)th derivative of (x**2-1)**n with respect
c                       to x=cos(theta).
c
c     2. the fourier transform of g(i,j).
c
c     c(m,i)          = 2/nlon times the sum from j=1 to j=nlon of
c                       g(i,j)*cos((m-1)*(j-1)*2*pi/nlon)
c                       (the first and last terms in this sum
c                       are divided by 2)
c
c     s(m,i)          = 2/nlon times the sum from j=2 to j=nlon of
c                       g(i,j)*sin((m-1)*(j-1)*2*pi/nlon)
c
c
c     3. the gaussian points and weights on the sphere
c        (computed by subroutine gaqd).
c
c        theta(1),...,theta(nlat) (gaussian pts in radians)
c        wts(1),...,wts(nlat) (corresponding gaussian weights)
c
c
c     4. the maximum (plus one) longitudinal wave number
c
c            mmax = min0(nlat,(nlon+2)/2) if nlon is even or
c            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c
c     then for m=0,...,mmax-1 and n=m,...,nlat-1 the arrays a,b
c     are given by
c
c     a(m+1,n+1)     =  the sum from i=1 to i=nlat of
c                       c(m+1,i)*wts(i)*pbar(m,n,theta(i))
c
c     b(m+1,n+1)      = the sum from i=1 to nlat of
c                       s(m+1,i)*wts(i)*pbar(m,n,theta(i))
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of isym
c            = 4  error in the specification of nt
c            = 5  error in the specification of idg
c            = 6  error in the specification of jdg
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lshags
c            = 10 error in the specification of lwork
c
c
c ****************************************************************
c
c     subroutine shagsi(nlat,nlon,wshags,lshags,work,lwork,dwork,ldwork,
c    +                  ierror)
c
c     subroutine shagsi initializes the array wshags which can then
c     be used repeatedly by subroutines shags. it precomputes
c     and stores in wshags quantities such as gaussian weights,
c     legendre polynomial coefficients, and fft trigonometric tables.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are compu
c            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid poi
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     wshags an array which must be initialized by subroutine shagsi.
c            once initialized, wshags can be used repeatedly by shags
c            as long as nlat and nlon remain unchanged.  wshags must
c            not be altered between calls of shags.
c
c     lshags the dimension of the array wshags as it appears in the
c            program that calls shags. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshags must be at least
c
c            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
c
c     work   a real work space which need not be saved
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shagsi. lwork must be at least
c            4*nlat*(nlat+2)+2 in the routine calling shagsi
c
c     dwork   a double precision work array that does not have to be saved.
c
c     ldwork  the length of dwork in the calling routine.  ldwork must
c             be at least nlat*(nlat+4)
c
c     output parameter
c
c     wshags an array which must be initialized before calling shags or
c            once initialized, wshags can be used repeatedly by shags or
c            as long as nlat and nlon remain unchanged.  wshags must not
c            altered between calls of shasc.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lshags
c            = 4  error in the specification of lwork
c            = 5  error in the specification of ldwork
c            = 6  failure in gaqd to compute gaussian points
c                 (due to failure in eigenvalue routine)
c
c
c ****************************************************************
      subroutine shags(nlat,nlon,mode,nt,g,idg,jdg,a,b,mdab,ndab,
     1                    wshags,lshags,work,lwork,ierror)
c     subroutine shags performs the spherical harmonic analysis on
c     a gaussian grid on the array(s) in g and returns the coefficients
c     in array(s) a,b. the necessary legendre polynomials are fully
c     stored in this version.
c
      dimension g(idg,jdg,1),a(mdab,ndab,1),b(mdab,ndab,1),
     1          wshags(lshags),work(lwork)
c     check input parameters
      ierror = 1
      if (nlat.lt.3) return
      ierror = 2
      if (nlon.lt.4) return
      ierror = 3
      if (mode.lt.0 .or.mode.gt.2) return
c     set m limit for pmn
      l = min0((nlon+2)/2,nlat)
c     set gaussian point nearest equator pointer
      late = (nlat+mod(nlat,2))/2
c     set number of grid points for analysis/synthesis
      lat = nlat
      if (mode.ne.0) lat = late
      ierror = 4
      if (nt.lt.1) return
      ierror = 5
      if (idg.lt.lat) return
      ierror = 6
      if (jdg.lt.nlon) return
      ierror = 7
      if(mdab .lt. l) return
      ierror = 8
      if(ndab .lt. nlat) return
      l1 = l
      l2 = late
      ierror = 9
c     check permanent work space length
c
      lp= nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
      if(lshags.lt.lp) return
      ierror = 10
c     check temporary work space length
      if (mode.eq.0 .and. lwork.lt.nlat*nlon*(nt+1)) return
      if (mode.ne.0 .and. lwork.lt.l2*nlon*(nt+1)) return
      ierror = 0
c     set starting address for gaussian wts ,fft values,
c     and fully stored legendre polys in wshags
      iwts = 1
      ifft = nlat+2*nlat*late+3*(l*(l-1)/2+(nlat-l)*(l-1))+1
      ipmn = ifft+nlon+15
c     set pointer for internal storage of g
      iw = lat*nlon*nt+1
      call shags1(nlat,nlon,l,lat,mode,g,idg,jdg,nt,a,b,mdab,ndab,
     1wshags(iwts),wshags(ifft),wshags(ipmn),late,work,work(iw))
      return
      end

      subroutine shags1(nlat,nlon,l,lat,mode,gs,idg,jdg,nt,a,b,mdab,
     1                  ndab,wts,wfft,pmn,late,g,work)
      dimension gs(idg,jdg,nt),a(mdab,ndab,nt),
     1          b(mdab,ndab,nt),g(lat,nlon,nt)
      dimension wfft(1),pmn(late,1),wts(nlat),work(1)
c     set gs array internally in shags1
      do 100 k=1,nt
      do 100 j=1,nlon
      do 100 i=1,lat
      g(i,j,k) = gs(i,j,k)
  100 continue

c     do fourier transform
      do 101 k=1,nt
      call hrfftf(lat,nlon,g(1,1,k),lat,wfft,work)
  101 continue

c     scale result
      sfn = 2.0/float(nlon)
      do 102 k=1,nt
      do 102 j=1,nlon
      do 102 i=1,lat
      g(i,j,k) = sfn*g(i,j,k)
  102 continue

c     compute using gaussian quadrature
c     a(n,m) = s (ga(theta,m)*pnm(theta)*sin(theta)*dtheta)
c     b(n,m) = s (gb(theta,m)*pnm(theta)*sin(theta)*dtheta)
c     here ga,gb are the cos(phi),sin(phi) coefficients of
c     the fourier expansion of g(theta,phi) in phi.  as a result
c     of the above fourier transform they are stored in array
c     g as follows:
c     for each theta(i) and k= l-1
c     ga(0),ga(1),gb(1),ga(2),gb(2),...,ga(k-1),gb(k-1),ga(k)
c     correspond to
c     g(i,1),g(i,2),g(i,3),g(i,4),g(i,5),...,g(i,2l-4),g(i,2l-3),g(i,2l-2)
c     whenever 2*l-2 = nlon exactly
c     initialize coefficients to zero
      do 103 k=1,nt
      do 103 np1=1,nlat
      do 103 mp1=1,l
      a(mp1,np1,k) = 0.0
      b(mp1,np1,k) = 0.0
  103 continue
c     set mp1 limit on b(mp1) calculation
      lm1 = l
      if (nlon .eq. l+l-2) lm1 = l-1

      if (mode.eq.0) then
c     for full sphere (mode=0) and even/odd reduction:
c     overwrite g(i) with (g(i)+g(nlat-i+1))*wts(i)
c     overwrite g(nlat-i+1) with (g(i)-g(nlat-i+1))*wts(i)
      nl2 = nlat/2
      do 104 k=1,nt
      do 104 j=1,nlon
      do 105 i=1,nl2
      is = nlat-i+1
      t1 = g(i,j,k)
      t2 = g(is,j,k)
      g(i,j,k) = wts(i)*(t1+t2)
      g(is,j,k) = wts(i)*(t1-t2)
  105 continue
c     adjust equator if necessary(nlat odd)
      if (mod(nlat,2).ne.0) g(late,j,k) = wts(late)*g(late,j,k)
  104 continue
c     set m = 0 coefficients first
      mp1 = 1
      m = 0
      mml1 = m*(2*nlat-m-1)/2
      do 106 k=1,nt
      do 106 i=1,late
      is = nlat-i+1
      do 107 np1=1,nlat,2
c     n even
      a(1,np1,k) = a(1,np1,k)+g(i,1,k)*pmn(i,mml1+np1)
  107 continue
      do 108 np1=2,nlat,2
c     n odd
      a(1,np1,k) = a(1,np1,k)+g(is,1,k)*pmn(i,mml1+np1)
  108 continue
  106 continue
c     compute m.ge.1  coefficients next
      do 109 mp1=2,lm1
      m = mp1-1
      mml1 = m*(2*nlat-m-1)/2
      mp2 = mp1+1
      do 110 k=1,nt
      do 111 i=1,late
      is = nlat-i+1
c     n-m even
      do 112 np1=mp1,nlat,2
      a(mp1,np1,k) = a(mp1,np1,k)+g(i,2*m,k)*pmn(i,mml1+np1)
      b(mp1,np1,k) = b(mp1,np1,k)+g(i,2*m+1,k)*pmn(i,mml1+np1)
  112 continue
c     n-m odd
      do 113 np1=mp2,nlat,2
      a(mp1,np1,k) = a(mp1,np1,k)+g(is,2*m,k)*pmn(i,mml1+np1)
      b(mp1,np1,k) = b(mp1,np1,k)+g(is,2*m+1,k)*pmn(i,mml1+np1)
  113 continue
  111 continue
  110 continue
  109 continue
      if (nlon .eq. l+l-2) then
c     compute m=l-1, n=l-1,l,...,nlat-1 coefficients
      m = l-1
      mml1 = m*(2*nlat-m-1)/2
      do 114 k=1,nt
      do 114 i=1,late
      is = nlat-i+1
      do 124 np1=l,nlat,2
      mn = mml1+np1
      a(l,np1,k) = a(l,np1,k)+0.5*g(i,nlon,k)*pmn(i,mn)
  124 continue
c     n-m  odd
      lp1 = l+1
      do 125 np1=lp1,nlat,2
      mn = mml1+np1
      a(l,np1,k) = a(l,np1,k)+0.5*g(is,nlon,k)*pmn(i,mn)
  125 continue
  114 continue
      end if

      else

c     half sphere
c     overwrite g(i) with wts(i)*(g(i)+g(i)) for i=1,...,nlate/2
      nl2 = nlat/2
      do 116  k=1,nt
      do 116 j=1,nlon
      do 115 i=1,nl2
      g(i,j,k) = wts(i)*(g(i,j,k)+g(i,j,k))
  115 continue
c     adjust equator separately if a grid point
      if (nl2.lt.late) g(late,j,k) = wts(late)*g(late,j,k)
  116 continue

c     set m = 0 coefficients first
      mp1 = 1
      m = 0
      mml1 = m*(2*nlat-m-1)/2
      ms = 1
      if (mode.eq.1) ms = 2
      do 117 k=1,nt
      do 117 i=1,late
      do 117 np1=ms,nlat,2
      a(1,np1,k) = a(1,np1,k)+g(i,1,k)*pmn(i,mml1+np1)
  117 continue

c     compute m.ge.1  coefficients next
      do 118 mp1=2,lm1
      m = mp1-1
      mml1 = m*(2*nlat-m-1)/2
      ms = mp1
      if (mode.eq.1) ms = mp1+1
      do 119 k=1,nt
      do 119 i=1,late
      do 119 np1=ms,nlat,2
      a(mp1,np1,k) = a(mp1,np1,k)+g(i,2*m,k)*pmn(i,mml1+np1)
      b(mp1,np1,k) = b(mp1,np1,k)+g(i,2*m+1,k)*pmn(i,mml1+np1)
  119 continue
  118 continue

      if (nlon.eq.l+l-2) then
c     compute n=m=l-1 coefficients last
      m = l-1
      mml1 = m*(2*nlat-m-1)/2
c     set starting n for mode even
      ns = l
c     set starting n for mode odd
      if (mode.eq.1) ns = l+1
      do 120 k=1,nt
      do 120 i=1,late
      do 120 np1=ns,nlat,2
      mn = mml1+np1
      a(l,np1,k) = a(l,np1,k)+0.5*g(i,nlon,k)*pmn(i,mn)
  120 continue
      end if

      end if

      return
      end
      subroutine shagsi(nlat,nlon,wshags,lshags,work,lwork,dwork,ldwork,
     +                  ierror)
c
c     this subroutine must be called before calling shags or shsgs with
c     fixed nlat,nlon. it precomputes the gaussian weights, points
c     and all necessary legendre polys and stores them in wshags.
c     these quantities must be preserved when calling shags or shsgs
c     repeatedly with fixed nlat,nlon.  dwork must be of length at
c     least nlat*(nlat+4) in the routine calling shagsi.  This is
c     not checked.  undetectable errors will result if dwork is
c     smaller than nlat*(nlat+4).
c
      dimension wshags(lshags),work(lwork)
      double precision dwork(ldwork)
      ierror = 1
      if (nlat.lt.3) return
      ierror = 2
      if (nlon.lt.4) return
c     set triangular truncation limit for spherical harmonic basis
      l = min0((nlon+2)/2,nlat)
c     set equator or nearest point (if excluded) pointer
      late = (nlat+1)/2
      l1 = l
      l2 = late
c     check permanent work space length
      ierror = 3
      lp=nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
      if(lshags.lt.lp) return
      ierror = 4
c     check temporary work space
      if (lwork.lt.4*nlat*(nlat+2)+2) return
      ierror = 5
c     check double precision temporary space
      if (ldwork .lt. nlat*(nlat+4)) return
      ierror = 0
c     set preliminary quantites needed to compute and store legendre polys
      ldw = nlat*(nlat+4)
      call shagsp(nlat,nlon,wshags,lshags,dwork,ldwork,ierror)
      if (ierror.ne.0) return
c     set legendre poly pointer in wshags
      ipmnf = nlat+2*nlat*late+3*(l*(l-1)/2+(nlat-l)*(l-1))+nlon+16
      call shagss1(nlat,l,late,wshags,work,wshags(ipmnf))
      return
      end
      subroutine shagss1(nlat,l,late,w,pmn,pmnf)
      dimension w(1),pmn(nlat,late,3),pmnf(late,1)
c     compute and store legendre polys for i=1,...,late,m=0,...,l-1
c     and n=m,...,l-1
      do i=1,nlat
	do j=1,late
	  do k=1,3
	   pmn(i,j,k) = 0.0
	  end do
	end do
      end do
      do 100 mp1=1,l
      m = mp1-1
      mml1 = m*(2*nlat-m-1)/2
c     compute pmn for n=m,...,nlat-1 and i=1,...,(l+1)/2
      mode = 0
      call legin(mode,l,nlat,m,w,pmn,km)
c     store above in pmnf
      do 101 np1=mp1,nlat
      mn = mml1+np1
      do 102 i=1,late
      pmnf(i,mn) = pmn(np1,i,km)
  102 continue
  101 continue
  100 continue
      return
      end
      subroutine shagsp(nlat,nlon,wshags,lshags,dwork,ldwork,ierror)
      dimension wshags(lshags)
      double precision dwork(ldwork)
      ierror = 1
      if (nlat.lt.3) return
      ierror = 2
      if (nlon.lt.4) return
c     set triangular truncation limit for spherical harmonic basis
      l = min0((nlon+2)/2,nlat)
c     set equator or nearest point (if excluded) pointer
      late = (nlat+mod(nlat,2))/2
      l1 = l
      l2 = late
      ierror = 3
c     check permanent work space length
      if (lshags .lt. nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15)return
      ierror = 4
c     if (lwork.lt.4*nlat*(nlat+2)+2) return
      if (ldwork.lt.nlat*(nlat+4))return
      ierror = 0
c     set pointers
      i1 = 1
      i2 = i1+nlat
      i3 = i2+nlat*late
      i4 = i3+nlat*late
      i5 = i4+l*(l-1)/2 +(nlat-l)*(l-1)
      i6 = i5+l*(l-1)/2 +(nlat-l)*(l-1)
      i7 = i6+l*(l-1)/2 +(nlat-l)*(l-1)
c     set indices in temp work for double precision gaussian wts and pts
      idth = 1
c     idwts = idth+2*nlat
c     iw = idwts+2*nlat
      idwts = idth+nlat
      iw = idwts+nlat
      call shagsp1(nlat,nlon,l,late,wshags(i1),wshags(i2),wshags(i3),
     1wshags(i4),wshags(i5),wshags(i6),wshags(i7),dwork(idth),
     2dwork(idwts),dwork(iw),ierror)
      if (ierror.ne.0) ierror = 6
      return
      end

      subroutine shagsp1(nlat,nlon,l,late,wts,p0n,p1n,abel,bbel,cbel,
     +                   wfft,dtheta,dwts,work,ier)
      dimension wts(nlat),p0n(nlat,late),p1n(nlat,late),abel(1),bbel(1),
     1 cbel(1),wfft(1),dtheta(nlat),dwts(nlat)
      double precision pb,dtheta,dwts,work(*)
      indx(m,n) = (n-1)*(n-2)/2+m-1
      imndx(m,n) = l*(l-1)/2+(n-l-1)*(l-1)+m-1
      call hrffti(nlon,wfft)

c     compute double precision gaussian points and weights
c     lw = 4*nlat*(nlat+2)
      lw = nlat*(nlat+2)
      call gaqd(nlat,dtheta,dwts,work,lw,ier)
      if (ier.ne.0) return

c     store gaussian weights single precision to save computation
c     in inner loops in analysis
      do 100 i=1,nlat
      wts(i) = dwts(i)
  100 continue
c     initialize p0n,p1n using double precision dnlfk,dnlft
      do 101 np1=1,nlat
      do 101 i=1,late
      p0n(np1,i) = 0.0
      p1n(np1,i) = 0.0
  101 continue
c     compute m=n=0 legendre polynomials for all theta(i)
      np1 = 1
      n = 0
      m = 0
      call dnlfk(m,n,work)
      do 103 i=1,late
      call dnlft(m,n,dtheta(i),work,pb)
      p0n(1,i) = pb
  103 continue
c     compute p0n,p1n for all theta(i) when n.gt.0
      do 104 np1=2,nlat
      n = np1-1
      m = 0
      call dnlfk(m,n,work)
      do 105 i=1,late
      call dnlft(m,n,dtheta(i),work,pb)
      p0n(np1,i) = pb
  105 continue
c     compute m=1 legendre polynomials for all n and theta(i)
      m = 1
      call dnlfk(m,n,work)
      do 106 i=1,late
      call dnlft(m,n,dtheta(i),work,pb)
      p1n(np1,i) = pb
  106 continue
  104 continue
c
c     compute and store swarztrauber recursion coefficients
c     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      do 107 n=2,nlat
      mlim = min0(n,l)
      do 107 m=2,mlim
      imn = indx(m,n)
      if (n.ge.l) imn = imndx(m,n)
      abel(imn)=sqrt(float((2*n+1)*(m+n-2)*(m+n-3))/
     1               float(((2*n-3)*(m+n-1)*(m+n))))
      bbel(imn)=sqrt(float((2*n+1)*(n-m-1)*(n-m))/
     1               float(((2*n-3)*(m+n-1)*(m+n))))
      cbel(imn)=sqrt(float((n-m+1)*(n-m+2))/
     1               float(((n+m-1)*(n+m))))
  107 continue
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
! ... file islapgs.f
!
!     this file includes documentation and code for
!     subroutine islapgs         i
!
! ... files which must be loaded with islapec.f
!
!     sphcom.f, hrfft.f, shags.f, shsgs.f
!
!     subroutine islapgs(nlat,nlon,isym,nt,xlmbda,sf,ids,jds,a,b,
!    +mdab,ndab,wshsgs,lshsgs,work,lwork,pertrb,ierror)
!
!     islapgs inverts the laplace or helmholz operator on a Gaussian grid.
!     Given the spherical harmonic coefficients a(m,n) and b(m,n) of the
!     right hand side slap(i,j), islapgc computes a solution sf(i,j) to
!     the following helmhotz equation :
!
!           2                2
!     [d(sf(i,j))/dlambda /sint + d(sint*d(sf(i,j))/dtheta)/dtheta]/sint
!
!                   - xlmbda * sf(i,j) = slap(i,j)
!
!      where sf(i,j) is computed at the Gaussian colatitude point theta(i)
!      (see nlat as an input argument) and longitude
!
!                 lambda(j) = (j-1)*2*pi/nlon
!
!            for i=1,...,nlat and j=1,...,nlon.
!
!
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are computed
!            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid point
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct longitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than zero. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!     isym   this parameter should have the same value input to subroutine
!            shags to compute the coefficients a and b for the scalar field
!            slap.  isym is set as follows:
!
!            = 0  no symmetries exist in slap about the equator. scalar
!                 synthesis is used to compute sf on the entire sphere.
!                 i.e., in the array sf(i,j) for i=1,...,nlat and
!                 j=1,...,nlon.
!
!           = 1  sf and slap are antisymmetric about the equator. the
!                synthesis used to compute sf is performed on the
!                northern hemisphere only.  if nlat is odd, sf(i,j) is
!                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
!                nlat is even, sf(i,j) is computed for i=1,...,nlat/2
!                and j=1,...,nlon.
!
!
!           = 2  sf and slap are symmetric about the equator. the
!                synthesis used to compute sf is performed on the
!                northern hemisphere only.  if nlat is odd, sf(i,j) is
!                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
!                nlat is even, sf(i,j) is computed for i=1,...,nlat/2
!                and j=1,...,nlon.
!
!
!     nt     the number of analyses.  in the program that calls islapgs
!            the arrays sf,a, and b can be three dimensional in which
!            case multiple synthesis will be performed.  the third index
!            is the synthesis index which assumes the values k=1,...,nt.
!            k is also the index for the perturbation array pertrb.
!            for a single analysis set nt=1. the description of the
!            remaining parameters is simplified by assuming that nt=1
!            or that sf,a,b are two dimensional and pertrb is a constant.
!
!   xlmbda   a one dimensional array with nt elements. if xlmbda is
!            is identically zero islapgc solves poisson's equation.
!            if xlmbda > 0.0 islapgc solves the helmholtz equation.
!            if xlmbda < 0.0 the nonfatal error flag ierror=-1 is
!            returned. negative xlambda could result in a division
!            by zero.
!
!   ids      the first dimension of the array sf as it appears in the
!            program that calls islapgs.  if isym = 0 then ids must be at
!            least nlat.  if isym > 0 and nlat is even then ids must be
!            at least nlat/2. if isym > 0 and nlat is odd then ids must
!            be at least (nlat+1)/2.
!
!   jds      the second dimension of the array sf as it appears in the
!            program that calls islapgs. jds must be at least nlon.
!
!
!   a,b      two or three dimensional arrays (see input parameter nt)
!            that contain scalar spherical harmonic coefficients
!            of the scalar field slap as computed by subroutine shags.
!     ***    a,b must be computed by shags prior to calling islapgs.
!
!
!    mdab    the first dimension of the arrays a and b as it appears
!            in the program that calls islapgs.  mdab must be at
!            least min0(nlat,(nlon+2)/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!    ndab    the second dimension of the arrays a and b as it appears
!            in the program that calls islapgs. ndbc must be at least
!            least nlat.
!
!            mdab,ndab should have the same values input to shags to
!            compute the coefficients a and b.
!
!
!    wshsgs  an array which must be initialized by subroutine islapgsi
!            (or equivalently by shsesi).  once initialized, wshsgs
!            can be used repeatedly by islapgs as long as nlat and nlon
!            remain unchanged.  wshsgs  must not be altered between calls
!            of islapgs.
!
!    lshsgs  the dimension of the array wshsgs as it appears in the
!            program that calls islapgs.  let
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshsgs must be at least
!
!            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls islapgs. define
!
!               l2 = nlat/2                    if nlat is even or
!               l2 = (nlat+1)/2                if nlat is odd
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            if isym is zero then lwork must be at least
!
!               (nt+1)*nlat*nlon + nlat*(2*nt*l1+1)
!
!            if isym is nonzero lwork must be at least
!
!               (nt+1)*l2*nlon + nlat*(2*nt*l1+1)
!
!
!     **************************************************************
!
!     output parameters
!
!
!    sf      a two or three dimensional arrays (see input parameter nt) that
!            inverts the scalar laplacian in slap.  sf(i,j) is given at
!            the colatitude
!
!                 theta(i) = (i-1)*pi/(nlat-1)
!
!            and longitude
!
!                 lambda(j) = (j-1)*2*pi/nlon
!
!            for i=1,...,nlat and j=1,...,nlon.
!
!   pertrb  a one dimensional array with nt elements (see input
!           parameter nt). in the discription that follows we assume
!           that nt=1. if xlmbda > 0.0 then pertrb=0.0 is always
!           returned because the helmholtz operator is invertible.
!           if xlmbda = 0.0 then a solution exists only if a(1,1)
!           is zero. islapec sets a(1,1) to zero. the resulting
!           solution sf(i,j) solves poisson's equation with
!           pertrb = a(1,1)/(2.*sqrt(2.)) subtracted from the
!           right side slap(i,j).
!
!  ierror    a parameter which flags errors in input parameters as follows:
!
!            = 0  no errors detected
!
!            = 1  error in the specification of nlat
!
!            = 2  error in the specification of nlon
!
!            = 3  error in the specification of ityp
!
!            = 4  error in the specification of nt
!
!            = 5  error in the specification of ids
!
!            = 6  error in the specification of jds
!
!            = 7  error in the specification of mdbc
!
!            = 8  error in the specification of ndbc
!
!            = 9  error in the specification of lshsgs
!
!            = 10 error in the specification of lwork
!
!
! **********************************************************************
!
!     end of documentation for islapgs
!
! **********************************************************************
!
!
      SUBROUTINE ISLAPGS(Nlat,Nlon,Isym,Nt,Xlmbda,Sf,Ids,Jds,A,B,Mdab,  &
                       & Ndab,Wshsgs,Lshsgs,Work,Lwork,Pertrb,Ierror)
      IMPLICIT NONE

      REAL A , B , Pertrb , Sf , Work , Wshsgs , Xlmbda
      INTEGER ia , ib , Ids , Ierror , ifn , imid , Isym , iwk , Jds ,  &
            & k , l1 , l2 , lp , ls , Lshsgs , lwk , lwkmin , Lwork ,   &
            & Mdab , mmax
      INTEGER mn , Ndab , Nlat , nln , Nlon , Nt

      DIMENSION Sf(Ids,Jds,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wshsgs(Lshsgs) , Work(Lwork) , Xlmbda(Nt) , Pertrb(Nt)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Ids<Nlat) .OR. (Isym>0 .AND. Ids<imid) )      &
         & RETURN
      Ierror = 6
      IF ( Jds<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,Nlon/2+1)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
!
!     set and verify saved work space length
!
      imid = (Nlat+1)/2
      l2 = (Nlat+MOD(Nlat,2))/2
      l1 = MIN0((Nlon+2)/2,Nlat)
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshsgs<lp ) RETURN
      Ierror = 10
!
!     set and verify unsaved work space length
!
      ls = Nlat
      IF ( Isym>0 ) ls = imid
      nln = Nt*ls*Nlon
      mn = mmax*Nlat*Nt
!     lwkmin = nln+ls*nlon+2*mn+nlat
!     if (lwork .lt. lwkmin) return
      l2 = (Nlat+1)/2
      l1 = MIN0(Nlat,Nlon/2+1)
      IF ( Isym==0 ) THEN
         lwkmin = (Nt+1)*Nlat*Nlon + Nlat*(2*Nt*l1+1)
      ELSE
         lwkmin = (Nt+1)*l2*Nlon + Nlat*(2*Nt*l1+1)
      ENDIF
      IF ( Lwork<lwkmin ) RETURN
      Ierror = 0
!
!     check sign of xlmbda
!
      DO k = 1 , Nt
         IF ( Xlmbda(k)<0.0 ) Ierror = -1
      ENDDO
!
!     set work space pointers
!
      ia = 1
      ib = ia + mn
      ifn = ib + mn
      iwk = ifn + Nlat
      lwk = Lwork - 2*mn - Nlat
      CALL ISLPGS1(Nlat,Nlon,Isym,Nt,Xlmbda,Sf,Ids,Jds,A,B,Mdab,Ndab,   &
                 & Work(ia),Work(ib),mmax,Work(ifn),Wshsgs,Lshsgs,      &
                 & Work(iwk),lwk,Pertrb,Ierror)
    END SUBROUTINE ISLAPGS

    
    SUBROUTINE ISLPGS1(Nlat,Nlon,Isym,Nt,Xlmbda,Sf,Ids,Jds,A,B,Mdab,  &
                       & Ndab,As,Bs,Mmax,Fnn,Wsav,Lsav,Wk,Lwk,Pertrb,   &
                       & Ierror)
      IMPLICIT NONE
      REAL A , As , B , Bs , fn , Fnn , Pertrb , Sf , Wk , Wsav , Xlmbda
      INTEGER Ids , Ierror , Isym , Jds , k , Lsav , Lwk , m , Mdab ,   &
            & Mmax , n , Ndab , Nlat , Nlon , Nt
      DIMENSION Sf(Ids,Jds,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION As(Mmax,Nlat,Nt) , Bs(Mmax,Nlat,Nt) , Fnn(Nlat)
      DIMENSION Wsav(Lsav) , Wk(Lwk) , Xlmbda(Nt) , Pertrb(Nt)
!
!     set multipliers and preset synthesis coefficients to zero
!
      DO n = 1 , Nlat
         fn = FLOAT(n-1)
         Fnn(n) = fn*(fn+1.0)
         DO m = 1 , Mmax
            DO k = 1 , Nt
               As(m,n,k) = 0.0
               Bs(m,n,k) = 0.0
            ENDDO
         ENDDO
      ENDDO
 
      DO k = 1 , Nt
!
!     compute synthesis coefficients for xlmbda zero or nonzero
!
         IF ( Xlmbda(k)==0.0 ) THEN
            DO n = 2 , Nlat
               As(1,n,k) = -A(1,n,k)/Fnn(n)
               Bs(1,n,k) = -B(1,n,k)/Fnn(n)
            ENDDO
            DO m = 2 , Mmax
               DO n = m , Nlat
                  As(m,n,k) = -A(m,n,k)/Fnn(n)
                  Bs(m,n,k) = -B(m,n,k)/Fnn(n)
               ENDDO
            ENDDO
         ELSE
!
!     xlmbda nonzero so operator invertible unless
!     -n*(n-1) = xlmbda(k) < 0.0  for some n
!
            Pertrb(k) = 0.0
            DO n = 1 , Nlat
               As(1,n,k) = -A(1,n,k)/(Fnn(n)+Xlmbda(k))
               Bs(1,n,k) = -B(1,n,k)/(Fnn(n)+Xlmbda(k))
            ENDDO
            DO m = 2 , Mmax
               DO n = m , Nlat
                  As(m,n,k) = -A(m,n,k)/(Fnn(n)+Xlmbda(k))
                  Bs(m,n,k) = -B(m,n,k)/(Fnn(n)+Xlmbda(k))
               ENDDO
            ENDDO
         ENDIF
      ENDDO
!
!     synthesize as,bs into sf
!
      CALL SHSGS(Nlat,Nlon,Isym,Nt,Sf,Ids,Jds,As,Bs,Mmax,Nlat,Wsav,Lsav,&
               & Wk,Lwk,Ierror)
    END SUBROUTINE ISLPGS1


    SUBROUTINE DISLAPGS(Nlat,Nlon,Isym,Nt,Xlmbda,Sf,Ids,Jds,A,B,Mdab,  &
                       & Ndab,Wshsgs,Lshsgs,Work,Lwork,Pertrb,Ierror)
      IMPLICIT NONE

      DOUBLE PRECISION A , B , Pertrb , Sf , Work , Wshsgs , Xlmbda
      INTEGER ia , ib , Ids , Ierror , ifn , imid , Isym , iwk , Jds ,  &
            & k , l1 , l2 , lp , ls , Lshsgs , lwk , lwkmin , Lwork ,   &
            & Mdab , mmax
      INTEGER mn , Ndab , Nlat , nln , Nlon , Nt

      DIMENSION Sf(Ids,Jds,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wshsgs(Lshsgs) , Work(Lwork) , Xlmbda(Nt) , Pertrb(Nt)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Ids<Nlat) .OR. (Isym>0 .AND. Ids<imid) )      &
         & RETURN
      Ierror = 6
      IF ( Jds<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,Nlon/2+1)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
!
!     set and verify saved work space length
!
      imid = (Nlat+1)/2
      l2 = (Nlat+MOD(Nlat,2))/2
      l1 = MIN0((Nlon+2)/2,Nlat)
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshsgs<lp ) RETURN
      Ierror = 10
!
!     set and verify unsaved work space length
!
      ls = Nlat
      IF ( Isym>0 ) ls = imid
      nln = Nt*ls*Nlon
      mn = mmax*Nlat*Nt
!     lwkmin = nln+ls*nlon+2*mn+nlat
!     if (lwork .lt. lwkmin) return
      l2 = (Nlat+1)/2
      l1 = MIN0(Nlat,Nlon/2+1)
      IF ( Isym==0 ) THEN
         lwkmin = (Nt+1)*Nlat*Nlon + Nlat*(2*Nt*l1+1)
      ELSE
         lwkmin = (Nt+1)*l2*Nlon + Nlat*(2*Nt*l1+1)
      ENDIF
      IF ( Lwork<lwkmin ) RETURN
      Ierror = 0
!
!     check sign of xlmbda
!
      DO k = 1 , Nt
         IF ( Xlmbda(k)<0.0 ) Ierror = -1
      ENDDO
!
!     set work space pointers
!
      ia = 1
      ib = ia + mn
      ifn = ib + mn
      iwk = ifn + Nlat
      lwk = Lwork - 2*mn - Nlat
      CALL DISLPGS1(Nlat,Nlon,Isym,Nt,Xlmbda,Sf,Ids,Jds,A,B,Mdab,Ndab,   &
                 & Work(ia),Work(ib),mmax,Work(ifn),Wshsgs,Lshsgs,      &
                 & Work(iwk),lwk,Pertrb,Ierror)
    END SUBROUTINE DISLAPGS

    
    SUBROUTINE DISLPGS1(Nlat,Nlon,Isym,Nt,Xlmbda,Sf,Ids,Jds,A,B,Mdab,  &
                       & Ndab,As,Bs,Mmax,Fnn,Wsav,Lsav,Wk,Lwk,Pertrb,   &
                       & Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION A , As , B , Bs , fn , Fnn , Pertrb , Sf , Wk , Wsav , Xlmbda
      INTEGER Ids , Ierror , Isym , Jds , k , Lsav , Lwk , m , Mdab ,   &
            & Mmax , n , Ndab , Nlat , Nlon , Nt
      DIMENSION Sf(Ids,Jds,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION As(Mmax,Nlat,Nt) , Bs(Mmax,Nlat,Nt) , Fnn(Nlat)
      DIMENSION Wsav(Lsav) , Wk(Lwk) , Xlmbda(Nt) , Pertrb(Nt)
!
!     set multipliers and preset synthesis coefficients to zero
!
      DO n = 1 , Nlat
         fn = FLOAT(n-1)
         Fnn(n) = fn*(fn+1.0)
         DO m = 1 , Mmax
            DO k = 1 , Nt
               As(m,n,k) = 0.0
               Bs(m,n,k) = 0.0
            ENDDO
         ENDDO
      ENDDO
 
      DO k = 1 , Nt
!
!     compute synthesis coefficients for xlmbda zero or nonzero
!
         IF ( Xlmbda(k)==0.0 ) THEN
            DO n = 2 , Nlat
               As(1,n,k) = -A(1,n,k)/Fnn(n)
               Bs(1,n,k) = -B(1,n,k)/Fnn(n)
            ENDDO
            DO m = 2 , Mmax
               DO n = m , Nlat
                  As(m,n,k) = -A(m,n,k)/Fnn(n)
                  Bs(m,n,k) = -B(m,n,k)/Fnn(n)
               ENDDO
            ENDDO
         ELSE
!
!     xlmbda nonzero so operator invertible unless
!     -n*(n-1) = xlmbda(k) < 0.0  for some n
!
            Pertrb(k) = 0.0
            DO n = 1 , Nlat
               As(1,n,k) = -A(1,n,k)/(Fnn(n)+Xlmbda(k))
               Bs(1,n,k) = -B(1,n,k)/(Fnn(n)+Xlmbda(k))
            ENDDO
            DO m = 2 , Mmax
               DO n = m , Nlat
                  As(m,n,k) = -A(m,n,k)/(Fnn(n)+Xlmbda(k))
                  Bs(m,n,k) = -B(m,n,k)/(Fnn(n)+Xlmbda(k))
               ENDDO
            ENDDO
         ENDIF
      ENDDO
!
!     synthesize as,bs into sf
!
      CALL DSHSGS(Nlat,Nlon,Isym,Nt,Sf,Ids,Jds,As,Bs,Mmax,Nlat,Wsav,Lsav,&
               & Wk,Lwk,Ierror)
    END SUBROUTINE DISLPGS1

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c ... file trssph.f
c
c     contains documentation and code for subroutine trssph
c
c ... required files
c
c     sphcom.f, hrfft.f, gaqd.f, shaec.f, shsec.f, shagc.f, shsgc.f
c
c
c     subroutine trssph(intl,igrida,nlona,nlata,da,igridb,nlonb,nlatb,
c    +db,wsave,lsave,lsvmin,work,lwork,lwkmin,dwork,ldwork,ier)
c
c *** purpose
c
c     subroutine trssph transfers data given in array da on a grid on the
c     full sphere to data in array db on a grid on the full sphere.  the
c     grids on which da is given and db is generated can be specified
c     independently of each other (see description below and the arguments
c     igrida,igridb).  for transferring vector data on the sphere, use
c     subroutine trvsph.

c     notice that scalar and vector quantities are fundamentally different
c     on the sphere.  for example, vectors are discontinuous and multiple
c     valued at the poles.  scalars are continuous and single valued at the
c     poles. erroneous results would be produced if one attempted to transfer
c     vector fields between grids with subroutine trssph applied to each
c     component of the vector.
c
c
c *** underlying grid assumptions and a description
c
c     discussions with the ncar scd data support group and others indicate
c     there is no standard grid for storing observational or model generated
c     data on the sphere.  subroutine trssph was designed to handle most
c     cases likely to be encountered when moving data from one grid format
c     to another.
c
c     the grid on which da is given must be equally spaced in longitude
c     and either equally spaced or gaussian in latitude (or colatitude).
c     longitude, which can be either the first or second dimension of da,
c     subdivides [0,2pi) excluding the periodic point 2pi.  (co)latitude,
c     which can be the second or first dimension of da, has south
c     to north or north to south orientation with increasing subscript
c     value in da (see the argument igrida).
c
c     the grid on which db is generated must be equally spaced in longitude
c     and either equally spaced or gaussian in latitude (or colatitude).
c     longitude, which can be either the first or second dimension of db,
c     subdivides [0,2pi) excluding the periodic point 2pi.  (co)latitude,
c     which can be the second or first dimension of db, has south
c     to north or north to south orientation with increasing subscript
c     value in db (see the argument igridb).
c
c     let nlon be either nlona or nlonb (the number of grid points in
c     longitude.  the longitude grid subdivides [0,2pi) into nlon spaced
c     points
c
c          (j-1)*2.*pi/nlon  (j=1,...,nlon).
c
c     it is not necessary to communicate to subroutine trssph whether the
c     underlying grids are in latitude or colatitude.  it is only necessary
c     to communicate whether they run south to north or north to south with
c     increasing subscripts.  a brief discussion of latitude and colatitude
c     follows.  equally spaced latitude grids are assumed to subdivide
c     [-pi/2,pi/2] with the south pole at -pi/2 and north pole at pi/2.
c     equally spaced colatitude grids subdivide [0,pi] with the north pole
c     at 0 and south pole at pi.  equally spaced partitions on the sphere
c     include both poles.  gaussian latitude grids subdivide (-pi/2,pi/2)
c     and gaussian colatitude grids subdivide (0,pi).  gaussian grids do not
c     include the poles.  the gaussian grid points are uniquely determined by
c     the size of the partition.  they can be computed in colatitude in
c     (0,pi) (north to south) in double precision by the spherepack subroutine
c     gaqd.  let nlat be nlata or nlatb if either the da or db grid is
c     gaussian.  let
c
c        north pole                             south pole
c        ----------                             ----------
c           0.0    <  cth(1) < ... < cth(nlat)  <   pi
c
c
c     be nlat gaussian colatitude points in the interval (0,pi) and let
c
c        south pole                        north pole
c        ----------                        ----------
c           -pi/2  < th(1) < ... < th(nlat) < pi/2
c
c     be nlat gaussian latitude points in the open interval (-pi/2,pi/2).
c     these are related by
c
c          th(i) = -pi/2 + cth(i)  (i=1,...,nlat)
c
c     if the da or db grid is equally spaced in (co)latitude then
c
c          ctht(i) = (i-1)*pi/(nlat-1)
c                                               (i=1,...,nlat)
c          tht(i) = -pi/2 + (i-1)*pi/(nlat-1)
c
c     define the equally spaced (north to south) colatitude and (south to
c     north) latitude grids.
c
c
c *** method (simplified description)
c
c     for simplicity, assume da is a nlat by nlon data tabulation and da(i,j)
c     is the value at latitude theta(i) and longitude phi(j).  then
c     coefficients a(m,n) and b(m,n) can be determined so that da(i,j) is
c     approximated by the sum
c
c         l-1  n
c     (a) sum sum pbar(m,n,theta(i))*(a(m,n)*cos(m*phi(j)+b(m,n)*sin(m*phi(j))
c         n=0 m=0
c
c     here pbar(n,m,theta) are the normalized associated legendre functions
c     and l = min0(nlat,(nlon+2)/2).  the determination of a(m,n) and b(m,n)
c     is called spherical harmonic analysis. a sum of this form can then be
c     used to regenerate the data in db on the new grid with the known
c     a(m,n) and b(m,n).  this is referred to spherical harmonic synthesis.
c     analysis and synthesis subroutines from the software package spherepack,
c     are used for these purposes.
c
c     if da or db is not in mathematical spherical coordinates then array
c     transposition and/or subscript reordering is used prior to harmonic
c     analysis and after harmonic synthesis.
c
c *** advantages
c
c     the use of surface spherical harmonics to transfer spherical grid data
c     has advantages over pointwise grid interpolation schemes on the sphere.
c     it is highly accurate.  if p(x,y,z) is any polynomial of degree n or
c     less in x,y,z cartesian coordinates which is restricted to the surface
c     of the sphere, then p is exactly represented by sums of the form (a)
c     whenever n = mino(nlat,nlon/2) (i.e., transfers with spherical harmonics
c     have n(th) order accuracy.  by way of contrast, bilinear interpolation
c     schemes are exact for polynomials of degree one.  bicubic interpolation
c     is exact only for polynomials of degree three or less.  the method
c     also produces a weighted least squares fit to the data in which waves
c     are resolved uniformly on the full sphere.  high frequencies, induced
c     by closeness of grid points near the poles (due to computational
c     or observational errors) are smoothed.  finally, the method is
c     consistent with methods used to generate data in numerical spectral
c     models based on spherical harmonics.  for more discussion of these and
c     related issues,  see the article: "on the spectral approximation of
c     discrete scalar and vector functions on the sphere," siam j. numer.
c     anal., vol 16. dec 1979, pp. 934-949, by paul swarztrauber.
c
c
c *** comment
c
c     on a nlon by nlat or nlat by nlon grid (gaussian or equally spaced)
c     spherical harmonic analysis generates and synthesis utilizes
c     min0(nlat,(nlon+2)/2)) by nlat coefficients.  consequently, for
c     da and db,  if either
c
c             min0(nlatb,(nlonb+2)/2) < min0(nlata,(nlona+2)/2)
c
c     or if
c
c             nlatb < nlata
c
c     then all the coefficients generated by an analysis of da cannot be used
c     in the synthesis which generates db.  in this case "information" can be
c     lost in generating db.  more precisely, information will be lost if the
c     analysis of da yields nonzero coefficients which are outside the bounds
c     determined by the db grid.  nevertheless, transference of values with
c     spherical harmonics will yield results consistent with grid resolution
c     and is highly accurate.
c
c
c *** input arguments
c
c ... intl
c
c     an initialization argument which should be zero on an initial call to
c     trssph.  intl should be one if trssph is being recalled and
c
c          igrida,nlona,nlata,igridb,nlonb,nlatb
c
c     have not changed from the previous call.  if any of these arguments
c     have changed, intl=0 must be used to avoid undetectable errors.  calls
c     with intl=1 bypass redundant computation and save time.  it can be used
c     when transferring multiple data sets with the same underlying grids.
c
c
c ... igrida
c
c     an integer vector dimensioned two which identifies the underlying grid
c     on the full sphere for the given data array da as follows:
c
c     igrida(1)
c
c     = -1
c     if the latitude (or colatitude) grid for da is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     runs north to south
c
c     = +1
c     if the latitude (or colatitude) grid for da is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     runs south to north
c
c     = -2
c     if the latitude (or colatitude) grid for da is a gaussian partition
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs north
c     to south
c
c     = +2
c     if the latitude (or colatitude) grid for da is a gaussian partition
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs south
c     north
c
c     igrida(2)
c
c     = 0 if the underlying grid for da is a nlona by nlata
c
c     = 1 if the underlying grid for da is a nlata by nlona
c
c
c ... nlona
c
c     the number of longitude points on the uniform grid which partitions
c     [0,2pi) for the given data array da.  nlona is also the first or second
c     dimension of da (see igrida(2)) in the program which calls trssph.
c     nlona determines the grid increment in longitude as 2*pi/nlona. for
c     example nlona = 72 for a five degree grid.  nlona must be greater than
c     or equal to 4.  the efficiency of the computation is improved when
c     nlona is a product of small prime numbers
c
c ... nlata
c
c     the number of points in the latitude (or colatitude) grid
c     for the given data array da.  nlata is also the first or second
c     dimension of da (see igrida(2)) in the program which calls trssph.
c     if nlata is odd then the equator will be located at the (nlata+1)/2
c     gaussian grid point.  if nlata is even then the equator will be
c     located half way between the nlata/2 and nlata/2+1 grid points.
c
c *** note:
c     igrida(1)=-1 or igrida(1)=-2 and igrida(2)=1 corresponds to
c     the "usual" mathematical spherical coordinate system required
c     by most of the drivers in spherepack2.  igrida(1)=1 or igrida(1)=2
c     and igrida(2)=0 corresponds to the "usual" geophysical spherical
c     coordinate system.
c
c ... da
c
c     a two dimensional array that contains the data to be transferred.
c     da must be dimensioned nlona by nlata in the program calling trssph if
c     igrida(2) = 0.  da must be dimensioned nlata by nlona in the program
c     calling trssph if igrida(2) = 1.  if da is not properly dimensioned
c     and if the latitude (colatitude) values do not run south to north or
c     north to south as flagged by igrida(1) (this cannot be checked!) then
c     incorrect results will be produced.
c
c ... igridb
c
c     an integer vector dimensioned two which identifies the underlying grid
c     on the full sphere for the transformed data array db as follows:
c
c     igridb(1)
c
c     = -1
c     if the latitude (or colatitude) grid for db is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     north to south
c
c     = +1
c     if the latitude (or colatitude) grid for db is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     south to north
c
c     = -2
c     if the latitude (or colatitude) grid for db is a gaussian partition
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs north to
c     south
c
c     = +2
c     if the latitude (or colatitude) grid for db is a gaussian partition
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs south to
c     north
c
c
c     igridb(2)
c
c     = 0 if the underlying grid for db is a nlonb by nlatb
c
c     = 1 if the underlying grid for db is a nlatb by nlonb
c
c
c ... nlonb
c
c     the number of longitude points on the uniform grid which partitions
c     [0,2pi) for the transformed data array db.  nlonb is also the first or
c     second dimension of db (see igridb(2)) in the program which calls
c     trssph.  nlonb determines the grid increment in longitude as 2*pi/nlonb.
c     for example nlonb = 72 for a five degree grid.  nlonb must be greater
c     than or equal to 4.  the efficiency of the computation is improved when
c     nlonb is a product of small prime numbers
c
c ... nlatb
c
c     the number of points in the latitude (or colatitude) grid
c     for the transformed data array db.  nlatb is also the first or second
c     dimension of db (see igridb(2)) in the program which calls trssph.
c     if nlatb is odd then the equator will be located at the (nlatb+1)/2
c     gaussian grid point.  if nlatb is even then the equator will be
c     located half way between the nlatb/2 and nlatb/2+1 grid points.
c
c ... wsave
c
c     a saved work space array that can be utilized repeatedly by trssph
c     as long as the arguments nlata,nlona,nlatb,nlonb remain unchanged.
c     wsave is set by a intl=0 call to trssph.  wsave must not be altered
c     when trssph is being recalled with intl=1.
c
c ... lsave
c
c     the dimension of the work space wsave as it appears in the program
c     that calls trssph.  the minimum required value of lsave for the
c     current set of input arguments is set in the output argument lsvmin.
c     it can be determined by calling trssph with lsave=0 and printing lsvmin.
c     let
c
c          lwa =  2*nlata*la2+3*((la1-2)*(nlata+nlata-la1-1))/2+nlona+15
c
c     if the grid for da is equally spaced in (co)latitude.  let
c
c          lwa = nlata*(2*la2+3*la1-2)+3*la1*(1-la1)/2+nlona+15
c
c     if the grid for da is gaussian in (co)latitude.
c     let
c
c          lwb = nlatb*(2*lb2+3*lb1-2)+3*lb1*(1-lb1)/2+nlonb+15
c
c     if the grid for db is gaussian in (co)latitude.  let
c
c          lwb = 2*nlatb*lb2+3*((lb1-2)*(nlatb+nlatb-lb1-1))/2+nlonb+15
c
c     if the grid for db is equally spaced in (co)latitude.  then
c     the quantity
c
c          lwa + lwb
c
c     is the minimum required length of wsave.  this value is returned
c     in the output argument lsvmin even if lsave is to small (ierror=10)
c
c ... work
c
c     a real work array that does not have to be preserved
c
c ... lwork
c
c     the dimension of the array work as it appears in the program
c     calling trssph. the minimum required value of lwork for the current
c     set of input arguments is set in the output argument lwkmin.
c     it can be determined by calling trssph with lwork=0 and printing
c     lwkmin.  an estimate for lwork follows.  let nlat,nlon,l1,l2 be
c     defined by
c
c       nlat = max0(nlata,nlatb), nlon = nax0(nlona,nlonb),
c       l1 = min0(nlat,(nlon+2)/2), l2 = (nlat+1)/2
c
c     then the quantity
c
c          nlat*(4*l1+nlon+2*nlat+4)+3*((l1-2)*2*(2*nlat-l1-1))/2
c
c     will suffice as a length for the unsaved work space.
c
c  *  both of the formulas above for lsave and lwork may overestimate the
c     required minimum values.  they can be predetermined by calling trssph
c     with lsave=lwork=0 and printout of lsvmin and lwkmin.
c
c ... dwork
c
c     a double precision work array that does not have to be preserved.
c
c ... ldwork
c
c     The length of dwork in the routine calling trssph.
c     Let
c
c       nlat = max0(nlata,nlatb)
c
c     ldwork must be at least nlat*(nlat+4)
c
c *** output arguments
c
c
c ... db
c
c     a two dimensional array that contains the transformed data.  db
c     must be dimensioned nlonb by nlatb in the program calling trssph if
c     igridb(2) = 0 or 1.  db must be dimensioned nlatb by nlonb in the
c     program calling trssph if igridb(2) = 1.  if db is not properly
c     dimensioned and if the latitude (colatitude) values do not run south
c     north or north to south as flagged by igrdb(1) (this cannot be checked!)
c     then incorrect results will be produced.
c
c ... lsvmin
c
c     the minimum length of the saved work space in wsave.
c     lsvmin is computed even if lsave < lsvmin (ier = 10).
c
c ... lwkmin
c
c     the minimum length of the unsaved work space in work.
c     lwkmin is computed even if lwork < lwkmin (ier = 11).
c
c *** error argument
c
c ... ier = 0  if no errors are detected
c
c         = 1  if intl is not 0 or 1
c
c         = 2  if igrida(1) is not -1 or +1 or -2 or +2
c
c         = 3  if igrida(2) is not 0 or 1
c
c         = 4  if nlona is less than 4
c
c         = 5  if nlata is less than 3
c
c         = 6  if igridb(1) is not -1 or +1 or -2 or +2
c
c         = 7  if igridb(2) is not 0 or 1
c
c         = 8  if nlonb is less than 4
c
c         = 9  if nlatb is less than 3

c         =10  if there is insufficient saved work space (lsave < lsvmin)
c
c         =11  if there is insufficient unsaved work space (lwork < lwkmin)
c
c         =12  indicates failure in an eigenvalue routine which computes
c              gaussian weights and points
c
c         =13  if ldwork is too small (insufficient unsaved double precision
c              work space)
c
c *****************************************************
c *****************************************************
c
c     end of argument description ... code follows
c
c *****************************************************
c *****************************************************
c
      SUBROUTINE TRSSPH (INTL,IGRIDA,NLONA,NLATA,DA,IGRIDB,NLONB,NLATB,
     +DB,WSAVE,LSAVE,LSVMIN,WORK,LWORK,LWKMIN,DWORK,LDWORK,IER)
      implicit none
      integer intl,igrida(2),nlona,nlata,igridb(2),nlonb,nlatb
      integer lsave,lsvmin,lwork,lwkmin,ldwork,ier
      real da(*),db(*),wsave(*),work(*)
      double precision dwork(*)
      integer ig,igrda,igrdb,la1,la2,lb1,lb2,lwa,lwb,iaa,iab,iba,ibb
      integer lwk3,lwk4,lw,iw,jb,nt,isym,nlat
c
c     include a save statement to ensure local variables in trssph, set during
c     an intl=0 call, are preserved if trssph is recalled with intl=1
c
      save
c
c     check input arguments
c
      ier = 1
      if (intl*(intl-1).ne.0) return
      ier = 2
      ig = igrida(1)
      if ((ig-1)*(ig+1)*(ig-2)*(ig+2).ne.0) return
      ier = 3
      ig = igrida(2)
      if (ig*(ig-1).ne.0) return
      ier = 4
      if (nlona .lt. 4) return
      ier = 5
      if (nlata .lt.3) return
      ier = 6
      ig = igridb(1)
      if ((ig-1)*(ig+1)*(ig-2)*(ig+2).ne.0) return
      ier = 7
      ig = igridb(2)
      if (ig*(ig-1).ne.0) return
      ier = 8
      if (nlonb .lt.4) return
      ier = 9
      if (nlatb .lt.3) return
      ier = 0

      igrda = iabs(igrida(1))
      igrdb = iabs(igridb(1))
      if (intl.eq.0) then
      la1 = min0(nlata,(nlona+2)/2)
      la2 = (nlata+1)/2
      lb1 = min0(nlatb,(nlonb+2)/2)
      lb2 = (nlatb+1)/2
c
c     set saved work space length for analysis
c
      if (igrda .eq. 1) then
c
c     saved space for analysis on  equally spaced grid
c
      lwa =  2*nlata*la2+3*((la1-2)*(nlata+nlata-la1-1))/2+nlona+15
      else
c
c     saved space for analysis on gaussian grid
c
      lwa = nlata*(2*la2+3*la1-2)+3*la1*(1-la1)/2+nlona+15
      end if
c
c     set wsave pointer
c
      jb = 1+lwa
c
c     set pointers for spherical harmonic coefs
c
      iaa = 1
      iba = iaa+la1*nlata
      iab = iba+la1*nlata
      if (igrdb .eq. 2) then
c
c     set saved work space length for gaussian synthesis
c
      lwb = nlatb*(2*lb2+3*lb1-2)+3*lb1*(1-lb1)/2+nlonb+15
      else
c
c     set saved work space length for equally spaced synthesis
c
      lwb = 2*nlatb*lb2+3*((lb1-2)*(nlatb+nlatb-lb1-1))/2+nlonb+15
      end if
c
c     set minimum saved work space length
c
      lsvmin = lwa + lwb
c
c     set remaining harmonic pointer
c
      ibb = iab+lb1*nlatb
c
c     set pointers for remaining work
c
      iw = ibb+lb1*nlatb
c
c     set remaining work space length in lw
c
      lw = lwork - iw
      lwk3 = nlata*nlona*2
      lwk4 = nlatb*nlonb*2
c
c     set minimum unsaved work space required by trssph
c
      lwkmin = iw + max0(lwk3,lwk4)
c
c     set error flags if saved or unsaved work spaces are insufficient
c
      ier = 10
      if (lsave .lt. lsvmin) return
      ier = 11
      if (lwork .lt. lwkmin) return
      ier = 13
      nlat = max0(nlata,nlatb)
      if (ldwork .lt. nlat*(nlat+4)) return
      ier = 0
      if (igrda .eq. 1) then
c
c     initialize wsave for equally spaced analysis
c
      call shaeci(nlata,nlona,wsave,lwa,dwork,ldwork,ier)
      else
c
c     initialize wsave for gaussian analysis
c
      call shagci(nlata,nlona,wsave,lwa,dwork,ldwork,ier)
      if (ier.ne.0) then
c
c     flag failure in spherepack gaussian software
c
      ier = 12
      return
      end if
      end if

      if (igrdb .eq. 2) then
c
c     initialize wsave for gaussian synthesis
c
      call shsgci(nlatb,nlonb,wsave(jb),lwb,dwork,ldwork,ier)
      if (ier.ne.0) then
c
c     flag failure in spherepack gaussian software
c
      ier = 12
      return
      end if
      else
c
c     initialize wsave for equally spaced synthesis
c
      call shseci(nlatb,nlonb,wsave(jb),lwb,dwork,ldwork,ier)
      end if
c
c     end of initialization (intl=0) call
c
      end if
c
c     transpose and/or reorder (co)latitude if necessary for da
c     (arrays must have latitude (colatitude) as the first dimension
c     and run north to south for spherepack software)
c
      if (igrida(2) .eq. 0) call trsplat(nlona,nlata,da,work)
      if (igrida(1) .gt. 0) call convlat(nlata,nlona,da)

      nt = 1
      isym = 0
      if (igrda .eq. 2) then
c
c     do spherical harmonic analysis of "adjusted" da on gaussian grid
c
      call shagc(nlata,nlona,isym,nt,da,nlata,nlona,work(iaa),
     +work(iba),la1,nlata,wsave,lwa,work(iw),lw,ier)
      else
c
c     do spherical harmonic analysis of "adjusted" da on equally spaced grid
c
      call shaec(nlata,nlona,isym,nt,da,nlata,nlona,work(iaa),
     +work(iba),la1,nlata,wsave,lwa,work(iw),lw,ier)
      end if
c
c     transfer da grid coefficients to db grid coefficients
c     truncating to zero as necessary
c
      call trab(la1,nlata,work(iaa),work(iba),lb1,nlatb,work(iab),
     +          work(ibb))

      if (igrdb .eq. 1) then
c
c     do spherical harmonic synthesis on nlatb by nlonb equally spaced grid
c
      call shsec(nlatb,nlonb,isym,nt,db,nlatb,nlonb,work(iab),
     +work(ibb),lb1,nlatb,wsave(jb),lwb,work(iw),lw,ier)
      else
c
c     do spherical harmonic synthesis on nlatb by nlonb gaussian grid
c
      call shsgc(nlatb,nlonb,isym,nt,db,nlatb,nlonb,work(iab),
     +work(ibb),lb1,nlatb,wsave(jb),lwb,work(iw),lw,ier)
      end if
c
c     both da,db are currently latitude by longitude north to south arrays
c     restore da and set db to agree with flags in igrida and igridb
c
      if (igrida(1) .gt. 0) call convlat(nlata,nlona,da)
      if (igridb(1) .gt. 0) call convlat(nlatb,nlonb,db)
      if (igrida(2) .eq. 0) call trsplat(nlata,nlona,da,work)
      if (igridb(2) .eq. 0) call trsplat(nlatb,nlonb,db,work)
      return
      end

      subroutine trab(ma,na,aa,ba,mb,nb,ab,bb)
      implicit none
      integer ma,na,mb,nb,i,j,m,n
      real aa(ma,na),ba(ma,na),ab(mb,nb),bb(mb,nb)
c
c     set coefficients for b grid from coefficients for a grid
c
      m = min0(ma,mb)
      n = min0(na,nb)
      do j=1,n
	do i=1,m
	  ab(i,j) = aa(i,j)
	  bb(i,j) = ba(i,j)
	end do
      end do
c
c     set coefs outside triangle to zero
c
      do i=m+1,mb
	do j=1,nb
	  ab(i,j) = 0.0
	  bb(i,j) = 0.0
	end do
      end do
      do j=n+1,nb
	do i=1,mb
	  ab(i,j) = 0.0
	  bb(i,j) = 0.0
	end do
      end do
      return
      end

      subroutine trsplat(n,m,data,work)
c
c     transpose the n by m array data to a m by n array data
c     work must be at least n*m words long
c
      implicit none
      integer n,m,i,j,ij,ji
      real data(*),work(*)
      do j=1,m
	do i=1,n
	  ij = (j-1)*n+i
	  work(ij) = data(ij)
	end do
      end do
      do i=1,n
	do j=1,m
	  ji = (i-1)*m+j
	  ij = (j-1)*n+i
	  data(ji) = work(ij)
	end do
      end do
      return
      end

      subroutine convlat(nlat,nlon,data)
c
c     reverse order of latitude (colatitude) grids
c
      implicit none
      integer nlat,nlon,nlat2,i,ib,j
      real data(nlat,nlon),temp
      nlat2 = nlat/2
      do i=1,nlat2
	ib = nlat-i+1
	do j=1,nlon
	  temp = data(i,j)
	  data(i,j) = data(ib,j)
	  data(ib,j) = temp
	end do
      end do
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
!
! ... file slapec.f
!
!     this file includes documentation and code for
!     subroutine slapec          i
!
! ... files which must be loaded with slapec.f
!
!     sphcom.f, hrfft.f, shaec.f, shsec.f
!
!
!
!     subroutine slapec(nlat,nlon,isym,nt,slap,ids,jds,a,b,mdab,ndab,
!    +                  wshsec,lshsec,work,lwork,ierror)
!
!
!     given the scalar spherical harmonic coefficients a and b, precomputed
!     by subroutine shaec for a scalar field sf, subroutine slapec computes
!     the laplacian of sf in the scalar array slap.  slap(i,j) is the
!     laplacian of sf at the colatitude
!
!         theta(i) = (i-1)*pi/(nlat-1)
!
!     and east longitude
!
!         lambda(j) = (j-1)*2*pi/nlon
!
!     on the sphere.  i.e.
!
!         slap(i,j) =
!
!                  2                2
!         [1/sint*d (sf(i,j)/dlambda + d(sint*d(sf(i,j))/dtheta)/dtheta]/sint
!
!
!     where sint = sin(theta(i)).  the scalar laplacian in slap has the
!     same symmetry or absence of symmetry about the equator as the scalar
!     field sf.  the input parameters isym,nt,mdab,ndab must have the
!     same values used by shaec to compute a and b for sf. the associated
!     legendre functions are recomputed rather than stored as they are
!     in subroutine slapes.
 
!
!     input parameters
!
!     nlat   the number of colatitudes on the full sphere including the
!            poles. for example, nlat = 37 for a five degree grid.
!            nlat determines the grid increment in colatitude as
!            pi/(nlat-1).  if nlat is odd the equator is located at
!            grid point i=(nlat+1)/2. if nlat is even the equator is
!            located half way between points i=nlat/2 and i=nlat/2+1.
!            nlat must be at least 3. note: on the half sphere, the
!            number of grid points in the colatitudinal direction is
!            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct longitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than zero. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!     isym   this parameter should have the same value input to subroutine
!            shaec to compute the coefficients a and b for the scalar field
!            sf.  isym is set as follows:
!
!            = 0  no symmetries exist in sf about the equator. scalar
!                 synthesis is used to compute slap on the entire sphere.
!                 i.e., in the array slap(i,j) for i=1,...,nlat and
!                 j=1,...,nlon.
!
!           = 1  sf and slap are antisymmetric about the equator. the
!                synthesis used to compute slap is performed on the
!                northern hemisphere only.  if nlat is odd, slap(i,j) is
!                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
!                nlat is even, slap(i,j) is computed for i=1,...,nlat/2
!                and j=1,...,nlon.
!
!
!           = 2  sf and slap are symmetric about the equator. the
!                synthesis used to compute slap is performed on the
!                northern hemisphere only.  if nlat is odd, slap(i,j) is
!                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
!                nlat is even, slap(i,j) is computed for i=1,...,nlat/2
!                and j=1,...,nlon.
!
!
!     nt     the number of analyses.  in the program that calls slapec
!            the arrays slap,a, and b can be three dimensional in which
!            case multiple synthesis will be performed.  the third index
!            is the synthesis index which assumes the values k=1,...,nt.
!            for a single analysis set nt=1. the description of the
!            remaining parameters is simplified by assuming that nt=1
!            or that all the arrays are two dimensional.
!
!   ids      the first dimension of the array slap as it appears in the
!            program that calls slapec.  if isym = 0 then ids must be at
!            least nlat.  if isym > 0 and nlat is even then ids must be
!            at least nlat/2. if isym > 0 and nlat is odd then ids must
!            be at least (nlat+1)/2.
!
!   jds      the second dimension of the array slap as it appears in the
!            program that calls slapec. jds must be at least nlon.
!
!
!   a,b      two or three dimensional arrays (see input parameter nt)
!            that contain scalar spherical harmonic coefficients
!            of the scalar field sf as computed by subroutine shaec.
!     ***    a,b must be computed by shaec prior to calling slapec.
!
!
!    mdab    the first dimension of the arrays a and b as it appears
!            in the program that calls slapec.  mdab must be at
!            least min0(nlat,(nlon+2)/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!    ndab    the second dimension of the arrays a and b as it appears
!            in the program that calls slapec. ndbc must be at least
!            least nlat.
!
!            mdab,ndab should have the same values input to shaec to
!            compute the coefficients a and b.
!
!
!    wshsec  an array which must be initialized by subroutine shseci
!            before calling slapec.  once initialized, wshsec
!            can be used repeatedly by slapec as long as nlat and nlon
!            remain unchanged.  wshsec must not be altered between calls
!            of slapec.
!
!    lshsec  the dimension of the array wshsec as it appears in the
!            program that calls slapec.  let
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshsec must be greater than or equal to
!
!               2*nlat*l2+3*((l1-2)*(nlat+nlat-l1-1))/2+nlon+15
!
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls slapec. define
!
!               l2 = nlat/2                    if nlat is even or
!               l2 = (nlat+1)/2                if nlat is odd
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            if isym = 0 let
!
!               lwkmin = nlat*(2*nt*nlon+max0(6*l2,nlon)+2*nt*l1+1.
!
!            if isym > 0 let
!
!               lwkmin = l2*(2*nt*nlon+max0(6*nlat,nlon))+nlat*(2*nt*l1+1)
!
!
!     then lwork must be greater than or equal to lwkmin (see ierror=10)
!
!     **************************************************************
!
!     output parameters
!
!
!    slap    a two or three dimensional arrays (see input parameter nt) that
!            contain the scalar laplacian of the scalar field sf.  slap(i,j)
!            is the scalar laplacian at the colatitude
!
!                 theta(i) = (i-1)*pi/(nlat-1)
!
!            and longitude
!
!                 lambda(j) = (j-1)*2*pi/nlon
!
!            for i=1,...,nlat and j=1,...,nlon.
!
!
!  ierror    a parameter which flags errors in input parameters as follows:
!
!            = 0  no errors detected
!
!            = 1  error in the specification of nlat
!
!            = 2  error in the specification of nlon
!
!            = 3  error in the specification of ityp
!
!            = 4  error in the specification of nt
!
!            = 5  error in the specification of ids
!
!            = 6  error in the specification of jds
!
!            = 7  error in the specification of mdbc
!
!            = 8  error in the specification of ndbc
!
!            = 9  error in the specification of lshsec
!
!            = 10 error in the specification of lwork
!
!
! **********************************************************************
!
!     end of documentation for slapec
!
! **********************************************************************
!
!
      SUBROUTINE SLAPEC(Nlat,Nlon,Isym,Nt,Slap,Ids,Jds,A,B,Mdab,Ndab,   &
                      & Wshsec,Lshsec,Work,Lwork,Ierror)
      IMPLICIT NONE
      REAL A , B , Slap , Work , Wshsec
      INTEGER ia , ib , Ids , Ierror , ifn , imid , Isym , iwk , Jds ,  &
            & l1 , l2 , ls , Lshsec , lwk , lwkmin , lwmin , Lwork ,    &
            & Mdab , mmax , mn
      INTEGER Ndab , Nlat , nln , Nlon , Nt
      DIMENSION Slap(Ids,Jds,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wshsec(Lshsec) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Ids<Nlat) .OR. (Isym>0 .AND. Ids<imid) )      &
         & RETURN
      Ierror = 6
      IF ( Jds<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,Nlon/2+1)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
!
!     set and verify saved work space length
!
!
      l1 = MIN0(Nlat,(Nlon+2)/2)
      l2 = (Nlat+1)/2
      lwmin = 2*Nlat*l2 + 3*((l1-2)*(Nlat+Nlat-l1-1))/2 + Nlon + 15
      IF ( Lshsec<lwmin ) RETURN
      Ierror = 10
!
!     set and verify unsaved work space length
!
      ls = Nlat
      IF ( Isym>0 ) ls = imid
      nln = Nt*ls*Nlon
      mn = mmax*Nlat*Nt
!     lwmin = nln+ls*nlon+2*mn+nlat
!     if (lwork .lt. lwmin) return
      l2 = (Nlat+1)/2
      l1 = MIN0(Nlat,Nlon/2+1)
      IF ( Isym==0 ) THEN
         lwkmin = Nlat*(2*Nt*Nlon+MAX0(6*l2,Nlon)+2*Nt*l1+1)
      ELSE
         lwkmin = l2*(2*Nt*Nlon+MAX0(6*Nlat,Nlon)) + Nlat*(2*Nt*l1+1)
      ENDIF
      IF ( Lwork<lwkmin ) RETURN
 
 
      Ierror = 0
!
!     set work space pointers
!
      ia = 1
      ib = ia + mn
      ifn = ib + mn
      iwk = ifn + Nlat
      lwk = Lwork - 2*mn - Nlat
      CALL SLAPEC1(Nlat,Nlon,Isym,Nt,Slap,Ids,Jds,A,B,Mdab,Ndab,Work(ia)&
                 & ,Work(ib),mmax,Work(ifn),Wshsec,Lshsec,Work(iwk),lwk,&
                 & Ierror)
      END SUBROUTINE SLAPEC


      
      SUBROUTINE SLAPEC1(Nlat,Nlon,Isym,Nt,Slap,Ids,Jds,A,B,Mdab,Ndab,  &
                       & Alap,Blap,Mmax,Fnn,Wshsec,Lshsec,Wk,Lwk,Ierror)
      IMPLICIT NONE
      REAL A , Alap , B , Blap , fn , Fnn , Slap , Wk , Wshsec
      INTEGER Ids , Ierror , Isym , Jds , k , Lshsec , Lwk , m , Mdab , &
            & Mmax , n , Ndab , Nlat , Nlon , Nt
      DIMENSION Slap(Ids,Jds,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Alap(Mmax,Nlat,Nt) , Blap(Mmax,Nlat,Nt) , Fnn(Nlat)
      DIMENSION Wshsec(Lshsec) , Wk(Lwk)
!
!     set coefficient multiplyers
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Fnn(n) = fn*(fn+1.)
      ENDDO
!
!     compute scalar laplacian coefficients for each vector field
!
      DO k = 1 , Nt
         DO n = 1 , Nlat
            DO m = 1 , Mmax
               Alap(m,n,k) = 0.0
               Blap(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            Alap(1,n,k) = -Fnn(n)*A(1,n,k)
            Blap(1,n,k) = -Fnn(n)*B(1,n,k)
         ENDDO
!
!     compute m>0 coefficients
!
         DO m = 2 , Mmax
            DO n = m , Nlat
               Alap(m,n,k) = -Fnn(n)*A(m,n,k)
               Blap(m,n,k) = -Fnn(n)*B(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     synthesize alap,blap into slap
!
      CALL SHSEC(Nlat,Nlon,Isym,Nt,Slap,Ids,Jds,Alap,Blap,Mmax,Nlat,    &
               & Wshsec,Lshsec,Wk,Lwk,Ierror)
      END SUBROUTINE SLAPEC1


      SUBROUTINE DSLAPEC(Nlat,Nlon,Isym,Nt,Slap,Ids,Jds,A,B,Mdab,Ndab,   &
                      & Wshsec,Lshsec,Work,Lwork,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , Slap , Work , Wshsec
      INTEGER ia , ib , Ids , Ierror , ifn , imid , Isym , iwk , Jds ,  &
            & l1 , l2 , ls , Lshsec , lwk , lwkmin , lwmin , Lwork ,    &
            & Mdab , mmax , mn
      INTEGER Ndab , Nlat , nln , Nlon , Nt
      DIMENSION Slap(Ids,Jds,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wshsec(Lshsec) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Ids<Nlat) .OR. (Isym>0 .AND. Ids<imid) )      &
         & RETURN
      Ierror = 6
      IF ( Jds<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,Nlon/2+1)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
!
!     set and verify saved work space length
!
!
      l1 = MIN0(Nlat,(Nlon+2)/2)
      l2 = (Nlat+1)/2
      lwmin = 2*Nlat*l2 + 3*((l1-2)*(Nlat+Nlat-l1-1))/2 + Nlon + 15
      IF ( Lshsec<lwmin ) RETURN
      Ierror = 10
!
!     set and verify unsaved work space length
!
      ls = Nlat
      IF ( Isym>0 ) ls = imid
      nln = Nt*ls*Nlon
      mn = mmax*Nlat*Nt
!     lwmin = nln+ls*nlon+2*mn+nlat
!     if (lwork .lt. lwmin) return
      l2 = (Nlat+1)/2
      l1 = MIN0(Nlat,Nlon/2+1)
      IF ( Isym==0 ) THEN
         lwkmin = Nlat*(2*Nt*Nlon+MAX0(6*l2,Nlon)+2*Nt*l1+1)
      ELSE
         lwkmin = l2*(2*Nt*Nlon+MAX0(6*Nlat,Nlon)) + Nlat*(2*Nt*l1+1)
      ENDIF
      IF ( Lwork<lwkmin ) RETURN
 
 
      Ierror = 0
!
!     set work space pointers
!
      ia = 1
      ib = ia + mn
      ifn = ib + mn
      iwk = ifn + Nlat
      lwk = Lwork - 2*mn - Nlat
      CALL DSLAPEC1(Nlat,Nlon,Isym,Nt,Slap,Ids,Jds,A,B,Mdab,Ndab,Work(ia)&
                 & ,Work(ib),mmax,Work(ifn),Wshsec,Lshsec,Work(iwk),lwk,&
                 & Ierror)
      END SUBROUTINE DSLAPEC


      
      SUBROUTINE DSLAPEC1(Nlat,Nlon,Isym,Nt,Slap,Ids,Jds,A,B,Mdab,Ndab,  &
                       & Alap,Blap,Mmax,Fnn,Wshsec,Lshsec,Wk,Lwk,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION A , Alap , B , Blap , fn , Fnn , Slap , Wk , Wshsec
      INTEGER Ids , Ierror , Isym , Jds , k , Lshsec , Lwk , m , Mdab , &
            & Mmax , n , Ndab , Nlat , Nlon , Nt
      DIMENSION Slap(Ids,Jds,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Alap(Mmax,Nlat,Nt) , Blap(Mmax,Nlat,Nt) , Fnn(Nlat)
      DIMENSION Wshsec(Lshsec) , Wk(Lwk)
!
!     set coefficient multiplyers
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Fnn(n) = fn*(fn+1.)
      ENDDO
!
!     compute scalar laplacian coefficients for each vector field
!
      DO k = 1 , Nt
         DO n = 1 , Nlat
            DO m = 1 , Mmax
               Alap(m,n,k) = 0.0
               Blap(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            Alap(1,n,k) = -Fnn(n)*A(1,n,k)
            Blap(1,n,k) = -Fnn(n)*B(1,n,k)
         ENDDO
!
!     compute m>0 coefficients
!
         DO m = 2 , Mmax
            DO n = m , Nlat
               Alap(m,n,k) = -Fnn(n)*A(m,n,k)
               Blap(m,n,k) = -Fnn(n)*B(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     synthesize alap,blap into slap
!
      CALL DSHSEC(Nlat,Nlon,Isym,Nt,Slap,Ids,Jds,Alap,Blap,Mmax,Nlat,    &
               & Wshsec,Lshsec,Wk,Lwk,Ierror)
      END SUBROUTINE DSLAPEC1

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c     file alf.f contains subroutines alfk,lfim,lfim1,lfin,lfin1,lfpt
c     for computing normalized associated legendre polynomials
c
c subroutine alfk (n,m,cp)
c
c dimension of           real cp(n/2 + mod(n,2))
c arguments
c
c purpose                routine alfk computes single precision fourier
c                        coefficients in the trigonometric series
c                        representation of the normalized associated
c                        legendre function pbar(n,m,theta) for use by
c                        routines lfp and lfpt in calculating single
c                        precision pbar(n,m,theta).
c
c                        first define the normalized associated
c                        legendre functions
c
c                        pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)
c                        /(2*factorial(n+m)))*sin(theta)**m/(2**n*
c                        factorial(n)) times the (n+m)th derivative of
c                        (x**2-1)**n with respect to x=cos(theta)
c
c                        where theta is colatitude.
c
c                        then subroutine alfk computes the coefficients
c                        cp(k) in the following trigonometric
c                        expansion of pbar(m,n,theta).
c
c                        1) for n even and m even, pbar(m,n,theta) =
c                           .5*cp(1) plus the sum from k=1 to k=n/2
c                           of cp(k)*cos(2*k*th)
c
c                        2) for n even and m odd, pbar(m,n,theta) =
c                           the sum from k=1 to k=n/2 of
c                           cp(k)*sin(2*k*th)
c
c                        3) for n odd and m even, pbar(m,n,theta) =
c                           the sum from k=1 to k=(n+1)/2 of
c                           cp(k)*cos((2*k-1)*th)
c
c                        4) for n odd and m odd,  pbar(m,n,theta) =
c                           the sum from k=1 to k=(n+1)/2 of
c                           cp(k)*sin((2*k-1)*th)
c
c
c usage                  call alfk(n,m,cp)
c
c arguments
c
c on input               n
c                          nonnegative integer specifying the degree of
c                          pbar(n,m,theta)
c
c                        m
c                          is the order of pbar(n,m,theta). m can be
c                          any integer however cp is computed such that
c                          pbar(n,m,theta) = 0 if abs(m) is greater
c                          than n and pbar(n,m,theta) = (-1)**m*
c                          pbar(n,-m,theta) for negative m.
c
c on output              cp
c                          single precision array of length (n/2)+1
c                          which contains the fourier coefficients in
c                          the trigonometric series representation of
c                          pbar(n,m,theta)
c
c
c special conditions     none
c
c precision              single
c
c algorithm              the highest order coefficient is determined in
c                        closed form and the remainig coefficients are
c                        determined as the solution of a backward
c                        recurrence relation.
c
c accuracy               comparison between routines alfk and double
c                        precision dalfk on the cray1 indicates
c                        greater accuracy for smaller values
c                        of input parameter n.  agreement to 14
c                        places was obtained for n=10 and to 13
c                        places for n=100.
c
      subroutine alfk (n,m,cp)
      dimension       cp(n/2+1)
      parameter (sc10=1024.)
      parameter (sc20=sc10*sc10)
      parameter (sc40=sc20*sc20)
c
      cp(1) = 0.
      ma = iabs(m)
      if(ma .gt. n) return
      if(n-1) 2,3,5
    2 cp(1) = sqrt(2.)
      return
    3 if(ma .ne. 0) go to 4
      cp(1) = sqrt(1.5)
      return
    4 cp(1) = sqrt(.75)
      if(m .eq. -1) cp(1) = -cp(1)
      return
    5 if(mod(n+ma,2) .ne. 0) go to 10
      nmms2 = (n-ma)/2
      fnum = n+ma+1
      fnmh = n-ma+1
      pm1 = 1.
      go to 15
   10 nmms2 = (n-ma-1)/2
      fnum = n+ma+2
      fnmh = n-ma+2
      pm1 = -1.
 15   t1 = 1./sc20
      nex = 20
      fden = 2.
      if(nmms2 .lt. 1) go to 20
      do 18 i=1,nmms2
      t1 = fnum*t1/fden
      if(t1 .gt. sc20) then
      t1 = t1/sc40
      nex = nex+40
      end if
      fnum = fnum+2.
      fden = fden+2.
   18 continue
   20 t1 = t1/2.**(n-1-nex)
      if(mod(ma/2,2) .ne. 0) t1 = -t1
      t2 = 1. 
      if(ma .eq. 0) go to 26
      do 25 i=1,ma
      t2 = fnmh*t2/(fnmh+pm1)
      fnmh = fnmh+2.
   25 continue
   26 cp2 = t1*sqrt((n+.5)*t2)
      fnnp1 = n*(n+1)
      fnmsq = fnnp1-2.*ma*ma
      l = (n+1)/2
      if(mod(n,2) .eq. 0 .and. mod(ma,2) .eq. 0) l = l+1
      cp(l) = cp2
      if(m .ge. 0) go to 29
      if(mod(ma,2) .ne. 0) cp(l) = -cp(l)
   29 if(l .le. 1) return
      fk = n
      a1 = (fk-2.)*(fk-1.)-fnnp1
      b1 = 2.*(fk*fk-fnmsq)
      cp(l-1) = b1*cp(l)/a1
   30 l = l-1
      if(l .le. 1) return
      fk = fk-2.
      a1 = (fk-2.)*(fk-1.)-fnnp1
      b1 = -2.*(fk*fk-fnmsq)
      c1 = (fk+1.)*(fk+2.)-fnnp1
      cp(l-1) = -(b1*cp(l)+c1*cp(l+1))/a1
      go to 30
      end
c subroutine lfim (init,theta,l,n,nm,pb,id,wlfim)
c
c dimension of           theta(l),  pb(id,nm+1),  wlfim(4*l*(nm+1))
c arguments
c
c purpose                given n and l, routine lfim calculates
c                        the normalized associated legendre functions
c                        pbar(n,m,theta) for m=0,...,n and theta(i)
c                        for i=1,...,l where
c
c                        pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)
c                        /(2*factorial(n+m)))*sin(theta)**m/(2**n*
c                        factorial(n)) times the (n+m)th derivative of
c                        (x**2-1)**n with respect to x=cos(theta)
c
c usage                  call lfim (init,theta,l,n,nm,pb,id,wlfim)
c
c arguments
c on input               init
c                        = 0
c                            initialization only - using parameters
c                            l, nm and array theta, subroutine lfim
c                            initializes array wlfim for subsequent
c                            use in the computation of the associated
c                            legendre functions pb. initialization
c                            does not have to be repeated unless
c                            l, nm, or array theta are changed.
c                        = 1
c                            subroutine lfim uses the array wlfim that
c                            was computed with init = 0 to compute pb.
c
c                        theta
c                          an array that contains the colatitudes
c                          at which the associated legendre functions
c                          will be computed. the colatitudes must be
c                          specified in radians.
c
c                        l
c                          the length of the theta array. lfim is
c                          vectorized with vector length l.
c
c                        n
c                          nonnegative integer, less than nm, specifying
c                          degree of pbar(n,m,theta). subroutine lfim
c                          must be called starting with n=0. n must be
c                          incremented by one in subsequent calls and
c                          must not exceed nm.
c
c                        nm
c                          the maximum value of n and m
c
c                        id
c                          the first dimension of the two dimensional
c                          array pb as it appears in the program that
c                          calls lfim. (see output parameter pb)
c
c                        wlfim
c                          an array with length 4*l*(nm+1) which
c                          must be initialized by calling lfim
c                          with init=0 (see parameter init)  it
c                          must not be altered between calls to
c                          lfim.
c
c
c on output              pb
c                          a two dimensional array with first
c                          dimension id in the program that calls
c                          lfim. the second dimension of pb must
c                          be at least nm+1. starting with n=0
c                          lfim is called repeatedly with n being
c                          increased by one between calls. on each
c                          call, subroutine lfim computes
c                          = pbar(m,n,theta(i)) for m=0,...,n and
c                          i=1,...l.
c
c                        wlfim
c                          array containing values which must not
c                          be altered unless l, nm or the array theta
c                          are changed in which case lfim must be
c                          called with init=0 to reinitialize the
c                          wlfim array.
c
c special conditions     n must be increased by one between calls
c                        of lfim in which n is not zero.
c
c precision              single
c
c
c algorithm              routine lfim calculates pbar(n,m,theta) using
c                        a four term recurrence relation. (unpublished
c                        notes by paul n. swarztrauber)
c
      subroutine lfim (init,theta,l,n,nm,pb,id,wlfim)
      dimension       pb(1)        ,wlfim(1)
c
c     total length of wlfim is 4*l*(nm+1)
c
      lnx = l*(nm+1)
      iw1 = lnx+1
      iw2 = iw1+lnx
      iw3 = iw2+lnx
      call lfim1(init,theta,l,n,nm,id,pb,wlfim,wlfim(iw1),
     1                wlfim(iw2),wlfim(iw3),wlfim(iw2))
      return
      end
      subroutine lfim1(init,theta,l,n,nm,id,p3,phz,ph1,p1,p2,cp)
      dimension       p1(l,1)    ,p2(l,1)    ,p3(id,1)   ,phz(l,1)   ,
     1                ph1(l,1)   ,cp(1)      ,theta(1)
      nmp1 = nm+1
      if(init .ne. 0) go to 5
      ssqrt2 = 1./sqrt(2.)
      do 10 i=1,l
      phz(i,1) = ssqrt2
   10 continue
      do 15 np1=2,nmp1
      nh = np1-1
      call alfk(nh,0,cp)
      do 16 i=1,l
      call lfpt(nh,0,theta(i),cp,phz(i,np1))
   16 continue
      call alfk(nh,1,cp)
      do 17 i=1,l
      call lfpt(nh,1,theta(i),cp,ph1(i,np1))
   17 continue
   15 continue
      return
    5 if(n .gt. 2) go to 60
      if(n-1)25,30,35
   25 do 45 i=1,l
      p3(i,1)=phz(i,1)
   45 continue
      return
   30 do 50 i=1,l
      p3(i,1) = phz(i,2)
      p3(i,2) = ph1(i,2)
   50 continue
      return
   35 sq5s6 = sqrt(5./6.)
      sq1s6 = sqrt(1./6.)
      do 55 i=1,l
      p3(i,1) = phz(i,3)
      p3(i,2) = ph1(i,3)
      p3(i,3) = sq5s6*phz(i,1)-sq1s6*p3(i,1)
      p1(i,1) = phz(i,2)
      p1(i,2) = ph1(i,2)
      p2(i,1) = phz(i,3)
      p2(i,2) = ph1(i,3)
      p2(i,3) = p3(i,3)
   55 continue
      return
   60 nm1 = n-1
      np1 = n+1
      fn = float(n)
      tn = fn+fn
      cn = (tn+1.)/(tn-3.)
      do 65 i=1,l
      p3(i,1) = phz(i,np1)
      p3(i,2) = ph1(i,np1)
   65 continue
      if(nm1 .lt. 3) go to 71
      do 70 mp1=3,nm1
      m = mp1-1
      fm = float(m)
      fnpm = fn+fm
      fnmm = fn-fm
      temp = fnpm*(fnpm-1.)
      cc = sqrt(cn*(fnpm-3.)*(fnpm-2.)/temp)
      dd = sqrt(cn*fnmm*(fnmm-1.)/temp)
      ee = sqrt((fnmm+1.)*(fnmm+2.)/temp)
      do 70 i=1,l
      p3(i,mp1) = cc*p1(i,mp1-2)+dd*p1(i,mp1)-ee*p3(i,mp1-2)
   70 continue
   71 fnpm = fn+fn-1.
      temp = fnpm*(fnpm-1.)
      cc = sqrt(cn*(fnpm-3.)*(fnpm-2.)/temp)
      ee = sqrt(6./temp)
      do 75 i=1,l
      p3(i,n) = cc*p1(i,n-2)-ee*p3(i,n-2)
   75 continue
      fnpm = fn+fn
      temp = fnpm*(fnpm-1.)
      cc = sqrt(cn*(fnpm-3.)*(fnpm-2.)/temp)
      ee = sqrt(2./temp)
      do 80 i=1,l
      p3(i,n+1) = cc*p1(i,n-1)-ee*p3(i,n-1)
   80 continue
      do 90 mp1=1,np1
      do 90 i=1,l
      p1(i,mp1) = p2(i,mp1)
      p2(i,mp1) = p3(i,mp1)
   90 continue
      return
      end
c subroutine lfin (init,theta,l,m,nm,pb,id,wlfin)
c
c dimension of           theta(l),  pb(id,nm+1),  wlfin(4*l*(nm+1))
c arguments
c
c purpose                given m and l, routine lfin calculates
c                        the normalized associated legendre functions
c                        pbar(n,m,theta) for n=m,...,nm and theta(i)
c                        for i=1,...,l where
c
c                        pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)
c                        /(2*factorial(n+m)))*sin(theta)**m/(2**n*
c                        factorial(n)) times the (n+m)th derivative of
c                        (x**2-1)**n with respect to x=cos(theta)
c
c usage                  call lfin (init,theta,l,m,nm,pb,id,wlfin)
c
c arguments
c on input               init
c                        = 0
c                            initialization only - using parameters
c                            l, nm and the array theta, subroutine lfin
c                            initializes the array wlfin for subsequent
c                            use in the computation of the associated
c                            legendre functions pb. initialization does
c                            not have to be repeated unless l, nm or
c                            the array theta are changed.
c                        = 1
c                            subroutine lfin uses the array wlfin that
c                            was computed with init = 0 to compute pb
c
c                        theta
c                          an array that contains the colatitudes
c                          at which the associated legendre functions
c                          will be computed. the colatitudes must be
c                          specified in radians.
c
c                        l
c                          the length of the theta array. lfin is
c                          vectorized with vector length l.
c
c                        m
c                          nonnegative integer, less than nm, specifying
c                          degree of pbar(n,m,theta). subroutine lfin
c                          must be called starting with n=0. n must be
c                          incremented by one in subsequent calls and
c                          must not exceed nm.
c
c                        nm
c                          the maximum value of n and m
c
c                        id
c                          the first dimension of the two dimensional
c                          array pb as it appears in the program that
c                          calls lfin. (see output parameter pb)
c
c                        wlfin
c                          an array with length 4*l*(nm+1) which
c                          must be initialized by calling lfin
c                          with init=0 (see parameter init)  it
c                          must not be altered between calls to
c                          lfin.
c
c
c on output              pb
c                          a two dimensional array with first
c                          dimension id in the program that calls
c                          lfin. the second dimension of pb must
c                          be at least nm+1. starting with m=0
c                          lfin is called repeatedly with m being
c                          increased by one between calls. on each
c                          call, subroutine lfin computes pb(i,n+1)
c                          = pbar(m,n,theta(i)) for n=m,...,nm and
c                          i=1,...l.
c
c                        wlfin
c                          array containing values which must not
c                          be altered unless l, nm or the array theta
c                          are changed in which case lfin must be
c                          called with init=0 to reinitialize the
c                          wlfin array.
c
c special conditions     m must be increased by one between calls
c                        of lfin in which m is not zero.
c
c precision              single
c
c algorithm              routine lfin calculates pbar(n,m,theta) using
c                        a four term recurrence relation. (unpublished
c                        notes by paul n. swarztrauber)
c
      subroutine lfin (init,theta,l,m,nm,pb,id,wlfin)
      dimension       pb(1)        ,wlfin(1)
c
c     total length of wlfin is 4*l*(nm+1)
c
      lnx = l*(nm+1)
      iw1 = lnx+1
      iw2 = iw1+lnx
      iw3 = iw2+lnx
      call lfin1(init,theta,l,m,nm,id,pb,wlfin,wlfin(iw1),
     1                wlfin(iw2),wlfin(iw3),wlfin(iw2))
      return
      end
      subroutine lfin1(init,theta,l,m,nm,id,p3,phz,ph1,p1,p2,cp)
      dimension       p1(l,1)    ,p2(l,1)    ,p3(id,1)   ,phz(l,1)   ,
     1                ph1(l,1)   ,cp(1)      ,theta(1)
      nmp1 = nm+1
      if(init .ne. 0) go to 5
      ssqrt2 = 1./sqrt(2.)
      do 10 i=1,l
      phz(i,1) = ssqrt2
   10 continue
      do 15 np1=2,nmp1
      nh = np1-1
      call alfk(nh,0,cp)
      do 16 i=1,l
      call lfpt(nh,0,theta(i),cp,phz(i,np1))
   16 continue
      call alfk(nh,1,cp)
      do 17 i=1,l
      call lfpt(nh,1,theta(i),cp,ph1(i,np1))
   17 continue
   15 continue
      return
    5 mp1 = m+1
      fm = float(m)
      tm = fm+fm
      if(m-1)25,30,35
   25 do 45 np1=1,nmp1
      do 45 i=1,l
      p3(i,np1) = phz(i,np1)
      p1(i,np1) = phz(i,np1)
   45 continue
      return
   30 do 50 np1=2,nmp1
      do 50 i=1,l
      p3(i,np1) = ph1(i,np1)
      p2(i,np1) = ph1(i,np1)
   50 continue
      return
   35 temp = tm*(tm-1.)
      cc = sqrt((tm+1.)*(tm-2.)/temp)
      ee = sqrt(2./temp)
      do 85 i=1,l
      p3(i,m+1) = cc*p1(i,m-1)-ee*p1(i,m+1)
   85 continue
      if(m .eq. nm) return
      temp = tm*(tm+1.)
      cc = sqrt((tm+3.)*(tm-2.)/temp)
      ee = sqrt(6./temp)
      do 70 i=1,l
      p3(i,m+2) = cc*p1(i,m)-ee*p1(i,m+2)
   70 continue
      mp3 = m+3
      if(nmp1 .lt. mp3) go to 80
      do 75 np1=mp3,nmp1
      n = np1-1
      fn = float(n)
      tn = fn+fn
      cn = (tn+1.)/(tn-3.)
      fnpm = fn+fm
      fnmm = fn-fm
      temp = fnpm*(fnpm-1.)
      cc = sqrt(cn*(fnpm-3.)*(fnpm-2.)/temp)
      dd = sqrt(cn*fnmm*(fnmm-1.)/temp)
      ee = sqrt((fnmm+1.)*(fnmm+2.)/temp)
      do 75 i=1,l
      p3(i,np1) = cc*p1(i,np1-2)+dd*p3(i,np1-2)-ee*p1(i,np1)
   75 continue
   80 do 90 np1=m,nmp1
      do 90 i=1,l
      p1(i,np1) = p2(i,np1)
      p2(i,np1) = p3(i,np1)
   90 continue
      return
      end
c subroutine lfpt (n,m,theta,cp,pb)
c
c dimension of
c arguments
c                        cp((n/2)+1)
c
c purpose                routine lfpt uses coefficients computed by
c                        routine alfk to compute the single precision
c                        normalized associated legendre function pbar(n,
c                        m,theta) at colatitude theta.
c
c usage                  call lfpt(n,m,theta,cp,pb)
c
c arguments
c
c on input               n
c                          nonnegative integer specifying the degree of
c                          pbar(n,m,theta)
c                        m
c                          is the order of pbar(n,m,theta). m can be
c                          any integer however pbar(n,m,theta) = 0
c                          if abs(m) is greater than n and
c                          pbar(n,m,theta) = (-1)**m*pbar(n,-m,theta)
c                          for negative m.
c
c                        theta
c                          single precision colatitude in radians
c
c                        cp
c                          single precision array of length (n/2)+1
c                          containing coefficients computed by routine
c                          alfk
c
c on output              pb
c                          single precision variable containing
c                          pbar(n,m,theta)
c
c special conditions     calls to routine lfpt must be preceded by an
c                        appropriate call to routine alfk.
c
c precision              single
c
c algorithm              the trigonometric series formula used by
c                        routine lfpt to calculate pbar(n,m,th) at
c                        colatitude th depends on m and n as follows:
c
c                           1) for n even and m even, the formula is
c                              .5*cp(1) plus the sum from k=1 to k=n/2
c                              of cp(k)*cos(2*k*th)
c                           2) for n even and m odd. the formula is
c                              the sum from k=1 to k=n/2 of
c                              cp(k)*sin(2*k*th)
c                           3) for n odd and m even, the formula is
c                              the sum from k=1 to k=(n+1)/2 of
c                              cp(k)*cos((2*k-1)*th)
c                           4) for n odd and m odd, the formula is
c                              the sum from k=1 to k=(n+1)/2 of
c                              cp(k)*sin((2*k-1)*th)
c
c accuracy               comparison between routines lfpt and double
c                        precision dlfpt on the cray1 indicates greater
c                        accuracy for greater values on input parameter
c                        n.  agreement to 13 places was obtained for
c                        n=10 and to 12 places for n=100.
c
c timing                 time per call to routine lfpt is dependent on
c                        the input parameter n.
c
      subroutine lfpt (n,m,theta,cp,pb)
      dimension       cp(1)
c
      pb = 0.
      ma = iabs(m)
      if(ma .gt. n) return
      if (n)  10, 10, 30
   10 if (ma)  20, 20, 30
   20 pb= sqrt(.5)
      go to 140
   30 np1 = n+1
      nmod = mod(n,2)
      mmod = mod(ma,2)
      if (nmod)  40, 40, 90
   40 if (mmod)  50, 50, 70
   50 kdo = n/2+1
      cdt = cos(theta+theta)
      sdt = sin(theta+theta)
      ct = 1.
      st = 0.
      sum = .5*cp(1)
      do  60 kp1=2,kdo
         cth = cdt*ct-sdt*st
         st = sdt*ct+cdt*st
         ct = cth
         sum = sum+cp(kp1)*ct
   60 continue
      pb= sum
      go to 140
   70 kdo = n/2
      cdt = cos(theta+theta)
      sdt = sin(theta+theta)
      ct = 1.
      st = 0.
      sum = 0.
      do  80 k=1,kdo
         cth = cdt*ct-sdt*st
         st = sdt*ct+cdt*st
         ct = cth
         sum = sum+cp(k)*st
   80 continue
      pb= sum
      go to 140
   90 kdo = (n+1)/2
      if (mmod) 100,100,120
  100 cdt = cos(theta+theta)
      sdt = sin(theta+theta)
      ct = cos(theta)
      st = -sin(theta)
      sum = 0.
      do 110 k=1,kdo
         cth = cdt*ct-sdt*st
         st = sdt*ct+cdt*st
         ct = cth
         sum = sum+cp(k)*ct
  110 continue
      pb= sum
      go to 140
  120 cdt = cos(theta+theta)
      sdt = sin(theta+theta)
      ct = cos(theta)
      st = -sin(theta)
      sum = 0.
      do 130 k=1,kdo
         cth = cdt*ct-sdt*st
         st = sdt*ct+cdt*st
         ct = cth
         sum = sum+cp(k)*st
  130 continue
      pb= sum
  140 return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file vtsgc.f
!
!     this file includes documentation and code for
!     subroutines vtsgc and vtsgci
!
! ... files which must be loaded with vtsgc.f
!
!     sphcom.f, hrfft.f, vhagc.f, vhsgc.f,gaqd.f
!
!
!     subroutine vtsgc(nlat,nlon,ityp,nt,vt,wt,idvw,jdvw,br,bi,cr,ci,
!    +                 mdab,ndab,wvts,lwvts,work,lwork,ierror)
!
!     given the vector harmonic analysis br,bi,cr, and ci (computed
!     by subroutine vhagc) of some vector function (v,w), this
!     subroutine computes the vector function (vt,wt) which is
!     the derivative of (v,w) with respect to colatitude theta. vtsgc
!     is similar to vhsgc except the vector harmonics are replaced by
!     their derivative with respect to colatitude with the result that
!     (vt,wt) is computed instead of (v,w). vt(i,j) is the derivative
!     of the colatitudinal component v(i,j) at the gaussian colatitude
!     theta(i) and longitude phi(j) = (j-1)*2*pi/nlon. the spectral
!     representation of (vt,wt) is given below at the definition of
!     output parameters vt,wt.
!
!     input parameters
!
!     nlat   the number of gaussian colatitudinal grid points theta(i)
!            such that 0 < theta(1) <...< theta(nlat) < pi. they are
!            computed by subroutine gaqd which is called by this
!            subroutine. if nlat is odd the equator is
!            theta((nlat+1)/2). if nlat is even the equator lies
!            half way between theta(nlat/2) and theta(nlat/2+1). nlat
!            must be at least 3. note: if (v,w) is symmetric about
!            the equator (see parameter ityp below) the number of
!            colatitudinal grid points is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than zero. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!     ityp   = 0  no symmetries exist about the equator. the synthesis
!                 is performed on the entire sphere. i.e. the arrays
!                 vt(i,j),wt(i,j) are computed for i=1,...,nlat and
!                 j=1,...,nlon.
!
!            = 1  no symmetries exist about the equator however the
!                 the coefficients cr and ci are zero which implies
!                 that the curl of (v,w) is zero. that is,
!                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
!                 the calculations are performed on the entire sphere.
!                 i.e. the arrays vt(i,j),wt(i,j) are computed for
!                 i=1,...,nlat and j=1,...,nlon.
!
!            = 2  no symmetries exist about the equator however the
!                 the coefficients br and bi are zero which implies
!                 that the divergence of (v,w) is zero. that is,
!                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
!                 the calculations are performed on the entire sphere.
!                 i.e. the arrays vt(i,j),wt(i,j) are computed for
!                 i=1,...,nlat and j=1,...,nlon.
!
!            = 3  vt is odd and wt is even about the equator. the
!                 synthesis is performed on the northern hemisphere
!                 only.  i.e., if nlat is odd the arrays vt(i,j)
!                 and wt(i,j) are computed for i=1,...,(nlat+1)/2
!                 and j=1,...,nlon. if nlat is even the arrays
!                 are computed for i=1,...,nlat/2 and j=1,...,nlon.
!
!            = 4  vt is odd and wt is even about the equator and the
!                 coefficients cr and ci are zero. the synthesis is
!                 performed on the northern hemisphere only. i.e. if
!                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
!                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the arrays vt(i,j),wt(i,j) are computed for
!                 i=1,...,nlat/2 and j=1,...,nlon.
!
!            = 5  vt is odd and wt is even about the equator and the
!                 coefficients br and bi are zero. the synthesis is
!                 performed on the northern hemisphere only. i.e. if
!                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
!                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the arrays vt(i,j),wt(i,j) are computed for
!                 i=1,...,nlat/2 and j=1,...,nlon.
!
!            = 6  vt is even and wt is odd about the equator. the
!                 synthesis is performed on the northern hemisphere
!                 only.  i.e., if nlat is odd the arrays vt(i,j),wt(i,j)
!                 are computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.
!                 if nlat is even the arrays vt(i,j),wt(i,j) are computed
!                 for i=1,...,nlat/2 and j=1,...,nlon.
!
!            = 7  vt is even and wt is odd about the equator and the
!                 coefficients cr and ci are zero. the synthesis is
!                 performed on the northern hemisphere only. i.e. if
!                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
!                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the arrays vt(i,j),wt(i,j) are computed for
!                 i=1,...,nlat/2 and j=1,...,nlon.
!
!            = 8  vt is even and wt is odd about the equator and the
!                 coefficients br and bi are zero. the synthesis is
!                 performed on the northern hemisphere only. i.e. if
!                 nlat is odd the arrays vt(i,j),wt(i,j) are computed
!                 for i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the arrays vt(i,j),wt(i,j) are computed for
!                 i=1,...,nlat/2 and j=1,...,nlon.
!
!     nt     the number of syntheses.  in the program that calls vtsgc,
!            the arrays vt,wt,br,bi,cr, and ci can be three dimensional
!            in which case multiple syntheses will be performed.
!            the third index is the synthesis index which assumes the
!            values k=1,...,nt.  for a single synthesis set nt=1. the
!            discription of the remaining parameters is simplified
!            by assuming that nt=1 or that all the arrays are two
!            dimensional.
!
!     idvw   the first dimension of the arrays vt,wt as it appears in
!            the program that calls vtsgc. if ityp .le. 2 then idvw
!            must be at least nlat.  if ityp .gt. 2 and nlat is
!            even then idvw must be at least nlat/2. if ityp .gt. 2
!            and nlat is odd then idvw must be at least (nlat+1)/2.
!
!     jdvw   the second dimension of the arrays vt,wt as it appears in
!            the program that calls vtsgc. jdvw must be at least nlon.
!
!     br,bi  two or three dimensional arrays (see input parameter nt)
!     cr,ci  that contain the vector spherical harmonic coefficients
!            of (v,w) as computed by subroutine vhagc.
!
!     mdab   the first dimension of the arrays br,bi,cr, and ci as it
!            appears in the program that calls vtsgc. mdab must be at
!            least min0(nlat,nlon/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndab   the second dimension of the arrays br,bi,cr, and ci as it
!            appears in the program that calls vtsgc. ndab must be at
!            least nlat.
!
!     wvts   an array which must be initialized by subroutine vtsgci.
!            once initialized, wvts can be used repeatedly by vtsgc
!            as long as nlon and nlat remain unchanged.  wvts must
!            not be altered between calls of vtsgc.
!
!     lwvts  the dimension of the array wvts as it appears in the
!            program that calls vtsgc. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lwvts must be at least
!
!            4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
!
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls vtsgc. define
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            if ityp .le. 2 then lwork must be at least
!
!                    nlat*(2*nt*nlon+max0(6*l2,nlon))
!
!            if ityp .gt. 2 then lwork must be at least
!
!                    l2*(2*nt*nlon+max0(6*nlat,nlon))
!
!     **************************************************************
!
!     output parameters
!
!     vt,wt  two or three dimensional arrays (see input parameter nt)
!            in which the derivative of (v,w) with respect to
!            colatitude theta is stored. vt(i,j),wt(i,j) contain the
!            derivatives at gaussian colatitude points theta(i)
!            and longitude phi(j) = (j-1)*2*pi/nlon. the index ranges
!            are defined above at the input parameter ityp. vt and wt
!            are computed from the formulas for v and w given in
!            subroutine vhsgc but with vbar and wbar replaced with
!            their derivatives with respect to colatitude. these
!            derivatives are denoted by vtbar and wtbar.
!
!   in terms of real variables this expansion takes the form
!
!             for i=1,...,nlat and  j=1,...,nlon
!
!     vt(i,j) = the sum from n=1 to n=nlat-1 of
!
!               .5*br(1,n+1)*vtbar(0,n,theta(i))
!
!     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
!     n=nlat-1 of the real part of
!
!       (br(m+1,n+1)*vtbar(m,n,theta(i))
!                   -ci(m+1,n+1)*wtbar(m,n,theta(i)))*cos(m*phi(j))
!      -(bi(m+1,n+1)*vtbar(m,n,theta(i))
!                   +cr(m+1,n+1)*wtbar(m,n,theta(i)))*sin(m*phi(j))
!
!    and for i=1,...,nlat and  j=1,...,nlon
!
!     wt(i,j) = the sum from n=1 to n=nlat-1 of
!
!              -.5*cr(1,n+1)*vtbar(0,n,theta(i))
!
!     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
!     n=nlat-1 of the real part of
!
!      -(cr(m+1,n+1)*vtbar(m,n,theta(i))
!                   +bi(m+1,n+1)*wtbar(m,n,theta(i)))*cos(m*phi(j))
!      +(ci(m+1,n+1)*vtbar(m,n,theta(i))
!                   -br(m+1,n+1)*wtbar(m,n,theta(i)))*sin(m*phi(j))
!
!
!      br(m+1,nlat),bi(m+1,nlat),cr(m+1,nlat), and ci(m+1,nlat) are
!      assumed zero for m even.
!
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of ityp
!            = 4  error in the specification of nt
!            = 5  error in the specification of idvw
!            = 6  error in the specification of jdvw
!            = 7  error in the specification of mdab
!            = 8  error in the specification of ndab
!            = 9  error in the specification of lwvts
!            = 10 error in the specification of lwork
!
!
! *******************************************************************
!
!     subroutine vtsgci(nlat,nlon,wvts,lwvts,dwork,ldwork,ierror)
!
!     subroutine vtsgci initializes the array wvts which can then be
!     used repeatedly by subroutine vtsgc until nlat or nlon is changed.
!
!     input parameters
!
!     nlat   the number of gaussian colatitudinal grid points theta(i)
!            such that 0 < theta(1) <...< theta(nlat) < pi. they are
!            computed by subroutine gaqd which is called by this
!            subroutine. if nlat is odd the equator is
!            theta((nlat+1)/2). if nlat is even the equator lies
!            half way between theta(nlat/2) and theta(nlat/2+1). nlat
!            must be at least 3. note: if (v,w) is symmetric about
!            the equator (see parameter ityp below) the number of
!            colatitudinal grid points is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than zero. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!     lwvts  the dimension of the array wvts as it appears in the
!            program that calls vtsgc. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lwvts must be at least
!
!            4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
!
!
!     dwork  a double precision work array that does not have to be saved.
!
!     ldwork the dimension of the array dwork as it appears in the
!            program that calls vtsgc. ldwork must be at least
!            nlat*(nlat+4)
!
!     **************************************************************
!
!     output parameters
!
!     wvts   an array which is initialized for use by subroutine vtsgc.
!            once initialized, wvts can be used repeatedly by vtsgc
!            as long as nlat or nlon remain unchanged.  wvts must not
!            be altered between calls of vtsgc.
!
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of lwvts
!            = 4  error in the specification of lwork
!
!
!
! **********************************************************************
!
      SUBROUTINE VTSGC(Nlat,Nlon,Ityp,Nt,Vt,Wt,Idvw,Jdvw,Br,Bi,Cr,Ci,   &
                     & Mdab,Ndab,Wvts,Lwvts,Work,Lwork,Ierror)
      IMPLICIT NONE
      REAL Bi , Br , Ci , Cr , Vt , Work , Wt , Wvts
      INTEGER idv , Idvw , Ierror , imid , ist , Ityp , iw1 , iw2 ,     &
            & iw3 , iw4 , iw5 , Jdvw , jw1 , jw2 , labc , lnl , Lwork , &
            & Lwvts , lwzvin , lzz1
      INTEGER Mdab , mmax , Ndab , Nlat , Nlon , Nt

      DIMENSION Vt(Idvw,Jdvw,1) , Wt(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,   &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Work(1) , Wvts(1)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      IF ( Ityp<0 .OR. Ityp>8 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Ityp<=2 .AND. Idvw<Nlat) .OR. (Ityp>2 .AND. Idvw<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lwvts<2*(lzz1+labc)+Nlon+15 ) RETURN
      Ierror = 10
      IF ( Ityp<=2 .AND. Lwork<Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon)) )     &
         & RETURN
      IF ( Ityp>2 .AND. Lwork<imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon)) )      &
         & RETURN
      Ierror = 0
      idv = Nlat
      IF ( Ityp>2 ) idv = imid
      lnl = Nt*idv*Nlon
      ist = 0
      IF ( Ityp<=2 ) ist = imid
      iw1 = ist + 1
      iw2 = lnl + 1
      iw3 = iw2 + ist
      iw4 = iw2 + lnl
      iw5 = iw4 + 3*imid*Nlat
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      lwzvin = lzz1 + labc
      jw1 = lwzvin + 1
      jw2 = jw1 + lwzvin
      CALL VTSGC1(Nlat,Nlon,Ityp,Nt,imid,Idvw,Jdvw,Vt,Wt,Mdab,Ndab,Br,  &
                & Bi,Cr,Ci,idv,Work,Work(iw1),Work(iw2),Work(iw3),      &
                & Work(iw4),Work(iw5),Wvts,Wvts(jw1),Wvts(jw2))
    END SUBROUTINE VTSGC

    
    SUBROUTINE VTSGC1(Nlat,Nlon,Ityp,Nt,Imid,Idvw,Jdvw,Vt,Wt,Mdab,    &
         & Ndab,Br,Bi,Cr,Ci,Idv,Vte,Vto,Wte,Wto,Vb,Wb,     &
         & Wvbin,Wwbin,Wrfft)
      IMPLICIT NONE
      REAL Bi , Br , Ci , Cr , Vb , Vt , Vte , Vto , Wb , Wrfft , Wt ,  &
         & Wte , Wto , Wvbin , Wwbin
      INTEGER i , Idv , Idvw , Imid , imm1 , Ityp , itypp , iv , iw ,   &
            & j , Jdvw , k , m , Mdab , mlat , mlon , mmax , mp1 , mp2 ,&
            & Ndab
      INTEGER ndo1 , ndo2 , Nlat , Nlon , nlp1 , np1 , Nt
      DIMENSION Vt(Idvw,Jdvw,1) , Wt(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,   &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Vte(Idv,Nlon,1) , Vto(Idv,Nlon,1) , Wte(Idv,Nlon,1) ,   &
              & Wto(Idv,Nlon,1) , Wvbin(1) , Wwbin(1) , Wrfft(1) ,      &
              & Vb(Imid,Nlat,3) , Wb(Imid,Nlat,3)
      nlp1 = Nlat + 1
      mlat = MOD(Nlat,2)
      mlon = MOD(Nlon,2)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      imm1 = Imid
      IF ( mlat/=0 ) imm1 = Imid - 1
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Idv
               Vte(i,j,k) = 0.
               Wte(i,j,k) = 0.
            ENDDO
         ENDDO
      ENDDO
      ndo1 = Nlat
      ndo2 = Nlat
      IF ( mlat/=0 ) ndo1 = Nlat - 1
      IF ( mlat==0 ) ndo2 = Nlat - 1
      itypp = Ityp + 1
      IF ( itypp==2 ) THEN
!
!     case ityp=1   no symmetries,  cr and ci equal zero
!
         CALL VBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , imm1
                  Vto(i,1,k) = Vto(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , Imid
                  Vte(i,1,k) = Vte(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==3 ) THEN
!
!     case ityp=2   no symmetries,  br and bi are equal to zero
!
         CALL VBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , imm1
                  Wto(i,1,k) = Wto(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , Imid
                  Wte(i,1,k) = Wte(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==4 ) THEN
!
!     case ityp=3   v odd,  w even
!
         CALL VBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , imm1
                  Vto(i,1,k) = Vto(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , Imid
                  Wte(i,1,k) = Wte(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==5 ) THEN
!
!     case ityp=4   v odd,  w even, and both cr and ci equal zero
!
         CALL VBIN(1,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , imm1
                  Vto(i,1,k) = Vto(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(1,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(1,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==6 ) THEN
!
!     case ityp=5   v odd,  w even,     br and bi equal zero
!
         CALL VBIN(2,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , Imid
                  Wte(i,1,k) = Wte(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(2,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(2,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==7 ) THEN
!
!     case ityp=6   v even  ,  w odd
!
         CALL VBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , imm1
                  Wto(i,1,k) = Wto(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , Imid
                  Vte(i,1,k) = Vte(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==8 ) THEN
!
!     case ityp=7   v even, w odd   cr and ci equal zero
!
         CALL VBIN(2,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , Imid
                  Vte(i,1,k) = Vte(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(2,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(2,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==9 ) THEN
!
!     case ityp=8   v even,  w odd   br and bi equal zero
!
         CALL VBIN(1,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , imm1
                  Wto(i,1,k) = Wto(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(1,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(1,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSE
!
!     case ityp=0   no symmetries
!
         CALL VBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , imm1
                  Vto(i,1,k) = Vto(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
                  Wto(i,1,k) = Wto(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , Imid
                  Vte(i,1,k) = Vte(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
                  Wte(i,1,k) = Wte(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ENDIF
      DO k = 1 , Nt
         CALL HRFFTB(Idv,Nlon,Vte(1,1,k),Idv,Wrfft,Vb)
         CALL HRFFTB(Idv,Nlon,Wte(1,1,k),Idv,Wrfft,Vb)
      ENDDO
      IF ( Ityp>2 ) THEN
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , imm1
                  Vt(i,j,k) = .5*Vte(i,j,k)
                  Wt(i,j,k) = .5*Wte(i,j,k)
               ENDDO
            ENDDO
         ENDDO
      ELSE
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , imm1
                  Vt(i,j,k) = .5*(Vte(i,j,k)+Vto(i,j,k))
                  Wt(i,j,k) = .5*(Wte(i,j,k)+Wto(i,j,k))
                  Vt(nlp1-i,j,k) = .5*(Vte(i,j,k)-Vto(i,j,k))
                  Wt(nlp1-i,j,k) = .5*(Wte(i,j,k)-Wto(i,j,k))
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      IF ( mlat==0 ) RETURN
      DO k = 1 , Nt
         DO j = 1 , Nlon
            Vt(Imid,j,k) = .5*Vte(Imid,j,k)
            Wt(Imid,j,k) = .5*Wte(Imid,j,k)
         ENDDO
      ENDDO
      END SUBROUTINE VTSGC1


      SUBROUTINE VTSGCI(Nlat,Nlon,Wvts,Lwvts,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER ierr , Ierror , imid , iw1 , iw2 , labc , ldwk , Ldwork , &
            & lwvbin , Lwvts , lzz1 , mmax , Nlat , Nlon
      REAL Wvts
      DIMENSION Wvts(Lwvts)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      imid = (Nlat+1)/2
      lzz1 = 2*Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lwvts<2*(lzz1+labc)+Nlon+15 ) RETURN
      Ierror = 4
!     if(lwork .lt. 2*nlat*(nlat+2)) return
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
!     call gaqd(nlat,work,work(2*nlat+1),work(4*nlat+1),lwork,ierr)
      ldwk = Ldwork - 2*Nlat
      CALL GAQD(Nlat,Dwork,Dwork(Nlat+1),Dwork(2*Nlat+1),ldwk,ierr)
      Ierror = 5
      IF ( ierr/=0 ) RETURN
      Ierror = 0
!     call vtgint (nlat,nlon,work,wvts,work(4*nlat+1))
      CALL VTGINT(Nlat,Nlon,Dwork,Wvts,Dwork(2*Nlat+1))
      lwvbin = lzz1 + labc
      iw1 = lwvbin + 1
!     call wtgint (nlat,nlon,work,wvts(iw1),work(4*nlat+1))
      CALL WTGINT(Nlat,Nlon,Dwork,Wvts(iw1),Dwork(2*Nlat+1))
      iw2 = iw1 + lwvbin
      CALL HRFFTI(Nlon,Wvts(iw2))
      END SUBROUTINE VTSGCI


      SUBROUTINE DVTSGC(Nlat,Nlon,Ityp,Nt,Vt,Wt,Idvw,Jdvw,Br,Bi,Cr,Ci,   &
                     & Mdab,Ndab,Wvts,Lwvts,Work,Lwork,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION Bi , Br , Ci , Cr , Vt , Work , Wt , Wvts
      INTEGER idv , Idvw , Ierror , imid , ist , Ityp , iw1 , iw2 ,     &
            & iw3 , iw4 , iw5 , Jdvw , jw1 , jw2 , labc , lnl , Lwork , &
            & Lwvts , lwzvin , lzz1
      INTEGER Mdab , mmax , Ndab , Nlat , Nlon , Nt

      DIMENSION Vt(Idvw,Jdvw,1) , Wt(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,   &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Work(1) , Wvts(1)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      IF ( Ityp<0 .OR. Ityp>8 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Ityp<=2 .AND. Idvw<Nlat) .OR. (Ityp>2 .AND. Idvw<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lwvts<2*(lzz1+labc)+Nlon+15 ) RETURN
      Ierror = 10
      IF ( Ityp<=2 .AND. Lwork<Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon)) )     &
         & RETURN
      IF ( Ityp>2 .AND. Lwork<imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon)) )      &
         & RETURN
      Ierror = 0
      idv = Nlat
      IF ( Ityp>2 ) idv = imid
      lnl = Nt*idv*Nlon
      ist = 0
      IF ( Ityp<=2 ) ist = imid
      iw1 = ist + 1
      iw2 = lnl + 1
      iw3 = iw2 + ist
      iw4 = iw2 + lnl
      iw5 = iw4 + 3*imid*Nlat
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      lwzvin = lzz1 + labc
      jw1 = lwzvin + 1
      jw2 = jw1 + lwzvin
      CALL DVTSGC1(Nlat,Nlon,Ityp,Nt,imid,Idvw,Jdvw,Vt,Wt,Mdab,Ndab,Br,  &
                & Bi,Cr,Ci,idv,Work,Work(iw1),Work(iw2),Work(iw3),      &
                & Work(iw4),Work(iw5),Wvts,Wvts(jw1),Wvts(jw2))
    END SUBROUTINE DVTSGC

    
    SUBROUTINE DVTSGC1(Nlat,Nlon,Ityp,Nt,Imid,Idvw,Jdvw,Vt,Wt,Mdab,    &
         & Ndab,Br,Bi,Cr,Ci,Idv,Vte,Vto,Wte,Wto,Vb,Wb,     &
         & Wvbin,Wwbin,Wrfft)
      IMPLICIT NONE
      DOUBLE PRECISION Bi , Br , Ci , Cr , Vb , Vt , Vte , Vto , Wb , Wrfft , Wt ,  &
         & Wte , Wto , Wvbin , Wwbin
      INTEGER i , Idv , Idvw , Imid , imm1 , Ityp , itypp , iv , iw ,   &
            & j , Jdvw , k , m , Mdab , mlat , mlon , mmax , mp1 , mp2 ,&
            & Ndab
      INTEGER ndo1 , ndo2 , Nlat , Nlon , nlp1 , np1 , Nt
      DIMENSION Vt(Idvw,Jdvw,1) , Wt(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,   &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Vte(Idv,Nlon,1) , Vto(Idv,Nlon,1) , Wte(Idv,Nlon,1) ,   &
              & Wto(Idv,Nlon,1) , Wvbin(1) , Wwbin(1) , Wrfft(1) ,      &
              & Vb(Imid,Nlat,3) , Wb(Imid,Nlat,3)
      nlp1 = Nlat + 1
      mlat = MOD(Nlat,2)
      mlon = MOD(Nlon,2)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      imm1 = Imid
      IF ( mlat/=0 ) imm1 = Imid - 1
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Idv
               Vte(i,j,k) = 0.
               Wte(i,j,k) = 0.
            ENDDO
         ENDDO
      ENDDO
      ndo1 = Nlat
      ndo2 = Nlat
      IF ( mlat/=0 ) ndo1 = Nlat - 1
      IF ( mlat==0 ) ndo2 = Nlat - 1
      itypp = Ityp + 1
      IF ( itypp==2 ) THEN
!
!     case ityp=1   no symmetries,  cr and ci equal zero
!
         CALL DVBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , imm1
                  Vto(i,1,k) = Vto(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , Imid
                  Vte(i,1,k) = Vte(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==3 ) THEN
!
!     case ityp=2   no symmetries,  br and bi are equal to zero
!
         CALL DVBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , imm1
                  Wto(i,1,k) = Wto(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , Imid
                  Wte(i,1,k) = Wte(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==4 ) THEN
!
!     case ityp=3   v odd,  w even
!
         CALL DVBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , imm1
                  Vto(i,1,k) = Vto(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , Imid
                  Wte(i,1,k) = Wte(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==5 ) THEN
!
!     case ityp=4   v odd,  w even, and both cr and ci equal zero
!
         CALL DVBIN(1,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , imm1
                  Vto(i,1,k) = Vto(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(1,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(1,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==6 ) THEN
!
!     case ityp=5   v odd,  w even,     br and bi equal zero
!
         CALL DVBIN(2,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , Imid
                  Wte(i,1,k) = Wte(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(2,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(2,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==7 ) THEN
!
!     case ityp=6   v even  ,  w odd
!
         CALL DVBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , imm1
                  Wto(i,1,k) = Wto(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , Imid
                  Vte(i,1,k) = Vte(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==8 ) THEN
!
!     case ityp=7   v even, w odd   cr and ci equal zero
!
         CALL DVBIN(2,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , Imid
                  Vte(i,1,k) = Vte(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(2,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(2,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==9 ) THEN
!
!     case ityp=8   v even,  w odd   br and bi equal zero
!
         CALL DVBIN(1,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , imm1
                  Wto(i,1,k) = Wto(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(1,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(1,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSE
!
!     case ityp=0   no symmetries
!
         CALL DVBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , imm1
                  Vto(i,1,k) = Vto(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
                  Wto(i,1,k) = Wto(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , Imid
                  Vte(i,1,k) = Vte(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
                  Wte(i,1,k) = Wte(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vto(i,2*mp1-2,k) = Vto(i,2*mp1-2,k)          &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vte(i,2*mp1-2,k) = Vte(i,2*mp1-2,k)          &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vto(i,2*mp1-1,k) = Vto(i,2*mp1-1,k)          &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Vte(i,2*mp1-1,k) = Vte(i,2*mp1-1,k)          &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-2,k) = Wto(i,2*mp1-2,k)          &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-2,k) = Wte(i,2*mp1-2,k)          &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wto(i,2*mp1-1,k) = Wto(i,2*mp1-1,k)          &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                           Wte(i,2*mp1-1,k) = Wte(i,2*mp1-1,k)          &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Vte(Imid,2*mp1-2,k) = Vte(Imid,2*mp1-2,k)    &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Vte(Imid,2*mp1-1,k) = Vte(Imid,2*mp1-1,k)    &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                           Wte(Imid,2*mp1-2,k) = Wte(Imid,2*mp1-2,k)    &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           Wte(Imid,2*mp1-1,k) = Wte(Imid,2*mp1-1,k)    &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ENDIF
      DO k = 1 , Nt
         CALL DHRFFTB(Idv,Nlon,Vte(1,1,k),Idv,Wrfft,Vb)
         CALL DHRFFTB(Idv,Nlon,Wte(1,1,k),Idv,Wrfft,Vb)
      ENDDO
      IF ( Ityp>2 ) THEN
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , imm1
                  Vt(i,j,k) = .5*Vte(i,j,k)
                  Wt(i,j,k) = .5*Wte(i,j,k)
               ENDDO
            ENDDO
         ENDDO
      ELSE
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , imm1
                  Vt(i,j,k) = .5*(Vte(i,j,k)+Vto(i,j,k))
                  Wt(i,j,k) = .5*(Wte(i,j,k)+Wto(i,j,k))
                  Vt(nlp1-i,j,k) = .5*(Vte(i,j,k)-Vto(i,j,k))
                  Wt(nlp1-i,j,k) = .5*(Wte(i,j,k)-Wto(i,j,k))
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      IF ( mlat==0 ) RETURN
      DO k = 1 , Nt
         DO j = 1 , Nlon
            Vt(Imid,j,k) = .5*Vte(Imid,j,k)
            Wt(Imid,j,k) = .5*Wte(Imid,j,k)
         ENDDO
      ENDDO
      END SUBROUTINE DVTSGC1


      SUBROUTINE DVTSGCI(Nlat,Nlon,Wvts,Lwvts,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER ierr , Ierror , imid , iw1 , iw2 , labc , ldwk , Ldwork , &
            & lwvbin , Lwvts , lzz1 , mmax , Nlat , Nlon
      DOUBLE PRECISION Wvts
      DIMENSION Wvts(Lwvts)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      imid = (Nlat+1)/2
      lzz1 = 2*Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lwvts<2*(lzz1+labc)+Nlon+15 ) RETURN
      Ierror = 4
!     if(lwork .lt. 2*nlat*(nlat+2)) return
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
!     call gaqd(nlat,work,work(2*nlat+1),work(4*nlat+1),lwork,ierr)
      ldwk = Ldwork - 2*Nlat
      CALL DGAQD(Nlat,Dwork,Dwork(Nlat+1),Dwork(2*Nlat+1),ldwk,ierr)
      Ierror = 5
      IF ( ierr/=0 ) RETURN
      Ierror = 0
!     call vtgint (nlat,nlon,work,wvts,work(4*nlat+1))
      CALL DVTGINT(Nlat,Nlon,Dwork,Wvts,Dwork(2*Nlat+1))
      lwvbin = lzz1 + labc
      iw1 = lwvbin + 1
!     call wtgint (nlat,nlon,work,wvts(iw1),work(4*nlat+1))
      CALL DWTGINT(Nlat,Nlon,Dwork,Wvts(iw1),Dwork(2*Nlat+1))
      iw2 = iw1 + lwvbin
      CALL DHRFFTI(Nlon,Wvts(iw2))
      END SUBROUTINE DVTSGCI

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c ... file hrfft.f
c
c     this file contains a multiple fft package for spherepack3.0.
c     it includes code and documentation for performing fast fourier
c     transforms (see subroutines hrffti,hrfftf and hrfftb)
c
c **********************************************************************
c
c     subroutine hrffti(n,wsave)
c
c     subroutine hrffti initializes the array wsave which is used in
c     both hrfftf and hrfftb. the prime factorization of n together 
c     with a tabulation of the trigonometric functions are computed and
c     stored in wsave.
c
c     input parameter
c
c     n       the length of the sequence to be transformed.
c
c     output parameter
c
c     wsave   a work array which must be dimensioned at least 2*n+15.
c             the same work array can be used for both hrfftf and 
c             hrfftb as long as n remains unchanged. different wsave 
c             arrays are required for different values of n. the 
c             contents of wsave must not be changed between calls 
c             of hrfftf or hrfftb.
c
c **********************************************************************
c
c     subroutine hrfftf(m,n,r,mdimr,wsave,work)
c
c     subroutine hrfftf computes the fourier coefficients of m real
c     perodic sequences (fourier analysis); i.e. hrfftf computes the
c     real fft of m sequences each with length n. the transform is 
c     defined below at output parameter r.
c
c     input parameters
c
c     m       the number of sequences.
c
c     n       the length of all m sequences.  the method is most
c             efficient when n is a product of small primes. n may
c             change as long as different work arrays are provided
c
c     r       r(m,n) is a two dimensional real array that contains m
c             sequences each with length n.
c
c     mdimr   the first dimension of the r array as it appears
c             in the program that calls hrfftf. mdimr must be
c             greater than or equal to m.
c
c
c     wsave   a work array with at least least 2*n+15 locations
c             in the program that calls hrfftf. the wsave array must be
c             initialized by calling subroutine hrffti(n,wsave) and a
c             different wsave array must be used for each different
c             value of n. this initialization does not have to be
c             repeated so long as n remains unchanged thus subsequent
c             transforms can be obtained faster than the first.
c             the same wsave array can be used by hrfftf and hrfftb.
c
c     work    a real work array with m*n locations.
c
c
c     output parameters
c
c     r      for all j=1,...,m
c  
c             r(j,1) = the sum from i=1 to i=n of r(j,i)
c
c             if n is even set l =n/2   , if n is odd set l = (n+1)/2
c
c               then for k = 2,...,l
c
c                  r(j,2*k-2) = the sum from i = 1 to i = n of
c
c                       r(j,i)*cos((k-1)*(i-1)*2*pi/n)
c
c                  r(j,2*k-1) = the sum from i = 1 to i = n of
c
c                      -r(j,i)*sin((k-1)*(i-1)*2*pi/n)
c
c             if n is even
c
c                  r(j,n) = the sum from i = 1 to i = n of
c
c                       (-1)**(i-1)*r(j,i)
c
c      *****  note
c                  this transform is unnormalized since a call of hrfftf
c                  followed by a call of hrfftb will multiply the input
c                  sequence by n.
c
c     wsave   contains results which must not be destroyed between
c             calls of hrfftf or hrfftb.
c
c     work    a real work array with m*n locations that does
c             not have to be saved.
c
c **********************************************************************
c
c     subroutine hrfftb(m,n,r,mdimr,wsave,work)
c
c     subroutine hrfftb computes the real perodic sequence of m
c     sequences from their fourier coefficients (fourier synthesis). 
c     the transform is defined below at output parameter r.
c
c     input parameters
c
c     m       the number of sequences.
c
c     n       the length of all m sequences.  the method is most
c             efficient when n is a product of small primes. n may
c             change as long as different work arrays are provided
c
c     r       r(m,n) is a two dimensional real array that contains
c             the fourier coefficients of m sequences each with 
c             length n.
c
c     mdimr   the first dimension of the r array as it appears
c             in the program that calls hrfftb. mdimr must be
c             greater than or equal to m.
c
c     wsave   a work array which must be dimensioned at least 2*n+15.
c             in the program that calls hrfftb. the wsave array must be
c             initialized by calling subroutine hrffti(n,wsave) and a
c             different wsave array must be used for each different
c             value of n. this initialization does not have to be
c             repeated so long as n remains unchanged thus subsequent
c             transforms can be obtained faster than the first.
c             the same wsave array can be used by hrfftf and hrfftb.
c
c     work    a real work array with m*n locations.
c
c
c     output parameters
c
c     r      for all j=1,...,m
c  
c             for n even and for i = 1,...,n
c
c                  r(j,i) = r(j,1)+(-1)**(i-1)*r(j,n)
c
c                       plus the sum from k=2 to k=n/2 of
c
c                        2.*r(j,2*k-2)*cos((k-1)*(i-1)*2*pi/n)
c
c                       -2.*r(j,2*k-1)*sin((k-1)*(i-1)*2*pi/n)
c
c             for n odd and for i = 1,...,n
c
c                  r(j,i) = r(j,1) plus the sum from k=2 to k=(n+1)/2 of
c
c                       2.*r(j,2*k-2)*cos((k-1)*(i-1)*2*pi/n)
c
c                      -2.*r(j,2*k-1)*sin((k-1)*(i-1)*2*pi/n)
c
c      *****  note
c                  this transform is unnormalized since a call of hrfftf
c                  followed by a call of hrfftb will multiply the input
c                  sequence by n.
c
c     wsave   contains results which must not be destroyed between
c             calls of hrfftb or hrfftf.
c
c     work    a real work array with m*n locations that does not
c             have to be saved
c
c **********************************************************************
c
c
c
      subroutine hrffti (n,wsave)
      dimension       wsave(n+15)                                              
      common /hrf/ tfft
      tfft = 0.
      if (n .eq. 1) return                                                     
      call hrfti1 (n,wsave(1),wsave(n+1))
      return                                                                   
      end                                                                      
      subroutine hrfti1 (n,wa,fac)
c                                                                              
c     a multiple fft package for spherepack
c                                                                              
      dimension       wa(n)      ,fac(15)    ,ntryh(4)                         
      double precision tpi,argh,argld,arg
      data ntryh(1),ntryh(2),ntryh(3),ntryh(4)/4,2,3,5/                        
      nl = n                                                                   
      nf = 0           
      j = 0            
  101 j = j+1          
      if (j-4) 102,102,103                
  102 ntry = ntryh(j)                     
      go to 104        
  103 ntry = ntry+2    
  104 nq = nl/ntry     
      nr = nl-ntry*nq                     
      if (nr) 101,105,101                 
  105 nf = nf+1        
      fac(nf+2) = ntry                    
      nl = nq          
      if (ntry .ne. 2) go to 107          
      if (nf .eq. 1) go to 107            
      do 106 i=2,nf    
         ib = nf-i+2   
         fac(ib+2) = fac(ib+1)            
  106 continue         
      fac(3) = 2       
  107 if (nl .ne. 1) go to 104            
      fac(1) = n       
      fac(2) = nf      
      tpi = 8.d0*datan(1.d0)
      argh = tpi/float(n)                 
      is = 0           
      nfm1 = nf-1      
      l1 = 1           
      if (nfm1 .eq. 0) return             
      do 110 k1=1,nfm1                    
         ip = fac(k1+2)                   
         ld = 0        
         l2 = l1*ip    
         ido = n/l2    
         ipm = ip-1    
         do 109 j=1,ipm                   
            ld = ld+l1                    
            i = is     
            argld = float(ld)*argh        
            fi = 0.    
            do 108 ii=3,ido,2             
               i = i+2                    
               fi = fi+1.                 
               arg = fi*argld             
	       wa(i-1) = dcos(arg)
	       wa(i) = dsin(arg)
  108       continue   
            is = is+ido                   
  109    continue      
         l1 = l2       
  110 continue         
      return           
      end              
      subroutine hrfftf (m,n,r,mdimr,whrfft,work)
c                      
c     a multiple fft package for spherepack
c                      
      dimension       r(mdimr,n)  ,work(1)    ,whrfft(n+15)
      common /hrf/ tfft
      if (n .eq. 1) return                
c     tstart = second(dum)
      call hrftf1 (m,n,r,mdimr,work,whrfft,whrfft(n+1))
c     tfft = tfft+second(dum)-tstart
      return           
      end              
      subroutine hrftf1 (m,n,c,mdimc,ch,wa,fac)
c                      
c     a multiple fft package for spherepack
c                      
      dimension       ch(m,n) ,c(mdimc,n)  ,wa(n)   ,fac(15)
      nf = fac(2)      
      na = 1           
      l2 = n           
      iw = n           
      do 111 k1=1,nf   
         kh = nf-k1    
         ip = fac(kh+3)                   
         l1 = l2/ip    
         ido = n/l2    
         idl1 = ido*l1                    
         iw = iw-(ip-1)*ido               
         na = 1-na     
         if (ip .ne. 4) go to 102         
         ix2 = iw+ido                     
         ix3 = ix2+ido                    
         if (na .ne. 0) go to 101         
	 call hradf4 (m,ido,l1,c,mdimc,ch,m,wa(iw),wa(ix2),wa(ix3))
         go to 110     
  101    call hradf4 (m,ido,l1,ch,m,c,mdimc,wa(iw),wa(ix2),wa(ix3))
         go to 110     
  102    if (ip .ne. 2) go to 104         
         if (na .ne. 0) go to 103         
	 call hradf2 (m,ido,l1,c,mdimc,ch,m,wa(iw))
         go to 110     
  103    call hradf2 (m,ido,l1,ch,m,c,mdimc,wa(iw))
         go to 110     
  104    if (ip .ne. 3) go to 106         
         ix2 = iw+ido                     
         if (na .ne. 0) go to 105         
	 call hradf3 (m,ido,l1,c,mdimc,ch,m,wa(iw),wa(ix2))
         go to 110     
  105    call hradf3 (m,ido,l1,ch,m,c,mdimc,wa(iw),wa(ix2))
         go to 110     
  106    if (ip .ne. 5) go to 108         
         ix2 = iw+ido                     
         ix3 = ix2+ido                    
         ix4 = ix3+ido                    
         if (na .ne. 0) go to 107         
      call hradf5(m,ido,l1,c,mdimc,ch,m,wa(iw),wa(ix2),wa(ix3),wa(ix4))
         go to 110     
  107 call hradf5(m,ido,l1,ch,m,c,mdimc,wa(iw),wa(ix2),wa(ix3),wa(ix4))
         go to 110     
  108    if (ido .eq. 1) na = 1-na        
         if (na .ne. 0) go to 109         
	 call hradfg (m,ido,ip,l1,idl1,c,c,c,mdimc,ch,ch,m,wa(iw))
         na = 1        
         go to 110     
  109    call hradfg (m,ido,ip,l1,idl1,ch,ch,ch,m,c,c,mdimc,wa(iw))
         na = 0        
  110    l2 = l1       
  111 continue         
      if (na .eq. 1) return
      do 112 j=1,n     
      do 112 i=1,m     
	 c(i,j) = ch(i,j)
  112 continue         
      return           
      end              
      subroutine hradf4 (mp,ido,l1,cc,mdimcc,ch,mdimch,wa1,wa2,wa3)
c                      
c     a multiple fft package for spherepack
c                      
      dimension    cc(mdimcc,ido,l1,4)   ,ch(mdimch,ido,4,l1)     ,
     1             wa1(ido)     ,wa2(ido)     ,wa3(ido)
      hsqt2=sqrt(2.)/2.                   
      do 101 k=1,l1    
         do 1001 m=1,mp                   
         ch(m,1,1,k) = (cc(m,1,k,2)+cc(m,1,k,4))             
     1      +(cc(m,1,k,1)+cc(m,1,k,3))    
         ch(m,ido,4,k) = (cc(m,1,k,1)+cc(m,1,k,3))           
     1      -(cc(m,1,k,2)+cc(m,1,k,4))    
         ch(m,ido,2,k) = cc(m,1,k,1)-cc(m,1,k,3)             
         ch(m,1,3,k) = cc(m,1,k,4)-cc(m,1,k,2)               
 1001    continue      
  101 continue         
      if (ido-2) 107,105,102              
  102 idp2 = ido+2     
      do 104 k=1,l1    
         do 103 i=3,ido,2                 
            ic = idp2-i                   
            do 1003 m=1,mp                
            ch(m,i-1,1,k) = ((wa1(i-2)*cc(m,i-1,k,2)+wa1(i-1)*                 
     1       cc(m,i,k,2))+(wa3(i-2)*cc(m,i-1,k,4)+wa3(i-1)*  
     1       cc(m,i,k,4)))+(cc(m,i-1,k,1)+(wa2(i-2)*cc(m,i-1,k,3)+             
     1       wa2(i-1)*cc(m,i,k,3)))       
            ch(m,ic-1,4,k) = (cc(m,i-1,k,1)+(wa2(i-2)*cc(m,i-1,k,3)+           
     1       wa2(i-1)*cc(m,i,k,3)))-((wa1(i-2)*cc(m,i-1,k,2)+                  
     1       wa1(i-1)*cc(m,i,k,2))+(wa3(i-2)*cc(m,i-1,k,4)+  
     1       wa3(i-1)*cc(m,i,k,4)))       
            ch(m,i,1,k) = ((wa1(i-2)*cc(m,i,k,2)-wa1(i-1)*   
     1       cc(m,i-1,k,2))+(wa3(i-2)*cc(m,i,k,4)-wa3(i-1)*  
     1       cc(m,i-1,k,4)))+(cc(m,i,k,1)+(wa2(i-2)*cc(m,i,k,3)-               
     1       wa2(i-1)*cc(m,i-1,k,3)))     
            ch(m,ic,4,k) = ((wa1(i-2)*cc(m,i,k,2)-wa1(i-1)*  
     1       cc(m,i-1,k,2))+(wa3(i-2)*cc(m,i,k,4)-wa3(i-1)*  
     1       cc(m,i-1,k,4)))-(cc(m,i,k,1)+(wa2(i-2)*cc(m,i,k,3)-               
     1       wa2(i-1)*cc(m,i-1,k,3)))     
            ch(m,i-1,3,k) = ((wa1(i-2)*cc(m,i,k,2)-wa1(i-1)* 
     1       cc(m,i-1,k,2))-(wa3(i-2)*cc(m,i,k,4)-wa3(i-1)*  
     1       cc(m,i-1,k,4)))+(cc(m,i-1,k,1)-(wa2(i-2)*cc(m,i-1,k,3)+           
     1       wa2(i-1)*cc(m,i,k,3)))       
            ch(m,ic-1,2,k) = (cc(m,i-1,k,1)-(wa2(i-2)*cc(m,i-1,k,3)+           
     1       wa2(i-1)*cc(m,i,k,3)))-((wa1(i-2)*cc(m,i,k,2)-wa1(i-1)*           
     1       cc(m,i-1,k,2))-(wa3(i-2)*cc(m,i,k,4)-wa3(i-1)*  
     1       cc(m,i-1,k,4)))              
            ch(m,i,3,k) = ((wa3(i-2)*cc(m,i-1,k,4)+wa3(i-1)* 
     1       cc(m,i,k,4))-(wa1(i-2)*cc(m,i-1,k,2)+wa1(i-1)*  
     1       cc(m,i,k,2)))+(cc(m,i,k,1)-(wa2(i-2)*cc(m,i,k,3)-                 
     1       wa2(i-1)*cc(m,i-1,k,3)))     
            ch(m,ic,2,k) = ((wa3(i-2)*cc(m,i-1,k,4)+wa3(i-1)*                  
     1       cc(m,i,k,4))-(wa1(i-2)*cc(m,i-1,k,2)+wa1(i-1)*  
     1       cc(m,i,k,2)))-(cc(m,i,k,1)-(wa2(i-2)*cc(m,i,k,3)-wa2(i-1)*        
     1       cc(m,i-1,k,3)))              
 1003       continue   
  103    continue      
  104 continue         
      if (mod(ido,2) .eq. 1) return       
  105 continue         
      do 106 k=1,l1    
         do 1006 m=1,mp                   
            ch(m,ido,1,k) = (hsqt2*(cc(m,ido,k,2)-cc(m,ido,k,4)))+              
     1       cc(m,ido,k,1)                
            ch(m,ido,3,k) = cc(m,ido,k,1)-(hsqt2*(cc(m,ido,k,2)-                
     1       cc(m,ido,k,4)))              
            ch(m,1,2,k) = (-hsqt2*(cc(m,ido,k,2)+cc(m,ido,k,4)))-               
     1       cc(m,ido,k,3)                
            ch(m,1,4,k) = (-hsqt2*(cc(m,ido,k,2)+cc(m,ido,k,4)))+               
     1       cc(m,ido,k,3)                
 1006    continue      
  106 continue         
  107 return           
      end              
      subroutine hradf2 (mp,ido,l1,cc,mdimcc,ch,mdimch,wa1)
c                      
c     a multiple fft package for spherepack
c                      
      dimension   ch(mdimch,ido,2,l1)  ,cc(mdimcc,ido,l1,2)     ,
     1                wa1(ido)            
      do 101 k=1,l1    
         do 1001 m=1,mp                   
         ch(m,1,1,k) = cc(m,1,k,1)+cc(m,1,k,2)               
         ch(m,ido,2,k) = cc(m,1,k,1)-cc(m,1,k,2)             
 1001    continue      
  101 continue         
      if (ido-2) 107,105,102              
  102 idp2 = ido+2     
      do 104 k=1,l1    
         do 103 i=3,ido,2                 
            ic = idp2-i                   
            do 1003 m=1,mp                
            ch(m,i,1,k) = cc(m,i,k,1)+(wa1(i-2)*cc(m,i,k,2)- 
     1       wa1(i-1)*cc(m,i-1,k,2))      
            ch(m,ic,2,k) = (wa1(i-2)*cc(m,i,k,2)-wa1(i-1)*   
     1       cc(m,i-1,k,2))-cc(m,i,k,1)   
            ch(m,i-1,1,k) = cc(m,i-1,k,1)+(wa1(i-2)*cc(m,i-1,k,2)+              
     1       wa1(i-1)*cc(m,i,k,2))        
            ch(m,ic-1,2,k) = cc(m,i-1,k,1)-(wa1(i-2)*cc(m,i-1,k,2)+             
     1       wa1(i-1)*cc(m,i,k,2))        
 1003       continue   
  103    continue      
  104 continue         
      if (mod(ido,2) .eq. 1) return       
  105 do 106 k=1,l1    
         do 1006 m=1,mp                   
         ch(m,1,2,k) = -cc(m,ido,k,2)     
         ch(m,ido,1,k) = cc(m,ido,k,1)    
 1006    continue      
  106 continue         
  107 return           
      end              
      subroutine hradf3 (mp,ido,l1,cc,mdimcc,ch,mdimch,wa1,wa2)
c                      
c     a multiple fft package for spherepack
c                      
      dimension   ch(mdimch,ido,3,l1)  ,cc(mdimcc,ido,l1,3)     ,
     1                wa1(ido)     ,wa2(ido)                 
      arg=2.*pimach()/3.                  
      taur=cos(arg)    
      taui=sin(arg)    
      do 101 k=1,l1    
         do 1001 m=1,mp                   
         ch(m,1,1,k) = cc(m,1,k,1)+(cc(m,1,k,2)+cc(m,1,k,3)) 
         ch(m,1,3,k) = taui*(cc(m,1,k,3)-cc(m,1,k,2))        
         ch(m,ido,2,k) = cc(m,1,k,1)+taur*                   
     1      (cc(m,1,k,2)+cc(m,1,k,3))     
 1001    continue      
  101 continue         
      if (ido .eq. 1) return              
      idp2 = ido+2     
      do 103 k=1,l1    
         do 102 i=3,ido,2                 
            ic = idp2-i                   
            do 1002 m=1,mp                
            ch(m,i-1,1,k) = cc(m,i-1,k,1)+((wa1(i-2)*cc(m,i-1,k,2)+             
     1       wa1(i-1)*cc(m,i,k,2))+(wa2(i-2)*cc(m,i-1,k,3)+wa2(i-1)*            
     1       cc(m,i,k,3)))                
            ch(m,i,1,k) = cc(m,i,k,1)+((wa1(i-2)*cc(m,i,k,2)-wa1(i-1)*          
     1       cc(m,i-1,k,2))+(wa2(i-2)*cc(m,i,k,3)-wa2(i-1)*  
     1       cc(m,i-1,k,3)))              
            ch(m,i-1,3,k) = (cc(m,i-1,k,1)+taur*((wa1(i-2)*  
     1       cc(m,i-1,k,2)+wa1(i-1)*cc(m,i,k,2))+(wa2(i-2)*  
     1       cc(m,i-1,k,3)+wa2(i-1)*cc(m,i,k,3))))+(taui*((wa1(i-2)*            
     1       cc(m,i,k,2)-wa1(i-1)*cc(m,i-1,k,2))-(wa2(i-2)*  
     1       cc(m,i,k,3)-wa2(i-1)*cc(m,i-1,k,3))))           
            ch(m,ic-1,2,k) = (cc(m,i-1,k,1)+taur*((wa1(i-2)* 
     1       cc(m,i-1,k,2)+wa1(i-1)*cc(m,i,k,2))+(wa2(i-2)*  
     1       cc(m,i-1,k,3)+wa2(i-1)*cc(m,i,k,3))))-(taui*((wa1(i-2)*            
     1       cc(m,i,k,2)-wa1(i-1)*cc(m,i-1,k,2))-(wa2(i-2)*  
     1       cc(m,i,k,3)-wa2(i-1)*cc(m,i-1,k,3))))           
            ch(m,i,3,k) = (cc(m,i,k,1)+taur*((wa1(i-2)*cc(m,i,k,2)-             
     1       wa1(i-1)*cc(m,i-1,k,2))+(wa2(i-2)*cc(m,i,k,3)-wa2(i-1)*            
     1       cc(m,i-1,k,3))))+(taui*((wa2(i-2)*cc(m,i-1,k,3)+wa2(i-1)*          
     1       cc(m,i,k,3))-(wa1(i-2)*cc(m,i-1,k,2)+wa1(i-1)*  
     1       cc(m,i,k,2))))               
            ch(m,ic,2,k) = (taui*((wa2(i-2)*cc(m,i-1,k,3)+wa2(i-1)*             
     1       cc(m,i,k,3))-(wa1(i-2)*cc(m,i-1,k,2)+wa1(i-1)*  
     1       cc(m,i,k,2))))-(cc(m,i,k,1)+taur*((wa1(i-2)*cc(m,i,k,2)-           
     1       wa1(i-1)*cc(m,i-1,k,2))+(wa2(i-2)*cc(m,i,k,3)-wa2(i-1)*            
     1       cc(m,i-1,k,3))))             
 1002       continue   
  102    continue      
  103 continue         
      return           
      end              
      subroutine hradf5 (mp,ido,l1,cc,mdimcc,ch,mdimch,
     1                   wa1,wa2,wa3,wa4)
c                      
c     a multiple fft package for spherepack
c                      
      dimension  cc(mdimcc,ido,l1,5)    ,ch(mdimch,ido,5,l1)     ,
     1           wa1(ido)     ,wa2(ido)     ,wa3(ido)     ,wa4(ido)             
      arg=2.*pimach()/5.                  
      tr11=cos(arg)    
      ti11=sin(arg)    
      tr12=cos(2.*arg)                    
      ti12=sin(2.*arg)                    
      do 101 k=1,l1    
         do 1001 m=1,mp                   
         ch(m,1,1,k) = cc(m,1,k,1)+(cc(m,1,k,5)+cc(m,1,k,2))+                   
     1    (cc(m,1,k,4)+cc(m,1,k,3))       
         ch(m,ido,2,k) = cc(m,1,k,1)+tr11*(cc(m,1,k,5)+cc(m,1,k,2))+            
     1    tr12*(cc(m,1,k,4)+cc(m,1,k,3))  
         ch(m,1,3,k) = ti11*(cc(m,1,k,5)-cc(m,1,k,2))+ti12*  
     1    (cc(m,1,k,4)-cc(m,1,k,3))       
         ch(m,ido,4,k) = cc(m,1,k,1)+tr12*(cc(m,1,k,5)+cc(m,1,k,2))+            
     1    tr11*(cc(m,1,k,4)+cc(m,1,k,3))  
         ch(m,1,5,k) = ti12*(cc(m,1,k,5)-cc(m,1,k,2))-ti11*  
     1    (cc(m,1,k,4)-cc(m,1,k,3))       
 1001    continue      
  101 continue         
      if (ido .eq. 1) return              
      idp2 = ido+2     
      do 103 k=1,l1    
         do 102 i=3,ido,2                 
            ic = idp2-i                   
            do 1002 m=1,mp                
            ch(m,i-1,1,k) = cc(m,i-1,k,1)+((wa1(i-2)*cc(m,i-1,k,2)+             
     1       wa1(i-1)*cc(m,i,k,2))+(wa4(i-2)*cc(m,i-1,k,5)+wa4(i-1)*            
     1       cc(m,i,k,5)))+((wa2(i-2)*cc(m,i-1,k,3)+wa2(i-1)*                   
     1       cc(m,i,k,3))+(wa3(i-2)*cc(m,i-1,k,4)+wa3(i-1)*cc(m,i,k,4)))        
            ch(m,i,1,k) = cc(m,i,k,1)+((wa1(i-2)*cc(m,i,k,2)-wa1(i-1)*          
     1       cc(m,i-1,k,2))+(wa4(i-2)*cc(m,i,k,5)-wa4(i-1)*  
     1       cc(m,i-1,k,5)))+((wa2(i-2)*cc(m,i,k,3)-wa2(i-1)*                   
     1       cc(m,i-1,k,3))+(wa3(i-2)*cc(m,i,k,4)-wa3(i-1)*  
     1       cc(m,i-1,k,4)))              
            ch(m,i-1,3,k) = cc(m,i-1,k,1)+tr11*              
     1      ( wa1(i-2)*cc(m,i-1,k,2)+wa1(i-1)*cc(m,i,k,2)    
     1       +wa4(i-2)*cc(m,i-1,k,5)+wa4(i-1)*cc(m,i,k,5))+tr12*                
     1      ( wa2(i-2)*cc(m,i-1,k,3)+wa2(i-1)*cc(m,i,k,3)    
     1       +wa3(i-2)*cc(m,i-1,k,4)+wa3(i-1)*cc(m,i,k,4))+ti11*                
     1      ( wa1(i-2)*cc(m,i,k,2)-wa1(i-1)*cc(m,i-1,k,2)    
     1       -(wa4(i-2)*cc(m,i,k,5)-wa4(i-1)*cc(m,i-1,k,5)))+ti12*              
     1      ( wa2(i-2)*cc(m,i,k,3)-wa2(i-1)*cc(m,i-1,k,3)    
     1       -(wa3(i-2)*cc(m,i,k,4)-wa3(i-1)*cc(m,i-1,k,4))) 
            ch(m,ic-1,2,k) = cc(m,i-1,k,1)+tr11*             
     1      ( wa1(i-2)*cc(m,i-1,k,2)+wa1(i-1)*cc(m,i,k,2)    
     1       +wa4(i-2)*cc(m,i-1,k,5)+wa4(i-1)*cc(m,i,k,5))+tr12*                
     1     ( wa2(i-2)*cc(m,i-1,k,3)+wa2(i-1)*cc(m,i,k,3)     
     1      +wa3(i-2)*cc(m,i-1,k,4)+wa3(i-1)*cc(m,i,k,4))-(ti11*                
     1      ( wa1(i-2)*cc(m,i,k,2)-wa1(i-1)*cc(m,i-1,k,2)    
     1       -(wa4(i-2)*cc(m,i,k,5)-wa4(i-1)*cc(m,i-1,k,5)))+ti12*              
     1      ( wa2(i-2)*cc(m,i,k,3)-wa2(i-1)*cc(m,i-1,k,3)    
     1       -(wa3(i-2)*cc(m,i,k,4)-wa3(i-1)*cc(m,i-1,k,4))))                   
            ch(m,i,3,k) = (cc(m,i,k,1)+tr11*((wa1(i-2)*cc(m,i,k,2)-             
     1       wa1(i-1)*cc(m,i-1,k,2))+(wa4(i-2)*cc(m,i,k,5)-wa4(i-1)*            
     1       cc(m,i-1,k,5)))+tr12*((wa2(i-2)*cc(m,i,k,3)-wa2(i-1)*              
     1       cc(m,i-1,k,3))+(wa3(i-2)*cc(m,i,k,4)-wa3(i-1)*  
     1       cc(m,i-1,k,4))))+(ti11*((wa4(i-2)*cc(m,i-1,k,5)+                   
     1       wa4(i-1)*cc(m,i,k,5))-(wa1(i-2)*cc(m,i-1,k,2)+wa1(i-1)*            
     1       cc(m,i,k,2)))+ti12*((wa3(i-2)*cc(m,i-1,k,4)+wa3(i-1)*              
     1       cc(m,i,k,4))-(wa2(i-2)*cc(m,i-1,k,3)+wa2(i-1)*  
     1       cc(m,i,k,3))))               
            ch(m,ic,2,k) = (ti11*((wa4(i-2)*cc(m,i-1,k,5)+wa4(i-1)*             
     1       cc(m,i,k,5))-(wa1(i-2)*cc(m,i-1,k,2)+wa1(i-1)*  
     1       cc(m,i,k,2)))+ti12*((wa3(i-2)*cc(m,i-1,k,4)+wa3(i-1)*              
     1       cc(m,i,k,4))-(wa2(i-2)*cc(m,i-1,k,3)+wa2(i-1)*  
     1       cc(m,i,k,3))))-(cc(m,i,k,1)+tr11*((wa1(i-2)*cc(m,i,k,2)-           
     1       wa1(i-1)*cc(m,i-1,k,2))+(wa4(i-2)*cc(m,i,k,5)-wa4(i-1)*            
     1       cc(m,i-1,k,5)))+tr12*((wa2(i-2)*cc(m,i,k,3)-wa2(i-1)*              
     1       cc(m,i-1,k,3))+(wa3(i-2)*cc(m,i,k,4)-wa3(i-1)*  
     1       cc(m,i-1,k,4))))             
            ch(m,i-1,5,k) = (cc(m,i-1,k,1)+tr12*((wa1(i-2)*  
     1       cc(m,i-1,k,2)+wa1(i-1)*cc(m,i,k,2))+(wa4(i-2)*  
     1       cc(m,i-1,k,5)+wa4(i-1)*cc(m,i,k,5)))+tr11*((wa2(i-2)*              
     1       cc(m,i-1,k,3)+wa2(i-1)*cc(m,i,k,3))+(wa3(i-2)*  
     1       cc(m,i-1,k,4)+wa3(i-1)*cc(m,i,k,4))))+(ti12*((wa1(i-2)*            
     1       cc(m,i,k,2)-wa1(i-1)*cc(m,i-1,k,2))-(wa4(i-2)*cc(m,i,k,5)-         
     1       wa4(i-1)*cc(m,i-1,k,5)))-ti11*((wa2(i-2)*cc(m,i,k,3)-              
     1       wa2(i-1)*cc(m,i-1,k,3))-(wa3(i-2)*cc(m,i,k,4)-wa3(i-1)*            
     1       cc(m,i-1,k,4))))             
            ch(m,ic-1,4,k) = (cc(m,i-1,k,1)+tr12*((wa1(i-2)* 
     1       cc(m,i-1,k,2)+wa1(i-1)*cc(m,i,k,2))+(wa4(i-2)*  
     1       cc(m,i-1,k,5)+wa4(i-1)*cc(m,i,k,5)))+tr11*((wa2(i-2)*              
     1       cc(m,i-1,k,3)+wa2(i-1)*cc(m,i,k,3))+(wa3(i-2)*  
     1       cc(m,i-1,k,4)+wa3(i-1)*cc(m,i,k,4))))-(ti12*((wa1(i-2)*            
     1       cc(m,i,k,2)-wa1(i-1)*cc(m,i-1,k,2))-(wa4(i-2)*cc(m,i,k,5)-         
     1       wa4(i-1)*cc(m,i-1,k,5)))-ti11*((wa2(i-2)*cc(m,i,k,3)-              
     1       wa2(i-1)*cc(m,i-1,k,3))-(wa3(i-2)*cc(m,i,k,4)-wa3(i-1)*            
     1       cc(m,i-1,k,4))))             
            ch(m,i,5,k) = (cc(m,i,k,1)+tr12*((wa1(i-2)*cc(m,i,k,2)-             
     1       wa1(i-1)*cc(m,i-1,k,2))+(wa4(i-2)*cc(m,i,k,5)-wa4(i-1)*            
     1       cc(m,i-1,k,5)))+tr11*((wa2(i-2)*cc(m,i,k,3)-wa2(i-1)*              
     1       cc(m,i-1,k,3))+(wa3(i-2)*cc(m,i,k,4)-wa3(i-1)*  
     1       cc(m,i-1,k,4))))+(ti12*((wa4(i-2)*cc(m,i-1,k,5)+                   
     1       wa4(i-1)*cc(m,i,k,5))-(wa1(i-2)*cc(m,i-1,k,2)+wa1(i-1)*            
     1       cc(m,i,k,2)))-ti11*((wa3(i-2)*cc(m,i-1,k,4)+wa3(i-1)*              
     1       cc(m,i,k,4))-(wa2(i-2)*cc(m,i-1,k,3)+wa2(i-1)*  
     1       cc(m,i,k,3))))               
            ch(m,ic,4,k) = (ti12*((wa4(i-2)*cc(m,i-1,k,5)+wa4(i-1)*             
     1       cc(m,i,k,5))-(wa1(i-2)*cc(m,i-1,k,2)+wa1(i-1)*  
     1       cc(m,i,k,2)))-ti11*((wa3(i-2)*cc(m,i-1,k,4)+wa3(i-1)*              
     1       cc(m,i,k,4))-(wa2(i-2)*cc(m,i-1,k,3)+wa2(i-1)*  
     1       cc(m,i,k,3))))-(cc(m,i,k,1)+tr12*((wa1(i-2)*cc(m,i,k,2)-           
     1       wa1(i-1)*cc(m,i-1,k,2))+(wa4(i-2)*cc(m,i,k,5)-wa4(i-1)*            
     1       cc(m,i-1,k,5)))+tr11*((wa2(i-2)*cc(m,i,k,3)-wa2(i-1)*              
     1       cc(m,i-1,k,3))+(wa3(i-2)*cc(m,i,k,4)-wa3(i-1)*  
     1       cc(m,i-1,k,4))))             
 1002       continue   
  102    continue      
  103 continue         
      return           
      end              
      subroutine hradfg (mp,ido,ip,l1,idl1,cc,c1,c2,mdimcc,
     1              ch,ch2,mdimch,wa)
c                      
c     a multiple fft package for spherepack
c                      
      dimension     ch(mdimch,ido,l1,ip)   ,cc(mdimcc,ido,ip,l1)  ,
     1            c1(mdimcc,ido,l1,ip)    ,c2(mdimcc,idl1,ip),
     2                ch2(mdimch,idl1,ip)           ,wa(ido)
      tpi=2.*pimach()                     
      arg = tpi/float(ip)                 
      dcp = cos(arg)   
      dsp = sin(arg)   
      ipph = (ip+1)/2                     
      ipp2 = ip+2      
      idp2 = ido+2     
      nbd = (ido-1)/2                     
      if (ido .eq. 1) go to 119           
      do 101 ik=1,idl1                    
         do 1001 m=1,mp                   
         ch2(m,ik,1) = c2(m,ik,1)         
 1001    continue      
  101 continue         
      do 103 j=2,ip    
         do 102 k=1,l1                    
            do 1002 m=1,mp                
            ch(m,1,k,j) = c1(m,1,k,j)     
 1002       continue   
  102    continue      
  103 continue         
      if (nbd .gt. l1) go to 107          
      is = -ido        
      do 106 j=2,ip    
         is = is+ido   
         idij = is     
         do 105 i=3,ido,2                 
            idij = idij+2                 
            do 104 k=1,l1                 
               do 1004 m=1,mp             
               ch(m,i-1,k,j) = wa(idij-1)*c1(m,i-1,k,j)+wa(idij)                
     1           *c1(m,i,k,j)             
               ch(m,i,k,j) = wa(idij-1)*c1(m,i,k,j)-wa(idij) 
     1           *c1(m,i-1,k,j)           
 1004          continue                   
  104       continue   
  105    continue      
  106 continue         
      go to 111        
  107 is = -ido        
      do 110 j=2,ip    
         is = is+ido   
         do 109 k=1,l1                    
            idij = is                     
            do 108 i=3,ido,2              
               idij = idij+2              
               do 1008 m=1,mp             
               ch(m,i-1,k,j) = wa(idij-1)*c1(m,i-1,k,j)+wa(idij)                
     1           *c1(m,i,k,j)             
               ch(m,i,k,j) = wa(idij-1)*c1(m,i,k,j)-wa(idij) 
     1           *c1(m,i-1,k,j)           
 1008          continue                   
  108       continue   
  109    continue      
  110 continue         
  111 if (nbd .lt. l1) go to 115          
      do 114 j=2,ipph                     
         jc = ipp2-j   
         do 113 k=1,l1                    
            do 112 i=3,ido,2              
               do 1012 m=1,mp             
               c1(m,i-1,k,j) = ch(m,i-1,k,j)+ch(m,i-1,k,jc)  
               c1(m,i-1,k,jc) = ch(m,i,k,j)-ch(m,i,k,jc)     
               c1(m,i,k,j) = ch(m,i,k,j)+ch(m,i,k,jc)        
               c1(m,i,k,jc) = ch(m,i-1,k,jc)-ch(m,i-1,k,j)   
 1012          continue                   
  112       continue   
  113    continue      
  114 continue         
      go to 121        
  115 do 118 j=2,ipph                     
         jc = ipp2-j   
         do 117 i=3,ido,2                 
            do 116 k=1,l1                 
               do 1016 m=1,mp             
               c1(m,i-1,k,j) = ch(m,i-1,k,j)+ch(m,i-1,k,jc)  
               c1(m,i-1,k,jc) = ch(m,i,k,j)-ch(m,i,k,jc)     
               c1(m,i,k,j) = ch(m,i,k,j)+ch(m,i,k,jc)        
               c1(m,i,k,jc) = ch(m,i-1,k,jc)-ch(m,i-1,k,j)   
 1016          continue                   
  116       continue   
  117    continue      
  118 continue         
      go to 121        
  119 do 120 ik=1,idl1                    
         do 1020 m=1,mp                   
         c2(m,ik,1) = ch2(m,ik,1)         
 1020    continue      
  120 continue         
  121 do 123 j=2,ipph                     
         jc = ipp2-j   
         do 122 k=1,l1                    
            do 1022 m=1,mp                
            c1(m,1,k,j) = ch(m,1,k,j)+ch(m,1,k,jc)           
            c1(m,1,k,jc) = ch(m,1,k,jc)-ch(m,1,k,j)          
 1022       continue   
  122    continue      
  123 continue         
c                      
      ar1 = 1.         
      ai1 = 0.         
      do 127 l=2,ipph                     
         lc = ipp2-l   
         ar1h = dcp*ar1-dsp*ai1           
         ai1 = dcp*ai1+dsp*ar1            
         ar1 = ar1h    
         do 124 ik=1,idl1                 
            do 1024 m=1,mp                
            ch2(m,ik,l) = c2(m,ik,1)+ar1*c2(m,ik,2)          
            ch2(m,ik,lc) = ai1*c2(m,ik,ip)                   
 1024       continue   
  124    continue      
         dc2 = ar1     
         ds2 = ai1     
         ar2 = ar1     
         ai2 = ai1     
         do 126 j=3,ipph                  
            jc = ipp2-j                   
            ar2h = dc2*ar2-ds2*ai2        
            ai2 = dc2*ai2+ds2*ar2         
            ar2 = ar2h                    
            do 125 ik=1,idl1              
               do 1025 m=1,mp             
               ch2(m,ik,l) = ch2(m,ik,l)+ar2*c2(m,ik,j)      
               ch2(m,ik,lc) = ch2(m,ik,lc)+ai2*c2(m,ik,jc)   
 1025          continue                   
  125       continue   
  126    continue      
  127 continue         
      do 129 j=2,ipph                     
         do 128 ik=1,idl1                 
            do 1028 m=1,mp                
            ch2(m,ik,1) = ch2(m,ik,1)+c2(m,ik,j)             
 1028       continue   
  128    continue      
  129 continue         
c                      
      if (ido .lt. l1) go to 132          
      do 131 k=1,l1    
         do 130 i=1,ido                   
            do 1030 m=1,mp                
            cc(m,i,1,k) = ch(m,i,k,1)     
 1030       continue   
  130    continue      
  131 continue         
      go to 135        
  132 do 134 i=1,ido   
         do 133 k=1,l1                    
            do 1033 m=1,mp                
            cc(m,i,1,k) = ch(m,i,k,1)     
 1033       continue   
  133    continue      
  134 continue         
  135 do 137 j=2,ipph                     
         jc = ipp2-j   
         j2 = j+j      
         do 136 k=1,l1                    
            do 1036 m=1,mp                
            cc(m,ido,j2-2,k) = ch(m,1,k,j)                   
            cc(m,1,j2-1,k) = ch(m,1,k,jc)                    
 1036       continue   
  136    continue      
  137 continue         
      if (ido .eq. 1) return              
      if (nbd .lt. l1) go to 141          
      do 140 j=2,ipph                     
         jc = ipp2-j   
         j2 = j+j      
         do 139 k=1,l1                    
            do 138 i=3,ido,2              
               ic = idp2-i                
               do 1038 m=1,mp             
               cc(m,i-1,j2-1,k) = ch(m,i-1,k,j)+ch(m,i-1,k,jc)                  
               cc(m,ic-1,j2-2,k) = ch(m,i-1,k,j)-ch(m,i-1,k,jc)                 
               cc(m,i,j2-1,k) = ch(m,i,k,j)+ch(m,i,k,jc)     
               cc(m,ic,j2-2,k) = ch(m,i,k,jc)-ch(m,i,k,j)    
 1038          continue                   
  138       continue   
  139    continue      
  140 continue         
      return           
  141 do 144 j=2,ipph                     
         jc = ipp2-j   
         j2 = j+j      
         do 143 i=3,ido,2                 
            ic = idp2-i                   
            do 142 k=1,l1                 
               do 1042 m=1,mp             
               cc(m,i-1,j2-1,k) = ch(m,i-1,k,j)+ch(m,i-1,k,jc)                  
               cc(m,ic-1,j2-2,k) = ch(m,i-1,k,j)-ch(m,i-1,k,jc)                 
               cc(m,i,j2-1,k) = ch(m,i,k,j)+ch(m,i,k,jc)     
               cc(m,ic,j2-2,k) = ch(m,i,k,jc)-ch(m,i,k,j)    
 1042          continue                   
  142       continue   
  143    continue      
  144 continue         
      return           
      end              
      function pimach()                   
      pimach=3.14159265358979             
      return           
      end              
      subroutine hrfftb(m,n,r,mdimr,whrfft,work)
c                      
c     a multiple fft package for spherepack
c                      
      dimension     r(mdimr,n)  ,work(1)    ,whrfft(n+15)
      common /hrf/ tfft
      if (n .eq. 1) return                
c     tstart = second(dum)
      call hrftb1 (m,n,r,mdimr,work,whrfft,whrfft(n+1))
c     tfft = tfft+second(dum)-tstart
      return           
      end              
      subroutine hrftb1 (m,n,c,mdimc,ch,wa,fac)
c                      
c     a multiple fft package for spherepack
c                      
      dimension       ch(m,n), c(mdimc,n), wa(n) ,fac(15)
      nf = fac(2)      
      na = 0           
      l1 = 1           
      iw = 1           
      do 116 k1=1,nf   
         ip = fac(k1+2)                   
         l2 = ip*l1    
         ido = n/l2    
         idl1 = ido*l1                    
         if (ip .ne. 4) go to 103         
         ix2 = iw+ido                     
         ix3 = ix2+ido                    
         if (na .ne. 0) go to 101         
	 call hradb4 (m,ido,l1,c,mdimc,ch,m,wa(iw),wa(ix2),wa(ix3))
         go to 102     
  101    call hradb4 (m,ido,l1,ch,m,c,mdimc,wa(iw),wa(ix2),wa(ix3))
  102    na = 1-na     
         go to 115     
  103    if (ip .ne. 2) go to 106         
         if (na .ne. 0) go to 104         
	 call hradb2 (m,ido,l1,c,mdimc,ch,m,wa(iw))
         go to 105     
  104    call hradb2 (m,ido,l1,ch,m,c,mdimc,wa(iw))
  105    na = 1-na     
         go to 115     
  106    if (ip .ne. 3) go to 109         
         ix2 = iw+ido                     
         if (na .ne. 0) go to 107         
	 call hradb3 (m,ido,l1,c,mdimc,ch,m,wa(iw),wa(ix2))
         go to 108     
  107    call hradb3 (m,ido,l1,ch,m,c,mdimc,wa(iw),wa(ix2))
  108    na = 1-na     
         go to 115     
  109    if (ip .ne. 5) go to 112         
         ix2 = iw+ido                     
         ix3 = ix2+ido                    
         ix4 = ix3+ido                    
         if (na .ne. 0) go to 110         
      call hradb5 (m,ido,l1,c,mdimc,ch,m,wa(iw),wa(ix2),wa(ix3),wa(ix4))
         go to 111     
  110 call hradb5 (m,ido,l1,ch,m,c,mdimc,wa(iw),wa(ix2),wa(ix3),wa(ix4))
  111    na = 1-na     
         go to 115     
  112    if (na .ne. 0) go to 113         
	 call hradbg (m,ido,ip,l1,idl1,c,c,c,mdimc,ch,ch,m,wa(iw))
         go to 114     
  113    call hradbg (m,ido,ip,l1,idl1,ch,ch,ch,m,c,c,mdimc,wa(iw))
  114    if (ido .eq. 1) na = 1-na        
  115    l1 = l2       
         iw = iw+(ip-1)*ido               
  116 continue         
      if (na .eq. 0) return
      do 117 j=1,n     
      do 117 i=1,m     
	 c(i,j) = ch(i,j)
  117 continue         
      return           
      end              
      subroutine hradbg (mp,ido,ip,l1,idl1,cc,c1,c2,mdimcc,
     1          ch,ch2,mdimch,wa)
c                      
c     a multiple fft package for spherepack
c                      
      dimension    ch(mdimch,ido,l1,ip)    ,cc(mdimcc,ido,ip,l1) ,
     1           c1(mdimcc,ido,l1,ip)     ,c2(mdimcc,idl1,ip),
     2                ch2(mdimch,idl1,ip)       ,wa(ido)
      tpi=2.*pimach()                     
      arg = tpi/float(ip)                 
      dcp = cos(arg)   
      dsp = sin(arg)   
      idp2 = ido+2     
      nbd = (ido-1)/2                     
      ipp2 = ip+2      
      ipph = (ip+1)/2                     
      if (ido .lt. l1) go to 103          
      do 102 k=1,l1    
         do 101 i=1,ido                   
            do 1001 m=1,mp                
            ch(m,i,k,1) = cc(m,i,1,k)     
 1001       continue   
  101    continue      
  102 continue         
      go to 106        
  103 do 105 i=1,ido   
         do 104 k=1,l1                    
            do 1004 m=1,mp                
            ch(m,i,k,1) = cc(m,i,1,k)     
 1004       continue   
  104    continue      
  105 continue         
  106 do 108 j=2,ipph                     
         jc = ipp2-j   
         j2 = j+j      
         do 107 k=1,l1                    
            do 1007 m=1,mp                
            ch(m,1,k,j) = cc(m,ido,j2-2,k)+cc(m,ido,j2-2,k)  
            ch(m,1,k,jc) = cc(m,1,j2-1,k)+cc(m,1,j2-1,k)     
 1007       continue   
  107    continue      
  108 continue         
      if (ido .eq. 1) go to 116           
      if (nbd .lt. l1) go to 112          
      do 111 j=2,ipph                     
         jc = ipp2-j   
         do 110 k=1,l1                    
            do 109 i=3,ido,2              
               ic = idp2-i                
               do 1009 m=1,mp             
               ch(m,i-1,k,j) = cc(m,i-1,2*j-1,k)+cc(m,ic-1,2*j-2,k)             
               ch(m,i-1,k,jc) = cc(m,i-1,2*j-1,k)-cc(m,ic-1,2*j-2,k)            
               ch(m,i,k,j) = cc(m,i,2*j-1,k)-cc(m,ic,2*j-2,k)                   
               ch(m,i,k,jc) = cc(m,i,2*j-1,k)+cc(m,ic,2*j-2,k)                  
 1009          continue                   
  109       continue   
  110    continue      
  111 continue         
      go to 116        
  112 do 115 j=2,ipph                     
         jc = ipp2-j   
         do 114 i=3,ido,2                 
            ic = idp2-i                   
            do 113 k=1,l1                 
               do 1013 m=1,mp             
               ch(m,i-1,k,j) = cc(m,i-1,2*j-1,k)+cc(m,ic-1,2*j-2,k)             
               ch(m,i-1,k,jc) = cc(m,i-1,2*j-1,k)-cc(m,ic-1,2*j-2,k)            
               ch(m,i,k,j) = cc(m,i,2*j-1,k)-cc(m,ic,2*j-2,k)                   
               ch(m,i,k,jc) = cc(m,i,2*j-1,k)+cc(m,ic,2*j-2,k)                  
 1013          continue                   
  113       continue   
  114    continue      
  115 continue         
  116 ar1 = 1.         
      ai1 = 0.         
      do 120 l=2,ipph                     
         lc = ipp2-l   
         ar1h = dcp*ar1-dsp*ai1           
         ai1 = dcp*ai1+dsp*ar1            
         ar1 = ar1h    
         do 117 ik=1,idl1                 
            do 1017 m=1,mp                
            c2(m,ik,l) = ch2(m,ik,1)+ar1*ch2(m,ik,2)         
            c2(m,ik,lc) = ai1*ch2(m,ik,ip)                   
 1017       continue   
  117    continue      
         dc2 = ar1     
         ds2 = ai1     
         ar2 = ar1     
         ai2 = ai1     
         do 119 j=3,ipph                  
            jc = ipp2-j                   
            ar2h = dc2*ar2-ds2*ai2        
            ai2 = dc2*ai2+ds2*ar2         
            ar2 = ar2h                    
            do 118 ik=1,idl1              
               do 1018 m=1,mp             
               c2(m,ik,l) = c2(m,ik,l)+ar2*ch2(m,ik,j)       
               c2(m,ik,lc) = c2(m,ik,lc)+ai2*ch2(m,ik,jc)    
 1018          continue                   
  118       continue   
  119    continue      
  120 continue         
      do 122 j=2,ipph                     
         do 121 ik=1,idl1                 
            do 1021 m=1,mp                
            ch2(m,ik,1) = ch2(m,ik,1)+ch2(m,ik,j)            
 1021       continue   
  121    continue      
  122 continue         
      do 124 j=2,ipph                     
         jc = ipp2-j   
         do 123 k=1,l1                    
            do 1023 m=1,mp                
            ch(m,1,k,j) = c1(m,1,k,j)-c1(m,1,k,jc)           
            ch(m,1,k,jc) = c1(m,1,k,j)+c1(m,1,k,jc)          
 1023       continue   
  123    continue      
  124 continue         
      if (ido .eq. 1) go to 132           
      if (nbd .lt. l1) go to 128          
      do 127 j=2,ipph                     
         jc = ipp2-j   
         do 126 k=1,l1                    
            do 125 i=3,ido,2              
               do 1025 m=1,mp             
               ch(m,i-1,k,j) = c1(m,i-1,k,j)-c1(m,i,k,jc)    
               ch(m,i-1,k,jc) = c1(m,i-1,k,j)+c1(m,i,k,jc)   
               ch(m,i,k,j) = c1(m,i,k,j)+c1(m,i-1,k,jc)      
               ch(m,i,k,jc) = c1(m,i,k,j)-c1(m,i-1,k,jc)     
 1025          continue                   
  125       continue   
  126    continue      
  127 continue         
      go to 132        
  128 do 131 j=2,ipph                     
         jc = ipp2-j   
         do 130 i=3,ido,2                 
            do 129 k=1,l1                 
               do 1029 m=1,mp             
               ch(m,i-1,k,j) = c1(m,i-1,k,j)-c1(m,i,k,jc)    
               ch(m,i-1,k,jc) = c1(m,i-1,k,j)+c1(m,i,k,jc)   
               ch(m,i,k,j) = c1(m,i,k,j)+c1(m,i-1,k,jc)      
               ch(m,i,k,jc) = c1(m,i,k,j)-c1(m,i-1,k,jc)     
 1029          continue                   
  129       continue   
  130    continue      
  131 continue         
  132 continue         
      if (ido .eq. 1) return              
      do 133 ik=1,idl1                    
         do 1033 m=1,mp                   
         c2(m,ik,1) = ch2(m,ik,1)         
 1033    continue      
  133 continue         
      do 135 j=2,ip    
         do 134 k=1,l1                    
            do 1034 m=1,mp                
            c1(m,1,k,j) = ch(m,1,k,j)     
 1034       continue   
  134    continue      
  135 continue         
      if (nbd .gt. l1) go to 139          
      is = -ido        
      do 138 j=2,ip    
         is = is+ido   
         idij = is     
         do 137 i=3,ido,2                 
            idij = idij+2                 
            do 136 k=1,l1                 
               do 1036 m=1,mp             
               c1(m,i-1,k,j) = wa(idij-1)*ch(m,i-1,k,j)-wa(idij)*               
     1          ch(m,i,k,j)               
               c1(m,i,k,j) = wa(idij-1)*ch(m,i,k,j)+wa(idij)*                   
     1          ch(m,i-1,k,j)             
 1036          continue                   
  136       continue   
  137    continue      
  138 continue         
      go to 143        
  139 is = -ido        
      do 142 j=2,ip    
         is = is+ido   
         do 141 k=1,l1                    
            idij = is                     
            do 140 i=3,ido,2              
               idij = idij+2              
               do 1040 m=1,mp             
               c1(m,i-1,k,j) = wa(idij-1)*ch(m,i-1,k,j)-wa(idij)*               
     1          ch(m,i,k,j)               
               c1(m,i,k,j) = wa(idij-1)*ch(m,i,k,j)+wa(idij)*                   
     1          ch(m,i-1,k,j)             
 1040          continue                   
  140       continue   
  141    continue      
  142 continue         
  143 return           
      end              
      subroutine hradb4 (mp,ido,l1,cc,mdimcc,ch,mdimch,wa1,wa2,wa3)
c                      
c     a multiple fft package for spherepack
c                      
      dimension  cc(mdimcc,ido,4,l1)  ,ch(mdimch,ido,l1,4)    ,
     1                wa1(ido)  ,wa2(ido)  ,wa3(ido)         
      sqrt2=sqrt(2.)   
      do 101 k=1,l1    
          do 1001 m=1,mp                  
         ch(m,1,k,3) = (cc(m,1,1,k)+cc(m,ido,4,k))           
     1   -(cc(m,ido,2,k)+cc(m,ido,2,k))   
         ch(m,1,k,1) = (cc(m,1,1,k)+cc(m,ido,4,k))           
     1   +(cc(m,ido,2,k)+cc(m,ido,2,k))   
         ch(m,1,k,4) = (cc(m,1,1,k)-cc(m,ido,4,k))           
     1   +(cc(m,1,3,k)+cc(m,1,3,k))       
         ch(m,1,k,2) = (cc(m,1,1,k)-cc(m,ido,4,k))           
     1   -(cc(m,1,3,k)+cc(m,1,3,k))       
 1001     continue     
  101 continue         
      if (ido-2) 107,105,102              
  102 idp2 = ido+2     
      do 104 k=1,l1    
         do 103 i=3,ido,2                 
            ic = idp2-i                   
               do 1002 m=1,mp             
            ch(m,i-1,k,1) = (cc(m,i-1,1,k)+cc(m,ic-1,4,k))   
     1      +(cc(m,i-1,3,k)+cc(m,ic-1,2,k))                  
            ch(m,i,k,1) = (cc(m,i,1,k)-cc(m,ic,4,k))         
     1      +(cc(m,i,3,k)-cc(m,ic,2,k))   
            ch(m,i-1,k,2)=wa1(i-2)*((cc(m,i-1,1,k)-cc(m,ic-1,4,k))              
     1      -(cc(m,i,3,k)+cc(m,ic,2,k)))-wa1(i-1)            
     1      *((cc(m,i,1,k)+cc(m,ic,4,k))+(cc(m,i-1,3,k)-cc(m,ic-1,2,k)))        
            ch(m,i,k,2)=wa1(i-2)*((cc(m,i,1,k)+cc(m,ic,4,k)) 
     1      +(cc(m,i-1,3,k)-cc(m,ic-1,2,k)))+wa1(i-1)        
     1      *((cc(m,i-1,1,k)-cc(m,ic-1,4,k))-(cc(m,i,3,k)+cc(m,ic,2,k)))        
            ch(m,i-1,k,3)=wa2(i-2)*((cc(m,i-1,1,k)+cc(m,ic-1,4,k))              
     1      -(cc(m,i-1,3,k)+cc(m,ic-1,2,k)))-wa2(i-1)        
     1      *((cc(m,i,1,k)-cc(m,ic,4,k))-(cc(m,i,3,k)-cc(m,ic,2,k)))            
            ch(m,i,k,3)=wa2(i-2)*((cc(m,i,1,k)-cc(m,ic,4,k)) 
     1      -(cc(m,i,3,k)-cc(m,ic,2,k)))+wa2(i-1)            
     1      *((cc(m,i-1,1,k)+cc(m,ic-1,4,k))-(cc(m,i-1,3,k)  
     1      +cc(m,ic-1,2,k)))             
            ch(m,i-1,k,4)=wa3(i-2)*((cc(m,i-1,1,k)-cc(m,ic-1,4,k))              
     1      +(cc(m,i,3,k)+cc(m,ic,2,k)))-wa3(i-1)            
     1     *((cc(m,i,1,k)+cc(m,ic,4,k))-(cc(m,i-1,3,k)-cc(m,ic-1,2,k)))         
            ch(m,i,k,4)=wa3(i-2)*((cc(m,i,1,k)+cc(m,ic,4,k)) 
     1      -(cc(m,i-1,3,k)-cc(m,ic-1,2,k)))+wa3(i-1)        
     1      *((cc(m,i-1,1,k)-cc(m,ic-1,4,k))+(cc(m,i,3,k)+cc(m,ic,2,k)))        
 1002          continue                   
  103    continue      
  104 continue         
      if (mod(ido,2) .eq. 1) return       
  105 continue         
      do 106 k=1,l1    
               do 1003 m=1,mp             
         ch(m,ido,k,1) = (cc(m,ido,1,k)+cc(m,ido,3,k))       
     1   +(cc(m,ido,1,k)+cc(m,ido,3,k))   
         ch(m,ido,k,2) = sqrt2*((cc(m,ido,1,k)-cc(m,ido,3,k))                   
     1   -(cc(m,1,2,k)+cc(m,1,4,k)))      
         ch(m,ido,k,3) = (cc(m,1,4,k)-cc(m,1,2,k))           
     1   +(cc(m,1,4,k)-cc(m,1,2,k))       
         ch(m,ido,k,4) = -sqrt2*((cc(m,ido,1,k)-cc(m,ido,3,k))                  
     1   +(cc(m,1,2,k)+cc(m,1,4,k)))      
 1003          continue                   
  106 continue         
  107 return           
      end              
      subroutine hradb2 (mp,ido,l1,cc,mdimcc,ch,mdimch,wa1)
c                      
c     a multiple fft package for spherepack
c                      
      dimension  cc(mdimcc,ido,2,l1)    ,ch(mdimch,ido,l1,2),
     1                wa1(ido)            
      do 101 k=1,l1    
          do 1001 m=1,mp                  
         ch(m,1,k,1) = cc(m,1,1,k)+cc(m,ido,2,k)             
         ch(m,1,k,2) = cc(m,1,1,k)-cc(m,ido,2,k)             
 1001     continue     
  101 continue         
      if (ido-2) 107,105,102              
  102 idp2 = ido+2     
      do 104 k=1,l1    
         do 103 i=3,ido,2                 
            ic = idp2-i                   
               do 1002 m=1,mp             
            ch(m,i-1,k,1) = cc(m,i-1,1,k)+cc(m,ic-1,2,k)     
            ch(m,i,k,1) = cc(m,i,1,k)-cc(m,ic,2,k)           
            ch(m,i-1,k,2) = wa1(i-2)*(cc(m,i-1,1,k)-cc(m,ic-1,2,k))             
     1      -wa1(i-1)*(cc(m,i,1,k)+cc(m,ic,2,k))             
            ch(m,i,k,2) = wa1(i-2)*(cc(m,i,1,k)+cc(m,ic,2,k))+wa1(i-1)          
     1      *(cc(m,i-1,1,k)-cc(m,ic-1,2,k))                  
 1002          continue                   
  103    continue      
  104 continue         
      if (mod(ido,2) .eq. 1) return       
  105 do 106 k=1,l1    
          do 1003 m=1,mp                  
         ch(m,ido,k,1) = cc(m,ido,1,k)+cc(m,ido,1,k)         
         ch(m,ido,k,2) = -(cc(m,1,2,k)+cc(m,1,2,k))          
 1003     continue     
  106 continue         
  107 return           
      end              
      subroutine hradb3 (mp,ido,l1,cc,mdimcc,ch,mdimch,wa1,wa2)
c                      
c     a multiple fft package for spherepack
c                      
      dimension  cc(mdimcc,ido,3,l1)    ,ch(mdimch,ido,l1,3),
     1                wa1(ido)   ,wa2(ido)                   
      arg=2.*pimach()/3.                  
      taur=cos(arg)    
      taui=sin(arg)    
      do 101 k=1,l1    
          do 1001 m=1,mp                  
         ch(m,1,k,1) = cc(m,1,1,k)+2.*cc(m,ido,2,k)          
         ch(m,1,k,2) = cc(m,1,1,k)+(2.*taur)*cc(m,ido,2,k)   
     1   -(2.*taui)*cc(m,1,3,k)           
         ch(m,1,k,3) = cc(m,1,1,k)+(2.*taur)*cc(m,ido,2,k)   
     1   +2.*taui*cc(m,1,3,k)             
 1001     continue     
  101 continue         
      if (ido .eq. 1) return              
      idp2 = ido+2     
      do 103 k=1,l1    
         do 102 i=3,ido,2                 
            ic = idp2-i                   
               do 1002 m=1,mp             
            ch(m,i-1,k,1) = cc(m,i-1,1,k)+(cc(m,i-1,3,k)+cc(m,ic-1,2,k))        
            ch(m,i,k,1) = cc(m,i,1,k)+(cc(m,i,3,k)-cc(m,ic,2,k))                
            ch(m,i-1,k,2) = wa1(i-2)*     
     1 ((cc(m,i-1,1,k)+taur*(cc(m,i-1,3,k)+cc(m,ic-1,2,k)))- 
     * (taui*(cc(m,i,3,k)+cc(m,ic,2,k))))                    
     2                   -wa1(i-1)*       
     3 ((cc(m,i,1,k)+taur*(cc(m,i,3,k)-cc(m,ic,2,k)))+       
     * (taui*(cc(m,i-1,3,k)-cc(m,ic-1,2,k))))                
            ch(m,i,k,2) = wa1(i-2)*       
     4 ((cc(m,i,1,k)+taur*(cc(m,i,3,k)-cc(m,ic,2,k)))+       
     8 (taui*(cc(m,i-1,3,k)-cc(m,ic-1,2,k))))                
     5                  +wa1(i-1)*        
     6 ((cc(m,i-1,1,k)+taur*(cc(m,i-1,3,k)+cc(m,ic-1,2,k)))- 
     8 (taui*(cc(m,i,3,k)+cc(m,ic,2,k))))                    
              ch(m,i-1,k,3) = wa2(i-2)*   
     7 ((cc(m,i-1,1,k)+taur*(cc(m,i-1,3,k)+cc(m,ic-1,2,k)))+ 
     8 (taui*(cc(m,i,3,k)+cc(m,ic,2,k))))                    
     8   -wa2(i-1)*    
     9 ((cc(m,i,1,k)+taur*(cc(m,i,3,k)-cc(m,ic,2,k)))-       
     8 (taui*(cc(m,i-1,3,k)-cc(m,ic-1,2,k))))                
            ch(m,i,k,3) = wa2(i-2)*       
     1 ((cc(m,i,1,k)+taur*(cc(m,i,3,k)-cc(m,ic,2,k)))-       
     8 (taui*(cc(m,i-1,3,k)-cc(m,ic-1,2,k))))                
     2                 +wa2(i-1)*         
     3 ((cc(m,i-1,1,k)+taur*(cc(m,i-1,3,k)+cc(m,ic-1,2,k)))+ 
     8 (taui*(cc(m,i,3,k)+cc(m,ic,2,k))))                    
 1002          continue                   
  102    continue      
  103 continue         
      return           
      end              
      subroutine hradb5 (mp,ido,l1,cc,mdimcc,ch,mdimch,
     1       wa1,wa2,wa3,wa4)
c                      
c     a multiple fft package for spherepack
c                      
      dimension  cc(mdimcc,ido,5,l1)    ,ch(mdimch,ido,l1,5),
     1             wa1(ido)     ,wa2(ido)     ,wa3(ido)     ,wa4(ido)           
      arg=2.*pimach()/5.                  
      tr11=cos(arg)    
      ti11=sin(arg)    
      tr12=cos(2.*arg)                    
      ti12=sin(2.*arg)                    
      do 101 k=1,l1    
      do 1001 m=1,mp   
         ch(m,1,k,1) = cc(m,1,1,k)+2.*cc(m,ido,2,k)+2.*cc(m,ido,4,k)            
         ch(m,1,k,2) = (cc(m,1,1,k)+tr11*2.*cc(m,ido,2,k)    
     1   +tr12*2.*cc(m,ido,4,k))-(ti11*2.*cc(m,1,3,k)        
     1   +ti12*2.*cc(m,1,5,k))            
         ch(m,1,k,3) = (cc(m,1,1,k)+tr12*2.*cc(m,ido,2,k)    
     1   +tr11*2.*cc(m,ido,4,k))-(ti12*2.*cc(m,1,3,k)        
     1   -ti11*2.*cc(m,1,5,k))            
         ch(m,1,k,4) = (cc(m,1,1,k)+tr12*2.*cc(m,ido,2,k)    
     1   +tr11*2.*cc(m,ido,4,k))+(ti12*2.*cc(m,1,3,k)        
     1   -ti11*2.*cc(m,1,5,k))            
         ch(m,1,k,5) = (cc(m,1,1,k)+tr11*2.*cc(m,ido,2,k)    
     1   +tr12*2.*cc(m,ido,4,k))+(ti11*2.*cc(m,1,3,k)        
     1   +ti12*2.*cc(m,1,5,k))            
 1001          continue                   
  101 continue         
      if (ido .eq. 1) return              
      idp2 = ido+2     
      do 103 k=1,l1    
         do 102 i=3,ido,2                 
            ic = idp2-i                   
      do 1002 m=1,mp   
            ch(m,i-1,k,1) = cc(m,i-1,1,k)+(cc(m,i-1,3,k)+cc(m,ic-1,2,k))        
     1      +(cc(m,i-1,5,k)+cc(m,ic-1,4,k))                  
            ch(m,i,k,1) = cc(m,i,1,k)+(cc(m,i,3,k)-cc(m,ic,2,k))                
     1      +(cc(m,i,5,k)-cc(m,ic,4,k))   
            ch(m,i-1,k,2) = wa1(i-2)*((cc(m,i-1,1,k)+tr11*   
     1      (cc(m,i-1,3,k)+cc(m,ic-1,2,k))+tr12              
     1      *(cc(m,i-1,5,k)+cc(m,ic-1,4,k)))-(ti11*(cc(m,i,3,k)                 
     1      +cc(m,ic,2,k))+ti12*(cc(m,i,5,k)+cc(m,ic,4,k)))) 
     1      -wa1(i-1)*((cc(m,i,1,k)+tr11*(cc(m,i,3,k)-cc(m,ic,2,k))             
     1      +tr12*(cc(m,i,5,k)-cc(m,ic,4,k)))+(ti11*(cc(m,i-1,3,k)              
     1      -cc(m,ic-1,2,k))+ti12*(cc(m,i-1,5,k)-cc(m,ic-1,4,k))))              
            ch(m,i,k,2) = wa1(i-2)*((cc(m,i,1,k)+tr11*(cc(m,i,3,k)              
     1      -cc(m,ic,2,k))+tr12*(cc(m,i,5,k)-cc(m,ic,4,k)))  
     1      +(ti11*(cc(m,i-1,3,k)-cc(m,ic-1,2,k))+ti12       
     1      *(cc(m,i-1,5,k)-cc(m,ic-1,4,k))))+wa1(i-1)       
     1      *((cc(m,i-1,1,k)+tr11*(cc(m,i-1,3,k)             
     1      +cc(m,ic-1,2,k))+tr12*(cc(m,i-1,5,k)+cc(m,ic-1,4,k)))               
     1      -(ti11*(cc(m,i,3,k)+cc(m,ic,2,k))+ti12           
     1      *(cc(m,i,5,k)+cc(m,ic,4,k))))                    
            ch(m,i-1,k,3) = wa2(i-2)      
     1      *((cc(m,i-1,1,k)+tr12*(cc(m,i-1,3,k)+cc(m,ic-1,2,k))                
     1      +tr11*(cc(m,i-1,5,k)+cc(m,ic-1,4,k)))-(ti12*(cc(m,i,3,k)            
     1      +cc(m,ic,2,k))-ti11*(cc(m,i,5,k)+cc(m,ic,4,k)))) 
     1     -wa2(i-1)   
     1     *((cc(m,i,1,k)+tr12*(cc(m,i,3,k)-                 
     1      cc(m,ic,2,k))+tr11*(cc(m,i,5,k)-cc(m,ic,4,k)))   
     1      +(ti12*(cc(m,i-1,3,k)-cc(m,ic-1,2,k))-ti11       
     1      *(cc(m,i-1,5,k)-cc(m,ic-1,4,k))))                
            ch(m,i,k,3) = wa2(i-2)        
     1     *((cc(m,i,1,k)+tr12*(cc(m,i,3,k)-                 
     1      cc(m,ic,2,k))+tr11*(cc(m,i,5,k)-cc(m,ic,4,k)))   
     1      +(ti12*(cc(m,i-1,3,k)-cc(m,ic-1,2,k))-ti11       
     1      *(cc(m,i-1,5,k)-cc(m,ic-1,4,k))))                
     1      +wa2(i-1)                     
     1      *((cc(m,i-1,1,k)+tr12*(cc(m,i-1,3,k)+cc(m,ic-1,2,k))                
     1      +tr11*(cc(m,i-1,5,k)+cc(m,ic-1,4,k)))-(ti12*(cc(m,i,3,k)            
     1      +cc(m,ic,2,k))-ti11*(cc(m,i,5,k)+cc(m,ic,4,k)))) 
            ch(m,i-1,k,4) = wa3(i-2)      
     1      *((cc(m,i-1,1,k)+tr12*(cc(m,i-1,3,k)+cc(m,ic-1,2,k))                
     1      +tr11*(cc(m,i-1,5,k)+cc(m,ic-1,4,k)))+(ti12*(cc(m,i,3,k)            
     1      +cc(m,ic,2,k))-ti11*(cc(m,i,5,k)+cc(m,ic,4,k)))) 
     1      -wa3(i-1)                     
     1     *((cc(m,i,1,k)+tr12*(cc(m,i,3,k)-                 
     1      cc(m,ic,2,k))+tr11*(cc(m,i,5,k)-cc(m,ic,4,k)))   
     1      -(ti12*(cc(m,i-1,3,k)-cc(m,ic-1,2,k))-ti11       
     1      *(cc(m,i-1,5,k)-cc(m,ic-1,4,k))))                
            ch(m,i,k,4) = wa3(i-2)        
     1     *((cc(m,i,1,k)+tr12*(cc(m,i,3,k)-                 
     1      cc(m,ic,2,k))+tr11*(cc(m,i,5,k)-cc(m,ic,4,k)))   
     1      -(ti12*(cc(m,i-1,3,k)-cc(m,ic-1,2,k))-ti11       
     1      *(cc(m,i-1,5,k)-cc(m,ic-1,4,k))))                
     1      +wa3(i-1)                     
     1      *((cc(m,i-1,1,k)+tr12*(cc(m,i-1,3,k)+cc(m,ic-1,2,k))                
     1      +tr11*(cc(m,i-1,5,k)+cc(m,ic-1,4,k)))+(ti12*(cc(m,i,3,k)            
     1      +cc(m,ic,2,k))-ti11*(cc(m,i,5,k)+cc(m,ic,4,k)))) 
            ch(m,i-1,k,5) = wa4(i-2)      
     1      *((cc(m,i-1,1,k)+tr11*(cc(m,i-1,3,k)+cc(m,ic-1,2,k))                
     1      +tr12*(cc(m,i-1,5,k)+cc(m,ic-1,4,k)))+(ti11*(cc(m,i,3,k)            
     1      +cc(m,ic,2,k))+ti12*(cc(m,i,5,k)+cc(m,ic,4,k)))) 
     1      -wa4(i-1)                     
     1      *((cc(m,i,1,k)+tr11*(cc(m,i,3,k)-cc(m,ic,2,k))   
     1      +tr12*(cc(m,i,5,k)-cc(m,ic,4,k)))-(ti11*(cc(m,i-1,3,k)              
     1      -cc(m,ic-1,2,k))+ti12*(cc(m,i-1,5,k)-cc(m,ic-1,4,k))))              
            ch(m,i,k,5) = wa4(i-2)        
     1      *((cc(m,i,1,k)+tr11*(cc(m,i,3,k)-cc(m,ic,2,k))   
     1      +tr12*(cc(m,i,5,k)-cc(m,ic,4,k)))-(ti11*(cc(m,i-1,3,k)              
     1      -cc(m,ic-1,2,k))+ti12*(cc(m,i-1,5,k)-cc(m,ic-1,4,k))))              
     1      +wa4(i-1)                     
     1      *((cc(m,i-1,1,k)+tr11*(cc(m,i-1,3,k)+cc(m,ic-1,2,k))                
     1      +tr12*(cc(m,i-1,5,k)+cc(m,ic-1,4,k)))+(ti11*(cc(m,i,3,k)            
     1      +cc(m,ic,2,k))+ti12*(cc(m,i,5,k)+cc(m,ic,4,k)))) 
 1002          continue                   
  102    continue      
  103 continue         
      return           
      end              

!
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file idvtec.f
!
!     this file includes documentation and code for
!     subroutine idvtec         i
!
! ... files which must be loaded with idvtec.f
!
!     sphcom.f, hrfft.f, vhsec.f,shaec.f
!
!
!     subroutine idvtec(nlat,nlon,isym,nt,v,w,idvw,jdvw,ad,bd,av,bv,
!    +mdab,ndab,wvhsec,lvhsec,work,lwork,pertbd,pertbv,ierror)
!
!     given the scalar spherical harmonic coefficients ad,bd precomputed
!     by subroutine shaec for the scalar field divg and coefficients av,bv
!     precomputed by subroutine shaec for the scalar field vort, subroutine
!     idvtec computes a vector field (v,w) whose divergence is divg - pertbd
!     and whose vorticity is vort - pertbv.  w the is east longitude component
!     and v is the colatitudinal component of the velocity.  if nt=1 (see nt
!     below) pertrbd and pertbv are constants which must be subtracted from
!     divg and vort for (v,w) to exist (see the description of pertbd and
!     pertrbv below).  usually pertbd and pertbv are zero or small relative
!     to divg and vort.  w(i,j) and v(i,j) are the velocity components at
!     colatitude
!
!            theta(i) = (i-1)*pi/(nlat-1)
!
!     and longitude
!
!            lambda(j) = (j-1)*2*pi/nlon
!
!     the
!
!            divergence(v(i,j),w(i,j))
!
!         =  [d(sint*v)/dtheta + dw/dlambda]/sint
!
!         =  divg(i,j) - pertbd
!
!     and
!
!            vorticity(v(i,j),w(i,j))
!
!         =  [-dv/dlambda + d(sint*w)/dtheta]/sint
!
!         =  vort(i,j) - pertbv
!
!     where
!
!            sint = cos(theta(i)).
!
!
!     input parameters
!
!     nlat   the number of colatitudes on the full sphere including the
!            poles. for example, nlat = 37 for a five degree grid.
!            nlat determines the grid increment in colatitude as
!            pi/(nlat-1).  if nlat is odd the equator is located at
!            grid point i=(nlat+1)/2. if nlat is even the equator is
!            located half way between points i=nlat/2 and i=nlat/2+1.
!            nlat must be at least 3. note: on the half sphere, the
!            number of grid points in the colatitudinal direction is
!            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than 3. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!
!     isym   isym determines whether (v,w) are computed on the full or half
!            sphere as follows:
!
!      = 0
!            divg,vort are neither pairwise symmetric/antisymmetric nor
!            antisymmetric/symmetric about the equator as described for
!            isym = 1 or isym = 2  below.  in this case, the vector field
!            (v,w) is computed on the entire sphere.  i.e., in the arrays
!            w(i,j) and v(i,j) i=1,...,nlat and j=1,...,nlon.
!
!      = 1
!
!            divg is antisymmetric and vort is symmetric about the equator.
!            in this case w is antisymmetric and v is symmetric about the
!            equator.  w and v are computed on the northern hemisphere only.
!            if nlat is odd they are computed for i=1,...,(nlat+1)/2
!            and j=1,...,nlon.  if nlat is even they are computed for
!            i=1,...,nlat/2 and j=1,...,nlon.
!
!      = 2
!
!            divg is symmetric and vort is antisymmetric about the equator.
!            in this case w is symmetric and v is antisymmetric about the
!            equator.  w and v are computed on the northern hemisphere only.
!            if nlat is odd they are computed for i=1,...,(nlat+1)/2
!            and j=1,...,nlon.  if nlat is even they are computed for
!            i=1,...,nlat/2 and j=1,...,nlon.
!
!
!     nt     in the program that calls idvtec, nt is the number of scalar
!            and vector fields.  some computational efficiency is obtained
!            for multiple fields.  the arrays ad,bd,av,bv,u, and v can be
!            three dimensional and pertbd,pertbv can be one dimensional
!            corresponding to indexed multiple arrays divg, vort.  in this
!            case, multiple synthesis will be performed to compute each
!            vector field.  the third index for ad,bd,av,bv,v,w and first
!            pertrbd,pertbv is the synthesis index which assumes the values
!            k=1,...,nt.  for a single synthesis set nt=1. the description of
!            remaining parameters is simplified by assuming that nt=1 or that
!            ad,bd,av,bv,v,w are two dimensional and pertbd,pertbv are
!            constants.
!
!     idvw   the first dimension of the arrays v,w as it appears in
!            the program that calls idvtec. if isym = 0 then idvw
!            must be at least nlat.  if isym = 1 or 2 and nlat is
!            even then idvw must be at least nlat/2. if isym = 1 or 2
!            and nlat is odd then idvw must be at least (nlat+1)/2.
!
!     jdvw   the second dimension of the arrays v,w as it appears in
!            the program that calls idvtec. jdvw must be at least nlon.
!
!     ad,bd  two or three dimensional arrays (see input parameter nt)
!            that contain scalar spherical harmonic coefficients
!            of the divergence array divg as computed by subroutine shaec.
!
!     av,bv  two or three dimensional arrays (see input parameter nt)
!            that contain scalar spherical harmonic coefficients
!            of the vorticity array vort as computed by subroutine shaec.
!     ***    ad,bd,av,bv must be computed by shaec prior to calling idvtec.
!
!     mdab   the first dimension of the arrays ad,bd,av,bv as it appears
!            in the program that calls idvtec (and shaec). mdab must be at
!            least min0(nlat,(nlon+2)/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndab   the second dimension of the arrays ad,bd,av,bv as it appears in
!            the program that calls idvtec (and shaec). ndab must be at
!            least nlat.
!
!  wvhsec    an array which must be initialized by subroutine vhseci.
!            wvhsec can be used repeatedly by idvtec as long as nlon
!            and nlat remain unchanged.  wvhsec must not be altered
!            between calls of idvtec.
!
!
!  lvhsec    the dimension of the array wvhsec as it appears in the
!            program that calls idvtec. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lvhsec must be at least
!
!               4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
!
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls idvtec. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2                  if nlat is even or
!               l2 = (nlat+1)/2              if nlat is odd
!
!
!            if isym = 0 then lwork must be at least
!
!                nlat*(2*nt*nlon+max0(6*l2,nlon)) + nlat*(4*l1*nt+1)
!
!            if isym = 1 or 2 then lwork must be at least
!
!                l2*(2*nt*nlon+max0(6*nlat,nlon)) + nlat*(4*l1*nt+1)
!
!
!
!     **************************************************************
!
!     output parameters
!
!
!     v,w   two or three dimensional arrays (see input parameter nt) that
!           contain a vector field whose divergence is divg - pertbd and
!           whose vorticity is vort - pertbv.  w(i,j) is the east longitude
!           component and v(i,j) is the colatitudinal component of velocity
!           at the colatitude theta(i) = (i-1)*pi/(nlat-1) and longitude
!           lambda(j) = (j-1)*2*pi/nlon for i=1,...,nlat and j=1,...,nlon.
!
!   pertbd  a nt dimensional array (see input parameter nt and assume nt=1
!           for the description that follows).  divg - pertbd is a scalar
!           field which can be the divergence of a vector field (v,w).
!           pertbd is related to the scalar harmonic coefficients ad,bd
!           of divg (computed by shaec) by the formula
!
!                pertbd = ad(1,1)/(2.*sqrt(2.))
!
!           an unperturbed divg can be the divergence of a vector field
!           only if ad(1,1) is zero.  if ad(1,1) is nonzero (flagged by
!           pertbd nonzero) then subtracting pertbd from divg yields a
!           scalar field for which ad(1,1) is zero.  usually pertbd is
!           zero or small relative to divg.
!
!   pertbv a nt dimensional array (see input parameter nt and assume nt=1
!           for the description that follows).  vort - pertbv is a scalar
!           field which can be the vorticity of a vector field (v,w).
!           pertbv is related to the scalar harmonic coefficients av,bv
!           of vort (computed by shaec) by the formula
!
!                pertbv = av(1,1)/(2.*sqrt(2.))
!
!           an unperturbed vort can be the vorticity of a vector field
!           only if av(1,1) is zero.  if av(1,1) is nonzero (flagged by
!           pertbv nonzero) then subtracting pertbv from vort yields a
!           scalar field for which av(1,1) is zero.  usually pertbv is
!           zero or small relative to vort.
!
!    ierror = 0  no errors
!           = 1  error in the specification of nlat
!           = 2  error in the specification of nlon
!           = 3  error in the specification of isym
!           = 4  error in the specification of nt
!           = 5  error in the specification of idvw
!           = 6  error in the specification of jdvw
!           = 7  error in the specification of mdab
!           = 8  error in the specification of ndab
!           = 9  error in the specification of lvhsec
!           = 10 error in the specification of lwork
! **********************************************************************

      SUBROUTINE IDVTEC(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Ad,Bd,Av,Bv,    &
                      & Mdab,Ndab,Wvhsec,Lvhsec,Work,Lwork,Pertbd,      &
                      & Pertbv,Ierror)
      IMPLICIT NONE

      REAL Ad , Av , Bd , Bv , Pertbd , Pertbv , V , W , Work , Wvhsec
      INTEGER ibi , ibr , ici , icr , Idvw , Ierror , imid , is , Isym ,&
            & iwk , Jdvw , labc , liwk , Lvhsec , Lwork , lzz1 , Mdab , &
            & mmax , mn , Ndab
      INTEGER Nlat , Nlon , Nt
      DIMENSION W(Idvw,Jdvw,Nt) , V(Idvw,Jdvw,Nt) , Pertbd(Nt) ,        &
              & Pertbv(Nt)
      DIMENSION Ad(Mdab,Ndab,Nt) , Bd(Mdab,Ndab,Nt)
      DIMENSION Av(Mdab,Ndab,Nt) , Bv(Mdab,Ndab,Nt)
      DIMENSION Wvhsec(Lvhsec) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idvw<Nlat) .OR. (Isym/=0 .AND. Idvw<imid) )   &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<MIN0(Nlat,(Nlon+2)/2) ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lvhsec<2*(lzz1+labc)+Nlon+15 ) RETURN
      Ierror = 10
!
!     verify unsaved work space length
!
      mn = mmax*Nlat*Nt
      IF ( Isym/=0 .AND. Lwork<Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon))       &
         & +4*mn+Nlat ) RETURN
      IF ( Isym==0 .AND. Lwork<imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon))       &
         & +4*mn+Nlat ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ibr = 1
      ibi = ibr + mn
      icr = ibi + mn
      ici = icr + mn
      is = ici + mn
      iwk = is + Nlat
      liwk = Lwork - 4*mn - Nlat
      CALL IDVTEC1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Work(ibr),Work(ibi), &
                 & Work(icr),Work(ici),mmax,Work(is),Mdab,Ndab,Ad,Bd,Av,&
                 & Bv,Wvhsec,Lvhsec,Work(iwk),liwk,Pertbd,Pertbv,Ierror)
    END SUBROUTINE IDVTEC

    
    SUBROUTINE IDVTEC1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,  &
                        & Mmax,Sqnn,Mdab,Ndab,Ad,Bd,Av,Bv,Wvhsec,Lvhsec,&
                        & Wk,Lwk,Pertbd,Pertbv,Ierror)
      IMPLICIT NONE
      INTEGER Idvw , Ierror , Isym , ityp , Jdvw , k , Lvhsec , Lwk ,   &
           & m , Mdab , Mmax , n , Ndab , Nlat , Nlon , Nt
      
      REAL V
      REAL W
      REAL Br
      REAL Bi
      REAL Cr
      REAL Ci
      REAL Sqnn
      REAL Ad
      REAL Bd
      REAL Av
      REAL Bv
      REAL Wvhsec
      REAL Wk
      REAL Pertbd
      REAL Pertbv
      REAL fn
      DIMENSION W(Idvw,Jdvw,Nt) , V(Idvw,Jdvw,Nt)
      DIMENSION Br(Mmax,Nlat,Nt) , Bi(Mmax,Nlat,Nt) , Sqnn(Nlat)
      DIMENSION Cr(Mmax,Nlat,Nt) , Ci(Mmax,Nlat,Nt)
      DIMENSION Ad(Mdab,Ndab,Nt) , Bd(Mdab,Ndab,Nt)
      DIMENSION Av(Mdab,Ndab,Nt) , Bv(Mdab,Ndab,Nt)
      DIMENSION Wvhsec(Lvhsec) , Wk(Lwk)
      DIMENSION Pertbd(Nt) , Pertbv(Nt)
!
!     preset coefficient multiplyers in vector
!
      DO n = 2 , Nlat
         fn = DBLE(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.D0))
      ENDDO
!
!     compute multiple vector fields coefficients
!
      DO k = 1 , Nt
!
!     set divergence,vorticity perturbation constants
!
         Pertbd(k) = Ad(1,1,k)/(2.D0*SQRT(2.D0))
         Pertbv(k) = Av(1,1,k)/(2.D0*SQRT(2.D0))
!
!     preset br,bi,cr,ci to 0.0
!
         DO n = 1 , Nlat
            DO m = 1 , Mmax
               Br(m,n,k) = 0.0D0
               Bi(m,n,k) = 0.0D0
               Cr(m,n,k) = 0.0D0
               Ci(m,n,k) = 0.0D0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            Br(1,n,k) = -Ad(1,n,k)/Sqnn(n)
            Bi(1,n,k) = -Bd(1,n,k)/Sqnn(n)
            Cr(1,n,k) = Av(1,n,k)/Sqnn(n)
            Ci(1,n,k) = Bv(1,n,k)/Sqnn(n)
         ENDDO
!
!     compute m>0 coefficients
!
         DO m = 2 , Mmax
            DO n = m , Nlat
               Br(m,n,k) = -Ad(m,n,k)/Sqnn(n)
               Bi(m,n,k) = -Bd(m,n,k)/Sqnn(n)
               Cr(m,n,k) = Av(m,n,k)/Sqnn(n)
               Ci(m,n,k) = Bv(m,n,k)/Sqnn(n)
            ENDDO
         ENDDO
      ENDDO
!
!     set ityp for vector synthesis without assuming div=0 or curl=0
!
      IF ( Isym==0 ) THEN
         ityp = 0
      ELSEIF ( Isym==1 ) THEN
         ityp = 3
      ELSEIF ( Isym==2 ) THEN
         ityp = 6
      ENDIF
!
!     sythesize br,bi,cr,ci into the vector field (v,w)
!
      CALL VHSEC(Nlat,Nlon,ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,Mmax,Nlat,&
                & Wvhsec,Lvhsec,Wk,Lwk,Ierror)
      END SUBROUTINE IDVTEC1

      
    SUBROUTINE DIDVTEC(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Ad,Bd,Av,Bv,    &
                      & Mdab,Ndab,Wvhsec,Lvhsec,Work,Lwork,Pertbd,      &
                      & Pertbv,Ierror)
      IMPLICIT NONE

      DOUBLE PRECISION Ad , Av , Bd , Bv , Pertbd , Pertbv , V , W , Work , Wvhsec
      INTEGER ibi , ibr , ici , icr , Idvw , Ierror , imid , is , Isym ,&
            & iwk , Jdvw , labc , liwk , Lvhsec , Lwork , lzz1 , Mdab , &
            & mmax , mn , Ndab
      INTEGER Nlat , Nlon , Nt
      DIMENSION W(Idvw,Jdvw,Nt) , V(Idvw,Jdvw,Nt) , Pertbd(Nt) ,        &
              & Pertbv(Nt)
      DIMENSION Ad(Mdab,Ndab,Nt) , Bd(Mdab,Ndab,Nt)
      DIMENSION Av(Mdab,Ndab,Nt) , Bv(Mdab,Ndab,Nt)
      DIMENSION Wvhsec(Lvhsec) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idvw<Nlat) .OR. (Isym/=0 .AND. Idvw<imid) )   &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<MIN0(Nlat,(Nlon+2)/2) ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lvhsec<2*(lzz1+labc)+Nlon+15 ) RETURN
      Ierror = 10
!
!     verify unsaved work space length
!
      mn = mmax*Nlat*Nt
      IF ( Isym/=0 .AND. Lwork<Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon))       &
         & +4*mn+Nlat ) RETURN
      IF ( Isym==0 .AND. Lwork<imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon))       &
         & +4*mn+Nlat ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ibr = 1
      ibi = ibr + mn
      icr = ibi + mn
      ici = icr + mn
      is = ici + mn
      iwk = is + Nlat
      liwk = Lwork - 4*mn - Nlat
      CALL DIDVTEC1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Work(ibr),Work(ibi), &
                 & Work(icr),Work(ici),mmax,Work(is),Mdab,Ndab,Ad,Bd,Av,&
                 & Bv,Wvhsec,Lvhsec,Work(iwk),liwk,Pertbd,Pertbv,Ierror)
      END SUBROUTINE DIDVTEC

      
      SUBROUTINE DIDVTEC1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,  &
                        & Mmax,Sqnn,Mdab,Ndab,Ad,Bd,Av,Bv,Wvhsec,Lvhsec,&
                        & Wk,Lwk,Pertbd,Pertbv,Ierror)
      IMPLICIT NONE
      INTEGER Idvw , Ierror , Isym , ityp , Jdvw , k , Lvhsec , Lwk ,   &
            & m , Mdab , Mmax , n , Ndab , Nlat , Nlon , Nt
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION Br
      DOUBLE PRECISION Bi
      DOUBLE PRECISION Cr
      DOUBLE PRECISION Ci
      DOUBLE PRECISION Sqnn
      DOUBLE PRECISION Ad
      DOUBLE PRECISION Bd
      DOUBLE PRECISION Av
      DOUBLE PRECISION Bv
      DOUBLE PRECISION Wvhsec
      DOUBLE PRECISION Wk
      DOUBLE PRECISION Pertbd
      DOUBLE PRECISION Pertbv
      DOUBLE PRECISION fn
      DIMENSION W(Idvw,Jdvw,Nt) , V(Idvw,Jdvw,Nt)
      DIMENSION Br(Mmax,Nlat,Nt) , Bi(Mmax,Nlat,Nt) , Sqnn(Nlat)
      DIMENSION Cr(Mmax,Nlat,Nt) , Ci(Mmax,Nlat,Nt)
      DIMENSION Ad(Mdab,Ndab,Nt) , Bd(Mdab,Ndab,Nt)
      DIMENSION Av(Mdab,Ndab,Nt) , Bv(Mdab,Ndab,Nt)
      DIMENSION Wvhsec(Lvhsec) , Wk(Lwk)
      DIMENSION Pertbd(Nt) , Pertbv(Nt)
!
!     preset coefficient multiplyers in vector
!
      DO n = 2 , Nlat
         fn = DBLE(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.D0))
      ENDDO
!
!     compute multiple vector fields coefficients
!
      DO k = 1 , Nt
!
!     set divergence,vorticity perturbation constants
!
         Pertbd(k) = Ad(1,1,k)/(2.D0*SQRT(2.D0))
         Pertbv(k) = Av(1,1,k)/(2.D0*SQRT(2.D0))
!
!     preset br,bi,cr,ci to 0.0
!
         DO n = 1 , Nlat
            DO m = 1 , Mmax
               Br(m,n,k) = 0.0D0
               Bi(m,n,k) = 0.0D0
               Cr(m,n,k) = 0.0D0
               Ci(m,n,k) = 0.0D0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            Br(1,n,k) = -Ad(1,n,k)/Sqnn(n)
            Bi(1,n,k) = -Bd(1,n,k)/Sqnn(n)
            Cr(1,n,k) = Av(1,n,k)/Sqnn(n)
            Ci(1,n,k) = Bv(1,n,k)/Sqnn(n)
         ENDDO
!
!     compute m>0 coefficients
!
         DO m = 2 , Mmax
            DO n = m , Nlat
               Br(m,n,k) = -Ad(m,n,k)/Sqnn(n)
               Bi(m,n,k) = -Bd(m,n,k)/Sqnn(n)
               Cr(m,n,k) = Av(m,n,k)/Sqnn(n)
               Ci(m,n,k) = Bv(m,n,k)/Sqnn(n)
            ENDDO
         ENDDO
      ENDDO
!
!     set ityp for vector synthesis without assuming div=0 or curl=0
!
      IF ( Isym==0 ) THEN
         ityp = 0
      ELSEIF ( Isym==1 ) THEN
         ityp = 3
      ELSEIF ( Isym==2 ) THEN
         ityp = 6
      ENDIF
!
!     sythesize br,bi,cr,ci into the vector field (v,w)
!
      CALL DVHSEC(Nlat,Nlon,ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,Mmax,Nlat,&
                & Wvhsec,Lvhsec,Wk,Lwk,Ierror)
      END SUBROUTINE DIDVTEC1

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vshifte.f contains code and documentation for subroutine vshifte
c     and its initialization subroutine vshifti
c
c ... required files
c
c     hrfft.f
c
c     subroutine vshifte(ioff,nlon,nlat,uoff,voff,ureg,vreg,
c    +                   wsave,lsave,work,lwork,ierror)
c
c *** purpose
c
c     subroutine vshifte does a highly accurate 1/2 grid increment shift
c     in both longitude and latitude of equally spaced vector data on the
c     sphere. data is transferred between the nlon by nlat "offset grid"
c     in (uoff,voff) (which excludes poles) and the nlon by nlat+1 "regular
c     grid" in (ureg,vreg) (which includes poles).  the transfer can go from
c     (uoff,voff) to (ureg,vreg) or vice versa (see ioff).  the grids which
c     underly the vector fields are described below.  the north and south
c     pole are at 0.5*pi and-0.5*pi radians respectively (pi=4.*atan(1.)).
c     uoff and ureg are the east longitudinal vector data components.  voff
c     and vreg are the latitudinal vector data components.
c
c     subroutine sshifte can be used to shift scalar data on the sphere.
c     notice that scalar and vector quantities are fundamentally different
c     on the sphere.  for example, vectors are discontinuous and multiple
c     valued at the poles.  scalars are continuous and single valued at the
c     poles. erroneous results would be produced if one attempted to shift
c     vector fields with subroutine sshifte applied to each component of
c     of the vector.
c
c *** grid descriptions
c
c     let dlon = (pi+pi)/nlon and dlat = pi/nlat be the uniform grid
c     increments in longitude and latitude
c
c     offset grid
c
c     the "1/2 increment offset" grid (long(j),lat(i)) on which uoff(j,i)
c     and voff(j,i) are given (ioff=0) or generated (ioff=1) is
c
c          long(j) =0.5*dlon + (j-1)*dlon  (j=1,...,nlon)
c
c     and
c
c          lat(i) = -0.5*pi + 0.5*dlat + (i-1)*dlat (i=1,...,nlat)
c
c     the data in (uoff,voff) is "shifted" one half a grid increment in both
c     longitude and latitude and excludes the poles.  each uoff(j,1),voff(j,1)
c     is given at latitude -pi/2+dlat/2.  uoff(j,nlat),voff(j,nlat) is
c     given at pi/2-dlat/2 (1/2 a grid increment away from the poles).
c     uoff(1,i),voff(1,i) is given at longitude dlon/2.  each uoff(nlon,i),
c     voff(nlon,i) is given at longitude 2*pi-dlon/2.
c
c     regular grid
c
c     let dlat,dlon be as above.  then the nlon by nlat+1 grid on which
c     ureg(j,i),vreg(j,i) are generated (ioff=0) or given (ioff=1) is
c
c          lone(j) = (j-1)*dlon (j=1,...,nlon)
c
c      and
c
c          late(i) = -0.5*pi + (i-1)*dlat (i=1,...,nlat+1)
c
c     values in ureg,vreg include the poles and start at zero degrees
c     longitude and at the south pole this is the "usual" equally spaced
c     grid in geophysical coordinates.
c
c *** remark
c
c     subroutine vshifte can be used in conjunction with subroutine trvsph
c     when transferring vector data from an equally spaced "1/2 increment
c     offset" grid to a gaussian or equally spaced grid (which includes poles)
c     of any resolution.  this problem (personal communication with dennis
c     shea) is encountered in geophysical modeling and data analysis.
c
c *** method
c
c     fast fourier transform software from spherepack2 and trigonometric
c     identities are used to accurately "shift" periodic vectors half a
c     grid increment in latitude and longitude.  latitudinal shifts are
c     accomplished by setting periodic 2*nlat vectors over the pole for each
c     longitude.  vector values must be negated on one side of the pole
c     to maintain periodicity prior to the 2*nlat shift over the poles.
c     when nlon is odd, the 2*nlat latitudinal shift requires an additional
c     longitude shift to obtain symmetry necessary for full circle shifts
c     over the poles.  finally longitudinal shifts are executed for each
c     shifted latitude.
c
c *** argument description
c
c ... ioff
c
c     ioff = 0 if values on the offset grid in (uoff,voff) are given and
c              values on the regular grid in (ureg,vreg) are to be generated.
c
c     ioff = 1 if values on the regular grid in (ureg,vreg) are given and
c              values on the offset grid in (uoff,voff) are to be generated.
c
c ... nlon
c
c     the number of longitude points on both the "offset" and "regular"
c     uniform grid in longitude (see "grid description" above).  nlon
c     is also the first dimension of uoff,voff,ureg,vreg.  nlon determines
c     the grid increment in longitude as dlon = 2.*pi/nlon.  for example,
c     nlon = 144 for a 2.5 degree grid.  nlon can be even or odd and must
c     be greater than or equal to 4.  the efficiency of the computation
c     is improved when nlon is a product of small primes.
c
c ... nlat
c
c     the number of latitude points on the "offset" uniform grid.  nlat+1
c     is the number of latitude points on the "regular" uniform grid (see
c     "grid description" above).  nlat is the second dimension of uoff,voff.
c     nlat+1 must be the second dimension of ureg,vreg in the program
c     calling vshifte.  nlat determines the grid in latitude as pi/nlat.
c     for example, nlat = 36 for a five degree grid.  nlat must be at least 3.
c
c ... uoff
c
c     a nlon by nlat array that contains the east longitudinal vector
c     data component on the offset grid described above.  uoff is a
c     given input argument if ioff=0.  uoff is a generated output
c     argument if ioff=1.
c
c ... voff
c
c     a nlon by nlat array that contains the latitudinal vector data
c     component on the offset grid described above.  voff is a given
c     input argument if ioff=0.  voff is a generated output argument
c     if ioff=1.
c
c ... ureg
c
c     a nlon by nlat+1 array that contains the east longitudinal vector
c     data component on the regular grid described above.  ureg is a given
c     input argument if ioff=1.  ureg is a generated output argument
c     if ioff=0.
c
c ... vreg
c
c     a nlon by nlat+1 array that contains the latitudinal vector data
c     component on the regular grid described above.  vreg is a given
c     input argument if ioff=1.  vreg is a generated output argument
c     if ioff=0.
c
c ... wsav
c
c     a real saved work space array that must be initialized by calling
c     subroutine vshifti(ioff,nlon,nlat,wsav,ier) before calling vshifte.
c     wsav can then be used repeatedly by vshifte as long as ioff, nlon,
c     and nlat do not change.  this bypasses redundant computations and
c     saves time.  undetectable errors will result if vshifte is called
c     without initializing wsav whenever ioff, nlon, or nlat change.
c
c ... lsav
c
c     the length of the saved work space wsav in the routine calling vshifte
c     and sshifti.  lsave must be greater than or equal to 2*(2*nlat+nlon+16).
c
c ... work
c
c     a real unsaved work space
c
c ... lwork
c
c     the length of the unsaved work space in the routine calling vshifte
c     if nlon is even then lwork must be greater than or equal to
c
c          2*nlon*(nlat+1)
c
c     if nlon is odd then lwork must be greater than or equal to
c
c          nlon*(5*nlat+1)
c
c ... ier
c
c     indicates errors in input parameters
c
c     = 0 if no errors are detected
c
c     = 1 if ioff is not equal to 0 or 1
c
c     = 2 if nlon < 4
c
c     = 3 if nlat < 3
c
c     = 4 if lsave < 2*(nlon+2*nlat)+32
c
c     = 5 if lwork < 2*nlon*(nlat+1) for nlon even or
c            lwork < nlon*(5*nlat+1) for nlon odd
c
c *** end of vshifte documentation
c
c     subroutine vshifti(ioff,nlon,nlat,lsav,wsav,ier)
c
c     subroutine vshifti initializes the saved work space wsav
c     for ioff and nlon and nlat (see documentation for vshifte).
c     vshifti must be called before vshifte whenever ioff or nlon
c     or nlat change.
c
c ... ier
c
c     = 0 if no errors with input arguments
c
c     = 1 if ioff is not 0 or 1
c
c     = 2 if nlon < 4
c
c     = 3 if nlat < 3
c
c     = 4 if lsav < 2*(2*nlat+nlon+16)
c
c *** end of vshifti documentation
c
      subroutine vshifte(ioff,nlon,nlat,uoff,voff,ureg,vreg,
     +                   wsav,lsav,wrk,lwrk,ier)
      implicit none
      integer ioff,nlon,nlat,n2,nr,nlat2,nlatp1,lsav,lwrk,ier
      integer i1,i2,i3
      real uoff(nlon,nlat),voff(nlon,nlat)
      real ureg(nlon,*),vreg(nlon,*)
      real wsav(lsav),wrk(lwrk)
c
c     check input parameters
c
      ier = 1
      if (ioff*(ioff-1).ne.0) return
      ier = 2
      if (nlon.lt.4) return
      ier = 3
      if (nlat .lt. 3) return
      ier = 4
      if (lsav .lt. 2*(2*nlat+nlon+16)) return
      nlat2 = nlat+nlat
      nlatp1 = nlat+1
      n2 = (nlon+1)/2
      ier = 5
      if (2*n2 .eq. nlon) then
	if (lwrk .lt. 2*nlon*(nlat+1)) return
	nr = n2
	i1 = 1
	i2 = 1
	i3 = i2+nlon*nlatp1
      else
	if (lwrk .lt. nlon*(5*nlat+1)) return
	nr = nlon
	i1 = 1
	i2 = i1+nlat2*nlon
	i3 = i2+nlatp1*nlon
      end if
      ier = 0
      if (ioff.eq.0) then
c
c     shift (uoff,voff) to (ureg,vreg)
c
	call vhftoff(nlon,nlat,uoff,ureg,wsav,nr,nlat2,
     +  nlatp1,wrk(i1),wrk(i2),wrk(i2),wrk(i3))
	call vhftoff(nlon,nlat,voff,vreg,wsav,nr,nlat2,
     +  nlatp1,wrk(i1),wrk(i2),wrk(i2),wrk(i3))
      else
c
c     shift (ureg,vreg) to (uoff,voff)
c
	call vhftreg(nlon,nlat,uoff,ureg,wsav,nr,nlat2,
     +  nlatp1,wrk(i1),wrk(i2),wrk(i2),wrk(i3))
	call vhftreg(nlon,nlat,voff,vreg,wsav,nr,nlat2,
     +  nlatp1,wrk(i1),wrk(i2),wrk(i2),wrk(i3))
      end if
      end

      subroutine vhftoff(nlon,nlat,uoff,ureg,wsav,nr,
     +nlat2,nlatp1,rlatu,rlonu,rlou,wrk)
c
c     generate ureg from uoff (a vector component!)
c
      implicit none
      integer nlon,nlat,nlat2,nlatp1,n2,nr,j,i,js,isav
      real uoff(nlon,nlat),ureg(nlon,nlatp1)
      real rlatu(nr,nlat2),rlonu(nlatp1,nlon),rlou(nlat,nlon)
      real wsav(*),wrk(*)
      isav = 4*nlat+17
      n2 = (nlon+1)/2
c
c     execute full circle latitude shifts for nlon odd or even
c
      if (2*n2 .gt. nlon) then
c
c     odd number of longitudes
c
	do i=1,nlat
	  do j=1,nlon
	    rlou(i,j) = uoff(j,i)
	  end do
	end do
c
c       half shift in longitude
c
	call vhifth(nlat,nlon,rlou,wsav(isav),wrk)
c
c       set full 2*nlat circles in rlatu using shifted values in rlonu
c
	do j=1,n2-1
	  js = j+n2
	  do i=1,nlat
	    rlatu(j,i)      = uoff(j,i)
	    rlatu(j,nlat+i) = -rlou(nlat+1-i,js)
	  end do
	end do
	do j=n2,nlon
	  js = j-n2+1
	  do i=1,nlat
	    rlatu(j,i)      = uoff(j,i)
	    rlatu(j,nlat+i) = -rlou(nlat+1-i,js)
	  end do
	end do
c
c       shift the nlon rlat vectors one half latitude grid
c
	call vhifth(nlon,nlat2,rlatu,wsav,wrk)
c
c       set in ureg
c
	do j=1,nlon
	  do i=1,nlat+1
	    ureg(j,i) =  rlatu(j,i)
	  end do
	end do
      else
c
c     even number of longitudes (no initial longitude shift necessary)
c     set full 2*nlat circles (over poles) for each longitude pair (j,js)
c     negating js vector side for periodicity
c
	do j=1,n2
	  js = n2+j
	  do i=1,nlat
	    rlatu(j,i)      = uoff(j,i)
	    rlatu(j,nlat+i) =-uoff(js,nlatp1-i)
	  end do
	end do
c
c       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
c
	call vhifth(n2,nlat2,rlatu,wsav,wrk)
c
c       set ureg,vreg shifted in latitude
c
	do j=1,n2
	  js = n2+j
	  ureg(j,1) =   rlatu(j,1)
	  ureg(js,1) = -rlatu(j,1)
	  do i=2,nlatp1
	    ureg(j,i) =  rlatu(j,i)
	    ureg(js,i) =-rlatu(j,nlat2-i+2)
	  end do
	end do
      end if
c
c     execute full circle longitude shift
c
      do j=1,nlon
	do i=1,nlatp1
	  rlonu(i,j) = ureg(j,i)
	end do
      end do
      call vhifth(nlatp1,nlon,rlonu,wsav(isav),wrk)
      do j=1,nlon
	do i=1,nlatp1
	  ureg(j,i) = rlonu(i,j)
	end do
      end do
      end

      subroutine vhftreg(nlon,nlat,uoff,ureg,wsav,nr,nlat2,
     +                   nlatp1,rlatu,rlonu,rlou,wrk)
c
c     generate uoff vector component from ureg
c
      implicit none
      integer nlon,nlat,nlat2,nlatp1,n2,nr,j,i,js,isav
      real uoff(nlon,nlat),ureg(nlon,nlatp1)
      real rlatu(nr,nlat2),rlonu(nlatp1,nlon),rlou(nlat,nlon)
      real wsav(*),wrk(*)
      isav = 4*nlat+17
      n2 = (nlon+1)/2
c
c     execute full circle latitude shifts for nlon odd or even
c
      if (2*n2 .gt. nlon) then
c
c     odd number of longitudes
c
	do i=1,nlatp1
	  do j=1,nlon
	    rlonu(i,j) = ureg(j,i)
	  end do
	end do
c
c       half shift in longitude in rlon
c
	call vhifth(nlatp1,nlon,rlonu,wsav(isav),wrk)
c
c       set full 2*nlat circles in rlat using shifted values in rlon
c
	do j=1,n2
	  js = j+n2-1
	  rlatu(j,1) = ureg(j,1)
	  do i=2,nlat
	    rlatu(j,i) = ureg(j,i)
	    rlatu(j,nlat+i) =-rlonu(nlat+2-i,js)
	  end do
	  rlatu(j,nlat+1) = ureg(j,nlat+1)
	end do
	do j=n2+1,nlon
	  js = j-n2
	  rlatu(j,1) = ureg(j,1)
	  do i=2,nlat
	    rlatu(j,i) = ureg(j,i)
	    rlatu(j,nlat+i) =-rlonu(nlat+2-i,js)
	  end do
	  rlatu(j,nlat+1) = ureg(j,nlat+1)
	end do
c
c       shift the nlon rlat vectors one halflatitude grid
c
	call vhifth(nlon,nlat2,rlatu,wsav,wrk)
c
c       set values in uoff
c
	do j=1,nlon
	  do i=1,nlat
	    uoff(j,i) = rlatu(j,i)
	  end do
	end do
      else
c
c     even number of longitudes (no initial longitude shift necessary)
c     set full 2*nlat circles (over poles) for each longitude pair (j,js)
c
	do j=1,n2
	  js = n2+j
	  rlatu(j,1) = ureg(j,1)
	  do i=2,nlat
	    rlatu(j,i) = ureg(j,i)
	    rlatu(j,nlat+i) =-ureg(js,nlat+2-i)
	  end do
	  rlatu(j,nlat+1) = ureg(j,nlat+1)
	end do
c
c       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
c
	call vhifth(n2,nlat2,rlatu,wsav,wrk)
c
c       set values in uoff
c
	do j=1,n2
	  js = n2+j
	  do i=1,nlat
	    uoff(j,i) =  rlatu(j,i)
	    uoff(js,i) =-rlatu(j,nlat2+1-i)
	  end do
	end do
      end if
c
c     execute full circle longitude shift for all latitude circles
c
      do j=1,nlon
	do i=1,nlat
	  rlou(i,j) = uoff(j,i)
	end do
      end do
      call vhifth(nlat,nlon,rlou,wsav(isav),wrk)
      do j=1,nlon
	do i=1,nlat
	  uoff(j,i) = rlou(i,j)
	end do
      end do
      end

      subroutine vshifti(ioff,nlon,nlat,lsav,wsav,ier)
c
c     initialize wsav for vshifte
c
      integer ioff,nlat,nlon,nlat2,isav,ier
      real wsav(lsav)
      real pi,dlat,dlon,dp
      ier = 1
      if (ioff*(ioff-1).ne.0) return
      ier = 2
      if (nlon .lt. 4) return
      ier = 3
      if (nlat .lt. 3) return
      ier = 4
      if (lsav .lt. 2*(2*nlat+nlon+16)) return
      ier = 0
      pi = 4.0*atan(1.0)
c
c     set lat,long increments
c
      dlat = pi/nlat
      dlon = (pi+pi)/nlon
c
c     set left or right latitude shifts
c
      if (ioff.eq.0) then
	dp = -0.5*dlat
      else
	dp = 0.5*dlat
      end if
      nlat2 = nlat+nlat
      call vhifthi(nlat2,dp,wsav)
c
c     set left or right longitude shifts
c
      if (ioff.eq.0) then
	dp = -0.5*dlon
      else
	dp = 0.5*dlon
      end if
      isav = 4*nlat + 17
      call vhifthi(nlon,dp,wsav(isav))
      return
      end

      subroutine vhifth(m,n,r,wsav,work)
      implicit none
      integer m,n,n2,k,l
      real r(m,n),wsav(*),work(*),r2km2,r2km1
      n2 = (n+1)/2
c
c     compute fourier coefficients for r on shifted grid
c
      call hrfftf(m,n,r,m,wsav(n+2),work)
      do l=1,m
	do k=2,n2
	  r2km2 = r(l,k+k-2)
	  r2km1 = r(l,k+k-1)
	  r(l,k+k-2)   =  r2km2*wsav(n2+k) - r2km1*wsav(k)
	  r(l,k+k-1)   =  r2km2*wsav(k)    + r2km1*wsav(n2+k)
	end do
      end do
c
c     shift r with fourier synthesis and normalization
c
      call hrfftb(m,n,r,m,wsav(n+2),work)
      do l=1,m
	do k=1,n
	  r(l,k) = r(l,k)/n
	end do
      end do
      return
      end

      subroutine vhifthi(n,dp,wsav)
c
c     initialize wsav for subroutine vhifth
c
      implicit none
      integer n,n2,k
      real wsav(*),dp
      n2 = (n+1)/2
      do k=2,n2
	wsav(k)    =  sin((k-1)*dp)
	wsav(k+n2) =  cos((k-1)*dp)
      end do
      call hrffti(n,wsav(n+2))
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
! ... file trvsph.f
!
!     this file contains documentation and code for subroutine trvsph
!
! ... required files
!
!     sphcom.f, hrfft.f, gaqd.f, vhaec.f, vhsec.f, vhagc.f, vhsgc.f
!
!     subroutine trvsph (intl,igrida,nlona,nlata,iveca,ua,va,
!    +igridb,nlonb,nlatb,ivecb,ub,vb,wsave,lsave,lsvmin,work,
!    +lwork,lwkmin,dwork,ldwork,ier)
!
! *** author
!
!     John C. Adams (NCAR 1997), email: johnad@ncar.ucar.edu
!
! *** purpose
!
!     subroutine trvsph transfers vector data given in (ua,va) on a grid on
!     the full sphere to vector data in (ub,vb) on a grid on the full sphere.
!     the grids on which (ua,va) is given and (ub,vb) is generated can be
!     specified independently of each other (see the input arguments igrida,
!     igridb,iveca,ivecb).  ua and ub are the east longitudinal components of
!     the given and transformed vector fields.  va is either the latitudinal
!     or colatitudinal component of the given vector field (see iveca).
!     vb is either the latitudinal or colatitudinal component of the
!     transformed vector field (see ivecb).  for transferring scalar data
!     on the sphere, use subroutine trssph.
!
! *   notice that scalar and vector quantities are fundamentally different
!     on the sphere.  for example, vectors are discontinuous and multiple
!     valued at the poles.  scalars are continuous and single valued at the
!     poles. erroneous results would be produced if one attempted to transfer
!     vector fields between grids with subroutine trssph applied to each
!     component of the vector.
!
! *** underlying grid assumptions and a description
!
!     discussions with the ncar scd data support group and others indicate
!     there is no standard grid for storing observational or model generated
!     data on the sphere.  subroutine trvsph was designed to handle most
!     cases likely to be encountered when moving data from one grid format
!     to another.
!
!     the grid on which (ua,va) is given must be equally spaced in longitude
!     and either equally spaced or gaussian in latitude (or colatitude).
!     longitude, which can be either the first or second dimension of ua,va
!     subdivides [0,2pi) excluding the periodic point 2pi.  (co)latitude,
!     which can be the second or first dimension of ua,va, has south
!     to north or north to south orientation with increasing subscript
!     value in ua,va (see the argument igrida).
!
!     the grid on which ub,vb is generated must be equally spaced in longitude
!     and either equally spaced or gaussian in latitude (or colatitude).
!     longitude, which can be either the first or second dimension of ub,vb
!     subdivides [0,2pi) excluding the periodic point 2pi.  (co)latitude,
!     which can be the second or first dimension of ub,vb, has south
!     to north or north to south orientation with increasing subscript
!     value in db (see the argument igridb).
!
!     let nlon be either nlona or nlonb (the number of grid points in
!     longitude.  the longitude grid subdivides [0,2pi) into nlon spaced
!     points
!
!          (j-1)*2.*pi/nlon  (j=1,...,nlon).
!
!     it is not necessary to communicate to subroutine trvsph whether the
!     underlying grids are in latitude or colatitude.  it is only necessary
!     to communicate whether they run south to north or north to south with
!     increasing subscripts.  a brief discussion of latitude and colatitude
!     follows.  equally spaced latitude grids are assumed to subdivide
!     [-pi/2,pi/2] with the south pole at -pi/2 and north pole at pi/2.
!     equally spaced colatitude grids subdivide [0,pi] with the north pole
!     at 0 and south pole at pi.  equally spaced partitions on the sphere
!     include both poles.  gaussian latitude grids subdivide (-pi/2,pi/2)
!     and gaussian colatitude grids subdivide (0,pi).  gaussian grids do not
!     include the poles.  the gaussian grid points are uniquely determined by
!     the size of the partition.  they can be computed in colatitude in
!     (0,pi) (north to south) in double precision by the spherepack subroutine
!     gaqd.  let nlat be nlata or nlatb if either the ua,va or ub,vb grid is
!     gaussian.  let
!
!        north pole                             south pole
!        ----------                             ----------
!           0.0    <  cth(1) < ... < cth(nlat)  <   pi
!
!
!     be nlat gaussian colatitude points in the interval (0,pi) and let
!
!        south pole                        north pole
!        ----------                        ----------
!           -pi/2  < th(1) < ... < th(nlat) < pi/2
!
!     be nlat gaussian latitude points in the open interval (-pi/2,pi/2).
!     these are related by
!
!          th(i) = -pi/2 + cth(i)  (i=1,...,nlat)
!
!     if the (ua,va) or (ub,vb) grid is equally spaced in (co)latitude then
!
!          ctht(i) = (i-1)*pi/(nlat-1)
!                                               (i=1,...,nlat)
!          tht(i) = -pi/2 + (i-1)*pi/(nlat-1)
!
!     define the equally spaced (north to south) colatitude and (south to
!     north) latitude grids.
!
! *** method (simplified description)
!
!    (1)
!
!     the vector field (ua,va) is reformated to a vector field in mathematical
!     spherical coordinates using array transpositions, subscript reordering
!     and negation of va as necessary (see arguments igrida,iveca).
!
!     (2)
!
!     a vector harmonic analysis is performed on the result from (1)
!
!     (3)
!
!     a vector harmonic synthesis is performed on the (ub,vb) grid
!     using as many coefficients from (2) as possible (i.e., as
!     as is consistent with the size of the ub,vb grid).
!
!     (4)
!
!     the vector field generated in (3) is transformed from mathematical
!     spherical coordinates to the form flagged by ivecb and igridb in
!     (ub,vb) using array transpositions, subscript reordering and negation
!     as necessary
!
!
! *** advantages
!
!     the use of vector spherical harmonics to transfer vector data is
!     highly accurate and preserves properties of vectors on the sphere.
!     the method produces a weighted least squares fit to vector data in
!     which waves are resolved uniformly on the full sphere.  high frequencies
!     induced by closeness of grid points near the poles (due to computational
!     or observational errors) are smoothed.  the method is consistent with
!     methods used to generate vector data in numerical spectral models based
!     on spherical harmonics.  for more discussion of these and related issues,
!     see "on the spectral approximation of discrete scalar and vector
!     functions on the sphere," siam j. numer. anal., vol. 16, december 1979,
!     pp. 934-949, by paul swarztrauber.
!
!
! *** comment
!
!     on a nlon by nlat or nlat by nlon grid (gaussian or equally spaced)
!     spherical harmonic analysis generates and synthesis utilizes
!     min0(nlat,(nlon+2)/2)) by nlat coefficients.  consequently, for
!     ua,va and ub,vb,  if either
!
!             min0(nlatb,(nlonb+2)/2) < min0(nlata,(nlona+2)/2)
!
!     or if
!
!             nlatb < nlata
!
!     then all the coefficients generated by an analysis of ua,va cannot be
!     used in the synthesis which generates ub,vb.  in this case "information"
!     can be lost in generating ub,vb.  more precisely, information will be
!     lost if the analysis of ua,va yields nonzero coefficients which are
!     outside the coefficient bounds determined by the ub,vb grid. still
!     transference with vector spherical harmonics will yield results
!     consistent with grid resolution and is highly accurate.
!
! *** input arguments
!
! ... intl
!
!     an initialization argument which should be zero on an initial call to
!     trvsph.  intl should be one if trvsph is being recalled and
!
!          igrida,nlona,nlata,iveca,igridb,nlonb,nlatb,ivecb
!
!     have not changed from the previous call.  if any of these arguments have
!     changed intl=0 must be used to avoid undetectable errors.  when allowed,
!     calls with intl=1 bypass redundant computation and save time.  it can
!     be used when transferring multiple vector data sets with the same
!     underlying grids.
!
! ... igrida
!
!     an integer vector dimensioned two which identifies the underlying grid
!     on the full sphere for the given vector data (ua,va) as follows:
!
!     igrida(1)
!
!     = -1
!     if the latitude (or colatitude) grid for ua,va is an equally spaced
!     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
!     runs north to south with increasing subscript value
!
!     = +1
!     if the latitude (or colatitude) grid for ua,va is an equally spaced
!     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
!     runs south to north with increasing subscript value
!
!     = -2
!     if the latitude (or colatitude) grid for ua,va is a gaussian partition
!     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs north
!     to south with increasing subscript value
!
!     = +2
!     if the latitude (or colatitude) grid for ua,va is a gaussian partition
!     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs south
!     north with increasing subscript value
!
!     igrida(2)
!
!     = 0 if the underlying grid for ua,va is a nlona by nlata
!
!     = 1 if the underlying grid for ua,va is a nlata by nlona
!
!
! ... nlona
!
!     the number of longitude points on the uniform grid which partitions
!     [0,2pi) for the given vector (ua,va).  nlona is also the first or second
!     dimension of ua,va (see igrida(2)) in the program which calls trvsph.
!     nlona determines the grid increment in longitude as 2*pi/nlona. for
!     example nlona = 72 for a five degree grid.  nlona must be greater than
!     or equal to 4.  the efficiency of the computation is improved when
!     nlona is a product of small prime numbers
!
! ... nlata
!
!     the number of points in the latitude (or colatitude) grid for the
!     given vector (ua,va).  nlata is also the first or second dimension
!     of ua and va (see igrida(2)) in the program which calls trvsph.
!     if nlata is odd then the equator will be located at the (nlata+1)/2
!     gaussian grid point.  if nlata is even then the equator will be
!     located half way between the nlata/2 and nlata/2+1 grid points.
!
! ... iveca
!
!     if iveca=0 is input then va is the latitudinal component of the
!     given vector field. if iveca=1 then va is the colatitudinal
!     compoenent of the given vector field.  in either case, ua must
!     be the east longitudinal component of the given vector field.
!
! *** note:
!     igrida(1)=-1 or igrida(1)=-2, igrida(2)=1, and iveca=1 corresponds
!     to the "usual" mathematical spherical coordinate system required
!     by most of the drivers in spherepack2.  igrida(1)=1 or igrida(1)=2,
!     igrida(2)=0, and iveca=0 corresponds to the "usual" geophysical
!     spherical coordinate system.
!
!
! ... ua
!
!     ua is the east longitudinal component of the given vector field.
!     ua must be dimensioned nlona by nlata in the program calling trvsph if
!     igrida(2) = 0.  ua must be dimensioned nlata by nlona in the program
!     calling trvsph if igrida(2) = 1.  if ua is not properly dimensioned
!     and if the latitude (colatitude) values do not run south to north or
!     north to south as flagged by igrida(1) (this cannot be checked!) then
!     incorrect results will be produced.
!
!
! ... va
!
!     va is either the latitudinal or colatitudinal componenet of the
!     given vector field (see iveca).  va must be dimensioned nlona by
!     nlata in the program calling trvsph if igrida(2)=0.  va must be
!     dimensioned nlata by nlona in the program calling trvsph if
!     igrida(2)=1.  if va is not properly dimensioned or if the latitude
!     (colatitude) values do not run south to north or north to south
!     as flagged by igrida(1) (this cannot be checked!) then incorrect
!     results will be produced.
!
! ... igridb
!
!     an integer vector dimensioned two which identifies the underlying grid
!     on the full sphere for the transformed vector (ub,vb) as follows:
!
!     igridb(1)
!
!     = -1
!     if the latitude (or colatitude) grid for ub,vb is an equally spaced
!     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
!     north to south
!
!     = +1
!     if the latitude (or colatitude) grid for ub,vb is an equally spaced
!     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
!     south to north
!
!     = -2
!     if the latitude (or colatitude) grid for ub,vb is a gaussian partition
!     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs north to
!     south
!
!     = +2
!     if the latitude (or colatitude) grid for ub,vb is a gaussian partition
!     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs south to
!     north
!
!     igridb(2)
!
!     = 0 if the underlying grid for ub,vb is a nlonb by nlatb
!
!     = 1 if the underlying grid for ub,vb is a nlatb by nlonb
!
!
! ... nlonb
!
!     the number of longitude points on the uniform grid which partitions
!     [0,2pi) for the transformed vector (ub,vb).  nlonb is also the first or
!     second dimension of ub and vb (see igridb(2)) in the program which calls
!     trvsph.  nlonb determines the grid increment in longitude as 2*pi/nlonb.
!     for example nlonb = 72 for a five degree grid.  nlonb must be greater
!     than or equal to 4.  the efficiency of the computation is improved when
!     nlonb is a product of small prime numbers
!
! ... nlatb
!
!     the number of points in the latitude (or colatitude) grid for the
!     transformed vector (ub,vb).  nlatb is also the first or second dimension
!     of ub and vb (see igridb(2)) in the program which calls trvsph.
!     if nlatb is odd then the equator will be located at the (nlatb+1)/2
!     gaussian grid point.  if nlatb is even then the equator will be
!     located half way between the nlatb/2 and nlatb/2+1 grid points.
!
! ... ivecb
!
!     if ivecb=0 is input then vb is the latitudinal component of the
!     given vector field. if ivecb=1 then vb is the colatitudinal
!     compoenent of the given vector field.  in either case, ub must
!     be the east longitudinal component of the given vector field.
!
! *** note:
!     igridb(1)=-1 or igridb(1)=-2, igridb(2)=1, and ivecb=1 corresponds
!     to the "usual" mathematical spherical coordinate system required
!     by most of the drivers in spherepack2.  igridb(1)=1 or igridb(1)=2,
!     igridb(2)=0, and ivecb=0 corresponds to the "usual" geophysical
!     spherical coordinate system.
!
! ... wsave
!
!     a saved work space array that can be utilized repeatedly by trvsph
!     as long as the arguments nlata,nlona,nlatb,nlonb remain unchanged.
!     wsave is set by a intl=0 call to trvsph.  wsave must not be altered
!     when trvsph is being recalled with intl=1.
!
! ... lsave
!
!     the dimension of the work space wsave as it appears in the program
!     that calls trvsph.  the minimum required value of lsave for the
!     current set of input arguments is set in the output argument lsvmin.
!     it can be determined by calling trvsph with lsave=0 and printing lsvmin.
!
!          la1 = min0(nlata,(nlona+1)/2), la2 = (nlata+1)/2
!
!          lb1 = min0(nlatb,(nlonb+1)/2), lb2 = (nlatb+1)/2
!
!          lwa = 4*nlata*la2+3*max0(la1-2,0)*(2*nlata-la1-1)+la2+nlona+15
!
!          lwb = 4*nlatb*lb2+3*max0(lb1-2,0)*(2*nlatb-lb1-1)+nlonb+15
!
!      then
!
!          lsvmin = lwa + lwb
!
!      is the minimal required work space length of wsave
!
!
! ... work
!
!     a work array that does not have to be preserved
!
! ... lwork
!
!     the dimension of the array work as it appears in the program that
!     calls trvsph. the minimum required value of lwork for the current
!     set of input arguments is set in the output argument lwkmin.
!     it can be determined by calling trvsph with lwork=0 and printing
!     lwkmin.  an estimate for lwork follows.  let nlat = max0(nlata,nlatb),
!     nlon = max0(nlona,nlonb) and l1 = min0(nlat,(nlon+2)/2).  with these
!     these definitions, the quantity
!
!            2*nlat*(8*l1 + 4*nlon + 3)
!
!     will suffice as a length for the unsaved work space.  this formula
!     may overestimate the required minimum value for lwork.  the exact
!     minimum value can be predetermined by calling trvsph wtih lwork=0
!     and printout of lwkmin.
!
! ... dwork
!
!     a double precision work array that does not have to be preserved.
!
! ... ldwork
!
!     the length of dwork in the routine calling trvsph
!     Let
!
!       nlat = max0(nlata,nlatb)
!
!     ldwork must be at least 2*nlat*(nlat+1)+1
!
!
! *** output arguments
!
!
! ... ub
!
!     a two dimensional array that contains the east longitudinal component
!     of the transformed vector data.  ub
!     must be dimensioned nlonb by nlatb in the program calling trvsph if
!     igridb(2)=0.  ub must be dimensioned nlatb by nlonb in the program
!     calling trvsph if igridb(2)=1.  if ub is not properly dimensioned
!     and if the latitude (colatitude) values do not run south to north or
!     north to south as flagged by igrdb(1) (this cannot be checked!) then
!     incorrect results will be produced.
!
!
! ... vb
!
!     a two dimensional array that contains the latitudinal or colatitudinal
!     component of the transformed vector data (see ivecb).
!     vb must be dimensioned nlonb by nlatb in the program calling trvsph if
!     igridb(2)=0.  vb must be dimensioned nlatb by nlonb in the program
!     calling trvsph if igridb(2)=1.  if vb is not properly dimensioned
!     and if the latitude (colatitude) values do not run south to north or
!     north to south as flagged by igrdb(1) (this cannot be checked!) then
!     incorrect results will be produced.
!
! ... lsvmin
!
!     the minimum length of the saved work space in wsave.
!     lsvmin is computed even if lsave < lsvmin (ier = 10).
!
! ... lwkmin
!
!     the minimum length of the unsaved work space in work.
!     lwkmin is computed even if lwork < lwkmin (ier = 11).
!
!
! *** error argument
!
! ... ier = 0  if no errors are detected
!
!         = 1  if intl is not 0 or 1
!
!         = 2  if igrida(1) is not -1 or +1 or -2 or +2
!
!         = 3  if igrida(2) is not 0 or 1
!
!         = 4  if nlona is less than 4
!
!         = 5  if nlata is less than 3
!
!         = 6  if iveca is not 0 or 1
!
!         = 7  if igridb(1) is not -1 or +1 or -2 or +2
!
!         = 8  if igridb(2) is not 0 or 1
!
!         = 9  if nlonb is less than 4
!
!         =10  if nlatb is less than 3
!
!         =11  if ivecb is not 0 or 1
!
!         =12  if there is insufficient saved work space (lsave < lsvmin)
!
!         =13  if there is insufficient unsaved work space (lwork < lwkmin)
!
!         =14  indicates failure in an eigenvalue routine which computes
!              gaussian weights and points
!
!         =15  if ldwork is too small (insufficient double precision
!              unsaved work space)
!
! *****************************************************
! *****************************************************
!
!     end of argument description ... code follows
!
! *****************************************************
! *****************************************************
!
      SUBROUTINE TRVSPH(Intl,Igrida,Nlona,Nlata,Iveca,Ua,Va,Igridb,     &
                      & Nlonb,Nlatb,Ivecb,Ub,Vb,Wsave,Lsave,Lsvmin,Work,&
                      & Lwork,Lwkmin,Dwork,Ldwork,Ier)
      IMPLICIT NONE
!*--TRVSPH507
      INTEGER Intl , Igrida(2) , Nlona , Nlata , Igridb(2) , Nlonb ,    &
            & Nlatb
      INTEGER Iveca , Ivecb , Lsave , Lsvmin , Lwork , Lwkmin , Ldwork ,&
            & Ier
      REAL Ua(*) , Va(*) , Ub(*) , Vb(*) , Wsave(*) , Work(*)
      DOUBLE PRECISION Dwork(*)
      INTEGER ig , igrda , igrdb , la1 , la2 , lb1 , lb2 , lwa , lwb
      INTEGER iabr , iabi , iacr , iaci , ibbr , ibbi , ibcr , ibci
      INTEGER nlat , lwk1 , lwk2 , lw , iw , jb , nt , ityp
!
!     include a save statement to ensure local variables in trvsph, set during
!     an intl=0 call, are preserved if trvsph is recalled with intl=1
!
      SAVE 
!
!     check input arguments
!
      Ier = 1
      IF ( Intl*(Intl-1)/=0 ) RETURN
      Ier = 2
      ig = Igrida(1)
      IF ( (ig-1)*(ig+1)*(ig-2)*(ig+2)/=0 ) RETURN
      Ier = 3
      ig = Igrida(2)
      IF ( ig*(ig-1)/=0 ) RETURN
      Ier = 4
      IF ( Nlona<4 ) RETURN
      Ier = 5
      IF ( Nlata<3 ) RETURN
      Ier = 6
      IF ( Iveca*(Iveca-1)/=0 ) RETURN
      Ier = 7
      ig = Igridb(1)
      IF ( (ig-1)*(ig+1)*(ig-2)*(ig+2)/=0 ) RETURN
      Ier = 8
      ig = Igridb(2)
      IF ( ig*(ig-1)/=0 ) RETURN
      Ier = 9
      IF ( Nlonb<4 ) RETURN
      Ier = 10
      IF ( Nlatb<3 ) RETURN
      Ier = 11
      IF ( Ivecb*(Ivecb-1)/=0 ) RETURN
      Ier = 0
      igrda = IABS(Igrida(1))
      igrdb = IABS(Igridb(1))
      IF ( Intl==0 ) THEN
         la1 = MIN0(Nlata,(Nlona+1)/2)
         la2 = (Nlata+1)/2
         lb1 = MIN0(Nlatb,(Nlonb+1)/2)
         lb2 = (Nlatb+1)/2
!
!     saved space for analysis on a grid
!
         lwa = 4*Nlata*la2 + 3*MAX0(la1-2,0)*(2*Nlata-la1-1)            &
             & + la2 + Nlona + 15
!
!     set saved work space length for synthesis on b grid
!
         lwb = 4*Nlatb*lb2 + 3*MAX0(lb1-2,0)*(2*Nlatb-lb1-1) + Nlonb +  &
             & 15
!
!     set minimum required saved work space length
!
         Lsvmin = lwa + lwb
!
!     set wsave pointer
!
         jb = 1 + lwa
!
!     set pointers for vector spherical harmonic coefs in work
!
         iabr = 1
         iabi = iabr + la1*Nlata
         iacr = iabi + la1*Nlata
         iaci = iacr + la1*Nlata
         ibbr = iaci + la1*Nlata
         ibbi = ibbr + lb1*Nlatb
         ibcr = ibbi + lb1*Nlatb
         ibci = ibcr + lb1*Nlatb
!
!     set pointers for remaining work
!
         iw = ibci + lb1*Nlatb
!
!     set remaining work space length in lw
!
         lw = Lwork - iw
!
!     compute unsaved space for analysis and synthesis
!
         lwk1 = 2*Nlata*(2*Nlona+MAX0(6*la2,Nlona))
         lwk2 = 2*Nlatb*(2*Nlonb+MAX0(6*lb2,Nlonb))
!
!     set minimum unsaved work space required by trvsph
!
         Lwkmin = iw + MAX0(lwk1,lwk2)
!
!     set error flags if saved or unsaved work space is insufficient
!
         Ier = 12
         IF ( Lsave<Lsvmin ) RETURN
         Ier = 13
         IF ( Lwork<Lwkmin ) RETURN
         Ier = 15
         nlat = MAX0(Nlata,Nlatb)
         IF ( Ldwork<2*nlat*(nlat+1)+1 ) RETURN
         Ier = 0
         IF ( igrda==1 ) THEN
!
!     initialize wsave for equally spaced analysis
!
            CALL VHAECI(Nlata,Nlona,Wsave,lwa,Dwork,Ldwork,Ier)
         ELSE
!
!     initialize wsave for gaussian analysis
!
            CALL VHAGCI(Nlata,Nlona,Wsave,lwa,Dwork,Ldwork,Ier)
            IF ( Ier/=0 ) THEN
!
!     flag failure in spherepack gaussian software
!
               Ier = 14
               RETURN
            ENDIF
         ENDIF
 
         IF ( igrdb==2 ) THEN
!
!     initialize wsave for gaussian synthesis
!
            CALL VHSGCI(Nlatb,Nlonb,Wsave(jb),lwb,Dwork,Ldwork,Ier)
            IF ( Ier/=0 ) THEN
!
!     flag failure in spherepack gaussian software
!
               Ier = 14
               RETURN
            ENDIF
         ELSE
!
!     initialize wsave for equally spaced synthesis
!
            CALL VHSECI(Nlatb,Nlonb,Wsave(jb),lwb,Dwork,Ldwork,Ier)
         ENDIF
!
!     end of initialization (intl=0) call
!
      ENDIF
!
!     convert the vector field (ua,va) to mathematical spherical coordinates
!
      IF ( Igrida(2)==0 ) THEN
         CALL TRVPLAT(Nlona,Nlata,Ua,Work)
         CALL TRVPLAT(Nlona,Nlata,Va,Work)
      ENDIF
      IF ( Igrida(1)>0 ) THEN
         CALL COVLAT(Nlata,Nlona,Ua)
         CALL COVLAT(Nlata,Nlona,Va)
      ENDIF
      IF ( Iveca==0 ) CALL NEGV(Nlata,Nlona,Va)
      nt = 1
      ityp = 0
!
!     analyze vector field
!
      IF ( igrda==2 ) THEN
         CALL VHAGC(Nlata,Nlona,ityp,nt,Va,Ua,Nlata,Nlona,Work(iabr),   &
                  & Work(iabi),Work(iacr),Work(iaci),la1,Nlata,Wsave,   &
                  & lwa,Work(iw),lw,Ier)
      ELSE
         CALL VHAEC(Nlata,Nlona,ityp,nt,Va,Ua,Nlata,Nlona,Work(iabr),   &
                  & Work(iabi),Work(iacr),Work(iaci),la1,Nlata,Wsave,   &
                  & lwa,Work(iw),lw,Ier)
      ENDIF
!
!     transfer a grid coefficients to b grid coefficients
!
      CALL TRVAB(la1,Nlata,Work(iabr),Work(iabi),Work(iacr),Work(iaci), &
               & lb1,Nlatb,Work(ibbr),Work(ibbi),Work(ibcr),Work(ibci))
!
!     synthesize on b grid
!
      IF ( igrdb==1 ) THEN
         CALL VHSEC(Nlatb,Nlonb,ityp,nt,Vb,Ub,Nlatb,Nlonb,Work(ibbr),   &
                  & Work(ibbi),Work(ibcr),Work(ibci),lb1,Nlatb,Wsave(jb)&
                  & ,lwb,Work(iw),lw,Ier)
      ELSE
         CALL VHSGC(Nlatb,Nlonb,ityp,nt,Vb,Ub,Nlatb,Nlonb,Work(ibbr),   &
                  & Work(ibbi),Work(ibcr),Work(ibci),lb1,Nlatb,Wsave(jb)&
                  & ,lwb,Work(iw),lw,Ier)
      ENDIF
!
!     restore a grid and b grid vector fields (now in math coordinates) to
!     agree with grid flags in igrida,iveca,igridb,ivecb
!
      IF ( Iveca==0 ) CALL NEGV(Nlata,Nlona,Va)
      IF ( Ivecb==0 ) CALL NEGV(Nlatb,Nlonb,Vb)
      IF ( Igrida(1)>0 ) THEN
         CALL COVLAT(Nlata,Nlona,Ua)
         CALL COVLAT(Nlata,Nlona,Va)
      ENDIF
      IF ( Igridb(1)>0 ) THEN
         CALL COVLAT(Nlatb,Nlonb,Ub)
         CALL COVLAT(Nlatb,Nlonb,Vb)
      ENDIF
      IF ( Igrida(2)==0 ) THEN
         CALL TRVPLAT(Nlata,Nlona,Ua,Work)
         CALL TRVPLAT(Nlata,Nlona,Va,Work)
      ENDIF
      IF ( Igridb(2)==0 ) THEN
         CALL TRVPLAT(Nlatb,Nlonb,Ub,Work)
         CALL TRVPLAT(Nlatb,Nlonb,Vb,Work)
      ENDIF
    END SUBROUTINE TRVSPH


      SUBROUTINE NEGV(Nlat,Nlon,V)
!
!     negate (co)latitudinal vector componenet
!
      IMPLICIT NONE
      INTEGER Nlat , Nlon , i , j
      REAL V(Nlat,Nlon)
      DO j = 1 , Nlon
         DO i = 1 , Nlat
            V(i,j) = -V(i,j)
         ENDDO
      ENDDO
    END SUBROUTINE NEGV


    SUBROUTINE TRVAB(Ma,Na,Abr,Abi,Acr,Aci,Mb,Nb,Bbr,Bbi,Bcr,Bci)
      IMPLICIT NONE
      INTEGER Ma , Na , Mb , Nb , i , j , m , n
      REAL Abr(Ma,Na) , Abi(Ma,Na) , Acr(Ma,Na) , Aci(Ma,Na)
      REAL Bbr(Mb,Nb) , Bbi(Mb,Nb) , Bcr(Mb,Nb) , Bci(Mb,Nb)
!
!     set coefficients for b grid from coefficients for a grid
!
      m = MIN0(Ma,Mb)
      n = MIN0(Na,Nb)
      DO j = 1 , n
         DO i = 1 , m
            Bbr(i,j) = Abr(i,j)
            Bbi(i,j) = Abi(i,j)
            Bcr(i,j) = Acr(i,j)
            Bci(i,j) = Aci(i,j)
         ENDDO
      ENDDO
!
!     set coefs outside triangle to zero
!
      DO i = m + 1 , Mb
         DO j = 1 , Nb
            Bbr(i,j) = 0.0
            Bbi(i,j) = 0.0
            Bcr(i,j) = 0.0
            Bci(i,j) = 0.0
         ENDDO
      ENDDO
      DO j = n + 1 , Nb
         DO i = 1 , Mb
            Bbr(i,j) = 0.0
            Bbi(i,j) = 0.0
            Bcr(i,j) = 0.0
            Bci(i,j) = 0.0
         ENDDO
      ENDDO
    END SUBROUTINE TRVAB


      SUBROUTINE TRVPLAT(N,M,Data,Work)
!
!     transpose the n by m array data to a m by n array data
!     work must be at least n*m words long
!
      IMPLICIT NONE
      INTEGER N , M , i , j , ij , ji
      REAL Data(*) , Work(*)
      DO j = 1 , M
         DO i = 1 , N
            ij = (j-1)*N + i
            Work(ij) = Data(ij)
         ENDDO
      ENDDO
      DO i = 1 , N
         DO j = 1 , M
            ji = (i-1)*M + j
            ij = (j-1)*N + i
            Data(ji) = Work(ij)
         ENDDO
      ENDDO
    END SUBROUTINE TRVPLAT

    
    SUBROUTINE COVLAT(Nlat,Nlon,Data)
      !
!     reverse order of latitude (colatitude) grids
!
      IMPLICIT NONE
      INTEGER Nlat , Nlon , nlat2 , i , ib , j
      REAL Data(Nlat,Nlon) , temp
      nlat2 = Nlat/2
      DO i = 1 , nlat2
         ib = Nlat - i + 1
         DO j = 1 , Nlon
            temp = Data(i,j)
            Data(i,j) = Data(ib,j)
            Data(ib,j) = temp
         ENDDO
      ENDDO
      END SUBROUTINE COVLAT


      SUBROUTINE DTRVSPH(Intl,Igrida,Nlona,Nlata,Iveca,Ua,Va,Igridb,     &
                      & Nlonb,Nlatb,Ivecb,Ub,Vb,Wsave,Lsave,Lsvmin,Work,&
                      & Lwork,Lwkmin,Dwork,Ldwork,Ier)
      IMPLICIT NONE
      INTEGER Intl , Igrida(2) , Nlona , Nlata , Igridb(2) , Nlonb ,    &
            & Nlatb
      INTEGER Iveca , Ivecb , Lsave , Lsvmin , Lwork , Lwkmin , Ldwork ,&
            & Ier
      DOUBLE PRECISION Ua(*) , Va(*) , Ub(*) , Vb(*) , Wsave(*) , Work(*)
      DOUBLE PRECISION Dwork(*)
      INTEGER ig , igrda , igrdb , la1 , la2 , lb1 , lb2 , lwa , lwb
      INTEGER iabr , iabi , iacr , iaci , ibbr , ibbi , ibcr , ibci
      INTEGER nlat , lwk1 , lwk2 , lw , iw , jb , nt , ityp
!
!     include a save statement to ensure local variables in trvsph, set during
!     an intl=0 call, are preserved if trvsph is recalled with intl=1
!
      SAVE 
!
!     check input arguments
!
      Ier = 1
      IF ( Intl*(Intl-1)/=0 ) RETURN
      Ier = 2
      ig = Igrida(1)
      IF ( (ig-1)*(ig+1)*(ig-2)*(ig+2)/=0 ) RETURN
      Ier = 3
      ig = Igrida(2)
      IF ( ig*(ig-1)/=0 ) RETURN
      Ier = 4
      IF ( Nlona<4 ) RETURN
      Ier = 5
      IF ( Nlata<3 ) RETURN
      Ier = 6
      IF ( Iveca*(Iveca-1)/=0 ) RETURN
      Ier = 7
      ig = Igridb(1)
      IF ( (ig-1)*(ig+1)*(ig-2)*(ig+2)/=0 ) RETURN
      Ier = 8
      ig = Igridb(2)
      IF ( ig*(ig-1)/=0 ) RETURN
      Ier = 9
      IF ( Nlonb<4 ) RETURN
      Ier = 10
      IF ( Nlatb<3 ) RETURN
      Ier = 11
      IF ( Ivecb*(Ivecb-1)/=0 ) RETURN
      Ier = 0
      igrda = IABS(Igrida(1))
      igrdb = IABS(Igridb(1))
      IF ( Intl==0 ) THEN
         la1 = MIN0(Nlata,(Nlona+1)/2)
         la2 = (Nlata+1)/2
         lb1 = MIN0(Nlatb,(Nlonb+1)/2)
         lb2 = (Nlatb+1)/2
!
!     saved space for analysis on a grid
!
         lwa = 4*Nlata*la2 + 3*MAX0(la1-2,0)*(2*Nlata-la1-1)            &
             & + la2 + Nlona + 15
!
!     set saved work space length for synthesis on b grid
!
         lwb = 4*Nlatb*lb2 + 3*MAX0(lb1-2,0)*(2*Nlatb-lb1-1) + Nlonb +  &
             & 15
!
!     set minimum required saved work space length
!
         Lsvmin = lwa + lwb
!
!     set wsave pointer
!
         jb = 1 + lwa
!
!     set pointers for vector spherical harmonic coefs in work
!
         iabr = 1
         iabi = iabr + la1*Nlata
         iacr = iabi + la1*Nlata
         iaci = iacr + la1*Nlata
         ibbr = iaci + la1*Nlata
         ibbi = ibbr + lb1*Nlatb
         ibcr = ibbi + lb1*Nlatb
         ibci = ibcr + lb1*Nlatb
!
!     set pointers for remaining work
!
         iw = ibci + lb1*Nlatb
!
!     set remaining work space length in lw
!
         lw = Lwork - iw
!
!     compute unsaved space for analysis and synthesis
!
         lwk1 = 2*Nlata*(2*Nlona+MAX0(6*la2,Nlona))
         lwk2 = 2*Nlatb*(2*Nlonb+MAX0(6*lb2,Nlonb))
!
!     set minimum unsaved work space required by trvsph
!
         Lwkmin = iw + MAX0(lwk1,lwk2)
!
!     set error flags if saved or unsaved work space is insufficient
!
         Ier = 12
         IF ( Lsave<Lsvmin ) RETURN
         Ier = 13
         IF ( Lwork<Lwkmin ) RETURN
         Ier = 15
         nlat = MAX0(Nlata,Nlatb)
         IF ( Ldwork<2*nlat*(nlat+1)+1 ) RETURN
         Ier = 0
         IF ( igrda==1 ) THEN
!
!     initialize wsave for equally spaced analysis
!
            CALL DVHAECI(Nlata,Nlona,Wsave,lwa,Dwork,Ldwork,Ier)
         ELSE
!
!     initialize wsave for gaussian analysis
!
            CALL DVHAGCI(Nlata,Nlona,Wsave,lwa,Dwork,Ldwork,Ier)
            IF ( Ier/=0 ) THEN
!
!     flag failure in spherepack gaussian software
!
               Ier = 14
               RETURN
            ENDIF
         ENDIF
 
         IF ( igrdb==2 ) THEN
!
!     initialize wsave for gaussian synthesis
!
            CALL DVHSGCI(Nlatb,Nlonb,Wsave(jb),lwb,Dwork,Ldwork,Ier)
            IF ( Ier/=0 ) THEN
!
!     flag failure in spherepack gaussian software
!
               Ier = 14
               RETURN
            ENDIF
         ELSE
!
!     initialize wsave for equally spaced synthesis
!
            CALL DVHSECI(Nlatb,Nlonb,Wsave(jb),lwb,Dwork,Ldwork,Ier)
         ENDIF
!
!     end of initialization (intl=0) call
!
      ENDIF
!
!     convert the vector field (ua,va) to mathematical spherical coordinates
!
      IF ( Igrida(2)==0 ) THEN
         CALL DTRVPLAT(Nlona,Nlata,Ua,Work)
         CALL DTRVPLAT(Nlona,Nlata,Va,Work)
      ENDIF
      IF ( Igrida(1)>0 ) THEN
         CALL DCOVLAT(Nlata,Nlona,Ua)
         CALL DCOVLAT(Nlata,Nlona,Va)
      ENDIF
      IF ( Iveca==0 ) CALL DNEGV(Nlata,Nlona,Va)
      nt = 1
      ityp = 0
!
!     analyze vector field
!
      IF ( igrda==2 ) THEN
         CALL DVHAGC(Nlata,Nlona,ityp,nt,Va,Ua,Nlata,Nlona,Work(iabr),   &
                  & Work(iabi),Work(iacr),Work(iaci),la1,Nlata,Wsave,   &
                  & lwa,Work(iw),lw,Ier)
      ELSE
         CALL DVHAEC(Nlata,Nlona,ityp,nt,Va,Ua,Nlata,Nlona,Work(iabr),   &
                  & Work(iabi),Work(iacr),Work(iaci),la1,Nlata,Wsave,   &
                  & lwa,Work(iw),lw,Ier)
      ENDIF
!
!     transfer a grid coefficients to b grid coefficients
!
      CALL DTRVAB(la1,Nlata,Work(iabr),Work(iabi),Work(iacr),Work(iaci), &
               & lb1,Nlatb,Work(ibbr),Work(ibbi),Work(ibcr),Work(ibci))
!
!     synthesize on b grid
!
      IF ( igrdb==1 ) THEN
         CALL DVHSEC(Nlatb,Nlonb,ityp,nt,Vb,Ub,Nlatb,Nlonb,Work(ibbr),   &
                  & Work(ibbi),Work(ibcr),Work(ibci),lb1,Nlatb,Wsave(jb)&
                  & ,lwb,Work(iw),lw,Ier)
      ELSE
         CALL DVHSGC(Nlatb,Nlonb,ityp,nt,Vb,Ub,Nlatb,Nlonb,Work(ibbr),   &
                  & Work(ibbi),Work(ibcr),Work(ibci),lb1,Nlatb,Wsave(jb)&
                  & ,lwb,Work(iw),lw,Ier)
      ENDIF
!
!     restore a grid and b grid vector fields (now in math coordinates) to
!     agree with grid flags in igrida,iveca,igridb,ivecb
!
      IF ( Iveca==0 ) CALL DNEGV(Nlata,Nlona,Va)
      IF ( Ivecb==0 ) CALL DNEGV(Nlatb,Nlonb,Vb)
      IF ( Igrida(1)>0 ) THEN
         CALL DCOVLAT(Nlata,Nlona,Ua)
         CALL DCOVLAT(Nlata,Nlona,Va)
      ENDIF
      IF ( Igridb(1)>0 ) THEN
         CALL DCOVLAT(Nlatb,Nlonb,Ub)
         CALL DCOVLAT(Nlatb,Nlonb,Vb)
      ENDIF
      IF ( Igrida(2)==0 ) THEN
         CALL DTRVPLAT(Nlata,Nlona,Ua,Work)
         CALL DTRVPLAT(Nlata,Nlona,Va,Work)
      ENDIF
      IF ( Igridb(2)==0 ) THEN
         CALL DTRVPLAT(Nlatb,Nlonb,Ub,Work)
         CALL DTRVPLAT(Nlatb,Nlonb,Vb,Work)
      ENDIF
    END SUBROUTINE DTRVSPH


    SUBROUTINE DNEGV(Nlat,Nlon,V)
!
!     negate (co)latitudinal vector componenet
!
      IMPLICIT NONE
      INTEGER Nlat , Nlon , i , j
      DOUBLE PRECISION V(Nlat,Nlon)
      DO j = 1 , Nlon
         DO i = 1 , Nlat
            V(i,j) = -V(i,j)
         ENDDO
      ENDDO
    END SUBROUTINE DNEGV


    SUBROUTINE DTRVAB(Ma,Na,Abr,Abi,Acr,Aci,Mb,Nb,Bbr,Bbi,Bcr,Bci)
      IMPLICIT NONE
      INTEGER Ma , Na , Mb , Nb , i , j , m , n
      DOUBLE PRECISION Abr(Ma,Na) , Abi(Ma,Na) , Acr(Ma,Na) , Aci(Ma,Na)
      DOUBLE PRECISION Bbr(Mb,Nb) , Bbi(Mb,Nb) , Bcr(Mb,Nb) , Bci(Mb,Nb)
!
!     set coefficients for b grid from coefficients for a grid
!
      m = MIN0(Ma,Mb)
      n = MIN0(Na,Nb)
      DO j = 1 , n
         DO i = 1 , m
            Bbr(i,j) = Abr(i,j)
            Bbi(i,j) = Abi(i,j)
            Bcr(i,j) = Acr(i,j)
            Bci(i,j) = Aci(i,j)
         ENDDO
      ENDDO
!
!     set coefs outside triangle to zero
!
      DO i = m + 1 , Mb
         DO j = 1 , Nb
            Bbr(i,j) = 0.0
            Bbi(i,j) = 0.0
            Bcr(i,j) = 0.0
            Bci(i,j) = 0.0
         ENDDO
      ENDDO
      DO j = n + 1 , Nb
         DO i = 1 , Mb
            Bbr(i,j) = 0.0
            Bbi(i,j) = 0.0
            Bcr(i,j) = 0.0
            Bci(i,j) = 0.0
         ENDDO
      ENDDO
    END SUBROUTINE DTRVAB


      SUBROUTINE DTRVPLAT(N,M,Data,Work)
!
!     transpose the n by m array data to a m by n array data
!     work must be at least n*m words long
!
      IMPLICIT NONE
      INTEGER N , M , i , j , ij , ji
      DOUBLE PRECISION Data(*) , Work(*)
      DO j = 1 , M
         DO i = 1 , N
            ij = (j-1)*N + i
            Work(ij) = Data(ij)
         ENDDO
      ENDDO
      DO i = 1 , N
         DO j = 1 , M
            ji = (i-1)*M + j
            ij = (j-1)*N + i
            Data(ji) = Work(ij)
         ENDDO
      ENDDO
    END SUBROUTINE DTRVPLAT

    
    SUBROUTINE DCOVLAT(Nlat,Nlon,Data)
      !
!     reverse order of latitude (colatitude) grids
!
      IMPLICIT NONE
      INTEGER Nlat , Nlon , nlat2 , i , ib , j
      DOUBLE PRECISION Data(Nlat,Nlon) , temp
      nlat2 = Nlat/2
      DO i = 1 , nlat2
         ib = Nlat - i + 1
         DO j = 1 , Nlon
            temp = Data(i,j)
            Data(i,j) = Data(ib,j)
            Data(ib,j) = temp
         ENDDO
      ENDDO
      END SUBROUTINE DCOVLAT

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c
c ... file slapes.f
c
c     this file includes documentation and code for
c     subroutine slapes          i
c
c ... files which must be loaded with slapec.f
c
c     sphcom.f, hrfft.f, shaes.f, shses.f
c
c
c
c     subroutine slapes(nlat,nlon,isym,nt,slap,ids,jds,a,b,mdab,ndab,
c    +                  wshses,lshses,work,lwork,ierror)
c
c
c     given the scalar spherical harmonic coefficients a and b, precomputed
c     by subroutine shaes for a scalar field sf, subroutine slapes computes
c     the laplacian of sf in the scalar array slap.  slap(i,j) is the
c     laplacian of sf at the colatitude
c
c         theta(i) = (i-1)*pi/(nlat-1)
c
c     and east longitude
c
c         lambda(j) = (j-1)*2*pi/nlon
c
c     on the sphere.  i.e.
c
c         slap(i,j) =
c
c                  2                2
c         [1/sint*d (sf(i,j)/dlambda + d(sint*d(sf(i,j))/dtheta)/dtheta]/sint
c
c
c     where sint = sin(theta(i)).  the scalar laplacian in slap has the
c     same symmetry or absence of symmetry about the equator as the scalar
c     field sf.  the input parameters isym,nt,mdab,ndab must have the
c     same values used by shaes to compute a and b for sf. the associated
c     legendre functions are stored rather than recomputed as they are
c     in subroutine slapec.

c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct longitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     isym   this parameter should have the same value input to subroutine
c            shaes to compute the coefficients a and b for the scalar field
c            sf.  isym is set as follows:
c
c            = 0  no symmetries exist in sf about the equator. scalar
c                 synthesis is used to compute slap on the entire sphere.
c                 i.e., in the array slap(i,j) for i=1,...,nlat and
c                 j=1,...,nlon.
c
c           = 1  sf and slap are antisymmetric about the equator. the
c                synthesis used to compute slap is performed on the
c                northern hemisphere only.  if nlat is odd, slap(i,j) is
c                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
c                nlat is even, slap(i,j) is computed for i=1,...,nlat/2
c                and j=1,...,nlon.
c
c
c           = 2  sf and slap are symmetric about the equator. the
c                synthesis used to compute slap is performed on the
c                northern hemisphere only.  if nlat is odd, slap(i,j) is
c                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
c                nlat is even, slap(i,j) is computed for i=1,...,nlat/2
c                and j=1,...,nlon.
c
c
c     nt     the number of analyses.  in the program that calls slapes
c            the arrays slap,a, and b can be three dimensional in which
c            case multiple synthesis will be performed.  the third index
c            is the synthesis index which assumes the values k=1,...,nt.
c            for a single analysis set nt=1. the description of the
c            remaining parameters is simplified by assuming that nt=1
c            or that all the arrays are two dimensional.
c
c   ids      the first dimension of the array slap as it appears in the
c            program that calls slapes.  if isym = 0 then ids must be at
c            least nlat.  if isym > 0 and nlat is even then ids must be
c            at least nlat/2. if isym > 0 and nlat is odd then ids must
c            be at least (nlat+1)/2.
c
c   jds      the second dimension of the array slap as it appears in the
c            program that calls slapes. jds must be at least nlon.
c
c
c   a,b      two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
c            of the scalar field sf as computed by subroutine shaes.
c     ***    a,b must be computed by shaes prior to calling slapes.
c
c
c    mdab    the first dimension of the arrays a and b as it appears
c            in the program that calls slapes.  mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c    ndab    the second dimension of the arrays a and b as it appears
c            in the program that calls slapes. ndbc must be at least
c            least nlat.
c
c            mdab,ndab should have the same values input to shaes to
c            compute the coefficients a and b.
c
c
c    wshses  an array which must be initialized by subroutine shsesi
c            before calling slapes.  once initialized, wshses
c            can be used repeatedly by slapes as long as nlat and nlon
c            remain unchanged.  wshses must not be altered between calls
c            of slapes.
c
c    lshses  the dimension of the array wshses as it appears in the
c            program that calls slapes.  let
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshses must be greater than or equal to
c
c               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15.
c
c
c     work   a work array that does not have to be saved.
c
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls slapes. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            if isym is zero then lwork must be at least
c
c               (nt+1)*nlat*nlon + nlat*(2*nt*l1+1)
c
c            if isym is nonzero lwork must be at least
c
c               (nt+1)*l2*nlon + nlat*(2*nt*l1+1)
c
c     **************************************************************
c
c     output parameters
c
c
c    slap    a two or three dimensional arrays (see input parameter nt) that
c            contain the scalar laplacian of the scalar field sf.  slap(i,j)
c            is the scalar laplacian at the colatitude
c
c                 theta(i) = (i-1)*pi/(nlat-1)
c
c            and longitude
c
c                 lambda(j) = (j-1)*2*pi/nlon
c
c            for i=1,...,nlat and j=1,...,nlon.
c
c
c  ierror    a parameter which flags errors in input parameters as follows:
c
c            = 0  no errors detected
c
c            = 1  error in the specification of nlat
c
c            = 2  error in the specification of nlon
c
c            = 3  error in the specification of ityp
c
c            = 4  error in the specification of nt
c
c            = 5  error in the specification of ids
c
c            = 6  error in the specification of jds
c
c            = 7  error in the specification of mdbc
c
c            = 8  error in the specification of ndbc
c
c            = 9  error in the specification of lshses
c
c            = 10 error in the specification of lwork
c
c
c **********************************************************************
c                                                                              
c     end of documentation for slapes
c
c **********************************************************************
c
      subroutine slapes(nlat,nlon,isym,nt,slap,ids,jds,a,b,mdab,ndab,
     +                  wshses,lshses,work,lwork,ierror)
      dimension slap(ids,jds,nt),a(mdab,ndab,nt),b(mdab,ndab,nt)
      dimension wshses(lshses),work(lwork)
c
c     check input parameters
c
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if(nlon .lt. 4) return
      ierror = 3
      if (isym.lt.0 .or. isym.gt.2) return
      ierror = 4
      if(nt .lt. 0) return
      ierror = 5
      imid = (nlat+1)/2
      if((isym.eq.0 .and. ids.lt.nlat) .or.
     1   (isym.gt.0 .and. ids.lt.imid)) return
      ierror = 6
      if(jds .lt. nlon) return
      ierror = 7
      mmax = min0(nlat,nlon/2+1)
      if(mdab .lt. mmax) return
      ierror = 8
      if(ndab .lt. nlat) return
      ierror = 9
      imid = (nlat+1)/2
      lpimn = (imid*mmax*(nlat+nlat-mmax+1))/2
      if(lshses .lt. lpimn+nlon+15) return
      ierror = 10
c
c     set and verify unsaved work space length
c
      ls = nlat
      if(isym .gt. 0) ls = imid
      nln = nt*ls*nlon
      mn = mmax*nlat*nt
c     lwkmin = nln+ls*nlon+2*mn+nlat
c     if (lwork .lt. lwkmin) return
      l2 = (nlat+1)/2
      l1 = min0(nlat,nlon/2+1)
      if (isym.eq.0) then
	lwkmin = (nt+1)*nlat*nlon + nlat*(2*nt*l1+1)
      else
	lwkmin = (nt+1)*l2*nlon + nlat*(2*nt*l1+1)
      end if
      if (lwork .lt. lwkmin) return
      ierror = 0
c
c     set work space pointers
c
      ia = 1
      ib = ia+mn
      ifn = ib+mn
      iwk = ifn+nlat
      lwk = lwork-2*mn-nlat
      call slapes1(nlat,nlon,isym,nt,slap,ids,jds,a,b,mdab,ndab,
     +work(ia),work(ib),mmax,work(ifn),wshses,lshses,work(iwk),lwk,
     +ierror)
      return
      end

      subroutine slapes1(nlat,nlon,isym,nt,slap,ids,jds,a,b,mdab,ndab,
     +                  alap,blap,mmax,fnn,wsave,lsave,wk,lwk,ierror)
      dimension slap(ids,jds,nt),a(mdab,ndab,nt),b(mdab,ndab,nt)
      dimension alap(mmax,nlat,nt),blap(mmax,nlat,nt),fnn(nlat)
      dimension wsave(lsave),wk(lwk)
c
c     set coefficient multiplyers
c
      do 1 n=2,nlat
      fn = float(n-1)
      fnn(n) = fn*(fn+1.)
    1 continue
c
c     compute scalar laplacian coefficients for each vector field
c
      do 2 k=1,nt
      do 3 n=1,nlat
      do 4 m=1,mmax
      alap(m,n,k) = 0.0
      blap(m,n,k) = 0.0
    4 continue
    3 continue
c
c     compute m=0 coefficients
c
      do 5 n=2,nlat
      alap(1,n,k) = -fnn(n)*a(1,n,k)
      blap(1,n,k) = -fnn(n)*b(1,n,k)
    5 continue
c
c     compute m>0 coefficients
c
      do 6 m=2,mmax
      do 7 n=m,nlat
      alap(m,n,k) = -fnn(n)*a(m,n,k)
      blap(m,n,k) = -fnn(n)*b(m,n,k)
    7 continue
    6 continue
    2 continue
c
c     synthesize alap,blap into slap
c
      call shses(nlat,nlon,isym,nt,slap,ids,jds,alap,blap,
     +           mmax,nlat,wsave,lsave,wk,lwk,ierror)
      return
      end

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c ... file sshifte.f contains code and documentation for subroutine sshifte
c     and its' initialization subroutine sshifti
c
c ... required files off spherepack3.0
c
c     hrfft.f
c
c     subroutine sshifte(ioff,nlon,nlat,goff,greg,wsav,lsav,work,lwork,ier)
c
c *** purpose
c
c     subroutine sshifte does a highly accurate 1/2 grid increment shift
c     in both longitude and latitude of equally spaced data on the sphere.
c     data is transferred between the nlon by nlat "offset grid" in goff
c     (which excludes poles) and the nlon by nlat+1 "regular grid" in greg
c     (which includes poles).  the transfer can go from goff to greg or from
c     greg to goff (see ioff).  the grids which underly goff and greg are
c     described below.  the north and south poles are at latitude 0.5*pi and
c     -0.5*pi radians respectively where pi = 4.*atan(1.).
c
c *** grid descriptions
c
c     let dlon = (pi+pi)/nlon and dlat = pi/nlat be the uniform grid
c     increments in longitude and latitude
c
c     offset grid
c
c     the "1/2 increment offset" grid (long(j),lat(i)) on which goff(j,i)
c     is given (ioff=0) or generated (ioff=1) is
c
c          long(j) =0.5*dlon + (j-1)*dlon  (j=1,...,nlon)
c
c     and
c
c          lat(i) = -0.5*pi + 0.5*dlat + (i-1)*dlat (i=1,...,nlat)
c
c     the data in goff is "shifted" one half a grid increment in longitude
c     and latitude and excludes the poles.  each goff(j,1) is given at
c     latitude -0.5*pi+0.5*dlat and goff(j,nlat) is given at 0.5*pi-0.5*dlat
c     (1/2 a grid increment away from the poles).  each goff(1,i),goff(nlon,i)
c     is given at longitude 0.5*dlon and 2.*pi-0.5*dlon.
c
c     regular grid
c
c     let dlat,dlon be as above.  then the nlon by nlat+1 grid on which
c     greg(j,i) is generated (ioff=0) or given (ioff=1) is given by
c
c          lone(j) = (j-1)*dlon (j=1,...,nlon)
c
c      and
c
c          late(i) = -0.5*pi + (i-1)*dlat (i=1,...,nlat+1)
c
c     values in greg include the poles and start at zero degrees longitude.
c
c *** remark
c
c     subroutine sshifte can be used in conjunction with subroutine trssph
c     when transferring data from an equally spaced "1/2 increment offset"
c     grid to a gaussian or equally spaced grid (which includes poles) of
c     any resolution.  this problem (personal communication with dennis
c     shea) is encountered in geophysical modeling and data analysis.
c
c *** method
c
c     fast fourier transform software from spherepack2 and trigonometric
c     identities are used to accurately "shift" periodic vectors half a
c     grid increment in latitude and longitude.  latitudinal shifts are
c     accomplished by setting periodic 2*nlat vectors over the pole for each
c     longitude.  when nlon is odd, this requires an additional longitude
c     shift.  longitudinal shifts are then executed for each shifted latitude.
c     when necessary (ioff=0) poles are obtained by averaging the nlon
c     shifted polar values.
c
c *** required files from spherepack3.0
c
c     hrfft.f
c
c *** argument description
c
c ... ioff
c
c     ioff = 0 if values on the offset grid in goff are given and values
c              on the regular grid in greg are to be generated.
c
c     ioff = 1 if values on the regular grid in greg are given and values
c              on the offset grid in goff are to be generated.
c
c ... nlon
c
c     the number of longitude points on both the "offset" and "regular"
c     uniform grid in longitude (see "grid description" above).  nlon
c     is also the first dimension of array goff and greg.  nlon determines
c     the grid increment in longitude as dlon = 2.*pi/nlon.  for example,
c     nlon = 144 for a 2.5 degree grid.  nlon can be even or odd and must
c     be greater than or equal to 4.  the efficiency of the computation
c     is improved when nlon is a product of small primes.
c
c ... nlat
c
c     the number of latitude points on the "offset" uniform grid.  nlat+1
c     is the number of latitude points on the "regular" uniform grid (see
c     "grid description" above).  nlat is the second dimension of array goff.
c     nlat+1 must be the second dimension of the array greg in the program
c     calling sshifte.  nlat determines the grid in latitude as pi/nlat.
c     for example, nlat = 36 for a five degree grid.  nlat must be at least 3.
c
c ... goff
c
c     a nlon by nlat array that contains data on the offset grid
c     described above.  goff is a given input argument if ioff=0.
c     goff is a generated output argument if ioff=1.
c
c ... greg
c
c     a nlon by nlat+1 array that contains data on the regular grid
c     described above.  greg is a given input argument if ioff=1.
c     greg is a generated output argument if ioff=0.
c
c ... wsav
c
c     a real saved work space array that must be initialized by calling
c     subroutine sshifti(ioff,nlon,nlat,wsav,ier) before calling sshifte.
c     wsav can then be used repeatedly by sshifte as long as ioff, nlon,
c     and nlat do not change.  this bypasses redundant computations and
c     saves time.  undetectable errors will result if sshifte is called
c     without initializing wsav whenever ioff, nlon, or nlat change.
c
c ... lsav
c
c     the length of the saved work space wsav in the routine calling sshifte
c     and sshifti.  lsave must be greater than or equal to 2*(2*nlat+nlon+16).
c
c ... work
c
c     a real unsaved work space
c
c ... lwork
c
c     the length of the unsaved work space in the routine calling sshifte
c     lwork must be greater than or equal to 2*nlon*(nlat+1) if nlon is even.
c     lwork must be greater than or equal to nlon*(5*nlat+1) if nlon is odd.
c
c ... ier
c
c     indicates errors in input parameters
c
c     = 0 if no errors are detected
c
c     = 1 if ioff is not equal to 0 or 1
c
c     = 1 if nlon < 4
c
c     = 2 if nlat < 3
c
c     = 3 if lsave < 2*(nlon+2*nlat+16)
c
c     = 4 if lwork < 2*nlon*(nlat+1) for nlon even or
c            lwork < nlon*(5*nlat+1) for nlon odd
c
c *** end of sshifte documentation
c
c     subroutine sshifti(ioff,nlon,nlat,lsav,wsav,ier)
c
c     subroutine sshifti initializes the saved work space wsav
c     for ioff and nlon and nlat (see documentation for sshifte).
c     sshifti must be called before sshifte whenever ioff or nlon
c     or nlat change.
c
c ... ier
c
c     = 0 if no errors with input arguments
c
c     = 1 if ioff is not 0 or 1
c
c     = 2 if nlon < 4
c
c     = 3 if nlat < 3
c
c     = 4 if lsav < 2*(2*nlat+nlon+16)
c
c *** end of sshifti documentation
c
      subroutine sshifte(ioff,nlon,nlat,goff,greg,wsav,lsav,
     +                   wrk,lwrk,ier)
      implicit none
      integer ioff,nlon,nlat,n2,nr,nlat2,nlatp1,lsav,lwrk,i1,i2,ier
      real goff(nlon,nlat),greg(nlon,*),wsav(lsav),wrk(lwrk)
c
c     check input parameters
c
      ier = 1
      if (ioff*(ioff-1).ne.0) return
      ier = 2
      if (nlon.lt.4) return
      ier = 3
      if (nlat .lt. 3) return
      ier = 4
      if (lsav .lt. 2*(2*nlat+nlon+16)) return
      ier = 5
      n2 = (nlon+1)/2
      if (2*n2 .eq. nlon) then
	if (lwrk .lt. 2*nlon*(nlat+1)) return
	i1 = 1
	nr = n2
      else
	if (lwrk .lt. nlon*(5*nlat+1)) return
	i1 = 1+2*nlat*nlon
	nr = nlon
      end if
      ier = 0
      nlat2 = nlat+nlat
      i2 = i1 + (nlat+1)*nlon
      if (ioff.eq.0) then
	call shftoff(nlon,nlat,goff,greg,wsav,nr,nlat2,
     +               wrk,wrk(i1),wrk(i2))
      else
	nlatp1 = nlat+1
	call shftreg(nlon,nlat,goff,greg,wsav,nr,nlat2,nlatp1,
     +               wrk,wrk(i1),wrk(i2))
      end if
      end

      subroutine shftoff(nlon,nlat,goff,greg,wsav,nr,nlat2,
     +                   rlat,rlon,wrk)
c
c     shift offset grid to regular grid, i.e.,
c     goff is given, greg is to be generated
c
      implicit none
      integer nlon,nlat,nlat2,n2,nr,j,i,js,isav
      real goff(nlon,nlat),greg(nlon,nlat+1)
      real rlat(nr,nlat2),rlon(nlat,nlon)
      real wsav(*),wrk(*)
      real gnorth,gsouth
      isav = 4*nlat+17
      n2 = (nlon+1)/2
c
c     execute full circle latitude shifts for nlon odd or even
c
      if (2*n2 .gt. nlon) then
c
c     odd number of longitudes
c
	do i=1,nlat
	  do j=1,nlon
	    rlon(i,j) = goff(j,i)
	  end do
	end do
c
c       half shift in longitude
c
	call shifth(nlat,nlon,rlon,wsav(isav),wrk)
c
c       set full 2*nlat circles in rlat using shifted values in rlon
c
	do j=1,n2-1
	  js = j+n2
	  do i=1,nlat
	    rlat(j,i)      = goff(j,i)
	    rlat(j,nlat+i) = rlon(nlat+1-i,js)
	  end do
	end do
	do j=n2,nlon
	  js = j-n2+1
	  do i=1,nlat
	    rlat(j,i)      = goff(j,i)
	    rlat(j,nlat+i) = rlon(nlat+1-i,js)
	  end do
	end do
c
c       shift the nlon rlat vectors one half latitude grid
c
	call shifth(nlon,nlat2,rlat,wsav,wrk)
c
c       set nonpole values in greg and average for poles
c
	gnorth = 0.0
	gsouth = 0.0
	do j=1,nlon
	  gnorth = gnorth + rlat(j,1)
	  gsouth = gsouth + rlat(j,nlat+1)
	  do i=2,nlat
	    greg(j,i) =  rlat(j,i)
	  end do
	end do
	gnorth = gnorth/nlon
	gsouth = gsouth/nlon

      else
c
c     even number of longitudes (no initial longitude shift necessary)
c     set full 2*nlat circles (over poles) for each longitude pair (j,js)
c
	do j=1,n2
	  js = n2+j
	  do i=1,nlat
	    rlat(j,i)      = goff(j,i)
	    rlat(j,nlat+i) = goff(js,nlat+1-i)
	  end do
	end do
c
c       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
c
	call shifth(n2,nlat2,rlat,wsav,wrk)
c
c       set nonpole values in greg and average poles
c
	gnorth = 0.0
	gsouth = 0.0
	do j=1,n2
	  js = n2+j
	  gnorth = gnorth + rlat(j,1)
	  gsouth = gsouth + rlat(j,nlat+1)
	  do i=2,nlat
	    greg(j,i) =  rlat(j,i)
	    greg(js,i) = rlat(j,nlat2-i+2)
	  end do
	end do
	gnorth = gnorth/n2
	gsouth = gsouth/n2
      end if
c
c     set poles
c
      do j=1,nlon
	greg(j,1)      = gnorth
	greg(j,nlat+1) = gsouth
      end do
c
c     execute full circle longitude shift
c
      do j=1,nlon
	do i=1,nlat
	  rlon(i,j) = greg(j,i)
	end do
      end do
      call shifth(nlat,nlon,rlon,wsav(isav),wrk)
      do j=1,nlon
	do i=2,nlat
	  greg(j,i) = rlon(i,j)
	end do
      end do
      end

      subroutine shftreg(nlon,nlat,goff,greg,wsav,nr,nlat2,nlatp1,
     +                   rlat,rlon,wrk)
c
c     shift regular grid to offset grid, i.e.,
c     greg is given, goff is to be generated
c
      implicit none
      integer nlon,nlat,nlat2,nlatp1,n2,nr,j,i,js,isav
      real goff(nlon,nlat),greg(nlon,nlatp1)
      real rlat(nr,nlat2),rlon(nlatp1,nlon)
      real wsav(*),wrk(*)
      isav = 4*nlat+17
      n2 = (nlon+1)/2
c
c     execute full circle latitude shifts for nlon odd or even
c
      if (2*n2 .gt. nlon) then
c
c     odd number of longitudes
c
	do i=1,nlat+1
	  do j=1,nlon
	    rlon(i,j) = greg(j,i)
	  end do
	end do
c
c       half shift in longitude in rlon
c
	call shifth(nlat+1,nlon,rlon,wsav(isav),wrk)
c
c       set full 2*nlat circles in rlat using shifted values in rlon
c
	do j=1,n2
	  js = j+n2-1
	  rlat(j,1) = greg(j,1)
	  do i=2,nlat
	    rlat(j,i) = greg(j,i)
	    rlat(j,nlat+i) = rlon(nlat+2-i,js)
	  end do
	  rlat(j,nlat+1) = greg(j,nlat+1)
	end do
	do j=n2+1,nlon
	  js = j-n2
	  rlat(j,1) = greg(j,1)
	  do i=2,nlat
	    rlat(j,i) = greg(j,i)
	    rlat(j,nlat+i) = rlon(nlat+2-i,js)
	  end do
	  rlat(j,nlat+1) = greg(j,nlat+1)
	end do
c
c       shift the nlon rlat vectors one halflatitude grid
c
	call shifth(nlon,nlat2,rlat,wsav,wrk)
c
c       set values in goff
c
	do j=1,nlon
	  do i=1,nlat
	    goff(j,i) =  rlat(j,i)
	  end do
	end do

      else
c
c     even number of longitudes (no initial longitude shift necessary)
c     set full 2*nlat circles (over poles) for each longitude pair (j,js)
c
	do j=1,n2
	  js = n2+j
	  rlat(j,1) = greg(j,1)
	  do i=2,nlat
	    rlat(j,i) = greg(j,i)
	    rlat(j,nlat+i) = greg(js,nlat+2-i)
	  end do
	  rlat(j,nlat+1) = greg(j,nlat+1)
	end do
c
c       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
c
	call shifth(n2,nlat2,rlat,wsav,wrk)
c
c       set values in goff
c
	do j=1,n2
	  js = n2+j
	  do i=1,nlat
	    goff(j,i) =  rlat(j,i)
	    goff(js,i) = rlat(j,nlat2+1-i)
	  end do
	end do
      end if
c
c     execute full circle longitude shift for all latitude circles
c
      do j=1,nlon
	do i=1,nlat
	  rlon(i,j) = goff(j,i)
	end do
      end do
      call shifth(nlat+1,nlon,rlon,wsav(isav),wrk)
      do j=1,nlon
	do i=1,nlat
	  goff(j,i) = rlon(i,j)
	end do
      end do
      end

      subroutine sshifti(ioff,nlon,nlat,lsav,wsav,ier)
      integer ioff,nlat,nlon,nlat2,isav,ier
      real wsav(lsav)
      real pi,dlat,dlon,dp
      ier = 1
      if (ioff*(ioff-1).ne.0) return
      ier = 2
      if (nlon .lt. 4) return
      ier = 3
      if (nlat .lt. 3) return
      ier = 4
      if (lsav .lt. 2*(2*nlat+nlon+16)) return
      ier = 0
      pi = 4.0*atan(1.0)
c
c     set lat,long increments
c
      dlat = pi/nlat
      dlon = (pi+pi)/nlon
c
c     initialize wsav for left or right latitude shifts
c
      if (ioff.eq.0) then
	dp = -0.5*dlat
      else
	dp = 0.5*dlat
      end if
      nlat2 = nlat+nlat
      call shifthi(nlat2,dp,wsav)
c
c     initialize wsav for left or right longitude shifts
c
      if (ioff.eq.0) then
	dp = -0.5*dlon
      else
	dp = 0.5*dlon
      end if
      isav = 4*nlat + 17
      call shifthi(nlon,dp,wsav(isav))
      return
      end

      subroutine shifth(m,n,r,wsav,work)
      implicit none
      integer m,n,n2,k,l
      real r(m,n),wsav(*),work(*),r2km2,r2km1
      n2 = (n+1)/2
c
c     compute fourier coefficients for r on shifted grid
c
      call hrfftf(m,n,r,m,wsav(n+2),work)
      do l=1,m
	do k=2,n2
	  r2km2 = r(l,k+k-2)
	  r2km1 = r(l,k+k-1)
	  r(l,k+k-2)   =  r2km2*wsav(n2+k) - r2km1*wsav(k)
	  r(l,k+k-1)   =  r2km2*wsav(k)    + r2km1*wsav(n2+k)
	end do
      end do
c
c     shift r with fourier synthesis and normalization
c
      call hrfftb(m,n,r,m,wsav(n+2),work)
      do l=1,m
	do k=1,n
	  r(l,k) = r(l,k)/n
	end do
      end do
      return
      end

      subroutine shifthi(n,dp,wsav)
c
c     initialize wsav for subroutine shifth
c
      implicit none
      integer n,n2,k
      real wsav(*),dp
      n2 = (n+1)/2
      do k=2,n2
	wsav(k)    =  sin((k-1)*dp)
	wsav(k+n2) =  cos((k-1)*dp)
      end do
      call hrffti(n,wsav(n+2))
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
! ... file ihgeod.f
!
!     contains documentation and code for subroutine ihgeod
!
!
      SUBROUTINE IHGEOD(M,Idp,Jdp,X,Y,Z)
      IMPLICIT NONE
      REAL beta , dphi , dxi , dxj , dyi , dyj , dzi , dzj , hdphi ,    &
         & phi , pi , rad , tdphi , theta , theta1 , theta2 , X , x1 ,  &
         & x2 , x3
      REAL x4 , x5 , x6 , xs , Y , y1 , y2 , y3 , y4 , y5 , y6 , ys ,   &
         & Z , z1 , z2 , z3 , z4 , z5 , z6 , zs
      INTEGER i , Idp , j , Jdp , k , M
      DIMENSION X(Idp,Jdp,5) , Y(Idp,Jdp,5) , Z(Idp,Jdp,5)
!
!     m         is the number of points on the edge of a
!               single geodesic triangle
!
!     x,y,z     the coordinates of the geodesic points on
!               the sphere are x(i,j,k), y(i,j,k), z(i,j,k)
!               where i=1,...,m+m-1; j=1,...,m; and k=1,...,5.
!               the indices are defined on the unfolded
!               icosahedron as follows for the case m=3
!
!                north pole
!
!                 (5,1)          0      l
!        i     (4,1) (5,2)              a    (repeated for
!           (3,1) (4,2) (5,3)  theta1   t    k=2,3,4,5 in
!        (2,1) (3,2) (4,3)              i        -->
!     (1,1) (2,2) (3,3)        theta2   t    the longitudinal
!        (1,2) (2,3)                    u    direction)
!           (1,3)                pi     d
!      j                                e
!         south pole
!
!                total number of points is 10*(m-1)**2+2
!                total number of triangles is 20*(m-1)**2
!                total number of edges is 30*(m-1)**2
!
      pi = 4.*ATAN(1.)
      dphi = .4*pi
      beta = COS(dphi)
      theta1 = ACOS(beta/(1.-beta))
      theta2 = pi - theta1
      hdphi = dphi/2.
      tdphi = 3.*hdphi
      DO k = 1 , 5
         phi = (k-1)*dphi
         CALL STOC(1.,theta2,phi,x1,y1,z1)
         CALL STOC(1.,pi,phi+hdphi,x2,y2,z2)
         CALL STOC(1.,theta2,phi+dphi,x3,y3,z3)
         dxi = (x2-x1)/(M-1)
         dyi = (y2-y1)/(M-1)
         dzi = (z2-z1)/(M-1)
         dxj = (x3-x2)/(M-1)
         dyj = (y3-y2)/(M-1)
         dzj = (z3-z2)/(M-1)
         DO i = 1 , M
            xs = x1 + (i-1)*dxi
            ys = y1 + (i-1)*dyi
            zs = z1 + (i-1)*dzi
            DO j = 1 , i
               X(j,i,k) = xs + (j-1)*dxj
               Y(j,i,k) = ys + (j-1)*dyj
               Z(j,i,k) = zs + (j-1)*dzj
            ENDDO
         ENDDO
         CALL STOC(1.,theta1,phi+hdphi,x4,y4,z4)
         dxi = (x3-x4)/(M-1)
         dyi = (y3-y4)/(M-1)
         dzi = (z3-z4)/(M-1)
         dxj = (x4-x1)/(M-1)
         dyj = (y4-y1)/(M-1)
         dzj = (z4-z1)/(M-1)
         DO j = 1 , M
            xs = x1 + (j-1)*dxj
            ys = y1 + (j-1)*dyj
            zs = z1 + (j-1)*dzj
            DO i = 1 , j
               X(j,i,k) = xs + (i-1)*dxi
               Y(j,i,k) = ys + (i-1)*dyi
               Z(j,i,k) = zs + (i-1)*dzi
            ENDDO
         ENDDO
         CALL STOC(1.,theta1,phi+tdphi,x5,y5,z5)
         dxj = (x5-x3)/(M-1)
         dyj = (y5-y3)/(M-1)
         dzj = (z5-z3)/(M-1)
         DO i = 1 , M
            xs = x4 + (i-1)*dxi
            ys = y4 + (i-1)*dyi
            zs = z4 + (i-1)*dzi
            DO j = 1 , i
               X(j+M-1,i,k) = xs + (j-1)*dxj
               Y(j+M-1,i,k) = ys + (j-1)*dyj
               Z(j+M-1,i,k) = zs + (j-1)*dzj
            ENDDO
         ENDDO
         CALL STOC(1.,0.,phi+dphi,x6,y6,z6)
         dxi = (x5-x6)/(M-1)
         dyi = (y5-y6)/(M-1)
         dzi = (z5-z6)/(M-1)
         dxj = (x6-x4)/(M-1)
         dyj = (y6-y4)/(M-1)
         dzj = (z6-z4)/(M-1)
         DO j = 1 , M
            xs = x4 + (j-1)*dxj
            ys = y4 + (j-1)*dyj
            zs = z4 + (j-1)*dzj
            DO i = 1 , j
               X(j+M-1,i,k) = xs + (i-1)*dxi
               Y(j+M-1,i,k) = ys + (i-1)*dyi
               Z(j+M-1,i,k) = zs + (i-1)*dzi
            ENDDO
         ENDDO
      ENDDO
      DO k = 1 , 5
         DO j = 1 , M + M - 1
            DO i = 1 , M
               CALL CTOS(X(j,i,k),Y(j,i,k),Z(j,i,k),rad,theta,phi)
               CALL STOC(1.,theta,phi,X(j,i,k),Y(j,i,k),Z(j,i,k))
            ENDDO
         ENDDO
      ENDDO
    END SUBROUTINE IHGEOD

    
    SUBROUTINE CTOS(X,Y,Z,R,Theta,Phi)
      IMPLICIT NONE
      REAL Phi , R , r1 , Theta , X , Y , Z
      r1 = X*X + Y*Y
      IF ( r1/=0. ) THEN
         R = SQRT(r1+Z*Z)
         r1 = SQRT(r1)
         Phi = ATAN2(Y,X)
         Theta = ATAN2(r1,Z)
         GOTO 99999
      ENDIF
      Phi = 0.
      Theta = 0.
      IF ( Z<0. ) Theta = 4.*ATAN(1.)
      RETURN
99999 END SUBROUTINE CTOS

      
      SUBROUTINE STOC(R,Theta,Phi,X,Y,Z)
      IMPLICIT NONE
      REAL Phi , R , st , Theta , X , Y , Z
      st = SIN(Theta)
      X = R*st*COS(Phi)
      Y = R*st*SIN(Phi)
      Z = R*COS(Theta)
      END SUBROUTINE STOC



      SUBROUTINE DIHGEOD(M,IDP,JDP,X,Y,Z)
        IMPLICIT NONE
        INTEGER M,  IDP, JDP, I, J, K
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION PI
      DOUBLE PRECISION DPHI
      DOUBLE PRECISION BETA
      DOUBLE PRECISION THETA1
      DOUBLE PRECISION THETA2
      DOUBLE PRECISION HDPHI
      DOUBLE PRECISION TDPHI
      DOUBLE PRECISION PHI
      DOUBLE PRECISION X1
      DOUBLE PRECISION Y1
      DOUBLE PRECISION Z1
      DOUBLE PRECISION X2
      DOUBLE PRECISION Y2
      DOUBLE PRECISION Z2
      DOUBLE PRECISION X3
      DOUBLE PRECISION Y3
      DOUBLE PRECISION Z3
      DOUBLE PRECISION DXI
      DOUBLE PRECISION DYI
      DOUBLE PRECISION DZI
      DOUBLE PRECISION DXJ
      DOUBLE PRECISION DYJ
      DOUBLE PRECISION DZJ
      DOUBLE PRECISION XS
      DOUBLE PRECISION YS
      DOUBLE PRECISION ZS
      DOUBLE PRECISION X4
      DOUBLE PRECISION Y4
      DOUBLE PRECISION Z4
      DOUBLE PRECISION X5
      DOUBLE PRECISION Y5
      DOUBLE PRECISION Z5
      DOUBLE PRECISION X6
      DOUBLE PRECISION Y6
      DOUBLE PRECISION Z6
      DOUBLE PRECISION RAD
      DOUBLE PRECISION THETA
      DIMENSION X(IDP,JDP,5),Y(IDP,JDP,5),Z(IDP,JDP,5)
!
!     m         is the number of points on the edge of a
!               single geodesic triangle
!
!     x,y,z     the coordinates of the geodesic points on
!               the sphere are x(i,j,k), y(i,j,k), z(i,j,k)
!               where i=1,...,m+m-1; j=1,...,m; and k=1,...,5.
!               the indices are defined on the unfolded
!               icosahedron as follows for the case m=3
!
!                north pole
!
!                 (5,1)          0      l
!        i     (4,1) (5,2)              a    (repeated for
!           (3,1) (4,2) (5,3)  theta1   t    k=2,3,4,5 in
!        (2,1) (3,2) (4,3)              i        -->
!     (1,1) (2,2) (3,3)        theta2   t    the longitudinal
!        (1,2) (2,3)                    u    direction)
!           (1,3)                pi     d
!      j                                e
!         south pole
!
!                total number of points is 10*(m-1)**2+2
!                total number of triangles is 20*(m-1)**2
!                total number of edges is 30*(m-1)**2
!
      PI = 4.D0*ATAN(1.D0)
      DPHI = .4D0*PI
      BETA = COS(DPHI)
      THETA1 = ACOS(BETA/ (1.D0-BETA))
      THETA2 = PI - THETA1
      HDPHI = DPHI/2.D0
      TDPHI = 3.D0*HDPHI
      DO K = 1,5
          PHI = (K-1)*DPHI
          CALL DSTOC(1.D0,THETA2,PHI,X1,Y1,Z1)
          CALL DSTOC(1.D0,PI,PHI+HDPHI,X2,Y2,Z2)
          CALL DSTOC(1.D0,THETA2,PHI+DPHI,X3,Y3,Z3)
          DXI = (X2-X1)/ (M-1)
          DYI = (Y2-Y1)/ (M-1)
          DZI = (Z2-Z1)/ (M-1)
          DXJ = (X3-X2)/ (M-1)
          DYJ = (Y3-Y2)/ (M-1)
          DZJ = (Z3-Z2)/ (M-1)
          DO I = 1,M
              XS = X1 + (I-1)*DXI
              YS = Y1 + (I-1)*DYI
              ZS = Z1 + (I-1)*DZI
              DO J = 1,I
                  X(J,I,K) = XS + (J-1)*DXJ
                  Y(J,I,K) = YS + (J-1)*DYJ
                  Z(J,I,K) = ZS + (J-1)*DZJ
              END DO
          END DO
          CALL DSTOC(1.D0,THETA1,PHI+HDPHI,X4,Y4,Z4)
          DXI = (X3-X4)/ (M-1)
          DYI = (Y3-Y4)/ (M-1)
          DZI = (Z3-Z4)/ (M-1)
          DXJ = (X4-X1)/ (M-1)
          DYJ = (Y4-Y1)/ (M-1)
          DZJ = (Z4-Z1)/ (M-1)
          DO J = 1,M
              XS = X1 + (J-1)*DXJ
              YS = Y1 + (J-1)*DYJ
              ZS = Z1 + (J-1)*DZJ
              DO I = 1,J
                  X(J,I,K) = XS + (I-1)*DXI
                  Y(J,I,K) = YS + (I-1)*DYI
                  Z(J,I,K) = ZS + (I-1)*DZI
              END DO
          END DO
          CALL DSTOC(1.D0,THETA1,PHI+TDPHI,X5,Y5,Z5)
          DXJ = (X5-X3)/ (M-1)
          DYJ = (Y5-Y3)/ (M-1)
          DZJ = (Z5-Z3)/ (M-1)
          DO I = 1,M
              XS = X4 + (I-1)*DXI
              YS = Y4 + (I-1)*DYI
              ZS = Z4 + (I-1)*DZI
              DO J = 1,I
                  X(J+M-1,I,K) = XS + (J-1)*DXJ
                  Y(J+M-1,I,K) = YS + (J-1)*DYJ
                  Z(J+M-1,I,K) = ZS + (J-1)*DZJ
              END DO
          END DO
          CALL DSTOC(1.D0,0.D0,PHI+DPHI,X6,Y6,Z6)
          DXI = (X5-X6)/ (M-1)
          DYI = (Y5-Y6)/ (M-1)
          DZI = (Z5-Z6)/ (M-1)
          DXJ = (X6-X4)/ (M-1)
          DYJ = (Y6-Y4)/ (M-1)
          DZJ = (Z6-Z4)/ (M-1)
          DO J = 1,M
              XS = X4 + (J-1)*DXJ
              YS = Y4 + (J-1)*DYJ
              ZS = Z4 + (J-1)*DZJ
              DO I = 1,J
                  X(J+M-1,I,K) = XS + (I-1)*DXI
                  Y(J+M-1,I,K) = YS + (I-1)*DYI
                  Z(J+M-1,I,K) = ZS + (I-1)*DZI
              END DO
          END DO
      END DO
      DO K = 1,5
          DO J = 1,M + M - 1
              DO I = 1,M
                  CALL DCTOS(X(J,I,K),Y(J,I,K),Z(J,I,K),RAD,THETA,PHI)
                  CALL DSTOC(1.D0,THETA,PHI,X(J,I,K),Y(J,I,K),Z(J,I,K))
              END DO
          END DO
      END DO
      RETURN
    END SUBROUTINE DIHGEOD
    
    SUBROUTINE DCTOS(X,Y,Z,R,THETA,PHI)
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION R
      DOUBLE PRECISION THETA
      DOUBLE PRECISION PHI
      DOUBLE PRECISION R1

      R1 = X*X + Y*Y
      IF (R1.NE.0.D0) GO TO 10
      PHI = 0.D0
      THETA = 0.D0
      IF (Z.LT.0.D0) THETA = 4.D0*ATAN(1.D0)
      RETURN
   10 R = SQRT(R1+Z*Z)
      R1 = SQRT(R1)
      PHI = ATAN2(Y,X)
      THETA = ATAN2(R1,Z)
      RETURN
    END SUBROUTINE DCTOS
    
    SUBROUTINE DSTOC(R,THETA,PHI,X,Y,Z)
      DOUBLE PRECISION R
      DOUBLE PRECISION THETA
      DOUBLE PRECISION PHI
      DOUBLE PRECISION X
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z
      DOUBLE PRECISION ST

      ST = SIN(THETA)
      X = R*ST*COS(PHI)
      Y = R*ST*SIN(PHI)
      Z = R*COS(THETA)
      RETURN
    END SUBROUTINE DSTOC

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vhagc.f
c
c     this file contains code and documentation for subroutines
c     vhagc and vhagci
c
c ... files which must be loaded with vhagc.f
c
c     sphcom.f, hrfft.f, gaqd.f
c
c                                                                              
c     subroutine vhagc(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
c    +                 mdab,ndab,wvhagc,lvhagc,work,lwork,ierror)
c
c     subroutine vhagc performs the vector spherical harmonic analysis
c     on the vector field (v,w) and stores the result in the arrays
c     br,bi,cr, and ci. v(i,j) and w(i,j) are the colatitudinal
c     (measured from the north pole) and east longitudinal components
c     respectively, located at the gaussian colatitude point theta(i)
c     and longitude phi(j) = (j-1)*2*pi/nlon. the spectral
c     representation of (v,w) is given at output parameters v,w in 
c     subroutine vhsec.  
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are computed
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     ityp   = 0  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and 
c                 j=1,...,nlon.   
c
c            = 1  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and 
c                 j=1,...,nlon. the curl of (v,w) is zero. that is, 
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0. 
c                 the coefficients cr and ci are zero.
c
c            = 2  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 arrays v(i,j),w(i,j) for i=1,...,nlat and 
c                 j=1,...,nlon. the divergence of (v,w) is zero. i.e., 
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0. 
c                 the coefficients br and bi are zero.
c
c            = 3  v is symmetric and w is antisymmetric about the 
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for 
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 4  v is symmetric and w is antisymmetric about the 
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for 
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the curl of (v,w) is zero. that is, 
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0. 
c                 the coefficients cr and ci are zero.
c
c            = 5  v is symmetric and w is antisymmetric about the 
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for 
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the divergence of (v,w) is zero. i.e., 
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0. 
c                 the coefficients br and bi are zero.
c
c            = 6  v is antisymmetric and w is symmetric about the 
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for 
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 7  v is antisymmetric and w is symmetric about the 
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for 
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the curl of (v,w) is zero. that is, 
c                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0. 
c                 the coefficients cr and ci are zero.
c
c            = 8  v is antisymmetric and w is symmetric about the 
c                 equator. the analysis is performed on the northern
c                 hemisphere only.  i.e., if nlat is odd the analysis
c                 is performed on the arrays v(i,j),w(i,j) for 
c                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
c                 even the analysis is performed on the the arrays
c                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c                 the divergence of (v,w) is zero. i.e., 
c                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0. 
c                 the coefficients br and bi are zero.
c
c
c     nt     the number of analyses.  in the program that calls vhagc,
c            the arrays v,w,br,bi,cr, and ci can be three dimensional
c            in which case multiple analyses will be performed.
c            the third index is the analysis index which assumes the 
c            values k=1,...,nt.  for a single analysis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that all the arrays are two
c            dimensional.
c
c     v,w    two or three dimensional arrays (see input parameter nt)
c            that contain the vector function to be analyzed.
c            v is the colatitudnal component and w is the east 
c            longitudinal component. v(i,j),w(i,j) contain the
c            components at colatitude theta(i) = (i-1)*pi/(nlat-1)
c            and longitude phi(j) = (j-1)*2*pi/nlon. the index ranges
c            are defined above at the input parameter ityp.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls vhagc. if ityp .le. 2 then idvw
c            must be at least nlat.  if ityp .gt. 2 and nlat is
c            even then idvw must be at least nlat/2. if ityp .gt. 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls vhagc. jdvw must be at least nlon.
c
c     mdab   the first dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vhagc. mdab must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays br,bi,cr, and ci as it
c            appears in the program that calls vhagc. ndab must be at
c            least nlat.
c
c     wvhagc an array which must be initialized by subroutine vhagci.
c            once initialized, wvhagc can be used repeatedly by vhagc
c            as long as nlon and nlat remain unchanged.  wvhagc must
c            not be altered between calls of vhagc.
c
c     lvhagc the dimension of the array wvhagc as it appears in the
c            program that calls vhagc. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhagc must be at least
c
c               4*nlat*l2+3*max0(l1-2,0)*(2*nlat-l1-1)+nlon+l2+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vhagc. define
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if ityp .le. 2 then lwork must be at least
c
c               2*nlat*(2*nlon*nt+3*l2)
c
c            if ityp .gt. 2 then lwork must be at least
c
c               2*l2*(2*nlon*nt+3*nlat)
c
c
c
c     **************************************************************
c
c     output parameters
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c     cr,ci  that contain the vector spherical harmonic coefficients
c            in the spectral representation of v(i,j) and w(i,j) given 
c            in the discription of subroutine vhsec. br(mp1,np1),
c            bi(mp1,np1),cr(mp1,np1), and ci(mp1,np1) are computed 
c            for mp1=1,...,mmax and np1=mp1,...,nlat except for np1=nlat
c            and odd mp1. mmax=min0(nlat,nlon/2) if nlon is even or 
c            mmax=min0(nlat,(nlon+1)/2) if nlon is odd. 
c      
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of ityp
c            = 4  error in the specification of nt
c            = 5  error in the specification of idvw
c            = 6  error in the specification of jdvw
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lvhagc
c            = 10 error in the specification of lwork
c
c ****************************************************************
c
c     subroutine vhagci(nlat,nlon,wvhagc,lvhagc,dwork,ldwork,ierror)
c
c     subroutine vhagci initializes the array wvhagc which can then be
c     used repeatedly by subroutine vhagc until nlat or nlon is changed.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are computed
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     lvhagc the dimension of the array wvhagc as it appears in the
c            program that calls vhagci.  define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhagc must be at least
c
c               4*nlat*l2+3*max0(l1-2,0)*(2*nlat-l1-1)+nlon+l2+15
c
c
c     dwork  a double precision work array that does not need to be saved
c
c     ldwork the dimension of the array dwork as it appears in the
c            program that calls vhagci. ldwork must be at least
c
c               2*nlat*(nlat+1)+1
c
c
c     **************************************************************
c
c     output parameters
c
c     wvhagc an array which is initialized for use by subroutine vhagc.
c            once initialized, wvhagc can be used repeatedly by vhagc
c            as long as nlat and nlon remain unchanged.  wvhagc must not
c            be altered between calls of vhagc.
c
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lvhagc
c            = 4  error in the specification of lwork
c
      subroutine vhagc(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
     1           mdab,ndab,wvhagc,lvhagc,work,lwork,ierror)
      dimension v(idvw,jdvw,1),w(idvw,jdvw,1),br(mdab,ndab,1),
     1          bi(mdab,ndab,1),cr(mdab,ndab,1),ci(mdab,ndab,1),
     2          work(1),wvhagc(1)
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if(nlon .lt. 1) return
      ierror = 3
      if(ityp.lt.0 .or. ityp.gt.8) return
      ierror = 4
      if(nt .lt. 0) return
      ierror = 5
      imid = (nlat+1)/2
      if((ityp.le.2 .and. idvw.lt.nlat) .or.
     +   (ityp.gt.2 .and. idvw.lt.imid)) return
      ierror = 6
      if(jdvw .lt. nlon) return
      ierror = 7
      mmax = min0(nlat,(nlon+1)/2)
      if(mdab .lt. mmax) return
      ierror = 8
      if(ndab .lt. nlat) return
      ierror = 9
      lzz1 = 2*nlat*imid
      labc = 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
      if(lvhagc .lt. 2*(lzz1+labc)+nlon+imid+15) return
      ierror = 10
      if (ityp.le.2 .and. lwork.lt.nlat*(4*nlon*nt+6*imid)) return
      if (ityp.gt.2 .and. lwork.lt.imid*(4*nlon*nt+6*nlat)) return
      ierror = 0
      idv = nlat
      if(ityp .gt. 2) idv = imid
      lnl = nt*idv*nlon
      ist = 0
      if(ityp .le. 2) ist = imid
      iw1 = ist+1
      iw2 = lnl+1
      iw3 = iw2+ist
      iw4 = iw2+lnl
      iw5 = iw4+3*imid*nlat
      lwzvin = lzz1+labc
      jw1 = (nlat+1)/2+1
      jw2 = jw1+lwzvin
      jw3 = jw2+lwzvin
      call vhagc1(nlat,nlon,ityp,nt,imid,idvw,jdvw,v,w,mdab,ndab,
     +br,bi,cr,ci,idv,work,work(iw1),work(iw2),work(iw3),
     +work(iw4),work(iw5),wvhagc,wvhagc(jw1),wvhagc(jw2),wvhagc(jw3))
      return
      end
      subroutine vhagc1(nlat,nlon,ityp,nt,imid,idvw,jdvw,v,w,mdab,
     +ndab,br,bi,cr,ci,idv,ve,vo,we,wo,vb,wb,wts,wvbin,wwbin,wrfft)
      dimension v(idvw,jdvw,1),w(idvw,jdvw,1),br(mdab,ndab,1),
     1          bi(mdab,ndab,1),cr(mdab,ndab,1),ci(mdab,ndab,1),
     2          ve(idv,nlon,1),vo(idv,nlon,1),we(idv,nlon,1),
     3          wo(idv,nlon,1),wts(*),wvbin(1),wwbin(1),wrfft(1),
     4          vb(imid,nlat,3),wb(imid,nlat,3)
      nlp1 = nlat+1
      tsn = 2./nlon
      fsn = 4./nlon
      mlat = mod(nlat,2)
      mlon = mod(nlon,2)
      mmax = min0(nlat,(nlon+1)/2)
      imm1 = imid
      if(mlat .ne. 0) imm1 = imid-1
      if(ityp .gt. 2) go to 3  
      do 5 k=1,nt 
      do 5 i=1,imm1
      do 5 j=1,nlon
      ve(i,j,k) = tsn*(v(i,j,k)+v(nlp1-i,j,k))
      vo(i,j,k) = tsn*(v(i,j,k)-v(nlp1-i,j,k))
      we(i,j,k) = tsn*(w(i,j,k)+w(nlp1-i,j,k))
      wo(i,j,k) = tsn*(w(i,j,k)-w(nlp1-i,j,k))
    5 continue
      go to 2
    3 do 8 k=1,nt
      do 8 i=1,imm1 
      do 8 j=1,nlon
      ve(i,j,k) = fsn*v(i,j,k)
      vo(i,j,k) = fsn*v(i,j,k)
      we(i,j,k) = fsn*w(i,j,k)
      wo(i,j,k) = fsn*w(i,j,k)
    8 continue
    2 if(mlat .eq. 0) go to 7
      do 6 k=1,nt 
      do 6 j=1,nlon
      ve(imid,j,k) = tsn*v(imid,j,k)
      we(imid,j,k) = tsn*w(imid,j,k)
    6 continue
    7 do 9 k=1,nt
      call hrfftf(idv,nlon,ve(1,1,k),idv,wrfft,vb)
      call hrfftf(idv,nlon,we(1,1,k),idv,wrfft,vb)
    9 continue 
      ndo1 = nlat
      ndo2 = nlat
      if(mlat .ne. 0) ndo1 = nlat-1
      if(mlat .eq. 0) ndo2 = nlat-1
      if(ityp.eq.2 .or. ityp.eq.5 .or. ityp.eq.8) go to 11 
      do 10 k=1,nt
      do 10 mp1=1,mmax
      do 10 np1=mp1,nlat
      br(mp1,np1,k)=0.
      bi(mp1,np1,k)=0.
   10 continue
   11 if(ityp.eq.1 .or. ityp.eq.4 .or. ityp.eq.7) go to 13 
      do 12 k=1,nt
      do 12 mp1=1,mmax
      do 12 np1=mp1,nlat
      cr(mp1,np1,k)=0.
      ci(mp1,np1,k)=0.
   12 continue
   13 itypp = ityp+1
      go to (1,100,200,300,400,500,600,700,800),itypp
c
c     case ityp=0 ,  no symmetries
c
    1 call vbin(0,nlat,nlon,0,vb,iv,wvbin)
c
c     case m=0
c
      do 15 k=1,nt
      do 1015 i=1,imid
      tv = ve(i,1,k)*wts(i)
      tw = we(i,1,k)*wts(i)
      do 10015 np1=2,ndo2,2
      br(1,np1,k) = br(1,np1,k)+vb(i,np1,iv)*tv
      cr(1,np1,k) = cr(1,np1,k)-vb(i,np1,iv)*tw
10015 continue
 1015 continue
   15 continue
      do 16 k=1,nt
      do 1016 i=1,imm1
      tv = vo(i,1,k)*wts(i)
      tw = wo(i,1,k)*wts(i)
      do 10016 np1=3,ndo1,2
      br(1,np1,k) = br(1,np1,k)+vb(i,np1,iv)*tv
      cr(1,np1,k) = cr(1,np1,k)-vb(i,np1,iv)*tw
10016 continue
 1016 continue
   16 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) return
      do 20 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(0,nlat,nlon,m,vb,iv,wvbin)
      call wbin(0,nlat,nlon,m,wb,iw,wwbin)
      if(mp1 .gt. ndo1) go to 17
      do 23 k=1,nt
      do 1023 i=1,imm1
c
c     set temps to optimize quadrature
c
      tvo1 = vo(i,2*mp1-1,k)*wts(i)
      tvo2 = vo(i,2*mp1-2,k)*wts(i)
      tve1 = ve(i,2*mp1-1,k)*wts(i)
      tve2 = ve(i,2*mp1-2,k)*wts(i)
      two1 = wo(i,2*mp1-1,k)*wts(i)
      two2 = wo(i,2*mp1-2,k)*wts(i)
      twe1 = we(i,2*mp1-1,k)*wts(i)
      twe2 = we(i,2*mp1-2,k)*wts(i)
      do 10023 np1=mp1,ndo1,2
      br(mp1,np1,k) = br(mp1,np1,k)+vb(i,np1,iv)*tvo2
     +                             +wb(i,np1,iw)*twe1
      bi(mp1,np1,k) = bi(mp1,np1,k)+vb(i,np1,iv)*tvo1
     +                             -wb(i,np1,iw)*twe2
      cr(mp1,np1,k) = cr(mp1,np1,k)-vb(i,np1,iv)*two2
     +                             +wb(i,np1,iw)*tve1
      ci(mp1,np1,k) = ci(mp1,np1,k)-vb(i,np1,iv)*two1
     +                             -wb(i,np1,iw)*tve2
10023 continue
 1023 continue
   23 continue

      if(mlat .eq. 0) go to 17
      i = imid
      do 24 k=1,nt
      do 1024 np1=mp1,ndo1,2
      br(mp1,np1,k)=br(mp1,np1,k)+wb(i,np1,iw)*we(i,2*mp1-1,k)*wts(i)
      bi(mp1,np1,k)=bi(mp1,np1,k)-wb(i,np1,iw)*we(i,2*mp1-2,k)*wts(i)
      cr(mp1,np1,k)=cr(mp1,np1,k)+wb(i,np1,iw)*ve(i,2*mp1-1,k)*wts(i)
      ci(mp1,np1,k)=ci(mp1,np1,k)-wb(i,np1,iw)*ve(i,2*mp1-2,k)*wts(i)
 1024 continue
   24 continue
   17 if(mp2 .gt. ndo2) go to 20
      do 21 k=1,nt
      do 1021 i=1,imm1
      tvo1 = vo(i,2*mp1-1,k)*wts(i)
      tvo2 = vo(i,2*mp1-2,k)*wts(i)
      tve1 = ve(i,2*mp1-1,k)*wts(i)
      tve2 = ve(i,2*mp1-2,k)*wts(i)
      two1 = wo(i,2*mp1-1,k)*wts(i)
      two2 = wo(i,2*mp1-2,k)*wts(i)
      twe1 = we(i,2*mp1-1,k)*wts(i)
      twe2 = we(i,2*mp1-2,k)*wts(i)
      do 10021 np1=mp2,ndo2,2
      br(mp1,np1,k) = br(mp1,np1,k)+vb(i,np1,iv)*tve2
     1                             +wb(i,np1,iw)*two1
      bi(mp1,np1,k) = bi(mp1,np1,k)+vb(i,np1,iv)*tve1
     1                             -wb(i,np1,iw)*two2
      cr(mp1,np1,k) = cr(mp1,np1,k)-vb(i,np1,iv)*twe2
     1                             +wb(i,np1,iw)*tvo1
      ci(mp1,np1,k) = ci(mp1,np1,k)-vb(i,np1,iv)*twe1
     1                             -wb(i,np1,iw)*tvo2
10021 continue
 1021 continue
   21 continue

      if(mlat .eq. 0) go to 20
      i = imid
      do 22 k=1,nt
      do 1022 np1=mp2,ndo2,2
      br(mp1,np1,k)=br(mp1,np1,k)+vb(i,np1,iv)*ve(i,2*mp1-2,k)*wts(i)
      bi(mp1,np1,k)=bi(mp1,np1,k)+vb(i,np1,iv)*ve(i,2*mp1-1,k)*wts(i)
      cr(mp1,np1,k)=cr(mp1,np1,k)-vb(i,np1,iv)*we(i,2*mp1-2,k)*wts(i)
      ci(mp1,np1,k)=ci(mp1,np1,k)-vb(i,np1,iv)*we(i,2*mp1-1,k)*wts(i)
 1022 continue
   22 continue
   20 continue
      return
c
c     case ityp=1 ,  no symmetries but cr and ci equal zero
c
  100 call vbin(0,nlat,nlon,0,vb,iv,wvbin)
c
c     case m=0
c
      do 115 k=1,nt
      do 115 i=1,imid
      tv = ve(i,1,k)*wts(i)
      do 115 np1=2,ndo2,2
      br(1,np1,k) = br(1,np1,k)+vb(i,np1,iv)*tv
  115 continue
      do 116 k=1,nt
      do 116 i=1,imm1
      tv = vo(i,1,k)*wts(i)
      do 116 np1=3,ndo1,2
      br(1,np1,k) = br(1,np1,k)+vb(i,np1,iv)*tv
  116 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) return
      do 120 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(0,nlat,nlon,m,vb,iv,wvbin)
      call wbin(0,nlat,nlon,m,wb,iw,wwbin)
      if(mp1 .gt. ndo1) go to 117
      do 123 k=1,nt
      do 123 i=1,imm1
      tvo1 = vo(i,2*mp1-1,k)*wts(i)
      tvo2 = vo(i,2*mp1-2,k)*wts(i)
      twe1 = we(i,2*mp1-1,k)*wts(i)
      twe2 = we(i,2*mp1-2,k)*wts(i)
      do 123 np1=mp1,ndo1,2
      br(mp1,np1,k) = br(mp1,np1,k)+vb(i,np1,iv)*tvo2
     +                             +wb(i,np1,iw)*twe1
      bi(mp1,np1,k) = bi(mp1,np1,k)+vb(i,np1,iv)*tvo1
     +                             -wb(i,np1,iw)*twe2
  123 continue
      if(mlat .eq. 0) go to 117
      i = imid
      do 124 k=1,nt
      do 124 np1=mp1,ndo1,2
      br(mp1,np1,k) = br(mp1,np1,k)+wb(i,np1,iw)*we(i,2*mp1-1,k)*wts(i)
      bi(mp1,np1,k) = bi(mp1,np1,k)-wb(i,np1,iw)*we(i,2*mp1-2,k)*wts(i)
  124 continue
  117 if(mp2 .gt. ndo2) go to 120
      do 121 k=1,nt
      do 121 i=1,imm1
      tve1 = ve(i,2*mp1-1,k)*wts(i)
      tve2 = ve(i,2*mp1-2,k)*wts(i)
      two1 = wo(i,2*mp1-1,k)*wts(i)
      two2 = wo(i,2*mp1-2,k)*wts(i)
      do 121 np1=mp2,ndo2,2
      br(mp1,np1,k) = br(mp1,np1,k)+vb(i,np1,iv)*tve2
     +                             +wb(i,np1,iw)*two1
      bi(mp1,np1,k) = bi(mp1,np1,k)+vb(i,np1,iv)*tve1
     +                             -wb(i,np1,iw)*two2
  121 continue
      if(mlat .eq. 0) go to 120
      i = imid
      do 122 k=1,nt
      do 122 np1=mp2,ndo2,2
      br(mp1,np1,k) = br(mp1,np1,k)+vb(i,np1,iv)*ve(i,2*mp1-2,k)*wts(i)
      bi(mp1,np1,k) = bi(mp1,np1,k)+vb(i,np1,iv)*ve(i,2*mp1-1,k)*wts(i)
  122 continue
  120 continue
      return
c
c     case ityp=2 ,  no symmetries but br and bi equal zero   
c
  200 call vbin(0,nlat,nlon,0,vb,iv,wvbin)
c
c     case m=0
c
      do 215 k=1,nt
      do 215 i=1,imid
      tw = we(i,1,k)*wts(i)
      do 215 np1=2,ndo2,2
      cr(1,np1,k) = cr(1,np1,k)-vb(i,np1,iv)*tw
  215 continue
      do 216 k=1,nt
      do 216 i=1,imm1
      tw = wo(i,1,k)*wts(i)
      do 216 np1=3,ndo1,2
      cr(1,np1,k) = cr(1,np1,k)-vb(i,np1,iv)*tw
  216 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) return
      do 220 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(0,nlat,nlon,m,vb,iv,wvbin)
      call wbin(0,nlat,nlon,m,wb,iw,wwbin)
      if(mp1 .gt. ndo1) go to 217
      do 223 k=1,nt
      do 223 i=1,imm1
      tve1 = ve(i,2*mp1-1,k)*wts(i)
      tve2 = ve(i,2*mp1-2,k)*wts(i)
      two1 = wo(i,2*mp1-1,k)*wts(i)
      two2 = wo(i,2*mp1-2,k)*wts(i)
      do 223 np1=mp1,ndo1,2
      cr(mp1,np1,k) = cr(mp1,np1,k)-vb(i,np1,iv)*two2
     +                             +wb(i,np1,iw)*tve1
      ci(mp1,np1,k) = ci(mp1,np1,k)-vb(i,np1,iv)*two1
     +                             -wb(i,np1,iw)*tve2
  223 continue
      if(mlat .eq. 0) go to 217
      i = imid
      do 224 k=1,nt
      do 224 np1=mp1,ndo1,2
      cr(mp1,np1,k) = cr(mp1,np1,k)+wb(i,np1,iw)*ve(i,2*mp1-1,k)*wts(i)
      ci(mp1,np1,k) = ci(mp1,np1,k)-wb(i,np1,iw)*ve(i,2*mp1-2,k)*wts(i)
  224 continue
  217 if(mp2 .gt. ndo2) go to 220
      do 221 k=1,nt
      do 221 i=1,imm1
      twe1 = we(i,2*mp1-1,k)*wts(i)
      twe2 = we(i,2*mp1-2,k)*wts(i)
      tvo1 = vo(i,2*mp1-1,k)*wts(i)
      tvo2 = vo(i,2*mp1-2,k)*wts(i)
      do 221 np1=mp2,ndo2,2
      cr(mp1,np1,k) = cr(mp1,np1,k)-vb(i,np1,iv)*twe2
     +                             +wb(i,np1,iw)*tvo1
      ci(mp1,np1,k) = ci(mp1,np1,k)-vb(i,np1,iv)*twe1
     +                             -wb(i,np1,iw)*tvo2
  221 continue
      if(mlat .eq. 0) go to 220
      i = imid
      do 222 k=1,nt
      do 222 np1=mp2,ndo2,2
      cr(mp1,np1,k) = cr(mp1,np1,k)-vb(i,np1,iv)*we(i,2*mp1-2,k)*wts(i)
      ci(mp1,np1,k) = ci(mp1,np1,k)-vb(i,np1,iv)*we(i,2*mp1-1,k)*wts(i)
  222 continue
  220 continue
      return
c
c     case ityp=3 ,  v even , w odd
c
  300 call vbin(0,nlat,nlon,0,vb,iv,wvbin)
c
c     case m=0
c
      do 315 k=1,nt
      do 315 i=1,imid
      tv = ve(i,1,k)*wts(i)
      do 315 np1=2,ndo2,2
      br(1,np1,k) = br(1,np1,k)+vb(i,np1,iv)*tv
  315 continue
      do 316 k=1,nt
      do 316 i=1,imm1
      tw = wo(i,1,k)*wts(i)
      do 316 np1=3,ndo1,2
      cr(1,np1,k) = cr(1,np1,k)-vb(i,np1,iv)*tw
  316 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) return
      do 320 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(0,nlat,nlon,m,vb,iv,wvbin)
      call wbin(0,nlat,nlon,m,wb,iw,wwbin)
      if(mp1 .gt. ndo1) go to 317
      do 323 k=1,nt
      do 323 i=1,imm1
      two1 = wo(i,2*mp1-1,k)*wts(i)
      two2 = wo(i,2*mp1-2,k)*wts(i)
      tve1 = ve(i,2*mp1-1,k)*wts(i)
      tve2 = ve(i,2*mp1-2,k)*wts(i)
      do 323 np1=mp1,ndo1,2
      cr(mp1,np1,k) = cr(mp1,np1,k)-vb(i,np1,iv)*two2
     +                             +wb(i,np1,iw)*tve1
      ci(mp1,np1,k) = ci(mp1,np1,k)-vb(i,np1,iv)*two1
     +                             -wb(i,np1,iw)*tve2
  323 continue
      if(mlat .eq. 0) go to 317
      i = imid
      do 324 k=1,nt
      do 324 np1=mp1,ndo1,2
      cr(mp1,np1,k) = cr(mp1,np1,k)+wb(i,np1,iw)*ve(i,2*mp1-1,k)*wts(i)
      ci(mp1,np1,k) = ci(mp1,np1,k)-wb(i,np1,iw)*ve(i,2*mp1-2,k)*wts(i)
  324 continue
  317 if(mp2 .gt. ndo2) go to 320
      do 321 k=1,nt
      do 321 i=1,imm1
      two1 = wo(i,2*mp1-1,k)*wts(i)
      two2 = wo(i,2*mp1-2,k)*wts(i)
      tve1 = ve(i,2*mp1-1,k)*wts(i)
      tve2 = ve(i,2*mp1-2,k)*wts(i)
      do 321 np1=mp2,ndo2,2
      br(mp1,np1,k) = br(mp1,np1,k)+vb(i,np1,iv)*tve2
     +                             +wb(i,np1,iw)*two1
      bi(mp1,np1,k) = bi(mp1,np1,k)+vb(i,np1,iv)*tve1
     +                             -wb(i,np1,iw)*two2
  321 continue
      if(mlat .eq. 0) go to 320
      i = imid
      do 322 k=1,nt
      do 322 np1=mp2,ndo2,2
      br(mp1,np1,k) = br(mp1,np1,k)+vb(i,np1,iv)*ve(i,2*mp1-2,k)*wts(i)
      bi(mp1,np1,k) = bi(mp1,np1,k)+vb(i,np1,iv)*ve(i,2*mp1-1,k)*wts(i)
  322 continue
  320 continue
      return
c
c     case ityp=4 ,  v even, w odd, and cr and ci equal 0. 
c
  400 call vbin(1,nlat,nlon,0,vb,iv,wvbin)
c
c     case m=0
c
      do 415 k=1,nt
      do 415 i=1,imid
      tv = ve(i,1,k)*wts(i)
      do 415 np1=2,ndo2,2
      br(1,np1,k) = br(1,np1,k)+vb(i,np1,iv)*tv
  415 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) return
      do 420 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(1,nlat,nlon,m,vb,iv,wvbin)
      call wbin(1,nlat,nlon,m,wb,iw,wwbin)
      if(mp2 .gt. ndo2) go to 420
      do 421 k=1,nt
      do 421 i=1,imm1
      two1 = wo(i,2*mp1-1,k)*wts(i)
      two2 = wo(i,2*mp1-2,k)*wts(i)
      tve1 = ve(i,2*mp1-1,k)*wts(i)
      tve2 = ve(i,2*mp1-2,k)*wts(i)
      do 421 np1=mp2,ndo2,2
      br(mp1,np1,k) = br(mp1,np1,k)+vb(i,np1,iv)*tve2
     +                             +wb(i,np1,iw)*two1
      bi(mp1,np1,k) = bi(mp1,np1,k)+vb(i,np1,iv)*tve1
     +                             -wb(i,np1,iw)*two2
  421 continue
      if(mlat .eq. 0) go to 420
      i = imid
      do 422 k=1,nt
      do 422 np1=mp2,ndo2,2
      br(mp1,np1,k) = br(mp1,np1,k)+vb(i,np1,iv)*ve(i,2*mp1-2,k)*wts(i)
      bi(mp1,np1,k) = bi(mp1,np1,k)+vb(i,np1,iv)*ve(i,2*mp1-1,k)*wts(i)
  422 continue
  420 continue
      return
c
c     case ityp=5   v even, w odd, and br and bi equal zero
c
  500 call vbin(2,nlat,nlon,0,vb,iv,wvbin)
c
c     case m=0
c
      do 516 k=1,nt
      do 516 i=1,imm1
      tw = wo(i,1,k)*wts(i)
      do 516 np1=3,ndo1,2
      cr(1,np1,k) = cr(1,np1,k)-vb(i,np1,iv)*tw
  516 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) return
      do 520 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(2,nlat,nlon,m,vb,iv,wvbin)
      call wbin(2,nlat,nlon,m,wb,iw,wwbin)
      if(mp1 .gt. ndo1) go to 520
      do 523 k=1,nt
      do 523 i=1,imm1
      two1 = wo(i,2*mp1-1,k)*wts(i)
      two2 = wo(i,2*mp1-2,k)*wts(i)
      tve1 = ve(i,2*mp1-1,k)*wts(i)
      tve2 = ve(i,2*mp1-2,k)*wts(i)
      do 523 np1=mp1,ndo1,2
      cr(mp1,np1,k) = cr(mp1,np1,k)-vb(i,np1,iv)*two2
     +                             +wb(i,np1,iw)*tve1
      ci(mp1,np1,k) = ci(mp1,np1,k)-vb(i,np1,iv)*two1
     +                             -wb(i,np1,iw)*tve2
  523 continue
      if(mlat .eq. 0) go to 520
      i = imid
      do 524 k=1,nt
      do 524 np1=mp1,ndo1,2
      cr(mp1,np1,k) = cr(mp1,np1,k)+wb(i,np1,iw)*ve(i,2*mp1-1,k)*wts(i)
      ci(mp1,np1,k) = ci(mp1,np1,k)-wb(i,np1,iw)*ve(i,2*mp1-2,k)*wts(i)
  524 continue
  520 continue
      return
c
c     case ityp=6 ,  v odd , w even
c
  600 call vbin(0,nlat,nlon,0,vb,iv,wvbin)
c
c     case m=0
c
      do 615 k=1,nt
      do 615 i=1,imid
      tw = we(i,1,k)*wts(i)
      do 615 np1=2,ndo2,2
      cr(1,np1,k) = cr(1,np1,k)-vb(i,np1,iv)*tw
  615 continue
      do 616 k=1,nt
      do 616 i=1,imm1
      tv = vo(i,1,k)*wts(i)
      do 616 np1=3,ndo1,2
      br(1,np1,k) = br(1,np1,k)+vb(i,np1,iv)*tv
  616 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) return
      do 620 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(0,nlat,nlon,m,vb,iv,wvbin)
      call wbin(0,nlat,nlon,m,wb,iw,wwbin)
      if(mp1 .gt. ndo1) go to 617
      do 623 k=1,nt
      do 623 i=1,imm1
      twe1 = we(i,2*mp1-1,k)*wts(i)
      twe2 = we(i,2*mp1-2,k)*wts(i)
      tvo1 = vo(i,2*mp1-1,k)*wts(i)
      tvo2 = vo(i,2*mp1-2,k)*wts(i)
      do 623 np1=mp1,ndo1,2
      br(mp1,np1,k) = br(mp1,np1,k)+vb(i,np1,iv)*tvo2
     +                             +wb(i,np1,iw)*twe1
      bi(mp1,np1,k) = bi(mp1,np1,k)+vb(i,np1,iv)*tvo1
     +                             -wb(i,np1,iw)*twe2
  623 continue
      if(mlat .eq. 0) go to 617
      i = imid
      do 624 k=1,nt
      do 624 np1=mp1,ndo1,2
      br(mp1,np1,k) = br(mp1,np1,k)+wb(i,np1,iw)*we(i,2*mp1-1,k)*wts(i)
      bi(mp1,np1,k) = bi(mp1,np1,k)-wb(i,np1,iw)*we(i,2*mp1-2,k)*wts(i)
  624 continue
  617 if(mp2 .gt. ndo2) go to 620
      do 621 k=1,nt
      do 621 i=1,imm1
      twe1 = we(i,2*mp1-1,k)*wts(i)
      twe2 = we(i,2*mp1-2,k)*wts(i)
      tvo1 = vo(i,2*mp1-1,k)*wts(i)
      tvo2 = vo(i,2*mp1-2,k)*wts(i)
      do 621 np1=mp2,ndo2,2
      cr(mp1,np1,k) = cr(mp1,np1,k)-vb(i,np1,iv)*twe2
     +                             +wb(i,np1,iw)*tvo1
      ci(mp1,np1,k) = ci(mp1,np1,k)-vb(i,np1,iv)*twe1
     +                             -wb(i,np1,iw)*tvo2
  621 continue
      if(mlat .eq. 0) go to 620
      i = imid
      do 622 k=1,nt
      do 622 np1=mp2,ndo2,2
      cr(mp1,np1,k) = cr(mp1,np1,k)-vb(i,np1,iv)*we(i,2*mp1-2,k)*wts(i)
      ci(mp1,np1,k) = ci(mp1,np1,k)-vb(i,np1,iv)*we(i,2*mp1-1,k)*wts(i)
  622 continue
  620 continue
      return
c
c     case ityp=7   v odd, w even, and cr and ci equal zero
c
  700 call vbin(2,nlat,nlon,0,vb,iv,wvbin)
c
c     case m=0
c
      do 716 k=1,nt
      do 716 i=1,imm1
      tv = vo(i,1,k)*wts(i)
      do 716 np1=3,ndo1,2
      br(1,np1,k) = br(1,np1,k)+vb(i,np1,iv)*tv
  716 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) return
      do 720 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(2,nlat,nlon,m,vb,iv,wvbin)
      call wbin(2,nlat,nlon,m,wb,iw,wwbin)
      if(mp1 .gt. ndo1) go to 720
      do 723 k=1,nt
      do 723 i=1,imm1
      twe1 = we(i,2*mp1-1,k)*wts(i)
      twe2 = we(i,2*mp1-2,k)*wts(i)
      tvo1 = vo(i,2*mp1-1,k)*wts(i)
      tvo2 = vo(i,2*mp1-2,k)*wts(i)
      do 723 np1=mp1,ndo1,2
      br(mp1,np1,k) = br(mp1,np1,k)+vb(i,np1,iv)*tvo2
     +                             +wb(i,np1,iw)*twe1
      bi(mp1,np1,k) = bi(mp1,np1,k)+vb(i,np1,iv)*tvo1
     +                             -wb(i,np1,iw)*twe2
  723 continue
      if(mlat .eq. 0) go to 720
      i = imid
      do 724 k=1,nt
      do 724 np1=mp1,ndo1,2
      br(mp1,np1,k) = br(mp1,np1,k)+wb(i,np1,iw)*we(i,2*mp1-1,k)*wts(i)
      bi(mp1,np1,k) = bi(mp1,np1,k)-wb(i,np1,iw)*we(i,2*mp1-2,k)*wts(i)
  724 continue
  720 continue
      return
c
c     case ityp=8   v odd, w even, and both br and bi equal zero
c
  800 call vbin(1,nlat,nlon,0,vb,iv,wvbin)
c
c     case m=0
c
      do 815 k=1,nt
      do 815 i=1,imid
      tw = we(i,1,k)*wts(i)
      do 815 np1=2,ndo2,2
      cr(1,np1,k) = cr(1,np1,k)-vb(i,np1,iv)*tw
  815 continue
c
c     case m = 1 through nlat-1
c
      if(mmax .lt. 2) return
      do 820 mp1=2,mmax
      m = mp1-1
      mp2 = mp1+1
      call vbin(1,nlat,nlon,m,vb,iv,wvbin)
      call wbin(1,nlat,nlon,m,wb,iw,wwbin)
      if(mp2 .gt. ndo2) go to 820
      do 821 k=1,nt
      do 821 i=1,imm1
      twe1 = we(i,2*mp1-1,k)*wts(i)
      twe2 = we(i,2*mp1-2,k)*wts(i)
      tvo1 = vo(i,2*mp1-1,k)*wts(i)
      tvo2 = vo(i,2*mp1-2,k)*wts(i)
      do 821 np1=mp2,ndo2,2
      cr(mp1,np1,k) = cr(mp1,np1,k)-vb(i,np1,iv)*twe2
     +                             +wb(i,np1,iw)*tvo1
      ci(mp1,np1,k) = ci(mp1,np1,k)-vb(i,np1,iv)*twe1
     +                             -wb(i,np1,iw)*tvo2
  821 continue
      if(mlat .eq. 0) go to 820
      i = imid
      do 822 k=1,nt
      do 822 np1=mp2,ndo2,2
      cr(mp1,np1,k) = cr(mp1,np1,k)-vb(i,np1,iv)*we(i,2*mp1-2,k)*wts(i)
      ci(mp1,np1,k) = ci(mp1,np1,k)-vb(i,np1,iv)*we(i,2*mp1-1,k)*wts(i)
  822 continue
  820 continue
      return
      end
      subroutine vhagci(nlat,nlon,wvhagc,lvhagc,dwork,ldwork,ierror)
      dimension wvhagc(1)
      double precision dwork(*)
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if(nlon .lt. 1) return
      ierror = 3
      imid = (nlat+1)/2
      lzz1 = 2*nlat*imid
      mmax = min0(nlat,(nlon+1)/2)
      labc = 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
      imid = (nlat+1)/2
      if(lvhagc .lt. 2*(lzz1+labc)+nlon+imid+15) return
      ierror = 4
      if (ldwork .lt. 2*nlat*(nlat+1)+1) return
      ierror = 0
c
c     compute gaussian points in first nlat+1 words of dwork
c     double precision
c
      lwk = nlat*(nlat+2)

      jw1 = 1
c     jw2 = jw1+nlat+nlat
c     jw3 = jw2+nlat+nlat
      jw2 = jw1+nlat
      jw3 = jw2+nlat
      call gaqd(nlat,dwork(jw1),dwork(jw2),dwork(jw3),lwk,ierror)
      imid = (nlat+1)/2
c
c     set first imid words of double precision weights in dwork
c     as single precision in first imid words of wvhagc
c
      call setwts(imid,dwork(nlat+1),wvhagc)
c
c     first nlat+1 words of dwork contain  double theta
c
c     iwrk = nlat+2
      iwrk = (nlat+1)/2 +1
      iw1 = imid+1
      call vbgint (nlat,nlon,dwork,wvhagc(iw1),dwork(iwrk))
      lwvbin = lzz1+labc
      iw2 = iw1+lwvbin
      call wbgint (nlat,nlon,dwork,wvhagc(iw2),dwork(iwrk))
      iw3 = iw2+lwvbin
      call hrffti(nlon,wvhagc(iw3))
      return
      end
      subroutine setwts(imid,dwts,wts)
c
c     set first imid =(nlat+1)/2 of double precision weights in dwts
c     as single precision in wts
c
      dimension dwts(imid),wts(imid)
      double precision dwts
      do 1 i=1,imid
      wts(i) = dwts(i)
    1 continue
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file vhags.f
!
!     this file contains code and documentation for subroutines
!     vhags and vhagsi
!
! ... files which must be loaded with vhags.f
!
!     sphcom.f, hrfft.f, gaqd.f
!
!     subroutine vhags(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
!    +                 mdab,ndab,wvhags,lvhags,work,lwork,ierror)
!
!     subroutine vhags performs the vector spherical harmonic analysis
!     on the vector field (v,w) and stores the result in the arrays
!     br, bi, cr, and ci. v(i,j) and w(i,j) are the colatitudinal
!     (measured from the north pole) and east longitudinal components
!     respectively, located at the gaussian colatitude point theta(i)
!     and longitude phi(j) = (j-1)*2*pi/nlon. the spectral
!     representation of (v,w) is given at output parameters v,w in
!     subroutine vhses.
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are computed
!            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid point
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than zero. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!     ityp   = 0  no symmetries exist about the equator. the analysis
!                 is performed on the entire sphere.  i.e. on the
!                 arrays v(i,j),w(i,j) for i=1,...,nlat and
!                 j=1,...,nlon.
!
!            = 1  no symmetries exist about the equator. the analysis
!                 is performed on the entire sphere.  i.e. on the
!                 arrays v(i,j),w(i,j) for i=1,...,nlat and
!                 j=1,...,nlon. the curl of (v,w) is zero. that is,
!                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
!                 the coefficients cr and ci are zero.
!
!            = 2  no symmetries exist about the equator. the analysis
!                 is performed on the entire sphere.  i.e. on the
!                 arrays v(i,j),w(i,j) for i=1,...,nlat and
!                 j=1,...,nlon. the divergence of (v,w) is zero. i.e.,
!                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
!                 the coefficients br and bi are zero.
!
!            = 3  v is symmetric and w is antisymmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!            = 4  v is symmetric and w is antisymmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the curl of (v,w) is zero. that is,
!                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
!                 the coefficients cr and ci are zero.
!
!            = 5  v is symmetric and w is antisymmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the divergence of (v,w) is zero. i.e.,
!                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
!                 the coefficients br and bi are zero.
!
!            = 6  v is antisymmetric and w is symmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!            = 7  v is antisymmetric and w is symmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the curl of (v,w) is zero. that is,
!                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
!                 the coefficients cr and ci are zero.
!
!            = 8  v is antisymmetric and w is symmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the divergence of (v,w) is zero. i.e.,
!                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
!                 the coefficients br and bi are zero.
!
!
!     nt     the number of analyses.  in the program that calls vhags,
!            the arrays v,w,br,bi,cr, and ci can be three dimensional
!            in which case multiple analyses will be performed.
!            the third index is the analysis index which assumes the
!            values k=1,...,nt.  for a single analysis set nt=1. the
!            discription of the remaining parameters is simplified
!            by assuming that nt=1 or that all the arrays are two
!            dimensional.
!
!     v,w    two or three dimensional arrays (see input parameter nt)
!            that contain the vector function to be analyzed.
!            v is the colatitudnal component and w is the east
!            longitudinal component. v(i,j),w(i,j) contain the
!            components at the gaussian colatitude point theta(i)
!            and longitude phi(j) = (j-1)*2*pi/nlon. the index ranges
!            are defined above at the input parameter ityp.
!
!     idvw   the first dimension of the arrays v,w as it appears in
!            the program that calls vhags. if ityp .le. 2 then idvw
!            must be at least nlat.  if ityp .gt. 2 and nlat is
!            even then idvw must be at least nlat/2. if ityp .gt. 2
!            and nlat is odd then idvw must be at least (nlat+1)/2.
!
!     jdvw   the second dimension of the arrays v,w as it appears in
!            the program that calls vhags. jdvw must be at least nlon.
!
!     mdab   the first dimension of the arrays br,bi,cr, and ci as it
!            appears in the program that calls vhags. mdab must be at
!            least min0(nlat,nlon/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndab   the second dimension of the arrays br,bi,cr, and ci as it
!            appears in the program that calls vhags. ndab must be at
!            least nlat.
!
!     wvhags an array which must be initialized by subroutine vhgsi.
!            once initialized, wvhags can be used repeatedly by vhags
!            as long as nlon and nlat remain unchanged.  wvhags must
!            not be altered between calls of vhags.
!
!     lvhags the dimension of the array wvhags as it appears in the
!            program that calls vhags. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lvhags must be at least
!
!            (nlat+1)*(nlat+1)*nlat/2 + nlon + 15
!
!
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls vhags. define
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            if ityp .le. 2 then lwork must be at least
!            the larger of the two quantities
!
!               3*nlat*(nlat+1)+2  (required by vhagsi)
!
!            and
!
!               (2*nt+1)*nlat*nlon
!
!            if ityp .gt. 2 then lwork must be at least
!            the larger of the two quantities
!
!               3*nlat*(nlat+1)+2  (required by vhagsi)
!
!            and
!
!              (2*nt+1)*l2*nlon
!
!
!     **************************************************************
!
!     output parameters
!
!     br,bi  two or three dimensional arrays (see input parameter nt)
!     cr,ci  that contain the vector spherical harmonic coefficients
!            in the spectral representation of v(i,j) and w(i,j) given
!            in the discription of subroutine vhses. br(mp1,np1),
!            bi(mp1,np1),cr(mp1,np1), and ci(mp1,np1) are computed
!            for mp1=1,...,mmax and np1=mp1,...,nlat except for np1=nlat
!            and odd mp1. mmax=min0(nlat,nlon/2) if nlon is even or
!            mmax=min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of ityp
!            = 4  error in the specification of nt
!            = 5  error in the specification of idvw
!            = 6  error in the specification of jdvw
!            = 7  error in the specification of mdab
!            = 8  error in the specification of ndab
!            = 9  error in the specification of lvhags
!            = 10 error in the specification of lwork
!
!
!     subroutine vhagsi(nlat,nlon,wvhags,lvhags,work,lwork,ierror)
!
!     subroutine vhagsi initializes the array wvhags which can then be
!     used repeatedly by subroutine vhags until nlat or nlon is changed.
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are computed
!            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid point
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than zero. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!     lvhags the dimension of the array wvhags as it appears in the
!            program that calls vhagsi.  define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lvhags must be at least
!
!               3*nlat*(nlat+1)+2  (required by vhagsi)
!
!     dwork  a double precision work space that does not need to be saved
!
!     ldwork the dimension of the array dwork as it appears in the
!            program that calls vhagsi. ldwork must be at least
!
!                   (3*nlat*(nlat+3)+2)/2
!
!     **************************************************************
!
!     output parameters
!
!     wvhags an array which is initialized for use by subroutine vhags.
!            once initialized, wvhags can be used repeatedly by vhags
!            as long as nlat and nlon remain unchanged.  wvhags must not
!            be altered between calls of vhags.
!
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of lvhags
!            = 4  error in the specification of ldwork
!
      SUBROUTINE VHAGS(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,Mdab,&
                     & Ndab,Wvhags,Lvhags,Work,Lwork,Ierror)
      IMPLICIT NONE
      REAL Bi , Br , Ci , Cr , V , W , Work , Wvhags
      INTEGER idv , Idvw , idz , Ierror , imid , ist , Ityp , iw1 ,     &
            & iw2 , iw3 , iw4 , Jdvw , jw1 , jw2 , jw3 , lmn , lnl ,    &
            & Lvhags , Lwork , lzimn
      INTEGER Mdab , mmax , Ndab , Nlat , Nlon , Nt
      DIMENSION V(Idvw,Jdvw,1) , W(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,     &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Work(1) , Wvhags(1)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      IF ( Ityp<0 .OR. Ityp>8 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Ityp<=2 .AND. Idvw<Nlat) .OR. (Ityp>2 .AND. Idvw<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      idz = (mmax*(Nlat+Nlat-mmax+1))/2
      lzimn = idz*imid
      IF ( Lvhags<lzimn+lzimn+Nlon+15 ) RETURN
      Ierror = 10
      idv = Nlat
      IF ( Ityp>2 ) idv = imid
      lnl = Nt*idv*Nlon
      IF ( Lwork<lnl+lnl+idv*Nlon ) RETURN
      Ierror = 0
      ist = 0
      IF ( Ityp<=2 ) ist = imid
!
!     set wvhags pointers
!
      lmn = Nlat*(Nlat+1)/2
      jw1 = 1
      jw2 = jw1 + imid*lmn
      jw3 = jw2 + imid*lmn
!
!     set work pointers
!
      iw1 = ist + 1
      iw2 = lnl + 1
      iw3 = iw2 + ist
      iw4 = iw2 + lnl
      CALL VHAGS1(Nlat,Nlon,Ityp,Nt,imid,Idvw,Jdvw,V,W,Mdab,Ndab,Br,Bi, &
                & Cr,Ci,idv,Work,Work(iw1),Work(iw2),Work(iw3),Work(iw4)&
                & ,idz,Wvhags(jw1),Wvhags(jw2),Wvhags(jw3))
    END SUBROUTINE VHAGS

      
    SUBROUTINE VHAGS1(Nlat,Nlon,Ityp,Nt,Imid,Idvw,Jdvw,V,W,Mdab,Ndab, &
                      & Br,Bi,Cr,Ci,Idv,Ve,Vo,We,Wo,Work,Idz,Vb,Wb,     &
                      & Wrfft)
      IMPLICIT NONE
      REAL Bi , Br , Ci , Cr , fsn , tsn , V , Vb , Ve , Vo , W , Wb ,  &
         & We , Wo , Work , Wrfft
      INTEGER i , Idv , Idvw , Idz , Imid , imm1 , Ityp , itypp , j ,   &
            & Jdvw , k , m , mb , Mdab , mlat , mlon , mmax , mp1 ,     &
            & mp2 , Ndab
      INTEGER ndo1 , ndo2 , Nlat , Nlon , nlp1 , np1 , Nt
      DIMENSION V(Idvw,Jdvw,1) , W(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,     &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Ve(Idv,Nlon,1) , Vo(Idv,Nlon,1) , We(Idv,Nlon,1) ,      &
              & Wo(Idv,Nlon,1) , Work(1) , Vb(Imid,1) , Wb(Imid,1) ,    &
              & Wrfft(1)
      nlp1 = Nlat + 1
      tsn = 2./Nlon
      fsn = 4./Nlon
      mlat = MOD(Nlat,2)
      mlon = MOD(Nlon,2)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      imm1 = Imid
      IF ( mlat/=0 ) imm1 = Imid - 1
      IF ( Ityp>2 ) THEN
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO j = 1 , Nlon
                  Ve(i,j,k) = fsn*V(i,j,k)
                  Vo(i,j,k) = fsn*V(i,j,k)
                  We(i,j,k) = fsn*W(i,j,k)
                  Wo(i,j,k) = fsn*W(i,j,k)
               ENDDO
            ENDDO
         ENDDO
      ELSE
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO j = 1 , Nlon
                  Ve(i,j,k) = tsn*(V(i,j,k)+V(nlp1-i,j,k))
                  Vo(i,j,k) = tsn*(V(i,j,k)-V(nlp1-i,j,k))
                  We(i,j,k) = tsn*(W(i,j,k)+W(nlp1-i,j,k))
                  Wo(i,j,k) = tsn*(W(i,j,k)-W(nlp1-i,j,k))
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      IF ( mlat/=0 ) THEN
         DO k = 1 , Nt
            DO j = 1 , Nlon
               Ve(Imid,j,k) = tsn*V(Imid,j,k)
               We(Imid,j,k) = tsn*W(Imid,j,k)
            ENDDO
         ENDDO
      ENDIF
      DO k = 1 , Nt
         CALL HRFFTF(Idv,Nlon,Ve(1,1,k),Idv,Wrfft,Work)
         CALL HRFFTF(Idv,Nlon,We(1,1,k),Idv,Wrfft,Work)
      ENDDO
      ndo1 = Nlat
      ndo2 = Nlat
      IF ( mlat/=0 ) ndo1 = Nlat - 1
      IF ( mlat==0 ) ndo2 = Nlat - 1
      IF ( Ityp/=2 .AND. Ityp/=5 .AND. Ityp/=8 ) THEN
         DO k = 1 , Nt
            DO mp1 = 1 , mmax
               DO np1 = mp1 , Nlat
                  Br(mp1,np1,k) = 0.
                  Bi(mp1,np1,k) = 0.
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      IF ( Ityp/=1 .AND. Ityp/=4 .AND. Ityp/=7 ) THEN
         DO k = 1 , Nt
            DO mp1 = 1 , mmax
               DO np1 = mp1 , Nlat
                  Cr(mp1,np1,k) = 0.
                  Ci(mp1,np1,k) = 0.
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      itypp = Ityp + 1
      IF ( itypp==2 ) THEN
!
!     case ityp=1 ,  no symmetries but cr and ci equal zero
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Ve(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Vo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Vo(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *We(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Vo(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *We(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Wb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) - Wb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Ve(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Wo(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Ve(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Wo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-2,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==3 ) THEN
!
!     case ityp=2 ,  no symmetries but br and bi equal zero
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*We(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*Wo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *Wo(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Ve(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *Wo(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Ve(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) + Wb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Wb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *We(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Vo(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *We(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Vo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-2,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==4 ) THEN
!
!     case ityp=3 ,  v even , w odd
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Ve(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*Wo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *Wo(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Ve(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *Wo(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Ve(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) + Wb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Wb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Ve(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Wo(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Ve(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Wo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-2,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==5 ) THEN
!
!     case ityp=4 ,  v even, w odd, and cr and ci equal 0.
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Ve(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Ve(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Wo(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Ve(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Wo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-2,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==6 ) THEN
!
!     case ityp=5   v even, w odd, and br and bi equal zero
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*Wo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *Wo(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Ve(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *Wo(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Ve(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) + Wb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Wb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==7 ) THEN
!
!     case ityp=6 ,  v odd , w even
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*We(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Vo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Vo(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *We(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Vo(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *We(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Wb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) - Wb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *We(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Vo(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *We(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Vo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-2,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==8 ) THEN
!
!     case ityp=7   v odd, w even, and cr and ci equal zero
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Vo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Vo(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *We(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Vo(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *We(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Wb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) - Wb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==9 ) THEN
!
!     case ityp=8   v odd, w even, and both br and bi equal zero
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*We(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *We(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Vo(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *We(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Vo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-2,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         GOTO 99999
      ENDIF
!
!     case ityp=0 ,  no symmetries
!
!     case m=0
!
      DO k = 1 , Nt
         DO i = 1 , Imid
            DO np1 = 2 , ndo2 , 2
               Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Ve(i,1,k)
               Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*We(i,1,k)
            ENDDO
         ENDDO
      ENDDO
      DO k = 1 , Nt
         DO i = 1 , imm1
            DO np1 = 3 , ndo1 , 2
               Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Vo(i,1,k)
               Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*Wo(i,1,k)
            ENDDO
         ENDDO
      ENDDO
!
!     case m = 1 through nlat-1
!
      IF ( mmax<2 ) RETURN
      DO mp1 = 2 , mmax
         m = mp1 - 1
         mb = m*Nlat - (m*(m+1))/2
         mp2 = mp1 + 1
         IF ( mp1<=ndo1 ) THEN
            DO k = 1 , Nt
               DO i = 1 , imm1
                  DO np1 = mp1 , ndo1 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)       &
                                   & *Vo(i,2*mp1-2,k) + Wb(i,np1+mb)    &
                                   & *We(i,2*mp1-1,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)       &
                                   & *Vo(i,2*mp1-1,k) - Wb(i,np1+mb)    &
                                   & *We(i,2*mp1-2,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)       &
                                   & *Wo(i,2*mp1-2,k) + Wb(i,np1+mb)    &
                                   & *Ve(i,2*mp1-1,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)       &
                                   & *Wo(i,2*mp1-1,k) - Wb(i,np1+mb)    &
                                   & *Ve(i,2*mp1-2,k)
                  ENDDO
               ENDDO
            ENDDO
            IF ( mlat/=0 ) THEN
               DO k = 1 , Nt
                  DO np1 = mp1 , ndo1 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Wb(Imid,np1+mb)    &
                                   & *We(Imid,2*mp1-1,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) - Wb(Imid,np1+mb)    &
                                   & *We(Imid,2*mp1-2,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) + Wb(Imid,np1+mb)    &
                                   & *Ve(Imid,2*mp1-1,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Wb(Imid,np1+mb)    &
                                   & *Ve(Imid,2*mp1-2,k)
                  ENDDO
               ENDDO
            ENDIF
         ENDIF
         IF ( mp2<=ndo2 ) THEN
            DO k = 1 , Nt
               DO i = 1 , imm1
                  DO np1 = mp2 , ndo2 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)       &
                                   & *Ve(i,2*mp1-2,k) + Wb(i,np1+mb)    &
                                   & *Wo(i,2*mp1-1,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)       &
                                   & *Ve(i,2*mp1-1,k) - Wb(i,np1+mb)    &
                                   & *Wo(i,2*mp1-2,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)       &
                                   & *We(i,2*mp1-2,k) + Wb(i,np1+mb)    &
                                   & *Vo(i,2*mp1-1,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)       &
                                   & *We(i,2*mp1-1,k) - Wb(i,np1+mb)    &
                                   & *Vo(i,2*mp1-2,k)
                  ENDDO
               ENDDO
            ENDDO
            IF ( mlat/=0 ) THEN
               DO k = 1 , Nt
                  DO np1 = mp2 , ndo2 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(Imid,np1+mb)    &
                                   & *Ve(Imid,2*mp1-2,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(Imid,np1+mb)    &
                                   & *Ve(Imid,2*mp1-1,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(Imid,np1+mb)    &
                                   & *We(Imid,2*mp1-2,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(Imid,np1+mb)    &
                                   & *We(Imid,2*mp1-1,k)
                  ENDDO
               ENDDO
            ENDIF
         ENDIF
      ENDDO
      RETURN
99999 END SUBROUTINE VHAGS1


      SUBROUTINE VHAGSI(Nlat,Nlon,Wvhags,Lvhags,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER Ierror , imid , iw1 , iw2 , iw3 , iw4 , jw1 , jw2 , jw3 , &
            & Ldwork , lmn , Lvhags , Nlat , Nlon
      REAL, DIMENSION(Lvhags) :: Wvhags
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      imid = (Nlat+1)/2
      lmn = (Nlat*(Nlat+1))/2
      IF ( Lvhags<2*(imid*lmn)+Nlon+15 ) RETURN
      Ierror = 4
!     if (ldwork.lt.nlat*(3*nlat+9)+2) return
      IF ( Ldwork<(Nlat*(3*Nlat+9)+2)/2 ) RETURN
      Ierror = 0
      jw1 = 1
      jw2 = jw1 + imid*lmn
      jw3 = jw2 + imid*lmn
      iw1 = 1
      iw2 = iw1 + Nlat
      iw3 = iw2 + Nlat
      iw4 = iw3 + 3*imid*Nlat
!     iw2 = iw1+nlat+nlat
!     iw3 = iw2+nlat+nlat
!     iw4 = iw3+6*imid*nlat
      CALL VHGAI1(Nlat,imid,Wvhags(jw1),Wvhags(jw2),Dwork(iw1),         &
                & Dwork(iw2),Dwork(iw3),Dwork(iw4))
      CALL HRFFTI(Nlon,Wvhags(jw3))
    END SUBROUTINE VHAGSI


    SUBROUTINE VHGAI1(Nlat,Imid,Vb,Wb,Dthet,Dwts,Dpbar,Work)
      IMPLICIT NONE
      INTEGER i , id , ierror , Imid , INDX , ix , iy , lwk , m , mn ,  &
            & n , Nlat , nm , np , nz
      REAL Vb , Wb
      DIMENSION Vb(Imid,*) , Wb(Imid,*)
      DOUBLE PRECISION abel , bbel , cbel , ssqr2 , dcf
      DOUBLE PRECISION Dpbar(Imid,Nlat,3) , Dthet(*) , Dwts(*) , Work(*)
!     lwk = 4*nlat*(nlat+2)
      lwk = Nlat*(Nlat+2)
      CALL GAQD(Nlat,Dthet,Dwts,Dpbar,lwk,ierror)
!
!     compute associated legendre functions
!
!     compute m=n=0 legendre polynomials for all theta(i)
!
      ssqr2 = 1./DSQRT(2.D0)
      DO i = 1 , Imid
         Dpbar(i,1,1) = ssqr2
         Vb(i,1) = 0.
         Wb(i,1) = 0.
      ENDDO
!
!     main loop for remaining vb, and wb
!
      DO n = 1 , Nlat - 1
         nm = MOD(n-2,3) + 1
         nz = MOD(n-1,3) + 1
         np = MOD(n,3) + 1
!
!     compute dpbar for m=0
!
         CALL DNLFK(0,n,Work)
         mn = INDX(0,n,Nlat)
         DO i = 1 , Imid
            CALL DNLFT(0,n,Dthet(i),Work,Dpbar(i,1,np))
         ENDDO
!
!     compute dpbar for m=1
!
         CALL DNLFK(1,n,Work)
         mn = INDX(1,n,Nlat)
         DO i = 1 , Imid
            CALL DNLFT(1,n,Dthet(i),Work,Dpbar(i,2,np))
!      pbar(i,mn) = dpbar(i,2,np)
         ENDDO
!
!     compute and store dpbar for m=2,n
!
         IF ( n>=2 ) THEN
            DO m = 2 , n
               abel = DSQRT(DBLE(FLOAT((2*n+1)*(m+n-2)*(m+n-3)))        &
                    & /DBLE(FLOAT((2*n-3)*(m+n-1)*(m+n))))
               bbel = DSQRT(DBLE(FLOAT((2*n+1)*(n-m-1)*(n-m)))          &
                    & /DBLE(FLOAT((2*n-3)*(m+n-1)*(m+n))))
               cbel = DSQRT(DBLE(FLOAT((n-m+1)*(n-m+2)))                &
                    & /DBLE(FLOAT((m+n-1)*(m+n))))
               id = INDX(m,n,Nlat)
               IF ( m>=n-1 ) THEN
                  DO i = 1 , Imid
                     Dpbar(i,m+1,np) = abel*Dpbar(i,m-1,nm)             &
                                     & - cbel*Dpbar(i,m-1,np)
                  ENDDO
               ELSE
                  DO i = 1 , Imid
                     Dpbar(i,m+1,np) = abel*Dpbar(i,m-1,nm)             &
                                     & + bbel*Dpbar(i,m+1,nm)           &
                                     & - cbel*Dpbar(i,m-1,np)
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
!
!     compute the derivative of the functions
!
         ix = INDX(0,n,Nlat)
         iy = INDX(n,n,Nlat)
         DO i = 1 , Imid
            Vb(i,ix) = -Dpbar(i,2,np)*Dwts(i)
            Vb(i,iy) = Dpbar(i,n,np)/DSQRT(DBLE(FLOAT(2*(n+1))))*Dwts(i)
         ENDDO
!
         IF ( n/=1 ) THEN
            dcf = DSQRT(DBLE(FLOAT(4*n*(n+1))))
            DO m = 1 , n - 1
               ix = INDX(m,n,Nlat)
               abel = DSQRT(DBLE(FLOAT((n+m)*(n-m+1))))/dcf
               bbel = DSQRT(DBLE(FLOAT((n-m)*(n+m+1))))/dcf
               DO i = 1 , Imid
                  Vb(i,ix) = (abel*Dpbar(i,m,np)-bbel*Dpbar(i,m+2,np))  &
                           & *Dwts(i)
               ENDDO
            ENDDO
         ENDIF
!
!     compute the vector harmonic w(theta) = m*pbar/cos(theta)
!
!     set wb=0 for m=0
!
         ix = INDX(0,n,Nlat)
         DO i = 1 , Imid
            Wb(i,ix) = 0.D0
         ENDDO
!
!     compute wb for m=1,n
!
         dcf = DSQRT(DBLE(FLOAT(n+n+1))/DBLE(FLOAT(4*n*(n+1)*(n+n-1))))
         DO m = 1 , n
            ix = INDX(m,n,Nlat)
            abel = dcf*DSQRT(DBLE(FLOAT((n+m)*(n+m-1))))
            bbel = dcf*DSQRT(DBLE(FLOAT((n-m)*(n-m-1))))
            IF ( m>=n-1 ) THEN
               DO i = 1 , Imid
                  Wb(i,ix) = abel*Dpbar(i,m,nz)*Dwts(i)
               ENDDO
            ELSE
               DO i = 1 , Imid
                  Wb(i,ix) = (abel*Dpbar(i,m,nz)+bbel*Dpbar(i,m+2,nz))  &
                           & *Dwts(i)
               ENDDO
            ENDIF
         ENDDO
      ENDDO
      END SUBROUTINE VHGAI1

      
      FUNCTION INDX(M,N,Nlat)
      IMPLICIT NONE
      INTEGER M , N , Nlat
      INTEGER INDX
      INDX = M*Nlat - (M*(M+1))/2 + N + 1
      END FUNCTION INDX


      SUBROUTINE DVHAGS(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,Mdab,&
                     & Ndab,Wvhags,Lvhags,Work,Lwork,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION Bi , Br , Ci , Cr , V , W , Work , Wvhags
      INTEGER idv , Idvw , idz , Ierror , imid , ist , Ityp , iw1 ,     &
            & iw2 , iw3 , iw4 , Jdvw , jw1 , jw2 , jw3 , lmn , lnl ,    &
            & Lvhags , Lwork , lzimn
      INTEGER Mdab , mmax , Ndab , Nlat , Nlon , Nt
      DIMENSION V(Idvw,Jdvw,1) , W(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,     &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Work(1) , Wvhags(1)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      IF ( Ityp<0 .OR. Ityp>8 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Ityp<=2 .AND. Idvw<Nlat) .OR. (Ityp>2 .AND. Idvw<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      idz = (mmax*(Nlat+Nlat-mmax+1))/2
      lzimn = idz*imid
      IF ( Lvhags<lzimn+lzimn+Nlon+15 ) RETURN
      Ierror = 10
      idv = Nlat
      IF ( Ityp>2 ) idv = imid
      lnl = Nt*idv*Nlon
      IF ( Lwork<lnl+lnl+idv*Nlon ) RETURN
      Ierror = 0
      ist = 0
      IF ( Ityp<=2 ) ist = imid
!
!     set wvhags pointers
!
      lmn = Nlat*(Nlat+1)/2
      jw1 = 1
      jw2 = jw1 + imid*lmn
      jw3 = jw2 + imid*lmn
!
!     set work pointers
!
      iw1 = ist + 1
      iw2 = lnl + 1
      iw3 = iw2 + ist
      iw4 = iw2 + lnl
      CALL DVHAGS1(Nlat,Nlon,Ityp,Nt,imid,Idvw,Jdvw,V,W,Mdab,Ndab,Br,Bi, &
                & Cr,Ci,idv,Work,Work(iw1),Work(iw2),Work(iw3),Work(iw4)&
                & ,idz,Wvhags(jw1),Wvhags(jw2),Wvhags(jw3))
    END SUBROUTINE DVHAGS

      
    SUBROUTINE DVHAGS1(Nlat,Nlon,Ityp,Nt,Imid,Idvw,Jdvw,V,W,Mdab,Ndab, &
                      & Br,Bi,Cr,Ci,Idv,Ve,Vo,We,Wo,Work,Idz,Vb,Wb,     &
                      & Wrfft)
      IMPLICIT NONE
      DOUBLE PRECISION Bi , Br , Ci , Cr , fsn , tsn , V , Vb , Ve , Vo , W , Wb ,  &
         & We , Wo , Work , Wrfft
      INTEGER i , Idv , Idvw , Idz , Imid , imm1 , Ityp , itypp , j ,   &
            & Jdvw , k , m , mb , Mdab , mlat , mlon , mmax , mp1 ,     &
            & mp2 , Ndab
      INTEGER ndo1 , ndo2 , Nlat , Nlon , nlp1 , np1 , Nt
      DIMENSION V(Idvw,Jdvw,1) , W(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,     &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Ve(Idv,Nlon,1) , Vo(Idv,Nlon,1) , We(Idv,Nlon,1) ,      &
              & Wo(Idv,Nlon,1) , Work(1) , Vb(Imid,1) , Wb(Imid,1) ,    &
              & Wrfft(1)
      nlp1 = Nlat + 1
      tsn = 2./Nlon
      fsn = 4./Nlon
      mlat = MOD(Nlat,2)
      mlon = MOD(Nlon,2)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      imm1 = Imid
      IF ( mlat/=0 ) imm1 = Imid - 1
      IF ( Ityp>2 ) THEN
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO j = 1 , Nlon
                  Ve(i,j,k) = fsn*V(i,j,k)
                  Vo(i,j,k) = fsn*V(i,j,k)
                  We(i,j,k) = fsn*W(i,j,k)
                  Wo(i,j,k) = fsn*W(i,j,k)
               ENDDO
            ENDDO
         ENDDO
      ELSE
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO j = 1 , Nlon
                  Ve(i,j,k) = tsn*(V(i,j,k)+V(nlp1-i,j,k))
                  Vo(i,j,k) = tsn*(V(i,j,k)-V(nlp1-i,j,k))
                  We(i,j,k) = tsn*(W(i,j,k)+W(nlp1-i,j,k))
                  Wo(i,j,k) = tsn*(W(i,j,k)-W(nlp1-i,j,k))
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      IF ( mlat/=0 ) THEN
         DO k = 1 , Nt
            DO j = 1 , Nlon
               Ve(Imid,j,k) = tsn*V(Imid,j,k)
               We(Imid,j,k) = tsn*W(Imid,j,k)
            ENDDO
         ENDDO
      ENDIF
      DO k = 1 , Nt
         CALL DHRFFTF(Idv,Nlon,Ve(1,1,k),Idv,Wrfft,Work)
         CALL DHRFFTF(Idv,Nlon,We(1,1,k),Idv,Wrfft,Work)
      ENDDO
      ndo1 = Nlat
      ndo2 = Nlat
      IF ( mlat/=0 ) ndo1 = Nlat - 1
      IF ( mlat==0 ) ndo2 = Nlat - 1
      IF ( Ityp/=2 .AND. Ityp/=5 .AND. Ityp/=8 ) THEN
         DO k = 1 , Nt
            DO mp1 = 1 , mmax
               DO np1 = mp1 , Nlat
                  Br(mp1,np1,k) = 0.
                  Bi(mp1,np1,k) = 0.
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      IF ( Ityp/=1 .AND. Ityp/=4 .AND. Ityp/=7 ) THEN
         DO k = 1 , Nt
            DO mp1 = 1 , mmax
               DO np1 = mp1 , Nlat
                  Cr(mp1,np1,k) = 0.
                  Ci(mp1,np1,k) = 0.
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      itypp = Ityp + 1
      IF ( itypp==2 ) THEN
!
!     case ityp=1 ,  no symmetries but cr and ci equal zero
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Ve(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Vo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Vo(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *We(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Vo(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *We(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Wb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) - Wb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Ve(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Wo(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Ve(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Wo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-2,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==3 ) THEN
!
!     case ityp=2 ,  no symmetries but br and bi equal zero
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*We(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*Wo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *Wo(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Ve(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *Wo(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Ve(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) + Wb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Wb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *We(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Vo(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *We(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Vo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-2,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==4 ) THEN
!
!     case ityp=3 ,  v even , w odd
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Ve(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*Wo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *Wo(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Ve(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *Wo(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Ve(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) + Wb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Wb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Ve(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Wo(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Ve(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Wo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-2,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==5 ) THEN
!
!     case ityp=4 ,  v even, w odd, and cr and ci equal 0.
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Ve(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Ve(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Wo(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Ve(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Wo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-2,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==6 ) THEN
!
!     case ityp=5   v even, w odd, and br and bi equal zero
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*Wo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *Wo(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Ve(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *Wo(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Ve(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) + Wb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Wb(Imid,np1+mb) &
                                      & *Ve(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==7 ) THEN
!
!     case ityp=6 ,  v odd , w even
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*We(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Vo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Vo(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *We(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Vo(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *We(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Wb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) - Wb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *We(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Vo(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *We(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Vo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-2,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==8 ) THEN
!
!     case ityp=7   v odd, w even, and cr and ci equal zero
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Vo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Vo(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *We(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)    &
                                      & *Vo(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *We(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Wb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) - Wb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==9 ) THEN
!
!     case ityp=8   v odd, w even, and both br and bi equal zero
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*We(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mb = m*Nlat - (m*(m+1))/2
            mp2 = mp1 + 1
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *We(i,2*mp1-2,k) + Wb(i,np1+mb) &
                                      & *Vo(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)    &
                                      & *We(i,2*mp1-1,k) - Wb(i,np1+mb) &
                                      & *Vo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-2,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(Imid,np1+mb) &
                                      & *We(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         GOTO 99999
      ENDIF
!
!     case ityp=0 ,  no symmetries
!
!     case m=0
!
      DO k = 1 , Nt
         DO i = 1 , Imid
            DO np1 = 2 , ndo2 , 2
               Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Ve(i,1,k)
               Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*We(i,1,k)
            ENDDO
         ENDDO
      ENDDO
      DO k = 1 , Nt
         DO i = 1 , imm1
            DO np1 = 3 , ndo1 , 2
               Br(1,np1,k) = Br(1,np1,k) + Vb(i,np1)*Vo(i,1,k)
               Cr(1,np1,k) = Cr(1,np1,k) - Vb(i,np1)*Wo(i,1,k)
            ENDDO
         ENDDO
      ENDDO
!
!     case m = 1 through nlat-1
!
      IF ( mmax<2 ) RETURN
      DO mp1 = 2 , mmax
         m = mp1 - 1
         mb = m*Nlat - (m*(m+1))/2
         mp2 = mp1 + 1
         IF ( mp1<=ndo1 ) THEN
            DO k = 1 , Nt
               DO i = 1 , imm1
                  DO np1 = mp1 , ndo1 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)       &
                                   & *Vo(i,2*mp1-2,k) + Wb(i,np1+mb)    &
                                   & *We(i,2*mp1-1,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)       &
                                   & *Vo(i,2*mp1-1,k) - Wb(i,np1+mb)    &
                                   & *We(i,2*mp1-2,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)       &
                                   & *Wo(i,2*mp1-2,k) + Wb(i,np1+mb)    &
                                   & *Ve(i,2*mp1-1,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)       &
                                   & *Wo(i,2*mp1-1,k) - Wb(i,np1+mb)    &
                                   & *Ve(i,2*mp1-2,k)
                  ENDDO
               ENDDO
            ENDDO
            IF ( mlat/=0 ) THEN
               DO k = 1 , Nt
                  DO np1 = mp1 , ndo1 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Wb(Imid,np1+mb)    &
                                   & *We(Imid,2*mp1-1,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) - Wb(Imid,np1+mb)    &
                                   & *We(Imid,2*mp1-2,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) + Wb(Imid,np1+mb)    &
                                   & *Ve(Imid,2*mp1-1,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Wb(Imid,np1+mb)    &
                                   & *Ve(Imid,2*mp1-2,k)
                  ENDDO
               ENDDO
            ENDIF
         ENDIF
         IF ( mp2<=ndo2 ) THEN
            DO k = 1 , Nt
               DO i = 1 , imm1
                  DO np1 = mp2 , ndo2 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(i,np1+mb)       &
                                   & *Ve(i,2*mp1-2,k) + Wb(i,np1+mb)    &
                                   & *Wo(i,2*mp1-1,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(i,np1+mb)       &
                                   & *Ve(i,2*mp1-1,k) - Wb(i,np1+mb)    &
                                   & *Wo(i,2*mp1-2,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(i,np1+mb)       &
                                   & *We(i,2*mp1-2,k) + Wb(i,np1+mb)    &
                                   & *Vo(i,2*mp1-1,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(i,np1+mb)       &
                                   & *We(i,2*mp1-1,k) - Wb(i,np1+mb)    &
                                   & *Vo(i,2*mp1-2,k)
                  ENDDO
               ENDDO
            ENDDO
            IF ( mlat/=0 ) THEN
               DO k = 1 , Nt
                  DO np1 = mp2 , ndo2 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Vb(Imid,np1+mb)    &
                                   & *Ve(Imid,2*mp1-2,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) + Vb(Imid,np1+mb)    &
                                   & *Ve(Imid,2*mp1-1,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) - Vb(Imid,np1+mb)    &
                                   & *We(Imid,2*mp1-2,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Vb(Imid,np1+mb)    &
                                   & *We(Imid,2*mp1-1,k)
                  ENDDO
               ENDDO
            ENDIF
         ENDIF
      ENDDO
      RETURN
99999 END SUBROUTINE DVHAGS1


      SUBROUTINE DVHAGSI(Nlat,Nlon,Wvhags,Lvhags,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER Ierror , imid , iw1 , iw2 , iw3 , iw4 , jw1 , jw2 , jw3 , &
            & Ldwork , lmn , Lvhags , Nlat , Nlon
      DOUBLE PRECISION, DIMENSION(Lvhags) :: Wvhags
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      imid = (Nlat+1)/2
      lmn = (Nlat*(Nlat+1))/2
      IF ( Lvhags<2*(imid*lmn)+Nlon+15 ) RETURN
      Ierror = 4
!     if (ldwork.lt.nlat*(3*nlat+9)+2) return
      IF ( Ldwork<(Nlat*(3*Nlat+9)+2)/2 ) RETURN
      Ierror = 0
      jw1 = 1
      jw2 = jw1 + imid*lmn
      jw3 = jw2 + imid*lmn
      iw1 = 1
      iw2 = iw1 + Nlat
      iw3 = iw2 + Nlat
      iw4 = iw3 + 3*imid*Nlat
!     iw2 = iw1+nlat+nlat
!     iw3 = iw2+nlat+nlat
!     iw4 = iw3+6*imid*nlat
      CALL DVHGAI1(Nlat,imid,Wvhags(jw1),Wvhags(jw2),Dwork(iw1),         &
                & Dwork(iw2),Dwork(iw3),Dwork(iw4))
      CALL DHRFFTI(Nlon,Wvhags(jw3))
    END SUBROUTINE DVHAGSI


    SUBROUTINE DVHGAI1(Nlat,Imid,Vb,Wb,Dthet,Dwts,Dpbar,Work)
      IMPLICIT NONE
      INTEGER i , id , ierror , Imid , INDX , ix , iy , lwk , m , mn ,  &
            & n , Nlat , nm , np , nz
      DOUBLE PRECISION Vb , Wb
      DIMENSION Vb(Imid,*) , Wb(Imid,*)
      DOUBLE PRECISION abel , bbel , cbel , ssqr2 , dcf
      DOUBLE PRECISION Dpbar(Imid,Nlat,3) , Dthet(*) , Dwts(*) , Work(*)
!     lwk = 4*nlat*(nlat+2)
      lwk = Nlat*(Nlat+2)
      CALL DGAQD(Nlat,Dthet,Dwts,Dpbar,lwk,ierror)
!
!     compute associated legendre functions
!
!     compute m=n=0 legendre polynomials for all theta(i)
!
      ssqr2 = 1./DSQRT(2.D0)
      DO i = 1 , Imid
         Dpbar(i,1,1) = ssqr2
         Vb(i,1) = 0.
         Wb(i,1) = 0.
      ENDDO
!
!     main loop for remaining vb, and wb
!
      DO n = 1 , Nlat - 1
         nm = MOD(n-2,3) + 1
         nz = MOD(n-1,3) + 1
         np = MOD(n,3) + 1
!
!     compute dpbar for m=0
!
         CALL DDNLFK(0,n,Work)
         mn = INDX(0,n,Nlat)
         DO i = 1 , Imid
            CALL DDNLFT(0,n,Dthet(i),Work,Dpbar(i,1,np))
         ENDDO
!
!     compute dpbar for m=1
!
         CALL DDNLFK(1,n,Work)
         mn = INDX(1,n,Nlat)
         DO i = 1 , Imid
            CALL DDNLFT(1,n,Dthet(i),Work,Dpbar(i,2,np))
!      pbar(i,mn) = dpbar(i,2,np)
         ENDDO
!
!     compute and store dpbar for m=2,n
!
         IF ( n>=2 ) THEN
            DO m = 2 , n
               abel = DSQRT(DBLE(FLOAT((2*n+1)*(m+n-2)*(m+n-3)))        &
                    & /DBLE(FLOAT((2*n-3)*(m+n-1)*(m+n))))
               bbel = DSQRT(DBLE(FLOAT((2*n+1)*(n-m-1)*(n-m)))          &
                    & /DBLE(FLOAT((2*n-3)*(m+n-1)*(m+n))))
               cbel = DSQRT(DBLE(FLOAT((n-m+1)*(n-m+2)))                &
                    & /DBLE(FLOAT((m+n-1)*(m+n))))
               id = INDX(m,n,Nlat)
               IF ( m>=n-1 ) THEN
                  DO i = 1 , Imid
                     Dpbar(i,m+1,np) = abel*Dpbar(i,m-1,nm)             &
                                     & - cbel*Dpbar(i,m-1,np)
                  ENDDO
               ELSE
                  DO i = 1 , Imid
                     Dpbar(i,m+1,np) = abel*Dpbar(i,m-1,nm)             &
                                     & + bbel*Dpbar(i,m+1,nm)           &
                                     & - cbel*Dpbar(i,m-1,np)
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
!
!     compute the derivative of the functions
!
         ix = INDX(0,n,Nlat)
         iy = INDX(n,n,Nlat)
         DO i = 1 , Imid
            Vb(i,ix) = -Dpbar(i,2,np)*Dwts(i)
            Vb(i,iy) = Dpbar(i,n,np)/DSQRT(DBLE(FLOAT(2*(n+1))))*Dwts(i)
         ENDDO
!
         IF ( n/=1 ) THEN
            dcf = DSQRT(DBLE(FLOAT(4*n*(n+1))))
            DO m = 1 , n - 1
               ix = INDX(m,n,Nlat)
               abel = DSQRT(DBLE(FLOAT((n+m)*(n-m+1))))/dcf
               bbel = DSQRT(DBLE(FLOAT((n-m)*(n+m+1))))/dcf
               DO i = 1 , Imid
                  Vb(i,ix) = (abel*Dpbar(i,m,np)-bbel*Dpbar(i,m+2,np))  &
                           & *Dwts(i)
               ENDDO
            ENDDO
         ENDIF
!
!     compute the vector harmonic w(theta) = m*pbar/cos(theta)
!
!     set wb=0 for m=0
!
         ix = INDX(0,n,Nlat)
         DO i = 1 , Imid
            Wb(i,ix) = 0.D0
         ENDDO
!
!     compute wb for m=1,n
!
         dcf = DSQRT(DBLE(FLOAT(n+n+1))/DBLE(FLOAT(4*n*(n+1)*(n+n-1))))
         DO m = 1 , n
            ix = INDX(m,n,Nlat)
            abel = dcf*DSQRT(DBLE(FLOAT((n+m)*(n+m-1))))
            bbel = dcf*DSQRT(DBLE(FLOAT((n-m)*(n-m-1))))
            IF ( m>=n-1 ) THEN
               DO i = 1 , Imid
                  Wb(i,ix) = abel*Dpbar(i,m,nz)*Dwts(i)
               ENDDO
            ELSE
               DO i = 1 , Imid
                  Wb(i,ix) = (abel*Dpbar(i,m,nz)+bbel*Dpbar(i,m+2,nz))  &
                           & *Dwts(i)
               ENDDO
            ENDIF
         ENDDO
      ENDDO
      END SUBROUTINE DVHGAI1

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
!
! ... file divgs.f
!
!     this file includes documentation and code for
!     subroutine divgs          i
!
! ... files which must be loaded with divgs.f
!
!     sphcom.f, hrfft.f, vhags.f, shsgs.f, gaqd.f
!
!
!     subroutine divgs(nlat,nlon,isym,nt,divg,idiv,jdiv,br,bi,mdb,ndb,
!    +                 wshsgs,lshsgs,work,lwork,ierror)
!
!     given the vector spherical harmonic coefficients br and bi, precomputed
!     by subroutine vhags for a vector field (v,w), subroutine divgs
!     computes the divergence of the vector field in the scalar array divg.
!     divg(i,j) is the divergence at the gaussian colatitude point theta(i)
!     (see nlat as input parameter) and east longitude
!
!            lambda(j) = (j-1)*2*pi/nlon
!
!     on the sphere.  i.e.
!
!            dv(i,j) = 1/sint*[ d(sint*v(i,j))/dtheta + d(w(i,j))/dlambda ]
!
!     where sint = sin(theta(i)).  w is the east longitudinal and v
!     is the colatitudinal component of the vector field from which
!     br,bi were precomputed
!
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are computed
!            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid point
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than zero. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!
!     isym   a parameter which determines whether the divergence is
!            computed on the full or half sphere as follows:
!
!      = 0
!
!            the symmetries/antsymmetries described in isym=1,2 below
!            do not exist in (v,w) about the equator.  in this case the
!            divergence is neither symmetric nor antisymmetric about
!            the equator.  the divergence is computed on the entire
!            sphere.  i.e., in the array divg(i,j) for i=1,...,nlat and
!            j=1,...,nlon.
!
!      = 1
!
!            w is antisymmetric and v is symmetric about the equator.
!            in this case the divergence is antisymmetyric about
!            the equator and is computed for the northern hemisphere
!            only.  i.e., if nlat is odd the divergence is computed
!            in the array divg(i,j) for i=1,...,(nlat+1)/2 and for
!            j=1,...,nlon.  if nlat is even the divergence is computed
!            in the array divg(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!      = 2
!            w is symmetric and v is antisymmetric about the equator
!            in this case the divergence is symmetyric about the
!            equator and is computed for the northern hemisphere
!            only.  i.e., if nlat is odd the divergence is computed
!            in the array divg(i,j) for i=1,...,(nlat+1)/2 and for
!            j=1,...,nlon.  if nlat is even the divergence is computed
!            in the array divg(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!
!     nt     nt is the number of scalar and vector fields.  some
!            computational efficiency is obtained for multiple fields.
!            in the program that calls divgs, the arrays br,bi, and divg
!            can be three dimensional corresponding to an indexed multiple
!            vector field.  in this case multiple scalar synthesis will
!            be performed to compute the divergence for each field.  the
!            third index is the synthesis index which assumes the values
!            k=1,...,nt.  for a single synthesis set nt = 1.  the
!            description of the remaining parameters is simplified by
!            assuming that nt=1 or that all the arrays are two dimensional.
!
!     idiv   the first dimension of the array divg as it appears in
!            the program that calls divgs. if isym = 0 then idiv
!            must be at least nlat.  if isym = 1 or 2 and nlat is
!            even then idiv must be at least nlat/2. if isym = 1 or 2
!            and nlat is odd then idiv must be at least (nlat+1)/2.
!
!     jdiv   the second dimension of the array divg as it appears in
!            the program that calls divgs. jdiv must be at least nlon.
!
!     br,bi  two or three dimensional arrays (see input parameter nt)
!            that contain vector spherical harmonic coefficients
!            of the vector field (v,w) as computed by subroutine vhags.
!     ***    br and bi must be computed by vhags prior to calling
!            divgs.
!
!     mdb    the first dimension of the arrays br and bi as it
!            appears in the program that calls divgs. mdb must be at
!            least min0(nlat,nlon/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndb    the second dimension of the arrays br and bi as it
!            appears in the program that calls divgs. ndb must be at
!            least nlat.
!
!
!     wshsgs an array which must be intialized by subroutine shsgsi.
!            once initialized,
!            wshsgs can be used repeatedly by divgs as long as nlon
!            and nlat remain unchanged.  wshsgs must not be altered
!            between calls of divgs.
!
!
!     lshsgs the dimension of the array wshsgs as it appears in the
!            program that calls divgs. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshsgs must be at least
!
!               nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
!
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls divgs. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2                    if nlat is even or
!               l2 = (nlat+1)/2                if nlat is odd
!
!            if isym = 0 then lwork must be at least
!
!               nlat*((nt+1)*nlon+2*nt*l1+1)
!
!            if isym > 0 then lwork must be at least
!
!               (nt+1)*l2*nlon+nlat*(2*nt*l1+1)
!
!     **************************************************************
!
!     output parameters
!
!
!    divg   a two or three dimensional array (see input parameter nt)
!           that contains the divergence of the vector field (v,w)
!           whose coefficients br,bi where computed by subroutine
!           vhags.  divg(i,j) is the divergence at the gaussian colatitude
!           point theta(i) and longitude point lambda(j) = (j-1)*2*pi/nlon.
!           the index ranges are defined above at the input parameter
!           isym.
!
!
!    ierror = 0  no errors
!           = 1  error in the specification of nlat
!           = 2  error in the specification of nlon
!           = 3  error in the specification of isym
!           = 4  error in the specification of nt
!           = 5  error in the specification of idiv
!           = 6  error in the specification of jdiv
!           = 7  error in the specification of mdb
!           = 8  error in the specification of ndb
!           = 9  error in the specification of lshsgs
!           = 10 error in the specification of lwork
! **********************************************************************
!
!
      SUBROUTINE DIVGS(Nlat,Nlon,Isym,Nt,Divg,Idiv,Jdiv,Br,Bi,Mdb,Ndb,  &
                     & Wshsgs,Lshsgs,Work,Lwork,Ierror)
      IMPLICIT NONE
      REAL Bi , Br , Divg , Work , Wshsgs
      INTEGER ia , ib , Idiv , Ierror , imid , is , Isym , iwk , Jdiv , &
            & l1 , l2 , lp , lpimn , ls , Lshsgs , lwk , Lwork , mab ,  &
            & Mdb , mmax
      INTEGER mn , Ndb , Nlat , nln , Nlon , Nt
 
      DIMENSION Divg(Idiv,Jdiv,Nt) , Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt)
      DIMENSION Wshsgs(Lshsgs) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idiv<Nlat) .OR. (Isym>0 .AND. Idiv<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jdiv<Nlon ) RETURN
      Ierror = 7
      IF ( Mdb<MIN0(Nlat,(Nlon+1)/2) ) RETURN
      mmax = MIN0(Nlat,(Nlon+2)/2)
      Ierror = 8
      IF ( Ndb<Nlat ) RETURN
      Ierror = 9
      imid = (Nlat+1)/2
      lpimn = (imid*mmax*(Nlat+Nlat-mmax+1))/2
!     check permanent work space length
      l2 = (Nlat+1)/2
      l1 = MIN0((Nlon+2)/2,Nlat)
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshsgs<lp ) RETURN
      Ierror = 10
!
!     verify unsaved work space (add to what shses requires, file f3)
!
      ls = Nlat
      IF ( Isym>0 ) ls = imid
      nln = Nt*ls*Nlon
!
!     set first dimension for a,b (as requried by shses)
!
      mab = MIN0(Nlat,Nlon/2+1)
      mn = mab*Nlat*Nt
      IF ( Lwork<nln+ls*Nlon+2*mn+Nlat ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ia = 1
      ib = ia + mn
      is = ib + mn
      iwk = is + Nlat
      lwk = Lwork - 2*mn - Nlat
      CALL DIVGS1(Nlat,Nlon,Isym,Nt,Divg,Idiv,Jdiv,Br,Bi,Mdb,Ndb,       &
                & Work(ia),Work(ib),mab,Work(is),Wshsgs,Lshsgs,Work(iwk)&
                & ,lwk,Ierror)
    END SUBROUTINE DIVGS
 
    SUBROUTINE DIVGS1(Nlat,Nlon,Isym,Nt,Divg,Idiv,Jdiv,Br,Bi,Mdb,Ndb, &
                      & A,B,Mab,Sqnn,Wshsgs,Lshsgs,Wk,Lwk,Ierror)
      IMPLICIT NONE
!*--DIVGS1286
      REAL A , B , Bi , Br , Divg , fn , Sqnn , Wk , Wshsgs
      INTEGER Idiv , Ierror , Isym , Jdiv , k , Lshsgs , Lwk , m , Mab ,&
            & Mdb , mmax , n , Ndb , Nlat , Nlon , Nt
      DIMENSION Divg(Idiv,Jdiv,Nt) , Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt)
      DIMENSION A(Mab,Nlat,Nt) , B(Mab,Nlat,Nt) , Sqnn(Nlat)
      DIMENSION Wshsgs(Lshsgs) , Wk(Lwk)
!
!     set coefficient multiplyers
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.))
      ENDDO
!
!     compute divergence scalar coefficients for each vector field
!
      DO k = 1 , Nt
         DO n = 1 , Nlat
            DO m = 1 , Mab
               A(m,n,k) = 0.0
               B(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            A(1,n,k) = -Sqnn(n)*Br(1,n,k)
            B(1,n,k) = -Sqnn(n)*Bi(1,n,k)
         ENDDO
!
!     compute m>0 coefficients using vector spherepack value for mmax
!
         mmax = MIN0(Nlat,(Nlon+1)/2)
         DO m = 2 , mmax
            DO n = m , Nlat
               A(m,n,k) = -Sqnn(n)*Br(m,n,k)
               B(m,n,k) = -Sqnn(n)*Bi(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     synthesize a,b into divg
!
      CALL SHSGS(Nlat,Nlon,Isym,Nt,Divg,Idiv,Jdiv,A,B,Mab,Nlat,Wshsgs,  &
               & Lshsgs,Wk,Lwk,Ierror)
    END SUBROUTINE DIVGS1


    
    SUBROUTINE DDIVGS(Nlat,Nlon,Isym,Nt,Divg,Idiv,Jdiv,Br,Bi,Mdb,Ndb,  &
                     & Wshsgs,Lshsgs,Work,Lwork,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION Bi , Br , Divg , Work , Wshsgs
      INTEGER ia , ib , Idiv , Ierror , imid , is , Isym , iwk , Jdiv , &
            & l1 , l2 , lp , lpimn , ls , Lshsgs , lwk , Lwork , mab ,  &
            & Mdb , mmax
      INTEGER mn , Ndb , Nlat , nln , Nlon , Nt
 
      DIMENSION Divg(Idiv,Jdiv,Nt) , Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt)
      DIMENSION Wshsgs(Lshsgs) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idiv<Nlat) .OR. (Isym>0 .AND. Idiv<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jdiv<Nlon ) RETURN
      Ierror = 7
      IF ( Mdb<MIN0(Nlat,(Nlon+1)/2) ) RETURN
      mmax = MIN0(Nlat,(Nlon+2)/2)
      Ierror = 8
      IF ( Ndb<Nlat ) RETURN
      Ierror = 9
      imid = (Nlat+1)/2
      lpimn = (imid*mmax*(Nlat+Nlat-mmax+1))/2
!     check permanent work space length
      l2 = (Nlat+1)/2
      l1 = MIN0((Nlon+2)/2,Nlat)
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshsgs<lp ) RETURN
      Ierror = 10
!
!     verify unsaved work space (add to what shses requires, file f3)
!
      ls = Nlat
      IF ( Isym>0 ) ls = imid
      nln = Nt*ls*Nlon
!
!     set first dimension for a,b (as requried by shses)
!
      mab = MIN0(Nlat,Nlon/2+1)
      mn = mab*Nlat*Nt
      IF ( Lwork<nln+ls*Nlon+2*mn+Nlat ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ia = 1
      ib = ia + mn
      is = ib + mn
      iwk = is + Nlat
      lwk = Lwork - 2*mn - Nlat
      CALL DDIVGS1(Nlat,Nlon,Isym,Nt,Divg,Idiv,Jdiv,Br,Bi,Mdb,Ndb,       &
                & Work(ia),Work(ib),mab,Work(is),Wshsgs,Lshsgs,Work(iwk)&
                & ,lwk,Ierror)
    END SUBROUTINE DDIVGS

    
    SUBROUTINE DDIVGS1(Nlat,Nlon,Isym,Nt,Divg,Idiv,Jdiv,Br,Bi,Mdb,Ndb, &
                      & A,B,Mab,Sqnn,Wshsgs,Lshsgs,Wk,Lwk,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , Bi , Br , Divg , fn , Sqnn , Wk , Wshsgs
      INTEGER Idiv , Ierror , Isym , Jdiv , k , Lshsgs , Lwk , m , Mab ,&
            & Mdb , mmax , n , Ndb , Nlat , Nlon , Nt
      DIMENSION Divg(Idiv,Jdiv,Nt) , Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt)
      DIMENSION A(Mab,Nlat,Nt) , B(Mab,Nlat,Nt) , Sqnn(Nlat)
      DIMENSION Wshsgs(Lshsgs) , Wk(Lwk)
!
!     set coefficient multiplyers
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.))
      ENDDO
!
!     compute divergence scalar coefficients for each vector field
!
      DO k = 1 , Nt
         DO n = 1 , Nlat
            DO m = 1 , Mab
               A(m,n,k) = 0.0
               B(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            A(1,n,k) = -Sqnn(n)*Br(1,n,k)
            B(1,n,k) = -Sqnn(n)*Bi(1,n,k)
         ENDDO
!
!     compute m>0 coefficients using vector spherepack value for mmax
!
         mmax = MIN0(Nlat,(Nlon+1)/2)
         DO m = 2 , mmax
            DO n = m , Nlat
               A(m,n,k) = -Sqnn(n)*Br(m,n,k)
               B(m,n,k) = -Sqnn(n)*Bi(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     synthesize a,b into divg
!
      CALL DSHSGS(Nlat,Nlon,Isym,Nt,Divg,Idiv,Jdiv,A,B,Mab,Nlat,Wshsgs,  &
               & Lshsgs,Wk,Lwk,Ierror)
    END SUBROUTINE DDIVGS1

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file vhsgc.f
!
!     this file contains code and documentation for subroutines
!     vhsgc and vhsgci
!
! ... files which must be loaded with vhsgc.f
!
!     sphcom.f, hrfft.f, gaqd.f
!
!     subroutine vhsgc(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
!    +                 mdab,ndab,wvhsgc,lvhsgc,work,lwork,ierror)
!
!     subroutine vhsgc performs the vector spherical harmonic synthesis
!     of the arrays br, bi, cr, and ci and stores the result in the
!     arrays v and w. v(i,j) and w(i,j) are the colatitudinal
!     (measured from the north pole) and east longitudinal components
!     respectively, located at the gaussian colatitude point theta(i)
!     and longitude phi(j) = (j-1)*2*pi/nlon. the spectral
!     representation of (v,w) is given below at output parameters v,w.
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are computed
!            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid point
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than zero. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!     ityp   = 0  no symmetries exist about the equator. the synthesis
!                 is performed on the entire sphere.  i.e. on the
!                 arrays v(i,j),w(i,j) for i=1,...,nlat and
!                 j=1,...,nlon.
!
!            = 1  no symmetries exist about the equator. the synthesis
!                 is performed on the entire sphere.  i.e. on the
!                 arrays v(i,j),w(i,j) for i=1,...,nlat and
!                 j=1,...,nlon. the curl of (v,w) is zero. that is,
!                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
!                 the coefficients cr and ci are zero.
!
!            = 2  no symmetries exist about the equator. the synthesis
!                 is performed on the entire sphere.  i.e. on the
!                 arrays v(i,j),w(i,j) for i=1,...,nlat and
!                 j=1,...,nlon. the divergence of (v,w) is zero. i.e.,
!                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
!                 the coefficients br and bi are zero.
!
!            = 3  v is symmetric and w is antisymmetric about the
!                 equator. the synthesis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the synthesis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the synthesis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!            = 4  v is symmetric and w is antisymmetric about the
!                 equator. the synthesis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the synthesis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the synthesis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the curl of (v,w) is zero. that is,
!                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
!                 the coefficients cr and ci are zero.
!
!            = 5  v is symmetric and w is antisymmetric about the
!                 equator. the synthesis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the synthesis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the synthesis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the divergence of (v,w) is zero. i.e.,
!                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
!                 the coefficients br and bi are zero.
!
!            = 6  v is antisymmetric and w is symmetric about the
!                 equator. the synthesis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the synthesis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the synthesis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!            = 7  v is antisymmetric and w is symmetric about the
!                 equator. the synthesis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the synthesis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the synthesis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the curl of (v,w) is zero. that is,
!                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
!                 the coefficients cr and ci are zero.
!
!            = 8  v is antisymmetric and w is symmetric about the
!                 equator. the synthesis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the synthesis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the synthesis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the divergence of (v,w) is zero. i.e.,
!                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
!                 the coefficients br and bi are zero.
!
!
!     nt     the number of syntheses.  in the program that calls vhsgc,
!            the arrays v,w,br,bi,cr, and ci can be three dimensional
!            in which case multiple syntheses will be performed.
!            the third index is the synthesis index which assumes the
!            values k=1,...,nt.  for a single synthesis set nt=1. the
!            discription of the remaining parameters is simplified
!            by assuming that nt=1 or that all the arrays are two
!            dimensional.
!
!     idvw   the first dimension of the arrays v,w as it appears in
!            the program that calls vhsgc. if ityp .le. 2 then idvw
!            must be at least nlat.  if ityp .gt. 2 and nlat is
!            even then idvw must be at least nlat/2. if ityp .gt. 2
!            and nlat is odd then idvw must be at least (nlat+1)/2.
!
!     jdvw   the second dimension of the arrays v,w as it appears in
!            the program that calls vhsgc. jdvw must be at least nlon.
!
!     br,bi  two or three dimensional arrays (see input parameter nt)
!     cr,ci  that contain the vector spherical harmonic coefficients
!            in the spectral representation of v(i,j) and w(i,j) given
!            below at the discription of output parameters v and w.
!
!     mdab   the first dimension of the arrays br,bi,cr, and ci as it
!            appears in the program that calls vhsgc. mdab must be at
!            least min0(nlat,nlon/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndab   the second dimension of the arrays br,bi,cr, and ci as it
!            appears in the program that calls vhsgc. ndab must be at
!            least nlat.
!
!     wvhsgc an array which must be initialized by subroutine vhsgci.
!            once initialized, wvhsgc can be used repeatedly by vhsgc
!            as long as nlon and nlat remain unchanged.  wvhsgc must
!            not be altered between calls of vhsgc.
!
!     lvhsgc the dimension of the array wvhsgc as it appears in the
!            program that calls vhsgc. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lvhsgc must be at least
!
!               4*nlat*l2+3*max0(l1-2,0)*(2*nlat-l1-1)+nlon+15
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls vhsgc. define
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            if ityp .le. 2 then lwork must be at least
!
!                    nlat*(2*nt*nlon+max0(6*l2,nlon))
!
!            if ityp .gt. 2 then lwork must be at least
!
!                    l2*(2*nt*nlon+max0(6*nlat,nlon))
!
!     **************************************************************
!
!     output parameters
!
!     v,w    two or three dimensional arrays (see input parameter nt)
!            in which the synthesis is stored. v is the colatitudinal
!            component and w is the east longitudinal component.
!            v(i,j),w(i,j) contain the components at the gaussian
!            colatitude theta(i) and longitude phi(j) = (j-1)*2*pi/nlon.
!            the index ranges are defined above at the input parameter
!            ityp. v and w are computed from the formulas given below.
!
!     define
!
!     1.  theta is colatitude and phi is east longitude
!
!     2.  the normalized associated legendre funnctions
!
!         pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)
!                        /(2*factorial(n+m)))*sin(theta)**m/(2**n*
!                        factorial(n)) times the (n+m)th derivative
!                        of (x**2-1)**n with respect to x=cos(theta)
!
!     3.  vbar(m,n,theta) = the derivative of pbar(m,n,theta) with
!                           respect to theta divided by the square
!                           root of n(n+1).
!
!         vbar(m,n,theta) is more easily computed in the form
!
!         vbar(m,n,theta) = (sqrt((n+m)*(n-m+1))*pbar(m-1,n,theta)
!         -sqrt((n-m)*(n+m+1))*pbar(m+1,n,theta))/(2*sqrt(n*(n+1)))
!
!     4.  wbar(m,n,theta) = m/(sin(theta))*pbar(m,n,theta) divided
!                           by the square root of n(n+1).
!
!         wbar(m,n,theta) is more easily computed in the form
!
!         wbar(m,n,theta) = sqrt((2n+1)/(2n-1))*(sqrt((n+m)*(n+m-1))
!         *pbar(m-1,n-1,theta)+sqrt((n-m)*(n-m-1))*pbar(m+1,n-1,theta))
!         /(2*sqrt(n*(n+1)))
!
!
!    the colatitudnal dependence of the normalized surface vector
!                spherical harmonics are defined by
!
!     5.    bbar(m,n,theta) = (vbar(m,n,theta),i*wbar(m,n,theta))
!
!     6.    cbar(m,n,theta) = (i*wbar(m,n,theta),-vbar(m,n,theta))
!
!
!    the coordinate to index mappings
!
!     7.   phi(j) = (j-1)*2*pi/nlon, theta(i) is the i(th) guassian
!          point (see nlat as an input parameter).
!
!     the maximum (plus one) longitudinal wave number
!
!     8.     mmax = min0(nlat,nlon/2) if nlon is even or
!            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
!
!    if we further define the output vector as
!
!     9.    h(i,j) = (v(i,j),w(i,j))
!
!    and the complex coefficients
!
!     10.   b(m,n) = cmplx(br(m+1,n+1),bi(m+1,n+1))
!
!     11.   c(m,n) = cmplx(cr(m+1,n+1),ci(m+1,n+1))
!
!
!    then for i=1,...,nlat and  j=1,...,nlon
!
!        the expansion for real h(i,j) takes the form
!
!     h(i,j) = the sum from n=1 to n=nlat-1 of the real part of
!
!         .5*(b(0,n)*bbar(0,n,theta(i))+c(0,n)*cbar(0,n,theta(i)))
!
!     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
!     n=nlat-1 of the real part of
!
!              b(m,n)*bbar(m,n,theta(i))*exp(i*m*phi(j))
!             +c(m,n)*cbar(m,n,theta(i))*exp(i*m*phi(j))
!
!   *************************************************************
!
!   in terms of real variables this expansion takes the form
!
!             for i=1,...,nlat and  j=1,...,nlon
!
!     v(i,j) = the sum from n=1 to n=nlat-1 of
!
!               .5*br(1,n+1)*vbar(0,n,theta(i))
!
!     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
!     n=nlat-1 of the real part of
!
!       (br(m+1,n+1)*vbar(m,n,theta(i))-ci(m+1,n+1)*wbar(m,n,theta(i)))
!                                          *cos(m*phi(j))
!      -(bi(m+1,n+1)*vbar(m,n,theta(i))+cr(m+1,n+1)*wbar(m,n,theta(i)))
!                                          *sin(m*phi(j))
!
!    and for i=1,...,nlat and  j=1,...,nlon
!
!     w(i,j) = the sum from n=1 to n=nlat-1 of
!
!              -.5*cr(1,n+1)*vbar(0,n,theta(i))
!
!     plus the sum from m=1 to m=mmax-1 of the sum from n=m to
!     n=nlat-1 of the real part of
!
!      -(cr(m+1,n+1)*vbar(m,n,theta(i))+bi(m+1,n+1)*wbar(m,n,theta(i)))
!                                          *cos(m*phi(j))
!      +(ci(m+1,n+1)*vbar(m,n,theta(i))-br(m+1,n+1)*wbar(m,n,theta(i)))
!                                          *sin(m*phi(j))
!
!
!      br(m+1,nlat),bi(m+1,nlat),cr(m+1,nlat), and ci(m+1,nlat) are
!      assumed zero for m even.
!
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of ityp
!            = 4  error in the specification of nt
!            = 5  error in the specification of idvw
!            = 6  error in the specification of jdvw
!            = 7  error in the specification of mdab
!            = 8  error in the specification of ndab
!            = 9  error in the specification of lvhsgc
!            = 10 error in the specification of lwork
!
!*************************************************************
!
!     subroutine vhsgci(nlat,nlon,wvhsgc,lvhsgc,dwork,ldwork,ierror)
!
!     subroutine vhsgci initializes the array wvhsgc which can then be
!     used repeatedly by subroutine vhsgc until nlat or nlon is changed.
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are computed
!            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid point
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than zero. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!     lvhsgc the dimension of the array wvhsgc as it appears in the
!            program that calls vhsgc. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lvhsgc must be at least
!
!               4*nlat*l2+3*max0(l1-2,0)*(2*nlat-l1-1)+nlon+15
!
!     work  a double precision work space that does not need to be saved
!
!     ldwork the dimension of the array dwork as it appears in the
!            program that calls vhsgsi. ldwork must be at least
!
!               2*nlat*(nlat+1)+1
!
!     **************************************************************
!
!     output parameters
!
!     wvhsgc an array which is initialized for use by subroutine vhsgc.
!            once initialized, wvhsgc can be used repeatedly by vhsgc
!            as long as nlat and nlon remain unchanged.  wvhsgc must not
!            be altered between calls of vhsgc.
!
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of lvhsgc
!            = 4  error in the specification of ldwork
!
      SUBROUTINE VHSGC(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,Mdab,&
                     & Ndab,Wvhsgc,Lvhsgc,Work,Lwork,Ierror)
      IMPLICIT NONE
      REAL Bi , Br , Ci , Cr , V , W , Work , Wvhsgc
      INTEGER idv , Idvw , Ierror , imid , ist , Ityp , iw1 , iw2 ,     &
            & iw3 , iw4 , iw5 , Jdvw , jw1 , jw2 , l1 , l2 , labc ,     &
            & lnl , Lvhsgc , lwmin
      INTEGER Lwork , lwzvin , lzz1 , Mdab , mmax , Ndab , Nlat , Nlon ,&
            & Nt
      DIMENSION V(Idvw,Jdvw,1) , W(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,     &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Work(1) , Wvhsgc(1)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      IF ( Ityp<0 .OR. Ityp>8 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Ityp<=2 .AND. Idvw<Nlat) .OR. (Ityp>2 .AND. Idvw<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
!
!     check save work space length
!
      l1 = MIN0(Nlat,(Nlon+1)/2)
      l2 = (Nlat+1)/2
      lwmin = 4*Nlat*l2 + 3*MAX0(l1-2,0)*(2*Nlat-l1-1) + Nlon + 15
      IF ( Lvhsgc<lwmin ) RETURN
 
 
!     if(lvhsgc .lt. 2*(lzz1+labc)+nlon+15) return
      Ierror = 10
      IF ( Ityp<=2 .AND. Lwork<Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon)) )     &
         & RETURN
      IF ( Ityp>2 .AND. Lwork<imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon)) )      &
         & RETURN
      Ierror = 0
      idv = Nlat
      IF ( Ityp>2 ) idv = imid
      lnl = Nt*idv*Nlon
      ist = 0
      IF ( Ityp<=2 ) ist = imid
      iw1 = ist + 1
      iw2 = lnl + 1
      iw3 = iw2 + ist
      iw4 = iw2 + lnl
      iw5 = iw4 + 3*imid*Nlat
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      lwzvin = lzz1 + labc
      jw1 = lwzvin + 1
      jw2 = jw1 + lwzvin
      CALL VHSGC1(Nlat,Nlon,Ityp,Nt,imid,Idvw,Jdvw,V,W,Mdab,Ndab,Br,Bi, &
                & Cr,Ci,idv,Work,Work(iw1),Work(iw2),Work(iw3),Work(iw4)&
                & ,Work(iw5),Wvhsgc,Wvhsgc(jw1),Wvhsgc(jw2))
      END SUBROUTINE VHSGC


      SUBROUTINE VHSGC1(Nlat,Nlon,Ityp,Nt,Imid,Idvw,Jdvw,V,W,Mdab,Ndab, &
                      & Br,Bi,Cr,Ci,Idv,Ve,Vo,We,Wo,Vb,Wb,Wvbin,Wwbin,  &
                      & Wrfft)
      IMPLICIT NONE
      REAL Bi , Br , Ci , Cr , V , Vb , Ve , Vo , W , Wb , We , Wo ,    &
         & Wrfft , Wvbin , Wwbin
      INTEGER i , Idv , Idvw , Imid , imm1 , Ityp , itypp , iv , iw ,   &
            & j , Jdvw , k , m , Mdab , mlat , mlon , mmax , mp1 , mp2 ,&
            & Ndab
      INTEGER ndo1 , ndo2 , Nlat , Nlon , nlp1 , np1 , Nt
      DIMENSION V(Idvw,Jdvw,1) , W(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,     &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Ve(Idv,Nlon,1) , Vo(Idv,Nlon,1) , We(Idv,Nlon,1) ,      &
              & Wo(Idv,Nlon,1) , Wvbin(1) , Wwbin(1) , Wrfft(1) ,       &
              & Vb(Imid,Nlat,3) , Wb(Imid,Nlat,3)
      nlp1 = Nlat + 1
      mlat = MOD(Nlat,2)
      mlon = MOD(Nlon,2)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      imm1 = Imid
      IF ( mlat/=0 ) imm1 = Imid - 1
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Idv
               Ve(i,j,k) = 0.
               We(i,j,k) = 0.
            ENDDO
         ENDDO
      ENDDO
      ndo1 = Nlat
      ndo2 = Nlat
      IF ( mlat/=0 ) ndo1 = Nlat - 1
      IF ( mlat==0 ) ndo2 = Nlat - 1
      itypp = Ityp + 1
      IF ( itypp==2 ) THEN
!
!     case ityp=1   no symmetries,  cr and ci equal zero
!
         CALL VBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , Imid
                  Ve(i,1,k) = Ve(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , imm1
                  Vo(i,1,k) = Vo(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==3 ) THEN
!
!     case ityp=2   no symmetries,  br and bi are equal to zero
!
         CALL VBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , Imid
                  We(i,1,k) = We(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , imm1
                  Wo(i,1,k) = Wo(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==4 ) THEN
!
!     case ityp=3   v even,  w odd
!
         CALL VBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , Imid
                  Ve(i,1,k) = Ve(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , imm1
                  Wo(i,1,k) = Wo(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==5 ) THEN
!
!     case ityp=4   v even,  w odd, and both cr and ci equal zero
!
         CALL VBIN(1,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , Imid
                  Ve(i,1,k) = Ve(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(1,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(1,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==6 ) THEN
!
!     case ityp=5   v even,  w odd,     br and bi equal zero
!
         CALL VBIN(2,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , imm1
                  Wo(i,1,k) = Wo(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(2,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(2,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==7 ) THEN
!
!     case ityp=6   v odd  ,  w even
!
         CALL VBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , Imid
                  We(i,1,k) = We(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , imm1
                  Vo(i,1,k) = Vo(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==8 ) THEN
!
!     case ityp=7   v odd, w even   cr and ci equal zero
!
         CALL VBIN(2,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , imm1
                  Vo(i,1,k) = Vo(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(2,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(2,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==9 ) THEN
!
!     case ityp=8   v odd,  w even   br and bi equal zero
!
         CALL VBIN(1,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , Imid
                  We(i,1,k) = We(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(1,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(1,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSE
!
!     case ityp=0   no symmetries
!
         CALL VBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , Imid
                  Ve(i,1,k) = Ve(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
                  We(i,1,k) = We(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , imm1
                  Vo(i,1,k) = Vo(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
                  Wo(i,1,k) = Wo(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL VBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL WBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ENDIF
      DO k = 1 , Nt
         CALL HRFFTB(Idv,Nlon,Ve(1,1,k),Idv,Wrfft,Vb)
         CALL HRFFTB(Idv,Nlon,We(1,1,k),Idv,Wrfft,Vb)
      ENDDO
      IF ( Ityp>2 ) THEN
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , imm1
                  V(i,j,k) = .5*Ve(i,j,k)
                  W(i,j,k) = .5*We(i,j,k)
               ENDDO
            ENDDO
         ENDDO
      ELSE
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , imm1
                  V(i,j,k) = .5*(Ve(i,j,k)+Vo(i,j,k))
                  W(i,j,k) = .5*(We(i,j,k)+Wo(i,j,k))
                  V(nlp1-i,j,k) = .5*(Ve(i,j,k)-Vo(i,j,k))
                  W(nlp1-i,j,k) = .5*(We(i,j,k)-Wo(i,j,k))
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      IF ( mlat==0 ) RETURN
      DO k = 1 , Nt
         DO j = 1 , Nlon
            V(Imid,j,k) = .5*Ve(Imid,j,k)
            W(Imid,j,k) = .5*We(Imid,j,k)
         ENDDO
      ENDDO
    END SUBROUTINE VHSGC1


      SUBROUTINE VHSGCI(Nlat,Nlon,Wvhsgc,Lvhsgc,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER Ierror , imid , iw1 , iw2 , iwrk , jw1 , jw2 , jw3 ,      &
            & labc , Ldwork , Lvhsgc , lwvbin , lzz1 , mmax , Nlat ,    &
            & Nlon
      REAL Wvhsgc
      DIMENSION Wvhsgc(Lvhsgc)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      imid = (Nlat+1)/2
      lzz1 = 2*Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lvhsgc<2*(lzz1+labc)+Nlon+15 ) RETURN
      Ierror = 4
      IF ( Ldwork<2*Nlat*(Nlat+1)+1 ) RETURN
      Ierror = 0
!
!     compute gaussian points in first nlat+1 words of dwork
!     double precision
!
!     lwk = 2*nlat*(nlat+2)
      jw1 = 1
      jw2 = jw1 + Nlat
      jw3 = jw2 + Nlat
!     jw2 = jw1+nlat+nlat
!     jw3 = jw2+nlat+nlat
      CALL GAQD(Nlat,Dwork(jw1),Dwork(jw2),Dwork(jw3),Ldwork,Ierror)
!     iwrk = nlat+2
      iwrk = (Nlat+1)/2 + 1
      CALL VBGINT(Nlat,Nlon,Dwork,Wvhsgc,Dwork(iwrk))
      lwvbin = lzz1 + labc
      iw1 = lwvbin + 1
      CALL WBGINT(Nlat,Nlon,Dwork,Wvhsgc(iw1),Dwork(iwrk))
      iw2 = iw1 + lwvbin
      CALL HRFFTI(Nlon,Wvhsgc(iw2))
      END SUBROUTINE VHSGCI


      
      SUBROUTINE DVHSGC(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,Mdab,&
                     & Ndab,Wvhsgc,Lvhsgc,Work,Lwork,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION Bi , Br , Ci , Cr , V , W , Work , Wvhsgc
      INTEGER idv , Idvw , Ierror , imid , ist , Ityp , iw1 , iw2 ,     &
            & iw3 , iw4 , iw5 , Jdvw , jw1 , jw2 , l1 , l2 , labc ,     &
            & lnl , Lvhsgc , lwmin
      INTEGER Lwork , lwzvin , lzz1 , Mdab , mmax , Ndab , Nlat , Nlon ,&
            & Nt
      DIMENSION V(Idvw,Jdvw,1) , W(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,     &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Work(1) , Wvhsgc(1)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      IF ( Ityp<0 .OR. Ityp>8 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Ityp<=2 .AND. Idvw<Nlat) .OR. (Ityp>2 .AND. Idvw<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
!
!     check save work space length
!
      l1 = MIN0(Nlat,(Nlon+1)/2)
      l2 = (Nlat+1)/2
      lwmin = 4*Nlat*l2 + 3*MAX0(l1-2,0)*(2*Nlat-l1-1) + Nlon + 15
      IF ( Lvhsgc<lwmin ) RETURN
 
 
!     if(lvhsgc .lt. 2*(lzz1+labc)+nlon+15) return
      Ierror = 10
      IF ( Ityp<=2 .AND. Lwork<Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon)) )     &
         & RETURN
      IF ( Ityp>2 .AND. Lwork<imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon)) )      &
         & RETURN
      Ierror = 0
      idv = Nlat
      IF ( Ityp>2 ) idv = imid
      lnl = Nt*idv*Nlon
      ist = 0
      IF ( Ityp<=2 ) ist = imid
      iw1 = ist + 1
      iw2 = lnl + 1
      iw3 = iw2 + ist
      iw4 = iw2 + lnl
      iw5 = iw4 + 3*imid*Nlat
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      lwzvin = lzz1 + labc
      jw1 = lwzvin + 1
      jw2 = jw1 + lwzvin
      CALL DVHSGC1(Nlat,Nlon,Ityp,Nt,imid,Idvw,Jdvw,V,W,Mdab,Ndab,Br,Bi, &
                & Cr,Ci,idv,Work,Work(iw1),Work(iw2),Work(iw3),Work(iw4)&
                & ,Work(iw5),Wvhsgc,Wvhsgc(jw1),Wvhsgc(jw2))
      END SUBROUTINE DVHSGC


      SUBROUTINE DVHSGC1(Nlat,Nlon,Ityp,Nt,Imid,Idvw,Jdvw,V,W,Mdab,Ndab, &
                      & Br,Bi,Cr,Ci,Idv,Ve,Vo,We,Wo,Vb,Wb,Wvbin,Wwbin,  &
                      & Wrfft)
      IMPLICIT NONE
      DOUBLE PRECISION Bi , Br , Ci , Cr , V , Vb , Ve , Vo , W , Wb , We , Wo ,    &
         & Wrfft , Wvbin , Wwbin
      INTEGER i , Idv , Idvw , Imid , imm1 , Ityp , itypp , iv , iw ,   &
            & j , Jdvw , k , m , Mdab , mlat , mlon , mmax , mp1 , mp2 ,&
            & Ndab
      INTEGER ndo1 , ndo2 , Nlat , Nlon , nlp1 , np1 , Nt
      DIMENSION V(Idvw,Jdvw,1) , W(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,     &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Ve(Idv,Nlon,1) , Vo(Idv,Nlon,1) , We(Idv,Nlon,1) ,      &
              & Wo(Idv,Nlon,1) , Wvbin(1) , Wwbin(1) , Wrfft(1) ,       &
              & Vb(Imid,Nlat,3) , Wb(Imid,Nlat,3)
      nlp1 = Nlat + 1
      mlat = MOD(Nlat,2)
      mlon = MOD(Nlon,2)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      imm1 = Imid
      IF ( mlat/=0 ) imm1 = Imid - 1
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Idv
               Ve(i,j,k) = 0.
               We(i,j,k) = 0.
            ENDDO
         ENDDO
      ENDDO
      ndo1 = Nlat
      ndo2 = Nlat
      IF ( mlat/=0 ) ndo1 = Nlat - 1
      IF ( mlat==0 ) ndo2 = Nlat - 1
      itypp = Ityp + 1
      IF ( itypp==2 ) THEN
!
!     case ityp=1   no symmetries,  cr and ci equal zero
!
         CALL DVBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , Imid
                  Ve(i,1,k) = Ve(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , imm1
                  Vo(i,1,k) = Vo(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==3 ) THEN
!
!     case ityp=2   no symmetries,  br and bi are equal to zero
!
         CALL DVBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , Imid
                  We(i,1,k) = We(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , imm1
                  Wo(i,1,k) = Wo(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==4 ) THEN
!
!     case ityp=3   v even,  w odd
!
         CALL DVBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , Imid
                  Ve(i,1,k) = Ve(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , imm1
                  Wo(i,1,k) = Wo(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==5 ) THEN
!
!     case ityp=4   v even,  w odd, and both cr and ci equal zero
!
         CALL DVBIN(1,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , Imid
                  Ve(i,1,k) = Ve(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(1,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(1,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==6 ) THEN
!
!     case ityp=5   v even,  w odd,     br and bi equal zero
!
         CALL DVBIN(2,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , imm1
                  Wo(i,1,k) = Wo(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(2,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(2,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==7 ) THEN
!
!     case ityp=6   v odd  ,  w even
!
         CALL DVBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , Imid
                  We(i,1,k) = We(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , imm1
                  Vo(i,1,k) = Vo(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==8 ) THEN
!
!     case ityp=7   v odd, w even   cr and ci equal zero
!
         CALL DVBIN(2,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , imm1
                  Vo(i,1,k) = Vo(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(2,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(2,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSEIF ( itypp==9 ) THEN
!
!     case ityp=8   v odd,  w even   br and bi equal zero
!
         CALL DVBIN(1,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , Imid
                  We(i,1,k) = We(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(1,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(1,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ELSE
!
!     case ityp=0   no symmetries
!
         CALL DVBIN(0,Nlat,Nlon,0,Vb,iv,Wvbin)
!
!     case m = 0
!
         DO k = 1 , Nt
            DO np1 = 2 , ndo2 , 2
               DO i = 1 , Imid
                  Ve(i,1,k) = Ve(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
                  We(i,1,k) = We(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO np1 = 3 , ndo1 , 2
               DO i = 1 , imm1
                  Vo(i,1,k) = Vo(i,1,k) + Br(1,np1,k)*Vb(i,np1,iv)
                  Wo(i,1,k) = Wo(i,1,k) - Cr(1,np1,k)*Vb(i,np1,iv)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax>=2 ) THEN
            DO mp1 = 2 , mmax
               m = mp1 - 1
               mp2 = mp1 + 1
               CALL DVBIN(0,Nlat,Nlon,m,Vb,iv,Wvbin)
               CALL DWBIN(0,Nlat,Nlon,m,Wb,iw,Wwbin)
               IF ( mp1<=ndo1 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        DO i = 1 , imm1
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & - Ci(mp1,np1,k)*Wb(Imid,np1,iw)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Cr(mp1,np1,k)*Wb(Imid,np1,iw)
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Bi(mp1,np1,k)*Wb(Imid,np1,iw)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & + Br(mp1,np1,k)*Wb(Imid,np1,iw)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
               IF ( mp2<=ndo2 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        DO i = 1 , imm1
                           Ve(i,2*mp1-2,k) = Ve(i,2*mp1-2,k)            &
                            & + Br(mp1,np1,k)*Vb(i,np1,iv)
                           Vo(i,2*mp1-2,k) = Vo(i,2*mp1-2,k)            &
                            & - Ci(mp1,np1,k)*Wb(i,np1,iw)
                           Ve(i,2*mp1-1,k) = Ve(i,2*mp1-1,k)            &
                            & + Bi(mp1,np1,k)*Vb(i,np1,iv)
                           Vo(i,2*mp1-1,k) = Vo(i,2*mp1-1,k)            &
                            & + Cr(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-2,k) = We(i,2*mp1-2,k)            &
                            & - Cr(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-2,k) = Wo(i,2*mp1-2,k)            &
                            & - Bi(mp1,np1,k)*Wb(i,np1,iw)
                           We(i,2*mp1-1,k) = We(i,2*mp1-1,k)            &
                            & - Ci(mp1,np1,k)*Vb(i,np1,iv)
                           Wo(i,2*mp1-1,k) = Wo(i,2*mp1-1,k)            &
                            & + Br(mp1,np1,k)*Wb(i,np1,iw)
                        ENDDO
                        IF ( mlat/=0 ) THEN
                           Ve(Imid,2*mp1-2,k) = Ve(Imid,2*mp1-2,k)      &
                            & + Br(mp1,np1,k)*Vb(Imid,np1,iv)
                           Ve(Imid,2*mp1-1,k) = Ve(Imid,2*mp1-1,k)      &
                            & + Bi(mp1,np1,k)*Vb(Imid,np1,iv)
                           We(Imid,2*mp1-2,k) = We(Imid,2*mp1-2,k)      &
                            & - Cr(mp1,np1,k)*Vb(Imid,np1,iv)
                           We(Imid,2*mp1-1,k) = We(Imid,2*mp1-1,k)      &
                            & - Ci(mp1,np1,k)*Vb(Imid,np1,iv)
                        ENDIF
                     ENDDO
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ENDIF
      DO k = 1 , Nt
         CALL DHRFFTB(Idv,Nlon,Ve(1,1,k),Idv,Wrfft,Vb)
         CALL DHRFFTB(Idv,Nlon,We(1,1,k),Idv,Wrfft,Vb)
      ENDDO
      IF ( Ityp>2 ) THEN
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , imm1
                  V(i,j,k) = .5*Ve(i,j,k)
                  W(i,j,k) = .5*We(i,j,k)
               ENDDO
            ENDDO
         ENDDO
      ELSE
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , imm1
                  V(i,j,k) = .5*(Ve(i,j,k)+Vo(i,j,k))
                  W(i,j,k) = .5*(We(i,j,k)+Wo(i,j,k))
                  V(nlp1-i,j,k) = .5*(Ve(i,j,k)-Vo(i,j,k))
                  W(nlp1-i,j,k) = .5*(We(i,j,k)-Wo(i,j,k))
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      IF ( mlat==0 ) RETURN
      DO k = 1 , Nt
         DO j = 1 , Nlon
            V(Imid,j,k) = .5*Ve(Imid,j,k)
            W(Imid,j,k) = .5*We(Imid,j,k)
         ENDDO
      ENDDO
    END SUBROUTINE DVHSGC1


      SUBROUTINE DVHSGCI(Nlat,Nlon,Wvhsgc,Lvhsgc,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER Ierror , imid , iw1 , iw2 , iwrk , jw1 , jw2 , jw3 ,      &
            & labc , Ldwork , Lvhsgc , lwvbin , lzz1 , mmax , Nlat ,    &
            & Nlon
      DOUBLE PRECISION Wvhsgc
      DIMENSION Wvhsgc(Lvhsgc)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      imid = (Nlat+1)/2
      lzz1 = 2*Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lvhsgc<2*(lzz1+labc)+Nlon+15 ) RETURN
      Ierror = 4
      IF ( Ldwork<2*Nlat*(Nlat+1)+1 ) RETURN
      Ierror = 0
!
!     compute gaussian points in first nlat+1 words of dwork
!     double precision
!
!     lwk = 2*nlat*(nlat+2)
      jw1 = 1
      jw2 = jw1 + Nlat
      jw3 = jw2 + Nlat
!     jw2 = jw1+nlat+nlat
!     jw3 = jw2+nlat+nlat
      CALL DGAQD(Nlat,Dwork(jw1),Dwork(jw2),Dwork(jw3),Ldwork,Ierror)
!     iwrk = nlat+2
      iwrk = (Nlat+1)/2 + 1
      CALL DVBGINT(Nlat,Nlon,Dwork,Wvhsgc,Dwork(iwrk))
      lwvbin = lzz1 + labc
      iw1 = lwvbin + 1
      CALL DWBGINT(Nlat,Nlon,Dwork,Wvhsgc(iw1),Dwork(iwrk))
      iw2 = iw1 + lwvbin
      CALL DHRFFTI(Nlon,Wvhsgc(iw2))
      END SUBROUTINE DVHSGCI

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
! ... file trssph.f
!
!     contains documentation and code for subroutine trssph
!
! ... required files
!
!     sphcom.f, hrfft.f, gaqd.f, shaec.f, shsec.f, shagc.f, shsgc.f
!
!
!     subroutine trssph(intl,igrida,nlona,nlata,da,igridb,nlonb,nlatb,
!    +db,wsave,lsave,lsvmin,work,lwork,lwkmin,dwork,ldwork,ier)
!
! *** purpose
!
!     subroutine trssph transfers data given in array da on a grid on the
!     full sphere to data in array db on a grid on the full sphere.  the
!     grids on which da is given and db is generated can be specified
!     independently of each other (see description below and the arguments
!     igrida,igridb).  for transferring vector data on the sphere, use
!     subroutine trvsph.
 
!     notice that scalar and vector quantities are fundamentally different
!     on the sphere.  for example, vectors are discontinuous and multiple
!     valued at the poles.  scalars are continuous and single valued at the
!     poles. erroneous results would be produced if one attempted to transfer
!     vector fields between grids with subroutine trssph applied to each
!     component of the vector.
!
!
! *** underlying grid assumptions and a description
!
!     discussions with the ncar scd data support group and others indicate
!     there is no standard grid for storing observational or model generated
!     data on the sphere.  subroutine trssph was designed to handle most
!     cases likely to be encountered when moving data from one grid format
!     to another.
!
!     the grid on which da is given must be equally spaced in longitude
!     and either equally spaced or gaussian in latitude (or colatitude).
!     longitude, which can be either the first or second dimension of da,
!     subdivides [0,2pi) excluding the periodic point 2pi.  (co)latitude,
!     which can be the second or first dimension of da, has south
!     to north or north to south orientation with increasing subscript
!     value in da (see the argument igrida).
!
!     the grid on which db is generated must be equally spaced in longitude
!     and either equally spaced or gaussian in latitude (or colatitude).
!     longitude, which can be either the first or second dimension of db,
!     subdivides [0,2pi) excluding the periodic point 2pi.  (co)latitude,
!     which can be the second or first dimension of db, has south
!     to north or north to south orientation with increasing subscript
!     value in db (see the argument igridb).
!
!     let nlon be either nlona or nlonb (the number of grid points in
!     longitude.  the longitude grid subdivides [0,2pi) into nlon spaced
!     points
!
!          (j-1)*2.*pi/nlon  (j=1,...,nlon).
!
!     it is not necessary to communicate to subroutine trssph whether the
!     underlying grids are in latitude or colatitude.  it is only necessary
!     to communicate whether they run south to north or north to south with
!     increasing subscripts.  a brief discussion of latitude and colatitude
!     follows.  equally spaced latitude grids are assumed to subdivide
!     [-pi/2,pi/2] with the south pole at -pi/2 and north pole at pi/2.
!     equally spaced colatitude grids subdivide [0,pi] with the north pole
!     at 0 and south pole at pi.  equally spaced partitions on the sphere
!     include both poles.  gaussian latitude grids subdivide (-pi/2,pi/2)
!     and gaussian colatitude grids subdivide (0,pi).  gaussian grids do not
!     include the poles.  the gaussian grid points are uniquely determined by
!     the size of the partition.  they can be computed in colatitude in
!     (0,pi) (north to south) in double precision by the spherepack subroutine
!     gaqd.  let nlat be nlata or nlatb if either the da or db grid is
!     gaussian.  let
!
!        north pole                             south pole
!        ----------                             ----------
!           0.0    <  cth(1) < ... < cth(nlat)  <   pi
!
!
!     be nlat gaussian colatitude points in the interval (0,pi) and let
!
!        south pole                        north pole
!        ----------                        ----------
!           -pi/2  < th(1) < ... < th(nlat) < pi/2
!
!     be nlat gaussian latitude points in the open interval (-pi/2,pi/2).
!     these are related by
!
!          th(i) = -pi/2 + cth(i)  (i=1,...,nlat)
!
!     if the da or db grid is equally spaced in (co)latitude then
!
!          ctht(i) = (i-1)*pi/(nlat-1)
!                                               (i=1,...,nlat)
!          tht(i) = -pi/2 + (i-1)*pi/(nlat-1)
!
!     define the equally spaced (north to south) colatitude and (south to
!     north) latitude grids.
!
!
! *** method (simplified description)
!
!     for simplicity, assume da is a nlat by nlon data tabulation and da(i,j)
!     is the value at latitude theta(i) and longitude phi(j).  then
!     coefficients a(m,n) and b(m,n) can be determined so that da(i,j) is
!     approximated by the sum
!
!         l-1  n
!     (a) sum sum pbar(m,n,theta(i))*(a(m,n)*cos(m*phi(j)+b(m,n)*sin(m*phi(j))
!         n=0 m=0
!
!     here pbar(n,m,theta) are the normalized associated legendre functions
!     and l = min0(nlat,(nlon+2)/2).  the determination of a(m,n) and b(m,n)
!     is called spherical harmonic analysis. a sum of this form can then be
!     used to regenerate the data in db on the new grid with the known
!     a(m,n) and b(m,n).  this is referred to spherical harmonic synthesis.
!     analysis and synthesis subroutines from the software package spherepack,
!     are used for these purposes.
!
!     if da or db is not in mathematical spherical coordinates then array
!     transposition and/or subscript reordering is used prior to harmonic
!     analysis and after harmonic synthesis.
!
! *** advantages
!
!     the use of surface spherical harmonics to transfer spherical grid data
!     has advantages over pointwise grid interpolation schemes on the sphere.
!     it is highly accurate.  if p(x,y,z) is any polynomial of degree n or
!     less in x,y,z cartesian coordinates which is restricted to the surface
!     of the sphere, then p is exactly represented by sums of the form (a)
!     whenever n = mino(nlat,nlon/2) (i.e., transfers with spherical harmonics
!     have n(th) order accuracy.  by way of contrast, bilinear interpolation
!     schemes are exact for polynomials of degree one.  bicubic interpolation
!     is exact only for polynomials of degree three or less.  the method
!     also produces a weighted least squares fit to the data in which waves
!     are resolved uniformly on the full sphere.  high frequencies, induced
!     by closeness of grid points near the poles (due to computational
!     or observational errors) are smoothed.  finally, the method is
!     consistent with methods used to generate data in numerical spectral
!     models based on spherical harmonics.  for more discussion of these and
!     related issues,  see the article: "on the spectral approximation of
!     discrete scalar and vector functions on the sphere," siam j. numer.
!     anal., vol 16. dec 1979, pp. 934-949, by paul swarztrauber.
!
!
! *** comment
!
!     on a nlon by nlat or nlat by nlon grid (gaussian or equally spaced)
!     spherical harmonic analysis generates and synthesis utilizes
!     min0(nlat,(nlon+2)/2)) by nlat coefficients.  consequently, for
!     da and db,  if either
!
!             min0(nlatb,(nlonb+2)/2) < min0(nlata,(nlona+2)/2)
!
!     or if
!
!             nlatb < nlata
!
!     then all the coefficients generated by an analysis of da cannot be used
!     in the synthesis which generates db.  in this case "information" can be
!     lost in generating db.  more precisely, information will be lost if the
!     analysis of da yields nonzero coefficients which are outside the bounds
!     determined by the db grid.  nevertheless, transference of values with
!     spherical harmonics will yield results consistent with grid resolution
!     and is highly accurate.
!
!
! *** input arguments
!
! ... intl
!
!     an initialization argument which should be zero on an initial call to
!     trssph.  intl should be one if trssph is being recalled and
!
!          igrida,nlona,nlata,igridb,nlonb,nlatb
!
!     have not changed from the previous call.  if any of these arguments
!     have changed, intl=0 must be used to avoid undetectable errors.  calls
!     with intl=1 bypass redundant computation and save time.  it can be used
!     when transferring multiple data sets with the same underlying grids.
!
!
! ... igrida
!
!     an integer vector dimensioned two which identifies the underlying grid
!     on the full sphere for the given data array da as follows:
!
!     igrida(1)
!
!     = -1
!     if the latitude (or colatitude) grid for da is an equally spaced
!     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
!     runs north to south
!
!     = +1
!     if the latitude (or colatitude) grid for da is an equally spaced
!     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
!     runs south to north
!
!     = -2
!     if the latitude (or colatitude) grid for da is a gaussian partition
!     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs north
!     to south
!
!     = +2
!     if the latitude (or colatitude) grid for da is a gaussian partition
!     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs south
!     north
!
!     igrida(2)
!
!     = 0 if the underlying grid for da is a nlona by nlata
!
!     = 1 if the underlying grid for da is a nlata by nlona
!
!
! ... nlona
!
!     the number of longitude points on the uniform grid which partitions
!     [0,2pi) for the given data array da.  nlona is also the first or second
!     dimension of da (see igrida(2)) in the program which calls trssph.
!     nlona determines the grid increment in longitude as 2*pi/nlona. for
!     example nlona = 72 for a five degree grid.  nlona must be greater than
!     or equal to 4.  the efficiency of the computation is improved when
!     nlona is a product of small prime numbers
!
! ... nlata
!
!     the number of points in the latitude (or colatitude) grid
!     for the given data array da.  nlata is also the first or second
!     dimension of da (see igrida(2)) in the program which calls trssph.
!     if nlata is odd then the equator will be located at the (nlata+1)/2
!     gaussian grid point.  if nlata is even then the equator will be
!     located half way between the nlata/2 and nlata/2+1 grid points.
!
! *** note:
!     igrida(1)=-1 or igrida(1)=-2 and igrida(2)=1 corresponds to
!     the "usual" mathematical spherical coordinate system required
!     by most of the drivers in spherepack2.  igrida(1)=1 or igrida(1)=2
!     and igrida(2)=0 corresponds to the "usual" geophysical spherical
!     coordinate system.
!
! ... da
!
!     a two dimensional array that contains the data to be transferred.
!     da must be dimensioned nlona by nlata in the program calling trssph if
!     igrida(2) = 0.  da must be dimensioned nlata by nlona in the program
!     calling trssph if igrida(2) = 1.  if da is not properly dimensioned
!     and if the latitude (colatitude) values do not run south to north or
!     north to south as flagged by igrida(1) (this cannot be checked!) then
!     incorrect results will be produced.
!
! ... igridb
!
!     an integer vector dimensioned two which identifies the underlying grid
!     on the full sphere for the transformed data array db as follows:
!
!     igridb(1)
!
!     = -1
!     if the latitude (or colatitude) grid for db is an equally spaced
!     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
!     north to south
!
!     = +1
!     if the latitude (or colatitude) grid for db is an equally spaced
!     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
!     south to north
!
!     = -2
!     if the latitude (or colatitude) grid for db is a gaussian partition
!     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs north to
!     south
!
!     = +2
!     if the latitude (or colatitude) grid for db is a gaussian partition
!     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs south to
!     north
!
!
!     igridb(2)
!
!     = 0 if the underlying grid for db is a nlonb by nlatb
!
!     = 1 if the underlying grid for db is a nlatb by nlonb
!
!
! ... nlonb
!
!     the number of longitude points on the uniform grid which partitions
!     [0,2pi) for the transformed data array db.  nlonb is also the first or
!     second dimension of db (see igridb(2)) in the program which calls
!     trssph.  nlonb determines the grid increment in longitude as 2*pi/nlonb.
!     for example nlonb = 72 for a five degree grid.  nlonb must be greater
!     than or equal to 4.  the efficiency of the computation is improved when
!     nlonb is a product of small prime numbers
!
! ... nlatb
!
!     the number of points in the latitude (or colatitude) grid
!     for the transformed data array db.  nlatb is also the first or second
!     dimension of db (see igridb(2)) in the program which calls trssph.
!     if nlatb is odd then the equator will be located at the (nlatb+1)/2
!     gaussian grid point.  if nlatb is even then the equator will be
!     located half way between the nlatb/2 and nlatb/2+1 grid points.
!
! ... wsave
!
!     a saved work space array that can be utilized repeatedly by trssph
!     as long as the arguments nlata,nlona,nlatb,nlonb remain unchanged.
!     wsave is set by a intl=0 call to trssph.  wsave must not be altered
!     when trssph is being recalled with intl=1.
!
! ... lsave
!
!     the dimension of the work space wsave as it appears in the program
!     that calls trssph.  the minimum required value of lsave for the
!     current set of input arguments is set in the output argument lsvmin.
!     it can be determined by calling trssph with lsave=0 and printing lsvmin.
!     let
!
!          lwa =  2*nlata*la2+3*((la1-2)*(nlata+nlata-la1-1))/2+nlona+15
!
!     if the grid for da is equally spaced in (co)latitude.  let
!
!          lwa = nlata*(2*la2+3*la1-2)+3*la1*(1-la1)/2+nlona+15
!
!     if the grid for da is gaussian in (co)latitude.
!     let
!
!          lwb = nlatb*(2*lb2+3*lb1-2)+3*lb1*(1-lb1)/2+nlonb+15
!
!     if the grid for db is gaussian in (co)latitude.  let
!
!          lwb = 2*nlatb*lb2+3*((lb1-2)*(nlatb+nlatb-lb1-1))/2+nlonb+15
!
!     if the grid for db is equally spaced in (co)latitude.  then
!     the quantity
!
!          lwa + lwb
!
!     is the minimum required length of wsave.  this value is returned
!     in the output argument lsvmin even if lsave is to small (ierror=10)
!
! ... work
!
!     a real work array that does not have to be preserved
!
! ... lwork
!
!     the dimension of the array work as it appears in the program
!     calling trssph. the minimum required value of lwork for the current
!     set of input arguments is set in the output argument lwkmin.
!     it can be determined by calling trssph with lwork=0 and printing
!     lwkmin.  an estimate for lwork follows.  let nlat,nlon,l1,l2 be
!     defined by
!
!       nlat = max0(nlata,nlatb), nlon = nax0(nlona,nlonb),
!       l1 = min0(nlat,(nlon+2)/2), l2 = (nlat+1)/2
!
!     then the quantity
!
!          nlat*(4*l1+nlon+2*nlat+4)+3*((l1-2)*2*(2*nlat-l1-1))/2
!
!     will suffice as a length for the unsaved work space.
!
!  *  both of the formulas above for lsave and lwork may overestimate the
!     required minimum values.  they can be predetermined by calling trssph
!     with lsave=lwork=0 and printout of lsvmin and lwkmin.
!
! ... dwork
!
!     a double precision work array that does not have to be preserved.
!
! ... ldwork
!
!     The length of dwork in the routine calling trssph.
!     Let
!
!       nlat = max0(nlata,nlatb)
!
!     ldwork must be at least nlat*(nlat+4)
!
! *** output arguments
!
!
! ... db
!
!     a two dimensional array that contains the transformed data.  db
!     must be dimensioned nlonb by nlatb in the program calling trssph if
!     igridb(2) = 0 or 1.  db must be dimensioned nlatb by nlonb in the
!     program calling trssph if igridb(2) = 1.  if db is not properly
!     dimensioned and if the latitude (colatitude) values do not run south
!     north or north to south as flagged by igrdb(1) (this cannot be checked!)
!     then incorrect results will be produced.
!
! ... lsvmin
!
!     the minimum length of the saved work space in wsave.
!     lsvmin is computed even if lsave < lsvmin (ier = 10).
!
! ... lwkmin
!
!     the minimum length of the unsaved work space in work.
!     lwkmin is computed even if lwork < lwkmin (ier = 11).
!
! *** error argument
!
! ... ier = 0  if no errors are detected
!
!         = 1  if intl is not 0 or 1
!
!         = 2  if igrida(1) is not -1 or +1 or -2 or +2
!
!         = 3  if igrida(2) is not 0 or 1
!
!         = 4  if nlona is less than 4
!
!         = 5  if nlata is less than 3
!
!         = 6  if igridb(1) is not -1 or +1 or -2 or +2
!
!         = 7  if igridb(2) is not 0 or 1
!
!         = 8  if nlonb is less than 4
!
!         = 9  if nlatb is less than 3
 
!         =10  if there is insufficient saved work space (lsave < lsvmin)
!
!         =11  if there is insufficient unsaved work space (lwork < lwkmin)
!
!         =12  indicates failure in an eigenvalue routine which computes
!              gaussian weights and points
!
!         =13  if ldwork is too small (insufficient unsaved double precision
!              work space)
!
! *****************************************************
! *****************************************************
!
!     end of argument description ... code follows
!
! *****************************************************
! *****************************************************
!
      SUBROUTINE TRSSPH(Intl,Igrida,Nlona,Nlata,Da,Igridb,Nlonb,Nlatb,  &
                      & Db,Wsave,Lsave,Lsvmin,Work,Lwork,Lwkmin,Dwork,  &
                      & Ldwork,Ier)
      IMPLICIT NONE
!*--TRSSPH468
      INTEGER Intl , Igrida(2) , Nlona , Nlata , Igridb(2) , Nlonb ,    &
            & Nlatb
      INTEGER Lsave , Lsvmin , Lwork , Lwkmin , Ldwork , Ier
      REAL Da(*) , Db(*) , Wsave(*) , Work(*)
      DOUBLE PRECISION Dwork(*)
      INTEGER ig , igrda , igrdb , la1 , la2 , lb1 , lb2 , lwa , lwb ,  &
            & iaa , iab , iba , ibb
      INTEGER lwk3 , lwk4 , lw , iw , jb , nt , isym , nlat
!
!     include a save statement to ensure local variables in trssph, set during
!     an intl=0 call, are preserved if trssph is recalled with intl=1
!
      SAVE 
!
!     check input arguments
!
      Ier = 1
      IF ( Intl*(Intl-1)/=0 ) RETURN
      Ier = 2
      ig = Igrida(1)
      IF ( (ig-1)*(ig+1)*(ig-2)*(ig+2)/=0 ) RETURN
      Ier = 3
      ig = Igrida(2)
      IF ( ig*(ig-1)/=0 ) RETURN
      Ier = 4
      IF ( Nlona<4 ) RETURN
      Ier = 5
      IF ( Nlata<3 ) RETURN
      Ier = 6
      ig = Igridb(1)
      IF ( (ig-1)*(ig+1)*(ig-2)*(ig+2)/=0 ) RETURN
      Ier = 7
      ig = Igridb(2)
      IF ( ig*(ig-1)/=0 ) RETURN
      Ier = 8
      IF ( Nlonb<4 ) RETURN
      Ier = 9
      IF ( Nlatb<3 ) RETURN
      Ier = 0
 
      igrda = IABS(Igrida(1))
      igrdb = IABS(Igridb(1))
      IF ( Intl==0 ) THEN
         la1 = MIN0(Nlata,(Nlona+2)/2)
         la2 = (Nlata+1)/2
         lb1 = MIN0(Nlatb,(Nlonb+2)/2)
         lb2 = (Nlatb+1)/2
!
!     set saved work space length for analysis
!
         IF ( igrda==1 ) THEN
!
!     saved space for analysis on  equally spaced grid
!
            lwa = 2*Nlata*la2 + 3*((la1-2)*(Nlata+Nlata-la1-1))         &
                & /2 + Nlona + 15
         ELSE
!
!     saved space for analysis on gaussian grid
!
            lwa = Nlata*(2*la2+3*la1-2) + 3*la1*(1-la1)/2 + Nlona + 15
         ENDIF
!
!     set wsave pointer
!
         jb = 1 + lwa
!
!     set pointers for spherical harmonic coefs
!
         iaa = 1
         iba = iaa + la1*Nlata
         iab = iba + la1*Nlata
         IF ( igrdb==2 ) THEN
!
!     set saved work space length for gaussian synthesis
!
            lwb = Nlatb*(2*lb2+3*lb1-2) + 3*lb1*(1-lb1)/2 + Nlonb + 15
         ELSE
!
!     set saved work space length for equally spaced synthesis
!
            lwb = 2*Nlatb*lb2 + 3*((lb1-2)*(Nlatb+Nlatb-lb1-1))         &
                & /2 + Nlonb + 15
         ENDIF
!
!     set minimum saved work space length
!
         Lsvmin = lwa + lwb
!
!     set remaining harmonic pointer
!
         ibb = iab + lb1*Nlatb
!
!     set pointers for remaining work
!
         iw = ibb + lb1*Nlatb
!
!     set remaining work space length in lw
!
         lw = Lwork - iw
         lwk3 = Nlata*Nlona*2
         lwk4 = Nlatb*Nlonb*2
!
!     set minimum unsaved work space required by trssph
!
         Lwkmin = iw + MAX0(lwk3,lwk4)
!
!     set error flags if saved or unsaved work spaces are insufficient
!
         Ier = 10
         IF ( Lsave<Lsvmin ) RETURN
         Ier = 11
         IF ( Lwork<Lwkmin ) RETURN
         Ier = 13
         nlat = MAX0(Nlata,Nlatb)
         IF ( Ldwork<nlat*(nlat+4) ) RETURN
         Ier = 0
         IF ( igrda==1 ) THEN
!
!     initialize wsave for equally spaced analysis
!
            CALL SHAECI(Nlata,Nlona,Wsave,lwa,Dwork,Ldwork,Ier)
         ELSE
!
!     initialize wsave for gaussian analysis
!
            CALL SHAGCI(Nlata,Nlona,Wsave,lwa,Dwork,Ldwork,Ier)
            IF ( Ier/=0 ) THEN
!
!     flag failure in spherepack gaussian software
!
               Ier = 12
               RETURN
            ENDIF
         ENDIF
 
         IF ( igrdb==2 ) THEN
!
!     initialize wsave for gaussian synthesis
!
            CALL SHSGCI(Nlatb,Nlonb,Wsave(jb),lwb,Dwork,Ldwork,Ier)
            IF ( Ier/=0 ) THEN
!
!     flag failure in spherepack gaussian software
!
               Ier = 12
               RETURN
            ENDIF
         ELSE
!
!     initialize wsave for equally spaced synthesis
!
            CALL SHSECI(Nlatb,Nlonb,Wsave(jb),lwb,Dwork,Ldwork,Ier)
         ENDIF
!
!     end of initialization (intl=0) call
!
      ENDIF
!
!     transpose and/or reorder (co)latitude if necessary for da
!     (arrays must have latitude (colatitude) as the first dimension
!     and run north to south for spherepack software)
!
      IF ( Igrida(2)==0 ) CALL TRSPLAT(Nlona,Nlata,Da,Work)
      IF ( Igrida(1)>0 ) CALL CONVLAT(Nlata,Nlona,Da)
 
      nt = 1
      isym = 0
      IF ( igrda==2 ) THEN
!
!     do spherical harmonic analysis of "adjusted" da on gaussian grid
!
         CALL SHAGC(Nlata,Nlona,isym,nt,Da,Nlata,Nlona,Work(iaa),       &
                  & Work(iba),la1,Nlata,Wsave,lwa,Work(iw),lw,Ier)
      ELSE
!
!     do spherical harmonic analysis of "adjusted" da on equally spaced grid
!
         CALL SHAEC(Nlata,Nlona,isym,nt,Da,Nlata,Nlona,Work(iaa),       &
                  & Work(iba),la1,Nlata,Wsave,lwa,Work(iw),lw,Ier)
      ENDIF
!
!     transfer da grid coefficients to db grid coefficients
!     truncating to zero as necessary
!
      CALL TRAB(la1,Nlata,Work(iaa),Work(iba),lb1,Nlatb,Work(iab),      &
              & Work(ibb))
 
      IF ( igrdb==1 ) THEN
!
!     do spherical harmonic synthesis on nlatb by nlonb equally spaced grid
!
         CALL SHSEC(Nlatb,Nlonb,isym,nt,Db,Nlatb,Nlonb,Work(iab),       &
                  & Work(ibb),lb1,Nlatb,Wsave(jb),lwb,Work(iw),lw,Ier)
      ELSE
!
!     do spherical harmonic synthesis on nlatb by nlonb gaussian grid
!
         CALL SHSGC(Nlatb,Nlonb,isym,nt,Db,Nlatb,Nlonb,Work(iab),       &
                  & Work(ibb),lb1,Nlatb,Wsave(jb),lwb,Work(iw),lw,Ier)
      ENDIF
!
!     both da,db are currently latitude by longitude north to south arrays
!     restore da and set db to agree with flags in igrida and igridb
!
      IF ( Igrida(1)>0 ) CALL CONVLAT(Nlata,Nlona,Da)
      IF ( Igridb(1)>0 ) CALL CONVLAT(Nlatb,Nlonb,Db)
      IF ( Igrida(2)==0 ) CALL TRSPLAT(Nlata,Nlona,Da,Work)
      IF ( Igridb(2)==0 ) CALL TRSPLAT(Nlatb,Nlonb,Db,Work)
    END SUBROUTINE TRSSPH
    
    
    SUBROUTINE TRAB(Ma,Na,Aa,Ba,Mb,Nb,Ab,Bb)
      IMPLICIT NONE
      INTEGER Ma , Na , Mb , Nb , i , j , m , n
      REAL Aa(Ma,Na) , Ba(Ma,Na) , Ab(Mb,Nb) , Bb(Mb,Nb)
!
!     set coefficients for b grid from coefficients for a grid
!
      m = MIN0(Ma,Mb)
      n = MIN0(Na,Nb)
      DO j = 1 , n
         DO i = 1 , m
            Ab(i,j) = Aa(i,j)
            Bb(i,j) = Ba(i,j)
         ENDDO
      ENDDO
!
!     set coefs outside triangle to zero
!
      DO i = m + 1 , Mb
         DO j = 1 , Nb
            Ab(i,j) = 0.0
            Bb(i,j) = 0.0
         ENDDO
      ENDDO
      DO j = n + 1 , Nb
         DO i = 1 , Mb
            Ab(i,j) = 0.0
            Bb(i,j) = 0.0
         ENDDO
      ENDDO
    END SUBROUTINE TRAB
      
    SUBROUTINE TRSPLAT(N,M,Data,Work)
!
!     transpose the n by m array data to a m by n array data
!     work must be at least n*m words long
!
      IMPLICIT NONE
!*--TRSPLAT721
      INTEGER N , M , i , j , ij , ji
      REAL Data(*) , Work(*)
      DO j = 1 , M
         DO i = 1 , N
            ij = (j-1)*N + i
            Work(ij) = Data(ij)
         ENDDO
      ENDDO
      DO i = 1 , N
         DO j = 1 , M
            ji = (i-1)*M + j
            ij = (j-1)*N + i
            Data(ji) = Work(ij)
         ENDDO
      ENDDO
    END SUBROUTINE TRSPLAT

    
      SUBROUTINE CONVLAT(Nlat,Nlon,Data)
!
!     reverse order of latitude (colatitude) grids
!
      IMPLICIT NONE
!*--CONVLAT745
      INTEGER Nlat , Nlon , nlat2 , i , ib , j
      REAL Data(Nlat,Nlon) , temp
      nlat2 = Nlat/2
      DO i = 1 , nlat2
         ib = Nlat - i + 1
         DO j = 1 , Nlon
            temp = Data(i,j)
            Data(i,j) = Data(ib,j)
            Data(ib,j) = temp
         ENDDO
      ENDDO
      END SUBROUTINE CONVLAT


      
      SUBROUTINE DTRSSPH(Intl,Igrida,Nlona,Nlata,Da,Igridb,Nlonb,Nlatb,  &
                      & Db,Wsave,Lsave,Lsvmin,Work,Lwork,Lwkmin,Dwork,  &
                      & Ldwork,Ier)
      IMPLICIT NONE
!*--TRSSPH468
      INTEGER Intl , Igrida(2) , Nlona , Nlata , Igridb(2) , Nlonb ,    &
            & Nlatb
      INTEGER Lsave , Lsvmin , Lwork , Lwkmin , Ldwork , Ier
      DOUBLE PRECISION Da(*) , Db(*) , Wsave(*) , Work(*)
      DOUBLE PRECISION Dwork(*)
      INTEGER ig , igrda , igrdb , la1 , la2 , lb1 , lb2 , lwa , lwb ,  &
            & iaa , iab , iba , ibb
      INTEGER lwk3 , lwk4 , lw , iw , jb , nt , isym , nlat
!
!     include a save statement to ensure local variables in trssph, set during
!     an intl=0 call, are preserved if trssph is recalled with intl=1
!
      SAVE 
!
!     check input arguments
!
      Ier = 1
      IF ( Intl*(Intl-1)/=0 ) RETURN
      Ier = 2
      ig = Igrida(1)
      IF ( (ig-1)*(ig+1)*(ig-2)*(ig+2)/=0 ) RETURN
      Ier = 3
      ig = Igrida(2)
      IF ( ig*(ig-1)/=0 ) RETURN
      Ier = 4
      IF ( Nlona<4 ) RETURN
      Ier = 5
      IF ( Nlata<3 ) RETURN
      Ier = 6
      ig = Igridb(1)
      IF ( (ig-1)*(ig+1)*(ig-2)*(ig+2)/=0 ) RETURN
      Ier = 7
      ig = Igridb(2)
      IF ( ig*(ig-1)/=0 ) RETURN
      Ier = 8
      IF ( Nlonb<4 ) RETURN
      Ier = 9
      IF ( Nlatb<3 ) RETURN
      Ier = 0
 
      igrda = IABS(Igrida(1))
      igrdb = IABS(Igridb(1))
      IF ( Intl==0 ) THEN
         la1 = MIN0(Nlata,(Nlona+2)/2)
         la2 = (Nlata+1)/2
         lb1 = MIN0(Nlatb,(Nlonb+2)/2)
         lb2 = (Nlatb+1)/2
!
!     set saved work space length for analysis
!
         IF ( igrda==1 ) THEN
!
!     saved space for analysis on  equally spaced grid
!
            lwa = 2*Nlata*la2 + 3*((la1-2)*(Nlata+Nlata-la1-1))         &
                & /2 + Nlona + 15
         ELSE
!
!     saved space for analysis on gaussian grid
!
            lwa = Nlata*(2*la2+3*la1-2) + 3*la1*(1-la1)/2 + Nlona + 15
         ENDIF
!
!     set wsave pointer
!
         jb = 1 + lwa
!
!     set pointers for spherical harmonic coefs
!
         iaa = 1
         iba = iaa + la1*Nlata
         iab = iba + la1*Nlata
         IF ( igrdb==2 ) THEN
!
!     set saved work space length for gaussian synthesis
!
            lwb = Nlatb*(2*lb2+3*lb1-2) + 3*lb1*(1-lb1)/2 + Nlonb + 15
         ELSE
!
!     set saved work space length for equally spaced synthesis
!
            lwb = 2*Nlatb*lb2 + 3*((lb1-2)*(Nlatb+Nlatb-lb1-1))         &
                & /2 + Nlonb + 15
         ENDIF
!
!     set minimum saved work space length
!
         Lsvmin = lwa + lwb
!
!     set remaining harmonic pointer
!
         ibb = iab + lb1*Nlatb
!
!     set pointers for remaining work
!
         iw = ibb + lb1*Nlatb
!
!     set remaining work space length in lw
!
         lw = Lwork - iw
         lwk3 = Nlata*Nlona*2
         lwk4 = Nlatb*Nlonb*2
!
!     set minimum unsaved work space required by trssph
!
         Lwkmin = iw + MAX0(lwk3,lwk4)
!
!     set error flags if saved or unsaved work spaces are insufficient
!
         Ier = 10
         IF ( Lsave<Lsvmin ) RETURN
         Ier = 11
         IF ( Lwork<Lwkmin ) RETURN
         Ier = 13
         nlat = MAX0(Nlata,Nlatb)
         IF ( Ldwork<nlat*(nlat+4) ) RETURN
         Ier = 0
         IF ( igrda==1 ) THEN
!
!     initialize wsave for equally spaced analysis
!
            CALL DSHAECI(Nlata,Nlona,Wsave,lwa,Dwork,Ldwork,Ier)
         ELSE
!
!     initialize wsave for gaussian analysis
!
            CALL DSHAGCI(Nlata,Nlona,Wsave,lwa,Dwork,Ldwork,Ier)
            IF ( Ier/=0 ) THEN
!
!     flag failure in spherepack gaussian software
!
               Ier = 12
               RETURN
            ENDIF
         ENDIF
 
         IF ( igrdb==2 ) THEN
!
!     initialize wsave for gaussian synthesis
!
            CALL DSHSGCI(Nlatb,Nlonb,Wsave(jb),lwb,Dwork,Ldwork,Ier)
            IF ( Ier/=0 ) THEN
!
!     flag failure in spherepack gaussian software
!
               Ier = 12
               RETURN
            ENDIF
         ELSE
!
!     initialize wsave for equally spaced synthesis
!
            CALL DSHSECI(Nlatb,Nlonb,Wsave(jb),lwb,Dwork,Ldwork,Ier)
         ENDIF
!
!     end of initialization (intl=0) call
!
      ENDIF
!
!     transpose and/or reorder (co)latitude if necessary for da
!     (arrays must have latitude (colatitude) as the first dimension
!     and run north to south for spherepack software)
!
      IF ( Igrida(2)==0 ) CALL DTRSPLAT(Nlona,Nlata,Da,Work)
      IF ( Igrida(1)>0 ) CALL DCONVLAT(Nlata,Nlona,Da)
 
      nt = 1
      isym = 0
      IF ( igrda==2 ) THEN
!
!     do spherical harmonic analysis of "adjusted" da on gaussian grid
!
         CALL DSHAGC(Nlata,Nlona,isym,nt,Da,Nlata,Nlona,Work(iaa),       &
                  & Work(iba),la1,Nlata,Wsave,lwa,Work(iw),lw,Ier)
      ELSE
!
!     do spherical harmonic analysis of "adjusted" da on equally spaced grid
!
         CALL DSHAEC(Nlata,Nlona,isym,nt,Da,Nlata,Nlona,Work(iaa),       &
                  & Work(iba),la1,Nlata,Wsave,lwa,Work(iw),lw,Ier)
      ENDIF
!
!     transfer da grid coefficients to db grid coefficients
!     truncating to zero as necessary
!
      CALL DTRAB(la1,Nlata,Work(iaa),Work(iba),lb1,Nlatb,Work(iab),      &
              & Work(ibb))
 
      IF ( igrdb==1 ) THEN
!
!     do spherical harmonic synthesis on nlatb by nlonb equally spaced grid
!
         CALL DSHSEC(Nlatb,Nlonb,isym,nt,Db,Nlatb,Nlonb,Work(iab),       &
                  & Work(ibb),lb1,Nlatb,Wsave(jb),lwb,Work(iw),lw,Ier)
      ELSE
!
!     do spherical harmonic synthesis on nlatb by nlonb gaussian grid
!
         CALL DSHSGC(Nlatb,Nlonb,isym,nt,Db,Nlatb,Nlonb,Work(iab),       &
                  & Work(ibb),lb1,Nlatb,Wsave(jb),lwb,Work(iw),lw,Ier)
      ENDIF
!
!     both da,db are currently latitude by longitude north to south arrays
!     restore da and set db to agree with flags in igrida and igridb
!
      IF ( Igrida(1)>0 ) CALL DCONVLAT(Nlata,Nlona,Da)
      IF ( Igridb(1)>0 ) CALL DCONVLAT(Nlatb,Nlonb,Db)
      IF ( Igrida(2)==0 ) CALL DTRSPLAT(Nlata,Nlona,Da,Work)
      IF ( Igridb(2)==0 ) CALL DTRSPLAT(Nlatb,Nlonb,Db,Work)
    END SUBROUTINE DTRSSPH
    
    
    SUBROUTINE DTRAB(Ma,Na,Aa,Ba,Mb,Nb,Ab,Bb)
      IMPLICIT NONE
      INTEGER Ma , Na , Mb , Nb , i , j , m , n
      DOUBLE PRECISION Aa(Ma,Na) , Ba(Ma,Na) , Ab(Mb,Nb) , Bb(Mb,Nb)
!
!     set coefficients for b grid from coefficients for a grid
!
      m = MIN0(Ma,Mb)
      n = MIN0(Na,Nb)
      DO j = 1 , n
         DO i = 1 , m
            Ab(i,j) = Aa(i,j)
            Bb(i,j) = Ba(i,j)
         ENDDO
      ENDDO
!
!     set coefs outside triangle to zero
!
      DO i = m + 1 , Mb
         DO j = 1 , Nb
            Ab(i,j) = 0.0
            Bb(i,j) = 0.0
         ENDDO
      ENDDO
      DO j = n + 1 , Nb
         DO i = 1 , Mb
            Ab(i,j) = 0.0
            Bb(i,j) = 0.0
         ENDDO
      ENDDO
    END SUBROUTINE DTRAB


    
    SUBROUTINE DTRSPLAT(N,M,Data,Work)
!
!     transpose the n by m array data to a m by n array data
!     work must be at least n*m words long
!
      IMPLICIT NONE
!*--TRSPLAT721
      INTEGER N , M , i , j , ij , ji
      DOUBLE PRECISION Data(*) , Work(*)
      DO j = 1 , M
         DO i = 1 , N
            ij = (j-1)*N + i
            Work(ij) = Data(ij)
         ENDDO
      ENDDO
      DO i = 1 , N
         DO j = 1 , M
            ji = (i-1)*M + j
            ij = (j-1)*N + i
            Data(ji) = Work(ij)
         ENDDO
      ENDDO
    END SUBROUTINE DTRSPLAT

    
    SUBROUTINE DCONVLAT(Nlat,Nlon,Data)
!
!     reverse order of latitude (colatitude) grids
!
      IMPLICIT NONE

      INTEGER Nlat , Nlon , nlat2 , i , ib , j
      DOUBLE PRECISION Data(Nlat,Nlon) , temp
      nlat2 = Nlat/2
      DO i = 1 , nlat2
         ib = Nlat - i + 1
         DO j = 1 , Nlon
            temp = Data(i,j)
            Data(i,j) = Data(ib,j)
            Data(ib,j) = temp
         ENDDO
      ENDDO
      END SUBROUTINE DCONVLAT

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file shigs.f
!
!     this file contains code and documentation for subroutine shigs
!
! ... files which must be loaded with shigs.f
!
!     sphcom.f, hrfft.f, gaqd.f
!
!     3/6/98
!
! *** shigs is functionally the same as shagsi or shsgsi.  It
!     it included in spherepack3.0 because legacy codes, using
!     the older version of spherepack, call shigs to initialize
!     the saved work space wshigs for either shags or shsgs
!     Its arguments are identical to those of shagsi or shsgsi.
!
! ****************************************************************
!
!     subroutine shigs(nlat,nlon,wshigs,lshigs,work,lwork,dwork,ldwork,
!    +                 ierror)
!
!     subroutine shigs initializes the array wshigs which can then
!     be used repeatedly by subroutines shags,shsgs. it precomputes
!     and stores in wshigs quantities such as gaussian weights,
!     legendre polynomial coefficients, and fft trigonometric tables.
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are compu
!            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid poi
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than or equal to 4. the efficiency of the computation is
!            improved when nlon is a product of small prime numbers.
!
!     wshigs an array which must be initialized by subroutine shigs .
!            once initialized, wshigs can be used repeatedly by shigs
!            as long as nlat and nlon remain unchanged.  wshigs must
!            not be altered between calls of shigs.
!
!     lshigs the dimension of the array wshigs as it appears in the
!            program that calls shigs. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshigs must be at least
!
!            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
!
!     work   a real work space which need not be saved
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls shigs. lwork must be at least
!            4*nlat*(nlat+2)+2 in the routine calling shigs
!
!     dwork   a double precision work array that does not have to be saved.
!
!     ldwork  the length of dwork in the calling routine.  ldwork must
!             be at least nlat*(nlat+4)
!
!     output parameter
!
!     wshags an array which must be initialized before calling shags or
!            once initialized, wshags can be used repeatedly by shags or
!            as long as nlat and nlon remain unchanged.  wshags must not
!            altered between calls of shasc.
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of lshags
!            = 4  error in the specification of lwork
!            = 5  error in the specification of ldwork
!            = 6  failure in gaqd to compute gaussian points
!                 (due to failure in eigenvalue routine)
!
!
! ****************************************************************
!
      SUBROUTINE SHIGS(Nlat,Nlon,Wshigs,Lshigs,Work,Lwork,Dwork,Ldwork, &
                     & Ierror)
      IMPLICIT NONE
      INTEGER Ierror , ipmnf , l , l1 , l2 , late , Ldwork , lp ,       &
            & Lshigs , Lwork , Nlat , Nlon
      REAL Work , Wshigs
!
!     this subroutine must be called before calling shags or shsgs with
!     fixed nlat,nlon. it precomputes the gaussian weights, points
!     and all necessary legendre polys and stores them in wshigs.
!     these quantities must be preserved when calling shsgs or shags
!     repeatedly with fixed nlat,nlon.
!
      DIMENSION Wshigs(Lshigs) , Work(Lwork)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+1)/2
      l1 = l
      l2 = late
!     check permanent work space length
      Ierror = 3
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshigs<lp ) RETURN
      Ierror = 4
!     check temporary work space
      IF ( Lwork<4*Nlat*(Nlat+2)+2 ) RETURN
!     check temp double precision space
      Ierror = 5
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set preliminary quantites needed to compute and store legendre polys
      CALL SHIGSP(Nlat,Nlon,Wshigs,Lshigs,Dwork,Ldwork,Ierror)
      IF ( Ierror/=0 ) RETURN
!     set legendre poly pointer in wshigs
      ipmnf = Nlat + 2*Nlat*late + 3*(l*(l-1)/2+(Nlat-l)*(l-1))         &
            & + Nlon + 16
      CALL SHIGSS1(Nlat,l,late,Wshigs,Work,Wshigs(ipmnf))
    END SUBROUTINE SHIGS

      
      SUBROUTINE SHIGSS1(Nlat,L,Late,W,Pmn,Pmnf)
      IMPLICIT NONE
      INTEGER i , j , k , km , L , Late , m , mml1 , mn , mode , mp1 ,  &
            & Nlat , np1
      REAL Pmn , Pmnf , W
      DIMENSION W(1) , Pmn(Nlat,Late,3) , Pmnf(Late,1)
!     compute and store legendre polys for i=1,...,late,m=0,...,l-1
!     and n=m,...,l-1
      DO i = 1 , Nlat
         DO j = 1 , Late
            DO k = 1 , 3
               Pmn(i,j,k) = 0.0
            ENDDO
         ENDDO
      ENDDO
      DO mp1 = 1 , L
         m = mp1 - 1
         mml1 = m*(2*Nlat-m-1)/2
!     compute pmn for n=m,...,nlat-1 and i=1,...,(l+1)/2
         mode = 0
         CALL LEGIN(mode,L,Nlat,m,W,Pmn,km)
!     store above in pmnf
         DO np1 = mp1 , Nlat
            mn = mml1 + np1
            DO i = 1 , Late
               Pmnf(i,mn) = Pmn(np1,i,km)
            ENDDO
         ENDDO
      ENDDO
      END SUBROUTINE SHIGSS1


      SUBROUTINE SHIGSP(Nlat,Nlon,Wshigs,Lshigs,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER i1 , i2 , i3 , i4 , i5 , i6 , i7 , idth , idwts , Ierror ,&
            & iw , l , l1 , l2 , late , Ldwork , Lshigs , Nlat , Nlon
      REAL Wshigs
      DIMENSION Wshigs(Lshigs)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+MOD(Nlat,2))/2
      l1 = l
      l2 = late
      Ierror = 3
!     check permanent work space length
      IF ( Lshigs<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 4
!     if (lwork.lt.4*nlat*(nlat+2)+2) return
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set pointers
      i1 = 1
      i2 = i1 + Nlat
      i3 = i2 + Nlat*late
      i4 = i3 + Nlat*late
      i5 = i4 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i6 = i5 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i7 = i6 + l*(l-1)/2 + (Nlat-l)*(l-1)
!     set indices in temp work for double precision gaussian wts and pts
      idth = 1
!     idwts = idth+2*nlat
!     iw = idwts+2*nlat
      idwts = idth + Nlat
      iw = idwts + Nlat
      CALL SHIGSP1(Nlat,Nlon,l,late,Wshigs(i1),Wshigs(i2),Wshigs(i3),   &
                 & Wshigs(i4),Wshigs(i5),Wshigs(i6),Wshigs(i7),         &
                 & Dwork(idth),Dwork(idwts),Dwork(iw),Ierror)
      IF ( Ierror/=0 ) Ierror = 5
      END SUBROUTINE SHIGSP

      
      SUBROUTINE SHIGSP1(Nlat,Nlon,L,Late,Wts,P0n,P1n,Abel,Bbel,Cbel,   &
                       & Wfft,Dtheta,Dwts,Work,Ier)
      IMPLICIT NONE
      REAL Abel , Bbel , Cbel , P0n , P1n , Wfft , Wts
      INTEGER i , Ier , imn , IMNDX , INDX , L , Late , lw , m , mlim , &
            & n , Nlat , Nlon , np1
      DIMENSION Wts(Nlat) , P0n(Nlat,Late) , P1n(Nlat,Late) , Abel(1) , &
              & Bbel(1) , Cbel(1) , Wfft(1) , Dtheta(Nlat) , Dwts(Nlat)
      DOUBLE PRECISION pb , Dtheta , Dwts , Work(*)
      INDX(m,n) = (n-1)*(n-2)/2 + m - 1
      IMNDX(m,n) = L*(L-1)/2 + (n-L-1)*(L-1) + m - 1
      CALL HRFFTI(Nlon,Wfft)
!     compute double precision gaussian points and weights
!     lw = 4*nlat*(nlat+2)
      lw = Nlat*(Nlat+2)
      CALL GAQD(Nlat,Dtheta,Dwts,Work,lw,Ier)
      IF ( Ier/=0 ) RETURN
!     store gaussian weights single precision to save computation
!     in inner loops in analysis
      DO i = 1 , Nlat
         Wts(i) = Dwts(i)
      ENDDO
!     initialize p0n,p1n using double precision dnlfk,dnlft
      DO np1 = 1 , Nlat
         DO i = 1 , Late
            P0n(np1,i) = 0.0
            P1n(np1,i) = 0.0
         ENDDO
      ENDDO
!     compute m=n=0 legendre polynomials for all theta(i)
      np1 = 1
      n = 0
      m = 0
      CALL DNLFK(m,n,Work)
      DO i = 1 , Late
         CALL DNLFT(m,n,Dtheta(i),Work,pb)
         P0n(1,i) = pb
      ENDDO
!     compute p0n,p1n for all theta(i) when n.gt.0
      DO np1 = 2 , Nlat
         n = np1 - 1
         m = 0
         CALL DNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DNLFT(m,n,Dtheta(i),Work,pb)
            P0n(np1,i) = pb
         ENDDO
!     compute m=1 legendre polynomials for all n and theta(i)
         m = 1
         CALL DNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DNLFT(m,n,Dtheta(i),Work,pb)
            P1n(np1,i) = pb
         ENDDO
      ENDDO
!
!     compute and store swarztrauber recursion coefficients
!     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      DO n = 2 , Nlat
         mlim = MIN0(n,L)
         DO m = 2 , mlim
            imn = INDX(m,n)
            IF ( n>=L ) imn = IMNDX(m,n)
            Abel(imn) = SQRT(FLOAT((2*n+1)*(m+n-2)*(m+n-3))/FLOAT(((2*n-&
                      & 3)*(m+n-1)*(m+n))))
            Bbel(imn) = SQRT(FLOAT((2*n+1)*(n-m-1)*(n-m))/FLOAT(((2*n-3)&
                      & *(m+n-1)*(m+n))))
            Cbel(imn) = SQRT(FLOAT((n-m+1)*(n-m+2))/FLOAT(((n+m-1)*(n+m)&
                      & )))
         ENDDO
      ENDDO
      END SUBROUTINE SHIGSP1

      SUBROUTINE DSHIGS(Nlat,Nlon,Wshigs,Lshigs,Work,Lwork,Dwork,Ldwork, &
                     & Ierror)
      IMPLICIT NONE
      INTEGER Ierror , ipmnf , l , l1 , l2 , late , Ldwork , lp ,       &
            & Lshigs , Lwork , Nlat , Nlon
      DOUBLE PRECISION Work , Wshigs
!
!     this subroutine must be called before calling shags or shsgs with
!     fixed nlat,nlon. it precomputes the gaussian weights, points
!     and all necessary legendre polys and stores them in wshigs.
!     these quantities must be preserved when calling shsgs or shags
!     repeatedly with fixed nlat,nlon.
!
      DIMENSION Wshigs(Lshigs) , Work(Lwork)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+1)/2
      l1 = l
      l2 = late
!     check permanent work space length
      Ierror = 3
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshigs<lp ) RETURN
      Ierror = 4
!     check temporary work space
      IF ( Lwork<4*Nlat*(Nlat+2)+2 ) RETURN
!     check temp double precision space
      Ierror = 5
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set preliminary quantites needed to compute and store legendre polys
      CALL DSHIGSP(Nlat,Nlon,Wshigs,Lshigs,Dwork,Ldwork,Ierror)
      IF ( Ierror/=0 ) RETURN
!     set legendre poly pointer in wshigs
      ipmnf = Nlat + 2*Nlat*late + 3*(l*(l-1)/2+(Nlat-l)*(l-1))         &
            & + Nlon + 16
      CALL DSHIGSS1(Nlat,l,late,Wshigs,Work,Wshigs(ipmnf))
    END SUBROUTINE DSHIGS

      
      SUBROUTINE DSHIGSS1(Nlat,L,Late,W,Pmn,Pmnf)
      IMPLICIT NONE
      INTEGER i , j , k , km , L , Late , m , mml1 , mn , mode , mp1 ,  &
            & Nlat , np1
      DOUBLE PRECISION Pmn , Pmnf , W
      DIMENSION W(1) , Pmn(Nlat,Late,3) , Pmnf(Late,1)
!     compute and store legendre polys for i=1,...,late,m=0,...,l-1
!     and n=m,...,l-1
      DO i = 1 , Nlat
         DO j = 1 , Late
            DO k = 1 , 3
               Pmn(i,j,k) = 0.0
            ENDDO
         ENDDO
      ENDDO
      DO mp1 = 1 , L
         m = mp1 - 1
         mml1 = m*(2*Nlat-m-1)/2
!     compute pmn for n=m,...,nlat-1 and i=1,...,(l+1)/2
         mode = 0
         CALL DLEGIN(mode,L,Nlat,m,W,Pmn,km)
!     store above in pmnf
         DO np1 = mp1 , Nlat
            mn = mml1 + np1
            DO i = 1 , Late
               Pmnf(i,mn) = Pmn(np1,i,km)
            ENDDO
         ENDDO
      ENDDO
      END SUBROUTINE DSHIGSS1


      SUBROUTINE DSHIGSP(Nlat,Nlon,Wshigs,Lshigs,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER i1 , i2 , i3 , i4 , i5 , i6 , i7 , idth , idwts , Ierror ,&
            & iw , l , l1 , l2 , late , Ldwork , Lshigs , Nlat , Nlon
      DOUBLE PRECISION Wshigs
      DIMENSION Wshigs(Lshigs)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+MOD(Nlat,2))/2
      l1 = l
      l2 = late
      Ierror = 3
!     check permanent work space length
      IF ( Lshigs<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 4
!     if (lwork.lt.4*nlat*(nlat+2)+2) return
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set pointers
      i1 = 1
      i2 = i1 + Nlat
      i3 = i2 + Nlat*late
      i4 = i3 + Nlat*late
      i5 = i4 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i6 = i5 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i7 = i6 + l*(l-1)/2 + (Nlat-l)*(l-1)
!     set indices in temp work for double precision gaussian wts and pts
      idth = 1
!     idwts = idth+2*nlat
!     iw = idwts+2*nlat
      idwts = idth + Nlat
      iw = idwts + Nlat
      CALL DSHIGSP1(Nlat,Nlon,l,late,Wshigs(i1),Wshigs(i2),Wshigs(i3),   &
                 & Wshigs(i4),Wshigs(i5),Wshigs(i6),Wshigs(i7),         &
                 & Dwork(idth),Dwork(idwts),Dwork(iw),Ierror)
      IF ( Ierror/=0 ) Ierror = 5
      END SUBROUTINE DSHIGSP

      
      SUBROUTINE DSHIGSP1(Nlat,Nlon,L,Late,Wts,P0n,P1n,Abel,Bbel,Cbel,   &
                       & Wfft,Dtheta,Dwts,Work,Ier)
      IMPLICIT NONE
      DOUBLE PRECISION Abel , Bbel , Cbel , P0n , P1n , Wfft , Wts
      INTEGER i , Ier , imn , IMNDX , INDX , L , Late , lw , m , mlim , &
            & n , Nlat , Nlon , np1
      DIMENSION Wts(Nlat) , P0n(Nlat,Late) , P1n(Nlat,Late) , Abel(1) , &
              & Bbel(1) , Cbel(1) , Wfft(1) , Dtheta(Nlat) , Dwts(Nlat)
      DOUBLE PRECISION pb , Dtheta , Dwts , Work(*)
      INDX(m,n) = (n-1)*(n-2)/2 + m - 1
      IMNDX(m,n) = L*(L-1)/2 + (n-L-1)*(L-1) + m - 1
      CALL DHRFFTI(Nlon,Wfft)
!     compute double precision gaussian points and weights
!     lw = 4*nlat*(nlat+2)
      lw = Nlat*(Nlat+2)
      CALL DGAQD(Nlat,Dtheta,Dwts,Work,lw,Ier)
      IF ( Ier/=0 ) RETURN
!     store gaussian weights single precision to save computation
!     in inner loops in analysis
      DO i = 1 , Nlat
         Wts(i) = Dwts(i)
      ENDDO
!     initialize p0n,p1n using double precision dnlfk,dnlft
      DO np1 = 1 , Nlat
         DO i = 1 , Late
            P0n(np1,i) = 0.0
            P1n(np1,i) = 0.0
         ENDDO
      ENDDO
!     compute m=n=0 legendre polynomials for all theta(i)
      np1 = 1
      n = 0
      m = 0
      CALL DDNLFK(m,n,Work)
      DO i = 1 , Late
         CALL DDNLFT(m,n,Dtheta(i),Work,pb)
         P0n(1,i) = pb
      ENDDO
!     compute p0n,p1n for all theta(i) when n.gt.0
      DO np1 = 2 , Nlat
         n = np1 - 1
         m = 0
         CALL DDNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DDNLFT(m,n,Dtheta(i),Work,pb)
            P0n(np1,i) = pb
         ENDDO
!     compute m=1 legendre polynomials for all n and theta(i)
         m = 1
         CALL DDNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DDNLFT(m,n,Dtheta(i),Work,pb)
            P1n(np1,i) = pb
         ENDDO
      ENDDO
!
!     compute and store swarztrauber recursion coefficients
!     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      DO n = 2 , Nlat
         mlim = MIN0(n,L)
         DO m = 2 , mlim
            imn = INDX(m,n)
            IF ( n>=L ) imn = IMNDX(m,n)
            Abel(imn) = SQRT(FLOAT((2*n+1)*(m+n-2)*(m+n-3))/FLOAT(((2*n-&
                      & 3)*(m+n-1)*(m+n))))
            Bbel(imn) = SQRT(FLOAT((2*n+1)*(n-m-1)*(n-m))/FLOAT(((2*n-3)&
                      & *(m+n-1)*(m+n))))
            Cbel(imn) = SQRT(FLOAT((n-m+1)*(n-m+2))/FLOAT(((n+m-1)*(n+m)&
                      & )))
         ENDDO
      ENDDO
      END SUBROUTINE DSHIGSP1

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file vlapgs.f
c
c     this file includes documentation and code for
c     subroutine vlapgs          i
c
c ... files which must be loaded with vlapgs.f
c
c     sphcom.f, hrfft.f, vhags.f, vhsgs.f, gaqd.f
c
c
c
c     subroutine vlapgs(nlat,nlon,ityp,nt,vlap,wlap,idvw,jdvw,br,bi,cr,ci,
c    +mdbc,ndbc,wvhsgs,lvhsgs,work,lwork,ierror)
c
c     given the vector spherical harmonic coefficients (br,bi,cr,ci)
c     precomputed by subroutine vhags for a vector field (v,w), subroutine
c     vlapgs computes the vector laplacian of the vector field (v,w)
c     in (vlap,wlap) (see the definition of the vector laplacian at
c     the output parameter description of vlap,wlap below).  w and wlap
c     are east longitudinal components of the vectors.  v and vlap are
c     colatitudinal components of the vectors.  the laplacian components
c     in (vlap,wlap) have the same symmetry or lack of symmetry about the
c     equator as (v,w).  the input parameters ityp,nt,mdbc,nbdc must have
c     the same values used by vhags to compute br,bi,cr, and ci for (v,w).
c     vlap(i,j) and wlap(i,j) are given on the sphere at the gaussian
c     colatitude theta(i) (see nlat as input parameter) and east longitude
c     lambda(j) = (j-1)*2*pi/nlon for i=1,...,nlat and j=1,...,nlon.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are computed
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct longitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     ityp   this parameter should have the same value input to subroutine
c            vhags to compute the coefficients br,bi,cr, and ci for the
c            vector field (v,w).  ityp is set as follows:
c
c            = 0  no symmetries exist in (v,w) about the equator. (vlap,wlap)
c                 is computed and stored on the entire sphere in the arrays
c                 vlap(i,j) and wlap(i,j) for i=1,...,nlat and j=1,...,nlon.
c
c
c            = 1  no symmetries exist in (v,w) about the equator. (vlap,wlap)
c                 is computed and stored on the entire sphere in the arrays
c                 vlap(i,j) and wlap(i,j) for i=1,...,nlat and j=1,...,nlon.
c                 the vorticity of (v,w) is zero so the coefficients cr and
c                 ci are zero and are not used.  the vorticity of (vlap,wlap)
c                 is also zero.
c
c
c            = 2  no symmetries exist in (v,w) about the equator. (vlap,wlap)
c                 is computed and stored on the entire sphere in the arrays
c                 vlap(i,j) and wlap(i,j) for i=1,...,nlat and j=1,...,nlon.
c                 the divergence of (v,w) is zero so the coefficients br and
c                 bi are zero and are not used.  the divergence of (vlap,wlap)
c                 is also zero.
c
c            = 3  w is antisymmetric and v is symmetric about the equator.
c                 consequently wlap is antisymmetric and vlap is symmetric.
c                 (vlap,wlap) is computed and stored on the northern
c                 hemisphere only.  if nlat is odd, storage is in the arrays
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 4  w is antisymmetric and v is symmetric about the equator.
c                 consequently wlap is antisymmetric and vlap is symmetric.
c                 (vlap,wlap) is computed and stored on the northern
c                 hemisphere only.  if nlat is odd, storage is in the arrays
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
c                 vorticity of (v,w) is zero so the coefficients cr,ci are
c                 zero and are not used. the vorticity of (vlap,wlap) is
c                 also zero.
c
c            = 5  w is antisymmetric and v is symmetric about the equator.
c                 consequently wlap is antisymmetric and vlap is symmetric.
c                 (vlap,wlap) is computed and stored on the northern
c                 hemisphere only.  if nlat is odd, storage is in the arrays
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
c                 divergence of (v,w) is zero so the coefficients br,bi
c                 are zero and are not used. the divergence of (vlap,wlap)
c                 is also zero.
c
c
c            = 6  w is symmetric and v is antisymmetric about the equator.
c                 consequently wlap is symmetric and vlap is antisymmetric.
c                 (vlap,wlap) is computed and stored on the northern
c                 hemisphere only.  if nlat is odd, storage is in the arrays
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 7  w is symmetric and v is antisymmetric about the equator.
c                 consequently wlap is symmetric and vlap is antisymmetric.
c                 (vlap,wlap) is computed and stored on the northern
c                 hemisphere only.  if nlat is odd, storage is in the arrays
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
c                 vorticity of (v,w) is zero so the coefficients cr,ci are
c                 zero and are not used. the vorticity of (vlap,wlap) is
c                 also zero.
c
c            = 8  w is symmetric and v is antisymmetric about the equator.
c                 consequently wlap is symmetric and vlap is antisymmetric.
c                 (vlap,wlap) is computed and stored on the northern
c                 hemisphere only.  if nlat is odd, storage is in the arrays
c                 vlap(i,j),wlap(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even, storage is in the arrays vlap(i,j),
c                 wlap(i,j) for i=1,...,nlat/2 and j=1,...,nlon.  the
c                 divergence of (v,w) is zero so the coefficients br,bi
c                 are zero and are not used. the divergence of (vlap,wlap)
c                 is also zero.
c
c
c     nt     nt is the number of vector fields (v,w).  some computational
c            efficiency is obtained for multiple fields.  in the program
c            that calls vlapgs, the arrays vlap,wlap,br,bi,cr and ci
c            can be three dimensional corresponding to an indexed multiple
c            vector field.  in this case multiple vector synthesis will
c            be performed to compute the vector laplacian for each field.
c            the third index is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt=1.  the description
c            of the remaining parameters is simplified by assuming that nt=1
c            or that all arrays are two dimensional.
c
c   idvw     the first dimension of the arrays vlap and wlap as it appears
c            in the program that calls vlapgs.  if ityp=0,1, or 2  then idvw
c            must be at least nlat.  if ityp > 2 and nlat is even then idvw
c            must be at least nlat/2. if ityp > 2 and nlat is odd then idvw
c            must be at least (nlat+1)/2.
c
c   jdvw     the second dimension of the arrays vlap and wlap as it appears
c            in the program that calls vlapgs. jdvw must be at least nlon.
c
c
c   br,bi    two or three dimensional arrays (see input parameter nt)
c   cr,ci    that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhags.
c            br,bi,cr and ci must be computed by vhags prior to calling
c            vlapgs.  if ityp=1,4, or 7 then cr,ci are not used and can
c            be dummy arguments.  if ityp=2,5, or 8 then br,bi are not
c            used and can be dummy arguments.
c
c    mdbc    the first dimension of the arrays br,bi,cr and ci as it
c            appears in the program that calls vlapgs.  mdbc must be
c            at least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c    ndbc    the second dimension of the arrays br,bi,cr and ci as it
c            appears in the program that calls vlapgs. ndbc must be at
c            least nlat.
c
c    wvhsgs  an array which must be initialized by subroutine vlapgsi
c            (or equivalently by vhsgsi).  once initialized, wvhsgs
c            can be used repeatedly by vlapgs as long as nlat and nlon
c            remain unchanged.  wvhsgs must not be altered between calls
c            of vlapgs.
c
c     lvhsgs the dimension of the array wvhsgs as it appears in the
c            program that calls vlapgs.  define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhsgs must be at least
c
c                 l1*l2*(nlat+nlat-l1+1)+nlon+15+2*nlat
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls vlapgs. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            if ityp .le. 2 then
c
c               (2*nt+1)*nlat*nlon + nlat*(4*nt*l1+1)
c
c            or if ityp .gt. 2 then
c
c               (2*nt+1)*l2*nlon + nlat*(4*nt*l1+1)
c
c            will suffice as a length for lwork.
c
c     **************************************************************
c
c     output parameters
c
c
c    vlap,   two or three dimensional arrays (see input parameter nt) that
c    wlap    contain the vector laplacian of the field (v,w).  wlap(i,j) is
c            the east longitude component and vlap(i,j) is the colatitudinal
c            component of the vector laplacian.  the definition of the
c            vector laplacian follows:
c
c            let cost and sint be the cosine and sine at colatitude theta.
c            let d( )/dlambda  and d( )/dtheta be the first order partial
c            derivatives in longitude and colatitude.  let del2 be the scalar
c            laplacian operator
c
c                 del2(s) = [d(sint*d(s)/dtheta)/dtheta +
c                             2            2
c                            d (s)/dlambda /sint]/sint
c
c            then the vector laplacian opeator
c
c                 dvel2(v,w) = (vlap,wlap)
c
c            is defined by
c
c                 vlap = del2(v) - (2*cost*dw/dlambda + v)/sint**2
c
c                 wlap = del2(w) + (2*cost*dv/dlambda - w)/sint**2
c
c  ierror    a parameter which flags errors in input parameters as follows:
c
c            = 0  no errors detected
c
c            = 1  error in the specification of nlat
c
c            = 2  error in the specification of nlon
c
c            = 3  error in the specification of ityp
c
c            = 4  error in the specification of nt
c
c            = 5  error in the specification of idvw
c
c            = 6  error in the specification of jdvw
c
c            = 7  error in the specification of mdbc
c
c            = 8  error in the specification of ndbc
c
c            = 9  error in the specification of lvhsgs
c
c            = 10 error in the specification of lwork
c
c
c **********************************************************************
c                                                                              
c     end of documentation for vlapgs
c
c **********************************************************************
c
      subroutine vlapgs(nlat,nlon,ityp,nt,vlap,wlap,idvw,jdvw,br,bi,
     +cr,ci,mdbc,ndbc,wvhsgs,lvhsgs,work,lwork,ierror)
      dimension vlap(idvw,jdvw,nt),wlap(idvw,jdvw,nt)
      dimension br(mdbc,ndbc,nt),bi(mdbc,ndbc,nt)
      dimension cr(mdbc,ndbc,nt),ci(mdbc,ndbc,nt)
      dimension wvhsgs(lvhsgs),work(lwork)
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if(nlon .lt. 1) return
      ierror = 3
      if(ityp.lt.0 .or. ityp.gt.8) return
      ierror = 4
      if(nt .lt. 0) return
      ierror = 5
      imid = (nlat+1)/2
      if((ityp.le.2 .and. idvw.lt.nlat) .or.
     1   (ityp.gt.2 .and. idvw.lt.imid)) return
      ierror = 6
      if(jdvw .lt. nlon) return
      ierror = 7
      mmax = min0(nlat,(nlon+1)/2)
      if(mdbc .lt. mmax) return
      ierror = 8
      if(ndbc .lt. nlat) return
      ierror = 9
      idz = (mmax*(nlat+nlat-mmax+1))/2
      lzimn = idz*imid
      lsavmin = lzimn+lzimn+nlon+15
      if(lvhsgs .lt. lsavmin) return
c
c     verify unsaved work space length
c
      mn = mmax*nlat*nt
      l2 = (nlat+1)/2
      l1 = mmax
      if (ityp .le. 2) then
	lwkmin = (2*nt+1)*nlat*nlon + nlat*(4*nt*l1+1)
      else
	lwkmin = (2*nt+1)*l2*nlon + nlat*(4*nt*l1+1)
      end if
      if (lwork .lt. lwkmin) return
      ierror = 0
c
c     set work space pointers for vector laplacian coefficients
c
      if (ityp.eq.0 .or. ityp.eq.3 .or. ityp.eq.6) then
      ibr = 1
      ibi = ibr+mn
      icr = ibi+mn
      ici = icr+mn
      else if (ityp.eq.1 .or. ityp.eq.4 .or. ityp.eq.7) then
      ibr = 1
      ibi = ibr+mn
      icr = ibi+mn
      ici = icr
      else
      ibr = 1
      ibi = 1
      icr = ibi+mn
      ici = icr+mn
      end if
      ifn = ici + mn
      iwk = ifn + nlat
      liwk = lwork-4*mn-nlat
      call vlapgs1(nlat,nlon,ityp,nt,vlap,wlap,idvw,jdvw,work(ibr),
     +work(ibi),work(icr),work(ici),mmax,work(ifn),mdbc,ndbc,br,bi,
     +cr,ci,wvhsgs,lvhsgs,work(iwk),liwk,ierror)
      return
      end

      subroutine vlapgs1(nlat,nlon,ityp,nt,vlap,wlap,idvw,jdvw,brlap,
     +bilap,crlap,cilap,mmax,fnn,mdb,ndb,br,bi,cr,ci,wsave,lsave,
     +wk,lwk,ierror)
      dimension vlap(idvw,jdvw,nt),wlap(idvw,jdvw,nt)
      dimension fnn(nlat),brlap(mmax,nlat,nt),bilap(mmax,nlat,nt)
      dimension crlap(mmax,nlat,nt),cilap(mmax,nlat,nt)
      dimension br(mdb,ndb,nt),bi(mdb,ndb,nt)
      dimension cr(mdb,ndb,nt),ci(mdb,ndb,nt)
      dimension wsave(lsave),wk(lwk)
c
c     preset coefficient multiplyers
c
      do 1 n=2,nlat
      fn = float(n-1)
      fnn(n) = -fn*(fn+1.)
    1 continue
c
c     set laplacian coefficients from br,bi,cr,ci
c
      if (ityp.eq.0 .or. ityp.eq.3 .or. ityp.eq.6) then
c
c     all coefficients needed
c
      do 2 k=1,nt
      do 3 n=1,nlat
      do 4 m=1,mmax
      brlap(m,n,k) = 0.0
      bilap(m,n,k) = 0.0
      crlap(m,n,k) = 0.0
      cilap(m,n,k) = 0.0
    4 continue
    3 continue
      do 5 n=2,nlat
      brlap(1,n,k) = fnn(n)*br(1,n,k)
      bilap(1,n,k) = fnn(n)*bi(1,n,k)
      crlap(1,n,k) = fnn(n)*cr(1,n,k)
      cilap(1,n,k) = fnn(n)*ci(1,n,k)
    5 continue
      do 6 m=2,mmax
      do 7 n=m,nlat
      brlap(m,n,k) = fnn(n)*br(m,n,k)
      bilap(m,n,k) = fnn(n)*bi(m,n,k)
      crlap(m,n,k) = fnn(n)*cr(m,n,k)
      cilap(m,n,k) = fnn(n)*ci(m,n,k)
    7 continue
    6 continue
    2 continue
      else if (ityp.eq.1 .or. ityp.eq.4 .or. ityp.eq.7) then
c
c     vorticity is zero so cr,ci=0 not used
c
      do 12 k=1,nt
      do 13 n=1,nlat
      do 14 m=1,mmax
      brlap(m,n,k) = 0.0
      bilap(m,n,k) = 0.0
   14 continue
   13 continue
      do 15 n=2,nlat
      brlap(1,n,k) = fnn(n)*br(1,n,k)
      bilap(1,n,k) = fnn(n)*bi(1,n,k)
   15 continue
      do 16 m=2,mmax
      do 17 n=m,nlat
      brlap(m,n,k) = fnn(n)*br(m,n,k)
      bilap(m,n,k) = fnn(n)*bi(m,n,k)
   17 continue
   16 continue
   12 continue
      else
c
c     divergence is zero so br,bi=0 not used
c
      do 22 k=1,nt
      do 23 n=1,nlat
      do 24 m=1,mmax
      crlap(m,n,k) = 0.0
      cilap(m,n,k) = 0.0
   24 continue
   23 continue
      do 25 n=2,nlat
      crlap(1,n,k) = fnn(n)*cr(1,n,k)
      cilap(1,n,k) = fnn(n)*ci(1,n,k)
   25 continue
      do 26 m=2,mmax
      do 27 n=m,nlat
      crlap(m,n,k) = fnn(n)*cr(m,n,k)
      cilap(m,n,k) = fnn(n)*ci(m,n,k)
   27 continue
   26 continue
   22 continue
      end if
c
c     sythesize coefs into vector field (vlap,wlap)
c
      call vhsgs(nlat,nlon,ityp,nt,vlap,wlap,idvw,jdvw,brlap,bilap,
     +           crlap,cilap,mmax,nlat,wsave,lsave,wk,lwk,ierror)
      return
      end

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file shagc.f
c
c     this file contains code and documentation for subroutines
c     shagc and shagci
c
c ... files which must be loaded with shagc.f
c
c     sphcom.f, hrfft.f, gaqd.f
c
c
c     subroutine shagc(nlat,nlon,isym,nt,g,idg,jdg,a,b,mdab,ndab,
c    +                 wshagc,lshagc,work,lwork,ierror)
c
c     subroutine shagc performs the spherical harmonic analysis
c     on the array g and stores the result in the arrays a and b.
c     the analysis is performed on a gaussian grid in colatitude
c     and an equally spaced grid in longitude.  the associated
c     legendre functions are recomputed rather than stored as they
c     are in subroutine shags.  the analysis is described below
c     at output parameters a,b.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are compu
c            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid poi
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     isym   = 0  no symmetries exist about the equator. the analysis
c                 is performed on the entire sphere.  i.e. on the
c                 array g(i,j) for i=1,...,nlat and j=1,...,nlon.
c                 (see description of g below)
c
c            = 1  g is antisymmetric about the equator. the analysis
c                 is performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the analysis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the analysis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c
c            = 2  g is symmetric about the equator. the analysis is
c                 performed on the northern hemisphere only.  i.e.
c                 if nlat is odd the analysis is performed on the
c                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
c                 if nlat is even the analysis is performed on the
c                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
c
c     nt     the number of analyses.  in the program that calls shagc,
c            the arrays g,a and b can be three dimensional in which
c            case multiple analyses will be performed.  the third
c            index is the analysis index which assumes the values
c            k=1,...,nt.  for a single analysis set nt=1. the
c            discription of the remaining parameters is simplified
c            by assuming that nt=1 or that the arrays g,a and b
c            have only two dimensions.
c
c     g      a two or three dimensional array (see input parameter
c            nt) that contains the discrete function to be analyzed.
c            g(i,j) contains the value of the function at the gaussian
c            point theta(i) and longitude point phi(j) = (j-1)*2*pi/nlon
c            the index ranges are defined above at the input parameter
c            isym.
c
c     idg    the first dimension of the array g as it appears in the
c            program that calls shagc. if isym equals zero then idg
c            must be at least nlat.  if isym is nonzero then idg must
c            be at least nlat/2 if nlat is even or at least (nlat+1)/2
c            if nlat is odd.
c
c     jdg    the second dimension of the array g as it appears in the
c            program that calls shagc. jdg must be at least nlon.
c
c     mdab   the first dimension of the arrays a and b as it appears
c            in the program that calls shagc. mdab must be at least
c            min0((nlon+2)/2,nlat) if nlon is even or at least
c            min0((nlon+1)/2,nlat) if nlon is odd
c
c     ndab   the second dimension of the arrays a and b as it appears
c            in the program that calls shaec. ndab must be at least nlat
c
c     wshagc an array which must be initialized by subroutine shagci.
c            once initialized, wshagc can be used repeatedly by shagc.
c            as long as nlat and nlon remain unchanged.  wshagc must
c            not be altered between calls of shagc.
c
c     lshagc the dimension of the array wshagc as it appears in the
c            program that calls shagc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshagc must be at least
c
c                  nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls shagc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            if isym is zero then lwork must be at least
c
c                      nlat*(nlon*nt+max0(3*l2,nlon))
c
c            if isym is not zero then lwork must be at least
c
c                      l2*(nlon*nt+max0(3*nlat,nlon))
c
c     **************************************************************
c
c     output parameters
c
c     a,b    both a,b are two or three dimensional arrays (see input
c            parameter nt) that contain the spherical harmonic
c            coefficients in the representation of g(i,j) given in the
c            discription of subroutine shagc. for isym=0, a(m,n) and
c            b(m,n) are given by the equations listed below. symmetric
c            versions are used when isym is greater than zero.
c
c     definitions
c
c     1. the normalized associated legendre functions
c
c     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
c                       *sin(theta)**m/(2**n*factorial(n)) times the
c                       (n+m)th derivative of (x**2-1)**n with respect
c                       to x=cos(theta).
c
c     2. the fourier transform of g(i,j).
c
c     c(m,i)          = 2/nlon times the sum from j=1 to j=nlon of
c                       g(i,j)*cos((m-1)*(j-1)*2*pi/nlon)
c                       (the first and last terms in this sum
c                       are divided by 2)
c
c     s(m,i)          = 2/nlon times the sum from j=2 to j=nlon of
c                       g(i,j)*sin((m-1)*(j-1)*2*pi/nlon)
c
c
c     3. the gaussian points and weights on the sphere
c        (computed by subroutine gaqd).
c
c        theta(1),...,theta(nlat) (gaussian pts in radians)
c        wts(1),...,wts(nlat) (corresponding gaussian weights)
c
c     4. the maximum (plus one) longitudinal wave number
c
c            mmax = min0(nlat,(nlon+2)/2) if nlon is even or
c            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
c
c
c     then for m=0,...,mmax-1 and n=m,...,nlat-1 the arrays a,b
c     are given by
c
c     a(m+1,n+1)     =  the sum from i=1 to i=nlat of
c                       c(m+1,i)*wts(i)*pbar(m,n,theta(i))
c
c     b(m+1,n+1)      = the sum from i=1 to nlat of
c                       s(m+1,i)*wts(i)*pbar(m,n,theta(i))
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of isym
c            = 4  error in the specification of nt
c            = 5  error in the specification of idg
c            = 6  error in the specification of jdg
c            = 7  error in the specification of mdab
c            = 8  error in the specification of ndab
c            = 9  error in the specification of lshagc
c            = 10 error in the specification of lwork
c
c
c ****************************************************************
c
c     subroutine shagci(nlat,nlon,wshagc,lshagc,dwork,ldwork,ierror)
c
c     subroutine shagci initializes the array wshagc which can then
c     be used repeatedly by subroutines shagc. it precomputes
c     and stores in wshagc quantities such as gaussian weights,
c     legendre polynomial coefficients, and fft trigonometric tables.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are compu
c            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid poi
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than or equal to 4. the efficiency of the computation is
c            improved when nlon is a product of small prime numbers.
c
c     wshagc an array which must be initialized by subroutine shagci.
c            once initialized, wshagc can be used repeatedly by shagc
c            as long as nlat and nlon remain unchanged.  wshagc must
c            not be altered between calls of shagc.
c
c     lshagc the dimension of the array wshagc as it appears in the
c            program that calls shagc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshagc must be at least
c
c                  nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
c
c     dwork   a double precision work array that does not have to be saved.
c
c     ldwork  the dimension of the array dwork as it appears in the
c            program that calls shagci. ldwork must be at least
c
c                nlat*(nlat+4)
c
c     output parameter
c
c     wshagc an array which must be initialized before calling shagc or
c            once initialized, wshagc can be used repeatedly by shagc or
c            as long as nlat and nlon remain unchanged.  wshagc must not
c            altered between calls of shagc.
c
c     ierror = 0  no errors
c            = 1  error in the specification of nlat
c            = 2  error in the specification of nlon
c            = 3  error in the specification of lshagc
c            = 4  error in the specification of ldwork
c            = 5  failure in gaqd to compute gaussian points
c                 (due to failure in eigenvalue routine)
c
c
c ****************************************************************
      subroutine shagc(nlat,nlon,isym,nt,g,idg,jdg,a,b,mdab,ndab,
     1                    wshagc,lshagc,work,lwork,ierror)
c     subroutine shagc performs the spherical harmonic analysis on
c     a gaussian grid on the array(s) in g and returns the coefficients
c     in array(s) a,b. the necessary legendre polynomials are computed
c     as needed in this version.
c
      dimension g(idg,jdg,1),a(mdab,ndab,1),b(mdab,ndab,1),
     1          wshagc(lshagc),work(lwork)
c     check input parameters
      ierror = 1
      if (nlat.lt.3) return
      ierror = 2
      if (nlon.lt.4) return
      ierror = 3
      if (isym.lt.0 .or.isym.gt.2) return
      ierror = 4
      if (nt.lt.1) return
c     set upper limit on m for spherical harmonic basis
      l = min0((nlon+2)/2,nlat)
c     set gaussian point nearest equator pointer
      late = (nlat+mod(nlat,2))/2
c     set number of grid points for analysis/synthesis
      lat = nlat
      if (isym.ne.0) lat = late
      ierror = 5
      if (idg.lt.lat) return
      ierror = 6
      if (jdg.lt.nlon) return
      ierror = 7
      if(mdab .lt. l) return
      ierror = 8
      if(ndab .lt. nlat) return
      l1 = l
      l2 = late
      ierror = 9
c     check permanent work space length
      if (lshagc .lt. nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15)return
      ierror = 10
c     check temporary work space length
      if (isym.eq.0) then
      if(lwork.lt.nlat*(nlon*nt+max0(3*l2,nlon))) return
      else
c     isym.ne.0
      if(lwork.lt.l2*(nlon*nt+max0(3*nlat,nlon))) return
      end if
      ierror = 0
c     starting address for gaussian wts in shigc and fft values
      iwts = 1
      ifft = nlat+2*nlat*late+3*(l*(l-1)/2+(nlat-l)*(l-1))+1
c     set pointers for internal storage of g and legendre polys
      ipmn = lat*nlon*nt+1
      call shagc1(nlat,nlon,l,lat,isym,g,idg,jdg,nt,a,b,mdab,ndab,
     1wshagc,wshagc(iwts),wshagc(ifft),late,work(ipmn),work)
      return
      end
      subroutine shagc1(nlat,nlon,l,lat,mode,gs,idg,jdg,nt,a,b,mdab,
     1                  ndab,w,wts,wfft,late,pmn,g)
      dimension gs(idg,jdg,nt),a(mdab,ndab,nt),
     1          b(mdab,ndab,nt),g(lat,nlon,nt)
      dimension w(1),wts(nlat),wfft(1),pmn(nlat,late,3)
c     set gs array internally in shagc1
      do 100 k=1,nt
      do 100 j=1,nlon
      do 100 i=1,lat
      g(i,j,k) = gs(i,j,k)
  100 continue
c     do fourier transform
      do 101 k=1,nt
      call hrfftf(lat,nlon,g(1,1,k),lat,wfft,pmn)
  101 continue
c     scale result
      sfn = 2.0/float(nlon)
      do 102 k=1,nt
      do 102 j=1,nlon
      do 102 i=1,lat
      g(i,j,k) = sfn*g(i,j,k)
  102 continue
c     compute using gaussian quadrature
c     a(n,m) = s (ga(theta,m)*pnm(theta)*sin(theta)*dtheta)
c     b(n,m) = s (gb(theta,m)*pnm(theta)*sin(theta)*dtheta)
c     here ga,gb are the cos(phi),sin(phi) coefficients of
c     the fourier expansion of g(theta,phi) in phi.  as a result
c     of the above fourier transform they are stored in array
c     g as follows:
c     for each theta(i) and k= l-1
c     ga(0),ga(1),gb(1),ga(2),gb(2),...,ga(k-1),gb(k-1),ga(k)
c     correspond to (in the case nlon=l+l-2)
c     g(i,1),g(i,2),g(i,3),g(i,4),g(i,5),...,g(i,2l-4),g(i,2l-3),g(i,2l-
c     initialize coefficients to zero
      do 103 k=1,nt
      do 103 np1=1,nlat
      do 103 mp1=1,l
      a(mp1,np1,k) = 0.0
      b(mp1,np1,k) = 0.0
  103 continue
c     set m+1 limit on b(m+1) calculation
      lm1 = l
      if (nlon .eq. l+l-2) lm1 = l-1
      if (mode.eq.0) then
c     for full sphere (mode=0) and even/odd reduction:
c     overwrite g(i) with (g(i)+g(nlat-i+1))*wts(i)
c     overwrite g(nlat-i+1) with (g(i)-g(nlat-i+1))*wts(i)
      nl2 = nlat/2
      do 104 k=1,nt
      do 104 j=1,nlon
      do 105 i=1,nl2
      is = nlat-i+1
      t1 = g(i,j,k)
      t2 = g(is,j,k)
      g(i,j,k) = wts(i)*(t1+t2)
      g(is,j,k) = wts(i)*(t1-t2)
  105 continue
c     adjust equator if necessary(nlat odd)
      if (mod(nlat,2).ne.0) g(late,j,k) = wts(late)*g(late,j,k)
  104 continue
c     set m = 0 coefficients first
      m = 0
      call legin(mode,l,nlat,m,w,pmn,km)
      do 106 k=1,nt
      do 106 i=1,late
      is = nlat-i+1
      do 107 np1=1,nlat,2
c     n even
      a(1,np1,k) = a(1,np1,k)+g(i,1,k)*pmn(np1,i,km)
  107 continue
      do 108 np1=2,nlat,2
c     n odd
      a(1,np1,k) = a(1,np1,k)+g(is,1,k)*pmn(np1,i,km)
  108 continue
  106 continue
c     compute coefficients for which b(m,n) is available
      do 109 mp1=2,lm1
      m = mp1-1
      mp2 = m+2
c     compute pmn for all i and n=m,...,l-1
      call legin(mode,l,nlat,m,w,pmn,km)
      do 110 k=1,nt
      do 111 i=1,late
      is = nlat-i+1
c     n-m even
      do 112 np1=mp1,nlat,2
      a(mp1,np1,k) = a(mp1,np1,k)+g(i,2*m,k)*pmn(np1,i,km)
      b(mp1,np1,k) = b(mp1,np1,k)+g(i,2*m+1,k)*pmn(np1,i,km)
  112 continue
c     n-m odd
      do 113 np1=mp2,nlat,2
      a(mp1,np1,k) = a(mp1,np1,k)+g(is,2*m,k)*pmn(np1,i,km)
      b(mp1,np1,k) = b(mp1,np1,k)+g(is,2*m+1,k)*pmn(np1,i,km)
  113 continue
  111 continue
  110 continue
  109 continue
      if (nlon .eq. l+l-2) then
c     compute a(l,np1) coefficients only
      m = l-1
      call legin(mode,l,nlat,m,w,pmn,km)
      do 114 k=1,nt
      do 114 i=1,late
      is = nlat-i+1
c     n-m even
      do 124 np1=l,nlat,2
      a(l,np1,k) = a(l,np1,k)+0.5*g(i,nlon,k)*pmn(np1,i,km)
  124 continue
      lp1 = l+1
c     n-m odd
      do 125 np1=lp1,nlat,2
      a(l,np1,k) = a(l,np1,k)+0.5*g(is,nlon,k)*pmn(np1,i,km)
  125 continue
  114 continue
      end if
      else
c     half sphere
c     overwrite g(i) with wts(i)*(g(i)+g(i)) for i=1,...,nlate/2
      nl2 = nlat/2
      do 116  k=1,nt
      do 116 j=1,nlon
      do 115 i=1,nl2
      g(i,j,k) = wts(i)*(g(i,j,k)+g(i,j,k))
  115 continue
c     adjust equator separately if a grid point
      if (nl2.lt.late) g(late,j,k) = wts(late)*g(late,j,k)
  116 continue
c     set m = 0 coefficients first
      m = 0
      call legin(mode,l,nlat,m,w,pmn,km)
      ms = 1
      if (mode.eq.1) ms = 2
      do 117 k=1,nt
      do 117 i=1,late
      do 117 np1=ms,nlat,2
      a(1,np1,k) = a(1,np1,k)+g(i,1,k)*pmn(np1,i,km)
  117 continue
c     compute coefficients for which b(m,n) is available
      do 118 mp1=2,lm1
      m = mp1-1
      ms = mp1
      if (mode.eq.1) ms = mp1+1
c     compute pmn for all i and n=m,...,nlat-1
      call legin(mode,l,nlat,m,w,pmn,km)
      do 119 k=1,nt
      do 119 i=1,late
      do 119 np1=ms,nlat,2
      a(mp1,np1,k) = a(mp1,np1,k)+g(i,2*m,k)*pmn(np1,i,km)
      b(mp1,np1,k) = b(mp1,np1,k)+g(i,2*m+1,k)*pmn(np1,i,km)
  119 continue
  118 continue
      if (nlon.eq.l+l-2) then
c     compute coefficient a(l,np1) only
      m = l-1
      call legin(mode,l,nlat,m,w,pmn,km)
      ns = l
      if (mode.eq.1) ns = l+1
      do 120 k=1,nt
      do 120 i=1,late
      do 120 np1=ns,nlat,2
      a(l,np1,k) = a(l,np1,k)+0.5*g(i,nlon,k)*pmn(np1,i,km)
  120 continue
      end if
      end if
      return
      end
      subroutine shagci(nlat,nlon,wshagc,lshagc,dwork,ldwork,ierror)
c     this subroutine must be called before calling shagc with
c     fixed nlat,nlon. it precomputes quantites such as the gaussian
c     points and weights, m=0,m=1 legendre polynomials, recursion
c     recursion coefficients.
      dimension wshagc(lshagc)
      double precision dwork(ldwork)
      ierror = 1
      if (nlat.lt.3) return
      ierror = 2
      if (nlon.lt.4) return
c     set triangular truncation limit for spherical harmonic basis
      l = min0((nlon+2)/2,nlat)
c     set equator or nearest point (if excluded) pointer
      late = (nlat+mod(nlat,2))/2
      l1 = l
      l2 = late
      ierror = 3
c     check permanent work space length
      if (lshagc .lt. nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15)return
      ierror = 4
      if (ldwork.lt.nlat*(nlat+4))return
      ierror = 0
c     set pointers
      i1 = 1
      i2 = i1+nlat
      i3 = i2+nlat*late
      i4 = i3+nlat*late
      i5 = i4+l*(l-1)/2 +(nlat-l)*(l-1)
      i6 = i5+l*(l-1)/2 +(nlat-l)*(l-1)
      i7 = i6+l*(l-1)/2 +(nlat-l)*(l-1)
c     set indices in temp work for double precision gaussian wts and pts
      idth = 1
      idwts = idth+nlat
      iw = idwts+nlat
      call shagci1(nlat,nlon,l,late,wshagc(i1),wshagc(i2),wshagc(i3),
     1wshagc(i4),wshagc(i5),wshagc(i6),wshagc(i7),dwork(idth),
     2dwork(idwts),dwork(iw),ierror)
      if (ierror.ne.0) ierror = 5
      return
      end
      subroutine shagci1(nlat,nlon,l,late,wts,p0n,p1n,abel,bbel,cbel,
     1                  wfft,dtheta,dwts,work,ier)
      dimension wts(nlat),p0n(nlat,late),p1n(nlat,late),abel(1),bbel(1),
     1 cbel(1),wfft(1)
      double precision pb,dtheta(nlat),dwts(nlat),work(*)
c     compute the nlat  gaussian points and weights, the
c     m=0,1 legendre polys for gaussian points and all n,
c     and the legendre recursion coefficients
c     define index function used in storing
c     arrays for recursion coefficients (functions of (m,n))
c     the index function indx(m,n) is defined so that
c     the pairs (m,n) map to [1,2,...,indx(l-1,l-1)] with no
c     "holes" as m varies from 2 to n and n varies from 2 to l-1.
c     (m=0,1 are set from p0n,p1n for all n)
c     define for 2.le.n.le.l-1
      indx(m,n) = (n-1)*(n-2)/2+m-1
c     define index function for l.le.n.le.nlat
      imndx(m,n) = l*(l-1)/2+(n-l-1)*(l-1)+m-1
c     preset quantites for fourier transform
      call hrffti(nlon,wfft)
c     compute double precision gaussian points and weights
c     lw = 4*nlat*(nlat+1)+2
      lw = nlat*(nlat+2)
      call gaqd(nlat,dtheta,dwts,work,lw,ier)
      if (ier.ne.0) return
c     store gaussian weights single precision to save computation
c     in inner loops in analysis
      do 100 i=1,nlat
      wts(i) = dwts(i)
  100 continue
c     initialize p0n,p1n using double precision dnlfk,dnlft
      do 101 np1=1,nlat
      do 101 i=1,late
      p0n(np1,i) = 0.0
      p1n(np1,i) = 0.0
  101 continue
c     compute m=n=0 legendre polynomials for all theta(i)
      np1 = 1
      n = 0
      m = 0
      call dnlfk(m,n,work)
      do 103 i=1,late
      call dnlft(m,n,dtheta(i),work,pb)
      p0n(1,i) = pb
  103 continue
c     compute p0n,p1n for all theta(i) when n.gt.0
      do 104 np1=2,nlat
      n = np1-1
      m = 0
      call dnlfk(m,n,work)
      do 105 i=1,late
      call dnlft(m,n,dtheta(i),work,pb)
      p0n(np1,i) = pb
  105 continue
c     compute m=1 legendre polynomials for all n and theta(i)
      m = 1
      call dnlfk(m,n,work)
      do 106 i=1,late
      call dnlft(m,n,dtheta(i),work,pb)
      p1n(np1,i) = pb
  106 continue
  104 continue
c     compute and store swarztrauber recursion coefficients
c     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      do 107 n=2,nlat
      mlim = min0(n,l)
      do 107 m=2,mlim
      imn = indx(m,n)
      if (n.ge.l) imn = imndx(m,n)
      abel(imn)=sqrt(float((2*n+1)*(m+n-2)*(m+n-3))/
     1               float(((2*n-3)*(m+n-1)*(m+n))))
      bbel(imn)=sqrt(float((2*n+1)*(n-m-1)*(n-m))/
     1               float(((2*n-3)*(m+n-1)*(m+n))))
      cbel(imn)=sqrt(float((n-m+1)*(n-m+2))/
     1               float(((n+m-1)*(n+m))))
  107 continue
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file shags.f
!
!     this file contains code and documentation for subroutines
!     shags and shagsi
!
! ... files which must be loaded with shags.f
!
!     sphcom.f, hrfft.f, gaqd.f
!
!     subroutine shags(nlat,nlon,isym,nt,g,idg,jdg,a,b,mdab,ndab,
!    1                    wshags,lshags,work,lwork,ierror)
!
!     subroutine shags performs the spherical harmonic analysis
!     on the array g and stores the result in the arrays a and b.
!     the analysis is performed on a gaussian grid in colatitude
!     and an equally spaced grid in longitude.  the associated
!     legendre functions are stored rather than recomputed as they
!     are in subroutine shagc.  the analysis is described below
!     at output parameters a,b.
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are compu
!            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid poi
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than or equal to 4. the efficiency of the computation is
!            improved when nlon is a product of small prime numbers.
!
!     isym   = 0  no symmetries exist about the equator. the analysis
!                 is performed on the entire sphere.  i.e. on the
!                 array g(i,j) for i=1,...,nlat and j=1,...,nlon.
!                 (see description of g below)
!
!            = 1  g is antisymmetric about the equator. the analysis
!                 is performed on the northern hemisphere only.  i.e.
!                 if nlat is odd the analysis is performed on the
!                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
!                 if nlat is even the analysis is performed on the
!                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!
!            = 2  g is symmetric about the equator. the analysis is
!                 performed on the northern hemisphere only.  i.e.
!                 if nlat is odd the analysis is performed on the
!                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
!                 if nlat is even the analysis is performed on the
!                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!     nt     the number of analyses.  in the program that calls shags,
!            the arrays g,a and b can be three dimensional in which
!            case multiple analyses will be performed.  the third
!            index is the analysis index which assumes the values
!            k=1,...,nt.  for a single analysis set nt=1. the
!            discription of the remaining parameters is simplified
!            by assuming that nt=1 or that the arrays g,a and b
!            have only two dimensions.
!
!     g      a two or three dimensional array (see input parameter
!            nt) that contains the discrete function to be analyzed.
!            g(i,j) contains the value of the function at the gaussian
!            point theta(i) and longitude point phi(j) = (j-1)*2*pi/nlon
!            the index ranges are defined above at the input parameter
!            isym.
!
!     idg    the first dimension of the array g as it appears in the
!            program that calls shags. if isym equals zero then idg
!            must be at least nlat.  if isym is nonzero then idg must
!            be at least nlat/2 if nlat is even or at least (nlat+1)/2
!            if nlat is odd.
!
!     jdg    the second dimension of the array g as it appears in the
!            program that calls shags. jdg must be at least nlon.
!
!     mdab   the first dimension of the arrays a and b as it appears
!            in the program that calls shags. mdab must be at least
!            min0((nlon+2)/2,nlat) if nlon is even or at least
!            min0((nlon+1)/2,nlat) if nlon is odd.
!
!     ndab   the second dimension of the arrays a and b as it appears
!            in the program that calls shags. ndab must be at least nlat
!
!     wshags an array which must be initialized by subroutine shagsi.
!            once initialized, wshags can be used repeatedly by shags
!            as long as nlat and nlon remain unchanged.  wshags must
!            not be altered between calls of shags.
!
!     lshags the dimension of the array wshags as it appears in the
!            program that calls shags. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshags must be at least
!
!            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
!
!     work   a real work space which need not be saved
!
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls shags. define
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!
!            if isym is zero then lwork must be at least
!
!                  nlat*nlon*(nt+1)
!
!            if isym is nonzero then lwork must be at least
!
!                  l2*nlon*(nt+1)
!
!     **************************************************************
!
!     output parameters
!
!     a,b    both a,b are two or three dimensional arrays (see input
!            parameter nt) that contain the spherical harmonic
!            coefficients in the representation of g(i,j) given in the
!            discription of subroutine shags. for isym=0, a(m,n) and
!            b(m,n) are given by the equations listed below. symmetric
!            versions are used when isym is greater than zero.
!
!     definitions
!
!     1. the normalized associated legendre functions
!
!     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
!                       *sin(theta)**m/(2**n*factorial(n)) times the
!                       (n+m)th derivative of (x**2-1)**n with respect
!                       to x=cos(theta).
!
!     2. the fourier transform of g(i,j).
!
!     c(m,i)          = 2/nlon times the sum from j=1 to j=nlon of
!                       g(i,j)*cos((m-1)*(j-1)*2*pi/nlon)
!                       (the first and last terms in this sum
!                       are divided by 2)
!
!     s(m,i)          = 2/nlon times the sum from j=2 to j=nlon of
!                       g(i,j)*sin((m-1)*(j-1)*2*pi/nlon)
!
!
!     3. the gaussian points and weights on the sphere
!        (computed by subroutine gaqd).
!
!        theta(1),...,theta(nlat) (gaussian pts in radians)
!        wts(1),...,wts(nlat) (corresponding gaussian weights)
!
!
!     4. the maximum (plus one) longitudinal wave number
!
!            mmax = min0(nlat,(nlon+2)/2) if nlon is even or
!            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
!
!
!     then for m=0,...,mmax-1 and n=m,...,nlat-1 the arrays a,b
!     are given by
!
!     a(m+1,n+1)     =  the sum from i=1 to i=nlat of
!                       c(m+1,i)*wts(i)*pbar(m,n,theta(i))
!
!     b(m+1,n+1)      = the sum from i=1 to nlat of
!                       s(m+1,i)*wts(i)*pbar(m,n,theta(i))
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of isym
!            = 4  error in the specification of nt
!            = 5  error in the specification of idg
!            = 6  error in the specification of jdg
!            = 7  error in the specification of mdab
!            = 8  error in the specification of ndab
!            = 9  error in the specification of lshags
!            = 10 error in the specification of lwork
!
!
! ****************************************************************
!
!     subroutine shagsi(nlat,nlon,wshags,lshags,work,lwork,dwork,ldwork,
!    +                  ierror)
!
!     subroutine shagsi initializes the array wshags which can then
!     be used repeatedly by subroutines shags. it precomputes
!     and stores in wshags quantities such as gaussian weights,
!     legendre polynomial coefficients, and fft trigonometric tables.
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are compu
!            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid poi
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than or equal to 4. the efficiency of the computation is
!            improved when nlon is a product of small prime numbers.
!
!     wshags an array which must be initialized by subroutine shagsi.
!            once initialized, wshags can be used repeatedly by shags
!            as long as nlat and nlon remain unchanged.  wshags must
!            not be altered between calls of shags.
!
!     lshags the dimension of the array wshags as it appears in the
!            program that calls shags. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshags must be at least
!
!            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
!
!     work   a real work space which need not be saved
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls shagsi. lwork must be at least
!            4*nlat*(nlat+2)+2 in the routine calling shagsi
!
!     dwork   a double precision work array that does not have to be saved.
!
!     ldwork  the length of dwork in the calling routine.  ldwork must
!             be at least nlat*(nlat+4)
!
!     output parameter
!
!     wshags an array which must be initialized before calling shags or
!            once initialized, wshags can be used repeatedly by shags or
!            as long as nlat and nlon remain unchanged.  wshags must not
!            altered between calls of shasc.
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of lshags
!            = 4  error in the specification of lwork
!            = 5  error in the specification of ldwork
!            = 6  failure in gaqd to compute gaussian points
!                 (due to failure in eigenvalue routine)
!
!
! ****************************************************************
      SUBROUTINE SHAGS(Nlat,Nlon,Mode,Nt,G,Idg,Jdg,A,B,Mdab,Ndab,Wshags,&
                     & Lshags,Work,Lwork,Ierror)
      IMPLICIT NONE
      REAL A , B , G , Work , Wshags
      INTEGER Idg , Ierror , ifft , ipmn , iw , iwts , Jdg , l , l1 ,   &
            & l2 , lat , late , lp , Lshags , Lwork , Mdab , Mode ,     &
            & Ndab , Nlat , Nlon
      INTEGER Nt
!     subroutine shags performs the spherical harmonic analysis on
!     a gaussian grid on the array(s) in g and returns the coefficients
!     in array(s) a,b. the necessary legendre polynomials are fully
!     stored in this version.
!
      DIMENSION G(Idg,Jdg,1) , A(Mdab,Ndab,1) , B(Mdab,Ndab,1) ,        &
              & Wshags(Lshags) , Work(Lwork)
!     check input parameters
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Mode<0 .OR. Mode>2 ) RETURN
!     set m limit for pmn
      l = MIN0((Nlon+2)/2,Nlat)
!     set gaussian point nearest equator pointer
      late = (Nlat+MOD(Nlat,2))/2
!     set number of grid points for analysis/synthesis
      lat = Nlat
      IF ( Mode/=0 ) lat = late
      Ierror = 4
      IF ( Nt<1 ) RETURN
      Ierror = 5
      IF ( Idg<lat ) RETURN
      Ierror = 6
      IF ( Jdg<Nlon ) RETURN
      Ierror = 7
      IF ( Mdab<l ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      l1 = l
      l2 = late
      Ierror = 9
!     check permanent work space length
!
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshags<lp ) RETURN
      Ierror = 10
!     check temporary work space length
      IF ( Mode==0 .AND. Lwork<Nlat*Nlon*(Nt+1) ) RETURN
      IF ( Mode/=0 .AND. Lwork<l2*Nlon*(Nt+1) ) RETURN
      Ierror = 0
!     set starting address for gaussian wts ,fft values,
!     and fully stored legendre polys in wshags
      iwts = 1
      ifft = Nlat + 2*Nlat*late + 3*(l*(l-1)/2+(Nlat-l)*(l-1)) + 1
      ipmn = ifft + Nlon + 15
!     set pointer for internal storage of g
      iw = lat*Nlon*Nt + 1
      CALL SHAGS1(Nlat,Nlon,l,lat,Mode,G,Idg,Jdg,Nt,A,B,Mdab,Ndab,      &
                & Wshags(iwts),Wshags(ifft),Wshags(ipmn),late,Work,     &
                & Work(iw))
    END SUBROUTINE SHAGS
    
    
    SUBROUTINE SHAGS1(Nlat,Nlon,L,Lat,Mode,Gs,Idg,Jdg,Nt,A,B,Mdab,    &
                      & Ndab,Wts,Wfft,Pmn,Late,G,Work)
      IMPLICIT NONE
      REAL A , B , G , Gs , Pmn , sfn , t1 , t2 , Wfft , Work , Wts
      INTEGER i , Idg , is , j , Jdg , k , L , Lat , Late , lm1 , lp1 , &
            & m , Mdab , mml1 , mn , Mode , mp1 , mp2 , ms , Ndab
      INTEGER nl2 , Nlat , Nlon , np1 , ns , Nt
      DIMENSION Gs(Idg,Jdg,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt) ,    &
              & G(Lat,Nlon,Nt)
      DIMENSION Wfft(1) , Pmn(Late,1) , Wts(Nlat) , Work(1)
!     set gs array internally in shags1
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               G(i,j,k) = Gs(i,j,k)
            ENDDO
         ENDDO
      ENDDO
 
!     do fourier transform
      DO k = 1 , Nt
         CALL HRFFTF(Lat,Nlon,G(1,1,k),Lat,Wfft,Work)
      ENDDO
 
!     scale result
      sfn = 2.0/FLOAT(Nlon)
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               G(i,j,k) = sfn*G(i,j,k)
            ENDDO
         ENDDO
      ENDDO
 
!     compute using gaussian quadrature
!     a(n,m) = s (ga(theta,m)*pnm(theta)*sin(theta)*dtheta)
!     b(n,m) = s (gb(theta,m)*pnm(theta)*sin(theta)*dtheta)
!     here ga,gb are the cos(phi),sin(phi) coefficients of
!     the fourier expansion of g(theta,phi) in phi.  as a result
!     of the above fourier transform they are stored in array
!     g as follows:
!     for each theta(i) and k= l-1
!     ga(0),ga(1),gb(1),ga(2),gb(2),...,ga(k-1),gb(k-1),ga(k)
!     correspond to
!     g(i,1),g(i,2),g(i,3),g(i,4),g(i,5),...,g(i,2l-4),g(i,2l-3),g(i,2l-2)
!     whenever 2*l-2 = nlon exactly
!     initialize coefficients to zero
      DO k = 1 , Nt
         DO np1 = 1 , Nlat
            DO mp1 = 1 , L
               A(mp1,np1,k) = 0.0
               B(mp1,np1,k) = 0.0
            ENDDO
         ENDDO
      ENDDO
!     set mp1 limit on b(mp1) calculation
      lm1 = L
      IF ( Nlon==L+L-2 ) lm1 = L - 1
 
      IF ( Mode==0 ) THEN
!     for full sphere (mode=0) and even/odd reduction:
!     overwrite g(i) with (g(i)+g(nlat-i+1))*wts(i)
!     overwrite g(nlat-i+1) with (g(i)-g(nlat-i+1))*wts(i)
         nl2 = Nlat/2
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  t1 = G(i,j,k)
                  t2 = G(is,j,k)
                  G(i,j,k) = Wts(i)*(t1+t2)
                  G(is,j,k) = Wts(i)*(t1-t2)
               ENDDO
!     adjust equator if necessary(nlat odd)
               IF ( MOD(Nlat,2)/=0 ) G(Late,j,k) = Wts(Late)*G(Late,j,k)
            ENDDO
         ENDDO
!     set m = 0 coefficients first
         mp1 = 1
         m = 0
         mml1 = m*(2*Nlat-m-1)/2
         DO k = 1 , Nt
            DO i = 1 , Late
               is = Nlat - i + 1
               DO np1 = 1 , Nlat , 2
!     n even
                  A(1,np1,k) = A(1,np1,k) + G(i,1,k)*Pmn(i,mml1+np1)
               ENDDO
               DO np1 = 2 , Nlat , 2
!     n odd
                  A(1,np1,k) = A(1,np1,k) + G(is,1,k)*Pmn(i,mml1+np1)
               ENDDO
            ENDDO
         ENDDO
!     compute m.ge.1  coefficients next
         DO mp1 = 2 , lm1
            m = mp1 - 1
            mml1 = m*(2*Nlat-m-1)/2
            mp2 = mp1 + 1
            DO k = 1 , Nt
               DO i = 1 , Late
                  is = Nlat - i + 1
!     n-m even
                  DO np1 = mp1 , Nlat , 2
                     A(mp1,np1,k) = A(mp1,np1,k) + G(i,2*m,k)           &
                                  & *Pmn(i,mml1+np1)
                     B(mp1,np1,k) = B(mp1,np1,k) + G(i,2*m+1,k)         &
                                  & *Pmn(i,mml1+np1)
                  ENDDO
!     n-m odd
                  DO np1 = mp2 , Nlat , 2
                     A(mp1,np1,k) = A(mp1,np1,k) + G(is,2*m,k)          &
                                  & *Pmn(i,mml1+np1)
                     B(mp1,np1,k) = B(mp1,np1,k) + G(is,2*m+1,k)        &
                                  & *Pmn(i,mml1+np1)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
         IF ( Nlon==L+L-2 ) THEN
!     compute m=l-1, n=l-1,l,...,nlat-1 coefficients
            m = L - 1
            mml1 = m*(2*Nlat-m-1)/2
            DO k = 1 , Nt
               DO i = 1 , Late
                  is = Nlat - i + 1
                  DO np1 = L , Nlat , 2
                     mn = mml1 + np1
                     A(L,np1,k) = A(L,np1,k) + 0.5*G(i,Nlon,k)*Pmn(i,mn)
                  ENDDO
!     n-m  odd
                  lp1 = L + 1
                  DO np1 = lp1 , Nlat , 2
                     mn = mml1 + np1
                     A(L,np1,k) = A(L,np1,k) + 0.5*G(is,Nlon,k)         &
                                & *Pmn(i,mn)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
 
      ELSE
 
!     half sphere
!     overwrite g(i) with wts(i)*(g(i)+g(i)) for i=1,...,nlate/2
         nl2 = Nlat/2
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , nl2
                  G(i,j,k) = Wts(i)*(G(i,j,k)+G(i,j,k))
               ENDDO
!     adjust equator separately if a grid point
               IF ( nl2<Late ) G(Late,j,k) = Wts(Late)*G(Late,j,k)
            ENDDO
         ENDDO
 
!     set m = 0 coefficients first
         mp1 = 1
         m = 0
         mml1 = m*(2*Nlat-m-1)/2
         ms = 1
         IF ( Mode==1 ) ms = 2
         DO k = 1 , Nt
            DO i = 1 , Late
               DO np1 = ms , Nlat , 2
                  A(1,np1,k) = A(1,np1,k) + G(i,1,k)*Pmn(i,mml1+np1)
               ENDDO
            ENDDO
         ENDDO
 
!     compute m.ge.1  coefficients next
         DO mp1 = 2 , lm1
            m = mp1 - 1
            mml1 = m*(2*Nlat-m-1)/2
            ms = mp1
            IF ( Mode==1 ) ms = mp1 + 1
            DO k = 1 , Nt
               DO i = 1 , Late
                  DO np1 = ms , Nlat , 2
                     A(mp1,np1,k) = A(mp1,np1,k) + G(i,2*m,k)           &
                                  & *Pmn(i,mml1+np1)
                     B(mp1,np1,k) = B(mp1,np1,k) + G(i,2*m+1,k)         &
                                  & *Pmn(i,mml1+np1)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
 
         IF ( Nlon==L+L-2 ) THEN
!     compute n=m=l-1 coefficients last
            m = L - 1
            mml1 = m*(2*Nlat-m-1)/2
!     set starting n for mode even
            ns = L
!     set starting n for mode odd
            IF ( Mode==1 ) ns = L + 1
            DO k = 1 , Nt
               DO i = 1 , Late
                  DO np1 = ns , Nlat , 2
                     mn = mml1 + np1
                     A(L,np1,k) = A(L,np1,k) + 0.5*G(i,Nlon,k)*Pmn(i,mn)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
 
      ENDIF
 
      END SUBROUTINE SHAGS1


      SUBROUTINE SHAGSI(Nlat,Nlon,Wshags,Lshags,Work,Lwork,Dwork,Ldwork,&
                      & Ierror)
      IMPLICIT NONE
      INTEGER Ierror , ipmnf , l , l1 , l2 , late , ldw , Ldwork , lp , &
            & Lshags , Lwork , Nlat , Nlon
      REAL Work , Wshags
!     this subroutine must be called before calling shags or shsgs with
!     fixed nlat,nlon. it precomputes the gaussian weights, points
!     and all necessary legendre polys and stores them in wshags.
!     these quantities must be preserved when calling shags or shsgs
!     repeatedly with fixed nlat,nlon.  dwork must be of length at
!     least nlat*(nlat+4) in the routine calling shagsi.  This is
!     not checked.  undetectable errors will result if dwork is
!     smaller than nlat*(nlat+4).
!
      DIMENSION Wshags(Lshags) , Work(Lwork)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+1)/2
      l1 = l
      l2 = late
!     check permanent work space length
      Ierror = 3
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshags<lp ) RETURN
      Ierror = 4
!     check temporary work space
      IF ( Lwork<4*Nlat*(Nlat+2)+2 ) RETURN
      Ierror = 5
!     check double precision temporary space
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set preliminary quantites needed to compute and store legendre polys
      ldw = Nlat*(Nlat+4)
      CALL SHAGSP(Nlat,Nlon,Wshags,Lshags,Dwork,Ldwork,Ierror)
      IF ( Ierror/=0 ) RETURN
!     set legendre poly pointer in wshags
      ipmnf = Nlat + 2*Nlat*late + 3*(l*(l-1)/2+(Nlat-l)*(l-1))         &
            & + Nlon + 16
      CALL SHAGSS1(Nlat,l,late,Wshags,Work,Wshags(ipmnf))
      END SUBROUTINE SHAGSI

      
      SUBROUTINE SHAGSS1(Nlat,L,Late,W,Pmn,Pmnf)
      IMPLICIT NONE
      INTEGER i , j , k , km , L , Late , m , mml1 , mn , mode , mp1 ,  &
            & Nlat , np1
      REAL Pmn , Pmnf , W
      DIMENSION W(1) , Pmn(Nlat,Late,3) , Pmnf(Late,1)
!     compute and store legendre polys for i=1,...,late,m=0,...,l-1
!     and n=m,...,l-1
      DO i = 1 , Nlat
         DO j = 1 , Late
            DO k = 1 , 3
               Pmn(i,j,k) = 0.0
            ENDDO
         ENDDO
      ENDDO
      DO mp1 = 1 , L
         m = mp1 - 1
         mml1 = m*(2*Nlat-m-1)/2
!     compute pmn for n=m,...,nlat-1 and i=1,...,(l+1)/2
         mode = 0
         CALL LEGIN(mode,L,Nlat,m,W,Pmn,km)
!     store above in pmnf
         DO np1 = mp1 , Nlat
            mn = mml1 + np1
            DO i = 1 , Late
               Pmnf(i,mn) = Pmn(np1,i,km)
            ENDDO
         ENDDO
      ENDDO
      END SUBROUTINE SHAGSS1 


      SUBROUTINE SHAGSP(Nlat,Nlon,Wshags,Lshags,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER i1 , i2 , i3 , i4 , i5 , i6 , i7 , idth , idwts , Ierror ,&
            & iw , l , l1 , l2 , late , Ldwork , Lshags , Nlat , Nlon
      REAL Wshags
      DIMENSION Wshags(Lshags)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+MOD(Nlat,2))/2
      l1 = l
      l2 = late
      Ierror = 3
!     check permanent work space length
      IF ( Lshags<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 4
!     if (lwork.lt.4*nlat*(nlat+2)+2) return
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set pointers
      i1 = 1
      i2 = i1 + Nlat
      i3 = i2 + Nlat*late
      i4 = i3 + Nlat*late
      i5 = i4 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i6 = i5 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i7 = i6 + l*(l-1)/2 + (Nlat-l)*(l-1)
!     set indices in temp work for double precision gaussian wts and pts
      idth = 1
!     idwts = idth+2*nlat
!     iw = idwts+2*nlat
      idwts = idth + Nlat
      iw = idwts + Nlat
      CALL SHAGSP1(Nlat,Nlon,l,late,Wshags(i1),Wshags(i2),Wshags(i3),   &
                 & Wshags(i4),Wshags(i5),Wshags(i6),Wshags(i7),         &
                 & Dwork(idth),Dwork(idwts),Dwork(iw),Ierror)
      IF ( Ierror/=0 ) Ierror = 6
      END SUBROUTINE SHAGSP 

      
      SUBROUTINE SHAGSP1(Nlat,Nlon,L,Late,Wts,P0n,P1n,Abel,Bbel,Cbel,   &
                       & Wfft,Dtheta,Dwts,Work,Ier)
      IMPLICIT NONE
      REAL Abel , Bbel , Cbel , P0n , P1n , Wfft , Wts
      INTEGER i , Ier , imn , IMNDX , INDX , L , Late , lw , m , mlim , &
            & n , Nlat , Nlon , np1
      DIMENSION Wts(Nlat) , P0n(Nlat,Late) , P1n(Nlat,Late) , Abel(1) , &
              & Bbel(1) , Cbel(1) , Wfft(1) , Dtheta(Nlat) , Dwts(Nlat)
      DOUBLE PRECISION pb , Dtheta , Dwts , Work(*)
      INDX(m,n) = (n-1)*(n-2)/2 + m - 1
      IMNDX(m,n) = L*(L-1)/2 + (n-L-1)*(L-1) + m - 1
      CALL HRFFTI(Nlon,Wfft)
 
!     compute double precision gaussian points and weights
!     lw = 4*nlat*(nlat+2)
      lw = Nlat*(Nlat+2)
      CALL GAQD(Nlat,Dtheta,Dwts,Work,lw,Ier)
      IF ( Ier/=0 ) RETURN
 
!     store gaussian weights single precision to save computation
!     in inner loops in analysis
      DO i = 1 , Nlat
         Wts(i) = Dwts(i)
      ENDDO
!     initialize p0n,p1n using double precision dnlfk,dnlft
      DO np1 = 1 , Nlat
         DO i = 1 , Late
            P0n(np1,i) = 0.0
            P1n(np1,i) = 0.0
         ENDDO
      ENDDO
!     compute m=n=0 legendre polynomials for all theta(i)
      np1 = 1
      n = 0
      m = 0
      CALL DNLFK(m,n,Work)
      DO i = 1 , Late
         CALL DNLFT(m,n,Dtheta(i),Work,pb)
         P0n(1,i) = pb
      ENDDO
!     compute p0n,p1n for all theta(i) when n.gt.0
      DO np1 = 2 , Nlat
         n = np1 - 1
         m = 0
         CALL DNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DNLFT(m,n,Dtheta(i),Work,pb)
            P0n(np1,i) = pb
         ENDDO
!     compute m=1 legendre polynomials for all n and theta(i)
         m = 1
         CALL DNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DNLFT(m,n,Dtheta(i),Work,pb)
            P1n(np1,i) = pb
         ENDDO
      ENDDO
!
!     compute and store swarztrauber recursion coefficients
!     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      DO n = 2 , Nlat
         mlim = MIN0(n,L)
         DO m = 2 , mlim
            imn = INDX(m,n)
            IF ( n>=L ) imn = IMNDX(m,n)
            Abel(imn) = SQRT(FLOAT((2*n+1)*(m+n-2)*(m+n-3))/FLOAT(((2*n-&
                      & 3)*(m+n-1)*(m+n))))
            Bbel(imn) = SQRT(FLOAT((2*n+1)*(n-m-1)*(n-m))/FLOAT(((2*n-3)&
                      & *(m+n-1)*(m+n))))
            Cbel(imn) = SQRT(FLOAT((n-m+1)*(n-m+2))/FLOAT(((n+m-1)*(n+m)&
                      & )))
         ENDDO
      ENDDO
    END SUBROUTINE SHAGSP1

    
    SUBROUTINE DSHAGS(Nlat,Nlon,Mode,Nt,G,Idg,Jdg,A,B,Mdab,Ndab,Wshags,&
                     & Lshags,Work,Lwork,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , G , Work , Wshags
      INTEGER Idg , Ierror , ifft , ipmn , iw , iwts , Jdg , l , l1 ,   &
            & l2 , lat , late , lp , Lshags , Lwork , Mdab , Mode ,     &
            & Ndab , Nlat , Nlon
      INTEGER Nt
!     subroutine shags performs the spherical harmonic analysis on
!     a gaussian grid on the array(s) in g and returns the coefficients
!     in array(s) a,b. the necessary legendre polynomials are fully
!     stored in this version.
!
      DIMENSION G(Idg,Jdg,1) , A(Mdab,Ndab,1) , B(Mdab,Ndab,1) ,        &
              & Wshags(Lshags) , Work(Lwork)
!     check input parameters
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Mode<0 .OR. Mode>2 ) RETURN
!     set m limit for pmn
      l = MIN0((Nlon+2)/2,Nlat)
!     set gaussian point nearest equator pointer
      late = (Nlat+MOD(Nlat,2))/2
!     set number of grid points for analysis/synthesis
      lat = Nlat
      IF ( Mode/=0 ) lat = late
      Ierror = 4
      IF ( Nt<1 ) RETURN
      Ierror = 5
      IF ( Idg<lat ) RETURN
      Ierror = 6
      IF ( Jdg<Nlon ) RETURN
      Ierror = 7
      IF ( Mdab<l ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      l1 = l
      l2 = late
      Ierror = 9
!     check permanent work space length
!
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshags<lp ) RETURN
      Ierror = 10
!     check temporary work space length
      IF ( Mode==0 .AND. Lwork<Nlat*Nlon*(Nt+1) ) RETURN
      IF ( Mode/=0 .AND. Lwork<l2*Nlon*(Nt+1) ) RETURN
      Ierror = 0
!     set starting address for gaussian wts ,fft values,
!     and fully stored legendre polys in wshags
      iwts = 1
      ifft = Nlat + 2*Nlat*late + 3*(l*(l-1)/2+(Nlat-l)*(l-1)) + 1
      ipmn = ifft + Nlon + 15
!     set pointer for internal storage of g
      iw = lat*Nlon*Nt + 1
      CALL DSHAGS1(Nlat,Nlon,l,lat,Mode,G,Idg,Jdg,Nt,A,B,Mdab,Ndab,      &
                & Wshags(iwts),Wshags(ifft),Wshags(ipmn),late,Work,     &
                & Work(iw))
    END SUBROUTINE DSHAGS
    
    
    SUBROUTINE DSHAGS1(Nlat,Nlon,L,Lat,Mode,Gs,Idg,Jdg,Nt,A,B,Mdab,    &
                      & Ndab,Wts,Wfft,Pmn,Late,G,Work)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , G , Gs , Pmn , sfn , t1 , t2 , Wfft , Work , Wts
      INTEGER i , Idg , is , j , Jdg , k , L , Lat , Late , lm1 , lp1 , &
            & m , Mdab , mml1 , mn , Mode , mp1 , mp2 , ms , Ndab
      INTEGER nl2 , Nlat , Nlon , np1 , ns , Nt
      DIMENSION Gs(Idg,Jdg,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt) ,    &
              & G(Lat,Nlon,Nt)
      DIMENSION Wfft(1) , Pmn(Late,1) , Wts(Nlat) , Work(1)
!     set gs array internally in shags1
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               G(i,j,k) = Gs(i,j,k)
            ENDDO
         ENDDO
      ENDDO
 
!     do fourier transform
      DO k = 1 , Nt
         CALL DHRFFTF(Lat,Nlon,G(1,1,k),Lat,Wfft,Work)
      ENDDO
 
!     scale result
      sfn = 2.0/FLOAT(Nlon)
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               G(i,j,k) = sfn*G(i,j,k)
            ENDDO
         ENDDO
      ENDDO
 
!     compute using gaussian quadrature
!     a(n,m) = s (ga(theta,m)*pnm(theta)*sin(theta)*dtheta)
!     b(n,m) = s (gb(theta,m)*pnm(theta)*sin(theta)*dtheta)
!     here ga,gb are the cos(phi),sin(phi) coefficients of
!     the fourier expansion of g(theta,phi) in phi.  as a result
!     of the above fourier transform they are stored in array
!     g as follows:
!     for each theta(i) and k= l-1
!     ga(0),ga(1),gb(1),ga(2),gb(2),...,ga(k-1),gb(k-1),ga(k)
!     correspond to
!     g(i,1),g(i,2),g(i,3),g(i,4),g(i,5),...,g(i,2l-4),g(i,2l-3),g(i,2l-2)
!     whenever 2*l-2 = nlon exactly
!     initialize coefficients to zero
      DO k = 1 , Nt
         DO np1 = 1 , Nlat
            DO mp1 = 1 , L
               A(mp1,np1,k) = 0.0
               B(mp1,np1,k) = 0.0
            ENDDO
         ENDDO
      ENDDO
!     set mp1 limit on b(mp1) calculation
      lm1 = L
      IF ( Nlon==L+L-2 ) lm1 = L - 1
 
      IF ( Mode==0 ) THEN
!     for full sphere (mode=0) and even/odd reduction:
!     overwrite g(i) with (g(i)+g(nlat-i+1))*wts(i)
!     overwrite g(nlat-i+1) with (g(i)-g(nlat-i+1))*wts(i)
         nl2 = Nlat/2
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  t1 = G(i,j,k)
                  t2 = G(is,j,k)
                  G(i,j,k) = Wts(i)*(t1+t2)
                  G(is,j,k) = Wts(i)*(t1-t2)
               ENDDO
!     adjust equator if necessary(nlat odd)
               IF ( MOD(Nlat,2)/=0 ) G(Late,j,k) = Wts(Late)*G(Late,j,k)
            ENDDO
         ENDDO
!     set m = 0 coefficients first
         mp1 = 1
         m = 0
         mml1 = m*(2*Nlat-m-1)/2
         DO k = 1 , Nt
            DO i = 1 , Late
               is = Nlat - i + 1
               DO np1 = 1 , Nlat , 2
!     n even
                  A(1,np1,k) = A(1,np1,k) + G(i,1,k)*Pmn(i,mml1+np1)
               ENDDO
               DO np1 = 2 , Nlat , 2
!     n odd
                  A(1,np1,k) = A(1,np1,k) + G(is,1,k)*Pmn(i,mml1+np1)
               ENDDO
            ENDDO
         ENDDO
!     compute m.ge.1  coefficients next
         DO mp1 = 2 , lm1
            m = mp1 - 1
            mml1 = m*(2*Nlat-m-1)/2
            mp2 = mp1 + 1
            DO k = 1 , Nt
               DO i = 1 , Late
                  is = Nlat - i + 1
!     n-m even
                  DO np1 = mp1 , Nlat , 2
                     A(mp1,np1,k) = A(mp1,np1,k) + G(i,2*m,k)           &
                                  & *Pmn(i,mml1+np1)
                     B(mp1,np1,k) = B(mp1,np1,k) + G(i,2*m+1,k)         &
                                  & *Pmn(i,mml1+np1)
                  ENDDO
!     n-m odd
                  DO np1 = mp2 , Nlat , 2
                     A(mp1,np1,k) = A(mp1,np1,k) + G(is,2*m,k)          &
                                  & *Pmn(i,mml1+np1)
                     B(mp1,np1,k) = B(mp1,np1,k) + G(is,2*m+1,k)        &
                                  & *Pmn(i,mml1+np1)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
         IF ( Nlon==L+L-2 ) THEN
!     compute m=l-1, n=l-1,l,...,nlat-1 coefficients
            m = L - 1
            mml1 = m*(2*Nlat-m-1)/2
            DO k = 1 , Nt
               DO i = 1 , Late
                  is = Nlat - i + 1
                  DO np1 = L , Nlat , 2
                     mn = mml1 + np1
                     A(L,np1,k) = A(L,np1,k) + 0.5*G(i,Nlon,k)*Pmn(i,mn)
                  ENDDO
!     n-m  odd
                  lp1 = L + 1
                  DO np1 = lp1 , Nlat , 2
                     mn = mml1 + np1
                     A(L,np1,k) = A(L,np1,k) + 0.5*G(is,Nlon,k)         &
                                & *Pmn(i,mn)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
 
      ELSE
 
!     half sphere
!     overwrite g(i) with wts(i)*(g(i)+g(i)) for i=1,...,nlate/2
         nl2 = Nlat/2
         DO k = 1 , Nt
            DO j = 1 , Nlon
               DO i = 1 , nl2
                  G(i,j,k) = Wts(i)*(G(i,j,k)+G(i,j,k))
               ENDDO
!     adjust equator separately if a grid point
               IF ( nl2<Late ) G(Late,j,k) = Wts(Late)*G(Late,j,k)
            ENDDO
         ENDDO
 
!     set m = 0 coefficients first
         mp1 = 1
         m = 0
         mml1 = m*(2*Nlat-m-1)/2
         ms = 1
         IF ( Mode==1 ) ms = 2
         DO k = 1 , Nt
            DO i = 1 , Late
               DO np1 = ms , Nlat , 2
                  A(1,np1,k) = A(1,np1,k) + G(i,1,k)*Pmn(i,mml1+np1)
               ENDDO
            ENDDO
         ENDDO
 
!     compute m.ge.1  coefficients next
         DO mp1 = 2 , lm1
            m = mp1 - 1
            mml1 = m*(2*Nlat-m-1)/2
            ms = mp1
            IF ( Mode==1 ) ms = mp1 + 1
            DO k = 1 , Nt
               DO i = 1 , Late
                  DO np1 = ms , Nlat , 2
                     A(mp1,np1,k) = A(mp1,np1,k) + G(i,2*m,k)           &
                                  & *Pmn(i,mml1+np1)
                     B(mp1,np1,k) = B(mp1,np1,k) + G(i,2*m+1,k)         &
                                  & *Pmn(i,mml1+np1)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
 
         IF ( Nlon==L+L-2 ) THEN
!     compute n=m=l-1 coefficients last
            m = L - 1
            mml1 = m*(2*Nlat-m-1)/2
!     set starting n for mode even
            ns = L
!     set starting n for mode odd
            IF ( Mode==1 ) ns = L + 1
            DO k = 1 , Nt
               DO i = 1 , Late
                  DO np1 = ns , Nlat , 2
                     mn = mml1 + np1
                     A(L,np1,k) = A(L,np1,k) + 0.5*G(i,Nlon,k)*Pmn(i,mn)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
 
      ENDIF
 
      END SUBROUTINE DSHAGS1


      SUBROUTINE DSHAGSI(Nlat,Nlon,Wshags,Lshags,Work,Lwork,Dwork,Ldwork,&
                      & Ierror)
      IMPLICIT NONE
      INTEGER Ierror , ipmnf , l , l1 , l2 , late , ldw , Ldwork , lp , &
            & Lshags , Lwork , Nlat , Nlon
      DOUBLE PRECISION Work , Wshags
!     this subroutine must be called before calling shags or shsgs with
!     fixed nlat,nlon. it precomputes the gaussian weights, points
!     and all necessary legendre polys and stores them in wshags.
!     these quantities must be preserved when calling shags or shsgs
!     repeatedly with fixed nlat,nlon.  dwork must be of length at
!     least nlat*(nlat+4) in the routine calling shagsi.  This is
!     not checked.  undetectable errors will result if dwork is
!     smaller than nlat*(nlat+4).
!
      DIMENSION Wshags(Lshags) , Work(Lwork)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+1)/2
      l1 = l
      l2 = late
!     check permanent work space length
      Ierror = 3
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshags<lp ) RETURN
      Ierror = 4
!     check temporary work space
      IF ( Lwork<4*Nlat*(Nlat+2)+2 ) RETURN
      Ierror = 5
!     check double precision temporary space
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set preliminary quantites needed to compute and store legendre polys
      ldw = Nlat*(Nlat+4)
      CALL DSHAGSP(Nlat,Nlon,Wshags,Lshags,Dwork,Ldwork,Ierror)
      IF ( Ierror/=0 ) RETURN
!     set legendre poly pointer in wshags
      ipmnf = Nlat + 2*Nlat*late + 3*(l*(l-1)/2+(Nlat-l)*(l-1))         &
            & + Nlon + 16
      CALL DSHAGSS1(Nlat,l,late,Wshags,Work,Wshags(ipmnf))
      END SUBROUTINE DSHAGSI

      
      SUBROUTINE DSHAGSS1(Nlat,L,Late,W,Pmn,Pmnf)
      IMPLICIT NONE
      INTEGER i , j , k , km , L , Late , m , mml1 , mn , mode , mp1 ,  &
            & Nlat , np1
      DOUBLE PRECISION Pmn , Pmnf , W
      DIMENSION W(1) , Pmn(Nlat,Late,3) , Pmnf(Late,1)
!     compute and store legendre polys for i=1,...,late,m=0,...,l-1
!     and n=m,...,l-1
      DO i = 1 , Nlat
         DO j = 1 , Late
            DO k = 1 , 3
               Pmn(i,j,k) = 0.0
            ENDDO
         ENDDO
      ENDDO
      DO mp1 = 1 , L
         m = mp1 - 1
         mml1 = m*(2*Nlat-m-1)/2
!     compute pmn for n=m,...,nlat-1 and i=1,...,(l+1)/2
         mode = 0
         CALL LEGIN(mode,L,Nlat,m,W,Pmn,km)
!     store above in pmnf
         DO np1 = mp1 , Nlat
            mn = mml1 + np1
            DO i = 1 , Late
               Pmnf(i,mn) = Pmn(np1,i,km)
            ENDDO
         ENDDO
      ENDDO
      END SUBROUTINE DSHAGSS1 


      SUBROUTINE DSHAGSP(Nlat,Nlon,Wshags,Lshags,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER i1 , i2 , i3 , i4 , i5 , i6 , i7 , idth , idwts , Ierror ,&
            & iw , l , l1 , l2 , late , Ldwork , Lshags , Nlat , Nlon
      DOUBLE PRECISION Wshags
      DIMENSION Wshags(Lshags)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+MOD(Nlat,2))/2
      l1 = l
      l2 = late
      Ierror = 3
!     check permanent work space length
      IF ( Lshags<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 4
!     if (lwork.lt.4*nlat*(nlat+2)+2) return
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set pointers
      i1 = 1
      i2 = i1 + Nlat
      i3 = i2 + Nlat*late
      i4 = i3 + Nlat*late
      i5 = i4 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i6 = i5 + l*(l-1)/2 + (Nlat-l)*(l-1)
      i7 = i6 + l*(l-1)/2 + (Nlat-l)*(l-1)
!     set indices in temp work for double precision gaussian wts and pts
      idth = 1
!     idwts = idth+2*nlat
!     iw = idwts+2*nlat
      idwts = idth + Nlat
      iw = idwts + Nlat
      CALL DSHAGSP1(Nlat,Nlon,l,late,Wshags(i1),Wshags(i2),Wshags(i3),   &
                 & Wshags(i4),Wshags(i5),Wshags(i6),Wshags(i7),         &
                 & Dwork(idth),Dwork(idwts),Dwork(iw),Ierror)
      IF ( Ierror/=0 ) Ierror = 6
      END SUBROUTINE DSHAGSP 

      
      SUBROUTINE DSHAGSP1(Nlat,Nlon,L,Late,Wts,P0n,P1n,Abel,Bbel,Cbel,   &
                       & Wfft,Dtheta,Dwts,Work,Ier)
      IMPLICIT NONE
      DOUBLE PRECISION Abel , Bbel , Cbel , P0n , P1n , Wfft , Wts
      INTEGER i , Ier , imn , IMNDX , INDX , L , Late , lw , m , mlim , &
            & n , Nlat , Nlon , np1
      DIMENSION Wts(Nlat) , P0n(Nlat,Late) , P1n(Nlat,Late) , Abel(1) , &
              & Bbel(1) , Cbel(1) , Wfft(1) , Dtheta(Nlat) , Dwts(Nlat)
      DOUBLE PRECISION pb , Dtheta , Dwts , Work(*)
      INDX(m,n) = (n-1)*(n-2)/2 + m - 1
      IMNDX(m,n) = L*(L-1)/2 + (n-L-1)*(L-1) + m - 1
      CALL DHRFFTI(Nlon,Wfft)
 
!     compute double precision gaussian points and weights
!     lw = 4*nlat*(nlat+2)
      lw = Nlat*(Nlat+2)
      CALL DGAQD(Nlat,Dtheta,Dwts,Work,lw,Ier)
      IF ( Ier/=0 ) RETURN
 
!     store gaussian weights single precision to save computation
!     in inner loops in analysis
      DO i = 1 , Nlat
         Wts(i) = Dwts(i)
      ENDDO
!     initialize p0n,p1n using double precision dnlfk,dnlft
      DO np1 = 1 , Nlat
         DO i = 1 , Late
            P0n(np1,i) = 0.0
            P1n(np1,i) = 0.0
         ENDDO
      ENDDO
!     compute m=n=0 legendre polynomials for all theta(i)
      np1 = 1
      n = 0
      m = 0
      CALL DDNLFK(m,n,Work)
      DO i = 1 , Late
         CALL DDNLFT(m,n,Dtheta(i),Work,pb)
         P0n(1,i) = pb
      ENDDO
!     compute p0n,p1n for all theta(i) when n.gt.0
      DO np1 = 2 , Nlat
         n = np1 - 1
         m = 0
         CALL DDNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DDNLFT(m,n,Dtheta(i),Work,pb)
            P0n(np1,i) = pb
         ENDDO
!     compute m=1 legendre polynomials for all n and theta(i)
         m = 1
         CALL DDNLFK(m,n,Work)
         DO i = 1 , Late
            CALL DDNLFT(m,n,Dtheta(i),Work,pb)
            P1n(np1,i) = pb
         ENDDO
      ENDDO
!
!     compute and store swarztrauber recursion coefficients
!     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
      DO n = 2 , Nlat
         mlim = MIN0(n,L)
         DO m = 2 , mlim
            imn = INDX(m,n)
            IF ( n>=L ) imn = IMNDX(m,n)
            Abel(imn) = SQRT(FLOAT((2*n+1)*(m+n-2)*(m+n-3))/FLOAT(((2*n-&
                      & 3)*(m+n-1)*(m+n))))
            Bbel(imn) = SQRT(FLOAT((2*n+1)*(n-m-1)*(n-m))/FLOAT(((2*n-3)&
                      & *(m+n-1)*(m+n))))
            Cbel(imn) = SQRT(FLOAT((n-m+1)*(n-m+2))/FLOAT(((n+m-1)*(n+m)&
                      & )))
         ENDDO
      ENDDO
    END SUBROUTINE DSHAGSP1

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file ivlapgc.f
c
c     this file includes documentation and code for
c     subroutine ivlapgc
c
c ... files which must be loaded with ivlapgc.f
c
c     sphcom.f, hrfft.f, vhagc.f, vhsgc.f, gaqd.f
c
c     subroutine ivlapgc(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
c    +mdbc,ndbc,wvhsgc,lvhsgc,work,lwork,ierror)
c
c     given the vector spherical harmonic coefficients (br,bi,cr,ci)
c     precomputed by subroutine vhagc for a vector field (vlap,wlap),
c     subroutine ivlapgc computes a vector field (v,w) whose vector
c     laplacian is (vlap,wlap).  v,vlap are the colatitudinal
c     components and w,wlap are the east longitudinal components of
c     the vectors.  (v,w) have the same symmetry or lack of symmetry
c     about the equator as (vlap,wlap).  the input parameters ityp,
c     nt,mdbc,ndbc must have the same values used by vhagc to compute
c     br,bi,cr,ci for (vlap,wlap).
c
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are computed
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct longitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     ityp   this parameter should have the same value input to subroutine
c            vhagc to compute the coefficients br,bi,cr, and ci for the
c            vector field (vlap,wlap).  ityp is set as follows:
c
c            = 0  no symmetries exist in (vlap,wlap) about the equator. (v,w)
c                 is computed and stored on the entire sphere in the arrays
c                 arrays v(i,j) and w(i,j) for i=1,...,nlat and j=1,...,nlon.
c
c            = 1  no symmetries exist in (vlap,wlap) about the equator. (v,w)
c                 is computed and stored on the entire sphere in the arrays
c                 v(i,j) and w(i,j) for i=1,...,nlat and j=1,...,nlon.  the
c                 vorticity of (vlap,wlap) is zero so the coefficients cr and
c                 ci are zero and are not used.  the vorticity of (v,w) is
c                 also zero.
c
c
c            = 2  no symmetries exist in (vlap,wlap) about the equator. (v,w)
c                 is computed and stored on the entire sphere in the arrays
c                 w(i,j) and v(i,j) for i=1,...,nlat and j=1,...,nlon.  the
c                 divergence of (vlap,wlap) is zero so the coefficients br and
c                 bi are zero and are not used.  the divergence of (v,w) is
c                 also zero.
c
c            = 3  wlap is antisymmetric and vlap is symmetric about the
c                 equator. consequently w is antisymmetric and v is symmetric.
c                 (v,w) is computed and stored on the northern hemisphere
c                 only.  if nlat is odd, storage is in the arrays v(i,j),
c                 w(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays v(i,j),w(i,j) for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 4  wlap is antisymmetric and vlap is symmetric about the
c                 equator. consequently w is antisymmetric and v is symmetric.
c                 (v,w) is computed and stored on the northern hemisphere
c                 only.  if nlat is odd, storage is in the arrays v(i,j),
c                 w(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays v(i,j),w(i,j) for
c                 i=1,...,nlat/2 and j=1,...,nlon.  the vorticity of (vlap,
c                 wlap) is zero so the coefficients cr,ci are zero and
c                 are not used. the vorticity of (v,w) is also zero.
c
c            = 5  wlap is antisymmetric and vlap is symmetric about the
c                 equator. consequently w is antisymmetric and v is symmetric.
c                 (v,w) is computed and stored on the northern hemisphere
c                 only.  if nlat is odd, storage is in the arrays w(i,j),
c                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays w(i,j),v(i,j) for
c                 i=1,...,nlat/2 and j=1,...,nlon.  the divergence of (vlap,
c                 wlap) is zero so the coefficients br,bi are zero and
c                 are not used. the divergence of (v,w) is also zero.
c
c
c            = 6  wlap is symmetric and vlap is antisymmetric about the
c                 equator. consequently w is symmetric and v is antisymmetric.
c                 (v,w) is computed and stored on the northern hemisphere
c                 only.  if nlat is odd, storage is in the arrays w(i,j),
c                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays w(i,j),v(i,j) for
c                 i=1,...,nlat/2 and j=1,...,nlon.
c
c            = 7  wlap is symmetric and vlap is antisymmetric about the
c                 equator. consequently w is symmetric and v is antisymmetric.
c                 (v,w) is computed and stored on the northern hemisphere
c                 only.  if nlat is odd, storage is in the arrays w(i,j),
c                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays w(i,j),v(i,j) for
c                 i=1,...,nlat/2 and j=1,...,nlon.  the vorticity of (vlap,
c                 wlap) is zero so the coefficients cr,ci are zero and
c                 are not used. the vorticity of (v,w) is also zero.
c
c            = 8  wlap is symmetric and vlap is antisymmetric about the
c                 equator. consequently w is symmetric and v is antisymmetric.
c                 (v,w) is computed and stored on the northern hemisphere
c                 only.  if nlat is odd, storage is in the arrays w(i,j),
c                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
c                 is even, storage is in the arrays w(i,j),v(i,j) for
c                 i=1,...,nlat/2 and j=1,...,nlon.  the divergence of (vlap,
c                 wlap) is zero so the coefficients br,bi are zero and
c                 are not used. the divergence of (v,w) is also zero.
c
c
c     nt     nt is the number of vector fields (vlap,wlap). some computational
c            efficiency is obtained for multiple fields.  in the program
c            that calls ivlapgc, the arrays v,w,br,bi,cr and ci can be
c            three dimensional corresponding to an indexed multiple vector
c            field.  in this case multiple vector synthesis will be performed
c            to compute the (v,w) for each field (vlap,wlap).  the third
c            index is the synthesis index which assumes the values k=1,...,nt.
c            for a single synthesis set nt=1.  the description of the
c            remaining parameters is simplified by assuming that nt=1 or
c            that all arrays are two dimensional.
c
c   idvw     the first dimension of the arrays w and v as it appears in
c            the program that calls ivlapgc.  if ityp=0,1, or 2  then idvw
c            must be at least nlat.  if ityp > 2 and nlat is even then idvw
c            must be at least nlat/2. if ityp > 2 and nlat is odd then idvw
c            must be at least (nlat+1)/2.
c
c   jdvw     the second dimension of the arrays w and v as it appears in
c            the program that calls ivlapgc. jdvw must be at least nlon.
c
c
c   br,bi    two or three dimensional arrays (see input parameter nt)
c   cr,ci    that contain vector spherical harmonic coefficients of the
c            vector field (vlap,wlap) as computed by subroutine vhagc.
c            br,bi,cr and ci must be computed by vhagc prior to calling
c            ivlapgc.  if ityp=1,4, or 7 then cr,ci are not used and can
c            be dummy arguments.  if ityp=2,5, or 8 then br,bi are not
c            used and can be dummy arguments.
c
c    mdbc    the first dimension of the arrays br,bi,cr and ci as it
c            appears in the program that calls ivlapgc.  mdbc must be
c            at least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c    ndbc    the second dimension of the arrays br,bi,cr and ci as it
c            appears in the program that calls ivlapgc. ndbc must be at
c            least nlat.
c
c    wvhsgc  an array which must be initialized by subroutine vhsgci.
c            once initialized, wvhsgc
c            can be used repeatedly by ivlapgc as long as nlat and nlon
c            remain unchanged.  wvhsgc must not be altered between calls
c            of ivlapgc.
c
c    lvhsgc  the dimension of the array wvhsgc as it appears in the
c            program that calls ivlapgc.  let
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd.
c
c            then lvhsgc must be at least
c
c               4*nlat*l2+3*max0(l1-2,0)*(2*nlat-l1-1)+nlon+15
c
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls ivlapgc. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            if ityp .le. 2 then
c
c               nlat*(2*nt*nlon+max0(6*l2,nlon)) + nlat*(4*nt*l1+1)
c
c            or if ityp .gt. 2 let
c
c               l2*(2*nt*nlon+max0(6*nlat,nlon)) + nlat*(4*nt*l1+1)
c
c            will suffice as a minimum length for lwork
c            (see ierror=10 below)
c
c     **************************************************************
c
c     output parameters
c
c
c    v,w     two or three dimensional arrays (see input parameter nt) that
c            contain a vector field whose vector laplacian is (vlap,wlap).
c            w(i,j) is the east longitude and v(i,j) is the colatitudinal
c            component of the vector. v(i,j) and w(i,j) are given on the
c            sphere at the guassian colatitude theta(i) for i=1,...,nlat
c            and east longitude lambda(j)=(j-1)*2*pi/nlon for j = 1,...,nlon.
c            let cost and sint be the cosine and sine at colatitude theta.
c            let d( )/dlambda  and d( )/dtheta be the first order partial
c            derivatives in longitude and colatitude.  let sf be either v
c            or w.  define:
c
c                 del2s(sf) = [d(sint*d(sf)/dtheta)/dtheta +
c                               2            2
c                              d (sf)/dlambda /sint]/sint
c
c            then the vector laplacian of (v,w) in (vlap,wlap) satisfies
c
c                 vlap = del2s(v) + (2*cost*dw/dlambda - v)/sint**2
c
c            and
c
c                 wlap = del2s(w) - (2*cost*dv/dlambda + w)/sint**2
c
c
c  ierror    a parameter which flags errors in input parameters as follows:
c
c            = 0  no errors detected
c
c            = 1  error in the specification of nlat
c
c            = 2  error in the specification of nlon
c
c            = 3  error in the specification of ityp
c
c            = 4  error in the specification of nt
c
c            = 5  error in the specification of idvw
c
c            = 6  error in the specification of jdvw
c
c            = 7  error in the specification of mdbc
c
c            = 8  error in the specification of ndbc
c
c            = 9  error in the specification of lvhsgc
c
c            = 10 error in the specification of lwork
c
c
c **********************************************************************
c                                                                              
c     end of documentation for ivlapgc
c
c **********************************************************************
c
      subroutine ivlapgc(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
     +mdbc,ndbc,wvhsgc,lvhsgc,work,lwork,ierror)
      dimension v(idvw,jdvw,nt),w(idvw,jdvw,nt)
      dimension br(mdbc,ndbc,nt),bi(mdbc,ndbc,nt)
      dimension cr(mdbc,ndbc,nt),ci(mdbc,ndbc,nt)
      dimension wvhsgc(lvhsgc),work(lwork)
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if(nlon .lt. 1) return
      ierror = 3
      if(ityp.lt.0 .or. ityp.gt.8) return
      ierror = 4
      if(nt .lt. 0) return
      ierror = 5
      imid = (nlat+1)/2
      if((ityp.le.2 .and. idvw.lt.nlat) .or.
     1   (ityp.gt.2 .and. idvw.lt.imid)) return
      ierror = 6
      if(jdvw .lt. nlon) return
      ierror = 7
      mmax = min0(nlat,(nlon+1)/2)
      if(mdbc .lt. mmax) return
      ierror = 8
      if(ndbc .lt. nlat) return
      ierror = 9
c
c     set minimum and verify saved workspace length
c
      idz = (mmax*(nlat+nlat-mmax+1))/2
      lzimn = idz*imid
      lsavmin = lzimn+lzimn+nlon+15
      if (lvhsgc .lt. lsavmin) return
c
c     set minimum and verify unsaved work space length
c
      ierror = 10
      mn = mmax*nlat*nt
      if(ityp.lt.3) then
c     no symmetry
	if (ityp.eq.0) then
c       br,bi,cr,ci nonzero
	lwkmin = nlat*(2*nt*nlon+max0(6*imid,nlon)+1)+4*mn
	else
c       br,bi or cr,ci zero
	lwkmin = nlat*(2*nt*nlon+max0(6*imid,nlon)+1)+2*mn
	end if
      else
c     symmetry
	if (ityp.eq.3 .or. ityp.eq.6) then
c       br,bi,cr,ci nonzero
	lwkmin = imid*(2*nt*nlon+max0(6*nlat,nlon))+4*mn+nlat
	else
c       br,bi or cr,ci zero
	lwkmin = imid*(2*nt*nlon+max0(6*nlat,nlon))+2*mn+nlat
	end if
      end if
      if (lwork .lt. lwkmin) return
      ierror = 0
c
c     set work space pointers for vector laplacian coefficients
c
      if (ityp.eq.0 .or. ityp.eq.3 .or. ityp.eq.6) then
      ibr = 1
      ibi = ibr+mn
      icr = ibi+mn
      ici = icr+mn
      else if (ityp.eq.1 .or. ityp.eq.4 .or. ityp.eq.7) then
      ibr = 1
      ibi = ibr+mn
      icr = ibi+mn
      ici = icr
      else
      ibr = 1
      ibi = 1
      icr = ibi+mn
      ici = icr+mn
      end if
      ifn = ici + mn
      iwk = ifn + nlat
      if (ityp.eq.0 .or. ityp.eq.3 .or. ityp.eq.6) then
      liwk = lwork-4*mn-nlat
      else
      liwk = lwork-2*mn-nlat
      end if
      call ivlapgc1(nlat,nlon,ityp,nt,v,w,idvw,jdvw,work(ibr),
     +work(ibi),work(icr),work(ici),mmax,work(ifn),mdbc,ndbc,br,bi,
     +cr,ci,wvhsgc,lvhsgc,work(iwk),liwk,ierror)
      return
      end

      subroutine ivlapgc1(nlat,nlon,ityp,nt,v,w,idvw,jdvw,brvw,
     +bivw,crvw,civw,mmax,fnn,mdbc,ndbc,br,bi,cr,ci,wvhsgc,lvhsgc,
     +wk,lwk,ierror)
      dimension v(idvw,jdvw,nt),w(idvw,jdvw,nt)
      dimension fnn(nlat),brvw(mmax,nlat,nt),bivw(mmax,nlat,nt)
      dimension crvw(mmax,nlat,nt),civw(mmax,nlat,nt)
      dimension br(mdbc,ndbc,nt),bi(mdbc,ndbc,nt)
      dimension cr(mdbc,ndbc,nt),ci(mdbc,ndbc,nt)
      dimension wvhsgc(lvhsgc),wk(lwk)
c
c     preset coefficient multiplyers
c
      do 1 n=2,nlat
      fn = float(n-1)
      fnn(n) = -1.0/(fn*(fn+1.))
    1 continue
c
c     set (u,v) coefficients from br,bi,cr,ci
c
      if (ityp.eq.0 .or. ityp.eq.3 .or. ityp.eq.6) then
c
c     all coefficients needed
c
      do 2 k=1,nt
      do 3 n=1,nlat
      do 4 m=1,mmax
      brvw(m,n,k) = 0.0
      bivw(m,n,k) = 0.0
      crvw(m,n,k) = 0.0
      civw(m,n,k) = 0.0
    4 continue
    3 continue
      do 5 n=2,nlat
      brvw(1,n,k) = fnn(n)*br(1,n,k)
      bivw(1,n,k) = fnn(n)*bi(1,n,k)
      crvw(1,n,k) = fnn(n)*cr(1,n,k)
      civw(1,n,k) = fnn(n)*ci(1,n,k)
    5 continue
      do 6 m=2,mmax
      do 7 n=m,nlat
      brvw(m,n,k) = fnn(n)*br(m,n,k)
      bivw(m,n,k) = fnn(n)*bi(m,n,k)
      crvw(m,n,k) = fnn(n)*cr(m,n,k)
      civw(m,n,k) = fnn(n)*ci(m,n,k)
    7 continue
    6 continue
    2 continue
      else if (ityp.eq.1 .or. ityp.eq.4 .or. ityp.eq.7) then
c
c     vorticity is zero so cr,ci=0 not used
c
      do 12 k=1,nt
      do 13 n=1,nlat
      do 14 m=1,mmax
      brvw(m,n,k) = 0.0
      bivw(m,n,k) = 0.0
   14 continue
   13 continue
      do 15 n=2,nlat
      brvw(1,n,k) = fnn(n)*br(1,n,k)
      bivw(1,n,k) = fnn(n)*bi(1,n,k)
   15 continue
      do 16 m=2,mmax
      do 17 n=m,nlat
      brvw(m,n,k) = fnn(n)*br(m,n,k)
      bivw(m,n,k) = fnn(n)*bi(m,n,k)
   17 continue
   16 continue
   12 continue
      else
c
c     divergence is zero so br,bi=0 not used
c
      do 22 k=1,nt
      do 23 n=1,nlat
      do 24 m=1,mmax
      crvw(m,n,k) = 0.0
      civw(m,n,k) = 0.0
   24 continue
   23 continue
      do 25 n=2,nlat
      crvw(1,n,k) = fnn(n)*cr(1,n,k)
      civw(1,n,k) = fnn(n)*ci(1,n,k)
   25 continue
      do 26 m=2,mmax
      do 27 n=m,nlat
      crvw(m,n,k) = fnn(n)*cr(m,n,k)
      civw(m,n,k) = fnn(n)*ci(m,n,k)
   27 continue
   26 continue
   22 continue
      end if
c
c     sythesize coefs into vector field (v,w)
c
      call vhsgc(nlat,nlon,ityp,nt,v,w,idvw,jdvw,brvw,bivw,
     +           crvw,civw,mmax,nlat,wvhsgc,lvhsgc,wk,lwk,ierror)
      return
      end

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c ... file islapgs.f
c
c     this file includes documentation and code for
c     subroutine islapgs         i
c
c ... files which must be loaded with islapec.f
c
c     sphcom.f, hrfft.f, shags.f, shsgs.f
c
c     subroutine islapgs(nlat,nlon,isym,nt,xlmbda,sf,ids,jds,a,b,
c    +mdab,ndab,wshsgs,lshsgs,work,lwork,pertrb,ierror)
c
c     islapgs inverts the laplace or helmholz operator on a Gaussian grid.
c     Given the spherical harmonic coefficients a(m,n) and b(m,n) of the
c     right hand side slap(i,j), islapgc computes a solution sf(i,j) to
c     the following helmhotz equation :
c
c           2                2
c     [d(sf(i,j))/dlambda /sint + d(sint*d(sf(i,j))/dtheta)/dtheta]/sint
c
c                   - xlmbda * sf(i,j) = slap(i,j)
c
c      where sf(i,j) is computed at the Gaussian colatitude point theta(i)
c      (see nlat as an input argument) and longitude
c
c                 lambda(j) = (j-1)*2*pi/nlon
c
c            for i=1,...,nlat and j=1,...,nlon.
c
c
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are computed
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct longitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     isym   this parameter should have the same value input to subroutine
c            shags to compute the coefficients a and b for the scalar field
c            slap.  isym is set as follows:
c
c            = 0  no symmetries exist in slap about the equator. scalar
c                 synthesis is used to compute sf on the entire sphere.
c                 i.e., in the array sf(i,j) for i=1,...,nlat and
c                 j=1,...,nlon.
c
c           = 1  sf and slap are antisymmetric about the equator. the
c                synthesis used to compute sf is performed on the
c                northern hemisphere only.  if nlat is odd, sf(i,j) is
c                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
c                nlat is even, sf(i,j) is computed for i=1,...,nlat/2
c                and j=1,...,nlon.
c
c
c           = 2  sf and slap are symmetric about the equator. the
c                synthesis used to compute sf is performed on the
c                northern hemisphere only.  if nlat is odd, sf(i,j) is
c                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
c                nlat is even, sf(i,j) is computed for i=1,...,nlat/2
c                and j=1,...,nlon.
c
c
c     nt     the number of analyses.  in the program that calls islapgs
c            the arrays sf,a, and b can be three dimensional in which
c            case multiple synthesis will be performed.  the third index
c            is the synthesis index which assumes the values k=1,...,nt.
c            k is also the index for the perturbation array pertrb.
c            for a single analysis set nt=1. the description of the
c            remaining parameters is simplified by assuming that nt=1
c            or that sf,a,b are two dimensional and pertrb is a constant.
c
c   xlmbda   a one dimensional array with nt elements. if xlmbda is
c            is identically zero islapgc solves poisson's equation.
c            if xlmbda > 0.0 islapgc solves the helmholtz equation.
c            if xlmbda < 0.0 the nonfatal error flag ierror=-1 is
c            returned. negative xlambda could result in a division
c            by zero.
c
c   ids      the first dimension of the array sf as it appears in the
c            program that calls islapgs.  if isym = 0 then ids must be at
c            least nlat.  if isym > 0 and nlat is even then ids must be
c            at least nlat/2. if isym > 0 and nlat is odd then ids must
c            be at least (nlat+1)/2.
c
c   jds      the second dimension of the array sf as it appears in the
c            program that calls islapgs. jds must be at least nlon.
c
c
c   a,b      two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
c            of the scalar field slap as computed by subroutine shags.
c     ***    a,b must be computed by shags prior to calling islapgs.
c
c
c    mdab    the first dimension of the arrays a and b as it appears
c            in the program that calls islapgs.  mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c    ndab    the second dimension of the arrays a and b as it appears
c            in the program that calls islapgs. ndbc must be at least
c            least nlat.
c
c            mdab,ndab should have the same values input to shags to
c            compute the coefficients a and b.
c
c
c    wshsgs  an array which must be initialized by subroutine islapgsi
c            (or equivalently by shsesi).  once initialized, wshsgs
c            can be used repeatedly by islapgs as long as nlat and nlon
c            remain unchanged.  wshsgs  must not be altered between calls
c            of islapgs.
c
c    lshsgs  the dimension of the array wshsgs as it appears in the
c            program that calls islapgs.  let
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsgs must be at least
c
c            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls islapgs. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            if isym is zero then lwork must be at least
c
c               (nt+1)*nlat*nlon + nlat*(2*nt*l1+1)
c
c            if isym is nonzero lwork must be at least
c
c               (nt+1)*l2*nlon + nlat*(2*nt*l1+1)
c
c
c     **************************************************************
c
c     output parameters
c
c
c    sf      a two or three dimensional arrays (see input parameter nt) that
c            inverts the scalar laplacian in slap.  sf(i,j) is given at
c            the colatitude
c
c                 theta(i) = (i-1)*pi/(nlat-1)
c
c            and longitude
c
c                 lambda(j) = (j-1)*2*pi/nlon
c
c            for i=1,...,nlat and j=1,...,nlon.
c
c   pertrb  a one dimensional array with nt elements (see input 
c           parameter nt). in the discription that follows we assume 
c           that nt=1. if xlmbda > 0.0 then pertrb=0.0 is always 
c           returned because the helmholtz operator is invertible.
c           if xlmbda = 0.0 then a solution exists only if a(1,1)
c           is zero. islapec sets a(1,1) to zero. the resulting
c           solution sf(i,j) solves poisson's equation with
c           pertrb = a(1,1)/(2.*sqrt(2.)) subtracted from the
c           right side slap(i,j).
c
c  ierror    a parameter which flags errors in input parameters as follows:
c
c            = 0  no errors detected
c
c            = 1  error in the specification of nlat
c
c            = 2  error in the specification of nlon
c
c            = 3  error in the specification of ityp
c
c            = 4  error in the specification of nt
c
c            = 5  error in the specification of ids
c
c            = 6  error in the specification of jds
c
c            = 7  error in the specification of mdbc
c
c            = 8  error in the specification of ndbc
c
c            = 9  error in the specification of lshsgs
c
c            = 10 error in the specification of lwork
c
c
c **********************************************************************
c                                                                              
c     end of documentation for islapgs
c
c **********************************************************************
c
c
      subroutine islapgs(nlat,nlon,isym,nt,xlmbda,sf,ids,jds,a,b,
     +mdab,ndab,wshsgs,lshsgs,work,lwork,pertrb,ierror)
      dimension sf(ids,jds,nt),a(mdab,ndab,nt),b(mdab,ndab,nt)
      dimension wshsgs(lshsgs),work(lwork),xlmbda(nt),pertrb(nt)
c
c     check input parameters
c
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if(nlon .lt. 4) return
      ierror = 3
      if (isym.lt.0 .or. isym.gt.2) return
      ierror = 4
      if(nt .lt. 0) return
      ierror = 5
      imid = (nlat+1)/2
      if((isym.eq.0 .and. ids.lt.nlat) .or.
     1   (isym.gt.0 .and. ids.lt.imid)) return
      ierror = 6
      if(jds .lt. nlon) return
      ierror = 7
      mmax = min0(nlat,nlon/2+1)
      if(mdab .lt. mmax) return
      ierror = 8
      if(ndab .lt. nlat) return
      ierror = 9
c
c     set and verify saved work space length
c
      imid = (nlat+1)/2
      l2 = (nlat+mod(nlat,2))/2
      l1 = min0((nlon+2)/2,nlat)
      lp=nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
      if(lshsgs.lt.lp) return
      ierror = 10
c
c     set and verify unsaved work space length
c
      ls = nlat
      if(isym .gt. 0) ls = imid
      nln = nt*ls*nlon
      mn = mmax*nlat*nt
c     lwkmin = nln+ls*nlon+2*mn+nlat
c     if (lwork .lt. lwkmin) return
      l2 = (nlat+1)/2
      l1 = min0(nlat,nlon/2+1)
      if (isym.eq.0) then
	lwkmin = (nt+1)*nlat*nlon + nlat*(2*nt*l1+1)
      else
	lwkmin = (nt+1)*l2*nlon + nlat*(2*nt*l1+1)
      end if
      if (lwork .lt. lwkmin) return
      ierror = 0
c
c     check sign of xlmbda
c
      do  k=1,nt
	if (xlmbda(k).lt.0.0) then
	  ierror = -1
	end if
      end do
c
c     set work space pointers
c
      ia = 1
      ib = ia+mn
      ifn = ib+mn
      iwk = ifn+nlat
      lwk = lwork-2*mn-nlat
      call islpgs1(nlat,nlon,isym,nt,xlmbda,sf,ids,jds,a,b,mdab,ndab,
     +work(ia),work(ib),mmax,work(ifn),wshsgs,lshsgs,work(iwk),lwk,
     +pertrb,ierror)
      return
      end

      subroutine islpgs1(nlat,nlon,isym,nt,xlmbda,sf,ids,jds,a,b,
     +mdab,ndab,as,bs,mmax,fnn,wsav,lsav,wk,lwk,pertrb,ierror)
      dimension sf(ids,jds,nt),a(mdab,ndab,nt),b(mdab,ndab,nt)
      dimension as(mmax,nlat,nt),bs(mmax,nlat,nt),fnn(nlat)
      dimension wsav(lsav),wk(lwk),xlmbda(nt),pertrb(nt)
c
c     set multipliers and preset synthesis coefficients to zero
c
      do n=1,nlat
	fn = float(n-1)
	fnn(n) = fn*(fn+1.0)
	do m=1,mmax
	  do k=1,nt
	    as(m,n,k) = 0.0
	    bs(m,n,k) = 0.0
	  end do
	end do
      end do

      do k=1,nt
c
c     compute synthesis coefficients for xlmbda zero or nonzero
c
	if (xlmbda(k) .eq. 0.0) then
	  do n=2,nlat
	    as(1,n,k) = -a(1,n,k)/fnn(n)
	    bs(1,n,k) = -b(1,n,k)/fnn(n)
	  end do
	  do m=2,mmax
	    do n=m,nlat
	      as(m,n,k) = -a(m,n,k)/fnn(n)
	      bs(m,n,k) = -b(m,n,k)/fnn(n)
	    end do
	  end do
	else
c
c     xlmbda nonzero so operator invertible unless
c     -n*(n-1) = xlmbda(k) < 0.0  for some n
c
	  pertrb(k) = 0.0
	  do n=1,nlat
	    as(1,n,k) = -a(1,n,k)/(fnn(n)+xlmbda(k))
	    bs(1,n,k) = -b(1,n,k)/(fnn(n)+xlmbda(k))
	  end do
	  do m=2,mmax
	    do n=m,nlat
	      as(m,n,k) = -a(m,n,k)/(fnn(n)+xlmbda(k))
	      bs(m,n,k) = -b(m,n,k)/(fnn(n)+xlmbda(k))
	    end do
	  end do
	end if
      end do
c
c     synthesize as,bs into sf
c
      call shsgs(nlat,nlon,isym,nt,sf,ids,jds,as,bs,mmax,nlat,
     +           wsav,lsav,wk,lwk,ierror)
      return
      end

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file igradgc.f
c
c     this file includes documentation and code for
c     subroutine igradgc         i
c
c ... files which must be loaded with igradgc.f
c
c     sphcom.f, hrfft.f, shsgc.f,vhagc.f
c
c     subroutine igradgc(nlat,nlon,isym,nt,sf,isf,jsf,br,bi,mdb,ndb,
c    +                   wshsgc,lshsgc,work,lwork,ierror)
c
c     let br,bi,cr,ci be the vector spherical harmonic coefficients
c     precomputed by vhagc for a vector field (v,w).  let (v',w') be
c     the irrotational component of (v,w) (i.e., (v',w') is generated
c     by assuming cr,ci are zero and synthesizing br,bi with vhsgs).
c     then subroutine igradgc computes a scalar field sf such that
c
c            gradient(sf) = (v',w').
c
c     i.e.,
c
c            v'(i,j) = d(sf(i,j))/dtheta          (colatitudinal component of
c                                                 the gradient)
c     and
c
c            w'(i,j) = 1/sint*d(sf(i,j))/dlambda  (east longitudinal component
c                                                 of the gradient)
c
c     at the gaussian colatitude theta(i) (see nlat as input parameter)
c     and longitude lambda(j) = (j-1)*2*pi/nlon where sint = sin(theta(i)).
c
c     note:  for an irrotational vector field (v,w), subroutine igradgc
c     computes a scalar field whose gradient is (v,w).  in ay case,
c     subroutine igradgc "inverts" the gradient subroutine gradgc.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are computed
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater than
c            3.  the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   a parameter which determines whether the scalar field sf is
c            computed on the full or half sphere as follows:
c
c      = 0
c
c            the symmetries/antsymmetries described in isym=1,2 below
c            do not exist in (v,w) about the equator.  in this case sf
c            is neither symmetric nor antisymmetric about the equator.
c            sf is computed on the entire sphere.  i.e., in the array
c            sf(i,j) for i=1,...,nlat and  j=1,...,nlon
c
c      = 1
c
c            w is antisymmetric and v is symmetric about the equator.
c            in this case sf is antisymmetyric about the equator and
c            is computed for the northern hemisphere only.  i.e.,
c            if nlat is odd sf is computed in the array sf(i,j) for
c            i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is even
c            sf is computed in the array sf(i,j) for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c      = 2
c
c            w is symmetric and v is antisymmetric about the equator.
c            in this case sf is symmetyric about the equator and
c            is computed for the northern hemisphere only.  i.e.,
c            if nlat is odd sf is computed in the array sf(i,j) for
c            i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is even
c            sf is computed in the array sf(i,j) for i=1,...,nlat/2
c            and j=1,...,nlon.
c
c
c     nt     nt is the number of scalar and vector fields.  some
c            computational efficiency is obtained for multiple fields.
c            the arrays br,bi, and sf can be three dimensional corresponding
c            to an indexed multiple vector field (v,w).  in this case,
c            multiple scalar synthesis will be performed to compute each
c            scalar field.  the third index for br,bi, and sf is the synthesis
c            index which assumes the values k = 1,...,nt.  for a single
c            synthesis set nt = 1.  the description of the remaining
c            parameters is simplified by assuming that nt=1 or that br,bi,
c            and sf are two dimensional arrays.
c
c     isf    the first dimension of the array sf as it appears in
c            the program that calls igradgc. if isym = 0 then isf
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then isf must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then isf must be at least (nlat+1)/2.
c
c     jsf    the second dimension of the array sf as it appears in
c            the program that calls igradgc. jsf must be at least nlon.
c
c     br,bi  two or three dimensional arrays (see input parameter nt)
c            that contain vector spherical harmonic coefficients
c            of the vector field (v,w) as computed by subroutine vhagc.
c     ***    br,bi must be computed by vhagc prior to calling igradgc.
c
c     mdb    the first dimension of the arrays br and bi as it appears in
c            the program that calls igradgc (and vhagc). mdb must be at
c            least min0(nlat,nlon/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndb    the second dimension of the arrays br and bi as it appears in
c            the program that calls igradgc (and vhagc). ndb must be at
c            least nlat.
c
c
c  wshsgc    an array which must be initialized by subroutine shsgci.
c            once initialized,
c            wshsgc can be used repeatedly by igradgc as long as nlon
c            and nlat remain unchanged.  wshsgc must not be altered
c            between calls of igradgc.
c
c
c  lshsgc    the dimension of the array wshsgc as it appears in the
c            program that calls igradgc. define
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd.
c
c
c            then lshsgc must be at least
c
c               nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls igradgc  define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd

c            if isym is zero then lwork must be at least
c
c               nlat*(nlon*nt+max0(3*l2,nlon)+2*nt*l1+1)
c
c            if isym is not zero then lwork must be at least
c
c               l2*(nlon*nt+max0(3*nlat,nlon)) + nlat*(2*nt*l1+1)
c
c
c
c     **************************************************************
c
c     output parameters
c
c
c     sf    a two or three dimensional array (see input parameter nt) that
c           contain a scalar field whose gradient is the irrotational
c           component of the vector field (v,w).  the vector spherical
c           harmonic coefficients br,bi were precomputed by subroutine
c           vhagc.  sf(i,j) is given at the gaussian colatitude theta(i)
c           and longitude lambda(j) = (j-1)*2*pi/nlon.  the index ranges
c           are defined at input parameter isym.
c
c
c  ierror   = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of isf
c           = 6  error in the specification of jsf
c           = 7  error in the specification of mdb
c           = 8  error in the specification of ndb
c           = 9  error in the specification of lshsgc
c           = 10 error in the specification of lwork
c
c **********************************************************************
c   
      subroutine igradgc(nlat,nlon,isym,nt,sf,isf,jsf,br,bi,mdb,ndb,
     +wshsgc,lshsgc,work,lwork,ierror)
      dimension sf(isf,jsf,nt)
      dimension br(mdb,ndb,nt),bi(mdb,ndb,nt)
      dimension wshsgc(lshsgc),work(lwork)
c
c     check input parameters
c
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if(nlon .lt. 4) return
      ierror = 3
      if(isym.lt.0 .or. isym.gt.2) return
      ierror = 4
      if(nt .lt. 0) return
      ierror = 5
      imid = (nlat+1)/2
      if((isym.eq.0 .and. isf.lt.nlat) .or.
     +   (isym.ne.0 .and. isf.lt.imid)) return
      ierror = 6
      if(jsf .lt. nlon) return
      ierror = 7
      mmax = min0(nlat,(nlon+2)/2)
      if(mdb .lt. min0(nlat,(nlon+1)/2)) return
      ierror = 8
      if(ndb .lt. nlat) return
      ierror = 9
c
c     verify saved work space length
c
      l2 = (nlat+mod(nlat,2))/2
      l1 = min0((nlon+2)/2,nlat)
      if (lshsgc .lt. nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15)return
      ierror = 10
c
c     set minimum and verify unsaved work space
c
      ls = nlat
      if(isym .gt. 0) ls = imid
      nln = nt*ls*nlon
c
c     set first dimension for a,b (as requried by shsgc)
c
      mab = min0(nlat,nlon/2+1)
      mn = mab*nlat*nt
c     lwkmin = nln+ls*nlon+2*mn+nlat
      if (isym .eq. 0) then
	lwkmin = nlat*(nt*nlon+max0(3*l2,nlon)+2*nt*l1+1)
      else
	lwkmin = l2*(nt*nlon+max0(3*nlat,nlon))+nlat*(2*nt*l1+1)
      end if
      if (lwork .lt. lwkmin) return
      ierror = 0
c
c     set work space pointers
c
      ia = 1
      ib = ia + mn
      is = ib + mn
      iwk = is + nlat
      liwk = lwork-2*mn-nlat
      call igrdgc1(nlat,nlon,isym,nt,sf,isf,jsf,work(ia),work(ib),mab,
     +work(is),mdb,ndb,br,bi,wshsgc,lshsgc,work(iwk),liwk,ierror)
      return
      end

      subroutine igrdgc1(nlat,nlon,isym,nt,sf,isf,jsf,a,b,mab,
     +sqnn,mdb,ndb,br,bi,wsav,lsav,wk,lwk,ierror)
      dimension sf(isf,jsf,nt)
      dimension br(mdb,ndb,nt),bi(mdb,ndb,nt),sqnn(nlat)
      dimension a(mab,nlat,nt),b(mab,nlat,nt)
      dimension wsav(lsav),wk(lwk)
c
c     preset coefficient multiplyers in vector
c
      do 1 n=2,nlat
      fn = float(n-1)
      sqnn(n) = 1.0/sqrt(fn*(fn+1.))
    1 continue
c
c     set upper limit for vector m subscript
c
      mmax = min0(nlat,(nlon+1)/2)
c
c     compute multiple scalar field coefficients
c
      do 2 k=1,nt
c
c     preset to 0.0
c
      do 3 n=1,nlat
      do 4 m=1,mab
      a(m,n,k) = 0.0
      b(m,n,k) = 0.0
    4 continue
    3 continue
c
c     compute m=0 coefficients
c
      do 5 n=2,nlat
      a(1,n,k) = br(1,n,k)*sqnn(n)
      b(1,n,k)= bi(1,n,k)*sqnn(n)
    5 continue
c
c     compute m>0 coefficients
c
      do 6 m=2,mmax
      do 7 n=m,nlat
      a(m,n,k) = sqnn(n)*br(m,n,k)
      b(m,n,k) = sqnn(n)*bi(m,n,k)
    7 continue
    6 continue
    2 continue
c
c     scalar sythesize a,b into sf
c
      call shsgc(nlat,nlon,isym,nt,sf,isf,jsf,a,b,mab,nlat,wsav,
     +           lsav,wk,lwk,ierror)
      return
      end

!
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file gradges.f
!
!     this file includes documentation and code for
!     subroutine grades         i
!
! ... files which must be loaded with gradges.f
!
!     sphcom.f, hrfft.f, shaes.f,vhses.f
!
!     subroutine grades(nlat,nlon,isym,nt,v,w,idvw,jdvw,a,b,mdab,ndab,
!    +                  wvhses,lvhses,work,lwork,ierror)
!
!     given the scalar spherical harmonic coefficients a and b, precomputed
!     by subroutine shaes for a scalar field sf, subroutine grades computes
!     an irrotational vector field (v,w) such that
!
!           gradient(sf) = (v,w).
!
!     v is the colatitudinal and w is the east longitudinal component
!     of the gradient.  i.e.,
!
!            v(i,j) = d(sf(i,j))/dtheta
!
!     and
!
!            w(i,j) = 1/sint*d(sf(i,j))/dlambda
!
!     at colatitude
!
!            theta(i) = (i-1)*pi/(nlat-1)
!
!     and longitude
!
!            lambda(j) = (j-1)*2*pi/nlon.
!
!     where sint = sin(theta(i)).  required associated legendre polynomials
!     are stored rather than recomputed as they are in subroutine gradec
!
!
!     input parameters
!
!
!     nlat   the number of colatitudes on the full sphere including the
!            poles. for example, nlat = 37 for a five degree grid.
!            nlat determines the grid increment in colatitude as
!            pi/(nlat-1).  if nlat is odd the equator is located at
!            grid point i=(nlat+1)/2. if nlat is even the equator is
!            located half way between points i=nlat/2 and i=nlat/2+1.
!            nlat must be at least 3. note: on the half sphere, the
!            number of grid points in the colatitudinal direction is
!            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater than
!            3.  the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!
!     isym   this has the same value as the isym that was input to
!            subroutine shaes to compute the arrays a and b from the
!            scalar field sf.  isym determines whether (v,w) are
!            computed on the full or half sphere as follows:
!
!      = 0
!
!           sf is not symmetric about the equator. in this case
!           the vector field (v,w) is computed on the entire sphere.
!           i.e., in the arrays  v(i,j),w(i,j) for i=1,...,nlat and
!           j=1,...,nlon.
!
!      = 1
!
!           sf is antisymmetric about the equator. in this case w is
!           antisymmetric and v is symmetric about the equator. w
!           and v are computed on the northern hemisphere only.  i.e.,
!           if nlat is odd they are computed for i=1,...,(nlat+1)/2
!           and j=1,...,nlon.  if nlat is even they are computed for
!           i=1,...,nlat/2 and j=1,...,nlon.
!
!      = 2
!
!           sf is symmetric about the equator. in this case w is
!           symmetric and v is antisymmetric about the equator. w
!           and v are computed on the northern hemisphere only.  i.e.,
!           if nlat is odd they are computed for i=1,...,(nlat+1)/2
!           and j=1,...,nlon.  if nlat is even they are computed for
!           i=1,...,nlat/2 and j=1,...,nlon.
!
!
!     nt     nt is the number of scalar and vector fields.  some
!            computational efficiency is obtained for multiple fields.
!            the arrays a,b,v, and w can be three dimensional corresponding
!            to an indexed multiple array sf.  in this case, multiple
!            vector synthesis will be performed to compute each vector
!            field.  the third index for a,b,v, and w is the synthesis
!            index which assumes the values k = 1,...,nt.  for a single
!            synthesis set nt = 1.  the description of the remaining
!            parameters is simplified by assuming that nt=1 or that a,b,v,
!            and w are two dimensional arrays.
!
!     idvw   the first dimension of the arrays v,w as it appears in
!            the program that calls grades. if isym = 0 then idvw
!            must be at least nlat.  if isym = 1 or 2 and nlat is
!            even then idvw must be at least nlat/2. if isym = 1 or 2
!            and nlat is odd then idvw must be at least (nlat+1)/2.
!
!     jdvw   the second dimension of the arrays v,w as it appears in
!            the program that calls grades. jdvw must be at least nlon.
!
!     a,b    two or three dimensional arrays (see input parameter nt)
!            that contain scalar spherical harmonic coefficients
!            of the scalar field array sf as computed by subroutine shaes.
!     ***    a,b must be computed by shaes prior to calling grades.
!
!     mdab   the first dimension of the arrays a and b as it appears in
!            the program that calls grades (and shaes). mdab must be at
!            least min0(nlat,(nlon+2)/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndab   the second dimension of the arrays a and b as it appears in
!            the program that calls grades (and shaes). ndab must be at
!            least nlat.
!
!
!   wvhses   an array which must be initialized by subroutine gradesi
!            (or equivalently by subroutine vhsesi).  once initialized,
!            wsav can be used repeatedly by grades as long as nlon
!            and nlat remain unchanged.  wvhses must not be altered
!            between calls of grades.
!
!
!  lvhses    the dimension of the array wvhses as it appears in the
!            program that calls grades. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd.
!
!            then lvhses must be greater than or equal to
!
!               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls grades. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2                  if nlat is even or
!               l2 = (nlat+1)/2              if nlat is odd
!
!            if isym = 0, lwork must be greater than or equal to
!
!               nlat*((2*nt+1)*nlon+2*l1*nt+1).
!
!            if isym = 1 or 2, lwork must be greater than or equal to
!
!               (2*nt+1)*l2*nlon+nlat*(2*l1*nt+1).
!
!
!     **************************************************************
!
!     output parameters
!
!
!     v,w   two or three dimensional arrays (see input parameter nt) that
!           contain an irrotational vector field such that the gradient of
!           the scalar field sf is (v,w).  w(i,j) is the east longitude
!           component and v(i,j) is the colatitudinal component of velocity
!           at colatitude theta(i) = (i-1)*pi/(nlat-1) and longitude
!           lambda(j) = (j-1)*2*pi/nlon. the indices for v and w are defined
!           at the input parameter isym.  the vorticity of (v,w) is zero.
!           note that any nonzero vector field on the sphere will be
!           multiple valued at the poles [reference swarztrauber].
!
!
!  ierror   = 0  no errors
!           = 1  error in the specification of nlat
!           = 2  error in the specification of nlon
!           = 3  error in the specification of isym
!           = 4  error in the specification of nt
!           = 5  error in the specification of idvw
!           = 6  error in the specification of jdvw
!           = 7  error in the specification of mdab
!           = 8  error in the specification of ndab
!           = 9  error in the specification of lvhses
!           = 10 error in the specification of lwork
! **********************************************************************
!
!
      SUBROUTINE GRADES(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,A,B,Mdab,Ndab,  &
                      & Wvhses,Lvhses,Work,Lwork,Ierror)
      IMPLICIT NONE
!*--GRADES220

      REAL A , B , V , W , Work , Wvhses
      INTEGER ibi , ibr , idv , Idvw , idz , Ierror , imid , is , Isym ,&
            & iwk , Jdvw , lgdmin , liwk , lnl , Lvhses , lwkmin ,      &
            & Lwork , lzimn , Mdab , mmax
      INTEGER mn , Ndab , Nlat , Nlon , Nt

      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt)
      DIMENSION A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wvhses(Lvhses) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat.LT.3 ) RETURN
      Ierror = 2
      IF ( Nlon.LT.4 ) RETURN
      Ierror = 3
      IF ( Isym.LT.0 .OR. Isym.GT.2 ) RETURN
      Ierror = 4
      IF ( Nt.LT.0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym.EQ.0 .AND. Idvw.LT.Nlat) .OR.                          &
         & (Isym.NE.0 .AND. Idvw.LT.imid) ) RETURN
      Ierror = 6
      IF ( Jdvw.LT.Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab.LT.MIN0(Nlat,(Nlon+2)/2) ) RETURN
      Ierror = 8
      IF ( Ndab.LT.Nlat ) RETURN
      Ierror = 9
!
!     verify minimum saved work space length
!
      idz = (mmax*(Nlat+Nlat-mmax+1))/2
      lzimn = idz*imid
      lgdmin = lzimn + lzimn + Nlon + 15
      IF ( Lvhses.LT.lgdmin ) RETURN
      Ierror = 10
!
!     verify minimum unsaved work space length
!
      mn = mmax*Nlat*Nt
      idv = Nlat
      IF ( Isym.NE.0 ) idv = imid
      lnl = Nt*idv*Nlon
      lwkmin = lnl + lnl + idv*Nlon + 2*mn + Nlat
      IF ( Lwork.LT.lwkmin ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ibr = 1
      ibi = ibr + mn
      is = ibi + mn
      iwk = is + Nlat
      liwk = Lwork - 2*mn - Nlat
      CALL GRADES1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Work(ibr),Work(ibi), &
                 & mmax,Work(is),Mdab,Ndab,A,B,Wvhses,Lvhses,Work(iwk), &
                 & liwk,Ierror)
    END SUBROUTINE GRADES

 
    SUBROUTINE GRADES1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Br,Bi,Mmax,    &
                       & Sqnn,Mdab,Ndab,A,B,Wvhses,Lvhses,Wk,Lwk,Ierror)
      IMPLICIT NONE

      REAL A , B , Bi , Br , ci , cr , fn , Sqnn , V , W , Wk , Wvhses
      INTEGER Idvw , Ierror , Isym , ityp , Jdvw , k , Lvhses , Lwk ,   &
            & m , Mdab , Mmax , n , Ndab , Nlat , Nlon , Nt

      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt)
      DIMENSION Br(Mmax,Nlat,Nt) , Bi(Mmax,Nlat,Nt) , Sqnn(Nlat)
      DIMENSION A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wvhses(Lvhses) , Wk(Lwk)
!
!     preset coefficient multiplyers in vector
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.))
      ENDDO
!
!     compute multiple vector fields coefficients
!
      DO k = 1 , Nt
!
!     preset br,bi to 0.0
!
         DO n = 1 , Nlat
            DO m = 1 , Mmax
               Br(m,n,k) = 0.0
               Bi(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            Br(1,n,k) = Sqnn(n)*A(1,n,k)
            Bi(1,n,k) = Sqnn(n)*B(1,n,k)
         ENDDO
!
!     compute m>0 coefficients
!
         DO m = 2 , Mmax
            DO n = m , Nlat
               Br(m,n,k) = Sqnn(n)*A(m,n,k)
               Bi(m,n,k) = Sqnn(n)*B(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     set ityp for irrotational vector synthesis to compute gradient
!
      IF ( Isym.EQ.0 ) THEN
         ityp = 1
      ELSEIF ( Isym.EQ.1 ) THEN
         ityp = 4
      ELSEIF ( Isym.EQ.2 ) THEN
         ityp = 7
      ENDIF
!
!     vector sythesize br,bi into (v,w) (cr,ci are dummy variables)
!
      CALL VHSES(Nlat,Nlon,ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,cr,ci,Mmax,Nlat, &
               & Wvhses,Lvhses,Wk,Lwk,Ierror)
    END SUBROUTINE GRADES1


      SUBROUTINE DGRADES(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,A,B,Mdab,Ndab,  &
                      & Wvhses,Lvhses,Work,Lwork,Ierror)
      IMPLICIT NONE

      DOUBLE PRECISION ::  A , B , V , W , Work , Wvhses
      INTEGER ibi , ibr , idv , Idvw , idz , Ierror , imid , is , Isym ,&
            & iwk , Jdvw , lgdmin , liwk , lnl , Lvhses , lwkmin ,      &
            & Lwork , lzimn , Mdab , mmax
      INTEGER mn , Ndab , Nlat , Nlon , Nt

      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt)
      DIMENSION A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wvhses(Lvhses) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat.LT.3 ) RETURN
      Ierror = 2
      IF ( Nlon.LT.4 ) RETURN
      Ierror = 3
      IF ( Isym.LT.0 .OR. Isym.GT.2 ) RETURN
      Ierror = 4
      IF ( Nt.LT.0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym.EQ.0 .AND. Idvw.LT.Nlat) .OR.                          &
         & (Isym.NE.0 .AND. Idvw.LT.imid) ) RETURN
      Ierror = 6
      IF ( Jdvw.LT.Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab.LT.MIN0(Nlat,(Nlon+2)/2) ) RETURN
      Ierror = 8
      IF ( Ndab.LT.Nlat ) RETURN
      Ierror = 9
!
!     verify minimum saved work space length
!
      idz = (mmax*(Nlat+Nlat-mmax+1))/2
      lzimn = idz*imid
      lgdmin = lzimn + lzimn + Nlon + 15
      IF ( Lvhses.LT.lgdmin ) RETURN
      Ierror = 10
!
!     verify minimum unsaved work space length
!
      mn = mmax*Nlat*Nt
      idv = Nlat
      IF ( Isym.NE.0 ) idv = imid
      lnl = Nt*idv*Nlon
      lwkmin = lnl + lnl + idv*Nlon + 2*mn + Nlat
      IF ( Lwork.LT.lwkmin ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ibr = 1
      ibi = ibr + mn
      is = ibi + mn
      iwk = is + Nlat
      liwk = Lwork - 2*mn - Nlat
      CALL DGRADES1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Work(ibr),Work(ibi), &
                 & mmax,Work(is),Mdab,Ndab,A,B,Wvhses,Lvhses,Work(iwk), &
                 & liwk,Ierror)
      END SUBROUTINE DGRADES

 
      SUBROUTINE DGRADES1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Br,Bi,Mmax,    &
                       & Sqnn,Mdab,Ndab,A,B,Wvhses,Lvhses,Wk,Lwk,Ierror)
      IMPLICIT NONE

      DOUBLE PRECISION  A , B , Bi , Br , ci , cr , fn , Sqnn , V , W , Wk , Wvhses
      INTEGER Idvw , Ierror , Isym , ityp , Jdvw , k , Lvhses , Lwk ,   &
            & m , Mdab , Mmax , n , Ndab , Nlat , Nlon , Nt

      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt)
      DIMENSION Br(Mmax,Nlat,Nt) , Bi(Mmax,Nlat,Nt) , Sqnn(Nlat)
      DIMENSION A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wvhses(Lvhses) , Wk(Lwk)
!
!     preset coefficient multiplyers in vector
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.))
      ENDDO
!
!     compute multiple vector fields coefficients
!
      DO k = 1 , Nt
!
!     preset br,bi to 0.0
!
         DO n = 1 , Nlat
            DO m = 1 , Mmax
               Br(m,n,k) = 0.0
               Bi(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            Br(1,n,k) = Sqnn(n)*A(1,n,k)
            Bi(1,n,k) = Sqnn(n)*B(1,n,k)
         ENDDO
!
!     compute m>0 coefficients
!
         DO m = 2 , Mmax
            DO n = m , Nlat
               Br(m,n,k) = Sqnn(n)*A(m,n,k)
               Bi(m,n,k) = Sqnn(n)*B(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     set ityp for irrotational vector synthesis to compute gradient
!
      IF ( Isym.EQ.0 ) THEN
         ityp = 1
      ELSEIF ( Isym.EQ.1 ) THEN
         ityp = 4
      ELSEIF ( Isym.EQ.2 ) THEN
         ityp = 7
      ENDIF
!
!     vector sythesize br,bi into (v,w) (cr,ci are dummy variables)
!
      CALL DVHSES(Nlat,Nlon,ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,cr,ci,Mmax,Nlat, &
               & Wvhses,Lvhses,Wk,Lwk,Ierror)
    END SUBROUTINE DGRADES1

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file ivrtgs.f
!
!     this file includes documentation and code for
!     subroutine ivrtgs
!
! ... files which must be loaded with ivrtgs.f
!
!     sphcom.f, hrfft.f, vhsgs.f,shags.f, gaqd.f
!
!
!     subroutine ivrtgs(nlat,nlon,isym,nt,v,w,idvw,jdvw,a,b,mdab,ndab,
!    +                  wvhsgs,lvhsgs,work,lwork,pertrb,ierror)
!
!     given the scalar spherical harmonic coefficients a and b, precomputed
!     by subroutine shags for a scalar array vt, subroutine ivrtgs computes
!     a divergence free vector field (v,w) whose vorticity is vt - pertrb.
!     w is the east longitude component and v is the colatitudinal component.
!     pertrb is a constant which must be subtracted from vt for (v,w) to
!     exist (see the description of pertrb below).  usually pertrb is zero
!     or small relative to vt.  the divergence of (v,w), as computed by
!     ivrtgs, is the zero scalar field.  v(i,j) and w(i,j) are the
!     colatitudinal and east longitude velocity components at gaussian
!     colatitude theta(i) (see nlat as input parameter) and longitude
!     lambda(j) = (j-1)*2*pi/nlon.  the
!
!            vorticity(v(i,j),w(i,j))
!
!         =  [-dv/dlambda + d(sint*w)/dtheta]/sint
!
!         =  vort(i,j) - pertrb
!
!     and
!
!            divergence(v(i,j),w(i,j))
!
!         =  [d(sint*v)/dtheta + dw/dlambda]/sint
!
!         =  0.0
!
!     where sint = sin(theta(i)).  required associated legendre polynomials
!     are stored rather than recomputed as they are in subroutine ivrtgc.
!
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are computed
!            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid point
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than 3. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!
!     isym   this has the same value as the isym that was input to
!            subroutine shags to compute the arrays a and b.  isym
!            determines whether (v,w) are computed on the full or half
!            sphere as follows:
!
!      = 0
!            vt is not symmetric about the equator. in this case
!            the vector field (v,w) is computed on the entire sphere.
!            i.e., in the arrays  v(i,j),w(i,j) for i=1,...,nlat and
!            j=1,...,nlon.
!
!      = 1
!
!            vt is symmetric about the equator. in this case w is
!            antiymmetric and v is symmetric about the equator. v
!            and w are computed on the northern hemisphere only.  i.e.,
!            if nlat is odd they are computed for i=1,...,(nlat+1)/2
!            and j=1,...,nlon.  if nlat is even they are computed for
!            i=1,...,nlat/2 and j=1,...,nlon.
!
!       = 2
!
!            vt is antisymmetric about the equator. in this case w is
!            symmetric and v is antisymmetric about the equator. w
!            and v are computed on the northern hemisphere only.  i.e.,
!            if nlat is odd they are computed for i=1,...,(nlat+1)/2
!            and j=1,...,nlon.  if nlat is even they are computed for
!            i=1,...,nlat/2 and j=1,...,nlon.
!
!
!     nt     in the program that calls ivrtgs, nt is the number of vorticity
!            and vector fields.  some computational efficiency is obtained
!            for multiple fields.  the arrays a,b,v, and w can be three
!            dimensional and pertrb can be one dimensional corresponding
!            to an indexed multiple array vt.  in this case, multiple vector
!            synthesis will be performed to compute each vector field.  the
!            third index for a,b,v,w and first for pertrb is the synthesis
!            index which assumes the values k=1,...,nt.  for a single
!            synthesis set nt=1. the description of the remaining parameters
!            is simplified by assuming that nt=1 or that a,b,v,w are two
!            dimensional and pertrb is a constant.
!
!     idvw   the first dimension of the arrays v,w as it appears in
!            the program that calls ivrtgs. if isym = 0 then idvw
!            must be at least nlat.  if isym = 1 or 2 and nlat is
!            even then idvw must be at least nlat/2. if isym = 1 or 2
!            and nlat is odd then idvw must be at least (nlat+1)/2.
!
!     jdvw   the second dimension of the arrays v,w as it appears in
!            the program that calls ivrtgs. jdvw must be at least nlon.
!
!     a,b    two or three dimensional arrays (see input parameter nt)
!            that contain scalar spherical harmonic coefficients
!            of the vorticity array vt as computed by subroutine shags.
!     ***    a,b must be computed by shags prior to calling ivrtgs.
!
!     mdab   the first dimension of the arrays a and b as it appears in
!            the program that calls ivrtgs (and shags). mdab must be at
!            least min0(nlat,(nlon+2)/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndab   the second dimension of the arrays a and b as it appears in
!            the program that calls ivrtgs (and shags). ndab must be at
!            least nlat.
!
!
!  wvhsgs    an array which must be initialized by subroutine vhsgsi.
!            once initialized
!            wvhsgs can be used repeatedly by ivrtgs as long as nlon
!            and nlat remain unchanged.  wvhsgs must not be altered
!            between calls of ivrtgs.
!
!
!  lvhsgs    the dimension of the array wvhsgs as it appears in the
!            program that calls ivrtgs. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lvhsgs must be at least
!
!               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
!
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls ivrtgs. define
!
!               l2 = nlat/2                    if nlat is even or
!               l2 = (nlat+1)/2                if nlat is odd
!               l1 = min0(nlat,nlon/2)         if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2)     if nlon is odd
!
!            if isym = 0 then lwork must be at least
!
!               (2*nt+1)*nlat*nlon + nlat*(2*nt*l1+1)
!
!            if isym = 1 or 2 then lwork must be at least
!
!               (2*nt+1)*l2*nlon + nlat*(2*nt*l1+1)
!
!
!     **************************************************************
!
!     output parameters
!
!
!     v,w   two or three dimensional arrays (see input parameter nt) that
!           contain a divergence free vector field whose vorticity is
!           vt - pertrb at the gaussian colatitude point theta(i)
!           and longitude point lambda(j)=(j-1)*2*pi/nlon.  w is the east
!           longitude component and v is the colatitudinal component.  the
!           indices for v and w are defined at the input parameter isym.
!           the divergence of (v,w) is the zero scalar field.
!
!   pertrb  a nt dimensional array (see input parameter nt and assume nt=1
!           for the description that follows).  vt - pertrb is a scalar
!           field which can be the vorticity of a vector field (v,w).
!           pertrb is related to the scalar harmonic coefficients a,b
!           of vt (computed by shags) by the formula
!
!                pertrb = a(1,1)/(2.*sqrt(2.))
!
!           an unperturbed vt can be the vorticity of a vector field
!           only if a(1,1) is zero.  if a(1,1) is nonzero (flagged by
!           pertrb nonzero) then subtracting pertrb from vt yields a
!           scalar field for which a(1,1) is zero.
!
!    ierror = 0  no errors
!           = 1  error in the specification of nlat
!           = 2  error in the specification of nlon
!           = 3  error in the specification of isym
!           = 4  error in the specification of nt
!           = 5  error in the specification of idvw
!           = 6  error in the specification of jdvw
!           = 7  error in the specification of mdab
!           = 8  error in the specification of ndab
!           = 9  error in the specification of lvhsgs
!           = 10 error in the specification of lwork
! **********************************************************************
!
!
      SUBROUTINE IVRTGS(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,A,B,Mdab,Ndab,  &
                      & Wvhsgs,Lvhsgs,Work,Lwork,Pertrb,Ierror)
      IMPLICIT NONE
      REAL A , B , Pertrb , V , W , Work , Wvhsgs
      INTEGER ici , icr , Idvw , idz , Ierror , imid , is , Isym , iwk ,&
            & Jdvw , liwk , Lvhsgs , Lwork , lzimn , Mdab , mmax , mn , &
            & Ndab , Nlat , Nlon
      INTEGER Nt
      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt) , Pertrb(Nt)
      DIMENSION A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wvhsgs(Lvhsgs) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idvw<Nlat) .OR. (Isym/=0 .AND. Idvw<imid) )   &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<MIN0(Nlat,(Nlon+2)/2) ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
!     lzz1 = 2*nlat*imid
!     labc = 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     if(lvhsgs .lt. 2*(lzz1+labc)+nlon+15) return
      idz = (mmax*(Nlat+Nlat-mmax+1))/2
      lzimn = idz*imid
      IF ( Lvhsgs<lzimn+lzimn+Nlon+15 ) RETURN
      Ierror = 10
!
!     verify unsaved work space length
!
      mn = mmax*Nlat*Nt
      IF ( Isym/=0 .AND. Lwork<Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon))       &
         & +2*mn+Nlat ) RETURN
      IF ( Isym==0 .AND. Lwork<imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon))       &
         & +2*mn+Nlat ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      icr = 1
      ici = icr + mn
      is = ici + mn
      iwk = is + Nlat
      liwk = Lwork - 2*mn - Nlat
      CALL IVTGS1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Work(icr),Work(ici),  &
                & mmax,Work(is),Mdab,Ndab,A,B,Wvhsgs,Lvhsgs,Work(iwk),  &
                & liwk,Pertrb,Ierror)
      END SUBROUTINE IVRTGS
 
      SUBROUTINE IVTGS1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Cr,Ci,Mmax,Sqnn,&
                      & Mdab,Ndab,A,B,Wsav,Lsav,Wk,Lwk,Pertrb,Ierror)
      IMPLICIT NONE
      REAL A , B , bi , br , Ci , Cr , fn , Pertrb , Sqnn , V , W , Wk ,&
         & Wsav
      INTEGER Idvw , Ierror , Isym , ityp , Jdvw , k , Lsav , Lwk , m , &
            & Mdab , Mmax , n , Ndab , Nlat , Nlon , Nt
      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt) , Pertrb(Nt)
      DIMENSION Cr(Mmax,Nlat,Nt) , Ci(Mmax,Nlat,Nt) , Sqnn(Nlat)
      DIMENSION A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wsav(Lsav) , Wk(Lwk)
!
!     preset coefficient multiplyers in vector
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.))
      ENDDO
!
!     compute multiple vector fields coefficients
!
      DO k = 1 , Nt
!
!     set vorticity field perturbation adjustment
!
         Pertrb(k) = A(1,1,k)/(2.*SQRT(2.))
!
!     preset br,bi to 0.0
!
         DO n = 1 , Nlat
            DO m = 1 , Mmax
               Cr(m,n,k) = 0.0
               Ci(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            Cr(1,n,k) = A(1,n,k)/Sqnn(n)
            Ci(1,n,k) = B(1,n,k)/Sqnn(n)
         ENDDO
!
!     compute m>0 coefficients
!
         DO m = 2 , Mmax
            DO n = m , Nlat
               Cr(m,n,k) = A(m,n,k)/Sqnn(n)
               Ci(m,n,k) = B(m,n,k)/Sqnn(n)
            ENDDO
         ENDDO
      ENDDO
!
!     set ityp for vector synthesis with divergence=0
!
      IF ( Isym==0 ) THEN
         ityp = 2
      ELSEIF ( Isym==1 ) THEN
         ityp = 5
      ELSEIF ( Isym==2 ) THEN
         ityp = 8
      ENDIF
!
!     vector sythesize cr,ci into divergence free vector field (v,w)
!
      CALL VHSGS(Nlat,Nlon,ityp,Nt,V,W,Idvw,Jdvw,br,bi,Cr,Ci,Mmax,Nlat, &
               & Wsav,Lsav,Wk,Lwk,Ierror)
      END SUBROUTINE IVTGS1


      SUBROUTINE DIVRTGS(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,A,B,Mdab,Ndab,  &
                      & Wvhsgs,Lvhsgs,Work,Lwork,Pertrb,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , Pertrb , V , W , Work , Wvhsgs
      INTEGER ici , icr , Idvw , idz , Ierror , imid , is , Isym , iwk ,&
            & Jdvw , liwk , Lvhsgs , Lwork , lzimn , Mdab , mmax , mn , &
            & Ndab , Nlat , Nlon
      INTEGER Nt
      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt) , Pertrb(Nt)
      DIMENSION A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wvhsgs(Lvhsgs) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idvw<Nlat) .OR. (Isym/=0 .AND. Idvw<imid) )   &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<MIN0(Nlat,(Nlon+2)/2) ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
!     lzz1 = 2*nlat*imid
!     labc = 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     if(lvhsgs .lt. 2*(lzz1+labc)+nlon+15) return
      idz = (mmax*(Nlat+Nlat-mmax+1))/2
      lzimn = idz*imid
      IF ( Lvhsgs<lzimn+lzimn+Nlon+15 ) RETURN
      Ierror = 10
!
!     verify unsaved work space length
!
      mn = mmax*Nlat*Nt
      IF ( Isym/=0 .AND. Lwork<Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon))       &
         & +2*mn+Nlat ) RETURN
      IF ( Isym==0 .AND. Lwork<imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon))       &
         & +2*mn+Nlat ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      icr = 1
      ici = icr + mn
      is = ici + mn
      iwk = is + Nlat
      liwk = Lwork - 2*mn - Nlat
      CALL DIVTGS1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Work(icr),Work(ici),  &
                & mmax,Work(is),Mdab,Ndab,A,B,Wvhsgs,Lvhsgs,Work(iwk),  &
                & liwk,Pertrb,Ierror)
      END SUBROUTINE DIVRTGS
 
      SUBROUTINE DIVTGS1(Nlat,Nlon,Isym,Nt,V,W,Idvw,Jdvw,Cr,Ci,Mmax,Sqnn,&
                      & Mdab,Ndab,A,B,Wsav,Lsav,Wk,Lwk,Pertrb,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , bi , br , Ci , Cr , fn , Pertrb , Sqnn , V , W , Wk ,&
         & Wsav
      INTEGER Idvw , Ierror , Isym , ityp , Jdvw , k , Lsav , Lwk , m , &
            & Mdab , Mmax , n , Ndab , Nlat , Nlon , Nt
      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt) , Pertrb(Nt)
      DIMENSION Cr(Mmax,Nlat,Nt) , Ci(Mmax,Nlat,Nt) , Sqnn(Nlat)
      DIMENSION A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wsav(Lsav) , Wk(Lwk)
!
!     preset coefficient multiplyers in vector
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.))
      ENDDO
!
!     compute multiple vector fields coefficients
!
      DO k = 1 , Nt
!
!     set vorticity field perturbation adjustment
!
         Pertrb(k) = A(1,1,k)/(2.*SQRT(2.))
!
!     preset br,bi to 0.0
!
         DO n = 1 , Nlat
            DO m = 1 , Mmax
               Cr(m,n,k) = 0.0
               Ci(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            Cr(1,n,k) = A(1,n,k)/Sqnn(n)
            Ci(1,n,k) = B(1,n,k)/Sqnn(n)
         ENDDO
!
!     compute m>0 coefficients
!
         DO m = 2 , Mmax
            DO n = m , Nlat
               Cr(m,n,k) = A(m,n,k)/Sqnn(n)
               Ci(m,n,k) = B(m,n,k)/Sqnn(n)
            ENDDO
         ENDDO
      ENDDO
!
!     set ityp for vector synthesis with divergence=0
!
      IF ( Isym==0 ) THEN
         ityp = 2
      ELSEIF ( Isym==1 ) THEN
         ityp = 5
      ELSEIF ( Isym==2 ) THEN
         ityp = 8
      ENDIF
!
!     vector sythesize cr,ci into divergence free vector field (v,w)
!
      CALL DVHSGS(Nlat,Nlon,ityp,Nt,V,W,Idvw,Jdvw,br,bi,Cr,Ci,Mmax,Nlat, &
               & Wsav,Lsav,Wk,Lwk,Ierror)
      END SUBROUTINE DIVTGS1

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file shsgs.f
!
!     this file contains code and documentation for subroutines
!     shsgs and shsgsi
!
! ... files which must be loaded with shsgs.f
 
!     sphcom.f, hrfft.f, gaqd.f
!
!     subroutine shsgs(nlat,nlon,isym,nt,g,idg,jdg,a,b,mdab,ndab,
!    1                    wshsgs,lshsgs,work,lwork,ierror)
!
!     subroutine shsgs performs the spherical harmonic synthesis
!     on the arrays a and b and stores the result in the array g.
!     the synthesis is performed on an equally spaced longitude grid
!     and a gaussian colatitude grid.  the associated legendre functions
!     are stored rather than recomputed as they are in subroutine
!     shsgc.  the synthesis is described below at output parameter
!     g.
!
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are compu
!            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid poi
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than or equal to 4. the efficiency of the computation is
!            improved when nlon is a product of small prime numbers.
!
!     isym   = 0  no symmetries exist about the equator. the synthesis
!                 is performed on the entire sphere.  i.e. on the
!                 array g(i,j) for i=1,...,nlat and j=1,...,nlon.
!                 (see description of g below)
!
!            = 1  g is antisymmetric about the equator. the synthesis
!                 is performed on the northern hemisphere only.  i.e.
!                 if nlat is odd the synthesis is performed on the
!                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
!                 if nlat is even the synthesis is performed on the
!                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!
!            = 2  g is symmetric about the equator. the synthesis is
!                 performed on the northern hemisphere only.  i.e.
!                 if nlat is odd the synthesis is performed on the
!                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
!                 if nlat is even the synthesis is performed on the
!                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!     nt     the number of syntheses.  in the program that calls shsgs,
!            the arrays g,a and b can be three dimensional in which
!            case multiple synthesis will be performed.  the third
!            index is the synthesis index which assumes the values
!            k=1,...,nt.  for a single synthesis set nt=1. the
!            discription of the remaining parameters is simplified
!            by assuming that nt=1 or that the arrays g,a and b
!            have only two dimensions.
!
!     idg    the first dimension of the array g as it appears in the
!            program that calls shagc. if isym equals zero then idg
!            must be at least nlat.  if isym is nonzero then idg must
!            be at least nlat/2 if nlat is even or at least (nlat+1)/2
!            if nlat is odd.
!
!     jdg    the second dimension of the array g as it appears in the
!            program that calls shagc. jdg must be at least nlon.
!
!     a,b    two or three dimensional arrays (see the input parameter
!            nt) that contain the coefficients in the spherical harmonic
!            expansion of g(i,j) given below at the definition of the
!            output parameter g.  a(m,n) and b(m,n) are defined for
!            indices m=1,...,mmax and n=m,...,nlat where mmax is the
!            maximum (plus one) longitudinal wave number given by
!            mmax = min0(nlat,(nlon+2)/2) if nlon is even or
!            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     mdab   the first dimension of the arrays a and b as it appears
!            in the program that calls shsgs. mdab must be at least
!            min0((nlon+2)/2,nlat) if nlon is even or at least
!            min0((nlon+1)/2,nlat) if nlon is odd.
!
!     ndab   the second dimension of the arrays a and b as it appears
!            in the program that calls shsgs. ndab must be at least nlat
!
!     wshsgs an array which must be initialized by subroutine shsgsi.
!            once initialized, wshsgs can be used repeatedly by shsgs
!            as long as nlat and nlon remain unchanged.  wshsgs must
!            not be altered between calls of shsgs.
!
!     lshsgs the dimension of the array wshsgs as it appears in the
!            program that calls shsgs. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshsgs must be at least
!
!            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
!
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls shsgs. define
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!
!            if isym is zero then lwork must be at least
!
!                  nlat*nlon*(nt+1)
!
!            if isym is nonzero then lwork must be at least
!
!                  l2*nlon*(nt+1)
!
!
!     **************************************************************
!
!     output parameters
!
!     g      a two or three dimensional array (see input parameter nt)
!            that contains the discrete function which is synthesized.
!            g(i,j) contains the value of the function at the gaussian
!            colatitude point theta(i) and longitude point
!            phi(j) = (j-1)*2*pi/nlon. the index ranges are defined
!            above at the input parameter isym.  for isym=0, g(i,j)
!            is given by the the equations listed below.  symmetric
!            versions are used when isym is greater than zero.
!
!     the normalized associated legendre functions are given by
!
!     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
!                       *sin(theta)**m/(2**n*factorial(n)) times the
!                       (n+m)th derivative of (x**2-1)**n with respect
!                       to x=cos(theta)
!
!     define the maximum (plus one) longitudinal wave number
!     as   mmax = min0(nlat,(nlon+2)/2) if nlon is even or
!          mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     then g(i,j) = the sum from n=0 to n=nlat-1 of
!
!                   .5*pbar(0,n,theta(i))*a(1,n+1)
!
!              plus the sum from m=1 to m=mmax-1 of
!
!                   the sum from n=m to n=nlat-1 of
!
!              pbar(m,n,theta(i))*(a(m+1,n+1)*cos(m*phi(j))
!                                    -b(m+1,n+1)*sin(m*phi(j)))
!
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of isym
!            = 4  error in the specification of nt
!            = 5  error in the specification of idg
!            = 6  error in the specification of jdg
!            = 7  error in the specification of mdab
!            = 8  error in the specification of ndab
!            = 9  error in the specification of lshsgs
!            = 10 error in the specification of lwork
!
!
! ****************************************************************
!
!     subroutine shsgsi(nlat,nlon,wshsgs,lshsgs,work,lwork,dwork,ldwork,
!    +                  ierror)
!
!     subroutine shsgsi initializes the array wshsgs which can then
!     be used repeatedly by subroutines shsgs. it precomputes
!     and stores in wshsgs quantities such as gaussian weights,
!     legendre polynomial coefficients, and fft trigonometric tables.
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are compu
!            in radians in theta(1),...,theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid poi
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than or equal to 4. the efficiency of the computation is
!            improved when nlon is a product of small prime numbers.
!
!     wshsgs an array which must be initialized by subroutine shsgsi.
!            once initialized, wshsgs can be used repeatedly by shsgs
!            as long as nlat and nlon remain unchanged.  wshsgs must
!            not be altered between calls of shsgs.
!
!     lshsgs the dimension of the array wshsgs as it appears in the
!            program that calls shsgs. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshsgs must be at least
!
!            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
!
!     work   a real work space which need not be saved
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls shsgsi. lwork must be at least
!            4*nlat*(nlat+2)+2 in the routine calling shsgsi
!
!     dwork   a double precision work array that does not have to be saved.
!
!     ldwork  the length of dwork in the calling routine.  ldwork must
!             be at least nlat*(nlat+4)
!
!     output parameter
!
!     wshsgs an array which must be initialized before calling shsgs or
!            once initialized, wshsgs can be used repeatedly by shsgs or
!            as long as nlat and nlon remain unchanged.  wshsgs must not
!            altered between calls of shsgs.
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of lshsgs
!            = 4  error in the specification of lwork
!            = 5  error in the specification of ldwork
!            = 5  failure in gaqd to compute gaussian points
!                 (due to failure in eigenvalue routine)
!
!
      SUBROUTINE SHSGS(Nlat,Nlon,Mode,Nt,G,Idg,Jdg,A,B,Mdab,Ndab,Wshsgs,&
                     & Lshsgs,Work,Lwork,Ierror)
      IMPLICIT NONE
      REAL A , B , G , Work , Wshsgs
      INTEGER Idg , Ierror , ifft , ipmn , iw , Jdg , l , l1 , l2 ,     &
            & lat , late , lp , Lshsgs , Lwork , Mdab , Mode , Ndab ,   &
            & Nlat , Nlon , Nt
      DIMENSION G(Idg,Jdg,1) , A(Mdab,Ndab,1) , B(Mdab,Ndab,1) ,        &
              & Wshsgs(Lshsgs) , Work(Lwork)
!     check input parameters
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Mode<0 .OR. Mode>2 ) RETURN
      Ierror = 4
      IF ( Nt<1 ) RETURN
!     set limit on m subscript
      l = MIN0((Nlon+2)/2,Nlat)
!     set gaussian point nearest equator pointer
      late = (Nlat+MOD(Nlat,2))/2
!     set number of grid points for analysis/synthesis
      lat = Nlat
      IF ( Mode/=0 ) lat = late
      Ierror = 5
      IF ( Idg<lat ) RETURN
      Ierror = 6
      IF ( Jdg<Nlon ) RETURN
      Ierror = 7
      IF ( Mdab<l ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      l1 = l
      l2 = late
      Ierror = 9
!     check permanent work space length
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshsgs<lp ) RETURN
!     check temporary work space length
      Ierror = 10
      IF ( Mode==0 .AND. Lwork<Nlat*Nlon*(Nt+1) ) RETURN
      IF ( Mode/=0 .AND. Lwork<l2*Nlon*(Nt+1) ) RETURN
      Ierror = 0
!     starting address for fft values and legendre polys in wshsgs
      ifft = Nlat + 2*Nlat*late + 3*(l*(l-1)/2+(Nlat-l)*(l-1)) + 1
      ipmn = ifft + Nlon + 15
!     set pointer for internal storage of g
      iw = lat*Nlon*Nt + 1
      CALL SHSGS1(Nlat,Nlon,l,lat,Mode,G,Idg,Jdg,Nt,A,B,Mdab,Ndab,      &
                & Wshsgs(ifft),Wshsgs(ipmn),late,Work,Work(iw))
    END SUBROUTINE SHSGS

      
    SUBROUTINE SHSGS1(Nlat,Nlon,L,Lat,Mode,Gs,Idg,Jdg,Nt,A,B,Mdab,    &
                      & Ndab,Wfft,Pmn,Late,G,Work)
      IMPLICIT NONE
      REAL A , B , G , Gs , Pmn , t1 , t2 , t3 , t4 , Wfft , Work
      INTEGER i , Idg , is , j , Jdg , k , L , Lat , Late , lm1 , lp1 , &
            & m , Mdab , meo , mml1 , mn , Mode , mp1 , mp2 , ms
      INTEGER Ndab , nl2 , Nlat , Nlon , np1 , ns , Nt
      DIMENSION Gs(Idg,Jdg,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wfft(1) , Pmn(Late,1) , G(Lat,Nlon,Nt) , Work(1)
 
!     reconstruct fourier coefficients in g on gaussian grid
!     using coefficients in a,b
 
!     initialize to zero
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               G(i,j,k) = 0.0
            ENDDO
         ENDDO
      ENDDO
 
      lm1 = L
      IF ( Nlon==L+L-2 ) lm1 = L - 1
      IF ( Mode==0 ) THEN
!     set first column in g
         m = 0
         mml1 = m*(2*Nlat-m-1)/2
         DO k = 1 , Nt
!     n even
            DO np1 = 1 , Nlat , 2
               mn = mml1 + np1
               DO i = 1 , Late
                  G(i,1,k) = G(i,1,k) + A(1,np1,k)*Pmn(i,mn)
               ENDDO
            ENDDO
!     n odd
            nl2 = Nlat/2
            DO np1 = 2 , Nlat , 2
               mn = mml1 + np1
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  G(is,1,k) = G(is,1,k) + A(1,np1,k)*Pmn(i,mn)
               ENDDO
            ENDDO
         ENDDO
 
!     restore m=0 coefficients from odd/even
         DO k = 1 , Nt
            DO i = 1 , nl2
               is = Nlat - i + 1
               t1 = G(i,1,k)
               t3 = G(is,1,k)
               G(i,1,k) = t1 + t3
               G(is,1,k) = t1 - t3
            ENDDO
         ENDDO
 
!     sweep interior columns of g
         DO mp1 = 2 , lm1
            m = mp1 - 1
            mml1 = m*(2*Nlat-m-1)/2
            mp2 = m + 2
            DO k = 1 , Nt
!     for n-m even store (g(i,p,k)+g(nlat-i+1,p,k))/2 in g(i,p,k) p=2*m,2*m+1
!     for i=1,...,late
               DO np1 = mp1 , Nlat , 2
                  mn = mml1 + np1
                  DO i = 1 , Late
                     G(i,2*m,k) = G(i,2*m,k) + A(mp1,np1,k)*Pmn(i,mn)
                     G(i,2*m+1,k) = G(i,2*m+1,k) + B(mp1,np1,k)         &
                                  & *Pmn(i,mn)
                  ENDDO
               ENDDO
 
!     for n-m odd store g(i,p,k)-g(nlat-i+1,p,k) in g(nlat-i+1,p,k)
!     for i=1,...,nlat/2 (p=2*m,p=2*m+1)
               DO np1 = mp2 , Nlat , 2
                  mn = mml1 + np1
                  DO i = 1 , nl2
                     is = Nlat - i + 1
                     G(is,2*m,k) = G(is,2*m,k) + A(mp1,np1,k)*Pmn(i,mn)
                     G(is,2*m+1,k) = G(is,2*m+1,k) + B(mp1,np1,k)       &
                                   & *Pmn(i,mn)
                  ENDDO
               ENDDO
 
!     now set fourier coefficients using even-odd reduction above
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  t1 = G(i,2*m,k)
                  t2 = G(i,2*m+1,k)
                  t3 = G(is,2*m,k)
                  t4 = G(is,2*m+1,k)
                  G(i,2*m,k) = t1 + t3
                  G(i,2*m+1,k) = t2 + t4
                  G(is,2*m,k) = t1 - t3
                  G(is,2*m+1,k) = t2 - t4
               ENDDO
 
            ENDDO
         ENDDO
 
!     set last column (using a only) if necessary
         IF ( Nlon==L+L-2 ) THEN
            m = L - 1
            mml1 = m*(2*Nlat-m-1)/2
            DO k = 1 , Nt
!     n-m even
               DO np1 = L , Nlat , 2
                  mn = mml1 + np1
                  DO i = 1 , Late
                     G(i,Nlon,k) = G(i,Nlon,k) + 2.0*A(L,np1,k)         &
                                 & *Pmn(i,mn)
 
                  ENDDO
               ENDDO
               lp1 = L + 1
!     n-m odd
               DO np1 = lp1 , Nlat , 2
                  mn = mml1 + np1
                  DO i = 1 , nl2
                     is = Nlat - i + 1
                     G(is,Nlon,k) = G(is,Nlon,k) + 2.0*A(L,np1,k)       &
                                  & *Pmn(i,mn)
                  ENDDO
               ENDDO
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  t1 = G(i,Nlon,k)
                  t3 = G(is,Nlon,k)
                  G(i,Nlon,k) = t1 + t3
                  G(is,Nlon,k) = t1 - t3
               ENDDO
            ENDDO
         ENDIF
 
      ELSE
!     half sphere (mode.ne.0)
!     set first column in g
         m = 0
         mml1 = m*(2*Nlat-m-1)/2
         meo = 1
         IF ( Mode==1 ) meo = 2
         ms = m + meo
         DO k = 1 , Nt
            DO np1 = ms , Nlat , 2
               mn = mml1 + np1
               DO i = 1 , Late
                  G(i,1,k) = G(i,1,k) + A(1,np1,k)*Pmn(i,mn)
               ENDDO
            ENDDO
         ENDDO
 
!     sweep interior columns of g
 
         DO mp1 = 2 , lm1
            m = mp1 - 1
            mml1 = m*(2*Nlat-m-1)/2
            ms = m + meo
            DO k = 1 , Nt
               DO np1 = ms , Nlat , 2
                  mn = mml1 + np1
                  DO i = 1 , Late
                     G(i,2*m,k) = G(i,2*m,k) + A(mp1,np1,k)*Pmn(i,mn)
                     G(i,2*m+1,k) = G(i,2*m+1,k) + B(mp1,np1,k)         &
                                  & *Pmn(i,mn)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
 
         IF ( Nlon==L+L-2 ) THEN
!     set last column
            m = L - 1
            mml1 = m*(2*Nlat-m-1)/2
            ns = L
            IF ( Mode==1 ) ns = L + 1
            DO k = 1 , Nt
               DO np1 = ns , Nlat , 2
                  mn = mml1 + np1
                  DO i = 1 , Late
                     G(i,Nlon,k) = G(i,Nlon,k) + 2.0*A(L,np1,k)         &
                                 & *Pmn(i,mn)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
 
      ENDIF
 
 
!     do inverse fourier transform
      DO k = 1 , Nt
         CALL HRFFTB(Lat,Nlon,G(1,1,k),Lat,Wfft,Work)
      ENDDO
!     scale output in gs
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               Gs(i,j,k) = 0.5*G(i,j,k)
            ENDDO
         ENDDO
      ENDDO
 
      END SUBROUTINE SHSGS1


      SUBROUTINE SHSGSI(Nlat,Nlon,Wshsgs,Lshsgs,Work,Lwork,Dwork,Ldwork,&
                      & Ierror)
      IMPLICIT NONE
      INTEGER Ierror , l , l1 , l2 , late , ldw , Ldwork , lp , Lshsgs ,&
            & Lwork , Nlat , Nlon
      REAL Work , Wshsgs
!
!     this subroutine must be called before calling shags or shsgs with
!     fixed nlat,nlon. it precomputes the gaussian weights, points
!     and all necessary legendre polys and stores them in wshsgs.
!     these quantities must be preserved when calling shsgs
!     repeatedly with fixed nlat,nlon.
!
      DIMENSION Wshsgs(Lshsgs) , Work(Lwork)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+1)/2
      l1 = l
      l2 = late
!     check permanent work space length
      Ierror = 3
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshsgs<lp ) RETURN
      Ierror = 4
!     check temporary work space
      IF ( Lwork<4*Nlat*(Nlat+2)+2 ) RETURN
      Ierror = 5
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set preliminary quantites needed to compute and store legendre polys
      ldw = Nlat*(Nlat+4)
      CALL SHSGSP(Nlat,Nlon,Wshsgs,Lshsgs,Dwork,Ldwork,Ierror)
      IF ( Ierror/=0 ) RETURN
!
!     this subroutine must be called before calling shags or shsgs with
!     fixed nlat,nlon. it precomputes the gaussian weights, points
!     and all necessary legendre polys and stores them in wshsgs.
!     these quantities must be preserved when calling shsgs
!     repeatedly with fixed nlat,nlon.
!
!     set triangular truncation limit for spherical harmonic basis
!     set equator or nearest point (if excluded) pointer
!     check permanent work space length
!     check temporary work space
!     set preliminary quantites needed to compute and store legendre polys
!     set legendre poly pointer in wshsgs
      END SUBROUTINE SHSGSI


      
      SUBROUTINE DSHSGS(Nlat,Nlon,Mode,Nt,G,Idg,Jdg,A,B,Mdab,Ndab,Wshsgs,&
                     & Lshsgs,Work,Lwork,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , G , Work , Wshsgs
      INTEGER Idg , Ierror , ifft , ipmn , iw , Jdg , l , l1 , l2 ,     &
            & lat , late , lp , Lshsgs , Lwork , Mdab , Mode , Ndab ,   &
            & Nlat , Nlon , Nt
      DIMENSION G(Idg,Jdg,1) , A(Mdab,Ndab,1) , B(Mdab,Ndab,1) ,        &
              & Wshsgs(Lshsgs) , Work(Lwork)
!     check input parameters
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Mode<0 .OR. Mode>2 ) RETURN
      Ierror = 4
      IF ( Nt<1 ) RETURN
!     set limit on m subscript
      l = MIN0((Nlon+2)/2,Nlat)
!     set gaussian point nearest equator pointer
      late = (Nlat+MOD(Nlat,2))/2
!     set number of grid points for analysis/synthesis
      lat = Nlat
      IF ( Mode/=0 ) lat = late
      Ierror = 5
      IF ( Idg<lat ) RETURN
      Ierror = 6
      IF ( Jdg<Nlon ) RETURN
      Ierror = 7
      IF ( Mdab<l ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      l1 = l
      l2 = late
      Ierror = 9
!     check permanent work space length
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshsgs<lp ) RETURN
!     check temporary work space length
      Ierror = 10
      IF ( Mode==0 .AND. Lwork<Nlat*Nlon*(Nt+1) ) RETURN
      IF ( Mode/=0 .AND. Lwork<l2*Nlon*(Nt+1) ) RETURN
      Ierror = 0
!     starting address for fft values and legendre polys in wshsgs
      ifft = Nlat + 2*Nlat*late + 3*(l*(l-1)/2+(Nlat-l)*(l-1)) + 1
      ipmn = ifft + Nlon + 15
!     set pointer for internal storage of g
      iw = lat*Nlon*Nt + 1
      CALL DSHSGS1(Nlat,Nlon,l,lat,Mode,G,Idg,Jdg,Nt,A,B,Mdab,Ndab,      &
                & Wshsgs(ifft),Wshsgs(ipmn),late,Work,Work(iw))
    END SUBROUTINE DSHSGS

      
    SUBROUTINE DSHSGS1(Nlat,Nlon,L,Lat,Mode,Gs,Idg,Jdg,Nt,A,B,Mdab,    &
                      & Ndab,Wfft,Pmn,Late,G,Work)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , G , Gs , Pmn , t1 , t2 , t3 , t4 , Wfft , Work
      INTEGER i , Idg , is , j , Jdg , k , L , Lat , Late , lm1 , lp1 , &
            & m , Mdab , meo , mml1 , mn , Mode , mp1 , mp2 , ms
      INTEGER Ndab , nl2 , Nlat , Nlon , np1 , ns , Nt
      DIMENSION Gs(Idg,Jdg,Nt) , A(Mdab,Ndab,Nt) , B(Mdab,Ndab,Nt)
      DIMENSION Wfft(1) , Pmn(Late,1) , G(Lat,Nlon,Nt) , Work(1)
 
!     reconstruct fourier coefficients in g on gaussian grid
!     using coefficients in a,b
 
!     initialize to zero
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               G(i,j,k) = 0.0
            ENDDO
         ENDDO
      ENDDO
 
      lm1 = L
      IF ( Nlon==L+L-2 ) lm1 = L - 1
      IF ( Mode==0 ) THEN
!     set first column in g
         m = 0
         mml1 = m*(2*Nlat-m-1)/2
         DO k = 1 , Nt
!     n even
            DO np1 = 1 , Nlat , 2
               mn = mml1 + np1
               DO i = 1 , Late
                  G(i,1,k) = G(i,1,k) + A(1,np1,k)*Pmn(i,mn)
               ENDDO
            ENDDO
!     n odd
            nl2 = Nlat/2
            DO np1 = 2 , Nlat , 2
               mn = mml1 + np1
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  G(is,1,k) = G(is,1,k) + A(1,np1,k)*Pmn(i,mn)
               ENDDO
            ENDDO
         ENDDO
 
!     restore m=0 coefficients from odd/even
         DO k = 1 , Nt
            DO i = 1 , nl2
               is = Nlat - i + 1
               t1 = G(i,1,k)
               t3 = G(is,1,k)
               G(i,1,k) = t1 + t3
               G(is,1,k) = t1 - t3
            ENDDO
         ENDDO
 
!     sweep interior columns of g
         DO mp1 = 2 , lm1
            m = mp1 - 1
            mml1 = m*(2*Nlat-m-1)/2
            mp2 = m + 2
            DO k = 1 , Nt
!     for n-m even store (g(i,p,k)+g(nlat-i+1,p,k))/2 in g(i,p,k) p=2*m,2*m+1
!     for i=1,...,late
               DO np1 = mp1 , Nlat , 2
                  mn = mml1 + np1
                  DO i = 1 , Late
                     G(i,2*m,k) = G(i,2*m,k) + A(mp1,np1,k)*Pmn(i,mn)
                     G(i,2*m+1,k) = G(i,2*m+1,k) + B(mp1,np1,k)         &
                                  & *Pmn(i,mn)
                  ENDDO
               ENDDO
 
!     for n-m odd store g(i,p,k)-g(nlat-i+1,p,k) in g(nlat-i+1,p,k)
!     for i=1,...,nlat/2 (p=2*m,p=2*m+1)
               DO np1 = mp2 , Nlat , 2
                  mn = mml1 + np1
                  DO i = 1 , nl2
                     is = Nlat - i + 1
                     G(is,2*m,k) = G(is,2*m,k) + A(mp1,np1,k)*Pmn(i,mn)
                     G(is,2*m+1,k) = G(is,2*m+1,k) + B(mp1,np1,k)       &
                                   & *Pmn(i,mn)
                  ENDDO
               ENDDO
 
!     now set fourier coefficients using even-odd reduction above
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  t1 = G(i,2*m,k)
                  t2 = G(i,2*m+1,k)
                  t3 = G(is,2*m,k)
                  t4 = G(is,2*m+1,k)
                  G(i,2*m,k) = t1 + t3
                  G(i,2*m+1,k) = t2 + t4
                  G(is,2*m,k) = t1 - t3
                  G(is,2*m+1,k) = t2 - t4
               ENDDO
 
            ENDDO
         ENDDO
 
!     set last column (using a only) if necessary
         IF ( Nlon==L+L-2 ) THEN
            m = L - 1
            mml1 = m*(2*Nlat-m-1)/2
            DO k = 1 , Nt
!     n-m even
               DO np1 = L , Nlat , 2
                  mn = mml1 + np1
                  DO i = 1 , Late
                     G(i,Nlon,k) = G(i,Nlon,k) + 2.0*A(L,np1,k)         &
                                 & *Pmn(i,mn)
 
                  ENDDO
               ENDDO
               lp1 = L + 1
!     n-m odd
               DO np1 = lp1 , Nlat , 2
                  mn = mml1 + np1
                  DO i = 1 , nl2
                     is = Nlat - i + 1
                     G(is,Nlon,k) = G(is,Nlon,k) + 2.0*A(L,np1,k)       &
                                  & *Pmn(i,mn)
                  ENDDO
               ENDDO
               DO i = 1 , nl2
                  is = Nlat - i + 1
                  t1 = G(i,Nlon,k)
                  t3 = G(is,Nlon,k)
                  G(i,Nlon,k) = t1 + t3
                  G(is,Nlon,k) = t1 - t3
               ENDDO
            ENDDO
         ENDIF
 
      ELSE
!     half sphere (mode.ne.0)
!     set first column in g
         m = 0
         mml1 = m*(2*Nlat-m-1)/2
         meo = 1
         IF ( Mode==1 ) meo = 2
         ms = m + meo
         DO k = 1 , Nt
            DO np1 = ms , Nlat , 2
               mn = mml1 + np1
               DO i = 1 , Late
                  G(i,1,k) = G(i,1,k) + A(1,np1,k)*Pmn(i,mn)
               ENDDO
            ENDDO
         ENDDO
 
!     sweep interior columns of g
 
         DO mp1 = 2 , lm1
            m = mp1 - 1
            mml1 = m*(2*Nlat-m-1)/2
            ms = m + meo
            DO k = 1 , Nt
               DO np1 = ms , Nlat , 2
                  mn = mml1 + np1
                  DO i = 1 , Late
                     G(i,2*m,k) = G(i,2*m,k) + A(mp1,np1,k)*Pmn(i,mn)
                     G(i,2*m+1,k) = G(i,2*m+1,k) + B(mp1,np1,k)         &
                                  & *Pmn(i,mn)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
 
         IF ( Nlon==L+L-2 ) THEN
!     set last column
            m = L - 1
            mml1 = m*(2*Nlat-m-1)/2
            ns = L
            IF ( Mode==1 ) ns = L + 1
            DO k = 1 , Nt
               DO np1 = ns , Nlat , 2
                  mn = mml1 + np1
                  DO i = 1 , Late
                     G(i,Nlon,k) = G(i,Nlon,k) + 2.0*A(L,np1,k)         &
                                 & *Pmn(i,mn)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
 
      ENDIF
 
 
!     do inverse fourier transform
      DO k = 1 , Nt
         CALL DHRFFTB(Lat,Nlon,G(1,1,k),Lat,Wfft,Work)
      ENDDO
!     scale output in gs
      DO k = 1 , Nt
         DO j = 1 , Nlon
            DO i = 1 , Lat
               Gs(i,j,k) = 0.5*G(i,j,k)
            ENDDO
         ENDDO
      ENDDO
 
      END SUBROUTINE DSHSGS1


      SUBROUTINE DSHSGSI(Nlat,Nlon,Wshsgs,Lshsgs,Work,Lwork,Dwork,Ldwork,&
                      & Ierror)
      IMPLICIT NONE
      INTEGER Ierror , l , l1 , l2 , late , ldw , Ldwork , lp , Lshsgs ,&
            & Lwork , Nlat , Nlon
      DOUBLE PRECISION Work , Wshsgs
!
!     this subroutine must be called before calling shags or shsgs with
!     fixed nlat,nlon. it precomputes the gaussian weights, points
!     and all necessary legendre polys and stores them in wshsgs.
!     these quantities must be preserved when calling shsgs
!     repeatedly with fixed nlat,nlon.
!
      DIMENSION Wshsgs(Lshsgs) , Work(Lwork)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
!     set triangular truncation limit for spherical harmonic basis
      l = MIN0((Nlon+2)/2,Nlat)
!     set equator or nearest point (if excluded) pointer
      late = (Nlat+1)/2
      l1 = l
      l2 = late
!     check permanent work space length
      Ierror = 3
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshsgs<lp ) RETURN
      Ierror = 4
!     check temporary work space
      IF ( Lwork<4*Nlat*(Nlat+2)+2 ) RETURN
      Ierror = 5
      IF ( Ldwork<Nlat*(Nlat+4) ) RETURN
      Ierror = 0
!     set preliminary quantites needed to compute and store legendre polys
      ldw = Nlat*(Nlat+4)
      CALL DSHSGSP(Nlat,Nlon,Wshsgs,Lshsgs,Dwork,Ldwork,Ierror)
      IF ( Ierror/=0 ) RETURN
!
!     this subroutine must be called before calling shags or shsgs with
!     fixed nlat,nlon. it precomputes the gaussian weights, points
!     and all necessary legendre polys and stores them in wshsgs.
!     these quantities must be preserved when calling shsgs
!     repeatedly with fixed nlat,nlon.
!
!     set triangular truncation limit for spherical harmonic basis
!     set equator or nearest point (if excluded) pointer
!     check permanent work space length
!     check temporary work space
!     set preliminary quantites needed to compute and store legendre polys
!     set legendre poly pointer in wshsgs
      END SUBROUTINE DSHSGSI

      SUBROUTINE DSHSGSP(NLAT,NLON,WSHSGS,LSHSGS,DWORK,LDWORK,IERROR)
      DOUBLE PRECISION WSHSGS
      DIMENSION WSHSGS(LSHSGS)
!*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
!     set triangular truncation limit for spherical harmonic basis
      L = MIN0((NLON+2)/2,NLAT)
!     set equator or nearest point (if excluded) pointer
      LATE = (NLAT+MOD(NLAT,2))/2
      L1 = L
      L2 = LATE
      IERROR = 3
!     check permanent work space length
      IF (LSHSGS.LT.NLAT* (2*L2+3*L1-2)+3*L1* (1-L1)/2+NLON+15) RETURN
      IERROR = 4
!     if (lwork.lt.4*nlat*(nlat+2)+2) return
      IF (LDWORK.LT.NLAT* (NLAT+4)) RETURN
      IERROR = 0
!     set pointers
      I1 = 1
      I2 = I1 + NLAT
      I3 = I2 + NLAT*LATE
      I4 = I3 + NLAT*LATE
      I5 = I4 + L* (L-1)/2 + (NLAT-L)* (L-1)
      I6 = I5 + L* (L-1)/2 + (NLAT-L)* (L-1)
      I7 = I6 + L* (L-1)/2 + (NLAT-L)* (L-1)
!     set indices in temp work for double precision gaussian wts and pts
      IDTH = 1
!     idwts = idth+2*nlat
!     iw = idwts+2*nlat
      IDWTS = IDTH + NLAT
      IW = IDWTS + NLAT
      CALL DSHSGSP1(NLAT,NLON,L,LATE,WSHSGS(I1),WSHSGS(I2),WSHSGS(I3), &
           WSHSGS(I4),WSHSGS(I5),WSHSGS(I6),WSHSGS(I7), &
           DWORK(IDTH),DWORK(IDWTS),DWORK(IW),IERROR)
      IF (IERROR.NE.0) IERROR = 6
      RETURN
    END SUBROUTINE DSHSGSP
    
    SUBROUTINE DSHSGSP1(NLAT,NLON,L,LATE,WTS,P0N,P1N,ABEL,BBEL,CBEL, &
      WFFT,DTHETA,DWTS,WORK,IER)
      DOUBLE PRECISION WTS
      DOUBLE PRECISION P0N
      DOUBLE PRECISION P1N
      DOUBLE PRECISION ABEL
      DOUBLE PRECISION BBEL
      DOUBLE PRECISION CBEL
      DOUBLE PRECISION WFFT
      DOUBLE PRECISION FN
      DOUBLE PRECISION FM
      DIMENSION WTS(NLAT),P0N(NLAT,LATE),P1N(NLAT,LATE),ABEL(1),BBEL(1), &
           CBEL(1),WFFT(1),DTHETA(NLAT),DWTS(NLAT)
!*PT*WARNING* Already double-precision
      DOUBLE PRECISION PB,DTHETA,DWTS,WORK(*)

      INDX(M,N) = (N-1)* (N-2)/2 + M - 1
      IMNDX(M,N) = L* (L-1)/2 + (N-L-1)* (L-1) + M - 1
      CALL DHRFFTI(NLON,WFFT)
!
!     compute double precision gaussian points and weights
!
      LW = NLAT* (NLAT+2)
      CALL DGAQD(NLAT,DTHETA,DWTS,WORK,LW,IER)
      IF (IER.NE.0) RETURN

!     store gaussian weights single precision to save computation
!     in inner loops in analysis
      DO  I = 1,NLAT
         WTS(I) = DWTS(I)
      END DO

!     initialize p0n,p1n using double precision dnlfk,dnlft
      DO  NP1 = 1,NLAT
         DO  I = 1,LATE
            P0N(NP1,I) = 0.0D0
            P1N(NP1,I) = 0.0D0
         END DO
      END DO
          
!     compute m=n=0 legendre polynomials for all theta(i)
      NP1 = 1
      N = 0
      M = 0
      CALL DDNLFK(M,N,WORK)
      DO  I = 1,LATE
          CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
          P0N(1,I) = PB
       END DO
!     compute p0n,p1n for all theta(i) when n.gt.0
      DO 104 NP1 = 2,NLAT
          N = NP1 - 1
          M = 0
          CALL DDNLFK(M,N,WORK)
          DO 105 I = 1,LATE
              CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
              P0N(NP1,I) = PB
  105     CONTINUE
!     compute m=1 legendre polynomials for all n and theta(i)
          M = 1
          CALL DDNLFK(M,N,WORK)
          DO 106 I = 1,LATE
              CALL DDNLFT(M,N,DTHETA(I),WORK,PB)
              P1N(NP1,I) = PB
  106     CONTINUE
  104 CONTINUE
!
!     compute and store swarztrauber recursion coefficients
!     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
              DO  N = 2,NLAT
                 FN = DBLE(N)
                 MLIM = MIN0(N,L)
                 DO  M = 2,MLIM
                    FM = DBLE(M)
                    IMN = INDX(M,N)
                    IF (N.GE.L) IMN = IMNDX(M,N)
                    ABEL(IMN) = SQRT(((2*FN+1)* (FM+FN-2)* (FM+FN-3))/ &
                         (((2*FN-3)* (FM+FN-1)* (FM+FN))))
                    BBEL(IMN) = SQRT(((2*FN+1)* (FN-FM-1)* (FN-FM))/ &
                         (((2*FN-3)* (FM+FN-1)* (FM+FN))))
                    CBEL(IMN) = SQRT(((FN-FM+1)* (FN-FM+2))/ &
                         (((FN+FM-1)* (FN+FM))))
                 END DO
              END DO
      RETURN
      END SUBROUTINE DSHSGSP1

      SUBROUTINE SHSGSP(NLAT,NLON,WSHSGS,LSHSGS,DWORK,LDWORK,IERROR)
      REAL WSHSGS
      DIMENSION WSHSGS(LSHSGS)
!*PT*WARNING* Already double-precision
      DOUBLE PRECISION DWORK(LDWORK)

      IERROR = 1
      IF (NLAT.LT.3) RETURN
      IERROR = 2
      IF (NLON.LT.4) RETURN
!     set triangular truncation limit for spherical harmonic basis
      L = MIN0((NLON+2)/2,NLAT)
!     set equator or nearest point (if excluded) pointer
      LATE = (NLAT+MOD(NLAT,2))/2
      L1 = L
      L2 = LATE
      IERROR = 3
!     check permanent work space length
      IF (LSHSGS.LT.NLAT* (2*L2+3*L1-2)+3*L1* (1-L1)/2+NLON+15) RETURN
      IERROR = 4
!     if (lwork.lt.4*nlat*(nlat+2)+2) return
      IF (LDWORK.LT.NLAT* (NLAT+4)) RETURN
      IERROR = 0
!     set pointers
      I1 = 1
      I2 = I1 + NLAT
      I3 = I2 + NLAT*LATE
      I4 = I3 + NLAT*LATE
      I5 = I4 + L* (L-1)/2 + (NLAT-L)* (L-1)
      I6 = I5 + L* (L-1)/2 + (NLAT-L)* (L-1)
      I7 = I6 + L* (L-1)/2 + (NLAT-L)* (L-1)
!     set indices in temp work for double precision gaussian wts and pts
      IDTH = 1
!     idwts = idth+2*nlat
!     iw = idwts+2*nlat
      IDWTS = IDTH + NLAT
      IW = IDWTS + NLAT
      CALL SHSGSP1(NLAT,NLON,L,LATE,WSHSGS(I1),WSHSGS(I2),WSHSGS(I3), &
           WSHSGS(I4),WSHSGS(I5),WSHSGS(I6),WSHSGS(I7), &
           DWORK(IDTH),DWORK(IDWTS),DWORK(IW),IERROR)
      IF (IERROR.NE.0) IERROR = 6
      RETURN
    END SUBROUTINE SHSGSP
    
    SUBROUTINE SHSGSP1(NLAT,NLON,L,LATE,WTS,P0N,P1N,ABEL,BBEL,CBEL, &
      WFFT,DTHETA,DWTS,WORK,IER)
      REAL WTS
      REAL P0N
      REAL P1N
      REAL ABEL
      REAL BBEL
      REAL CBEL
      REAL WFFT
      REAL FN
      REAL FM
      DIMENSION WTS(NLAT),P0N(NLAT,LATE),P1N(NLAT,LATE),ABEL(1),BBEL(1), &
           CBEL(1),WFFT(1),DTHETA(NLAT),DWTS(NLAT)
!*PT*WARNING* Already double-precision
      DOUBLE PRECISION PB,DTHETA,DWTS,WORK(*)

      INDX(M,N) = (N-1)* (N-2)/2 + M - 1
      IMNDX(M,N) = L* (L-1)/2 + (N-L-1)* (L-1) + M - 1
      CALL HRFFTI(NLON,WFFT)
!
!     compute double precision gaussian points and weights
!
      LW = NLAT* (NLAT+2)
      CALL GAQD(NLAT,DTHETA,DWTS,WORK,LW,IER)
      IF (IER.NE.0) RETURN

!     store gaussian weights single precision to save computation
!     in inner loops in analysis
      DO  I = 1,NLAT
         WTS(I) = DWTS(I)
      END DO

!     initialize p0n,p1n using double precision dnlfk,dnlft
      DO  NP1 = 1,NLAT
         DO  I = 1,LATE
            P0N(NP1,I) = 0.0D0
            P1N(NP1,I) = 0.0D0
         END DO
      END DO
          
!     compute m=n=0 legendre polynomials for all theta(i)
      NP1 = 1
      N = 0
      M = 0
      CALL DNLFK(M,N,WORK)
      DO  I = 1,LATE
          CALL DNLFT(M,N,DTHETA(I),WORK,PB)
          P0N(1,I) = PB
       END DO
!     compute p0n,p1n for all theta(i) when n.gt.0
      DO 104 NP1 = 2,NLAT
          N = NP1 - 1
          M = 0
          CALL DNLFK(M,N,WORK)
          DO 105 I = 1,LATE
              CALL DNLFT(M,N,DTHETA(I),WORK,PB)
              P0N(NP1,I) = PB
  105     CONTINUE
!     compute m=1 legendre polynomials for all n and theta(i)
          M = 1
          CALL DNLFK(M,N,WORK)
          DO 106 I = 1,LATE
              CALL DNLFT(M,N,DTHETA(I),WORK,PB)
              P1N(NP1,I) = PB
  106     CONTINUE
  104 CONTINUE
!
!     compute and store swarztrauber recursion coefficients
!     for 2.le.m.le.n and 2.le.n.le.nlat in abel,bbel,cbel
              DO  N = 2,NLAT
                 FN = DBLE(N)
                 MLIM = MIN0(N,L)
                 DO  M = 2,MLIM
                    FM = DBLE(M)
                    IMN = INDX(M,N)
                    IF (N.GE.L) IMN = IMNDX(M,N)
                    ABEL(IMN) = SQRT(((2*FN+1)* (FM+FN-2)* (FM+FN-3))/ &
                         (((2*FN-3)* (FM+FN-1)* (FM+FN))))
                    BBEL(IMN) = SQRT(((2*FN+1)* (FN-FM-1)* (FN-FM))/ &
                         (((2*FN-3)* (FM+FN-1)* (FM+FN))))
                    CBEL(IMN) = SQRT(((FN-FM+1)* (FN-FM+2))/ &
                         (((FN+FM-1)* (FN+FM))))
                 END DO
              END DO
      RETURN
      END SUBROUTINE SHSGSP1

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c ... file sphcom.f
c
c     this file must be loaded with all driver level files
c     in spherepack3.0.  it includes undocumented subroutines
c     called by some or all of the drivers
c
      subroutine dnlfk (m,n,cp)
c
      double precision cp,fnum,fden,fnmh,a1,b1,c1,cp2,fnnp1,fnmsq,fk,
     1       t1,t2,pm1,sc10,sc20,sc40
      dimension       cp(1)
      parameter (sc10=1024.d0)
      parameter (sc20=sc10*sc10)
      parameter (sc40=sc20*sc20)
c
      cp(1) = 0.
      ma = iabs(m)
      if(ma .gt. n) return
      if(n-1) 2,3,5
    2 cp(1) = dsqrt(2.d0)
      return
    3 if(ma .ne. 0) go to 4
      cp(1) = dsqrt(1.5d0)
      return
    4 cp(1) = dsqrt(.75d0)
      if(m .eq. -1) cp(1) = -cp(1)
      return
    5 if(mod(n+ma,2) .ne. 0) go to 10
      nmms2 = (n-ma)/2
      fnum = n+ma+1
      fnmh = n-ma+1
      pm1 = 1.d0
      go to 15
   10 nmms2 = (n-ma-1)/2
      fnum = n+ma+2
      fnmh = n-ma+2
      pm1 = -1.d0
c      t1 = 1.
c      t1 = 2.d0**(n-1)
c      t1 = 1.d0/t1
 15   t1 = 1.d0/sc20
      nex = 20
      fden = 2.d0
      if(nmms2 .lt. 1) go to 20
      do 18 i=1,nmms2
      t1 = fnum*t1/fden
      if(t1 .gt. sc20) then
      t1 = t1/sc40
      nex = nex+40
      end if
      fnum = fnum+2.
      fden = fden+2.
   18 continue
   20 t1 = t1/2.d0**(n-1-nex)
      if(mod(ma/2,2) .ne. 0) t1 = -t1
      t2 = 1. 
      if(ma .eq. 0) go to 26
      do 25 i=1,ma
      t2 = fnmh*t2/(fnmh+pm1)
      fnmh = fnmh+2.
   25 continue
   26 cp2 = t1*dsqrt((n+.5d0)*t2)
      fnnp1 = n*(n+1)
      fnmsq = fnnp1-2.d0*ma*ma
      l = (n+1)/2
      if(mod(n,2) .eq. 0 .and. mod(ma,2) .eq. 0) l = l+1
      cp(l) = cp2
      if(m .ge. 0) go to 29
      if(mod(ma,2) .ne. 0) cp(l) = -cp(l)
   29 if(l .le. 1) return
      fk = n
      a1 = (fk-2.)*(fk-1.)-fnnp1
      b1 = 2.*(fk*fk-fnmsq)
      cp(l-1) = b1*cp(l)/a1
   30 l = l-1
      if(l .le. 1) return
      fk = fk-2.
      a1 = (fk-2.)*(fk-1.)-fnnp1
      b1 = -2.*(fk*fk-fnmsq)
      c1 = (fk+1.)*(fk+2.)-fnnp1
      cp(l-1) = -(b1*cp(l)+c1*cp(l+1))/a1
      go to 30
      end
      subroutine dnlft (m,n,theta,cp,pb)
      double precision cp(*),pb,theta,cdt,sdt,cth,sth,chh
      cdt = dcos(theta+theta)
      sdt = dsin(theta+theta)
      nmod=mod(n,2)
      mmod=mod(m,2)
      if(nmod)1,1,2
1     if(mmod)3,3,4
c
c     n even, m even
c
3     kdo=n/2
      pb = .5*cp(1)
      if(n .eq. 0) return
      cth = cdt
      sth = sdt
      do 170 k=1,kdo
c     pb = pb+cp(k+1)*dcos(2*k*theta)
      pb = pb+cp(k+1)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
  170 continue
      return
c
c     n even, m odd
c
    4 kdo = n/2
      pb = 0.
      cth = cdt
      sth = sdt
      do 180 k=1,kdo
c     pb = pb+cp(k)*dsin(2*k*theta)
      pb = pb+cp(k)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
  180 continue
      return
2     if(mmod)13,13,14
c
c     n odd, m even
c
13    kdo = (n+1)/2
      pb = 0.
      cth = dcos(theta)
      sth = dsin(theta)
      do 190 k=1,kdo
c     pb = pb+cp(k)*dcos((2*k-1)*theta)
      pb = pb+cp(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
  190 continue
      return
c
c     n odd, m odd
c
   14 kdo = (n+1)/2
      pb = 0.
      cth = dcos(theta)
      sth = dsin(theta)
      do 200 k=1,kdo
c     pb = pb+cp(k)*dsin((2*k-1)*theta)
      pb = pb+cp(k)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
  200 continue
      return
      end
      subroutine legin(mode,l,nlat,m,w,pmn,km)
c     this subroutine computes legendre polynomials for n=m,...,l-1
c     and  i=1,...,late (late=((nlat+mod(nlat,2))/2)gaussian grid
c     in pmn(n+1,i,km) using swarztrauber's recursion formula.
c     the vector w contains quantities precomputed in shigc.
c     legin must be called in the order m=0,1,...,l-1
c     (e.g., if m=10 is sought it must be preceded by calls with
c     m=0,1,2,...,9 in that order)
      dimension w(1),pmn(1)
c     set size of pole to equator gaussian grid
      late = (nlat+mod(nlat,2))/2
c     partition w (set pointers for p0n,p1n,abel,bbel,cbel,pmn)
      i1 = 1+nlat
      i2 = i1+nlat*late
      i3 = i2+nlat*late
      i4 = i3+(2*nlat-l)*(l-1)/2
      i5 = i4+(2*nlat-l)*(l-1)/2
      call legin1(mode,l,nlat,late,m,w(i1),w(i2),w(i3),w(i4),
     1            w(i5),pmn,km)
      return
      end
      subroutine legin1(mode,l,nlat,late,m,p0n,p1n,abel,bbel,cbel,
     1                  pmn,km)
      dimension p0n(nlat,late),p1n(nlat,late)
      dimension abel(1),bbel(1),cbel(1),pmn(nlat,late,3)
      data km0,km1,km2/ 1,2,3/
      save km0,km1,km2
c     define index function used in storing triangular
c     arrays for recursion coefficients (functions of (m,n))
c     for 2.le.m.le.n-1 and 2.le.n.le.l-1
      indx(m,n) = (n-1)*(n-2)/2+m-1
c     for l.le.n.le.nlat and 2.le.m.le.l
      imndx(m,n) = l*(l-1)/2+(n-l-1)*(l-1)+m-1

c     set do loop indices for full or half sphere
      ms = m+1
      ninc = 1
      if (mode.eq.1) then
c     only compute pmn for n-m odd
      ms = m+2
      ninc = 2
      else if (mode.eq.2) then
c     only compute pmn for n-m even
      ms = m+1
      ninc = 2
      end if


      if (m.gt.1) then
      do 100 np1=ms,nlat,ninc
      n = np1-1
      imn = indx(m,n)
      if (n.ge.l) imn = imndx(m,n)
      do 100 i=1,late
      pmn(np1,i,km0) = abel(imn)*pmn(n-1,i,km2)
     1            +bbel(imn)*pmn(n-1,i,km0)
     2            -cbel(imn)*pmn(np1,i,km2)
  100 continue

      else if (m.eq.0) then
      do 101 np1=ms,nlat,ninc
      do 101 i=1,late
      pmn(np1,i,km0) = p0n(np1,i)
  101 continue

      else if (m.eq.1) then
      do 102 np1=ms,nlat,ninc
      do 102 i=1,late
      pmn(np1,i,km0) = p1n(np1,i)
  102 continue
      end if

c     permute column indices
c     km0,km1,km2 store m,m-1,m-2 columns
      kmt = km0
      km0 = km2
      km2 = km1
      km1 = kmt
c     set current m index in output param km
      km = kmt
      return
      end


      subroutine zfin (isym,nlat,nlon,m,z,i3,wzfin)
      dimension       z(1)        ,wzfin(1)
      imid = (nlat+1)/2
      lim = nlat*imid
      mmax = min0(nlat,nlon/2+1)
      labc = ((mmax-2)*(nlat+nlat-mmax-1))/2
      iw1 = lim+1
      iw2 = iw1+lim
      iw3 = iw2+labc
      iw4 = iw3+labc
c
c     the length of wzfin is 2*lim+3*labc
c
      call zfin1 (isym,nlat,m,z,imid,i3,wzfin,wzfin(iw1),wzfin(iw2),
     1            wzfin(iw3),wzfin(iw4))
      return
      end
      subroutine zfin1 (isym,nlat,m,z,imid,i3,zz,z1,a,b,c)
      dimension       z(imid,nlat,3),zz(imid,1),z1(imid,1),
     1                a(1),b(1),c(1)
      save i1,i2
      ihold = i1
      i1 = i2
      i2 = i3
      i3 = ihold
      if(m-1)25,30,35
   25 i1 = 1
      i2 = 2
      i3 = 3
      do 45 np1=1,nlat
      do 45 i=1,imid
      z(i,np1,i3) = zz(i,np1)
   45 continue
      return
   30 do 50 np1=2,nlat
      do 50 i=1,imid
      z(i,np1,i3) = z1(i,np1)
   50 continue
      return
   35 ns = ((m-2)*(nlat+nlat-m-1))/2+1
      if(isym .eq. 1) go to 36
      do 85 i=1,imid
      z(i,m+1,i3) = a(ns)*z(i,m-1,i1)-c(ns)*z(i,m+1,i1)
   85 continue
   36 if(m .eq. nlat-1) return
      if(isym .eq. 2) go to 71
      ns = ns+1
      do 70 i=1,imid
      z(i,m+2,i3) = a(ns)*z(i,m,i1)-c(ns)*z(i,m+2,i1)
   70 continue
   71 nstrt = m+3
      if(isym .eq. 1) nstrt = m+4
      if(nstrt .gt. nlat) go to 80
      nstp = 2
      if(isym .eq. 0) nstp = 1
      do 75 np1=nstrt,nlat,nstp
      ns = ns+nstp
      do 75 i=1,imid
      z(i,np1,i3) = a(ns)*z(i,np1-2,i1)+b(ns)*z(i,np1-2,i3)
     1                              -c(ns)*z(i,np1,i1)
   75 continue
   80 return
      end
      subroutine zfinit (nlat,nlon,wzfin,dwork)
      dimension       wzfin(*)
      double precision dwork(*)
      imid = (nlat+1)/2
      iw1 = 2*nlat*imid+1
c
c     the length of wzfin is 3*((l-3)*l+2)/2 + 2*l*imid
c     the length of dwork is nlat+1
c
      call zfini1 (nlat,nlon,imid,wzfin,wzfin(iw1),dwork,dwork(imid+1))
      return
      end
      subroutine zfini1 (nlat,nlon,imid,z,abc,cz,work)
c
c     abc must have 3*((mmax-2)*(nlat+nlat-mmax-1))/2 locations
c     where mmax = min0(nlat,nlon/2+1)
c     cz and work must each have nlat+1 locations
c
      dimension z(imid,nlat,2),abc(1)
      double precision pi,dt,th,zh,cz(*),work(*)
      pi = 4.*datan(1.d0)
      dt = pi/(nlat-1)
      do 160 mp1=1,2
      m = mp1-1
      do 160 np1=mp1,nlat
      n = np1-1
      call dnzfk(nlat,m,n,cz,work)
      do 165 i=1,imid
      th = (i-1)*dt
      call dnzft(nlat,m,n,th,cz,zh)
      z(i,np1,mp1) = zh
  165 continue
      z(1,np1,mp1) = .5*z(1,np1,mp1)
  160 continue
      call rabcp(nlat,nlon,abc)
      return
      end
      subroutine dnzfk(nlat,m,n,cz,work)
c
c     dnzfk computes the coefficients in the trigonometric
c     expansion of the z functions that are used in spherical
c     harmonic analysis.
c
      dimension  cz(1),work(1)
c
c     cz and work must both have nlat+1 locations
c
      double precision sum,sc1,t1,t2,work,cz
      lc = (nlat+1)/2
      sc1 = 2.d0/float(nlat-1)
      call dnlfk(m,n,work)
      nmod = mod(n,2)
      mmod = mod(m,2)
      if(nmod)1,1,2
1     if(mmod)3,3,4
c
c     n even, m even
c
3     kdo = n/2+1
      do 5 idx=1,lc
      i = idx+idx-2
      sum = work(1)/(1.d0-i*i)
      if(kdo.lt.2) go to 29
      do 6 kp1=2,kdo
      k = kp1-1
      t1 = 1.d0-(k+k+i)**2
      t2 = 1.d0-(k+k-i)**2
8     sum = sum+work(kp1)*(t1+t2)/(t1*t2)
6     continue
29    cz(idx) = sc1*sum
5     continue
      return
c
c     n even, m odd
c
4     kdo = n/2
      do 9 idx=1,lc
      i = idx+idx-2
      sum = 0.
      do 101 k=1,kdo
      t1 = 1.d0-(k+k+i)**2
      t2 = 1.d0-(k+k-i)**2
12    sum=sum+work(k)*(t1-t2)/(t1*t2)
101   continue
      cz(idx) = sc1*sum
9     continue
      return
2     if(mmod)13,13,14
c
c     n odd, m even
c
13    kdo = (n+1)/2
      do 15 idx=1,lc
      i = idx+idx-1
      sum = 0.
      do 16 k=1,kdo
      t1 = 1.d0-(k+k-1+i)**2
      t2 = 1.d0-(k+k-1-i)**2
18    sum=sum+work(k)*(t1+t2)/(t1*t2)
16    continue
      cz(idx)=sc1*sum
15    continue
      return
c
c     n odd, m odd
c
14    kdo = (n+1)/2
      do 19 idx=1,lc
      i = idx+idx-3
      sum=0.
      do 20 k=1,kdo
      t1 = 1.d0-(k+k-1+i)**2
      t2 = 1.d0-(k+k-1-i)**2
22    sum=sum+work(k)*(t1-t2)/(t1*t2)
20    continue
      cz(idx)=sc1*sum
19    continue
      return
      end
      subroutine dnzft(nlat,m,n,th,cz,zh)
      dimension cz(1)
      double precision cz,zh,th,cdt,sdt,cth,sth,chh
      zh = 0.
      cdt = dcos(th+th)
      sdt = dsin(th+th)
      lmod = mod(nlat,2)
      mmod = mod(m,2)
      nmod = mod(n,2)
      if(lmod)20,20,10
   10 lc = (nlat+1)/2
      lq = lc-1
      ls = lc-2
      if(nmod)1,1,2
    1 if(mmod)3,3,4
c
c     nlat odd n even m even
c
    3 zh = .5*(cz(1)+cz(lc)*dcos(2*lq*th))
      cth = cdt
      sth = sdt
      do 201 k=2,lq
c     zh = zh+cz(k)*dcos(2*(k-1)*th)
      zh = zh+cz(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
  201 continue
      return
c
c     nlat odd n even m odd
c
    4 cth = cdt
      sth = sdt
      do 202 k=1,ls
c     zh = zh+cz(k+1)*dsin(2*k*th)
      zh = zh+cz(k+1)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
  202 continue
      return
c
c     nlat odd n odd, m even
c
    2 if(mmod)5,5,6
    5 cth = dcos(th)
      sth = dsin(th)
      do 203 k=1,lq
c     zh = zh+cz(k)*dcos((2*k-1)*th)
      zh = zh+cz(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
  203 continue
      return
c
c     nlat odd n odd m odd
c
    6 cth = dcos(th)
      sth = dsin(th)
      do 204 k=1,lq
c     zh = zh+cz(k+1)*dsin((2*k-1)*th)
      zh = zh+cz(k+1)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
  204 continue
      return
   20 lc = nlat/2
      lq = lc-1
      if(nmod)30,30,80
   30 if(mmod)40,40,60
c
c     nlat even n even m even
c
   40 zh = .5*cz(1)
      cth = cdt
      sth = sdt
      do 50 k=2,lc
c     zh = zh+cz(k)*dcos(2*(k-1)*th)
      zh = zh+cz(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   50 continue
      return
c
c     nlat even n even m odd
c
   60 cth = cdt
      sth = sdt
      do 70 k=1,lq
c     zh = zh+cz(k+1)*dsin(2*k*th)
      zh = zh+cz(k+1)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   70 continue
      return
c
c     nlat even n odd m even
c
   80 if(mmod)90,90,110
   90 zh = .5*cz(lc)*dcos((nlat-1)*th)
      cth = dcos(th)
      sth = dsin(th)
      do 100 k=1,lq
c     zh = zh+cz(k)*dcos((2*k-1)*th)
      zh = zh+cz(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
  100 continue
      return
c
c     nlat even n odd m odd
c
  110 cth = dcos(th)
      sth = dsin(th)
      do 120 k=1,lq
c     zh = zh+cz(k+1)*dsin((2*k-1)*th)
      zh = zh+cz(k+1)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
  120 continue
      return
      end
      subroutine alin (isym,nlat,nlon,m,p,i3,walin)
      dimension       p(1)        ,walin(1)
      imid = (nlat+1)/2
      lim = nlat*imid
      mmax = min0(nlat,nlon/2+1)
      labc = ((mmax-2)*(nlat+nlat-mmax-1))/2
      iw1 = lim+1
      iw2 = iw1+lim
      iw3 = iw2+labc
      iw4 = iw3+labc
c
c     the length of walin is ((5*l-7)*l+6)/2
c
      call alin1 (isym,nlat,m,p,imid,i3,walin,walin(iw1),walin(iw2),
     1            walin(iw3),walin(iw4))
      return
      end
      subroutine alin1 (isym,nlat,m,p,imid,i3,pz,p1,a,b,c)
      dimension       p(imid,nlat,3),pz(imid,1),p1(imid,1),
     1                a(1),b(1),c(1)
      save i1,i2
      ihold = i1
      i1 = i2
      i2 = i3
      i3 = ihold
      if(m-1)25,30,35
   25 i1 = 1
      i2 = 2
      i3 = 3
      do 45 np1=1,nlat
      do 45 i=1,imid
      p(i,np1,i3) = pz(i,np1)
   45 continue
      return
   30 do 50 np1=2,nlat
      do 50 i=1,imid
      p(i,np1,i3) = p1(i,np1)
   50 continue
      return
   35 ns = ((m-2)*(nlat+nlat-m-1))/2+1
      if(isym .eq. 1) go to 36
      do 85 i=1,imid
      p(i,m+1,i3) = a(ns)*p(i,m-1,i1)-c(ns)*p(i,m+1,i1)
   85 continue
   36 if(m .eq. nlat-1) return
      if(isym .eq. 2) go to 71
      ns = ns+1
      do 70 i=1,imid
      p(i,m+2,i3) = a(ns)*p(i,m,i1)-c(ns)*p(i,m+2,i1)
   70 continue
   71 nstrt = m+3
      if(isym .eq. 1) nstrt = m+4
      if(nstrt .gt. nlat) go to 80
      nstp = 2
      if(isym .eq. 0) nstp = 1
      do 75 np1=nstrt,nlat,nstp
      ns = ns+nstp
      do 75 i=1,imid
      p(i,np1,i3) = a(ns)*p(i,np1-2,i1)+b(ns)*p(i,np1-2,i3)
     1                              -c(ns)*p(i,np1,i1)
   75 continue
   80 return
      end
      subroutine alinit (nlat,nlon,walin,dwork)
      dimension       walin(*)
      double precision dwork(*)
      imid = (nlat+1)/2
      iw1 = 2*nlat*imid+1
c
c     the length of walin is 3*((l-3)*l+2)/2 + 2*l*imid
c     the length of work is nlat+1
c
      call alini1 (nlat,nlon,imid,walin,walin(iw1),dwork)
      return
      end
      subroutine alini1 (nlat,nlon,imid,p,abc,cp)
      dimension p(imid,nlat,2),abc(1),cp(1)
      double precision pi,dt,th,cp,ph
      pi = 4.*datan(1.d0)
      dt = pi/(nlat-1)
      do 160 mp1=1,2
      m = mp1-1
      do 160 np1=mp1,nlat
      n = np1-1
      call dnlfk (m,n,cp)
      do 160 i=1,imid
      th = (i-1)*dt
      call dnlft (m,n,th,cp,ph)
      p(i,np1,mp1) = ph
  160 continue
      call rabcp(nlat,nlon,abc)
      return
      end
      subroutine rabcp(nlat,nlon,abc)
c
c     subroutine rabcp computes the coefficients in the recurrence
c     relation for the associated legendre fuctions. array abc
c     must have 3*((mmax-2)*(nlat+nlat-mmax-1))/2 locations.
c
      dimension abc(1)
      mmax = min0(nlat,nlon/2+1)
      labc = ((mmax-2)*(nlat+nlat-mmax-1))/2
      iw1 = labc+1
      iw2 = iw1+labc
      call rabcp1(nlat,nlon,abc,abc(iw1),abc(iw2))
      return
      end
      subroutine rabcp1(nlat,nlon,a,b,c)
c
c     coefficients a, b, and c for computing pbar(m,n,theta) are
c     stored in location ((m-2)*(nlat+nlat-m-1))/2+n+1
c
      dimension a(1),b(1),c(1)
      mmax = min0(nlat,nlon/2+1)
      do 215 mp1=3,mmax
      m = mp1-1
      ns = ((m-2)*(nlat+nlat-m-1))/2+1
      fm = float(m)
      tm = fm+fm
      temp = tm*(tm-1.)
      a(ns) = sqrt((tm+1.)*(tm-2.)/temp)
      c(ns) = sqrt(2./temp)
      if(m .eq. nlat-1) go to 215
      ns = ns+1
      temp = tm*(tm+1.)
      a(ns) = sqrt((tm+3.)*(tm-2.)/temp)
      c(ns) = sqrt(6./temp)
      mp3 = m+3
      if(mp3 .gt. nlat) go to 215
      do 210 np1=mp3,nlat
      n = np1-1
      ns = ns+1
      fn = float(n)
      tn = fn+fn
      cn = (tn+1.)/(tn-3.)
      fnpm = fn+fm
      fnmm = fn-fm
      temp = fnpm*(fnpm-1.)
      a(ns) = sqrt(cn*(fnpm-3.)*(fnpm-2.)/temp)
      b(ns) = sqrt(cn*fnmm*(fnmm-1.)/temp)
      c(ns) = sqrt((fnmm+1.)*(fnmm+2.)/temp)
  210 continue
  215 continue
      return
      end
      subroutine sea1(nlat,nlon,imid,z,idz,zin,wzfin,dwork)
      dimension z(idz,*),zin(imid,nlat,3),wzfin(*)
      double precision dwork(*)
      call zfinit(nlat,nlon,wzfin,dwork)
      mmax = min0(nlat,nlon/2+1)
      do 33 mp1=1,mmax
      m = mp1-1
      call zfin (0,nlat,nlon,m,zin,i3,wzfin)
      do 33 np1=mp1,nlat
      mn = m*(nlat-1)-(m*(m-1))/2+np1
      do 33 i=1,imid
      z(mn,i) = zin(i,np1,i3)
   33 continue
      return
      end
      subroutine ses1(nlat,nlon,imid,p,pin,walin,dwork)
      dimension p(imid,*),pin(imid,nlat,3),walin(*)
      double precision dwork(*)
      call alinit (nlat,nlon,walin,dwork)
      mmax = min0(nlat,nlon/2+1)
      do 10 mp1=1,mmax
      m = mp1-1
      call alin(0,nlat,nlon,m,pin,i3,walin)
      do 10 np1=mp1,nlat
      mn = m*(nlat-1)-(m*(m-1))/2+np1
      do 10 i=1,imid
      p(i,mn) = pin(i,np1,i3)
   10 continue
      return
      end
      subroutine zvinit (nlat,nlon,wzvin,dwork)
      dimension       wzvin(1)
      double precision dwork(*)
      imid = (nlat+1)/2
      iw1 = 2*nlat*imid+1
c
c     the length of wzvin is 
c         2*nlat*imid +3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     the length of dwork is 2*nlat+2
c
      call zvini1 (nlat,nlon,imid,wzvin,wzvin(iw1),dwork,dwork(nlat+2))
      return
      end
      subroutine zvini1 (nlat,nlon,imid,zv,abc,czv,work)
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     czv and work must each have nlat+1  locations
c
      dimension zv(imid,nlat,2),abc(1)
      double precision pi,dt,czv(1),zvh,th,work(1)
      pi = 4.*datan(1.d0)
      dt = pi/(nlat-1)
      mdo = min0(2,nlat,(nlon+1)/2)
      do 160 mp1=1,mdo
      m = mp1-1
      do 160 np1=mp1,nlat
      n = np1-1
      call dzvk(nlat,m,n,czv,work)
      do 165 i=1,imid
      th = (i-1)*dt
      call dzvt(nlat,m,n,th,czv,zvh)
      zv(i,np1,mp1) = zvh
  165 continue
      zv(1,np1,mp1) = .5*zv(1,np1,mp1)
  160 continue
      call rabcv(nlat,nlon,abc)
      return
      end
      subroutine zwinit (nlat,nlon,wzwin,dwork)
      dimension       wzwin(1)
      double precision dwork(*)
      imid = (nlat+1)/2
      iw1 = 2*nlat*imid+1
c
c     the length of wzvin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of dwork is 2*nlat+2
c
      call zwini1 (nlat,nlon,imid,wzwin,wzwin(iw1),dwork,dwork(nlat+2))
      return
      end
      subroutine zwini1 (nlat,nlon,imid,zw,abc,czw,work)
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     czw and work must each have nlat+1 locations
c
      dimension zw(imid,nlat,2),abc(1)
      double precision  pi,dt,czw(1),zwh,th,work(1)
      pi = 4.*datan(1.d0)
      dt = pi/(nlat-1)
      mdo = min0(3,nlat,(nlon+1)/2)
      if(mdo .lt. 2) return
      do 160 mp1=2,mdo
      m = mp1-1
      do 160 np1=mp1,nlat
      n = np1-1
      call dzwk(nlat,m,n,czw,work)
      do 165 i=1,imid
      th = (i-1)*dt
      call dzwt(nlat,m,n,th,czw,zwh)
      zw(i,np1,m) = zwh
  165 continue
      zw(1,np1,m) = .5*zw(1,np1,m)
  160 continue
      call rabcw(nlat,nlon,abc)
      return
      end
      subroutine zvin (ityp,nlat,nlon,m,zv,i3,wzvin)
      dimension       zv(1)        ,wzvin(1)
      imid = (nlat+1)/2
      lim = nlat*imid
      mmax = min0(nlat,(nlon+1)/2)
      labc = (max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
      iw1 = lim+1
      iw2 = iw1+lim
      iw3 = iw2+labc
      iw4 = iw3+labc
c
c     the length of wzvin is 2*lim+3*labc
c
      call zvin1 (ityp,nlat,m,zv,imid,i3,wzvin,wzvin(iw1),wzvin(iw2),
     1            wzvin(iw3),wzvin(iw4))
      return
      end
      subroutine zvin1 (ityp,nlat,m,zv,imid,i3,zvz,zv1,a,b,c)
      dimension       zv(imid,nlat,3),zvz(imid,1),zv1(imid,1),
     1                a(1),b(1),c(1)
      save i1,i2
      ihold = i1
      i1 = i2
      i2 = i3
      i3 = ihold
      if(m-1)25,30,35
   25 i1 = 1
      i2 = 2
      i3 = 3
      do 45 np1=1,nlat
      do 45 i=1,imid
      zv(i,np1,i3) = zvz(i,np1)
   45 continue
      return
   30 do 50 np1=2,nlat
      do 50 i=1,imid
      zv(i,np1,i3) = zv1(i,np1)
   50 continue
      return
   35 ns = ((m-2)*(nlat+nlat-m-1))/2+1
      if(ityp .eq. 1) go to 36
      do 85 i=1,imid
      zv(i,m+1,i3) = a(ns)*zv(i,m-1,i1)-c(ns)*zv(i,m+1,i1)
   85 continue
   36 if(m .eq. nlat-1) return
      if(ityp .eq. 2) go to 71
      ns = ns+1
      do 70 i=1,imid
      zv(i,m+2,i3) = a(ns)*zv(i,m,i1)-c(ns)*zv(i,m+2,i1)
   70 continue
   71 nstrt = m+3
      if(ityp .eq. 1) nstrt = m+4
      if(nstrt .gt. nlat) go to 80
      nstp = 2
      if(ityp .eq. 0) nstp = 1
      do 75 np1=nstrt,nlat,nstp
      ns = ns+nstp
      do 75 i=1,imid
      zv(i,np1,i3) = a(ns)*zv(i,np1-2,i1)+b(ns)*zv(i,np1-2,i3)
     1                              -c(ns)*zv(i,np1,i1)
   75 continue
   80 return
      end
      subroutine zwin (ityp,nlat,nlon,m,zw,i3,wzwin)
      dimension       zw(1)        ,wzwin(1)
      imid = (nlat+1)/2
      lim = nlat*imid
      mmax = min0(nlat,(nlon+1)/2)
      labc = (max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
      iw1 = lim+1
      iw2 = iw1+lim
      iw3 = iw2+labc
      iw4 = iw3+labc
c
c     the length of wzwin is 2*lim+3*labc
c
      call zwin1 (ityp,nlat,m,zw,imid,i3,wzwin,wzwin(iw1),wzwin(iw2),
     1            wzwin(iw3),wzwin(iw4))
      return
      end
      subroutine zwin1 (ityp,nlat,m,zw,imid,i3,zw1,zw2,a,b,c)
      dimension       zw(imid,nlat,3),zw1(imid,1),zw2(imid,1),
     1                a(1),b(1),c(1)
      save i1,i2
      ihold = i1
      i1 = i2
      i2 = i3
      i3 = ihold
      if(m-2)25,30,35
   25 i1 = 1
      i2 = 2
      i3 = 3
      do 45 np1=2,nlat
      do 45 i=1,imid
      zw(i,np1,i3) = zw1(i,np1)
   45 continue
      return
   30 do 50 np1=3,nlat
      do 50 i=1,imid
      zw(i,np1,i3) = zw2(i,np1)
   50 continue
      return
   35 ns = ((m-2)*(nlat+nlat-m-1))/2+1
      if(ityp .eq. 1) go to 36
      do 85 i=1,imid
      zw(i,m+1,i3) = a(ns)*zw(i,m-1,i1)-c(ns)*zw(i,m+1,i1)
   85 continue
   36 if(m .eq. nlat-1) return
      if(ityp .eq. 2) go to 71
      ns = ns+1
      do 70 i=1,imid
      zw(i,m+2,i3) = a(ns)*zw(i,m,i1)-c(ns)*zw(i,m+2,i1)
   70 continue
   71 nstrt = m+3
      if(ityp .eq. 1) nstrt = m+4
      if(nstrt .gt. nlat) go to 80
      nstp = 2
      if(ityp .eq. 0) nstp = 1
      do 75 np1=nstrt,nlat,nstp
      ns = ns+nstp
      do 75 i=1,imid
      zw(i,np1,i3) = a(ns)*zw(i,np1-2,i1)+b(ns)*zw(i,np1-2,i3)
     1                              -c(ns)*zw(i,np1,i1)
   75 continue
   80 return
      end
      subroutine vbinit (nlat,nlon,wvbin,dwork)
      dimension wvbin(1)
      double precision dwork(*)
      imid = (nlat+1)/2
      iw1 = 2*nlat*imid+1
c
c     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of dwork is 2*nlat+2
c
      call vbini1 (nlat,nlon,imid,wvbin,wvbin(iw1),dwork,dwork(nlat+2))
      return
      end
      subroutine vbini1 (nlat,nlon,imid,vb,abc,cvb,work)
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     cvb and work must each have nlat+1 locations
c
      dimension vb(imid,nlat,2),abc(1)
      double precision pi,dt,cvb(1),th,vbh,work(1)
      pi = 4.*datan(1.d0)
      dt = pi/(nlat-1)
      mdo = min0(2,nlat,(nlon+1)/2)
      do 160 mp1=1,mdo
      m = mp1-1
      do 160 np1=mp1,nlat
      n = np1-1
      call dvbk(m,n,cvb,work)
      do 165 i=1,imid
      th = (i-1)*dt
      call dvbt(m,n,th,cvb,vbh)
      vb(i,np1,mp1) = vbh
  165 continue
  160 continue
      call rabcv(nlat,nlon,abc)
      return
      end
      subroutine wbinit (nlat,nlon,wwbin,dwork)
      dimension       wwbin(1)
      double precision dwork(*)
      imid = (nlat+1)/2
      iw1 = 2*nlat*imid+1
c
c     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of dwork is 2*nlat+2
c
      call wbini1 (nlat,nlon,imid,wwbin,wwbin(iw1),dwork,dwork(nlat+2))
      return
      end
      subroutine wbini1 (nlat,nlon,imid,wb,abc,cwb,work)
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     cwb and work must each have nlat+1 locations
c
      dimension wb(imid,nlat,2),abc(1)
      double precision pi,dt,cwb(1),wbh,th,work(1)
      pi = 4.*datan(1.d0)
      dt = pi/(nlat-1)
      mdo = min0(3,nlat,(nlon+1)/2)
      if(mdo .lt. 2) return
      do 160 mp1=2,mdo
      m = mp1-1
      do 160 np1=mp1,nlat
      n = np1-1
      call dwbk(m,n,cwb,work)
      do 165 i=1,imid
      th = (i-1)*dt
      call dwbt(m,n,th,cwb,wbh)
      wb(i,np1,m) = wbh
  165 continue
  160 continue
      call rabcw(nlat,nlon,abc)
      return
      end
      subroutine vbin (ityp,nlat,nlon,m,vb,i3,wvbin)
      dimension       vb(1)        ,wvbin(1)
      imid = (nlat+1)/2
      lim = nlat*imid
      mmax = min0(nlat,(nlon+1)/2)
      labc = (max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
      iw1 = lim+1
      iw2 = iw1+lim
      iw3 = iw2+labc
      iw4 = iw3+labc
c
c     the length of wvbin is 2*lim+3*labc
c
      call vbin1 (ityp,nlat,m,vb,imid,i3,wvbin,wvbin(iw1),wvbin(iw2),
     1            wvbin(iw3),wvbin(iw4))
      return
      end
      subroutine vbin1 (ityp,nlat,m,vb,imid,i3,vbz,vb1,a,b,c)
      dimension       vb(imid,nlat,3),vbz(imid,1),vb1(imid,1),
     1                a(1),b(1),c(1)
      save i1,i2
      ihold = i1
      i1 = i2
      i2 = i3
      i3 = ihold
      if(m-1)25,30,35
   25 i1 = 1
      i2 = 2
      i3 = 3
      do 45 np1=1,nlat
      do 45 i=1,imid
      vb(i,np1,i3) = vbz(i,np1)
   45 continue
      return
   30 do 50 np1=2,nlat
      do 50 i=1,imid
      vb(i,np1,i3) = vb1(i,np1)
   50 continue
      return
   35 ns = ((m-2)*(nlat+nlat-m-1))/2+1
      if(ityp .eq. 1) go to 36
      do 85 i=1,imid
      vb(i,m+1,i3) = a(ns)*vb(i,m-1,i1)-c(ns)*vb(i,m+1,i1)
   85 continue
   36 if(m .eq. nlat-1) return
      if(ityp .eq. 2) go to 71
      ns = ns+1
      do 70 i=1,imid
      vb(i,m+2,i3) = a(ns)*vb(i,m,i1)-c(ns)*vb(i,m+2,i1)
   70 continue
   71 nstrt = m+3
      if(ityp .eq. 1) nstrt = m+4
      if(nstrt .gt. nlat) go to 80
      nstp = 2
      if(ityp .eq. 0) nstp = 1
      do 75 np1=nstrt,nlat,nstp
      ns = ns+nstp
      do 75 i=1,imid
      vb(i,np1,i3) = a(ns)*vb(i,np1-2,i1)+b(ns)*vb(i,np1-2,i3)
     1                              -c(ns)*vb(i,np1,i1)
   75 continue
   80 return
      end
      subroutine wbin (ityp,nlat,nlon,m,wb,i3,wwbin)
      dimension       wb(1)        ,wwbin(1)
      imid = (nlat+1)/2
      lim = nlat*imid
      mmax = min0(nlat,(nlon+1)/2)
      labc = (max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
      iw1 = lim+1
      iw2 = iw1+lim
      iw3 = iw2+labc
      iw4 = iw3+labc
c
c     the length of wwbin is 2*lim+3*labc
c
      call wbin1 (ityp,nlat,m,wb,imid,i3,wwbin,wwbin(iw1),wwbin(iw2),
     1            wwbin(iw3),wwbin(iw4))
      return
      end
      subroutine wbin1 (ityp,nlat,m,wb,imid,i3,wb1,wb2,a,b,c)
      dimension       wb(imid,nlat,3),wb1(imid,1),wb2(imid,1),
     1                a(1),b(1),c(1)
      save i1,i2
      ihold = i1
      i1 = i2
      i2 = i3
      i3 = ihold
      if(m-2)25,30,35
   25 i1 = 1
      i2 = 2
      i3 = 3
      do 45 np1=2,nlat
      do 45 i=1,imid
      wb(i,np1,i3) = wb1(i,np1)
   45 continue
      return
   30 do 50 np1=3,nlat
      do 50 i=1,imid
      wb(i,np1,i3) = wb2(i,np1)
   50 continue
      return
   35 ns = ((m-2)*(nlat+nlat-m-1))/2+1
      if(ityp .eq. 1) go to 36
      do 85 i=1,imid
      wb(i,m+1,i3) = a(ns)*wb(i,m-1,i1)-c(ns)*wb(i,m+1,i1)
   85 continue
   36 if(m .eq. nlat-1) return
      if(ityp .eq. 2) go to 71
      ns = ns+1
      do 70 i=1,imid
      wb(i,m+2,i3) = a(ns)*wb(i,m,i1)-c(ns)*wb(i,m+2,i1)
   70 continue
   71 nstrt = m+3
      if(ityp .eq. 1) nstrt = m+4
      if(nstrt .gt. nlat) go to 80
      nstp = 2
      if(ityp .eq. 0) nstp = 1
      do 75 np1=nstrt,nlat,nstp
      ns = ns+nstp
      do 75 i=1,imid
      wb(i,np1,i3) = a(ns)*wb(i,np1-2,i1)+b(ns)*wb(i,np1-2,i3)
     1                              -c(ns)*wb(i,np1,i1)
   75 continue
   80 return
      end
       subroutine dzvk(nlat,m,n,czv,work)
c
c     subroutine dzvk computes the coefficients in the trigonometric
c     expansion of the quadrature function zvbar(n,m,theta)
c
c     input parameters
c
c     nlat      the number of colatitudes including the poles.
c
c     n      the degree (subscript) of wbarv(n,m,theta)
c
c     m      the order (superscript) of wbarv(n,m,theta)
c
c     work   a work array with at least (nlat+1)/2 locations
c
c     output parameter
c
c     czv     the fourier coefficients of zvbar(n,m,theta).
c
      dimension czv(1),work(1)
      double precision czv,sc1,sum,work,t1,t2
      if(n .le. 0) return
      lc = (nlat+1)/2
      sc1 = 2.d0/float(nlat-1)
      call dvbk(m,n,work,czv)
      nmod = mod(n,2)
      mmod = mod(m,2)
      if(nmod .ne. 0) go to 1
      if(mmod .ne. 0) go to 2
c
c     n even, m even
c
      kdo = n/2
      do 9 id=1,lc
      i = id+id-2
      sum = 0.
      do 10 k=1,kdo
      t1 = 1.d0-(k+k+i)**2
      t2 = 1.d0-(k+k-i)**2
      sum = sum+work(k)*(t1-t2)/(t1*t2)
   10 continue
      czv(id) = sc1*sum
    9 continue
      return
c
c     n even, m odd
c
    2 kdo = n/2
      do 5 id=1,lc
      i = id+id-2
      sum = 0.
      do 6 k=1,kdo
      t1 = 1.d0-(k+k+i)**2
      t2 = 1.d0-(k+k-i)**2
      sum = sum+work(k)*(t1+t2)/(t1*t2)
    6 continue
      czv(id) = sc1*sum
    5 continue
      return
    1 if(mmod .ne. 0) go to 3
c
c     n odd, m even
c
      kdo = (n+1)/2
      do 19 id=1,lc
      i = id+id-3
      sum = 0.
      do 20 k=1,kdo
      t1 = 1.d0-(k+k-1+i)**2
      t2 = 1.d0-(k+k-1-i)**2
      sum = sum+work(k)*(t1-t2)/(t1*t2)
   20 continue
      czv(id) = sc1*sum
   19 continue
      return
c
c     n odd, m odd
c
    3 kdo = (n+1)/2
      do 15 id=1,lc
      i = id+id-1
      sum = 0.
      do 16 k=1,kdo
      t1 = 1.d0-(k+k-1+i)**2
      t2 = 1.d0-(k+k-1-i)**2
      sum = sum+work(k)*(t1+t2)/(t1*t2)
   16 continue
      czv(id) = sc1*sum
   15 continue
      return
      end
      subroutine dzvt(nlat,m,n,th,czv,zvh)
c
c     subroutine dzvt tabulates the function zvbar(n,m,theta)
c     at theta = th in double precision
c
c     input parameters
c
c     nlat      the number of colatitudes including the poles.
c
c     n      the degree (subscript) of zvbar(n,m,theta)
c
c     m      the order (superscript) of zvbar(n,m,theta)
c
c     czv     the fourier coefficients of zvbar(n,m,theta)
c             as computed by subroutine zwk.
c
c     output parameter
c
c     zvh     zvbar(m,n,theta) evaluated at theta = th
c
      dimension czv(1)
      double precision th,czv,zvh,cth,sth,cdt,sdt,chh
      zvh = 0.
      if(n .le. 0) return
      lc = (nlat+1)/2
      lq = lc-1
      ls = lc-2
      cth = dcos(th)
      sth = dsin(th)
      cdt = cth*cth-sth*sth
      sdt = 2.*sth*cth
      lmod = mod(nlat,2)
      mmod = mod(m,2)
      nmod = mod(n,2)
      if(lmod .eq. 0) go to 50
      if(nmod .ne. 0) go to 1
      cth = cdt
      sth = sdt
      if(mmod .ne. 0) go to 2
c
c     nlat odd  n even  m even
c
      do 10 k=1,ls
      zvh = zvh+czv(k+1)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   10 continue
      return
c
c     nlat odd  n even  m odd
c
    2 zvh = .5*czv(1)
      do 20 k=2,lq
      zvh = zvh+czv(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   20 continue
      zvh = zvh+.5*czv(lc)*dcos((nlat-1)*th)
      return
    1 if(mmod .ne. 0) go to 3
c
c     nlat odd  n odd  m even
c
      do 30 k=1,lq
      zvh = zvh+czv(k+1)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   30 continue
      return
c
c     nlat odd  n odd  m odd
c
    3 do 40 k=1,lq
      zvh = zvh+czv(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   40 continue
      return
   50 if(nmod .ne. 0) go to 51
      cth = cdt
      sth = sdt
      if(mmod .ne. 0) go to 52
c
c     nlat even  n even  m even
c
      do 55 k=1,lq
      zvh = zvh+czv(k+1)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   55 continue
      return
c
c     nlat even  n even  m odd
c
   52 zvh = .5*czv(1)
      do 57 k=2,lc
      zvh = zvh+czv(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   57 continue
      return
   51 if(mmod .ne. 0) go to 53
c
c     nlat even  n odd  m even
c
      do 58 k=1,lq
      zvh = zvh+czv(k+1)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   58 continue
      return
c
c     nlat even  n odd  m odd
c
   53 zvh = .5*czv(lc)*dcos((nlat-1)*th)
      do 60 k=1,lq
      zvh = zvh+czv(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   60 continue
      return
      end
      subroutine dzwk(nlat,m,n,czw,work)
c
c     subroutine dzwk computes the coefficients in the trigonometric
c     expansion of the quadrature function zwbar(n,m,theta)
c
c     input parameters
c
c     nlat      the number of colatitudes including the poles.
c
c     n      the degree (subscript) of zwbar(n,m,theta)
c
c     m      the order (superscript) of zwbar(n,m,theta)
c
c     work   a work array with at least (nlat+1)/2 locations
c
c     output parameter
c
c     czw     the fourier coefficients of zwbar(n,m,theta).
c
      dimension czw(1),work(1)
      double precision czw,work,sc1,sum,t1,t2
      if(n .le. 0) return
      lc = (nlat+1)/2
      sc1 = 2.d0/float(nlat-1)
      call dwbk(m,n,work,czw)
      nmod = mod(n,2)
      mmod = mod(m,2)
      if(nmod .ne. 0) go to 1
      if(mmod .ne. 0) go to 2
c
c     n even, m even
c
      kdo = n/2
      do 19 id=1,lc
      i = id+id-3
      sum = 0.
      do 20 k=1,kdo
      t1 = 1.d0-(k+k-1+i)**2
      t2 = 1.d0-(k+k-1-i)**2
      sum = sum+work(k)*(t1-t2)/(t1*t2)
   20 continue
      czw(id) = sc1*sum
   19 continue
      return
c
c     n even, m odd
c
    2 kdo = n/2
      do 15 id=1,lc
      i = id+id-1
      sum = 0.
      do 16 k=1,kdo
      t1 = 1.d0-(k+k-1+i)**2
      t2 = 1.d0-(k+k-1-i)**2
      sum = sum+work(k)*(t1+t2)/(t1*t2)
   16 continue
      czw(id) = sc1*sum
   15 continue
      return
    1 if(mmod .ne. 0) go to 3
c
c     n odd, m even
c
      kdo = (n-1)/2
      do 9 id=1,lc
      i = id+id-2
      sum = 0.
      do 10 k=1,kdo
      t1 = 1.d0-(k+k+i)**2
      t2 = 1.d0-(k+k-i)**2
      sum = sum+work(k)*(t1-t2)/(t1*t2)
   10 continue
      czw(id) = sc1*sum
    9 continue
      return
c
c     n odd, m odd
c
    3 kdo = (n+1)/2
      do 5 id=1,lc
      i = id+id-2
      sum = work(1)/(1.d0-i*i)
      if(kdo .lt. 2) go to 29
      do 6 kp1=2,kdo
      k = kp1-1
      t1 = 1.d0-(k+k+i)**2
      t2 = 1.d0-(k+k-i)**2
      sum = sum+work(kp1)*(t1+t2)/(t1*t2)
    6 continue
   29 czw(id) = sc1*sum
    5 continue
      return
      end
      subroutine dzwt(nlat,m,n,th,czw,zwh)
c
c     subroutine dzwt tabulates the function zwbar(n,m,theta)
c     at theta = th in double precision
c
c     input parameters
c
c     nlat      the number of colatitudes including the poles.
c            nlat must be an odd integer
c
c     n      the degree (subscript) of zwbar(n,m,theta)
c
c     m      the order (superscript) of zwbar(n,m,theta)
c
c     czw     the fourier coefficients of zwbar(n,m,theta)
c             as computed by subroutine zwk.
c
c     output parameter
c
c     zwh     zwbar(m,n,theta) evaluated at theta = th
c
      dimension czw(1)
      double precision czw,zwh,th,cth,sth,cdt,sdt,chh
      zwh = 0.
      if(n .le. 0) return
      lc = (nlat+1)/2
      lq = lc-1
      ls = lc-2
      cth = dcos(th)
      sth = dsin(th)
      cdt = cth*cth-sth*sth
      sdt = 2.*sth*cth
      lmod = mod(nlat,2)
      mmod = mod(m,2)
      nmod = mod(n,2)
      if(lmod .eq. 0) go to 50
      if(nmod .ne. 0) go to 1
      if(mmod .ne. 0) go to 2
c
c     nlat odd  n even  m even
c
      do 30 k=1,lq
      zwh = zwh+czw(k+1)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   30 continue
      return
c
c     nlat odd  n even  m odd
c
    2 do 40 k=1,lq
      zwh = zwh+czw(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   40 continue
      return
    1 cth = cdt
      sth = sdt
      if(mmod .ne. 0) go to 3
c
c     nlat odd  n odd  m even
c
      do 10 k=1,ls
      zwh = zwh+czw(k+1)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   10 continue
      return
c
c     nlat odd  n odd  m odd
c
    3 zwh = .5*czw(1)
      do 20 k=2,lq
      zwh = zwh+czw(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   20 continue
      zwh = zwh+.5*czw(lc)*dcos((nlat-1)*th)
      return
   50 if(nmod .ne. 0) go to 51
      if(mmod .ne. 0) go to 52
c
c     nlat even  n even  m even
c
      do 55 k=1,lq
      zwh = zwh+czw(k+1)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   55 continue
      return
c
c     nlat even  n even  m odd
c
   52 zwh = .5*czw(lc)*dcos((nlat-1)*th)
      do 60 k=1,lq
      zwh = zwh+czw(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   60 continue
      return
   51 cth = cdt
      sth = sdt
      if(mmod .ne. 0) go to 53
c
c     nlat even  n odd  m even
c
      do 65 k=1,lq
      zwh = zwh+czw(k+1)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   65 continue
      return
c
c     nlat even  n odd  m odd
c
   53 zwh = .5*czw(1)
      do 70 k=2,lc
      zwh = zwh+czw(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   70 continue
      return
      end
      subroutine dvbk(m,n,cv,work)
      double precision cv(1),work(1),fn,fk,cf
      cv(1) = 0.
      if(n .le. 0) return
      fn = n
      srnp1 = dsqrt(fn*(fn+1.))
      cf = 2.*m/srnp1
      modn = mod(n,2)
      modm = mod(m,2)
      call dnlfk(m,n,work)
      if(modn .ne. 0) go to 70
      ncv = n/2
      if(ncv .eq. 0) return
      fk = 0.
      if(modm .ne. 0) go to 60
c
c     n even m even
c
      do 55 l=1,ncv
      fk = fk+2.
      cv(l) = -fk*work(l+1)/srnp1
   55 continue
      return
c
c     n even m odd
c
   60 do 65 l=1,ncv
      fk = fk+2.
      cv(l) = fk*work(l)/srnp1
   65 continue
      return
   70 ncv = (n+1)/2
      fk = -1.
      if(modm .ne. 0) go to 80
c
c     n odd m even
c
      do 75 l=1,ncv
      fk = fk+2.
      cv(l) = -fk*work(l)/srnp1
   75 continue
      return
c
c     n odd m odd
c
   80 do 85 l=1,ncv
      fk = fk+2.
      cv(l) = fk*work(l)/srnp1
   85 continue
      return
      end
      subroutine dwbk(m,n,cw,work)
      double precision cw(1),work(1),fn,cf,srnp1
      cw(1) = 0.
      if(n.le.0 .or. m.le.0) return
      fn = n
      srnp1 = dsqrt(fn*(fn+1.))
      cf = 2.*m/srnp1
      modn = mod(n,2)
      modm = mod(m,2)
      call dnlfk(m,n,work)
      if(m .eq. 0) go to 50
      if(modn .ne. 0) go to 30
      l = n/2
      if(l .eq. 0) go to 50
      if(modm .ne. 0) go to 20
c
c     n even m even
c
      cw(l) = -cf*work(l+1)
   10 l = l-1
      if(l .le. 0) go to 50
      cw(l) = cw(l+1)-cf*work(l+1)
      go to 10
c
c     n even m odd
c
   20 cw(l) = cf*work(l)
   25 l = l-1
      if(l .le. 0) go to 50
      cw(l) = cw(l+1)+cf*work(l)
      go to 25
   30 if(modm .ne. 0) go to 40
      l = (n-1)/2
      if(l .eq. 0) go to 50
c
c     n odd m even
c
      cw(l) = -cf*work(l+1)
   35 l = l-1
      if(l .le. 0) go to 50
      cw(l) = cw(l+1)-cf*work(l+1)
      go to 35
c
c     n odd m odd
c
   40 l = (n+1)/2
      cw(l) = cf*work(l)
   45 l = l-1
      if(l .le. 0) go to 50
      cw(l) = cw(l+1)+cf*work(l)
      go to 45
   50 return
      end
      subroutine dvbt(m,n,theta,cv,vh)
      dimension cv(1)
      double precision cv,vh,theta,cth,sth,cdt,sdt,chh
      vh = 0.
      if(n.eq.0) return
      cth = dcos(theta)
      sth = dsin(theta)
      cdt = cth*cth-sth*sth
      sdt = 2.*sth*cth
      mmod = mod(m,2)
      nmod = mod(n,2)
      if(nmod .ne. 0) go to 1
      cth = cdt
      sth = sdt
      if(mmod .ne. 0) go to 2
c
c     n even  m even
c
      ncv = n/2
      do 10 k=1,ncv
      vh = vh+cv(k)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   10 continue
      return
c
c     n even  m odd
c
    2 ncv = n/2
      do 15 k=1,ncv
      vh = vh+cv(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   15 continue
      return
    1 if(mmod .ne. 0) go to 3
c
c     n odd m even
c
      ncv = (n+1)/2
      do 20 k=1,ncv
      vh = vh+cv(k)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   20 continue
      return
c
c case m odd and n odd
c
    3 ncv = (n+1)/2
      do 25 k=1,ncv
      vh = vh+cv(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   25 continue
      return
      end
      subroutine dwbt(m,n,theta,cw,wh)
      dimension cw(1)
      double precision theta,cw,wh,cth,sth,cdt,sdt,chh
      wh = 0.
      if(n.le.0 .or. m.le.0) return
      cth = dcos(theta)
      sth = dsin(theta)
      cdt = cth*cth-sth*sth
      sdt = 2.*sth*cth
      mmod=mod(m,2)
      nmod=mod(n,2)
      if(nmod .ne. 0) go to 1
      if(mmod .ne. 0) go to 2
c
c     n even  m even
c
      ncw = n/2
      do 10 k=1,ncw
      wh = wh+cw(k)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   10 continue
      return
c
c     n even  m odd
c
    2 ncw = n/2
      do 8 k=1,ncw
      wh = wh+cw(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
    8 continue
      return
    1 cth = cdt
      sth = sdt
      if(mmod .ne. 0) go to 3
c
c     n odd m even
c
      ncw = (n-1)/2
      do 20 k=1,ncw
      wh = wh+cw(k)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   20 continue
      return
c
c case m odd and n odd
c
    3 ncw = (n+1)/2
      wh = .5*cw(1)
      if(ncw.lt.2) return
      do 25 k=2,ncw
      wh = wh+cw(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   25 continue
      return
      end
      subroutine rabcv(nlat,nlon,abc)
c
c     subroutine rabcp computes the coefficients in the recurrence
c     relation for the functions vbar(m,n,theta). array abc
c     must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2 locations.
c
      dimension abc(1)
      mmax = min0(nlat,(nlon+1)/2)
      labc = (max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
      iw1 = labc+1
      iw2 = iw1+labc
      call rabcv1(nlat,nlon,abc,abc(iw1),abc(iw2))
      return
      end
      subroutine rabcv1(nlat,nlon,a,b,c)
c
c     coefficients a, b, and c for computing vbar(m,n,theta) are
c     stored in location ((m-2)*(nlat+nlat-m-1))/2+n+1
c
      dimension a(1),b(1),c(1)
      mmax = min0(nlat,(nlon+1)/2)
      if(mmax .lt. 3) return
      do 215 mp1=3,mmax
      m = mp1-1
      ns = ((m-2)*(nlat+nlat-m-1))/2+1
      fm = float(m)
      tm = fm+fm
      temp = tm*(tm-1.)
      tpn = (fm-2.)*(fm-1.)/(fm*(fm+1.))
      a(ns) = sqrt(tpn*(tm+1.)*(tm-2.)/temp)
      c(ns) = sqrt(2./temp)
      if(m .eq. nlat-1) go to 215
      ns = ns+1
      temp = tm*(tm+1.)
      tpn = (fm-1.)*fm/((fm+1.)*(fm+2.))
      a(ns) = sqrt(tpn*(tm+3.)*(tm-2.)/temp)
      c(ns) = sqrt(6./temp)
      mp3 = m+3
      if(mp3 .gt. nlat) go to 215
      do 210 np1=mp3,nlat
      n = np1-1
      ns = ns+1
      fn = float(n)
      tn = fn+fn
      cn = (tn+1.)/(tn-3.)
      tpn = (fn-2.)*(fn-1.)/(fn*(fn+1.))
      fnpm = fn+fm
      fnmm = fn-fm
      temp = fnpm*(fnpm-1.)
      a(ns) = sqrt(tpn*cn*(fnpm-3.)*(fnpm-2.)/temp)
      b(ns) = sqrt(tpn*cn*fnmm*(fnmm-1.)/temp)
      c(ns) = sqrt((fnmm+1.)*(fnmm+2.)/temp)
  210 continue
  215 continue
      return
      end
      subroutine rabcw(nlat,nlon,abc)
c
c     subroutine rabcw computes the coefficients in the recurrence
c     relation for the functions wbar(m,n,theta). array abc
c     must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2 locations.
c
      dimension abc(1)
      mmax = min0(nlat,(nlon+1)/2)
      labc = (max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
      iw1 = labc+1
      iw2 = iw1+labc
      call rabcw1(nlat,nlon,abc,abc(iw1),abc(iw2))
      return
      end
      subroutine rabcw1(nlat,nlon,a,b,c)
c
c     coefficients a, b, and c for computing wbar(m,n,theta) are
c     stored in location ((m-2)*(nlat+nlat-m-1))/2+n+1
c
      dimension a(1),b(1),c(1)
      mmax = min0(nlat,(nlon+1)/2)
      if(mmax .lt. 4) return
      do 215 mp1=4,mmax
      m = mp1-1
      ns = ((m-2)*(nlat+nlat-m-1))/2+1
      fm = float(m)
      tm = fm+fm
      temp = tm*(tm-1.)
      tpn = (fm-2.)*(fm-1.)/(fm*(fm+1.))
      tph = fm/(fm-2.)
      a(ns) = tph*sqrt(tpn*(tm+1.)*(tm-2.)/temp)
      c(ns) = tph*sqrt(2./temp)
      if(m .eq. nlat-1) go to 215
      ns = ns+1
      temp = tm*(tm+1.)
      tpn = (fm-1.)*fm/((fm+1.)*(fm+2.))
      tph = fm/(fm-2.)
      a(ns) = tph*sqrt(tpn*(tm+3.)*(tm-2.)/temp)
      c(ns) = tph*sqrt(6./temp)
      mp3 = m+3
      if(mp3 .gt. nlat) go to 215
      do 210 np1=mp3,nlat
      n = np1-1
      ns = ns+1
      fn = float(n)
      tn = fn+fn
      cn = (tn+1.)/(tn-3.)
      fnpm = fn+fm
      fnmm = fn-fm
      temp = fnpm*(fnpm-1.)
      tpn = (fn-2.)*(fn-1.)/(fn*(fn+1.))
      tph = fm/(fm-2.)
      a(ns) = tph*sqrt(tpn*cn*(fnpm-3.)*(fnpm-2.)/temp)
      b(ns) = sqrt(tpn*cn*fnmm*(fnmm-1.)/temp)
      c(ns) = tph*sqrt((fnmm+1.)*(fnmm+2.)/temp)
  210 continue
  215 continue
      return
      end
      subroutine vtinit (nlat,nlon,wvbin,dwork)
      dimension       wvbin(*)
      double precision dwork(*)
      imid = (nlat+1)/2
      iw1 = 2*nlat*imid+1
c
c     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of dwork is 2*nlat+2
c
      call vtini1 (nlat,nlon,imid,wvbin,wvbin(iw1),dwork,dwork(nlat+2))
      return
      end
      subroutine vtini1 (nlat,nlon,imid,vb,abc,cvb,work)
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     cvb and work must each have nlat+1 locations
c
      dimension vb(imid,nlat,2),abc(1),cvb(1)
      double precision pi,dt,cvb,th,vbh,work(*)
      pi = 4.*datan(1.d0)
      dt = pi/(nlat-1)
      mdo = min0(2,nlat,(nlon+1)/2)
      do 160 mp1=1,mdo
      m = mp1-1
      do 160 np1=mp1,nlat
      n = np1-1
      call dvtk(m,n,cvb,work)
      do 165 i=1,imid
      th = (i-1)*dt
      call dvtt(m,n,th,cvb,vbh)
      vb(i,np1,mp1) = vbh
  165 continue
  160 continue
      call rabcv(nlat,nlon,abc)
      return
      end
      subroutine wtinit (nlat,nlon,wwbin,dwork)
      dimension       wwbin(1)
      double precision dwork(*)
      imid = (nlat+1)/2
      iw1 = 2*nlat*imid+1
c
c     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of dwork is 2*nlat+2
c
      call wtini1 (nlat,nlon,imid,wwbin,wwbin(iw1),dwork,dwork(nlat+2))
      return
      end
      subroutine wtini1 (nlat,nlon,imid,wb,abc,cwb,work)
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     cwb and work must each have nlat+1 locations
c
      dimension wb(imid,nlat,2),abc(1)
      double precision pi,dt,cwb(*),wbh,th,work(*)
      pi = 4.*datan(1.d0)
      dt = pi/(nlat-1)
      mdo = min0(3,nlat,(nlon+1)/2)
      if(mdo .lt. 2) return
      do 160 mp1=2,mdo
      m = mp1-1
      do 160 np1=mp1,nlat
      n = np1-1
      call dwtk(m,n,cwb,work)
      do 165 i=1,imid
      th = (i-1)*dt
      call dwtt(m,n,th,cwb,wbh)
      wb(i,np1,m) = wbh
  165 continue
  160 continue
      call rabcw(nlat,nlon,abc)
      return
      end
      subroutine vtgint (nlat,nlon,theta,wvbin,work)
      dimension       wvbin(*)
      double precision theta(*), work(*)
      imid = (nlat+1)/2
      iw1 = 2*nlat*imid+1
c
c     theta is a double precision array with (nlat+1)/2 locations
c     nlat is the maximum value of n+1
c     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of work is 2*nlat+2
c
      call vtgit1 (nlat,nlon,imid,theta,wvbin,wvbin(iw1),
     +                        work,work(nlat+2))
c    1                        work,work(2*nlat+3))
      return
      end
      subroutine vtgit1 (nlat,nlon,imid,theta,vb,abc,cvb,work)
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     cvb and work must each have nlat+1   locations
c
      dimension vb(imid,nlat,2),abc(*)
      double precision theta(*),cvb(*),work(*),vbh
      mdo = min0(2,nlat,(nlon+1)/2)
      do 160 mp1=1,mdo
      m = mp1-1
      do 160 np1=mp1,nlat
      n = np1-1
      call dvtk(m,n,cvb,work)
      do 165 i=1,imid
      call dvtt(m,n,theta(i),cvb,vbh)
      vb(i,np1,mp1) = vbh
  165 continue
  160 continue
      call rabcv(nlat,nlon,abc)
      return
      end
      subroutine wtgint (nlat,nlon,theta,wwbin,work)
      dimension       wwbin(*)
      double precision theta(*), work(*)
      imid = (nlat+1)/2
      iw1 = 2*nlat*imid+1
c
c     theta is a double precision array with (nlat+1)/2 locations
c     nlat is the maximum value of n+1
c     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of work is 2*nlat+2
c
      call wtgit1 (nlat,nlon,imid,theta,wwbin,wwbin(iw1),
     1                        work,work(nlat+2))
      return
      end
      subroutine wtgit1 (nlat,nlon,imid,theta,wb,abc,cwb,work)
c
c     abc must have 3*((nlat-3)*nlat+2)/2 locations
c     cwb and work must each have nlat+1 locations
c
      dimension wb(imid,nlat,2),abc(1)
      double precision theta(*), cwb(*), work(*), wbh
      mdo = min0(3,nlat,(nlon+1)/2)
      if(mdo .lt. 2) return
      do 160 mp1=2,mdo
      m = mp1-1
      do 160 np1=mp1,nlat
      n = np1-1
      call dwtk(m,n,cwb,work)
      do 165 i=1,imid
      call dwtt(m,n,theta(i),cwb,wbh)
      wb(i,np1,m) = wbh
  165 continue
  160 continue
      call rabcw(nlat,nlon,abc)
      return
      end
      subroutine dvtk(m,n,cv,work)
      double precision cv(*),work(*),fn,fk,cf,srnp1
      cv(1) = 0.
      if(n .le. 0) return
      fn = n
      srnp1 = dsqrt(fn*(fn+1.))
      cf = 2.*m/srnp1
      modn = mod(n,2)
      modm = mod(m,2)
      call dnlfk(m,n,work)
      if(modn .ne. 0) go to 70
      ncv = n/2
      if(ncv .eq. 0) return
      fk = 0.
      if(modm .ne. 0) go to 60
c
c     n even m even
c
      do 55 l=1,ncv
      fk = fk+2.
      cv(l) = -fk*fk*work(l+1)/srnp1
   55 continue
      return
c
c     n even m odd
c
   60 do 65 l=1,ncv
      fk = fk+2.
      cv(l) = -fk*fk*work(l)/srnp1
   65 continue
      return
   70 ncv = (n+1)/2
      fk = -1.
      if(modm .ne. 0) go to 80
c
c     n odd m even
c
      do 75 l=1,ncv
      fk = fk+2.
      cv(l) = -fk*fk*work(l)/srnp1
   75 continue
      return
c
c     n odd m odd
c
   80 do 85 l=1,ncv
      fk = fk+2.
      cv(l) = -fk*fk*work(l)/srnp1
   85 continue
      return
      end
      subroutine dwtk(m,n,cw,work)
      double precision cw(*),work(*),fn,cf,srnp1
      cw(1) = 0.
      if(n.le.0 .or. m.le.0) return
      fn = n
      srnp1 = dsqrt(fn*(fn+1.))
      cf = 2.*m/srnp1
      modn = mod(n,2)
      modm = mod(m,2)
      call dnlfk(m,n,work)
      if(m .eq. 0) go to 50
      if(modn .ne. 0) go to 30
      l = n/2
      if(l .eq. 0) go to 50
      if(modm .ne. 0) go to 20
c
c     n even m even
c
      cw(l) = -cf*work(l+1)
   10 l = l-1
      if(l .le. 0) go to 50
      cw(l) = cw(l+1)-cf*work(l+1)
      cw(l+1) = (l+l+1)*cw(l+1)
      go to 10
c
c     n even m odd
c
   20 cw(l) = cf*work(l)
   25 l = l-1
      if(l) 50,27,26
   26 cw(l) = cw(l+1)+cf*work(l)
   27 cw(l+1) = -(l+l+1)*cw(l+1)
      go to 25
   30 if(modm .ne. 0) go to 40
      l = (n-1)/2
      if(l .eq. 0) go to 50
c
c     n odd m even
c
      cw(l) = -cf*work(l+1)
   35 l = l-1
      if(l) 50,37,36
   36 cw(l) = cw(l+1)-cf*work(l+1)
   37 cw(l+1) = (l+l+2)*cw(l+1)
      go to 35
c
c     n odd m odd
c
   40 l = (n+1)/2
      cw(l) = cf*work(l)
   45 l = l-1
      if(l) 50,47,46
   46 cw(l) = cw(l+1)+cf*work(l)
   47 cw(l+1) = -(l+l)*cw(l+1)
      go to 45
   50 return
      end
      subroutine dvtt(m,n,theta,cv,vh)
      dimension cv(1)
      double precision cv,vh,theta,cth,sth,cdt,sdt,chh
      vh = 0.
      if(n.eq.0) return
      cth = dcos(theta)
      sth = dsin(theta)
      cdt = cth*cth-sth*sth
      sdt = 2.*sth*cth
      mmod = mod(m,2)
      nmod = mod(n,2)
      if(nmod .ne. 0) go to 1
      cth = cdt
      sth = sdt
      if(mmod .ne. 0) go to 2
c
c     n even  m even
c
      ncv = n/2
      do 10 k=1,ncv
      vh = vh+cv(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   10 continue
      return
c
c     n even  m odd
c
    2 ncv = n/2
      do 15 k=1,ncv
      vh = vh+cv(k)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   15 continue
      return
    1 if(mmod .ne. 0) go to 3
c
c     n odd m even
c
      ncv = (n+1)/2
      do 20 k=1,ncv
      vh = vh+cv(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   20 continue
      return
c
c case m odd and n odd
c
    3 ncv = (n+1)/2
      do 25 k=1,ncv
      vh = vh+cv(k)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   25 continue
      return
      end
      subroutine dwtt(m,n,theta,cw,wh)
      dimension cw(1)
      double precision theta,cw,wh,cth,sth,cdt,sdt,chh
      wh = 0.
      if(n.le.0 .or. m.le.0) return
      cth = dcos(theta)
      sth = dsin(theta)
      cdt = cth*cth-sth*sth
      sdt = 2.*sth*cth
      mmod=mod(m,2)
      nmod=mod(n,2)
      if(nmod .ne. 0) go to 1
      if(mmod .ne. 0) go to 2
c
c     n even  m even
c
      ncw = n/2
      do 10 k=1,ncw
      wh = wh+cw(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   10 continue
      return
c
c     n even  m odd
c
    2 ncw = n/2
      do 8 k=1,ncw
      wh = wh+cw(k)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
    8 continue
      return
    1 cth = cdt
      sth = sdt
      if(mmod .ne. 0) go to 3
c
c     n odd m even
c
      ncw = (n-1)/2
      do 20 k=1,ncw
      wh = wh+cw(k)*cth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   20 continue
      return
c
c case m odd and n odd
c
    3 ncw = (n+1)/2
      wh = 0.
      if(ncw.lt.2) return
      do 25 k=2,ncw
      wh = wh+cw(k)*sth
      chh = cdt*cth-sdt*sth
      sth = sdt*cth+cdt*sth
      cth = chh
   25 continue
      return
      end
      subroutine vbgint (nlat,nlon,theta,wvbin,work)
      dimension       wvbin(1)
      double precision theta(*),work(*)
      imid = (nlat+1)/2
      iw1 = 2*nlat*imid+1
c
c     theta is a double precision array with (nlat+1)/2 locations
c     nlat is the maximum value of n+1
c     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of work is 2*nlat+2
c
      call vbgit1 (nlat,nlon,imid,theta,wvbin,wvbin(iw1),
     +                        work,work(nlat+2))
c    1                        work,work(2*nlat+3))
      return
      end
      subroutine vbgit1 (nlat,nlon,imid,theta,vb,abc,cvb,work)
c
c     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
c     locations where mmax = min0(nlat,(nlon+1)/2)
c     cvb and work must each have nlat+1 locations
c
      dimension vb(imid,nlat,2),abc(1)
      double precision cvb(1),theta(1),vbh,work(1)
      mdo = min0(2,nlat,(nlon+1)/2)
      do 160 mp1=1,mdo
      m = mp1-1
      do 160 np1=mp1,nlat
      n = np1-1
      call dvbk(m,n,cvb,work)
      do 165 i=1,imid
      call dvbt(m,n,theta(i),cvb,vbh)
      vb(i,np1,mp1) = vbh
  165 continue
  160 continue
      call rabcv(nlat,nlon,abc)
      return
      end
      subroutine wbgint (nlat,nlon,theta,wwbin,work)
      dimension       wwbin(1)
      double precision work(*),theta(*)
      imid = (nlat+1)/2
      iw1 = 2*nlat*imid+1
c
c     theta is a double precision array with (nlat+1)/2 locations
c     nlat is the maximum value of n+1
c     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
c     the length of work is 2*nlat+2
c
      call wbgit1 (nlat,nlon,imid,theta,wwbin,wwbin(iw1),
     +                        work,work(nlat+2))
      return
      end
      subroutine wbgit1 (nlat,nlon,imid,theta,wb,abc,cwb,work)
c
c     abc must have 3*((nlat-3)*nlat+2)/2 locations
c     cwb and work must each have nlat+1 locations
c
      dimension wb(imid,nlat,2),abc(1)
      double precision cwb(1),theta(1),wbh,work(1)
      mdo = min0(3,nlat,(nlon+1)/2)
      if(mdo .lt. 2) return
      do 160 mp1=2,mdo
      m = mp1-1
      do 160 np1=mp1,nlat
      n = np1-1
      call dwbk(m,n,cwb,work)
      do 165 i=1,imid
      call dwbt(m,n,theta(i),cwb,wbh)
      wb(i,np1,m) = wbh
  165 continue
  160 continue
      call rabcw(nlat,nlon,abc)
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file ivlapec.f
!
!     this file includes documentation and code for
!     subroutine ivlapec
!
! ... files which must be loaded with ivlapec.f
!
!     sphcom.f, hrfft.f, vhaec.f, vhsec.f
!
!
!
!     subroutine ivlapec(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
!    +mdbc,ndbc,wvhsec,lvhsec,work,lwork,ierror)
!
!
!     subroutine ivlapec computes a the vector field (v,w) whose vector
!     laplacian is (vlap,wlap).  w and wlap are east longitudinal
!     components of the vectors.  v and vlap are colatitudinal components
!     of the vectors.  br,bi,cr, and ci are the vector harmonic coefficients
!     of (vlap,wlap).  these must be precomputed by vhaec and are input
!     parameters to ivlapec.  (v,w) have the same symmetry or lack of
!     symmetry about the about the equator as (vlap,wlap).  the input
!     parameters ityp,nt,mdbc,ndbc must have the same values used by
!     vhaec to compute br,bi,cr, and ci for (vlap,wlap).
!
!
!     input parameters
!
!     nlat   the number of colatitudes on the full sphere including the
!            poles. for example, nlat = 37 for a five degree grid.
!            nlat determines the grid increment in colatitude as
!            pi/(nlat-1).  if nlat is odd the equator is located at
!            grid point i=(nlat+1)/2. if nlat is even the equator is
!            located half way between points i=nlat/2 and i=nlat/2+1.
!            nlat must be at least 3. note: on the half sphere, the
!            number of grid points in the colatitudinal direction is
!            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct longitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than zero. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!     ityp   this parameter should have the same value input to subroutine
!            vhaec to compute the coefficients br,bi,cr, and ci for the
!            vector field (vlap,wlap).  ityp is set as follows:
!
!            = 0  no symmetries exist in (vlap,wlap) about the equator. (v,w)
!                 is computed and stored on the entire sphere in the arrays
!                 arrays v(i,j) and w(i,j) for i=1,...,nlat and j=1,...,nlon.
!
!            = 1  no symmetries exist in (vlap,wlap) about the equator. (v,w)
!                 is computed and stored on the entire sphere in the arrays
!                 v(i,j) and w(i,j) for i=1,...,nlat and j=1,...,nlon.  the
!                 vorticity of (vlap,wlap) is zero so the coefficients cr and
!                 ci are zero and are not used.  the vorticity of (v,w) is
!                 also zero.
!
!
!            = 2  no symmetries exist in (vlap,wlap) about the equator. (v,w)
!                 is computed and stored on the entire sphere in the arrays
!                 w(i,j) and v(i,j) for i=1,...,nlat and j=1,...,nlon.  the
!                 divergence of (vlap,wlap) is zero so the coefficients br and
!                 bi are zero and are not used.  the divergence of (v,w) is
!                 also zero.
!
!            = 3  wlap is antisymmetric and vlap is symmetric about the
!                 equator. consequently w is antisymmetric and v is symmetric.
!                 (v,w) is computed and stored on the northern hemisphere
!                 only.  if nlat is odd, storage is in the arrays v(i,j),
!                 w(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
!                 is even, storage is in the arrays v(i,j),w(i,j) for
!                 i=1,...,nlat/2 and j=1,...,nlon.
!
!            = 4  wlap is antisymmetric and vlap is symmetric about the
!                 equator. consequently w is antisymmetric and v is symmetric.
!                 (v,w) is computed and stored on the northern hemisphere
!                 only.  if nlat is odd, storage is in the arrays v(i,j),
!                 w(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
!                 is even, storage is in the arrays v(i,j),w(i,j) for
!                 i=1,...,nlat/2 and j=1,...,nlon.  the vorticity of (vlap,
!                 wlap) is zero so the coefficients cr,ci are zero and
!                 are not used. the vorticity of (v,w) is also zero.
!
!            = 5  wlap is antisymmetric and vlap is symmetric about the
!                 equator. consequently w is antisymmetric and v is symmetric.
!                 (v,w) is computed and stored on the northern hemisphere
!                 only.  if nlat is odd, storage is in the arrays w(i,j),
!                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
!                 is even, storage is in the arrays w(i,j),v(i,j) for
!                 i=1,...,nlat/2 and j=1,...,nlon.  the divergence of (vlap,
!                 wlap) is zero so the coefficients br,bi are zero and
!                 are not used. the divergence of (v,w) is also zero.
!
!
!            = 6  wlap is symmetric and vlap is antisymmetric about the
!                 equator. consequently w is symmetric and v is antisymmetric.
!                 (v,w) is computed and stored on the northern hemisphere
!                 only.  if nlat is odd, storage is in the arrays w(i,j),
!                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
!                 is even, storage is in the arrays w(i,j),v(i,j) for
!                 i=1,...,nlat/2 and j=1,...,nlon.
!
!            = 7  wlap is symmetric and vlap is antisymmetric about the
!                 equator. consequently w is symmetric and v is antisymmetric.
!                 (v,w) is computed and stored on the northern hemisphere
!                 only.  if nlat is odd, storage is in the arrays w(i,j),
!                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
!                 is even, storage is in the arrays w(i,j),v(i,j) for
!                 i=1,...,nlat/2 and j=1,...,nlon.  the vorticity of (vlap,
!                 wlap) is zero so the coefficients cr,ci are zero and
!                 are not used. the vorticity of (v,w) is also zero.
!
!            = 8  wlap is symmetric and vlap is antisymmetric about the
!                 equator. consequently w is symmetric and v is antisymmetric.
!                 (v,w) is computed and stored on the northern hemisphere
!                 only.  if nlat is odd, storage is in the arrays w(i,j),
!                 v(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if nlat
!                 is even, storage is in the arrays w(i,j),v(i,j) for
!                 i=1,...,nlat/2 and j=1,...,nlon.  the divergence of (vlap,
!                 wlap) is zero so the coefficients br,bi are zero and
!                 are not used. the divergence of (v,w) is also zero.
!
!
!     nt     nt is the number of vector fields (vlap,wlap). some computational
!            efficiency is obtained for multiple fields.  in the program
!            that calls ivlapec, the arrays v,w,br,bi,cr and ci can be
!            three dimensional corresponding to an indexed multiple vector
!            field.  in this case multiple vector synthesis will be performed
!            to compute the (v,w) for each field (vlap,wlap).  the third
!            index is the synthesis index which assumes the values k=1,...,nt.
!            for a single synthesis set nt=1.  the description of the
!            remaining parameters is simplified by assuming that nt=1 or
!            that all arrays are two dimensional.
!
!   idvw     the first dimension of the arrays w and v as it appears in
!            the program that calls ivlapec.  if ityp=0,1, or 2  then idvw
!            must be at least nlat.  if ityp > 2 and nlat is even then idvw
!            must be at least nlat/2. if ityp > 2 and nlat is odd then idvw
!            must be at least (nlat+1)/2.
!
!   jdvw     the second dimension of the arrays w and v as it appears in
!            the program that calls ivlapec. jdvw must be at least nlon.
!
!
!   br,bi    two or three dimensional arrays (see input parameter nt)
!   cr,ci    that contain vector spherical harmonic coefficients of the
!            vector field (vlap,wlap) as computed by subroutine vhaec.
!            br,bi,cr and ci must be computed by vhaec prior to calling
!            ivlapec.  if ityp=1,4, or 7 then cr,ci are not used and can
!            be dummy arguments.  if ityp=2,5, or 8 then br,bi are not
!            used and can be dummy arguments.
!
!    mdbc    the first dimension of the arrays br,bi,cr and ci as it
!            appears in the program that calls ivlapec.  mdbc must be
!            at least min0(nlat,nlon/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!    ndbc    the second dimension of the arrays br,bi,cr and ci as it
!            appears in the program that calls ivlapec. ndbc must be at
!            least nlat.
!
!    wvhsec  an array which must be initialized by subroutine vhseci.
!            once initialized, wvhsec
!            can be used repeatedly by ivlapec as long as nlat and nlon
!            remain unchanged.  wvhsec must not be altered between calls
!            of ivlapec.
!
!    lvhsec  the dimension of the array wvhsec as it appears in the
!            program that calls ivlapec.  let
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd.
!
!            then lvhsec must be at least
!
!            4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls ivlapec. define
!
!               l2 = nlat/2                    if nlat is even or
!               l2 = (nlat+1)/2                if nlat is odd
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            if ityp .le. 2 then
!
!               nlat*(2*nt*nlon+max0(6*l2,nlon)) + nlat*(4*nt*l1+1)
!
!            or if ityp .gt. 2 let
!
!               l2*(2*nt*nlon+max0(6*nlat,nlon)) + nlat*(4*nt*l1+1)
!
!            will suffice as a minimum length for lwork
!            (see ierror=10 below)
!
!     **************************************************************
!
!     output parameters
!
!
!    v,w     two or three dimensional arrays (see input parameter nt) that
!            contain a vector field whose vector laplacian is (vlap,wlap).
!            w(i,j) is the east longitude and v(i,j) is the colatitudinal
!            component of the vector. v(i,j) and w(i,j) are given on the
!            sphere at the colatitude
!
!                 theta(i) = (i-1)*pi/(nlat-1)
!
!            for i=1,...,nlat and east longitude
!
!                 lambda(j) = (j-1)*2*pi/nlon
!
!            for j=1,...,nlon.
!
!            let cost and sint be the cosine and sine at colatitude theta.
!            let d( )/dlambda  and d( )/dtheta be the first order partial
!            derivatives in longitude and colatitude.  let sf be either v
!            or w.  define:
!
!                 del2s(sf) = [d(sint*d(sf)/dtheta)/dtheta +
!                               2            2
!                              d (sf)/dlambda /sint]/sint
!
!            then the vector laplacian of (v,w) in (vlap,wlap) satisfies
!
!                 vlap = del2s(v) + (2*cost*dw/dlambda - v)/sint**2
!
!            and
!
!                 wlap = del2s(w) - (2*cost*dv/dlambda + w)/sint**2
!
!
!  ierror    a parameter which flags errors in input parameters as follows:
!
!            = 0  no errors detected
!
!            = 1  error in the specification of nlat
!
!            = 2  error in the specification of nlon
!
!            = 3  error in the specification of ityp
!
!            = 4  error in the specification of nt
!
!            = 5  error in the specification of idvw
!
!            = 6  error in the specification of jdvw
!
!            = 7  error in the specification of mdbc
!
!            = 8  error in the specification of ndbc
!
!            = 9  error in the specification of lvhsec
!
!            = 10 error in the specification of lwork
!
!
! **********************************************************************
!
!     end of documentation for ivlapec
!
! **********************************************************************
!
      SUBROUTINE IVLAPEC(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,   &
                       & Mdbc,Ndbc,Wvhsec,Lvhsec,Work,Lwork,Ierror)
      IMPLICIT NONE

      REAL Bi , Br , Ci , Cr , V , W , Work , Wvhsec
      INTEGER ibi , ibr , ici , icr , Idvw , idz , Ierror , ifn , imid ,&
            & Ityp , iwk , Jdvw , labc , liwk , Lvhsec , lwkmin ,       &
            & Lwork , lzimn , lzz1 , Mdbc
      INTEGER mmax , mn , Ndbc , Nlat , Nlon , Nt
      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt)
      DIMENSION Br(Mdbc,Ndbc,Nt) , Bi(Mdbc,Ndbc,Nt)
      DIMENSION Cr(Mdbc,Ndbc,Nt) , Ci(Mdbc,Ndbc,Nt)
      DIMENSION Wvhsec(Lvhsec) , Work(Lwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      IF ( Ityp<0 .OR. Ityp>8 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Ityp<=2 .AND. Idvw<Nlat) .OR. (Ityp>2 .AND. Idvw<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdbc<mmax ) RETURN
      Ierror = 8
      IF ( Ndbc<Nlat ) RETURN
      Ierror = 9
!
!     set minimum and verify saved workspace length
!
      idz = (mmax*(Nlat+Nlat-mmax+1))/2
      lzimn = idz*imid
!     lsavmin = lzimn+lzimn+nlon+15
!     if (lvhsec .lt. lsavmin) return
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lvhsec<2*(lzz1+labc)+Nlon+15 ) RETURN
!
!     set minimum and verify unsaved work space length
!
      Ierror = 10
      mn = mmax*Nlat*Nt
      IF ( Ityp<3 ) THEN
!     no symmetry
         IF ( Ityp==0 ) THEN
!       br,bi,cr,ci nonzero
            lwkmin = Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon)+1) + 4*mn
         ELSE
!       br,bi or cr,ci zero
            lwkmin = Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon)+1) + 2*mn
         ENDIF
!     symmetry
      ELSEIF ( Ityp==3 .OR. Ityp==6 ) THEN
!       br,bi,cr,ci nonzero
         lwkmin = imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon)) + 4*mn + Nlat
      ELSE
!       br,bi or cr,ci zero
         lwkmin = imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon)) + 2*mn + Nlat
      ENDIF
      IF ( Lwork<lwkmin ) RETURN
      Ierror = 0
!
!     set work space pointers for vector laplacian coefficients
!
      IF ( Ityp==0 .OR. Ityp==3 .OR. Ityp==6 ) THEN
         ibr = 1
         ibi = ibr + mn
         icr = ibi + mn
         ici = icr + mn
      ELSEIF ( Ityp==1 .OR. Ityp==4 .OR. Ityp==7 ) THEN
         ibr = 1
         ibi = ibr + mn
         icr = ibi + mn
         ici = icr
      ELSE
         ibr = 1
         ibi = 1
         icr = ibi + mn
         ici = icr + mn
      ENDIF
      ifn = ici + mn
      iwk = ifn + Nlat
      IF ( Ityp==0 .OR. Ityp==3 .OR. Ityp==6 ) THEN
         liwk = Lwork - 4*mn - Nlat
      ELSE
         liwk = Lwork - 2*mn - Nlat
      ENDIF
      CALL IVLAPEC1(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Work(ibr),Work(ibi),&
                  & Work(icr),Work(ici),mmax,Work(ifn),Mdbc,Ndbc,Br,Bi, &
                  & Cr,Ci,Wvhsec,Lvhsec,Work(iwk),liwk,Ierror)
    END SUBROUTINE IVLAPEC
 

    SUBROUTINE IVLAPEC1(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Brvw,Bivw,    &
                        & Crvw,Civw,Mmax,Fnn,Mdbc,Ndbc,Br,Bi,Cr,Ci,     &
                        & Wsave,Lwsav,Wk,Lwk,Ierror)
      IMPLICIT NONE
      REAL Bi , Bivw , Br , Brvw , Ci , Civw , Cr , Crvw , fn , Fnn ,   &
         & V , W , Wk , Wsave
      INTEGER Idvw , Ierror , Ityp , Jdvw , k , Lwk , Lwsav , m , Mdbc ,&
            & Mmax , n , Ndbc , Nlat , Nlon , Nt

      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt)
      DIMENSION Fnn(Nlat) , Brvw(Mmax,Nlat,Nt) , Bivw(Mmax,Nlat,Nt)
      DIMENSION Crvw(Mmax,Nlat,Nt) , Civw(Mmax,Nlat,Nt)
      DIMENSION Br(Mdbc,Ndbc,Nt) , Bi(Mdbc,Ndbc,Nt)
      DIMENSION Cr(Mdbc,Ndbc,Nt) , Ci(Mdbc,Ndbc,Nt)
      DIMENSION Wsave(Lwsav) , Wk(Lwk)
!
!     preset coefficient multiplyers
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Fnn(n) = -1.0/(fn*(fn+1.))
      ENDDO
!
!     set (v,w) coefficients from br,bi,cr,ci
!
      IF ( Ityp==0 .OR. Ityp==3 .OR. Ityp==6 ) THEN
!
!     all coefficients needed
!
         DO k = 1 , Nt
            DO n = 1 , Nlat
               DO m = 1 , Mmax
                  Brvw(m,n,k) = 0.0
                  Bivw(m,n,k) = 0.0
                  Crvw(m,n,k) = 0.0
                  Civw(m,n,k) = 0.0
               ENDDO
            ENDDO
            DO n = 2 , Nlat
               Brvw(1,n,k) = Fnn(n)*Br(1,n,k)
               Bivw(1,n,k) = Fnn(n)*Bi(1,n,k)
               Crvw(1,n,k) = Fnn(n)*Cr(1,n,k)
               Civw(1,n,k) = Fnn(n)*Ci(1,n,k)
            ENDDO
            DO m = 2 , Mmax
               DO n = m , Nlat
                  Brvw(m,n,k) = Fnn(n)*Br(m,n,k)
                  Bivw(m,n,k) = Fnn(n)*Bi(m,n,k)
                  Crvw(m,n,k) = Fnn(n)*Cr(m,n,k)
                  Civw(m,n,k) = Fnn(n)*Ci(m,n,k)
               ENDDO
            ENDDO
         ENDDO
      ELSEIF ( Ityp==1 .OR. Ityp==4 .OR. Ityp==7 ) THEN
!
!     vorticity is zero so cr,ci=0 not used
!
         DO k = 1 , Nt
            DO n = 1 , Nlat
               DO m = 1 , Mmax
                  Brvw(m,n,k) = 0.0
                  Bivw(m,n,k) = 0.0
               ENDDO
            ENDDO
            DO n = 2 , Nlat
               Brvw(1,n,k) = Fnn(n)*Br(1,n,k)
               Bivw(1,n,k) = Fnn(n)*Bi(1,n,k)
            ENDDO
            DO m = 2 , Mmax
               DO n = m , Nlat
                  Brvw(m,n,k) = Fnn(n)*Br(m,n,k)
                  Bivw(m,n,k) = Fnn(n)*Bi(m,n,k)
               ENDDO
            ENDDO
         ENDDO
      ELSE
!
!     divergence is zero so br,bi=0 not used
!
         DO k = 1 , Nt
            DO n = 1 , Nlat
               DO m = 1 , Mmax
                  Crvw(m,n,k) = 0.0
                  Civw(m,n,k) = 0.0
               ENDDO
            ENDDO
            DO n = 2 , Nlat
               Crvw(1,n,k) = Fnn(n)*Cr(1,n,k)
               Civw(1,n,k) = Fnn(n)*Ci(1,n,k)
            ENDDO
            DO m = 2 , Mmax
               DO n = m , Nlat
                  Crvw(m,n,k) = Fnn(n)*Cr(m,n,k)
                  Civw(m,n,k) = Fnn(n)*Ci(m,n,k)
               ENDDO
            ENDDO
         ENDDO
      ENDIF
!
!     sythesize coefs into vector field (v,w)
!
      CALL VHSEC(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Brvw,Bivw,Crvw,Civw,   &
               & Mmax,Nlat,Wsave,Lwsav,Wk,Lwk,Ierror)
      END SUBROUTINE IVLAPEC1


      SUBROUTINE DIVLAPEC(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,   &
                       & Mdbc,Ndbc,Wvhsec,Lvhsec,Work,Lwork,Ierror)
      IMPLICIT NONE

      DOUBLE PRECISION Bi , Br , Ci , Cr , V , W , Work , Wvhsec
      INTEGER ibi , ibr , ici , icr , Idvw , idz , Ierror , ifn , imid ,&
            & Ityp , iwk , Jdvw , labc , liwk , Lvhsec , lwkmin ,       &
            & Lwork , lzimn , lzz1 , Mdbc
      INTEGER mmax , mn , Ndbc , Nlat , Nlon , Nt
      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt)
      DIMENSION Br(Mdbc,Ndbc,Nt) , Bi(Mdbc,Ndbc,Nt)
      DIMENSION Cr(Mdbc,Ndbc,Nt) , Ci(Mdbc,Ndbc,Nt)
      DIMENSION Wvhsec(Lvhsec) , Work(Lwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      IF ( Ityp<0 .OR. Ityp>8 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Ityp<=2 .AND. Idvw<Nlat) .OR. (Ityp>2 .AND. Idvw<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdbc<mmax ) RETURN
      Ierror = 8
      IF ( Ndbc<Nlat ) RETURN
      Ierror = 9
!
!     set minimum and verify saved workspace length
!
      idz = (mmax*(Nlat+Nlat-mmax+1))/2
      lzimn = idz*imid
!     lsavmin = lzimn+lzimn+nlon+15
!     if (lvhsec .lt. lsavmin) return
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lvhsec<2*(lzz1+labc)+Nlon+15 ) RETURN
!
!     set minimum and verify unsaved work space length
!
      Ierror = 10
      mn = mmax*Nlat*Nt
      IF ( Ityp<3 ) THEN
!     no symmetry
         IF ( Ityp==0 ) THEN
!       br,bi,cr,ci nonzero
            lwkmin = Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon)+1) + 4*mn
         ELSE
!       br,bi or cr,ci zero
            lwkmin = Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon)+1) + 2*mn
         ENDIF
!     symmetry
      ELSEIF ( Ityp==3 .OR. Ityp==6 ) THEN
!       br,bi,cr,ci nonzero
         lwkmin = imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon)) + 4*mn + Nlat
      ELSE
!       br,bi or cr,ci zero
         lwkmin = imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon)) + 2*mn + Nlat
      ENDIF
      IF ( Lwork<lwkmin ) RETURN
      Ierror = 0
!
!     set work space pointers for vector laplacian coefficients
!
      IF ( Ityp==0 .OR. Ityp==3 .OR. Ityp==6 ) THEN
         ibr = 1
         ibi = ibr + mn
         icr = ibi + mn
         ici = icr + mn
      ELSEIF ( Ityp==1 .OR. Ityp==4 .OR. Ityp==7 ) THEN
         ibr = 1
         ibi = ibr + mn
         icr = ibi + mn
         ici = icr
      ELSE
         ibr = 1
         ibi = 1
         icr = ibi + mn
         ici = icr + mn
      ENDIF
      ifn = ici + mn
      iwk = ifn + Nlat
      IF ( Ityp==0 .OR. Ityp==3 .OR. Ityp==6 ) THEN
         liwk = Lwork - 4*mn - Nlat
      ELSE
         liwk = Lwork - 2*mn - Nlat
      ENDIF
      CALL DIVLAPEC1(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Work(ibr),Work(ibi),&
                  & Work(icr),Work(ici),mmax,Work(ifn),Mdbc,Ndbc,Br,Bi, &
                  & Cr,Ci,Wvhsec,Lvhsec,Work(iwk),liwk,Ierror)
    END SUBROUTINE DIVLAPEC
 

    SUBROUTINE DIVLAPEC1(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Brvw,Bivw,    &
                        & Crvw,Civw,Mmax,Fnn,Mdbc,Ndbc,Br,Bi,Cr,Ci,     &
                        & Wsave,Lwsav,Wk,Lwk,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION Bi , Bivw , Br , Brvw , Ci , Civw , Cr , Crvw , fn , Fnn ,   &
         & V , W , Wk , Wsave
      INTEGER Idvw , Ierror , Ityp , Jdvw , k , Lwk , Lwsav , m , Mdbc ,&
            & Mmax , n , Ndbc , Nlat , Nlon , Nt

      DIMENSION V(Idvw,Jdvw,Nt) , W(Idvw,Jdvw,Nt)
      DIMENSION Fnn(Nlat) , Brvw(Mmax,Nlat,Nt) , Bivw(Mmax,Nlat,Nt)
      DIMENSION Crvw(Mmax,Nlat,Nt) , Civw(Mmax,Nlat,Nt)
      DIMENSION Br(Mdbc,Ndbc,Nt) , Bi(Mdbc,Ndbc,Nt)
      DIMENSION Cr(Mdbc,Ndbc,Nt) , Ci(Mdbc,Ndbc,Nt)
      DIMENSION Wsave(Lwsav) , Wk(Lwk)
!
!     preset coefficient multiplyers
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Fnn(n) = -1.0/(fn*(fn+1.))
      ENDDO
!
!     set (v,w) coefficients from br,bi,cr,ci
!
      IF ( Ityp==0 .OR. Ityp==3 .OR. Ityp==6 ) THEN
!
!     all coefficients needed
!
         DO k = 1 , Nt
            DO n = 1 , Nlat
               DO m = 1 , Mmax
                  Brvw(m,n,k) = 0.0
                  Bivw(m,n,k) = 0.0
                  Crvw(m,n,k) = 0.0
                  Civw(m,n,k) = 0.0
               ENDDO
            ENDDO
            DO n = 2 , Nlat
               Brvw(1,n,k) = Fnn(n)*Br(1,n,k)
               Bivw(1,n,k) = Fnn(n)*Bi(1,n,k)
               Crvw(1,n,k) = Fnn(n)*Cr(1,n,k)
               Civw(1,n,k) = Fnn(n)*Ci(1,n,k)
            ENDDO
            DO m = 2 , Mmax
               DO n = m , Nlat
                  Brvw(m,n,k) = Fnn(n)*Br(m,n,k)
                  Bivw(m,n,k) = Fnn(n)*Bi(m,n,k)
                  Crvw(m,n,k) = Fnn(n)*Cr(m,n,k)
                  Civw(m,n,k) = Fnn(n)*Ci(m,n,k)
               ENDDO
            ENDDO
         ENDDO
      ELSEIF ( Ityp==1 .OR. Ityp==4 .OR. Ityp==7 ) THEN
!
!     vorticity is zero so cr,ci=0 not used
!
         DO k = 1 , Nt
            DO n = 1 , Nlat
               DO m = 1 , Mmax
                  Brvw(m,n,k) = 0.0
                  Bivw(m,n,k) = 0.0
               ENDDO
            ENDDO
            DO n = 2 , Nlat
               Brvw(1,n,k) = Fnn(n)*Br(1,n,k)
               Bivw(1,n,k) = Fnn(n)*Bi(1,n,k)
            ENDDO
            DO m = 2 , Mmax
               DO n = m , Nlat
                  Brvw(m,n,k) = Fnn(n)*Br(m,n,k)
                  Bivw(m,n,k) = Fnn(n)*Bi(m,n,k)
               ENDDO
            ENDDO
         ENDDO
      ELSE
!
!     divergence is zero so br,bi=0 not used
!
         DO k = 1 , Nt
            DO n = 1 , Nlat
               DO m = 1 , Mmax
                  Crvw(m,n,k) = 0.0
                  Civw(m,n,k) = 0.0
               ENDDO
            ENDDO
            DO n = 2 , Nlat
               Crvw(1,n,k) = Fnn(n)*Cr(1,n,k)
               Civw(1,n,k) = Fnn(n)*Ci(1,n,k)
            ENDDO
            DO m = 2 , Mmax
               DO n = m , Nlat
                  Crvw(m,n,k) = Fnn(n)*Cr(m,n,k)
                  Civw(m,n,k) = Fnn(n)*Ci(m,n,k)
               ENDDO
            ENDDO
         ENDDO
      ENDIF
!
!     sythesize coefs into vector field (v,w)
!
      CALL DVHSEC(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Brvw,Bivw,Crvw,Civw,   &
               & Mmax,Nlat,Wsave,Lwsav,Wk,Lwk,Ierror)
      END SUBROUTINE DIVLAPEC1

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by ucar                 .
c  .                                                             .
c  .       university corporation for atmospheric research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         spherepack3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file gaqd.f
c
c     this file includes documentation and code for subrooutine gaqd.
c
c ... required files
c
c     none
c
c     subroutine gaqd(nlat,theta,wts,dwork,ldwork,ierror)
c
c     subroutine gaqd computes the nlat gaussian colatitudes and weights
c     in double precision. the colatitudes are in radians and lie in the
c     in the interval (0,pi).
c
c     input parameters
c
c     nlat    the number of gaussian colatitudes in the interval (0,pi)
c             (between the two poles).  nlat must be greater than zero.
c
c     dwork   a temporary work space
c
c     ldwork  the length of the work space  in the routine calling gaqd
c             ldwork must be at least nlat*(nlat+2).
c
c     output parameters
c
c     theta   a double precision vector of length nlat containing the
c             nlat gaussian colatitudes on the sphere in increasing radians
c             in the interval (o,pi).
c
c     wts     a double precision vector of length nlat containing the
c             nlat gaussian weights.
c
c     ierror = 0 no errors
c            = 1 if ldwork.lt.nlat*(nlat+2)
c            = 2 if nlat.le.0
c            = 3 if unable to compute gaussian points
c                (failure in in eigenvalue routine)
c
c  *****************************************************************
      subroutine gaqd(nlat,theta,wts,dwork,ldwork,ierror)
      double precision theta(nlat),wts(nlat),dwork(ldwork),x
      n = nlat
      ierror = 1
c     check work space length
      if (ldwork .lt. n*(n+2)) return
      ierror = 2
      if (n.le.0) return
      ierror = 0
      if (n.gt.2) then
c
c     partition dwork space for double precision eigenvalue(vector computation)
c
      i1 = 1
      i2 = i1+n
      i3 = i2+n
      call gaqd1(n,theta,wts,dwork(i1),dwork(i2),dwork(i3),ierror)
      if (ierror.ne.0) then
      ierror = 3
      return
      end if
      return
      else if (n.eq.1) then
      wts(1) = 2.0d0
      theta(1) = dacos(0.0d0)
      else if (n.eq.2) then
c     compute weights and points analytically when n=2
      wts(1) = 1.0d0
      wts(2) = 1.0d0
      x = dsqrt(1.0d0/3.0d0)
      theta(1) = dacos(x)
      theta(2) = dacos(-x)
      return
      end if
      end
      subroutine gaqd1(n,theta,wts,w,e,z,ier)
      dimension theta(n),wts(n),w(n),e(n),z(n,n)
      double precision theta,wts,temp,w,e,z
c     set symmetric tridiagnonal matrix subdiagonal and diagonal
c     coefficients for matrix coming from coefficients in the
c     recursion formula for legendre polynomials
c     a(n)*p(n-1)+b(n)*p(n)+c(n)*p(n+1) = 0.
      w(1)=0.d0
      e(1) = 0.d0
      do 100 j=2,n
      e(j)= (j-1.d0)/dsqrt((2.d0*j-1.d0)*(2.d0*j-3.d0))
      w(j) = 0.d0
  100 continue
c
c     compute eigenvalues and eigenvectors
c
      matz = 1
      call drst(n,n,w,e,matz,z,ier)
      if (ier.ne.0) return
c
c     compute gaussian weights and points
c
      do 101 j=1,n
      theta(j) = dacos(w(j))
c
c     set gaussian weights as 1st components of eigenvectors squared
c 
      wts(j) = 2.0d0*z(1,j)**2
  101 continue
c
c     reverse order of gaussian points to be
c     monotonic increasing in radians
c
      n2 = n/2
      do 102 i=1,n2
      temp = theta(i)
      theta(i) = theta(n-i+1)
      theta(n-i+1) = temp
  102 continue
      return
      end
      subroutine drst(nm,n,w,e,matz,z,ierr)
c     drst is a double precision modification of rst off eispack
c     to be used  to compute gaussian points and weights

c
      integer i,j,n,nm,ierr,matz
      double precision w(n),e(n),z(nm,n)

c
c     .......... find both eigenvalues and eigenvectors ..........
   20 do 40 i = 1, n
c
	 do 30 j = 1, n
	    z(j,i) = 0.0d0
   30    continue
c
	 z(i,i) = 1.0d0
   40 continue
c
      call  dintql(nm,n,w,e,z,ierr)
      return
      end
      subroutine dintql(nm,n,d,e,z,ierr)
c     dintql is a double precision modification of intql2 off
c     eispack to be used by gaqd in spherepack for computing
c     gaussian weights and points
c
      integer i,j,k,l,m,n,ii,nm,mml,ierr
      double precision d(n),e(n),z(nm,n)
      double precision b,c,f,g,p,r,s,tst1,tst2,dpytha
      ierr = 0
      if (n .eq. 1) go to 1001
c
      do 100 i = 2, n
  100 e(i-1) = e(i)
c
      e(n) = 0.0d0
c
      do 240 l = 1, n
	 j = 0
c     .......... look for small sub-diagonal element ..........
c
  105    nm1 = n-1     
         if(l .gt. nm1) go to 111
         do 110 mdo = l, nm1
            m = mdo
	    tst1 = dabs(d(m)) + dabs(d(m+1))
	    tst2 = tst1 + dabs(e(m))
	    if (tst2 .eq. tst1) go to 120
  110    continue
  111    m = n
c
  120    p = d(l)
	 if (m .eq. l) go to 240
	 if (j .eq. 30) go to 1000
	 j = j + 1
c     .......... form shift ..........
	 g = (d(l+1) - p) / (2.0d0 * e(l))
	 r = dpytha(g,1.0d0)
	 g = d(m) - p + e(l) / (g + sign(r,g))
	 s = 1.0d0
	 c = 1.0d0
	 p = 0.0d0
	 mml = m - l
c     .......... for i=m-1 step -1 until l do -- ..........
	 do 200 ii = 1, mml
	    i = m - ii
	    f = s * e(i)
	    b = c * e(i)
	    r = dpytha(f,g)
	    e(i+1) = r
	    if (r .eq. 0.0d0) go to 210
	    s = f / r
	    c = g / r
	    g = d(i+1) - p
	    r = (d(i) - g) * s + 2.0d0 * c * b
	    p = s * r
	    d(i+1) = g + p
	    g = c * r - b
c     .......... form vector ..........
	    do 180 k = 1, n
	       f = z(k,i+1)
	       z(k,i+1) = s * z(k,i) + c * f
	       z(k,i) = c * z(k,i) - s * f
  180       continue
c
  200    continue
c
	 d(l) = d(l) - p
	 e(l) = g
	 e(m) = 0.0d0
	 go to 105
c     .......... recover from underflow ..........
  210    d(i+1) = d(i+1) - p
	 e(m) = 0.0d0
	 go to 105
  240 continue
c     .......... order eigenvalues and eigenvectors ..........
      do 300 ii = 2, n
	 i = ii - 1
	 k = i
	 p = d(i)
c
	 do 260 j = ii, n
	    if (d(j) .ge. p) go to 260
	    k = j
	    p = d(j)
  260    continue
c
	 if (k .eq. i) go to 300
	 d(k) = d(i)
	 d(i) = p
c
	 do 280 j = 1, n
	    p = z(j,i)
	    z(j,i) = z(j,k)
	    z(j,k) = p
  280    continue
c
  300 continue
c
      go to 1001
c     .......... set error -- no convergence to an
c                eigenvalue after 30 iterations ..........
 1000 ierr = l
 1001 return
      end
      double precision function dpytha(a,b)
      double precision a,b
c     dpytha is a double precision modification of pythag off eispack
c     for use by dimtql

c
c     finds sqrt(a**2+b**2) without overflow or destructive underflow
c
      double precision p,r,s,t,u
      p = dabs(a)
      if (dabs(b).ge.dabs(a)) p = dabs(b)
      if (p .eq. 0.0d0) go to 20
      r = (dabs(a)/p)**2
      if (dabs(b).lt.dabs(a)) r = (dabs(b)/p)**2
   10 continue
	 t = 4.0d0 + r
	 if (t .eq. 4.0d0) go to 20
	 s = r/t
	 u = 1.0d0 + 2.0d0*s
	 p = u*p
	 r = (s/u)**2 * r
      go to 10
   20 dpytha = p
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file vhagc.f
!
!     this file contains code and documentation for subroutines
!     vhagc and vhagci
!
! ... files which must be loaded with vhagc.f
!
!     sphcom.f, hrfft.f, gaqd.f
!
!
!     subroutine vhagc(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
!    +                 mdab,ndab,wvhagc,lvhagc,work,lwork,ierror)
!
!     subroutine vhagc performs the vector spherical harmonic analysis
!     on the vector field (v,w) and stores the result in the arrays
!     br,bi,cr, and ci. v(i,j) and w(i,j) are the colatitudinal
!     (measured from the north pole) and east longitudinal components
!     respectively, located at the gaussian colatitude point theta(i)
!     and longitude phi(j) = (j-1)*2*pi/nlon. the spectral
!     representation of (v,w) is given at output parameters v,w in
!     subroutine vhsec.
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are computed
!            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid point
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than zero. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!     ityp   = 0  no symmetries exist about the equator. the analysis
!                 is performed on the entire sphere.  i.e. on the
!                 arrays v(i,j),w(i,j) for i=1,...,nlat and
!                 j=1,...,nlon.
!
!            = 1  no symmetries exist about the equator. the analysis
!                 is performed on the entire sphere.  i.e. on the
!                 arrays v(i,j),w(i,j) for i=1,...,nlat and
!                 j=1,...,nlon. the curl of (v,w) is zero. that is,
!                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
!                 the coefficients cr and ci are zero.
!
!            = 2  no symmetries exist about the equator. the analysis
!                 is performed on the entire sphere.  i.e. on the
!                 arrays v(i,j),w(i,j) for i=1,...,nlat and
!                 j=1,...,nlon. the divergence of (v,w) is zero. i.e.,
!                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
!                 the coefficients br and bi are zero.
!
!            = 3  v is symmetric and w is antisymmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!            = 4  v is symmetric and w is antisymmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the curl of (v,w) is zero. that is,
!                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
!                 the coefficients cr and ci are zero.
!
!            = 5  v is symmetric and w is antisymmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the divergence of (v,w) is zero. i.e.,
!                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
!                 the coefficients br and bi are zero.
!
!            = 6  v is antisymmetric and w is symmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!            = 7  v is antisymmetric and w is symmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the curl of (v,w) is zero. that is,
!                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
!                 the coefficients cr and ci are zero.
!
!            = 8  v is antisymmetric and w is symmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the divergence of (v,w) is zero. i.e.,
!                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
!                 the coefficients br and bi are zero.
!
!
!     nt     the number of analyses.  in the program that calls vhagc,
!            the arrays v,w,br,bi,cr, and ci can be three dimensional
!            in which case multiple analyses will be performed.
!            the third index is the analysis index which assumes the
!            values k=1,...,nt.  for a single analysis set nt=1. the
!            discription of the remaining parameters is simplified
!            by assuming that nt=1 or that all the arrays are two
!            dimensional.
!
!     v,w    two or three dimensional arrays (see input parameter nt)
!            that contain the vector function to be analyzed.
!            v is the colatitudnal component and w is the east
!            longitudinal component. v(i,j),w(i,j) contain the
!            components at colatitude theta(i) = (i-1)*pi/(nlat-1)
!            and longitude phi(j) = (j-1)*2*pi/nlon. the index ranges
!            are defined above at the input parameter ityp.
!
!     idvw   the first dimension of the arrays v,w as it appears in
!            the program that calls vhagc. if ityp .le. 2 then idvw
!            must be at least nlat.  if ityp .gt. 2 and nlat is
!            even then idvw must be at least nlat/2. if ityp .gt. 2
!            and nlat is odd then idvw must be at least (nlat+1)/2.
!
!     jdvw   the second dimension of the arrays v,w as it appears in
!            the program that calls vhagc. jdvw must be at least nlon.
!
!     mdab   the first dimension of the arrays br,bi,cr, and ci as it
!            appears in the program that calls vhagc. mdab must be at
!            least min0(nlat,nlon/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndab   the second dimension of the arrays br,bi,cr, and ci as it
!            appears in the program that calls vhagc. ndab must be at
!            least nlat.
!
!     wvhagc an array which must be initialized by subroutine vhagci.
!            once initialized, wvhagc can be used repeatedly by vhagc
!            as long as nlon and nlat remain unchanged.  wvhagc must
!            not be altered between calls of vhagc.
!
!     lvhagc the dimension of the array wvhagc as it appears in the
!            program that calls vhagc. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lvhagc must be at least
!
!               4*nlat*l2+3*max0(l1-2,0)*(2*nlat-l1-1)+nlon+l2+15
!
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls vhagc. define
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            if ityp .le. 2 then lwork must be at least
!
!               2*nlat*(2*nlon*nt+3*l2)
!
!            if ityp .gt. 2 then lwork must be at least
!
!               2*l2*(2*nlon*nt+3*nlat)
!
!
!
!     **************************************************************
!
!     output parameters
!
!     br,bi  two or three dimensional arrays (see input parameter nt)
!     cr,ci  that contain the vector spherical harmonic coefficients
!            in the spectral representation of v(i,j) and w(i,j) given
!            in the discription of subroutine vhsec. br(mp1,np1),
!            bi(mp1,np1),cr(mp1,np1), and ci(mp1,np1) are computed
!            for mp1=1,...,mmax and np1=mp1,...,nlat except for np1=nlat
!            and odd mp1. mmax=min0(nlat,nlon/2) if nlon is even or
!            mmax=min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of ityp
!            = 4  error in the specification of nt
!            = 5  error in the specification of idvw
!            = 6  error in the specification of jdvw
!            = 7  error in the specification of mdab
!            = 8  error in the specification of ndab
!            = 9  error in the specification of lvhagc
!            = 10 error in the specification of lwork
!
! ****************************************************************
!
!     subroutine vhagci(nlat,nlon,wvhagc,lvhagc,dwork,ldwork,ierror)
!
!     subroutine vhagci initializes the array wvhagc which can then be
!     used repeatedly by subroutine vhagc until nlat or nlon is changed.
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are computed
!            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid point
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than zero. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!     lvhagc the dimension of the array wvhagc as it appears in the
!            program that calls vhagci.  define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lvhagc must be at least
!
!               4*nlat*l2+3*max0(l1-2,0)*(2*nlat-l1-1)+nlon+l2+15
!
!
!     dwork  a double precision work array that does not need to be saved
!
!     ldwork the dimension of the array dwork as it appears in the
!            program that calls vhagci. ldwork must be at least
!
!               2*nlat*(nlat+1)+1
!
!
!     **************************************************************
!
!     output parameters
!
!     wvhagc an array which is initialized for use by subroutine vhagc.
!            once initialized, wvhagc can be used repeatedly by vhagc
!            as long as nlat and nlon remain unchanged.  wvhagc must not
!            be altered between calls of vhagc.
!
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of lvhagc
!            = 4  error in the specification of lwork
!
      SUBROUTINE VHAGC(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,Mdab,&
                     & Ndab,Wvhagc,Lvhagc,Work,Lwork,Ierror)
      IMPLICIT NONE
      REAL Bi , Br , Ci , Cr , V , W , Work , Wvhagc
      INTEGER idv , Idvw , Ierror , imid , ist , Ityp , iw1 , iw2 ,     &
            & iw3 , iw4 , iw5 , Jdvw , jw1 , jw2 , jw3 , labc , lnl ,   &
            & Lvhagc , Lwork , lwzvin
      INTEGER lzz1 , Mdab , mmax , Ndab , Nlat , Nlon , Nt
      DIMENSION V(Idvw,Jdvw,1) , W(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,     &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Work(1) , Wvhagc(1)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      IF ( Ityp<0 .OR. Ityp>8 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Ityp<=2 .AND. Idvw<Nlat) .OR. (Ityp>2 .AND. Idvw<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lvhagc<2*(lzz1+labc)+Nlon+imid+15 ) RETURN
      Ierror = 10
      IF ( Ityp<=2 .AND. Lwork<Nlat*(4*Nlon*Nt+6*imid) ) RETURN
      IF ( Ityp>2 .AND. Lwork<imid*(4*Nlon*Nt+6*Nlat) ) RETURN
      Ierror = 0
      idv = Nlat
      IF ( Ityp>2 ) idv = imid
      lnl = Nt*idv*Nlon
      ist = 0
      IF ( Ityp<=2 ) ist = imid
      iw1 = ist + 1
      iw2 = lnl + 1
      iw3 = iw2 + ist
      iw4 = iw2 + lnl
      iw5 = iw4 + 3*imid*Nlat
      lwzvin = lzz1 + labc
      jw1 = (Nlat+1)/2 + 1
      jw2 = jw1 + lwzvin
      jw3 = jw2 + lwzvin
      CALL VHAGC1(Nlat,Nlon,Ityp,Nt,imid,Idvw,Jdvw,V,W,Mdab,Ndab,Br,Bi, &
                & Cr,Ci,idv,Work,Work(iw1),Work(iw2),Work(iw3),Work(iw4)&
                & ,Work(iw5),Wvhagc,Wvhagc(jw1),Wvhagc(jw2),Wvhagc(jw3))
      END SUBROUTINE VHAGC


      SUBROUTINE VHAGCI(Nlat,Nlon,Wvhagc,Lvhagc,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER Ierror , imid , iw1 , iw2 , iw3 , iwrk , jw1 , jw2 , jw3 ,&
            & labc , Ldwork , Lvhagc , lwk , lwvbin , lzz1 , mmax ,     &
            & Nlat , Nlon
      REAL Wvhagc
      DIMENSION Wvhagc(1)
      DOUBLE PRECISION Dwork(*)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      imid = (Nlat+1)/2
      lzz1 = 2*Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      imid = (Nlat+1)/2
      IF ( Lvhagc<2*(lzz1+labc)+Nlon+imid+15 ) RETURN
      Ierror = 4
      IF ( Ldwork<2*Nlat*(Nlat+1)+1 ) RETURN
      Ierror = 0
!
!     compute gaussian points in first nlat+1 words of dwork
!     double precision
!
      lwk = Nlat*(Nlat+2)
 
      jw1 = 1
!     jw2 = jw1+nlat+nlat
!     jw3 = jw2+nlat+nlat
      jw2 = jw1 + Nlat
      jw3 = jw2 + Nlat
      CALL GAQD(Nlat,Dwork(jw1),Dwork(jw2),Dwork(jw3),lwk,Ierror)
      imid = (Nlat+1)/2
!
!     set first imid words of double precision weights in dwork
!     as single precision in first imid words of wvhagc
!
      CALL SETWTS(imid,Dwork(Nlat+1),Wvhagc)
!
!     first nlat+1 words of dwork contain  double theta
!
!     iwrk = nlat+2
      iwrk = (Nlat+1)/2 + 1
      iw1 = imid + 1
      CALL VBGINT(Nlat,Nlon,Dwork,Wvhagc(iw1),Dwork(iwrk))
      lwvbin = lzz1 + labc
      iw2 = iw1 + lwvbin
      CALL WBGINT(Nlat,Nlon,Dwork,Wvhagc(iw2),Dwork(iwrk))
      iw3 = iw2 + lwvbin
      CALL HRFFTI(Nlon,Wvhagc(iw3))
      END SUBROUTINE VHAGCI


      SUBROUTINE SETWTS(Imid,Dwts,Wts)
      IMPLICIT NONE
      INTEGER i , Imid
      REAL Wts
!
!     set first imid =(nlat+1)/2 of double precision weights in dwts
!     as single precision in wts
!
      DIMENSION Dwts(Imid) , Wts(Imid)
      DOUBLE PRECISION Dwts
      DO i = 1 , Imid
         Wts(i) = Dwts(i)
      ENDDO
      END SUBROUTINE SETWTS


      SUBROUTINE DVHAGC(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,Mdab,&
           & Ndab,Wvhagc,Lvhagc,Work,Lwork,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION Bi , Br , Ci , Cr , V , W , Work , Wvhagc
      INTEGER idv , Idvw , Ierror , imid , ist , Ityp , iw1 , iw2 ,     &
            & iw3 , iw4 , iw5 , Jdvw , jw1 , jw2 , jw3 , labc , lnl ,   &
            & Lvhagc , Lwork , lwzvin
      INTEGER lzz1 , Mdab , mmax , Ndab , Nlat , Nlon , Nt
      DIMENSION V(Idvw,Jdvw,1) , W(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,     &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Work(1) , Wvhagc(1)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      IF ( Ityp<0 .OR. Ityp>8 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Ityp<=2 .AND. Idvw<Nlat) .OR. (Ityp>2 .AND. Idvw<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lvhagc<2*(lzz1+labc)+Nlon+imid+15 ) RETURN
      Ierror = 10
      IF ( Ityp<=2 .AND. Lwork<Nlat*(4*Nlon*Nt+6*imid) ) RETURN
      IF ( Ityp>2 .AND. Lwork<imid*(4*Nlon*Nt+6*Nlat) ) RETURN
      Ierror = 0
      idv = Nlat
      IF ( Ityp>2 ) idv = imid
      lnl = Nt*idv*Nlon
      ist = 0
      IF ( Ityp<=2 ) ist = imid
      iw1 = ist + 1
      iw2 = lnl + 1
      iw3 = iw2 + ist
      iw4 = iw2 + lnl
      iw5 = iw4 + 3*imid*Nlat
      lwzvin = lzz1 + labc
      jw1 = (Nlat+1)/2 + 1
      jw2 = jw1 + lwzvin
      jw3 = jw2 + lwzvin
      CALL DVHAGC1(Nlat,Nlon,Ityp,Nt,imid,Idvw,Jdvw,V,W,Mdab,Ndab,Br,Bi, &
                & Cr,Ci,idv,Work,Work(iw1),Work(iw2),Work(iw3),Work(iw4)&
                & ,Work(iw5),Wvhagc,Wvhagc(jw1),Wvhagc(jw2),Wvhagc(jw3))
      END SUBROUTINE DVHAGC


      SUBROUTINE DVHAGCI(Nlat,Nlon,Wvhagc,Lvhagc,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER Ierror , imid , iw1 , iw2 , iw3 , iwrk , jw1 , jw2 , jw3 ,&
            & labc , Ldwork , Lvhagc , lwk , lwvbin , lzz1 , mmax ,     &
            & Nlat , Nlon
      DOUBLE PRECISION Wvhagc
      DIMENSION Wvhagc(1)
      DOUBLE PRECISION Dwork(*)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      imid = (Nlat+1)/2
      lzz1 = 2*Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      imid = (Nlat+1)/2
      IF ( Lvhagc<2*(lzz1+labc)+Nlon+imid+15 ) RETURN
      Ierror = 4
      IF ( Ldwork<2*Nlat*(Nlat+1)+1 ) RETURN
      Ierror = 0
!
!     compute gaussian points in first nlat+1 words of dwork
!     double precision
!
      lwk = Nlat*(Nlat+2)
 
      jw1 = 1
!     jw2 = jw1+nlat+nlat
!     jw3 = jw2+nlat+nlat
      jw2 = jw1 + Nlat
      jw3 = jw2 + Nlat
      CALL DGAQD(Nlat,Dwork(jw1),Dwork(jw2),Dwork(jw3),lwk,Ierror)
      imid = (Nlat+1)/2
!
!     set first imid words of double precision weights in dwork
!     as single precision in first imid words of wvhagc
!
      CALL DSETWTS(imid,Dwork(Nlat+1),Wvhagc)
!
!     first nlat+1 words of dwork contain  double theta
!
!     iwrk = nlat+2
      iwrk = (Nlat+1)/2 + 1
      iw1 = imid + 1
      CALL DVBGINT(Nlat,Nlon,Dwork,Wvhagc(iw1),Dwork(iwrk))
      lwvbin = lzz1 + labc
      iw2 = iw1 + lwvbin
      CALL DWBGINT(Nlat,Nlon,Dwork,Wvhagc(iw2),Dwork(iwrk))
      iw3 = iw2 + lwvbin
      CALL DHRFFTI(Nlon,Wvhagc(iw3))
      END SUBROUTINE DVHAGCI


      SUBROUTINE DSETWTS(Imid,Dwts,Wts)
      IMPLICIT NONE
      INTEGER i , Imid
      DOUBLE PRECISION Wts
!
!     set first imid =(nlat+1)/2 of double precision weights in dwts
!     as single precision in wts
!
      DIMENSION Dwts(Imid) , Wts(Imid)
      DOUBLE PRECISION Dwts
      DO i = 1 , Imid
         Wts(i) = Dwts(i)
      ENDDO
      END SUBROUTINE DSETWTS
      
      SUBROUTINE DVHAGC1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,V,W,MDAB,NDAB,   &
                        BR,BI,CR,CI,IDV,VE,VO,WE,WO,VB,WB,WTS,WVBIN,   &
                        WWBIN,WRFFT)
      DOUBLE PRECISION V
      DOUBLE PRECISION W
      DOUBLE PRECISION BR
      DOUBLE PRECISION BI
      DOUBLE PRECISION CR
      DOUBLE PRECISION CI
      DOUBLE PRECISION VE
      DOUBLE PRECISION VO
      DOUBLE PRECISION WE
      DOUBLE PRECISION WO
      DOUBLE PRECISION VB
      DOUBLE PRECISION WB
      DOUBLE PRECISION WTS
      DOUBLE PRECISION WVBIN
      DOUBLE PRECISION WWBIN
      DOUBLE PRECISION WRFFT
      DOUBLE PRECISION TSN
      DOUBLE PRECISION FSN
      DOUBLE PRECISION TV
      DOUBLE PRECISION TW
      DOUBLE PRECISION TVO1
      DOUBLE PRECISION TVO2
      DOUBLE PRECISION TVE1
      DOUBLE PRECISION TVE2
      DOUBLE PRECISION TWO1
      DOUBLE PRECISION TWO2
      DOUBLE PRECISION TWE1
      DOUBLE PRECISION TWE2
      DIMENSION V(IDVW,JDVW,1),W(IDVW,JDVW,1),BR(MDAB,NDAB,1),   &
               BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),  &
               VE(IDV,NLON,1),VO(IDV,NLON,1),WE(IDV,NLON,1),  &
               WO(IDV,NLON,1),WTS(*),WVBIN(1),WWBIN(1),WRFFT(1),  &
               VB(IMID,NLAT,3),WB(IMID,NLAT,3)  

      NLP1 = NLAT + 1
      TSN = 2.D0/NLON
      FSN = 4.D0/NLON
      MLAT = MOD(NLAT,2)
      MLON = MOD(NLON,2)
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IMM1 = IMID
      IF (MLAT.NE.0) IMM1 = IMID - 1
      IF (ITYP.GT.2) THEN
         DO K = 1,NT
            DO  I = 1,IMM1
               DO  J = 1,NLON
                  VE(I,J,K) = FSN*V(I,J,K)
                  VO(I,J,K) = FSN*V(I,J,K)
                  WE(I,J,K) = FSN*W(I,J,K)
                  WO(I,J,K) = FSN*W(I,J,K)
               END DO
            END DO
         END DO
      ELSE
         DO  K = 1,NT
            DO I = 1,IMM1
              DO  J = 1,NLON
                  VE(I,J,K) = TSN* (V(I,J,K)+V(NLP1-I,J,K))
                  VO(I,J,K) = TSN* (V(I,J,K)-V(NLP1-I,J,K))
                  WE(I,J,K) = TSN* (W(I,J,K)+W(NLP1-I,J,K))
                  WO(I,J,K) = TSN* (W(I,J,K)-W(NLP1-I,J,K))
               END DO
            END DO
         END DO
      ENDIF
      IF (MLAT.EQ.0) GO TO 7
      DO  K = 1,NT
          DO J = 1,NLON
              VE(IMID,J,K) = TSN*V(IMID,J,K)
              WE(IMID,J,K) = TSN*W(IMID,J,K)
           END DO
        END DO
    7  DO K = 1,NT
          CALL DHRFFTF(IDV,NLON,VE(1,1,K),IDV,WRFFT,VB)
          CALL DHRFFTF(IDV,NLON,WE(1,1,K),IDV,WRFFT,VB)
      END DO
      NDO1 = NLAT
      NDO2 = NLAT
      IF (MLAT.NE.0) NDO1 = NLAT - 1
      IF (MLAT.EQ.0) NDO2 = NLAT - 1
      IF (ITYP.EQ.2 .OR. ITYP.EQ.5 .OR. ITYP.EQ.8) GO TO 11
      DO K = 1,NT
          DO  MP1 = 1,MMAX
              DO  NP1 = MP1,NLAT
                  BR(MP1,NP1,K) = 0.D0
                  BI(MP1,NP1,K) = 0.D0
               END DO
            END DO
         END DO
   10 CONTINUE
   11 IF (ITYP.EQ.1 .OR. ITYP.EQ.4 .OR. ITYP.EQ.7) GO TO 13
      DO K = 1,NT
          DO  MP1 = 1,MMAX
              DO  NP1 = MP1,NLAT
                  CR(MP1,NP1,K) = 0.D0
                  CI(MP1,NP1,K) = 0.D0
               END DO
            END DO
         END DO
   12 CONTINUE
   13 ITYPP = ITYP + 1
      GO TO (1,100,200,300,400,500,600,700,800) ITYPP
!
!     case ityp=0 ,  no symmetries
!
    1 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO 15 K = 1,NT
          DO  I = 1,IMID
              TV = VE(I,1,K)*WTS(I)
              TW = WE(I,1,K)*WTS(I)
              DO  NP1 = 2,NDO2,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
               END DO
            END DO
   15 CONTINUE
      DO 16 K = 1,NT
          DO 1016 I = 1,IMM1
              TV = VO(I,1,K)*WTS(I)
              TW = WO(I,1,K)*WTS(I)
              DO 10016 NP1 = 3,NDO1,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
10016         CONTINUE
 1016     CONTINUE
   16 CONTINUE
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 20 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 17
          DO K = 1,NT
              DO  I = 1,IMM1
!
!     set temps to optimize quadrature
!
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) + &
     &                                VB(I,NP1,IV)*TVO2 +  &
     &                                WB(I,NP1,IW)*TWE1 
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) + &
     &                                VB(I,NP1,IV)*TVO1 - &
     &                                WB(I,NP1,IW)*TWE2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -  &
     &                                VB(I,NP1,IV)*TWO2 + &
     &                                WB(I,NP1,IW)*TVE1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -   &
     &                                VB(I,NP1,IV)*TWO1 - &
     &                                WB(I,NP1,IW)*TVE2
                   END DO
                END DO
             END DO
   23     CONTINUE

          IF (MLAT.EQ.0) GO TO 17
          I = IMID
          DO  K = 1,NT
              DO  NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +                &
     &                            WB(I,NP1,IW)*WE(I,2*MP1-1,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -   &
     &                            WB(I,NP1,IW)*WE(I,2*MP1-2,K)*WTS(I)
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +   &
     &                            WB(I,NP1,IW)*VE(I,2*MP1-1,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -   &
     &                            WB(I,NP1,IW)*VE(I,2*MP1-2,K)*WTS(I)
               END DO
            END DO
   17     IF (MP2.GT.NDO2) GO TO 20
          DO 21 K = 1,NT
              DO 1021 I = 1,IMM1
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  DO 10021 NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +  &
     &                                VB(I,NP1,IV)*TVE2 + &
     &                                WB(I,NP1,IW)*TWO1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +  &
     &                                VB(I,NP1,IV)*TVE1 - &
     &                                WB(I,NP1,IW)*TWO2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -   &
     &                                 VB(I,NP1,IV)*TWE2 +  &
     &                                WB(I,NP1,IW)*TVO1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -   &
     &                                VB(I,NP1,IV)*TWE1 - &
     &                                WB(I,NP1,IW)*TVO2
10021             CONTINUE
 1021         CONTINUE
   21     CONTINUE

          IF (MLAT.EQ.0) GO TO 20
          I = IMID
          DO 22 K = 1,NT
              DO 1022 NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +  &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-2,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +  &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-1,K)*WTS(I)
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -  &
     &                            VB(I,NP1,IV)*WE(I,2*MP1-2,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -  &
     &                            VB(I,NP1,IV)*WE(I,2*MP1-1,K)*WTS(I)
 1022         CONTINUE
   22     CONTINUE
   20 CONTINUE
      RETURN
!
!     case ityp=1 ,  no symmetries but cr and ci equal zero
!
  100 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
          DO  I = 1,IMID
              TV = VE(I,1,K)*WTS(I)
              DO  NP1 = 2,NDO2,2
                 BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
              END DO
           END DO
        END DO
  115 CONTINUE
      DO K = 1,NT
          DO I = 1,IMM1
              TV = VO(I,1,K)*WTS(I)
              DO  NP1 = 3,NDO1,2
                 BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
              END DO
           END DO
        END DO
  116 CONTINUE
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 120 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 117
          DO  K = 1,NT
              DO  I = 1,IMM1
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +     &
     &                                VB(I,NP1,IV)*TVO2 + &
     &                                WB(I,NP1,IW)*TWE1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +     &
     &                                VB(I,NP1,IV)*TVO1 - &
     &                                WB(I,NP1,IW)*TWE2
                   END DO
                END DO
             END DO
  123     CONTINUE
          IF (MLAT.EQ.0) GO TO 117
          I = IMID
          DO  K = 1,NT
              DO  NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +   &
     &                            WB(I,NP1,IW)*WE(I,2*MP1-1,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -   &
     &                            WB(I,NP1,IW)*WE(I,2*MP1-2,K)*WTS(I)
               END DO
            END DO
  124     CONTINUE
  117     IF (MP2.GT.NDO2) GO TO 120
          DO K = 1,NT
              DO  I = 1,IMM1
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +      &
     &                                VB(I,NP1,IV)*TVE2 +  &
     &                                WB(I,NP1,IW)*TWO1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +      &
     &                                VB(I,NP1,IV)*TVE1 -  &
     &                                WB(I,NP1,IW)*TWO2
                   END DO
                END DO
             END DO
                      
          IF (MLAT.EQ.0) GO TO 120
          I = IMID
          DO K = 1,NT
              DO  NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +    &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-2,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +    &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-1,K)*WTS(I)
               END DO
            END DO
  120 CONTINUE
      RETURN
!
!     case ityp=2 ,  no symmetries but br and bi equal zero
!
  200 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
          DO  I = 1,IMID
              TW = WE(I,1,K)*WTS(I)
              DO  NP1 = 2,NDO2,2
                 CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
              END DO
           END DO
        END DO
  215 CONTINUE
      DO  K = 1,NT
          DO  I = 1,IMM1
              TW = WO(I,1,K)*WTS(I)
              DO  NP1 = 3,NDO1,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
               END DO
            END DO
         END DO
216               CONTINUE
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 220 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 217
          DO K = 1,NT
              DO  I = 1,IMM1
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP1,NDO1,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -     &
     &                                VB(I,NP1,IV)*TWO2 + &
     &                                WB(I,NP1,IW)*TVE1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -    &
     &                                VB(I,NP1,IV)*TWO1 -  &
     &                                WB(I,NP1,IW)*TVE2

                   END DO
                END DO
             END DO
          IF (MLAT.EQ.0) GO TO 217
          I = IMID
          DO  K = 1,NT
              DO  NP1 = MP1,NDO1,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +   &
     &                            WB(I,NP1,IW)*VE(I,2*MP1-1,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -   &
     &                            WB(I,NP1,IW)*VE(I,2*MP1-2,K)*WTS(I)
               END DO
            END DO
  217     IF (MP2.GT.NDO2) GO TO 220
          DO K = 1,NT
              DO I = 1,IMM1
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP2,NDO2,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -     &
     &                                VB(I,NP1,IV)*TWE2 + &
     &                                WB(I,NP1,IW)*TVO1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -      &
     &                                VB(I,NP1,IV)*TWE1 -  &
     &                                WB(I,NP1,IW)*TVO2
                   END DO
                END DO
             END DO
221                   CONTINUE
                      
          IF (MLAT.EQ.0) GO TO 220
          I = IMID
          DO  K = 1,NT
              DO  NP1 = MP2,NDO2,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -   &
                       VB(I,NP1,IV)*WE(I,2*MP1-2,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -   &
                       VB(I,NP1,IV)*WE(I,2*MP1-1,K)*WTS(I)
               END DO
            END DO
  220 CONTINUE
      RETURN
!
!     case ityp=3 ,  v even , w odd
!
  300 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
          DO  I = 1,IMID
              TV = VE(I,1,K)*WTS(I)
              DO  NP1 = 2,NDO2,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
             END DO
          END DO
       END DO
      DO K = 1,NT
          DO  I = 1,IMM1
              TW = WO(I,1,K)*WTS(I)
              DO  NP1 = 3,NDO1,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
               END DO
            END DO
         END DO
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 320 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 317
          DO K = 1,NT
              DO I = 1,IMM1
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP1,NDO1,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -     &
     &                                VB(I,NP1,IV)*TWO2 + &
     &                                WB(I,NP1,IW)*TVE1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -     &
     &                                VB(I,NP1,IV)*TWO1 - &
     &                                WB(I,NP1,IW)*TVE2
                   END DO
                END DO
             END DO
             
          IF (MLAT.EQ.0) GO TO 317
          I = IMID
          DO K = 1,NT
              DO  NP1 = MP1,NDO1,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +     &
     &                            WB(I,NP1,IW)*VE(I,2*MP1-1,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -     &
     &                            WB(I,NP1,IW)*VE(I,2*MP1-2,K)*WTS(I)
               END DO
            END DO
  317     IF (MP2.GT.NDO2) GO TO 320
          DO  K = 1,NT
              DO  I = 1,IMM1
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +       &
     &                                VB(I,NP1,IV)*TVE2 +   &
     &                                WB(I,NP1,IW)*TWO1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +       &
     &                                VB(I,NP1,IV)*TVE1 -   &
     &                                WB(I,NP1,IW)*TWO2
                   END DO
                END DO
             END DO
          IF (MLAT.EQ.0) GO TO 320
          I = IMID
          DO  K = 1,NT
              DO  NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +    &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-2,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +    &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-1,K)*WTS(I)
               END DO
            END DO
  320 CONTINUE
      RETURN
!
!     case ityp=4 ,  v even, w odd, and cr and ci equal 0.
!
  400 CALL DVBIN(1,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
         DO  I = 1,IMID
            TV = VE(I,1,K)*WTS(I)
            DO  NP1 = 2,NDO2,2
               BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
            END DO
         END DO
      END DO
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 420 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(1,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(1,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP2.GT.NDO2) GO TO 420
          DO  K = 1,NT
              DO  I = 1,IMM1
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +      &
     &                                VB(I,NP1,IV)*TVE2 +  &
     &                                WB(I,NP1,IW)*TWO1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +      &
     &                                VB(I,NP1,IV)*TVE1 -  &
     &                                WB(I,NP1,IW)*TWO2
                   END DO
                END DO
                END DO
          IF (MLAT.EQ.0) GO TO 420
          I = IMID
          DO  K = 1,NT
              DO  NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +    &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-2,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +    &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-1,K)*WTS(I)
               END DO
            END DO
            
  420 CONTINUE
      RETURN
!
!     case ityp=5   v even, w odd, and br and bi equal zero
!
  500 CALL DVBIN(2,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
          DO  I = 1,IMM1
             TW = WO(I,1,K)*WTS(I)
             DO  NP1 = 3,NDO1,2
                CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
             END DO
          END DO
       END DO
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 520 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(2,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(2,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 520
          DO  K = 1,NT
              DO  I = 1,IMM1
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP1,NDO1,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -       &
                           VB(I,NP1,IV)*TWO2 +   &
                           WB(I,NP1,IW)*TVE1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -       &
                           VB(I,NP1,IV)*TWO1 -   &
                           WB(I,NP1,IW)*TVE2
                   END DO
                END DO 
                END DO
          IF (MLAT.EQ.0) GO TO 520
          I = IMID
          DO  K = 1,NT
             DO  NP1 = MP1,NDO1,2
                CR(MP1,NP1,K) = CR(MP1,NP1,K) +      &
                     WB(I,NP1,IW)*VE(I,2*MP1-1,K)*WTS(I)
                CI(MP1,NP1,K) = CI(MP1,NP1,K) -      &
                     WB(I,NP1,IW)*VE(I,2*MP1-2,K)*WTS(I)
             END DO
          END DO
  520 CONTINUE
      RETURN
!
!     case ityp=6 ,  v odd , w even
!
  600 CALL DVBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
         DO  I = 1,IMID
            TW = WE(I,1,K)*WTS(I)
            DO NP1 = 2,NDO2,2
               CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
            END DO
         END DO
      END DO
      DO  K = 1,NT
         DO  I = 1,IMM1
            TV = VO(I,1,K)*WTS(I)
            DO  NP1 = 3,NDO1,2
               BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
            END DO
         END DO
      END DO
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 620 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 617
          DO  K = 1,NT
             DO I = 1,IMM1
                TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                DO  NP1 = MP1,NDO1,2
                   BR(MP1,NP1,K) = BR(MP1,NP1,K) +      &
                        VB(I,NP1,IV)*TVO2 +  &
                        WB(I,NP1,IW)*TWE1
                   BI(MP1,NP1,K) = BI(MP1,NP1,K) +      &
                        VB(I,NP1,IV)*TVO1 -  &
                        WB(I,NP1,IW)*TWE2
                END DO
             END DO
          END DO
          IF (MLAT.EQ.0) GO TO 617
          I = IMID
          DO  K = 1,NT
             DO  NP1 = MP1,NDO1,2
                BR(MP1,NP1,K) = BR(MP1,NP1,K) +  &
                     WB(I,NP1,IW)*WE(I,2*MP1-1,K)*WTS(I)
                BI(MP1,NP1,K) = BI(MP1,NP1,K) -   &
                     WB(I,NP1,IW)*WE(I,2*MP1-2,K)*WTS(I)
             END DO
          END DO
                  
  617     IF (MP2.GT.NDO2) GO TO 620
          DO  K = 1,NT
             DO  I = 1,IMM1
                TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                DO  NP1 = MP2,NDO2,2
                   CR(MP1,NP1,K) = CR(MP1,NP1,K) -      &
                        VB(I,NP1,IV)*TWE2 +  &
                        WB(I,NP1,IW)*TVO1
                   CI(MP1,NP1,K) = CI(MP1,NP1,K) -      &
                        VB(I,NP1,IV)*TWE1 -  &
                        WB(I,NP1,IW)*TVO2
                END DO
             END DO
          END DO
          IF (MLAT.EQ.0) GO TO 620
          I = IMID
          DO  K = 1,NT
             DO  NP1 = MP2,NDO2,2
                CR(MP1,NP1,K) = CR(MP1,NP1,K) -  &
                     VB(I,NP1,IV)*WE(I,2*MP1-2,K)*WTS(I)
                CI(MP1,NP1,K) = CI(MP1,NP1,K) -  &
                     VB(I,NP1,IV)*WE(I,2*MP1-1,K)*WTS(I)
             END DO
          END DO
  620 CONTINUE
      RETURN
!
!     case ityp=7   v odd, w even, and cr and ci equal zero
!
  700 CALL DVBIN(2,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
         DO  I = 1,IMM1
            TV = VO(I,1,K)*WTS(I)
            DO  NP1 = 3,NDO1,2
               BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
            END DO
         END DO
      END DO
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 720 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(2,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(2,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 720
          DO  K = 1,NT
              DO  I = 1,IMM1
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +  &
     &                                VB(I,NP1,IV)*TVO2 +  &
     &                                WB(I,NP1,IW)*TWE1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +   &
     &                                VB(I,NP1,IV)*TVO1 -  &
     &                                WB(I,NP1,IW)*TWE2   
                 END DO
              END DO
          END DO
          IF (MLAT.EQ.0) GO TO 720
          I = IMID
          DO K = 1,NT
             DO  NP1 = MP1,NDO1,2
                 BR(MP1,NP1,K) = BR(MP1,NP1,K) +  &
     &                            WB(I,NP1,IW)*WE(I,2*MP1-1,K)*WTS(I)
                 BI(MP1,NP1,K) = BI(MP1,NP1,K) -  &
     &                           WB(I,NP1,IW)*WE(I,2*MP1-2,K)*WTS(I)
             END DO
          END DO
720  CONTINUE
      RETURN
!
!     case ityp=8   v odd, w even, and both br and bi equal zero
!
  800 CALL DVBIN(1,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
         DO  I = 1,IMID
            TW = WE(I,1,K)*WTS(I)
            DO  NP1 = 2,NDO2,2
               CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
            END DO
         END DO
      END DO
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 820 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL DVBIN(1,NLAT,NLON,M,VB,IV,WVBIN)
          CALL DWBIN(1,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP2.GT.NDO2) GO TO 820
          DO  K = 1,NT
             DO  I = 1,IMM1
                TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                DO  NP1 = MP2,NDO2,2
                   CR(MP1,NP1,K) = CR(MP1,NP1,K) -      &
                        VB(I,NP1,IV)*TWE2 +  &
                        WB(I,NP1,IW)*TVO1A
                   CI(MP1,NP1,K) = CI(MP1,NP1,K) -      &
                        VB(I,NP1,IV)*TWE1 -  &
                        WB(I,NP1,IW)*TVO2
                END DO
             END DO
          END DO
          IF (MLAT.EQ.0) GO TO 820
          I = IMID
          DO  K = 1,NT
             DO  NP1 = MP2,NDO2,2
                CR(MP1,NP1,K) = CR(MP1,NP1,K) -  &
                     VB(I,NP1,IV)*WE(I,2*MP1-2,K)*WTS(I)
                CI(MP1,NP1,K) = CI(MP1,NP1,K) -  &
                     VB(I,NP1,IV)*WE(I,2*MP1-1,K)*WTS(I)
             END DO
          END DO
  820 CONTINUE
      RETURN
      END SUBROUTINE DVHAGC1



      SUBROUTINE VHAGC1(NLAT,NLON,ITYP,NT,IMID,IDVW,JDVW,V,W,MDAB,NDAB,   &
                        BR,BI,CR,CI,IDV,VE,VO,WE,WO,VB,WB,WTS,WVBIN,   &
                        WWBIN,WRFFT)
      REAL V
      REAL W
      REAL BR
      REAL BI
      REAL CR
      REAL CI
      REAL VE
      REAL VO
      REAL WE
      REAL WO
      REAL VB
      REAL WB
      REAL WTS
      REAL WVBIN
      REAL WWBIN
      REAL WRFFT
      REAL TSN
      REAL FSN
      REAL TV
      REAL TW
      REAL TVO1
      REAL TVO2
      REAL TVE1
      REAL TVE2
      REAL TWO1
      REAL TWO2
      REAL TWE1
      REAL TWE2
      DIMENSION V(IDVW,JDVW,1),W(IDVW,JDVW,1),BR(MDAB,NDAB,1),   &
               BI(MDAB,NDAB,1),CR(MDAB,NDAB,1),CI(MDAB,NDAB,1),  &
               VE(IDV,NLON,1),VO(IDV,NLON,1),WE(IDV,NLON,1),  &
               WO(IDV,NLON,1),WTS(*),WVBIN(1),WWBIN(1),WRFFT(1),  &
               VB(IMID,NLAT,3),WB(IMID,NLAT,3)  

      NLP1 = NLAT + 1
      TSN = 2.D0/NLON
      FSN = 4.D0/NLON
      MLAT = MOD(NLAT,2)
      MLON = MOD(NLON,2)
      MMAX = MIN0(NLAT, (NLON+1)/2)
      IMM1 = IMID
      IF (MLAT.NE.0) IMM1 = IMID - 1
      IF (ITYP.GT.2) THEN
         DO K = 1,NT
            DO  I = 1,IMM1
               DO  J = 1,NLON
                  VE(I,J,K) = FSN*V(I,J,K)
                  VO(I,J,K) = FSN*V(I,J,K)
                  WE(I,J,K) = FSN*W(I,J,K)
                  WO(I,J,K) = FSN*W(I,J,K)
               END DO
            END DO
         END DO
      ELSE
         DO  K = 1,NT
            DO I = 1,IMM1
              DO  J = 1,NLON
                  VE(I,J,K) = TSN* (V(I,J,K)+V(NLP1-I,J,K))
                  VO(I,J,K) = TSN* (V(I,J,K)-V(NLP1-I,J,K))
                  WE(I,J,K) = TSN* (W(I,J,K)+W(NLP1-I,J,K))
                  WO(I,J,K) = TSN* (W(I,J,K)-W(NLP1-I,J,K))
               END DO
            END DO
         END DO
      ENDIF
      IF (MLAT.EQ.0) GO TO 7
      DO  K = 1,NT
          DO J = 1,NLON
              VE(IMID,J,K) = TSN*V(IMID,J,K)
              WE(IMID,J,K) = TSN*W(IMID,J,K)
           END DO
        END DO
    7  DO K = 1,NT
          CALL HRFFTF(IDV,NLON,VE(1,1,K),IDV,WRFFT,VB)
          CALL HRFFTF(IDV,NLON,WE(1,1,K),IDV,WRFFT,VB)
      END DO
      NDO1 = NLAT
      NDO2 = NLAT
      IF (MLAT.NE.0) NDO1 = NLAT - 1
      IF (MLAT.EQ.0) NDO2 = NLAT - 1
      IF (ITYP.EQ.2 .OR. ITYP.EQ.5 .OR. ITYP.EQ.8) GO TO 11
      DO K = 1,NT
          DO  MP1 = 1,MMAX
              DO  NP1 = MP1,NLAT
                  BR(MP1,NP1,K) = 0.D0
                  BI(MP1,NP1,K) = 0.D0
               END DO
            END DO
         END DO
   10 CONTINUE
   11 IF (ITYP.EQ.1 .OR. ITYP.EQ.4 .OR. ITYP.EQ.7) GO TO 13
      DO K = 1,NT
          DO  MP1 = 1,MMAX
              DO  NP1 = MP1,NLAT
                  CR(MP1,NP1,K) = 0.D0
                  CI(MP1,NP1,K) = 0.D0
               END DO
            END DO
         END DO
   12 CONTINUE
   13 ITYPP = ITYP + 1
      GO TO (1,100,200,300,400,500,600,700,800) ITYPP
!
!     case ityp=0 ,  no symmetries
!
    1 CALL VBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
         DO  I = 1,IMID
            TV = VE(I,1,K)*WTS(I)
            TW = WE(I,1,K)*WTS(I)
            DO  NP1 = 2,NDO2,2
               BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
               CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
            END DO
         END DO
      END DO
      DO 16 K = 1,NT
         DO  I = 1,IMM1
            TV = VO(I,1,K)*WTS(I)
            TW = WO(I,1,K)*WTS(I)
            DO  NP1 = 3,NDO1,2
               BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
               CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
            END DO
         END DO
   16 CONTINUE
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 20 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL VBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL WBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 17
          DO K = 1,NT
              DO  I = 1,IMM1
!
!     set temps to optimize quadrature
!
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) + &
     &                                VB(I,NP1,IV)*TVO2 +  &
     &                                WB(I,NP1,IW)*TWE1 
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) + &
     &                                VB(I,NP1,IV)*TVO1 - &
     &                                WB(I,NP1,IW)*TWE2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -  &
     &                                VB(I,NP1,IV)*TWO2 + &
     &                                WB(I,NP1,IW)*TVE1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -   &
     &                                VB(I,NP1,IV)*TWO1 - &
     &                                WB(I,NP1,IW)*TVE2
                   END DO
                END DO
             END DO
   23     CONTINUE

          IF (MLAT.EQ.0) GO TO 17
          I = IMID
          DO  K = 1,NT
              DO  NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +                &
     &                            WB(I,NP1,IW)*WE(I,2*MP1-1,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -   &
     &                            WB(I,NP1,IW)*WE(I,2*MP1-2,K)*WTS(I)
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +   &
     &                            WB(I,NP1,IW)*VE(I,2*MP1-1,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -   &
     &                            WB(I,NP1,IW)*VE(I,2*MP1-2,K)*WTS(I)
               END DO
            END DO
   17     IF (MP2.GT.NDO2) GO TO 20
          DO 21 K = 1,NT
              DO 1021 I = 1,IMM1
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  DO 10021 NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +  &
     &                                VB(I,NP1,IV)*TVE2 + &
     &                                WB(I,NP1,IW)*TWO1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +  &
     &                                VB(I,NP1,IV)*TVE1 - &
     &                                WB(I,NP1,IW)*TWO2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -   &
     &                                 VB(I,NP1,IV)*TWE2 +  &
     &                                WB(I,NP1,IW)*TVO1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -   &
     &                                VB(I,NP1,IV)*TWE1 - &
     &                                WB(I,NP1,IW)*TVO2
10021             CONTINUE
 1021         CONTINUE
   21     CONTINUE

          IF (MLAT.EQ.0) GO TO 20
          I = IMID
          DO 22 K = 1,NT
              DO 1022 NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +  &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-2,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +  &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-1,K)*WTS(I)
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -  &
     &                            VB(I,NP1,IV)*WE(I,2*MP1-2,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -  &
     &                            VB(I,NP1,IV)*WE(I,2*MP1-1,K)*WTS(I)
 1022         CONTINUE
   22     CONTINUE
   20 CONTINUE
      RETURN
!
!     case ityp=1 ,  no symmetries but cr and ci equal zero
!
  100 CALL VBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
          DO  I = 1,IMID
              TV = VE(I,1,K)*WTS(I)
              DO  NP1 = 2,NDO2,2
                 BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
              END DO
           END DO
        END DO
  115 CONTINUE
      DO K = 1,NT
          DO I = 1,IMM1
              TV = VO(I,1,K)*WTS(I)
              DO  NP1 = 3,NDO1,2
                 BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
              END DO
           END DO
        END DO
  116 CONTINUE
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 120 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL VBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL WBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 117
          DO  K = 1,NT
              DO  I = 1,IMM1
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +     &
     &                                VB(I,NP1,IV)*TVO2 + &
     &                                WB(I,NP1,IW)*TWE1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +     &
     &                                VB(I,NP1,IV)*TVO1 - &
     &                                WB(I,NP1,IW)*TWE2
                   END DO
                END DO
             END DO
  123     CONTINUE
          IF (MLAT.EQ.0) GO TO 117
          I = IMID
          DO  K = 1,NT
              DO  NP1 = MP1,NDO1,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +   &
     &                            WB(I,NP1,IW)*WE(I,2*MP1-1,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) -   &
     &                            WB(I,NP1,IW)*WE(I,2*MP1-2,K)*WTS(I)
               END DO
            END DO
  124     CONTINUE
  117     IF (MP2.GT.NDO2) GO TO 120
          DO K = 1,NT
              DO  I = 1,IMM1
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +      &
     &                                VB(I,NP1,IV)*TVE2 +  &
     &                                WB(I,NP1,IW)*TWO1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +      &
     &                                VB(I,NP1,IV)*TVE1 -  &
     &                                WB(I,NP1,IW)*TWO2
                   END DO
                END DO
             END DO
                      
          IF (MLAT.EQ.0) GO TO 120
          I = IMID
          DO K = 1,NT
              DO  NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +    &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-2,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +    &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-1,K)*WTS(I)
               END DO
            END DO
  120 CONTINUE
      RETURN
!
!     case ityp=2 ,  no symmetries but br and bi equal zero
!
  200 CALL VBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
          DO  I = 1,IMID
              TW = WE(I,1,K)*WTS(I)
              DO  NP1 = 2,NDO2,2
                 CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
              END DO
           END DO
        END DO
  215 CONTINUE
      DO  K = 1,NT
          DO  I = 1,IMM1
              TW = WO(I,1,K)*WTS(I)
              DO  NP1 = 3,NDO1,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
               END DO
            END DO
         END DO
216               CONTINUE
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 220 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL VBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL WBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 217
          DO K = 1,NT
              DO  I = 1,IMM1
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP1,NDO1,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -     &
     &                                VB(I,NP1,IV)*TWO2 + &
     &                                WB(I,NP1,IW)*TVE1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -    &
     &                                VB(I,NP1,IV)*TWO1 -  &
     &                                WB(I,NP1,IW)*TVE2

                   END DO
                END DO
             END DO
          IF (MLAT.EQ.0) GO TO 217
          I = IMID
          DO  K = 1,NT
              DO  NP1 = MP1,NDO1,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +   &
     &                            WB(I,NP1,IW)*VE(I,2*MP1-1,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -   &
     &                            WB(I,NP1,IW)*VE(I,2*MP1-2,K)*WTS(I)
               END DO
            END DO
  217     IF (MP2.GT.NDO2) GO TO 220
          DO K = 1,NT
              DO I = 1,IMM1
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP2,NDO2,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -     &
     &                                VB(I,NP1,IV)*TWE2 + &
     &                                WB(I,NP1,IW)*TVO1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -      &
     &                                VB(I,NP1,IV)*TWE1 -  &
     &                                WB(I,NP1,IW)*TVO2
                   END DO
                END DO
             END DO
221                   CONTINUE
                      
          IF (MLAT.EQ.0) GO TO 220
          I = IMID
          DO  K = 1,NT
              DO  NP1 = MP2,NDO2,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) -   &
                       VB(I,NP1,IV)*WE(I,2*MP1-2,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -   &
                       VB(I,NP1,IV)*WE(I,2*MP1-1,K)*WTS(I)
               END DO
            END DO
  220 CONTINUE
      RETURN
!
!     case ityp=3 ,  v even , w odd
!
  300 CALL VBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
          DO  I = 1,IMID
              TV = VE(I,1,K)*WTS(I)
              DO  NP1 = 2,NDO2,2
                  BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
             END DO
          END DO
       END DO
      DO K = 1,NT
          DO  I = 1,IMM1
              TW = WO(I,1,K)*WTS(I)
              DO  NP1 = 3,NDO1,2
                  CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
               END DO
            END DO
         END DO
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 320 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL VBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL WBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 317
          DO K = 1,NT
              DO I = 1,IMM1
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP1,NDO1,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -     &
     &                                VB(I,NP1,IV)*TWO2 + &
     &                                WB(I,NP1,IW)*TVE1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -     &
     &                                VB(I,NP1,IV)*TWO1 - &
     &                                WB(I,NP1,IW)*TVE2
                   END DO
                END DO
             END DO
             
          IF (MLAT.EQ.0) GO TO 317
          I = IMID
          DO K = 1,NT
              DO  NP1 = MP1,NDO1,2
                  CR(MP1,NP1,K) = CR(MP1,NP1,K) +     &
     &                            WB(I,NP1,IW)*VE(I,2*MP1-1,K)*WTS(I)
                  CI(MP1,NP1,K) = CI(MP1,NP1,K) -     &
     &                            WB(I,NP1,IW)*VE(I,2*MP1-2,K)*WTS(I)
               END DO
            END DO
  317     IF (MP2.GT.NDO2) GO TO 320
          DO  K = 1,NT
              DO  I = 1,IMM1
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +       &
     &                                VB(I,NP1,IV)*TVE2 +   &
     &                                WB(I,NP1,IW)*TWO1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +       &
     &                                VB(I,NP1,IV)*TVE1 -   &
     &                                WB(I,NP1,IW)*TWO2
                   END DO
                END DO
             END DO
          IF (MLAT.EQ.0) GO TO 320
          I = IMID
          DO  K = 1,NT
              DO  NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +    &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-2,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +    &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-1,K)*WTS(I)
               END DO
            END DO
  320 CONTINUE
      RETURN
!
!     case ityp=4 ,  v even, w odd, and cr and ci equal 0.
!
  400 CALL VBIN(1,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
         DO  I = 1,IMID
            TV = VE(I,1,K)*WTS(I)
            DO  NP1 = 2,NDO2,2
               BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
            END DO
         END DO
      END DO
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 420 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL VBIN(1,NLAT,NLON,M,VB,IV,WVBIN)
          CALL WBIN(1,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP2.GT.NDO2) GO TO 420
          DO  K = 1,NT
              DO  I = 1,IMM1
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP2,NDO2,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +      &
     &                                VB(I,NP1,IV)*TVE2 +  &
     &                                WB(I,NP1,IW)*TWO1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +      &
     &                                VB(I,NP1,IV)*TVE1 -  &
     &                                WB(I,NP1,IW)*TWO2
                   END DO
                END DO
                END DO
          IF (MLAT.EQ.0) GO TO 420
          I = IMID
          DO  K = 1,NT
              DO  NP1 = MP2,NDO2,2
                  BR(MP1,NP1,K) = BR(MP1,NP1,K) +    &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-2,K)*WTS(I)
                  BI(MP1,NP1,K) = BI(MP1,NP1,K) +    &
     &                            VB(I,NP1,IV)*VE(I,2*MP1-1,K)*WTS(I)
               END DO
            END DO
            
  420 CONTINUE
      RETURN
!
!     case ityp=5   v even, w odd, and br and bi equal zero
!
  500 CALL VBIN(2,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
          DO  I = 1,IMM1
             TW = WO(I,1,K)*WTS(I)
             DO  NP1 = 3,NDO1,2
                CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
             END DO
          END DO
       END DO
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 520 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL VBIN(2,NLAT,NLON,M,VB,IV,WVBIN)
          CALL WBIN(2,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 520
          DO  K = 1,NT
              DO  I = 1,IMM1
                  TWO1 = WO(I,2*MP1-1,K)*WTS(I)
                  TWO2 = WO(I,2*MP1-2,K)*WTS(I)
                  TVE1 = VE(I,2*MP1-1,K)*WTS(I)
                  TVE2 = VE(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP1,NDO1,2
                      CR(MP1,NP1,K) = CR(MP1,NP1,K) -       &
                           VB(I,NP1,IV)*TWO2 +   &
                           WB(I,NP1,IW)*TVE1
                      CI(MP1,NP1,K) = CI(MP1,NP1,K) -       &
                           VB(I,NP1,IV)*TWO1 -   &
                           WB(I,NP1,IW)*TVE2
                   END DO
                END DO 
                END DO
          IF (MLAT.EQ.0) GO TO 520
          I = IMID
          DO  K = 1,NT
             DO  NP1 = MP1,NDO1,2
                CR(MP1,NP1,K) = CR(MP1,NP1,K) +      &
                     WB(I,NP1,IW)*VE(I,2*MP1-1,K)*WTS(I)
                CI(MP1,NP1,K) = CI(MP1,NP1,K) -      &
                     WB(I,NP1,IW)*VE(I,2*MP1-2,K)*WTS(I)
             END DO
          END DO
  520 CONTINUE
      RETURN
!
!     case ityp=6 ,  v odd , w even
!
  600 CALL VBIN(0,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
         DO  I = 1,IMID
            TW = WE(I,1,K)*WTS(I)
            DO NP1 = 2,NDO2,2
               CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
            END DO
         END DO
      END DO
      DO  K = 1,NT
         DO  I = 1,IMM1
            TV = VO(I,1,K)*WTS(I)
            DO  NP1 = 3,NDO1,2
               BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
            END DO
         END DO
      END DO
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 620 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL VBIN(0,NLAT,NLON,M,VB,IV,WVBIN)
          CALL WBIN(0,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 617
          DO  K = 1,NT
             DO I = 1,IMM1
                TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                DO  NP1 = MP1,NDO1,2
                   BR(MP1,NP1,K) = BR(MP1,NP1,K) +      &
                        VB(I,NP1,IV)*TVO2 +  &
                        WB(I,NP1,IW)*TWE1
                   BI(MP1,NP1,K) = BI(MP1,NP1,K) +      &
                        VB(I,NP1,IV)*TVO1 -  &
                        WB(I,NP1,IW)*TWE2
                END DO
             END DO
          END DO
          IF (MLAT.EQ.0) GO TO 617
          I = IMID
          DO  K = 1,NT
             DO  NP1 = MP1,NDO1,2
                BR(MP1,NP1,K) = BR(MP1,NP1,K) +  &
                     WB(I,NP1,IW)*WE(I,2*MP1-1,K)*WTS(I)
                BI(MP1,NP1,K) = BI(MP1,NP1,K) -   &
                     WB(I,NP1,IW)*WE(I,2*MP1-2,K)*WTS(I)
             END DO
          END DO
                  
  617     IF (MP2.GT.NDO2) GO TO 620
          DO  K = 1,NT
             DO  I = 1,IMM1
                TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                DO  NP1 = MP2,NDO2,2
                   CR(MP1,NP1,K) = CR(MP1,NP1,K) -      &
                        VB(I,NP1,IV)*TWE2 +  &
                        WB(I,NP1,IW)*TVO1
                   CI(MP1,NP1,K) = CI(MP1,NP1,K) -      &
                        VB(I,NP1,IV)*TWE1 -  &
                        WB(I,NP1,IW)*TVO2
                END DO
             END DO
          END DO
          IF (MLAT.EQ.0) GO TO 620
          I = IMID
          DO  K = 1,NT
             DO  NP1 = MP2,NDO2,2
                CR(MP1,NP1,K) = CR(MP1,NP1,K) -  &
                     VB(I,NP1,IV)*WE(I,2*MP1-2,K)*WTS(I)
                CI(MP1,NP1,K) = CI(MP1,NP1,K) -  &
                     VB(I,NP1,IV)*WE(I,2*MP1-1,K)*WTS(I)
             END DO
          END DO
  620 CONTINUE
      RETURN
!
!     case ityp=7   v odd, w even, and cr and ci equal zero
!
  700 CALL VBIN(2,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
         DO  I = 1,IMM1
            TV = VO(I,1,K)*WTS(I)
            DO  NP1 = 3,NDO1,2
               BR(1,NP1,K) = BR(1,NP1,K) + VB(I,NP1,IV)*TV
            END DO
         END DO
      END DO
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 720 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL VBIN(2,NLAT,NLON,M,VB,IV,WVBIN)
          CALL WBIN(2,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP1.GT.NDO1) GO TO 720
          DO  K = 1,NT
              DO  I = 1,IMM1
                  TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                  TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                  TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                  TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                  DO  NP1 = MP1,NDO1,2
                      BR(MP1,NP1,K) = BR(MP1,NP1,K) +  &
     &                                VB(I,NP1,IV)*TVO2 +  &
     &                                WB(I,NP1,IW)*TWE1
                      BI(MP1,NP1,K) = BI(MP1,NP1,K) +   &
     &                                VB(I,NP1,IV)*TVO1 -  &
     &                                WB(I,NP1,IW)*TWE2   
                 END DO
              END DO
          END DO
          IF (MLAT.EQ.0) GO TO 720
          I = IMID
          DO K = 1,NT
             DO  NP1 = MP1,NDO1,2
                 BR(MP1,NP1,K) = BR(MP1,NP1,K) +  &
     &                            WB(I,NP1,IW)*WE(I,2*MP1-1,K)*WTS(I)
                 BI(MP1,NP1,K) = BI(MP1,NP1,K) -  &
     &                           WB(I,NP1,IW)*WE(I,2*MP1-2,K)*WTS(I)
             END DO
          END DO
720  CONTINUE
      RETURN
!
!     case ityp=8   v odd, w even, and both br and bi equal zero
!
  800 CALL VBIN(1,NLAT,NLON,0,VB,IV,WVBIN)
!
!     case m=0
!
      DO  K = 1,NT
         DO  I = 1,IMID
            TW = WE(I,1,K)*WTS(I)
            DO  NP1 = 2,NDO2,2
               CR(1,NP1,K) = CR(1,NP1,K) - VB(I,NP1,IV)*TW
            END DO
         END DO
      END DO
!
!     case m = 1 through nlat-1
!
      IF (MMAX.LT.2) RETURN
      DO 820 MP1 = 2,MMAX
          M = MP1 - 1
          MP2 = MP1 + 1
          CALL VBIN(1,NLAT,NLON,M,VB,IV,WVBIN)
          CALL WBIN(1,NLAT,NLON,M,WB,IW,WWBIN)
          IF (MP2.GT.NDO2) GO TO 820
          DO  K = 1,NT
             DO  I = 1,IMM1
                TWE1 = WE(I,2*MP1-1,K)*WTS(I)
                TWE2 = WE(I,2*MP1-2,K)*WTS(I)
                TVO1 = VO(I,2*MP1-1,K)*WTS(I)
                TVO2 = VO(I,2*MP1-2,K)*WTS(I)
                DO  NP1 = MP2,NDO2,2
                   CR(MP1,NP1,K) = CR(MP1,NP1,K) -      &
                        VB(I,NP1,IV)*TWE2 +  &
                        WB(I,NP1,IW)*TVO1A
                   CI(MP1,NP1,K) = CI(MP1,NP1,K) -      &
                        VB(I,NP1,IV)*TWE1 -  &
                        WB(I,NP1,IW)*TVO2
                END DO
             END DO
          END DO
          IF (MLAT.EQ.0) GO TO 820
          I = IMID
          DO  K = 1,NT
             DO  NP1 = MP2,NDO2,2
                CR(MP1,NP1,K) = CR(MP1,NP1,K) -  &
                     VB(I,NP1,IV)*WE(I,2*MP1-2,K)*WTS(I)
                CI(MP1,NP1,K) = CI(MP1,NP1,K) -  &
                     VB(I,NP1,IV)*WE(I,2*MP1-1,K)*WTS(I)
             END DO
          END DO
  820 CONTINUE
      RETURN
      END SUBROUTINE VHAGC1

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
! ... file sphcom.f
!
!     this file must be loaded with all driver level files
!     in spherepack3.0.  it includes undocumented subroutines
!     called by some or all of the drivers
!
      SUBROUTINE DNLFK(M,N,Cp)
      IMPLICIT NONE
      INTEGER i , l , M , ma , N , nex , nmms2
!
      DOUBLE PRECISION Cp , fnum , fden , fnmh , a1 , b1 , c1 , cp2 ,   &
                     & fnnp1 , fnmsq , fk , t1 , t2 , pm1 , SC10 ,      &
                     & SC20 , SC40
      DIMENSION Cp(1)
      PARAMETER (SC10=1024.D0)
      PARAMETER (SC20=SC10*SC10)
      PARAMETER (SC40=SC20*SC20)
!
      Cp(1) = 0.
      ma = IABS(M)
      IF ( ma>N ) RETURN
      IF ( N<1 ) THEN
         Cp(1) = DSQRT(2.D0)
         RETURN
      ELSEIF ( N==1 ) THEN
         IF ( ma/=0 ) THEN
            Cp(1) = DSQRT(.75D0)
            IF ( M==-1 ) Cp(1) = -Cp(1)
            RETURN
         ELSE
            Cp(1) = DSQRT(1.5D0)
            RETURN
         ENDIF
      ELSE
         IF ( MOD(N+ma,2)/=0 ) THEN
            nmms2 = (N-ma-1)/2
            fnum = N + ma + 2
            fnmh = N - ma + 2
            pm1 = -1.D0
         ELSE
            nmms2 = (N-ma)/2
            fnum = N + ma + 1
            fnmh = N - ma + 1
            pm1 = 1.D0
         ENDIF
!      t1 = 1.
!      t1 = 2.d0**(n-1)
!      t1 = 1.d0/t1
         t1 = 1.D0/SC20
         nex = 20
         fden = 2.D0
         IF ( nmms2>=1 ) THEN
            DO i = 1 , nmms2
               t1 = fnum*t1/fden
               IF ( t1>SC20 ) THEN
                  t1 = t1/SC40
                  nex = nex + 40
               ENDIF
               fnum = fnum + 2.
               fden = fden + 2.
            ENDDO
         ENDIF
         t1 = t1/2.D0**(N-1-nex)
         IF ( MOD(ma/2,2)/=0 ) t1 = -t1
         t2 = 1.
         IF ( ma/=0 ) THEN
            DO i = 1 , ma
               t2 = fnmh*t2/(fnmh+pm1)
               fnmh = fnmh + 2.
            ENDDO
         ENDIF
         cp2 = t1*DSQRT((N+.5D0)*t2)
         fnnp1 = N*(N+1)
         fnmsq = fnnp1 - 2.D0*ma*ma
         l = (N+1)/2
         IF ( MOD(N,2)==0 .AND. MOD(ma,2)==0 ) l = l + 1
         Cp(l) = cp2
         IF ( M<0 ) THEN
            IF ( MOD(ma,2)/=0 ) Cp(l) = -Cp(l)
         ENDIF
         IF ( l<=1 ) RETURN
         fk = N
         a1 = (fk-2.)*(fk-1.) - fnnp1
         b1 = 2.*(fk*fk-fnmsq)
         Cp(l-1) = b1*Cp(l)/a1
 50      l = l - 1
         IF ( l<=1 ) RETURN
         fk = fk - 2.
         a1 = (fk-2.)*(fk-1.) - fnnp1
         b1 = -2.*(fk*fk-fnmsq)
         c1 = (fk+1.)*(fk+2.) - fnnp1
         Cp(l-1) = -(b1*Cp(l)+c1*Cp(l+1))/a1
         GOTO 50
      ENDIF
      END SUBROUTINE DNLFK


      SUBROUTINE DNLFT(M,N,Theta,Cp,Pb)
      IMPLICIT NONE
      INTEGER k , kdo , M , mmod , N , nmod
      DOUBLE PRECISION Cp(*) , Pb , Theta , cdt , sdt , cth , sth , chh
      cdt = DCOS(Theta+Theta)
      sdt = DSIN(Theta+Theta)
      nmod = MOD(N,2)
      mmod = MOD(M,2)
      IF ( nmod<=0 ) THEN
         IF ( mmod<=0 ) THEN
!
!     n even, m even
!
            kdo = N/2
            Pb = .5*Cp(1)
            IF ( N==0 ) RETURN
            cth = cdt
            sth = sdt
            DO k = 1 , kdo
!     pb = pb+cp(k+1)*dcos(2*k*theta)
               Pb = Pb + Cp(k+1)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ELSE
!
!     n even, m odd
!
            kdo = N/2
            Pb = 0.
            cth = cdt
            sth = sdt
            DO k = 1 , kdo
!     pb = pb+cp(k)*dsin(2*k*theta)
               Pb = Pb + Cp(k)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ELSEIF ( mmod<=0 ) THEN
!
!     n odd, m even
!
         kdo = (N+1)/2
         Pb = 0.
         cth = DCOS(Theta)
         sth = DSIN(Theta)
         DO k = 1 , kdo
!     pb = pb+cp(k)*dcos((2*k-1)*theta)
            Pb = Pb + Cp(k)*cth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         RETURN
      ELSE
!
!     n odd, m odd
!
         kdo = (N+1)/2
         Pb = 0.
         cth = DCOS(Theta)
         sth = DSIN(Theta)
         DO k = 1 , kdo
!     pb = pb+cp(k)*dsin((2*k-1)*theta)
            Pb = Pb + Cp(k)*sth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
      ENDIF
      END SUBROUTINE DNLFT


      SUBROUTINE LEGIN(Mode,L,Nlat,M,W,Pmn,Km)
      IMPLICIT NONE
      INTEGER i1 , i2 , i3 , i4 , i5 , Km , L , late , M , Mode , Nlat
      REAL Pmn , W
!     this subroutine computes legendre polynomials for n=m,...,l-1
!     and  i=1,...,late (late=((nlat+mod(nlat,2))/2)gaussian grid
!     in pmn(n+1,i,km) using swarztrauber's recursion formula.
!     the vector w contains quantities precomputed in shigc.
!     legin must be called in the order m=0,1,...,l-1
!     (e.g., if m=10 is sought it must be preceded by calls with
!     m=0,1,2,...,9 in that order)
      DIMENSION W(1) , Pmn(1)
!     set size of pole to equator gaussian grid
      late = (Nlat+MOD(Nlat,2))/2
!     partition w (set pointers for p0n,p1n,abel,bbel,cbel,pmn)
      i1 = 1 + Nlat
      i2 = i1 + Nlat*late
      i3 = i2 + Nlat*late
      i4 = i3 + (2*Nlat-L)*(L-1)/2
      i5 = i4 + (2*Nlat-L)*(L-1)/2
      CALL LEGIN1(Mode,L,Nlat,late,M,W(i1),W(i2),W(i3),W(i4),W(i5),Pmn, &
                & Km)
      END SUBROUTINE LEGIN


      SUBROUTINE LEGIN1(Mode,L,Nlat,Late,M,P0n,P1n,Abel,Bbel,Cbel,Pmn,  &
                      & Km)
      IMPLICIT NONE
      REAL Abel , Bbel , Cbel , P0n , P1n , Pmn
      INTEGER i , imn , IMNDX , INDX , Km , km0 , km1 , km2 , kmt , L , &
            & Late , M , Mode , ms , n , ninc , Nlat , np1
      DIMENSION P0n(Nlat,Late) , P1n(Nlat,Late)
      DIMENSION Abel(1) , Bbel(1) , Cbel(1) , Pmn(Nlat,Late,3)
      DATA km0 , km1 , km2/1 , 2 , 3/
      SAVE km0 , km1 , km2
!     define index function used in storing triangular
!     arrays for recursion coefficients (functions of (m,n))
!     for 2.le.m.le.n-1 and 2.le.n.le.l-1
      INDX(M,n) = (n-1)*(n-2)/2 + M - 1
!     for l.le.n.le.nlat and 2.le.m.le.l
      IMNDX(M,n) = L*(L-1)/2 + (n-L-1)*(L-1) + M - 1
 
!     set do loop indices for full or half sphere
      ms = M + 1
      ninc = 1
      IF ( Mode==1 ) THEN
!     only compute pmn for n-m odd
         ms = M + 2
         ninc = 2
      ELSEIF ( Mode==2 ) THEN
!     only compute pmn for n-m even
         ms = M + 1
         ninc = 2
      ENDIF
 
 
      IF ( M>1 ) THEN
         DO np1 = ms , Nlat , ninc
            n = np1 - 1
            imn = INDX(M,n)
            IF ( n>=L ) imn = IMNDX(M,n)
            DO i = 1 , Late
               Pmn(np1,i,km0) = Abel(imn)*Pmn(n-1,i,km2) + Bbel(imn)    &
                              & *Pmn(n-1,i,km0) - Cbel(imn)             &
                              & *Pmn(np1,i,km2)
            ENDDO
         ENDDO
 
      ELSEIF ( M==0 ) THEN
         DO np1 = ms , Nlat , ninc
            DO i = 1 , Late
               Pmn(np1,i,km0) = P0n(np1,i)
            ENDDO
         ENDDO
 
      ELSEIF ( M==1 ) THEN
         DO np1 = ms , Nlat , ninc
            DO i = 1 , Late
               Pmn(np1,i,km0) = P1n(np1,i)
            ENDDO
         ENDDO
      ENDIF
 
!     permute column indices
!     km0,km1,km2 store m,m-1,m-2 columns
      kmt = km0
      km0 = km2
      km2 = km1
      km1 = kmt
!     set current m index in output param km
      Km = kmt
      END SUBROUTINE LEGIN1
 
 
      SUBROUTINE ZFIN(Isym,Nlat,Nlon,M,Z,I3,Wzfin)
      IMPLICIT NONE
      INTEGER I3 , imid , Isym , iw1 , iw2 , iw3 , iw4 , labc , lim ,   &
            & M , mmax , Nlat , Nlon
      REAL Wzfin , Z
      DIMENSION Z(1) , Wzfin(1)
      imid = (Nlat+1)/2
      lim = Nlat*imid
      mmax = MIN0(Nlat,Nlon/2+1)
      labc = ((mmax-2)*(Nlat+Nlat-mmax-1))/2
      iw1 = lim + 1
      iw2 = iw1 + lim
      iw3 = iw2 + labc
      iw4 = iw3 + labc
!
!     the length of wzfin is 2*lim+3*labc
!
      CALL ZFIN1(Isym,Nlat,M,Z,imid,I3,Wzfin,Wzfin(iw1),Wzfin(iw2),     &
               & Wzfin(iw3),Wzfin(iw4))
      END SUBROUTINE ZFIN


      SUBROUTINE ZFIN1(Isym,Nlat,M,Z,Imid,I3,Zz,Z1,A,B,C)
      IMPLICIT NONE
      REAL A , B , C , Z , Z1 , Zz
      INTEGER i , i1 , i2 , I3 , ihold , Imid , Isym , M , Nlat , np1 , &
            & ns , nstp , nstrt
      DIMENSION Z(Imid,Nlat,3) , Zz(Imid,1) , Z1(Imid,1) , A(1) , B(1) ,&
              & C(1)
      SAVE i1 , i2
      ihold = i1
      i1 = i2
      i2 = I3
      I3 = ihold
      IF ( M<1 ) THEN
         i1 = 1
         i2 = 2
         I3 = 3
         DO np1 = 1 , Nlat
            DO i = 1 , Imid
               Z(i,np1,I3) = Zz(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSEIF ( M==1 ) THEN
         DO np1 = 2 , Nlat
            DO i = 1 , Imid
               Z(i,np1,I3) = Z1(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSE
         ns = ((M-2)*(Nlat+Nlat-M-1))/2 + 1
         IF ( Isym/=1 ) THEN
            DO i = 1 , Imid
               Z(i,M+1,I3) = A(ns)*Z(i,M-1,i1) - C(ns)*Z(i,M+1,i1)
            ENDDO
         ENDIF
         IF ( M==Nlat-1 ) RETURN
         IF ( Isym/=2 ) THEN
            ns = ns + 1
            DO i = 1 , Imid
               Z(i,M+2,I3) = A(ns)*Z(i,M,i1) - C(ns)*Z(i,M+2,i1)
            ENDDO
         ENDIF
         nstrt = M + 3
         IF ( Isym==1 ) nstrt = M + 4
         IF ( nstrt<=Nlat ) THEN
            nstp = 2
            IF ( Isym==0 ) nstp = 1
            DO np1 = nstrt , Nlat , nstp
               ns = ns + nstp
               DO i = 1 , Imid
                  Z(i,np1,I3) = A(ns)*Z(i,np1-2,i1) + B(ns)             &
                              & *Z(i,np1-2,I3) - C(ns)*Z(i,np1,i1)
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      END SUBROUTINE ZFIN1


      SUBROUTINE ZFINIT(Nlat,Nlon,Wzfin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      REAL Wzfin
      DIMENSION Wzfin(*)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of wzfin is 3*((l-3)*l+2)/2 + 2*l*imid
!     the length of dwork is nlat+1
!
      CALL ZFINI1(Nlat,Nlon,imid,Wzfin,Wzfin(iw1),Dwork,Dwork(imid+1))
      END SUBROUTINE ZFINIT


      SUBROUTINE ZFINI1(Nlat,Nlon,Imid,Z,Abc,Cz,Work)
      IMPLICIT NONE
      REAL Abc , Z
      INTEGER i , Imid , m , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*((mmax-2)*(nlat+nlat-mmax-1))/2 locations
!     where mmax = min0(nlat,nlon/2+1)
!     cz and work must each have nlat+1 locations
!
      DIMENSION Z(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION pi , dt , th , zh , Cz(*) , Work(*)
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      DO mp1 = 1 , 2
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DNZFK(Nlat,m,n,Cz,Work)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DNZFT(Nlat,m,n,th,Cz,zh)
               Z(i,np1,mp1) = zh
            ENDDO
            Z(1,np1,mp1) = .5*Z(1,np1,mp1)
         ENDDO
      ENDDO
      CALL RABCP(Nlat,Nlon,Abc)
      END SUBROUTINE ZFINI1


      SUBROUTINE DNZFK(Nlat,M,N,Cz,Work)
      IMPLICIT NONE
      INTEGER i , idx , k , kdo , kp1 , lc , M , mmod , N , Nlat , nmod
!
!     dnzfk computes the coefficients in the trigonometric
!     expansion of the z functions that are used in spherical
!     harmonic analysis.
!
      DIMENSION Cz(1) , Work(1)
!
!     cz and work must both have nlat+1 locations
!
      DOUBLE PRECISION sum , sc1 , t1 , t2 , Work , Cz
      lc = (Nlat+1)/2
      sc1 = 2.D0/FLOAT(Nlat-1)
      CALL DNLFK(M,N,Work)
      nmod = MOD(N,2)
      mmod = MOD(M,2)
      IF ( nmod<=0 ) THEN
         IF ( mmod<=0 ) THEN
!
!     n even, m even
!
            kdo = N/2 + 1
            DO idx = 1 , lc
               i = idx + idx - 2
               sum = Work(1)/(1.D0-i*i)
               IF ( kdo>=2 ) THEN
                  DO kp1 = 2 , kdo
                     k = kp1 - 1
                     t1 = 1.D0 - (k+k+i)**2
                     t2 = 1.D0 - (k+k-i)**2
                     sum = sum + Work(kp1)*(t1+t2)/(t1*t2)
                  ENDDO
               ENDIF
               Cz(idx) = sc1*sum
            ENDDO
            RETURN
         ELSE
!
!     n even, m odd
!
            kdo = N/2
            DO idx = 1 , lc
               i = idx + idx - 2
               sum = 0.
               DO k = 1 , kdo
                  t1 = 1.D0 - (k+k+i)**2
                  t2 = 1.D0 - (k+k-i)**2
                  sum = sum + Work(k)*(t1-t2)/(t1*t2)
               ENDDO
               Cz(idx) = sc1*sum
            ENDDO
            RETURN
         ENDIF
      ELSEIF ( mmod<=0 ) THEN
!
!     n odd, m even
!
         kdo = (N+1)/2
         DO idx = 1 , lc
            i = idx + idx - 1
            sum = 0.
            DO k = 1 , kdo
               t1 = 1.D0 - (k+k-1+i)**2
               t2 = 1.D0 - (k+k-1-i)**2
               sum = sum + Work(k)*(t1+t2)/(t1*t2)
            ENDDO
            Cz(idx) = sc1*sum
         ENDDO
         RETURN
      ELSE
!
!     n odd, m odd
!
         kdo = (N+1)/2
         DO idx = 1 , lc
            i = idx + idx - 3
            sum = 0.
            DO k = 1 , kdo
               t1 = 1.D0 - (k+k-1+i)**2
               t2 = 1.D0 - (k+k-1-i)**2
               sum = sum + Work(k)*(t1-t2)/(t1*t2)
            ENDDO
            Cz(idx) = sc1*sum
         ENDDO
      ENDIF
      END SUBROUTINE DNZFK


      SUBROUTINE DNZFT(Nlat,M,N,Th,Cz,Zh)
      IMPLICIT NONE
      INTEGER k , lc , lmod , lq , ls , M , mmod , N , Nlat , nmod
      DIMENSION Cz(1)
      DOUBLE PRECISION Cz , Zh , Th , cdt , sdt , cth , sth , chh
      Zh = 0.
      cdt = DCOS(Th+Th)
      sdt = DSIN(Th+Th)
      lmod = MOD(Nlat,2)
      mmod = MOD(M,2)
      nmod = MOD(N,2)
      IF ( lmod<=0 ) THEN
         lc = Nlat/2
         lq = lc - 1
         IF ( nmod<=0 ) THEN
            IF ( mmod<=0 ) THEN
!
!     nlat even n even m even
!
               Zh = .5*Cz(1)
               cth = cdt
               sth = sdt
               DO k = 2 , lc
!     zh = zh+cz(k)*dcos(2*(k-1)*th)
                  Zh = Zh + Cz(k)*cth
                  chh = cdt*cth - sdt*sth
                  sth = sdt*cth + cdt*sth
                  cth = chh
               ENDDO
               RETURN
            ELSE
!
!     nlat even n even m odd
!
               cth = cdt
               sth = sdt
               DO k = 1 , lq
!     zh = zh+cz(k+1)*dsin(2*k*th)
                  Zh = Zh + Cz(k+1)*sth
                  chh = cdt*cth - sdt*sth
                  sth = sdt*cth + cdt*sth
                  cth = chh
               ENDDO
               RETURN
            ENDIF
!
!     nlat even n odd m even
!
         ELSEIF ( mmod<=0 ) THEN
            Zh = .5*Cz(lc)*DCOS((Nlat-1)*Th)
            cth = DCOS(Th)
            sth = DSIN(Th)
            DO k = 1 , lq
!     zh = zh+cz(k)*dcos((2*k-1)*th)
               Zh = Zh + Cz(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ELSE
!
!     nlat even n odd m odd
!
            cth = DCOS(Th)
            sth = DSIN(Th)
            DO k = 1 , lq
!     zh = zh+cz(k+1)*dsin((2*k-1)*th)
               Zh = Zh + Cz(k+1)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            GOTO 99999
         ENDIF
      ELSE
         lc = (Nlat+1)/2
         lq = lc - 1
         ls = lc - 2
         IF ( nmod<=0 ) THEN
            IF ( mmod<=0 ) THEN
!
!     nlat odd n even m even
!
               Zh = .5*(Cz(1)+Cz(lc)*DCOS(2*lq*Th))
               cth = cdt
               sth = sdt
               DO k = 2 , lq
!     zh = zh+cz(k)*dcos(2*(k-1)*th)
                  Zh = Zh + Cz(k)*cth
                  chh = cdt*cth - sdt*sth
                  sth = sdt*cth + cdt*sth
                  cth = chh
               ENDDO
               RETURN
            ELSE
!
!     nlat odd n even m odd
!
               cth = cdt
               sth = sdt
               DO k = 1 , ls
!     zh = zh+cz(k+1)*dsin(2*k*th)
                  Zh = Zh + Cz(k+1)*sth
                  chh = cdt*cth - sdt*sth
                  sth = sdt*cth + cdt*sth
                  cth = chh
               ENDDO
               RETURN
            ENDIF
!
!     nlat odd n odd, m even
!
         ELSEIF ( mmod<=0 ) THEN
            cth = DCOS(Th)
            sth = DSIN(Th)
            DO k = 1 , lq
!     zh = zh+cz(k)*dcos((2*k-1)*th)
               Zh = Zh + Cz(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ENDIF
!
!     nlat odd n odd m odd
!
      cth = DCOS(Th)
      sth = DSIN(Th)
      DO k = 1 , lq
!     zh = zh+cz(k+1)*dsin((2*k-1)*th)
         Zh = Zh + Cz(k+1)*sth
         chh = cdt*cth - sdt*sth
         sth = sdt*cth + cdt*sth
         cth = chh
      ENDDO
      RETURN
99999 END SUBROUTINE DNZFT


      SUBROUTINE ALIN(Isym,Nlat,Nlon,M,P,I3,Walin)
      IMPLICIT NONE
      INTEGER I3 , imid , Isym , iw1 , iw2 , iw3 , iw4 , labc , lim ,   &
            & M , mmax , Nlat , Nlon
      REAL P , Walin
      DIMENSION P(1) , Walin(1)
      imid = (Nlat+1)/2
      lim = Nlat*imid
      mmax = MIN0(Nlat,Nlon/2+1)
      labc = ((mmax-2)*(Nlat+Nlat-mmax-1))/2
      iw1 = lim + 1
      iw2 = iw1 + lim
      iw3 = iw2 + labc
      iw4 = iw3 + labc
!
!     the length of walin is ((5*l-7)*l+6)/2
!
      CALL ALIN1(Isym,Nlat,M,P,imid,I3,Walin,Walin(iw1),Walin(iw2),     &
               & Walin(iw3),Walin(iw4))
      END SUBROUTINE ALIN


      SUBROUTINE ALIN1(Isym,Nlat,M,P,Imid,I3,Pz,P1,A,B,C)
      IMPLICIT NONE
      REAL A , B , C , P , P1 , Pz
      INTEGER i , i1 , i2 , I3 , ihold , Imid , Isym , M , Nlat , np1 , &
            & ns , nstp , nstrt
      DIMENSION P(Imid,Nlat,3) , Pz(Imid,1) , P1(Imid,1) , A(1) , B(1) ,&
              & C(1)
      SAVE i1 , i2
      ihold = i1
      i1 = i2
      i2 = I3
      I3 = ihold
      IF ( M<1 ) THEN
         i1 = 1
         i2 = 2
         I3 = 3
         DO np1 = 1 , Nlat
            DO i = 1 , Imid
               P(i,np1,I3) = Pz(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSEIF ( M==1 ) THEN
         DO np1 = 2 , Nlat
            DO i = 1 , Imid
               P(i,np1,I3) = P1(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSE
         ns = ((M-2)*(Nlat+Nlat-M-1))/2 + 1
         IF ( Isym/=1 ) THEN
            DO i = 1 , Imid
               P(i,M+1,I3) = A(ns)*P(i,M-1,i1) - C(ns)*P(i,M+1,i1)
            ENDDO
         ENDIF
         IF ( M==Nlat-1 ) RETURN
         IF ( Isym/=2 ) THEN
            ns = ns + 1
            DO i = 1 , Imid
               P(i,M+2,I3) = A(ns)*P(i,M,i1) - C(ns)*P(i,M+2,i1)
            ENDDO
         ENDIF
         nstrt = M + 3
         IF ( Isym==1 ) nstrt = M + 4
         IF ( nstrt<=Nlat ) THEN
            nstp = 2
            IF ( Isym==0 ) nstp = 1
            DO np1 = nstrt , Nlat , nstp
               ns = ns + nstp
               DO i = 1 , Imid
                  P(i,np1,I3) = A(ns)*P(i,np1-2,i1) + B(ns)             &
                              & *P(i,np1-2,I3) - C(ns)*P(i,np1,i1)
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      END SUBROUTINE ALIN1


      SUBROUTINE ALINIT(Nlat,Nlon,Walin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      REAL Walin
      DIMENSION Walin(*)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of walin is 3*((l-3)*l+2)/2 + 2*l*imid
!     the length of work is nlat+1
!
      CALL ALINI1(Nlat,Nlon,imid,Walin,Walin(iw1),Dwork)
      END SUBROUTINE ALINIT


      SUBROUTINE ALINI1(Nlat,Nlon,Imid,P,Abc,Cp)
      IMPLICIT NONE
      REAL Abc , P
      INTEGER i , Imid , m , mp1 , n , Nlat , Nlon , np1
      DIMENSION P(Imid,Nlat,2) , Abc(1) , Cp(1)
      DOUBLE PRECISION pi , dt , th , Cp , ph
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      DO mp1 = 1 , 2
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DNLFK(m,n,Cp)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DNLFT(m,n,th,Cp,ph)
               P(i,np1,mp1) = ph
            ENDDO
         ENDDO
      ENDDO
      CALL RABCP(Nlat,Nlon,Abc)
      END SUBROUTINE ALINI1

      
      SUBROUTINE RABCP(Nlat,Nlon,Abc)
      IMPLICIT NONE
      REAL Abc
      INTEGER iw1 , iw2 , labc , mmax , Nlat , Nlon
!
!     subroutine rabcp computes the coefficients in the recurrence
!     relation for the associated legendre fuctions. array abc
!     must have 3*((mmax-2)*(nlat+nlat-mmax-1))/2 locations.
!
      DIMENSION Abc(1)
      mmax = MIN0(Nlat,Nlon/2+1)
      labc = ((mmax-2)*(Nlat+Nlat-mmax-1))/2
      iw1 = labc + 1
      iw2 = iw1 + labc
      CALL RABCP1(Nlat,Nlon,Abc,Abc(iw1),Abc(iw2))
      END SUBROUTINE RABCP


      SUBROUTINE RABCP1(Nlat,Nlon,A,B,C)
      IMPLICIT NONE
      REAL A , B , C , cn , fm , fn , fnmm , fnpm , temp , tm , tn
      INTEGER m , mmax , mp1 , mp3 , n , Nlat , Nlon , np1 , ns
!
!     coefficients a, b, and c for computing pbar(m,n,theta) are
!     stored in location ((m-2)*(nlat+nlat-m-1))/2+n+1
!
      DIMENSION A(1) , B(1) , C(1)
      mmax = MIN0(Nlat,Nlon/2+1)
      DO mp1 = 3 , mmax
         m = mp1 - 1
         ns = ((m-2)*(Nlat+Nlat-m-1))/2 + 1
         fm = FLOAT(m)
         tm = fm + fm
         temp = tm*(tm-1.)
         A(ns) = SQRT((tm+1.)*(tm-2.)/temp)
         C(ns) = SQRT(2./temp)
         IF ( m/=Nlat-1 ) THEN
            ns = ns + 1
            temp = tm*(tm+1.)
            A(ns) = SQRT((tm+3.)*(tm-2.)/temp)
            C(ns) = SQRT(6./temp)
            mp3 = m + 3
            IF ( mp3<=Nlat ) THEN
               DO np1 = mp3 , Nlat
                  n = np1 - 1
                  ns = ns + 1
                  fn = FLOAT(n)
                  tn = fn + fn
                  cn = (tn+1.)/(tn-3.)
                  fnpm = fn + fm
                  fnmm = fn - fm
                  temp = fnpm*(fnpm-1.)
                  A(ns) = SQRT(cn*(fnpm-3.)*(fnpm-2.)/temp)
                  B(ns) = SQRT(cn*fnmm*(fnmm-1.)/temp)
                  C(ns) = SQRT((fnmm+1.)*(fnmm+2.)/temp)
               ENDDO
            ENDIF
         ENDIF
      ENDDO
      END SUBROUTINE RABCP1

      
      SUBROUTINE SEA1(Nlat,Nlon,Imid,Z,Idz,Zin,Wzfin,Dwork)
      IMPLICIT NONE
      INTEGER i , i3 , Idz , Imid , m , mmax , mn , mp1 , Nlat , Nlon , &
            & np1
      REAL Wzfin , Z , Zin
      DIMENSION Z(Idz,*) , Zin(Imid,Nlat,3) , Wzfin(*)
      DOUBLE PRECISION Dwork(*)
      CALL ZFINIT(Nlat,Nlon,Wzfin,Dwork)
      mmax = MIN0(Nlat,Nlon/2+1)
      DO mp1 = 1 , mmax
         m = mp1 - 1
         CALL ZFIN(0,Nlat,Nlon,m,Zin,i3,Wzfin)
         DO np1 = mp1 , Nlat
            mn = m*(Nlat-1) - (m*(m-1))/2 + np1
            DO i = 1 , Imid
               Z(mn,i) = Zin(i,np1,i3)
            ENDDO
         ENDDO
      ENDDO
      END SUBROUTINE SEA1


      SUBROUTINE SES1(Nlat,Nlon,Imid,P,Pin,Walin,Dwork)
      IMPLICIT NONE
      INTEGER i , i3 , Imid , m , mmax , mn , mp1 , Nlat , Nlon , np1
      REAL P , Pin , Walin
      DIMENSION P(Imid,*) , Pin(Imid,Nlat,3) , Walin(*)
      DOUBLE PRECISION Dwork(*)
      CALL ALINIT(Nlat,Nlon,Walin,Dwork)
      mmax = MIN0(Nlat,Nlon/2+1)
      DO mp1 = 1 , mmax
         m = mp1 - 1
         CALL ALIN(0,Nlat,Nlon,m,Pin,i3,Walin)
         DO np1 = mp1 , Nlat
            mn = m*(Nlat-1) - (m*(m-1))/2 + np1
            DO i = 1 , Imid
               P(i,mn) = Pin(i,np1,i3)
            ENDDO
         ENDDO
      ENDDO
    END SUBROUTINE  SES1


      SUBROUTINE ZVINIT(Nlat,Nlon,Wzvin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      REAL Wzvin
      DIMENSION Wzvin(1)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of wzvin is
!         2*nlat*imid +3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     the length of dwork is 2*nlat+2
!
      CALL ZVINI1(Nlat,Nlon,imid,Wzvin,Wzvin(iw1),Dwork,Dwork(Nlat+2))
      END SUBROUTINE ZVINIT


      SUBROUTINE ZVINI1(Nlat,Nlon,Imid,Zv,Abc,Czv,Work)
      IMPLICIT NONE
      REAL Abc , Zv
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     czv and work must each have nlat+1  locations
!
      DIMENSION Zv(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION pi , dt , Czv(1) , zvh , th , Work(1)
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      mdo = MIN0(2,Nlat,(Nlon+1)/2)
      DO mp1 = 1 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DZVK(Nlat,m,n,Czv,Work)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DZVT(Nlat,m,n,th,Czv,zvh)
               Zv(i,np1,mp1) = zvh
            ENDDO
            Zv(1,np1,mp1) = .5*Zv(1,np1,mp1)
         ENDDO
      ENDDO
      CALL RABCV(Nlat,Nlon,Abc)
      END SUBROUTINE ZVINI1


      SUBROUTINE ZWINIT(Nlat,Nlon,Wzwin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      REAL Wzwin
      DIMENSION Wzwin(1)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of wzvin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of dwork is 2*nlat+2
!
      CALL ZWINI1(Nlat,Nlon,imid,Wzwin,Wzwin(iw1),Dwork,Dwork(Nlat+2))
    END SUBROUTINE ZWINIT
    

      SUBROUTINE ZWINI1(Nlat,Nlon,Imid,Zw,Abc,Czw,Work)
      IMPLICIT NONE
      REAL Abc , Zw
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     czw and work must each have nlat+1 locations
!
      DIMENSION Zw(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION pi , dt , Czw(1) , zwh , th , Work(1)
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      mdo = MIN0(3,Nlat,(Nlon+1)/2)
      IF ( mdo<2 ) RETURN
      DO mp1 = 2 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DZWK(Nlat,m,n,Czw,Work)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DZWT(Nlat,m,n,th,Czw,zwh)
               Zw(i,np1,m) = zwh
            ENDDO
            Zw(1,np1,m) = .5*Zw(1,np1,m)
         ENDDO
      ENDDO
      CALL RABCW(Nlat,Nlon,Abc)
      END SUBROUTINE ZWINI1


      SUBROUTINE ZVIN(Ityp,Nlat,Nlon,M,Zv,I3,Wzvin)
      IMPLICIT NONE
      INTEGER I3 , imid , Ityp , iw1 , iw2 , iw3 , iw4 , labc , lim ,   &
            & M , mmax , Nlat , Nlon
      REAL Wzvin , Zv
      DIMENSION Zv(1) , Wzvin(1)
      imid = (Nlat+1)/2
      lim = Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = (MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      iw1 = lim + 1
      iw2 = iw1 + lim
      iw3 = iw2 + labc
      iw4 = iw3 + labc
!
!     the length of wzvin is 2*lim+3*labc
!
      CALL ZVIN1(Ityp,Nlat,M,Zv,imid,I3,Wzvin,Wzvin(iw1),Wzvin(iw2),    &
               & Wzvin(iw3),Wzvin(iw4))
      END SUBROUTINE ZVIN


      SUBROUTINE ZVIN1(Ityp,Nlat,M,Zv,Imid,I3,Zvz,Zv1,A,B,C)
      IMPLICIT NONE
      REAL A , B , C , Zv , Zv1 , Zvz
      INTEGER i , i1 , i2 , I3 , ihold , Imid , Ityp , M , Nlat , np1 , &
            & ns , nstp , nstrt
      DIMENSION Zv(Imid,Nlat,3) , Zvz(Imid,1) , Zv1(Imid,1) , A(1) ,    &
              & B(1) , C(1)
      SAVE i1 , i2
      ihold = i1
      i1 = i2
      i2 = I3
      I3 = ihold
      IF ( M<1 ) THEN
         i1 = 1
         i2 = 2
         I3 = 3
         DO np1 = 1 , Nlat
            DO i = 1 , Imid
               Zv(i,np1,I3) = Zvz(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSEIF ( M==1 ) THEN
         DO np1 = 2 , Nlat
            DO i = 1 , Imid
               Zv(i,np1,I3) = Zv1(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSE
         ns = ((M-2)*(Nlat+Nlat-M-1))/2 + 1
         IF ( Ityp/=1 ) THEN
            DO i = 1 , Imid
               Zv(i,M+1,I3) = A(ns)*Zv(i,M-1,i1) - C(ns)*Zv(i,M+1,i1)
            ENDDO
         ENDIF
         IF ( M==Nlat-1 ) RETURN
         IF ( Ityp/=2 ) THEN
            ns = ns + 1
            DO i = 1 , Imid
               Zv(i,M+2,I3) = A(ns)*Zv(i,M,i1) - C(ns)*Zv(i,M+2,i1)
            ENDDO
         ENDIF
         nstrt = M + 3
         IF ( Ityp==1 ) nstrt = M + 4
         IF ( nstrt<=Nlat ) THEN
            nstp = 2
            IF ( Ityp==0 ) nstp = 1
            DO np1 = nstrt , Nlat , nstp
               ns = ns + nstp
               DO i = 1 , Imid
                  Zv(i,np1,I3) = A(ns)*Zv(i,np1-2,i1) + B(ns)           &
                               & *Zv(i,np1-2,I3) - C(ns)*Zv(i,np1,i1)
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      END SUBROUTINE ZVIN1


      SUBROUTINE ZWIN(Ityp,Nlat,Nlon,M,Zw,I3,Wzwin)
      IMPLICIT NONE
      INTEGER I3 , imid , Ityp , iw1 , iw2 , iw3 , iw4 , labc , lim ,   &
            & M , mmax , Nlat , Nlon
      REAL Wzwin , Zw
      DIMENSION Zw(1) , Wzwin(1)
      imid = (Nlat+1)/2
      lim = Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = (MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      iw1 = lim + 1
      iw2 = iw1 + lim
      iw3 = iw2 + labc
      iw4 = iw3 + labc
!
!     the length of wzwin is 2*lim+3*labc
!
      CALL ZWIN1(Ityp,Nlat,M,Zw,imid,I3,Wzwin,Wzwin(iw1),Wzwin(iw2),    &
               & Wzwin(iw3),Wzwin(iw4))
      END SUBROUTINE ZWIN


      SUBROUTINE ZWIN1(Ityp,Nlat,M,Zw,Imid,I3,Zw1,Zw2,A,B,C)
      IMPLICIT NONE
      REAL A , B , C , Zw , Zw1 , Zw2
      INTEGER i , i1 , i2 , I3 , ihold , Imid , Ityp , M , Nlat , np1 , &
            & ns , nstp , nstrt
      DIMENSION Zw(Imid,Nlat,3) , Zw1(Imid,1) , Zw2(Imid,1) , A(1) ,    &
              & B(1) , C(1)
      SAVE i1 , i2
      ihold = i1
      i1 = i2
      i2 = I3
      I3 = ihold
      IF ( M<2 ) THEN
         i1 = 1
         i2 = 2
         I3 = 3
         DO np1 = 2 , Nlat
            DO i = 1 , Imid
               Zw(i,np1,I3) = Zw1(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSEIF ( M==2 ) THEN
         DO np1 = 3 , Nlat
            DO i = 1 , Imid
               Zw(i,np1,I3) = Zw2(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSE
         ns = ((M-2)*(Nlat+Nlat-M-1))/2 + 1
         IF ( Ityp/=1 ) THEN
            DO i = 1 , Imid
               Zw(i,M+1,I3) = A(ns)*Zw(i,M-1,i1) - C(ns)*Zw(i,M+1,i1)
            ENDDO
         ENDIF
         IF ( M==Nlat-1 ) RETURN
         IF ( Ityp/=2 ) THEN
            ns = ns + 1
            DO i = 1 , Imid
               Zw(i,M+2,I3) = A(ns)*Zw(i,M,i1) - C(ns)*Zw(i,M+2,i1)
            ENDDO
         ENDIF
         nstrt = M + 3
         IF ( Ityp==1 ) nstrt = M + 4
         IF ( nstrt<=Nlat ) THEN
            nstp = 2
            IF ( Ityp==0 ) nstp = 1
            DO np1 = nstrt , Nlat , nstp
               ns = ns + nstp
               DO i = 1 , Imid
                  Zw(i,np1,I3) = A(ns)*Zw(i,np1-2,i1) + B(ns)           &
                               & *Zw(i,np1-2,I3) - C(ns)*Zw(i,np1,i1)
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      END  SUBROUTINE ZWIN1


      SUBROUTINE VBINIT(Nlat,Nlon,Wvbin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      REAL Wvbin
      DIMENSION Wvbin(1)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of dwork is 2*nlat+2
!
      CALL VBINI1(Nlat,Nlon,imid,Wvbin,Wvbin(iw1),Dwork,Dwork(Nlat+2))
      END SUBROUTINE VBINIT


      SUBROUTINE VBINI1(Nlat,Nlon,Imid,Vb,Abc,Cvb,Work)
      IMPLICIT NONE
      REAL Abc , Vb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     cvb and work must each have nlat+1 locations
!
      DIMENSION Vb(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION pi , dt , Cvb(1) , th , vbh , Work(1)
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      mdo = MIN0(2,Nlat,(Nlon+1)/2)
      DO mp1 = 1 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DVBK(m,n,Cvb,Work)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DVBT(m,n,th,Cvb,vbh)
               Vb(i,np1,mp1) = vbh
            ENDDO
         ENDDO
      ENDDO
      CALL RABCV(Nlat,Nlon,Abc)
      END SUBROUTINE VBINI1


      SUBROUTINE WBINIT(Nlat,Nlon,Wwbin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      REAL Wwbin
      DIMENSION Wwbin(1)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of dwork is 2*nlat+2
!
      CALL WBINI1(Nlat,Nlon,imid,Wwbin,Wwbin(iw1),Dwork,Dwork(Nlat+2))
      END SUBROUTINE WBINIT

      
      SUBROUTINE WBINI1(Nlat,Nlon,Imid,Wb,Abc,Cwb,Work)
      IMPLICIT NONE
      REAL Abc , Wb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     cwb and work must each have nlat+1 locations
!
      DIMENSION Wb(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION pi , dt , Cwb(1) , wbh , th , Work(1)
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      mdo = MIN0(3,Nlat,(Nlon+1)/2)
      IF ( mdo<2 ) RETURN
      DO mp1 = 2 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DWBK(m,n,Cwb,Work)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DWBT(m,n,th,Cwb,wbh)
               Wb(i,np1,m) = wbh
            ENDDO
         ENDDO
      ENDDO
      CALL RABCW(Nlat,Nlon,Abc)
      END SUBROUTINE WBINI1


      SUBROUTINE VBIN(Ityp,Nlat,Nlon,M,Vb,I3,Wvbin)
      IMPLICIT NONE
      INTEGER I3 , imid , Ityp , iw1 , iw2 , iw3 , iw4 , labc , lim ,   &
            & M , mmax , Nlat , Nlon
      REAL Vb , Wvbin
      DIMENSION Vb(1) , Wvbin(1)
      imid = (Nlat+1)/2
      lim = Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = (MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      iw1 = lim + 1
      iw2 = iw1 + lim
      iw3 = iw2 + labc
      iw4 = iw3 + labc
!
!     the length of wvbin is 2*lim+3*labc
!
      CALL VBIN1(Ityp,Nlat,M,Vb,imid,I3,Wvbin,Wvbin(iw1),Wvbin(iw2),    &
               & Wvbin(iw3),Wvbin(iw4))
      END SUBROUTINE VBIN


      SUBROUTINE VBIN1(Ityp,Nlat,M,Vb,Imid,I3,Vbz,Vb1,A,B,C)
      IMPLICIT NONE
      REAL A , B , C , Vb , Vb1 , Vbz
      INTEGER i , i1 , i2 , I3 , ihold , Imid , Ityp , M , Nlat , np1 , &
            & ns , nstp , nstrt
      DIMENSION Vb(Imid,Nlat,3) , Vbz(Imid,1) , Vb1(Imid,1) , A(1) ,    &
              & B(1) , C(1)
      SAVE i1 , i2
      ihold = i1
      i1 = i2
      i2 = I3
      I3 = ihold
      IF ( M<1 ) THEN
         i1 = 1
         i2 = 2
         I3 = 3
         DO np1 = 1 , Nlat
            DO i = 1 , Imid
               Vb(i,np1,I3) = Vbz(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSEIF ( M==1 ) THEN
         DO np1 = 2 , Nlat
            DO i = 1 , Imid
               Vb(i,np1,I3) = Vb1(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSE
         ns = ((M-2)*(Nlat+Nlat-M-1))/2 + 1
         IF ( Ityp/=1 ) THEN
            DO i = 1 , Imid
               Vb(i,M+1,I3) = A(ns)*Vb(i,M-1,i1) - C(ns)*Vb(i,M+1,i1)
            ENDDO
         ENDIF
         IF ( M==Nlat-1 ) RETURN
         IF ( Ityp/=2 ) THEN
            ns = ns + 1
            DO i = 1 , Imid
               Vb(i,M+2,I3) = A(ns)*Vb(i,M,i1) - C(ns)*Vb(i,M+2,i1)
            ENDDO
         ENDIF
         nstrt = M + 3
         IF ( Ityp==1 ) nstrt = M + 4
         IF ( nstrt<=Nlat ) THEN
            nstp = 2
            IF ( Ityp==0 ) nstp = 1
            DO np1 = nstrt , Nlat , nstp
               ns = ns + nstp
               DO i = 1 , Imid
                  Vb(i,np1,I3) = A(ns)*Vb(i,np1-2,i1) + B(ns)           &
                               & *Vb(i,np1-2,I3) - C(ns)*Vb(i,np1,i1)
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      END SUBROUTINE VBIN1


      SUBROUTINE WBIN(Ityp,Nlat,Nlon,M,Wb,I3,Wwbin)
      IMPLICIT NONE
      INTEGER I3 , imid , Ityp , iw1 , iw2 , iw3 , iw4 , labc , lim ,   &
            & M , mmax , Nlat , Nlon
      REAL Wb , Wwbin
      DIMENSION Wb(1) , Wwbin(1)
      imid = (Nlat+1)/2
      lim = Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = (MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      iw1 = lim + 1
      iw2 = iw1 + lim
      iw3 = iw2 + labc
      iw4 = iw3 + labc
!
!     the length of wwbin is 2*lim+3*labc
!
      CALL WBIN1(Ityp,Nlat,M,Wb,imid,I3,Wwbin,Wwbin(iw1),Wwbin(iw2),    &
               & Wwbin(iw3),Wwbin(iw4))
      END SUBROUTINE WBIN

      
      SUBROUTINE WBIN1(Ityp,Nlat,M,Wb,Imid,I3,Wb1,Wb2,A,B,C)
      IMPLICIT NONE
      REAL A , B , C , Wb , Wb1 , Wb2
      INTEGER i , i1 , i2 , I3 , ihold , Imid , Ityp , M , Nlat , np1 , &
            & ns , nstp , nstrt
      DIMENSION Wb(Imid,Nlat,3) , Wb1(Imid,1) , Wb2(Imid,1) , A(1) ,    &
              & B(1) , C(1)
      SAVE i1 , i2
      ihold = i1
      i1 = i2
      i2 = I3
      I3 = ihold
      IF ( M<2 ) THEN
         i1 = 1
         i2 = 2
         I3 = 3
         DO np1 = 2 , Nlat
            DO i = 1 , Imid
               Wb(i,np1,I3) = Wb1(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSEIF ( M==2 ) THEN
         DO np1 = 3 , Nlat
            DO i = 1 , Imid
               Wb(i,np1,I3) = Wb2(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSE
         ns = ((M-2)*(Nlat+Nlat-M-1))/2 + 1
         IF ( Ityp/=1 ) THEN
            DO i = 1 , Imid
               Wb(i,M+1,I3) = A(ns)*Wb(i,M-1,i1) - C(ns)*Wb(i,M+1,i1)
            ENDDO
         ENDIF
         IF ( M==Nlat-1 ) RETURN
         IF ( Ityp/=2 ) THEN
            ns = ns + 1
            DO i = 1 , Imid
               Wb(i,M+2,I3) = A(ns)*Wb(i,M,i1) - C(ns)*Wb(i,M+2,i1)
            ENDDO
         ENDIF
         nstrt = M + 3
         IF ( Ityp==1 ) nstrt = M + 4
         IF ( nstrt<=Nlat ) THEN
            nstp = 2
            IF ( Ityp==0 ) nstp = 1
            DO np1 = nstrt , Nlat , nstp
               ns = ns + nstp
               DO i = 1 , Imid
                  Wb(i,np1,I3) = A(ns)*Wb(i,np1-2,i1) + B(ns)           &
                               & *Wb(i,np1-2,I3) - C(ns)*Wb(i,np1,i1)
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      END SUBROUTINE WBIN1


      SUBROUTINE DZVK(Nlat,M,N,Czv,Work)
      IMPLICIT NONE
      INTEGER i , id , k , kdo , lc , M , mmod , N , Nlat , nmod
!
!     subroutine dzvk computes the coefficients in the trigonometric
!     expansion of the quadrature function zvbar(n,m,theta)
!
!     input parameters
!
!     nlat      the number of colatitudes including the poles.
!
!     n      the degree (subscript) of wbarv(n,m,theta)
!
!     m      the order (superscript) of wbarv(n,m,theta)
!
!     work   a work array with at least (nlat+1)/2 locations
!
!     output parameter
!
!     czv     the fourier coefficients of zvbar(n,m,theta).
!
      DIMENSION Czv(1) , Work(1)
      DOUBLE PRECISION Czv , sc1 , sum , Work , t1 , t2
      IF ( N<=0 ) RETURN
      lc = (Nlat+1)/2
      sc1 = 2.D0/FLOAT(Nlat-1)
      CALL DVBK(M,N,Work,Czv)
      nmod = MOD(N,2)
      mmod = MOD(M,2)
      IF ( nmod/=0 ) THEN
         IF ( mmod/=0 ) THEN
!
!     n odd, m odd
!
            kdo = (N+1)/2
            DO id = 1 , lc
               i = id + id - 1
               sum = 0.
               DO k = 1 , kdo
                  t1 = 1.D0 - (k+k-1+i)**2
                  t2 = 1.D0 - (k+k-1-i)**2
                  sum = sum + Work(k)*(t1+t2)/(t1*t2)
               ENDDO
               Czv(id) = sc1*sum
            ENDDO
            GOTO 99999
         ENDIF
      ELSEIF ( mmod/=0 ) THEN
!
!     n even, m odd
!
         kdo = N/2
         DO id = 1 , lc
            i = id + id - 2
            sum = 0.
            DO k = 1 , kdo
               t1 = 1.D0 - (k+k+i)**2
               t2 = 1.D0 - (k+k-i)**2
               sum = sum + Work(k)*(t1+t2)/(t1*t2)
            ENDDO
            Czv(id) = sc1*sum
         ENDDO
         RETURN
      ELSE
!
!     n even, m even
!
         kdo = N/2
         DO id = 1 , lc
            i = id + id - 2
            sum = 0.
            DO k = 1 , kdo
               t1 = 1.D0 - (k+k+i)**2
               t2 = 1.D0 - (k+k-i)**2
               sum = sum + Work(k)*(t1-t2)/(t1*t2)
            ENDDO
            Czv(id) = sc1*sum
         ENDDO
         RETURN
      ENDIF
!
!     n odd, m even
!
      kdo = (N+1)/2
      DO id = 1 , lc
         i = id + id - 3
         sum = 0.
         DO k = 1 , kdo
            t1 = 1.D0 - (k+k-1+i)**2
            t2 = 1.D0 - (k+k-1-i)**2
            sum = sum + Work(k)*(t1-t2)/(t1*t2)
         ENDDO
         Czv(id) = sc1*sum
      ENDDO
      RETURN
99999 END SUBROUTINE DZVK


      SUBROUTINE DZVT(Nlat,M,N,Th,Czv,Zvh)
      IMPLICIT NONE
      INTEGER k , lc , lmod , lq , ls , M , mmod , N , Nlat , nmod
!
!     subroutine dzvt tabulates the function zvbar(n,m,theta)
!     at theta = th in double precision
!
!     input parameters
!
!     nlat      the number of colatitudes including the poles.
!
!     n      the degree (subscript) of zvbar(n,m,theta)
!
!     m      the order (superscript) of zvbar(n,m,theta)
!
!     czv     the fourier coefficients of zvbar(n,m,theta)
!             as computed by subroutine zwk.
!
!     output parameter
!
!     zvh     zvbar(m,n,theta) evaluated at theta = th
!
      DIMENSION Czv(1)
      DOUBLE PRECISION Th , Czv , Zvh , cth , sth , cdt , sdt , chh
      Zvh = 0.
      IF ( N<=0 ) RETURN
      lc = (Nlat+1)/2
      lq = lc - 1
      ls = lc - 2
      cth = DCOS(Th)
      sth = DSIN(Th)
      cdt = cth*cth - sth*sth
      sdt = 2.*sth*cth
      lmod = MOD(Nlat,2)
      mmod = MOD(M,2)
      nmod = MOD(N,2)
      IF ( lmod==0 ) THEN
         IF ( nmod==0 ) THEN
            cth = cdt
            sth = sdt
            IF ( mmod/=0 ) THEN
!
!     nlat even  n even  m odd
!
               Zvh = .5*Czv(1)
               DO k = 2 , lc
                  Zvh = Zvh + Czv(k)*cth
                  chh = cdt*cth - sdt*sth
                  sth = sdt*cth + cdt*sth
                  cth = chh
               ENDDO
               RETURN
            ELSE
!
!     nlat even  n even  m even
!
               DO k = 1 , lq
                  Zvh = Zvh + Czv(k+1)*sth
                  chh = cdt*cth - sdt*sth
                  sth = sdt*cth + cdt*sth
                  cth = chh
               ENDDO
               RETURN
            ENDIF
         ELSEIF ( mmod/=0 ) THEN
!
!     nlat even  n odd  m odd
!
            Zvh = .5*Czv(lc)*DCOS((Nlat-1)*Th)
            DO k = 1 , lq
               Zvh = Zvh + Czv(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            GOTO 99999
         ENDIF
      ELSEIF ( nmod/=0 ) THEN
         IF ( mmod/=0 ) THEN
!
!     nlat odd  n odd  m odd
!
            DO k = 1 , lq
               Zvh = Zvh + Czv(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ELSE
!
!     nlat odd  n odd  m even
!
            DO k = 1 , lq
               Zvh = Zvh + Czv(k+1)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ELSE
         cth = cdt
         sth = sdt
         IF ( mmod/=0 ) THEN
!
!     nlat odd  n even  m odd
!
            Zvh = .5*Czv(1)
            DO k = 2 , lq
               Zvh = Zvh + Czv(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            Zvh = Zvh + .5*Czv(lc)*DCOS((Nlat-1)*Th)
            RETURN
         ELSE
!
!     nlat odd  n even  m even
!
            DO k = 1 , ls
               Zvh = Zvh + Czv(k+1)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ENDIF
!
!     nlat even  n odd  m even
!
      DO k = 1 , lq
         Zvh = Zvh + Czv(k+1)*sth
         chh = cdt*cth - sdt*sth
         sth = sdt*cth + cdt*sth
         cth = chh
      ENDDO
      RETURN
99999 END SUBROUTINE DZVT

      
      SUBROUTINE DZWK(Nlat,M,N,Czw,Work)
      IMPLICIT NONE
      INTEGER i , id , k , kdo , kp1 , lc , M , mmod , N , Nlat , nmod
!
!     subroutine dzwk computes the coefficients in the trigonometric
!     expansion of the quadrature function zwbar(n,m,theta)
!
!     input parameters
!
!     nlat      the number of colatitudes including the poles.
!
!     n      the degree (subscript) of zwbar(n,m,theta)
!
!     m      the order (superscript) of zwbar(n,m,theta)
!
!     work   a work array with at least (nlat+1)/2 locations
!
!     output parameter
!
!     czw     the fourier coefficients of zwbar(n,m,theta).
!
      DIMENSION Czw(1) , Work(1)
      DOUBLE PRECISION Czw , Work , sc1 , sum , t1 , t2
      IF ( N<=0 ) RETURN
      lc = (Nlat+1)/2
      sc1 = 2.D0/FLOAT(Nlat-1)
      CALL DWBK(M,N,Work,Czw)
      nmod = MOD(N,2)
      mmod = MOD(M,2)
      IF ( nmod/=0 ) THEN
         IF ( mmod/=0 ) THEN
!
!     n odd, m odd
!
            kdo = (N+1)/2
            DO id = 1 , lc
               i = id + id - 2
               sum = Work(1)/(1.D0-i*i)
               IF ( kdo>=2 ) THEN
                  DO kp1 = 2 , kdo
                     k = kp1 - 1
                     t1 = 1.D0 - (k+k+i)**2
                     t2 = 1.D0 - (k+k-i)**2
                     sum = sum + Work(kp1)*(t1+t2)/(t1*t2)
                  ENDDO
               ENDIF
               Czw(id) = sc1*sum
            ENDDO
            GOTO 99999
         ENDIF
      ELSEIF ( mmod/=0 ) THEN
!
!     n even, m odd
!
         kdo = N/2
         DO id = 1 , lc
            i = id + id - 1
            sum = 0.
            DO k = 1 , kdo
               t1 = 1.D0 - (k+k-1+i)**2
               t2 = 1.D0 - (k+k-1-i)**2
               sum = sum + Work(k)*(t1+t2)/(t1*t2)
            ENDDO
            Czw(id) = sc1*sum
         ENDDO
         RETURN
      ELSE
!
!     n even, m even
!
         kdo = N/2
         DO id = 1 , lc
            i = id + id - 3
            sum = 0.
            DO k = 1 , kdo
               t1 = 1.D0 - (k+k-1+i)**2
               t2 = 1.D0 - (k+k-1-i)**2
               sum = sum + Work(k)*(t1-t2)/(t1*t2)
            ENDDO
            Czw(id) = sc1*sum
         ENDDO
         RETURN
      ENDIF
!
!     n odd, m even
!
      kdo = (N-1)/2
      DO id = 1 , lc
         i = id + id - 2
         sum = 0.
         DO k = 1 , kdo
            t1 = 1.D0 - (k+k+i)**2
            t2 = 1.D0 - (k+k-i)**2
            sum = sum + Work(k)*(t1-t2)/(t1*t2)
         ENDDO
         Czw(id) = sc1*sum
      ENDDO
      RETURN
99999 END SUBROUTINE DZWK


      SUBROUTINE DZWT(Nlat,M,N,Th,Czw,Zwh)
      IMPLICIT NONE
      INTEGER k , lc , lmod , lq , ls , M , mmod , N , Nlat , nmod
!
!     subroutine dzwt tabulates the function zwbar(n,m,theta)
!     at theta = th in double precision
!
!     input parameters
!
!     nlat      the number of colatitudes including the poles.
!            nlat must be an odd integer
!
!     n      the degree (subscript) of zwbar(n,m,theta)
!
!     m      the order (superscript) of zwbar(n,m,theta)
!
!     czw     the fourier coefficients of zwbar(n,m,theta)
!             as computed by subroutine zwk.
!
!     output parameter
!
!     zwh     zwbar(m,n,theta) evaluated at theta = th
!
      DIMENSION Czw(1)
      DOUBLE PRECISION Czw , Zwh , Th , cth , sth , cdt , sdt , chh
      Zwh = 0.
      IF ( N<=0 ) RETURN
      lc = (Nlat+1)/2
      lq = lc - 1
      ls = lc - 2
      cth = DCOS(Th)
      sth = DSIN(Th)
      cdt = cth*cth - sth*sth
      sdt = 2.*sth*cth
      lmod = MOD(Nlat,2)
      mmod = MOD(M,2)
      nmod = MOD(N,2)
      IF ( lmod==0 ) THEN
         IF ( nmod/=0 ) THEN
            cth = cdt
            sth = sdt
            IF ( mmod/=0 ) THEN
!
!     nlat even  n odd  m odd
!
               Zwh = .5*Czw(1)
               DO k = 2 , lc
                  Zwh = Zwh + Czw(k)*cth
                  chh = cdt*cth - sdt*sth
                  sth = sdt*cth + cdt*sth
                  cth = chh
               ENDDO
               GOTO 99999
            ENDIF
         ELSEIF ( mmod/=0 ) THEN
!
!     nlat even  n even  m odd
!
            Zwh = .5*Czw(lc)*DCOS((Nlat-1)*Th)
            DO k = 1 , lq
               Zwh = Zwh + Czw(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ELSE
!
!     nlat even  n even  m even
!
            DO k = 1 , lq
               Zwh = Zwh + Czw(k+1)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ELSEIF ( nmod/=0 ) THEN
         cth = cdt
         sth = sdt
         IF ( mmod/=0 ) THEN
!
!     nlat odd  n odd  m odd
!
            Zwh = .5*Czw(1)
            DO k = 2 , lq
               Zwh = Zwh + Czw(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            Zwh = Zwh + .5*Czw(lc)*DCOS((Nlat-1)*Th)
            RETURN
         ELSE
!
!     nlat odd  n odd  m even
!
            DO k = 1 , ls
               Zwh = Zwh + Czw(k+1)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ELSEIF ( mmod/=0 ) THEN
!
!     nlat odd  n even  m odd
!
         DO k = 1 , lq
            Zwh = Zwh + Czw(k)*cth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         RETURN
      ELSE
!
!     nlat odd  n even  m even
!
         DO k = 1 , lq
            Zwh = Zwh + Czw(k+1)*sth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         RETURN
      ENDIF
!
!     nlat even  n odd  m even
!
      DO k = 1 , lq
         Zwh = Zwh + Czw(k+1)*sth
         chh = cdt*cth - sdt*sth
         sth = sdt*cth + cdt*sth
         cth = chh
      ENDDO
      RETURN
99999 END SUBROUTINE DZWT


      SUBROUTINE DVBK(M,N,Cv,Work)
      IMPLICIT NONE
      INTEGER l , M , modm , modn , N , ncv
      REAL srnp1
      DOUBLE PRECISION Cv(1) , Work(1) , fn , fk , cf
      Cv(1) = 0.
      IF ( N<=0 ) RETURN
      fn = N
      srnp1 = DSQRT(fn*(fn+1.))
      cf = 2.*M/srnp1
      modn = MOD(N,2)
      modm = MOD(M,2)
      CALL DNLFK(M,N,Work)
      IF ( modn/=0 ) THEN
         ncv = (N+1)/2
         fk = -1.
         IF ( modm/=0 ) THEN
!
!     n odd m odd
!
            DO l = 1 , ncv
               fk = fk + 2.
               Cv(l) = fk*Work(l)/srnp1
            ENDDO
            GOTO 99999
         ENDIF
      ELSE
         ncv = N/2
         IF ( ncv==0 ) RETURN
         fk = 0.
         IF ( modm/=0 ) THEN
!
!     n even m odd
!
            DO l = 1 , ncv
               fk = fk + 2.
               Cv(l) = fk*Work(l)/srnp1
            ENDDO
            RETURN
         ELSE
!
!     n even m even
!
            DO l = 1 , ncv
               fk = fk + 2.
               Cv(l) = -fk*Work(l+1)/srnp1
            ENDDO
            RETURN
         ENDIF
      ENDIF
!
!     n odd m even
!
      DO l = 1 , ncv
         fk = fk + 2.
         Cv(l) = -fk*Work(l)/srnp1
      ENDDO
      RETURN
99999 END SUBROUTINE DVBK


      SUBROUTINE DWBK(M,N,Cw,Work)
      IMPLICIT NONE
      INTEGER l , M , modm , modn , N
      DOUBLE PRECISION Cw(1) , Work(1) , fn , cf , srnp1
      Cw(1) = 0.
      IF ( N<=0 .OR. M<=0 ) RETURN
      fn = N
      srnp1 = DSQRT(fn*(fn+1.))
      cf = 2.*M/srnp1
      modn = MOD(N,2)
      modm = MOD(M,2)
      CALL DNLFK(M,N,Work)
      IF ( M/=0 ) THEN
         IF ( modn==0 ) THEN
            l = N/2
            IF ( l/=0 ) THEN
               IF ( modm/=0 ) THEN
!
!     n even m odd
!
                  Cw(l) = cf*Work(l)
 5                l = l - 1
                  IF ( l>0 ) THEN
                     Cw(l) = Cw(l+1) + cf*Work(l)
                     GOTO 5
                  ENDIF
               ELSE
!
!     n even m even
!
                  Cw(l) = -cf*Work(l+1)
 10               l = l - 1
                  IF ( l>0 ) THEN
                     Cw(l) = Cw(l+1) - cf*Work(l+1)
                     GOTO 10
                  ENDIF
               ENDIF
            ENDIF
         ELSEIF ( modm/=0 ) THEN
!
!     n odd m odd
!
            l = (N+1)/2
            Cw(l) = cf*Work(l)
 20         l = l - 1
            IF ( l>0 ) THEN
               Cw(l) = Cw(l+1) + cf*Work(l)
               GOTO 20
            ENDIF
         ELSE
            l = (N-1)/2
            IF ( l/=0 ) THEN
!
!     n odd m even
!
               Cw(l) = -cf*Work(l+1)
 30            l = l - 1
               IF ( l>0 ) THEN
                  Cw(l) = Cw(l+1) - cf*Work(l+1)
                  GOTO 30
               ENDIF
            ENDIF
         ENDIF
      ENDIF
      END SUBROUTINE DWBK


      SUBROUTINE DVBT(M,N,Theta,Cv,Vh)
      IMPLICIT NONE
      INTEGER k , M , mmod , N , ncv , nmod
      DIMENSION Cv(1)
      DOUBLE PRECISION Cv , Vh , Theta , cth , sth , cdt , sdt , chh
      Vh = 0.
      IF ( N==0 ) RETURN
      cth = DCOS(Theta)
      sth = DSIN(Theta)
      cdt = cth*cth - sth*sth
      sdt = 2.*sth*cth
      mmod = MOD(M,2)
      nmod = MOD(N,2)
      IF ( nmod==0 ) THEN
         cth = cdt
         sth = sdt
         IF ( mmod/=0 ) THEN
!
!     n even  m odd
!
            ncv = N/2
            DO k = 1 , ncv
               Vh = Vh + Cv(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ELSE
!
!     n even  m even
!
            ncv = N/2
            DO k = 1 , ncv
               Vh = Vh + Cv(k)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ELSEIF ( mmod/=0 ) THEN
!
! case m odd and n odd
!
         ncv = (N+1)/2
         DO k = 1 , ncv
            Vh = Vh + Cv(k)*cth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         GOTO 99999
      ENDIF
!
!     n odd m even
!
      ncv = (N+1)/2
      DO k = 1 , ncv
         Vh = Vh + Cv(k)*sth
         chh = cdt*cth - sdt*sth
         sth = sdt*cth + cdt*sth
         cth = chh
      ENDDO
      RETURN
99999 END SUBROUTINE DVBT


      SUBROUTINE DWBT(M,N,Theta,Cw,Wh)
      IMPLICIT NONE
      INTEGER k , M , mmod , N , ncw , nmod
      DIMENSION Cw(1)
      DOUBLE PRECISION Theta , Cw , Wh , cth , sth , cdt , sdt , chh
      Wh = 0.
      IF ( N<=0 .OR. M<=0 ) RETURN
      cth = DCOS(Theta)
      sth = DSIN(Theta)
      cdt = cth*cth - sth*sth
      sdt = 2.*sth*cth
      mmod = MOD(M,2)
      nmod = MOD(N,2)
      IF ( nmod/=0 ) THEN
         cth = cdt
         sth = sdt
         IF ( mmod/=0 ) THEN
!
! case m odd and n odd
!
            ncw = (N+1)/2
            Wh = .5*Cw(1)
            IF ( ncw<2 ) RETURN
            DO k = 2 , ncw
               Wh = Wh + Cw(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            GOTO 99999
         ENDIF
      ELSEIF ( mmod/=0 ) THEN
!
!     n even  m odd
!
         ncw = N/2
         DO k = 1 , ncw
            Wh = Wh + Cw(k)*cth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         RETURN
      ELSE
!
!     n even  m even
!
         ncw = N/2
         DO k = 1 , ncw
            Wh = Wh + Cw(k)*sth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         RETURN
      ENDIF
!
!     n odd m even
!
      ncw = (N-1)/2
      DO k = 1 , ncw
         Wh = Wh + Cw(k)*sth
         chh = cdt*cth - sdt*sth
         sth = sdt*cth + cdt*sth
         cth = chh
      ENDDO
      RETURN
99999 END SUBROUTINE DWBT


      SUBROUTINE RABCV(Nlat,Nlon,Abc)
      IMPLICIT NONE
      REAL Abc
      INTEGER iw1 , iw2 , labc , mmax , Nlat , Nlon
!
!     subroutine rabcp computes the coefficients in the recurrence
!     relation for the functions vbar(m,n,theta). array abc
!     must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2 locations.
!
      DIMENSION Abc(1)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = (MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      iw1 = labc + 1
      iw2 = iw1 + labc
      CALL RABCV1(Nlat,Nlon,Abc,Abc(iw1),Abc(iw2))
      END SUBROUTINE RABCV

      
      SUBROUTINE RABCV1(Nlat,Nlon,A,B,C)
      IMPLICIT NONE
      REAL A , B , C , cn , fm , fn , fnmm , fnpm , temp , tm , tn , tpn
      INTEGER m , mmax , mp1 , mp3 , n , Nlat , Nlon , np1 , ns
!
!     coefficients a, b, and c for computing vbar(m,n,theta) are
!     stored in location ((m-2)*(nlat+nlat-m-1))/2+n+1
!
      DIMENSION A(1) , B(1) , C(1)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( mmax<3 ) RETURN
      DO mp1 = 3 , mmax
         m = mp1 - 1
         ns = ((m-2)*(Nlat+Nlat-m-1))/2 + 1
         fm = FLOAT(m)
         tm = fm + fm
         temp = tm*(tm-1.)
         tpn = (fm-2.)*(fm-1.)/(fm*(fm+1.))
         A(ns) = SQRT(tpn*(tm+1.)*(tm-2.)/temp)
         C(ns) = SQRT(2./temp)
         IF ( m/=Nlat-1 ) THEN
            ns = ns + 1
            temp = tm*(tm+1.)
            tpn = (fm-1.)*fm/((fm+1.)*(fm+2.))
            A(ns) = SQRT(tpn*(tm+3.)*(tm-2.)/temp)
            C(ns) = SQRT(6./temp)
            mp3 = m + 3
            IF ( mp3<=Nlat ) THEN
               DO np1 = mp3 , Nlat
                  n = np1 - 1
                  ns = ns + 1
                  fn = FLOAT(n)
                  tn = fn + fn
                  cn = (tn+1.)/(tn-3.)
                  tpn = (fn-2.)*(fn-1.)/(fn*(fn+1.))
                  fnpm = fn + fm
                  fnmm = fn - fm
                  temp = fnpm*(fnpm-1.)
                  A(ns) = SQRT(tpn*cn*(fnpm-3.)*(fnpm-2.)/temp)
                  B(ns) = SQRT(tpn*cn*fnmm*(fnmm-1.)/temp)
                  C(ns) = SQRT((fnmm+1.)*(fnmm+2.)/temp)
               ENDDO
            ENDIF
         ENDIF
      ENDDO
      END SUBROUTINE RABCV1


      SUBROUTINE RABCW(Nlat,Nlon,Abc)
      IMPLICIT NONE
      REAL Abc
      INTEGER iw1 , iw2 , labc , mmax , Nlat , Nlon
!
!     subroutine rabcw computes the coefficients in the recurrence
!     relation for the functions wbar(m,n,theta). array abc
!     must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2 locations.
!
      DIMENSION Abc(1)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = (MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      iw1 = labc + 1
      iw2 = iw1 + labc
      CALL RABCW1(Nlat,Nlon,Abc,Abc(iw1),Abc(iw2))
      END SUBROUTINE RABCW


      SUBROUTINE RABCW1(Nlat,Nlon,A,B,C)
      IMPLICIT NONE
      REAL A , B , C , cn , fm , fn , fnmm , fnpm , temp , tm , tn ,    &
         & tph , tpn
      INTEGER m , mmax , mp1 , mp3 , n , Nlat , Nlon , np1 , ns
!*** End of declarations inserted by SPAG
!
!     coefficients a, b, and c for computing wbar(m,n,theta) are
!     stored in location ((m-2)*(nlat+nlat-m-1))/2+n+1
!
      DIMENSION A(1) , B(1) , C(1)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( mmax<4 ) RETURN
      DO mp1 = 4 , mmax
         m = mp1 - 1
         ns = ((m-2)*(Nlat+Nlat-m-1))/2 + 1
         fm = FLOAT(m)
         tm = fm + fm
         temp = tm*(tm-1.)
         tpn = (fm-2.)*(fm-1.)/(fm*(fm+1.))
         tph = fm/(fm-2.)
         A(ns) = tph*SQRT(tpn*(tm+1.)*(tm-2.)/temp)
         C(ns) = tph*SQRT(2./temp)
         IF ( m/=Nlat-1 ) THEN
            ns = ns + 1
            temp = tm*(tm+1.)
            tpn = (fm-1.)*fm/((fm+1.)*(fm+2.))
            tph = fm/(fm-2.)
            A(ns) = tph*SQRT(tpn*(tm+3.)*(tm-2.)/temp)
            C(ns) = tph*SQRT(6./temp)
            mp3 = m + 3
            IF ( mp3<=Nlat ) THEN
               DO np1 = mp3 , Nlat
                  n = np1 - 1
                  ns = ns + 1
                  fn = FLOAT(n)
                  tn = fn + fn
                  cn = (tn+1.)/(tn-3.)
                  fnpm = fn + fm
                  fnmm = fn - fm
                  temp = fnpm*(fnpm-1.)
                  tpn = (fn-2.)*(fn-1.)/(fn*(fn+1.))
                  tph = fm/(fm-2.)
                  A(ns) = tph*SQRT(tpn*cn*(fnpm-3.)*(fnpm-2.)/temp)
                  B(ns) = SQRT(tpn*cn*fnmm*(fnmm-1.)/temp)
                  C(ns) = tph*SQRT((fnmm+1.)*(fnmm+2.)/temp)
               ENDDO
            ENDIF
         ENDIF
      ENDDO
      END SUBROUTINE  RABCW1

      
      SUBROUTINE VTINIT(Nlat,Nlon,Wvbin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      REAL Wvbin
      DIMENSION Wvbin(*)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of dwork is 2*nlat+2
!
      CALL VTINI1(Nlat,Nlon,imid,Wvbin,Wvbin(iw1),Dwork,Dwork(Nlat+2))
      END SUBROUTINE VTINIT


      SUBROUTINE VTINI1(Nlat,Nlon,Imid,Vb,Abc,Cvb,Work)
      IMPLICIT NONE
      REAL Abc , Vb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     cvb and work must each have nlat+1 locations
!
      DIMENSION Vb(Imid,Nlat,2) , Abc(1) , Cvb(1)
      DOUBLE PRECISION pi , dt , Cvb , th , vbh , Work(*)
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      mdo = MIN0(2,Nlat,(Nlon+1)/2)
      DO mp1 = 1 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DVTK(m,n,Cvb,Work)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DVTT(m,n,th,Cvb,vbh)
               Vb(i,np1,mp1) = vbh
            ENDDO
         ENDDO
      ENDDO
      CALL RABCV(Nlat,Nlon,Abc)
      END SUBROUTINE VTINI1


      SUBROUTINE WTINIT(Nlat,Nlon,Wwbin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      REAL Wwbin
      DIMENSION Wwbin(1)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of dwork is 2*nlat+2
!
      CALL WTINI1(Nlat,Nlon,imid,Wwbin,Wwbin(iw1),Dwork,Dwork(Nlat+2))
      END SUBROUTINE WTINIT


      SUBROUTINE WTINI1(Nlat,Nlon,Imid,Wb,Abc,Cwb,Work)
      IMPLICIT NONE
      REAL Abc , Wb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     cwb and work must each have nlat+1 locations
!
      DIMENSION Wb(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION pi , dt , Cwb(*) , wbh , th , Work(*)
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      mdo = MIN0(3,Nlat,(Nlon+1)/2)
      IF ( mdo<2 ) RETURN
      DO mp1 = 2 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DWTK(m,n,Cwb,Work)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DWTT(m,n,th,Cwb,wbh)
               Wb(i,np1,m) = wbh
            ENDDO
         ENDDO
      ENDDO
      CALL RABCW(Nlat,Nlon,Abc)
      END SUBROUTINE WTINI1


      SUBROUTINE VTGINT(Nlat,Nlon,Theta,Wvbin,Work)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      REAL Wvbin
      DIMENSION Wvbin(*)
      DOUBLE PRECISION Theta(*) , Work(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     theta is a double precision array with (nlat+1)/2 locations
!     nlat is the maximum value of n+1
!     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of work is 2*nlat+2
!
      CALL VTGIT1(Nlat,Nlon,imid,Theta,Wvbin,Wvbin(iw1),Work,           &
                & Work(Nlat+2))
!    1                        work,work(2*nlat+3))
      END SUBROUTINE VTGINT


      SUBROUTINE VTGIT1(Nlat,Nlon,Imid,Theta,Vb,Abc,Cvb,Work)
      IMPLICIT NONE
      REAL Abc , Vb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     cvb and work must each have nlat+1   locations
!
      DIMENSION Vb(Imid,Nlat,2) , Abc(*)
      DOUBLE PRECISION Theta(*) , Cvb(*) , Work(*) , vbh
      mdo = MIN0(2,Nlat,(Nlon+1)/2)
      DO mp1 = 1 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DVTK(m,n,Cvb,Work)
            DO i = 1 , Imid
               CALL DVTT(m,n,Theta(i),Cvb,vbh)
               Vb(i,np1,mp1) = vbh
            ENDDO
         ENDDO
      ENDDO
      CALL RABCV(Nlat,Nlon,Abc)
    END SUBROUTINE VTGIT1


      SUBROUTINE WTGINT(Nlat,Nlon,Theta,Wwbin,Work)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      REAL Wwbin
      DIMENSION Wwbin(*)
      DOUBLE PRECISION Theta(*) , Work(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     theta is a double precision array with (nlat+1)/2 locations
!     nlat is the maximum value of n+1
!     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of work is 2*nlat+2
!
      CALL WTGIT1(Nlat,Nlon,imid,Theta,Wwbin,Wwbin(iw1),Work,           &
                & Work(Nlat+2))
      END SUBROUTINE WTGINT


      SUBROUTINE WTGIT1(Nlat,Nlon,Imid,Theta,Wb,Abc,Cwb,Work)
      IMPLICIT NONE
      REAL Abc , Wb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*((nlat-3)*nlat+2)/2 locations
!     cwb and work must each have nlat+1 locations
!
      DIMENSION Wb(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION Theta(*) , Cwb(*) , Work(*) , wbh
      mdo = MIN0(3,Nlat,(Nlon+1)/2)
      IF ( mdo<2 ) RETURN
      DO mp1 = 2 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DWTK(m,n,Cwb,Work)
            DO i = 1 , Imid
               CALL DWTT(m,n,Theta(i),Cwb,wbh)
               Wb(i,np1,m) = wbh
            ENDDO
         ENDDO
      ENDDO
      CALL RABCW(Nlat,Nlon,Abc)
      END SUBROUTINE WTGIT1


      SUBROUTINE DVTK(M,N,Cv,Work)
      IMPLICIT NONE
      INTEGER l , M , modm , modn , N , ncv
      DOUBLE PRECISION Cv(*) , Work(*) , fn , fk , cf , srnp1
      Cv(1) = 0.
      IF ( N<=0 ) RETURN
      fn = N
      srnp1 = DSQRT(fn*(fn+1.))
      cf = 2.*M/srnp1
      modn = MOD(N,2)
      modm = MOD(M,2)
      CALL DNLFK(M,N,Work)
      IF ( modn/=0 ) THEN
         ncv = (N+1)/2
         fk = -1.
         IF ( modm/=0 ) THEN
!
!     n odd m odd
!
            DO l = 1 , ncv
               fk = fk + 2.
               Cv(l) = -fk*fk*Work(l)/srnp1
            ENDDO
            GOTO 99999
         ENDIF
      ELSE
         ncv = N/2
         IF ( ncv==0 ) RETURN
         fk = 0.
         IF ( modm/=0 ) THEN
!
!     n even m odd
!
            DO l = 1 , ncv
               fk = fk + 2.
               Cv(l) = -fk*fk*Work(l)/srnp1
            ENDDO
            RETURN
         ELSE
!
!     n even m even
!
            DO l = 1 , ncv
               fk = fk + 2.
               Cv(l) = -fk*fk*Work(l+1)/srnp1
            ENDDO
            RETURN
         ENDIF
      ENDIF
!
!     n odd m even
!
      DO l = 1 , ncv
         fk = fk + 2.
         Cv(l) = -fk*fk*Work(l)/srnp1
      ENDDO
      RETURN
99999 END SUBROUTINE DVTK


      SUBROUTINE DWTK(M,N,Cw,Work)
      IMPLICIT NONE
      INTEGER l , M , modm , modn , N
      DOUBLE PRECISION Cw(*) , Work(*) , fn , cf , srnp1
      Cw(1) = 0.
      IF ( N<=0 .OR. M<=0 ) RETURN
      fn = N
      srnp1 = DSQRT(fn*(fn+1.))
      cf = 2.*M/srnp1
      modn = MOD(N,2)
      modm = MOD(M,2)
      CALL DNLFK(M,N,Work)
      IF ( M==0 ) GOTO 99999
      IF ( modn==0 ) THEN
         l = N/2
         IF ( l==0 ) GOTO 99999
         IF ( modm/=0 ) THEN
!
!     n even m odd
!
            Cw(l) = cf*Work(l)
         ELSE
!
!     n even m even
!
            Cw(l) = -cf*Work(l+1)
 20         l = l - 1
            IF ( l<=0 ) GOTO 99999
            Cw(l) = Cw(l+1) - cf*Work(l+1)
            Cw(l+1) = (l+l+1)*Cw(l+1)
            GOTO 20
         ENDIF
      ELSEIF ( modm/=0 ) THEN
!
!     n odd m odd
!
         l = (N+1)/2
         Cw(l) = cf*Work(l)
         GOTO 300
      ELSE
         l = (N-1)/2
         IF ( l==0 ) GOTO 99999
!
!     n odd m even
!
         Cw(l) = -cf*Work(l+1)
         GOTO 200
      ENDIF
 100  l = l - 1
      IF ( l<0 ) GOTO 99999
      IF ( l/=0 ) Cw(l) = Cw(l+1) + cf*Work(l)
      Cw(l+1) = -(l+l+1)*Cw(l+1)
      GOTO 100
 200  l = l - 1
      IF ( l<0 ) GOTO 99999
      IF ( l/=0 ) Cw(l) = Cw(l+1) - cf*Work(l+1)
      Cw(l+1) = (l+l+2)*Cw(l+1)
      GOTO 200
 300  l = l - 1
      IF ( l<0 ) GOTO 99999
      IF ( l/=0 ) Cw(l) = Cw(l+1) + cf*Work(l)
      Cw(l+1) = -(l+l)*Cw(l+1)
      GOTO 300
99999 END


      SUBROUTINE DVTT(M,N,Theta,Cv,Vh)
      IMPLICIT NONE
      INTEGER k , M , mmod , N , ncv , nmod
      DIMENSION Cv(1)
      DOUBLE PRECISION Cv , Vh , Theta , cth , sth , cdt , sdt , chh
      Vh = 0.
      IF ( N==0 ) RETURN
      cth = DCOS(Theta)
      sth = DSIN(Theta)
      cdt = cth*cth - sth*sth
      sdt = 2.*sth*cth
      mmod = MOD(M,2)
      nmod = MOD(N,2)
      IF ( nmod==0 ) THEN
         cth = cdt
         sth = sdt
         IF ( mmod/=0 ) THEN
!
!     n even  m odd
!
            ncv = N/2
            DO k = 1 , ncv
               Vh = Vh + Cv(k)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ELSE
!
!     n even  m even
!
            ncv = N/2
            DO k = 1 , ncv
               Vh = Vh + Cv(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ELSEIF ( mmod/=0 ) THEN
!
! case m odd and n odd
!
         ncv = (N+1)/2
         DO k = 1 , ncv
            Vh = Vh + Cv(k)*sth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         GOTO 99999
      ENDIF
!
!     n odd m even
!
      ncv = (N+1)/2
      DO k = 1 , ncv
         Vh = Vh + Cv(k)*cth
         chh = cdt*cth - sdt*sth
         sth = sdt*cth + cdt*sth
         cth = chh
      ENDDO
      RETURN
99999 END SUBROUTINE DVTT


      SUBROUTINE DWTT(M,N,Theta,Cw,Wh)
      IMPLICIT NONE
      INTEGER k , M , mmod , N , ncw , nmod
      DIMENSION Cw(1)
      DOUBLE PRECISION Theta , Cw , Wh , cth , sth , cdt , sdt , chh
      Wh = 0.
      IF ( N<=0 .OR. M<=0 ) RETURN
      cth = DCOS(Theta)
      sth = DSIN(Theta)
      cdt = cth*cth - sth*sth
      sdt = 2.*sth*cth
      mmod = MOD(M,2)
      nmod = MOD(N,2)
      IF ( nmod/=0 ) THEN
         cth = cdt
         sth = sdt
         IF ( mmod/=0 ) THEN
!
! case m odd and n odd
!
            ncw = (N+1)/2
            Wh = 0.
            IF ( ncw<2 ) RETURN
            DO k = 2 , ncw
               Wh = Wh + Cw(k)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            GOTO 99999
         ENDIF
      ELSEIF ( mmod/=0 ) THEN
!
!     n even  m odd
!
         ncw = N/2
         DO k = 1 , ncw
            Wh = Wh + Cw(k)*sth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         RETURN
      ELSE
!
!     n even  m even
!
         ncw = N/2
         DO k = 1 , ncw
            Wh = Wh + Cw(k)*cth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         RETURN
      ENDIF
!
!     n odd m even
!
      ncw = (N-1)/2
      DO k = 1 , ncw
         Wh = Wh + Cw(k)*cth
         chh = cdt*cth - sdt*sth
         sth = sdt*cth + cdt*sth
         cth = chh
      ENDDO
      RETURN
99999 END SUBROUTINE DWTT


      SUBROUTINE VBGINT(Nlat,Nlon,Theta,Wvbin,Work)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      REAL Wvbin
      DIMENSION Wvbin(1)
      DOUBLE PRECISION Theta(*) , Work(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     theta is a double precision array with (nlat+1)/2 locations
!     nlat is the maximum value of n+1
!     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of work is 2*nlat+2
!
      CALL VBGIT1(Nlat,Nlon,imid,Theta,Wvbin,Wvbin(iw1),Work,           &
                & Work(Nlat+2))
!    1                        work,work(2*nlat+3))
      END


      SUBROUTINE VBGIT1(Nlat,Nlon,Imid,Theta,Vb,Abc,Cvb,Work)
      IMPLICIT NONE
      REAL Abc , Vb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     cvb and work must each have nlat+1 locations
!
      DIMENSION Vb(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION Cvb(1) , Theta(1) , vbh , Work(1)
      mdo = MIN0(2,Nlat,(Nlon+1)/2)
      DO mp1 = 1 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DVBK(m,n,Cvb,Work)
            DO i = 1 , Imid
               CALL DVBT(m,n,Theta(i),Cvb,vbh)
               Vb(i,np1,mp1) = vbh
            ENDDO
         ENDDO
      ENDDO
      CALL RABCV(Nlat,Nlon,Abc)
      END SUBROUTINE VBGIT1


      SUBROUTINE WBGINT(Nlat,Nlon,Theta,Wwbin,Work)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      REAL Wwbin
      DIMENSION Wwbin(1)
      DOUBLE PRECISION Work(*) , Theta(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     theta is a double precision array with (nlat+1)/2 locations
!     nlat is the maximum value of n+1
!     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of work is 2*nlat+2
!
      CALL WBGIT1(Nlat,Nlon,imid,Theta,Wwbin,Wwbin(iw1),Work,           &
                & Work(Nlat+2))
      END

      
      SUBROUTINE WBGIT1(Nlat,Nlon,Imid,Theta,Wb,Abc,Cwb,Work)
      IMPLICIT NONE
      REAL Abc , Wb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*((nlat-3)*nlat+2)/2 locations
!     cwb and work must each have nlat+1 locations
!
      DIMENSION Wb(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION Cwb(1) , Theta(1) , wbh , Work(1)
      mdo = MIN0(3,Nlat,(Nlon+1)/2)
      IF ( mdo<2 ) RETURN
      DO mp1 = 2 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DWBK(m,n,Cwb,Work)
            DO i = 1 , Imid
               CALL DWBT(m,n,Theta(i),Cwb,wbh)
               Wb(i,np1,m) = wbh
            ENDDO
         ENDDO
      ENDDO
      CALL RABCW(Nlat,Nlon,Abc)
    END SUBROUTINE WBGIT1


    SUBROUTINE DDNLFK(M,N,Cp)
      IMPLICIT NONE
      INTEGER i , l , M , ma , N , nex , nmms2
!
      DOUBLE PRECISION Cp , fnum , fden , fnmh , a1 , b1 , c1 , cp2 ,   &
                     & fnnp1 , fnmsq , fk , t1 , t2 , pm1 , SC10 ,      &
                     & SC20 , SC40
      DIMENSION Cp(1)
      PARAMETER (SC10=1024.D0)
      PARAMETER (SC20=SC10*SC10)
      PARAMETER (SC40=SC20*SC20)
!
      Cp(1) = 0.
      ma = IABS(M)
      IF ( ma>N ) RETURN
      IF ( N<1 ) THEN
         Cp(1) = DSQRT(2.D0)
         RETURN
      ELSEIF ( N==1 ) THEN
         IF ( ma/=0 ) THEN
            Cp(1) = DSQRT(.75D0)
            IF ( M==-1 ) Cp(1) = -Cp(1)
            RETURN
         ELSE
            Cp(1) = DSQRT(1.5D0)
            RETURN
         ENDIF
      ELSE
         IF ( MOD(N+ma,2)/=0 ) THEN
            nmms2 = (N-ma-1)/2
            fnum = N + ma + 2
            fnmh = N - ma + 2
            pm1 = -1.D0
         ELSE
            nmms2 = (N-ma)/2
            fnum = N + ma + 1
            fnmh = N - ma + 1
            pm1 = 1.D0
         ENDIF
!      t1 = 1.
!      t1 = 2.d0**(n-1)
!      t1 = 1.d0/t1
         t1 = 1.D0/SC20
         nex = 20
         fden = 2.D0
         IF ( nmms2>=1 ) THEN
            DO i = 1 , nmms2
               t1 = fnum*t1/fden
               IF ( t1>SC20 ) THEN
                  t1 = t1/SC40
                  nex = nex + 40
               ENDIF
               fnum = fnum + 2.
               fden = fden + 2.
            ENDDO
         ENDIF
         t1 = t1/2.D0**(N-1-nex)
         IF ( MOD(ma/2,2)/=0 ) t1 = -t1
         t2 = 1.
         IF ( ma/=0 ) THEN
            DO i = 1 , ma
               t2 = fnmh*t2/(fnmh+pm1)
               fnmh = fnmh + 2.
            ENDDO
         ENDIF
         cp2 = t1*DSQRT((N+.5D0)*t2)
         fnnp1 = N*(N+1)
         fnmsq = fnnp1 - 2.D0*ma*ma
         l = (N+1)/2
         IF ( MOD(N,2)==0 .AND. MOD(ma,2)==0 ) l = l + 1
         Cp(l) = cp2
         IF ( M<0 ) THEN
            IF ( MOD(ma,2)/=0 ) Cp(l) = -Cp(l)
         ENDIF
         IF ( l<=1 ) RETURN
         fk = N
         a1 = (fk-2.)*(fk-1.) - fnnp1
         b1 = 2.*(fk*fk-fnmsq)
         Cp(l-1) = b1*Cp(l)/a1
 50      l = l - 1
         IF ( l<=1 ) RETURN
         fk = fk - 2.
         a1 = (fk-2.)*(fk-1.) - fnnp1
         b1 = -2.*(fk*fk-fnmsq)
         c1 = (fk+1.)*(fk+2.) - fnnp1
         Cp(l-1) = -(b1*Cp(l)+c1*Cp(l+1))/a1
         GOTO 50
      ENDIF
      END SUBROUTINE DDNLFK


      SUBROUTINE DDNLFT(M,N,Theta,Cp,Pb)
      IMPLICIT NONE
      INTEGER k , kdo , M , mmod , N , nmod
      DOUBLE PRECISION Cp(*) , Pb , Theta , cdt , sdt , cth , sth , chh
      cdt = DCOS(Theta+Theta)
      sdt = DSIN(Theta+Theta)
      nmod = MOD(N,2)
      mmod = MOD(M,2)
      IF ( nmod<=0 ) THEN
         IF ( mmod<=0 ) THEN
!
!     n even, m even
!
            kdo = N/2
            Pb = .5*Cp(1)
            IF ( N==0 ) RETURN
            cth = cdt
            sth = sdt
            DO k = 1 , kdo
!     pb = pb+cp(k+1)*dcos(2*k*theta)
               Pb = Pb + Cp(k+1)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ELSE
!
!     n even, m odd
!
            kdo = N/2
            Pb = 0.
            cth = cdt
            sth = sdt
            DO k = 1 , kdo
!     pb = pb+cp(k)*dsin(2*k*theta)
               Pb = Pb + Cp(k)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ELSEIF ( mmod<=0 ) THEN
!
!     n odd, m even
!
         kdo = (N+1)/2
         Pb = 0.
         cth = DCOS(Theta)
         sth = DSIN(Theta)
         DO k = 1 , kdo
!     pb = pb+cp(k)*dcos((2*k-1)*theta)
            Pb = Pb + Cp(k)*cth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         RETURN
      ELSE
!
!     n odd, m odd
!
         kdo = (N+1)/2
         Pb = 0.
         cth = DCOS(Theta)
         sth = DSIN(Theta)
         DO k = 1 , kdo
!     pb = pb+cp(k)*dsin((2*k-1)*theta)
            Pb = Pb + Cp(k)*sth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
      ENDIF
      END SUBROUTINE DDNLFT


      SUBROUTINE DLEGIN(Mode,L,Nlat,M,W,Pmn,Km)
      IMPLICIT NONE
      INTEGER i1 , i2 , i3 , i4 , i5 , Km , L , late , M , Mode , Nlat
      DOUBLE PRECISION Pmn , W
!     this subroutine computes legendre polynomials for n=m,...,l-1
!     and  i=1,...,late (late=((nlat+mod(nlat,2))/2)gaussian grid
!     in pmn(n+1,i,km) using swarztrauber's recursion formula.
!     the vector w contains quantities precomputed in shigc.
!     legin must be called in the order m=0,1,...,l-1
!     (e.g., if m=10 is sought it must be preceded by calls with
!     m=0,1,2,...,9 in that order)
      DIMENSION W(1) , Pmn(1)
!     set size of pole to equator gaussian grid
      late = (Nlat+MOD(Nlat,2))/2
!     partition w (set pointers for p0n,p1n,abel,bbel,cbel,pmn)
      i1 = 1 + Nlat
      i2 = i1 + Nlat*late
      i3 = i2 + Nlat*late
      i4 = i3 + (2*Nlat-L)*(L-1)/2
      i5 = i4 + (2*Nlat-L)*(L-1)/2
      CALL DLEGIN1(Mode,L,Nlat,late,M,W(i1),W(i2),W(i3),W(i4),W(i5),Pmn, &
                & Km)
      END SUBROUTINE DLEGIN


      SUBROUTINE DLEGIN1(Mode,L,Nlat,Late,M,P0n,P1n,Abel,Bbel,Cbel,Pmn,  &
                      & Km)
      IMPLICIT NONE
      DOUBLE PRECISION Abel , Bbel , Cbel , P0n , P1n , Pmn
      INTEGER i , imn , IMNDX , INDX , Km , km0 , km1 , km2 , kmt , L , &
            & Late , M , Mode , ms , n , ninc , Nlat , np1
      DIMENSION P0n(Nlat,Late) , P1n(Nlat,Late)
      DIMENSION Abel(1) , Bbel(1) , Cbel(1) , Pmn(Nlat,Late,3)
      DATA km0 , km1 , km2/1 , 2 , 3/
      SAVE km0 , km1 , km2
!     define index function used in storing triangular
!     arrays for recursion coefficients (functions of (m,n))
!     for 2.le.m.le.n-1 and 2.le.n.le.l-1
      INDX(M,n) = (n-1)*(n-2)/2 + M - 1
!     for l.le.n.le.nlat and 2.le.m.le.l
      IMNDX(M,n) = L*(L-1)/2 + (n-L-1)*(L-1) + M - 1
 
!     set do loop indices for full or half sphere
      ms = M + 1
      ninc = 1
      IF ( Mode==1 ) THEN
!     only compute pmn for n-m odd
         ms = M + 2
         ninc = 2
      ELSEIF ( Mode==2 ) THEN
!     only compute pmn for n-m even
         ms = M + 1
         ninc = 2
      ENDIF
 
 
      IF ( M>1 ) THEN
         DO np1 = ms , Nlat , ninc
            n = np1 - 1
            imn = INDX(M,n)
            IF ( n>=L ) imn = IMNDX(M,n)
            DO i = 1 , Late
               Pmn(np1,i,km0) = Abel(imn)*Pmn(n-1,i,km2) + Bbel(imn)    &
                              & *Pmn(n-1,i,km0) - Cbel(imn)             &
                              & *Pmn(np1,i,km2)
            ENDDO
         ENDDO
 
      ELSEIF ( M==0 ) THEN
         DO np1 = ms , Nlat , ninc
            DO i = 1 , Late
               Pmn(np1,i,km0) = P0n(np1,i)
            ENDDO
         ENDDO
 
      ELSEIF ( M==1 ) THEN
         DO np1 = ms , Nlat , ninc
            DO i = 1 , Late
               Pmn(np1,i,km0) = P1n(np1,i)
            ENDDO
         ENDDO
      ENDIF
 
!     permute column indices
!     km0,km1,km2 store m,m-1,m-2 columns
      kmt = km0
      km0 = km2
      km2 = km1
      km1 = kmt
!     set current m index in output param km
      Km = kmt
      END SUBROUTINE DLEGIN1
 
 
      SUBROUTINE DZFIN(Isym,Nlat,Nlon,M,Z,I3,Wzfin)
      IMPLICIT NONE
      INTEGER I3 , imid , Isym , iw1 , iw2 , iw3 , iw4 , labc , lim ,   &
            & M , mmax , Nlat , Nlon
      DOUBLE PRECISION Wzfin , Z
      DIMENSION Z(1) , Wzfin(1)
      imid = (Nlat+1)/2
      lim = Nlat*imid
      mmax = MIN0(Nlat,Nlon/2+1)
      labc = ((mmax-2)*(Nlat+Nlat-mmax-1))/2
      iw1 = lim + 1
      iw2 = iw1 + lim
      iw3 = iw2 + labc
      iw4 = iw3 + labc
!
!     the length of wzfin is 2*lim+3*labc
!
      CALL DZFIN1(Isym,Nlat,M,Z,imid,I3,Wzfin,Wzfin(iw1),Wzfin(iw2),     &
               & Wzfin(iw3),Wzfin(iw4))
      END SUBROUTINE DZFIN


      SUBROUTINE DZFIN1(Isym,Nlat,M,Z,Imid,I3,Zz,Z1,A,B,C)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , C , Z , Z1 , Zz
      INTEGER i , i1 , i2 , I3 , ihold , Imid , Isym , M , Nlat , np1 , &
            & ns , nstp , nstrt
      DIMENSION Z(Imid,Nlat,3) , Zz(Imid,1) , Z1(Imid,1) , A(1) , B(1) ,&
              & C(1)
      SAVE i1 , i2
      ihold = i1
      i1 = i2
      i2 = I3
      I3 = ihold
      IF ( M<1 ) THEN
         i1 = 1
         i2 = 2
         I3 = 3
         DO np1 = 1 , Nlat
            DO i = 1 , Imid
               Z(i,np1,I3) = Zz(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSEIF ( M==1 ) THEN
         DO np1 = 2 , Nlat
            DO i = 1 , Imid
               Z(i,np1,I3) = Z1(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSE
         ns = ((M-2)*(Nlat+Nlat-M-1))/2 + 1
         IF ( Isym/=1 ) THEN
            DO i = 1 , Imid
               Z(i,M+1,I3) = A(ns)*Z(i,M-1,i1) - C(ns)*Z(i,M+1,i1)
            ENDDO
         ENDIF
         IF ( M==Nlat-1 ) RETURN
         IF ( Isym/=2 ) THEN
            ns = ns + 1
            DO i = 1 , Imid
               Z(i,M+2,I3) = A(ns)*Z(i,M,i1) - C(ns)*Z(i,M+2,i1)
            ENDDO
         ENDIF
         nstrt = M + 3
         IF ( Isym==1 ) nstrt = M + 4
         IF ( nstrt<=Nlat ) THEN
            nstp = 2
            IF ( Isym==0 ) nstp = 1
            DO np1 = nstrt , Nlat , nstp
               ns = ns + nstp
               DO i = 1 , Imid
                  Z(i,np1,I3) = A(ns)*Z(i,np1-2,i1) + B(ns)             &
                              & *Z(i,np1-2,I3) - C(ns)*Z(i,np1,i1)
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      END SUBROUTINE DZFIN1


      SUBROUTINE DZFINIT(Nlat,Nlon,Wzfin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      DOUBLE PRECISION Wzfin
      DIMENSION Wzfin(*)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of wzfin is 3*((l-3)*l+2)/2 + 2*l*imid
!     the length of dwork is nlat+1
!
      CALL DZFINI1(Nlat,Nlon,imid,Wzfin,Wzfin(iw1),Dwork,Dwork(imid+1))
      END SUBROUTINE DZFINIT


      SUBROUTINE DZFINI1(Nlat,Nlon,Imid,Z,Abc,Cz,Work)
      IMPLICIT NONE
      DOUBLE PRECISION Abc , Z
      INTEGER i , Imid , m , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*((mmax-2)*(nlat+nlat-mmax-1))/2 locations
!     where mmax = min0(nlat,nlon/2+1)
!     cz and work must each have nlat+1 locations
!
      DIMENSION Z(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION pi , dt , th , zh , Cz(*) , Work(*)
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      DO mp1 = 1 , 2
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DDNZFK(Nlat,m,n,Cz,Work)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DDNZFT(Nlat,m,n,th,Cz,zh)
               Z(i,np1,mp1) = zh
            ENDDO
            Z(1,np1,mp1) = .5*Z(1,np1,mp1)
         ENDDO
      ENDDO
      CALL DRABCP(Nlat,Nlon,Abc)
      END SUBROUTINE DZFINI1


      SUBROUTINE DDNZFK(Nlat,M,N,Cz,Work)
      IMPLICIT NONE
      INTEGER i , idx , k , kdo , kp1 , lc , M , mmod , N , Nlat , nmod
!
!     dnzfk computes the coefficients in the trigonometric
!     expansion of the z functions that are used in spherical
!     harmonic analysis.
!
      DIMENSION Cz(1) , Work(1)
!
!     cz and work must both have nlat+1 locations
!
      DOUBLE PRECISION sum , sc1 , t1 , t2 , Work , Cz
      lc = (Nlat+1)/2
      sc1 = 2.D0/FLOAT(Nlat-1)
      CALL DDNLFK(M,N,Work)
      nmod = MOD(N,2)
      mmod = MOD(M,2)
      IF ( nmod<=0 ) THEN
         IF ( mmod<=0 ) THEN
!
!     n even, m even
!
            kdo = N/2 + 1
            DO idx = 1 , lc
               i = idx + idx - 2
               sum = Work(1)/(1.D0-i*i)
               IF ( kdo>=2 ) THEN
                  DO kp1 = 2 , kdo
                     k = kp1 - 1
                     t1 = 1.D0 - (k+k+i)**2
                     t2 = 1.D0 - (k+k-i)**2
                     sum = sum + Work(kp1)*(t1+t2)/(t1*t2)
                  ENDDO
               ENDIF
               Cz(idx) = sc1*sum
            ENDDO
            RETURN
         ELSE
!
!     n even, m odd
!
            kdo = N/2
            DO idx = 1 , lc
               i = idx + idx - 2
               sum = 0.
               DO k = 1 , kdo
                  t1 = 1.D0 - (k+k+i)**2
                  t2 = 1.D0 - (k+k-i)**2
                  sum = sum + Work(k)*(t1-t2)/(t1*t2)
               ENDDO
               Cz(idx) = sc1*sum
            ENDDO
            RETURN
         ENDIF
      ELSEIF ( mmod<=0 ) THEN
!
!     n odd, m even
!
         kdo = (N+1)/2
         DO idx = 1 , lc
            i = idx + idx - 1
            sum = 0.
            DO k = 1 , kdo
               t1 = 1.D0 - (k+k-1+i)**2
               t2 = 1.D0 - (k+k-1-i)**2
               sum = sum + Work(k)*(t1+t2)/(t1*t2)
            ENDDO
            Cz(idx) = sc1*sum
         ENDDO
         RETURN
      ELSE
!
!     n odd, m odd
!
         kdo = (N+1)/2
         DO idx = 1 , lc
            i = idx + idx - 3
            sum = 0.
            DO k = 1 , kdo
               t1 = 1.D0 - (k+k-1+i)**2
               t2 = 1.D0 - (k+k-1-i)**2
               sum = sum + Work(k)*(t1-t2)/(t1*t2)
            ENDDO
            Cz(idx) = sc1*sum
         ENDDO
      ENDIF
      END SUBROUTINE DDNZFK


      SUBROUTINE DDNZFT(Nlat,M,N,Th,Cz,Zh)
      IMPLICIT NONE
      INTEGER k , lc , lmod , lq , ls , M , mmod , N , Nlat , nmod
      DIMENSION Cz(1)
      DOUBLE PRECISION Cz , Zh , Th , cdt , sdt , cth , sth , chh
      Zh = 0.
      cdt = DCOS(Th+Th)
      sdt = DSIN(Th+Th)
      lmod = MOD(Nlat,2)
      mmod = MOD(M,2)
      nmod = MOD(N,2)
      IF ( lmod<=0 ) THEN
         lc = Nlat/2
         lq = lc - 1
         IF ( nmod<=0 ) THEN
            IF ( mmod<=0 ) THEN
!
!     nlat even n even m even
!
               Zh = .5*Cz(1)
               cth = cdt
               sth = sdt
               DO k = 2 , lc
!     zh = zh+cz(k)*dcos(2*(k-1)*th)
                  Zh = Zh + Cz(k)*cth
                  chh = cdt*cth - sdt*sth
                  sth = sdt*cth + cdt*sth
                  cth = chh
               ENDDO
               RETURN
            ELSE
!
!     nlat even n even m odd
!
               cth = cdt
               sth = sdt
               DO k = 1 , lq
!     zh = zh+cz(k+1)*dsin(2*k*th)
                  Zh = Zh + Cz(k+1)*sth
                  chh = cdt*cth - sdt*sth
                  sth = sdt*cth + cdt*sth
                  cth = chh
               ENDDO
               RETURN
            ENDIF
!
!     nlat even n odd m even
!
         ELSEIF ( mmod<=0 ) THEN
            Zh = .5*Cz(lc)*DCOS((Nlat-1)*Th)
            cth = DCOS(Th)
            sth = DSIN(Th)
            DO k = 1 , lq
!     zh = zh+cz(k)*dcos((2*k-1)*th)
               Zh = Zh + Cz(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ELSE
!
!     nlat even n odd m odd
!
            cth = DCOS(Th)
            sth = DSIN(Th)
            DO k = 1 , lq
!     zh = zh+cz(k+1)*dsin((2*k-1)*th)
               Zh = Zh + Cz(k+1)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            GOTO 99999
         ENDIF
      ELSE
         lc = (Nlat+1)/2
         lq = lc - 1
         ls = lc - 2
         IF ( nmod<=0 ) THEN
            IF ( mmod<=0 ) THEN
!
!     nlat odd n even m even
!
               Zh = .5*(Cz(1)+Cz(lc)*DCOS(2*lq*Th))
               cth = cdt
               sth = sdt
               DO k = 2 , lq
!     zh = zh+cz(k)*dcos(2*(k-1)*th)
                  Zh = Zh + Cz(k)*cth
                  chh = cdt*cth - sdt*sth
                  sth = sdt*cth + cdt*sth
                  cth = chh
               ENDDO
               RETURN
            ELSE
!
!     nlat odd n even m odd
!
               cth = cdt
               sth = sdt
               DO k = 1 , ls
!     zh = zh+cz(k+1)*dsin(2*k*th)
                  Zh = Zh + Cz(k+1)*sth
                  chh = cdt*cth - sdt*sth
                  sth = sdt*cth + cdt*sth
                  cth = chh
               ENDDO
               RETURN
            ENDIF
!
!     nlat odd n odd, m even
!
         ELSEIF ( mmod<=0 ) THEN
            cth = DCOS(Th)
            sth = DSIN(Th)
            DO k = 1 , lq
!     zh = zh+cz(k)*dcos((2*k-1)*th)
               Zh = Zh + Cz(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ENDIF
!
!     nlat odd n odd m odd
!
      cth = DCOS(Th)
      sth = DSIN(Th)
      DO k = 1 , lq
!     zh = zh+cz(k+1)*dsin((2*k-1)*th)
         Zh = Zh + Cz(k+1)*sth
         chh = cdt*cth - sdt*sth
         sth = sdt*cth + cdt*sth
         cth = chh
      ENDDO
      RETURN
99999 END SUBROUTINE DDNZFT


      SUBROUTINE DALIN(Isym,Nlat,Nlon,M,P,I3,Walin)
      IMPLICIT NONE
      INTEGER I3 , imid , Isym , iw1 , iw2 , iw3 , iw4 , labc , lim ,   &
            & M , mmax , Nlat , Nlon
      DOUBLE PRECISION P , Walin
      DIMENSION P(1) , Walin(1)
      imid = (Nlat+1)/2
      lim = Nlat*imid
      mmax = MIN0(Nlat,Nlon/2+1)
      labc = ((mmax-2)*(Nlat+Nlat-mmax-1))/2
      iw1 = lim + 1
      iw2 = iw1 + lim
      iw3 = iw2 + labc
      iw4 = iw3 + labc
!
!     the length of walin is ((5*l-7)*l+6)/2
!
      CALL DALIN1(Isym,Nlat,M,P,imid,I3,Walin,Walin(iw1),Walin(iw2),     &
               & Walin(iw3),Walin(iw4))
      END SUBROUTINE DALIN


      SUBROUTINE DALIN1(Isym,Nlat,M,P,Imid,I3,Pz,P1,A,B,C)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , C , P , P1 , Pz
      INTEGER i , i1 , i2 , I3 , ihold , Imid , Isym , M , Nlat , np1 , &
            & ns , nstp , nstrt
      DIMENSION P(Imid,Nlat,3) , Pz(Imid,1) , P1(Imid,1) , A(1) , B(1) ,&
              & C(1)
      SAVE i1 , i2
      ihold = i1
      i1 = i2
      i2 = I3
      I3 = ihold
      IF ( M<1 ) THEN
         i1 = 1
         i2 = 2
         I3 = 3
         DO np1 = 1 , Nlat
            DO i = 1 , Imid
               P(i,np1,I3) = Pz(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSEIF ( M==1 ) THEN
         DO np1 = 2 , Nlat
            DO i = 1 , Imid
               P(i,np1,I3) = P1(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSE
         ns = ((M-2)*(Nlat+Nlat-M-1))/2 + 1
         IF ( Isym/=1 ) THEN
            DO i = 1 , Imid
               P(i,M+1,I3) = A(ns)*P(i,M-1,i1) - C(ns)*P(i,M+1,i1)
            ENDDO
         ENDIF
         IF ( M==Nlat-1 ) RETURN
         IF ( Isym/=2 ) THEN
            ns = ns + 1
            DO i = 1 , Imid
               P(i,M+2,I3) = A(ns)*P(i,M,i1) - C(ns)*P(i,M+2,i1)
            ENDDO
         ENDIF
         nstrt = M + 3
         IF ( Isym==1 ) nstrt = M + 4
         IF ( nstrt<=Nlat ) THEN
            nstp = 2
            IF ( Isym==0 ) nstp = 1
            DO np1 = nstrt , Nlat , nstp
               ns = ns + nstp
               DO i = 1 , Imid
                  P(i,np1,I3) = A(ns)*P(i,np1-2,i1) + B(ns)             &
                              & *P(i,np1-2,I3) - C(ns)*P(i,np1,i1)
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      END SUBROUTINE DALIN1


      SUBROUTINE DALINIT(Nlat,Nlon,Walin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      DOUBLE PRECISION Walin
      DIMENSION Walin(*)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of walin is 3*((l-3)*l+2)/2 + 2*l*imid
!     the length of work is nlat+1
!
      CALL DALINI1(Nlat,Nlon,imid,Walin,Walin(iw1),Dwork)
      END SUBROUTINE DALINIT


      SUBROUTINE DALINI1(Nlat,Nlon,Imid,P,Abc,Cp)
      IMPLICIT NONE
      DOUBLE PRECISION Abc , P
      INTEGER i , Imid , m , mp1 , n , Nlat , Nlon , np1
      DIMENSION P(Imid,Nlat,2) , Abc(1) , Cp(1)
      DOUBLE PRECISION pi , dt , th , Cp , ph
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      DO mp1 = 1 , 2
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DDNLFK(m,n,Cp)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DDNLFT(m,n,th,Cp,ph)
               P(i,np1,mp1) = ph
            ENDDO
         ENDDO
      ENDDO
      CALL DRABCP(Nlat,Nlon,Abc)
      END SUBROUTINE DALINI1

      
      SUBROUTINE DRABCP(Nlat,Nlon,Abc)
      IMPLICIT NONE
      DOUBLE PRECISION Abc
      INTEGER iw1 , iw2 , labc , mmax , Nlat , Nlon
!
!     subroutine rabcp computes the coefficients in the recurrence
!     relation for the associated legendre fuctions. array abc
!     must have 3*((mmax-2)*(nlat+nlat-mmax-1))/2 locations.
!
      DIMENSION Abc(1)
      mmax = MIN0(Nlat,Nlon/2+1)
      labc = ((mmax-2)*(Nlat+Nlat-mmax-1))/2
      iw1 = labc + 1
      iw2 = iw1 + labc
      CALL DRABCP1(Nlat,Nlon,Abc,Abc(iw1),Abc(iw2))
      END SUBROUTINE DRABCP


      SUBROUTINE DRABCP1(Nlat,Nlon,A,B,C)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , C , cn , fm , fn , fnmm , fnpm , temp , tm , tn
      INTEGER m , mmax , mp1 , mp3 , n , Nlat , Nlon , np1 , ns
!
!     coefficients a, b, and c for computing pbar(m,n,theta) are
!     stored in location ((m-2)*(nlat+nlat-m-1))/2+n+1
!
      DIMENSION A(1) , B(1) , C(1)
      mmax = MIN0(Nlat,Nlon/2+1)
      DO mp1 = 3 , mmax
         m = mp1 - 1
         ns = ((m-2)*(Nlat+Nlat-m-1))/2 + 1
         fm = FLOAT(m)
         tm = fm + fm
         temp = tm*(tm-1.)
         A(ns) = SQRT((tm+1.)*(tm-2.)/temp)
         C(ns) = SQRT(2./temp)
         IF ( m/=Nlat-1 ) THEN
            ns = ns + 1
            temp = tm*(tm+1.)
            A(ns) = SQRT((tm+3.)*(tm-2.)/temp)
            C(ns) = SQRT(6./temp)
            mp3 = m + 3
            IF ( mp3<=Nlat ) THEN
               DO np1 = mp3 , Nlat
                  n = np1 - 1
                  ns = ns + 1
                  fn = FLOAT(n)
                  tn = fn + fn
                  cn = (tn+1.)/(tn-3.)
                  fnpm = fn + fm
                  fnmm = fn - fm
                  temp = fnpm*(fnpm-1.)
                  A(ns) = SQRT(cn*(fnpm-3.)*(fnpm-2.)/temp)
                  B(ns) = SQRT(cn*fnmm*(fnmm-1.)/temp)
                  C(ns) = SQRT((fnmm+1.)*(fnmm+2.)/temp)
               ENDDO
            ENDIF
         ENDIF
      ENDDO
      END SUBROUTINE DRABCP1

      
      SUBROUTINE DSEA1(Nlat,Nlon,Imid,Z,Idz,Zin,Wzfin,Dwork)
      IMPLICIT NONE
      INTEGER i , i3 , Idz , Imid , m , mmax , mn , mp1 , Nlat , Nlon , &
            & np1
      DOUBLE PRECISION Wzfin , Z , Zin
      DIMENSION Z(Idz,*) , Zin(Imid,Nlat,3) , Wzfin(*)
      DOUBLE PRECISION Dwork(*)
      CALL DZFINIT(Nlat,Nlon,Wzfin,Dwork)
      mmax = MIN0(Nlat,Nlon/2+1)
      DO mp1 = 1 , mmax
         m = mp1 - 1
         CALL DZFIN(0,Nlat,Nlon,m,Zin,i3,Wzfin)
         DO np1 = mp1 , Nlat
            mn = m*(Nlat-1) - (m*(m-1))/2 + np1
            DO i = 1 , Imid
               Z(mn,i) = Zin(i,np1,i3)
            ENDDO
         ENDDO
      ENDDO
      END SUBROUTINE DSEA1


      SUBROUTINE DSES1(Nlat,Nlon,Imid,P,Pin,Walin,Dwork)
      IMPLICIT NONE
      INTEGER i , i3 , Imid , m , mmax , mn , mp1 , Nlat , Nlon , np1
      DOUBLE PRECISION P , Pin , Walin
      DIMENSION P(Imid,*) , Pin(Imid,Nlat,3) , Walin(*)
      DOUBLE PRECISION Dwork(*)
      CALL DALINIT(Nlat,Nlon,Walin,Dwork)
      mmax = MIN0(Nlat,Nlon/2+1)
      DO mp1 = 1 , mmax
         m = mp1 - 1
         CALL DALIN(0,Nlat,Nlon,m,Pin,i3,Walin)
         DO np1 = mp1 , Nlat
            mn = m*(Nlat-1) - (m*(m-1))/2 + np1
            DO i = 1 , Imid
               P(i,mn) = Pin(i,np1,i3)
            ENDDO
         ENDDO
      ENDDO
    END SUBROUTINE DSES1


      SUBROUTINE DZVINIT(Nlat,Nlon,Wzvin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      DOUBLE PRECISION Wzvin
      DIMENSION Wzvin(1)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of wzvin is
!         2*nlat*imid +3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     the length of dwork is 2*nlat+2
!
      CALL DZVINI1(Nlat,Nlon,imid,Wzvin,Wzvin(iw1),Dwork,Dwork(Nlat+2))
      END SUBROUTINE DZVINIT


      SUBROUTINE DZVINI1(Nlat,Nlon,Imid,Zv,Abc,Czv,Work)
      IMPLICIT NONE
      DOUBLE PRECISION Abc , Zv
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     czv and work must each have nlat+1  locations
!
      DIMENSION Zv(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION pi , dt , Czv(1) , zvh , th , Work(1)
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      mdo = MIN0(2,Nlat,(Nlon+1)/2)
      DO mp1 = 1 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DDZVK(Nlat,m,n,Czv,Work)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DDZVT(Nlat,m,n,th,Czv,zvh)
               Zv(i,np1,mp1) = zvh
            ENDDO
            Zv(1,np1,mp1) = .5*Zv(1,np1,mp1)
         ENDDO
      ENDDO
      CALL DRABCV(Nlat,Nlon,Abc)
      END SUBROUTINE DZVINI1


      SUBROUTINE DZWINIT(Nlat,Nlon,Wzwin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      DOUBLE PRECISION Wzwin
      DIMENSION Wzwin(1)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of wzvin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of dwork is 2*nlat+2
!
      CALL DZWINI1(Nlat,Nlon,imid,Wzwin,Wzwin(iw1),Dwork,Dwork(Nlat+2))
    END SUBROUTINE DZWINIT
    

      SUBROUTINE DZWINI1(Nlat,Nlon,Imid,Zw,Abc,Czw,Work)
      IMPLICIT NONE
      DOUBLE PRECISION Abc , Zw
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     czw and work must each have nlat+1 locations
!
      DIMENSION Zw(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION pi , dt , Czw(1) , zwh , th , Work(1)
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      mdo = MIN0(3,Nlat,(Nlon+1)/2)
      IF ( mdo<2 ) RETURN
      DO mp1 = 2 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DDZWK(Nlat,m,n,Czw,Work)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DDZWT(Nlat,m,n,th,Czw,zwh)
               Zw(i,np1,m) = zwh
            ENDDO
            Zw(1,np1,m) = .5*Zw(1,np1,m)
         ENDDO
      ENDDO
      CALL DRABCW(Nlat,Nlon,Abc)
      END SUBROUTINE DZWINI1


      SUBROUTINE DZVIN(Ityp,Nlat,Nlon,M,Zv,I3,Wzvin)
      IMPLICIT NONE
      INTEGER I3 , imid , Ityp , iw1 , iw2 , iw3 , iw4 , labc , lim ,   &
            & M , mmax , Nlat , Nlon
      DOUBLE PRECISION Wzvin , Zv
      DIMENSION Zv(1) , Wzvin(1)
      imid = (Nlat+1)/2
      lim = Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = (MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      iw1 = lim + 1
      iw2 = iw1 + lim
      iw3 = iw2 + labc
      iw4 = iw3 + labc
!
!     the length of wzvin is 2*lim+3*labc
!
      CALL DZVIN1(Ityp,Nlat,M,Zv,imid,I3,Wzvin,Wzvin(iw1),Wzvin(iw2),    &
               & Wzvin(iw3),Wzvin(iw4))
      END SUBROUTINE DZVIN


      SUBROUTINE DZVIN1(Ityp,Nlat,M,Zv,Imid,I3,Zvz,Zv1,A,B,C)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , C , Zv , Zv1 , Zvz
      INTEGER i , i1 , i2 , I3 , ihold , Imid , Ityp , M , Nlat , np1 , &
            & ns , nstp , nstrt
      DIMENSION Zv(Imid,Nlat,3) , Zvz(Imid,1) , Zv1(Imid,1) , A(1) ,    &
              & B(1) , C(1)
      SAVE i1 , i2
      ihold = i1
      i1 = i2
      i2 = I3
      I3 = ihold
      IF ( M<1 ) THEN
         i1 = 1
         i2 = 2
         I3 = 3
         DO np1 = 1 , Nlat
            DO i = 1 , Imid
               Zv(i,np1,I3) = Zvz(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSEIF ( M==1 ) THEN
         DO np1 = 2 , Nlat
            DO i = 1 , Imid
               Zv(i,np1,I3) = Zv1(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSE
         ns = ((M-2)*(Nlat+Nlat-M-1))/2 + 1
         IF ( Ityp/=1 ) THEN
            DO i = 1 , Imid
               Zv(i,M+1,I3) = A(ns)*Zv(i,M-1,i1) - C(ns)*Zv(i,M+1,i1)
            ENDDO
         ENDIF
         IF ( M==Nlat-1 ) RETURN
         IF ( Ityp/=2 ) THEN
            ns = ns + 1
            DO i = 1 , Imid
               Zv(i,M+2,I3) = A(ns)*Zv(i,M,i1) - C(ns)*Zv(i,M+2,i1)
            ENDDO
         ENDIF
         nstrt = M + 3
         IF ( Ityp==1 ) nstrt = M + 4
         IF ( nstrt<=Nlat ) THEN
            nstp = 2
            IF ( Ityp==0 ) nstp = 1
            DO np1 = nstrt , Nlat , nstp
               ns = ns + nstp
               DO i = 1 , Imid
                  Zv(i,np1,I3) = A(ns)*Zv(i,np1-2,i1) + B(ns)           &
                               & *Zv(i,np1-2,I3) - C(ns)*Zv(i,np1,i1)
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      END SUBROUTINE DZVIN1


      SUBROUTINE DZWIN(Ityp,Nlat,Nlon,M,Zw,I3,Wzwin)
      IMPLICIT NONE
      INTEGER I3 , imid , Ityp , iw1 , iw2 , iw3 , iw4 , labc , lim ,   &
            & M , mmax , Nlat , Nlon
      DOUBLE PRECISION Wzwin , Zw
      DIMENSION Zw(1) , Wzwin(1)
      imid = (Nlat+1)/2
      lim = Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = (MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      iw1 = lim + 1
      iw2 = iw1 + lim
      iw3 = iw2 + labc
      iw4 = iw3 + labc
!
!     the length of wzwin is 2*lim+3*labc
!
      CALL DZWIN1(Ityp,Nlat,M,Zw,imid,I3,Wzwin,Wzwin(iw1),Wzwin(iw2),    &
               & Wzwin(iw3),Wzwin(iw4))
      END SUBROUTINE DZWIN


      SUBROUTINE DZWIN1(Ityp,Nlat,M,Zw,Imid,I3,Zw1,Zw2,A,B,C)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , C , Zw , Zw1 , Zw2
      INTEGER i , i1 , i2 , I3 , ihold , Imid , Ityp , M , Nlat , np1 , &
            & ns , nstp , nstrt
      DIMENSION Zw(Imid,Nlat,3) , Zw1(Imid,1) , Zw2(Imid,1) , A(1) ,    &
              & B(1) , C(1)
      SAVE i1 , i2
      ihold = i1
      i1 = i2
      i2 = I3
      I3 = ihold
      IF ( M<2 ) THEN
         i1 = 1
         i2 = 2
         I3 = 3
         DO np1 = 2 , Nlat
            DO i = 1 , Imid
               Zw(i,np1,I3) = Zw1(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSEIF ( M==2 ) THEN
         DO np1 = 3 , Nlat
            DO i = 1 , Imid
               Zw(i,np1,I3) = Zw2(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSE
         ns = ((M-2)*(Nlat+Nlat-M-1))/2 + 1
         IF ( Ityp/=1 ) THEN
            DO i = 1 , Imid
               Zw(i,M+1,I3) = A(ns)*Zw(i,M-1,i1) - C(ns)*Zw(i,M+1,i1)
            ENDDO
         ENDIF
         IF ( M==Nlat-1 ) RETURN
         IF ( Ityp/=2 ) THEN
            ns = ns + 1
            DO i = 1 , Imid
               Zw(i,M+2,I3) = A(ns)*Zw(i,M,i1) - C(ns)*Zw(i,M+2,i1)
            ENDDO
         ENDIF
         nstrt = M + 3
         IF ( Ityp==1 ) nstrt = M + 4
         IF ( nstrt<=Nlat ) THEN
            nstp = 2
            IF ( Ityp==0 ) nstp = 1
            DO np1 = nstrt , Nlat , nstp
               ns = ns + nstp
               DO i = 1 , Imid
                  Zw(i,np1,I3) = A(ns)*Zw(i,np1-2,i1) + B(ns)           &
                               & *Zw(i,np1-2,I3) - C(ns)*Zw(i,np1,i1)
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      END  SUBROUTINE DZWIN1


      SUBROUTINE DVBINIT(Nlat,Nlon,Wvbin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      DOUBLE PRECISION Wvbin
      DIMENSION Wvbin(1)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of dwork is 2*nlat+2
!
      CALL DVBINI1(Nlat,Nlon,imid,Wvbin,Wvbin(iw1),Dwork,Dwork(Nlat+2))
      END SUBROUTINE DVBINIT


      SUBROUTINE DVBINI1(Nlat,Nlon,Imid,Vb,Abc,Cvb,Work)
      IMPLICIT NONE
      DOUBLE PRECISION Abc , Vb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     cvb and work must each have nlat+1 locations
!
      DIMENSION Vb(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION pi , dt , Cvb(1) , th , vbh , Work(1)
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      mdo = MIN0(2,Nlat,(Nlon+1)/2)
      DO mp1 = 1 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DDVBK(m,n,Cvb,Work)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DDVBT(m,n,th,Cvb,vbh)
               Vb(i,np1,mp1) = vbh
            ENDDO
         ENDDO
      ENDDO
      CALL DRABCV(Nlat,Nlon,Abc)
      END SUBROUTINE DVBINI1


      SUBROUTINE DWBINIT(Nlat,Nlon,Wwbin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      DOUBLE PRECISION Wwbin
      DIMENSION Wwbin(1)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of dwork is 2*nlat+2
!
      CALL DWBINI1(Nlat,Nlon,imid,Wwbin,Wwbin(iw1),Dwork,Dwork(Nlat+2))
      END SUBROUTINE DWBINIT

      
      SUBROUTINE DWBINI1(Nlat,Nlon,Imid,Wb,Abc,Cwb,Work)
      IMPLICIT NONE
      DOUBLE PRECISION Abc , Wb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     cwb and work must each have nlat+1 locations
!
      DIMENSION Wb(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION pi , dt , Cwb(1) , wbh , th , Work(1)
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      mdo = MIN0(3,Nlat,(Nlon+1)/2)
      IF ( mdo<2 ) RETURN
      DO mp1 = 2 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DDWBK(m,n,Cwb,Work)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DDWBT(m,n,th,Cwb,wbh)
               Wb(i,np1,m) = wbh
            ENDDO
         ENDDO
      ENDDO
      CALL DRABCW(Nlat,Nlon,Abc)
      END SUBROUTINE DWBINI1


      SUBROUTINE DVBIN(Ityp,Nlat,Nlon,M,Vb,I3,Wvbin)
      IMPLICIT NONE
      INTEGER I3 , imid , Ityp , iw1 , iw2 , iw3 , iw4 , labc , lim ,   &
            & M , mmax , Nlat , Nlon
      DOUBLE PRECISION Vb , Wvbin
      DIMENSION Vb(1) , Wvbin(1)
      imid = (Nlat+1)/2
      lim = Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = (MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      iw1 = lim + 1
      iw2 = iw1 + lim
      iw3 = iw2 + labc
      iw4 = iw3 + labc
!
!     the length of wvbin is 2*lim+3*labc
!
      CALL DVBIN1(Ityp,Nlat,M,Vb,imid,I3,Wvbin,Wvbin(iw1),Wvbin(iw2),    &
               & Wvbin(iw3),Wvbin(iw4))
      END SUBROUTINE DVBIN


      SUBROUTINE DVBIN1(Ityp,Nlat,M,Vb,Imid,I3,Vbz,Vb1,A,B,C)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , C , Vb , Vb1 , Vbz
      INTEGER i , i1 , i2 , I3 , ihold , Imid , Ityp , M , Nlat , np1 , &
            & ns , nstp , nstrt
      DIMENSION Vb(Imid,Nlat,3) , Vbz(Imid,1) , Vb1(Imid,1) , A(1) ,    &
              & B(1) , C(1)
      SAVE i1 , i2
      ihold = i1
      i1 = i2
      i2 = I3
      I3 = ihold
      IF ( M<1 ) THEN
         i1 = 1
         i2 = 2
         I3 = 3
         DO np1 = 1 , Nlat
            DO i = 1 , Imid
               Vb(i,np1,I3) = Vbz(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSEIF ( M==1 ) THEN
         DO np1 = 2 , Nlat
            DO i = 1 , Imid
               Vb(i,np1,I3) = Vb1(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSE
         ns = ((M-2)*(Nlat+Nlat-M-1))/2 + 1
         IF ( Ityp/=1 ) THEN
            DO i = 1 , Imid
               Vb(i,M+1,I3) = A(ns)*Vb(i,M-1,i1) - C(ns)*Vb(i,M+1,i1)
            ENDDO
         ENDIF
         IF ( M==Nlat-1 ) RETURN
         IF ( Ityp/=2 ) THEN
            ns = ns + 1
            DO i = 1 , Imid
               Vb(i,M+2,I3) = A(ns)*Vb(i,M,i1) - C(ns)*Vb(i,M+2,i1)
            ENDDO
         ENDIF
         nstrt = M + 3
         IF ( Ityp==1 ) nstrt = M + 4
         IF ( nstrt<=Nlat ) THEN
            nstp = 2
            IF ( Ityp==0 ) nstp = 1
            DO np1 = nstrt , Nlat , nstp
               ns = ns + nstp
               DO i = 1 , Imid
                  Vb(i,np1,I3) = A(ns)*Vb(i,np1-2,i1) + B(ns)           &
                               & *Vb(i,np1-2,I3) - C(ns)*Vb(i,np1,i1)
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      END SUBROUTINE DVBIN1


      SUBROUTINE DWBIN(Ityp,Nlat,Nlon,M,Wb,I3,Wwbin)
      IMPLICIT NONE
      INTEGER I3 , imid , Ityp , iw1 , iw2 , iw3 , iw4 , labc , lim ,   &
            & M , mmax , Nlat , Nlon
      DOUBLE PRECISION Wb , Wwbin
      DIMENSION Wb(1) , Wwbin(1)
      imid = (Nlat+1)/2
      lim = Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = (MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      iw1 = lim + 1
      iw2 = iw1 + lim
      iw3 = iw2 + labc
      iw4 = iw3 + labc
!
!     the length of wwbin is 2*lim+3*labc
!
      CALL DWBIN1(Ityp,Nlat,M,Wb,imid,I3,Wwbin,Wwbin(iw1),Wwbin(iw2),    &
               & Wwbin(iw3),Wwbin(iw4))
      END SUBROUTINE DWBIN

      
      SUBROUTINE DWBIN1(Ityp,Nlat,M,Wb,Imid,I3,Wb1,Wb2,A,B,C)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , C , Wb , Wb1 , Wb2
      INTEGER i , i1 , i2 , I3 , ihold , Imid , Ityp , M , Nlat , np1 , &
            & ns , nstp , nstrt
      DIMENSION Wb(Imid,Nlat,3) , Wb1(Imid,1) , Wb2(Imid,1) , A(1) ,    &
              & B(1) , C(1)
      SAVE i1 , i2
      ihold = i1
      i1 = i2
      i2 = I3
      I3 = ihold
      IF ( M<2 ) THEN
         i1 = 1
         i2 = 2
         I3 = 3
         DO np1 = 2 , Nlat
            DO i = 1 , Imid
               Wb(i,np1,I3) = Wb1(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSEIF ( M==2 ) THEN
         DO np1 = 3 , Nlat
            DO i = 1 , Imid
               Wb(i,np1,I3) = Wb2(i,np1)
            ENDDO
         ENDDO
         RETURN
      ELSE
         ns = ((M-2)*(Nlat+Nlat-M-1))/2 + 1
         IF ( Ityp/=1 ) THEN
            DO i = 1 , Imid
               Wb(i,M+1,I3) = A(ns)*Wb(i,M-1,i1) - C(ns)*Wb(i,M+1,i1)
            ENDDO
         ENDIF
         IF ( M==Nlat-1 ) RETURN
         IF ( Ityp/=2 ) THEN
            ns = ns + 1
            DO i = 1 , Imid
               Wb(i,M+2,I3) = A(ns)*Wb(i,M,i1) - C(ns)*Wb(i,M+2,i1)
            ENDDO
         ENDIF
         nstrt = M + 3
         IF ( Ityp==1 ) nstrt = M + 4
         IF ( nstrt<=Nlat ) THEN
            nstp = 2
            IF ( Ityp==0 ) nstp = 1
            DO np1 = nstrt , Nlat , nstp
               ns = ns + nstp
               DO i = 1 , Imid
                  Wb(i,np1,I3) = A(ns)*Wb(i,np1-2,i1) + B(ns)           &
                               & *Wb(i,np1-2,I3) - C(ns)*Wb(i,np1,i1)
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      END SUBROUTINE DWBIN1


      SUBROUTINE DDZVK(Nlat,M,N,Czv,Work)
      IMPLICIT NONE
      INTEGER i , id , k , kdo , lc , M , mmod , N , Nlat , nmod
!
!     subroutine dzvk computes the coefficients in the trigonometric
!     expansion of the quadrature function zvbar(n,m,theta)
!
!     input parameters
!
!     nlat      the number of colatitudes including the poles.
!
!     n      the degree (subscript) of wbarv(n,m,theta)
!
!     m      the order (superscript) of wbarv(n,m,theta)
!
!     work   a work array with at least (nlat+1)/2 locations
!
!     output parameter
!
!     czv     the fourier coefficients of zvbar(n,m,theta).
!
      DIMENSION Czv(1) , Work(1)
      DOUBLE PRECISION Czv , sc1 , sum , Work , t1 , t2
      IF ( N<=0 ) RETURN
      lc = (Nlat+1)/2
      sc1 = 2.D0/FLOAT(Nlat-1)
      CALL DDVBK(M,N,Work,Czv)
      nmod = MOD(N,2)
      mmod = MOD(M,2)
      IF ( nmod/=0 ) THEN
         IF ( mmod/=0 ) THEN
!
!     n odd, m odd
!
            kdo = (N+1)/2
            DO id = 1 , lc
               i = id + id - 1
               sum = 0.
               DO k = 1 , kdo
                  t1 = 1.D0 - (k+k-1+i)**2
                  t2 = 1.D0 - (k+k-1-i)**2
                  sum = sum + Work(k)*(t1+t2)/(t1*t2)
               ENDDO
               Czv(id) = sc1*sum
            ENDDO
            GOTO 99999
         ENDIF
      ELSEIF ( mmod/=0 ) THEN
!
!     n even, m odd
!
         kdo = N/2
         DO id = 1 , lc
            i = id + id - 2
            sum = 0.
            DO k = 1 , kdo
               t1 = 1.D0 - (k+k+i)**2
               t2 = 1.D0 - (k+k-i)**2
               sum = sum + Work(k)*(t1+t2)/(t1*t2)
            ENDDO
            Czv(id) = sc1*sum
         ENDDO
         RETURN
      ELSE
!
!     n even, m even
!
         kdo = N/2
         DO id = 1 , lc
            i = id + id - 2
            sum = 0.
            DO k = 1 , kdo
               t1 = 1.D0 - (k+k+i)**2
               t2 = 1.D0 - (k+k-i)**2
               sum = sum + Work(k)*(t1-t2)/(t1*t2)
            ENDDO
            Czv(id) = sc1*sum
         ENDDO
         RETURN
      ENDIF
!
!     n odd, m even
!
      kdo = (N+1)/2
      DO id = 1 , lc
         i = id + id - 3
         sum = 0.
         DO k = 1 , kdo
            t1 = 1.D0 - (k+k-1+i)**2
            t2 = 1.D0 - (k+k-1-i)**2
            sum = sum + Work(k)*(t1-t2)/(t1*t2)
         ENDDO
         Czv(id) = sc1*sum
      ENDDO
      RETURN
99999 END SUBROUTINE DDZVK


      SUBROUTINE DDZVT(Nlat,M,N,Th,Czv,Zvh)
      IMPLICIT NONE
      INTEGER k , lc , lmod , lq , ls , M , mmod , N , Nlat , nmod
!
!     subroutine dzvt tabulates the function zvbar(n,m,theta)
!     at theta = th in double precision
!
!     input parameters
!
!     nlat      the number of colatitudes including the poles.
!
!     n      the degree (subscript) of zvbar(n,m,theta)
!
!     m      the order (superscript) of zvbar(n,m,theta)
!
!     czv     the fourier coefficients of zvbar(n,m,theta)
!             as computed by subroutine zwk.
!
!     output parameter
!
!     zvh     zvbar(m,n,theta) evaluated at theta = th
!
      DIMENSION Czv(1)
      DOUBLE PRECISION Th , Czv , Zvh , cth , sth , cdt , sdt , chh
      Zvh = 0.
      IF ( N<=0 ) RETURN
      lc = (Nlat+1)/2
      lq = lc - 1
      ls = lc - 2
      cth = DCOS(Th)
      sth = DSIN(Th)
      cdt = cth*cth - sth*sth
      sdt = 2.*sth*cth
      lmod = MOD(Nlat,2)
      mmod = MOD(M,2)
      nmod = MOD(N,2)
      IF ( lmod==0 ) THEN
         IF ( nmod==0 ) THEN
            cth = cdt
            sth = sdt
            IF ( mmod/=0 ) THEN
!
!     nlat even  n even  m odd
!
               Zvh = .5*Czv(1)
               DO k = 2 , lc
                  Zvh = Zvh + Czv(k)*cth
                  chh = cdt*cth - sdt*sth
                  sth = sdt*cth + cdt*sth
                  cth = chh
               ENDDO
               RETURN
            ELSE
!
!     nlat even  n even  m even
!
               DO k = 1 , lq
                  Zvh = Zvh + Czv(k+1)*sth
                  chh = cdt*cth - sdt*sth
                  sth = sdt*cth + cdt*sth
                  cth = chh
               ENDDO
               RETURN
            ENDIF
         ELSEIF ( mmod/=0 ) THEN
!
!     nlat even  n odd  m odd
!
            Zvh = .5*Czv(lc)*DCOS((Nlat-1)*Th)
            DO k = 1 , lq
               Zvh = Zvh + Czv(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            GOTO 99999
         ENDIF
      ELSEIF ( nmod/=0 ) THEN
         IF ( mmod/=0 ) THEN
!
!     nlat odd  n odd  m odd
!
            DO k = 1 , lq
               Zvh = Zvh + Czv(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ELSE
!
!     nlat odd  n odd  m even
!
            DO k = 1 , lq
               Zvh = Zvh + Czv(k+1)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ELSE
         cth = cdt
         sth = sdt
         IF ( mmod/=0 ) THEN
!
!     nlat odd  n even  m odd
!
            Zvh = .5*Czv(1)
            DO k = 2 , lq
               Zvh = Zvh + Czv(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            Zvh = Zvh + .5*Czv(lc)*DCOS((Nlat-1)*Th)
            RETURN
         ELSE
!
!     nlat odd  n even  m even
!
            DO k = 1 , ls
               Zvh = Zvh + Czv(k+1)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ENDIF
!
!     nlat even  n odd  m even
!
      DO k = 1 , lq
         Zvh = Zvh + Czv(k+1)*sth
         chh = cdt*cth - sdt*sth
         sth = sdt*cth + cdt*sth
         cth = chh
      ENDDO
      RETURN
99999 END SUBROUTINE DDZVT

      
      SUBROUTINE DDZWK(Nlat,M,N,Czw,Work)
      IMPLICIT NONE
      INTEGER i , id , k , kdo , kp1 , lc , M , mmod , N , Nlat , nmod
!
!     subroutine dzwk computes the coefficients in the trigonometric
!     expansion of the quadrature function zwbar(n,m,theta)
!
!     input parameters
!
!     nlat      the number of colatitudes including the poles.
!
!     n      the degree (subscript) of zwbar(n,m,theta)
!
!     m      the order (superscript) of zwbar(n,m,theta)
!
!     work   a work array with at least (nlat+1)/2 locations
!
!     output parameter
!
!     czw     the fourier coefficients of zwbar(n,m,theta).
!
      DIMENSION Czw(1) , Work(1)
      DOUBLE PRECISION Czw , Work , sc1 , sum , t1 , t2
      IF ( N<=0 ) RETURN
      lc = (Nlat+1)/2
      sc1 = 2.D0/FLOAT(Nlat-1)
      CALL DDWBK(M,N,Work,Czw)
      nmod = MOD(N,2)
      mmod = MOD(M,2)
      IF ( nmod/=0 ) THEN
         IF ( mmod/=0 ) THEN
!
!     n odd, m odd
!
            kdo = (N+1)/2
            DO id = 1 , lc
               i = id + id - 2
               sum = Work(1)/(1.D0-i*i)
               IF ( kdo>=2 ) THEN
                  DO kp1 = 2 , kdo
                     k = kp1 - 1
                     t1 = 1.D0 - (k+k+i)**2
                     t2 = 1.D0 - (k+k-i)**2
                     sum = sum + Work(kp1)*(t1+t2)/(t1*t2)
                  ENDDO
               ENDIF
               Czw(id) = sc1*sum
            ENDDO
            GOTO 99999
         ENDIF
      ELSEIF ( mmod/=0 ) THEN
!
!     n even, m odd
!
         kdo = N/2
         DO id = 1 , lc
            i = id + id - 1
            sum = 0.
            DO k = 1 , kdo
               t1 = 1.D0 - (k+k-1+i)**2
               t2 = 1.D0 - (k+k-1-i)**2
               sum = sum + Work(k)*(t1+t2)/(t1*t2)
            ENDDO
            Czw(id) = sc1*sum
         ENDDO
         RETURN
      ELSE
!
!     n even, m even
!
         kdo = N/2
         DO id = 1 , lc
            i = id + id - 3
            sum = 0.
            DO k = 1 , kdo
               t1 = 1.D0 - (k+k-1+i)**2
               t2 = 1.D0 - (k+k-1-i)**2
               sum = sum + Work(k)*(t1-t2)/(t1*t2)
            ENDDO
            Czw(id) = sc1*sum
         ENDDO
         RETURN
      ENDIF
!
!     n odd, m even
!
      kdo = (N-1)/2
      DO id = 1 , lc
         i = id + id - 2
         sum = 0.
         DO k = 1 , kdo
            t1 = 1.D0 - (k+k+i)**2
            t2 = 1.D0 - (k+k-i)**2
            sum = sum + Work(k)*(t1-t2)/(t1*t2)
         ENDDO
         Czw(id) = sc1*sum
      ENDDO
      RETURN
99999 END SUBROUTINE DDZWK


      SUBROUTINE DDZWT(Nlat,M,N,Th,Czw,Zwh)
      IMPLICIT NONE
      INTEGER k , lc , lmod , lq , ls , M , mmod , N , Nlat , nmod
!
!     subroutine dzwt tabulates the function zwbar(n,m,theta)
!     at theta = th in double precision
!
!     input parameters
!
!     nlat      the number of colatitudes including the poles.
!            nlat must be an odd integer
!
!     n      the degree (subscript) of zwbar(n,m,theta)
!
!     m      the order (superscript) of zwbar(n,m,theta)
!
!     czw     the fourier coefficients of zwbar(n,m,theta)
!             as computed by subroutine zwk.
!
!     output parameter
!
!     zwh     zwbar(m,n,theta) evaluated at theta = th
!
      DIMENSION Czw(1)
      DOUBLE PRECISION Czw , Zwh , Th , cth , sth , cdt , sdt , chh
      Zwh = 0.
      IF ( N<=0 ) RETURN
      lc = (Nlat+1)/2
      lq = lc - 1
      ls = lc - 2
      cth = DCOS(Th)
      sth = DSIN(Th)
      cdt = cth*cth - sth*sth
      sdt = 2.*sth*cth
      lmod = MOD(Nlat,2)
      mmod = MOD(M,2)
      nmod = MOD(N,2)
      IF ( lmod==0 ) THEN
         IF ( nmod/=0 ) THEN
            cth = cdt
            sth = sdt
            IF ( mmod/=0 ) THEN
!
!     nlat even  n odd  m odd
!
               Zwh = .5*Czw(1)
               DO k = 2 , lc
                  Zwh = Zwh + Czw(k)*cth
                  chh = cdt*cth - sdt*sth
                  sth = sdt*cth + cdt*sth
                  cth = chh
               ENDDO
               GOTO 99999
            ENDIF
         ELSEIF ( mmod/=0 ) THEN
!
!     nlat even  n even  m odd
!
            Zwh = .5*Czw(lc)*DCOS((Nlat-1)*Th)
            DO k = 1 , lq
               Zwh = Zwh + Czw(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ELSE
!
!     nlat even  n even  m even
!
            DO k = 1 , lq
               Zwh = Zwh + Czw(k+1)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ELSEIF ( nmod/=0 ) THEN
         cth = cdt
         sth = sdt
         IF ( mmod/=0 ) THEN
!
!     nlat odd  n odd  m odd
!
            Zwh = .5*Czw(1)
            DO k = 2 , lq
               Zwh = Zwh + Czw(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            Zwh = Zwh + .5*Czw(lc)*DCOS((Nlat-1)*Th)
            RETURN
         ELSE
!
!     nlat odd  n odd  m even
!
            DO k = 1 , ls
               Zwh = Zwh + Czw(k+1)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ELSEIF ( mmod/=0 ) THEN
!
!     nlat odd  n even  m odd
!
         DO k = 1 , lq
            Zwh = Zwh + Czw(k)*cth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         RETURN
      ELSE
!
!     nlat odd  n even  m even
!
         DO k = 1 , lq
            Zwh = Zwh + Czw(k+1)*sth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         RETURN
      ENDIF
!
!     nlat even  n odd  m even
!
      DO k = 1 , lq
         Zwh = Zwh + Czw(k+1)*sth
         chh = cdt*cth - sdt*sth
         sth = sdt*cth + cdt*sth
         cth = chh
      ENDDO
      RETURN
99999 END SUBROUTINE DDZWT


      SUBROUTINE DDVBK(M,N,Cv,Work)
      IMPLICIT NONE
      INTEGER l , M , modm , modn , N , ncv
      DOUBLE PRECISION srnp1
      DOUBLE PRECISION Cv(1) , Work(1) , fn , fk , cf
      Cv(1) = 0.
      IF ( N<=0 ) RETURN
      fn = N
      srnp1 = DSQRT(fn*(fn+1.))
      cf = 2.*M/srnp1
      modn = MOD(N,2)
      modm = MOD(M,2)
      CALL DNLFK(M,N,Work)
      IF ( modn/=0 ) THEN
         ncv = (N+1)/2
         fk = -1.
         IF ( modm/=0 ) THEN
!
!     n odd m odd
!
            DO l = 1 , ncv
               fk = fk + 2.
               Cv(l) = fk*Work(l)/srnp1
            ENDDO
            GOTO 99999
         ENDIF
      ELSE
         ncv = N/2
         IF ( ncv==0 ) RETURN
         fk = 0.
         IF ( modm/=0 ) THEN
!
!     n even m odd
!
            DO l = 1 , ncv
               fk = fk + 2.
               Cv(l) = fk*Work(l)/srnp1
            ENDDO
            RETURN
         ELSE
!
!     n even m even
!
            DO l = 1 , ncv
               fk = fk + 2.
               Cv(l) = -fk*Work(l+1)/srnp1
            ENDDO
            RETURN
         ENDIF
      ENDIF
!
!     n odd m even
!
      DO l = 1 , ncv
         fk = fk + 2.
         Cv(l) = -fk*Work(l)/srnp1
      ENDDO
      RETURN
99999 END SUBROUTINE DDVBK


      SUBROUTINE DDWBK(M,N,Cw,Work)
      IMPLICIT NONE
      INTEGER l , M , modm , modn , N
      DOUBLE PRECISION Cw(1) , Work(1) , fn , cf , srnp1
      Cw(1) = 0.
      IF ( N<=0 .OR. M<=0 ) RETURN
      fn = N
      srnp1 = DSQRT(fn*(fn+1.))
      cf = 2.*M/srnp1
      modn = MOD(N,2)
      modm = MOD(M,2)
      CALL DDNLFK(M,N,Work)
      IF ( M/=0 ) THEN
         IF ( modn==0 ) THEN
            l = N/2
            IF ( l/=0 ) THEN
               IF ( modm/=0 ) THEN
!
!     n even m odd
!
                  Cw(l) = cf*Work(l)
 5                l = l - 1
                  IF ( l>0 ) THEN
                     Cw(l) = Cw(l+1) + cf*Work(l)
                     GOTO 5
                  ENDIF
               ELSE
!
!     n even m even
!
                  Cw(l) = -cf*Work(l+1)
 10               l = l - 1
                  IF ( l>0 ) THEN
                     Cw(l) = Cw(l+1) - cf*Work(l+1)
                     GOTO 10
                  ENDIF
               ENDIF
            ENDIF
         ELSEIF ( modm/=0 ) THEN
!
!     n odd m odd
!
            l = (N+1)/2
            Cw(l) = cf*Work(l)
 20         l = l - 1
            IF ( l>0 ) THEN
               Cw(l) = Cw(l+1) + cf*Work(l)
               GOTO 20
            ENDIF
         ELSE
            l = (N-1)/2
            IF ( l/=0 ) THEN
!
!     n odd m even
!
               Cw(l) = -cf*Work(l+1)
 30            l = l - 1
               IF ( l>0 ) THEN
                  Cw(l) = Cw(l+1) - cf*Work(l+1)
                  GOTO 30
               ENDIF
            ENDIF
         ENDIF
      ENDIF
      END SUBROUTINE DDWBK


      SUBROUTINE DDVBT(M,N,Theta,Cv,Vh)
      IMPLICIT NONE
      INTEGER k , M , mmod , N , ncv , nmod
      DIMENSION Cv(1)
      DOUBLE PRECISION Cv , Vh , Theta , cth , sth , cdt , sdt , chh
      Vh = 0.
      IF ( N==0 ) RETURN
      cth = DCOS(Theta)
      sth = DSIN(Theta)
      cdt = cth*cth - sth*sth
      sdt = 2.*sth*cth
      mmod = MOD(M,2)
      nmod = MOD(N,2)
      IF ( nmod==0 ) THEN
         cth = cdt
         sth = sdt
         IF ( mmod/=0 ) THEN
!
!     n even  m odd
!
            ncv = N/2
            DO k = 1 , ncv
               Vh = Vh + Cv(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ELSE
!
!     n even  m even
!
            ncv = N/2
            DO k = 1 , ncv
               Vh = Vh + Cv(k)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ELSEIF ( mmod/=0 ) THEN
!
! case m odd and n odd
!
         ncv = (N+1)/2
         DO k = 1 , ncv
            Vh = Vh + Cv(k)*cth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         GOTO 99999
      ENDIF
!
!     n odd m even
!
      ncv = (N+1)/2
      DO k = 1 , ncv
         Vh = Vh + Cv(k)*sth
         chh = cdt*cth - sdt*sth
         sth = sdt*cth + cdt*sth
         cth = chh
      ENDDO
      RETURN
99999 END SUBROUTINE DDVBT


      SUBROUTINE DDWBT(M,N,Theta,Cw,Wh)
      IMPLICIT NONE
      INTEGER k , M , mmod , N , ncw , nmod
      DIMENSION Cw(1)
      DOUBLE PRECISION Theta , Cw , Wh , cth , sth , cdt , sdt , chh
      Wh = 0.
      IF ( N<=0 .OR. M<=0 ) RETURN
      cth = DCOS(Theta)
      sth = DSIN(Theta)
      cdt = cth*cth - sth*sth
      sdt = 2.*sth*cth
      mmod = MOD(M,2)
      nmod = MOD(N,2)
      IF ( nmod/=0 ) THEN
         cth = cdt
         sth = sdt
         IF ( mmod/=0 ) THEN
!
! case m odd and n odd
!
            ncw = (N+1)/2
            Wh = .5*Cw(1)
            IF ( ncw<2 ) RETURN
            DO k = 2 , ncw
               Wh = Wh + Cw(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            GOTO 99999
         ENDIF
      ELSEIF ( mmod/=0 ) THEN
!
!     n even  m odd
!
         ncw = N/2
         DO k = 1 , ncw
            Wh = Wh + Cw(k)*cth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         RETURN
      ELSE
!
!     n even  m even
!
         ncw = N/2
         DO k = 1 , ncw
            Wh = Wh + Cw(k)*sth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         RETURN
      ENDIF
!
!     n odd m even
!
      ncw = (N-1)/2
      DO k = 1 , ncw
         Wh = Wh + Cw(k)*sth
         chh = cdt*cth - sdt*sth
         sth = sdt*cth + cdt*sth
         cth = chh
      ENDDO
      RETURN
99999 END SUBROUTINE DDWBT


      SUBROUTINE DRABCV(Nlat,Nlon,Abc)
      IMPLICIT NONE
      DOUBLE PRECISION Abc
      INTEGER iw1 , iw2 , labc , mmax , Nlat , Nlon
!
!     subroutine rabcp computes the coefficients in the recurrence
!     relation for the functions vbar(m,n,theta). array abc
!     must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2 locations.
!
      DIMENSION Abc(1)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = (MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      iw1 = labc + 1
      iw2 = iw1 + labc
      CALL DRABCV1(Nlat,Nlon,Abc,Abc(iw1),Abc(iw2))
      END SUBROUTINE DRABCV

      
      SUBROUTINE DRABCV1(Nlat,Nlon,A,B,C)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , C , cn , fm , fn , fnmm , fnpm , temp , tm , tn , tpn
      INTEGER m , mmax , mp1 , mp3 , n , Nlat , Nlon , np1 , ns
!
!     coefficients a, b, and c for computing vbar(m,n,theta) are
!     stored in location ((m-2)*(nlat+nlat-m-1))/2+n+1
!
      DIMENSION A(1) , B(1) , C(1)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( mmax<3 ) RETURN
      DO mp1 = 3 , mmax
         m = mp1 - 1
         ns = ((m-2)*(Nlat+Nlat-m-1))/2 + 1
         fm = FLOAT(m)
         tm = fm + fm
         temp = tm*(tm-1.)
         tpn = (fm-2.)*(fm-1.)/(fm*(fm+1.))
         A(ns) = SQRT(tpn*(tm+1.)*(tm-2.)/temp)
         C(ns) = SQRT(2./temp)
         IF ( m/=Nlat-1 ) THEN
            ns = ns + 1
            temp = tm*(tm+1.)
            tpn = (fm-1.)*fm/((fm+1.)*(fm+2.))
            A(ns) = SQRT(tpn*(tm+3.)*(tm-2.)/temp)
            C(ns) = SQRT(6./temp)
            mp3 = m + 3
            IF ( mp3<=Nlat ) THEN
               DO np1 = mp3 , Nlat
                  n = np1 - 1
                  ns = ns + 1
                  fn = FLOAT(n)
                  tn = fn + fn
                  cn = (tn+1.)/(tn-3.)
                  tpn = (fn-2.)*(fn-1.)/(fn*(fn+1.))
                  fnpm = fn + fm
                  fnmm = fn - fm
                  temp = fnpm*(fnpm-1.)
                  A(ns) = SQRT(tpn*cn*(fnpm-3.)*(fnpm-2.)/temp)
                  B(ns) = SQRT(tpn*cn*fnmm*(fnmm-1.)/temp)
                  C(ns) = SQRT((fnmm+1.)*(fnmm+2.)/temp)
               ENDDO
            ENDIF
         ENDIF
      ENDDO
      END SUBROUTINE DRABCV1


      SUBROUTINE DRABCW(Nlat,Nlon,Abc)
      IMPLICIT NONE
      DOUBLE PRECISION Abc
      INTEGER iw1 , iw2 , labc , mmax , Nlat , Nlon
!
!     subroutine rabcw computes the coefficients in the recurrence
!     relation for the functions wbar(m,n,theta). array abc
!     must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2 locations.
!
      DIMENSION Abc(1)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = (MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      iw1 = labc + 1
      iw2 = iw1 + labc
      CALL DRABCW1(Nlat,Nlon,Abc,Abc(iw1),Abc(iw2))
      END SUBROUTINE DRABCW


      SUBROUTINE DRABCW1(Nlat,Nlon,A,B,C)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , C , cn , fm , fn , fnmm , fnpm , temp , tm , tn ,    &
         & tph , tpn
      INTEGER m , mmax , mp1 , mp3 , n , Nlat , Nlon , np1 , ns
!*** End of declarations inserted by SPAG
!
!     coefficients a, b, and c for computing wbar(m,n,theta) are
!     stored in location ((m-2)*(nlat+nlat-m-1))/2+n+1
!
      DIMENSION A(1) , B(1) , C(1)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( mmax<4 ) RETURN
      DO mp1 = 4 , mmax
         m = mp1 - 1
         ns = ((m-2)*(Nlat+Nlat-m-1))/2 + 1
         fm = FLOAT(m)
         tm = fm + fm
         temp = tm*(tm-1.)
         tpn = (fm-2.)*(fm-1.)/(fm*(fm+1.))
         tph = fm/(fm-2.)
         A(ns) = tph*SQRT(tpn*(tm+1.)*(tm-2.)/temp)
         C(ns) = tph*SQRT(2./temp)
         IF ( m/=Nlat-1 ) THEN
            ns = ns + 1
            temp = tm*(tm+1.)
            tpn = (fm-1.)*fm/((fm+1.)*(fm+2.))
            tph = fm/(fm-2.)
            A(ns) = tph*SQRT(tpn*(tm+3.)*(tm-2.)/temp)
            C(ns) = tph*SQRT(6./temp)
            mp3 = m + 3
            IF ( mp3<=Nlat ) THEN
               DO np1 = mp3 , Nlat
                  n = np1 - 1
                  ns = ns + 1
                  fn = FLOAT(n)
                  tn = fn + fn
                  cn = (tn+1.)/(tn-3.)
                  fnpm = fn + fm
                  fnmm = fn - fm
                  temp = fnpm*(fnpm-1.)
                  tpn = (fn-2.)*(fn-1.)/(fn*(fn+1.))
                  tph = fm/(fm-2.)
                  A(ns) = tph*SQRT(tpn*cn*(fnpm-3.)*(fnpm-2.)/temp)
                  B(ns) = SQRT(tpn*cn*fnmm*(fnmm-1.)/temp)
                  C(ns) = tph*SQRT((fnmm+1.)*(fnmm+2.)/temp)
               ENDDO
            ENDIF
         ENDIF
      ENDDO
      END SUBROUTINE  DRABCW1

      
      SUBROUTINE DVTINIT(Nlat,Nlon,Wvbin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      DOUBLE PRECISION Wvbin
      DIMENSION Wvbin(*)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of dwork is 2*nlat+2
!
      CALL DVTINI1(Nlat,Nlon,imid,Wvbin,Wvbin(iw1),Dwork,Dwork(Nlat+2))
      END SUBROUTINE DVTINIT


      SUBROUTINE DVTINI1(Nlat,Nlon,Imid,Vb,Abc,Cvb,Work)
      IMPLICIT NONE
      DOUBLE PRECISION Abc , Vb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     cvb and work must each have nlat+1 locations
!
      DIMENSION Vb(Imid,Nlat,2) , Abc(1) , Cvb(1)
      DOUBLE PRECISION pi , dt , Cvb , th , vbh , Work(*)
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      mdo = MIN0(2,Nlat,(Nlon+1)/2)
      DO mp1 = 1 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DDVTK(m,n,Cvb,Work)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DDVTT(m,n,th,Cvb,vbh)
               Vb(i,np1,mp1) = vbh
            ENDDO
         ENDDO
      ENDDO
      CALL DRABCV(Nlat,Nlon,Abc)
      END SUBROUTINE DVTINI1


      SUBROUTINE DWTINIT(Nlat,Nlon,Wwbin,Dwork)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      DOUBLE PRECISION Wwbin
      DIMENSION Wwbin(1)
      DOUBLE PRECISION Dwork(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of dwork is 2*nlat+2
!
      CALL DWTINI1(Nlat,Nlon,imid,Wwbin,Wwbin(iw1),Dwork,Dwork(Nlat+2))
      END SUBROUTINE DWTINIT


      SUBROUTINE DWTINI1(Nlat,Nlon,Imid,Wb,Abc,Cwb,Work)
      IMPLICIT NONE
      DOUBLE PRECISION Abc , Wb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     cwb and work must each have nlat+1 locations
!
      DIMENSION Wb(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION pi , dt , Cwb(*) , wbh , th , Work(*)
      pi = 4.*DATAN(1.D0)
      dt = pi/(Nlat-1)
      mdo = MIN0(3,Nlat,(Nlon+1)/2)
      IF ( mdo<2 ) RETURN
      DO mp1 = 2 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DDWTK(m,n,Cwb,Work)
            DO i = 1 , Imid
               th = (i-1)*dt
               CALL DWTT(m,n,th,Cwb,wbh)
               Wb(i,np1,m) = wbh
            ENDDO
         ENDDO
      ENDDO
      CALL DRABCW(Nlat,Nlon,Abc)
      END SUBROUTINE DWTINI1


      SUBROUTINE DVTGINT(Nlat,Nlon,Theta,Wvbin,Work)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      DOUBLE PRECISION Wvbin
      DIMENSION Wvbin(*)
      DOUBLE PRECISION Theta(*) , Work(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     theta is a double precision array with (nlat+1)/2 locations
!     nlat is the maximum value of n+1
!     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of work is 2*nlat+2
!
      CALL DVTGIT1(Nlat,Nlon,imid,Theta,Wvbin,Wvbin(iw1),Work,           &
                & Work(Nlat+2))
!    1                        work,work(2*nlat+3))
      END SUBROUTINE DVTGINT


      SUBROUTINE DVTGIT1(Nlat,Nlon,Imid,Theta,Vb,Abc,Cvb,Work)
      IMPLICIT NONE
      DOUBLE PRECISION Abc , Vb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     cvb and work must each have nlat+1   locations
!
      DIMENSION Vb(Imid,Nlat,2) , Abc(*)
      DOUBLE PRECISION Theta(*) , Cvb(*) , Work(*) , vbh
      mdo = MIN0(2,Nlat,(Nlon+1)/2)
      DO mp1 = 1 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DDVTK(m,n,Cvb,Work)
            DO i = 1 , Imid
               CALL DDVTT(m,n,Theta(i),Cvb,vbh)
               Vb(i,np1,mp1) = vbh
            ENDDO
         ENDDO
      ENDDO
      CALL DRABCV(Nlat,Nlon,Abc)
    END SUBROUTINE DVTGIT1


      SUBROUTINE DWTGINT(Nlat,Nlon,Theta,Wwbin,Work)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      DOUBLE PRECISION Wwbin
      DIMENSION Wwbin(*)
      DOUBLE PRECISION Theta(*) , Work(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     theta is a double precision array with (nlat+1)/2 locations
!     nlat is the maximum value of n+1
!     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of work is 2*nlat+2
!
      CALL DWTGIT1(Nlat,Nlon,imid,Theta,Wwbin,Wwbin(iw1),Work,           &
                & Work(Nlat+2))
      END SUBROUTINE DWTGINT


      SUBROUTINE DWTGIT1(Nlat,Nlon,Imid,Theta,Wb,Abc,Cwb,Work)
      IMPLICIT NONE
      DOUBLE PRECISION Abc , Wb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*((nlat-3)*nlat+2)/2 locations
!     cwb and work must each have nlat+1 locations
!
      DIMENSION Wb(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION Theta(*) , Cwb(*) , Work(*) , wbh
      mdo = MIN0(3,Nlat,(Nlon+1)/2)
      IF ( mdo<2 ) RETURN
      DO mp1 = 2 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DDWTK(m,n,Cwb,Work)
            DO i = 1 , Imid
               CALL DDWTT(m,n,Theta(i),Cwb,wbh)
               Wb(i,np1,m) = wbh
            ENDDO
         ENDDO
      ENDDO
      CALL DRABCW(Nlat,Nlon,Abc)
      END SUBROUTINE DWTGIT1


      SUBROUTINE DDVTK(M,N,Cv,Work)
      IMPLICIT NONE
      INTEGER l , M , modm , modn , N , ncv
      DOUBLE PRECISION Cv(*) , Work(*) , fn , fk , cf , srnp1
      Cv(1) = 0.
      IF ( N<=0 ) RETURN
      fn = N
      srnp1 = DSQRT(fn*(fn+1.))
      cf = 2.*M/srnp1
      modn = MOD(N,2)
      modm = MOD(M,2)
      CALL DDNLFK(M,N,Work)
      IF ( modn/=0 ) THEN
         ncv = (N+1)/2
         fk = -1.
         IF ( modm/=0 ) THEN
!
!     n odd m odd
!
            DO l = 1 , ncv
               fk = fk + 2.
               Cv(l) = -fk*fk*Work(l)/srnp1
            ENDDO
            GOTO 99999
         ENDIF
      ELSE
         ncv = N/2
         IF ( ncv==0 ) RETURN
         fk = 0.
         IF ( modm/=0 ) THEN
!
!     n even m odd
!
            DO l = 1 , ncv
               fk = fk + 2.
               Cv(l) = -fk*fk*Work(l)/srnp1
            ENDDO
            RETURN
         ELSE
!
!     n even m even
!
            DO l = 1 , ncv
               fk = fk + 2.
               Cv(l) = -fk*fk*Work(l+1)/srnp1
            ENDDO
            RETURN
         ENDIF
      ENDIF
!
!     n odd m even
!
      DO l = 1 , ncv
         fk = fk + 2.
         Cv(l) = -fk*fk*Work(l)/srnp1
      ENDDO
      RETURN
99999 END SUBROUTINE DDVTK


      SUBROUTINE DDWTK(M,N,Cw,Work)
      IMPLICIT NONE
      INTEGER l , M , modm , modn , N
      DOUBLE PRECISION Cw(*) , Work(*) , fn , cf , srnp1
      Cw(1) = 0.
      IF ( N<=0 .OR. M<=0 ) RETURN
      fn = N
      srnp1 = DSQRT(fn*(fn+1.))
      cf = 2.*M/srnp1
      modn = MOD(N,2)
      modm = MOD(M,2)
      CALL DDNLFK(M,N,Work)
      IF ( M==0 ) GOTO 99999
      IF ( modn==0 ) THEN
         l = N/2
         IF ( l==0 ) GOTO 99999
         IF ( modm/=0 ) THEN
!
!     n even m odd
!
            Cw(l) = cf*Work(l)
         ELSE
!
!     n even m even
!
            Cw(l) = -cf*Work(l+1)
 20         l = l - 1
            IF ( l<=0 ) GOTO 99999
            Cw(l) = Cw(l+1) - cf*Work(l+1)
            Cw(l+1) = (l+l+1)*Cw(l+1)
            GOTO 20
         ENDIF
      ELSEIF ( modm/=0 ) THEN
!
!     n odd m odd
!
         l = (N+1)/2
         Cw(l) = cf*Work(l)
         GOTO 300
      ELSE
         l = (N-1)/2
         IF ( l==0 ) GOTO 99999
!
!     n odd m even
!
         Cw(l) = -cf*Work(l+1)
         GOTO 200
      ENDIF
 100  l = l - 1
      IF ( l<0 ) GOTO 99999
      IF ( l/=0 ) Cw(l) = Cw(l+1) + cf*Work(l)
      Cw(l+1) = -(l+l+1)*Cw(l+1)
      GOTO 100
 200  l = l - 1
      IF ( l<0 ) GOTO 99999
      IF ( l/=0 ) Cw(l) = Cw(l+1) - cf*Work(l+1)
      Cw(l+1) = (l+l+2)*Cw(l+1)
      GOTO 200
 300  l = l - 1
      IF ( l<0 ) GOTO 99999
      IF ( l/=0 ) Cw(l) = Cw(l+1) + cf*Work(l)
      Cw(l+1) = -(l+l)*Cw(l+1)
      GOTO 300
99999 END SUBROUTINE DDWTK 


      SUBROUTINE DDVTT(M,N,Theta,Cv,Vh)
      IMPLICIT NONE
      INTEGER k , M , mmod , N , ncv , nmod
      DIMENSION Cv(1)
      DOUBLE PRECISION Cv , Vh , Theta , cth , sth , cdt , sdt , chh
      Vh = 0.
      IF ( N==0 ) RETURN
      cth = DCOS(Theta)
      sth = DSIN(Theta)
      cdt = cth*cth - sth*sth
      sdt = 2.*sth*cth
      mmod = MOD(M,2)
      nmod = MOD(N,2)
      IF ( nmod==0 ) THEN
         cth = cdt
         sth = sdt
         IF ( mmod/=0 ) THEN
!
!     n even  m odd
!
            ncv = N/2
            DO k = 1 , ncv
               Vh = Vh + Cv(k)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ELSE
!
!     n even  m even
!
            ncv = N/2
            DO k = 1 , ncv
               Vh = Vh + Cv(k)*cth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            RETURN
         ENDIF
      ELSEIF ( mmod/=0 ) THEN
!
! case m odd and n odd
!
         ncv = (N+1)/2
         DO k = 1 , ncv
            Vh = Vh + Cv(k)*sth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         GOTO 99999
      ENDIF
!
!     n odd m even
!
      ncv = (N+1)/2
      DO k = 1 , ncv
         Vh = Vh + Cv(k)*cth
         chh = cdt*cth - sdt*sth
         sth = sdt*cth + cdt*sth
         cth = chh
      ENDDO
      RETURN
99999 END SUBROUTINE DDVTT


      SUBROUTINE DDWTT(M,N,Theta,Cw,Wh)
      IMPLICIT NONE
      INTEGER k , M , mmod , N , ncw , nmod
      DIMENSION Cw(1)
      DOUBLE PRECISION Theta , Cw , Wh , cth , sth , cdt , sdt , chh
      Wh = 0.
      IF ( N<=0 .OR. M<=0 ) RETURN
      cth = DCOS(Theta)
      sth = DSIN(Theta)
      cdt = cth*cth - sth*sth
      sdt = 2.*sth*cth
      mmod = MOD(M,2)
      nmod = MOD(N,2)
      IF ( nmod/=0 ) THEN
         cth = cdt
         sth = sdt
         IF ( mmod/=0 ) THEN
!
! case m odd and n odd
!
            ncw = (N+1)/2
            Wh = 0.
            IF ( ncw<2 ) RETURN
            DO k = 2 , ncw
               Wh = Wh + Cw(k)*sth
               chh = cdt*cth - sdt*sth
               sth = sdt*cth + cdt*sth
               cth = chh
            ENDDO
            GOTO 99999
         ENDIF
      ELSEIF ( mmod/=0 ) THEN
!
!     n even  m odd
!
         ncw = N/2
         DO k = 1 , ncw
            Wh = Wh + Cw(k)*sth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         RETURN
      ELSE
!
!     n even  m even
!
         ncw = N/2
         DO k = 1 , ncw
            Wh = Wh + Cw(k)*cth
            chh = cdt*cth - sdt*sth
            sth = sdt*cth + cdt*sth
            cth = chh
         ENDDO
         RETURN
      ENDIF
!
!     n odd m even
!
      ncw = (N-1)/2
      DO k = 1 , ncw
         Wh = Wh + Cw(k)*cth
         chh = cdt*cth - sdt*sth
         sth = sdt*cth + cdt*sth
         cth = chh
      ENDDO
      RETURN
99999 END SUBROUTINE DDWTT


      SUBROUTINE DVBGINT(Nlat,Nlon,Theta,Wvbin,Work)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      DOUBLE PRECISION Wvbin
      DIMENSION Wvbin(1)
      DOUBLE PRECISION Theta(*) , Work(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     theta is a double precision array with (nlat+1)/2 locations
!     nlat is the maximum value of n+1
!     the length of wvbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of work is 2*nlat+2
!
      CALL DVBGIT1(Nlat,Nlon,imid,Theta,Wvbin,Wvbin(iw1),Work,           &
                & Work(Nlat+2))
!    1                        work,work(2*nlat+3))
      END SUBROUTINE DVBGINT


      SUBROUTINE DVBGIT1(Nlat,Nlon,Imid,Theta,Vb,Abc,Cvb,Work)
      IMPLICIT NONE
      DOUBLE PRECISION Abc , Vb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*(max0(mmax-2,0)*(nlat+nlat-mmax-1))/2
!     locations where mmax = min0(nlat,(nlon+1)/2)
!     cvb and work must each have nlat+1 locations
!
      DIMENSION Vb(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION Cvb(1) , Theta(1) , vbh , Work(1)
      mdo = MIN0(2,Nlat,(Nlon+1)/2)
      DO mp1 = 1 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DDVBK(m,n,Cvb,Work)
            DO i = 1 , Imid
               CALL DDVBT(m,n,Theta(i),Cvb,vbh)
               Vb(i,np1,mp1) = vbh
            ENDDO
         ENDDO
      ENDDO
      CALL DRABCV(Nlat,Nlon,Abc)
      END SUBROUTINE DVBGIT1


      SUBROUTINE DWBGINT(Nlat,Nlon,Theta,Wwbin,Work)
      IMPLICIT NONE
      INTEGER imid , iw1 , Nlat , Nlon
      DOUBLE PRECISION Wwbin
      DIMENSION Wwbin(1)
      DOUBLE PRECISION Work(*) , Theta(*)
      imid = (Nlat+1)/2
      iw1 = 2*Nlat*imid + 1
!
!     theta is a double precision array with (nlat+1)/2 locations
!     nlat is the maximum value of n+1
!     the length of wwbin is 2*nlat*imid+3*((nlat-3)*nlat+2)/2
!     the length of work is 2*nlat+2
!
      CALL DWBGIT1(Nlat,Nlon,imid,Theta,Wwbin,Wwbin(iw1),Work,           &
                & Work(Nlat+2))
      END SUBROUTINE DWBGINT

      
      SUBROUTINE DWBGIT1(Nlat,Nlon,Imid,Theta,Wb,Abc,Cwb,Work)
      IMPLICIT NONE
      DOUBLE PRECISION Abc , Wb
      INTEGER i , Imid , m , mdo , mp1 , n , Nlat , Nlon , np1
!
!     abc must have 3*((nlat-3)*nlat+2)/2 locations
!     cwb and work must each have nlat+1 locations
!
      DIMENSION Wb(Imid,Nlat,2) , Abc(1)
      DOUBLE PRECISION Cwb(1) , Theta(1) , wbh , Work(1)
      mdo = MIN0(3,Nlat,(Nlon+1)/2)
      IF ( mdo<2 ) RETURN
      DO mp1 = 2 , mdo
         m = mp1 - 1
         DO np1 = mp1 , Nlat
            n = np1 - 1
            CALL DDWBK(m,n,Cwb,Work)
            DO i = 1 , Imid
               CALL DDWBT(m,n,Theta(i),Cwb,wbh)
               Wb(i,np1,m) = wbh
            ENDDO
         ENDDO
      ENDDO
      CALL DRABCW(Nlat,Nlon,Abc)
    END SUBROUTINE DWBGIT1

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file divgc.f
!
!     this file includes documentation and code for
!     subroutine divgc          i
!
! ... files which must be loaded with divgc.f
!
!     sphcom.f, hrfft.f, vhagc.f, shsgc.f, gaqd.f
!
!
!     subroutine divgc(nlat,nlon,isym,nt,dv,idv,jdv,br,bi,mdb,ndb,
!    +                 wshsgc,lshsgc,work,lwork,ierror)
!
!     given the vector spherical harmonic coefficients br and bi, precomputed
!     by subroutine vhagc for a vector field (v,w), subroutine divgc
!     computes the divergence of the vector field in the scalar array dv.
!     dv(i,j) is the divergence at the gaussian colatitude point theta(i)
!     (see nlat as input parameter) and east longitude
!
!            lambda(j) = (j-1)*2*pi/nlon
!
!     on the sphere.  i.e.
!
!            dv(i,j) = 1/sint*[ d(sint*v(i,j))/dtheta + d(w(i,j))/dlambda ]
!
!     where sint = sin(theta(i)).  w is the east longitudinal and v
!     is the colatitudinal component of the vector field from which
!     br,bi were precomputed.  required associated legendre polynomials
!     are recomputed rather than stored as they are in subroutine divgs.
!
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are computed
!            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid point
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than zero. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!
!     isym   a parameter which determines whether the divergence is
!            computed on the full or half sphere as follows:
!
!      = 0
!
!            the symmetries/antsymmetries described in isym=1,2 below
!            do not exist in (v,w) about the equator.  in this case the
!            divergence is neither symmetric nor antisymmetric about
!            the equator.  the divergence is computed on the entire
!            sphere.  i.e., in the array dv(i,j) for i=1,...,nlat and
!            j=1,...,nlon.
!
!      = 1
!
!            w is antisymmetric and v is symmetric about the equator.
!            in this case the divergence is antisymmetyric about
!            the equator and is computed for the northern hemisphere
!            only.  i.e., if nlat is odd the divergence is computed
!            in the array dv(i,j) for i=1,...,(nlat+1)/2 and for
!            j=1,...,nlon.  if nlat is even the divergence is computed
!            in the array dv(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!      = 2
!            w is symmetric and v is antisymmetric about the equator
!            in this case the divergence is symmetyric about the
!            equator and is computed for the northern hemisphere
!            only.  i.e., if nlat is odd the divergence is computed
!            in the array dv(i,j) for i=1,...,(nlat+1)/2 and for
!            j=1,...,nlon.  if nlat is even the divergence is computed
!            in the array dv(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!
!     nt     nt is the number of scalar and vector fields.  some
!            computational efficiency is obtained for multiple fields.
!            in the program that calls divgc, the arrays br,bi, and dv
!            can be three dimensional corresponding to an indexed multiple
!            vector field.  in this case multiple scalar synthesis will
!            be performed to compute the divergence for each field.  the
!            third index is the synthesis index which assumes the values
!            k=1,...,nt.  for a single synthesis set nt = 1.  the
!            description of the remaining parameters is simplified by
!            assuming that nt=1 or that all the arrays are two dimensional.
!
!     idv    the first dimension of the array dv as it appears in
!            the program that calls divgc. if isym = 0 then idv
!            must be at least nlat.  if isym = 1 or 2 and nlat is
!            even then idv must be at least nlat/2. if isym = 1 or 2
!            and nlat is odd then idv must be at least (nlat+1)/2.
!
!     jdv    the second dimension of the array dv as it appears in
!            the program that calls divgc. jdv must be at least nlon.
!
!     br,bi  two or three dimensional arrays (see input parameter nt)
!            that contain vector spherical harmonic coefficients
!            of the vector field (v,w) as computed by subroutine vhagc.
!     ***    br and bi must be computed by vhagc prior to calling
!            divgc.
!
!     mdb    the first dimension of the arrays br and bi as it
!            appears in the program that calls divgc. mdb must be at
!            least min0(nlat,nlon/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndb    the second dimension of the arrays br and bi as it
!            appears in the program that calls divgc. ndb must be at
!            least nlat.
!
!
!     wshsgc an array which must be initialized by subroutine shsgci
!            once initialized, wshsgc can be used repeatedly by divgc
!            as long as nlon and nlat remain unchanged.  wshsgc must
!            not be altered between calls of divgc.
!
!
!     lshsgc the dimension of the array wshsgc as it appears in the
!            program that calls divgc. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshsgc must be at least
!
!               nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls divgc. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2                    if nlat is even or
!               l2 = (nlat+1)/2                if nlat is odd
!
!
!            if isym is zero then lwork must be at least
!
!               nlat*(nlon*nt+max0(3*l2,nlon) + 2*nt*l1+1)
!
!            if isym is not zero then lwork must be at least
!
!               l2*(nlon*nt+max0(3*nlat,nlon)) + nlat*(2*nt*l1+1)
!
!
!     **************************************************************
!
!     output parameters
!
!
!    dv     a two or three dimensional array (see input parameter nt)
!           that contains the divergence of the vector field (v,w)
!           whose coefficients br,bi where computed by subroutine
!           vhagc.  dv(i,j) is the divergence at the gaussian colatitude
!           point theta(i) and longitude point lambda(j) = (j-1)*2*pi/nlon.
!           the index ranges are defined above at the input parameter
!           isym.
!
!
!    ierror = 0  no errors
!           = 1  error in the specification of nlat
!           = 2  error in the specification of nlon
!           = 3  error in the specification of isym
!           = 4  error in the specification of nt
!           = 5  error in the specification of idv
!           = 6  error in the specification of jdv
!           = 7  error in the specification of mdb
!           = 8  error in the specification of ndb
!           = 9  error in the specification of lshsgc
!           = 10 error in the specification of lwork
! **********************************************************************
!
!
      SUBROUTINE DIVGC(Nlat,Nlon,Isym,Nt,Dv,Idv,Jdv,Br,Bi,Mdb,Ndb,      &
                     & Wshsgc,Lshsgc,Work,Lwork,Ierror)
      IMPLICIT NONE

      REAL Bi , Br , Dv , Work , Wshsgc
      INTEGER ia , ib , Idv , Ierror , imid , is , Isym , iwk , Jdv ,   &
            & l1 , l2 , lpimn , ls , Lshsgc , lwk , lwkmin , Lwork ,    &
            & mab , Mdb , mmax
      INTEGER mn , Ndb , Nlat , nln , Nlon , Nt

 
      DIMENSION Dv(Idv,Jdv,Nt) , Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt)
      DIMENSION Wshsgc(Lshsgc) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idv<Nlat) .OR. (Isym>0 .AND. Idv<imid) )      &
         & RETURN
      Ierror = 6
      IF ( Jdv<Nlon ) RETURN
      Ierror = 7
      IF ( Mdb<MIN0(Nlat,(Nlon+1)/2) ) RETURN
      mmax = MIN0(Nlat,(Nlon+2)/2)
      Ierror = 8
      IF ( Ndb<Nlat ) RETURN
      Ierror = 9
      imid = (Nlat+1)/2
      lpimn = (imid*mmax*(Nlat+Nlat-mmax+1))/2
!     check permanent work space length
      l2 = (Nlat+1)/2
      l1 = MIN0((Nlon+2)/2,Nlat)
      IF ( Lshsgc<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 10
!
!     verify unsaved work space (add to what shsgc requires)
!
      ls = Nlat
      IF ( Isym>0 ) ls = imid
      nln = Nt*ls*Nlon
!
!     set first dimension for a,b (as requried by shsgc)
!
      mab = MIN0(Nlat,Nlon/2+1)
      mn = mab*Nlat*Nt
!     if(lwork.lt. nln+ls*nlon+2*mn+nlat) return
      l1 = MIN0(Nlat,(Nlon+2)/2)
      l2 = (Nlat+1)/2
      IF ( Isym==0 ) THEN
         lwkmin = Nlat*(Nt*Nlon+MAX0(3*l2,Nlon)+2*Nt*l1+1)
      ELSE
         lwkmin = l2*(Nt*Nlon+MAX0(3*Nlat,Nlon)) + Nlat*(2*Nt*l1+1)
      ENDIF
      IF ( Lwork<lwkmin ) RETURN
 
 
      Ierror = 0
!
!     set work space pointers
!
      ia = 1
      ib = ia + mn
      is = ib + mn
      iwk = is + Nlat
      lwk = Lwork - 2*mn - Nlat
      CALL DIVGC1(Nlat,Nlon,Isym,Nt,Dv,Idv,Jdv,Br,Bi,Mdb,Ndb,Work(ia),  &
                & Work(ib),mab,Work(is),Wshsgc,Lshsgc,Work(iwk),lwk,    &
                & Ierror)
      END SUBROUTINE DIVGC

      
      SUBROUTINE DDIVGC(Nlat,Nlon,Isym,Nt,Dv,Idv,Jdv,Br,Bi,Mdb,Ndb,      &
                     & Wshsgc,Lshsgc,Work,Lwork,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION  Bi , Br , Dv , Work , Wshsgc
      INTEGER ia , ib , Idv , Ierror , imid , is , Isym , iwk , Jdv ,   &
            & l1 , l2 , lpimn , ls , Lshsgc , lwk , lwkmin , Lwork ,    &
            & mab , Mdb , mmax
      INTEGER mn , Ndb , Nlat , nln , Nlon , Nt
      
      DIMENSION Dv(Idv,Jdv,Nt) , Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt)
      DIMENSION Wshsgc(Lshsgc) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Idv<Nlat) .OR. (Isym>0 .AND. Idv<imid) )      &
         & RETURN
      Ierror = 6
      IF ( Jdv<Nlon ) RETURN
      Ierror = 7
      IF ( Mdb<MIN0(Nlat,(Nlon+1)/2) ) RETURN
      mmax = MIN0(Nlat,(Nlon+2)/2)
      Ierror = 8
      IF ( Ndb<Nlat ) RETURN
      Ierror = 9
      imid = (Nlat+1)/2
      lpimn = (imid*mmax*(Nlat+Nlat-mmax+1))/2
!     check permanent work space length
      l2 = (Nlat+1)/2
      l1 = MIN0((Nlon+2)/2,Nlat)
      IF ( Lshsgc<Nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+Nlon+15 ) RETURN
      Ierror = 10
!
!     verify unsaved work space (add to what shsgc requires)
!
      ls = Nlat
      IF ( Isym>0 ) ls = imid
      nln = Nt*ls*Nlon
!
!     set first dimension for a,b (as requried by shsgc)
!
      mab = MIN0(Nlat,Nlon/2+1)
      mn = mab*Nlat*Nt
!     if(lwork.lt. nln+ls*nlon+2*mn+nlat) return
      l1 = MIN0(Nlat,(Nlon+2)/2)
      l2 = (Nlat+1)/2
      IF ( Isym==0 ) THEN
         lwkmin = Nlat*(Nt*Nlon+MAX0(3*l2,Nlon)+2*Nt*l1+1)
      ELSE
         lwkmin = l2*(Nt*Nlon+MAX0(3*Nlat,Nlon)) + Nlat*(2*Nt*l1+1)
      ENDIF
      IF ( Lwork<lwkmin ) RETURN
 
 
      Ierror = 0
!
!     set work space pointers
!
      ia = 1
      ib = ia + mn
      is = ib + mn
      iwk = is + Nlat
      lwk = Lwork - 2*mn - Nlat
      CALL DDIVGC1(Nlat,Nlon,Isym,Nt,Dv,Idv,Jdv,Br,Bi,Mdb,Ndb,Work(ia),  &
                & Work(ib),mab,Work(is),Wshsgc,Lshsgc,Work(iwk),lwk,    &
                & Ierror)
      END SUBROUTINE DDIVGC

 
      SUBROUTINE DIVGC1(Nlat,Nlon,Isym,Nt,Dv,Idv,Jdv,Br,Bi,Mdb,Ndb,A,B, &
                      & Mab,Sqnn,Wshsgc,Lshsgc,Wk,Lwk,Ierror)
      IMPLICIT NONE

      REAL A , B , Bi , Br , Dv , fn , Sqnn
      REAL, DIMENSION(Lwk)    :: Wk
      REAL, DIMENSION(Lshsgc) :: Wshsgc 
      INTEGER Idv , Ierror , Isym , Jdv , k , Lshsgc , Lwk , m , Mab ,  &
            & Mdb , mmax , n , Ndb , Nlat , Nlon , Nt

      DIMENSION Dv(Idv,Jdv,Nt) , Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt)
      DIMENSION A(Mab,Nlat,Nt) , B(Mab,Nlat,Nt) , Sqnn(Nlat)
!
!     set coefficient multiplyers
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.))
      ENDDO
!
!     compute divergence scalar coefficients for each vector field
!
      DO k = 1 , Nt
         DO n = 1 , Nlat
            DO m = 1 , Mab
               A(m,n,k) = 0.0
               B(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            A(1,n,k) = -Sqnn(n)*Br(1,n,k)
            B(1,n,k) = -Sqnn(n)*Bi(1,n,k)
         ENDDO
!
!     compute m>0 coefficients using vector spherepack value for mmax
!
         mmax = MIN0(Nlat,(Nlon+1)/2)
         DO m = 2 , mmax
            DO n = m , Nlat
               A(m,n,k) = -Sqnn(n)*Br(m,n,k)
               B(m,n,k) = -Sqnn(n)*Bi(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     synthesize a,b into dv
!
      CALL SHSGC(Nlat,Nlon,Isym,Nt,Dv,Idv,Jdv,A,B,Mab,Nlat,Wshsgc,      &
               & Lshsgc,Wk,Lwk,Ierror)
    END SUBROUTINE DIVGC1

    
    SUBROUTINE DDIVGC1(Nlat,Nlon,Isym,Nt,Dv,Idv,Jdv,Br,Bi,Mdb,Ndb,A,B, &
                      & Mab,Sqnn,Wshsgc,Lshsgc,Wk,Lwk,Ierror)
      IMPLICIT NONE

      DOUBLE PRECISION  A , B , Bi , Br , Dv , fn , Sqnn
      DOUBLE PRECISION, DIMENSION(Lwk)    :: Wk
      DOUBLE PRECISION, DIMENSION(Lshsgc) :: Wshsgc 
      INTEGER Idv , Ierror , Isym , Jdv , k , Lshsgc , Lwk , m , Mab ,  &
            & Mdb , mmax , n , Ndb , Nlat , Nlon , Nt

      DIMENSION Dv(Idv,Jdv,Nt) , Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt)
      DIMENSION A(Mab,Nlat,Nt) , B(Mab,Nlat,Nt) , Sqnn(Nlat)
!
!     set coefficient multiplyers
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.))
      ENDDO
!
!     compute divergence scalar coefficients for each vector field
!
      DO k = 1 , Nt
         DO n = 1 , Nlat
            DO m = 1 , Mab
               A(m,n,k) = 0.0
               B(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            A(1,n,k) = -Sqnn(n)*Br(1,n,k)
            B(1,n,k) = -Sqnn(n)*Bi(1,n,k)
         ENDDO
!
!     compute m>0 coefficients using vector spherepack value for mmax
!
         mmax = MIN0(Nlat,(Nlon+1)/2)
         DO m = 2 , mmax
            DO n = m , Nlat
               A(m,n,k) = -Sqnn(n)*Br(m,n,k)
               B(m,n,k) = -Sqnn(n)*Bi(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     synthesize a,b into dv
!
      CALL DSHSGC(Nlat,Nlon,Isym,Nt,Dv,Idv,Jdv,A,B,Mab,Nlat,Wshsgc,      &
               & Lshsgc,Wk,Lwk,Ierror)
      END  SUBROUTINE  DDIVGC1

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c ... file trvsph.f
c
c     this file contains documentation and code for subroutine trvsph
c
c ... required files
c
c     sphcom.f, hrfft.f, gaqd.f, vhaec.f, vhsec.f, vhagc.f, vhsgc.f
c
c     subroutine trvsph (intl,igrida,nlona,nlata,iveca,ua,va,
c    +igridb,nlonb,nlatb,ivecb,ub,vb,wsave,lsave,lsvmin,work,
c    +lwork,lwkmin,dwork,ldwork,ier)
c
c *** author
c
c     John C. Adams (NCAR 1997), email: johnad@ncar.ucar.edu
c
c *** purpose
c
c     subroutine trvsph transfers vector data given in (ua,va) on a grid on
c     the full sphere to vector data in (ub,vb) on a grid on the full sphere.
c     the grids on which (ua,va) is given and (ub,vb) is generated can be
c     specified independently of each other (see the input arguments igrida,
c     igridb,iveca,ivecb).  ua and ub are the east longitudinal components of
c     the given and transformed vector fields.  va is either the latitudinal
c     or colatitudinal component of the given vector field (see iveca).
c     vb is either the latitudinal or colatitudinal component of the
c     transformed vector field (see ivecb).  for transferring scalar data
c     on the sphere, use subroutine trssph.
c
c *   notice that scalar and vector quantities are fundamentally different
c     on the sphere.  for example, vectors are discontinuous and multiple
c     valued at the poles.  scalars are continuous and single valued at the
c     poles. erroneous results would be produced if one attempted to transfer
c     vector fields between grids with subroutine trssph applied to each
c     component of the vector.
c
c *** underlying grid assumptions and a description
c
c     discussions with the ncar scd data support group and others indicate
c     there is no standard grid for storing observational or model generated
c     data on the sphere.  subroutine trvsph was designed to handle most
c     cases likely to be encountered when moving data from one grid format
c     to another.
c
c     the grid on which (ua,va) is given must be equally spaced in longitude
c     and either equally spaced or gaussian in latitude (or colatitude).
c     longitude, which can be either the first or second dimension of ua,va
c     subdivides [0,2pi) excluding the periodic point 2pi.  (co)latitude,
c     which can be the second or first dimension of ua,va, has south
c     to north or north to south orientation with increasing subscript
c     value in ua,va (see the argument igrida).
c
c     the grid on which ub,vb is generated must be equally spaced in longitude
c     and either equally spaced or gaussian in latitude (or colatitude).
c     longitude, which can be either the first or second dimension of ub,vb
c     subdivides [0,2pi) excluding the periodic point 2pi.  (co)latitude,
c     which can be the second or first dimension of ub,vb, has south
c     to north or north to south orientation with increasing subscript
c     value in db (see the argument igridb).
c
c     let nlon be either nlona or nlonb (the number of grid points in
c     longitude.  the longitude grid subdivides [0,2pi) into nlon spaced
c     points
c
c          (j-1)*2.*pi/nlon  (j=1,...,nlon).
c
c     it is not necessary to communicate to subroutine trvsph whether the
c     underlying grids are in latitude or colatitude.  it is only necessary
c     to communicate whether they run south to north or north to south with
c     increasing subscripts.  a brief discussion of latitude and colatitude
c     follows.  equally spaced latitude grids are assumed to subdivide
c     [-pi/2,pi/2] with the south pole at -pi/2 and north pole at pi/2.
c     equally spaced colatitude grids subdivide [0,pi] with the north pole
c     at 0 and south pole at pi.  equally spaced partitions on the sphere
c     include both poles.  gaussian latitude grids subdivide (-pi/2,pi/2)
c     and gaussian colatitude grids subdivide (0,pi).  gaussian grids do not
c     include the poles.  the gaussian grid points are uniquely determined by
c     the size of the partition.  they can be computed in colatitude in
c     (0,pi) (north to south) in double precision by the spherepack subroutine
c     gaqd.  let nlat be nlata or nlatb if either the ua,va or ub,vb grid is
c     gaussian.  let
c
c        north pole                             south pole
c        ----------                             ----------
c           0.0    <  cth(1) < ... < cth(nlat)  <   pi
c
c
c     be nlat gaussian colatitude points in the interval (0,pi) and let
c
c        south pole                        north pole
c        ----------                        ----------
c           -pi/2  < th(1) < ... < th(nlat) < pi/2
c
c     be nlat gaussian latitude points in the open interval (-pi/2,pi/2).
c     these are related by
c
c          th(i) = -pi/2 + cth(i)  (i=1,...,nlat)
c
c     if the (ua,va) or (ub,vb) grid is equally spaced in (co)latitude then
c
c          ctht(i) = (i-1)*pi/(nlat-1)
c                                               (i=1,...,nlat)
c          tht(i) = -pi/2 + (i-1)*pi/(nlat-1)
c
c     define the equally spaced (north to south) colatitude and (south to
c     north) latitude grids.
c
c *** method (simplified description)
c
c    (1)
c
c     the vector field (ua,va) is reformated to a vector field in mathematical
c     spherical coordinates using array transpositions, subscript reordering
c     and negation of va as necessary (see arguments igrida,iveca).
c
c     (2)
c
c     a vector harmonic analysis is performed on the result from (1)
c
c     (3)
c
c     a vector harmonic synthesis is performed on the (ub,vb) grid
c     using as many coefficients from (2) as possible (i.e., as
c     as is consistent with the size of the ub,vb grid).
c
c     (4)
c
c     the vector field generated in (3) is transformed from mathematical
c     spherical coordinates to the form flagged by ivecb and igridb in
c     (ub,vb) using array transpositions, subscript reordering and negation
c     as necessary
c
c
c *** advantages
c
c     the use of vector spherical harmonics to transfer vector data is
c     highly accurate and preserves properties of vectors on the sphere.
c     the method produces a weighted least squares fit to vector data in
c     which waves are resolved uniformly on the full sphere.  high frequencies
c     induced by closeness of grid points near the poles (due to computational
c     or observational errors) are smoothed.  the method is consistent with
c     methods used to generate vector data in numerical spectral models based
c     on spherical harmonics.  for more discussion of these and related issues,
c     see "on the spectral approximation of discrete scalar and vector
c     functions on the sphere," siam j. numer. anal., vol. 16, december 1979,
c     pp. 934-949, by paul swarztrauber.
c
c
c *** comment
c
c     on a nlon by nlat or nlat by nlon grid (gaussian or equally spaced)
c     spherical harmonic analysis generates and synthesis utilizes
c     min0(nlat,(nlon+2)/2)) by nlat coefficients.  consequently, for
c     ua,va and ub,vb,  if either
c
c             min0(nlatb,(nlonb+2)/2) < min0(nlata,(nlona+2)/2)
c
c     or if
c
c             nlatb < nlata
c
c     then all the coefficients generated by an analysis of ua,va cannot be
c     used in the synthesis which generates ub,vb.  in this case "information"
c     can be lost in generating ub,vb.  more precisely, information will be
c     lost if the analysis of ua,va yields nonzero coefficients which are
c     outside the coefficient bounds determined by the ub,vb grid. still
c     transference with vector spherical harmonics will yield results
c     consistent with grid resolution and is highly accurate.
c
c *** input arguments
c
c ... intl
c
c     an initialization argument which should be zero on an initial call to
c     trvsph.  intl should be one if trvsph is being recalled and
c
c          igrida,nlona,nlata,iveca,igridb,nlonb,nlatb,ivecb
c
c     have not changed from the previous call.  if any of these arguments have
c     changed intl=0 must be used to avoid undetectable errors.  when allowed,
c     calls with intl=1 bypass redundant computation and save time.  it can
c     be used when transferring multiple vector data sets with the same
c     underlying grids.
c
c ... igrida
c
c     an integer vector dimensioned two which identifies the underlying grid
c     on the full sphere for the given vector data (ua,va) as follows:
c
c     igrida(1)
c
c     = -1
c     if the latitude (or colatitude) grid for ua,va is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     runs north to south with increasing subscript value
c
c     = +1
c     if the latitude (or colatitude) grid for ua,va is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     runs south to north with increasing subscript value
c
c     = -2
c     if the latitude (or colatitude) grid for ua,va is a gaussian partition
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs north
c     to south with increasing subscript value
c
c     = +2
c     if the latitude (or colatitude) grid for ua,va is a gaussian partition
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs south
c     north with increasing subscript value
c
c     igrida(2)
c
c     = 0 if the underlying grid for ua,va is a nlona by nlata
c
c     = 1 if the underlying grid for ua,va is a nlata by nlona
c
c
c ... nlona
c
c     the number of longitude points on the uniform grid which partitions
c     [0,2pi) for the given vector (ua,va).  nlona is also the first or second
c     dimension of ua,va (see igrida(2)) in the program which calls trvsph.
c     nlona determines the grid increment in longitude as 2*pi/nlona. for
c     example nlona = 72 for a five degree grid.  nlona must be greater than
c     or equal to 4.  the efficiency of the computation is improved when
c     nlona is a product of small prime numbers
c
c ... nlata
c
c     the number of points in the latitude (or colatitude) grid for the
c     given vector (ua,va).  nlata is also the first or second dimension
c     of ua and va (see igrida(2)) in the program which calls trvsph.
c     if nlata is odd then the equator will be located at the (nlata+1)/2
c     gaussian grid point.  if nlata is even then the equator will be
c     located half way between the nlata/2 and nlata/2+1 grid points.
c
c ... iveca
c
c     if iveca=0 is input then va is the latitudinal component of the
c     given vector field. if iveca=1 then va is the colatitudinal
c     compoenent of the given vector field.  in either case, ua must
c     be the east longitudinal component of the given vector field.
c
c *** note:
c     igrida(1)=-1 or igrida(1)=-2, igrida(2)=1, and iveca=1 corresponds
c     to the "usual" mathematical spherical coordinate system required
c     by most of the drivers in spherepack2.  igrida(1)=1 or igrida(1)=2,
c     igrida(2)=0, and iveca=0 corresponds to the "usual" geophysical
c     spherical coordinate system.
c
c
c ... ua
c
c     ua is the east longitudinal component of the given vector field.
c     ua must be dimensioned nlona by nlata in the program calling trvsph if
c     igrida(2) = 0.  ua must be dimensioned nlata by nlona in the program
c     calling trvsph if igrida(2) = 1.  if ua is not properly dimensioned
c     and if the latitude (colatitude) values do not run south to north or
c     north to south as flagged by igrida(1) (this cannot be checked!) then
c     incorrect results will be produced.
c
c
c ... va
c
c     va is either the latitudinal or colatitudinal componenet of the
c     given vector field (see iveca).  va must be dimensioned nlona by
c     nlata in the program calling trvsph if igrida(2)=0.  va must be
c     dimensioned nlata by nlona in the program calling trvsph if
c     igrida(2)=1.  if va is not properly dimensioned or if the latitude
c     (colatitude) values do not run south to north or north to south
c     as flagged by igrida(1) (this cannot be checked!) then incorrect
c     results will be produced.
c
c ... igridb
c
c     an integer vector dimensioned two which identifies the underlying grid
c     on the full sphere for the transformed vector (ub,vb) as follows:
c
c     igridb(1)
c
c     = -1
c     if the latitude (or colatitude) grid for ub,vb is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     north to south
c
c     = +1
c     if the latitude (or colatitude) grid for ub,vb is an equally spaced
c     partition of [-pi/2,pi/2] ( or [0,pi] ) including the poles which
c     south to north
c
c     = -2
c     if the latitude (or colatitude) grid for ub,vb is a gaussian partition
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs north to
c     south
c
c     = +2
c     if the latitude (or colatitude) grid for ub,vb is a gaussian partition
c     of (-pi/2,pi/2) ( or (0,pi) ) excluding the poles which runs south to
c     north
c
c     igridb(2)
c
c     = 0 if the underlying grid for ub,vb is a nlonb by nlatb
c
c     = 1 if the underlying grid for ub,vb is a nlatb by nlonb
c
c
c ... nlonb
c
c     the number of longitude points on the uniform grid which partitions
c     [0,2pi) for the transformed vector (ub,vb).  nlonb is also the first or
c     second dimension of ub and vb (see igridb(2)) in the program which calls
c     trvsph.  nlonb determines the grid increment in longitude as 2*pi/nlonb.
c     for example nlonb = 72 for a five degree grid.  nlonb must be greater
c     than or equal to 4.  the efficiency of the computation is improved when
c     nlonb is a product of small prime numbers
c
c ... nlatb
c
c     the number of points in the latitude (or colatitude) grid for the
c     transformed vector (ub,vb).  nlatb is also the first or second dimension
c     of ub and vb (see igridb(2)) in the program which calls trvsph.
c     if nlatb is odd then the equator will be located at the (nlatb+1)/2
c     gaussian grid point.  if nlatb is even then the equator will be
c     located half way between the nlatb/2 and nlatb/2+1 grid points.
c
c ... ivecb
c
c     if ivecb=0 is input then vb is the latitudinal component of the
c     given vector field. if ivecb=1 then vb is the colatitudinal
c     compoenent of the given vector field.  in either case, ub must
c     be the east longitudinal component of the given vector field.
c
c *** note:
c     igridb(1)=-1 or igridb(1)=-2, igridb(2)=1, and ivecb=1 corresponds
c     to the "usual" mathematical spherical coordinate system required
c     by most of the drivers in spherepack2.  igridb(1)=1 or igridb(1)=2,
c     igridb(2)=0, and ivecb=0 corresponds to the "usual" geophysical
c     spherical coordinate system.
c
c ... wsave
c
c     a saved work space array that can be utilized repeatedly by trvsph
c     as long as the arguments nlata,nlona,nlatb,nlonb remain unchanged.
c     wsave is set by a intl=0 call to trvsph.  wsave must not be altered
c     when trvsph is being recalled with intl=1.
c
c ... lsave
c
c     the dimension of the work space wsave as it appears in the program
c     that calls trvsph.  the minimum required value of lsave for the
c     current set of input arguments is set in the output argument lsvmin.
c     it can be determined by calling trvsph with lsave=0 and printing lsvmin.
c
c          la1 = min0(nlata,(nlona+1)/2), la2 = (nlata+1)/2
c
c          lb1 = min0(nlatb,(nlonb+1)/2), lb2 = (nlatb+1)/2
c
c          lwa = 4*nlata*la2+3*max0(la1-2,0)*(2*nlata-la1-1)+la2+nlona+15
c
c          lwb = 4*nlatb*lb2+3*max0(lb1-2,0)*(2*nlatb-lb1-1)+nlonb+15
c
c      then
c
c          lsvmin = lwa + lwb
c
c      is the minimal required work space length of wsave
c
c
c ... work
c
c     a work array that does not have to be preserved
c
c ... lwork
c
c     the dimension of the array work as it appears in the program that
c     calls trvsph. the minimum required value of lwork for the current
c     set of input arguments is set in the output argument lwkmin.
c     it can be determined by calling trvsph with lwork=0 and printing
c     lwkmin.  an estimate for lwork follows.  let nlat = max0(nlata,nlatb),
c     nlon = max0(nlona,nlonb) and l1 = min0(nlat,(nlon+2)/2).  with these
c     these definitions, the quantity
c
c            2*nlat*(8*l1 + 4*nlon + 3)
c
c     will suffice as a length for the unsaved work space.  this formula
c     may overestimate the required minimum value for lwork.  the exact
c     minimum value can be predetermined by calling trvsph wtih lwork=0
c     and printout of lwkmin.
c
c ... dwork
c
c     a double precision work array that does not have to be preserved.
c
c ... ldwork
c
c     the length of dwork in the routine calling trvsph
c     Let
c
c       nlat = max0(nlata,nlatb)
c
c     ldwork must be at least 2*nlat*(nlat+1)+1
c
c
c *** output arguments
c
c
c ... ub
c
c     a two dimensional array that contains the east longitudinal component
c     of the transformed vector data.  ub
c     must be dimensioned nlonb by nlatb in the program calling trvsph if
c     igridb(2)=0.  ub must be dimensioned nlatb by nlonb in the program
c     calling trvsph if igridb(2)=1.  if ub is not properly dimensioned
c     and if the latitude (colatitude) values do not run south to north or
c     north to south as flagged by igrdb(1) (this cannot be checked!) then
c     incorrect results will be produced.
c
c
c ... vb
c
c     a two dimensional array that contains the latitudinal or colatitudinal
c     component of the transformed vector data (see ivecb).
c     vb must be dimensioned nlonb by nlatb in the program calling trvsph if
c     igridb(2)=0.  vb must be dimensioned nlatb by nlonb in the program
c     calling trvsph if igridb(2)=1.  if vb is not properly dimensioned
c     and if the latitude (colatitude) values do not run south to north or
c     north to south as flagged by igrdb(1) (this cannot be checked!) then
c     incorrect results will be produced.
c
c ... lsvmin
c
c     the minimum length of the saved work space in wsave.
c     lsvmin is computed even if lsave < lsvmin (ier = 10).
c
c ... lwkmin
c
c     the minimum length of the unsaved work space in work.
c     lwkmin is computed even if lwork < lwkmin (ier = 11).
c
c
c *** error argument
c
c ... ier = 0  if no errors are detected
c
c         = 1  if intl is not 0 or 1
c
c         = 2  if igrida(1) is not -1 or +1 or -2 or +2
c
c         = 3  if igrida(2) is not 0 or 1
c
c         = 4  if nlona is less than 4
c
c         = 5  if nlata is less than 3
c
c         = 6  if iveca is not 0 or 1
c
c         = 7  if igridb(1) is not -1 or +1 or -2 or +2
c
c         = 8  if igridb(2) is not 0 or 1
c
c         = 9  if nlonb is less than 4
c
c         =10  if nlatb is less than 3
c
c         =11  if ivecb is not 0 or 1
c
c         =12  if there is insufficient saved work space (lsave < lsvmin)
c
c         =13  if there is insufficient unsaved work space (lwork < lwkmin)
c
c         =14  indicates failure in an eigenvalue routine which computes
c              gaussian weights and points
c
c         =15  if ldwork is too small (insufficient double precision
c              unsaved work space)
c
c *****************************************************
c *****************************************************
c
c     end of argument description ... code follows
c
c *****************************************************
c *****************************************************
c
      subroutine trvsph (intl,igrida,nlona,nlata,iveca,ua,va,
     +igridb,nlonb,nlatb,ivecb,ub,vb,wsave,lsave,lsvmin,work,
     +lwork,lwkmin,dwork,ldwork,ier)
      implicit none
      integer intl,igrida(2),nlona,nlata,igridb(2),nlonb,nlatb
      integer iveca,ivecb,lsave,lsvmin,lwork,lwkmin,ldwork,ier
      real ua(*),va(*),ub(*),vb(*),wsave(*),work(*)
      double precision dwork(*)
      integer ig,igrda,igrdb,la1,la2,lb1,lb2,lwa,lwb
      integer iabr,iabi,iacr,iaci,ibbr,ibbi,ibcr,ibci
      integer nlat,lwk1,lwk2,lw,iw,jb,nt,ityp
c
c     include a save statement to ensure local variables in trvsph, set during
c     an intl=0 call, are preserved if trvsph is recalled with intl=1
c
      save
c
c     check input arguments
c
      ier = 1
      if (intl*(intl-1).ne.0) return
      ier = 2
      ig = igrida(1)
      if ((ig-1)*(ig+1)*(ig-2)*(ig+2).ne.0) return
      ier = 3
      ig = igrida(2)
      if (ig*(ig-1).ne.0) return
      ier = 4
      if (nlona .lt. 4) return
      ier = 5
      if (nlata .lt.3) return
      ier = 6
      if (iveca*(iveca-1).ne.0) return
      ier = 7
      ig = igridb(1)
      if ((ig-1)*(ig+1)*(ig-2)*(ig+2).ne.0) return
      ier = 8
      ig = igridb(2)
      if (ig*(ig-1).ne.0) return
      ier = 9
      if (nlonb .lt.4) return
      ier = 10
      if (nlatb .lt.3) return
      ier = 11
      if (ivecb*(ivecb-1).ne.0) return
      ier = 0
      igrda = iabs(igrida(1))
      igrdb = iabs(igridb(1))
      if (intl.eq.0) then
      la1 = min0(nlata,(nlona+1)/2)
      la2 = (nlata+1)/2
      lb1 = min0(nlatb,(nlonb+1)/2)
      lb2 = (nlatb+1)/2
c
c     saved space for analysis on a grid
c
      lwa = 4*nlata*la2+3*max0(la1-2,0)*(2*nlata-la1-1)+la2+nlona+15
c
c     set saved work space length for synthesis on b grid
c
      lwb = 4*nlatb*lb2+3*max0(lb1-2,0)*(2*nlatb-lb1-1)+nlonb+15
c
c     set minimum required saved work space length
c
      lsvmin = lwa + lwb
c
c     set wsave pointer
c
      jb = 1+lwa
c
c     set pointers for vector spherical harmonic coefs in work
c
      iabr = 1
      iabi = iabr + la1*nlata
      iacr = iabi + la1*nlata
      iaci = iacr + la1*nlata
      ibbr = iaci + la1*nlata
      ibbi = ibbr + lb1*nlatb
      ibcr = ibbi + lb1*nlatb
      ibci = ibcr + lb1*nlatb
c
c     set pointers for remaining work
c
      iw = ibci + lb1*nlatb
c
c     set remaining work space length in lw
c
      lw = lwork - iw
c
c     compute unsaved space for analysis and synthesis
c
      lwk1 = 2*nlata*(2*nlona+max0(6*la2,nlona))
      lwk2 = 2*nlatb*(2*nlonb+max0(6*lb2,nlonb))
c
c     set minimum unsaved work space required by trvsph
c
      lwkmin = iw + max0(lwk1,lwk2)
c
c     set error flags if saved or unsaved work space is insufficient
c
      ier = 12
      if (lsave .lt. lsvmin) return
      ier = 13
      if (lwork .lt. lwkmin) return
      ier = 15
      nlat = max0(nlata,nlatb)
      if (ldwork .lt. 2*nlat*(nlat+1)+1) return
      ier = 0
      if (igrda .eq. 1) then
c
c     initialize wsave for equally spaced analysis
c
      call vhaeci(nlata,nlona,wsave,lwa,dwork,ldwork,ier)
      else
c
c     initialize wsave for gaussian analysis
c
      call vhagci(nlata,nlona,wsave,lwa,dwork,ldwork,ier)
      if (ier.ne.0) then
c
c     flag failure in spherepack gaussian software
c
      ier = 14
      return
      end if
      end if

      if (igrdb .eq. 2) then
c
c     initialize wsave for gaussian synthesis
c
      call vhsgci(nlatb,nlonb,wsave(jb),lwb,dwork,ldwork,ier)
      if (ier.ne.0) then
c
c     flag failure in spherepack gaussian software
c
      ier = 14
      return
      end if
      else
c
c     initialize wsave for equally spaced synthesis
c
      call vhseci(nlatb,nlonb,wsave(jb),lwb,dwork,ldwork,ier)
      end if
c
c     end of initialization (intl=0) call
c
      end if
c
c     convert the vector field (ua,va) to mathematical spherical coordinates
c
      if (igrida(2).eq.0) then
	call trvplat(nlona,nlata,ua,work)
	call trvplat(nlona,nlata,va,work)
      end if
      if (igrida(1) .gt. 0) then
	call covlat(nlata,nlona,ua)
	call covlat(nlata,nlona,va)
      end if
      if (iveca .eq. 0) then
	call negv(nlata,nlona,va)
      end if
      nt = 1
      ityp = 0
c
c     analyze vector field
c
      if (igrda .eq. 2) then
	call vhagc(nlata,nlona,ityp,nt,va,ua,nlata,nlona,work(iabr),
     +  work(iabi),work(iacr),work(iaci),la1,nlata,wsave,lwa,work(iw),
     +  lw,ier)
      else
	call vhaec(nlata,nlona,ityp,nt,va,ua,nlata,nlona,work(iabr),
     +  work(iabi),work(iacr),work(iaci),la1,nlata,wsave,lwa,work(iw),
     +  lw,ier)
      end if
c
c     transfer a grid coefficients to b grid coefficients
c
      call trvab(la1,nlata,work(iabr),work(iabi),work(iacr),work(iaci),
     +           lb1,nlatb,work(ibbr),work(ibbi),work(ibcr),work(ibci))
c
c     synthesize on b grid
c
      if (igrdb .eq. 1) then
      call vhsec(nlatb,nlonb,ityp,nt,vb,ub,nlatb,nlonb,work(ibbr),
     +work(ibbi),work(ibcr),work(ibci),lb1,nlatb,wsave(jb),lwb,
     +work(iw),lw,ier)
      else
      call vhsgc(nlatb,nlonb,ityp,nt,vb,ub,nlatb,nlonb,work(ibbr),
     +work(ibbi),work(ibcr),work(ibci),lb1,nlatb,wsave(jb),lwb,work(iw),
     +lw,ier)
      end if
c
c     restore a grid and b grid vector fields (now in math coordinates) to
c     agree with grid flags in igrida,iveca,igridb,ivecb
c
      if (iveca .eq. 0) then
	call negv(nlata,nlona,va)
      end if
      if (ivecb .eq. 0) then
	call negv(nlatb,nlonb,vb)
      end if
      if (igrida(1).gt. 0) then
	call covlat(nlata,nlona,ua)
	call covlat(nlata,nlona,va)
      end if
      if (igridb(1) .gt. 0) then
	call covlat(nlatb,nlonb,ub)
	call covlat(nlatb,nlonb,vb)
      end if
      if (igrida(2) .eq. 0) then
	call trvplat(nlata,nlona,ua,work)
	call trvplat(nlata,nlona,va,work)
      end if
      if (igridb(2) .eq. 0) then
	call trvplat(nlatb,nlonb,ub,work)
	call trvplat(nlatb,nlonb,vb,work)
      end if
      return
      end
      subroutine negv(nlat,nlon,v)
c
c     negate (co)latitudinal vector componenet
c
      implicit none
      integer nlat,nlon,i,j
      real v(nlat,nlon)
      do j=1,nlon
	do i=1,nlat
	  v(i,j) = -v(i,j)
	end do
      end do
      return
      end
      subroutine trvab(ma,na,abr,abi,acr,aci,mb,nb,bbr,bbi,bcr,bci)
      implicit none
      integer ma,na,mb,nb,i,j,m,n
      real abr(ma,na),abi(ma,na),acr(ma,na),aci(ma,na)
      real bbr(mb,nb),bbi(mb,nb),bcr(mb,nb),bci(mb,nb)
c
c     set coefficients for b grid from coefficients for a grid
c
      m = min0(ma,mb)
      n = min0(na,nb)
      do j=1,n
	do i=1,m
	  bbr(i,j) = abr(i,j)
	  bbi(i,j) = abi(i,j)
	  bcr(i,j) = acr(i,j)
	  bci(i,j) = aci(i,j)
	end do
      end do
c
c     set coefs outside triangle to zero
c
      do i=m+1,mb
	do j=1,nb
	  bbr(i,j) = 0.0
	  bbi(i,j) = 0.0
	  bcr(i,j) = 0.0
	  bci(i,j) = 0.0
	end do
      end do
      do j=n+1,nb
	do i=1,mb
	  bbr(i,j) = 0.0
	  bbi(i,j) = 0.0
	  bcr(i,j) = 0.0
	  bci(i,j) = 0.0
	end do
      end do
      return
      end
      subroutine trvplat(n,m,data,work)
c
c     transpose the n by m array data to a m by n array data
c     work must be at least n*m words long
c
      implicit none
      integer n,m,i,j,ij,ji
      real data(*),work(*)
      do j=1,m
	do i=1,n
	  ij = (j-1)*n+i
	  work(ij) = data(ij)
	end do
      end do
      do i=1,n
	do j=1,m
	  ji = (i-1)*m+j
	  ij = (j-1)*n+i
	  data(ji) = work(ij)
	end do
      end do
      return
      end
      subroutine covlat(nlat,nlon,data)
c
c     reverse order of latitude (colatitude) grids
c
      implicit none
      integer nlat,nlon,nlat2,i,ib,j
      real data(nlat,nlon),temp
      nlat2 = nlat/2
      do i=1,nlat2
	ib = nlat-i+1
	do j=1,nlon
	  temp = data(i,j)
	  data(i,j) = data(ib,j)
	  data(ib,j) = temp
	end do
      end do
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file vrtgs.f
!
!     this file includes documentation and code for
!     subroutine divgs          i
!
! ... files which must be loaded with vrtgs.f
!
!     sphcom.f, hrfft.f, vhgsc.f, shsgs.f, gaqd.f
!
!     subroutine vrtgs(nlat,nlon,isym,nt,vort,ivrt,jvrt,cr,ci,mdc,ndc,
!    +                 wshsgs,lshsgs,work,lwork,ierror)
!
!     given the vector spherical harmonic coefficients cr and ci, precomputed
!     by subroutine vhags for a vector field (v,w), subroutine vrtgs
!     computes the vorticity of the vector field in the scalar array
!     vort.  vort(i,j) is the vorticity at the gaussian colatitude
!     theta(i) (see nlat as input parameter) and longitude
!     lambda(j) = (j-1)*2*pi/nlon on the sphere.  i.e.,
!
!            vort(i,j) =  [-dv/dlambda + d(sint*w)/dtheta]/sint
!
!     where sint = sin(theta(i)).  w is the east longitudinal and v
!     is the colatitudinal component of the vector field from which
!     cr,ci were precomputed.  required associated legendre polynomials
!     are stored rather than recomputed as they are in subroutine vrtgc.
!
!
!     input parameters
!
!     nlat   the number of points in the gaussian colatitude grid on the
!            full sphere. these lie in the interval (0,pi) and are computed
!            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
!            if nlat is odd the equator will be included as the grid point
!            theta((nlat+1)/2).  if nlat is even the equator will be
!            excluded as a grid point and will lie half way between
!            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
!            note: on the half sphere, the number of grid points in the
!            colatitudinal direction is nlat/2 if nlat is even or
!            (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than 3. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!
!     isym   a parameter which determines whether the vorticity is
!            computed on the full or half sphere as follows:
!
!      = 0
!            the symmetries/antsymmetries described in isym=1,2 below
!            do not exist in (v,w) about the equator.  in this case the
!            vorticity is neither symmetric nor antisymmetric about
!            the equator.  the vorticity is computed on the entire
!            sphere.  i.e., in the array vort(i,j) for i=1,...,nlat and
!            j=1,...,nlon.
!
!      = 1
!            w is antisymmetric and v is symmetric about the equator.
!            in this case the vorticity is symmetyric about the
!            equator and is computed for the northern hemisphere
!            only.  i.e., if nlat is odd the vorticity is computed
!            in the array vort(i,j) for i=1,...,(nlat+1)/2 and for
!            j=1,...,nlon.  if nlat is even the vorticity is computed
!            in the array vort(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!      = 2
!            w is symmetric and v is antisymmetric about the equator
!            in this case the vorticity is antisymmetric about the
!            equator and is computed for the northern hemisphere
!            only.  i.e., if nlat is odd the vorticity is computed
!            in the array vort(i,j) for i=1,...,(nlat+1)/2 and for
!            j=1,...,nlon.  if nlat is even the vorticity is computed
!            in the array vort(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!
!      nt    nt is the number of scalar and vector fields.  some
!            computational efficiency is obtained for multiple fields.
!            in the program that calls vrtgs, the arrays cr,ci, and vort
!            can be three dimensional corresponding to an indexed multiple
!            vector field.  in this case multiple scalar synthesis will
!            be performed to compute the vorticity for each field.  the
!            third index is the synthesis index which assumes the values
!            k=1,...,nt.  for a single synthesis set nt = 1.  the
!            description of the remaining parameters is simplified by
!            assuming that nt=1 or that all the arrays are two dimensional.
!
!     ivrt   the first dimension of the array vort as it appears in
!            the program that calls vrtgs. if isym = 0 then ivrt
!            must be at least nlat.  if isym = 1 or 2 and nlat is
!            even then ivrt must be at least nlat/2. if isym = 1 or 2
!            and nlat is odd then ivrt must be at least (nlat+1)/2.
!
!     jvrt   the second dimension of the array vort as it appears in
!            the program that calls vrtgs. jvrt must be at least nlon.
!
!    cr,ci   two or three dimensional arrays (see input parameter nt)
!            that contain vector spherical harmonic coefficients
!            of the vector field (v,w) as computed by subroutine vhags.
!     ***    cr and ci must be computed by vhags prior to calling
!            vrtgs.
!
!      mdc   the first dimension of the arrays cr and ci as it
!            appears in the program that calls vrtgs. mdc must be at
!            least min0(nlat,nlon/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!      ndc   the second dimension of the arrays cr and ci as it
!            appears in the program that calls vrtgs. ndc must be at
!            least nlat.
!
!   wshsgs   an array which must be initialized by subroutine shsgsi.
!            once initialized,
!            wshsgs can be used repeatedly by vrtgs as long as nlon
!            and nlat remain unchanged.  wshsgs must not be altered
!            between calls of vrtgs
!
!   lshsgs   the dimension of the array wshsgs   as it appears in the
!            program that calls vrtgs. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshsgs must be at least
!
!            nlat*(3*(l1+l2)-2)+(l1-1)*(l2*(2*nlat-l1)-3*l1)/2+nlon+15
!
!     work   a work array that does not have to be saved.
!
!    lwork   the dimension of the array work as it appears in the
!            program that calls vrtgs. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd.
!
!            if isym = 0 then lwork must be at least
!
!               nlat*((nt+1)*nlon+2*nt*l1+1)
!
!            if isym > 0 then lwork must be at least
!
!               (nt+1)*l2*nlon+nlat*(2*nt*l1+1)
!
!
!     **************************************************************
!
!     output parameters
!
!
!     vort   a two or three dimensional array (see input parameter nt)
!            that contains the vorticity of the vector field (v,w)
!            whose coefficients cr,ci where computed by subroutine vhags.
!            vort(i,j) is the vorticity at the gaussian colatitude point
!            theta(i) and longitude point lambda(j) = (j-1)*2*pi/nlon.
!            the index ranges are defined above at the input parameter
!            isym.
!
!
!   ierror   an error parameter which indicates fatal errors with input
!            parameters when returned positive.
!          = 0  no errors
!          = 1  error in the specification of nlat
!          = 2  error in the specification of nlon
!          = 3  error in the specification of isym
!          = 4  error in the specification of nt
!          = 5  error in the specification of ivrt
!          = 6  error in the specification of jvrt
!          = 7  error in the specification of mdc
!          = 8  error in the specification of ndc
!          = 9  error in the specification of lshsgs
!          = 10 error in the specification of lwork
! **********************************************************************
!
!
      SUBROUTINE VRTGS(Nlat,Nlon,Isym,Nt,Vort,Ivrt,Jvrt,Cr,Ci,Mdc,Ndc,  &
                     & Wshsgs,Lshsgs,Work,Lwork,Ierror)
      IMPLICIT NONE
      REAL Ci , Cr , Vort , Work , Wshsgs
      INTEGER ia , ib , Ierror , imid , is , Isym , Ivrt , iwk , Jvrt , &
            & l1 , l2 , lp , lpimn , ls , Lshsgs , lwk , Lwork , mab ,  &
            & Mdc , mmax
      INTEGER mn , Ndc , Nlat , nln , Nlon , Nt
 
      DIMENSION Vort(Ivrt,Jvrt,Nt) , Cr(Mdc,Ndc,Nt) , Ci(Mdc,Ndc,Nt)
      DIMENSION Wshsgs(Lshsgs) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Ivrt<Nlat) .OR. (Isym>0 .AND. Ivrt<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jvrt<Nlon ) RETURN
      Ierror = 7
      IF ( Mdc<MIN0(Nlat,(Nlon+1)/2) ) RETURN
      mmax = MIN0(Nlat,(Nlon+2)/2)
      Ierror = 8
      IF ( Ndc<Nlat ) RETURN
      Ierror = 9
      imid = (Nlat+1)/2
      lpimn = (imid*mmax*(Nlat+Nlat-mmax+1))/2
      l2 = (Nlat+MOD(Nlat,2))/2
      l1 = MIN0((Nlon+2)/2,Nlat)
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshsgs<lp ) RETURN
      Ierror = 10
!
!     verify unsaved work space (add to what shses requires, file f3)
!
!
!     set first dimension for a,b (as requried by shses)
!
      mab = MIN0(Nlat,Nlon/2+1)
      mn = mab*Nlat*Nt
      ls = Nlat
      IF ( Isym>0 ) ls = imid
      nln = Nt*ls*Nlon
      IF ( Lwork<nln+ls*Nlon+2*mn+Nlat ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ia = 1
      ib = ia + mn
      is = ib + mn
      iwk = is + Nlat
      lwk = Lwork - 2*mn - Nlat
      CALL VRTGS1(Nlat,Nlon,Isym,Nt,Vort,Ivrt,Jvrt,Cr,Ci,Mdc,Ndc,       &
                & Work(ia),Work(ib),mab,Work(is),Wshsgs,Lshsgs,Work(iwk)&
                & ,lwk,Ierror)
      END SUBROUTINE VRTGS

      
      SUBROUTINE VRTGS1(Nlat,Nlon,Isym,Nt,Vort,Ivrt,Jvrt,Cr,Ci,Mdc,Ndc, &
                      & A,B,Mab,Sqnn,Wsav,Lwsav,Wk,Lwk,Ierror)
      IMPLICIT NONE
      REAL A , B , Ci , Cr , fn , Sqnn , Vort , Wk , Wsav
      INTEGER Ierror , Isym , Ivrt , Jvrt , k , Lwk , Lwsav , m , Mab , &
            & Mdc , mmax , n , Ndc , Nlat , Nlon , Nt
      DIMENSION Vort(Ivrt,Jvrt,Nt) , Cr(Mdc,Ndc,Nt) , Ci(Mdc,Ndc,Nt)
      DIMENSION A(Mab,Nlat,Nt) , B(Mab,Nlat,Nt) , Sqnn(Nlat)
      DIMENSION Wsav(Lwsav) , Wk(Lwk)
!
!     set coefficient multiplyers
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.))
      ENDDO
!
!     compute divergence scalar coefficients for each vector field
!
      DO k = 1 , Nt
         DO n = 1 , Nlat
            DO m = 1 , Mab
               A(m,n,k) = 0.0
               B(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            A(1,n,k) = Sqnn(n)*Cr(1,n,k)
            B(1,n,k) = Sqnn(n)*Ci(1,n,k)
         ENDDO
!
!     compute m>0 coefficients
!
         mmax = MIN0(Nlat,(Nlon+1)/2)
         DO m = 2 , mmax
            DO n = m , Nlat
               A(m,n,k) = Sqnn(n)*Cr(m,n,k)
               B(m,n,k) = Sqnn(n)*Ci(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     synthesize a,b into vort
!
      CALL SHSGS(Nlat,Nlon,Isym,Nt,Vort,Ivrt,Jvrt,A,B,Mab,Nlat,Wsav,    &
               & Lwsav,Wk,Lwk,Ierror)
      END SUBROUTINE VRTGS1

      
      SUBROUTINE DVRTGS(Nlat,Nlon,Isym,Nt,Vort,Ivrt,Jvrt,Cr,Ci,Mdc,Ndc,  &
                     & Wshsgs,Lshsgs,Work,Lwork,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION Ci , Cr , Vort , Work , Wshsgs
      INTEGER ia , ib , Ierror , imid , is , Isym , Ivrt , iwk , Jvrt , &
            & l1 , l2 , lp , lpimn , ls , Lshsgs , lwk , Lwork , mab ,  &
            & Mdc , mmax
      INTEGER mn , Ndc , Nlat , nln , Nlon , Nt
 
      DIMENSION Vort(Ivrt,Jvrt,Nt) , Cr(Mdc,Ndc,Nt) , Ci(Mdc,Ndc,Nt)
      DIMENSION Wshsgs(Lshsgs) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Ivrt<Nlat) .OR. (Isym>0 .AND. Ivrt<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jvrt<Nlon ) RETURN
      Ierror = 7
      IF ( Mdc<MIN0(Nlat,(Nlon+1)/2) ) RETURN
      mmax = MIN0(Nlat,(Nlon+2)/2)
      Ierror = 8
      IF ( Ndc<Nlat ) RETURN
      Ierror = 9
      imid = (Nlat+1)/2
      lpimn = (imid*mmax*(Nlat+Nlat-mmax+1))/2
      l2 = (Nlat+MOD(Nlat,2))/2
      l1 = MIN0((Nlon+2)/2,Nlat)
      lp = Nlat*(3*(l1+l2)-2) + (l1-1)*(l2*(2*Nlat-l1)-3*l1)/2 + Nlon + &
         & 15
      IF ( Lshsgs<lp ) RETURN
      Ierror = 10
!
!     verify unsaved work space (add to what shses requires, file f3)
!
!
!     set first dimension for a,b (as requried by shses)
!
      mab = MIN0(Nlat,Nlon/2+1)
      mn = mab*Nlat*Nt
      ls = Nlat
      IF ( Isym>0 ) ls = imid
      nln = Nt*ls*Nlon
      IF ( Lwork<nln+ls*Nlon+2*mn+Nlat ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ia = 1
      ib = ia + mn
      is = ib + mn
      iwk = is + Nlat
      lwk = Lwork - 2*mn - Nlat
      CALL DVRTGS1(Nlat,Nlon,Isym,Nt,Vort,Ivrt,Jvrt,Cr,Ci,Mdc,Ndc,       &
                & Work(ia),Work(ib),mab,Work(is),Wshsgs,Lshsgs,Work(iwk)&
                & ,lwk,Ierror)
      END SUBROUTINE DVRTGS

      
      SUBROUTINE DVRTGS1(Nlat,Nlon,Isym,Nt,Vort,Ivrt,Jvrt,Cr,Ci,Mdc,Ndc, &
                      & A,B,Mab,Sqnn,Wsav,Lwsav,Wk,Lwk,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , Ci , Cr , fn , Sqnn , Vort , Wk , Wsav
      INTEGER Ierror , Isym , Ivrt , Jvrt , k , Lwk , Lwsav , m , Mab , &
            & Mdc , mmax , n , Ndc , Nlat , Nlon , Nt
      DIMENSION Vort(Ivrt,Jvrt,Nt) , Cr(Mdc,Ndc,Nt) , Ci(Mdc,Ndc,Nt)
      DIMENSION A(Mab,Nlat,Nt) , B(Mab,Nlat,Nt) , Sqnn(Nlat)
      DIMENSION Wsav(Lwsav) , Wk(Lwk)
!
!     set coefficient multiplyers
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = SQRT(fn*(fn+1.))
      ENDDO
!
!     compute divergence scalar coefficients for each vector field
!
      DO k = 1 , Nt
         DO n = 1 , Nlat
            DO m = 1 , Mab
               A(m,n,k) = 0.0
               B(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            A(1,n,k) = Sqnn(n)*Cr(1,n,k)
            B(1,n,k) = Sqnn(n)*Ci(1,n,k)
         ENDDO
!
!     compute m>0 coefficients
!
         mmax = MIN0(Nlat,(Nlon+1)/2)
         DO m = 2 , mmax
            DO n = m , Nlat
               A(m,n,k) = Sqnn(n)*Cr(m,n,k)
               B(m,n,k) = Sqnn(n)*Ci(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     synthesize a,b into vort
!
      CALL DSHSGS(Nlat,Nlon,Isym,Nt,Vort,Ivrt,Jvrt,A,B,Mab,Nlat,Wsav,    &
               & Lwsav,Wk,Lwk,Ierror)
      END SUBROUTINE DVRTGS1

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file islapec.f
c
c     this file includes documentation and code for
c     subroutine islapec         i
c
c ... files which must be loaded with islapec.f
c
c     sphcom.f, hrfft.f, shaec.f, shsec.f
c
c     subroutine islapec(nlat,nlon,isym,nt,xlmbda,sf,ids,jds,a,b,
c    +mdab,ndab,wshsec,lshsec,work,lwork,pertrb,ierror)
c
c     islapec inverts the laplace or helmholz operator on an equally
c     spaced latitudinal grid using o(n**2) storage. given the
c     spherical harmonic coefficients a(m,n) and b(m,n) of the right
c     hand side slap(i,j), islapec computes a solution sf(i,j) to
c     the following helmhotz equation :
c
c           2                2
c     [d(sf(i,j))/dlambda /sint + d(sint*d(sf(i,j))/dtheta)/dtheta]/sint
c
c                   - xlmbda * sf(i,j) = slap(i,j)
c
c      where sf(i,j) is computed at colatitude
c
c                 theta(i) = (i-1)*pi/(nlat-1)
c
c            and longitude
c
c                 lambda(j) = (j-1)*2*pi/nlon
c
c            for i=1,...,nlat and j=1,...,nlon.
c
c
c     input parameters
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct longitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     isym   this parameter should have the same value input to subroutine
c            shaec to compute the coefficients a and b for the scalar field
c            slap.  isym is set as follows:
c
c            = 0  no symmetries exist in slap about the equator. scalar
c                 synthesis is used to compute sf on the entire sphere.
c                 i.e., in the array sf(i,j) for i=1,...,nlat and
c                 j=1,...,nlon.
c
c           = 1  sf and slap are antisymmetric about the equator. the
c                synthesis used to compute sf is performed on the
c                northern hemisphere only.  if nlat is odd, sf(i,j) is
c                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
c                nlat is even, sf(i,j) is computed for i=1,...,nlat/2
c                and j=1,...,nlon.
c
c
c           = 2  sf and slap are symmetric about the equator. the
c                synthesis used to compute sf is performed on the
c                northern hemisphere only.  if nlat is odd, sf(i,j) is
c                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
c                nlat is even, sf(i,j) is computed for i=1,...,nlat/2
c                and j=1,...,nlon.
c
c
c   nt       the number of solutions. in the program that calls islapec
c            the arrays sf,a, and b can be three dimensional in which
c            case multiple solutions are computed. the third index
c            is the solution index with values k=1,...,nt.
c            for a single solution set nt=1. the description of the
c            remaining parameters is simplified by assuming that nt=1
c            and sf,a,b are two dimensional.
c
c   xlmbda   a one dimensional array with nt elements. if xlmbda is
c            is identically zero islapec solves poisson's equation.
c            if xlmbda > 0.0 islapec solves the helmholtz equation.
c            if xlmbda < 0.0 the nonfatal error flag ierror=-1 is
c            returned. negative xlambda could result in a division
c            by zero.
c
c   ids      the first dimension of the array sf as it appears in the
c            program that calls islapec.  if isym = 0 then ids must be at
c            least nlat.  if isym > 0 and nlat is even then ids must be
c            at least nlat/2. if isym > 0 and nlat is odd then ids must
c            be at least (nlat+1)/2.
c
c   jds      the second dimension of the array sf as it appears in the
c            program that calls islapec. jds must be at least nlon.
c
c
c   a,b      two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
c            of the scalar field slap. a,b must be computed by shaec
c            prior to calling islapec.
c
c
c   mdab     the first dimension of the arrays a and b as it appears
c            in the program that calls islapec.  mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c   ndab     the second dimension of the arrays a and b as it appears
c            in the program that calls islapec. ndab must be at least
c            least nlat.
c
c            mdab,ndab should have the same values input to shaec to
c            compute the coefficients a and b.
c
c
c   wshsec   an array which must be initialized by subroutine shseci.
c            once initialized, wshsec can be used repeatedly by
c            islapec as long as nlat and nlon  remain unchanged.
c            wshsec must not be altered between calls of islapec.
c
c   lshsec   the dimension of the array wshsec as it appears in the
c            program that calls islapec.  let
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lsave must be greater than or equal to
c
c               2*nlat*l2+3*((l1-2)*(nlat+nlat-l1-1))/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls islapec. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            if isym = 0 let
c
c               lwkmin = nlat*(2*nt*nlon+max0(6*l2,nlon)+2*nt*l1+1).
c
c            if isym > 0 let
c
c               lwkmin = l2*(2*nt*nlon+max0(6*nlat,nlon))+nlat*(2*nt*l1+1)
c
c
c     then lwork must be greater than or equal to lwkmin (see ierror=10)
c
c     **************************************************************
c
c     output parameters
c
c
c    sf      two or three dimensional arrays (see input parameter nt)
c            that contain the solution to either the helmholtz 
c            (xlmbda>0.0) or poisson's equation. sf(i,j) is computed
c            at colatitude
c
c                 theta(i) = (i-1)*pi/(nlat-1)
c
c            and longitude
c
c                 lambda(j) = (j-1)*2*pi/nlon
c
c            for i=1,...,nlat and j=1,...,nlon.
c
c   pertrb  a one dimensional array with nt elements (see input 
c           parameter nt). in the discription that follows we assume 
c           that nt=1. if xlmbda > 0.0 then pertrb=0.0 is always 
c           returned because the helmholtz operator is invertible.
c           if xlmbda = 0.0 then a solution exists only if a(1,1)
c           is zero. islapec sets a(1,1) to zero. the resulting
c           solution sf(i,j) solves poisson's equation with
c           pertrb = a(1,1)/(2.*sqrt(2.)) subtracted from the
c           right side slap(i,j).
c
c
c  ierror   a parameter which flags errors in input parameters as follows:
c
c            =-1  xlmbda is input negative (nonfatal error)
c
c            = 0  no errors detected
c
c            = 1  error in the specification of nlat
c
c            = 2  error in the specification of nlon
c
c            = 3  error in the specification of ityp
c
c            = 4  error in the specification of nt
c
c            = 5  error in the specification of ids
c
c            = 6  error in the specification of jds
c
c            = 7  error in the specification of mdbc
c
c            = 8  error in the specification of ndbc
c
c            = 9  error in the specification of lsave
c
c            = 10 error in the specification of lwork
c
c
c **********************************************************************
c                                                                              
c     end of documentation for islapec
c
c **********************************************************************
c


      subroutine islapec(nlat,nlon,isym,nt,xlmbda,sf,ids,jds,a,b,
     +mdab,ndab,wshsec,lshsec,work,lwork,pertrb,ierror)
      dimension sf(ids,jds,nt),a(mdab,ndab,nt),b(mdab,ndab,nt)
      dimension wshsec(lshsec),work(lwork),pertrb(nt),xlmbda(nt)
c
c     check input parameters
c
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if(nlon .lt. 4) return
      ierror = 3
      if (isym.lt.0 .or. isym.gt.2) return
      ierror = 4
      if(nt .lt. 0) return
      ierror = 5
      imid = (nlat+1)/2
      if((isym.eq.0 .and. ids.lt.nlat) .or.
     1   (isym.gt.0 .and. ids.lt.imid)) return
      ierror = 6
      if(jds .lt. nlon) return
      ierror = 7
      mmax = min0(nlat,nlon/2+1)
      if(mdab .lt. mmax) return
      ierror = 8
      if(ndab .lt. nlat) return
      ierror = 9
c
c     set and verify saved work space length
c
c
      l1 = min0(nlat,(nlon+2)/2)
      l2 = (nlat+1)/2
      lwmin = 2*nlat*l2+3*((l1-2)*(nlat+nlat-l1-1))/2+nlon+15
      if(lshsec .lt. lwmin) return
      ierror = 10
c
c     set and verify unsaved work space length
c
      ls = nlat
      if(isym .gt. 0) ls = imid
      nln = nt*ls*nlon
      mn = mmax*nlat*nt
c     lwmin = nln+ls*nlon+2*mn+nlat
c     if (lwork .lt. lwmin) return
      l2 = (nlat+1)/2
      l1 = min0(nlat,nlon/2+1)
      if (isym .eq. 0) then
	lwkmin = nlat*(2*nt*nlon+max0(6*l2,nlon)+2*nt*l1+1)
      else
	lwkmin = l2*(2*nt*nlon+max0(6*nlat,nlon))+nlat*(2*nt*l1+1)
      end if
      if (lwork .lt. lwkmin) return
      ierror = 0
c
c     check sign of xlmbda
c
      do  k=1,nt
	if (xlmbda(k).lt.0.0) then
	  ierror = -1
	end if
      end do
c
c     set work space pointers
c
      ia = 1
      ib = ia+mn
      ifn = ib+mn
      iwk = ifn+nlat
      lwk = lwork-2*mn-nlat
      call islpec1(nlat,nlon,isym,nt,xlmbda,sf,ids,jds,a,b,mdab,ndab,
     +work(ia),work(ib),mmax,work(ifn),wshsec,lshsec,work(iwk),lwk,
     +pertrb,ierror)
      return
      end

      subroutine islpec1(nlat,nlon,isym,nt,xlmbda,sf,ids,jds,a,b,
     +mdab,ndab,as,bs,mmax,fnn,wshsec,lshsec,wk,lwk,pertrb,ierror)
      dimension sf(ids,jds,nt),a(mdab,ndab,nt),b(mdab,ndab,nt)
      dimension as(mmax,nlat,nt),bs(mmax,nlat,nt),fnn(nlat)
      dimension wshsec(lshsec),wk(lwk),pertrb(nt),xlmbda(nt)
c
c     set multipliers and preset synthesis coefficients to zero
c
      do n=1,nlat
	fn = float(n-1)
	fnn(n) = fn*(fn+1.0)
	do m=1,mmax
	  do k=1,nt
	    as(m,n,k) = 0.0
	    bs(m,n,k) = 0.0
	  end do
	end do
      end do

      do k=1,nt
c
c     compute synthesis coefficients for xlmbda zero or nonzero
c
	if (xlmbda(k) .eq. 0.0) then
	  do n=2,nlat
	    as(1,n,k) = -a(1,n,k)/fnn(n)
	    bs(1,n,k) = -b(1,n,k)/fnn(n)
	  end do
	  do m=2,mmax
	    do n=m,nlat
	      as(m,n,k) = -a(m,n,k)/fnn(n)
	      bs(m,n,k) = -b(m,n,k)/fnn(n)
	    end do
	  end do
	else
c
c     xlmbda nonzero so operator invertible unless
c     -n*(n-1) = xlmbda(k) < 0.0  for some n
c
	  pertrb(k) = 0.0
	  do n=1,nlat
	    as(1,n,k) = -a(1,n,k)/(fnn(n)+xlmbda(k))
	    bs(1,n,k) = -b(1,n,k)/(fnn(n)+xlmbda(k))
	  end do
	  do m=2,mmax
	    do n=m,nlat
	      as(m,n,k) = -a(m,n,k)/(fnn(n)+xlmbda(k))
	      bs(m,n,k) = -b(m,n,k)/(fnn(n)+xlmbda(k))
	    end do
	  end do
	end if
      end do
c
c     synthesize as,bs into sf
c
      call shsec(nlat,nlon,isym,nt,sf,ids,jds,as,bs,mmax,nlat,
     +           wshsec,lshsec,wk,lwk,ierror)
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by ucar                 .
!  .                                                             .
!  .       university corporation for atmospheric research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         spherepack3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file gaqd.f
!
!     this file includes documentation and code for subrooutine gaqd.
!
! ... required files
!
!     none
!
!     subroutine gaqd(nlat,theta,wts,dwork,ldwork,ierror)
!
!     subroutine gaqd computes the nlat gaussian colatitudes and weights
!     in double precision. the colatitudes are in radians and lie in the
!     in the interval (0,pi).
!
!     input parameters
!
!     nlat    the number of gaussian colatitudes in the interval (0,pi)
!             (between the two poles).  nlat must be greater than zero.
!
!     dwork   a temporary work space
!
!     ldwork  the length of the work space  in the routine calling gaqd
!             ldwork must be at least nlat*(nlat+2).
!
!     output parameters
!
!     theta   a double precision vector of length nlat containing the
!             nlat gaussian colatitudes on the sphere in increasing radians
!             in the interval (o,pi).
!
!     wts     a double precision vector of length nlat containing the
!             nlat gaussian weights.
!
!     ierror = 0 no errors
!            = 1 if ldwork.lt.nlat*(nlat+2)
!            = 2 if nlat.le.0
!            = 3 if unable to compute gaussian points
!                (failure in in eigenvalue routine)
!
!  *****************************************************************
      SUBROUTINE GAQD(Nlat,Theta,Wts,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
!*--GAQD60

      INTEGER i1 , i2 , i3 , Ierror , Ldwork , n , Nlat
      DOUBLE PRECISION Theta(Nlat) , Wts(Nlat) , Dwork(Ldwork) , x
      n = Nlat
      Ierror = 1
!     check work space length
      IF ( Ldwork<n*(n+2) ) RETURN
      Ierror = 2
      IF ( n<=0 ) RETURN
      Ierror = 0
      IF ( n>2 ) THEN
!
!     partition dwork space for double precision eigenvalue(vector computation)
!
         i1 = 1
         i2 = i1 + n
         i3 = i2 + n
         CALL GAQD1(n,Theta,Wts,Dwork(i1),Dwork(i2),Dwork(i3),Ierror)
         IF ( Ierror/=0 ) THEN
            Ierror = 3
            RETURN
         ENDIF
         RETURN
      ELSEIF ( n==1 ) THEN
         Wts(1) = 2.0D0
         Theta(1) = DACOS(0.0D0)
      ELSEIF ( n==2 ) THEN
!     compute weights and points analytically when n=2
         Wts(1) = 1.0D0
         Wts(2) = 1.0D0
         x = DSQRT(1.0D0/3.0D0)
         Theta(1) = DACOS(x)
         Theta(2) = DACOS(-x)
         RETURN
      ENDIF
      END SUBROUTINE GAQD
      
      SUBROUTINE DGAQD(Nlat,Theta,Wts,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
!*--GAQD60
      INTEGER i1 , i2 , i3 , Ierror , Ldwork , n , Nlat
      DOUBLE PRECISION Theta(Nlat) , Wts(Nlat) , Dwork(Ldwork) , x

      ! Already a double precision routine
      CALL GAQD(Nlat,Theta,Wts,Dwork,Ldwork,Ierror)
      

      END SUBROUTINE DGAQD


      SUBROUTINE GAQD1(N,Theta,Wts,W,E,Z,Ier)
      IMPLICIT NONE
!*--GAQD1101
      INTEGER i , Ier , j , matz , N , n2
      DOUBLE PRECISION, DIMENSION(N) :: Theta, Wts, W, E      
      DOUBLE PRECISION, DIMENSION(N,N) ::  Z
      DOUBLE PRECISION :: temp
      
!     set symmetric tridiagnonal matrix subdiagonal and diagonal
!     coefficients for matrix coming from coefficients in the
!     recursion formula for legendre polynomials
!     a(n)*p(n-1)+b(n)*p(n)+c(n)*p(n+1) = 0.
      W(1) = 0.D0
      E(1) = 0.D0
      DO j = 2 , N
         E(j) = (j-1.D0)/DSQRT((2.D0*j-1.D0)*(2.D0*j-3.D0))
         W(j) = 0.D0
      ENDDO
!
!     compute eigenvalues and eigenvectors
!
      matz = 1
      CALL DRST(N,N,W,E,matz,Z,Ier)
      IF ( Ier/=0 ) RETURN
!
!     compute gaussian weights and points
!
      DO j = 1 , N
         Theta(j) = DACOS(W(j))
!
!     set gaussian weights as 1st components of eigenvectors squared
!
         Wts(j) = 2.0D0*Z(1,j)**2
      ENDDO
!
!     reverse order of gaussian points to be
!     monotonic increasing in radians
!
      n2 = N/2
      DO i = 1 , n2
         temp = Theta(i)
         Theta(i) = Theta(N-i+1)
         Theta(N-i+1) = temp
      ENDDO
      END

      SUBROUTINE DRST(Nm,N,W,E,Matz,Z,Ierr)
      IMPLICIT NONE
!*--DRST147
!     drst is a double precision modification of rst off eispack
!     to be used  to compute gaussian points and weights
 
!
      INTEGER i , j , N , Nm , Ierr , Matz
      DOUBLE PRECISION W(N) , E(N) , Z(Nm,N)
 
!
!     .......... find both eigenvalues and eigenvectors ..........
      DO i = 1 , N
!
         DO j = 1 , N
            Z(j,i) = 0.0D0
         ENDDO
!
         Z(i,i) = 1.0D0
      ENDDO
!
      CALL DINTQL(Nm,N,W,E,Z,Ierr)
      END

      SUBROUTINE DINTQL(Nm,N,D,E,Z,Ierr)
      IMPLICIT NONE
!*--DINTQL171

      INTEGER mdo , nm1

!     dintql is a double precision modification of intql2 off
!     eispack to be used by gaqd in spherepack for computing
!     gaussian weights and points
!
      INTEGER i , j , k , l , m , N , ii , Nm , mml , Ierr
      DOUBLE PRECISION D(N) , E(N) , Z(Nm,N)
      DOUBLE PRECISION b , c , f , g , p , r , s , tst1 , tst2 , DPYTHA
      Ierr = 0
      IF ( N/=1 ) THEN
!
         DO i = 2 , N
            E(i-1) = E(i)
         ENDDO
!
         E(N) = 0.0D0
!
         DO l = 1 , N
            j = 0
!     .......... look for small sub-diagonal element ..........
!
 20         nm1 = N - 1
            IF ( l<=nm1 ) THEN
               DO mdo = l , nm1
                  m = mdo
                  tst1 = DABS(D(m)) + DABS(D(m+1))
                  tst2 = tst1 + DABS(E(m))
                  IF ( tst2==tst1 ) GOTO 40
               ENDDO
            ENDIF
            m = N
!
 40         p = D(l)
            IF ( m/=l ) THEN
               IF ( j==30 ) GOTO 100
               j = j + 1
!     .......... form shift ..........
               g = (D(l+1)-p)/(2.0D0*E(l))
               r = DPYTHA(g,1.0D0)
               g = D(m) - p + E(l)/(g+SIGN(r,g))
               s = 1.0D0
               c = 1.0D0
               p = 0.0D0
               mml = m - l
!     .......... for i=m-1 step -1 until l do -- ..........
               DO ii = 1 , mml
                  i = m - ii
                  f = s*E(i)
                  b = c*E(i)
                  r = DPYTHA(f,g)
                  E(i+1) = r
                  IF ( r==0.0D0 ) GOTO 50
                  s = f/r
                  c = g/r
                  g = D(i+1) - p
                  r = (D(i)-g)*s + 2.0D0*c*b
                  p = s*r
                  D(i+1) = g + p
                  g = c*r - b
!     .......... form vector ..........
                  DO k = 1 , N
                     f = Z(k,i+1)
                     Z(k,i+1) = s*Z(k,i) + c*f
                     Z(k,i) = c*Z(k,i) - s*f
                  ENDDO
!
               ENDDO
!
               D(l) = D(l) - p
               E(l) = g
               E(m) = 0.0D0
               GOTO 20
!     .......... recover from underflow ..........
 50            D(i+1) = D(i+1) - p
               E(m) = 0.0D0
               GOTO 20
            ENDIF
         ENDDO
!     .......... order eigenvalues and eigenvectors ..........
         DO ii = 2 , N
            i = ii - 1
            k = i
            p = D(i)
!
            DO j = ii , N
               IF ( D(j)<p ) THEN
                  k = j
                  p = D(j)
               ENDIF
            ENDDO
!
            IF ( k/=i ) THEN
               D(k) = D(i)
               D(i) = p
!
               DO j = 1 , N
                  p = Z(j,i)
                  Z(j,i) = Z(j,k)
                  Z(j,k) = p
               ENDDO
            ENDIF
!
!
         ENDDO
      ENDIF
      GOTO 99999
!     .......... set error -- no convergence to an
!                eigenvalue after 30 iterations ..........
 100  Ierr = l
99999 END

      DOUBLE PRECISION FUNCTION DPYTHA(A,B)
      IMPLICIT NONE
!*--DPYTHA287
      DOUBLE PRECISION A , B
!     dpytha is a double precision modification of pythag off eispack
!     for use by dimtql
 
!
!     finds sqrt(a**2+b**2) without overflow or destructive underflow
!
      DOUBLE PRECISION p , r , s , t , u
      p = DABS(A)
      IF ( DABS(B)>=DABS(A) ) p = DABS(B)
      IF ( p==0.0D0 ) THEN
         DPYTHA = p
      ELSE
         r = (DABS(A)/p)**2
         IF ( DABS(B)<DABS(A) ) r = (DABS(B)/p)**2
 50      t = 4.0D0 + r
         IF ( t==4.0D0 ) THEN
            DPYTHA = p
         ELSE
            s = r/t
            u = 1.0D0 + 2.0D0*s
            p = u*p
            r = (s/u)**2*r
            GOTO 50
         ENDIF
      ENDIF
      END

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
! ... file hrfft.f
!
!     this file contains a multiple fft package for spherepack3.0.
!     it includes code and documentation for performing fast fourier
!     transforms (see subroutines hrffti,hrfftf and hrfftb)
!
! **********************************************************************
!
!     subroutine hrffti(n,wsave)
!
!     subroutine hrffti initializes the array wsave which is used in
!     both hrfftf and hrfftb. the prime factorization of n together
!     with a tabulation of the trigonometric functions are computed and
!     stored in wsave.
!
!     input parameter
!
!     n       the length of the sequence to be transformed.
!
!     output parameter
!
!     wsave   a work array which must be dimensioned at least 2*n+15.
!             the same work array can be used for both hrfftf and
!             hrfftb as long as n remains unchanged. different wsave
!             arrays are required for different values of n. the
!             contents of wsave must not be changed between calls
!             of hrfftf or hrfftb.
!
! **********************************************************************
!
!     subroutine hrfftf(m,n,r,mdimr,wsave,work)
!
!     subroutine hrfftf computes the fourier coefficients of m real
!     perodic sequences (fourier analysis); i.e. hrfftf computes the
!     real fft of m sequences each with length n. the transform is
!     defined below at output parameter r.
!
!     input parameters
!
!     m       the number of sequences.
!
!     n       the length of all m sequences.  the method is most
!             efficient when n is a product of small primes. n may
!             change as long as different work arrays are provided
!
!     r       r(m,n) is a two dimensional real array that contains m
!             sequences each with length n.
!
!     mdimr   the first dimension of the r array as it appears
!             in the program that calls hrfftf. mdimr must be
!             greater than or equal to m.
!
!
!     wsave   a work array with at least least 2*n+15 locations
!             in the program that calls hrfftf. the wsave array must be
!             initialized by calling subroutine hrffti(n,wsave) and a
!             different wsave array must be used for each different
!             value of n. this initialization does not have to be
!             repeated so long as n remains unchanged thus subsequent
!             transforms can be obtained faster than the first.
!             the same wsave array can be used by hrfftf and hrfftb.
!
!     work    a real work array with m*n locations.
!
!
!     output parameters
!
!     r      for all j=1,...,m
!
!             r(j,1) = the sum from i=1 to i=n of r(j,i)
!
!             if n is even set l =n/2   , if n is odd set l = (n+1)/2
!
!               then for k = 2,...,l
!
!                  r(j,2*k-2) = the sum from i = 1 to i = n of
!
!                       r(j,i)*cos((k-1)*(i-1)*2*pi/n)
!
!                  r(j,2*k-1) = the sum from i = 1 to i = n of
!
!                      -r(j,i)*sin((k-1)*(i-1)*2*pi/n)
!
!             if n is even
!
!                  r(j,n) = the sum from i = 1 to i = n of
!
!                       (-1)**(i-1)*r(j,i)
!
!      *****  note
!                  this transform is unnormalized since a call of hrfftf
!                  followed by a call of hrfftb will multiply the input
!                  sequence by n.
!
!     wsave   contains results which must not be destroyed between
!             calls of hrfftf or hrfftb.
!
!     work    a real work array with m*n locations that does
!             not have to be saved.
!
! **********************************************************************
!
!     subroutine hrfftb(m,n,r,mdimr,wsave,work)
!
!     subroutine hrfftb computes the real perodic sequence of m
!     sequences from their fourier coefficients (fourier synthesis).
!     the transform is defined below at output parameter r.
!
!     input parameters
!
!     m       the number of sequences.
!
!     n       the length of all m sequences.  the method is most
!             efficient when n is a product of small primes. n may
!             change as long as different work arrays are provided
!
!     r       r(m,n) is a two dimensional real array that contains
!             the fourier coefficients of m sequences each with
!             length n.
!
!     mdimr   the first dimension of the r array as it appears
!             in the program that calls hrfftb. mdimr must be
!             greater than or equal to m.
!
!     wsave   a work array which must be dimensioned at least 2*n+15.
!             in the program that calls hrfftb. the wsave array must be
!             initialized by calling subroutine hrffti(n,wsave) and a
!             different wsave array must be used for each different
!             value of n. this initialization does not have to be
!             repeated so long as n remains unchanged thus subsequent
!             transforms can be obtained faster than the first.
!             the same wsave array can be used by hrfftf and hrfftb.
!
!     work    a real work array with m*n locations.
!
!
!     output parameters
!
!     r      for all j=1,...,m
!
!             for n even and for i = 1,...,n
!
!                  r(j,i) = r(j,1)+(-1)**(i-1)*r(j,n)
!
!                       plus the sum from k=2 to k=n/2 of
!
!                        2.*r(j,2*k-2)*cos((k-1)*(i-1)*2*pi/n)
!
!                       -2.*r(j,2*k-1)*sin((k-1)*(i-1)*2*pi/n)
!
!             for n odd and for i = 1,...,n
!
!                  r(j,i) = r(j,1) plus the sum from k=2 to k=(n+1)/2 of
!
!                       2.*r(j,2*k-2)*cos((k-1)*(i-1)*2*pi/n)
!
!                      -2.*r(j,2*k-1)*sin((k-1)*(i-1)*2*pi/n)
!
!      *****  note
!                  this transform is unnormalized since a call of hrfftf
!                  followed by a call of hrfftb will multiply the input
!                  sequence by n.
!
!     wsave   contains results which must not be destroyed between
!             calls of hrfftb or hrfftf.
!
!     work    a real work array with m*n locations that does not
!             have to be saved
!
! **********************************************************************
!
!
!
      SUBROUTINE HRFFTI(N,Wsave)
      IMPLICIT NONE

      INTEGER N
      REAL TFFt 
      REAL, DIMENSION(N+15) :: Wsave

      COMMON /HRF   / TFFt
      TFFt = 0.
      IF ( N==1 ) RETURN
      CALL HRFTI1(N,Wsave(1),Wsave(N+1))
      END SUBROUTINE HRFFTI

      SUBROUTINE HRFTI1(N,Wa,Fac)
      IMPLICIT NONE

      REAL fi
      REAL, DIMENSION(15) :: Fac
      REAL, DIMENSION(N) :: Wa
      INTEGER i , ib , ido , ii , ip , ipm , is , j , k1 , l1 , l2 ,    &
            & ld , N , nf , nfm1 , nl , nq , nr , ntry , ntryh
!
!     a multiple fft package for spherepack
!
      DIMENSION ntryh(4)
      DOUBLE PRECISION tpi , argh , argld , arg
      DATA ntryh(1) , ntryh(2) , ntryh(3) , ntryh(4)/4 , 2 , 3 , 5/
      nl = N
      nf = 0
      j = 0
 100  j = j + 1
      IF ( j<=4 ) THEN
         ntry = ntryh(j)
      ELSE
         ntry = ntry + 2
      ENDIF
 200  nq = nl/ntry
      nr = nl - ntry*nq
      IF ( nr/=0 ) GOTO 100
      nf = nf + 1
      Fac(nf+2) = ntry
      nl = nq
      IF ( ntry==2 ) THEN
         IF ( nf/=1 ) THEN
            DO i = 2 , nf
               ib = nf - i + 2
               Fac(ib+2) = Fac(ib+1)
            ENDDO
            Fac(3) = 2
         ENDIF
      ENDIF
      IF ( nl/=1 ) GOTO 200
      Fac(1) = N
      Fac(2) = nf
      tpi = 8.D0*DATAN(1.D0)
      argh = tpi/FLOAT(N)
      is = 0
      nfm1 = nf - 1
      l1 = 1
      IF ( nfm1==0 ) RETURN
      DO k1 = 1 , nfm1
         ip = Fac(k1+2)
         ld = 0
         l2 = l1*ip
         ido = N/l2
         ipm = ip - 1
         DO j = 1 , ipm
            ld = ld + l1
            i = is
            argld = FLOAT(ld)*argh
            fi = 0.
            DO ii = 3 , ido , 2
               i = i + 2
               fi = fi + 1.
               arg = fi*argld
               Wa(i-1) = DCOS(arg)
               Wa(i) = DSIN(arg)
            ENDDO
            is = is + ido
         ENDDO
         l1 = l2
      ENDDO
      END SUBROUTINE HRFTI1


      SUBROUTINE HRFFTF(M,N,R,Mdimr,Whrfft,Work)
      IMPLICIT NONE

      INTEGER M , Mdimr , N
      REAL R , TFFt , Whrfft , Work
!
!     a multiple fft package for spherepack
!
      DIMENSION R(Mdimr,N) , Work(1) , Whrfft(N+15)
      COMMON /HRF   / TFFt
      IF ( N==1 ) RETURN
!     tstart = second(dum)
      CALL HRFTF1(M,N,R,Mdimr,Work,Whrfft,Whrfft(N+1))
!     tfft = tfft+second(dum)-tstart
      END SUBROUTINE HRFFTF

      SUBROUTINE HRFTF1(M,N,C,Mdimc,Ch,Wa,Fac)
      IMPLICIT NONE

      REAL C , Ch , Fac , Wa
      INTEGER i , idl1 , ido , ip , iw , ix2 , ix3 , ix4 , j , k1 , kh ,&
            & l1 , l2 , M , Mdimc , N , na , nf
!
!     a multiple fft package for spherepack
!
      DIMENSION Ch(M,N) , C(Mdimc,N) , Wa(N) , Fac(15)
      nf = Fac(2)
      na = 1
      l2 = N
      iw = N
      DO k1 = 1 , nf
         kh = nf - k1
         ip = Fac(kh+3)
         l1 = l2/ip
         ido = N/l2
         idl1 = ido*l1
         iw = iw - (ip-1)*ido
         na = 1 - na
         IF ( ip==4 ) THEN
            ix2 = iw + ido
            ix3 = ix2 + ido
            IF ( na/=0 ) THEN
               CALL HRADF4(M,ido,l1,Ch,M,C,Mdimc,Wa(iw),Wa(ix2),Wa(ix3))
            ELSE
               CALL HRADF4(M,ido,l1,C,Mdimc,Ch,M,Wa(iw),Wa(ix2),Wa(ix3))
            ENDIF
         ELSEIF ( ip/=2 ) THEN
            IF ( ip==3 ) THEN
               ix2 = iw + ido
               IF ( na/=0 ) THEN
                  CALL HRADF3(M,ido,l1,Ch,M,C,Mdimc,Wa(iw),Wa(ix2))
               ELSE
                  CALL HRADF3(M,ido,l1,C,Mdimc,Ch,M,Wa(iw),Wa(ix2))
               ENDIF
            ELSEIF ( ip/=5 ) THEN
               IF ( ido==1 ) na = 1 - na
               IF ( na/=0 ) THEN
                  CALL HRADFG(M,ido,ip,l1,idl1,Ch,Ch,Ch,M,C,C,Mdimc,    &
                            & Wa(iw))
                  na = 0
               ELSE
                  CALL HRADFG(M,ido,ip,l1,idl1,C,C,C,Mdimc,Ch,Ch,M,     &
                            & Wa(iw))
                  na = 1
               ENDIF
            ELSE
               ix2 = iw + ido
               ix3 = ix2 + ido
               ix4 = ix3 + ido
               IF ( na/=0 ) THEN
                  CALL HRADF5(M,ido,l1,Ch,M,C,Mdimc,Wa(iw),Wa(ix2),     &
                            & Wa(ix3),Wa(ix4))
               ELSE
                  CALL HRADF5(M,ido,l1,C,Mdimc,Ch,M,Wa(iw),Wa(ix2),     &
                            & Wa(ix3),Wa(ix4))
               ENDIF
            ENDIF
         ELSEIF ( na/=0 ) THEN
            CALL HRADF2(M,ido,l1,Ch,M,C,Mdimc,Wa(iw))
         ELSE
            CALL HRADF2(M,ido,l1,C,Mdimc,Ch,M,Wa(iw))
         ENDIF
         l2 = l1
      ENDDO
      IF ( na==1 ) RETURN
      DO j = 1 , N
         DO i = 1 , M
            C(i,j) = Ch(i,j)
         ENDDO
      ENDDO
      END SUBROUTINE HRFTF1

      SUBROUTINE HRADF4(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1,Wa2,Wa3)
      IMPLICIT NONE

      REAL Cc , Ch , hsqt2 , Wa1 , Wa2 , Wa3
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp
!
!     a multiple fft package for spherepack
!
      DIMENSION Cc(Mdimcc,Ido,L1,4) , Ch(Mdimch,Ido,4,L1) , Wa1(Ido) ,  &
              & Wa2(Ido) , Wa3(Ido)
      hsqt2 = SQRT(2.)/2.
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,1,k) = (Cc(m,1,k,2)+Cc(m,1,k,4))                     &
                        & + (Cc(m,1,k,1)+Cc(m,1,k,3))
            Ch(m,Ido,4,k) = (Cc(m,1,k,1)+Cc(m,1,k,3))                   &
                          & - (Cc(m,1,k,2)+Cc(m,1,k,4))
            Ch(m,Ido,2,k) = Cc(m,1,k,1) - Cc(m,1,k,3)
            Ch(m,1,3,k) = Cc(m,1,k,4) - Cc(m,1,k,2)
         ENDDO
      ENDDO
      IF ( Ido<2 ) GOTO 99999
      IF ( Ido/=2 ) THEN
         idp2 = Ido + 2
         DO k = 1 , L1
            DO i = 3 , Ido , 2
               ic = idp2 - i
               DO m = 1 , Mp
                  Ch(m,i-1,1,k) = ((Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)*Cc(m&
                                & ,i,k,2))                              &
                                & +(Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)     &
                                & *Cc(m,i,k,4)))                        &
                                & + (Cc(m,i-1,k,1)+(Wa2(i-2)            &
                                & *Cc(m,i-1,k,3)+Wa2(i-1)*Cc(m,i,k,3)))
                  Ch(m,ic-1,4,k) = (Cc(m,i-1,k,1)+(Wa2(i-2)*Cc(m,i-1,k,3&
                                 & )+Wa2(i-1)*Cc(m,i,k,3)))             &
                                 & - ((Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)  &
                                 & *Cc(m,i,k,2))                        &
                                 & +(Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)    &
                                 & *Cc(m,i,k,4)))
                  Ch(m,i,1,k) = ((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)*Cc(m,i-1&
                              & ,k,2))                                  &
                              & +(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)*Cc(m,   &
                              & i-1,k,4)))                              &
                              & + (Cc(m,i,k,1)+(Wa2(i-2)*Cc(m,i,k,3)    &
                              & -Wa2(i-1)*Cc(m,i-1,k,3)))
                  Ch(m,ic,4,k) = ((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)*Cc(m,i-&
                               & 1,k,2))                                &
                               & +(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)*Cc(m,  &
                               & i-1,k,4)))                             &
                               & - (Cc(m,i,k,1)+(Wa2(i-2)*Cc(m,i,k,3)   &
                               & -Wa2(i-1)*Cc(m,i-1,k,3)))
                  Ch(m,i-1,3,k) = ((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)*Cc(m,i&
                                & -1,k,2))                              &
                                & -(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)       &
                                & *Cc(m,i-1,k,4)))                      &
                                & + (Cc(m,i-1,k,1)-(Wa2(i-2)            &
                                & *Cc(m,i-1,k,3)+Wa2(i-1)*Cc(m,i,k,3)))
                  Ch(m,ic-1,2,k) = (Cc(m,i-1,k,1)-(Wa2(i-2)*Cc(m,i-1,k,3&
                                 & )+Wa2(i-1)*Cc(m,i,k,3)))             &
                                 & - ((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)    &
                                 & *Cc(m,i-1,k,2))                      &
                                 & -(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)      &
                                 & *Cc(m,i-1,k,4)))
                  Ch(m,i,3,k) = ((Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)*Cc(m,i&
                              & ,k,4))                                  &
                              & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)*Cc(m, &
                              & i,k,2)))                                &
                              & + (Cc(m,i,k,1)-(Wa2(i-2)*Cc(m,i,k,3)    &
                              & -Wa2(i-1)*Cc(m,i-1,k,3)))
                  Ch(m,ic,2,k) = ((Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)*Cc(m,&
                               & i,k,4))                                &
                               & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)      &
                               & *Cc(m,i,k,2)))                         &
                               & - (Cc(m,i,k,1)-(Wa2(i-2)*Cc(m,i,k,3)   &
                               & -Wa2(i-1)*Cc(m,i-1,k,3)))
               ENDDO
            ENDDO
         ENDDO
         IF ( MOD(Ido,2)==1 ) RETURN
      ENDIF
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,Ido,1,k) = (hsqt2*(Cc(m,Ido,k,2)-Cc(m,Ido,k,4)))       &
                          & + Cc(m,Ido,k,1)
            Ch(m,Ido,3,k) = Cc(m,Ido,k,1)                               &
                          & - (hsqt2*(Cc(m,Ido,k,2)-Cc(m,Ido,k,4)))
            Ch(m,1,2,k) = (-hsqt2*(Cc(m,Ido,k,2)+Cc(m,Ido,k,4)))        &
                        & - Cc(m,Ido,k,3)
            Ch(m,1,4,k) = (-hsqt2*(Cc(m,Ido,k,2)+Cc(m,Ido,k,4)))        &
                        & + Cc(m,Ido,k,3)
         ENDDO
      ENDDO
99999 END SUBROUTINE HRADF4

      SUBROUTINE HRADF2(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1)
      IMPLICIT NONE

      REAL Cc , Ch , Wa1
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp
!
!     a multiple fft package for spherepack
!
      DIMENSION Ch(Mdimch,Ido,2,L1) , Cc(Mdimcc,Ido,L1,2) , Wa1(Ido)
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,1,k) = Cc(m,1,k,1) + Cc(m,1,k,2)
            Ch(m,Ido,2,k) = Cc(m,1,k,1) - Cc(m,1,k,2)
         ENDDO
      ENDDO
      IF ( Ido<2 ) GOTO 99999
      IF ( Ido/=2 ) THEN
         idp2 = Ido + 2
         DO k = 1 , L1
            DO i = 3 , Ido , 2
               ic = idp2 - i
               DO m = 1 , Mp
                  Ch(m,i,1,k) = Cc(m,i,k,1)                             &
                              & + (Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)        &
                              & *Cc(m,i-1,k,2))
                  Ch(m,ic,2,k) = (Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)*Cc(m,i-1&
                               & ,k,2)) - Cc(m,i,k,1)
                  Ch(m,i-1,1,k) = Cc(m,i-1,k,1)                         &
                                & + (Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)    &
                                & *Cc(m,i,k,2))
                  Ch(m,ic-1,2,k) = Cc(m,i-1,k,1)                        &
                                 & - (Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)   &
                                 & *Cc(m,i,k,2))
               ENDDO
            ENDDO
         ENDDO
         IF ( MOD(Ido,2)==1 ) RETURN
      ENDIF
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,2,k) = -Cc(m,Ido,k,2)
            Ch(m,Ido,1,k) = Cc(m,Ido,k,1)
         ENDDO
      ENDDO
99999 END SUBROUTINE HRADF2

      SUBROUTINE HRADF3(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1,Wa2)
      IMPLICIT NONE

      REAL arg , Cc , Ch , PIMACH , taui , taur , Wa1 , Wa2
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp
!
!     a multiple fft package for spherepack
!
      DIMENSION Ch(Mdimch,Ido,3,L1) , Cc(Mdimcc,Ido,L1,3) , Wa1(Ido) ,  &
              & Wa2(Ido)
      arg = 2.*PIMACH()/3.
      taur = COS(arg)
      taui = SIN(arg)
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,1,k) = Cc(m,1,k,1) + (Cc(m,1,k,2)+Cc(m,1,k,3))
            Ch(m,1,3,k) = taui*(Cc(m,1,k,3)-Cc(m,1,k,2))
            Ch(m,Ido,2,k) = Cc(m,1,k,1) + taur*(Cc(m,1,k,2)+Cc(m,1,k,3))
         ENDDO
      ENDDO
      IF ( Ido==1 ) RETURN
      idp2 = Ido + 2
      DO k = 1 , L1
         DO i = 3 , Ido , 2
            ic = idp2 - i
            DO m = 1 , Mp
               Ch(m,i-1,1,k) = Cc(m,i-1,k,1)                            &
                             & + ((Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)      &
                             & *Cc(m,i,k,2))                            &
                             & +(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)        &
                             & *Cc(m,i,k,3)))
               Ch(m,i,1,k) = Cc(m,i,k,1)                                &
                           & + ((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)          &
                           & *Cc(m,i-1,k,2))                            &
                           & +(Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)            &
                           & *Cc(m,i-1,k,3)))
               Ch(m,i-1,3,k) = (Cc(m,i-1,k,1)+taur*((Wa1(i-2)*Cc(m,i-1,k&
                             & ,2)+Wa1(i-1)*Cc(m,i,k,2))                &
                             & +(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)        &
                             & *Cc(m,i,k,3))))                          &
                             & + (taui*((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)  &
                             & *Cc(m,i-1,k,2))                          &
                             & -(Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)          &
                             & *Cc(m,i-1,k,3))))
               Ch(m,ic-1,2,k) = (Cc(m,i-1,k,1)+taur*((Wa1(i-2)*Cc(m,i-1,&
                              & k,2)+Wa1(i-1)*Cc(m,i,k,2))              &
                              & +(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)       &
                              & *Cc(m,i,k,3))))                         &
                              & - (taui*((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1) &
                              & *Cc(m,i-1,k,2))                         &
                              & -(Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)         &
                              & *Cc(m,i-1,k,3))))
               Ch(m,i,3,k) = (Cc(m,i,k,1)+taur*((Wa1(i-2)*Cc(m,i,k,2)-  &
                           & Wa1(i-1)*Cc(m,i-1,k,2))                    &
                           & +(Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)            &
                           & *Cc(m,i-1,k,3))))                          &
                           & + (taui*((Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)  &
                           & *Cc(m,i,k,3))                              &
                           & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)          &
                           & *Cc(m,i,k,2))))
               Ch(m,ic,2,k) = (taui*((Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)*Cc&
                            & (m,i,k,3))                                &
                            & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)         &
                            & *Cc(m,i,k,2))))                           &
                            & - (Cc(m,i,k,1)+taur*((Wa1(i-2)*Cc(m,i,k,2)&
                            & -Wa1(i-1)*Cc(m,i-1,k,2))                  &
                            & +(Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)           &
                            & *Cc(m,i-1,k,3))))
            ENDDO
         ENDDO
      ENDDO
      END SUBROUTINE HRADF3

      SUBROUTINE HRADF5(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1,Wa2,Wa3,Wa4)
      IMPLICIT NONE
      REAL arg , Cc , Ch , PIMACH , ti11 , ti12 , tr11 , tr12 , Wa1 ,   &
         & Wa2 , Wa3 , Wa4
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp
!
!     a multiple fft package for spherepack
!
      DIMENSION Cc(Mdimcc,Ido,L1,5) , Ch(Mdimch,Ido,5,L1) , Wa1(Ido) ,  &
              & Wa2(Ido) , Wa3(Ido) , Wa4(Ido)
      arg = 2.*PIMACH()/5.
      tr11 = COS(arg)
      ti11 = SIN(arg)
      tr12 = COS(2.*arg)
      ti12 = SIN(2.*arg)
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,1,k) = Cc(m,1,k,1) + (Cc(m,1,k,5)+Cc(m,1,k,2))       &
                        & + (Cc(m,1,k,4)+Cc(m,1,k,3))
            Ch(m,Ido,2,k) = Cc(m,1,k,1) + tr11*(Cc(m,1,k,5)+Cc(m,1,k,2))&
                          & + tr12*(Cc(m,1,k,4)+Cc(m,1,k,3))
            Ch(m,1,3,k) = ti11*(Cc(m,1,k,5)-Cc(m,1,k,2))                &
                        & + ti12*(Cc(m,1,k,4)-Cc(m,1,k,3))
            Ch(m,Ido,4,k) = Cc(m,1,k,1) + tr12*(Cc(m,1,k,5)+Cc(m,1,k,2))&
                          & + tr11*(Cc(m,1,k,4)+Cc(m,1,k,3))
            Ch(m,1,5,k) = ti12*(Cc(m,1,k,5)-Cc(m,1,k,2))                &
                        & - ti11*(Cc(m,1,k,4)-Cc(m,1,k,3))
         ENDDO
      ENDDO
      IF ( Ido==1 ) RETURN
      idp2 = Ido + 2
      DO k = 1 , L1
         DO i = 3 , Ido , 2
            ic = idp2 - i
            DO m = 1 , Mp
               Ch(m,i-1,1,k) = Cc(m,i-1,k,1)                            &
                             & + ((Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)      &
                             & *Cc(m,i,k,2))                            &
                             & +(Wa4(i-2)*Cc(m,i-1,k,5)+Wa4(i-1)        &
                             & *Cc(m,i,k,5)))                           &
                             & + ((Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)      &
                             & *Cc(m,i,k,3))                            &
                             & +(Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)        &
                             & *Cc(m,i,k,4)))
               Ch(m,i,1,k) = Cc(m,i,k,1)                                &
                           & + ((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)          &
                           & *Cc(m,i-1,k,2))                            &
                           & +(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)            &
                           & *Cc(m,i-1,k,5)))                           &
                           & + ((Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)          &
                           & *Cc(m,i-1,k,3))                            &
                           & +(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)            &
                           & *Cc(m,i-1,k,4)))
               Ch(m,i-1,3,k) = Cc(m,i-1,k,1)                            &
                             & + tr11*(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)  &
                             & *Cc(m,i,k,2)+Wa4(i-2)*Cc(m,i-1,k,5)      &
                             & +Wa4(i-1)*Cc(m,i,k,5))                   &
                             & + tr12*(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)  &
                             & *Cc(m,i,k,3)+Wa3(i-2)*Cc(m,i-1,k,4)      &
                             & +Wa3(i-1)*Cc(m,i,k,4))                   &
                             & + ti11*(Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)    &
                             & *Cc(m,i-1,k,2)                           &
                             & -(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)          &
                             & *Cc(m,i-1,k,5)))                         &
                             & + ti12*(Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)    &
                             & *Cc(m,i-1,k,3)                           &
                             & -(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)          &
                             & *Cc(m,i-1,k,4)))
               Ch(m,ic-1,2,k) = Cc(m,i-1,k,1)                           &
                              & + tr11*(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1) &
                              & *Cc(m,i,k,2)+Wa4(i-2)*Cc(m,i-1,k,5)     &
                              & +Wa4(i-1)*Cc(m,i,k,5))                  &
                              & + tr12*(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1) &
                              & *Cc(m,i,k,3)+Wa3(i-2)*Cc(m,i-1,k,4)     &
                              & +Wa3(i-1)*Cc(m,i,k,4))                  &
                              & - (ti11*(Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)  &
                              & *Cc(m,i-1,k,2)                          &
                              & -(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)         &
                              & *Cc(m,i-1,k,5)))                        &
                              & +ti12*(Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)    &
                              & *Cc(m,i-1,k,3)                          &
                              & -(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)         &
                              & *Cc(m,i-1,k,4))))
               Ch(m,i,3,k) = (Cc(m,i,k,1)+tr11*((Wa1(i-2)*Cc(m,i,k,2)-  &
                           & Wa1(i-1)*Cc(m,i-1,k,2))                    &
                           & +(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)            &
                           & *Cc(m,i-1,k,5)))                           &
                           & +tr12*((Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)      &
                           & *Cc(m,i-1,k,3))                            &
                           & +(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)            &
                           & *Cc(m,i-1,k,4))))                          &
                           & + (ti11*((Wa4(i-2)*Cc(m,i-1,k,5)+Wa4(i-1)  &
                           & *Cc(m,i,k,5))                              &
                           & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)          &
                           & *Cc(m,i,k,2)))                             &
                           & +ti12*((Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)    &
                           & *Cc(m,i,k,4))                              &
                           & -(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)          &
                           & *Cc(m,i,k,3))))
               Ch(m,ic,2,k) = (ti11*((Wa4(i-2)*Cc(m,i-1,k,5)+Wa4(i-1)*Cc&
                            & (m,i,k,5))                                &
                            & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)         &
                            & *Cc(m,i,k,2)))                            &
                            & +ti12*((Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)   &
                            & *Cc(m,i,k,4))                             &
                            & -(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)         &
                            & *Cc(m,i,k,3))))                           &
                            & - (Cc(m,i,k,1)+tr11*((Wa1(i-2)*Cc(m,i,k,2)&
                            & -Wa1(i-1)*Cc(m,i-1,k,2))                  &
                            & +(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)           &
                            & *Cc(m,i-1,k,5)))                          &
                            & +tr12*((Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)     &
                            & *Cc(m,i-1,k,3))                           &
                            & +(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)           &
                            & *Cc(m,i-1,k,4))))
               Ch(m,i-1,5,k) = (Cc(m,i-1,k,1)+tr12*((Wa1(i-2)*Cc(m,i-1,k&
                             & ,2)+Wa1(i-1)*Cc(m,i,k,2))                &
                             & +(Wa4(i-2)*Cc(m,i-1,k,5)+Wa4(i-1)        &
                             & *Cc(m,i,k,5)))                           &
                             & +tr11*((Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)  &
                             & *Cc(m,i,k,3))                            &
                             & +(Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)        &
                             & *Cc(m,i,k,4))))                          &
                             & + (ti12*((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)  &
                             & *Cc(m,i-1,k,2))                          &
                             & -(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)          &
                             & *Cc(m,i-1,k,5)))                         &
                             & -ti11*((Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)    &
                             & *Cc(m,i-1,k,3))                          &
                             & -(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)          &
                             & *Cc(m,i-1,k,4))))
               Ch(m,ic-1,4,k) = (Cc(m,i-1,k,1)+tr12*((Wa1(i-2)*Cc(m,i-1,&
                              & k,2)+Wa1(i-1)*Cc(m,i,k,2))              &
                              & +(Wa4(i-2)*Cc(m,i-1,k,5)+Wa4(i-1)       &
                              & *Cc(m,i,k,5)))                          &
                              & +tr11*((Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1) &
                              & *Cc(m,i,k,3))                           &
                              & +(Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)       &
                              & *Cc(m,i,k,4))))                         &
                              & - (ti12*((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1) &
                              & *Cc(m,i-1,k,2))                         &
                              & -(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)         &
                              & *Cc(m,i-1,k,5)))                        &
                              & -ti11*((Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)   &
                              & *Cc(m,i-1,k,3))                         &
                              & -(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)         &
                              & *Cc(m,i-1,k,4))))
               Ch(m,i,5,k) = (Cc(m,i,k,1)+tr12*((Wa1(i-2)*Cc(m,i,k,2)-  &
                           & Wa1(i-1)*Cc(m,i-1,k,2))                    &
                           & +(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)            &
                           & *Cc(m,i-1,k,5)))                           &
                           & +tr11*((Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)      &
                           & *Cc(m,i-1,k,3))                            &
                           & +(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)            &
                           & *Cc(m,i-1,k,4))))                          &
                           & + (ti12*((Wa4(i-2)*Cc(m,i-1,k,5)+Wa4(i-1)  &
                           & *Cc(m,i,k,5))                              &
                           & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)          &
                           & *Cc(m,i,k,2)))                             &
                           & -ti11*((Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)    &
                           & *Cc(m,i,k,4))                              &
                           & -(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)          &
                           & *Cc(m,i,k,3))))
               Ch(m,ic,4,k) = (ti12*((Wa4(i-2)*Cc(m,i-1,k,5)+Wa4(i-1)*Cc&
                            & (m,i,k,5))                                &
                            & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)         &
                            & *Cc(m,i,k,2)))                            &
                            & -ti11*((Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)   &
                            & *Cc(m,i,k,4))                             &
                            & -(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)         &
                            & *Cc(m,i,k,3))))                           &
                            & - (Cc(m,i,k,1)+tr12*((Wa1(i-2)*Cc(m,i,k,2)&
                            & -Wa1(i-1)*Cc(m,i-1,k,2))                  &
                            & +(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)           &
                            & *Cc(m,i-1,k,5)))                          &
                            & +tr11*((Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)     &
                            & *Cc(m,i-1,k,3))                           &
                            & +(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)           &
                            & *Cc(m,i-1,k,4))))
            ENDDO
         ENDDO
      ENDDO
      END SUBROUTINE HRADF5

      SUBROUTINE HRADFG(Mp,Ido,Ip,L1,Idl1,Cc,C1,C2,Mdimcc,Ch,Ch2,Mdimch,&
                      & Wa)
      IMPLICIT NONE
      REAL ai1 , ai2 , ar1 , ar1h , ar2 , ar2h , arg , C1 , C2 , Cc ,   &
         & Ch , Ch2 , dc2 , dcp , ds2 , dsp , PIMACH , tpi , Wa
      INTEGER i , ic , idij , Idl1 , Ido , idp2 , ik , Ip , ipp2 ,      &
            & ipph , is , j , j2 , jc , k , l , L1 , lc , m , Mdimcc
      INTEGER Mdimch , Mp , nbd
!
!     a multiple fft package for spherepack
!
      DIMENSION Ch(Mdimch,Ido,L1,Ip) , Cc(Mdimcc,Ido,Ip,L1) ,           &
              & C1(Mdimcc,Ido,L1,Ip) , C2(Mdimcc,Idl1,Ip) ,             &
              & Ch2(Mdimch,Idl1,Ip) , Wa(Ido)
      tpi = 2.*PIMACH()
      arg = tpi/FLOAT(Ip)
      dcp = COS(arg)
      dsp = SIN(arg)
      ipph = (Ip+1)/2
      ipp2 = Ip + 2
      idp2 = Ido + 2
      nbd = (Ido-1)/2
      IF ( Ido==1 ) THEN
         DO ik = 1 , Idl1
            DO m = 1 , Mp
               C2(m,ik,1) = Ch2(m,ik,1)
            ENDDO
         ENDDO
      ELSE
         DO ik = 1 , Idl1
            DO m = 1 , Mp
               Ch2(m,ik,1) = C2(m,ik,1)
            ENDDO
         ENDDO
         DO j = 2 , Ip
            DO k = 1 , L1
               DO m = 1 , Mp
                  Ch(m,1,k,j) = C1(m,1,k,j)
               ENDDO
            ENDDO
         ENDDO
         IF ( nbd>L1 ) THEN
            is = -Ido
            DO j = 2 , Ip
               is = is + Ido
               DO k = 1 , L1
                  idij = is
                  DO i = 3 , Ido , 2
                     idij = idij + 2
                     DO m = 1 , Mp
                        Ch(m,i-1,k,j) = Wa(idij-1)*C1(m,i-1,k,j)        &
                                      & + Wa(idij)*C1(m,i,k,j)
                        Ch(m,i,k,j) = Wa(idij-1)*C1(m,i,k,j) - Wa(idij) &
                                    & *C1(m,i-1,k,j)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ELSE
            is = -Ido
            DO j = 2 , Ip
               is = is + Ido
               idij = is
               DO i = 3 , Ido , 2
                  idij = idij + 2
                  DO k = 1 , L1
                     DO m = 1 , Mp
                        Ch(m,i-1,k,j) = Wa(idij-1)*C1(m,i-1,k,j)        &
                                      & + Wa(idij)*C1(m,i,k,j)
                        Ch(m,i,k,j) = Wa(idij-1)*C1(m,i,k,j) - Wa(idij) &
                                    & *C1(m,i-1,k,j)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
         IF ( nbd<L1 ) THEN
            DO j = 2 , ipph
               jc = ipp2 - j
               DO i = 3 , Ido , 2
                  DO k = 1 , L1
                     DO m = 1 , Mp
                        C1(m,i-1,k,j) = Ch(m,i-1,k,j) + Ch(m,i-1,k,jc)
                        C1(m,i-1,k,jc) = Ch(m,i,k,j) - Ch(m,i,k,jc)
                        C1(m,i,k,j) = Ch(m,i,k,j) + Ch(m,i,k,jc)
                        C1(m,i,k,jc) = Ch(m,i-1,k,jc) - Ch(m,i-1,k,j)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ELSE
            DO j = 2 , ipph
               jc = ipp2 - j
               DO k = 1 , L1
                  DO i = 3 , Ido , 2
                     DO m = 1 , Mp
                        C1(m,i-1,k,j) = Ch(m,i-1,k,j) + Ch(m,i-1,k,jc)
                        C1(m,i-1,k,jc) = Ch(m,i,k,j) - Ch(m,i,k,jc)
                        C1(m,i,k,j) = Ch(m,i,k,j) + Ch(m,i,k,jc)
                        C1(m,i,k,jc) = Ch(m,i-1,k,jc) - Ch(m,i-1,k,j)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      DO j = 2 , ipph
         jc = ipp2 - j
         DO k = 1 , L1
            DO m = 1 , Mp
               C1(m,1,k,j) = Ch(m,1,k,j) + Ch(m,1,k,jc)
               C1(m,1,k,jc) = Ch(m,1,k,jc) - Ch(m,1,k,j)
            ENDDO
         ENDDO
      ENDDO
!
      ar1 = 1.
      ai1 = 0.
      DO l = 2 , ipph
         lc = ipp2 - l
         ar1h = dcp*ar1 - dsp*ai1
         ai1 = dcp*ai1 + dsp*ar1
         ar1 = ar1h
         DO ik = 1 , Idl1
            DO m = 1 , Mp
               Ch2(m,ik,l) = C2(m,ik,1) + ar1*C2(m,ik,2)
               Ch2(m,ik,lc) = ai1*C2(m,ik,Ip)
            ENDDO
         ENDDO
         dc2 = ar1
         ds2 = ai1
         ar2 = ar1
         ai2 = ai1
         DO j = 3 , ipph
            jc = ipp2 - j
            ar2h = dc2*ar2 - ds2*ai2
            ai2 = dc2*ai2 + ds2*ar2
            ar2 = ar2h
            DO ik = 1 , Idl1
               DO m = 1 , Mp
                  Ch2(m,ik,l) = Ch2(m,ik,l) + ar2*C2(m,ik,j)
                  Ch2(m,ik,lc) = Ch2(m,ik,lc) + ai2*C2(m,ik,jc)
               ENDDO
            ENDDO
         ENDDO
      ENDDO
      DO j = 2 , ipph
         DO ik = 1 , Idl1
            DO m = 1 , Mp
               Ch2(m,ik,1) = Ch2(m,ik,1) + C2(m,ik,j)
            ENDDO
         ENDDO
      ENDDO
!
      IF ( Ido<L1 ) THEN
         DO i = 1 , Ido
            DO k = 1 , L1
               DO m = 1 , Mp
                  Cc(m,i,1,k) = Ch(m,i,k,1)
               ENDDO
            ENDDO
         ENDDO
      ELSE
         DO k = 1 , L1
            DO i = 1 , Ido
               DO m = 1 , Mp
                  Cc(m,i,1,k) = Ch(m,i,k,1)
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      DO j = 2 , ipph
         jc = ipp2 - j
         j2 = j + j
         DO k = 1 , L1
            DO m = 1 , Mp
               Cc(m,Ido,j2-2,k) = Ch(m,1,k,j)
               Cc(m,1,j2-1,k) = Ch(m,1,k,jc)
            ENDDO
         ENDDO
      ENDDO
      IF ( Ido==1 ) RETURN
      IF ( nbd<L1 ) THEN
         DO j = 2 , ipph
            jc = ipp2 - j
            j2 = j + j
            DO i = 3 , Ido , 2
               ic = idp2 - i
               DO k = 1 , L1
                  DO m = 1 , Mp
                     Cc(m,i-1,j2-1,k) = Ch(m,i-1,k,j) + Ch(m,i-1,k,jc)
                     Cc(m,ic-1,j2-2,k) = Ch(m,i-1,k,j) - Ch(m,i-1,k,jc)
                     Cc(m,i,j2-1,k) = Ch(m,i,k,j) + Ch(m,i,k,jc)
                     Cc(m,ic,j2-2,k) = Ch(m,i,k,jc) - Ch(m,i,k,j)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
         GOTO 99999
      ENDIF
      DO j = 2 , ipph
         jc = ipp2 - j
         j2 = j + j
         DO k = 1 , L1
            DO i = 3 , Ido , 2
               ic = idp2 - i
               DO m = 1 , Mp
                  Cc(m,i-1,j2-1,k) = Ch(m,i-1,k,j) + Ch(m,i-1,k,jc)
                  Cc(m,ic-1,j2-2,k) = Ch(m,i-1,k,j) - Ch(m,i-1,k,jc)
                  Cc(m,i,j2-1,k) = Ch(m,i,k,j) + Ch(m,i,k,jc)
                  Cc(m,ic,j2-2,k) = Ch(m,i,k,jc) - Ch(m,i,k,j)
               ENDDO
            ENDDO
         ENDDO
      ENDDO
      RETURN
99999 END SUBROUTINE  HRADFG

      FUNCTION PIMACH()
        IMPLICIT NONE
        REAL PIMACH
      PIMACH = 3.14159265358979
      END FUNCTION PIMACH

      FUNCTION DPIMACH()
      IMPLICIT NONE
      DOUBLE PRECISION DPIMACH
      DPIMACH = 3.14159265358979
      END FUNCTION DPIMACH

      SUBROUTINE HRFFTB(M,N,R,Mdimr,Whrfft,Work)
      IMPLICIT NONE
      INTEGER M , Mdimr , N
      REAL R , TFFt , Whrfft , Work
!
!     a multiple fft package for spherepack
!
      DIMENSION R(Mdimr,N) , Work(1) , Whrfft(N+15)
      COMMON /HRF   / TFFt
      IF ( N==1 ) RETURN
!     tstart = second(dum)
      CALL HRFTB1(M,N,R,Mdimr,Work,Whrfft,Whrfft(N+1))
!     tfft = tfft+second(dum)-tstart
      END SUBROUTINE HRFFTB

      SUBROUTINE HRFTB1(M,N,C,Mdimc,Ch,Wa,Fac)
      IMPLICIT NONE
      REAL C , Ch , Fac , Wa
      INTEGER i , idl1 , ido , ip , iw , ix2 , ix3 , ix4 , j , k1 , l1 ,&
            & l2 , M , Mdimc , N , na , nf
!
!     a multiple fft package for spherepack
!
      DIMENSION Ch(M,N) , C(Mdimc,N) , Wa(N) , Fac(15)
      nf = Fac(2)
      na = 0
      l1 = 1
      iw = 1
      DO k1 = 1 , nf
         ip = Fac(k1+2)
         l2 = ip*l1
         ido = N/l2
         idl1 = ido*l1
         IF ( ip==4 ) THEN
            ix2 = iw + ido
            ix3 = ix2 + ido
            IF ( na/=0 ) THEN
               CALL HRADB4(M,ido,l1,Ch,M,C,Mdimc,Wa(iw),Wa(ix2),Wa(ix3))
            ELSE
               CALL HRADB4(M,ido,l1,C,Mdimc,Ch,M,Wa(iw),Wa(ix2),Wa(ix3))
            ENDIF
            na = 1 - na
         ELSEIF ( ip==2 ) THEN
            IF ( na/=0 ) THEN
               CALL HRADB2(M,ido,l1,Ch,M,C,Mdimc,Wa(iw))
            ELSE
               CALL HRADB2(M,ido,l1,C,Mdimc,Ch,M,Wa(iw))
            ENDIF
            na = 1 - na
         ELSEIF ( ip==3 ) THEN
            ix2 = iw + ido
            IF ( na/=0 ) THEN
               CALL HRADB3(M,ido,l1,Ch,M,C,Mdimc,Wa(iw),Wa(ix2))
            ELSE
               CALL HRADB3(M,ido,l1,C,Mdimc,Ch,M,Wa(iw),Wa(ix2))
            ENDIF
            na = 1 - na
         ELSEIF ( ip/=5 ) THEN
            IF ( na/=0 ) THEN
               CALL HRADBG(M,ido,ip,l1,idl1,Ch,Ch,Ch,M,C,C,Mdimc,Wa(iw))
            ELSE
               CALL HRADBG(M,ido,ip,l1,idl1,C,C,C,Mdimc,Ch,Ch,M,Wa(iw))
            ENDIF
            IF ( ido==1 ) na = 1 - na
         ELSE
            ix2 = iw + ido
            ix3 = ix2 + ido
            ix4 = ix3 + ido
            IF ( na/=0 ) THEN
               CALL HRADB5(M,ido,l1,Ch,M,C,Mdimc,Wa(iw),Wa(ix2),Wa(ix3),&
                         & Wa(ix4))
            ELSE
               CALL HRADB5(M,ido,l1,C,Mdimc,Ch,M,Wa(iw),Wa(ix2),Wa(ix3),&
                         & Wa(ix4))
            ENDIF
            na = 1 - na
         ENDIF
         l1 = l2
         iw = iw + (ip-1)*ido
      ENDDO
      IF ( na==0 ) RETURN
      DO j = 1 , N
         DO i = 1 , M
            C(i,j) = Ch(i,j)
         ENDDO
      ENDDO
      END SUBROUTINE HRFTB1

      SUBROUTINE HRADBG(Mp,Ido,Ip,L1,Idl1,Cc,C1,C2,Mdimcc,Ch,Ch2,Mdimch,&
                      & Wa)
      IMPLICIT NONE
      REAL ai1 , ai2 , ar1 , ar1h , ar2 , ar2h , arg , C1 , C2 , Cc ,   &
         & Ch , Ch2 , dc2 , dcp , ds2 , dsp , PIMACH , tpi , Wa
      INTEGER i , ic , idij , Idl1 , Ido , idp2 , ik , Ip , ipp2 ,      &
            & ipph , is , j , j2 , jc , k , l , L1 , lc , m , Mdimcc
      INTEGER Mdimch , Mp , nbd
!
!     a multiple fft package for spherepack
!
      DIMENSION Ch(Mdimch,Ido,L1,Ip) , Cc(Mdimcc,Ido,Ip,L1) ,           &
              & C1(Mdimcc,Ido,L1,Ip) , C2(Mdimcc,Idl1,Ip) ,             &
              & Ch2(Mdimch,Idl1,Ip) , Wa(Ido)
      tpi = 2.*PIMACH()
      arg = tpi/FLOAT(Ip)
      dcp = COS(arg)
      dsp = SIN(arg)
      idp2 = Ido + 2
      nbd = (Ido-1)/2
      ipp2 = Ip + 2
      ipph = (Ip+1)/2
      IF ( Ido<L1 ) THEN
         DO i = 1 , Ido
            DO k = 1 , L1
               DO m = 1 , Mp
                  Ch(m,i,k,1) = Cc(m,i,1,k)
               ENDDO
            ENDDO
         ENDDO
      ELSE
         DO k = 1 , L1
            DO i = 1 , Ido
               DO m = 1 , Mp
                  Ch(m,i,k,1) = Cc(m,i,1,k)
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      DO j = 2 , ipph
         jc = ipp2 - j
         j2 = j + j
         DO k = 1 , L1
            DO m = 1 , Mp
               Ch(m,1,k,j) = Cc(m,Ido,j2-2,k) + Cc(m,Ido,j2-2,k)
               Ch(m,1,k,jc) = Cc(m,1,j2-1,k) + Cc(m,1,j2-1,k)
            ENDDO
         ENDDO
      ENDDO
      IF ( Ido/=1 ) THEN
         IF ( nbd<L1 ) THEN
            DO j = 2 , ipph
               jc = ipp2 - j
               DO i = 3 , Ido , 2
                  ic = idp2 - i
                  DO k = 1 , L1
                     DO m = 1 , Mp
                        Ch(m,i-1,k,j) = Cc(m,i-1,2*j-1,k)               &
                                      & + Cc(m,ic-1,2*j-2,k)
                        Ch(m,i-1,k,jc) = Cc(m,i-1,2*j-1,k)              &
                         & - Cc(m,ic-1,2*j-2,k)
                        Ch(m,i,k,j) = Cc(m,i,2*j-1,k) - Cc(m,ic,2*j-2,k)
                        Ch(m,i,k,jc) = Cc(m,i,2*j-1,k)                  &
                                     & + Cc(m,ic,2*j-2,k)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ELSE
            DO j = 2 , ipph
               jc = ipp2 - j
               DO k = 1 , L1
                  DO i = 3 , Ido , 2
                     ic = idp2 - i
                     DO m = 1 , Mp
                        Ch(m,i-1,k,j) = Cc(m,i-1,2*j-1,k)               &
                                      & + Cc(m,ic-1,2*j-2,k)
                        Ch(m,i-1,k,jc) = Cc(m,i-1,2*j-1,k)              &
                         & - Cc(m,ic-1,2*j-2,k)
                        Ch(m,i,k,j) = Cc(m,i,2*j-1,k) - Cc(m,ic,2*j-2,k)
                        Ch(m,i,k,jc) = Cc(m,i,2*j-1,k)                  &
                                     & + Cc(m,ic,2*j-2,k)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      ar1 = 1.
      ai1 = 0.
      DO l = 2 , ipph
         lc = ipp2 - l
         ar1h = dcp*ar1 - dsp*ai1
         ai1 = dcp*ai1 + dsp*ar1
         ar1 = ar1h
         DO ik = 1 , Idl1
            DO m = 1 , Mp
               C2(m,ik,l) = Ch2(m,ik,1) + ar1*Ch2(m,ik,2)
               C2(m,ik,lc) = ai1*Ch2(m,ik,Ip)
            ENDDO
         ENDDO
         dc2 = ar1
         ds2 = ai1
         ar2 = ar1
         ai2 = ai1
         DO j = 3 , ipph
            jc = ipp2 - j
            ar2h = dc2*ar2 - ds2*ai2
            ai2 = dc2*ai2 + ds2*ar2
            ar2 = ar2h
            DO ik = 1 , Idl1
               DO m = 1 , Mp
                  C2(m,ik,l) = C2(m,ik,l) + ar2*Ch2(m,ik,j)
                  C2(m,ik,lc) = C2(m,ik,lc) + ai2*Ch2(m,ik,jc)
               ENDDO
            ENDDO
         ENDDO
      ENDDO
      DO j = 2 , ipph
         DO ik = 1 , Idl1
            DO m = 1 , Mp
               Ch2(m,ik,1) = Ch2(m,ik,1) + Ch2(m,ik,j)
            ENDDO
         ENDDO
      ENDDO
      DO j = 2 , ipph
         jc = ipp2 - j
         DO k = 1 , L1
            DO m = 1 , Mp
               Ch(m,1,k,j) = C1(m,1,k,j) - C1(m,1,k,jc)
               Ch(m,1,k,jc) = C1(m,1,k,j) + C1(m,1,k,jc)
            ENDDO
         ENDDO
      ENDDO
      IF ( Ido/=1 ) THEN
         IF ( nbd<L1 ) THEN
            DO j = 2 , ipph
               jc = ipp2 - j
               DO i = 3 , Ido , 2
                  DO k = 1 , L1
                     DO m = 1 , Mp
                        Ch(m,i-1,k,j) = C1(m,i-1,k,j) - C1(m,i,k,jc)
                        Ch(m,i-1,k,jc) = C1(m,i-1,k,j) + C1(m,i,k,jc)
                        Ch(m,i,k,j) = C1(m,i,k,j) + C1(m,i-1,k,jc)
                        Ch(m,i,k,jc) = C1(m,i,k,j) - C1(m,i-1,k,jc)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ELSE
            DO j = 2 , ipph
               jc = ipp2 - j
               DO k = 1 , L1
                  DO i = 3 , Ido , 2
                     DO m = 1 , Mp
                        Ch(m,i-1,k,j) = C1(m,i-1,k,j) - C1(m,i,k,jc)
                        Ch(m,i-1,k,jc) = C1(m,i-1,k,j) + C1(m,i,k,jc)
                        Ch(m,i,k,j) = C1(m,i,k,j) + C1(m,i-1,k,jc)
                        Ch(m,i,k,jc) = C1(m,i,k,j) - C1(m,i-1,k,jc)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      IF ( Ido==1 ) RETURN
      DO ik = 1 , Idl1
         DO m = 1 , Mp
            C2(m,ik,1) = Ch2(m,ik,1)
         ENDDO
      ENDDO
      DO j = 2 , Ip
         DO k = 1 , L1
            DO m = 1 , Mp
               C1(m,1,k,j) = Ch(m,1,k,j)
            ENDDO
         ENDDO
      ENDDO
      IF ( nbd>L1 ) THEN
         is = -Ido
         DO j = 2 , Ip
            is = is + Ido
            DO k = 1 , L1
               idij = is
               DO i = 3 , Ido , 2
                  idij = idij + 2
                  DO m = 1 , Mp
                     C1(m,i-1,k,j) = Wa(idij-1)*Ch(m,i-1,k,j) - Wa(idij)&
                                   & *Ch(m,i,k,j)
                     C1(m,i,k,j) = Wa(idij-1)*Ch(m,i,k,j) + Wa(idij)    &
                                 & *Ch(m,i-1,k,j)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
      ELSE
         is = -Ido
         DO j = 2 , Ip
            is = is + Ido
            idij = is
            DO i = 3 , Ido , 2
               idij = idij + 2
               DO k = 1 , L1
                  DO m = 1 , Mp
                     C1(m,i-1,k,j) = Wa(idij-1)*Ch(m,i-1,k,j) - Wa(idij)&
                                   & *Ch(m,i,k,j)
                     C1(m,i,k,j) = Wa(idij-1)*Ch(m,i,k,j) + Wa(idij)    &
                                 & *Ch(m,i-1,k,j)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      END SUBROUTINE HRADBG

      SUBROUTINE HRADB4(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1,Wa2,Wa3)
      IMPLICIT NONE


      REAL Cc , Ch , sqrt2 , Wa1 , Wa2 , Wa3
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp

!
!     a multiple fft package for spherepack
!
      DIMENSION Cc(Mdimcc,Ido,4,L1) , Ch(Mdimch,Ido,L1,4) , Wa1(Ido) ,  &
              & Wa2(Ido) , Wa3(Ido)
      sqrt2 = SQRT(2.)
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,k,3) = (Cc(m,1,1,k)+Cc(m,Ido,4,k))                   &
                        & - (Cc(m,Ido,2,k)+Cc(m,Ido,2,k))
            Ch(m,1,k,1) = (Cc(m,1,1,k)+Cc(m,Ido,4,k))                   &
                        & + (Cc(m,Ido,2,k)+Cc(m,Ido,2,k))
            Ch(m,1,k,4) = (Cc(m,1,1,k)-Cc(m,Ido,4,k))                   &
                        & + (Cc(m,1,3,k)+Cc(m,1,3,k))
            Ch(m,1,k,2) = (Cc(m,1,1,k)-Cc(m,Ido,4,k))                   &
                        & - (Cc(m,1,3,k)+Cc(m,1,3,k))
         ENDDO
      ENDDO
      IF ( Ido<2 ) GOTO 99999
      IF ( Ido/=2 ) THEN
         idp2 = Ido + 2
         DO k = 1 , L1
            DO i = 3 , Ido , 2
               ic = idp2 - i
               DO m = 1 , Mp
                  Ch(m,i-1,k,1) = (Cc(m,i-1,1,k)+Cc(m,ic-1,4,k))        &
                                & + (Cc(m,i-1,3,k)+Cc(m,ic-1,2,k))
                  Ch(m,i,k,1) = (Cc(m,i,1,k)-Cc(m,ic,4,k))              &
                              & + (Cc(m,i,3,k)-Cc(m,ic,2,k))
                  Ch(m,i-1,k,2) = Wa1(i-2)                              &
                                & *((Cc(m,i-1,1,k)-Cc(m,ic-1,4,k))      &
                                & -(Cc(m,i,3,k)+Cc(m,ic,2,k)))          &
                                & - Wa1(i-1)                            &
                                & *((Cc(m,i,1,k)+Cc(m,ic,4,k))+         &
                                & (Cc(m,i-1,3,k)-Cc(m,ic-1,2,k)))
                  Ch(m,i,k,2) = Wa1(i-2)                                &
                              & *((Cc(m,i,1,k)+Cc(m,ic,4,k))+(Cc(m,i-1, &
                              & 3,k)-Cc(m,ic-1,2,k))) + Wa1(i-1)        &
                              & *((Cc(m,i-1,1,k)-Cc(m,ic-1,4,k))        &
                              & -(Cc(m,i,3,k)+Cc(m,ic,2,k)))
                  Ch(m,i-1,k,3) = Wa2(i-2)                              &
                                & *((Cc(m,i-1,1,k)+Cc(m,ic-1,4,k))      &
                                & -(Cc(m,i-1,3,k)+Cc(m,ic-1,2,k)))      &
                                & - Wa2(i-1)                            &
                                & *((Cc(m,i,1,k)-Cc(m,ic,4,k))-         &
                                & (Cc(m,i,3,k)-Cc(m,ic,2,k)))
                  Ch(m,i,k,3) = Wa2(i-2)                                &
                              & *((Cc(m,i,1,k)-Cc(m,ic,4,k))-(Cc(m,i,3, &
                              & k)-Cc(m,ic,2,k))) + Wa2(i-1)            &
                              & *((Cc(m,i-1,1,k)+Cc(m,ic-1,4,k))        &
                              & -(Cc(m,i-1,3,k)+Cc(m,ic-1,2,k)))
                  Ch(m,i-1,k,4) = Wa3(i-2)                              &
                                & *((Cc(m,i-1,1,k)-Cc(m,ic-1,4,k))      &
                                & +(Cc(m,i,3,k)+Cc(m,ic,2,k)))          &
                                & - Wa3(i-1)                            &
                                & *((Cc(m,i,1,k)+Cc(m,ic,4,k))-         &
                                & (Cc(m,i-1,3,k)-Cc(m,ic-1,2,k)))
                  Ch(m,i,k,4) = Wa3(i-2)                                &
                              & *((Cc(m,i,1,k)+Cc(m,ic,4,k))-(Cc(m,i-1, &
                              & 3,k)-Cc(m,ic-1,2,k))) + Wa3(i-1)        &
                              & *((Cc(m,i-1,1,k)-Cc(m,ic-1,4,k))        &
                              & +(Cc(m,i,3,k)+Cc(m,ic,2,k)))
               ENDDO
            ENDDO
         ENDDO
         IF ( MOD(Ido,2)==1 ) RETURN
      ENDIF
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,Ido,k,1) = (Cc(m,Ido,1,k)+Cc(m,Ido,3,k))               &
                          & + (Cc(m,Ido,1,k)+Cc(m,Ido,3,k))
            Ch(m,Ido,k,2) = sqrt2*((Cc(m,Ido,1,k)-Cc(m,Ido,3,k))-(Cc(m,1&
                          & ,2,k)+Cc(m,1,4,k)))
            Ch(m,Ido,k,3) = (Cc(m,1,4,k)-Cc(m,1,2,k))                   &
                          & + (Cc(m,1,4,k)-Cc(m,1,2,k))
            Ch(m,Ido,k,4) = -sqrt2*((Cc(m,Ido,1,k)-Cc(m,Ido,3,k))+(Cc(m,&
                          & 1,2,k)+Cc(m,1,4,k)))
         ENDDO
      ENDDO
99999 END SUBROUTINE HRADB4

      SUBROUTINE HRADB2(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1)
      IMPLICIT NONE
      REAL Cc , Ch , Wa1
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp
!
!     a multiple fft package for spherepack
!
      DIMENSION Cc(Mdimcc,Ido,2,L1) , Ch(Mdimch,Ido,L1,2) , Wa1(Ido)
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,k,1) = Cc(m,1,1,k) + Cc(m,Ido,2,k)
            Ch(m,1,k,2) = Cc(m,1,1,k) - Cc(m,Ido,2,k)
         ENDDO
      ENDDO
      IF ( Ido<2 ) GOTO 99999
      IF ( Ido/=2 ) THEN
         idp2 = Ido + 2
         DO k = 1 , L1
            DO i = 3 , Ido , 2
               ic = idp2 - i
               DO m = 1 , Mp
                  Ch(m,i-1,k,1) = Cc(m,i-1,1,k) + Cc(m,ic-1,2,k)
                  Ch(m,i,k,1) = Cc(m,i,1,k) - Cc(m,ic,2,k)
                  Ch(m,i-1,k,2) = Wa1(i-2)                              &
                                & *(Cc(m,i-1,1,k)-Cc(m,ic-1,2,k))       &
                                & - Wa1(i-1)*(Cc(m,i,1,k)+Cc(m,ic,2,k))
                  Ch(m,i,k,2) = Wa1(i-2)*(Cc(m,i,1,k)+Cc(m,ic,2,k))     &
                              & + Wa1(i-1)                              &
                              & *(Cc(m,i-1,1,k)-Cc(m,ic-1,2,k))
               ENDDO
            ENDDO
         ENDDO
         IF ( MOD(Ido,2)==1 ) RETURN
      ENDIF
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,Ido,k,1) = Cc(m,Ido,1,k) + Cc(m,Ido,1,k)
            Ch(m,Ido,k,2) = -(Cc(m,1,2,k)+Cc(m,1,2,k))
         ENDDO
      ENDDO
99999 END SUBROUTINE HRADB2

      SUBROUTINE HRADB3(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1,Wa2)
      IMPLICIT NONE
      REAL arg , Cc , Ch , PIMACH , taui , taur , Wa1 , Wa2
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp
!
!     a multiple fft package for spherepack
!
      DIMENSION Cc(Mdimcc,Ido,3,L1) , Ch(Mdimch,Ido,L1,3) , Wa1(Ido) ,  &
              & Wa2(Ido)
      arg = 2.*PIMACH()/3.
      taur = COS(arg)
      taui = SIN(arg)
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,k,1) = Cc(m,1,1,k) + 2.*Cc(m,Ido,2,k)
            Ch(m,1,k,2) = Cc(m,1,1,k) + (2.*taur)*Cc(m,Ido,2,k)         &
                        & - (2.*taui)*Cc(m,1,3,k)
            Ch(m,1,k,3) = Cc(m,1,1,k) + (2.*taur)*Cc(m,Ido,2,k)         &
                        & + 2.*taui*Cc(m,1,3,k)
         ENDDO
      ENDDO
      IF ( Ido==1 ) RETURN
      idp2 = Ido + 2
      DO k = 1 , L1
         DO i = 3 , Ido , 2
            ic = idp2 - i
            DO m = 1 , Mp
               Ch(m,i-1,k,1) = Cc(m,i-1,1,k)                            &
                             & + (Cc(m,i-1,3,k)+Cc(m,ic-1,2,k))
               Ch(m,i,k,1) = Cc(m,i,1,k) + (Cc(m,i,3,k)-Cc(m,ic,2,k))
               Ch(m,i-1,k,2) = Wa1(i-2)                                 &
                             & *((Cc(m,i-1,1,k)+taur*(Cc(m,i-1,3,k)     &
                             & +Cc(m,ic-1,2,k)))                        &
                             & -(taui*(Cc(m,i,3,k)+Cc(m,ic,2,k))))      &
                             & - Wa1(i-1)                               &
                             & *((Cc(m,i,1,k)+taur*(Cc(m,i,3,k)         &
                             & -Cc(m,ic,2,k)))                          &
                             & +(taui*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))))
               Ch(m,i,k,2) = Wa1(i-2)                                   &
                           & *((Cc(m,i,1,k)+taur*(Cc(m,i,3,k)-Cc(m,ic,2,&
                           & k)))+(taui*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))))&
                           & + Wa1(i-1)                                 &
                           & *((Cc(m,i-1,1,k)+taur*(Cc(m,i-1,3,k)       &
                           & +Cc(m,ic-1,2,k)))                          &
                           & -(taui*(Cc(m,i,3,k)+Cc(m,ic,2,k))))
               Ch(m,i-1,k,3) = Wa2(i-2)                                 &
                             & *((Cc(m,i-1,1,k)+taur*(Cc(m,i-1,3,k)     &
                             & +Cc(m,ic-1,2,k)))                        &
                             & +(taui*(Cc(m,i,3,k)+Cc(m,ic,2,k))))      &
                             & - Wa2(i-1)                               &
                             & *((Cc(m,i,1,k)+taur*(Cc(m,i,3,k)         &
                             & -Cc(m,ic,2,k)))                          &
                             & -(taui*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))))
               Ch(m,i,k,3) = Wa2(i-2)                                   &
                           & *((Cc(m,i,1,k)+taur*(Cc(m,i,3,k)-Cc(m,ic,2,&
                           & k)))-(taui*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))))&
                           & + Wa2(i-1)                                 &
                           & *((Cc(m,i-1,1,k)+taur*(Cc(m,i-1,3,k)       &
                           & +Cc(m,ic-1,2,k)))                          &
                           & +(taui*(Cc(m,i,3,k)+Cc(m,ic,2,k))))
            ENDDO
         ENDDO
      ENDDO
      END SUBROUTINE HRADB3

      SUBROUTINE HRADB5(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1,Wa2,Wa3,Wa4)
      IMPLICIT NONE
      REAL arg , Cc , Ch , PIMACH , ti11 , ti12 , tr11 , tr12 , Wa1 ,   &
         & Wa2 , Wa3 , Wa4
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp
!
!     a multiple fft package for spherepack
!
      DIMENSION Cc(Mdimcc,Ido,5,L1) , Ch(Mdimch,Ido,L1,5) , Wa1(Ido) ,  &
              & Wa2(Ido) , Wa3(Ido) , Wa4(Ido)
      arg = 2.*PIMACH()/5.
      tr11 = COS(arg)
      ti11 = SIN(arg)
      tr12 = COS(2.*arg)
      ti12 = SIN(2.*arg)
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,k,1) = Cc(m,1,1,k) + 2.*Cc(m,Ido,2,k)                &
                        & + 2.*Cc(m,Ido,4,k)
            Ch(m,1,k,2) = (Cc(m,1,1,k)+tr11*2.*Cc(m,Ido,2,k)+tr12*2.*Cc(&
                        & m,Ido,4,k))                                   &
                        & - (ti11*2.*Cc(m,1,3,k)+ti12*2.*Cc(m,1,5,k))
            Ch(m,1,k,3) = (Cc(m,1,1,k)+tr12*2.*Cc(m,Ido,2,k)+tr11*2.*Cc(&
                        & m,Ido,4,k))                                   &
                        & - (ti12*2.*Cc(m,1,3,k)-ti11*2.*Cc(m,1,5,k))
            Ch(m,1,k,4) = (Cc(m,1,1,k)+tr12*2.*Cc(m,Ido,2,k)+tr11*2.*Cc(&
                        & m,Ido,4,k))                                   &
                        & + (ti12*2.*Cc(m,1,3,k)-ti11*2.*Cc(m,1,5,k))
            Ch(m,1,k,5) = (Cc(m,1,1,k)+tr11*2.*Cc(m,Ido,2,k)+tr12*2.*Cc(&
                        & m,Ido,4,k))                                   &
                        & + (ti11*2.*Cc(m,1,3,k)+ti12*2.*Cc(m,1,5,k))
         ENDDO
      ENDDO
      IF ( Ido==1 ) RETURN
      idp2 = Ido + 2
      DO k = 1 , L1
         DO i = 3 , Ido , 2
            ic = idp2 - i
            DO m = 1 , Mp
               Ch(m,i-1,k,1) = Cc(m,i-1,1,k)                            &
                             & + (Cc(m,i-1,3,k)+Cc(m,ic-1,2,k))         &
                             & + (Cc(m,i-1,5,k)+Cc(m,ic-1,4,k))
               Ch(m,i,k,1) = Cc(m,i,1,k) + (Cc(m,i,3,k)-Cc(m,ic,2,k))   &
                           & + (Cc(m,i,5,k)-Cc(m,ic,4,k))
               Ch(m,i-1,k,2) = Wa1(i-2)                                 &
                             & *((Cc(m,i-1,1,k)+tr11*(Cc(m,i-1,3,k)     &
                             & +Cc(m,ic-1,2,k))                         &
                             & +tr12*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))    &
                             & -(ti11*(Cc(m,i,3,k)+Cc(m,ic,2,k))        &
                             & +ti12*(Cc(m,i,5,k)+Cc(m,ic,4,k))))       &
                             & - Wa1(i-1)                               &
                             & *((Cc(m,i,1,k)+tr11*(Cc(m,i,3,k)         &
                             & -Cc(m,ic,2,k))                           &
                             & +tr12*(Cc(m,i,5,k)-Cc(m,ic,4,k)))        &
                             & +(ti11*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))    &
                             & +ti12*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))
               Ch(m,i,k,2) = Wa1(i-2)                                   &
                           & *((Cc(m,i,1,k)+tr11*(Cc(m,i,3,k)-Cc(m,ic,2,&
                           & k))+tr12*(Cc(m,i,5,k)-Cc(m,ic,4,k)))       &
                           & +(ti11*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))      &
                           & +ti12*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))     &
                           & + Wa1(i-1)                                 &
                           & *((Cc(m,i-1,1,k)+tr11*(Cc(m,i-1,3,k)       &
                           & +Cc(m,ic-1,2,k))                           &
                           & +tr12*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))      &
                           & -(ti11*(Cc(m,i,3,k)+Cc(m,ic,2,k))          &
                           & +ti12*(Cc(m,i,5,k)+Cc(m,ic,4,k))))
               Ch(m,i-1,k,3) = Wa2(i-2)                                 &
                             & *((Cc(m,i-1,1,k)+tr12*(Cc(m,i-1,3,k)     &
                             & +Cc(m,ic-1,2,k))                         &
                             & +tr11*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))    &
                             & -(ti12*(Cc(m,i,3,k)+Cc(m,ic,2,k))        &
                             & -ti11*(Cc(m,i,5,k)+Cc(m,ic,4,k))))       &
                             & - Wa2(i-1)                               &
                             & *((Cc(m,i,1,k)+tr12*(Cc(m,i,3,k)         &
                             & -Cc(m,ic,2,k))                           &
                             & +tr11*(Cc(m,i,5,k)-Cc(m,ic,4,k)))        &
                             & +(ti12*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))    &
                             & -ti11*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))
               Ch(m,i,k,3) = Wa2(i-2)                                   &
                           & *((Cc(m,i,1,k)+tr12*(Cc(m,i,3,k)-Cc(m,ic,2,&
                           & k))+tr11*(Cc(m,i,5,k)-Cc(m,ic,4,k)))       &
                           & +(ti12*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))      &
                           & -ti11*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))     &
                           & + Wa2(i-1)                                 &
                           & *((Cc(m,i-1,1,k)+tr12*(Cc(m,i-1,3,k)       &
                           & +Cc(m,ic-1,2,k))                           &
                           & +tr11*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))      &
                           & -(ti12*(Cc(m,i,3,k)+Cc(m,ic,2,k))          &
                           & -ti11*(Cc(m,i,5,k)+Cc(m,ic,4,k))))
               Ch(m,i-1,k,4) = Wa3(i-2)                                 &
                             & *((Cc(m,i-1,1,k)+tr12*(Cc(m,i-1,3,k)     &
                             & +Cc(m,ic-1,2,k))                         &
                             & +tr11*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))    &
                             & +(ti12*(Cc(m,i,3,k)+Cc(m,ic,2,k))        &
                             & -ti11*(Cc(m,i,5,k)+Cc(m,ic,4,k))))       &
                             & - Wa3(i-1)                               &
                             & *((Cc(m,i,1,k)+tr12*(Cc(m,i,3,k)         &
                             & -Cc(m,ic,2,k))                           &
                             & +tr11*(Cc(m,i,5,k)-Cc(m,ic,4,k)))        &
                             & -(ti12*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))    &
                             & -ti11*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))
               Ch(m,i,k,4) = Wa3(i-2)                                   &
                           & *((Cc(m,i,1,k)+tr12*(Cc(m,i,3,k)-Cc(m,ic,2,&
                           & k))+tr11*(Cc(m,i,5,k)-Cc(m,ic,4,k)))       &
                           & -(ti12*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))      &
                           & -ti11*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))     &
                           & + Wa3(i-1)                                 &
                           & *((Cc(m,i-1,1,k)+tr12*(Cc(m,i-1,3,k)       &
                           & +Cc(m,ic-1,2,k))                           &
                           & +tr11*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))      &
                           & +(ti12*(Cc(m,i,3,k)+Cc(m,ic,2,k))          &
                           & -ti11*(Cc(m,i,5,k)+Cc(m,ic,4,k))))
               Ch(m,i-1,k,5) = Wa4(i-2)                                 &
                             & *((Cc(m,i-1,1,k)+tr11*(Cc(m,i-1,3,k)     &
                             & +Cc(m,ic-1,2,k))                         &
                             & +tr12*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))    &
                             & +(ti11*(Cc(m,i,3,k)+Cc(m,ic,2,k))        &
                             & +ti12*(Cc(m,i,5,k)+Cc(m,ic,4,k))))       &
                             & - Wa4(i-1)                               &
                             & *((Cc(m,i,1,k)+tr11*(Cc(m,i,3,k)         &
                             & -Cc(m,ic,2,k))                           &
                             & +tr12*(Cc(m,i,5,k)-Cc(m,ic,4,k)))        &
                             & -(ti11*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))    &
                             & +ti12*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))
               Ch(m,i,k,5) = Wa4(i-2)                                   &
                           & *((Cc(m,i,1,k)+tr11*(Cc(m,i,3,k)-Cc(m,ic,2,&
                           & k))+tr12*(Cc(m,i,5,k)-Cc(m,ic,4,k)))       &
                           & -(ti11*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))      &
                           & +ti12*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))     &
                           & + Wa4(i-1)                                 &
                           & *((Cc(m,i-1,1,k)+tr11*(Cc(m,i-1,3,k)       &
                           & +Cc(m,ic-1,2,k))                           &
                           & +tr12*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))      &
                           & +(ti11*(Cc(m,i,3,k)+Cc(m,ic,2,k))          &
                           & +ti12*(Cc(m,i,5,k)+Cc(m,ic,4,k))))
            ENDDO
         ENDDO
      ENDDO
      END SUBROUTINE HRADB5

      SUBROUTINE DHRFFTI(N,Wsave)
      IMPLICIT NONE

      INTEGER N
      DOUBLE PRECISION TFFt 
      DOUBLE PRECISION, DIMENSION(N+15) :: Wsave

      COMMON /DHRF   / TFFt
      TFFt = 0.
      IF ( N==1 ) RETURN
      CALL DHRFTI1(N,Wsave(1),Wsave(N+1))
      END SUBROUTINE DHRFFTI

      SUBROUTINE DHRFTI1(N,Wa,Fac)
      IMPLICIT NONE

      DOUBLE PRECISION fi
      DOUBLE PRECISION, DIMENSION(15) :: Fac
      DOUBLE PRECISION, DIMENSION(N) :: Wa
      INTEGER i , ib , ido , ii , ip , ipm , is , j , k1 , l1 , l2 ,    &
            & ld , N , nf , nfm1 , nl , nq , nr , ntry , ntryh
!
!     a multiple fft package for spherepack
!
      DIMENSION ntryh(4)
      DOUBLE PRECISION tpi , argh , argld , arg
      DATA ntryh(1) , ntryh(2) , ntryh(3) , ntryh(4)/4 , 2 , 3 , 5/
      nl = N
      nf = 0
      j = 0
 100  j = j + 1
      IF ( j<=4 ) THEN
         ntry = ntryh(j)
      ELSE
         ntry = ntry + 2
      ENDIF
 200  nq = nl/ntry
      nr = nl - ntry*nq
      IF ( nr/=0 ) GOTO 100
      nf = nf + 1
      Fac(nf+2) = ntry
      nl = nq
      IF ( ntry==2 ) THEN
         IF ( nf/=1 ) THEN
            DO i = 2 , nf
               ib = nf - i + 2
               Fac(ib+2) = Fac(ib+1)
            ENDDO
            Fac(3) = 2
         ENDIF
      ENDIF
      IF ( nl/=1 ) GOTO 200
      Fac(1) = N
      Fac(2) = nf
      tpi = 8.D0*DATAN(1.D0)
      argh = tpi/FLOAT(N)
      is = 0
      nfm1 = nf - 1
      l1 = 1
      IF ( nfm1==0 ) RETURN
      DO k1 = 1 , nfm1
         ip = Fac(k1+2)
         ld = 0
         l2 = l1*ip
         ido = N/l2
         ipm = ip - 1
         DO j = 1 , ipm
            ld = ld + l1
            i = is
            argld = FLOAT(ld)*argh
            fi = 0.
            DO ii = 3 , ido , 2
               i = i + 2
               fi = fi + 1.
               arg = fi*argld
               Wa(i-1) = DCOS(arg)
               Wa(i) = DSIN(arg)
            ENDDO
            is = is + ido
         ENDDO
         l1 = l2
      ENDDO
      END SUBROUTINE DHRFTI1

      SUBROUTINE DHRFFTF(M,N,R,Mdimr,Whrfft,Work)
      IMPLICIT NONE

      INTEGER M , Mdimr , N
      DOUBLE PRECISION R , TFFt , Whrfft , Work
!
!     a multiple fft package for spherepack
!
      DIMENSION R(Mdimr,N) , Work(1) , Whrfft(N+15)
      COMMON /DHRF   / TFFt
      IF ( N==1 ) RETURN
!     tstart = second(dum)
      CALL DHRFTF1(M,N,R,Mdimr,Work,Whrfft,Whrfft(N+1))
!     tfft = tfft+second(dum)-tstart
      END SUBROUTINE DHRFFTF

      SUBROUTINE DHRFTF1(M,N,C,Mdimc,Ch,Wa,Fac)
      IMPLICIT NONE

      DOUBLE PRECISION C , Ch , Fac , Wa
      INTEGER i , idl1 , ido , ip , iw , ix2 , ix3 , ix4 , j , k1 , kh ,&
            & l1 , l2 , M , Mdimc , N , na , nf
!
!     a multiple fft package for spherepack
!
      DIMENSION Ch(M,N) , C(Mdimc,N) , Wa(N) , Fac(15)
      nf = Fac(2)
      na = 1
      l2 = N
      iw = N
      DO k1 = 1 , nf
         kh = nf - k1
         ip = Fac(kh+3)
         l1 = l2/ip
         ido = N/l2
         idl1 = ido*l1
         iw = iw - (ip-1)*ido
         na = 1 - na
         IF ( ip==4 ) THEN
            ix2 = iw + ido
            ix3 = ix2 + ido
            IF ( na/=0 ) THEN
               CALL DHRADF4(M,ido,l1,Ch,M,C,Mdimc,Wa(iw),Wa(ix2),Wa(ix3))
            ELSE
               CALL DHRADF4(M,ido,l1,C,Mdimc,Ch,M,Wa(iw),Wa(ix2),Wa(ix3))
            ENDIF
         ELSEIF ( ip/=2 ) THEN
            IF ( ip==3 ) THEN
               ix2 = iw + ido
               IF ( na/=0 ) THEN
                  CALL DHRADF3(M,ido,l1,Ch,M,C,Mdimc,Wa(iw),Wa(ix2))
               ELSE
                  CALL DHRADF3(M,ido,l1,C,Mdimc,Ch,M,Wa(iw),Wa(ix2))
               ENDIF
            ELSEIF ( ip/=5 ) THEN
               IF ( ido==1 ) na = 1 - na
               IF ( na/=0 ) THEN
                  CALL DHRADFG(M,ido,ip,l1,idl1,Ch,Ch,Ch,M,C,C,Mdimc,    &
                            & Wa(iw))
                  na = 0
               ELSE
                  CALL DHRADFG(M,ido,ip,l1,idl1,C,C,C,Mdimc,Ch,Ch,M,     &
                            & Wa(iw))
                  na = 1
               ENDIF
            ELSE
               ix2 = iw + ido
               ix3 = ix2 + ido
               ix4 = ix3 + ido
               IF ( na/=0 ) THEN
                  CALL DHRADF5(M,ido,l1,Ch,M,C,Mdimc,Wa(iw),Wa(ix2),     &
                            & Wa(ix3),Wa(ix4))
               ELSE
                  CALL DHRADF5(M,ido,l1,C,Mdimc,Ch,M,Wa(iw),Wa(ix2),     &
                            & Wa(ix3),Wa(ix4))
               ENDIF
            ENDIF
         ELSEIF ( na/=0 ) THEN
            CALL DHRADF2(M,ido,l1,Ch,M,C,Mdimc,Wa(iw))
         ELSE
            CALL DHRADF2(M,ido,l1,C,Mdimc,Ch,M,Wa(iw))
         ENDIF
         l2 = l1
      ENDDO
      IF ( na==1 ) RETURN
      DO j = 1 , N
         DO i = 1 , M
            C(i,j) = Ch(i,j)
         ENDDO
      ENDDO
      END SUBROUTINE DHRFTF1

      SUBROUTINE DHRADF4(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1,Wa2,Wa3)
      IMPLICIT NONE

      DOUBLE PRECISION Cc , Ch , hsqt2 , Wa1 , Wa2 , Wa3
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp
!
!     a multiple fft package for spherepack
!
      DIMENSION Cc(Mdimcc,Ido,L1,4) , Ch(Mdimch,Ido,4,L1) , Wa1(Ido) ,  &
              & Wa2(Ido) , Wa3(Ido)
      hsqt2 = SQRT(2.)/2.
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,1,k) = (Cc(m,1,k,2)+Cc(m,1,k,4))                     &
                        & + (Cc(m,1,k,1)+Cc(m,1,k,3))
            Ch(m,Ido,4,k) = (Cc(m,1,k,1)+Cc(m,1,k,3))                   &
                          & - (Cc(m,1,k,2)+Cc(m,1,k,4))
            Ch(m,Ido,2,k) = Cc(m,1,k,1) - Cc(m,1,k,3)
            Ch(m,1,3,k) = Cc(m,1,k,4) - Cc(m,1,k,2)
         ENDDO
      ENDDO
      IF ( Ido<2 ) GOTO 99999
      IF ( Ido/=2 ) THEN
         idp2 = Ido + 2
         DO k = 1 , L1
            DO i = 3 , Ido , 2
               ic = idp2 - i
               DO m = 1 , Mp
                  Ch(m,i-1,1,k) = ((Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)*Cc(m&
                                & ,i,k,2))                              &
                                & +(Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)     &
                                & *Cc(m,i,k,4)))                        &
                                & + (Cc(m,i-1,k,1)+(Wa2(i-2)            &
                                & *Cc(m,i-1,k,3)+Wa2(i-1)*Cc(m,i,k,3)))
                  Ch(m,ic-1,4,k) = (Cc(m,i-1,k,1)+(Wa2(i-2)*Cc(m,i-1,k,3&
                                 & )+Wa2(i-1)*Cc(m,i,k,3)))             &
                                 & - ((Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)  &
                                 & *Cc(m,i,k,2))                        &
                                 & +(Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)    &
                                 & *Cc(m,i,k,4)))
                  Ch(m,i,1,k) = ((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)*Cc(m,i-1&
                              & ,k,2))                                  &
                              & +(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)*Cc(m,   &
                              & i-1,k,4)))                              &
                              & + (Cc(m,i,k,1)+(Wa2(i-2)*Cc(m,i,k,3)    &
                              & -Wa2(i-1)*Cc(m,i-1,k,3)))
                  Ch(m,ic,4,k) = ((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)*Cc(m,i-&
                               & 1,k,2))                                &
                               & +(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)*Cc(m,  &
                               & i-1,k,4)))                             &
                               & - (Cc(m,i,k,1)+(Wa2(i-2)*Cc(m,i,k,3)   &
                               & -Wa2(i-1)*Cc(m,i-1,k,3)))
                  Ch(m,i-1,3,k) = ((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)*Cc(m,i&
                                & -1,k,2))                              &
                                & -(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)       &
                                & *Cc(m,i-1,k,4)))                      &
                                & + (Cc(m,i-1,k,1)-(Wa2(i-2)            &
                                & *Cc(m,i-1,k,3)+Wa2(i-1)*Cc(m,i,k,3)))
                  Ch(m,ic-1,2,k) = (Cc(m,i-1,k,1)-(Wa2(i-2)*Cc(m,i-1,k,3&
                                 & )+Wa2(i-1)*Cc(m,i,k,3)))             &
                                 & - ((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)    &
                                 & *Cc(m,i-1,k,2))                      &
                                 & -(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)      &
                                 & *Cc(m,i-1,k,4)))
                  Ch(m,i,3,k) = ((Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)*Cc(m,i&
                              & ,k,4))                                  &
                              & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)*Cc(m, &
                              & i,k,2)))                                &
                              & + (Cc(m,i,k,1)-(Wa2(i-2)*Cc(m,i,k,3)    &
                              & -Wa2(i-1)*Cc(m,i-1,k,3)))
                  Ch(m,ic,2,k) = ((Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)*Cc(m,&
                               & i,k,4))                                &
                               & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)      &
                               & *Cc(m,i,k,2)))                         &
                               & - (Cc(m,i,k,1)-(Wa2(i-2)*Cc(m,i,k,3)   &
                               & -Wa2(i-1)*Cc(m,i-1,k,3)))
               ENDDO
            ENDDO
         ENDDO
         IF ( MOD(Ido,2)==1 ) RETURN
      ENDIF
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,Ido,1,k) = (hsqt2*(Cc(m,Ido,k,2)-Cc(m,Ido,k,4)))       &
                          & + Cc(m,Ido,k,1)
            Ch(m,Ido,3,k) = Cc(m,Ido,k,1)                               &
                          & - (hsqt2*(Cc(m,Ido,k,2)-Cc(m,Ido,k,4)))
            Ch(m,1,2,k) = (-hsqt2*(Cc(m,Ido,k,2)+Cc(m,Ido,k,4)))        &
                        & - Cc(m,Ido,k,3)
            Ch(m,1,4,k) = (-hsqt2*(Cc(m,Ido,k,2)+Cc(m,Ido,k,4)))        &
                        & + Cc(m,Ido,k,3)
         ENDDO
      ENDDO
99999 END SUBROUTINE DHRADF4

      SUBROUTINE DHRADF2(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1)
      IMPLICIT NONE

      DOUBLE PRECISION Cc , Ch , Wa1
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp
!
!     a multiple fft package for spherepack
!
      DIMENSION Ch(Mdimch,Ido,2,L1) , Cc(Mdimcc,Ido,L1,2) , Wa1(Ido)
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,1,k) = Cc(m,1,k,1) + Cc(m,1,k,2)
            Ch(m,Ido,2,k) = Cc(m,1,k,1) - Cc(m,1,k,2)
         ENDDO
      ENDDO
      IF ( Ido<2 ) GOTO 99999
      IF ( Ido/=2 ) THEN
         idp2 = Ido + 2
         DO k = 1 , L1
            DO i = 3 , Ido , 2
               ic = idp2 - i
               DO m = 1 , Mp
                  Ch(m,i,1,k) = Cc(m,i,k,1)                             &
                              & + (Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)        &
                              & *Cc(m,i-1,k,2))
                  Ch(m,ic,2,k) = (Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)*Cc(m,i-1&
                               & ,k,2)) - Cc(m,i,k,1)
                  Ch(m,i-1,1,k) = Cc(m,i-1,k,1)                         &
                                & + (Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)    &
                                & *Cc(m,i,k,2))
                  Ch(m,ic-1,2,k) = Cc(m,i-1,k,1)                        &
                                 & - (Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)   &
                                 & *Cc(m,i,k,2))
               ENDDO
            ENDDO
         ENDDO
         IF ( MOD(Ido,2)==1 ) RETURN
      ENDIF
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,2,k) = -Cc(m,Ido,k,2)
            Ch(m,Ido,1,k) = Cc(m,Ido,k,1)
         ENDDO
      ENDDO
99999 END SUBROUTINE DHRADF2

      SUBROUTINE DHRADF3(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1,Wa2)
      IMPLICIT NONE

      DOUBLE PRECISION arg , Cc , Ch , DPIMACH , taui , taur , Wa1 , Wa2
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp
!
!     a multiple fft package for spherepack
!
      DIMENSION Ch(Mdimch,Ido,3,L1) , Cc(Mdimcc,Ido,L1,3) , Wa1(Ido) ,  &
              & Wa2(Ido)
      arg = 2.*DPIMACH()/3.
      taur = COS(arg)
      taui = SIN(arg)
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,1,k) = Cc(m,1,k,1) + (Cc(m,1,k,2)+Cc(m,1,k,3))
            Ch(m,1,3,k) = taui*(Cc(m,1,k,3)-Cc(m,1,k,2))
            Ch(m,Ido,2,k) = Cc(m,1,k,1) + taur*(Cc(m,1,k,2)+Cc(m,1,k,3))
         ENDDO
      ENDDO
      IF ( Ido==1 ) RETURN
      idp2 = Ido + 2
      DO k = 1 , L1
         DO i = 3 , Ido , 2
            ic = idp2 - i
            DO m = 1 , Mp
               Ch(m,i-1,1,k) = Cc(m,i-1,k,1)                            &
                             & + ((Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)      &
                             & *Cc(m,i,k,2))                            &
                             & +(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)        &
                             & *Cc(m,i,k,3)))
               Ch(m,i,1,k) = Cc(m,i,k,1)                                &
                           & + ((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)          &
                           & *Cc(m,i-1,k,2))                            &
                           & +(Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)            &
                           & *Cc(m,i-1,k,3)))
               Ch(m,i-1,3,k) = (Cc(m,i-1,k,1)+taur*((Wa1(i-2)*Cc(m,i-1,k&
                             & ,2)+Wa1(i-1)*Cc(m,i,k,2))                &
                             & +(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)        &
                             & *Cc(m,i,k,3))))                          &
                             & + (taui*((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)  &
                             & *Cc(m,i-1,k,2))                          &
                             & -(Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)          &
                             & *Cc(m,i-1,k,3))))
               Ch(m,ic-1,2,k) = (Cc(m,i-1,k,1)+taur*((Wa1(i-2)*Cc(m,i-1,&
                              & k,2)+Wa1(i-1)*Cc(m,i,k,2))              &
                              & +(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)       &
                              & *Cc(m,i,k,3))))                         &
                              & - (taui*((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1) &
                              & *Cc(m,i-1,k,2))                         &
                              & -(Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)         &
                              & *Cc(m,i-1,k,3))))
               Ch(m,i,3,k) = (Cc(m,i,k,1)+taur*((Wa1(i-2)*Cc(m,i,k,2)-  &
                           & Wa1(i-1)*Cc(m,i-1,k,2))                    &
                           & +(Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)            &
                           & *Cc(m,i-1,k,3))))                          &
                           & + (taui*((Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)  &
                           & *Cc(m,i,k,3))                              &
                           & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)          &
                           & *Cc(m,i,k,2))))
               Ch(m,ic,2,k) = (taui*((Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)*Cc&
                            & (m,i,k,3))                                &
                            & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)         &
                            & *Cc(m,i,k,2))))                           &
                            & - (Cc(m,i,k,1)+taur*((Wa1(i-2)*Cc(m,i,k,2)&
                            & -Wa1(i-1)*Cc(m,i-1,k,2))                  &
                            & +(Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)           &
                            & *Cc(m,i-1,k,3))))
            ENDDO
         ENDDO
      ENDDO
      END SUBROUTINE DHRADF3

      SUBROUTINE DHRADF5(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1,Wa2,Wa3,Wa4)
      IMPLICIT NONE
      DOUBLE PRECISION arg , Cc , Ch , DPIMACH , ti11 , ti12 , tr11 , tr12 , Wa1 ,   &
         & Wa2 , Wa3 , Wa4
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp
!
!     a multiple fft package for spherepack
!
      DIMENSION Cc(Mdimcc,Ido,L1,5) , Ch(Mdimch,Ido,5,L1) , Wa1(Ido) ,  &
              & Wa2(Ido) , Wa3(Ido) , Wa4(Ido)
      arg = 2.*DPIMACH()/5.
      tr11 = COS(arg)
      ti11 = SIN(arg)
      tr12 = COS(2.*arg)
      ti12 = SIN(2.*arg)
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,1,k) = Cc(m,1,k,1) + (Cc(m,1,k,5)+Cc(m,1,k,2))       &
                        & + (Cc(m,1,k,4)+Cc(m,1,k,3))
            Ch(m,Ido,2,k) = Cc(m,1,k,1) + tr11*(Cc(m,1,k,5)+Cc(m,1,k,2))&
                          & + tr12*(Cc(m,1,k,4)+Cc(m,1,k,3))
            Ch(m,1,3,k) = ti11*(Cc(m,1,k,5)-Cc(m,1,k,2))                &
                        & + ti12*(Cc(m,1,k,4)-Cc(m,1,k,3))
            Ch(m,Ido,4,k) = Cc(m,1,k,1) + tr12*(Cc(m,1,k,5)+Cc(m,1,k,2))&
                          & + tr11*(Cc(m,1,k,4)+Cc(m,1,k,3))
            Ch(m,1,5,k) = ti12*(Cc(m,1,k,5)-Cc(m,1,k,2))                &
                        & - ti11*(Cc(m,1,k,4)-Cc(m,1,k,3))
         ENDDO
      ENDDO
      IF ( Ido==1 ) RETURN
      idp2 = Ido + 2
      DO k = 1 , L1
         DO i = 3 , Ido , 2
            ic = idp2 - i
            DO m = 1 , Mp
               Ch(m,i-1,1,k) = Cc(m,i-1,k,1)                            &
                             & + ((Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)      &
                             & *Cc(m,i,k,2))                            &
                             & +(Wa4(i-2)*Cc(m,i-1,k,5)+Wa4(i-1)        &
                             & *Cc(m,i,k,5)))                           &
                             & + ((Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)      &
                             & *Cc(m,i,k,3))                            &
                             & +(Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)        &
                             & *Cc(m,i,k,4)))
               Ch(m,i,1,k) = Cc(m,i,k,1)                                &
                           & + ((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)          &
                           & *Cc(m,i-1,k,2))                            &
                           & +(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)            &
                           & *Cc(m,i-1,k,5)))                           &
                           & + ((Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)          &
                           & *Cc(m,i-1,k,3))                            &
                           & +(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)            &
                           & *Cc(m,i-1,k,4)))
               Ch(m,i-1,3,k) = Cc(m,i-1,k,1)                            &
                             & + tr11*(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)  &
                             & *Cc(m,i,k,2)+Wa4(i-2)*Cc(m,i-1,k,5)      &
                             & +Wa4(i-1)*Cc(m,i,k,5))                   &
                             & + tr12*(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)  &
                             & *Cc(m,i,k,3)+Wa3(i-2)*Cc(m,i-1,k,4)      &
                             & +Wa3(i-1)*Cc(m,i,k,4))                   &
                             & + ti11*(Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)    &
                             & *Cc(m,i-1,k,2)                           &
                             & -(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)          &
                             & *Cc(m,i-1,k,5)))                         &
                             & + ti12*(Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)    &
                             & *Cc(m,i-1,k,3)                           &
                             & -(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)          &
                             & *Cc(m,i-1,k,4)))
               Ch(m,ic-1,2,k) = Cc(m,i-1,k,1)                           &
                              & + tr11*(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1) &
                              & *Cc(m,i,k,2)+Wa4(i-2)*Cc(m,i-1,k,5)     &
                              & +Wa4(i-1)*Cc(m,i,k,5))                  &
                              & + tr12*(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1) &
                              & *Cc(m,i,k,3)+Wa3(i-2)*Cc(m,i-1,k,4)     &
                              & +Wa3(i-1)*Cc(m,i,k,4))                  &
                              & - (ti11*(Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)  &
                              & *Cc(m,i-1,k,2)                          &
                              & -(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)         &
                              & *Cc(m,i-1,k,5)))                        &
                              & +ti12*(Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)    &
                              & *Cc(m,i-1,k,3)                          &
                              & -(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)         &
                              & *Cc(m,i-1,k,4))))
               Ch(m,i,3,k) = (Cc(m,i,k,1)+tr11*((Wa1(i-2)*Cc(m,i,k,2)-  &
                           & Wa1(i-1)*Cc(m,i-1,k,2))                    &
                           & +(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)            &
                           & *Cc(m,i-1,k,5)))                           &
                           & +tr12*((Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)      &
                           & *Cc(m,i-1,k,3))                            &
                           & +(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)            &
                           & *Cc(m,i-1,k,4))))                          &
                           & + (ti11*((Wa4(i-2)*Cc(m,i-1,k,5)+Wa4(i-1)  &
                           & *Cc(m,i,k,5))                              &
                           & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)          &
                           & *Cc(m,i,k,2)))                             &
                           & +ti12*((Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)    &
                           & *Cc(m,i,k,4))                              &
                           & -(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)          &
                           & *Cc(m,i,k,3))))
               Ch(m,ic,2,k) = (ti11*((Wa4(i-2)*Cc(m,i-1,k,5)+Wa4(i-1)*Cc&
                            & (m,i,k,5))                                &
                            & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)         &
                            & *Cc(m,i,k,2)))                            &
                            & +ti12*((Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)   &
                            & *Cc(m,i,k,4))                             &
                            & -(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)         &
                            & *Cc(m,i,k,3))))                           &
                            & - (Cc(m,i,k,1)+tr11*((Wa1(i-2)*Cc(m,i,k,2)&
                            & -Wa1(i-1)*Cc(m,i-1,k,2))                  &
                            & +(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)           &
                            & *Cc(m,i-1,k,5)))                          &
                            & +tr12*((Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)     &
                            & *Cc(m,i-1,k,3))                           &
                            & +(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)           &
                            & *Cc(m,i-1,k,4))))
               Ch(m,i-1,5,k) = (Cc(m,i-1,k,1)+tr12*((Wa1(i-2)*Cc(m,i-1,k&
                             & ,2)+Wa1(i-1)*Cc(m,i,k,2))                &
                             & +(Wa4(i-2)*Cc(m,i-1,k,5)+Wa4(i-1)        &
                             & *Cc(m,i,k,5)))                           &
                             & +tr11*((Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)  &
                             & *Cc(m,i,k,3))                            &
                             & +(Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)        &
                             & *Cc(m,i,k,4))))                          &
                             & + (ti12*((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1)  &
                             & *Cc(m,i-1,k,2))                          &
                             & -(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)          &
                             & *Cc(m,i-1,k,5)))                         &
                             & -ti11*((Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)    &
                             & *Cc(m,i-1,k,3))                          &
                             & -(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)          &
                             & *Cc(m,i-1,k,4))))
               Ch(m,ic-1,4,k) = (Cc(m,i-1,k,1)+tr12*((Wa1(i-2)*Cc(m,i-1,&
                              & k,2)+Wa1(i-1)*Cc(m,i,k,2))              &
                              & +(Wa4(i-2)*Cc(m,i-1,k,5)+Wa4(i-1)       &
                              & *Cc(m,i,k,5)))                          &
                              & +tr11*((Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1) &
                              & *Cc(m,i,k,3))                           &
                              & +(Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)       &
                              & *Cc(m,i,k,4))))                         &
                              & - (ti12*((Wa1(i-2)*Cc(m,i,k,2)-Wa1(i-1) &
                              & *Cc(m,i-1,k,2))                         &
                              & -(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)         &
                              & *Cc(m,i-1,k,5)))                        &
                              & -ti11*((Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)   &
                              & *Cc(m,i-1,k,3))                         &
                              & -(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)         &
                              & *Cc(m,i-1,k,4))))
               Ch(m,i,5,k) = (Cc(m,i,k,1)+tr12*((Wa1(i-2)*Cc(m,i,k,2)-  &
                           & Wa1(i-1)*Cc(m,i-1,k,2))                    &
                           & +(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)            &
                           & *Cc(m,i-1,k,5)))                           &
                           & +tr11*((Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)      &
                           & *Cc(m,i-1,k,3))                            &
                           & +(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)            &
                           & *Cc(m,i-1,k,4))))                          &
                           & + (ti12*((Wa4(i-2)*Cc(m,i-1,k,5)+Wa4(i-1)  &
                           & *Cc(m,i,k,5))                              &
                           & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)          &
                           & *Cc(m,i,k,2)))                             &
                           & -ti11*((Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)    &
                           & *Cc(m,i,k,4))                              &
                           & -(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)          &
                           & *Cc(m,i,k,3))))
               Ch(m,ic,4,k) = (ti12*((Wa4(i-2)*Cc(m,i-1,k,5)+Wa4(i-1)*Cc&
                            & (m,i,k,5))                                &
                            & -(Wa1(i-2)*Cc(m,i-1,k,2)+Wa1(i-1)         &
                            & *Cc(m,i,k,2)))                            &
                            & -ti11*((Wa3(i-2)*Cc(m,i-1,k,4)+Wa3(i-1)   &
                            & *Cc(m,i,k,4))                             &
                            & -(Wa2(i-2)*Cc(m,i-1,k,3)+Wa2(i-1)         &
                            & *Cc(m,i,k,3))))                           &
                            & - (Cc(m,i,k,1)+tr12*((Wa1(i-2)*Cc(m,i,k,2)&
                            & -Wa1(i-1)*Cc(m,i-1,k,2))                  &
                            & +(Wa4(i-2)*Cc(m,i,k,5)-Wa4(i-1)           &
                            & *Cc(m,i-1,k,5)))                          &
                            & +tr11*((Wa2(i-2)*Cc(m,i,k,3)-Wa2(i-1)     &
                            & *Cc(m,i-1,k,3))                           &
                            & +(Wa3(i-2)*Cc(m,i,k,4)-Wa3(i-1)           &
                            & *Cc(m,i-1,k,4))))
            ENDDO
         ENDDO
      ENDDO
      END SUBROUTINE DHRADF5

      SUBROUTINE DHRADFG(Mp,Ido,Ip,L1,Idl1,Cc,C1,C2,Mdimcc,Ch,Ch2,Mdimch,&
                      & Wa)
      IMPLICIT NONE
      DOUBLE PRECISION ai1 , ai2 , ar1 , ar1h , ar2 , ar2h , arg , C1 , C2 , Cc ,   &
         & Ch , Ch2 , dc2 , dcp , ds2 , dsp , DPIMACH , tpi , Wa
      INTEGER i , ic , idij , Idl1 , Ido , idp2 , ik , Ip , ipp2 ,      &
            & ipph , is , j , j2 , jc , k , l , L1 , lc , m , Mdimcc
      INTEGER Mdimch , Mp , nbd
!
!     a multiple fft package for spherepack
!
      DIMENSION Ch(Mdimch,Ido,L1,Ip) , Cc(Mdimcc,Ido,Ip,L1) ,           &
              & C1(Mdimcc,Ido,L1,Ip) , C2(Mdimcc,Idl1,Ip) ,             &
              & Ch2(Mdimch,Idl1,Ip) , Wa(Ido)
      tpi = 2.*DPIMACH()
      arg = tpi/FLOAT(Ip)
      dcp = COS(arg)
      dsp = SIN(arg)
      ipph = (Ip+1)/2
      ipp2 = Ip + 2
      idp2 = Ido + 2
      nbd = (Ido-1)/2
      IF ( Ido==1 ) THEN
         DO ik = 1 , Idl1
            DO m = 1 , Mp
               C2(m,ik,1) = Ch2(m,ik,1)
            ENDDO
         ENDDO
      ELSE
         DO ik = 1 , Idl1
            DO m = 1 , Mp
               Ch2(m,ik,1) = C2(m,ik,1)
            ENDDO
         ENDDO
         DO j = 2 , Ip
            DO k = 1 , L1
               DO m = 1 , Mp
                  Ch(m,1,k,j) = C1(m,1,k,j)
               ENDDO
            ENDDO
         ENDDO
         IF ( nbd>L1 ) THEN
            is = -Ido
            DO j = 2 , Ip
               is = is + Ido
               DO k = 1 , L1
                  idij = is
                  DO i = 3 , Ido , 2
                     idij = idij + 2
                     DO m = 1 , Mp
                        Ch(m,i-1,k,j) = Wa(idij-1)*C1(m,i-1,k,j)        &
                                      & + Wa(idij)*C1(m,i,k,j)
                        Ch(m,i,k,j) = Wa(idij-1)*C1(m,i,k,j) - Wa(idij) &
                                    & *C1(m,i-1,k,j)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ELSE
            is = -Ido
            DO j = 2 , Ip
               is = is + Ido
               idij = is
               DO i = 3 , Ido , 2
                  idij = idij + 2
                  DO k = 1 , L1
                     DO m = 1 , Mp
                        Ch(m,i-1,k,j) = Wa(idij-1)*C1(m,i-1,k,j)        &
                                      & + Wa(idij)*C1(m,i,k,j)
                        Ch(m,i,k,j) = Wa(idij-1)*C1(m,i,k,j) - Wa(idij) &
                                    & *C1(m,i-1,k,j)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
         IF ( nbd<L1 ) THEN
            DO j = 2 , ipph
               jc = ipp2 - j
               DO i = 3 , Ido , 2
                  DO k = 1 , L1
                     DO m = 1 , Mp
                        C1(m,i-1,k,j) = Ch(m,i-1,k,j) + Ch(m,i-1,k,jc)
                        C1(m,i-1,k,jc) = Ch(m,i,k,j) - Ch(m,i,k,jc)
                        C1(m,i,k,j) = Ch(m,i,k,j) + Ch(m,i,k,jc)
                        C1(m,i,k,jc) = Ch(m,i-1,k,jc) - Ch(m,i-1,k,j)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ELSE
            DO j = 2 , ipph
               jc = ipp2 - j
               DO k = 1 , L1
                  DO i = 3 , Ido , 2
                     DO m = 1 , Mp
                        C1(m,i-1,k,j) = Ch(m,i-1,k,j) + Ch(m,i-1,k,jc)
                        C1(m,i-1,k,jc) = Ch(m,i,k,j) - Ch(m,i,k,jc)
                        C1(m,i,k,j) = Ch(m,i,k,j) + Ch(m,i,k,jc)
                        C1(m,i,k,jc) = Ch(m,i-1,k,jc) - Ch(m,i-1,k,j)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      DO j = 2 , ipph
         jc = ipp2 - j
         DO k = 1 , L1
            DO m = 1 , Mp
               C1(m,1,k,j) = Ch(m,1,k,j) + Ch(m,1,k,jc)
               C1(m,1,k,jc) = Ch(m,1,k,jc) - Ch(m,1,k,j)
            ENDDO
         ENDDO
      ENDDO
!
      ar1 = 1.
      ai1 = 0.
      DO l = 2 , ipph
         lc = ipp2 - l
         ar1h = dcp*ar1 - dsp*ai1
         ai1 = dcp*ai1 + dsp*ar1
         ar1 = ar1h
         DO ik = 1 , Idl1
            DO m = 1 , Mp
               Ch2(m,ik,l) = C2(m,ik,1) + ar1*C2(m,ik,2)
               Ch2(m,ik,lc) = ai1*C2(m,ik,Ip)
            ENDDO
         ENDDO
         dc2 = ar1
         ds2 = ai1
         ar2 = ar1
         ai2 = ai1
         DO j = 3 , ipph
            jc = ipp2 - j
            ar2h = dc2*ar2 - ds2*ai2
            ai2 = dc2*ai2 + ds2*ar2
            ar2 = ar2h
            DO ik = 1 , Idl1
               DO m = 1 , Mp
                  Ch2(m,ik,l) = Ch2(m,ik,l) + ar2*C2(m,ik,j)
                  Ch2(m,ik,lc) = Ch2(m,ik,lc) + ai2*C2(m,ik,jc)
               ENDDO
            ENDDO
         ENDDO
      ENDDO
      DO j = 2 , ipph
         DO ik = 1 , Idl1
            DO m = 1 , Mp
               Ch2(m,ik,1) = Ch2(m,ik,1) + C2(m,ik,j)
            ENDDO
         ENDDO
      ENDDO
!
      IF ( Ido<L1 ) THEN
         DO i = 1 , Ido
            DO k = 1 , L1
               DO m = 1 , Mp
                  Cc(m,i,1,k) = Ch(m,i,k,1)
               ENDDO
            ENDDO
         ENDDO
      ELSE
         DO k = 1 , L1
            DO i = 1 , Ido
               DO m = 1 , Mp
                  Cc(m,i,1,k) = Ch(m,i,k,1)
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      DO j = 2 , ipph
         jc = ipp2 - j
         j2 = j + j
         DO k = 1 , L1
            DO m = 1 , Mp
               Cc(m,Ido,j2-2,k) = Ch(m,1,k,j)
               Cc(m,1,j2-1,k) = Ch(m,1,k,jc)
            ENDDO
         ENDDO
      ENDDO
      IF ( Ido==1 ) RETURN
      IF ( nbd<L1 ) THEN
         DO j = 2 , ipph
            jc = ipp2 - j
            j2 = j + j
            DO i = 3 , Ido , 2
               ic = idp2 - i
               DO k = 1 , L1
                  DO m = 1 , Mp
                     Cc(m,i-1,j2-1,k) = Ch(m,i-1,k,j) + Ch(m,i-1,k,jc)
                     Cc(m,ic-1,j2-2,k) = Ch(m,i-1,k,j) - Ch(m,i-1,k,jc)
                     Cc(m,i,j2-1,k) = Ch(m,i,k,j) + Ch(m,i,k,jc)
                     Cc(m,ic,j2-2,k) = Ch(m,i,k,jc) - Ch(m,i,k,j)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
         GOTO 99999
      ENDIF
      DO j = 2 , ipph
         jc = ipp2 - j
         j2 = j + j
         DO k = 1 , L1
            DO i = 3 , Ido , 2
               ic = idp2 - i
               DO m = 1 , Mp
                  Cc(m,i-1,j2-1,k) = Ch(m,i-1,k,j) + Ch(m,i-1,k,jc)
                  Cc(m,ic-1,j2-2,k) = Ch(m,i-1,k,j) - Ch(m,i-1,k,jc)
                  Cc(m,i,j2-1,k) = Ch(m,i,k,j) + Ch(m,i,k,jc)
                  Cc(m,ic,j2-2,k) = Ch(m,i,k,jc) - Ch(m,i,k,j)
               ENDDO
            ENDDO
         ENDDO
      ENDDO
      RETURN
99999 END SUBROUTINE  DHRADFG


      SUBROUTINE DHRFFTB(M,N,R,Mdimr,Whrfft,Work)
      IMPLICIT NONE
      INTEGER M , Mdimr , N
      DOUBLE PRECISION R , TFFt , Whrfft , Work
!
!     a multiple fft package for spherepack
!
      DIMENSION R(Mdimr,N) , Work(1) , Whrfft(N+15)
      COMMON /DHRF   / TFFt
      IF ( N==1 ) RETURN
!     tstart = second(dum)
      CALL DHRFTB1(M,N,R,Mdimr,Work,Whrfft,Whrfft(N+1))
!     tfft = tfft+second(dum)-tstart
      END SUBROUTINE DHRFFTB

      SUBROUTINE DHRFTB1(M,N,C,Mdimc,Ch,Wa,Fac)
      IMPLICIT NONE
      DOUBLE PRECISION C , Ch , Fac , Wa
      INTEGER i , idl1 , ido , ip , iw , ix2 , ix3 , ix4 , j , k1 , l1 ,&
            & l2 , M , Mdimc , N , na , nf
!
!     a multiple fft package for spherepack
!
      DIMENSION Ch(M,N) , C(Mdimc,N) , Wa(N) , Fac(15)
      nf = Fac(2)
      na = 0
      l1 = 1
      iw = 1
      DO k1 = 1 , nf
         ip = Fac(k1+2)
         l2 = ip*l1
         ido = N/l2
         idl1 = ido*l1
         IF ( ip==4 ) THEN
            ix2 = iw + ido
            ix3 = ix2 + ido
            IF ( na/=0 ) THEN
               CALL DHRADB4(M,ido,l1,Ch,M,C,Mdimc,Wa(iw),Wa(ix2),Wa(ix3))
            ELSE
               CALL DHRADB4(M,ido,l1,C,Mdimc,Ch,M,Wa(iw),Wa(ix2),Wa(ix3))
            ENDIF
            na = 1 - na
         ELSEIF ( ip==2 ) THEN
            IF ( na/=0 ) THEN
               CALL DHRADB2(M,ido,l1,Ch,M,C,Mdimc,Wa(iw))
            ELSE
               CALL DHRADB2(M,ido,l1,C,Mdimc,Ch,M,Wa(iw))
            ENDIF
            na = 1 - na
         ELSEIF ( ip==3 ) THEN
            ix2 = iw + ido
            IF ( na/=0 ) THEN
               CALL DHRADB3(M,ido,l1,Ch,M,C,Mdimc,Wa(iw),Wa(ix2))
            ELSE
               CALL DHRADB3(M,ido,l1,C,Mdimc,Ch,M,Wa(iw),Wa(ix2))
            ENDIF
            na = 1 - na
         ELSEIF ( ip/=5 ) THEN
            IF ( na/=0 ) THEN
               CALL DHRADBG(M,ido,ip,l1,idl1,Ch,Ch,Ch,M,C,C,Mdimc,Wa(iw))
            ELSE
               CALL DHRADBG(M,ido,ip,l1,idl1,C,C,C,Mdimc,Ch,Ch,M,Wa(iw))
            ENDIF
            IF ( ido==1 ) na = 1 - na
         ELSE
            ix2 = iw + ido
            ix3 = ix2 + ido
            ix4 = ix3 + ido
            IF ( na/=0 ) THEN
               CALL DHRADB5(M,ido,l1,Ch,M,C,Mdimc,Wa(iw),Wa(ix2),Wa(ix3),&
                         & Wa(ix4))
            ELSE
               CALL DHRADB5(M,ido,l1,C,Mdimc,Ch,M,Wa(iw),Wa(ix2),Wa(ix3),&
                         & Wa(ix4))
            ENDIF
            na = 1 - na
         ENDIF
         l1 = l2
         iw = iw + (ip-1)*ido
      ENDDO
      IF ( na==0 ) RETURN
      DO j = 1 , N
         DO i = 1 , M
            C(i,j) = Ch(i,j)
         ENDDO
      ENDDO
      END SUBROUTINE DHRFTB1

      SUBROUTINE DHRADBG(Mp,Ido,Ip,L1,Idl1,Cc,C1,C2,Mdimcc,Ch,Ch2,Mdimch,&
                      & Wa)
      IMPLICIT NONE
      DOUBLE PRECISION ai1 , ai2 , ar1 , ar1h , ar2 , ar2h , arg , C1 , C2 , Cc ,   &
         & Ch , Ch2 , dc2 , dcp , ds2 , dsp , DPIMACH , tpi , Wa
      INTEGER i , ic , idij , Idl1 , Ido , idp2 , ik , Ip , ipp2 ,      &
            & ipph , is , j , j2 , jc , k , l , L1 , lc , m , Mdimcc
      INTEGER Mdimch , Mp , nbd
!
!     a multiple fft package for spherepack
!
      DIMENSION Ch(Mdimch,Ido,L1,Ip) , Cc(Mdimcc,Ido,Ip,L1) ,           &
              & C1(Mdimcc,Ido,L1,Ip) , C2(Mdimcc,Idl1,Ip) ,             &
              & Ch2(Mdimch,Idl1,Ip) , Wa(Ido)
      tpi = 2.*DPIMACH()
      arg = tpi/FLOAT(Ip)
      dcp = COS(arg)
      dsp = SIN(arg)
      idp2 = Ido + 2
      nbd = (Ido-1)/2
      ipp2 = Ip + 2
      ipph = (Ip+1)/2
      IF ( Ido<L1 ) THEN
         DO i = 1 , Ido
            DO k = 1 , L1
               DO m = 1 , Mp
                  Ch(m,i,k,1) = Cc(m,i,1,k)
               ENDDO
            ENDDO
         ENDDO
      ELSE
         DO k = 1 , L1
            DO i = 1 , Ido
               DO m = 1 , Mp
                  Ch(m,i,k,1) = Cc(m,i,1,k)
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      DO j = 2 , ipph
         jc = ipp2 - j
         j2 = j + j
         DO k = 1 , L1
            DO m = 1 , Mp
               Ch(m,1,k,j) = Cc(m,Ido,j2-2,k) + Cc(m,Ido,j2-2,k)
               Ch(m,1,k,jc) = Cc(m,1,j2-1,k) + Cc(m,1,j2-1,k)
            ENDDO
         ENDDO
      ENDDO
      IF ( Ido/=1 ) THEN
         IF ( nbd<L1 ) THEN
            DO j = 2 , ipph
               jc = ipp2 - j
               DO i = 3 , Ido , 2
                  ic = idp2 - i
                  DO k = 1 , L1
                     DO m = 1 , Mp
                        Ch(m,i-1,k,j) = Cc(m,i-1,2*j-1,k)               &
                                      & + Cc(m,ic-1,2*j-2,k)
                        Ch(m,i-1,k,jc) = Cc(m,i-1,2*j-1,k)              &
                         & - Cc(m,ic-1,2*j-2,k)
                        Ch(m,i,k,j) = Cc(m,i,2*j-1,k) - Cc(m,ic,2*j-2,k)
                        Ch(m,i,k,jc) = Cc(m,i,2*j-1,k)                  &
                                     & + Cc(m,ic,2*j-2,k)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ELSE
            DO j = 2 , ipph
               jc = ipp2 - j
               DO k = 1 , L1
                  DO i = 3 , Ido , 2
                     ic = idp2 - i
                     DO m = 1 , Mp
                        Ch(m,i-1,k,j) = Cc(m,i-1,2*j-1,k)               &
                                      & + Cc(m,ic-1,2*j-2,k)
                        Ch(m,i-1,k,jc) = Cc(m,i-1,2*j-1,k)              &
                         & - Cc(m,ic-1,2*j-2,k)
                        Ch(m,i,k,j) = Cc(m,i,2*j-1,k) - Cc(m,ic,2*j-2,k)
                        Ch(m,i,k,jc) = Cc(m,i,2*j-1,k)                  &
                                     & + Cc(m,ic,2*j-2,k)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      ar1 = 1.
      ai1 = 0.
      DO l = 2 , ipph
         lc = ipp2 - l
         ar1h = dcp*ar1 - dsp*ai1
         ai1 = dcp*ai1 + dsp*ar1
         ar1 = ar1h
         DO ik = 1 , Idl1
            DO m = 1 , Mp
               C2(m,ik,l) = Ch2(m,ik,1) + ar1*Ch2(m,ik,2)
               C2(m,ik,lc) = ai1*Ch2(m,ik,Ip)
            ENDDO
         ENDDO
         dc2 = ar1
         ds2 = ai1
         ar2 = ar1
         ai2 = ai1
         DO j = 3 , ipph
            jc = ipp2 - j
            ar2h = dc2*ar2 - ds2*ai2
            ai2 = dc2*ai2 + ds2*ar2
            ar2 = ar2h
            DO ik = 1 , Idl1
               DO m = 1 , Mp
                  C2(m,ik,l) = C2(m,ik,l) + ar2*Ch2(m,ik,j)
                  C2(m,ik,lc) = C2(m,ik,lc) + ai2*Ch2(m,ik,jc)
               ENDDO
            ENDDO
         ENDDO
      ENDDO
      DO j = 2 , ipph
         DO ik = 1 , Idl1
            DO m = 1 , Mp
               Ch2(m,ik,1) = Ch2(m,ik,1) + Ch2(m,ik,j)
            ENDDO
         ENDDO
      ENDDO
      DO j = 2 , ipph
         jc = ipp2 - j
         DO k = 1 , L1
            DO m = 1 , Mp
               Ch(m,1,k,j) = C1(m,1,k,j) - C1(m,1,k,jc)
               Ch(m,1,k,jc) = C1(m,1,k,j) + C1(m,1,k,jc)
            ENDDO
         ENDDO
      ENDDO
      IF ( Ido/=1 ) THEN
         IF ( nbd<L1 ) THEN
            DO j = 2 , ipph
               jc = ipp2 - j
               DO i = 3 , Ido , 2
                  DO k = 1 , L1
                     DO m = 1 , Mp
                        Ch(m,i-1,k,j) = C1(m,i-1,k,j) - C1(m,i,k,jc)
                        Ch(m,i-1,k,jc) = C1(m,i-1,k,j) + C1(m,i,k,jc)
                        Ch(m,i,k,j) = C1(m,i,k,j) + C1(m,i-1,k,jc)
                        Ch(m,i,k,jc) = C1(m,i,k,j) - C1(m,i-1,k,jc)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ELSE
            DO j = 2 , ipph
               jc = ipp2 - j
               DO k = 1 , L1
                  DO i = 3 , Ido , 2
                     DO m = 1 , Mp
                        Ch(m,i-1,k,j) = C1(m,i-1,k,j) - C1(m,i,k,jc)
                        Ch(m,i-1,k,jc) = C1(m,i-1,k,j) + C1(m,i,k,jc)
                        Ch(m,i,k,j) = C1(m,i,k,j) + C1(m,i-1,k,jc)
                        Ch(m,i,k,jc) = C1(m,i,k,j) - C1(m,i-1,k,jc)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
      ENDIF
      IF ( Ido==1 ) RETURN
      DO ik = 1 , Idl1
         DO m = 1 , Mp
            C2(m,ik,1) = Ch2(m,ik,1)
         ENDDO
      ENDDO
      DO j = 2 , Ip
         DO k = 1 , L1
            DO m = 1 , Mp
               C1(m,1,k,j) = Ch(m,1,k,j)
            ENDDO
         ENDDO
      ENDDO
      IF ( nbd>L1 ) THEN
         is = -Ido
         DO j = 2 , Ip
            is = is + Ido
            DO k = 1 , L1
               idij = is
               DO i = 3 , Ido , 2
                  idij = idij + 2
                  DO m = 1 , Mp
                     C1(m,i-1,k,j) = Wa(idij-1)*Ch(m,i-1,k,j) - Wa(idij)&
                                   & *Ch(m,i,k,j)
                     C1(m,i,k,j) = Wa(idij-1)*Ch(m,i,k,j) + Wa(idij)    &
                                 & *Ch(m,i-1,k,j)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
      ELSE
         is = -Ido
         DO j = 2 , Ip
            is = is + Ido
            idij = is
            DO i = 3 , Ido , 2
               idij = idij + 2
               DO k = 1 , L1
                  DO m = 1 , Mp
                     C1(m,i-1,k,j) = Wa(idij-1)*Ch(m,i-1,k,j) - Wa(idij)&
                                   & *Ch(m,i,k,j)
                     C1(m,i,k,j) = Wa(idij-1)*Ch(m,i,k,j) + Wa(idij)    &
                                 & *Ch(m,i-1,k,j)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      END SUBROUTINE DHRADBG

      SUBROUTINE DHRADB4(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1,Wa2,Wa3)
      IMPLICIT NONE

      DOUBLE PRECISION Cc , Ch , sqrt2 , Wa1 , Wa2 , Wa3
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp

!
!     a multiple fft package for spherepack
!
      DIMENSION Cc(Mdimcc,Ido,4,L1) , Ch(Mdimch,Ido,L1,4) , Wa1(Ido) ,  &
              & Wa2(Ido) , Wa3(Ido)
      sqrt2 = SQRT(2.)
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,k,3) = (Cc(m,1,1,k)+Cc(m,Ido,4,k))                   &
                        & - (Cc(m,Ido,2,k)+Cc(m,Ido,2,k))
            Ch(m,1,k,1) = (Cc(m,1,1,k)+Cc(m,Ido,4,k))                   &
                        & + (Cc(m,Ido,2,k)+Cc(m,Ido,2,k))
            Ch(m,1,k,4) = (Cc(m,1,1,k)-Cc(m,Ido,4,k))                   &
                        & + (Cc(m,1,3,k)+Cc(m,1,3,k))
            Ch(m,1,k,2) = (Cc(m,1,1,k)-Cc(m,Ido,4,k))                   &
                        & - (Cc(m,1,3,k)+Cc(m,1,3,k))
         ENDDO
      ENDDO
      IF ( Ido<2 ) GOTO 99999
      IF ( Ido/=2 ) THEN
         idp2 = Ido + 2
         DO k = 1 , L1
            DO i = 3 , Ido , 2
               ic = idp2 - i
               DO m = 1 , Mp
                  Ch(m,i-1,k,1) = (Cc(m,i-1,1,k)+Cc(m,ic-1,4,k))        &
                                & + (Cc(m,i-1,3,k)+Cc(m,ic-1,2,k))
                  Ch(m,i,k,1) = (Cc(m,i,1,k)-Cc(m,ic,4,k))              &
                              & + (Cc(m,i,3,k)-Cc(m,ic,2,k))
                  Ch(m,i-1,k,2) = Wa1(i-2)                              &
                                & *((Cc(m,i-1,1,k)-Cc(m,ic-1,4,k))      &
                                & -(Cc(m,i,3,k)+Cc(m,ic,2,k)))          &
                                & - Wa1(i-1)                            &
                                & *((Cc(m,i,1,k)+Cc(m,ic,4,k))+         &
                                & (Cc(m,i-1,3,k)-Cc(m,ic-1,2,k)))
                  Ch(m,i,k,2) = Wa1(i-2)                                &
                              & *((Cc(m,i,1,k)+Cc(m,ic,4,k))+(Cc(m,i-1, &
                              & 3,k)-Cc(m,ic-1,2,k))) + Wa1(i-1)        &
                              & *((Cc(m,i-1,1,k)-Cc(m,ic-1,4,k))        &
                              & -(Cc(m,i,3,k)+Cc(m,ic,2,k)))
                  Ch(m,i-1,k,3) = Wa2(i-2)                              &
                                & *((Cc(m,i-1,1,k)+Cc(m,ic-1,4,k))      &
                                & -(Cc(m,i-1,3,k)+Cc(m,ic-1,2,k)))      &
                                & - Wa2(i-1)                            &
                                & *((Cc(m,i,1,k)-Cc(m,ic,4,k))-         &
                                & (Cc(m,i,3,k)-Cc(m,ic,2,k)))
                  Ch(m,i,k,3) = Wa2(i-2)                                &
                              & *((Cc(m,i,1,k)-Cc(m,ic,4,k))-(Cc(m,i,3, &
                              & k)-Cc(m,ic,2,k))) + Wa2(i-1)            &
                              & *((Cc(m,i-1,1,k)+Cc(m,ic-1,4,k))        &
                              & -(Cc(m,i-1,3,k)+Cc(m,ic-1,2,k)))
                  Ch(m,i-1,k,4) = Wa3(i-2)                              &
                                & *((Cc(m,i-1,1,k)-Cc(m,ic-1,4,k))      &
                                & +(Cc(m,i,3,k)+Cc(m,ic,2,k)))          &
                                & - Wa3(i-1)                            &
                                & *((Cc(m,i,1,k)+Cc(m,ic,4,k))-         &
                                & (Cc(m,i-1,3,k)-Cc(m,ic-1,2,k)))
                  Ch(m,i,k,4) = Wa3(i-2)                                &
                              & *((Cc(m,i,1,k)+Cc(m,ic,4,k))-(Cc(m,i-1, &
                              & 3,k)-Cc(m,ic-1,2,k))) + Wa3(i-1)        &
                              & *((Cc(m,i-1,1,k)-Cc(m,ic-1,4,k))        &
                              & +(Cc(m,i,3,k)+Cc(m,ic,2,k)))
               ENDDO
            ENDDO
         ENDDO
         IF ( MOD(Ido,2)==1 ) RETURN
      ENDIF
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,Ido,k,1) = (Cc(m,Ido,1,k)+Cc(m,Ido,3,k))               &
                          & + (Cc(m,Ido,1,k)+Cc(m,Ido,3,k))
            Ch(m,Ido,k,2) = sqrt2*((Cc(m,Ido,1,k)-Cc(m,Ido,3,k))-(Cc(m,1&
                          & ,2,k)+Cc(m,1,4,k)))
            Ch(m,Ido,k,3) = (Cc(m,1,4,k)-Cc(m,1,2,k))                   &
                          & + (Cc(m,1,4,k)-Cc(m,1,2,k))
            Ch(m,Ido,k,4) = -sqrt2*((Cc(m,Ido,1,k)-Cc(m,Ido,3,k))+(Cc(m,&
                          & 1,2,k)+Cc(m,1,4,k)))
         ENDDO
      ENDDO
99999 END SUBROUTINE DHRADB4

      SUBROUTINE DHRADB2(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1)
      IMPLICIT NONE
      DOUBLE PRECISION Cc , Ch , Wa1
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp
!
!     a multiple fft package for spherepack
!
      DIMENSION Cc(Mdimcc,Ido,2,L1) , Ch(Mdimch,Ido,L1,2) , Wa1(Ido)
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,k,1) = Cc(m,1,1,k) + Cc(m,Ido,2,k)
            Ch(m,1,k,2) = Cc(m,1,1,k) - Cc(m,Ido,2,k)
         ENDDO
      ENDDO
      IF ( Ido<2 ) GOTO 99999
      IF ( Ido/=2 ) THEN
         idp2 = Ido + 2
         DO k = 1 , L1
            DO i = 3 , Ido , 2
               ic = idp2 - i
               DO m = 1 , Mp
                  Ch(m,i-1,k,1) = Cc(m,i-1,1,k) + Cc(m,ic-1,2,k)
                  Ch(m,i,k,1) = Cc(m,i,1,k) - Cc(m,ic,2,k)
                  Ch(m,i-1,k,2) = Wa1(i-2)                              &
                                & *(Cc(m,i-1,1,k)-Cc(m,ic-1,2,k))       &
                                & - Wa1(i-1)*(Cc(m,i,1,k)+Cc(m,ic,2,k))
                  Ch(m,i,k,2) = Wa1(i-2)*(Cc(m,i,1,k)+Cc(m,ic,2,k))     &
                              & + Wa1(i-1)                              &
                              & *(Cc(m,i-1,1,k)-Cc(m,ic-1,2,k))
               ENDDO
            ENDDO
         ENDDO
         IF ( MOD(Ido,2)==1 ) RETURN
      ENDIF
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,Ido,k,1) = Cc(m,Ido,1,k) + Cc(m,Ido,1,k)
            Ch(m,Ido,k,2) = -(Cc(m,1,2,k)+Cc(m,1,2,k))
         ENDDO
      ENDDO
99999 END SUBROUTINE DHRADB2

      SUBROUTINE DHRADB3(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1,Wa2)
      IMPLICIT NONE
      DOUBLE PRECISION arg , Cc , Ch , DPIMACH , taui , taur , Wa1 , Wa2
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp
!
!     a multiple fft package for spherepack
!
      DIMENSION Cc(Mdimcc,Ido,3,L1) , Ch(Mdimch,Ido,L1,3) , Wa1(Ido) ,  &
              & Wa2(Ido)
      arg = 2.*DPIMACH()/3.
      taur = COS(arg)
      taui = SIN(arg)
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,k,1) = Cc(m,1,1,k) + 2.*Cc(m,Ido,2,k)
            Ch(m,1,k,2) = Cc(m,1,1,k) + (2.*taur)*Cc(m,Ido,2,k)         &
                        & - (2.*taui)*Cc(m,1,3,k)
            Ch(m,1,k,3) = Cc(m,1,1,k) + (2.*taur)*Cc(m,Ido,2,k)         &
                        & + 2.*taui*Cc(m,1,3,k)
         ENDDO
      ENDDO
      IF ( Ido==1 ) RETURN
      idp2 = Ido + 2
      DO k = 1 , L1
         DO i = 3 , Ido , 2
            ic = idp2 - i
            DO m = 1 , Mp
               Ch(m,i-1,k,1) = Cc(m,i-1,1,k)                            &
                             & + (Cc(m,i-1,3,k)+Cc(m,ic-1,2,k))
               Ch(m,i,k,1) = Cc(m,i,1,k) + (Cc(m,i,3,k)-Cc(m,ic,2,k))
               Ch(m,i-1,k,2) = Wa1(i-2)                                 &
                             & *((Cc(m,i-1,1,k)+taur*(Cc(m,i-1,3,k)     &
                             & +Cc(m,ic-1,2,k)))                        &
                             & -(taui*(Cc(m,i,3,k)+Cc(m,ic,2,k))))      &
                             & - Wa1(i-1)                               &
                             & *((Cc(m,i,1,k)+taur*(Cc(m,i,3,k)         &
                             & -Cc(m,ic,2,k)))                          &
                             & +(taui*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))))
               Ch(m,i,k,2) = Wa1(i-2)                                   &
                           & *((Cc(m,i,1,k)+taur*(Cc(m,i,3,k)-Cc(m,ic,2,&
                           & k)))+(taui*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))))&
                           & + Wa1(i-1)                                 &
                           & *((Cc(m,i-1,1,k)+taur*(Cc(m,i-1,3,k)       &
                           & +Cc(m,ic-1,2,k)))                          &
                           & -(taui*(Cc(m,i,3,k)+Cc(m,ic,2,k))))
               Ch(m,i-1,k,3) = Wa2(i-2)                                 &
                             & *((Cc(m,i-1,1,k)+taur*(Cc(m,i-1,3,k)     &
                             & +Cc(m,ic-1,2,k)))                        &
                             & +(taui*(Cc(m,i,3,k)+Cc(m,ic,2,k))))      &
                             & - Wa2(i-1)                               &
                             & *((Cc(m,i,1,k)+taur*(Cc(m,i,3,k)         &
                             & -Cc(m,ic,2,k)))                          &
                             & -(taui*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))))
               Ch(m,i,k,3) = Wa2(i-2)                                   &
                           & *((Cc(m,i,1,k)+taur*(Cc(m,i,3,k)-Cc(m,ic,2,&
                           & k)))-(taui*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))))&
                           & + Wa2(i-1)                                 &
                           & *((Cc(m,i-1,1,k)+taur*(Cc(m,i-1,3,k)       &
                           & +Cc(m,ic-1,2,k)))                          &
                           & +(taui*(Cc(m,i,3,k)+Cc(m,ic,2,k))))
            ENDDO
         ENDDO
      ENDDO
      END SUBROUTINE DHRADB3

      SUBROUTINE DHRADB5(Mp,Ido,L1,Cc,Mdimcc,Ch,Mdimch,Wa1,Wa2,Wa3,Wa4)
      IMPLICIT NONE
      DOUBLE PRECISION arg , Cc , Ch , DPIMACH , ti11 , ti12 , tr11 , tr12 , Wa1 ,   &
         & Wa2 , Wa3 , Wa4
      INTEGER i , ic , Ido , idp2 , k , L1 , m , Mdimcc , Mdimch , Mp
!
!     a multiple fft package for spherepack
!
      DIMENSION Cc(Mdimcc,Ido,5,L1) , Ch(Mdimch,Ido,L1,5) , Wa1(Ido) ,  &
              & Wa2(Ido) , Wa3(Ido) , Wa4(Ido)
      arg = 2.*DPIMACH()/5.
      tr11 = COS(arg)
      ti11 = SIN(arg)
      tr12 = COS(2.*arg)
      ti12 = SIN(2.*arg)
      DO k = 1 , L1
         DO m = 1 , Mp
            Ch(m,1,k,1) = Cc(m,1,1,k) + 2.*Cc(m,Ido,2,k)                &
                        & + 2.*Cc(m,Ido,4,k)
            Ch(m,1,k,2) = (Cc(m,1,1,k)+tr11*2.*Cc(m,Ido,2,k)+tr12*2.*Cc(&
                        & m,Ido,4,k))                                   &
                        & - (ti11*2.*Cc(m,1,3,k)+ti12*2.*Cc(m,1,5,k))
            Ch(m,1,k,3) = (Cc(m,1,1,k)+tr12*2.*Cc(m,Ido,2,k)+tr11*2.*Cc(&
                        & m,Ido,4,k))                                   &
                        & - (ti12*2.*Cc(m,1,3,k)-ti11*2.*Cc(m,1,5,k))
            Ch(m,1,k,4) = (Cc(m,1,1,k)+tr12*2.*Cc(m,Ido,2,k)+tr11*2.*Cc(&
                        & m,Ido,4,k))                                   &
                        & + (ti12*2.*Cc(m,1,3,k)-ti11*2.*Cc(m,1,5,k))
            Ch(m,1,k,5) = (Cc(m,1,1,k)+tr11*2.*Cc(m,Ido,2,k)+tr12*2.*Cc(&
                        & m,Ido,4,k))                                   &
                        & + (ti11*2.*Cc(m,1,3,k)+ti12*2.*Cc(m,1,5,k))
         ENDDO
      ENDDO
      IF ( Ido==1 ) RETURN
      idp2 = Ido + 2
      DO k = 1 , L1
         DO i = 3 , Ido , 2
            ic = idp2 - i
            DO m = 1 , Mp
               Ch(m,i-1,k,1) = Cc(m,i-1,1,k)                            &
                             & + (Cc(m,i-1,3,k)+Cc(m,ic-1,2,k))         &
                             & + (Cc(m,i-1,5,k)+Cc(m,ic-1,4,k))
               Ch(m,i,k,1) = Cc(m,i,1,k) + (Cc(m,i,3,k)-Cc(m,ic,2,k))   &
                           & + (Cc(m,i,5,k)-Cc(m,ic,4,k))
               Ch(m,i-1,k,2) = Wa1(i-2)                                 &
                             & *((Cc(m,i-1,1,k)+tr11*(Cc(m,i-1,3,k)     &
                             & +Cc(m,ic-1,2,k))                         &
                             & +tr12*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))    &
                             & -(ti11*(Cc(m,i,3,k)+Cc(m,ic,2,k))        &
                             & +ti12*(Cc(m,i,5,k)+Cc(m,ic,4,k))))       &
                             & - Wa1(i-1)                               &
                             & *((Cc(m,i,1,k)+tr11*(Cc(m,i,3,k)         &
                             & -Cc(m,ic,2,k))                           &
                             & +tr12*(Cc(m,i,5,k)-Cc(m,ic,4,k)))        &
                             & +(ti11*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))    &
                             & +ti12*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))
               Ch(m,i,k,2) = Wa1(i-2)                                   &
                           & *((Cc(m,i,1,k)+tr11*(Cc(m,i,3,k)-Cc(m,ic,2,&
                           & k))+tr12*(Cc(m,i,5,k)-Cc(m,ic,4,k)))       &
                           & +(ti11*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))      &
                           & +ti12*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))     &
                           & + Wa1(i-1)                                 &
                           & *((Cc(m,i-1,1,k)+tr11*(Cc(m,i-1,3,k)       &
                           & +Cc(m,ic-1,2,k))                           &
                           & +tr12*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))      &
                           & -(ti11*(Cc(m,i,3,k)+Cc(m,ic,2,k))          &
                           & +ti12*(Cc(m,i,5,k)+Cc(m,ic,4,k))))
               Ch(m,i-1,k,3) = Wa2(i-2)                                 &
                             & *((Cc(m,i-1,1,k)+tr12*(Cc(m,i-1,3,k)     &
                             & +Cc(m,ic-1,2,k))                         &
                             & +tr11*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))    &
                             & -(ti12*(Cc(m,i,3,k)+Cc(m,ic,2,k))        &
                             & -ti11*(Cc(m,i,5,k)+Cc(m,ic,4,k))))       &
                             & - Wa2(i-1)                               &
                             & *((Cc(m,i,1,k)+tr12*(Cc(m,i,3,k)         &
                             & -Cc(m,ic,2,k))                           &
                             & +tr11*(Cc(m,i,5,k)-Cc(m,ic,4,k)))        &
                             & +(ti12*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))    &
                             & -ti11*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))
               Ch(m,i,k,3) = Wa2(i-2)                                   &
                           & *((Cc(m,i,1,k)+tr12*(Cc(m,i,3,k)-Cc(m,ic,2,&
                           & k))+tr11*(Cc(m,i,5,k)-Cc(m,ic,4,k)))       &
                           & +(ti12*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))      &
                           & -ti11*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))     &
                           & + Wa2(i-1)                                 &
                           & *((Cc(m,i-1,1,k)+tr12*(Cc(m,i-1,3,k)       &
                           & +Cc(m,ic-1,2,k))                           &
                           & +tr11*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))      &
                           & -(ti12*(Cc(m,i,3,k)+Cc(m,ic,2,k))          &
                           & -ti11*(Cc(m,i,5,k)+Cc(m,ic,4,k))))
               Ch(m,i-1,k,4) = Wa3(i-2)                                 &
                             & *((Cc(m,i-1,1,k)+tr12*(Cc(m,i-1,3,k)     &
                             & +Cc(m,ic-1,2,k))                         &
                             & +tr11*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))    &
                             & +(ti12*(Cc(m,i,3,k)+Cc(m,ic,2,k))        &
                             & -ti11*(Cc(m,i,5,k)+Cc(m,ic,4,k))))       &
                             & - Wa3(i-1)                               &
                             & *((Cc(m,i,1,k)+tr12*(Cc(m,i,3,k)         &
                             & -Cc(m,ic,2,k))                           &
                             & +tr11*(Cc(m,i,5,k)-Cc(m,ic,4,k)))        &
                             & -(ti12*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))    &
                             & -ti11*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))
               Ch(m,i,k,4) = Wa3(i-2)                                   &
                           & *((Cc(m,i,1,k)+tr12*(Cc(m,i,3,k)-Cc(m,ic,2,&
                           & k))+tr11*(Cc(m,i,5,k)-Cc(m,ic,4,k)))       &
                           & -(ti12*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))      &
                           & -ti11*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))     &
                           & + Wa3(i-1)                                 &
                           & *((Cc(m,i-1,1,k)+tr12*(Cc(m,i-1,3,k)       &
                           & +Cc(m,ic-1,2,k))                           &
                           & +tr11*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))      &
                           & +(ti12*(Cc(m,i,3,k)+Cc(m,ic,2,k))          &
                           & -ti11*(Cc(m,i,5,k)+Cc(m,ic,4,k))))
               Ch(m,i-1,k,5) = Wa4(i-2)                                 &
                             & *((Cc(m,i-1,1,k)+tr11*(Cc(m,i-1,3,k)     &
                             & +Cc(m,ic-1,2,k))                         &
                             & +tr12*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))    &
                             & +(ti11*(Cc(m,i,3,k)+Cc(m,ic,2,k))        &
                             & +ti12*(Cc(m,i,5,k)+Cc(m,ic,4,k))))       &
                             & - Wa4(i-1)                               &
                             & *((Cc(m,i,1,k)+tr11*(Cc(m,i,3,k)         &
                             & -Cc(m,ic,2,k))                           &
                             & +tr12*(Cc(m,i,5,k)-Cc(m,ic,4,k)))        &
                             & -(ti11*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))    &
                             & +ti12*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))
               Ch(m,i,k,5) = Wa4(i-2)                                   &
                           & *((Cc(m,i,1,k)+tr11*(Cc(m,i,3,k)-Cc(m,ic,2,&
                           & k))+tr12*(Cc(m,i,5,k)-Cc(m,ic,4,k)))       &
                           & -(ti11*(Cc(m,i-1,3,k)-Cc(m,ic-1,2,k))      &
                           & +ti12*(Cc(m,i-1,5,k)-Cc(m,ic-1,4,k))))     &
                           & + Wa4(i-1)                                 &
                           & *((Cc(m,i-1,1,k)+tr11*(Cc(m,i-1,3,k)       &
                           & +Cc(m,ic-1,2,k))                           &
                           & +tr12*(Cc(m,i-1,5,k)+Cc(m,ic-1,4,k)))      &
                           & +(ti11*(Cc(m,i,3,k)+Cc(m,ic,2,k))          &
                           & +ti12*(Cc(m,i,5,k)+Cc(m,ic,4,k))))
            ENDDO
         ENDDO
      ENDDO
      END SUBROUTINE DHRADB5

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file idvtgs.f
c
c     this file includes documentation and code for
c     subroutine idvtgs         i
c
c ... files which must be loaded with idvtgs.f
c
c     sphcom.f, hrfft.f, vhsgs.f,shags.f, gaqd.f
c
c
c     subroutine idvtgs(nlat,nlon,isym,nt,v,w,idvw,jdvw,ad,bd,av,bv,
c    +mdab,ndab,wvhsgs,lvhsgs,work,lwork,pertbd,pertbv,ierror)
c
c     given the scalar spherical harmonic coefficients ad,bd precomputed
c     by subroutine shaes for the scalar field divg and coefficients av,bv
c     precomputed by subroutine shaes for the scalar field vort, subroutine
c     idvtgs computes a vector field (v,w) whose divergence is divg - pertbd
c     and whose vorticity is vort - pertbv.  w the is east longitude component
c     and v is the colatitudinal component of the velocity.  if nt=1 (see nt
c     below) pertrbd and pertbv are constants which must be subtracted from
c     divg and vort for (v,w) to exist (see the description of pertbd and
c     pertrbv below).  usually pertbd and pertbv are zero or small relative
c     to divg and vort.  w(i,j) and v(i,j) are the velocity components at
c     gaussian colatitude theta(i) (see nlat as input argument) and longitude
c     lambda(j) = (j-1)*2*pi/nlon
c
c     the
c
c            divergence(v(i,j),w(i,j))
c
c         =  [d(sint*v)/dtheta + dw/dlambda]/sint
c
c         =  divg(i,j) - pertbd
c
c     and
c
c            vorticity(v(i,j),w(i,j))
c
c         =  [-dv/dlambda + d(sint*w)/dtheta]/sint
c
c         =  vort(i,j) - pertbv
c
c     where
c
c            sint = cos(theta(i)).
c
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are computed
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than 3. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   isym determines whether (v,w) are computed on the full or half
c            sphere as follows:
c
c      = 0
c            divg,vort are neither pairwise symmetric/antisymmetric nor
c            antisymmetric/symmetric about the equator as described for
c            isym = 1 or isym = 2  below.  in this case, the vector field
c            (v,w) is computed on the entire sphere.  i.e., in the arrays
c            w(i,j) and v(i,j) i=1,...,nlat and j=1,...,nlon.
c
c      = 1
c
c            divg is antisymmetric and vort is symmetric about the equator.
c            in this case w is antisymmetric and v is symmetric about the
c            equator.  w and v are computed on the northern hemisphere only.
c            if nlat is odd they are computed for i=1,...,(nlat+1)/2
c            and j=1,...,nlon.  if nlat is even they are computed for
c            i=1,...,nlat/2 and j=1,...,nlon.
c
c      = 2
c
c            divg is symmetric and vort is antisymmetric about the equator.
c            in this case w is symmetric and v is antisymmetric about the
c            equator.  w and v are computed on the northern hemisphere only.
c            if nlat is odd they are computed for i=1,...,(nlat+1)/2
c            and j=1,...,nlon.  if nlat is even they are computed for
c            i=1,...,nlat/2 and j=1,...,nlon.
c
c
c     nt     in the program that calls idvtgs, nt is the number of scalar
c            and vector fields.  some computational efficiency is obtained
c            for multiple fields.  the arrays ad,bd,av,bv,u, and v can be
c            three dimensional and pertbd,pertbv can be one dimensional
c            corresponding to indexed multiple arrays divg, vort.  in this
c            case, multiple synthesis will be performed to compute each
c            vector field.  the third index for ad,bd,av,bv,v,w and first
c            pertrbd,pertbv is the synthesis index which assumes the values
c            k=1,...,nt.  for a single synthesis set nt=1. the description of
c            remaining parameters is simplified by assuming that nt=1 or that
c            ad,bd,av,bv,v,w are two dimensional and pertbd,pertbv are
c            constants.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls idvtgs. if isym = 0 then idvw
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idvw must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls idvtgs. jdvw must be at least nlon.
c
c     ad,bd  two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
c            of the divergence array divg as computed by subroutine shaes.
c
c     av,bv  two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
c            of the vorticity array vort as computed by subroutine shaes.
c     ***    ad,bd,av,bv must be computed by shaes prior to calling idvtgs.
c
c     mdab   the first dimension of the arrays ad,bd,av,bv as it appears
c            in the program that calls idvtgs (and shags). mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays ad,bd,av,bv as it appears in
c            the program that calls idvtgs (and shags). ndab must be at
c            least nlat.
c
c  wvhsgs    an array which must be initialized by subroutine vhsgsi.
c            wvhsgs can be used repeatedly by idvtgs as long as nlon
c            and nlat remain unchanged.  wvhsgs must not be altered
c            between calls of idvtgs.
c
c
c  lvhsgs    the dimension of the array wvhsgs as it appears in the
c            program that calls idvtgs. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lvhsgs must be at least
c
c               l1*l2*(nlat+nlat-l1+1)+nlon+15+2*nlat
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls idvtgs. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,nlon/2)       if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2)   if nlon is odd
c
c            if isym = 0 then lwork must be at least
c
c                       nlat*((2*nt+1)*nlon+4*nt*l1+1)
c
c            if isym = 1 or 2 then lwork must be at least
c
c                       (2*nt+1)*l2*nlon+nlat*(4*nt*l1+1)
c
c     **************************************************************
c
c     output parameters
c
c
c     v,w   two or three dimensional arrays (see input parameter nt) that
c           contain a vector field whose divergence is divg - pertbd and
c           whose vorticity is vort - pertbv.  w(i,j) is the east longitude
c           component and v(i,j) is the colatitudinal component of velocity
c           at the colatitude theta(i) = (i-1)*pi/(nlat-1) and longitude
c           lambda(j) = (j-1)*2*pi/nlon for i=1,...,nlat and j=1,...,nlon.
c
c   pertbd  a nt dimensional array (see input parameter nt and assume nt=1
c           for the description that follows).  divg - pertbd is a scalar
c           field which can be the divergence of a vector field (v,w).
c           pertbd is related to the scalar harmonic coefficients ad,bd
c           of divg (computed by shaes) by the formula
c
c                pertbd = ad(1,1)/(2.*sqrt(2.))
c
c           an unperturbed divg can be the divergence of a vector field
c           only if ad(1,1) is zero.  if ad(1,1) is nonzero (flagged by
c           pertbd nonzero) then subtracting pertbd from divg yields a
c           scalar field for which ad(1,1) is zero.  usually pertbd is
c           zero or small relative to divg.
c
c   pertbv a nt dimensional array (see input parameter nt and assume nt=1
c           for the description that follows).  vort - pertbv is a scalar
c           field which can be the vorticity of a vector field (v,w).
c           pertbv is related to the scalar harmonic coefficients av,bv
c           of vort (computed by shaes) by the formula
c
c                pertbv = av(1,1)/(2.*sqrt(2.))
c
c           an unperturbed vort can be the vorticity of a vector field
c           only if av(1,1) is zero.  if av(1,1) is nonzero (flagged by
c           pertbv nonzero) then subtracting pertbv from vort yields a
c           scalar field for which av(1,1) is zero.  usually pertbv is
c           zero or small relative to vort.
c
c    ierror = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idvw
c           = 6  error in the specification of jdvw
c           = 7  error in the specification of mdab
c           = 8  error in the specification of ndab
c           = 9  error in the specification of lvhsgs
c           = 10 error in the specification of lwork
c **********************************************************************
c                                                                              
c   
      subroutine idvtgs(nlat,nlon,isym,nt,v,w,idvw,jdvw,ad,bd,av,bv,
     +mdab,ndab,wvhsgs,lvhsgs,work,lwork,pertbd,pertbv,ierror)
      dimension w(idvw,jdvw,nt),v(idvw,jdvw,nt),pertbd(nt),pertbv(nt)
      dimension ad(mdab,ndab,nt),bd(mdab,ndab,nt)
      dimension av(mdab,ndab,nt),bv(mdab,ndab,nt)
      dimension wvhsgs(lvhsgs),work(lwork)
c
c     check input parameters
c
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if(nlon .lt. 4) return
      ierror = 3
      if(isym.lt.0 .or. isym.gt.2) return
      ierror = 4
      if(nt .lt. 0) return
      ierror = 5
      imid = (nlat+1)/2
      if((isym.eq.0 .and. idvw.lt.nlat) .or.
     +   (isym.ne.0 .and. idvw.lt.imid)) return
      ierror = 6
      if(jdvw .lt. nlon) return
      ierror = 7
      mmax = min0(nlat,(nlon+1)/2)
      if(mdab .lt. min0(nlat,(nlon+2)/2)) return
      ierror = 8
      if(ndab .lt. nlat) return
      ierror = 9
      idz = (mmax*(nlat+nlat-mmax+1))/2
      lzimn = idz*imid
      if(lvhsgs .lt. lzimn+lzimn+nlon+15) return
      ierror = 10
c
c     verify unsaved work space length
c
      mn = mmax*nlat*nt
      if(isym.ne.0  .and. lwork .lt.
     +nlat*(2*nt*nlon+max0(6*imid,nlon))+4*mn+nlat) return
      if(isym.eq.0  .and. lwork .lt.
     +imid*(2*nt*nlon+max0(6*nlat,nlon))+4*mn+nlat) return
      ierror = 0
c
c     set work space pointers
c
      ibr = 1
      ibi = ibr+mn
      icr = ibi+mn
      ici = icr + mn
      is = ici + mn
      iwk = is + nlat
      liwk = lwork-4*mn-nlat
      call idvtgs1(nlat,nlon,isym,nt,v,w,idvw,jdvw,work(ibr),
     +work(ibi),work(icr),work(ici),mmax,work(is),mdab,ndab,ad,bd,
     +av,bv,wvhsgs,lvhsgs,work(iwk),liwk,pertbd,pertbv,ierror)
      return
      end

      subroutine idvtgs1(nlat,nlon,isym,nt,v,w,idvw,jdvw,br,bi,
     +cr,ci,mmax,sqnn,mdab,ndab,ad,bd,av,bv,wvhsgs,lvhsgs,wk,lwk,
     +pertbd,pertbv,ierror)
      dimension w(idvw,jdvw,nt),v(idvw,jdvw,nt)
      dimension br(mmax,nlat,nt),bi(mmax,nlat,nt),sqnn(nlat)
      dimension cr(mmax,nlat,nt),ci(mmax,nlat,nt)
      dimension ad(mdab,ndab,nt),bd(mdab,ndab,nt)
      dimension av(mdab,ndab,nt),bv(mdab,ndab,nt)
      dimension wvhsgs(lvhsgs),wk(lwk)
      dimension pertbd(nt),pertbv(nt)
c
c     preset coefficient multiplyers in vector
c
      do 1 n=2,nlat
      fn = float(n-1)
      sqnn(n) = sqrt(fn*(fn+1.))
    1 continue
c
c     compute multiple vector fields coefficients
c
      do 2 k=1,nt
c
c     set divergence,vorticity perturbation constants
c
      pertbd(k) = ad(1,1,k)/(2.*sqrt(2.))
      pertbv(k) = av(1,1,k)/(2.*sqrt(2.))
c
c     preset br,bi,cr,ci to 0.0
c
      do 3 n=1,nlat
      do 4 m=1,mmax
      br(m,n,k) = 0.0
      bi(m,n,k) = 0.0
      cr(m,n,k) = 0.0
      ci(m,n,k) = 0.0
    4 continue
    3 continue
c
c     compute m=0 coefficients
c
      do 5 n=2,nlat
      br(1,n,k) = -ad(1,n,k)/sqnn(n)
      bi(1,n,k) = -bd(1,n,k)/sqnn(n)
      cr(1,n,k) = av(1,n,k)/sqnn(n)
      ci(1,n,k) = bv(1,n,k)/sqnn(n)
    5 continue
c
c     compute m>0 coefficients
c
      do 6 m=2,mmax
      do 7 n=m,nlat
      br(m,n,k) = -ad(m,n,k)/sqnn(n)
      bi(m,n,k) = -bd(m,n,k)/sqnn(n)
      cr(m,n,k) = av(m,n,k)/sqnn(n)
      ci(m,n,k) = bv(m,n,k)/sqnn(n)
    7 continue
    6 continue
    2 continue
c
c     set ityp for vector synthesis without assuming div=0 or curl=0
c
      if (isym.eq.0) then
      ityp = 0
      else if (isym.eq.1) then
      ityp = 3
      else if (isym.eq.2) then
      ityp = 6
      end if
c
c     sythesize br,bi,cr,ci into the vector field (v,w)
c
      call vhsgs(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
     +           mmax,nlat,wvhsgs,lvhsgs,wk,lwk,ierror)
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file igrades.f
!
!     this file includes documentation and code for
!     subroutine igrades         i
!
! ... files which must be loaded with igradec.f
!
!     sphcom.f, hrfft.f, shses.f,vhaes.f
!
!     subroutine igrades(nlat,nlon,isym,nt,sf,isf,jsf,br,bi,mdb,ndb,
!    +                   wshses,lshses,work,lwork,ierror)
!
!     let br,bi,cr,ci be the vector spherical harmonic coefficients
!     precomputed by vhaes for a vector field (v,w).  let (v',w') be
!     the irrotational component of (v,w) (i.e., (v',w') is generated
!     by assuming cr,ci are zero and synthesizing br,bi with vhses).
!     then subroutine igrades computes a scalar field sf such that
!
!            gradient(sf) = (v',w').
!
!     i.e.,
!
!            v'(i,j) = d(sf(i,j))/dtheta          (colatitudinal component of
!                                                 the gradient)
!     and
!
!            w'(i,j) = 1/sint*d(sf(i,j))/dlambda  (east longitudinal component
!                                                 of the gradient)
!
!     at colatitude
!
!            theta(i) = (i-1)*pi/(nlat-1)
!
!     and longitude
!
!            lambda(j) = (j-1)*2*pi/nlon
!
!     where sint = sin(theta(i)).  required associated legendre polynomials
!     are stored rather than recomputed as they are in subroutine igradec.
!
!     note:  for an irrotational vector field (v,w), subroutine igrades
!     computes a scalar field whose gradient is (v,w).  in ay case,
!     subroutine igrades "inverts" the gradient subroutine grades.
!
!
!     input parameters
!
!     nlat   the number of colatitudes on the full sphere including the
!            poles. for example, nlat = 37 for a five degree grid.
!            nlat determines the grid increment in colatitude as
!            pi/(nlat-1).  if nlat is odd the equator is located at
!            grid point i=(nlat+1)/2. if nlat is even the equator is
!            located half way between points i=nlat/2 and i=nlat/2+1.
!            nlat must be at least 3. note: on the half sphere, the
!            number of grid points in the colatitudinal direction is
!            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater than
!            3.  the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!
!     isym   a parameter which determines whether the scalar field sf is
!            computed on the full or half sphere as follows:
!
!      = 0
!
!            the symmetries/antsymmetries described in isym=1,2 below
!            do not exist in (v,w) about the equator.  in this case sf
!            is neither symmetric nor antisymmetric about the equator.
!            sf is computed on the entire sphere.  i.e., in the array
!            sf(i,j) for i=1,...,nlat and  j=1,...,nlon
!
!      = 1
!
!            w is antisymmetric and v is symmetric about the equator.
!            in this case sf is antisymmetyric about the equator and
!            is computed for the northern hemisphere only.  i.e.,
!            if nlat is odd sf is computed in the array sf(i,j) for
!            i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is even
!            sf is computed in the array sf(i,j) for i=1,...,nlat/2
!            and j=1,...,nlon.
!
!      = 2
!
!            w is symmetric and v is antisymmetric about the equator.
!            in this case sf is symmetyric about the equator and
!            is computed for the northern hemisphere only.  i.e.,
!            if nlat is odd sf is computed in the array sf(i,j) for
!            i=1,...,(nlat+1)/2 and for j=1,...,nlon.  if nlat is even
!            sf is computed in the array sf(i,j) for i=1,...,nlat/2
!            and j=1,...,nlon.
!
!
!     nt     nt is the number of scalar and vector fields.  some
!            computational efficiency is obtained for multiple fields.
!            the arrays br,bi, and sf can be three dimensional corresponding
!            to an indexed multiple vector field (v,w).  in this case,
!            multiple scalar synthesis will be performed to compute each
!            scalar field.  the third index for br,bi, and sf is the synthesis
!            index which assumes the values k = 1,...,nt.  for a single
!            synthesis set nt = 1.  the description of the remaining
!            parameters is simplified by assuming that nt=1 or that br,bi,
!            and sf are two dimensional arrays.
!
!     isf    the first dimension of the array sf as it appears in
!            the program that calls igrades. if isym = 0 then isf
!            must be at least nlat.  if isym = 1 or 2 and nlat is
!            even then isf must be at least nlat/2. if isym = 1 or 2
!            and nlat is odd then isf must be at least (nlat+1)/2.
!
!     jsf    the second dimension of the array sf as it appears in
!            the program that calls igrades. jsf must be at least nlon.
!
!     br,bi  two or three dimensional arrays (see input parameter nt)
!            that contain vector spherical harmonic coefficients
!            of the vector field (v,w) as computed by subroutine vhaes.
!     ***    br,bi must be computed by vhaes prior to calling igrades.
!
!     mdb    the first dimension of the arrays br and bi as it appears in
!            the program that calls igrades (and vhaes). mdb must be at
!            least min0(nlat,nlon/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndb    the second dimension of the arrays br and bi as it appears in
!            the program that calls igrades (and vhaes). ndb must be at
!            least nlat.
!
!
!  wshses    an array which must be initialized by subroutine igradesi
!            (or equivalently by subroutine shsesi).  once initialized,
!            wshses can be used repeatedly by igrades as long as nlon
!            and nlat remain unchanged.  wshses must not be altered
!            between calls of igrades.
!
!
!  lshses    the dimension of the array wshses as it appears in the
!            program that calls igrades. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd.
!
!
!            then lshses must be greater than or equal to
!
!               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls igrades. define
!
!               l2 = nlat/2                    if nlat is even or
!               l2 = (nlat+1)/2                if nlat is odd
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            if isym = 0 lwork must be greater than or equal to
!
!               nlat*((nt+1)*nlon+2*nt*l1+1)
!
!            if isym > 0 lwork must be greater than or equal to
!
!               (nt+1)*l2*nlon+nlat*(2*nt*l1+1)
!
!
!
!     **************************************************************
!
!     output parameters
!
!
!     sf    a two or three dimensional array (see input parameter nt) that
!           contain a scalar field whose gradient is the irrotational
!           component of the vector field (v,w).  the vector spherical
!           harmonic coefficients br,bi were precomputed by subroutine
!           vhaes.  sf(i,j) is given at the gaussian colatitude theta(i)
!           and longitude lambda(j) = (j-1)*2*pi/nlon.  the index ranges
!           are defined at input parameter isym.
!
!
!  ierror   = 0  no errors
!           = 1  error in the specification of nlat
!           = 2  error in the specification of nlon
!           = 3  error in the specification of isym
!           = 4  error in the specification of nt
!           = 5  error in the specification of isf
!           = 6  error in the specification of jsf
!           = 7  error in the specification of mdb
!           = 8  error in the specification of ndb
!           = 9  error in the specification of lshses
!           = 10 error in the specification of lwork
!
! **********************************************************************
!
      SUBROUTINE IGRADES(Nlat,Nlon,Isym,Nt,Sf,Isf,Jsf,Br,Bi,Mdb,Ndb,    &
                       & Wshses,Lshses,Work,Lwork,Ierror)
      IMPLICIT NONE
      REAL Bi , Br , Sf , Work , Wshses
      INTEGER ia , ib , Ierror , imid , is , Isf , Isym , iwk , Jsf ,   &
            & liwk , lpimn , ls , Lshses , lwkmin , Lwork , mab , Mdb , &
            & mmax , mn , Ndb
      INTEGER Nlat , nln , Nlon , Nt
      DIMENSION Sf(Isf,Jsf,Nt)
      DIMENSION Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt)
      DIMENSION Wshses(Lshses) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Isf<Nlat) .OR. (Isym/=0 .AND. Isf<imid) )     &
         & RETURN
      Ierror = 6
      IF ( Jsf<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+2)/2)
      IF ( Mdb<MIN0(Nlat,(Nlon+1)/2) ) RETURN
      Ierror = 8
      IF ( Ndb<Nlat ) RETURN
      Ierror = 9
!
!     verify saved work space length
!
      imid = (Nlat+1)/2
      lpimn = (imid*mmax*(Nlat+Nlat-mmax+1))/2
      IF ( Lshses<lpimn+Nlon+15 ) RETURN
      Ierror = 10
!
!     set minimum and verify unsaved work space
!
      ls = Nlat
      IF ( Isym>0 ) ls = imid
      nln = Nt*ls*Nlon
!
!     set first dimension for a,b (as requried by shses)
!
      mab = MIN0(Nlat,Nlon/2+1)
      mn = mab*Nlat*Nt
      lwkmin = nln + ls*Nlon + 2*mn + Nlat
      IF ( Lwork<lwkmin ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ia = 1
      ib = ia + mn
      is = ib + mn
      iwk = is + Nlat
      liwk = Lwork - 2*mn - Nlat
      CALL IGRDES1(Nlat,Nlon,Isym,Nt,Sf,Isf,Jsf,Work(ia),Work(ib),mab,  &
                 & Work(is),Mdb,Ndb,Br,Bi,Wshses,Lshses,Work(iwk),liwk, &
                 & Ierror)
    END SUBROUTINE IGRADES

    
    SUBROUTINE IGRDES1(Nlat,Nlon,Isym,Nt,Sf,Isf,Jsf,A,B,Mab,Sqnn,Mdb, &
                       & Ndb,Br,Bi,Wshses,Lshses,Wk,Lwk,Ierror)
      IMPLICIT NONE
      REAL A , B , Bi , Br , fn , Sf , Sqnn , Wk , Wshses
      INTEGER Ierror , Isf , Isym , Jsf , k , Lshses , Lwk , m , Mab ,  &
            & Mdb , mmax , n , Ndb , Nlat , Nlon , Nt
      DIMENSION Sf(Isf,Jsf,Nt)
      DIMENSION Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt) , Sqnn(Nlat)
      DIMENSION A(Mab,Nlat,Nt) , B(Mab,Nlat,Nt)
      DIMENSION Wshses(Lshses) , Wk(Lwk)
!
!     preset coefficient multiplyers in vector
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = 1.0/SQRT(fn*(fn+1.))
      ENDDO
!
!     set upper limit for vector m subscript
!
      mmax = MIN0(Nlat,(Nlon+1)/2)
!
!     compute multiple scalar field coefficients
!
      DO k = 1 , Nt
!
!     preset to 0.0
!
         DO n = 1 , Nlat
            DO m = 1 , Mab
               A(m,n,k) = 0.0
               B(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            A(1,n,k) = Br(1,n,k)*Sqnn(n)
            B(1,n,k) = Bi(1,n,k)*Sqnn(n)
         ENDDO
!
!     compute m>0 coefficients
!
         DO m = 2 , mmax
            DO n = m , Nlat
               A(m,n,k) = Sqnn(n)*Br(m,n,k)
               B(m,n,k) = Sqnn(n)*Bi(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     scalar sythesize a,b into sf
!
      CALL SHSES(Nlat,Nlon,Isym,Nt,Sf,Isf,Jsf,A,B,Mab,Nlat,Wshses,      &
               & Lshses,Wk,Lwk,Ierror)
      END SUBROUTINE IGRDES1

      
      SUBROUTINE DIGRADES(Nlat,Nlon,Isym,Nt,Sf,Isf,Jsf,Br,Bi,Mdb,Ndb,    &
                       & Wshses,Lshses,Work,Lwork,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION Bi , Br , Sf , Work , Wshses
      INTEGER ia , ib , Ierror , imid , is , Isf , Isym , iwk , Jsf ,   &
            & liwk , lpimn , ls , Lshses , lwkmin , Lwork , mab , Mdb , &
            & mmax , mn , Ndb
      INTEGER Nlat , nln , Nlon , Nt
      DIMENSION Sf(Isf,Jsf,Nt)
      DIMENSION Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt)
      DIMENSION Wshses(Lshses) , Work(Lwork)
!
!     check input parameters
!
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Isym==0 .AND. Isf<Nlat) .OR. (Isym/=0 .AND. Isf<imid) )     &
         & RETURN
      Ierror = 6
      IF ( Jsf<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+2)/2)
      IF ( Mdb<MIN0(Nlat,(Nlon+1)/2) ) RETURN
      Ierror = 8
      IF ( Ndb<Nlat ) RETURN
      Ierror = 9
!
!     verify saved work space length
!
      imid = (Nlat+1)/2
      lpimn = (imid*mmax*(Nlat+Nlat-mmax+1))/2
      IF ( Lshses<lpimn+Nlon+15 ) RETURN
      Ierror = 10
!
!     set minimum and verify unsaved work space
!
      ls = Nlat
      IF ( Isym>0 ) ls = imid
      nln = Nt*ls*Nlon
!
!     set first dimension for a,b (as requried by shses)
!
      mab = MIN0(Nlat,Nlon/2+1)
      mn = mab*Nlat*Nt
      lwkmin = nln + ls*Nlon + 2*mn + Nlat
      IF ( Lwork<lwkmin ) RETURN
      Ierror = 0
!
!     set work space pointers
!
      ia = 1
      ib = ia + mn
      is = ib + mn
      iwk = is + Nlat
      liwk = Lwork - 2*mn - Nlat
      CALL DIGRDES1(Nlat,Nlon,Isym,Nt,Sf,Isf,Jsf,Work(ia),Work(ib),mab,  &
                 & Work(is),Mdb,Ndb,Br,Bi,Wshses,Lshses,Work(iwk),liwk, &
                 & Ierror)
    END SUBROUTINE DIGRADES

    
    SUBROUTINE DIGRDES1(Nlat,Nlon,Isym,Nt,Sf,Isf,Jsf,A,B,Mab,Sqnn,Mdb, &
                       & Ndb,Br,Bi,Wshses,Lshses,Wk,Lwk,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , Bi , Br , fn , Sf , Sqnn , Wk , Wshses
      INTEGER Ierror , Isf , Isym , Jsf , k , Lshses , Lwk , m , Mab ,  &
            & Mdb , mmax , n , Ndb , Nlat , Nlon , Nt
      DIMENSION Sf(Isf,Jsf,Nt)
      DIMENSION Br(Mdb,Ndb,Nt) , Bi(Mdb,Ndb,Nt) , Sqnn(Nlat)
      DIMENSION A(Mab,Nlat,Nt) , B(Mab,Nlat,Nt)
      DIMENSION Wshses(Lshses) , Wk(Lwk)
!
!     preset coefficient multiplyers in vector
!
      DO n = 2 , Nlat
         fn = FLOAT(n-1)
         Sqnn(n) = 1.0/SQRT(fn*(fn+1.))
      ENDDO
!
!     set upper limit for vector m subscript
!
      mmax = MIN0(Nlat,(Nlon+1)/2)
!
!     compute multiple scalar field coefficients
!
      DO k = 1 , Nt
!
!     preset to 0.0
!
         DO n = 1 , Nlat
            DO m = 1 , Mab
               A(m,n,k) = 0.0
               B(m,n,k) = 0.0
            ENDDO
         ENDDO
!
!     compute m=0 coefficients
!
         DO n = 2 , Nlat
            A(1,n,k) = Br(1,n,k)*Sqnn(n)
            B(1,n,k) = Bi(1,n,k)*Sqnn(n)
         ENDDO
!
!     compute m>0 coefficients
!
         DO m = 2 , mmax
            DO n = m , Nlat
               A(m,n,k) = Sqnn(n)*Br(m,n,k)
               B(m,n,k) = Sqnn(n)*Bi(m,n,k)
            ENDDO
         ENDDO
      ENDDO
!
!     scalar sythesize a,b into sf
!
      CALL DSHSES(Nlat,Nlon,Isym,Nt,Sf,Isf,Jsf,A,B,Mab,Nlat,Wshses,      &
               & Lshses,Wk,Lwk,Ierror)
      END SUBROUTINE DIGRDES1

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c ... file gradges.f
c
c     this file includes documentation and code for
c     subroutine grades         i
c
c ... files which must be loaded with gradges.f
c
c     sphcom.f, hrfft.f, shaes.f,vhses.f
c
c     subroutine grades(nlat,nlon,isym,nt,v,w,idvw,jdvw,a,b,mdab,ndab,
c    +                  wvhses,lvhses,work,lwork,ierror)
c
c     given the scalar spherical harmonic coefficients a and b, precomputed
c     by subroutine shaes for a scalar field sf, subroutine grades computes
c     an irrotational vector field (v,w) such that
c
c           gradient(sf) = (v,w).
c
c     v is the colatitudinal and w is the east longitudinal component
c     of the gradient.  i.e.,
c
c            v(i,j) = d(sf(i,j))/dtheta
c
c     and
c
c            w(i,j) = 1/sint*d(sf(i,j))/dlambda
c
c     at colatitude
c
c            theta(i) = (i-1)*pi/(nlat-1)
c
c     and longitude
c
c            lambda(j) = (j-1)*2*pi/nlon.
c
c     where sint = sin(theta(i)).  required associated legendre polynomials
c     are stored rather than recomputed as they are in subroutine gradec
c
c
c     input parameters
c
c
c     nlat   the number of colatitudes on the full sphere including the
c            poles. for example, nlat = 37 for a five degree grid.
c            nlat determines the grid increment in colatitude as
c            pi/(nlat-1).  if nlat is odd the equator is located at
c            grid point i=(nlat+1)/2. if nlat is even the equator is
c            located half way between points i=nlat/2 and i=nlat/2+1.
c            nlat must be at least 3. note: on the half sphere, the
c            number of grid points in the colatitudinal direction is
c            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct londitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater than
c            3.  the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c
c     isym   this has the same value as the isym that was input to
c            subroutine shaes to compute the arrays a and b from the
c            scalar field sf.  isym determines whether (v,w) are
c            computed on the full or half sphere as follows:
c
c      = 0
c
c           sf is not symmetric about the equator. in this case
c           the vector field (v,w) is computed on the entire sphere.
c           i.e., in the arrays  v(i,j),w(i,j) for i=1,...,nlat and
c           j=1,...,nlon.
c
c      = 1
c
c           sf is antisymmetric about the equator. in this case w is
c           antisymmetric and v is symmetric about the equator. w
c           and v are computed on the northern hemisphere only.  i.e.,
c           if nlat is odd they are computed for i=1,...,(nlat+1)/2
c           and j=1,...,nlon.  if nlat is even they are computed for
c           i=1,...,nlat/2 and j=1,...,nlon.
c
c      = 2
c
c           sf is symmetric about the equator. in this case w is
c           symmetric and v is antisymmetric about the equator. w
c           and v are computed on the northern hemisphere only.  i.e.,
c           if nlat is odd they are computed for i=1,...,(nlat+1)/2
c           and j=1,...,nlon.  if nlat is even they are computed for
c           i=1,...,nlat/2 and j=1,...,nlon.
c
c
c     nt     nt is the number of scalar and vector fields.  some
c            computational efficiency is obtained for multiple fields.
c            the arrays a,b,v, and w can be three dimensional corresponding
c            to an indexed multiple array sf.  in this case, multiple
c            vector synthesis will be performed to compute each vector
c            field.  the third index for a,b,v, and w is the synthesis
c            index which assumes the values k = 1,...,nt.  for a single
c            synthesis set nt = 1.  the description of the remaining
c            parameters is simplified by assuming that nt=1 or that a,b,v,
c            and w are two dimensional arrays.
c
c     idvw   the first dimension of the arrays v,w as it appears in
c            the program that calls grades. if isym = 0 then idvw
c            must be at least nlat.  if isym = 1 or 2 and nlat is
c            even then idvw must be at least nlat/2. if isym = 1 or 2
c            and nlat is odd then idvw must be at least (nlat+1)/2.
c
c     jdvw   the second dimension of the arrays v,w as it appears in
c            the program that calls grades. jdvw must be at least nlon.
c
c     a,b    two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
c            of the scalar field array sf as computed by subroutine shaes.
c     ***    a,b must be computed by shaes prior to calling grades.
c
c     mdab   the first dimension of the arrays a and b as it appears in
c            the program that calls grades (and shaes). mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c     ndab   the second dimension of the arrays a and b as it appears in
c            the program that calls grades (and shaes). ndab must be at
c            least nlat.
c
c
c   wvhses   an array which must be initialized by subroutine gradesi
c            (or equivalently by subroutine vhsesi).  once initialized,
c            wsav can be used repeatedly by grades as long as nlon
c            and nlat remain unchanged.  wvhses must not be altered
c            between calls of grades.
c
c
c  lvhses    the dimension of the array wvhses as it appears in the
c            program that calls grades. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd.
c
c            then lvhses must be greater than or equal to
c
c               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls grades. define
c
c               l1 = min0(nlat,nlon/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2                  if nlat is even or
c               l2 = (nlat+1)/2              if nlat is odd
c
c            if isym = 0, lwork must be greater than or equal to
c
c               nlat*((2*nt+1)*nlon+2*l1*nt+1).
c
c            if isym = 1 or 2, lwork must be greater than or equal to
c
c               (2*nt+1)*l2*nlon+nlat*(2*l1*nt+1).
c
c
c     **************************************************************
c
c     output parameters
c
c
c     v,w   two or three dimensional arrays (see input parameter nt) that
c           contain an irrotational vector field such that the gradient of
c           the scalar field sf is (v,w).  w(i,j) is the east longitude
c           component and v(i,j) is the colatitudinal component of velocity
c           at colatitude theta(i) = (i-1)*pi/(nlat-1) and longitude
c           lambda(j) = (j-1)*2*pi/nlon. the indices for v and w are defined
c           at the input parameter isym.  the vorticity of (v,w) is zero.
c           note that any nonzero vector field on the sphere will be
c           multiple valued at the poles [reference swarztrauber].
c
c
c  ierror   = 0  no errors
c           = 1  error in the specification of nlat
c           = 2  error in the specification of nlon
c           = 3  error in the specification of isym
c           = 4  error in the specification of nt
c           = 5  error in the specification of idvw
c           = 6  error in the specification of jdvw
c           = 7  error in the specification of mdab
c           = 8  error in the specification of ndab
c           = 9  error in the specification of lvhses
c           = 10 error in the specification of lwork
c **********************************************************************
c                                                                              
c   
      subroutine grades(nlat,nlon,isym,nt,v,w,idvw,jdvw,a,b,mdab,ndab,
     +wvhses,lvhses,work,lwork,ierror)
      dimension v(idvw,jdvw,nt),w(idvw,jdvw,nt)
      dimension a(mdab,ndab,nt),b(mdab,ndab,nt)
      dimension wvhses(lvhses),work(lwork)
c
c     check input parameters
c
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if(nlon .lt. 4) return
      ierror = 3
      if(isym.lt.0 .or. isym.gt.2) return
      ierror = 4
      if(nt .lt. 0) return
      ierror = 5
      imid = (nlat+1)/2
      if((isym.eq.0 .and. idvw.lt.nlat) .or.
     +   (isym.ne.0 .and. idvw.lt.imid)) return
      ierror = 6
      if(jdvw .lt. nlon) return
      ierror = 7
      mmax = min0(nlat,(nlon+1)/2)
      if(mdab .lt. min0(nlat,(nlon+2)/2)) return
      ierror = 8
      if(ndab .lt. nlat) return
      ierror = 9
c
c     verify minimum saved work space length
c
      idz = (mmax*(nlat+nlat-mmax+1))/2
      lzimn = idz*imid
      lgdmin = lzimn+lzimn+nlon+15
      if(lvhses .lt. lgdmin) return
      ierror = 10
c
c     verify minimum unsaved work space length
c
      mn = mmax*nlat*nt
      idv = nlat
      if (isym.ne.0) idv = imid
      lnl = nt*idv*nlon
      lwkmin =  lnl+lnl+idv*nlon+2*mn+nlat
      if (lwork .lt. lwkmin) return
      ierror = 0
c
c     set work space pointers
c
      ibr = 1
      ibi = ibr + mn
      is = ibi + mn
      iwk = is + nlat
      liwk = lwork-2*mn-nlat
      call grades1(nlat,nlon,isym,nt,v,w,idvw,jdvw,work(ibr),work(ibi),
     +mmax,work(is),mdab,ndab,a,b,wvhses,lvhses,work(iwk),liwk,
     +ierror)
      return
      end

      subroutine grades1(nlat,nlon,isym,nt,v,w,idvw,jdvw,br,bi,mmax,
     +sqnn,mdab,ndab,a,b,wvhses,lvhses,wk,lwk,ierror)
      dimension v(idvw,jdvw,nt),w(idvw,jdvw,nt)
      dimension br(mmax,nlat,nt),bi(mmax,nlat,nt),sqnn(nlat)
      dimension a(mdab,ndab,nt),b(mdab,ndab,nt)
      dimension wvhses(lvhses),wk(lwk)
c
c     preset coefficient multiplyers in vector
c
      do 1 n=2,nlat
      fn = float(n-1)
      sqnn(n) = sqrt(fn*(fn+1.))
    1 continue
c
c     compute multiple vector fields coefficients
c
      do 2 k=1,nt
c
c     preset br,bi to 0.0
c
      do 3 n=1,nlat
      do 4 m=1,mmax
      br(m,n,k) = 0.0
      bi(m,n,k) = 0.0
    4 continue
    3 continue
c
c     compute m=0 coefficients
c
      do 5 n=2,nlat
      br(1,n,k) = sqnn(n)*a(1,n,k)
      bi(1,n,k) = sqnn(n)*b(1,n,k)
    5 continue
c
c     compute m>0 coefficients
c
      do 6 m=2,mmax
      do 7 n=m,nlat
      br(m,n,k) = sqnn(n)*a(m,n,k)
      bi(m,n,k) = sqnn(n)*b(m,n,k)
    7 continue
    6 continue
    2 continue
c
c     set ityp for irrotational vector synthesis to compute gradient
c
      if (isym.eq.0) then
      ityp = 1
      else if (isym.eq.1) then
      ityp = 4
      else if (isym.eq.2) then
      ityp = 7
      end if
c
c     vector sythesize br,bi into (v,w) (cr,ci are dummy variables)
c
      call vhses(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
     +           mmax,nlat,wvhses,lvhses,wk,lwk,ierror)
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file vshifte.f contains code and documentation for subroutine vshifte
!     and its initialization subroutine vshifti
!
! ... required files
!
!     hrfft.f
!
!     subroutine vshifte(ioff,nlon,nlat,uoff,voff,ureg,vreg,
!    +                   wsave,lsave,work,lwork,ierror)
!
! *** purpose
!
!     subroutine vshifte does a highly accurate 1/2 grid increment shift
!     in both longitude and latitude of equally spaced vector data on the
!     sphere. data is transferred between the nlon by nlat "offset grid"
!     in (uoff,voff) (which excludes poles) and the nlon by nlat+1 "regular
!     grid" in (ureg,vreg) (which includes poles).  the transfer can go from
!     (uoff,voff) to (ureg,vreg) or vice versa (see ioff).  the grids which
!     underly the vector fields are described below.  the north and south
!     pole are at 0.5*pi and-0.5*pi radians respectively (pi=4.*atan(1.)).
!     uoff and ureg are the east longitudinal vector data components.  voff
!     and vreg are the latitudinal vector data components.
!
!     subroutine sshifte can be used to shift scalar data on the sphere.
!     notice that scalar and vector quantities are fundamentally different
!     on the sphere.  for example, vectors are discontinuous and multiple
!     valued at the poles.  scalars are continuous and single valued at the
!     poles. erroneous results would be produced if one attempted to shift
!     vector fields with subroutine sshifte applied to each component of
!     of the vector.
!
! *** grid descriptions
!
!     let dlon = (pi+pi)/nlon and dlat = pi/nlat be the uniform grid
!     increments in longitude and latitude
!
!     offset grid
!
!     the "1/2 increment offset" grid (long(j),lat(i)) on which uoff(j,i)
!     and voff(j,i) are given (ioff=0) or generated (ioff=1) is
!
!          long(j) =0.5*dlon + (j-1)*dlon  (j=1,...,nlon)
!
!     and
!
!          lat(i) = -0.5*pi + 0.5*dlat + (i-1)*dlat (i=1,...,nlat)
!
!     the data in (uoff,voff) is "shifted" one half a grid increment in both
!     longitude and latitude and excludes the poles.  each uoff(j,1),voff(j,1)
!     is given at latitude -pi/2+dlat/2.  uoff(j,nlat),voff(j,nlat) is
!     given at pi/2-dlat/2 (1/2 a grid increment away from the poles).
!     uoff(1,i),voff(1,i) is given at longitude dlon/2.  each uoff(nlon,i),
!     voff(nlon,i) is given at longitude 2*pi-dlon/2.
!
!     regular grid
!
!     let dlat,dlon be as above.  then the nlon by nlat+1 grid on which
!     ureg(j,i),vreg(j,i) are generated (ioff=0) or given (ioff=1) is
!
!          lone(j) = (j-1)*dlon (j=1,...,nlon)
!
!      and
!
!          late(i) = -0.5*pi + (i-1)*dlat (i=1,...,nlat+1)
!
!     values in ureg,vreg include the poles and start at zero degrees
!     longitude and at the south pole this is the "usual" equally spaced
!     grid in geophysical coordinates.
!
! *** remark
!
!     subroutine vshifte can be used in conjunction with subroutine trvsph
!     when transferring vector data from an equally spaced "1/2 increment
!     offset" grid to a gaussian or equally spaced grid (which includes poles)
!     of any resolution.  this problem (personal communication with dennis
!     shea) is encountered in geophysical modeling and data analysis.
!
! *** method
!
!     fast fourier transform software from spherepack2 and trigonometric
!     identities are used to accurately "shift" periodic vectors half a
!     grid increment in latitude and longitude.  latitudinal shifts are
!     accomplished by setting periodic 2*nlat vectors over the pole for each
!     longitude.  vector values must be negated on one side of the pole
!     to maintain periodicity prior to the 2*nlat shift over the poles.
!     when nlon is odd, the 2*nlat latitudinal shift requires an additional
!     longitude shift to obtain symmetry necessary for full circle shifts
!     over the poles.  finally longitudinal shifts are executed for each
!     shifted latitude.
!
! *** argument description
!
! ... ioff
!
!     ioff = 0 if values on the offset grid in (uoff,voff) are given and
!              values on the regular grid in (ureg,vreg) are to be generated.
!
!     ioff = 1 if values on the regular grid in (ureg,vreg) are given and
!              values on the offset grid in (uoff,voff) are to be generated.
!
! ... nlon
!
!     the number of longitude points on both the "offset" and "regular"
!     uniform grid in longitude (see "grid description" above).  nlon
!     is also the first dimension of uoff,voff,ureg,vreg.  nlon determines
!     the grid increment in longitude as dlon = 2.*pi/nlon.  for example,
!     nlon = 144 for a 2.5 degree grid.  nlon can be even or odd and must
!     be greater than or equal to 4.  the efficiency of the computation
!     is improved when nlon is a product of small primes.
!
! ... nlat
!
!     the number of latitude points on the "offset" uniform grid.  nlat+1
!     is the number of latitude points on the "regular" uniform grid (see
!     "grid description" above).  nlat is the second dimension of uoff,voff.
!     nlat+1 must be the second dimension of ureg,vreg in the program
!     calling vshifte.  nlat determines the grid in latitude as pi/nlat.
!     for example, nlat = 36 for a five degree grid.  nlat must be at least 3.
!
! ... uoff
!
!     a nlon by nlat array that contains the east longitudinal vector
!     data component on the offset grid described above.  uoff is a
!     given input argument if ioff=0.  uoff is a generated output
!     argument if ioff=1.
!
! ... voff
!
!     a nlon by nlat array that contains the latitudinal vector data
!     component on the offset grid described above.  voff is a given
!     input argument if ioff=0.  voff is a generated output argument
!     if ioff=1.
!
! ... ureg
!
!     a nlon by nlat+1 array that contains the east longitudinal vector
!     data component on the regular grid described above.  ureg is a given
!     input argument if ioff=1.  ureg is a generated output argument
!     if ioff=0.
!
! ... vreg
!
!     a nlon by nlat+1 array that contains the latitudinal vector data
!     component on the regular grid described above.  vreg is a given
!     input argument if ioff=1.  vreg is a generated output argument
!     if ioff=0.
!
! ... wsav
!
!     a real saved work space array that must be initialized by calling
!     subroutine vshifti(ioff,nlon,nlat,wsav,ier) before calling vshifte.
!     wsav can then be used repeatedly by vshifte as long as ioff, nlon,
!     and nlat do not change.  this bypasses redundant computations and
!     saves time.  undetectable errors will result if vshifte is called
!     without initializing wsav whenever ioff, nlon, or nlat change.
!
! ... lsav
!
!     the length of the saved work space wsav in the routine calling vshifte
!     and sshifti.  lsave must be greater than or equal to 2*(2*nlat+nlon+16).
!
! ... work
!
!     a real unsaved work space
!
! ... lwork
!
!     the length of the unsaved work space in the routine calling vshifte
!     if nlon is even then lwork must be greater than or equal to
!
!          2*nlon*(nlat+1)
!
!     if nlon is odd then lwork must be greater than or equal to
!
!          nlon*(5*nlat+1)
!
! ... ier
!
!     indicates errors in input parameters
!
!     = 0 if no errors are detected
!
!     = 1 if ioff is not equal to 0 or 1
!
!     = 2 if nlon < 4
!
!     = 3 if nlat < 3
!
!     = 4 if lsave < 2*(nlon+2*nlat)+32
!
!     = 5 if lwork < 2*nlon*(nlat+1) for nlon even or
!            lwork < nlon*(5*nlat+1) for nlon odd
!
! *** end of vshifte documentation
!
!     subroutine vshifti(ioff,nlon,nlat,lsav,wsav,ier)
!
!     subroutine vshifti initializes the saved work space wsav
!     for ioff and nlon and nlat (see documentation for vshifte).
!     vshifti must be called before vshifte whenever ioff or nlon
!     or nlat change.
!
! ... ier
!
!     = 0 if no errors with input arguments
!
!     = 1 if ioff is not 0 or 1
!
!     = 2 if nlon < 4
!
!     = 3 if nlat < 3
!
!     = 4 if lsav < 2*(2*nlat+nlon+16)
!
! *** end of vshifti documentation
!
      SUBROUTINE VSHIFTE(Ioff,Nlon,Nlat,Uoff,Voff,Ureg,Vreg,Wsav,Lsav,  &
                       & Wrk,Lwrk,Ier)
      IMPLICIT NONE
!*--VSHIFTE237
      INTEGER Ioff , Nlon , Nlat , n2 , nr , nlat2 , nlatp1 , Lsav ,    &
            & Lwrk , Ier
      INTEGER i1 , i2 , i3
      REAL Uoff(Nlon,Nlat) , Voff(Nlon,Nlat)
      REAL Ureg(Nlon,*) , Vreg(Nlon,*)
      REAL Wsav(Lsav) , Wrk(Lwrk)
!
!     check input parameters
!
      Ier = 1
      IF ( Ioff*(Ioff-1)/=0 ) RETURN
      Ier = 2
      IF ( Nlon<4 ) RETURN
      Ier = 3
      IF ( Nlat<3 ) RETURN
      Ier = 4
      IF ( Lsav<2*(2*Nlat+Nlon+16) ) RETURN
      nlat2 = Nlat + Nlat
      nlatp1 = Nlat + 1
      n2 = (Nlon+1)/2
      Ier = 5
      IF ( 2*n2==Nlon ) THEN
         IF ( Lwrk<2*Nlon*(Nlat+1) ) RETURN
         nr = n2
         i1 = 1
         i2 = 1
         i3 = i2 + Nlon*nlatp1
      ELSE
         IF ( Lwrk<Nlon*(5*Nlat+1) ) RETURN
         nr = Nlon
         i1 = 1
         i2 = i1 + nlat2*Nlon
         i3 = i2 + nlatp1*Nlon
      ENDIF
      Ier = 0
      IF ( Ioff==0 ) THEN
!
!     shift (uoff,voff) to (ureg,vreg)
!
         CALL VHFTOFF(Nlon,Nlat,Uoff,Ureg,Wsav,nr,nlat2,nlatp1,Wrk(i1), &
                    & Wrk(i2),Wrk(i2),Wrk(i3))
         CALL VHFTOFF(Nlon,Nlat,Voff,Vreg,Wsav,nr,nlat2,nlatp1,Wrk(i1), &
                    & Wrk(i2),Wrk(i2),Wrk(i3))
      ELSE
!
!     shift (ureg,vreg) to (uoff,voff)
!
         CALL VHFTREG(Nlon,Nlat,Uoff,Ureg,Wsav,nr,nlat2,nlatp1,Wrk(i1), &
                    & Wrk(i2),Wrk(i2),Wrk(i3))
         CALL VHFTREG(Nlon,Nlat,Voff,Vreg,Wsav,nr,nlat2,nlatp1,Wrk(i1), &
                    & Wrk(i2),Wrk(i2),Wrk(i3))
      ENDIF
      END SUBROUTINE VSHIFTE

      
      SUBROUTINE VHFTOFF(Nlon,Nlat,Uoff,Ureg,Wsav,Nr,Nlat2,Nlatp1,Rlatu,&
                       & Rlonu,Rlou,Wrk)
!
!     generate ureg from uoff (a vector component!)
!
      IMPLICIT NONE
!*--VHFTOFF299
      INTEGER Nlon , Nlat , Nlat2 , Nlatp1 , n2 , Nr , j , i , js , isav
      REAL Uoff(Nlon,Nlat) , Ureg(Nlon,Nlatp1)
      REAL Rlatu(Nr,Nlat2) , Rlonu(Nlatp1,Nlon) , Rlou(Nlat,Nlon)
      REAL Wsav(*) , Wrk(*)
      isav = 4*Nlat + 17
      n2 = (Nlon+1)/2
!
!     execute full circle latitude shifts for nlon odd or even
!
      IF ( 2*n2>Nlon ) THEN
!
!     odd number of longitudes
!
         DO i = 1 , Nlat
            DO j = 1 , Nlon
               Rlou(i,j) = Uoff(j,i)
            ENDDO
         ENDDO
!
!       half shift in longitude
!
         CALL VHIFTH(Nlat,Nlon,Rlou,Wsav(isav),Wrk)
!
!       set full 2*nlat circles in rlatu using shifted values in rlonu
!
         DO j = 1 , n2 - 1
            js = j + n2
            DO i = 1 , Nlat
               Rlatu(j,i) = Uoff(j,i)
               Rlatu(j,Nlat+i) = -Rlou(Nlat+1-i,js)
            ENDDO
         ENDDO
         DO j = n2 , Nlon
            js = j - n2 + 1
            DO i = 1 , Nlat
               Rlatu(j,i) = Uoff(j,i)
               Rlatu(j,Nlat+i) = -Rlou(Nlat+1-i,js)
            ENDDO
         ENDDO
!
!       shift the nlon rlat vectors one half latitude grid
!
         CALL VHIFTH(Nlon,Nlat2,Rlatu,Wsav,Wrk)
!
!       set in ureg
!
         DO j = 1 , Nlon
            DO i = 1 , Nlat + 1
               Ureg(j,i) = Rlatu(j,i)
            ENDDO
         ENDDO
      ELSE
!
!     even number of longitudes (no initial longitude shift necessary)
!     set full 2*nlat circles (over poles) for each longitude pair (j,js)
!     negating js vector side for periodicity
!
         DO j = 1 , n2
            js = n2 + j
            DO i = 1 , Nlat
               Rlatu(j,i) = Uoff(j,i)
               Rlatu(j,Nlat+i) = -Uoff(js,Nlatp1-i)
            ENDDO
         ENDDO
!
!       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
!
         CALL VHIFTH(n2,Nlat2,Rlatu,Wsav,Wrk)
!
!       set ureg,vreg shifted in latitude
!
         DO j = 1 , n2
            js = n2 + j
            Ureg(j,1) = Rlatu(j,1)
            Ureg(js,1) = -Rlatu(j,1)
            DO i = 2 , Nlatp1
               Ureg(j,i) = Rlatu(j,i)
               Ureg(js,i) = -Rlatu(j,Nlat2-i+2)
            ENDDO
         ENDDO
      ENDIF
!
!     execute full circle longitude shift
!
      DO j = 1 , Nlon
         DO i = 1 , Nlatp1
            Rlonu(i,j) = Ureg(j,i)
         ENDDO
      ENDDO
      CALL VHIFTH(Nlatp1,Nlon,Rlonu,Wsav(isav),Wrk)
      DO j = 1 , Nlon
         DO i = 1 , Nlatp1
            Ureg(j,i) = Rlonu(i,j)
         ENDDO
      ENDDO
      END SUBROUTINE VHFTOFF
      
 
      SUBROUTINE VHFTREG(Nlon,Nlat,Uoff,Ureg,Wsav,Nr,Nlat2,Nlatp1,Rlatu,&
                       & Rlonu,Rlou,Wrk)
!
!     generate uoff vector component from ureg
!
      IMPLICIT NONE
      INTEGER Nlon , Nlat , Nlat2 , Nlatp1 , n2 , Nr , j , i , js , isav
      REAL Uoff(Nlon,Nlat) , Ureg(Nlon,Nlatp1)
      REAL Rlatu(Nr,Nlat2) , Rlonu(Nlatp1,Nlon) , Rlou(Nlat,Nlon)
      REAL Wsav(*) , Wrk(*)
      isav = 4*Nlat + 17
      n2 = (Nlon+1)/2
!
!     execute full circle latitude shifts for nlon odd or even
!
      IF ( 2*n2>Nlon ) THEN
!
!     odd number of longitudes
!
         DO i = 1 , Nlatp1
            DO j = 1 , Nlon
               Rlonu(i,j) = Ureg(j,i)
            ENDDO
         ENDDO
!
!       half shift in longitude in rlon
!
         CALL VHIFTH(Nlatp1,Nlon,Rlonu,Wsav(isav),Wrk)
!
!       set full 2*nlat circles in rlat using shifted values in rlon
!
         DO j = 1 , n2
            js = j + n2 - 1
            Rlatu(j,1) = Ureg(j,1)
            DO i = 2 , Nlat
               Rlatu(j,i) = Ureg(j,i)
               Rlatu(j,Nlat+i) = -Rlonu(Nlat+2-i,js)
            ENDDO
            Rlatu(j,Nlat+1) = Ureg(j,Nlat+1)
         ENDDO
         DO j = n2 + 1 , Nlon
            js = j - n2
            Rlatu(j,1) = Ureg(j,1)
            DO i = 2 , Nlat
               Rlatu(j,i) = Ureg(j,i)
               Rlatu(j,Nlat+i) = -Rlonu(Nlat+2-i,js)
            ENDDO
            Rlatu(j,Nlat+1) = Ureg(j,Nlat+1)
         ENDDO
!
!       shift the nlon rlat vectors one halflatitude grid
!
         CALL VHIFTH(Nlon,Nlat2,Rlatu,Wsav,Wrk)
!
!       set values in uoff
!
         DO j = 1 , Nlon
            DO i = 1 , Nlat
               Uoff(j,i) = Rlatu(j,i)
            ENDDO
         ENDDO
      ELSE
!
!     even number of longitudes (no initial longitude shift necessary)
!     set full 2*nlat circles (over poles) for each longitude pair (j,js)
!
         DO j = 1 , n2
            js = n2 + j
            Rlatu(j,1) = Ureg(j,1)
            DO i = 2 , Nlat
               Rlatu(j,i) = Ureg(j,i)
               Rlatu(j,Nlat+i) = -Ureg(js,Nlat+2-i)
            ENDDO
            Rlatu(j,Nlat+1) = Ureg(j,Nlat+1)
         ENDDO
!
!       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
!
         CALL VHIFTH(n2,Nlat2,Rlatu,Wsav,Wrk)
!
!       set values in uoff
!
         DO j = 1 , n2
            js = n2 + j
            DO i = 1 , Nlat
               Uoff(j,i) = Rlatu(j,i)
               Uoff(js,i) = -Rlatu(j,Nlat2+1-i)
            ENDDO
         ENDDO
      ENDIF
!
!     execute full circle longitude shift for all latitude circles
!
      DO j = 1 , Nlon
         DO i = 1 , Nlat
            Rlou(i,j) = Uoff(j,i)
         ENDDO
      ENDDO
      CALL VHIFTH(Nlat,Nlon,Rlou,Wsav(isav),Wrk)
      DO j = 1 , Nlon
         DO i = 1 , Nlat
            Uoff(j,i) = Rlou(i,j)
         ENDDO
      ENDDO
      END SUBROUTINE VHFTREG
 

      SUBROUTINE VSHIFTI(Ioff,Nlon,Nlat,Lsav,Wsav,Ier)
      IMPLICIT NONE
      INTEGER Lsav
!
!     initialize wsav for vshifte
!
      INTEGER Ioff , Nlat , Nlon , nlat2 , isav , Ier
      REAL Wsav(Lsav)
      REAL pi , dlat , dlon , dp
      Ier = 1
      IF ( Ioff*(Ioff-1)/=0 ) RETURN
      Ier = 2
      IF ( Nlon<4 ) RETURN
      Ier = 3
      IF ( Nlat<3 ) RETURN
      Ier = 4
      IF ( Lsav<2*(2*Nlat+Nlon+16) ) RETURN
      Ier = 0
      pi = 4.0*ATAN(1.0)
!
!     set lat,long increments
!
      dlat = pi/Nlat
      dlon = (pi+pi)/Nlon
!
!     set left or right latitude shifts
!
      IF ( Ioff==0 ) THEN
         dp = -0.5*dlat
      ELSE
         dp = 0.5*dlat
      ENDIF
      nlat2 = Nlat + Nlat
      CALL VHIFTHI(nlat2,dp,Wsav)
!
!     set left or right longitude shifts
!
      IF ( Ioff==0 ) THEN
         dp = -0.5*dlon
      ELSE
         dp = 0.5*dlon
      ENDIF
      isav = 4*Nlat + 17
      CALL VHIFTHI(Nlon,dp,Wsav(isav))
      END

      
      SUBROUTINE VHIFTH(M,N,R,Wsav,Work)
      IMPLICIT NONE
      INTEGER M , N , n2 , k , l
      REAL R(M,N) , Wsav(*) , Work(*) , r2km2 , r2km1
      n2 = (N+1)/2
!
!     compute fourier coefficients for r on shifted grid
!
      CALL HRFFTF(M,N,R,M,Wsav(N+2),Work)
      DO l = 1 , M
         DO k = 2 , n2
            r2km2 = R(l,k+k-2)
            r2km1 = R(l,k+k-1)
            R(l,k+k-2) = r2km2*Wsav(n2+k) - r2km1*Wsav(k)
            R(l,k+k-1) = r2km2*Wsav(k) + r2km1*Wsav(n2+k)
         ENDDO
      ENDDO
!
!     shift r with fourier synthesis and normalization
!
      CALL HRFFTB(M,N,R,M,Wsav(N+2),Work)
      DO l = 1 , M
         DO k = 1 , N
            R(l,k) = R(l,k)/N
         ENDDO
      ENDDO
      END SUBROUTINE VHIFTH

      
      SUBROUTINE VHIFTHI(N,Dp,Wsav)
!
!     initialize wsav for subroutine vhifth
!
      IMPLICIT NONE
!*--VHIFTHI591
      INTEGER N , n2 , k
      REAL Wsav(*) , Dp
      n2 = (N+1)/2
      DO k = 2 , n2
         Wsav(k) = SIN((k-1)*Dp)
         Wsav(k+n2) = COS((k-1)*Dp)
      ENDDO
      CALL HRFFTI(N,Wsav(N+2))
      END SUBROUTINE VHIFTHI


      SUBROUTINE DVSHIFTE(Ioff,Nlon,Nlat,Uoff,Voff,Ureg,Vreg,Wsav,Lsav,  &
                       & Wrk,Lwrk,Ier)
      IMPLICIT NONE
      INTEGER Ioff , Nlon , Nlat , n2 , nr , nlat2 , nlatp1 , Lsav ,    &
            & Lwrk , Ier
      INTEGER i1 , i2 , i3
      DOUBLE PRECISION Uoff(Nlon,Nlat) , Voff(Nlon,Nlat)
      DOUBLE PRECISION Ureg(Nlon,*) , Vreg(Nlon,*)
      DOUBLE PRECISION Wsav(Lsav) , Wrk(Lwrk)
!
!     check input parameters
!
      Ier = 1
      IF ( Ioff*(Ioff-1)/=0 ) RETURN
      Ier = 2
      IF ( Nlon<4 ) RETURN
      Ier = 3
      IF ( Nlat<3 ) RETURN
      Ier = 4
      IF ( Lsav<2*(2*Nlat+Nlon+16) ) RETURN
      nlat2 = Nlat + Nlat
      nlatp1 = Nlat + 1
      n2 = (Nlon+1)/2
      Ier = 5
      IF ( 2*n2==Nlon ) THEN
         IF ( Lwrk<2*Nlon*(Nlat+1) ) RETURN
         nr = n2
         i1 = 1
         i2 = 1
         i3 = i2 + Nlon*nlatp1
      ELSE
         IF ( Lwrk<Nlon*(5*Nlat+1) ) RETURN
         nr = Nlon
         i1 = 1
         i2 = i1 + nlat2*Nlon
         i3 = i2 + nlatp1*Nlon
      ENDIF
      Ier = 0
      IF ( Ioff==0 ) THEN
!
!     shift (uoff,voff) to (ureg,vreg)
!
         CALL DVHFTOFF(Nlon,Nlat,Uoff,Ureg,Wsav,nr,nlat2,nlatp1,Wrk(i1), &
                    & Wrk(i2),Wrk(i2),Wrk(i3))
         CALL DVHFTOFF(Nlon,Nlat,Voff,Vreg,Wsav,nr,nlat2,nlatp1,Wrk(i1), &
                    & Wrk(i2),Wrk(i2),Wrk(i3))
      ELSE
!
!     shift (ureg,vreg) to (uoff,voff)
!
         CALL DVHFTREG(Nlon,Nlat,Uoff,Ureg,Wsav,nr,nlat2,nlatp1,Wrk(i1), &
                    & Wrk(i2),Wrk(i2),Wrk(i3))
         CALL DVHFTREG(Nlon,Nlat,Voff,Vreg,Wsav,nr,nlat2,nlatp1,Wrk(i1), &
                    & Wrk(i2),Wrk(i2),Wrk(i3))
      ENDIF
      END SUBROUTINE DVSHIFTE

      
      SUBROUTINE DVHFTOFF(Nlon,Nlat,Uoff,Ureg,Wsav,Nr,Nlat2,Nlatp1,Rlatu,&
                       & Rlonu,Rlou,Wrk)
!
!     generate ureg from uoff (a vector component!)
!
      IMPLICIT NONE
      INTEGER Nlon , Nlat , Nlat2 , Nlatp1 , n2 , Nr , j , i , js , isav
      DOUBLE PRECISION Uoff(Nlon,Nlat) , Ureg(Nlon,Nlatp1)
      DOUBLE PRECISION Rlatu(Nr,Nlat2) , Rlonu(Nlatp1,Nlon) , Rlou(Nlat,Nlon)
      DOUBLE PRECISION Wsav(*) , Wrk(*)
      isav = 4*Nlat + 17
      n2 = (Nlon+1)/2
!
!     execute full circle latitude shifts for nlon odd or even
!
      IF ( 2*n2>Nlon ) THEN
!
!     odd number of longitudes
!
         DO i = 1 , Nlat
            DO j = 1 , Nlon
               Rlou(i,j) = Uoff(j,i)
            ENDDO
         ENDDO
!
!       half shift in longitude
!
         CALL DVHIFTH(Nlat,Nlon,Rlou,Wsav(isav),Wrk)
!
!       set full 2*nlat circles in rlatu using shifted values in rlonu
!
         DO j = 1 , n2 - 1
            js = j + n2
            DO i = 1 , Nlat
               Rlatu(j,i) = Uoff(j,i)
               Rlatu(j,Nlat+i) = -Rlou(Nlat+1-i,js)
            ENDDO
         ENDDO
         DO j = n2 , Nlon
            js = j - n2 + 1
            DO i = 1 , Nlat
               Rlatu(j,i) = Uoff(j,i)
               Rlatu(j,Nlat+i) = -Rlou(Nlat+1-i,js)
            ENDDO
         ENDDO
!
!       shift the nlon rlat vectors one half latitude grid
!
         CALL DVHIFTH(Nlon,Nlat2,Rlatu,Wsav,Wrk)
!
!       set in ureg
!
         DO j = 1 , Nlon
            DO i = 1 , Nlat + 1
               Ureg(j,i) = Rlatu(j,i)
            ENDDO
         ENDDO
      ELSE
!
!     even number of longitudes (no initial longitude shift necessary)
!     set full 2*nlat circles (over poles) for each longitude pair (j,js)
!     negating js vector side for periodicity
!
         DO j = 1 , n2
            js = n2 + j
            DO i = 1 , Nlat
               Rlatu(j,i) = Uoff(j,i)
               Rlatu(j,Nlat+i) = -Uoff(js,Nlatp1-i)
            ENDDO
         ENDDO
!
!       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
!
         CALL DVHIFTH(n2,Nlat2,Rlatu,Wsav,Wrk)
!
!       set ureg,vreg shifted in latitude
!
         DO j = 1 , n2
            js = n2 + j
            Ureg(j,1) = Rlatu(j,1)
            Ureg(js,1) = -Rlatu(j,1)
            DO i = 2 , Nlatp1
               Ureg(j,i) = Rlatu(j,i)
               Ureg(js,i) = -Rlatu(j,Nlat2-i+2)
            ENDDO
         ENDDO
      ENDIF
!
!     execute full circle longitude shift
!
      DO j = 1 , Nlon
         DO i = 1 , Nlatp1
            Rlonu(i,j) = Ureg(j,i)
         ENDDO
      ENDDO
      CALL DVHIFTH(Nlatp1,Nlon,Rlonu,Wsav(isav),Wrk)
      DO j = 1 , Nlon
         DO i = 1 , Nlatp1
            Ureg(j,i) = Rlonu(i,j)
         ENDDO
      ENDDO
      END SUBROUTINE DVHFTOFF
      
 
      SUBROUTINE DVHFTREG(Nlon,Nlat,Uoff,Ureg,Wsav,Nr,Nlat2,Nlatp1,Rlatu,&
                       & Rlonu,Rlou,Wrk)
!
!     generate uoff vector component from ureg
!
      IMPLICIT NONE
      INTEGER Nlon , Nlat , Nlat2 , Nlatp1 , n2 , Nr , j , i , js , isav
      DOUBLE PRECISION Uoff(Nlon,Nlat) , Ureg(Nlon,Nlatp1)
      DOUBLE PRECISION Rlatu(Nr,Nlat2) , Rlonu(Nlatp1,Nlon) , Rlou(Nlat,Nlon)
      DOUBLE PRECISION Wsav(*) , Wrk(*)
      isav = 4*Nlat + 17
      n2 = (Nlon+1)/2
!
!     execute full circle latitude shifts for nlon odd or even
!
      IF ( 2*n2>Nlon ) THEN
!
!     odd number of longitudes
!
         DO i = 1 , Nlatp1
            DO j = 1 , Nlon
               Rlonu(i,j) = Ureg(j,i)
            ENDDO
         ENDDO
!
!       half shift in longitude in rlon
!
         CALL DVHIFTH(Nlatp1,Nlon,Rlonu,Wsav(isav),Wrk)
!
!       set full 2*nlat circles in rlat using shifted values in rlon
!
         DO j = 1 , n2
            js = j + n2 - 1
            Rlatu(j,1) = Ureg(j,1)
            DO i = 2 , Nlat
               Rlatu(j,i) = Ureg(j,i)
               Rlatu(j,Nlat+i) = -Rlonu(Nlat+2-i,js)
            ENDDO
            Rlatu(j,Nlat+1) = Ureg(j,Nlat+1)
         ENDDO
         DO j = n2 + 1 , Nlon
            js = j - n2
            Rlatu(j,1) = Ureg(j,1)
            DO i = 2 , Nlat
               Rlatu(j,i) = Ureg(j,i)
               Rlatu(j,Nlat+i) = -Rlonu(Nlat+2-i,js)
            ENDDO
            Rlatu(j,Nlat+1) = Ureg(j,Nlat+1)
         ENDDO
!
!       shift the nlon rlat vectors one halflatitude grid
!
         CALL DVHIFTH(Nlon,Nlat2,Rlatu,Wsav,Wrk)
!
!       set values in uoff
!
         DO j = 1 , Nlon
            DO i = 1 , Nlat
               Uoff(j,i) = Rlatu(j,i)
            ENDDO
         ENDDO
      ELSE
!
!     even number of longitudes (no initial longitude shift necessary)
!     set full 2*nlat circles (over poles) for each longitude pair (j,js)
!
         DO j = 1 , n2
            js = n2 + j
            Rlatu(j,1) = Ureg(j,1)
            DO i = 2 , Nlat
               Rlatu(j,i) = Ureg(j,i)
               Rlatu(j,Nlat+i) = -Ureg(js,Nlat+2-i)
            ENDDO
            Rlatu(j,Nlat+1) = Ureg(j,Nlat+1)
         ENDDO
!
!       shift the n2=(nlon+1)/2 rlat vectors one half latitude grid
!
         CALL DVHIFTH(n2,Nlat2,Rlatu,Wsav,Wrk)
!
!       set values in uoff
!
         DO j = 1 , n2
            js = n2 + j
            DO i = 1 , Nlat
               Uoff(j,i) = Rlatu(j,i)
               Uoff(js,i) = -Rlatu(j,Nlat2+1-i)
            ENDDO
         ENDDO
      ENDIF
!
!     execute full circle longitude shift for all latitude circles
!
      DO j = 1 , Nlon
         DO i = 1 , Nlat
            Rlou(i,j) = Uoff(j,i)
         ENDDO
      ENDDO
      CALL DVHIFTH(Nlat,Nlon,Rlou,Wsav(isav),Wrk)
      DO j = 1 , Nlon
         DO i = 1 , Nlat
            Uoff(j,i) = Rlou(i,j)
         ENDDO
      ENDDO
      END SUBROUTINE DVHFTREG
 

      SUBROUTINE DVSHIFTI(Ioff,Nlon,Nlat,Lsav,Wsav,Ier)
      IMPLICIT NONE
      INTEGER Lsav
!
!     initialize wsav for vshifte
!
      INTEGER Ioff , Nlat , Nlon , nlat2 , isav , Ier
      DOUBLE PRECISION Wsav(Lsav)
      DOUBLE PRECISION pi , dlat , dlon , dp
      Ier = 1
      IF ( Ioff*(Ioff-1)/=0 ) RETURN
      Ier = 2
      IF ( Nlon<4 ) RETURN
      Ier = 3
      IF ( Nlat<3 ) RETURN
      Ier = 4
      IF ( Lsav<2*(2*Nlat+Nlon+16) ) RETURN
      Ier = 0
      pi = 4.0*ATAN(1.0)
!
!     set lat,long increments
!
      dlat = pi/Nlat
      dlon = (pi+pi)/Nlon
!
!     set left or right latitude shifts
!
      IF ( Ioff==0 ) THEN
         dp = -0.5*dlat
      ELSE
         dp = 0.5*dlat
      ENDIF
      nlat2 = Nlat + Nlat
      CALL DVHIFTHI(nlat2,dp,Wsav)
!
!     set left or right longitude shifts
!
      IF ( Ioff==0 ) THEN
         dp = -0.5*dlon
      ELSE
         dp = 0.5*dlon
      ENDIF
      isav = 4*Nlat + 17
      CALL DVHIFTHI(Nlon,dp,Wsav(isav))
      END

      
      SUBROUTINE DVHIFTH(M,N,R,Wsav,Work)
      IMPLICIT NONE
      INTEGER M , N , n2 , k , l
      DOUBLE PRECISION R(M,N) , Wsav(*) , Work(*) , r2km2 , r2km1
      n2 = (N+1)/2
!
!     compute fourier coefficients for r on shifted grid
!
      CALL DHRFFTF(M,N,R,M,Wsav(N+2),Work)
      DO l = 1 , M
         DO k = 2 , n2
            r2km2 = R(l,k+k-2)
            r2km1 = R(l,k+k-1)
            R(l,k+k-2) = r2km2*Wsav(n2+k) - r2km1*Wsav(k)
            R(l,k+k-1) = r2km2*Wsav(k) + r2km1*Wsav(n2+k)
         ENDDO
      ENDDO
!
!     shift r with fourier synthesis and normalization
!
      CALL DHRFFTB(M,N,R,M,Wsav(N+2),Work)
      DO l = 1 , M
         DO k = 1 , N
            R(l,k) = R(l,k)/N
         ENDDO
      ENDDO
      END SUBROUTINE DVHIFTH

      
      SUBROUTINE DVHIFTHI(N,Dp,Wsav)
!
!     initialize wsav for subroutine vhifth
!
      IMPLICIT NONE
      INTEGER N , n2 , k
      DOUBLE PRECISION Wsav(*) , Dp
      n2 = (N+1)/2
      DO k = 2 , n2
         Wsav(k) = SIN((k-1)*Dp)
         Wsav(k+n2) = COS((k-1)*Dp)
      ENDDO
      CALL DHRFFTI(N,Wsav(N+2))
      END SUBROUTINE DVHIFTHI

c
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c  .                                                             .
c  .                  copyright (c) 1998 by UCAR                 .
c  .                                                             .
c  .       University Corporation for Atmospheric Research       .
c  .                                                             .
c  .                      all rights reserved                    .
c  .                                                             .
c  .                                                             .
c  .                         SPHEREPACK3.0                       .
c  .                                                             .
c  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
c
c
c
c
c ... file slapgc.f
c
c     this file includes documentation and code for
c     subroutine slapgc          i
c
c ... files which must be loaded with slapec.f
c
c     sphcom.f, hrfft.f, shagc.f, shsgc.f
c
c
c
c     subroutine slapgc(nlat,nlon,isym,nt,slap,ids,jds,a,b,
c    +mdab,ndab,wshsgc,lshsgc,work,lwork,ierror)
c
c
c     given the scalar spherical harmonic coefficients a and b, precomputed
c     by subroutine shagc for a scalar field sf, subroutine slapgc computes
c     the laplacian of sf in the scalar array slap.  slap(i,j) is the
c     laplacian of sf at the gaussian colatitude theta(i) (see nlat as
c     an input parameter) and east longitude lambda(j) = (j-1)*2*pi/nlon
c     on the sphere.  i.e.
c
c         slap(i,j) =
c
c                  2                2
c         [1/sint*d (sf(i,j)/dlambda + d(sint*d(sf(i,j))/dtheta)/dtheta]/sint
c
c
c     where sint = sin(theta(i)).  the scalar laplacian in slap has the
c     same symmetry or absence of symmetry about the equator as the scalar
c     field sf.  the input parameters isym,nt,mdab,ndab must have the
c     same values used by shagc to compute a and b for sf. the associated
c     legendre functions are stored rather than recomputed as they are
c     in subroutine slapgc.
c
c     input parameters
c
c     nlat   the number of points in the gaussian colatitude grid on the
c            full sphere. these lie in the interval (0,pi) and are computed
c            in radians in theta(1) <...< theta(nlat) by subroutine gaqd.
c            if nlat is odd the equator will be included as the grid point
c            theta((nlat+1)/2).  if nlat is even the equator will be
c            excluded as a grid point and will lie half way between
c            theta(nlat/2) and theta(nlat/2+1). nlat must be at least 3.
c            note: on the half sphere, the number of grid points in the
c            colatitudinal direction is nlat/2 if nlat is even or
c            (nlat+1)/2 if nlat is odd.
c
c     nlon   the number of distinct longitude points.  nlon determines
c            the grid increment in longitude as 2*pi/nlon. for example
c            nlon = 72 for a five degree grid. nlon must be greater
c            than zero. the axisymmetric case corresponds to nlon=1.
c            the efficiency of the computation is improved when nlon
c            is a product of small prime numbers.
c
c     isym   this parameter should have the same value input to subroutine
c            shagc to compute the coefficients a and b for the scalar field
c            sf.  isym is set as follows:
c
c            = 0  no symmetries exist in sf about the equator. scalar
c                 synthesis is used to compute slap on the entire sphere.
c                 i.e., in the array slap(i,j) for i=1,...,nlat and
c                 j=1,...,nlon.
c
c           = 1  sf and slap are antisymmetric about the equator. the
c                synthesis used to compute slap is performed on the
c                northern hemisphere only.  if nlat is odd, slap(i,j) is
c                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
c                nlat is even, slap(i,j) is computed for i=1,...,nlat/2
c                and j=1,...,nlon.
c
c
c           = 2  sf and slap are symmetric about the equator. the
c                synthesis used to compute slap is performed on the
c                northern hemisphere only.  if nlat is odd, slap(i,j) is
c                computed for i=1,...,(nlat+1)/2 and j=1,...,nlon.  if
c                nlat is even, slap(i,j) is computed for i=1,...,nlat/2
c                and j=1,...,nlon.
c
c
c     nt     the number of analyses.  in the program that calls slapgc
c            the arrays slap,a, and b can be three dimensional in which
c            case multiple synthesis will be performed.  the third index
c            is the synthesis index which assumes the values k=1,...,nt.
c            for a single analysis set nt=1. the description of the
c            remaining parameters is simplified by assuming that nt=1
c            or that all the arrays are two dimensional.
c
c   ids      the first dimension of the array slap as it appears in the
c            program that calls slapgc.  if isym = 0 then ids must be at
c            least nlat.  if isym > 0 and nlat is even then ids must be
c            at least nlat/2. if isym > 0 and nlat is odd then ids must
c            be at least (nlat+1)/2.
c
c   jds      the second dimension of the array slap as it appears in the
c            program that calls slapgc. jds must be at least nlon.
c
c
c   a,b      two or three dimensional arrays (see input parameter nt)
c            that contain scalar spherical harmonic coefficients
c            of the scalar field sf as computed by subroutine shagc.
c     ***    a,b must be computed by shagc prior to calling slapgc.
c
c
c    mdab    the first dimension of the arrays a and b as it appears
c            in the program that calls slapgc.  mdab must be at
c            least min0(nlat,(nlon+2)/2) if nlon is even or at least
c            min0(nlat,(nlon+1)/2) if nlon is odd.
c
c    ndab    the second dimension of the arrays a and b as it appears
c            in the program that calls slapgc. ndbc must be at least
c            least nlat.
c
c            mdab,ndab should have the same values input to shagc to
c            compute the coefficients a and b.
c
c
c    wshsgc  an array which must be initialized by subroutine shsgci.
c            once initialized, wshsgc
c            can be used repeatedly by slapgc as long as nlat and nlon
c            remain unchanged.  wshsgc must not be altered between calls
c            of slapgc.
c
c    lshsgc  the dimension of the array wshsgc as it appears in the
c            program that calls slapgc.  let
c
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            and
c
c               l2 = nlat/2        if nlat is even or
c               l2 = (nlat+1)/2    if nlat is odd
c
c            then lshsgc must be at least
c
c               nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15
c
c
c     work   a work array that does not have to be saved.
c
c     lwork  the dimension of the array work as it appears in the
c            program that calls slapgc. define
c
c               l2 = nlat/2                    if nlat is even or
c               l2 = (nlat+1)/2                if nlat is odd
c               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
c               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
c
c            if isym = 0 let
c
c               lwkmin = nlat*(2*nt*nlon+max0(6*l2,nlon)+2*nt*l1+1.
c
c            if isym > 0 let
c
c               lwkmin = l2*(2*nt*nlon+max0(6*nlat,nlon))+nlat*(2*nt*l1+1)
c
c
c     then lwork must be greater than or equal to lwkmin (see ierror=10)
c
c     **************************************************************
c
c     output parameters
c
c
c    slap    a two or three dimensional arrays (see input parameter nt) that
c            contain the scalar laplacian of the scalar field sf.  slap(i,j)
c            is the scalar laplacian at the gaussian colatitude theta(i)
c            and longitude lambda(j) = (j-1)*2*pi/nlon for i=1,...,nlat
c            and j=1,...,nlon.
c
c
c  ierror    a parameter which flags errors in input parameters as follows:
c
c            = 0  no errors detected
c
c            = 1  error in the specification of nlat
c
c            = 2  error in the specification of nlon
c
c            = 3  error in the specification of ityp
c
c            = 4  error in the specification of nt
c
c            = 5  error in the specification of ids
c
c            = 6  error in the specification of jds
c
c            = 7  error in the specification of mdbc
c
c            = 8  error in the specification of ndbc
c
c            = 9  error in the specification of lshsgc
c
c            = 10 error in the specification of lwork
c
c
c **********************************************************************
c                                                                              
c     end of documentation for slapgc
c
c **********************************************************************
c
c
      subroutine slapgc(nlat,nlon,isym,nt,slap,ids,jds,a,b,mdab,ndab,
     +                  wshsgc,lshsgc,work,lwork,ierror)
      dimension slap(ids,jds,nt),a(mdab,ndab,nt),b(mdab,ndab,nt)
      dimension wshsgc(lshsgc),work(lwork)
c
c     check input parameters
c
      ierror = 1
      if(nlat .lt. 3) return
      ierror = 2
      if(nlon .lt. 4) return
      ierror = 3
      if (isym.lt.0 .or. isym.gt.2) return
      ierror = 4
      if(nt .lt. 0) return
      ierror = 5
      imid = (nlat+1)/2
      if((isym.eq.0 .and. ids.lt.nlat) .or.
     1   (isym.gt.0 .and. ids.lt.imid)) return
      ierror = 6
      if(jds .lt. nlon) return
      ierror = 7
      mmax = min0(nlat,nlon/2+1)
      if(mdab .lt. mmax) return
      ierror = 8
      if(ndab .lt. nlat) return
      ierror = 9
c
c     set and verify saved work space length
c
c
      l1 = min0(nlat,(nlon+2)/2)
      l2 = (nlat+1)/2
      if (lshsgc .lt. nlat*(2*l2+3*l1-2)+3*l1*(1-l1)/2+nlon+15)return
      ierror = 10
c
c     set and verify unsaved work space length
c
      ls = nlat
      if(isym .gt. 0) ls = imid
      nln = nt*ls*nlon
      mn = mmax*nlat*nt
c     lwmin = nln+ls*nlon+2*mn+nlat
c     if (lwork .lt. lwmin) return
      l2 = (nlat+1)/2
      l1 = min0(nlat,nlon/2+1)
      if (isym .eq. 0) then
	lwkmin = nlat*(2*nt*nlon+max0(6*l2,nlon)+2*nt*l1+1)
      else
	lwkmin = l2*(2*nt*nlon+max0(6*nlat,nlon))+nlat*(2*nt*l1+1)
      end if
      if (lwork .lt. lwkmin) return
      ierror = 0
c
c     set work space pointers
c
      ia = 1
      ib = ia+mn
      ifn = ib+mn
      iwk = ifn+nlat
      lwk = lwork-2*mn-nlat
      call slapgc1(nlat,nlon,isym,nt,slap,ids,jds,a,b,mdab,ndab,
     +work(ia),work(ib),mmax,work(ifn),wshsgc,lshsgc,work(iwk),lwk,
     +ierror)
      return
      end

      subroutine slapgc1(nlat,nlon,isym,nt,slap,ids,jds,a,b,mdab,ndab,
     +                  alap,blap,mmax,fnn,wsave,lsave,wk,lwk,ierror)
      dimension slap(ids,jds,nt),a(mdab,ndab,nt),b(mdab,ndab,nt)
      dimension alap(mmax,nlat,nt),blap(mmax,nlat,nt),fnn(nlat)
      dimension wsave(lsave),wk(lwk)
c
c     set coefficient multiplyers
c
      do 1 n=2,nlat
      fn = float(n-1)
      fnn(n) = fn*(fn+1.)
    1 continue
c
c     compute scalar laplacian coefficients for each vector field
c
      do 2 k=1,nt
      do 3 n=1,nlat
      do 4 m=1,mmax
      alap(m,n,k) = 0.0
      blap(m,n,k) = 0.0
    4 continue
    3 continue
c
c     compute m=0 coefficients
c
      do 5 n=2,nlat
      alap(1,n,k) = -fnn(n)*a(1,n,k)
      blap(1,n,k) = -fnn(n)*b(1,n,k)
    5 continue
c
c     compute m>0 coefficients
c
      do 6 m=2,mmax
      do 7 n=m,nlat
      alap(m,n,k) = -fnn(n)*a(m,n,k)
      blap(m,n,k) = -fnn(n)*b(m,n,k)
    7 continue
    6 continue
    2 continue
c
c     synthesize alap,blap into slap
c
      call shsgc(nlat,nlon,isym,nt,slap,ids,jds,alap,blap,
     +           mmax,nlat,wsave,lsave,wk,lwk,ierror)
      return
      end

!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!  .                                                             .
!  .                  copyright (c) 1998 by ucar                 .
!  .                                                             .
!  .       university corporation for atmospheric research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         spherepack3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file vhaec.f
!
!     this file contains code and documentation for subroutines
!     vhaec and vhaeci
!
! ... files which must be loaded with vhaec.f
!
!     sphcom.f, hrfft.f
!
!
!     subroutine vhaec(nlat,nlon,ityp,nt,v,w,idvw,jdvw,br,bi,cr,ci,
!    +                 mdab,ndab,wvhaec,lvhaec,work,lwork,ierror)
!
!     subroutine vhaec performs the vector spherical harmonic analysis
!     on the vector field (v,w) and stores the result in the arrays
!     br, bi, cr, and ci. v(i,j) and w(i,j) are the colatitudinal
!     (measured from the north pole) and east longitudinal components
!     respectively, located at colatitude theta(i) = (i-1)*pi/(nlat-1)
!     and longitude phi(j) = (j-1)*2*pi/nlon. the spectral
!     representation of (v,w) is given at output parameters v,w in
!     subroutine vhsec.
!
!     input parameters
!
!     nlat   the number of colatitudes on the full sphere including the
!            poles. for example, nlat = 37 for a five degree grid.
!            nlat determines the grid increment in colatitude as
!            pi/(nlat-1).  if nlat is odd the equator is located at
!            grid point i=(nlat+1)/2. if nlat is even the equator is
!            located half way between points i=nlat/2 and i=nlat/2+1.
!            nlat must be at least 3. note: on the half sphere, the
!            number of grid points in the colatitudinal direction is
!            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than zero. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!     ityp   = 0  no symmetries exist about the equator. the analysis
!                 is performed on the entire sphere.  i.e. on the
!                 arrays v(i,j),w(i,j) for i=1,...,nlat and
!                 j=1,...,nlon.
!
!            = 1  no symmetries exist about the equator. the analysis
!                 is performed on the entire sphere.  i.e. on the
!                 arrays v(i,j),w(i,j) for i=1,...,nlat and
!                 j=1,...,nlon. the curl of (v,w) is zero. that is,
!                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
!                 the coefficients cr and ci are zero.
!
!            = 2  no symmetries exist about the equator. the analysis
!                 is performed on the entire sphere.  i.e. on the
!                 arrays v(i,j),w(i,j) for i=1,...,nlat and
!                 j=1,...,nlon. the divergence of (v,w) is zero. i.e.,
!                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
!                 the coefficients br and bi are zero.
!
!            = 3  v is symmetric and w is antisymmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!            = 4  v is symmetric and w is antisymmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the curl of (v,w) is zero. that is,
!                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
!                 the coefficients cr and ci are zero.
!
!            = 5  v is symmetric and w is antisymmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the divergence of (v,w) is zero. i.e.,
!                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
!                 the coefficients br and bi are zero.
!
!            = 6  v is antisymmetric and w is symmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!            = 7  v is antisymmetric and w is symmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the curl of (v,w) is zero. that is,
!                 (d/dtheta (sin(theta) w) - dv/dphi)/sin(theta) = 0.
!                 the coefficients cr and ci are zero.
!
!            = 8  v is antisymmetric and w is symmetric about the
!                 equator. the analysis is performed on the northern
!                 hemisphere only.  i.e., if nlat is odd the analysis
!                 is performed on the arrays v(i,j),w(i,j) for
!                 i=1,...,(nlat+1)/2 and j=1,...,nlon. if nlat is
!                 even the analysis is performed on the the arrays
!                 v(i,j),w(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!                 the divergence of (v,w) is zero. i.e.,
!                 (d/dtheta (sin(theta) v) + dw/dphi)/sin(theta) = 0.
!                 the coefficients br and bi are zero.
!
!
!     nt     the number of analyses.  in the program that calls vhaec,
!            the arrays v,w,br,bi,cr, and ci can be three dimensional
!            in which case multiple analyses will be performed.
!            the third index is the analysis index which assumes the
!            values k=1,...,nt.  for a single analysis set nt=1. the
!            discription of the remaining parameters is simplified
!            by assuming that nt=1 or that all the arrays are two
!            dimensional.
!
!     v,w    two or three dimensional arrays (see input parameter nt)
!            that contain the vector function to be analyzed.
!            v is the colatitudnal component and w is the east
!            longitudinal component. v(i,j),w(i,j) contain the
!            components at colatitude theta(i) = (i-1)*pi/(nlat-1)
!            and longitude phi(j) = (j-1)*2*pi/nlon. the index ranges
!            are defined above at the input parameter ityp.
!
!     idvw   the first dimension of the arrays v,w as it appears in
!            the program that calls vhaec. if ityp .le. 2 then idvw
!            must be at least nlat.  if ityp .gt. 2 and nlat is
!            even then idvw must be at least nlat/2. if ityp .gt. 2
!            and nlat is odd then idvw must be at least (nlat+1)/2.
!
!     jdvw   the second dimension of the arrays v,w as it appears in
!            the program that calls vhaec. jdvw must be at least nlon.
!
!     mdab   the first dimension of the arrays br,bi,cr, and ci as it
!            appears in the program that calls vhaec. mdab must be at
!            least min0(nlat,nlon/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndab   the second dimension of the arrays br,bi,cr, and ci as it
!            appears in the program that calls vhaec. ndab must be at
!            least nlat.
!
!     wvhaec an array which must be initialized by subroutine vhaeci.
!            once initialized, wvhaec can be used repeatedly by vhaec
!            as long as nlon and nlat remain unchanged.  wvhaec must
!            not be altered between calls of vhaec.
!
!     lvhaec the dimension of the array wvhaec as it appears in the
!            program that calls vhaec. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lvhaec must be at least
!
!            4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
!
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls vhaec. define
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            if ityp .le. 2 then lwork must be at least
!
!                    nlat*(2*nt*nlon+max0(6*l2,nlon))
!
!            if ityp .gt. 2 then lwork must be at least
!
!                    l2*(2*nt*nlon+max0(6*nlat,nlon))
!
!     **************************************************************
!
!     output parameters
!
!     br,bi  two or three dimensional arrays (see input parameter nt)
!     cr,ci  that contain the vector spherical harmonic coefficients
!            in the spectral representation of v(i,j) and w(i,j) given
!            in the discription of subroutine vhsec. br(mp1,np1),
!            bi(mp1,np1),cr(mp1,np1), and ci(mp1,np1) are computed
!            for mp1=1,...,mmax and np1=mp1,...,nlat except for np1=nlat
!            and odd mp1. mmax=min0(nlat,nlon/2) if nlon is even or
!            mmax=min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of ityp
!            = 4  error in the specification of nt
!            = 5  error in the specification of idvw
!            = 6  error in the specification of jdvw
!            = 7  error in the specification of mdab
!            = 8  error in the specification of ndab
!            = 9  error in the specification of lvhaec
!            = 10 error in the specification of lwork
!
!
! *******************************************************************
!
!     subroutine vhaeci(nlat,nlon,wvhaec,lvhaec,dwork,ldwork,ierror)
!
!     subroutine vhaeci initializes the array wvhaec which can then be
!     used repeatedly by subroutine vhaec until nlat or nlon is changed.
!
!     input parameters
!
!     nlat   the number of colatitudes on the full sphere including the
!            poles. for example, nlat = 37 for a five degree grid.
!            nlat determines the grid increment in colatitude as
!            pi/(nlat-1).  if nlat is odd the equator is located at
!            grid point i=(nlat+1)/2. if nlat is even the equator is
!            located half way between points i=nlat/2 and i=nlat/2+1.
!            nlat must be at least 3. note: on the half sphere, the
!            number of grid points in the colatitudinal direction is
!            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than zero. the axisymmetric case corresponds to nlon=1.
!            the efficiency of the computation is improved when nlon
!            is a product of small prime numbers.
!
!     lvhaec the dimension of the array wvhaec as it appears in the
!            program that calls vhaec. define
!
!               l1 = min0(nlat,nlon/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lvhaec must be at least
!
!            4*nlat*l2+3*max0(l1-2,0)*(nlat+nlat-l1-1)+nlon+15
!
!
!     dwork  a double precision work array that does not have to be saved.
!
!     ldwork the dimension of the array dwork as it appears in the
!            program that calls vhaec. ldwork must be at least
!            2*(nlat+2)
!
!
!     **************************************************************
!
!     output parameters
!
!     wvhaec an array which is initialized for use by subroutine vhaec.
!            once initialized, wvhaec can be used repeatedly by vhaec
!            as long as nlat or nlon remain unchanged.  wvhaec must not
!            be altered between calls of vhaec.
!
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of lvhaec
!            = 4  error in the specification of ldwork
!
!
! **********************************************************************
      SUBROUTINE VHAEC(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,Mdab,&
                     & Ndab,Wvhaec,Lvhaec,Work,Lwork,Ierror)
      IMPLICIT NONE
      REAL Bi , Br , Ci , Cr , V , W , Work , Wvhaec
      INTEGER idv , Idvw , Ierror , imid , ist , Ityp , iw1 , iw2 ,     &
            & iw3 , iw4 , iw5 , Jdvw , jw1 , jw2 , labc , lnl , Lvhaec ,&
            & Lwork , lwzvin , lzz1
      INTEGER Mdab , mmax , Ndab , Nlat , Nlon , Nt
      DIMENSION V(Idvw,Jdvw,1) , W(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,     &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Work(1) , Wvhaec(1)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      IF ( Ityp<0 .OR. Ityp>8 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Ityp<=2 .AND. Idvw<Nlat) .OR. (Ityp>2 .AND. Idvw<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lvhaec<2*(lzz1+labc)+Nlon+15 ) RETURN
      Ierror = 10
      IF ( Ityp<=2 .AND. Lwork<Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon)) )     &
         & RETURN
      IF ( Ityp>2 .AND. Lwork<imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon)) )      &
         & RETURN
      Ierror = 0
      idv = Nlat
      IF ( Ityp>2 ) idv = imid
      lnl = Nt*idv*Nlon
      ist = 0
      IF ( Ityp<=2 ) ist = imid
      iw1 = ist + 1
      iw2 = lnl + 1
      iw3 = iw2 + ist
      iw4 = iw2 + lnl
      iw5 = iw4 + 3*imid*Nlat
      lwzvin = lzz1 + labc
      jw1 = lwzvin + 1
      jw2 = jw1 + lwzvin
      CALL VHAEC1(Nlat,Nlon,Ityp,Nt,imid,Idvw,Jdvw,V,W,Mdab,Ndab,Br,Bi, &
                & Cr,Ci,idv,Work,Work(iw1),Work(iw2),Work(iw3),Work(iw4)&
                & ,Work(iw5),Wvhaec,Wvhaec(jw1),Wvhaec(jw2))
      END SUBROUTINE VHAEC


      SUBROUTINE VHAEC1(Nlat,Nlon,Ityp,Nt,Imid,Idvw,Jdvw,V,W,Mdab,Ndab, &
                      & Br,Bi,Cr,Ci,Idv,Ve,Vo,We,Wo,Zv,Zw,Wzvin,Wzwin,  &
                      & Wrfft)
      IMPLICIT NONE
      REAL Bi , Br , Ci , Cr , fsn , tsn , V , Ve , Vo , W , We , Wo ,  &
         & Wrfft , Wzvin , Wzwin , Zv , Zw
      INTEGER i , Idv , Idvw , Imid , imm1 , Ityp , itypp , iv , iw ,   &
            & j , Jdvw , k , m , Mdab , mlat , mlon , mmax , mp1 , mp2 ,&
            & Ndab
      INTEGER ndo1 , ndo2 , Nlat , Nlon , nlp1 , np1 , Nt
      DIMENSION V(Idvw,Jdvw,1) , W(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,     &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Ve(Idv,Nlon,1) , Vo(Idv,Nlon,1) , We(Idv,Nlon,1) ,      &
              & Wo(Idv,Nlon,1) , Wzvin(1) , Wzwin(1) , Wrfft(1) ,       &
              & Zv(Imid,Nlat,3) , Zw(Imid,Nlat,3)
      nlp1 = Nlat + 1
      tsn = 2./Nlon
      fsn = 4./Nlon
      mlat = MOD(Nlat,2)
      mlon = MOD(Nlon,2)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      imm1 = Imid
      IF ( mlat/=0 ) imm1 = Imid - 1
      IF ( Ityp>2 ) THEN
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO j = 1 , Nlon
                  Ve(i,j,k) = fsn*V(i,j,k)
                  Vo(i,j,k) = fsn*V(i,j,k)
                  We(i,j,k) = fsn*W(i,j,k)
                  Wo(i,j,k) = fsn*W(i,j,k)
               ENDDO
            ENDDO
         ENDDO
      ELSE
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO j = 1 , Nlon
                  Ve(i,j,k) = tsn*(V(i,j,k)+V(nlp1-i,j,k))
                  Vo(i,j,k) = tsn*(V(i,j,k)-V(nlp1-i,j,k))
                  We(i,j,k) = tsn*(W(i,j,k)+W(nlp1-i,j,k))
                  Wo(i,j,k) = tsn*(W(i,j,k)-W(nlp1-i,j,k))
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      IF ( mlat/=0 ) THEN
         DO k = 1 , Nt
            DO j = 1 , Nlon
               Ve(Imid,j,k) = tsn*V(Imid,j,k)
               We(Imid,j,k) = tsn*W(Imid,j,k)
            ENDDO
         ENDDO
      ENDIF
      DO k = 1 , Nt
         CALL HRFFTF(Idv,Nlon,Ve(1,1,k),Idv,Wrfft,Zv)
         CALL HRFFTF(Idv,Nlon,We(1,1,k),Idv,Wrfft,Zv)
      ENDDO
      ndo1 = Nlat
      ndo2 = Nlat
      IF ( mlat/=0 ) ndo1 = Nlat - 1
      IF ( mlat==0 ) ndo2 = Nlat - 1
      IF ( Ityp/=2 .AND. Ityp/=5 .AND. Ityp/=8 ) THEN
         DO k = 1 , Nt
            DO mp1 = 1 , mmax
               DO np1 = mp1 , Nlat
                  Br(mp1,np1,k) = 0.
                  Bi(mp1,np1,k) = 0.
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      IF ( Ityp/=1 .AND. Ityp/=4 .AND. Ityp/=7 ) THEN
         DO k = 1 , Nt
            DO mp1 = 1 , mmax
               DO np1 = mp1 , Nlat
                  Cr(mp1,np1,k) = 0.
                  Ci(mp1,np1,k) = 0.
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      itypp = Ityp + 1
      IF ( itypp==2 ) THEN
!
!     case ityp=1 ,  no symmetries but cr and ci equal zero
!
         CALL ZVIN(0,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Ve(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Vo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL ZVIN(0,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL ZWIN(0,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Vo(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *We(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Vo(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *We(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zw(Imid,np1,iw) &
                                      & *We(Imid,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) - Zw(Imid,np1,iw) &
                                      & *We(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Ve(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Wo(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Ve(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Wo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(Imid,np1,iv) &
                                      & *Ve(Imid,2*mp1-2,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(Imid,np1,iv) &
                                      & *Ve(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==3 ) THEN
!
!     case ityp=2 ,  no symmetries but br and bi equal zero
!
         CALL ZVIN(0,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*We(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*Wo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL ZVIN(0,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL ZWIN(0,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *Wo(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Ve(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *Wo(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Ve(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) + Zw(Imid,np1,iw) &
                                      & *Ve(Imid,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zw(Imid,np1,iw) &
                                      & *Ve(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *We(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Vo(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *We(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Vo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(Imid,np1,iv) &
                                      & *We(Imid,2*mp1-2,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(Imid,np1,iv) &
                                      & *We(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==4 ) THEN
!
!     case ityp=3 ,  v even , w odd
!
         CALL ZVIN(0,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Ve(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*Wo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL ZVIN(0,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL ZWIN(0,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *Wo(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Ve(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *Wo(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Ve(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) + Zw(Imid,np1,iw) &
                                      & *Ve(Imid,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zw(Imid,np1,iw) &
                                      & *Ve(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Ve(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Wo(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Ve(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Wo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(Imid,np1,iv) &
                                      & *Ve(Imid,2*mp1-2,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(Imid,np1,iv) &
                                      & *Ve(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==5 ) THEN
!
!     case ityp=4 ,  v even, w odd, and cr and ci equal 0.
!
         CALL ZVIN(1,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Ve(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL ZVIN(1,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL ZWIN(1,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Ve(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Wo(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Ve(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Wo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(Imid,np1,iv) &
                                      & *Ve(Imid,2*mp1-2,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(Imid,np1,iv) &
                                      & *Ve(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==6 ) THEN
!
!     case ityp=5   v even, w odd, and br and bi equal zero
!
         CALL ZVIN(2,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*Wo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL ZVIN(2,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL ZWIN(2,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *Wo(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Ve(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *Wo(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Ve(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) + Zw(Imid,np1,iw) &
                                      & *Ve(Imid,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zw(Imid,np1,iw) &
                                      & *Ve(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==7 ) THEN
!
!     case ityp=6 ,  v odd , w even
!
         CALL ZVIN(0,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*We(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Vo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL ZVIN(0,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL ZWIN(0,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Vo(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *We(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Vo(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *We(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zw(Imid,np1,iw) &
                                      & *We(Imid,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) - Zw(Imid,np1,iw) &
                                      & *We(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *We(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Vo(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *We(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Vo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(Imid,np1,iv) &
                                      & *We(Imid,2*mp1-2,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(Imid,np1,iv) &
                                      & *We(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==8 ) THEN
!
!     case ityp=7   v odd, w even, and cr and ci equal zero
!
         CALL ZVIN(2,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Vo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL ZVIN(2,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL ZWIN(2,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Vo(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *We(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Vo(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *We(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zw(Imid,np1,iw) &
                                      & *We(Imid,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) - Zw(Imid,np1,iw) &
                                      & *We(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==9 ) THEN
!
!     case ityp=8   v odd, w even, and both br and bi equal zero
!
         CALL ZVIN(1,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*We(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL ZVIN(1,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL ZWIN(1,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *We(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Vo(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *We(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Vo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(Imid,np1,iv) &
                                      & *We(Imid,2*mp1-2,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(Imid,np1,iv) &
                                      & *We(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         GOTO 99999
      ENDIF
!
!     case ityp=0 ,  no symmetries
!
      CALL ZVIN(0,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
      DO k = 1 , Nt
         DO i = 1 , Imid
            DO np1 = 2 , ndo2 , 2
               Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Ve(i,1,k)
               Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*We(i,1,k)
            ENDDO
         ENDDO
      ENDDO
      DO k = 1 , Nt
         DO i = 1 , imm1
            DO np1 = 3 , ndo1 , 2
               Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Vo(i,1,k)
               Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*Wo(i,1,k)
            ENDDO
         ENDDO
      ENDDO
!
!     case m = 1 through nlat-1
!
      IF ( mmax<2 ) RETURN
      DO mp1 = 2 , mmax
         m = mp1 - 1
         mp2 = mp1 + 1
         CALL ZVIN(0,Nlat,Nlon,m,Zv,iv,Wzvin)
         CALL ZWIN(0,Nlat,Nlon,m,Zw,iw,Wzwin)
         IF ( mp1<=ndo1 ) THEN
            DO k = 1 , Nt
               DO i = 1 , imm1
                  DO np1 = mp1 , ndo1 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)       &
                                   & *Vo(i,2*mp1-2,k) + Zw(i,np1,iw)    &
                                   & *We(i,2*mp1-1,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)       &
                                   & *Vo(i,2*mp1-1,k) - Zw(i,np1,iw)    &
                                   & *We(i,2*mp1-2,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)       &
                                   & *Wo(i,2*mp1-2,k) + Zw(i,np1,iw)    &
                                   & *Ve(i,2*mp1-1,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)       &
                                   & *Wo(i,2*mp1-1,k) - Zw(i,np1,iw)    &
                                   & *Ve(i,2*mp1-2,k)
                  ENDDO
               ENDDO
            ENDDO
            IF ( mlat/=0 ) THEN
               DO k = 1 , Nt
                  DO np1 = mp1 , ndo1 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Zw(Imid,np1,iw)    &
                                   & *We(Imid,2*mp1-1,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) - Zw(Imid,np1,iw)    &
                                   & *We(Imid,2*mp1-2,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) + Zw(Imid,np1,iw)    &
                                   & *Ve(Imid,2*mp1-1,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zw(Imid,np1,iw)    &
                                   & *Ve(Imid,2*mp1-2,k)
                  ENDDO
               ENDDO
            ENDIF
         ENDIF
         IF ( mp2<=ndo2 ) THEN
            DO k = 1 , Nt
               DO i = 1 , imm1
                  DO np1 = mp2 , ndo2 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)       &
                                   & *Ve(i,2*mp1-2,k) + Zw(i,np1,iw)    &
                                   & *Wo(i,2*mp1-1,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)       &
                                   & *Ve(i,2*mp1-1,k) - Zw(i,np1,iw)    &
                                   & *Wo(i,2*mp1-2,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)       &
                                   & *We(i,2*mp1-2,k) + Zw(i,np1,iw)    &
                                   & *Vo(i,2*mp1-1,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)       &
                                   & *We(i,2*mp1-1,k) - Zw(i,np1,iw)    &
                                   & *Vo(i,2*mp1-2,k)
                  ENDDO
               ENDDO
            ENDDO
            IF ( mlat/=0 ) THEN
               DO k = 1 , Nt
                  DO np1 = mp2 , ndo2 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(Imid,np1,iv)    &
                                   & *Ve(Imid,2*mp1-2,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(Imid,np1,iv)    &
                                   & *Ve(Imid,2*mp1-1,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(Imid,np1,iv)    &
                                   & *We(Imid,2*mp1-2,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(Imid,np1,iv)    &
                                   & *We(Imid,2*mp1-1,k)
                  ENDDO
               ENDDO
            ENDIF
         ENDIF
      ENDDO
      RETURN
99999 END SUBROUTINE VHAEC1


      SUBROUTINE VHAECI(Nlat,Nlon,Wvhaec,Lvhaec,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER Ierror , imid , iw1 , iw2 , labc , Ldwork , Lvhaec ,      &
            & lwzvin , lzz1 , mmax , Nlat , Nlon
      REAL Wvhaec
      DIMENSION Wvhaec(Lvhaec)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      imid = (Nlat+1)/2
      lzz1 = 2*Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lvhaec<2*(lzz1+labc)+Nlon+15 ) RETURN
      Ierror = 4
      IF ( Ldwork<2*Nlat+2 ) RETURN
      Ierror = 0
      CALL ZVINIT(Nlat,Nlon,Wvhaec,Dwork)
      lwzvin = lzz1 + labc
      iw1 = lwzvin + 1
      CALL ZWINIT(Nlat,Nlon,Wvhaec(iw1),Dwork)
      iw2 = iw1 + lwzvin
      CALL HRFFTI(Nlon,Wvhaec(iw2))
      END SUBROUTINE VHAECI


      SUBROUTINE DVHAEC(Nlat,Nlon,Ityp,Nt,V,W,Idvw,Jdvw,Br,Bi,Cr,Ci,Mdab,&
                     & Ndab,Wvhaec,Lvhaec,Work,Lwork,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION Bi , Br , Ci , Cr , V , W , Work , Wvhaec
      INTEGER idv , Idvw , Ierror , imid , ist , Ityp , iw1 , iw2 ,     &
            & iw3 , iw4 , iw5 , Jdvw , jw1 , jw2 , labc , lnl , Lvhaec ,&
            & Lwork , lwzvin , lzz1
      INTEGER Mdab , mmax , Ndab , Nlat , Nlon , Nt
      DIMENSION V(Idvw,Jdvw,1) , W(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,     &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Work(1) , Wvhaec(1)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      IF ( Ityp<0 .OR. Ityp>8 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      imid = (Nlat+1)/2
      IF ( (Ityp<=2 .AND. Idvw<Nlat) .OR. (Ityp>2 .AND. Idvw<imid) )    &
         & RETURN
      Ierror = 6
      IF ( Jdvw<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,(Nlon+1)/2)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      lzz1 = 2*Nlat*imid
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lvhaec<2*(lzz1+labc)+Nlon+15 ) RETURN
      Ierror = 10
      IF ( Ityp<=2 .AND. Lwork<Nlat*(2*Nt*Nlon+MAX0(6*imid,Nlon)) )     &
         & RETURN
      IF ( Ityp>2 .AND. Lwork<imid*(2*Nt*Nlon+MAX0(6*Nlat,Nlon)) )      &
         & RETURN
      Ierror = 0
      idv = Nlat
      IF ( Ityp>2 ) idv = imid
      lnl = Nt*idv*Nlon
      ist = 0
      IF ( Ityp<=2 ) ist = imid
      iw1 = ist + 1
      iw2 = lnl + 1
      iw3 = iw2 + ist
      iw4 = iw2 + lnl
      iw5 = iw4 + 3*imid*Nlat
      lwzvin = lzz1 + labc
      jw1 = lwzvin + 1
      jw2 = jw1 + lwzvin
      CALL DVHAEC1(Nlat,Nlon,Ityp,Nt,imid,Idvw,Jdvw,V,W,Mdab,Ndab,Br,Bi, &
                & Cr,Ci,idv,Work,Work(iw1),Work(iw2),Work(iw3),Work(iw4)&
                & ,Work(iw5),Wvhaec,Wvhaec(jw1),Wvhaec(jw2))
      END SUBROUTINE DVHAEC


      SUBROUTINE DVHAEC1(Nlat,Nlon,Ityp,Nt,Imid,Idvw,Jdvw,V,W,Mdab,Ndab, &
                      & Br,Bi,Cr,Ci,Idv,Ve,Vo,We,Wo,Zv,Zw,Wzvin,Wzwin,  &
                      & Wrfft)
      IMPLICIT NONE
      DOUBLE PRECISION Bi , Br , Ci , Cr , fsn , tsn , V , Ve , Vo , W , We , Wo ,  &
         & Wrfft , Wzvin , Wzwin , Zv , Zw
      INTEGER i , Idv , Idvw , Imid , imm1 , Ityp , itypp , iv , iw ,   &
            & j , Jdvw , k , m , Mdab , mlat , mlon , mmax , mp1 , mp2 ,&
            & Ndab
      INTEGER ndo1 , ndo2 , Nlat , Nlon , nlp1 , np1 , Nt
      DIMENSION V(Idvw,Jdvw,1) , W(Idvw,Jdvw,1) , Br(Mdab,Ndab,1) ,     &
              & Bi(Mdab,Ndab,1) , Cr(Mdab,Ndab,1) , Ci(Mdab,Ndab,1) ,   &
              & Ve(Idv,Nlon,1) , Vo(Idv,Nlon,1) , We(Idv,Nlon,1) ,      &
              & Wo(Idv,Nlon,1) , Wzvin(1) , Wzwin(1) , Wrfft(1) ,       &
              & Zv(Imid,Nlat,3) , Zw(Imid,Nlat,3)
      nlp1 = Nlat + 1
      tsn = 2./Nlon
      fsn = 4./Nlon
      mlat = MOD(Nlat,2)
      mlon = MOD(Nlon,2)
      mmax = MIN0(Nlat,(Nlon+1)/2)
      imm1 = Imid
      IF ( mlat/=0 ) imm1 = Imid - 1
      IF ( Ityp>2 ) THEN
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO j = 1 , Nlon
                  Ve(i,j,k) = fsn*V(i,j,k)
                  Vo(i,j,k) = fsn*V(i,j,k)
                  We(i,j,k) = fsn*W(i,j,k)
                  Wo(i,j,k) = fsn*W(i,j,k)
               ENDDO
            ENDDO
         ENDDO
      ELSE
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO j = 1 , Nlon
                  Ve(i,j,k) = tsn*(V(i,j,k)+V(nlp1-i,j,k))
                  Vo(i,j,k) = tsn*(V(i,j,k)-V(nlp1-i,j,k))
                  We(i,j,k) = tsn*(W(i,j,k)+W(nlp1-i,j,k))
                  Wo(i,j,k) = tsn*(W(i,j,k)-W(nlp1-i,j,k))
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      IF ( mlat/=0 ) THEN
         DO k = 1 , Nt
            DO j = 1 , Nlon
               Ve(Imid,j,k) = tsn*V(Imid,j,k)
               We(Imid,j,k) = tsn*W(Imid,j,k)
            ENDDO
         ENDDO
      ENDIF
      DO k = 1 , Nt
         CALL DHRFFTF(Idv,Nlon,Ve(1,1,k),Idv,Wrfft,Zv)
         CALL DHRFFTF(Idv,Nlon,We(1,1,k),Idv,Wrfft,Zv)
      ENDDO
      ndo1 = Nlat
      ndo2 = Nlat
      IF ( mlat/=0 ) ndo1 = Nlat - 1
      IF ( mlat==0 ) ndo2 = Nlat - 1
      IF ( Ityp/=2 .AND. Ityp/=5 .AND. Ityp/=8 ) THEN
         DO k = 1 , Nt
            DO mp1 = 1 , mmax
               DO np1 = mp1 , Nlat
                  Br(mp1,np1,k) = 0.
                  Bi(mp1,np1,k) = 0.
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      IF ( Ityp/=1 .AND. Ityp/=4 .AND. Ityp/=7 ) THEN
         DO k = 1 , Nt
            DO mp1 = 1 , mmax
               DO np1 = mp1 , Nlat
                  Cr(mp1,np1,k) = 0.
                  Ci(mp1,np1,k) = 0.
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      itypp = Ityp + 1
      IF ( itypp==2 ) THEN
!
!     case ityp=1 ,  no symmetries but cr and ci equal zero
!
         CALL DZVIN(0,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Ve(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Vo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL DZVIN(0,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL DZWIN(0,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Vo(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *We(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Vo(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *We(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zw(Imid,np1,iw) &
                                      & *We(Imid,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) - Zw(Imid,np1,iw) &
                                      & *We(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Ve(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Wo(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Ve(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Wo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(Imid,np1,iv) &
                                      & *Ve(Imid,2*mp1-2,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(Imid,np1,iv) &
                                      & *Ve(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==3 ) THEN
!
!     case ityp=2 ,  no symmetries but br and bi equal zero
!
         CALL DZVIN(0,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*We(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*Wo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL DZVIN(0,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL DZWIN(0,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *Wo(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Ve(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *Wo(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Ve(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) + Zw(Imid,np1,iw) &
                                      & *Ve(Imid,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zw(Imid,np1,iw) &
                                      & *Ve(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *We(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Vo(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *We(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Vo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(Imid,np1,iv) &
                                      & *We(Imid,2*mp1-2,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(Imid,np1,iv) &
                                      & *We(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==4 ) THEN
!
!     case ityp=3 ,  v even , w odd
!
         CALL DZVIN(0,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Ve(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*Wo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL DZVIN(0,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL DZWIN(0,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *Wo(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Ve(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *Wo(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Ve(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) + Zw(Imid,np1,iw) &
                                      & *Ve(Imid,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zw(Imid,np1,iw) &
                                      & *Ve(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Ve(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Wo(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Ve(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Wo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(Imid,np1,iv) &
                                      & *Ve(Imid,2*mp1-2,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(Imid,np1,iv) &
                                      & *Ve(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==5 ) THEN
!
!     case ityp=4 ,  v even, w odd, and cr and ci equal 0.
!
         CALL DZVIN(1,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Ve(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL DZVIN(1,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL DZWIN(1,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Ve(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Wo(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Ve(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Wo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(Imid,np1,iv) &
                                      & *Ve(Imid,2*mp1-2,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(Imid,np1,iv) &
                                      & *Ve(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==6 ) THEN
!
!     case ityp=5   v even, w odd, and br and bi equal zero
!
         CALL DZVIN(2,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*Wo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL DZVIN(2,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL DZWIN(2,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *Wo(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Ve(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *Wo(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Ve(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) + Zw(Imid,np1,iw) &
                                      & *Ve(Imid,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zw(Imid,np1,iw) &
                                      & *Ve(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==7 ) THEN
!
!     case ityp=6 ,  v odd , w even
!
         CALL DZVIN(0,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*We(i,1,k)
               ENDDO
            ENDDO
         ENDDO
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Vo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL DZVIN(0,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL DZWIN(0,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Vo(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *We(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Vo(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *We(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zw(Imid,np1,iw) &
                                      & *We(Imid,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) - Zw(Imid,np1,iw) &
                                      & *We(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *We(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Vo(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *We(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Vo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(Imid,np1,iv) &
                                      & *We(Imid,2*mp1-2,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(Imid,np1,iv) &
                                      & *We(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==8 ) THEN
!
!     case ityp=7   v odd, w even, and cr and ci equal zero
!
         CALL DZVIN(2,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , imm1
               DO np1 = 3 , ndo1 , 2
                  Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Vo(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL DZVIN(2,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL DZWIN(2,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp1<=ndo1 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Vo(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *We(i,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)    &
                                      & *Vo(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *We(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp1 , ndo1 , 2
                        Br(mp1,np1,k) = Br(mp1,np1,k) + Zw(Imid,np1,iw) &
                                      & *We(Imid,2*mp1-1,k)
                        Bi(mp1,np1,k) = Bi(mp1,np1,k) - Zw(Imid,np1,iw) &
                                      & *We(Imid,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         RETURN
      ELSEIF ( itypp==9 ) THEN
!
!     case ityp=8   v odd, w even, and both br and bi equal zero
!
         CALL DZVIN(1,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO np1 = 2 , ndo2 , 2
                  Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*We(i,1,k)
               ENDDO
            ENDDO
         ENDDO
!
!     case m = 1 through nlat-1
!
         IF ( mmax<2 ) RETURN
         DO mp1 = 2 , mmax
            m = mp1 - 1
            mp2 = mp1 + 1
            CALL DZVIN(1,Nlat,Nlon,m,Zv,iv,Wzvin)
            CALL DZWIN(1,Nlat,Nlon,m,Zw,iw,Wzwin)
            IF ( mp2<=ndo2 ) THEN
               DO k = 1 , Nt
                  DO i = 1 , imm1
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *We(i,2*mp1-2,k) + Zw(i,np1,iw) &
                                      & *Vo(i,2*mp1-1,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)    &
                                      & *We(i,2*mp1-1,k) - Zw(i,np1,iw) &
                                      & *Vo(i,2*mp1-2,k)
                     ENDDO
                  ENDDO
               ENDDO
               IF ( mlat/=0 ) THEN
                  DO k = 1 , Nt
                     DO np1 = mp2 , ndo2 , 2
                        Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(Imid,np1,iv) &
                                      & *We(Imid,2*mp1-2,k)
                        Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(Imid,np1,iv) &
                                      & *We(Imid,2*mp1-1,k)
                     ENDDO
                  ENDDO
               ENDIF
            ENDIF
         ENDDO
         GOTO 99999
      ENDIF
!
!     case ityp=0 ,  no symmetries
!
      CALL DZVIN(0,Nlat,Nlon,0,Zv,iv,Wzvin)
!
!     case m=0
!
      DO k = 1 , Nt
         DO i = 1 , Imid
            DO np1 = 2 , ndo2 , 2
               Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Ve(i,1,k)
               Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*We(i,1,k)
            ENDDO
         ENDDO
      ENDDO
      DO k = 1 , Nt
         DO i = 1 , imm1
            DO np1 = 3 , ndo1 , 2
               Br(1,np1,k) = Br(1,np1,k) + Zv(i,np1,iv)*Vo(i,1,k)
               Cr(1,np1,k) = Cr(1,np1,k) - Zv(i,np1,iv)*Wo(i,1,k)
            ENDDO
         ENDDO
      ENDDO
!
!     case m = 1 through nlat-1
!
      IF ( mmax<2 ) RETURN
      DO mp1 = 2 , mmax
         m = mp1 - 1
         mp2 = mp1 + 1
         CALL DZVIN(0,Nlat,Nlon,m,Zv,iv,Wzvin)
         CALL DZWIN(0,Nlat,Nlon,m,Zw,iw,Wzwin)
         IF ( mp1<=ndo1 ) THEN
            DO k = 1 , Nt
               DO i = 1 , imm1
                  DO np1 = mp1 , ndo1 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)       &
                                   & *Vo(i,2*mp1-2,k) + Zw(i,np1,iw)    &
                                   & *We(i,2*mp1-1,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)       &
                                   & *Vo(i,2*mp1-1,k) - Zw(i,np1,iw)    &
                                   & *We(i,2*mp1-2,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)       &
                                   & *Wo(i,2*mp1-2,k) + Zw(i,np1,iw)    &
                                   & *Ve(i,2*mp1-1,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)       &
                                   & *Wo(i,2*mp1-1,k) - Zw(i,np1,iw)    &
                                   & *Ve(i,2*mp1-2,k)
                  ENDDO
               ENDDO
            ENDDO
            IF ( mlat/=0 ) THEN
               DO k = 1 , Nt
                  DO np1 = mp1 , ndo1 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Zw(Imid,np1,iw)    &
                                   & *We(Imid,2*mp1-1,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) - Zw(Imid,np1,iw)    &
                                   & *We(Imid,2*mp1-2,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) + Zw(Imid,np1,iw)    &
                                   & *Ve(Imid,2*mp1-1,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zw(Imid,np1,iw)    &
                                   & *Ve(Imid,2*mp1-2,k)
                  ENDDO
               ENDDO
            ENDIF
         ENDIF
         IF ( mp2<=ndo2 ) THEN
            DO k = 1 , Nt
               DO i = 1 , imm1
                  DO np1 = mp2 , ndo2 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(i,np1,iv)       &
                                   & *Ve(i,2*mp1-2,k) + Zw(i,np1,iw)    &
                                   & *Wo(i,2*mp1-1,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(i,np1,iv)       &
                                   & *Ve(i,2*mp1-1,k) - Zw(i,np1,iw)    &
                                   & *Wo(i,2*mp1-2,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(i,np1,iv)       &
                                   & *We(i,2*mp1-2,k) + Zw(i,np1,iw)    &
                                   & *Vo(i,2*mp1-1,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(i,np1,iv)       &
                                   & *We(i,2*mp1-1,k) - Zw(i,np1,iw)    &
                                   & *Vo(i,2*mp1-2,k)
                  ENDDO
               ENDDO
            ENDDO
            IF ( mlat/=0 ) THEN
               DO k = 1 , Nt
                  DO np1 = mp2 , ndo2 , 2
                     Br(mp1,np1,k) = Br(mp1,np1,k) + Zv(Imid,np1,iv)    &
                                   & *Ve(Imid,2*mp1-2,k)
                     Bi(mp1,np1,k) = Bi(mp1,np1,k) + Zv(Imid,np1,iv)    &
                                   & *Ve(Imid,2*mp1-1,k)
                     Cr(mp1,np1,k) = Cr(mp1,np1,k) - Zv(Imid,np1,iv)    &
                                   & *We(Imid,2*mp1-2,k)
                     Ci(mp1,np1,k) = Ci(mp1,np1,k) - Zv(Imid,np1,iv)    &
                                   & *We(Imid,2*mp1-1,k)
                  ENDDO
               ENDDO
            ENDIF
         ENDIF
      ENDDO
      RETURN
99999 END SUBROUTINE DVHAEC1


      SUBROUTINE DVHAECI(Nlat,Nlon,Wvhaec,Lvhaec,Dwork,Ldwork,Ierror)
      IMPLICIT NONE
      INTEGER Ierror , imid , iw1 , iw2 , labc , Ldwork , Lvhaec ,      &
            & lwzvin , lzz1 , mmax , Nlat , Nlon
      DOUBLE PRECISION Wvhaec
      DIMENSION Wvhaec(Lvhaec)
      DOUBLE PRECISION Dwork(Ldwork)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<1 ) RETURN
      Ierror = 3
      imid = (Nlat+1)/2
      lzz1 = 2*Nlat*imid
      mmax = MIN0(Nlat,(Nlon+1)/2)
      labc = 3*(MAX0(mmax-2,0)*(Nlat+Nlat-mmax-1))/2
      IF ( Lvhaec<2*(lzz1+labc)+Nlon+15 ) RETURN
      Ierror = 4
      IF ( Ldwork<2*Nlat+2 ) RETURN
      Ierror = 0
      CALL DZVINIT(Nlat,Nlon,Wvhaec,Dwork)
      lwzvin = lzz1 + labc
      iw1 = lwzvin + 1
      CALL DZWINIT(Nlat,Nlon,Wvhaec(iw1),Dwork)
      iw2 = iw1 + lwzvin
      CALL DHRFFTI(Nlon,Wvhaec(iw2))
      END SUBROUTINE DVHAECI

!  .                                                             .
!  .                  copyright (c) 1998 by UCAR                 .
!  .                                                             .
!  .       University Corporation for Atmospheric Research       .
!  .                                                             .
!  .                      all rights reserved                    .
!  .                                                             .
!  .                                                             .
!  .                         SPHEREPACK3.0                       .
!  .                                                             .
!  . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
!
!
!
! ... file shses.f
!
!     this file contains code and documentation for subroutines
!     shses and shsesi
!
! ... files which must be loaded with shses.f
!
!     sphcom.f, hrfft.f
!
!     subroutine shses(nlat,nlon,isym,nt,g,idg,jdg,a,b,mdab,ndab,
!    +                 wshses,lshses,work,lwork,ierror)
!
!     subroutine shses performs the spherical harmonic synthesis
!     on the arrays a and b and stores the result in the array g.
!     the synthesis is performed on an equally spaced grid.  the
!     associated legendre functions are stored rather than recomputed
!     as they are in subroutine shsec.  the synthesis is described
!     below at output parameter g.
!
! *** required files from spherepack2
!
!     sphcom.f, hrfft.f
!
!
!     input parameters
!
!     nlat   the number of colatitudes on the full sphere including the
!            poles. for example, nlat = 37 for a five degree grid.
!            nlat determines the grid increment in colatitude as
!            pi/(nlat-1).  if nlat is odd the equator is located at
!            grid point i=(nlat+1)/2. if nlat is even the equator is
!            located half way between points i=nlat/2 and i=nlat/2+1.
!            nlat must be at least 3. note: on the half sphere, the
!            number of grid points in the colatitudinal direction is
!            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than or equal to 4. the efficiency of the computation is
!            improved when nlon is a product of small prime numbers.
!
!     isym   = 0  no symmetries exist about the equator. the synthesis
!                 is performed on the entire sphere.  i.e. on the
!                 array g(i,j) for i=1,...,nlat and j=1,...,nlon.
!                 (see description of g below)
!
!            = 1  g is antisymmetric about the equator. the synthesis
!                 is performed on the northern hemisphere only.  i.e.
!                 if nlat is odd the synthesis is performed on the
!                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
!                 if nlat is even the synthesis is performed on the
!                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!
!            = 2  g is symmetric about the equator. the synthesis is
!                 performed on the northern hemisphere only.  i.e.
!                 if nlat is odd the synthesis is performed on the
!                 array g(i,j) for i=1,...,(nlat+1)/2 and j=1,...,nlon.
!                 if nlat is even the synthesis is performed on the
!                 array g(i,j) for i=1,...,nlat/2 and j=1,...,nlon.
!
!     nt     the number of syntheses.  in the program that calls shses,
!            the arrays g,a and b can be three dimensional in which
!            case multiple syntheses will be performed.  the third
!            index is the synthesis index which assumes the values
!            k=1,...,nt.  for a single synthesis set nt=1. the
!            discription of the remaining parameters is simplified
!            by assuming that nt=1 or that the arrays g,a and b
!            have only two dimensions.
!
!     idg    the first dimension of the array g as it appears in the
!            program that calls shses.  if isym equals zero then idg
!            must be at least nlat.  if isym is nonzero then idg
!            must be at least nlat/2 if nlat is even or at least
!            (nlat+1)/2 if nlat is odd.
!
!     jdg    the second dimension of the array g as it appears in the
!            program that calls shses.  jdg must be at least nlon.
!
!     a,b    two or three dimensional arrays (see the input parameter
!            nt) that contain the coefficients in the spherical harmonic
!            expansion of g(i,j) given below at the definition of the
!            output parameter g.  a(m,n) and b(m,n) are defined for
!            indices m=1,...,mmax and n=m,...,nlat where mmax is the
!            maximum (plus one) longitudinal wave number given by
!            mmax = min0(nlat,(nlon+2)/2) if nlon is even or
!            mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     mdab   the first dimension of the arrays a and b as it appears
!            in the program that calls shses. mdab must be at least
!            min0(nlat,(nlon+2)/2) if nlon is even or at least
!            min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     ndab   the second dimension of the arrays a and b as it appears
!            in the program that calls shses. ndab must be at least nlat
!
!     wshses an array which must be initialized by subroutine shsesi.
!            once initialized, wshses can be used repeatedly by shses
!            as long as nlon and nlat remain unchanged.  wshses must
!            not be altered between calls of shses.
!
!     lshses the dimension of the array wshses as it appears in the
!            program that calls shses. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshses must be at least
!
!               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
!
!     work   a work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in the
!            program that calls shses.  define
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            if isym is zero then lwork must be at least
!
!               (nt+1)*nlat*nlon
!
!            if isym is nonzero lwork must be at least
!
!               (nt+1)*l2*nlon.
!
!     **************************************************************
!
!     output parameters
!
!     g      a two or three dimensional array (see input parameter
!            nt) that contains the spherical harmonic synthesis of
!            the arrays a and b at the colatitude point theta(i) =
!            (i-1)*pi/(nlat-1) and longitude point phi(j) =
!            (j-1)*2*pi/nlon. the index ranges are defined above at
!            at the input parameter isym.  for isym=0, g(i,j) is
!            given by the the equations listed below.  symmetric
!            versions are used when isym is greater than zero.
!
!     the normalized associated legendre functions are given by
!
!     pbar(m,n,theta) = sqrt((2*n+1)*factorial(n-m)/(2*factorial(n+m)))
!                       *sin(theta)**m/(2**n*factorial(n)) times the
!                       (n+m)th derivative of (x**2-1)**n with respect
!                       to x=cos(theta)
!
!     define the maximum (plus one) longitudinal wave number
!     as   mmax = min0(nlat,(nlon+2)/2) if nlon is even or
!          mmax = min0(nlat,(nlon+1)/2) if nlon is odd.
!
!     then g(i,j) = the sum from n=0 to n=nlat-1 of
!
!                   .5*pbar(0,n,theta(i))*a(1,n+1)
!
!              plus the sum from m=1 to m=mmax-1 of
!
!                   the sum from n=m to n=nlat-1 of
!
!              pbar(m,n,theta(i))*(a(m+1,n+1)*cos(m*phi(j))
!                                    -b(m+1,n+1)*sin(m*phi(j)))
!
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of isym
!            = 4  error in the specification of nt
!            = 5  error in the specification of idg
!            = 6  error in the specification of jdg
!            = 7  error in the specification of mdab
!            = 8  error in the specification of ndab
!            = 9  error in the specification of lshses
!            = 10 error in the specification of lwork
!
!
! ****************************************************************
!     subroutine shsesi(nlat,nlon,wshses,lshses,work,lwork,dwork,
!    +                  ldwork,ierror)
!
!     subroutine shsesi initializes the array wshses which can then
!     be used repeatedly by subroutine shses.
!
!     input parameters
!
!     nlat   the number of colatitudes on the full sphere including the
!            poles. for example, nlat = 37 for a five degree grid.
!            nlat determines the grid increment in colatitude as
!            pi/(nlat-1).  if nlat is odd the equator is located at
!            grid point i=(nlat+1)/2. if nlat is even the equator is
!            located half way between points i=nlat/2 and i=nlat/2+1.
!            nlat must be at least 3. note: on the half sphere, the
!            number of grid points in the colatitudinal direction is
!            nlat/2 if nlat is even or (nlat+1)/2 if nlat is odd.
!
!     nlon   the number of distinct londitude points.  nlon determines
!            the grid increment in longitude as 2*pi/nlon. for example
!            nlon = 72 for a five degree grid. nlon must be greater
!            than or equal to 4. the efficiency of the computation is
!            improved when nlon is a product of small prime numbers.
!
!     lshses the dimension of the array wshses as it appears in the
!            program that calls shsesi. define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lshses must be at least
!
!               (l1*l2*(nlat+nlat-l1+1))/2+nlon+15
!
!     work   a real   work array that does not have to be saved.
!
!     lwork  the dimension of the array work as it appears in
!            the program that calls shsesi.  define
!
!               l1 = min0(nlat,(nlon+2)/2) if nlon is even or
!               l1 = min0(nlat,(nlon+1)/2) if nlon is odd
!
!            and
!
!               l2 = nlat/2        if nlat is even or
!               l2 = (nlat+1)/2    if nlat is odd
!
!            then lwork must be at least
!
!               5*nlat*l2+3*((l1-2)*(nlat+nlat-l1-1))/2
!
!
!     dwork  a double precision work array that does not have to be saved.
!
!     ldwork the dimension of the array dwork as it appears in the
!            program that calls shsesi.  ldwork must be at least nlat+1
!
!
!     output parameters
!
!     wshses an array which is initialized for use by subroutine shses.
!            once initialized, wshses can be used repeatedly by shses
!            as long as nlon and nlat remain unchanged.  wshses must
!            not be altered between calls of shses.
!
!     ierror = 0  no errors
!            = 1  error in the specification of nlat
!            = 2  error in the specification of nlon
!            = 3  error in the specification of lshses
!            = 4  error in the specification of lwork
!            = 5  error in the specification of ldwork
!
! ****************************************************************
      SUBROUTINE SHSES(Nlat,Nlon,Isym,Nt,G,Idg,Jdg,A,B,Mdab,Ndab,Wshses,&
                     & Lshses,Work,Lwork,Ierror)
      IMPLICIT NONE
      REAL A , B , G , Work , Wshses
      INTEGER Idg , Ierror , imid , ist , Isym , Jdg , lpimn , ls ,     &
            & Lshses , Lwork , Mdab , mmax , Ndab , Nlat , nln , Nlon , &
            & Nt
      DIMENSION G(Idg,Jdg,1) , A(Mdab,Ndab,1) , B(Mdab,Ndab,1) ,        &
              & Wshses(1) , Work(1)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      IF ( (Isym==0 .AND. Idg<Nlat) .OR. (Isym/=0 .AND. Idg<(Nlat+1)/2) &
         & ) RETURN
      Ierror = 6
      IF ( Jdg<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,Nlon/2+1)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      imid = (Nlat+1)/2
      lpimn = (imid*mmax*(Nlat+Nlat-mmax+1))/2
      IF ( Lshses<lpimn+Nlon+15 ) RETURN
      Ierror = 10
      ls = Nlat
      IF ( Isym>0 ) ls = imid
      nln = Nt*ls*Nlon
      IF ( Lwork<nln+ls*Nlon ) RETURN
      Ierror = 0
      ist = 0
      IF ( Isym==0 ) ist = imid
      CALL SHSES1(Nlat,Isym,Nt,G,Idg,Jdg,A,B,Mdab,Ndab,Wshses,imid,ls,  &
                & Nlon,Work,Work(ist+1),Work(nln+1),Wshses(lpimn+1))
    END SUBROUTINE SHSES

    
      SUBROUTINE SHSES1(Nlat,Isym,Nt,G,Idgs,Jdgs,A,B,Mdab,Ndab,P,Imid,  &
                      & Idg,Jdg,Ge,Go,Work,Whrfft)
      IMPLICIT NONE
      REAL A , B , G , Ge , Go , P , Whrfft , Work
      INTEGER i , Idg , Idgs , Imid , imm1 , Isym , j , Jdg , Jdgs , k ,&
            & ls , m , mb , Mdab , mdo , mmax , mn , modl , mp1 , mp2
      INTEGER Ndab , ndo , Nlat , nlon , nlp1 , np1 , Nt
      DIMENSION G(Idgs,Jdgs,1) , A(Mdab,Ndab,1) , B(Mdab,Ndab,1) ,      &
              & P(Imid,1) , Ge(Idg,Jdg,1) , Go(Idg,Jdg,1) , Work(1) ,   &
              & Whrfft(1)
      ls = Idg
      nlon = Jdg
      mmax = MIN0(Nlat,nlon/2+1)
      mdo = mmax
      IF ( mdo+mdo-1>nlon ) mdo = mmax - 1
      nlp1 = Nlat + 1
      modl = MOD(Nlat,2)
      imm1 = Imid
      IF ( modl/=0 ) imm1 = Imid - 1
      DO k = 1 , Nt
         DO j = 1 , nlon
            DO i = 1 , ls
               Ge(i,j,k) = 0.
            ENDDO
         ENDDO
      ENDDO
      IF ( Isym/=1 ) THEN
         DO k = 1 , Nt
            DO np1 = 1 , Nlat , 2
               DO i = 1 , Imid
                  Ge(i,1,k) = Ge(i,1,k) + A(1,np1,k)*P(i,np1)
               ENDDO
            ENDDO
         ENDDO
         ndo = Nlat
         IF ( MOD(Nlat,2)==0 ) ndo = Nlat - 1
         DO mp1 = 2 , mdo
            m = mp1 - 1
            mb = m*(Nlat-1) - (m*(m-1))/2
            DO np1 = mp1 , ndo , 2
               mn = mb + np1
               DO k = 1 , Nt
                  DO i = 1 , Imid
                     Ge(i,2*mp1-2,k) = Ge(i,2*mp1-2,k) + A(mp1,np1,k)   &
                                     & *P(i,mn)
                     Ge(i,2*mp1-1,k) = Ge(i,2*mp1-1,k) + B(mp1,np1,k)   &
                                     & *P(i,mn)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
         IF ( mdo/=mmax .AND. mmax<=ndo ) THEN
            mb = mdo*(Nlat-1) - (mdo*(mdo-1))/2
            DO np1 = mmax , ndo , 2
               mn = mb + np1
               DO k = 1 , Nt
                  DO i = 1 , Imid
                     Ge(i,2*mmax-2,k) = Ge(i,2*mmax-2,k) + A(mmax,np1,k)&
                                      & *P(i,mn)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
         IF ( Isym==2 ) GOTO 100
      ENDIF
      DO k = 1 , Nt
         DO np1 = 2 , Nlat , 2
            DO i = 1 , imm1
               Go(i,1,k) = Go(i,1,k) + A(1,np1,k)*P(i,np1)
            ENDDO
         ENDDO
      ENDDO
      ndo = Nlat
      IF ( MOD(Nlat,2)/=0 ) ndo = Nlat - 1
      DO mp1 = 2 , mdo
         mp2 = mp1 + 1
         m = mp1 - 1
         mb = m*(Nlat-1) - (m*(m-1))/2
         DO np1 = mp2 , ndo , 2
            mn = mb + np1
            DO k = 1 , Nt
               DO i = 1 , imm1
                  Go(i,2*mp1-2,k) = Go(i,2*mp1-2,k) + A(mp1,np1,k)      &
                                  & *P(i,mn)
                  Go(i,2*mp1-1,k) = Go(i,2*mp1-1,k) + B(mp1,np1,k)      &
                                  & *P(i,mn)
               ENDDO
            ENDDO
         ENDDO
      ENDDO
      mp2 = mmax + 1
      IF ( mdo/=mmax .AND. mp2<=ndo ) THEN
         mb = mdo*(Nlat-1) - (mdo*(mdo-1))/2
         DO np1 = mp2 , ndo , 2
            mn = mb + np1
            DO k = 1 , Nt
               DO i = 1 , imm1
                  Go(i,2*mmax-2,k) = Go(i,2*mmax-2,k) + A(mmax,np1,k)   &
                                   & *P(i,mn)
               ENDDO
            ENDDO
         ENDDO
      ENDIF
 100  DO k = 1 , Nt
         IF ( MOD(nlon,2)==0 ) THEN
            DO i = 1 , ls
               Ge(i,nlon,k) = 2.*Ge(i,nlon,k)
            ENDDO
         ENDIF
         CALL HRFFTB(ls,nlon,Ge(1,1,k),ls,Whrfft,Work)
      ENDDO
      IF ( Isym/=0 ) THEN
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO j = 1 , nlon
                  G(i,j,k) = .5*Ge(i,j,k)
               ENDDO
            ENDDO
         ENDDO
         GOTO 99999
      ENDIF
      DO k = 1 , Nt
         DO j = 1 , nlon
            DO i = 1 , imm1
               G(i,j,k) = .5*(Ge(i,j,k)+Go(i,j,k))
               G(nlp1-i,j,k) = .5*(Ge(i,j,k)-Go(i,j,k))
            ENDDO
            IF ( modl/=0 ) G(Imid,j,k) = .5*Ge(Imid,j,k)
         ENDDO
      ENDDO
      RETURN
99999 END SUBROUTINE SHSES1

      
      SUBROUTINE SHSESI(Nlat,Nlon,Wshses,Lshses,Work,Lwork,Dwork,Ldwork,&
                      & Ierror)
      IMPLICIT NONE
      INTEGER Ierror , imid , iw1 , labc , Ldwork , lpimn , Lshses ,    &
            & Lwork , mmax , Nlat , Nlon
      REAL Work , Wshses
      DIMENSION Wshses(*) , Work(*)
      DOUBLE PRECISION Dwork(*)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      mmax = MIN0(Nlat,Nlon/2+1)
      imid = (Nlat+1)/2
      lpimn = (imid*mmax*(Nlat+Nlat-mmax+1))/2
      IF ( Lshses<lpimn+Nlon+15 ) RETURN
      Ierror = 4
      labc = 3*((mmax-2)*(Nlat+Nlat-mmax-1))/2
      IF ( Lwork<5*Nlat*imid+labc ) RETURN
      Ierror = 5
      IF ( Ldwork<Nlat+1 ) RETURN
      Ierror = 0
      iw1 = 3*Nlat*imid + 1
      CALL SES1(Nlat,Nlon,imid,Wshses,Work,Work(iw1),Dwork)
      CALL HRFFTI(Nlon,Wshses(lpimn+1))
    END SUBROUTINE SHSESI


    
    SUBROUTINE DSHSES(Nlat,Nlon,Isym,Nt,G,Idg,Jdg,A,B,Mdab,Ndab,Wshses,&
                     & Lshses,Work,Lwork,Ierror)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , G , Work , Wshses
      INTEGER Idg , Ierror , imid , ist , Isym , Jdg , lpimn , ls ,     &
            & Lshses , Lwork , Mdab , mmax , Ndab , Nlat , nln , Nlon , &
            & Nt
      DIMENSION G(Idg,Jdg,1) , A(Mdab,Ndab,1) , B(Mdab,Ndab,1) ,        &
              & Wshses(1) , Work(1)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      IF ( Isym<0 .OR. Isym>2 ) RETURN
      Ierror = 4
      IF ( Nt<0 ) RETURN
      Ierror = 5
      IF ( (Isym==0 .AND. Idg<Nlat) .OR. (Isym/=0 .AND. Idg<(Nlat+1)/2) &
         & ) RETURN
      Ierror = 6
      IF ( Jdg<Nlon ) RETURN
      Ierror = 7
      mmax = MIN0(Nlat,Nlon/2+1)
      IF ( Mdab<mmax ) RETURN
      Ierror = 8
      IF ( Ndab<Nlat ) RETURN
      Ierror = 9
      imid = (Nlat+1)/2
      lpimn = (imid*mmax*(Nlat+Nlat-mmax+1))/2
      IF ( Lshses<lpimn+Nlon+15 ) RETURN
      Ierror = 10
      ls = Nlat
      IF ( Isym>0 ) ls = imid
      nln = Nt*ls*Nlon
      IF ( Lwork<nln+ls*Nlon ) RETURN
      Ierror = 0
      ist = 0
      IF ( Isym==0 ) ist = imid
      CALL DSHSES1(Nlat,Isym,Nt,G,Idg,Jdg,A,B,Mdab,Ndab,Wshses,imid,ls,  &
                & Nlon,Work,Work(ist+1),Work(nln+1),Wshses(lpimn+1))
    END SUBROUTINE DSHSES

    
      SUBROUTINE DSHSES1(Nlat,Isym,Nt,G,Idgs,Jdgs,A,B,Mdab,Ndab,P,Imid,  &
                      & Idg,Jdg,Ge,Go,Work,Whrfft)
      IMPLICIT NONE
      DOUBLE PRECISION A , B , G , Ge , Go , P , Whrfft , Work
      INTEGER i , Idg , Idgs , Imid , imm1 , Isym , j , Jdg , Jdgs , k ,&
            & ls , m , mb , Mdab , mdo , mmax , mn , modl , mp1 , mp2
      INTEGER Ndab , ndo , Nlat , nlon , nlp1 , np1 , Nt
      DIMENSION G(Idgs,Jdgs,1) , A(Mdab,Ndab,1) , B(Mdab,Ndab,1) ,      &
              & P(Imid,1) , Ge(Idg,Jdg,1) , Go(Idg,Jdg,1) , Work(1) ,   &
              & Whrfft(1)
      ls = Idg
      nlon = Jdg
      mmax = MIN0(Nlat,nlon/2+1)
      mdo = mmax
      IF ( mdo+mdo-1>nlon ) mdo = mmax - 1
      nlp1 = Nlat + 1
      modl = MOD(Nlat,2)
      imm1 = Imid
      IF ( modl/=0 ) imm1 = Imid - 1
      DO k = 1 , Nt
         DO j = 1 , nlon
            DO i = 1 , ls
               Ge(i,j,k) = 0.
            ENDDO
         ENDDO
      ENDDO
      IF ( Isym/=1 ) THEN
         DO k = 1 , Nt
            DO np1 = 1 , Nlat , 2
               DO i = 1 , Imid
                  Ge(i,1,k) = Ge(i,1,k) + A(1,np1,k)*P(i,np1)
               ENDDO
            ENDDO
         ENDDO
         ndo = Nlat
         IF ( MOD(Nlat,2)==0 ) ndo = Nlat - 1
         DO mp1 = 2 , mdo
            m = mp1 - 1
            mb = m*(Nlat-1) - (m*(m-1))/2
            DO np1 = mp1 , ndo , 2
               mn = mb + np1
               DO k = 1 , Nt
                  DO i = 1 , Imid
                     Ge(i,2*mp1-2,k) = Ge(i,2*mp1-2,k) + A(mp1,np1,k)   &
                                     & *P(i,mn)
                     Ge(i,2*mp1-1,k) = Ge(i,2*mp1-1,k) + B(mp1,np1,k)   &
                                     & *P(i,mn)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
         IF ( mdo/=mmax .AND. mmax<=ndo ) THEN
            mb = mdo*(Nlat-1) - (mdo*(mdo-1))/2
            DO np1 = mmax , ndo , 2
               mn = mb + np1
               DO k = 1 , Nt
                  DO i = 1 , Imid
                     Ge(i,2*mmax-2,k) = Ge(i,2*mmax-2,k) + A(mmax,np1,k)&
                                      & *P(i,mn)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF
         IF ( Isym==2 ) GOTO 100
      ENDIF
      DO k = 1 , Nt
         DO np1 = 2 , Nlat , 2
            DO i = 1 , imm1
               Go(i,1,k) = Go(i,1,k) + A(1,np1,k)*P(i,np1)
            ENDDO
         ENDDO
      ENDDO
      ndo = Nlat
      IF ( MOD(Nlat,2)/=0 ) ndo = Nlat - 1
      DO mp1 = 2 , mdo
         mp2 = mp1 + 1
         m = mp1 - 1
         mb = m*(Nlat-1) - (m*(m-1))/2
         DO np1 = mp2 , ndo , 2
            mn = mb + np1
            DO k = 1 , Nt
               DO i = 1 , imm1
                  Go(i,2*mp1-2,k) = Go(i,2*mp1-2,k) + A(mp1,np1,k)      &
                                  & *P(i,mn)
                  Go(i,2*mp1-1,k) = Go(i,2*mp1-1,k) + B(mp1,np1,k)      &
                                  & *P(i,mn)
               ENDDO
            ENDDO
         ENDDO
      ENDDO
      mp2 = mmax + 1
      IF ( mdo/=mmax .AND. mp2<=ndo ) THEN
         mb = mdo*(Nlat-1) - (mdo*(mdo-1))/2
         DO np1 = mp2 , ndo , 2
            mn = mb + np1
            DO k = 1 , Nt
               DO i = 1 , imm1
                  Go(i,2*mmax-2,k) = Go(i,2*mmax-2,k) + A(mmax,np1,k)   &
                                   & *P(i,mn)
               ENDDO
            ENDDO
         ENDDO
      ENDIF
 100  DO k = 1 , Nt
         IF ( MOD(nlon,2)==0 ) THEN
            DO i = 1 , ls
               Ge(i,nlon,k) = 2.*Ge(i,nlon,k)
            ENDDO
         ENDIF
         CALL DHRFFTB(ls,nlon,Ge(1,1,k),ls,Whrfft,Work)
      ENDDO
      IF ( Isym/=0 ) THEN
         DO k = 1 , Nt
            DO i = 1 , Imid
               DO j = 1 , nlon
                  G(i,j,k) = .5*Ge(i,j,k)
               ENDDO
            ENDDO
         ENDDO
         GOTO 99999
      ENDIF
      DO k = 1 , Nt
         DO j = 1 , nlon
            DO i = 1 , imm1
               G(i,j,k) = .5*(Ge(i,j,k)+Go(i,j,k))
               G(nlp1-i,j,k) = .5*(Ge(i,j,k)-Go(i,j,k))
            ENDDO
            IF ( modl/=0 ) G(Imid,j,k) = .5*Ge(Imid,j,k)
         ENDDO
      ENDDO
      RETURN
99999 END SUBROUTINE DSHSES1

      
      SUBROUTINE DSHSESI(Nlat,Nlon,Wshses,Lshses,Work,Lwork,Dwork,Ldwork,&
                      & Ierror)
      IMPLICIT NONE
      INTEGER Ierror , imid , iw1 , labc , Ldwork , lpimn , Lshses ,    &
            & Lwork , mmax , Nlat , Nlon
      DOUBLE PRECISION Work , Wshses
      DIMENSION Wshses(*) , Work(*)
      DOUBLE PRECISION Dwork(*)
      Ierror = 1
      IF ( Nlat<3 ) RETURN
      Ierror = 2
      IF ( Nlon<4 ) RETURN
      Ierror = 3
      mmax = MIN0(Nlat,Nlon/2+1)
      imid = (Nlat+1)/2
      lpimn = (imid*mmax*(Nlat+Nlat-mmax+1))/2
      IF ( Lshses<lpimn+Nlon+15 ) RETURN
      Ierror = 4
      labc = 3*((mmax-2)*(Nlat+Nlat-mmax-1))/2
      IF ( Lwork<5*Nlat*imid+labc ) RETURN
      Ierror = 5
      IF ( Ldwork<Nlat+1 ) RETURN
      Ierror = 0
      iw1 = 3*Nlat*imid + 1
      CALL DSES1(Nlat,Nlon,imid,Wshses,Work,Work(iw1),Dwork)
      CALL DHRFFTI(Nlon,Wshses(lpimn+1))
    END SUBROUTINE DSHSESI


      
